This file introduces Mark Williams Company's documentation for COHERENT,
its clone of the UNIX operating system. It describes the origin of the
documentation, its structure, and how you can rebuild it.

ORIGIN
The documentation originated in the late 1970s, when Mark Williams Company
began its project to clone the UNIX operating system. The basic set of
documents was written by William Lederer, Steve Ness, and Bob Swartz. Fred
Butzen took over the documentation in 1985, and worked on it from then to
February 1, 1995, when Mark Williams Company closed its doors. Practically
all Mark Williams personnel contributed in one way or another to the
documentation, through suggestions, technical information, or example
programs. In particular, Roger Critchlow conceived of the "lexicon" format
for the manual, and Charles Fiterman wrote many its example programs.

Publication History

The Coherent manual went through a number of releases. Its original form
was printed on 8.5x11" paper, in monospaced font, and bound in two ring
binders. The second edition, prepared in part for the release of the
aborted Commodore Coherent project, was professionally typeset and bound
in two 7.5x6" binders.

Beginning with the release of the $99 edition of Coherent in, I believe,
1992, the manual was perfect bound in a large paperback book. In the
three years that $99 Coherent was on sale, the manual went through 11
revisions, each new revision being released when a new batch of manuals
had to be printed. Camera-ready copy was printed on a laser printer and
sent directly to the printer. A 12th edition was nearing completion when
MWC closed its doors.

STRUCTURE


Directories

This directory contains the sources for Mark Williams Company's
documentation, as follows:

coherent -     Sources for the manual to the Coherent operating system.
csd -          Sources for the manual for CSD, the C Source Debugger sold
               for MS-DOS and the Atari ST.
front.office - Sources for the manual that describes MWC's sales system:
	       its design and how to run it.
mwc -          Sources for the manual for Mark Williams C, the C compiler
               sold for MS-DOS and the Atari ST.
rdb -	       The manual for rdb, a relational data-base product sold for
               Coherent.

troff Macros




Ancillary Files



REBUILDING

This directory holds the sources for "rdb", a relational data-base product
that was (briefly) sold by MWC.  To rebuild the manual, uncompress all
of the files, then type "Run".  You may have to tinker with the script a
bit, although in main it's pretty sound.

hpfonts/Read_me 12/14/90

hpfonts reorganized 12/13/90 by steve:
Directories:
	etc			Font loading scripts and miscellany from mwc!
	Century		cn*	Century Schoolbook fonts
	Courier		co*	Courier fonts
	Helvetica	hv*	Helvetica fonts
	Humanist	op*	Zapf Humanist fonts
	LinePrinter	lp*	Line Printer fonts
	Other			None of the above fonts
	Prestige	pr*	Prestige fonts
	Times		tr*	Times-Roman fonts

Font names are typically xxdddspn.ccy, where:
	xx	indicates font family name, as above
	ddd	indicates point size in points*10
	s	indicates style, r=Roman b=bold i=italic
	pn	indicates proportional spacing
	cc	indicates character set, typically "us"
	y	indicates orientation, p=portrait l=landscape

Program fwtable (previously called hptable) builds font width tables.

This directory holds the source files for the Mark Williams internal
manuals.

Directory "sm" holds information on the Sales Manual written by Stephen Davis.

Archive source.tgz holds the sources for the sales system.

The rest of the files hold the manual for the sales system.  To rebuild it,
uncompress the files, then type "Run".

This directory holds the sources for the manual for CSD, the C source
debugger for MS-DOS and the Atari ST.  To re-build the manual, uncompress
all of the files, then type "Run".

NB, you probably will have to rewrite most of the Run scripts as they
invoke macro packages that no longer exist, and use techniques that are
truly bogus.  Good luck.

This directory and its subdirectories contain the text files
for the documentation for the various versions of the Mark Williams
C compiler.

At present, manuals have been prepared for the COHERENT system,
MS-DOS (Let's C), TOS, a variety of Intel UDI systems (both native
and as a cross-compiler), and the book "ANSI C:  A Lexical Guide".

Each manual has its own directory.  In that directory is a shell
script called "Run" that controls the construction of the manual.
Each manual's directory also contains a file called "top.r" that
contains string definitions peculiar to that particular manual, and
a file called "fonts.r" that redefines the standard troff fonts to
those used in the given manual.

The directory called "lx" contains all of the entries for the
Mark Williams Lexicon.  A version of the Lexicon is built for each
compiler's manual.  Each file is headed by a comment
that tells which environments that file applies: COHERENT, LC, CPS,
TOS, UDI, or the ANSI manual.  The file "lx/READ.ME" describes
the Lexicon and its conventions in more detail.  See lx/Read.me
for information on lx's sub-directories.

The directory called "errata" contains the errata sheets for each
printing of each manual for each compiler.

The directory called "text" contains the text files used to build
the front portions of all manuals:  introduction, tutorials, error
messages, etc.

Directory "MUST_DO" has mail message from hither and yon that describe
fixes to the various manuals that have not yet been done.

Directory "aesvdi" contains scripts to build a manual for the GEM
AES and VDI alone.  This was built on the off chance that we ship
GEM libraries for a system other than the Atari ST.

Directory "alphabet" contains files that hold the big letters of the
alphabet that appear at the beginning of each alphabetical group of
lexicon entries.

Directory "ansi" holds scripts etc. that build the ANSI C manual.

Directory "beginners" holds files for the tutorial "C for Beginners".
This tutorial is only half finished.  The finished portion is in the
file "text/beginners.r"; the unfinished portions are in directory
beginners, should anyone feel ambitious and like to finish it.

Directory "dos" holds files to build the manual for Let's C.

Directory "errata" holds versions of the errata pamphlets shipped
with various products and releases.

Directory "examples" contains shell scripts that can extract the
example C programs from lexicon entries.

Directory "help" contains C programs and shell scripts that build the
help file used with MicroEMACS.

Directory "isis" contains shell scripts that build the manuals for
the UDI compiler, the ISIS compiler, and the VAX cross-compiler.
Note that the UDI and ISIS compilers probably are dead products, because
Intel has now published its own 8086 compiler, so these files probably
can be archived and forgotten about, should anyone feel ambitious.

Directory "lx" holds all of the Lexicon.

Directory "relnotes" holds release notes for the current releases of
our products.

Directory "tos" holds files that build the Atari manual.

Material throughout is conditionalized by number registers, as follows:

	.if \nX=0 Print material specific to the COHERENT system
	.if \nX=1 Print material specific to Let's C or CPS
	.if \nX=2 Print material specific to TOS
	.if \nX=3 Print material specific to ISIS/UDI
	.if \nX=4 Print material specific to the ANSI C manual

	.if \nG=0 Print material specific to the 8086 for the UDI compiler
	.if \nG=1 Print material specific to the 80286 for the UDI compiler


NB, you probably will have to rewrite most of the Run scripts as they
invoke macro packages that no longer exist, and use techniques that are
truly bogus.  Good luck.

This directory contains the "Run" scripts from which the Coherent manual
is built:

	Run.manual - build the entire manual
	Run.conindex - build the table of contents and the index
	Run.lex - build a batch of Lexicon entries
	Run.misc - build miscellaneous pages (preface, copyright, etc.)
	Run.text - build a tutorial

	fonts.r - name fonts used in the manual
	top.r - macros used in the manual

Please note that "top.r" is also used by most of the other documentation
packages.

The following miscellaneous scripts and files are used to help build the
Coherent documentation:

Download.font	- Download the keycaps font to the printer, for those documents
		  that require
I_keyb.fwt	- The font width table for the keycaps font.  Be sure that it
		  is copied into directory /usr/lib/roff/troff_ps/fwt, so it
		  can be read by the documents that use it.
bld.files	- Build the file "Lexicon.files" in the parent directory.
		  This file links each Lexicon entry's title with the name
		  the file that holds it.
contents	- Build the table of contents from the raw material output
		  during the building of the Coherent manual.
finderror	- Scan troff output (the stuff bounced off the standard
		  error) for error messages from troff/nroff.
findstring	- Find a string in all of the Lexicon files.
index		- Build the index for the Coherent manual from the raw stuff
		  output by troff.
indexnew	- Build a new-style index.  This is not used because of bugs
		  in troff that Steve has not had time to fix.
keyfont.ps1	- The keycaps font.
makeman		- Build a single manual page, suitable for viewing or printing.
		  For its options, read the script itself.
shoot.pick	- This script is captures the contents of an X window, and
		  turns it into an EPS file.  It lets you pick the window
		  interactively.  NB, you will have to set the bounding-box
		  by hand, because the X utility that does so is broken.
shoot.screen	- Turn the contents of the entire screen into an EPS file.
shoot.window	- Turn the contents of the current window into an EPS file.
sift		- Throw away the extra characters that nroff outputs to
		  indicate bold and italic characters.

This directory contains raw files that was to have used for a Coherent
networking manual.

Directory "hedrick" contains the raw versions of documetns by
Charles L. Hedrick.

Directory lx holds pages for networking commands, in various states of
incompletion.

The current directory holds drafts of tutorial sections.  Files with the
suffix ".do" holds mail messages on various networking-related topics.
Files "net.worth" and "internet.note" index two networking-related columns
published in "UNIX Review".

This directory holds the sources from which the manual for the Coherent
Device Driver Kit is built.  Directory "286" holds the sources for the
Coherent-286 driver kit (Coherent 3.2); directory coh4.0 holds the sources
for the manual for Coherent release 4.0.

Tutorial sections are the files in the current directory that have suffix .r.
The Lexicon entries are in directory lx.

Files with the suffix ".do" contain mail message from various Coherent
developers (mostly former developers), that discuss proposed changes to the
manual.  These should be gone through and resolved before the next manual
is published.

To rebuild the manual, type "Run.driver".

This directory contains manual pages for the "elm" mailer.  As "elm" is
not yet part of Coherent, they are set aside in this directory.

If elm becomes part of Coherent, do the following:

- Move the files in the current directory into /v/doc/coherent/lx, with
  the exception of files READ.ME and TO.DO.  Also, do not move the
  directories into lx, or bloody hell will happen when you try to rebuild
  the Lexicon.

- Open file TO.DO and follow the directions therein.  When you install new
  files into the Lexicon, the appropriate overview articles must also be
  updated; TO.DO names these articles.

This directory contains notes to be used for software that manipulate
sound cards under Coherent, both drivers and applications.  These tools
were stillborn.  This documentation is very sketchy, but contains useful
information.

This directory holds files from which the manual for Randy Wright's "cohulip"
program was built.  To rebuilt the manual, type "Run.troff" or "Run.nroff";
the former builds a printable version, the latter a version that can be
displayed on screen.

Directory "help" contains the help files included with cohulip.  Directory
"xfig" contains files output by xfig; these files hold the charts and
graphs used in the cohulip manual.  Note that the PostScript versions of
these are kept in directory /v/PostScript/manual.

This directory contains miscellaneous manual pages and documentation.
Most is for packages that will never be part of Coherent:

	- cohware6.tgz:  raw manual pages for a package of games for
	  Coherent; this probably will never be shipped.
	- dialog: the GNU dialog package.
	- hwp: Harry Pulley's word processor.
	- idlesecs: count the seconds the CPU is idle.
	- libvga.tgz: routines for Harry Pulley's VGA graphics.
	- lmo: automatically log a user out.
	- rb: batch receive program, raw form
	- rx: rewritten manual page for "rx"
	- rxvt: rewritten manual page for rxvt, the X terminal program
	- rz: rewritten manual page for "rz"
	- smail.doc.tgz: raw manual pages for smail
	- sz: rewritten manual page for "sz"
	- tass: rewritten manual page for "tass"
	- tput: rewritten manual page for "tput"
	- vgaset: rewritten manual page for "vgaset"
	- xcdplayer: rewritten manual page for "xcdplayer"

This directory contains back-up copies of the troff/nroff macro packages
from which the various Mark Williams documentations packages are built.
Copy them into directory /usr/lib.

Files "specials.*" include versions of files "specials.r" used for special
settings of the manual, in particular the HTML version of the Lexicon.
Copy each into the appropriate directory, as indicated by its name.

This directory contains script that build the sets of manual pages for
Coherent and the Coherent Driver Kit.  To build Coherent manual pages,
su to "bin" and execute script "Run.coh"; to build driver-kit manual
pages, su to "bin" and execute script "Run.ddk".

This directory contains the sources for the manual included with X Windows
for Coherent:

Default - A template for an X Lexicon entry
Run.xman - Build the manual
Run.xmisc - Build miscellaneous X stuff
cross.thoughts - Index for the column Cross Thoughts, published in UNIX Review.
fixes - File that describe fixes that must be made to the manual.
lx - Lexicon entries
misc.docs - Miscellaneous manual pages for X programs that didn't make it
		into the X package
text - Sources for tutorials included in the X manual
x.docs - MIT X docs
x.org - Files available on machine ftp.x.org.
xfree - Documentation for XFree 3.1

This directory contains stuff that was to have been used in writing a
tutorial for "elvis".  The files with suffix ".do" contain mail from
various present (and former) Coherent users with suggestions about the
tutorial.  Directory "vitutor" contains an interactive tutor for "vi".
This will help you get started with elvis.

This directory contains files used to build an HTML version of the Coherent
Lexicon.  The output of this command can be read with Mosaic; cross-references
are output in the form of anchors, so the appropriate files can be invoked by
clicking on them.

To build this, su to "bin"; then type "Run.html".  File "sed.html" is a
sed script that preprocesses each Lexicon entry, in order to predigest HTML's
magic escape characters.  Script "Run.one" processes a single Lexicon entry.
Directory "images" holds the images included within selected Lexicon entries,
in the form of X bit-maps.  These bit-maps were build from the xfig originals
that are kept in directory /v/doc/coherent/xfig.

This directory contains the sources for sets of release notes included
with various Mark Williams products:

	bbl - Sources for notes used with the Coherent versions of BBL
		image packages.
	coherent - Release notes for various releases of Coherent.
	cohware - Release notes for the five COHware packages.
	comeau - Release notes for Comeau C++.
	driver.kit - Release notes for various release of the Coherent DDK.
	floppytape - Release notes for the floppy-tape update to Coherent
		(Coherent 4.2.12).
	gnu - Release notes for various editions of GNU tools and GNU C
		for Coherent.
	x - Release notes for the two release of Coherent X.

This directory holds some miscellaneous files, as follows:

Print.char.pcl   - a script that prints a full character set on a PCL printer
Print.char.ps	 - a script that prints a full character set on a PostScript
		   printer
Print.specials   - a script that prints all of nroff/troff special characters
Run.blind	 - a script that builds all of our tutorials into nroff-able
		   format, so they can be "read" by a blind user.
Run.gdbm	 - build all of the articles that relate to libgdbm, the
		   GNU DBM library
Run.mlp		 - build all of the articles that relate to the MLP spooler
Run.smail	 - build all of the articles that relate to smail and its
		   utilities
Run.taylor	 - build all of the articles that relate to Taylor UUCP
build_coh	 - a long mail message from Hal Snyder that describes how to
		   build a Coherent release
pocket.gtz	 - a set of scripts that build a pocket version of the
		   Coherent manual

   Copyright (C) 1989, 1992, 1993 Aladdin Enterprises.  All rights reserved.

This file is part of Ghostscript.

Ghostscript is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY.  No author or distributor accepts responsibility
to anyone for the consequences of using it or for whether it serves any
particular purpose or works at all, unless he says so in writing.  Refer
to the Ghostscript General Public License for full details.

Everyone is granted permission to copy, modify and redistribute
Ghostscript, but only under the conditions described in the Ghostscript
General Public License.  A copy of this license is supposed to have been
given to you along with Ghostscript so you can know your rights and
responsibilities.  It should be in a file named COPYING.  Among other
things, the copyright notice and this notice must be preserved on all
copies.

- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

*****************************************************
* This file describes version 2.6.1 of Ghostscript. *
*****************************************************

********
******** An overview of Ghostscript ********
********

Ghostscript is the name of a set of software that provides:

	- An interpreter for the PostScript (TM) language, and

	- A set of C procedures (the Ghostscript library) that
implement the graphics capabilities that appear as primitive
operations in the PostScript language.

The primary contact for Ghostscript is:

	Aladdin Enterprises
	P.O. box 60264
	Palo Alto, CA 94306
	voice (415)322-0103
	fax (415)322-1734
	...{uunet,decwrl}!aladdin!ghost
	ghost@aladdin.com

L. Peter Deutsch, president of Aladdin Enterprises, was the original
creator, and is the primary developer and maintainer, of Ghostscript.
Aladdin Enterprises owns the copyright in Ghostscript; Ghostscript is
distributed with the GNU General Public License, and is also available for
commercial licensing.

The Ghostscript language interpreter and library are written entirely
in C, with some assembly-language accelerators for MS-DOS platforms.
Currently, Ghostscript is known to run on the following platform
families:

	- IBM PC and compatibles with EGA, VGA, SuperVGA, or compatible
	  graphics under MS-DOS 3.1, 3.3, or 5.0, with or without
	  Microsoft Windows 3.0 or 3.1;

	- IBM PC and compatibles under OS/2 2.0 and 2.1;

	- A wide variety of Unix systems using X Windows version 11,
	  release 3, 4, and 5, including Sun-3, Sun-4, Sun-386i,
	  Sun SPARCStation 1 and 2; generic 80386 machines running 386/ix,
	  ISC Unix, and SCO Unix; H-P 9000/300 and 9000/800;
	  DECStation 2100 and 3100; VAX running Ultrix; Sequent Symmetry;
	  Convex C1 and C2; Tektronix 4300; SGI Iris Indigo;

	- Sun workstations (Sun-3, SPARC, Sun-386i) running SunView;

	- VAX, VMS with X11R3/4/5 and gcc.  (Ghostscript currently is
	not compatible with the DEC C compilers, because they
	interpret the ANSI C standard in a way different from all
	other known compilers.)

It is very likely that Ghostscript will run under other versions of
MS-DOS, and other versions of Unix that support X11, but it has not
been tested in these environments.  Ghostscript does NOT run well on
PC-compatibles with Hercules display cards: text and graphics output
interfere with each other.

Other platforms
---------------

Ghostscript has also been ported a number of platforms by users, who
are willing to be contacted regarding problems on those specific
platforms:

	- For information on a port to the Apple Macintosh, contact
	Martin Fong (mwfong@nisc.sri.com).  (Aladdin Enterprises will be
	offering a Macintosh port in early 1993.)

	- For information on a port to the Acorn Archimedes, contact
	David Elworthy (David.Elworthy@cl.cam.ac.uk).

	- For information on two different ports to Win-OS/2, contact
	Gershon Elber (gershon@gr.cs.utah.edu) and/or Jim Yang
	(jyang@daedalus.caltech.edu).

	- For information on a port to the Atari ST, contact Tim
	Gallivan (timg@landau.ph.utexas.edu).

********
******** Related work
********

There are two freely available X Windows screen previewers based on
Ghostscript: Ghostview and GSPreview.  For information on Ghostview,
contact Tim Theisen (ghostview@cs.wisc.edu).  For information on
GSPreview, contact Richard Hesketh (rlh2@ukc.ac.uk).

There is a freely available MS Windows screen previewer based on
Ghostscript, called Ghostview for Windows.  For information on Ghostview
for Windows, contact Russell Lang (rjl@monu1.cc.monash.edu.au).

A set of patches and additions for Kanji capability for Ghostscript
version 2.4.1 is available for anonymous FTP from
ftp.cs.titech.ac.jp:GNU/gs241j11.tar.Z.  For more information, contact
Mr. Norio Katayama (katayama@nacsis.ac.jp).

Thomas Wolff (wolff@inf.fu-berlin.de) is working on extending the
Hershey fonts to include international characters.

********
******** Documentation overview ********
********

All the file names mentioned in the documentation, except for README,
are in lower case, which is the usual convention for Unix systems.
On MS-DOS systems, all file names are actually upper-case.

When you receive Ghostscript, you should start by reading:

> README - this file.

> readme.doc - information about problems and major changes new
features in the current release.

If you have used a previous release of Ghostscript, you probably
should also read any more recent sections of:

> NEWS - a complete, detailed history of changes in the most recent
Ghostscript releases.

Especially for new users
------------------------

If you are a new user of Ghostscript, you should read:

> use.doc - information about to install and use Ghostscript.  This
information is also contained in gs.1 - a `man' page for Ghostscript.

> devices.doc - more detailed information about specific devices that
Ghostscript knows about.

> ps2epsi.doc, unix-lpr.doc - more detailed information about some of
the shell scripts and batch files distributed with Ghostscript.

If you are going to compile Ghostscript, rather than just use an
executable you got from somewhere, you should read:

> make.doc - how to install, compile and link Ghostscript.

If you run into any questions, or if you are going to be using
Ghostscript extensively, you should at least skim, and probably
eventually read:

> fonts.doc - information about the fonts distributed with
Ghostscript, including how to add or replace fonts.

> language.doc - A description of the Ghostscript language, and its
differences from the documented PostScript language.

> psfiles.doc - information about the .ps files distributed with
Ghostscript (other than fonts).

Especially for developers
-------------------------

If you are going to be writing a new driver for Ghostscript, you
should read:

> drivers.doc - the interface between Ghostscript and device drivers.

> xfonts.doc - the interface between Ghostscript and platform-supplied
fonts.  (Read drivers.doc first.)

If you are considering distributing Ghostscript in conjunction with a
commercial product, you should read the COPYING license carefully,
and you should also read:

> commprod.doc - additional clarification of the circumstances under
which Ghostscript can be distributed with a commercial product.

Other files
-----------

> ps2epsi.doc - documentation for the PostScript to EPSI conversion
utility.

> helpers.doc - a note of thanks to all the people who have helped with
Ghostscript development.

> hershey.doc - information about the Hershey fonts, which are the
basis of some of the Ghostscript fonts.

> history.doc - a history of changes in older Ghostscript release.

> humor.doc - a humorous comment on Ghostscript contributed by a user.

> lib.doc - information about the Ghostscript library.

> unix-lpr.doc - information about how to integrate Ghostscript with
Unix printer spooling.

********
******** Trouble reporting ********
********

Aladdin Enterprises doesn't have the resources to respond to questions
from general users of Ghostscript.  If you have problems with Ghostscript,
and you have access to Usenet news, we suggest you post your question to
gnu.ghostscript.bug.  There are hundreds of Ghostscript user sites all
over the world, and often another user will be able to help you.  (If you
have access to Internet mail, but not news, send e-mail to
bug-ghostscript@prep.ai.mit.edu.)  If you are having trouble with a
specific device driver, look in the file devs.mak and see if it is a
user-maintained driver.  If so, please contact the person listed there
directly; please do not contact Aladdin Enterprises regarding
user-maintained drivers.

Aladdin Enterprises does want Ghostscript to be of high quality, so if you
have been running Ghostscript and encounter a problem, we will consider
investigating it if you meet all the following criteria:

	- You are using the most recent version of Ghostscript.

	- You obtained Ghostscript directly from Aladdin Enterprises,
	or from a GNU distribution site on the Internet (i.e., not from a
	bulletin board system or a commercial system such as CompuServe or
	GEnie).

	- You have installed Ghostscript successfully, and used it
	successfully on other input data.

	- Your problem is reproducible, and you can send us the input
	data that evokes it (by e-mail, anonymous FTP, or PC diskette).
	(But please do not send anything unless we ask you for it.)

	- Your bug report tells us what hardware, operating system,
	window system, and C compiler you are using.

Bug reports that include suggested fixes are especially welcome.

As time permits, Aladdin Enterprises will also respond to e-mail from
the following classes of users:

	- Beta testers who have actually given us at least one report on
	some beta version supplied to them.

	- People developing drivers that are for, or applications that
	are based on, Ghostscript and that will be made freely available.

	- People who express serious interest in commercial licensing
	of Ghostscript.

	- Commercial licensees.

Given the choice between the Internet and the UUCP address, remember
that the Internet is not to be used for general commercial traffic:
if you aren't sure whether you or your organization can use the
Internet, use UUCP.

Aladdin Enterprises owns or has access to the following hardware and
software:

	80486 PC, MS-DOS 5.0, Microsoft Windows 3.1;
	  Borland C++ 3.1 (and several older versions);
	  color SuperVGA display; Epson-compatible printer
	  (the printer also is compatible with the IBM Proprinter);
	  various H-P printers; Canon BubbleJet.

	SPARCstation, SunOS 4.1, cc and gcc, X11R5 and SunView;
	  both monochrome and color displays.

	DECstation, Ultrix.

If your problem turns out to be specific to some other hardware or
software configuration, it may take longer to track down, since we
will have to rely on other users to help.

If you call on the phone, you will usually be talking to an answering
machine.  In this case, please leave a message with your name and
phone number and the best time for us to return the call.

********
******** Things you can do to help ********
********

There are some projects that users could do that are somewhat
decoupled from the main body of the code, and that would help improve
Ghostscript:

	- Since Aladdin Enterprises doesn't have ready access to Unix
systems, someone else is needed to take responsibility for texinfo and/or
man page documentation for Ghostscript.  What this would involve is
updating this documentation during the beta test period for each release,
and sending it to Aladdin to be included in the final fileset.  (Aladdin
would continue to supply the plain-text documentation as it currently
exists.)

	- Ghostscript needs some good, free, Type 1 (outline) fonts.  Karl
Berry is working on this, but it might go faster if he got some
knowledgeable assistance.  Contact karl@cs.umb.edu if you want to help
with this.

	- Adobe has donated the specification of the Display PostScript C
API to the X distribution.  Implementing this API for Ghostscript might
make Ghostscript a lot more useful, since it would then be "plug
compatible" with Display PostScript in an important way.  Contact
ghost@aladdin.com if you would like to help with this.

	- On gray-scale displays, it might be worthwhile implementing
anti-aliased fonts.  To do this, one would modify the renderer so that it
cached a high-resolution bitmap, and then did the anti-aliasing as it
copied the bitmap to the device.  This would allow simulating
fractional-pixel positioning, which is one of the great benefits of
anti-aliased fonts.  Contact ghost@aladdin.com if this is of interest to
you.

	- Ghostscript currently runs on Microsoft Windows 3.0 and 3.1 on
top of MS-DOS, but does not yet run on Windows NT.  If you are interested
in helping port Ghostscript to run on Windows NT (presumably by getting it
to run using Win32/Win32s), please contact ghost@aladdin.com.

********
******** Authors ********
********

Ghostscript was originally created, and is primarily developed and
maintained, by L. Peter Deutsch, President of Aladdin Enterprises.

Special thanks are due to Russell Lang, for the gsview (Ghostview for
Microsoft Windows) program and for contributing most of the code for the
Microsoft Windows environment, and to Tim Theisen, for the Ghostview
program for X Windows and for major contributions to the code for the X
Windows environment.

The file helpers.doc contains a list of all the many other people who have
contributed significantly to improving Ghostscript.

- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

PostScript is a trademark of Adobe Systems, Incorporated.

.NH "Xware 4:  Utilities"
.PP
Congratulations on purchasing Xware 4.
This package contains a selection of X utilities.
We believe that you will find most of them to be fun to work with, and
all of them useful.
.PP
This package also holds the library
.BR libXpm.a ,
whose functions manipulate pix-mapped images;
and a manual page for every program.
.SH "What is Xware?"
Xware is a series of packages from Mark Williams Company
that bundle some of the most popular and useful software
for the X Window System.
Each program in a Xware package comes with an executable binary;
source code;
instructions and scripts to help you recompile and install the program;
and a manual page for the program edited and formatted in the \*(CO
Lexicon format, which you can view with the \*(CO command
.BR man .
.PP
Other Xware packages are available or are being prepared.
These include packages of X window managers, games, graphics,
and development tools.
Xware makes it easy and convenient for you
to enlarge your supply of X software.
.SH "System Resources"
.PP
All of the programs in this package run in eight megabytes of RAM.
.PP
The amount of disk space depends upon how many programs you install,
and whether you leave the sources archives on your system or delete them.
As a rule of thumb,
you should assume that each de-archived program and its sources
consume between one-half and one megabyte of disk space.
Directions on how to install a program are given below.
.PP
The size of the screen required varies from program to program.
A few will run on a 640\(mu480 screen; most fit into 800\(mu600;
a few require a 1024\(mu768 screen.
Those that use the 1024\(mu768 screen can, in most instances,
be run under 800\(mu600, although the image being displayed may be cropped.
If you are using a virtual window manager (e.g.,
.B fvwm
or
.BR olwm ,
both of which are included with Xware volume 1),
you can cope by sliding the screen window around; patience is recommended.
.PP
Most programs recompile correctly with the \*(CO C compiler.
A few must be recompiled with the GCC compiler, which is
not included with this package.
Each archive contains a file named
.BR README.Coh ,
which describes how to install and recompile it; and each contains a
script called
.B Install.Coh
which installs the executable and its ancillary files (if any)
onto your system.
.PP
By default,
some of the utilities in this package use fonts that are included with the
Xware 1 window-managers package.
If you do not have this package, you can either revise the resource files
for these applications so that they use fonts that are included with X
Windows for \*(CO, or you can obtain the fonts from the Mark Williams
Bulletin Board.
.SH "Contents of This Package"
.PP
The individual programs are kept in the form of compressed archives.
When you install this package onto your system, all of the archives are
copied into directory
.BR /usr/X11/utilities ,
and the manual pages are installed into directory
.BR /usr/man/Xware4 .
.PP
The following describes the contents of this package:
.IP \fBgremlin\fR
A tool for drawing pictures and diagrams.
.IP \fBnotes\fR
Write, edit, and review notes to yourself.
Notes can be ``pasted'' to the screen as reminders.
.IP \fBsunclock\fR
Display the solar time around the globe.
This utility features excellent graphics.
.IP \fBtransfig\fR
Transform graphics files created with
.B xfig
into a variety of formats, including PostScript and TeX.
.IP \fBxabacus\fR
Display a standard Chinese abacus,
on which you can count and perform
arithmetic.
This utility also comes with a series of interactive tutorials to teach
you how to use the oldest computer of them all.
.IP \fBxcalendar\fR
Display a monthly calendar.
You can write reminders and notes for each day of the month.
.IP \fBxcuckoo\fR
This program lays its ``egg'' in the title bar of a window that is owned
by another program.
It's not exactly a utility, but it does demonstrate how to program
interprocess communication under X.
.IP \fBxdu\fR
This program reads the output of the \*(CO command
.BR du ,
and translates it into a histogram that shows graphically how much disk
space directories are consuming.
.IP \fBxfig\fR
This paint program lets you draw and paint pictures interactively.
With its companion program
.BR transfig ,
you can write
.BR xfig 's
the output into a variety of formats, including PostScript and TeX.
.IP \fBxfilemgr\fR
Manipulate files interactively, using a point-and-click environment.
The graphics are impressive.
.IP \fBxman\fR
Display manual pages interactively, by pointing and clicking.
.IP \fBxmore\fR
This resembles the \*(CO command
.BR more ,
which displays text files;
except that it uses a graphical X interface and has more features.
.IP \fBxpostit\fR
Create an electronic version of the popular
``Post-it'' notes.
With this program, you can create notes,
``stick'' them onto your root window, save them, and redisplay them.
The notes come in standard sizes and ``designer colors''.
.IP \fBxpt\fR
This program displays the periodic table of the elements.
Clicking on one cell of the table displays detailed
information about that element.
.IP \fBxspread\fR
A spreadsheet program that resembles some popular commercial packages.
Included are tools to perform matrix arithmetic and graphing.
.SH "Installing This Package"
.PP
To install this package onto your system, log in as the superuser
.B root
and type the installation command:
either
.DM
	/etc/install Xware4 /dev/fva0 4
.DE
if you have a 3.5-inch floppy-disk drive, or
.DM
	/etc/install Xware4 /dev/fha0 5
.DE
if your floppy-disk drive is 5.25 inches.
.B install
copies the programs into directory
.BR /usr/X11/utilities ,
installs the few extra tools you need to recompile these programs,
and automatically installs the manual pages for the programs.
.SH "Installing an Individual Program"
.PP
As described above, each program is kept in a compressed archive in directory
.BR /usr/X11/utilities .
Each archive contains a compiled version of the program, ready for running;
the sources for the program;
a file called
.BR README.Coh ,
which describes how to recompile the program, should you wish;
and a script named
.BR Install.Coh ,
which installs the program for you.
To install a program so you can use it, do the following:
.IP \(bu 0.3i
.B cd
to directory
.BR /usr/X11/utilities .
.IP \(bu
Use the command
.B gtar
to de-archive and uncompress the archive that holds the program you want.
For example, if you want to install program
.BR xfig ,
type the command:
.DM
	gtar -xvzf xfig.gtz
.DE
.IP \(bu
Change to the directory that holds the newly de-archived program.
For example, when you un-tar archive
.BR xfig.gtz ,
the program and its source files are copied into directory
.BR xfig .
.IP \(bu
Use the command
.B su
to become the superuser
.BR root ,
and execute script
.BR Install.Coh .
Each program has such a script; it handles all the details of
installation for you.
.IP \(bu
After you have installed the program, you may wish to remove the source
code and other files that you do not need.
To do so,
.B cd
back to the program's parent directory, and use the command
.B "rm \-rf"
to remove the directory and its contents.
For example, after you have installed
.BR xfig ,
you can remove this directory by typing the following commands:
.DM
	cd ..
	rm -rf xfig
.DE
Note that the archive from which you copied the program,
.BR xfig.gtz ,
is untouched by removing the directory
.BR xfig .
You can always de-archive the program again should you wish to work with
its program files or re-install it.
.PP
If you wish to recompile a program, follow the directions given in file
.B README.Coh
in that program's source directory.
.SH Recompiling
.PP
The file
.B README.Coh
in each package describes how to recompile it.
Before you can recompile some programs, you must first install the
X update kit.
This kit contains updated versions of some X header files, of the utility
.BR make ,
and of the \*(CO C compiler, as well as modified versions of other files.
This kit is available for free from the MWC BBS, or from the
.B ftp
site
.BR raven.alaska.edu .
If you cannot contact either site, write to MWC Technical Support as described
below, and a copy will be sent to you.
.SH "Modifying Resource Files"
The resource files that are installed by default with these applications
work nicely on a color monitor.
Most also work with a monochrome display; however, in some instances you
may wish to modify them.
.PP
Consider, for example, the following entries from the resource file
.BR /usr/X11/lib/app-defaults/XPostit ,
which is used by the program
.BR xpostit .
It contains the following entries that set colors:
.DM
.ta 0.5i 2.5i
	XPostit*Background:	PeachPuff
	XPostit*Foreground:	NavyBlue
	XPostit*Text*Background:	Yellow
	XPostit*Text*Foreground:	Black
	XPostit*Plaid*Background:	Red
	XPostit*Plaid*Foreground:	Black
.DE
.PP
A monochrome server maps both red and black (the colors used by the
.B Plaid
resource) to black; therefore, instead of seeing a cheerful plaid, you will
just see a black rectangle.
To fix this problem, edit the lines to read as follows:
.DM
.ta 0.5i 2.5i
	XPostit*Background:	PeachPuff
	XPostit*Foreground:	NavyBlue
	XPostit*Text*Background:	Yellow
	XPostit*Text*Foreground:	Black
	XPostit*Plaid*Background:	White
	XPostit*Plaid*Foreground:	Black
.DE
.PP
It's not always easy to predict which colors will be mapped to black and
which to white; you may have to depend upon trial and error.
.SH "Copyrights"
.PP
Please note that the software in this package comes from third-party sources.
It is offered ``as is'', with no guarantee or warranty stated or implied,
whatsoever.
The copyrights on the source code and any executables built from it
belong to the persons who wrote the original code; full copyright
statements are included with the source code to each program.
We ask that you read and respect these statements.
.SH "Technical Support"
.PP
The sources in this package have been compiled and run successfully under
\*(CO.
If you have a problem bringing up one of the programs or with
compiling the source code as it is configured in this package, our
technical support team will attempt to help you.
However, because of the highly technical nature of the source
code in these packages, Mark Williams Company
.I cannot
give you technical assistance should you modify any of the source code
included in this package in any manner whatsoever.
.SH "A Final Word"
.PP
Most of the source code for these programs, and for the program shipped in
our other Xware packages,
is available for free on the Mark Williams bulletin board system.
The tutorial for
.B UUCP
in the \*(CO manual describes how to contact the BBS and make its services
available to you.
.PP
We hope that you enjoy using these programs!

.II UUCP^tutorial
.ds TL "UUCP Remote Communication"
.NH "UUCP, Remote Communications Utility"
.PP
\*(UU is a set of programs that together let you
communicate in an unattended manner with remote \*(CO and \*(UN sites.
The term
.I UUCP
is an abbreviation for \*(QL\*(UN to \*(UN copy\*(QR; as its name
implies, \*(UU was developed under the \*(UN operating system.
.PP
\*(UU allows your \*(CO system to talk
to other computers that also run \*(CO or \*(UN.
It can transmit files and mail to other systems and receive material from them,
without needing you to guide it by hand every step of the way.
Moreover, you can instruct
\*(UU to telephone other computers at the same time each day;
this permits regular, orderly
exchange of mail, news, and files among computers, and allows you
to take advantage of lower telephone rates during off-peak periods.
In a similar fashion, \*(UU allows other systems to log into your system,
to exchange mail or other information, and otherwise perform useful tasks.
.PP
Numerous \*(UU systems have linked together to create an informal
network called the \fIUsenet\fR.
Many megabytes of source code, news, and technical information are
available across the Usenet.
Anyone who is connected to the Usenet can exchange mail with anyone
else who is also connected to the Usenet.
All that is required to hook into the Usenet is to obtain a \*(UU
connection to anyone else who is connected to the Usenet.
.PP
You can use \*(UU only if you have telephone access to another computer that
runs \*(UU, and if your system and the remote system with which you wish to
communicate have been described to each other.
\*(UU is standard with \*(CO and \*(UN, and can be purchased for \*(MD.
If you wish to copy files from another system, you
must arrange with the system administrator of
that system before you can begin to use \*(UU.
Likewise, if you want someone else to dial into your system to upload or
download files, you must first describe that system to your copy of \*(UU.
.Sh "Contents of This Tutorial"
.PP
This tutorial describes \*(UU and tells you how to set
up and run your \*(UU system.
It contains the following sections:
.IP \(bu 0.3i
An overview of \*(UU.
.IP \(bu
How to set up your modem to dial out.
.IP \(bu
How to set up \*(UU to contact
.BR mwcbbs ,
the Mark Williams bulletin board.
.IP \(bu
How to use the \*(CO utility
.B uuinstall
to set up \*(UU to contact
.BR mwcbbs .
.IP \(bu
How to set up your \*(UU system to accept calls from remote systems.
.IP \(bu
How to use the \*(UU utilities to exchange files and mail with remote
systems.
.IP \(bu
How to debug some common problems with \*(UU.
.IP \(bu
How to administer your \*(UU system.
.IP \(bu
A brief introduction to networks.
.PP
Try as we might, there is no way to present all of \*(UU in a brief tutorial.
If you wish to explore the heights and depths of \*(UU, we urge you to
acquire the following books:
.IP \(bu 0.3i
O'Reilly, T.:
\fI!%@:: A Directory of Electronic Mail Addressing and Networks.\fR
Sebastapol, Calif, O'Reilly & Associates Inc., 1989.
.IP \(bu
O'Reilly, T.; Todino, G.:
\fIManaging UUCP and Usenet\fR.
Sebastopol, Calif, O'Reilly & Associates Inc., 1987.
.IP \(bu
Krol, E.:
\fIThe Whole Internet:
User's Guide & Catalog.\fR
Sebastopol, Calif, O'Reilly & Associates Inc., 1992.
\fIHighly recommended.\fR
.IP \(bu
Seyer M.D.:
\fIRS-232 Made Easy:
Connecting Computers, Printers, Terminals, and Modems\fR.
Englewood Cliffs, NJ, Prentice-Hall Inc., 1984.
.SH "An Overview of UUCP"
.PP
\*(UU is a set of programs that exchange files with other computers that
run \*(UU.
You can set aside files or mail messages to be transferred
to another computer; \*(UU regularly checks to see if material
has been set aside to be transferred, dials the remote system, and
exchanges the files without requiring your assistance.
.PP
This appears to be a simple function, but it can be extremely useful to you.
Suppose, for example, that you run a real-estate office
that is a member of an organization with regional and national offices.
You can tell \*(UU to call your regional office each night,
to send a file of your new listings and to accept a file
of new listings in your district that had come from other local offices.
Likewise, your association's regional office can telephone the national office
each night to receive new listings in your region, which can then be passed on
automatically to the appropriate neighborhood offices.
All of this information can be transferred at night, when telephone
rates are lowest, and without needing you to be at the console.
When you come to work the next morning, you will have the latest
listings instantly available on your terminal.
.PP
In brief, what \*(UU offers is the ability to join a \fInetwork\fR
of computers, in which every user of every computer can exchange information
with every user on every other computer, automatically.
What computer networks can do is limited only by your need to exchange
information with other computer users, and by your imagination.
.Sh "Implementations of UUCP"
.PP
.II "Taylor, Ian"
This version of \*(CO implements \fBTaylor UUCP\fR,
a \*(UU package written be Ian Taylor (\fBian@airs.com\fR)
with numerous contributions from other people in the USENET community.
\*(CO does not implement the full suite of \*(UU
utilities provided with the Taylor \*(UU package; however, it does
implement the enough utilities for you to set up a robust \*(UU site
on your system.
.PP
The source code for the full Taylor distribution is available via
.B ftp
from various sources, and can be downloaded from
.BR mwcbbs .
For a description of the full package, see Ian Taylor's documentation
for his package, which is included with your \*(CO package.
.PP
This chapter presents examples to help you learn how to set up a simple
\*(UU configuration for a remote site.
It does not discuss the more exotic features of \*(UU;
however, the information given in this chapter is sufficient
for you to set up communications with most remote sites.
.PP
For more background information on the (sometimes arcane) subjects of serial
ports and modems, see the Lexicon entries for
.BR UUCP ,
.BR modem ,
.B asy
(the serial-port driver), and
.BR RS-232 .
These discuss aspects of serial communication, and point you to other
articles that you may find helpful.
.Sh "Programs"
.PP
The \*(UU system uses the following programs to do its work:
.IP \fBuucico\fR 1.0i
Call remote systems:
log into the remote system and transfer files.
.IP \fBuuconv\fR
Convert configuration files into Taylor format.
You will use this only if you are porting your system from another
implementation of \*(UU.
.IP \fBuucp\fR
\*(UN-to-\*(UN Copy:
copy files from one computer to another.
Be sure not to confuse the command
.B uucp
with the \*(UU system, despite their similar names.
.II "Soviet Union"
(Note that the name of this utility is retained for the sake of convenience,
and because the abbreviation of the phrase \*(CO-to\*(CO Copy would remind
users of the late Soviet Union.)
.IP \fBuuencode\fR
Translate binary files into printable ASCII characters for transmission
to another system.
.IP \fBuudecode\fR
Translate files encoded by \fBuuencode\fR back into object code.
.IP \fBuuinstall\fR
This program displays a template on your screen, and helps you describe
a system to \*(UU relatively painlessly.
.IP \fBuulog\fR
Read the \*(UU logs, which record what \*(UU does.
.IP \fBuumkdir\fR
Create a directory for a remote site.
This command is invoked by
.B uuinstall
and other programs.
.IP \fBuumvlog\fR
Copy the current \*(UU log files into backup files.
Throw away all log files older than a requested number of days.
\*(UU logs everything that it does; and since it does a lot, its log files
can grow very large very quickly.
.B uumvlog
ensures both that you have enough information
on your system to diagnose problems
with uucp, and that the \*(UU log files do not overwhelm your system.
.IP \fBuuname\fR
List the systems that your computer can reach.
.IP \fBuupick\fR
``Pick up'' files that have been uploaded to your system from a remote site.
.IP \fBuusched\fR
This is a script which invoke the command
.B uucico
to call all systems that have jobs waiting for them.
.IP \fBuuto\fR
This is a script that invokes the command
.B uucp
to copy files from your system to another system via \*(UU.
.IP \fBuutouch\fR
Create a file that triggers a call to a named remote system.
.IP \fBuutry\fR
Force a call to a remote system, for debugging purposes.
.IP \fBuux\fR
Execute a command on a remote system.
.IP \fBuuxqt\fR
Check directory \fB/usr/spool/uucp/\fIsitename\fR and execute all
files therein that have the prefix ``X.''
.PP
Two other programs, while not part of \*(UU \fIper se\fR, are used by it:
.IP \fBttystat\fR 1.0i
Check the status of your asynchronous ports.
If \*(UU is not receiving files from other systems or not sending
files to other systems, it may be because the appropriate ports
have not been enabled.
.IP \fBmail\fR
Send ``electronic mail'' to another person, either on your system
or on another system via \*(UU.
.SH "Files and Directories"
.PP
As mentioned earlier, your system can use \*(UU to contact many different
remote sites, and can have many different sites contact it.
Each site differs from all others in many respects:
by its name;
by the telephone number at which you call it;
by the permissions it may grant you and you may grant it;
by the day of the week and the time of day during which you may wish to
call it;
and by the procedure you must follow to log into it.
Remote sites may also differ with regard to the port by which you contact them;
the manner in which you contact it (direct connect or via modem);
the protocol with which you exchange files;
and the name by which your system identifies itself to the remote system.
.PP
As you can see, \*(UU needs a considerable amount of information before it can
communicate with a remote site.
\*(UU reads this information from data files.
The processing of setting up communicate with a remote system means that you
write the correct information about that site into each of the appropriate
\*(UU data files.
This process will be confusing at first \(em in part
because some of the notation is rather obscure, and in part because there's
simply a lot of it, and some of the information needed may touch on aspects
of your system about which you may not know very much.
.PP
Each implementation of \*(UU has its own suite of data files that you must
manipulate to set up a remote site.
\*(UU uses the following files and directories:
.IP \fB/etc/domain\fR
This file lists the \*(UU domain.
It is read by
.BR mail .
.IP \fB/etc/uucpname\fR
Holds the name of your system, as it is known to other \*(UU sites.
.IP \fB/usr/bin/uucp\fR
The \fBuucp\fR command.
Copy a file to another system that runs \*(UU.
.IP \fB/usr/bin/uulog\fR
The \fBuulog\fR command.
.IP \fB/usr/bin/uuname\fR
The \fBuuname\fR command.
.IP \fB/usr/bin/uudecode\fR
The \fBuudecode\fR command.
.IP \fB/usr/bin/uuencode\fR
The \fBuuencode\fR command.
.IP \fB/usr/bin/uupick\fR
The
.B uupick
command.
.IP \fB/usr/bin/uuto\fr
The script
.BR uuto .
.IP \fB/usr/lib/uucp\fR
Contains \*(UU commands and system data files.
.IP \fB/usr/lib/uucp/dial\fR
This file tells
.B uucico
how to dial the modems on your system.
.IP \fB/usr/lib/uucp/port\fR
This file describes the devices that
.B uucico
uses to call each remote \*(UU site.
.IP \fB/usr/lib/uucp/sys\fR
This file describes the remote \*(UU sites that your site can call,
or that can call your site.
The command
.B uucico
(the command that actually talks with remote systems)
reads the information in this file to to connect to remote systems.
This file also names the directories on your system
into which a each remote site may read or write files;
and names the protocol or protocols that
.B uucico
uses to exchange files with a given remote system.
.IP \fB/usr/lib/uucp/uucico\fR
The \fBuucico\fR command.
.IP \fB/usr/lib/uucp/uuconv\fR
The
.B uuconv
command.
.IP \fB/usr/lib/uucp/uumkdir\fR
The
.B uumkdir
command.
.IP \fB/usr/lib/uucp/uumvlog\fR
The \fBuumvlog\fR command.
.IP \fB/usr/lib/uusched\fR
The script
.BR uusched .
.IP \fB/usr/lib/uucp/uutouch\fR
The \fBuutouch\fR command.
.IP \fB/usr/lib/uucp/uutry\fR
The \fBuutry\fR command.
.IP \fB/usr/lib/uucp/uuxqt\fR
The \fBuuxqt\fR command.
.IP \fB/usr/spool/logs/uucp\fR
Log of \*(UU activity.
.IP \fB/usr/spool/uucp/.Admin/audit.local\fR
.B uucico
stores logging information in this file
when you invoke it with with logging specified.
.IP \fB/usr/spool/uucp/.Admin/xferstats\fR
This file stores the transfer rates of files received or transmitted.
.IP \fB/usr/spool/uucp/.Log\fR
Directory containing \*(UU logfiles, as follows:
.DS
	\fB/usr/spool/uucp/.Log/uucico/\fIsitename\fR
	\fB/usr/spool/uucp/.Log/uux/\fIsitename\fR
	\fB/usr/spool/uucp/.Log/uucp/\fIsitename\fR
	\fB/usr/spool/uucp/.Log/uuxqt/\fIsitename\fR
.DE
.IP \fB/usr/spool/uucp/\fIsitename\fB/TM*\fR
.IS \fB/usr/spool/uucp/.temp/\fIsitename\fB/*\fR
These are temporary files that \fBuucico\fR generates when receiving files.
.IP \fB/usr/spool/uucp/\fIsitename\fB/C.*\fR
Files that instruct the local system either to send or to receive files.
.IP \fB/usr/spool/uucp/\fIsitename\fB/D.*\fR
Work files for outgoing and incoming files.
.II "UUCP^lock files"
.II "lck files"
.II "lock files"
.II "file locking, UUCP"
.IP \fB/usr/spool/uucp/LCK.*\fR
The ``lock'' files \*(UU uses to coordinate its resources.
When a \*(UU program attempts to access a remote site, it writes a ``lock''
file for that site.
This is to prevent \*(UU from accidentally attempting to access the same
site more than once simultaneously.
When the program that wrote the lock file exits successfully, it erases
its lock files, and so makes that site accessible to other \*(UU programs.
.IP \fB/usr/spool/uucp/.Sequence\fR
This directory contains the sequence number of the last file
handled by \*(UU.
.IP \fB/usr/spool/uucp/\fIsitename\fB/X.*\fR
Executed files.
These files will be executed by the command \fBuuxqt\fR, and are
generated by a remote system.
.IP \fB/usr/spool/uucppublic\fR
Public directory accessible by all remote \*(UU systems.
.SH "Attaching a Modem to Your Computer"
.PP
You can use \*(UU to network computers that are within the same office or
the same building.
It is far more common, though, to use uucp to connect computers that are
far apart via modem.
This tutorial assumes that you will be using uucp to exchange files via modem.
.PP
If you have not yet attached a modem to your computer, this section will give
you some useful hints.
It is straightforward to attach a modem to your computer, but you must be
careful.
.PP
First, read the documentation that comes with your modem, and look
for (1) the baud rate at which the modem operates, and (2) the command
protocol that your modem uses.
.PP
Second, check the plug on the back of your modem.
The modem will connect to your computer via a nine-pin or 25-pin D plug, also
known as an ``RS-232 interface''.
Such a plug can be either \fImale\fR or \fIfemale\fR:
the male plug has nine or 25 small pins projecting from it, whereas the
female does not.
.PP
Due to what can only be termed extreme stupidity, IBM AT and AT-compatible
computers use RS-232D plugs for both serial and parallel ports.
\fIBe sure to plug your modem into a serial port, not the parallel port, or you
can damage your computer and your modem!\fR
.PP
Third, obtain a cable to connect one of the serial ports on your computer
to the modem.
The serial ports on an IBM AT or AT-compatible computer are almost always male.
If your modem has a female plug, you will need a male-to-female cable, whereas
if your modem's plug is male (which is very rare), you will need a
female-to-female plug.
Be sure to purchase a standard modem cable for an IBM AT; practically
every computer dealer carries them.
The cable you purchase should support ``full modem control''; if
it does not say on the package, be sure to ask your dealer before you buy it.
If you are handy with a soldering iron you may be able to solder up such a
cable for yourself, but unless you know precisely
what you are doing it probably is not worth the trouble.
.PP
The Lexicon entry
.B RS-232
contains pinouts for both nine- and 25-pin connectors.
When you plug in your cable,
be sure to note whether you plugged it into port \fBcom1\fR,
\fBcom2\fP, \fBcom3\fP or \fBcom4\fP.
.PP
Fourth, reconfigure the serial port to suit your modem.
This involves the following steps:
.IP \fB1.\fR 0.3i
Log in as the superuser
.BR root .
.IP \fB2.\fR
Edit the file \fB/etc/ttys\fR.
This file normally has several lines in it, one that describes the console
and one for each serial port.
Each line has four fields:
a one-character field that indicates whether a login prompt should be
displayed (used only for devices from which people will be logging into
your system); a one-character field that describes whether the device
is local or remote (a local would be a modem from which you wished to dial
out, a remote device would be a modem from which someone could dial in);
a one-character field that describes the speed (or baud rate) at which
the device operates; and a field of indefinite length that names the
device being described.
.IP
If you have plugged into serial port \fBcom1\fR
a 9600-baud modem that will allow remote logins, edit
the line for \fBcom1\fR to read as follows:
.DM
	1rPcom1r
.DE
If you have plugged into serial port \fBcom2\fR a 2400-baud modem from
which you are only going to dial out, edit the line for \fBcom2\fR
to read as follows:
.DM
	0llcom2l
.DE
Note that the second and last character are a lower-case L, not a one.
For more information, see the Lexicon entries
for
.BR ttys .
.IP \fB3.\fR
Test if you have connected your modem.
Turn on your modem; then
log in as the superuser \fBroot\fR and type the following command:
.DM
	echo "foo" >/dev/com\fI?\fPl
.DE
where
.I ?
is the number of the port.
If you are addressing the correct port,
the lights on your modem should blink briefly.
For a more sophisticated test, try to communicate with your modem by using
the command
.BR ckermit .
If you are not familiar with
.BR ckermit ,
see its entry in the Lexicon for details.
.IP \fB4.\fR
When you have finished editing \fB/etc/ttys\fR, type the following command:
.DM
	kill quit 1
.DE
This forces \*(CO to read \fB/etc/ttys\fR and set up its ports in the
manner that you have configured them.
.PP
If you continue to have problems making connections with your modem,
see the volume \fIRS-232 Made Easy\fR, referenced above.
It describes in lavish detail how to connect all manner of devices via
the RS-232 interface.
also check the Lexicon articles \fBmodem\fR and \fBRS-232\fR for helpful
information.
.Sh "Selecting Site and Domain Names"
.PP
The first step to setting up \*(UU is to select a site name for your system.
You probably did this already when you installed \*(CO on your system,
because the \*(CO mail system does not work unless you have named your
system.
If, however, you have not yet named your system, you can do so by editing
the file
.BR /etc/uucpname .
The name you select must have eight characters or fewer, and must be
unique \(em or unique, at least, to the system into which you will log in.
Avoid names taken from popular culture, such as ``calvin,'' ``hobbes,''
or ``arnold'' \(em these have already been used many times.
See the Lexicon entry
.B uucpname
for more details.
.PP
Next, select a domain name for your system.
Again, you probably did this when you installed \*(CO.
A \fIdomain\fR is a set of \*(UU systems that together form one group with
a common name.
Even if you do not belong to a domain, you must set a domain for your system,
because
.B mail
expects it.
By convention, you can use your site name plus the suffix \fB.UUCP\fR to
create a domain.
The domain name is written into file
.BR /etc/domain .
See the Lexicon entry
.B domain
for details.
.PP
You must edit \fB/etc/uucpname\fR and \fB/etc/domain\fR to
install these names.
.SH "Set Up a UUCP Site by Hand"
.PP
This chapter walks you through the setting up of
a typical remote site, and explains what it's doing (and why) at each step
of the way.
We hope that when you have finished reading it, you will grasp at least
the principles of how \*(UU works.
.PP
Setting up \*(UU to call a remote system can be confusing and difficult,
mainly because there are many points at which this task can fail.
However, with patience and with the cooperation of the administrator of
the system that you will be contacting, you can accomplish this task.
Fortunately, once you have succeeded in exchanging files with another
system, your connection should work indefinitely without needing modification.
Fortunately, too, \*(UU is designed in such a way that you can reuse
system descriptions; so over time this process should become easier.
.PP
To set up \*(UU so it can contact another system, you must enter information
into files
.BR /usr/lib/uucp/sys ,
.BR /usr/lib/uucp/dial ,
and
.BR /usr/lib/uucp/port .
.B uucico
reads these files to learn how to communicate with a given remote system.
.PP
The rest of this section describes how to configure your system so it can
communicate with
.BR mwcbbs ,
Mark Williams Company's bulletin board.
A later section describes how to use \*(UU's commands and utilities
to work with a remote system once you have established communications.
.Sh "port:  Describe a Serial Port"
.PP
To call a given remote system, \*(UU must know about the devices
that it uses to communicate with that site.
File \fB/usr/lib/uucp/port\fR
describes ports that \fBuucico\fR can use.
.PP
Before you proceed any further, answer the following questions:
.IP \fB1\fR 0.3i
What serial device will be used for communications?
For example, the port \fB/dev/com2l\fR.
.IP \fB2\fR
At what speed will communication take place?
.IP \fB3\fR
What name will you give to this port?
.IP \fB4\fR
Does communication via this port involve a modem?
.IP \fB5\fR
If a modem is used, what dialer entry from \fB/usr/lib/uucp/dial\fR should
.B uucico
use?
.PP
With the above questions answered, let's put together our
.B port
entry.
.PP
A \fBport\fR entry begins with the lines that names the port.
Because \fBmwcbbs\fR is the system to be called for the purposes of this
example, let's call this port \fBMWCBBS\fR.
The port entry should look like this:
.DM
	port MWCBBS
	type modem
	device /dev/com2l
	baud 2400
	dialer hayes
.DE
Note that in the \fBdialer\fR line of this entry,
an underscore was used instead of a normal space character.
Do not use spaces in the
fields used to name the port, the actual device nor the dialer.
.PP
Note also the \fBtype\fR line of this port entry.
It says
.BR modem .
The only other valid value for this line is
.BR direct ,
which you would use should you be contacting a system via a wire that
runs directly from your serial port to the other system.
Because the goal here is to call
\fBmwcbbs\fR, you must specify
.BR modem .
.Sh "dial: Describe a Modem"
.PP
Because the port described above has a modem attached to it,
you must tell \fBuucico\fR how to talk to that modem.
The following example assumes that you will call
.B mwcbbs
via a 2400-bps, Hayes-compatible modem.
If you are not familiar with sending instructions to a modem,
stop here and find the manual for your modem,
or find someone familiar with modem communications before continuing.
.PP
To write the
.B dial
entry for your modem, you must answer the following questions.
Some of the questions may be unclear at first, but
don't worry \(em we'll get into the details and get you through this:
.IP \fB1\fR 0.3i
What will you name this dial entry?
For example, you could call your 2400-baud Hayes modem \fBhayes\fR.
.IP \fB2\fR
What command tells the modem to dial out?
Most Hayes-compatible modems use the command \fBATDT\fR (for Touch-Tone
telephone lines) or \fBATDP\fR (for pulse-dial lines).
.IP \fB3\fR
What message does the modem return when it connects to the remote
system's modem?
Most Hayes-compatible modems return the phrase \fBCONNECT 2400\fR).
.IP \fB4\fR
What messages does the modem send when it fails to connect to the remote
system's modem?
Example include \fBBUSY\fR,
\fBNO ANSWER\fR, \fBNO DIALTONE\fR, and \fBNO CARRIER\fR.
.IP \fB5\fR
What command tells the modem to hang up?
Most Hayes-compatible modems use the command \fBATH0\fR.
.IP \fB6\fR
How many seconds do you want to give the modem to make the connection
before \fBuucico\fR times out and gives up try to connect via this modem?
.PP
Some above information is optional,
but you should find all of it to write a thorough description of your modem.
.PP
An entry in
.B dial
begins with the line that names the modem.
In the earlier example for the
.B port
file, we decided to use the modem named \fBhayes\fR.
Therefore, the first line in our example is:
.DM
	dialer hayes
.DE
.II "chat script"
Our next step is to write a chat script for the modem.
At this point, a short discussion of chat scripts is in order.
A
.I "chat script"
gives the dialogue (or ``chat'')
that \*(UU has with a device or a remote system.
It consists of pairs of messages:
an
.I expect
message, which is a prompt that your system expects to receive from the
device or remote system, and a
.I response
message, which is what your system sends in response to it.
Spaces separate messages from each other;
therefore, you cannot use a space character within a message.
Instead, use the escape sequence \fB\es\fR to represent a space character.
If you want
.B uucico
to send a message
immediately, or to send a response message without waiting
for an expect message,
use an empty string \fB""\fR to represent the expect string.
.PP
The next line in our example give the chat script with which
.B uucico
dials your modem.
This is built from your answer to question 2, above.
Because a Hayes modem normally does not send a prompt to request a dial command,
use an empty string for the expect string.
The usual command to dial a Hayes compatible modem is \fBATDT\fR
(as described above), followed by the telephone number to dial.
The chat script for this dialogue is as follows:
.DM
	chat "" atdt\eD
.DE
Let's take a closer look at this chat script.
It begins with \fB""\fR, which tells
.B uucico
to expect nothing from the modem.
.B atdt\eD
is the message that
.B uucico
is to send to the modem.
.B atdt
is the dial command for a Touch-Tone telephone line, as noted above.
The escape sequence
.B \eD
represents the telephone number.
We use an escape sequence instead of the literal telephone number
because you can dial many different remote sites from the same modem.
.B uucico
finds the telephone number to dial from the entry for
.B mwcbbs
in the file
.BR sys ,
as will be described below.
.PP
Although this simple chat script will dial the desired telephone number,
it can be improved.
For example,
.B uucico
may fail to connect to the remote system for any number of reasons.
The more information
we can get back from the modem, the easier it will be to debug any problems
we have in connecting to the remote system.
If the modem is set up to return verbal result codes,
.B uucico
can check for these codes to determine if a connection to a remote modem
succeeded.
(For more information on \fIverbal result codes\fR,
see the manual that came with your modem.)
The following adds these features to our chat script for a Hayes-compatible
modem:
.DM
	chat "" ATQ0E1V1L2M1DT\eD CONNECT\es2400
.DE
Look at this chat script carefully.
Again,
.B uucico
expects nothing and sends a command to make the modem dial out.
The command
.B ATQ0E1V1L2M1DT\eD
has a lot of information packed into it.
It is written mostly in Hayes-ese,
so we'll break it up and show you what each portion means:
.IP \fBAT\fR 0.3i
Attention:
tell the modem that the following is a command.
.IP \fBQ0\fR
Return result codes.
.IP \fBE1\fR
Echo commands sent to it.
(You can tell
.B uucico
to log what the modem returns, so you can see exactly what it is doing.)
.IP \fBV1\fR
Use the long form of result codes.
.IP \fBL2\fR
Set the loudness of the dial tone to medium.
.IP \fBM1\fR
Turn on the speaker on the modem.
Sometimes it is helpful to hear when the modem dials out.
.IP \fBDT\fR
Dial Touch-Tone.
.IP \fB\eD\fR
The \*(UU escape sequence that represents the telephone number, as described
above.
.PP
Now, look at the end of this chat script:
we have added a second expect message.
This tells
.B uucico
that after it has dialed the telephone number for this site,
it should expect the string \fBCONNECT 2400\fR.
When
.B uucico
sees this message, it assumes that a modem connection
was successfully established and that it can continue normally.
If
.B uucico
does not see this message within a given period of time
(as will be described below) or if it receives different message,
it assumes that the connection attempt failed.
When this occurs,
.B uucico
aborts the connection attempt.
.PP
Note that, as mentioned earlier, you must use the escape sequence \fB\es\fR
to represent the space character in the phrase \fBCONNECT 2400\fR.
.PP
To review, the dial entry for dialer
.B hayes
now looks like this:
.DM
	dialer hayes
	chat "" ATQ0E1V1L2M1DT\eD CONNECT\es2400
.DE
The next line, \fBchat-timeout\fR, gives the number of seconds that
.B uucico
should wait before it quits trying to connect to a remote system.
The default is 40 seconds.
You may or may not prefer to change this value;
but for the purpose of this example,
let's assume that you want
.B uucico
to wait 60 seconds before it times out.
The
.B dial
entry for
.B hayes
now looks like this:
.DM
	dialer hayes
	chat "" ATQ0E1V1L2M1DT\eD CONNECT\es2400
	chat-timeout 60
.DE
Recall that our chat script for this modem turned on verbal result codes.
Now, it is time to take advantage of this.
Hayes compatible modems, will, in general,
return any number of messages if a connection fails, depending upon the cause
of the failure.
The entry
.B chat-fail
defines a string that the modem returns when it has failed to connect.
When
.B uucico
receives the string, it realizes that the attempt to connect has failed,
and quits.
The description for a modem can include any number of
.B chat-fail
entries.
Let's add some messages
that a typical Hayes-compatible modem might return
when it fails to connect to a remote modem.
The
.B dial
entry for the modem named
.B hayes
now looks like:
.DM
	dialer hayes
	chat "" ATQ0E1V1L2M1DT\eD CONNECT\es2400
	chat-timeout 60
	chat-fail BUSY
	chat-fail NO\esCARRIER
	chat-fail NO\esANSWER
.DE
Modem-result codes offer many advantages.
By looking for specific messages,
.B uucico
knows immediately when the modem cannot connect to a remote site, and
quits immediately rather than waiting to time out.
More important,
.BR uucico 's
log files will show why the connection failed,
which eases the debugging of connection problems.
.PP
We can add yet another safeguard to this dialer entry.
By naming \fBabort-chat\fR and \fBcomplete-chat\fR scripts,
we can tell
.B uucico
to chat again with the modem after a communication session has ended.
These scripts can, for example, ensure that the modem hangs up the
telephone and turns off error messages and echoing.
If the port for this modem normally is enabled,
then it is vital that you turn off echoing and error messages,
to prevent the modem and your \*(CO getting into an infinite
dialogue when the modem echoes \*(CO's login prompt.
For details on this problem, see the Lexicon entry for \fBmodem\fR.
The following adds
\fBabort-chat\fR and \fBcomplete-chat\fR scripts to our description of
.BR hayes :
.DM
	dialer hayes
	chat "" ATQ0E1V1L2M1DT\eD CONNECT\es2400
	chat-timeout 60
	chat-fail BUSY
	chat-fail NO\esCARRIER
	chat-fail NO\esANSWER
	complete-chat "" +++ OK ATH0E0V0Q1
	abort-chat "" +++ OK ATH0E0V0Q1
.DE
Notice that the two chat scripts are identical.
.B uucico
runs this script whenever a session ends \(em
regardless of whether it failed or completed successfully.
As with the
.B chat
script, the first entry is an empty string, to indicate that
.B uucico
should expect nothing before it sends its first response message \(em
in this case the string \fB+++\fR, which in Hayes-ese is the escape
sequence that puts the modem into command mode.
The modem replies with the message \fIOK\fR.
When
.B uucico
sees \fBOK\fR, it sends the reply
.BR ATH0E0V0Q1 ,
which is the Hayes command sequence to
(1) hang up the telephone,
(2) turn off echoing,
(3) turn off verbose error messages, and
(4) turn off error messages altogether.
.PP
Please note that the last six lines of this dialer entry are optional.
The only required lines are the first two.
.Sh "sys: Individual System Configuration"
.PP
Having completed the
.B port
and
.B dial
entries for calling
.BR mwcbbs ,
the last \(em and most difficult \(em step
is to describe
.B mwcbbs
to
.BR uucico .
This is done by writing an entry in file \fB/usr/lib/uucp/sys\fR.
The entry does the following:
.IP \(bu 0.3i
Names the remote system.
.IS \(bu
Specifies valid times to call the system.
.IS \(bu
Specifies telephone number to use when calling the system.
.IS \(bu
Specifies valid protocols to use to exchange files with the system.
.IS \(bu
Restricts read and write access for the remote system.
.PP
Before we continue,
please note that the following example is typical of an entry in
.BR sys ,
but it is by no means exhaustive.
Please refer to the Lexicon article \fBsys\fR for more information.
.PP
Now, be prepared to answer the following questions:
.IP \fB1\fR 0.3i
What is the name of the remote system?
.IP \fB2\fR
When is it legal for
.B uucico
to telephone the remote system?
.IP \fB3\fR
At what speed will communications take place?
.IP \fB4\fR
On which port will the call to the remote system be made?
.IP \fB5\fR
What telephone number, if any, must be dialed?
.IP \fB6\fR
What is the ``chat sequence'' (chat script) to be used to log into the system?
.IP \fB7\fR
What protocol should be used to transfer files?
.IP \fB8\fR
How should your system identify itself to the remote system?
.PP
An entry in 
.B sys
must begin with the line
\fBsystem \fIsysname\fR, where
.I sysname
is the name of the remote system.
This both names the remote system and tells
.B uucico
that a new entry is beginning.
Make this entry into \fBsys\fR:
.DM
	system mwcbbs
.DE
The next line of the entry, \fBtime\fR, restricts when the
.B uucico
may call the remote system.
You can restrict calls to a given day of the week
by using the following abbreviations:
.DS
	\fBWk\fR	Every weekday (Monday through Friday)
	\fBSu\fR	Sunday
	\fBMo\fR	Monday
	\fBTu\fR	Tuesday
	\fBWe\fR	Wednesday
	\fBTh\fR	Thursday
	\fBFr\fR	Friday
	\fBSa\fR	Saturday
.DE
You can restrict the time of contact;
all time notation must be in military time.
The following give some examples of day/time entries:
.DM
.ta 0.5i 2.0i
	\fB0100-0200\fR	Valid to call every day between 1 and 2 AM
	\fBMo0100-0200\fR	Valid to call every Monday between 1 and 2 AM
	\fBSa\fR	Valid to call at any time on every Saturday
	\fBAny\fR	Valid to call at any time
	\fBNever\fR	Never call the system
.DE
To restrict the valid times for calling
.B mwcbbs
to Saturday and Sunday nights from 10 to 11:15 PM, add the line:
.DM
	time SaSu2200-2315
.DE
Our \fBsys\fR entry now looks like this:
.DM
	system mwcbbs
	time SaSu2200-2315
.DE
The next line of the \fBsys\fR entry, \fBbaud\fR, is self-explanatory and is
answered by the third question above.
For this example, we will assume a speed of 2400 bps.
The
.B sys
entry now look like:
.DM
	system mwcbbs
	time SaSu2200-2315
	baud 2400
.DE
The next line, \fBport\fR, names the port that
.B uucico
is to use to telephone the remote system.
This must name a port that is defined in file
.BR port ;
in this case we'll use port
.BR MWCBBS ,
which we wrote earlier:
.DM
	port MWCBBS
.DE
The next line, \fBphone\fR, is answered by question 5, above; this, too, is
self-explanatory.
Add the following line to our
.B sys
entry:
.DM
	phone 17085590412
.DE
.B uucico
uses this telephone number to expand the escape sequence \fB\eD\fR, used in the
.B dial
entry defined above.
.II "mwcbbs^telephone numbers"
Note, by the way, that you can access
.B mwcbbs
through the following three telephone numbers:
.DS
.ta 0.5i 3.5i
	1200/2400-baud generic modem:	708-559-0412
	9600-baud Trailblazer modem:	708-559-0445
	9600-baud V.32 or HST modem:	708-559-0452
.DE
.PP
This example assumes that you have a generic 2400-baud modem; but you should
select the number that best suits your modem.
.PP
The next line, \fBchat\fR, is the chat script that
.B uucico
uses to log into the remote system.
Please refer to the previous section about the \fBdial\fR file for
a brief description of what a chat script is and how it is laid out;
or see the Lexicon entry for
.BR sys :
.DM
	chat "" \en in:--in: nuucp word: public word: \fIserialnum\fP
.DE
Please note that the string
.I serialnum
represents the serial number of your \*(CO system.
You must use this number to log into system
.BR mwcbbs .
.PP
Let's take a moment to review this line.
By the time
.B uucico
needs the information from this line,
it has already successfully dialed into and connected to one of the modems on
.BR mwcbbs .
Now it must log into the system.
The chat script tells
.B uucico
to expect nothing and to immediately send out a newline,
as represented by the escape sequence \fB\en\fR.
.PP
After
.B uucico
sends the newline character, it waits for
.BR in: ,
i.e., the final characters in the
.B mwcbbs
login prompt
.BR "mwcbbs 386 login:" .
It is not necessary to expect the entire login prompt, just enough of it to let
.B uucico
know that it can send the next message \(em in this case, your system's
login identifier.
If
.B uucico
does not receive
.BR in: ,
it sends another newline character 
and again waits for
.BR in: .
(\fB--in:\fR is equivilant to \fB-\en-in:\fR).
.PP
Once it receives
.BR in: ,
.B uucico
sends
.BR nuucp ,
which is the login name that
.B mwcbbs
expects to receive from your system.
.B uucico
now expects the message
.B word:
which is the is the tail of the prompt
.B mwcbbs
really transmits,
.BR password: .
When
.B uucico
sees
.BR word: ,
it sends 
.BR public ,
which is the password that
.B mwcbbs
expects.
Once
.B mwcbbs
receives the password it expects, it sends out a prompt for a
remote-access password \(em hence, this chat script again expects to see
.B word:
again.
When it receives this second password prompt, this chat script tells
.B uucico
to send your system's serial number.
This completes the chat script.
.PP
The
.B sys
entry for
.B mwcbbs
now looks like this:
.DM
	system mwcbbs
	time SaSu2200-2315
	baud 2400
	port MWCBBS
	phone 17085590412
	chat "" \en in:--in: nuucp word: public word: \fIserialnum\fR
.DE
Now, we will add the
.B protocol
line to this entry.
This tells
.B uucico
which protocol to use when exchanging files with the remote system.
Different implementations of \*(UU use various protocols for exchanging files.
The
.B g
protocol was the first \*(UU protocol to be invented, and is still
the most commonly used.
.II "Chesson, Greg"
(By the way, this protocol is named after its designer, Greg Chesson.)
Since then, other protocols have been invented.
Each protocol has its strengths and weaknesses; you should weigh carefully
how you are communicating with the remote system and what protocols the
remote system, supports before you select a protocol.
Please refer to the Lexicon article
\fBsys\fR for a complete list of the protocols that the Taylor \*(UU
package recognizes, and for information on when each should be used.
.PP
Please note, too, that the
.B g
protocol is not implemented uniformly by all versions of \*(UU.
For instance, some
.B g
protocols can only send data in packets of 64 bytes, using
three \fIsliding windows\fR.
Other implementations can support up to 4,096 bytes per packet,
using seven sliding windows.
The more windows supported,
the greater that transfer rate of data.
The larger the packet size per window, the greater the transfer rate of data.
For a detailed discussion of the internals of \*(UU protocols,
please refer to third-party publications
or to documentation for the Taylor \*(UU system
in the file
.BR /usr/src/alien/uudoc.tar.Z .
Taylor \*(UU can be configured from as
little as three windows and 64 bytes per packet,
to seven windows and 4,096 bytes per packet.
You can set these parameters in the \fBsys\fR file;
for details, see the Lexicon entry for
.BR sys .
In this example, we will use the default values of seven windows and 64-byte
packets.
.PP
After all of this discussion, add the following line to the
.B sys
entry we are building:
.DM
	protocol g
.DE
For the next step,
you must select the name by which your system identifies itself to
.BR mwcbbs ,
asked in question 8, above.
``But wait!'' you say.
``Didn't I answer this in the chat script that we labored over just earlier?
We identified ourselves as `nuucp'.''
Well, not exactly, as we will make clear.
.PP
The login name of
.B nuucp
is not the same as the site name with which we wish to identify ourselves.
Once our system has logged into the remote system (in this case,
.BR mwcbbs ),
the remote system fires up
.B uucico
on its end.
Once again our system must identify itself \(em but this time to
.BR uucico ,
not to the login program.
.PP
Think of the login sequence this way:
as a normal user must log in giving his
name and a password or two just to run a shell, so to must
.B uucico
log into
.BR mwcbbs .
It logs in with the name
.B nuucp
and gives the necessary passwords;
however,
.BR mwcbbs ,
instead of invoking a shell for user
.BR nuucp ,
invokes
.BR uucico
instead.
(If you look in the file
.BR /etc/passwd ,
you'll see that the last entry for each user is the program that the system
runs for that user; usually it is a shell, but sometimes it's another program,
e.g.,
.BR uucico ).
Now,
.B uucico
on
.B mwcbbs
begins to talk with
.B uucico
on your system.
The real work of transfering files can begin, as long as
.B mwcbbs
recognizes the sitename with which your system identifies itself.
.PP
.B mwcbbs
does not recognize many remote systems,
yet it receives calls from more than 100 different systems per day.
How does
.B mwcbbs
handle all of these calls if it really only knows a few dozen systems?
Most systems identify themselves by the same name,
.BR bbsuser .
.B mwcbbs
is set up to always recognize the remote site
.BR bbsuser .
.PP
Where does this name come from?
In normal circumstances, this name is read from the file
.BR /etc/uucpname .
This file holds the name you gave your system when you installed \*(CO;
you were required to select a name because electronic mail will
not work without it.
(For more information on this file, see its entry in the Lexicon.)
The odds are that you did not choose the name
.BR bbsuser .
Let's say that when you installed \*(CO onto your system, you chose the name
.BR foobar .
Now, when you system calls
.BR mwcbbs ,
by default it will identify itself to
.BR mwcbbs 's
edition of
.B uucico 
as
.BR foobar .
However,
.B mwcbbs
doesn't know
.B foobar
from Adam, so it logs your system off and hangs up the telephone.
.PP
To get around this, you must insert the line
.B myname
into the
.B sys
entry for
.BR mwcbbs .
Add this line to the sys entry we are building:
.DM
	myname bbsuser
.DE
Now, whenever your system calls
.BR mwcbbs ,
it will identify itself to
.BR mwcbbs 's
.B uucico
as
.BR bbsuser .
.PP
At this point, we could fill dozens of pages with
discussions of the items you can configure in
.BR sys .
However,  we now have all of the information we need to call
.BR mwcbbs .
For a fuller discussion of
.BR sys ,
look up its entry in the Lexicon.
.PP
For now, the completed
.B sys
entry for
.B mwcbbs
is as follows:
.DM
	system mwcbbs
	time SaSu2200-2315
	baud 2400
	port MWCBBS
	phone 17085590412
	chat "" \en in:--in: nuucp word: public word: \fIserialnum\fP
	protocol g
	myname bbsuser
.DE
There are a few other items that you will find yourself configuring as part
of a typical entry in
.B sys .
.PP
First, you must indicate whether the remote system and request files from
your system, and transfer files into it.
You may wish to deny this capacity to some remote systems, but you do want
to grant it to
.BR mwcbbs ,
as the whole point of access that system is to have it download files to you.
So, add the following two lines to the bottom of the entry for
.BR mwcbbs :
.DM
	request yes
	transfer yes
.DE
Next, you must name the directories on your system
from which the remote system can request files,
and the directories on the remote system onto which
your system has permission to write files.
By default, remote systems are limited to requesting files from directory
.B /usr/spool/uucppublic
and its subdirectories.
To change this default, add the instructions
.B remote-send
and
.B remote-receive
to the entry in
.B sys
for the remote site.
For example, suppose you decided to let
.B mwcbbs
read the directory
.BR /usr/private ,
but not
.BR /usr/private/myfiles .
You also decided to let
.B mwcbbs
write files into
.BR /tmp ,
but not into directory
.BR /tmp/secret .
To do this, add the following instructions to the
.B sys
entry for
.BR mwcbbs :
.DM
	remote-send /usr/private !/usr/private/myfiles
	remote-receive /tmp !/tmp/secret
.DE
Naming a directory in
.B remote-send
or
.B remote-receive
lets the remote system, respectively, read from that directory
and all of its sub-directories.
However, if you prefix a directory name with an exclamation point `!',
that directory and its subdirectories are specifically excluded from being
accessed by the remote system.
The following gives the normal settings for these directories:
.DM
	remote-send /usr/spool/uucppublic /tmp
	remote-receive /usr/spool/uucppublic /tmp
.DE
Next, you must name the directories from which your system can send files
to the remote system, and into which your system can write the files that
you have requested from the remote system.
These are named by, respectively, the instructions
.B local-send
and
.B local-receive .
The following gives the normal settings for these directories:
.DM
	local-send /usr/spool/uucppublic /tmp
	local-receive /usr/spool/uucppublic /tmp
.DE
If you are confused about how these instructions differ from the
instructions
.B remote-send
and
.BR remote-receive ,
just remember that the
.B remote
instructions name directories for send/receive requests initiated by
the remote system; where as the
.B local
instructions name directories for send/receive requests initiated by
your system.
.PP
One last entry needs to go into this file:
you need to name the commands that
.B mwcbbs
can execute on your system.
It needs to execute at least the commands
.B rmail
and
.B uucp
so that it can send you mail and upload files to your system.
So, add the following line to the end of the entry for
.BR mwcbbs :
.DM
	commands rmail uucp
.DE
With these lines, our
.B sys
entry for
.B mwcbbs
is complete.
It looks like this:
.DM
	system mwcbbs
	time SaSu2200-2315
	baud 2400
	port MWCBBS
	phone 17085590412
	chat "" \en in:--in: nuucp word: public word: \fIserialnum\fP
	protocol g
	myname bbsuser
	request yes
	transfer yes
	remote-send /usr/spool/uucppublic /tmp
	remote-receive /usr/spool/uucppublic /tmp
	commands rmail uucp
.DE
This is a typical
.B sys
entry for calling a remote system.
.SH "Simplifying a UUCP Configuration With uuinstall"
.PP
The program
.B /usr/bin/uuinstall
has been included to help build, modify, or delete entries in the files
.BR sys ,
.BR port ,
and
.BR dial ,
making configuring \*(UU easier.
.B uuinstall
uses a system of screens and windows to gather and organize the information
\*(UU needs to work with a remote system.
While
.B uuinstall
does not remove all of the pain from setting up communications with a
remote site, it does make this (admittedly complex) task easier.
.PP
This section shows how
.B uuinstall
can simplify the process of configuring \*(UU to communicate with
.BR mwcbbs .
.PP
If you have not read the previous section of this chapter, regarding
configuring \*(UU to call \fBmwcbbs\fR\fI, please do so now.
That section discusses in detail many topics that will not be repeated here.
In particular, look at the questions asked in the previous section
regarding configuring the files
.BR port,
.BR dial ,
and
.BR sys ,
and be prepared to answer them in this section.
.Sh "Invoking uuinstall"
.PP
To invoke
.BR uuinstall ,
just type
.B uuinstall
at the shell prompt.
.PP
For security reasons, only the superuser
.B root
and user
.B uucp
can invoke this program.
If other users could access this program,
they would have access to the information necessary
to log into the remote systems listed in
.BR sys .
Only priviledged users should have access to this information.
.PP
When you invoke
.BR uuinstall ,
the following screen appears:
.B1
.sp
                     UUCP Configuration: Main menu
.sp 3
	<s>ys file      Configuration information for specific systems
	<p>ort file     Information for individual ports
	<d>ial file     Configuration information for dialing modems
.sp 3
         Press the letter corresponding to the file you wish to examine
                            or <q> to quit
.sp
.B2
.Sh "The Port File"
.PP
The menu says it all:
choose the file to work with.
For the sake of simplicity, we will modify the system files in the same
order that we did in the extended example that appeared in the previous
section; so, press
.B p
to select the file
.BR port .
.PP
When you make your selection,
.B uuinstall
displays its \fBaction menu\fR:
.B1
.sp
	                     Action menu
.sp
	     You have selected to work with the port file.
.sp
	                Do you wish to:
	                        <a>dd an entry
	                        <d>elete an existing entry
	                        <m>odify an existing entry
	                        <v>iew an existing entry
.sp
	Press the letter corresponding to the action you wish to perform
	            or press <RETURN> for the main menu.
.sp 2
.B2
.PP
Press
.B a
to add an entry.
The following screen appears:
.B1
.sp
	         Port File Entry Screen
.sp 2
	        port   [_             ]
	        type   [     ]
	        device [/dev/             ]
	        baud   [     ]
	        dialer [              ]
.sp 2
	Enter the name that you want associated with
	   the device that this entry will define.
	          Enter nothing to cancel.
.sp 2
.B2
.PP
It is time to enter our information.
To do so, type the appropriate information into each field on the screen.
When you have entered all of the information required by that field, press
\*(RT;
the cursor drops to the next field on the screen.
.PP
When the cursor enters selected fields,
.B uuinstall
displays a help message to describe the information that you must enter.
The message will, in many cases, give an example of valid data.
.PP
If you wish not to enter anything into a given field, type \*(RT
when the cursor enters that field.
Some fields are
.IR required :
that is, the system demands that you type something into the field;
in this case, the cursor will not move until you have entered something.
After you have completed the last line,
.B uuinstall
prompts you to ask if it should add the new entry to file
.BR port .
.PP
From here, configuring a
.B port
entry is simple.
Look at the questions that we asked in the previous section
about the information that a
.B port
entry needs.
Earlier, we decided to name this port \fBMWCBBS\fR; therefore, type
.B MWCBBS
into the first field on the screen \(em the one labelled
.BR port .
Press \*(RT;
the cursor jumps to the next field, which is labelled
.BR type .
.PP
The port can be either of two types:
.B direct
or
.BR modem .
Since we're using a modem to telephone
.BR mwcbbs ,
type
.B m
into the field labelled
.BR type .
You would type
.B d
(for \fIdirect\fR) should the remote system be connected to yours via a
line that runs directly from your serial port to the remote system.
The cursor jumps to the next field, which is labelled
.BR device ,
and positions itself just to the right of the string
.BR /dev/ .
.PP
Now, type the name of the device associated with this port.
Earlier, we chose
.BR /dev/com2l .
Because
.B /dev/
is already in place, just type
.BR com2l .
Again, press \*(RT;
the cursor jumps to the field labelled
.BR baud .
.PP
Type the speed that communications will take place at:
in this example,
.BR 2400 ,
then press \*(RT.
The cursor jumps to the field labelled
.BR dialer .
.PP
Finally, type the name of the dialer script that
.B uucico
is to use to talk with the modem plugged into this port.
As you recall, our example uses the script named
.BR hayes ;
so type that into this field and press \*(RT.
.PP
The completed entry, as we typed it here, looks like this:
.B1
.sp
	       Port File Entry Screen
.sp 2
	Do you wish to write this entry? (y/n)_
.sp
	        port   [MWCBBS]
	        type   [modem]
	        device [/dev/com2l]
	        baud   [2400]
	        dialer [hayes     ]
.sp 2
.B2
.PP
.B uuinstall
now asks if you wish to write this entry into file
.BR /usr/lib/uucp/port .
Type
.BR y ,
and press \*(RT.
.B uuinstall
saves the information and returns to its main menu.
.Sh "The Dial File"
.PP
From the main menu, press
.B d
to select the file
.BR dial .
This will take us to the action menu.
Again, select
.B a
to add an entry.
.B uuinstall
then displays the following screen:
.B1
.sp 2
	                 Dial File Entry Screen
.sp
	dialer:        [_             ]
	chat:          [                                             ]
	chat-timeout:  [   ]
	chat-fail:     [                         ]
	chat-fail:     [                         ]
	chat-fail:     [                         ]
	complete-chat: [                                             ]
	abort-chat:    [                                             ]
.sp 2
	Enter the name of the dialer that
	this entry describes.
	Leaving this field blank aborts entry.
.sp 2
.B2
.PP
Begin by typing the name of the dialer script.
In the previous example, we named it
.BR hayes .
Type this in the first line; then press \*(RT.
The cursor jumps to the next field, which is labelled
.BR chat .
.PP
Now, type the chat script that
.B uucico
will use to dial the modem.
Please refer to the previous section for a discussion of what a chat
script is, and of the elements that the dialer chat should contain.
In the previous section, we decided to use the following script:
.DM
	"" ATE0Q1V1L1M0DT\eD CONNECT\es2400
.DE
Type this, then press \*(RT.
The cursor jumps to the next field, which is labelled
.BR chat-timeout .
.PP
Type the number of seconds that 
.B uucico
should wait before it aborts its attempt to dial out on the modem.
Press \*(RT;
the cursor jumps to first field labelled
.BR chat-fail .
.PP
Into the next three fields,
enter messages that the modem might return when an attempt to connect to
a remote system fails.
In the previous section, we selected the messages
.BR NO\esCARRIER ,
.BR BUSY ,
and
.BR NO\esDIALTONE .
Type the first message, then press \*(RT.
The cursor jumps to the second
.B chat-fail
field; type the second message and press \*(RT again.
The cursor jumps to the third
.B chat-fail
field; type the third message and press \*(RT once again.
The cursor jumps to the field labelled
.BR complete-chat .
.PP
Note that
.B uuinstall
gives you space to enter three
.B chat-fail
messages.
You can, however, enter an indefinite number of these messages
into a dialer script.
If you wish to enter more than three
.B chat-fail
messages, you must edit the file
.BR /usr/lib/uucp/dial
by hand.
.PP
The next two fields, respectively labelled
.B complete-chat
and
.BR abort-chat ,
let you enter the chat scripts that
.B uucico
should execute when, respectively,
a call completes successfully or fails for some reason.
As we noted in the previous section, these scripts are optional; however,
you are well advised to enter them, to ensure that the modem is returned to
its correct state after a call is completed.
In the previous section, we devised the following script for our
Hayes-compatible modem:
.DM
	"" +++ OK ATH0E0V0Q1
.DE
Type that script into the field labelled
.BR complete-chat ,
then press \*(RT.
Type again type it into the field labelled
.BR abort-chat ,
and press \*(RT again.
.PP
The completed dial entry screen should now look like this:
.B1
.sp 2
	           Dial File Entry Screen
.sp
	dialer:        [hayes     ]
	chat:          ["" ATE0Q1V1L1M0DT\eD CONNECT\es2400]
	chat-timeout:  [60]
	chat-fail:     [BUSY]
	chat-fail:     [NO\esDIALTONE]
	chat-fail:     [NO\esCARRIER]
	complete-chat: ["" +++ OK ATH0E0V0Q1]
	abort-chat:    ["" +++ OK ATH0E0V0Q1]
.sp 2
	     Do you wish to save this entry? (y/n)
.sp 2
.B2
.PP
If you are comfortable with your entry as it is, then press
.B y
to write it into
.BR /usr/lib/uucp/dial .
If not, press
.BR n .
In either case,
.B uuinstall
returns to its main menu.
.Sh "The sys File"
.PP
It is now time to describe a remote system, in this case
.BR mwcbbs ,
to this system.
From the main menu, press
.B s
to select the
.B sys
file, then select
.B a
from the action menu to add an entry to the sys file.
The following screen will appear:
.B1
.sp 2
	                      Sys File Entry Screen
.sp 2
	system:     [_       ]
	time:       [                                             ]
	speed:      [     ]
	port:       [             ] 
	phone:      [                                             ]
	chat:       [                                                       ]
	myname:     [        ]
	protocol:   [   ]
	commands:   [                                                       ]
	read-path:  [                                                       ]
	write-path: [                                                       ]
.sp 2
	Enter the name of a remote uucp system. You should
	limit the name to 8 characters.
.sp
	Leaving this field blank aborts entry.
.sp 2
.B2
.PP
Because we are using the remote system
.B mwcbbs
as our example, type
.B mwcbbs
into the field labelled
.BR system ,
then press \*(RT;
the cursor jumps to the field labelled
.BR time .
.PP
For this field, let's get a little creative.
Let's limit calling
.B mwcbbs
to after 6 PM and before 6 AM on weekdays, but permit any time on weekends.
Type the following line in the
.B time
field:
.DM
	Sa,Su,Wk1800-0600
.DE
Press \*(RT,
which moves the cursor to the field labelled
.BR speed .
.PP
Now enter the speed or (``baud rate'') at which communications will occur.
Earlier, we selected 2400 bps; so type
.BR 2400
and then \*(RT.
.PP
The cursor is now in the field labelled
.BR port .
Type the name of the port via which we will call
.BR mwcbbs .
As noted above, we will be using the port that we named
.BR MWCBBS ;
so type that into this field and then press \*(RT.
.PP
The cursor is now in the field labelled
.BR phone ,
which holds the telephone number for the remote system.
To find the telephone number for
.BR mwcbbs ,
check the release notes that came with your copy of \*(CO; then
type it into this field and press \*(RT.
The cursor jumps into the field
labelled
.BR chat ,
for the chat script.
.PP
We discussed the chat script in some detail in the previous section.
Enter the following chat script in this field:
.DM
	"" \en in:--in: nuucp word: public word: \fIserialno\fP
.DE
Remember to replace
.I serialno
with the serial number provided with your \*(CO package.
When you have finished typing the chat script, press \*(RT.
this moves the cursor to the field labelled
.BR myname .
.PP
Because
.B mwcbbs
does not grant access to just any system,
your system must identify itself as a system that
.B mwcbbs
already knows about.
.B mwcbbs
grants access to every system that identifies itself as
.BR bbsuser ;
so type
.B bbsuser
into this field, and press \*(RT.
The cursor moves into the field labelled 
.BR protocol .
.PP
This field holds the protocol with which your system will exchange files with
.BR mwcbbs .
The Taylor \*(UU package supports several protocols.
.B mwcbbs
in turn recognizes protocols
.BR a ,
.BR g ,
and
.BR i .
Please refer to the Lexicon article
.B sys
for more information on available protocols, and the strengths and weaknesses
of each.
For the purposes of this example, type
.B g
(for the
.B g
protocol), then press \*(RT.
.PP
The cursor is now in the field labelled
.BR commands ,
which lists the commands that the remote system may execute on your system.
Because
.B mwcbbs
will not be calling you, just press \*(RT.
.B uuinstall
will write a default list of commands into this field, then
move the cursor to the next field.
.PP
The last two fields, which respectively are labelled
.B read-path
and
.BR write-path ,
limit the directories that the remote system can, respectively, write into
or read from.
They point to the
.B remote-send
and
.B remote-receive
instructions within a
.B sys
entry.
Press \*(RT for each field;
.B uuinstall
will write into each field the default directory, which is
.BR /usr/spool/uucppublic .
.PP
With the template completed, your entry should look like this:
.B1
.sp 2
	                      Sys File Entry Screen
.sp 2
	system:     [mwcbbs]
	time:       [Sa,Su,Wk1800-0600]
	speed:      [2400]
	port:       [MWCBBS]
	phone:      [17085590412]
	chat:       ["" \en in:--in: nuucp word: public word: \fIserialno\fP]
	myname:     [bbsuser]
	protocol:   [g]
	commands:   [rmail rnews uucp uux]
	read-path:  [/usr/spool/uucppublic]
	write-path: [/usr/spool/uucppublic]
.sp 2
	           Do you wish to save this entry? (y/n)
.sp 2
.B2
.PP
If you are comfortable with the information you entered, press
.B y
to have it written to the file
.BR /usr/lib/uucp/sys .
.PP
This concludes our examples of configuring \*(UU to call remote systems.
Due to the extreme flexibility of the Taylor \*(UU package, it is not feasible to
review all possible configurations available to you.
Each of the configuration files,
.BR /usr/lib/uucp/sys ,
.BR /usr/lib/uucp/port ,
and
.BR /usr/lib/uucp/dial ,
can include more commands than are reviewed here.
Many of these are reviewed in the Lexicon entries for each of the files.
A complete set of ASCII text Taylor \*(UU documentation,
as provided with the distribution available from
several internet sites, is included in the file
.BR /usr/src/alien/uudoc104.tar.Z .
The complete source code for the Taylor \*(UU package as distributed with
\*(CO is available from
.BR mwcbbs .
.Sh "Modifying an Existing Entry"
.PP
The above examples show how to use
.B uuinstall
to enter a new entry into files
.BR port ,
.BR dial ,
and
.BR sys .
You can also use
.B uuinstall
to delete, view, or modify existing entries in these files.
Of these, the most useful is the feature for modifying an existing entry.
.PP
Let's say that we want to modify our entry for dialer
.B MWCBBS
to include a fourth
.BR chat-fail
instruction, for the modem message
.BR ERROR .
To do so, do the following:
.IP \(bu 0.3i
Invoke
.B uuinstall
from the shell, as described above.
.IP \(bu
When
.B uuinstall
displays its main menu, type
.BR d ,
to edit the file
.BR /usr/lib/uucp/dialer .
.IP \(bu
When
.B uuinstall
displays its action screen, type
.BR m ,
to modify this file.
.IP \(bu
.B uuinstall
then displays the names of all of the entries in this file.
Use the arrow keys on your terminal to move the cursor to the entry
that you wish to enter, in this case
.BR MWCBBS ;
then press \*(RT.
.IP \(bu
.B uuinstall
extracts the entry for
.B MWCBBS
from
.BR /usr/lib/uucp/dial ,
writes it into a temporary file, then invokes the \*(ME editor
for that temporary file.
You can use the usual \*(ME commands to edit this entry.
In this case, add the line
.DM
	chat-fail ERROR
.DE
into the entry.
.IP \(bu
When you have finished editing the entry, type
.BR <ctrl-Z> .
.IP \(bu
.B uuinstall
will prompt you and ask if you wish to save your changes.
Type
.B y
if you do,
.B n
if you do not.
.PP
Note that if you do save your changes, you can always use
.B uuinstall
to remodify the entry.
.SH "Configuring UUCP for Dial-in Access"
.PP
The above examples show how to configure your \*(UU system so that it can
dial out to another remote system.
Configuring \*(UU so that other systems can dial into your system is, for the
most part, like configuring it to dial out; but this task does present
some special problems that you must consider.
The following example shows how to set up \*(UU so that remote system
.B dalek
can dial into your system.
.Sh "Giving a Remote UUCP Site a Login"
.PP
At this point, you are now the systems administrator of your \*(CO
system who must tell someone else how to set up her \*(UU to log into
your system.
We've shown you the flip side of this by showing you how to access
.BR mwcbbs :
now the job is yours.
.PP
When a \*(UU site calls your system, it must log in as would any ordinary
user would.
Once it has logged in, however, it runs the command
.B /usr/lib/uucp/uucico
rather than a shell, which a normal user would run.
This portion of what you must set up is configured in the file
.BR /etc/passwd .
.PP
You can create a \*(UU login by running the command
.BR newusr ;
then edit the last field of the
.B /etc/passwd
entry for the login you just established to run the command 
.B /usr/lib/uucp/uucico
instead of a
.B /bin/sh
or
.BR /usr/bin/ksh .
.PP
You could also create a \*(UU login by manually editing
.B /etc/passwd
and copy the entry for user
.BR uucp ,
but change the user name of 
.B uucp
to something else.
.PP
You must also define the home directory if using
.BR newusr .
Because this is a \*(UU account, the home directory appears
under the directory
.BR /usr/spool/uucp .
For example, if you wanted site
.B dalek
to call you, you might establish an
.B /etc/passwd
entry that looks like:
.DM
	dalek:\fIpassword\fP:6:6:Coherent-Coherent \e
		copy:/usr/spool/uucp:/usr/lib/uucp/uucico
.DE
Please note that
.I password
in the entry for
.B dalek
represents the encrypted password you assigned to site
.BR dalek .
Give the password to the system administrator of site
.B dalek
so that she may properly configure her chat script to log into your system.
.PP
If we were to stop right here,
.B dalek
could call your system, log in, and begin a \*(UU session.
Unfortunately, since we've yet to configure the \*(UU
files themselves to know about
.BR dalek ,
your site would quickly terminate the call when
.B dalek
identified itself to your system after completing its chat script.
.Sh "Configuring a Spooling Directory for Remote UUCP Access"
.PP
Each \*(UU site that calls your system must have a
.I "spooling directory"
in
.BR /usr/spool/uucp .
While logged in as
.BR root ,
go to the directory
.B /usr/spool/uucp
and run the command:
.DM
	/usr/lib/uucp/uumkdir dalek
.DE
.PP
.Sh "Configuring UUCP Files"
.PP
To control what
.B dalek
does on your system,
you should describe it in file
.BR /usr/lib/uucp/sys .
\*(CO includes a dummy entry in this file that you can easily modify
for site
.BR dalek .
You should make an entry that looks like this:
.DM
	system dalek
	time Never
	commands rmail rnews uucp uux
	remote-send /usr/spool/uucppublic !/usr/spool/uucppublic/bobfiles
	remote-receive /usr/spool/uucppublic !/usr/spool/uucppublic/private
.DE
.PP
This entry names
.B dalek
as a system \*(UU recognizes.
Your system will never call
.BR dalek ,
because the \fBtime\fR command (which gives the legal dates and times
during which the remote system can be contacted) states
.BR Never .
.PP
The \fBcommands\fR instruction names the commands that you permit
.B dalek
to execute on your system.
This line overrides any permissions that may be available to
.B dalek
on the system level:
that is, this line can stop
.B dalek
from executing commands that it otherwise would have permission to
execute (e.g., \fBls\fR or \fBcat\fR), but it cannot enable
.B dalek
to execute commands that it normally would not be permitted to run
(e.g., \fBsu\fR, \fBshutdown\fR, or \fBreboot\fR).
.PP
The lines \fBremote-send\fR and \fBremote-receive\fR name, respectively,
the directories whose contents
.B dalek
can read, and the directories into which it can write files.
Once again, these lines can stop
.B dalek
from accessing directories that it otherwise would be allowed to access
(e.g., \fBtmp\fR), but they cannot give
.B dalek
permission to manipulate directories that it normally would not be able
to access (e.g., \fBbin\fR).
.PP
In brief, all you have done is identified
.B dalek
to your system, named the commands it can execute on your system,
and limited the directories it can access.
It's that easy!
.Sh "One Last, Loose Thread"
.PP
With the spooling directory created, we are almost done.
Run this command:
.DM
	/usr/lib/uucp/uutouch dalek
.DE
It will place a dummy command in
.BR dalek 's
spooling directory.
More important, it returns an error if it finds some errors in the \*(UU
configuration for
.BR dalek .
.PP
Unfortunately, we cannot give you a test system that will call your system
to test your \*(UU configuration.
You will have to use this section as a guide
to configure for another \*(UU site to call yours.
.SH "Requesting Files From a Remote UUCP System"
.PP
To request a file from a remote \*(UU system, you must know
where that file is on the remote system.
The file
.B howto.start
can be found in the directory
.B /usr/spool/uucppublic/mwcnews
on
.BR mwcbbs .
This file introduces
.BR mwcbbs ,
its features and intended uses, and how to request files from it.
.PP
With this bit of knowledge, we can now request the file with the command
.BR uucp .
.PP
.B uucp
is very simple.
Invoked it with a specific site to call, and file to upload or download.
For example, the command:
.DM
	uucp mwcbbs!/usr/spool/uucppublic/mwcnews/howto.start /tmp
.DE
tells your machine to call
.BR mwcbbs ,
download the file
.DM
	/usr/spool/uucppublic/mwcnews/howto.start
.DE
and put it into directory
.B /tmp
on your system.
The call will take place seconds after you enter the command,
unless you tell
.B uucp
to spool the request.
For more information on
this and other arguments, see the Lexicon entry for
.BR uucp .
.PP
Please note that the entry for
.B mwcbbs
in
.B /usr/lib/uucp/sys
must specify that
.B mwcbbs
can write to
.B /tmp
as part of the
.B remote-receive
instruction.
.PP
To send a file to
.BR mwcbbs ,
use the command:
.DM
	uucp \fIfilename\fP mwcbbs!/usr/spool/uucppublic/uploads/
.DE
This command uploads a copy of
.I filename
to the directory
.B /usr/spool/uucppublic/uploads
on
.BR mwcbbs .
Again, the call takes place within seconds, unless you tell
.B uucp
to spool the request.
.PP
At this point, we have completed our
.B uucp
configuration to ``talk''
to
.BR mwcbbs ,
and we have requested our first file.
You can tell
.B uucp
to download other files from
.BR mwcbbs ;
only the file names and path names will change.
.SH "Sending Files to a Remote UUCP System"
.PP
Suppose, for example that site \fBsanta\fR has been described to
your \*(UU system, and everyone has permission to read from your
current directory.
Suppose, too, that you have permission to write into directory
\fB/usr/spool/reports/parents\fR.
To send the files \fBgood.kids\fR and \fBbad.kids\fR to \fBsanta\fR,
type the following command:
.DM
	uucp good.kids bad.kids santa!/usr/spool/reports/parents
.DE
The
.B uucp
command compels \*(UU to copy one or more files from your site to a remote site.
\*(UU queues both files automatically and sends them at the next scheduled time.
.PP
Note, too, the use of the \*(Ql!\*(Qr in the above command.
The `!' separates a site name from another site name, from
a directory name, or from a user ID.
In the above example, the `!' indicates that directory
.B /usr/spool/reports/parents
can be found at site
.BR santa .
One feature of a \*(UU network is that any member can send
files to any other member.
That does not mean that every member must have full permissions
with every other member; rather, for the sake of efficiency it
is possible to route files through one or more intermediate
computers, to allow batch transmissions of files.
For example, to send the file \fBvisibility\fR
to user \fBblitzen\fR via machines
\fBsanta\fR and \fBreindeer\fR, use the following command:
.DM
	uucp visibility santa!reindeer!blitzen!/usr/spool/weather/usa
.DE
In this example, the string
.B santa!reindeer!blitzen!/usr/spool/weather
indicates that directory
.B /usr/spool/weather
can be contacted at site
.BR blitzen ,
which in turn can be contacted via site
.BR reindeer ,
which in turn can be contacted via site
.BR santa .
This scenario assumes that site \fBreindeer\fR
has permission to write into directory
.B /usr/spool/weather
on site
.BR blitzen ,
and that site
.B santa
has permission to upload files to site
.BR reindeer .
(And, of course, that you have permission to upload files to site
.BR santa .)
If any of these are not true, the transaction will fail.
.\".PP
.\"With \*(UU networks growing to international dimensions, such path
.\"names can become quite complex. 
.\"The command \fBmail\fR has an \fBalias\fR function that allows
.\"you to define a user's \*(UU path name under a simpler
.\"name that serves as that user's alias.
.\".B mail
.\"reads the file
.\".B /usr/lib/mail/aliases
.\"for every user listed on its command line.
.\"If it finds a match, then it substitutes the description in
.\".B aliases
.\"for the user name.
.\"If the entry in aliases consists of two or more fields separated by
.\"exclamation points,
.\".B mail
.\"then invokes the
.\".B uucp
.\"command to copy the mail message to the named site.
.\"For example, if you regularly send mail to user
.\".B joe
.\"at site
.\".B widget ,
.\"then insert the following entry into
.\".BR /usr/lib/mail/aliases :
.\".DM
.\"	joe:	widget!joe
.\".DE
.\"Make sure, first, that you have described site
.\".B widget
.\"to \*(UU or this will not work.
.\"Second, make sure that your local system does not have a user named
.\".BR joe ;
.\"if it does, his mail thereafter will be shipped to the other
.\".B joe
.\"at the remote site.
.SH "UUCP Administration"
.PP
Once you have written and debugged the descriptions of your ports,
dialers, and systems,
administering \*(UU consists mainly of
reviewing the log files periodically to ensure that all connections
are being made, and all programs executed correctly.
The command
.B uulog
will assist you in this.
When you type the command
.DM
	uulog widget
.DE
.B uulog
will open all of the log files associated with site
.BR widget ,
and display them for you.
Given that the log files for given site are kept in four different
directories, this can be a great convenience.
.PP
Logfiles are organized as follows:
.DM
	/usr/spool/uucp/.Log/uucico/\fIsitename\fP
	/usr/spool/uucp/.Log/uucp/\fIsitename\fP
	/usr/spool/uucp/.Log/uux/\fIsitename\fP
	/usr/spool/uucp/.Log/uuxqt/\fIsitename\fP
.DE
As you can see, one logfile for each site is kept in a directory named
after a given \*(UU command.
\*(UU records every transaction; so by reading these files, you can see
whether your \*(UU commands are succeeding.
.PP
If you are having trouble with your \*(UU connections,
send files through \*(UU and observe how they fail.
You may need to use \fBuuinstall\fR a few times to tweak your description
of the remote site.
If all else fails, contact Mark Williams Company.
.PP
If all is going well, you should run
.B /usr/lib/uucp/uumvlog
every day.
This keeps the log files from getting out of hand.
The previous section on setting the polling time describes how to do this.
.PP
The main task of the \*(UU administrator is
to monitor the \*(UU log files to see that hardware
is functioning correctly, and that files are transferred
correctly.
For example, failure to connect with a remote site after
several attempts may mean that the remote site is having
problems with its modem, or that it is scheduling outgoing
calls for when you were scheduled to call in.
Likewise, failure to receive scheduled calls from several
sites may indicate equipment failure on your end.
.PP
Finally, the \*(UU administrator must monitor the use of
disk space on the system.
Old mail and messages, multiple copies of files, and files
automatically input by various subscription and network services
can eat up disk space rapidly; you must prune extraneous material
ruthlessly.
.SH "Networks"
.PP
\*(UU becomes truly useful when you are hooked into a network of machines
that exchange information.
Through \*(UU, you can gain access to the Internet,
through which you can exchange news and mail with others users
around the world.
.PP
This section briefly describes the services you can obtain from
a network, and the networks now available.
.Sh Services
.PP
Many different services are available from networks:
domain-name service (DNS), mail exchanger service, and connectivity.
.PP
.II "UUCP^domain-name service"
DNS is the registration of an Internet-style domain,
e.g.,
.B mwc.com
or
.BR baqaqi.chi.il.us .
This usually divides into two subservices \(em
registration in an existing domain, and registration of your own domain.
For this service you need two sites on the Internet willing
to either register you in their nameserver or run a nameserver for
your domain.
A
.I nameserver
gives other people's machines information
about your registered machine or registered domain.
In particular, the nameserver publishes an MX record,
which tells machines how to get mail to you.
(There are other kinds of records, but MX
records are the important ones for \*(UU sites.)
.PP
.II "UUCP^mail forwarding"
MX service is mail forwarding.
The MX record published by the
nameserver must point at a machine directly on the Internet.
This machine will the be responsible for figuring out how to actually get
the mail to you.
.PP
.I Connectivity
usually means a \*(UU connection.
Because almost everybody
in a major city is connected to everyone else, a \*(UU connection
to anybody effectively translates to an indirect connection to the Internet.
.Sh "Available Networks"
.PP
.II UUCP^UUNET
.II UUNET
.B UUNET
is a company in Falls Church, Virginia, that provides a large
number of networking services, including all of those mentioned above.
.PP
.II UUCP^UUCP network"
The
.B "UUCP network"
is an extremely
informal group of machines defined only by the fact that they connect
to each other via the \*(UU protocol.
It is one of the largest
networks in the world and has no central control.
.PP
.II UUCP^UseNet
.II UseNet
.B UseNet
is a network of machines defined by the fact that they
exchange UseNet news with each other.
UseNet is also an anarchy \(em
no central organization runs it.
It includes machines in the \*(UU network and the Internet,
as well as hundreds of other networks.
It is the largest network in the world.
.PP
.II Internet
.II UUCP^Internet
The
.B Internet
is a group of high-speed networks which all
communicate with
.IR "Internet Protocol" ,
.II TCP/IP
.II UUCP^TCP/IP
i.e., TCP/IP.
The networks that
comprise the Internet are mostly academic and research networks run by
large central organizations, such as the National Science Foundation or
the Australian Academic Research Project.
The center of the Internet
is the NIC (Network Information Center), whose address is
.BR nic.ddn.mil .
.PP
The
.B internet
(lower-case `i') is defined by connectivity under mail.
It is technically larger than UseNet, though
less is said about it because it is so weakly defined.
.PP
For information on networks, what is available on them, and how to connect
to them, we strongly recommend the book \fIThe Whole Internet:
User's Guide and Catalog\fR, cited above.
For a copy, check your local bookstore, or telephone the publisher,
O'Reilly & Company, at 1-800-998-9938.
.SH "Debugging UUCP Problems"
.PP
When you have a problem with \*(UU \(em and in particular, a problem with
telephoning another \*(UU system \(em you must have
a clear picture of what is occurring, and what is not occurring.
For instance, if you try to call
.B mwcbbs
and \*(UU fails, you must determine what is working properly
before the failure takes place.
.PP
The following subsections describe common problems with \*(UU, and gives
some hints on how to solve them.
Please review them
.I carefully
before you telephone Mark Williams Company to ask for help.
If you do not, we will ask that you do review them and call back
only if you still cannot solve the problem.
.Sh "Define the Problem Exactly"
.PP
\*(UU problems can take many forms.
Define the problem
.IR exactly .
This process may actually help you solve the problem.
Statements like ``I'm having a problem using \*(UU'' or
``\*(UU doesn't work'' do not describe problems relating to \*(UU.
You need to know
.I exactly
what does or does not happen when you try to connect with another site.
Please review it before you call Mark Williams Technical Support.
.\" i.e., RTFM!
.PP
Before you do anything else, trying running
.B uucp
and
.B uucico
with the option
.BR \-x .
This option tells these programs to log what they do; the logs are written
into the subdirectories of directory
.BR /usr/spool/uucp/.Admin .
Often, these log messages will point directly to the problem.
.PP
A subtle error within a \*(UU configuration file can cause no end
of grief when you try to debug a \*(UU problem.
To help spot these potential problems,
run the command \fB/usr/lib/uucp/uuchk\fR.
This command generates a full report on your configuration files.
It will spot and report on syntax errors in your configuration files.
You will, of course, have to fix by hand whatever
.B uuchk
finds to be in error.
.PP
The following sections discuss commonly encountered problems.
.Sh "Enabling and Disabling Ports"
.PP
.II enable
.II disable
On some \*(CO systems, the permissions for the programs
.B /etc/enable
and
.B /etc/disable
are set to:
.DM
	-r-x------   root     root
.DE
That is, these commands can be executed only by user
.BR root .
This is to close a security hole; otherwise, a person who breaks into
your system can disable any port she wants \(em including the console.
.PP
If you have only one modem, and you both initiate and receive \*(UU
sessions on that modem, you may run into problems with enabling and
disabling that port.
.II uucico^permissions
For the communications program
.B uucico
to be able to enable and disable the port on its own,
.B /etc/enable
and
.B /etc/disable
must have the permissions:
.DM
	-r-s--s--x   root     root
.DE
These permissions permit
.B uucico
to dial out on an enabled port on its own; but it reopens the security hole.
.I "Caveat utilitor."
.PP
.II chmod
For information on how to change permissions, see the Lexicon entry for the
command
.BR chmod .
.Sh "Stale Requests and Multiple Requests"
.PP
From time to time, you may accidentally issue the same
.B uucp
request more than once.
.PP
Note that if
.B uucp
fails because you failed to connect with the remote site,
one action you should
.I not
take is to repeat the
.B uucp
command.
If you do this,
.B uucp
will simply queue another request for the same file or files that you
requested with the previous
.B uucp
command.
When connection is finally made, multiple
.B uucp
requests will be executed, thus downloading multiple copies of the same file
or files.
Depending upon the size of the file or files, this could be an expensive
mistake.
.PP
To remove stale requests, log in as user
.B uucp
or user
.BR root ;
then
.B cd
to directory \fB/usr/spool/uucp/\fIsitename\fR and remove the extraneous
requests.
(You can also do this to remove mail files about which you have had second
thoughts.)
.PP
Note that a
.B uucp
generates one file, which has the prefix
.BR C .
A mail message generates two files:
one with the prefix
.BR C ,
which tells the remote system what to do with the mail message; the
other has the prefix
.BR D ,
which holds the text of the message.
Read the existing files to make sure that you are removing the correct
files.
.Sh "Problems With Lock Files"
.PP
If
.B uucico
wishes to dial on a modem but somebody else is already using it,
you will see the message
.DM
	ERROR: All matching ports in use
.DE
in the log file for the site
.B uucico
is attempting to call.
The solution simply is to wait until the port clears.
.PP
If
.B uucico
is already communicating with a given remote system, or if a lock
file exists for a given remote system, you will see the message
.DM
	ERROR: System already locked
.DE
in the log file for the site
.B uucico
is attempting to call.
.PP
Sometimes lock files are not cleared properly, and so tie up the system
long after they should have been removed.
Such files are called
.I stale
lock files.
The solution is to use the command
.B uurmlock
to remove stale files.
.PP
Note that in some instances, permission problems may stop
.B uurmlock
from removing lock files.
In this case, log in as the superuser
.B root
and execute the command:
.DM
	rm /usr/spool/uucp/LCK*
.DE
.Sh "Enabling Ports, /etc/ttys Problems"
.PP
.B uucico
reads a port's status in file
.BR /etc/ttys ,
then restores that status after it finishes its work.
If you had disabled a port by hand, it remains disabled after
.B uucico
has worked with it \(em which means, of course, that no remote system
can dial into your system via that port.
To re-enable a port, use the command
.BR /etc/enable .
.PP
Note, too, that file
.B /etc/ttys
is sensitive to the order in which devices are named within it.
The port into which you have plugged your modem must have an entry for
both the remote device (e.g.,
.BR /dev/com1r )
and the local device (e.g.,
.BR /dev/com1l ).
Note that the entry for the raw device
.I must
precede the entry for the local device.
If it does not,
.B uucico
will not be able to dial out properly.
.PP
Note, too, that device
.B /dev/console
.I must
be the last entry in
.BR /etc/ttys ,
or your system will not be able to dial out via a serial port.
.Sh "Permission Problems"
.PP
Incorrect permissions on
files and directories will harm \*(UU's behavior.
.PP
.B uucico
runs as a user named
.B uucp
and therefore does not have any special permission or privileges
that give it free access to every file or directory on your system.
For example, consider what \*(UU does when it attempts to contact a
remote system:
.IP \fB1.\fR 0.3i
The daemon
.B uucico
checks the directory
.B /usr/spool/uucp
to see if any lock files are present;
these lock files indicate whether someone has already logged into the port
from which
.B uucico
wishes to dial out.
.IP \fB2.\fR
If
.B uucico
finds a lock file for the port it wants to use, it checks the file
.B /usr/lib/uucp/sys
for information on an alternate way to contact the remote system.
If
.B uucico
finds an alternate way to contact the remote system, it tries that way.
If it does not, then it quits.
.IP \fB3.\fR
When
.B uucico
finds a port that is available,
it then check file
.B /etc/ttys
to see if the port is already enabled for remote logins.
.IP \fB4.\fR
If the port is enabled,
.B uucico
disables the port and makes its call.
.PP
So far, so good.
If, however,
.B uucico
does not have read and write permission on the port device from which
it is attempting to make its call, its attempt to make the call will fail.
.PP
For another example of how directory-level permission affect the behavior
of \*(UU, consider how \*(UU transfers files.
When \*(UU transfers files,
it stores those files as temporary files in the directory
\fB/usr/spool/uucp/\fIsitename\fR,
where
.I sitename
is the name of the system with which \*(UU is communicating.
All files and directories under
.B /usr/spool/uucp
must be owned by user
.B uucp
and group
.BR uucp ,
or \*(UU cannot transfer files correctly.
.PP
\*(UU can also write temporary files into directory
\fB/usr/spool/uucp/.Temp/\fIsitename\fR.
This directory must also be owned by user and group
.BR uucp .
.PP
The permissions on the serial port from which you will dial out
can affect the behavior of \*(UU.
\*(UU must have permission to read and write to that port.
The device specified by the
.B line
entry in 
.B /usr/lib/uucp/port
should have permissions of
.B 666
(see the Lexicon entry for the command
.BR chmod ).
.PP
.B uucp
should own all of its spooling directories.
The
.I "spooling directory"
is the directory into which
\*(UU writes stores data and command files for the site being contacted.
The spool directory for a given remote site resides under
.B /usr/spool/uucp
and is named after the remote site.
For example, your system will use directory
.B /usr/spool/uucp/mwcbbs
to store files being exchanged with
.BR mwcbbs .
Likewise,
.B mwcbbs
has the directory \fI/usr/spool/uucp/\fIyoursystem\fR,
where \*(UU stores
files to be exchanged with
.IR yoursystem .
.Sh "UUCP Cannot Find Its Own Files"
.PP
If the command
.B /usr/bin/uucp
says it can not get its own name when you invoke it,
then you give yourself a \*(UU site name of no more than
seven characters in the file
.BR /etc/uucpname .
.PP
The command
.B /bin/mail
command may also return a similar message.
The cure is the same.
.PP
As noted above,
a \*(UU command may also fail to execute because permissions are
set up incorrectly on the \*(UU executables.
\*(UU commands frequently invoke one another.
For instance,
.B uucico
invokes
.B uuxqt
after it has communicated with a remote system.
.B uuxqt
processes all files uploaded from the remote system.
.B uuxqt
may, in turn, invoke other commands \(em for example, it can invoke
.B smail
to deliver mail to a user on your
system or forward mail to a user on another remote system.
If the permissions on a \*(UU executable are incorrect,
it may find that, when it tries to complete a task, it
does not have permission to write to a given directory or a log.
A list of \*(UU permissions appears in the Lexicon entry for
.BR UUCP .
Make sure that the permission on your file conform to what is given there.
.Sh "Modem Configuration"
.PP
The commonest source of error lies in modem configuration.
Each modem has its idiosyncrasies, and command languages differ from
device to device; however, in general your modem should be configured
as follows:
.IP \(bu 0.3i
Echo off.
.IS \(bu
No result codes.
.IS \(bu
Carrier detect (DCD) is true.
.IS \(bu
Terminal ready (DTR) is true.
.IS \(bu
DCD follows DTR.
.PP
If you are working with a high-speed modem (9600 baud or faster),
you should also configure it to do the following:
.IP \(bu 0.3i
Lock modem to computer baud rate at 19,200
if your modem supports it;, if not, lock it to 9600 baud.
.IS \(bu
Set modem for RTS/CTS handshaking.
.IS \(bu
Use a flow-control device for the port's description in file
.BR /usr/lib/uucp/port .
See the Lexicon entry
.B asy
for details on how to do this.
.PP
Telebit modems present special problems for configuration.
They are designed to be used with \*(UU, and in general
they are fast and robust; but
because they do more than ordinary modems, they require more
extensive setup to work correctly.
The Lexicon entry for
.B modem
gives detailed information on how to set up a Trailblazer modem so that
it works properly with the \*(CO implementation of \*(UU.
.PP
If your modem supports data compression, it may not be ideal to use this
feature with every remote site.
For instance, attempting to compress files that already are compressed
(as are the files on the Mark Williams bulletin board),
only adds to the data stream and
.I reduces
overall throughput.
Before you turn on data compression, make sure that the files you are
downloading are
.I not
compressed.
.Sh "The Modem Does Not Respond"
.PP
When you try to call a system via the commands
.B /usr/bin/uucp
or
.B /usr/lib/uucp/uucico
and the modem does not respond (i.e., the lights on the modem do not
flicker), look at file
.BR /usr/lib/uucp/port .
Check the permissions on the
serial port used to dial out on, as specified therein.
.PP
In some cases, you will see the error message
.DM
	Retry time not reached
.DE
Taylor \*(UU puts a horizon on callouts:
if a call to a given site fails, \*(UU will wait a predetermined
amount of time before it tries again.
If you are repeatedly invoking
.B uucp
or
.B uucico
from the command line, you may see this error.
To get around this limitation, use the command-line option
.BR \-f ;
for example:
.DM
	uucico -s systemname -f
.DE
This problem can also arise if a previous connection to a site failed.
In this case, \*(UU writes a bad-connection report into file
.DM
	/usr/spool/uucp/.Status/\fIsystemname\fP
.DE
where
.I systemname
names the system you are trying to contact.
\*(UU does this to keep your system from wasting time contacting a system
whose connection is defective, even if you use the \fB\-S\fR option with
.BR uucico .
Remove this file and \*(UU will resume dialing out.
Note that this will not clear up the problem that triggered the
original bad-connection report, and the connection may fail for other reasons.
.Sh "The Modem Responds But Does Not Dial"
.PP
In some cases, the modem responds (i.e., its lights flicker)
but it does not dial out.
This can have any of several causes.
.PP
First, the modem's register settings may be incorrect.
Review them.
Check the above example for some simple examples of how to set
modem registers, and check the documentation that came with your modem.
.PP
You may be trying to access the modem through the remote COM port,
e.g.,
.BR /dev/com1r .
In this instance, the system awaits a carrier signal, as you cannot
open a remote COM port without; therefore, no communication ever begins.
The solution is to use the local device, e.g.,
.BR /dev/com1l .
This way, the system will not wait for the carrier to come up on the modem,
and dialing will begin.
.Sh "The Modem Dials But No Connection Made"
.PP
Sometimes a modem will dial out but no connection is made.
This is typically caused by plugging the telephone line
into the wrong port on the modem.
.PP
Check the log file for the site you are calling.
It will usually give a message that indicates what the problem really is.
If calling
.BR mwcbbs ,
use the command:
.DM
	uulog mwcbbs
.DE
.Sh "The Modem Dials, Carrier Is Established, Nothing Else Happens"
.PP
The first suspect is the modem's register settings.
The modem register settings that we discussed above generally work well for
.B uucp
to dial out to another system,
.I if
your modem is Hayes-compatible.
If it is not, or if it is an off-brand that only
.I claims
to be Hayes-compatible,
check your modem's documentation and make sure that
the register settings are correct.
.PP
To get a picture of what is happening, run the command
.B /usr/lib/uucp/uucico 
with the option \fB-xchat\fR.
If calling
.BR mwcbbs ,
use the command:
.DM
	/usr/lib/uucp/uucico -Smwcbbs -xchat
.DE
This tells your system to call
.B mwcbbs
and to write debugging information into its log file
.BR /usr/spool/uucp/.Admin/audit.local ,
which you can review later.
This is very useful in determining if there is a problem in a chat script.
.Sh "uulog Shows Lost Packets"
.PP
If your \*(UU communication sessions terminate prematurely,
your system may be losing characters on the serial ports.
An indication of this problem is the appearance of the message
.B "Lost Packets"
in your \*(UU logs.
If your system exhibits these symptoms during transfers on 4800-bps or
higher-speed lines,
.I
we strongly urge you to replace your existing
8250- or 16450-based UARTs with those based upon the 16550A design,
such as the National Semiconductor NS16550AFN.
.R
These newer UARTs are pin-compatible with the older UARTs.
\*(CO automatically senses and enables them when it boots.
.Sh "uulog Shows Incorrect Response"
.PP
This points to one of four problems:
.IP \fB1.\fR 0.3i
Your site is sending an improper site name
to the remote system (in other words, the remote site doesn't
know about your system).
.IP \fB2.\fR
The remote site does not have a spooling directory
for your site.
.IP \fB3.\fR
Your site does not have a spooling directory for the remote
site
.IP \fB4.\fR
.B /usr/lib/uucp/sys
contains an error or incorrect chat script.
.Sh "Files Refuse To Be Sent or Cannot Be Received"
.PP
Check the instructions
.BR local-send ,
.BR local-receive ,
.BR remote-send ,
and
.BR remote-receive
in the remote system's entry in file
.BR /usr/lib/uucp/sys .
This can result in the remote system being denied permission to load files
onto your system, or read files from it.
Make sure these instructions are set correctly, and point to directories
in which user
.B uucp
has read and write permission.
.Sh "File Transfers Fail With imsg Statements"
.PP
One problem is frequently encountered when \*(CO systems attempt to \*(UU
with Sun workstations:
connections are made correctly, but when file transfers fail with numerous
iterations of the debug message ``imsg'' until the script times out.
This is caused by differences in parity:
the \*(CO chat scripts by default use no parity,
while those on the other system do.
The solution is to change the chat script on the Sun system to set
no parity when it talks with \*(CO system.
.Sh "Files are Being Lost"
.PP
If a configuration problem exists on your side of a \*(UU connection,
files could be lost.
This may be true if
.B uucico
or
.B uuxqt
are running with incorrect permissions.
Taylor \*(UU notes problems of this nature in its log files.
If it can preserve a file that would otherwise be lost,
.B uucico
saves the file in directory
.BR /usr/spool/uucp/.Preserve ,
and logs the fact that it has saved it.
.Sh "Non-COHERENT UUCP Site Problems"
.PP
It is important to understand that \*(CO's \*(UU is designed to be
compatible with other implementations of \*(UU, but may not use the same
configuration files.
This can complicate the debugging of problems when you attempt to establish
communication with a system that uses a different implementation of \*(UU.
.PP
We will supply whatever assistance we can, but if it is
determined that the non-\*(CO site is part of the problem,
it is up to you to find how that non-\*(CO site has configured itself.
You may even need to set up a
conference call among yourself, the remote site's administrator,
and MWC Technical Support.
.SH "Where to Go From Here"
.PP
As we mentioned earlier, \*(CO does not now implement the entire Taylor \*(UU
package.
Full sources for Taylor \*(UU are available from
.BR mwcbbs ,
and from various sites on the Internet.
.PP
This tutorial only touches upon the esentials of configuring \*(UU for
communicating with other systems.
Taylor \*(UU is much more conformable than this tutorial may have led you
to believe.
.PP
For a fuller description of the Taylor \*(UU configuration files, see the
Lexicon entries for
.BR dial ,
.BR port ,
and
.BR sys .
For further information, check the Lexicon entry for each \*(UU command,
as well as the overview article
.BR UUCP .
This article will also point you to related articles in the Lexicon,
such as the ones for
.B modem
and
.BR RS-232 .

.IP \fBbash\fR 1.0i
The ``Bourne-again shell'' \(em a more fully featured
version of the Bourne shell.
.BR /bin/sh .
.IS \fBbison\fR
This is the GNU version of
.BR yacc .
.IS \fBcat\fR
Print the contents of a file to the standard output.
.IS \fBchgrp\fR
Change the group ownership of a file.
.IS \fBchmod\fR
Change a file's permissions.
.IS \fBchown\fR
Change the owner of a file.
.IS \fBcmp\fR
Compare two files byte-by-byte.
.IS \fBcomm\fR
Print the common lines in two files.
.IS \fBcp\fR
Copy one or more files.
.IS \fBcsplit\fR
Split a file into sections determined by context lines.
.IS \fBcut\fR
Remove sections from each line of a file.
.IS \fBdd\fR
File conversion utility.
.IS \fBdiff\fR
Summarize the differences between two files.
.IS \fBdiff3\fR
Summarize the differences among three files.
.IS \fBdir\fR
List the contents of a directory.
.IS \fBdu\fR
Disk usage:
summarize the usage of space on a device.
.IS \fBexpand\fR
Convert tabs to spaces.
.IS \fBfgrep\fR
Search a file for a pattern match.
.IS \fBflex\fR
The GNU equivalent of
.BR lex ,
the lexical analyzer generator.
.IS \fBfold\fR
Wrap each input line to fit a specified width.
.IS \fBginstall\fR
Copy files and set their attributes.
.IS \fBhead\fR
Output the beginning portion of a file.
.IS \fBjoin\fR
Join lines of two files on a common field.
.IS \fBln\fR
Create a link to a file.
.IS \fBls\fR
List the contents of a directory.
.IS \fBmake\fR
Program-building discipline.
.IS \fBmawk\fR
GNU's other implementation of the
.B awk
pattern scanning language.
.IS \fBmkdir\fR
Create a directory.
.IS \fBmkfifo\fR
Create a named pipe.
.IS \fBmknod\fR
Create a character- or block-special file.
.IS \fBmv\fR
Move/rename a file.
.IS \fBmvdir\fR
Rename a directory.
.IS \fBnl\fR
Number the lines of a file.
.IS \fBpaste\fR
Merge two files.
.IS \fBperl\fR
``Practical Extraction and Report Language'' \(em a mixture of
.BR awk ,
.BR yacc ,
and C that combines the best \(em or worst \(em features of all.
.IS \fBpr\fR
Paginate text files, to make them suitable for printing.
.IS \fBrm\fR
Remove a file.
.IS \fBrmdir\fR
Remove a directory.
.IS \fBsed\fR
Non-interactive stream editor.
.IS \fBsort\fR
Sort a text file.
.IS \fBsplit\fR
Split a file into pieces.
.IS \fBsum\fR
Checksum and count the blocks in a file.
.IS \fBtac\fR
Concatenate and print file in reverse order \(em from last line to first.
.IS \fBtail\fR
Output end of a file.
.IS \fBtar\fR
Create/extract \fBtar\fR-format archives.
.IS \fBtr\fR
Translate or delete characters in an input stream.
.IS \fBunexpand\fR
Convert spaces to tabs.
.IS \fBuniq\fR
Remove or find duplicate lines from a sorted file.
.IS \fBvdir\fR
Display an expanded listing of a directory's contents.
.IS \fBwc\fR
Count the number of bytes, words, and lines in a file.

.SH "Bibliography"
.II "bibliography"
.PP
The following books may be helpful in
developing your skills with C.
This list also contains all books that are referenced in this manual.
It is by no means exhaustive; however, it
should prove helpful to both beginners and experienced
programmers.
.PP
American National Standards Institute:  \fIDraft Programming
Language C (October 1986 Draft)\fR.  Washington, D.C.: X3 Secretariat,
Computer and Business Equipment Manufacturers Association, 1986.
.PP
AT&T Bell Laboratories:  \fIThe C Programmer's Handbook\fR.
Englewood Cliffs, N.J.:  Prentice-Hall, Inc., 1985.
.PP
Chirlin, P.M.:  \fIIntroduction to C\fR.  Beaverton, Or.:  Matrix
Publishers, Inc., 1984.
.PP
Derman, B. (ed.):  \fIApplied C\fR.  New York: Van Nostrand Reinhold Co.,
Inc., 1986.
.PP
Feuer, A.R.:  \fIThe C Puzzle Book\fR.
Englewood Cliffs, N.J.:  Prentice-Hall, Inc., 1982.
.PP
Gehani, G.:  \fIAdvanced C:  Food for the Educated Palate\fR.
Rockville, Md.:  Computer Science Press, 1985.
.PP
Hancock, L.: Krieger, M.:  \fIThe C Primer\fR.
New York:  McGraw-Hill Book Publishers, Inc., 1982.
.PP
Harbison, S.; Steele, G.:  \fIC: A Reference Manual\fR.
Englewood Cliffs, NJ: Prentice-Hall, Inc., 1984.
.PP
Hogan, T.:  \fIThe C Programmer's Handbook\fR.
Bowie, Md.:  Brady Publishing, 1984.
.PP
Kelley, A.; Pohl, I.:  \fIC by Dissection:
The Essentials of C Programming\fR.
Menlo Park, Ca.: The Benjamin/Cummings Publishing Company, Inc.,
1987.
.PP
Kernighan, B.W.; Ritchie, D.M.:  \fIThe C Programming Language\fR.
Englewood Cliffs, N.J.:  Prentice-Hall, Inc., 1978.
.PP
Kernighan, B.W.; Plauger, P.J.:  \fIThe Elements of Programming Style\fR,
ed. 2.  New York:  McGraw-Hill Book Co., 1978.
.PP
Kochan, S.G.:  \fIProgramming in C\fR.
Hasbrouck Heights, N.J.: Hayden Book Co., Inc., 1983.
.PP
Knuth, D.E.:  \fIThe Art of Computer Programming\fR, vol. 1:  \fIBasic
Algorithms.\fR  Reading, Ma.:  Addison-Wesley Publishing Co., 1969.
.PP
Knuth, D.E.:  \fIThe Art of Computer Programming\fR, vol. 2:  \fISeminumerical
Algorithms.\fR  Reading, Ma.:  Addison-Wesley Publishing Co., 1969.
.PP
Knuth, D.E.:  \fIThe Art of Computer Programming\fR, vol. 3:  \fISorting
and Searching.\fR  Reading, Ma.:  Addison-Wesley Publishing Co., 1969.
.PP
Plum, T.:  \fILearning to Program in C\fR.
Cardiff, N.J.:  Plum Hall, Inc., 1983.
.PP
Plum, T.:  \fIC Programming Guidelines\fR.
Cardiff, N.J.:  Plum Hall, Inc., 1984.
.PP
Plum, T.; Brodie, J.:  \fIEfficient C\fR.
Cardiff, NJ:  Plum Hall, Inc., 1985.
.PP
Purdum, J.:  \fIC Programming Guide\fR.
Indianapolis:  Que Corp., 1983.
.PP
Purdum, J.; Leslie, T.C.; Stegemoller, A.L.:  \fIC Programmer's Library\fR.
Indianapolis:  Que Corp., 1984.
.PP
Traister, R.J.:  \fIProgramming in C for the Microprocessor User\fR.
Englewood Cliffs, N.J.:  Prentice-Hall, Inc., 1984.
.PP
Traister, R.J.:  \fIGoing from BASIC to C\fR.
Englewood Cliffs, N.J.:  Prentice-Hall, Inc., 1984.
.PP
Vile, R.C., Jr.:  \fIProgramming in C with Let's C\fR.
Glenview, IL: Scott, Foresman and Company, 1988.
.PP
Waite, M.; Prata, S.; Martin, D.: \fIC Primer Plus\fR.
Indianapolis: Howard W. Sams, Inc., 1984.
.PP
Weber Systems, Inc.:  \fIC Language User's Handbook\fR.
New York:  Ballantine Books, 1984.
.PP
Zahn, C.T.:  \fIC Notes\fR.
New York:  Yourdan Press, 1979.
.if \nX=1 \{\
.Sh "i8086/MS-DOS information"
.II "MS-DOS references"
.II "i8086 references"
.PP
Duncan, R.: \fIAdvanced MS-DOS: The Microsoft guide for assembly language
and C programmers.\fR
Redmond, WA:  Microsoft Press, 1986.
\fIRecommended.\fR
.PP
IBM Corporation: \fITechnical Reference, Personal Computer XT\fR.
Boca Raton, FL: International Business Machines Corporation, 1983.
.PP
Intel Corporation: \fI8086 Relocatable Object Module Formats\fR.
Document No. 121748-001.
Santa Clara, CA: Intel Corporation.
.PP
Intel Corporation: \fI8086/8087/8088 Assembly Language Reference Manual
for 8086-Based Development Systems\fR.
Santa Clara, CA: Intel Corporation, 1983.
.PP
Intel Corporation: \fIiAPX 286 Programmer's Reference Manual\fR.
Santa Clara, CA: Intel Corporation, 1985.
.PP
Microsoft Corporation: \fIMS-DOS Technical Reference Encyclopedia.\fR
Bellevue, WA: Microsoft Press, 1986.
.PP
Norton, P.: \fIThe Peter Norton Programmer's Guide to the IBM PC.\fR
Bellevue, WA: Microsoft Press, 1985.
.PP
Young, M.:  \fIPerformance Programming Under MS-DOS.\fR
Alameda, CA:  SYBEX, Inc., 1987.
\fIRecommended.\fR \}
.if \nX=2 \{\
.Sh "Atari ST information"
.II "Atari ST references"
.PP
Balma, P.; Fitler, W.:  \fIProgrammer's Guide to GEM\fR.
Berkeley, Calif.:  SYBEX, Inc., 1986.
.PP
Digital Research Institute:  \fIGEM Programmer's Guide\fR.
Pacific Grove, Calif.:  Digital Research Institute, Inc., 1984.
.PP
Field, S.; Mandis, K.; Myers, D.:
\fICOMPUTE!'s ST Applications Programming in C\fR.
Greensboro, NC: COMPUTE! Publications, Inc., 1987.
\fIRecommended.\fR
.PP
General Instrument Corporation:  \fIProgrammable Sound Generator
Data Manual\fR.  Hicksville, N.Y.: General Instrument Corporation, 1981.
.PP
Gerits, K.; Englisch, L.; Bruckmann, R.:  \fIAtari ST Internals:
The Authoritative Insider's Guide.\fR
Grand Rapids, Mich.: ABACUS Software, Inc., 1986.
.PP
Leemon, S.:
\fICOMPUTE!'s Technical Reference Guide:
Atari ST, Volume 1: VDI\fR.
Greensboro, NC: COMPUTE! Publications, Inc., 1987.
.PP
\fIM68000 16/32-Bit Microprocessor Programmer's Reference Manual\fR, ed. 4.
Englewood Cliffs, N.J.: Prentice-Hall, Inc., 1984.
.PP
Oren, T.: \fIProfessional GEM\fR.
Available through CompuServe, ANTIC-ONLINE, Atari ST forum.
\fIRecommended.\fR
.PP
Szczepanowski, N.; Gunther, B.:  \fIAtari ST GEM Programmer's Reference.\fR
Grand Rapids, Mich.: ABACUS Software, Inc., 1986. \}
.if \nX=3 \{\
.Sh "Intel information"
.II "Intel references"
.PP
The following documents are available from Intel Corporation:
.PP
\fIPL/M-86 User's Guide\fR, publication no. 121636.
.PP
\fIPSCOPE 86 User's Guide\fR, publication no. 121790.
.PP
\fI8086/8087/8088 Assembly Language Reference Manual for 8086-Based
Development Systems\fR, publication no. 121627.
.PP
\fIIntellec Series III Console Operating Instructions\fR,
publication no. 121609.
.PP
\fIIntellec Series III Programmer Reference Manual\fR,
publication no. 121618.
.PP
\fIIntellec Series IV Operating and Programming Guide\fR,
publication no. 121753.
.PP
\fIiAPX 86,88 Family Utilities User's Guide\fR,
publication no. 121616.
.PP
\fIRun-Time Support Manual for iAPX 86,88 Applications\fR,
publication no. 121776.
.PP
\fI8086 Relocatable Object Module Formats\fR,
publication no. 121748. \}
.if \nG=1 \{\
.PP
\fIiAPX286 Utilities User's Guide\fR,
publication no. 121934.
.PP
\fIASM286 Assembly Language Reference Manual\fR,
publication no. 121924. \}

/v/doc/coherent/lx/raise
/v/doc/coherent/lx/ram
/v/doc/coherent/lx/ramdisk
/v/doc/coherent/lx/rand
/v/doc/coherent/lx/rand_max
/v/doc/coherent/lx/random
/v/doc/coherent/lx/random_ac
/v/doc/coherent/lx/ranlib
/v/doc/coherent/lx/rc
/v/doc/coherent/lx/read-only
/v/doc/coherent/lx/read.c
/v/doc/coherent/lx/read.s
/v/doc/coherent/lx/readdir
/v/doc/coherent/lx/readline
/v/doc/coherent/lx/readonlyc
/v/doc/coherent/lx/readonlyk
/v/doc/coherent/lx/realloc
/v/doc/coherent/lx/reboot
/v/doc/coherent/lx/recursion
/v/doc/coherent/lx/recv
/v/doc/coherent/lx/recvfrom
/v/doc/coherent/lx/ref
/v/doc/coherent/lx/regcomp
/v/doc/coherent/lx/regerror
/v/doc/coherent/lx/regexec
/v/doc/coherent/lx/regexp.h
/v/doc/coherent/lx/register
/v/doc/coherent/lx/registerv
/v/doc/coherent/lx/regsub
/v/doc/coherent/lx/remove
/v/doc/coherent/lx/rename
/v/doc/coherent/lx/reprint
/v/doc/coherent/lx/resetterm
/v/doc/coherent/lx/restor
/v/doc/coherent/lx/return
/v/doc/coherent/lx/rev
/v/doc/coherent/lx/rewind
/v/doc/coherent/lx/rewinddir
/v/doc/coherent/lx/rindex
/v/doc/coherent/lx/rm
/v/doc/coherent/lx/rmail
/v/doc/coherent/lx/rmdir.c
/v/doc/coherent/lx/rmdir.s
/v/doc/coherent/lx/root
/v/doc/coherent/lx/route
/v/doc/coherent/lx/routers
/v/doc/coherent/lx/rpow
/v/doc/coherent/lx/rs-232
/v/doc/coherent/lx/rsmtp
/v/doc/coherent/lx/rubik
/v/doc/coherent/lx/runq
/v/doc/coherent/lx/rvalue

.IP \fBafio\fR 1.0i
\fBfile_utils/afio.zip\fR
(disk 2)
.br
A `smart'
.BR cpio -format
archiver.
.IP \fBbasic\fR
\fBlanguage/basic.zip\fR
(disk 1)
.br
A BASIC interpreter.
.IP \fBbyacc\fR
\fBlanguages/byacc.zip\fR
(disk 1)
.br
A Berkeley-style
.BR yacc .
.IP "\fBckermit 1.88\fR"
\fBcommunication/ckermit188.zip\fR
(disk 1)
.br
The latest version of the popular
.B kermit
communications package from Columbia University.
.IP "\fBcomb 1.48\fR"
\fBmail/comb148.zip\fR
(disk 1)
.br
The popular alternative to COHERENT's mail program.
.IP \fBdte\fR
\fBeditor/dte.zip\fR
(disk 1)
.br
A screen editor that used WordStar-style command sequences.
.IP \fBelvis\fR
\fBeditor/elvis.zip\fR
(disk 3)
.br
The full source kit used to build
.BR elvis ,
the clone of the UNIX editor
.B vi
that is included with COHERENT 4.0.
.IP \fBempire\fR
\fBgames/empire.zip\fR
(disk 2)
.br
A war game between you and the computer, in which your
war efforts are supported by the various cities you own.
.IP "\fBminicom 1.33\fR"
\fBcommunication/mc133.tar.Z\fR
(disk 3)
.br
A popular communcations package that features
VT-100 emulation and supports external file-transfer protocols.
.IP \fBtcsh\fR
\fBshell/tcsh.zip\fR
(disk 2)
.br
A popular clone of the Berkeley C shell.
.IP \fBtex2roff\fR
\fBmisc/tex2roff.zip\fR
(disk 4)
.br
A utility that translates
texinfo documents into a format printable by
.B nroff
or
.BR troff .
.IP "\fBtin 1.18\fR"
\fBnews/tin118.zip\fR
(disk 3)
.br
A news reader and posting program.
.IP "\fBTaylor UUCP 1.04\(*g\fR
\fBcommunication/tay104g.zip\fR
\fBcommunication/taybin.zip\fR
(disk 4)
.br
The latest version of the Taylor UUCP package.
.\" and yes, folks, it *really* works
It features an implementation of the Berkeley utility
.B cu
and supports various UUCP file-transfer protocols.
.IP \fBwanderer\fR
\fBgames/wanderer.zip\fR
(disk 2)
.br
Wander through a magical cave as you pick up riches and
fight monsters along the way.
.IP \fBworld\fR
\fBgames/world.tar.Z\fR
(disk 3)
.br
A text-based adventure that takes place on another world.
.IP \fBxscheme\fR
\fBlanguage/xscheme.zip\fR
(disk 1)
.br
An interpreter of the SCHEME language.

.ds TI "Floppy Tape for COHERENT"
.ds TL "Release Notes"
.NH "COHERENT Update for Floppy Tape"
.PP
These notes describe how to install the new \*(CO driver
for QIC-40/QIC-80 (``floppy tape'') devices.
This driver is in a kit that is on the single floppy disk included with
these notes.
.SH "Before You Begin"
.PP
Before you begin installation of this kit,
please note that you must have \*(CO release 4.2.10 or later to use the
\*(CO floppy-tape driver.
If you do not yet have \*(CO 4.2.10, send e-mail to
.BR updates@mwc.com .
You will be sent by a copy without charge.
If you do not have e-mail, write to
.B Support
at the address given in the \*(CO manual.
.PP
Note, too, that installing this disk replaces the contents of directory
.B /etc/conf
and its sub-directories.
You should use the command
.B gtar
or
.B cpio
to back up this directory before you install this kit.
The installation script backs up this directory,
but it never hurt to be doubly sure.
.PP
Finally, copy the kernel that you boot by default into a backup file.
This will let you back out from this kit should something go wrong.
.SH "Installing the Kit"
.PP
To install the kit, log in as the superuser
.BR root ,
or use the command
.B "shutdown single 0"
to bring the system down to single-user mode.
Then run one of the following versions of the command
.BR install .
Which version you run depends upon whether you are installing from
floppy-disk drive A or B, and whether that drive is 3.5 or 5.25 inches,
as follows:
.IP "3.5-inch Drive A"
If you are installing from a 3.5-inch drive 0 (drive A),
use this command:
.DM
	/etc/install -c ft_1 /dev/fva0 1
.DE
.IP "3.5-inch Drive B"
If you are installing from a 3.5-inch drive 1 (drive B),
use this command:
.DM
	/etc/install -c ft_1 /dev/fva1 1
.DE
.IP "5.25-inch Drive A"
If you are installing from a 5.25-inch drive 0 (drive A),
use this command:
.DM
	/etc/install -c ft_1 /dev/fha0 1
.DE
.IP "5.25-inch Drive B"
If you are installing from a 5.25-inch drive 1 (drive B),
use this command:
.DM
	/etc/install -c ft_1 /dev/fha1 1
.DE
.PP
After it copies the bits from the floppy disk,
the installation script invokes the command
.B /etc/conf/bin/idbld
to link a new \*(CO kernel, called
.BR /coh.ft .
It then links this kernel to
.B /autoboot
so that it is loaded by default when you boot your system.
If you want to save your old default kernel,
copy it into a backup file.
For example, if your default kernel is named
.BR /coherent ,
use the command:
.DM
	cp /coherent /coherent.bak
.DE
Please note that must be the superuser
.B root
to execute this command.
.PP
Command
.B idbld
asks about how your system is configured.
Because installing this update disk replaces the directory
.B /etc/conf
and all of its sub-directories,
you must enable the hard-disk device driver (or drivers) for your system,
and repeat the system configuration you specified when you last installed
or updated \*(CO.
A good test to see whether the new system is
configured the same as before is to look at files
.B /etc/conf/sdevice
and
.B /etc/conf/stune
both before and after the update, and make sure any
old entries have not changed inadvertently.
.PP
After you have installed, we suggest that you test the tape drive, as follows:
.IP \(bu 0.3i
Try making several archives of varying size on tape.
The utilities
.B gtar
and
.B cpio
are optimally suited for this.
.IP \(bu
Try concatenating several archives onto the same tape.
The manual page for
.BR backups ,
which is included with these notes, describes how to do this.
.IP \(bu
Use the
.B \-d
option with
.B gtar
to verify the contents of the archive.
.PP
For further information, see the attached note and the revised manual pages
provided on the floppy disk.
.Sh "Documentation"
.PP
The following pages give printed versions of updated manual pages for
the commands
.B tape
and
.BR ftbad ,
for technical information on tape and backup procedures, and for the driver
.BR ft .

.II "awk^tutorial"
.ds TL "The awk Language"
.NH "Introduction to the awk Language" 1
.PP
\fBawk\fR is a general-purpose language for processing text.
With \fBawk\fR, you can manipulate strings,
process records, and generate reports.
.PP
.II "Aho, A.V."
.II "Weinberger, P.J."
.II "Kernighan, Brian W."
.B awk
is named after its creators:
A. V. Aho, P. J. Weinberger, and Brian W. Kernighan.
Unfortunately, its name suggests that
.B awk
is awkward \(em whereas in truth the
.B awk
language is simple, elegant, and powerful.
With it, you can perform many tasks that would otherwise require
hours of drudgery.
.PP
\fBawk\fR uses a simple syntax.
Each statement in an \fBawk\fR program contains
either or both of two elements:
a \fIpattern\fR and an \fIaction\fR.
The pattern tells \fBawk\fR what lines to select from the input stream;
and the action tells \fBawk\fR what to do with the selected data.
.PP
This tutorial explains how to write
.B awk
programs.
It explains how to describe a pattern to \fBawk\fR.
It also describes the range of actions that
.B awk
can perform;
these include formatted printing of text,
assigning variables, defining arrays, and controlling the flow of data.
.SH "Example Files"
.PP
Before you begin to study
.BR awk ,
please take the time to type the following text files that
are used by the examples in this tutorial.
.PP
The first is some text from Shakespeare.
Use the command \fBcat\fR to type it into the file
.BR text1 ,
as follows.
Note that \fB<ctrl-D>\fR means that you should hold down the \fBCtrl\fR
(or \fBcontrol\fR) key and simultaneously press `D'.
Do not type it literally.
.DM
.II "Shakespeare, William"
	cat > text1
	When, in disgrace with fortune and men's eyes,
	I all alone beweep my outcast state,
	And trouble deaf heaven with my bootless cries,
	And look upon myself, and curse my fate,
	Wishing me like to one more rich in hope,
	Featured like him, like him with friends possest,
	Desiring this man's art and that man's scope,
	With what I most enjoy contented least.
	Yet in these thoughts myself almost despising,
	Haply I think on thee - and then my state,
	Like to the lark at break of day arising
	From sullen earth, sings hymns at heaven's gate;
	For thy sweet love remember'd such wealth brings
	That then I scorn to change my state with kings.
	<ctrl-D>
.DE
.II "Ruth, Babe"
The second example consists of some of Babe Ruth's batting statistics,
which we will use to demonstrate how \fBawk\fR processes tabular input.
Type it into file
.BR table1 ,
as follows:
.DM
	cat > table1
	1920	.376	54	158	137
	1921	.378	59	177	171
	1922	.315	35	94	99
	1923	.393	41	151	131
	1924	.378	46	143	121
	1925	.290	25	61	66
	1926	.372	47	139	145
	1927	.356	60	158	164
	1928	.323	54	163	142
	1929	.345	46	121	154
	<ctrl-D>
.DE
The columns give, respectively,
the season, the batting average, and the numbers of
home runs, runs scored, and runs batted in (RBIs).
.PP
The rest of this tutorial presents many examples that use these files.
Type them in and run them!
In that way, you can get a feel for
.B awk
into your fingers.
Experiment; try some variations on the examples.
Don't be afraid of making mistakes; this is one good way to learn the
limits (and the strengths) of a language.
.SH "Using awk"
.PP
\fBawk\fR reads input from the standard input
(entered from your terminal or from a file you specify),
processes each input line according to a specified \fBawk\fR program,
and writes output to the standard output.
This section explains the structure of an \fBawk\fR program
and the syntax of \fBawk\fR command lines.
.Sh "Command-line Options"
.PP
.II "awk^command-line options"
The complete form for the \fBawk\fR command line is as follows:
.DM
	\fBawk\fR  [\fB-y\^\fR] [\fB\-F\fIc\^\fR] [\fB\-f \fIprogfile\^\fR] [\fIprog\^\fR] [\fIfile1\^\fR] [\fIfile2\^\fR] ...
.DE
The following describes each element of the command line.
.IP \fB\-y\fR
Map
.I patterns
from lower case to both lower-case and upper-case letters.
For example, with this option the string
.B the
would match
.B the
or
.BR The .
.IP \fB\-F\fIc\fR
Set the field-separator character to the character
.IR c .
The field-separator character and its uses are described below.
.IP "\fB\-f \fIprogfile\fR"
Read the
.B awk
program from
.I progfile .
.IP \fIprog\fR
An
.B awk
program to execute.
If you do not use the
.B -f
option, you must enter
.BR awk 's
statements on its command line.
.sp \n(pDu
Note that if you include
.BR awk 's
program on its command line (instead of in a separate file),
you must enclose the program between apostrophes.
Otherwise, some of the
.B awk
statements will be modified by the shell before \fBawk\fR ever sees them,
which will make a mess of your program.
For example:
.DM
	awk 'BEGIN {print "sample output file"}
	            {print NR, $0}'
.DE
(The following sections explain
what the stuff between the apostrophes means.)
However, if you include the statement within a file that you pass to
.B awk
via its \fB\-f\fR option, you must \fInot\fR enclose the statements within
parentheses; otherwise,
.B awk
will become very confused.
If you were to put the statements in the above program into an
.B awk
program file, they would appear as follows:
.DM
	BEGIN {print "sample output file"}
        {print NR, $0}
.DE
.IP "\fIfile1 file2 ...\fR"
The files whose text you wish to process.
For example, the command
.DM
	awk '{print NR, $0}' text1
.DE
prints the contents of
.BR text1 ,
but precedes each line with a line number.
.sp \n(pDu
If you do not name an input file,
.B awk
processes what it reads from the standard input.
For example, the command
.DM
	awk '{print NR, $0}'
.DE
reads what you type from the keyboard and echoes it preceded with a line
number.
To exit from this program, type
.BR <ctrl-D> .
.SH "Structure of an awk Program"
.PP
.II "awk^statement"
An
.B awk
program consists of one or more statements of the form:
.DS
	\fIpattern \fB{ \fIaction \fB}\fR
.DE
Note that
.B awk
insists that the
action
be enclosed between braces, so that it can distinguish the action
from the pattern.
.PP
A program can contain as many statements
as you need to accomplish your purposes.
When
.B awk
reads a line of input,
it compares that line with the \fIpattern\fR in each statement.
Each time a line matches \fIpattern\fR,
\fBawk\fR performs the corresponding \fIaction\fR.
.B awk
then reads the next line of input.
.PP
A statement can specify an \fIaction\fR without a \fIpattern\fR.
In this case,
.B awk
performs the action on every line of input.
For example, the program
.DM
	awk '{ print }' text1
.DE
prints every line of
.B text1
onto the standard output.
.PP
An \fBawk\fR program may also specify a pattern without an action.
In this case, when an input line matches the pattern,
\fBawk\fR prints it on the standard output.
For example, the command
.DM
	awk 'NR > 0' table1
.DE
prints all of
.B table1
onto the standard output.
Note that you can use the same pattern in more than one statement.
Examples of this will be given below.
.PP
.BR awk 's
method of forming patterns uses
.I "regular expressions"
(also called
.IR patterns ),
like those used by the \*(CO commands
.BR sed ,
.BR ed ,
and
.BR egrep .
Likewise,
.BR awk 's
method of constructing actions is modelled after the C programming language.
If you are familiar with regular expressions and with C, you should have
no problem learning how to use
.BR awk .
However,
if you are not familiar with them, they will be explained in the following
sections.
.Sh "Records and Fields"
.PP
.II "awk^records"
.II "awk^fields"
\fBawk\fR divides its input into
.IR records .
It divides each record, in turn, into
.IR fields .
.II "awk^input-record separator"
.II "awk^input-field separator"
Records are separated by a character called
the
.IR "input-record separator" ;
likewise, fields are separated by the
.IR "input-field separator" .
.B awk
in effect conceives of its input as a table with an indefinite
number of columns.
.PP
The newline character is the default input-field separator,
so \fBawk\fR normally regards each input line as a separate record.
The space and the tab characters are
the default input-field separator,
so white space normally separates fields.
.PP
To address a field within a record, use the syntax \fB$\fIN\fR, where
.I N
is the number of the field within the current record.
The pattern \fB$0\fR addresses the entire record.
Examples of this will be given below.
.II "awk^output-record separator"
.II "awk^output-field separator"
In addition to input record and field separators,
\fBawk\fR provides output record and field separators,
which it prints between output records and fields.
The default output-field separator
is the newline character;
\fBawk\fR normally prints each output record as a separate line.
The space character is the default output-field separator.
.SH "Patterns"
.PP
This section describes how
.B awk
interprets the pattern section of a statement.
.Sh "Special Patterns"
.PP
.II "awk^special patterns"
.II "awk^pattern, special"
To begin,
.B awk
defines and sets a number of special \fIpattern\fRs.
You can use these patterns in your program for special purposes.
You can also redefine some of these patterns to suit your preferences.
The following describes the commonest such special
.IR patterns ,
and how they're used:
.II "awk^BEGIN"
.IP \fBBEGIN\fR
This pattern matches the beginning of the input file.
.B awk
executes all
.I actions
associated with this pattern before it begins to read input.
.II "awk^END"
.IP \fBEND\fR
This pattern matches the end of the input file.
.B awk
executes all
.I actions
associated with this pattern after it had read all of its input.
.II "awk^FILENAME"
.IP \fBFILENAME\fR
.B awk
sets this pattern to the name of the file
that it is currently reading.
Should you name more than one input file on the command line,
.B awk
resets this pattern as it reads each file in turn.
.II "awk^FS"
.IP \fBFS\fR
Input-field separator.
This pattern names the character that
.B awk
recognizes as the field separator for the records it reads.
.II "awk^NF"
.IP \fBNF\fR
This pattern gives the number of fields within the current record.
.II "awk^NR"
.IP \fBNR\fR
This pattern gives the number of the current record within the
input stream.
.II "awk^OFS"
.IP \fBOFS\fR
Output-field separator.
.B awk
sets this pattern to the character that it writes in its output to
separate one field from another.
.II "awk^ORS"
.IP \fBORS\fR
Output-record separator.
.B awk
sets this pattern to the character that it writes in its output to
separate one field from another.
.II "awk^RS"
.IP \fBRS\fR
Input-record separator.
.B awk
sets this pattern to the character by which it separates records
that it reads.
.Sh "Arithmetic Relational Expressions"
.II "awk^arithmetic operators"
.PP
An
.I operator
marks a task to be within an expression,
much as the `+' or `/' within an arithmetic expression indicates
that the numbers are to be, respectively, added or divided.
You can use \fBawk\fR's operators to:
.IP \(bu 0.3i
Compare a special pattern with a variable, a field, or a constant.
.IS \(bu
Assign a value to a variable or to a special pattern.
.IS \(bu
Dictate the relationship among two or more expressions.
.PP
The first type of operator to be discussed are
.IR "arithmetic relational operators" .
These compare the input text with an arithmetic value.
.B awk
recognizes the following arithmetic operators:
.DS
	\fB<\fR	Less than
	\fB<=\fR	Less than or equal to
	\fB==\fR	Equivalent
	\fB!=\fR	Not equal
	\fB>=\fR	Greater than or equal to
	\fB>\fR	Greater than
.DE
With these operators, you can compare a field with a constant;
compare one field with another;
or compare a special pattern with either a
field or a constant.
.PP
For example, the following
.B awk
program prints all of the years in which Babe Ruth hit more than
50 home runs:
.DM
	awk '$3 >= 50' table1
.DE
(As you recall, column 3 in the file
.B table1
gives the number of home runs.)
The program prints the following on your screen:
.DM
	1920	.376	54	158	137
	1921	.378	59	177	171
	1927	.356	60	158	164
	1928	.323	54	163	142
.DE
The following program, however, shows the years in which Babe Ruth scored
more runs than he drove in:
.DM
	awk '$4 > $5 { print $1 }' table1
.DE
Remember, field 4 in file
.B table1
gives the number of runs scored, and field 5 gives the number of
runs batted in.
You should see the following on your screen:
.DM
	1920
	1921
	1923
	1924
	1928
.DE
In the above program, expression
.DM
	{print $1}
.DE
defines the action to perform, as noted by the fact that expression is
enclosed between braces.
In this case, the program tells
.B awk
that if the input record matches the pattern, to print only the first
field.
However, to print both the season and the number of runs scored, use the
following program:
.DM
	awk '$4 > $5 { print $1, $4 }' table1
.DE
This prints the following:
.DM
	1920 158
	1921 177
	1923 151
	1924 143
	1928 163
.DE
Note that
.B $1
and
.B $4
are separated by a comma.
.II "awk^,"
The comma tells
.B awk
to print its default output-field separator between columns.
If we had left out the comma, the output would have appeared as follows:
.DM
	1920158
	1921177
	1923151
	1924143
	1928163
.DE
As we noted above, the special pattern
.B OFS
gives the output-field separator.
.B awk
by default defines this special pattern to the space character.
If we wish to redefine the output-field separator,
we can use an operator, plus the special pattern
.BR BEGIN ,
as follows:
.DM
	awk 'BEGIN { OFS = ":" }
		$4 > $5	{ print $1, $4 }' table1
.DE
This prints:
.DM
	1920:158
	1921:177
	1923:151
	1924:143
	1928:163
.DE
The first statement
.DM
	BEGIN { OFS = ":"}
.DE
tells
.B awk
to set the output-field separator (the special pattern \fBOFS\fR)
to `:' before it processes any input (as indicated by the special
pattern \fBBEGIN\fR).
.PP
Although we're getting a little ahead of ourselves, note that there's
no reason to print the fields in the order in which they appear in
the input record.
For example, if you wish to print the number of runs scored before the
season, use the command:
.DM
	awk 'BEGIN { OFS = ":"}
		$4 > $5	{ print $4, $1 }' table1
.DE
This prints:
.DM
	158:1920
	177:1921
	151:1923
	143:1924
	163:1928
.DE
As you recall, the special pattern
.B NR
gives the number of the current input record.
You can execute an action by comparing this pattern with a constant.
For example, the command
.DM
	awk 'NR > 12' text1
.DE
prints:
.DM
	For thy sweet love remember'd such wealth brings
	That then I scorn to change my state with kings.
.DE
That is, the program prints every line after line 12 in the input file.
As you recall, a statement that has a pattern but no action
prints the entire record that matches the pattern.
.PP
As we saw with the special patterns, some patterns can be defined to
be numbers and others to be text.
If you compare a number with a string,
.B awk
by default makes a string comparison.
The following example shows how \fBawk\fR
compares one field to part of the alphabet:
.DM
	awk '$1 <= "C"' text1
.DE
This program prints:
.DM
	And trouble deaf heaven with my bootless cries,
	And look upon myself, and curse my fate,
.DE
The statement
\fB$1 <= "C"\fR selected all records that begin
with an ASCII value less than or equal to that of the letter `C' (0x43) \(em
in this case, both lines that begin with `A' (0x41).
If we ran this example against
.BR table1 ,
it would print every record in the file.
This is because each record begins with the character `1' (0x31), which
matches the pattern \fB$1 <= "C"\fR.
.PP
Finally, you can use a numeric field plus a constant in a comparison
statement.
For example, the following program prints all of the seasons in which
Babe Ruth had at least 100 more runs batted in than home runs:
.DM
	awk '$3 + 100 < $5 {print $1}' table1
.DE
This prints the following:
.DM
	1921
	1927
	1929
.DE
.Sh "Boolean Combinations of Expressions"
.PP
.II "awk^Boolean operators"
.B awk
has a number of operators, called
.I Boolean
operators, that let you hook together several small expressions
into one large, complex expression.
.B awk
recognizes the following Boolean operators:
.DS
	\fB||\fR	Boolean OR (one expression or the other is true)
	\fB&&\fR	Boolean AND (both expressions are true)
	\fB!\fR	Boolean NOT (invert the value of an expression)
.DE
.II "Boole, George"
(The eponym ``Boolean'' comes from the English mathematician George Boole.)
In a Boolean expression,
.B awk
evaluates each sub-expression to see if it is true or false;
the relationship of sub-expressions (as set by the Boolean operator)
then determines whether the entire expression is true or false.
.PP
For example, the following program prints all seasons in which
Babe Ruth hit between 40 and 50 home runs:
.DM
	awk '$3 >= 40 && $3 <= 50 { print $1, $3 }' table1
.DE
This prints the following:
.DM
	1923 41
	1924 46
	1926 47
	1929 46
.DE
In the above program,
.B awk
printed its output only if the subexpression \fB$3 >= 40\fR
was true \fIand\fR (\fB&&\fR) the subexpression \fB$3 <= 50\fR
was true.
.PP
The next example demonstrates the Boolean OR operator.
It prints all seasons for which Babe Ruth hit fewer
than 40 home runs or more than 50 home runs:
.DM
	awk '$3 < 40 || $3 > 50 { print $1, $3}' table1
.DE
This example prints the following:
.DM
	1920 54
	1921 59
	1922 35
	1925 25
	1927 60
	1928 54
.DE
In this example,
.B awk
printed its output if the subexpression \fB$3 < 40\fR
was true \fIor\fR (\fB||\fR) the subexpression \fB$3 > 50\fR was true.
Note that the output would also printed if both subexpressions were true
(although in this case, this is impossible).
.PP
Finally, the Boolean operator `!' negates the truth-value of any expression.
For example, the expression \fB$1 = "And"\fR is true if the first field
in the current record equals ``And''; however, the expression
\fB$1 != "And"\fR is true if the first field does \fInot\fR equal ``And''.
For example, the program
.DM
	awk '$1 != "And"' text1
.DE
prints:
.DM
	When, in disgrace with fortune and men's eyes,
	I all alone beweep my outcast state,
	Wishing me like to one more rich in hope,
	Featured like him, like him with friends possest,
	Desiring this man's art and that man's scope,
	With what I most enjoy contented least.
	Yet in these thoughts myself almost despising,
	Haply I think on thee - and then my state,
	Like to the lark at break of day arising
	From sullen earth, sings hymns at heaven's gate;
	For thy sweet love remember'd such wealth brings
	That then I scorn to change my state with kings.
.DE
These are the 12 lines from \fBtext1\fR that do not begin with ``And''.
.PP
Note that
.B awk
evaluates all operators from left to right unless sub-expressions are
grouped together with parentheses, as is described in the following section.
.Sh "Patterns"
.II "awk^patterns"
.PP
The previous examples have all matched strings or numbers against predefined
fields in each input record.
This is fine for manipulating tabular information, like our table of
Babe Ruth's batting statistics, but it is not terribly useful when
you are processing free text.
Free text is not organized into predefined columns, nor are you likely to
know which field (that is, which word) will contain the pattern you're seeking.
.PP
.II ed
.II sed
To help you manage free text,
.B awk
has a pattern-matching facility that resembles those of the editors
.B ed
and
.BR sed .
.PP
The most common way to search for a pattern is to enclose it between slashes.
For example, the program
.DM
	awk '/and/' text1
.DE
prints every line in
.B text1
that contains the string ``and''.
.DM
	When, in disgrace with fortune and men's eyes,
	And look upon myself, and curse my fate,
	Desiring this man's art and that man's scope,
	Haply I think on thee - and then my state,
.DE
Note that ``and'' does not have to be a word by itself \(em it can be
a fragment within a word as well.
Note, too, that this pattern matches ``and'' but does not match ``And'' \(em
but it would if we were to use the \fB\-y\fR option on the \fBawk\fR command
line (described above).
.PP
You can use Boolean operators to search for more than one string at once.
For example, the program
.DM
	awk '/and/ && /or/' text1
.DE
finds every line in \fBtext1\fR that contains both ``and'' and ``or''.
There is only one:
.DM
	When, in disgrace with fortune and men's eyes,
.DE
Note that the ``or'' in this line is embedded in the word ``fortune''.
.PP
.B awk
can also scan for classes and types of characters.
To do so, enclose the characters within brackets and place the bracketed
characters between the slashes.
For example, the following program looks for every line in \fBtext1\fR
that contains a capital `A' through a capital `E':
.DM
	awk '/[A-E]/' text1
.DE
This prints the following:
.DM
	And trouble deaf heaven with my bootless cries,
	And look upon myself, and curse my fate,
	Desiring this man's art and that man's scope,
.DE
.II "awk^special characters"
In addition, you can use the following
special characters for further flexibility:
.DS
	\fB[ ]\fR	Class of characters
	\fB( )\fR	Grouping subexpressions
	\fB|\fR	Alternatives among expressions
	\fB+\fR	One or more occurrences of the expression
	\fB?\fR	Zero or more occurrences of the expression
	\fB*\fR	Zero, one, or more occurrences of the expression
	\fB.\fR	Any non-newline character
.DE
When adding a special character to a pattern, enclose the special
character as well as the rest of the pattern
within slashes.
.PP
To search for a string that contains one of
the special characters, you must precede the
character with a backslash.
For example, if you are looking for the string ``today?'',
use the following pattern:
.DM
	/today\e?/
.DE
When you need to find an expression in a
particular field, not just anywhere in the
record, you can use one of these operators:
.DS
	\fB~\fR	Contains the data in question
	\fB!~\fR	Does not contain the data in question
.DE
For example, if you need to find the digit `9'
in the fourth field of file \fBtable1\fR, use the following
program:
.DM
	awk '$4~/9/ {print $1, $4}' table1
.DE
This prints the following:
.DM
	1922 94
	1926 139
.DE
As you can see, the above program found every record with a `9' in its
fourth field, regardless of whether the `9' came at the beginning of the
field or its end.
.B awk
also recognizes two operators that let you set where a pattern is within
a field:
.DS
	\fB^\fR	Beginning of the record or field
	\fB$\fR	End of the record or field
.DE
For example, to find every record in \fBtable1\fR whose fourth field
\fIbegins\fR with a `9', run the following program:
.DM
	awk '$4~/^9/ {print $1, $4}' table1
.DE
This prints:
.DM
	1922 94
.DE
Finally, to negate a pattern use the operator \fB!~\fR.
For example, to print every record in
.B table1
whose fourth column does
.I not
begin with a `9', use the following program:
.DM
	awk '$4!~/^9/ {print $1, $4}' table1
.DE
This prints:
.DM
	1920 158
	1921 177
	1923 151
	1924 143
	1925 61
	1926 139
	1927 158
	1928 163
	1929 121
.DE
.Sh "Ranges of Patterns"
.PP
.II "awk^patterns, range"
You can tell \fBawk\fR to perform an action
on all records between two patterns.
For example, to print all records between the
.I patterns
\fB1925\fR and \fB1929\fR, inclusive,
enclose the strings in slashes and separate them with a comma,
then indicate the
.B print
action, as follows:
.DM
	awk '/1925/,/1929/ { print }' table1
.DE
You can also use the special pattern
.B NR
(or \fIrecord number\^\fR) to name a range of record numbers.
For example, to print records 5 through 10 of file
.BR text1 ,
use the following program:
.DM
	awk 'NR == 5, NR == 10 { print }' text1
.DE
.Sh "Resetting Separators"
.PP
.II "awk^separators, reset"
As noted above,
.B awk
recognizes certain characters by default to parse its input into
records and fields, and to separate its output into records and fields:
.II "awk^FS"
.IP \fBFS\fR
Input-field separator.
By default, this is one or more white-space characters (tabs or spaces).
.II "awk^OFS"
.IP \fBOFS\fR
Output-field separator.
By default, this is exactly one space character.
.II "awk^ORS"
.IP \fBORS\fR
Output-record separator.
By default, this is the newline character.
.II "awk^RS"
.IP \fBRS\fR
Input-record separator.
By default, this is the newline character.
.PP
By resetting any of these special patterns, you can change how
.B awk
parses its input or organizes its output.
Consider, for example, the command:
.DM
	awk 'BEGIN {ORS = "|"}
		/1920/,/1925/ {print $1, $5}' table1
.DE
This prints the following:
.DM
	1920 137|1921 171|1922 99|1923 131|1924 121|1925 66|
.DE
As you can see, this prints the season and the number of runs batted
in for the 1920 through 1925 season.
However,
.B awk
uses the pipe character `|' instead of the newline character to separate
records.
If you wish to change the output-field separator as well as the
output-record separator, use the program:
.DM
	awk 'BEGIN {ORS = "|" ;	OFS = ":"}
		/1920/,/1925/ {print $1, $5}' table1
.DE
This produces:
.DM
	1920:137|1921:171|1922:99|1923:131|1924:121|1925:66|
.DE
.II "awk^;"
As you can see,
.B awk
has used the colon `:' instead of a white-space character to separate
one field from another.
.PP
Note, too, that the semicolon `;' character separates expressions
in the action portion of the statement associated with the
.B BEGIN
pattern.
This lets you associate more than one action with a given pattern, so you
do not have to repeat that pattern.
This is discussed at greater length below.
.PP
You can also change the input-record separator from the newline
character to something else that you prefer.
For example, the following program changes the input-record separator
from the newline to the comma:
.DM
	awk 'BEGIN {RS = ","}
		{print $0}' text1
.DE
This yields the following:
.DM
	When
	 in disgrace with fortune and men's eyes
.sp \n(pDu
	I all alone beweep my outcast state
.sp \n(pDu
	And trouble deaf heaven with my bootless cries
.sp \n(pDu
	And look upon myself
	 and curse my fate
.sp \n(pDu
	Wishing me like to one more rich in hope
.sp \n(pDu
	Featured like him
	 like him with friends possest
.sp \n(pDu
	Desiring this man's art and that man's scope
.sp \n(pDu
	With what I most enjoy contented least.
	Yet in these thoughts myself almost despising
.sp \n(pDu
	Haply I think on thee - and then my state
.sp \n(pDu
	Like to the lark at break of day arising
	From sullen earth
	 sings hymns at heaven's gate;
	For thy sweet love remember'd such wealth brings
	That then I scorn to change my state with kings.
.DE
The blank lines resulted from a comma's occurring at the end of a line.
.PP
.II "awk^="
Note that by specifying the null string \fB(RS="")\fR,
you can make two consecutive newlines the record separator.
Note, too, that only one character can be the input-record separator.
If you try to reset this separator to a string,
.B awk
uses the first character in the string as the separator, and ignores the rest.
.PP
You can change the input-field separator by redefining
.BR FS .
The default
.B FS
is \fB<space>\et\fR exactly and in that order
(where \fB<space>\fR is the space character).
In this case,
.B awk
uses its ``white-space rule,'' in which
.B awk
treats any sequence of spaces and tabs as a single separator.
This is the default rule for
.BR FS .
If you set
.B FS
to anything else, including \fB\et<space>\fR, then each separator is separate.
For example, the following program changes the input-field separator
to the comma and prints the first such field it finds in each line from file
.BR text1 :
.DM
	awk 'BEGIN {FS = ","}
		{print $1}' text1
.DE
This produces:
.DM
	When
	I all alone beweep my outcast state
	And trouble deaf heaven with my bootless cries
	And look upon myself
	Wishing me like to one more rich in hope
	Featured like him
	Desiring this man's art and that man's scope
	With what I most enjoy contented least.
	Yet in these thoughts myself almost despising
	Haply I think on thee - and then my state
	Like to the lark at break of day arising
	From sullen earth
	For thy sweet love remember'd such wealth brings
	That then I scorn to change my state with kings.
.DE
As you can see, this program prints text up to the first comma in
each line.
.B awk
throws away the comma itself, because the input-field separator is not
explicitly printed.
.PP
You can define several characters to be input-field separators
simultaneously.
When you specify several characters within
quotation marks, each character becomes a field
separator, and all separators have equal precedence.
For example, you can specify the letters `i', `j', and `k' to be
input-field separators.
The following program does this, and prints the first field so
defined from each record in file
.BR text1 :
.DM
	awk 'BEGIN  {FS = "ijk"}
		{print $1}' text1
.DE
This prints:
.DM
	When, 
	I all alone beweep my outcast state,
	And trouble deaf heaven w
	And loo
	W
	Featured l
	Des
	W
	Yet 
	Haply I th
	L
	From sullen earth, s
	For thy sweet love remember'd such wealth br
	That then I scorn to change my state w
.DE
Note that if you set the input-record separator to a null string, you
can use the newline character as the input-field separator.
This is a handy way to concatenate clusters of lines into records that
you can then manipulate further.
.PP
One last point about the
.B FS
separator.
If the white-space rule is not invoked and
an assignment is made to a nonexistent field,
.B awk
can add the proper number of field separators.
For example if
\fBFS=":"\fR and the input line is \fBa:b\fR, then
the command \fB$5 = "e"\fR produces \fBa:b:::e\fR.
If the white-space rule were in effect,
.B awk
would add spaces as if each space were a separator,
and print a warning message.
In short, it would try to produce the sanest result from the error.
.PP
Finally, the variable
.B NR
gives the number of the current record.
The next example prints the total number of records in file
.BR text1 :
.DM
	awk 'END {print NR}' text1
.DE
The output is
.DM
	14
.DE
which is to be expected, since
.B text1
is a sonnet.
.SH "Actions"
.PP
.II "awk^actions"
The previous section described how to construct a
.I pattern
for
.BR awk .
For each pattern, there must be a corresponding
.IR action .
So far, the only action shown has been to print output.
However,
.B awk
can perform many varieties of actions.
In addition to printing, \fBawk\fR can:
.DS
	\(bu Execute built-in functions
	\(bu Redirect output
	\(bu Assign variables
	\(bu Use fields as variables
	\(bu Define arrays
	\(bu Use control statements
.DE
These actions are discussed in detail in the following sections.
.PP
As noted above, each
.B awk
statement must have an action.
If a statement does not include an action,
.B awk
assumes that the action is
.BR {print} .
.PP
Within each statement,
.B awk
distinguishes an action from its corresponding pattern by the fact
that the action is enclosed within braces.
Note that the action section of a statement may include several
individual actions;
however, each action must be separated from the others by
semicolons `;' or newlines.
.PP
.II "Free Software Foundation"
Some forms of
.BR awk ,
such as that provided by the Free Software Foundation (FSF),
allow user-defined functions.
The FSF version of
.B awk
is available from the MWC BBS as well as via COHware.
Note that your system must have at least two megabytes of RAM
to run the FSF version of
.BR awk .
.Sh "awk Functions"
.PP
.II "awk^functions"
\fBawk\fR includes the following functions with which you can
manipulate input.
You can assign a function to any variable or use it in a pattern.
The following lists
.BR awk 's
functions.
Note that an
.I argument
can be a variable, a field, a constant, or an expression:
.II "awk^abs"
.IP \fBabs(\fIargument\^\fB)\fR
Return the absolute value of \fIargument\fR.
.II "awk^exp"
.IP \fBexp(\fIargument\^\fB)\fR
.II "Euler, Leonhart"
Return Euler's number
.I e
(2.178...) to the power of \fIargument\fR.
.II "awk^index"
.IP \fBindex(\fIstring1\^\fB,\fIstring2\^\fB)\fR
Return the position of \fIstring2\fR within
\fIstring1\fR.
If \fIs2\fR does not occur in \fIs1\fR,
.B awk
returns zero.
This
.B awk
function resembles the \*(CO C function
.BR index() .
.II "awk^int"
.IP \fBint(\fIargument\^\fB)\fR
Return the integer portion of \fIargument\fR.
.II "awk^length"
.IP \fBlength\fR
Return the length, in bytes, of the current record.
.IP \fBlength(\fIargument\^\fB)\fR
Return the length, in bytes, of \fIargument\fR.
.II "awk^log"
.IP \fBlog(\fIargument\^\fB)\fR
Return the natural logarithm of \fIargument\fR.
.II "awk^print"
.IP "\fBprint(\fIargument1 argument2 ... argumentN\^\fB)\fR"
Concatenate and print
.I argument1
through
.IR argumentN .
.IP "\fBprint(\fIargument1\^\fB,\fIargument2\^\fB, \fI... argumentN\^\fB)\fR"
Print
.I argument1
through
.IR argumentN .
Separate each
.I argument
with the
.B OFS
character.
.II "awk^printf"
.IP "\fBprintf(\fIf\^\fB, \fIargument1\^\fB, \fI... argumentN\^\fB)\fR"
Format and print strings \fIargument1\fR through \fIargument\fR in the
manner set by the formatting string
.IR f ,
which can use \fBprintf()\fR-style formatting codes.
.IP "\fBsplit(\fIstr\^\fB, \fIarray\^\fB, \fIfs\^\fB)\fR"
Divide the string \fIstr\fR into fields associated with
\fIarray\fR.
The fields are separated by character \fIfs\fR or the default field separator.
.II "awk^sprintf"
.IP "\fBsprintf(\fIf\^\fB, \fIe1\^\fB, \fIe2\^\fB)\fR"
Format strings \fIe1\fR and \fIe2\fR in the
manner set by the formatting string
.IR f ,
and return the formatted string.
.I f
can use \fBprintf()\fR-style formatting codes.
.II "awk^sqrt"
.IP "\fBsqrt(\fIargument\^\fB)\fR"
Return the square root of \fIargument\fR.
.II "awk^substr"
.IP "\fBsubstr(\fIstr\^\fB, \fIbeg\^\fB, \fIlen\^\fB)\fR"
Scan string \fIstr\fR for position \fIbeg\fR;
if found, print the next \fIlen\fR characters.
If \fIlen\fR is not included, print from from \fIbeg\fR
to the end of the record.
.Sh "Printing with awk"
.PP
.II "awk^printing"
Printing is the commonest task you will perform in your
.B awk
programs.
.BR awk 's
printing functions
.B printf
and
.B sprintf
resemble the C functions
.B printf()
and
.BR sprintf() ;
however, there are enough differences to make a close reading of this
section worthwhile.
.PP
.B print
is the commonest, and simplest, \fBawk\fR function.
When used without any arguments,
.B print
prints all of the current record.
The following example prints every record in file
.BR text1 :
.DM
	awk '{print}' text1
.DE
You can print fields in any order you desire.
For example, the following program reverses the order of the season
and batting-average columns from file
.BR table1 :
.B
.DM
	awk '/1920/,/1925/ { print $2,$1 }' table1
.DE
The output is as follows:
.DM
	.376 1920
	.378 1921
	.315 1922
	.393 1923
	.378 1924
	.290 1925
.DE
Because the field names are separated by a comma,
\fBawk\fR inserts the
.B OFS
between the fields when it prints them.
If you do not separate field names with commas,
\fBawk\fR concatenates the fields when it printing them.
For example, the program
.DM
	awk '/1920/,/1925/ { print $2 $1 }' table1
.DE
produces:
.DM
	.3761920
	.3781921
	.3151922
	.3931923
	.3781924
	.2901925
.DE
When you use \fBawk\fR to process a column of text or numbers,
you may wish to specify a consistent format for the output.
The statement for formatting a column of numbers follows this
.IR pattern :
.DM
	{printf "format", expression}
.DE
where
.I format
prescribes how to format the output, and
.I expression
specifies the fields for \fBawk\fR to print.
.PP
The following table names and defines
the most commonly used of \fBawk\fR's format control characters.
Each character must be preceded by a percent sign `%'
and a number in the form of
.I n
or
.IR n.m .
.DS
	\fB%\fIn\fBd\fR	Decimal number
	\fB%\fIn\^\fB.\fIm\^\fBf\fR	Floating-point number
	\fB%\fIn\^\fB.\fIm\^\fBs\fR	String
	\fB%%\fR	Literal `%' character
.DE
When you use the
.B printf()
function, you must define the output-record separator within the
format string.
The following codes are available:
.DS
	\fB\en\fR	Newline
	\fB\et\fR	Tab
	\fB\ef\fR	Form feed
	\fB\er\fR	Carriage return
	\fB\e"\fR	Quotation mark
.DE
For example, the following program prints Babe Ruth's RBIs unformatted:
.DM
	awk '/1920/,/1925/ { print $1, $5 }' table1
.DE
The output appears as follows:
.DM
	1920 137
	1921 171
	1922 99
	1923 131
	1924 121
	1925 66
.DE
As you can see,
.B awk
right-justifies its output by default.
To left-justify the second column, use the following program:
.DM
	awk '/1920/,/1925/ { printf("%d %3d\en", $1, $5) }' table1
.DE
The output is as follows:
.DM
	1920 137
	1921 171
	1922  99
	1923 131
	1924 121
	1925  66
.DE
Note that the `3' in the string
.B %3d
specifies the minimum number of characters to be displayed.
If the size of the number exceeds the space allotted to it,
.B awk
prints the entire number.
A different rule applies when printing strings, as will be
shown below.
.PP
To print a floating-point number, you must specify the minimum number of
digits you wish to appear on either side of the decimal point.
For example, the following program gives the average number of RBIs
Babe Ruth hit in each game between 1920 and 1925:
.DM
	awk '/1920/,/1925/ { printf("%d %1.2f\en", $1, $5/154.0) }' table1
.DE
This prints the following:
.DM
	1920 0.89
	1921 1.11
	1922 0.64
	1923 0.85
	1924 0.79
	1925 0.43
.DE
Note the following points about the above program:
.IP \(bu 0.3i
To get the average number of runs batted in, we had to divide the
total number of RBIs in a season by the number of games in a season
(which in the 1920s was 154).
.B awk
permits you to use a constant to perform arithmetic on a field; this will
be discussed in more detail below.
.IP \(bu
To force
.B awk
to produce a floating-point number, the constant had to be in the format
of a floating-point number, i.e., ``154.0'' instead of ``154''.
Dividing an integer by another integer would not have produced what we wanted.
.PP
.B awk
rounds its output to match sensitivity you've requested \(em that is,
the number of digits to the right of the decimal point.
To see how sensitivity affects output, run the following program:
.DM
awk '/1920/,/1925/{printf("%1.2f %1.3f %1.4f\en",$5/154.0,$5/154.0,$5/154.0)}'\e
table1
.DE
This prints the following:
.DM
	0.89 0.890 0.8896
	1.11 1.110 1.1104
	0.64 0.643 0.6429
	0.85 0.851 0.8506
	0.79 0.786 0.7857
	0.43 0.429 0.4286
.DE
As an aside, the above example also shows that
you can break \fBawk\fR's command line across more than one
line using a backslash `\e' at the end of every line but the last.
Note, however, that you
.I cannot
break an
.B awk
statement across more than one line, or
.B awk
will complain about a syntax error.
.PP
One last example of floating-point numbers prints Babe Ruth's
ratio of runs scored to runs batted in between 1920 and 1925:
.DM
	awk '/1920/,/1925/{x = ($5*1.0) ; printf("%1.3f\en", $4/x)}' table1
.DE
This produces the following:
.DM
	1.153
	1.035
	0.949
	1.153
	1.182
	0.924
.DE
The expression
.B "x = ($5*1.0)"
was needed to turn field 5 (the divisor) into a floating-point number,
so we could obtain the decimal fraction that we wanted.
This is discussed further below, when we discuss how to manipulate
constants.
.PP
The function
.B sprintf()
also formats expressions; however, instead of printing
its output, it returns it for assignment to a variable.
For example, you could rewrite the previous example program to replace
the multiplication operation with a call to
.BR sprintf() :
.DM
	awk '/1920/,/1925/{x = sprintf("%3.1f", $5)
		printf("%1.3f\en", $4/x)}' table1
.DE
The output is the same as that shown above.
.PP
The
.B %s
formatting string can be used to align text in fields.
The digit to the left of the period gives the width of the field;
that to the right of the period gives the number of characters to write
into the field.
Note that if input is larger than the number of characters allotted to it,
.B awk
truncates the input.
For example, the following program aligns on seven-character fields
some words from file
.BR text1 :
.DM
	awk '{x=sprintf("%7.5s %7.5s %7.5s %7.5s", $1, $2, $3, $4)
		print x}' text1
.DE
The output is as follows:
.DM
	  When,      in   disgr    with
	      I     all   alone   bewee
	    And   troub    deaf   heave
	    And    look    upon   mysel
	  Wishi      me    like      to
	  Featu    like    him,    like
	  Desir    this   man's     art
	   With    what       I    most
	    Yet      in   these   thoug
	  Haply       I   think      on
	   Like      to     the    lark
	   From   sulle   earth   sings
	    For     thy   sweet    love
	   That    then       I   scorn
.DE
Note that fields (words) longer than five characters are truncated;
and every word is right-justified on a seven-character field.
.Sh "Redirecting Output"
.PP
.II "awk^redirecting output"
In addition to printing to the standard output,
.B awk
can redirect the output of an action into a file, or append it onto
an existing file.
With this feature, you can extract information from
a given file and construct new documents.
The following example shows an easy way to sift Babe Ruth's statistics
into four separate files, for further processing:
.DM
	awk '{	print $1, $2 > "average"
		print $1, $3 > "home.runs"
		print $1, $4 > "runs.scored"
		print $1, $5 > "rbi"}' table1
.DE
Note like as under the shell, the
operator `>' creates the named file if it does not exist,
or replaces its contents if it does.
To append
.BR awk 's
onto the end of an existing file, use the operator `>>'.
.PP
.B awk
can also pipe the output of an action to another program.
As under the shell, the operator `|' pipes the output of one
process into another process.
For example, if it is vital for user
.B fred
to know Babe Ruth's batting
average for 1925, you can mail it to him with the following command:
.DM
	awk '/1925/ {print $1, $2 | "mail fred"}' table1
.DE
.Sh "Assignment of Variables"
.PP
.II "awk^assigning variables"
A number of the previous examples assign values to variables.
.B awk
lets you create variables, perform arithmetic upon them,
and otherwise work with them.
.PP
An
.B awk
variable can be a string or a number,
depending upon the context.
Unlike C,
.B awk
does not require that you declare a variable.
By default, variables are set to the null
string (numeric value zero) on start-up of the \fBawk\fR program.
To set the variable
.B x
to the numeric value one, you can use the assignment operator `=':
.DM
	x = 1
.DE
To set x to the string
.B ted ,
also use the assignment operator:
.DM
	x = "ted"
.DE
When the context demands it, \fBawk\fR converts strings to numbers or numbers
to strings.
For example, the statement
.DM
	x = "3"
.DE
initializes to
.B x
to the string ``3''.
When an expression contains an
arithmetic operator such as the `-',
\fBawk\fR interprets the expression as numeric.
(Alphabetic strings evaluate to zero.)
Therefore, the expression
.DM
	x = "3" - "1"
.DE
assigns the numeric value two to variable
.B x ,
not the string ``2''.
.PP
When the operator is included within the
quotation marks, \fBawk\fR treats the operator as a
character in the string.
In the following example
.DM
	x = "3 - 1"
.DE
initializes
.B x
to the string ``3 - 1''.
.PP
A number of examples in the previous section showed you how to perform
arithmetic on fields.
.II "awk^arithmetic operators"
The following table gives \fBawk\fR's arithmetic operators:
.DS
	\fB+\fR	Addition
	\fB-\fR	Subtraction
	\fB*\fR	Multiplication
	\fB/\fR	Division
	\fB%\fR	Modulus
	\fB++\fR	Increment
	\fB--\fR	Decrement
	\fB+=\fR	Add and assign value
	\fB-=\fR	Subtract and assign value
	\fB*=\fR	Multiply and assign value
	\fB/=\fR	Divide and assign value
	\fB%=\fR	Divide modulo and assign value
.DE
Variables are often used with increment operators.
For example, the following program computes the average number of home
runs Babe Ruth hit each season during the 1920s:
.DM
	awk '	{ x += $3 }
		END { y = (NR * 1.0) 
			printf("Average for %d years: %2.3f.\en", NR, x/y) }' table1
.DE
The output is:
.DM
	Average for 10 years: 46.700.
.DE
.Sh "Field Variables"
.PP
.II "awk^field variables"
\fBawk\fR lets fields receive assignments, be used in arithmetic,
and be manipulated in string operations.
One task that has not yet been demonstrated is using 
a variable to address a field.
For example, the following program prints the
.BR NR th
field (word) from the first seven lines in file
.BR text1 :
.DM
	awk 'NR < 8 {print NR, $(NR)}' text1
.DE
The output is:
.DM
	1 When,
	2 all
	3 deaf
	4 myself,
	5 one
	6 with
	7 man's
.DE
.Sh "Control Statements"
.PP
.II "awk^control statements"
\fBawk\fR has seven defined control statements.
This section explains them and gives examples of their use.
.II "awk^if"
.II "awk^else"
.IP "\fBif (\fIcondition\^\fB) \fIaction1 \fB[else\fI action2 \fB]\fR"
If \fIcondition\fR is true, then execute
.IR action1 .
If the optional
.B else
clause is present and
.I condition
is false, then
execute
.IR action2 .
.sp \n(pDu
The following program keeps running totals of Babe Ruth's RBIs, for both
the years where his runs scored exceeded his RBIs and the years where they
did not:
.DM
	awk '{ if ( $4 > $5 )
		    gyear++
		else
		    lyear++
	     }
	     END { printf("Scored exceed RBIs: %d years.\n", gyear)
		   printf("Scored not exceed RBIs: %d years.\n", lyear)
	     }' table1
.DE
This produces:
.DM
	Scored exceed RBIs: 5 years.
	Scored not exceed RBIs: 5 years.
.DE
Note that if more than one action is associated with an
.B if
or
.B else
statement, you must enclose the statements between braces.
If you use braces with both the
.B if
and
.B else
statements, note that the beginning and closing braces
.I must
appear on the same line as the
.B else
statement.
For example:
.DM
	if (expr) {
		stuff
		stuff
	} else {
		stuff 
		stuff
	}
.DE
.II "awk^while"
.IS "\fBwhile (\fIcondition\^\fB) \fIaction\fR"
The
.B while
statement executes
.I action
as long as
.I condition
is true.
For example, the following program counts the number of times the word
.B the
appears in file
.BR text1 .
The
.B while
loop uses a variable to examine every word in every line:
.DM
	awk ' { i = 1
		while (i <= NF ) {
			if ($i == "the") j++
			i++
		}
	      }
	END   { printf ("The word \e"the\e" occurs %d times.\en", j) }' text1
.DE
.II "Shakespeare, William"
The result, as follows, shows Shakespeare's economy of language:
.DM
	The word "the" occurs 1 times.
.DE
By the way, note that if a control statement has more than one statement
in its action section,
enclose the action section between braces.
If you do not,
.B awk
will behave erratically or exit with a syntax error.
.II "awk^for"
.IP "\fBfor( \fIinitial\fB ; \fIend\fB ; \fIiteration\fB ) \fIaction\fR"
.IS "\fBfor( \fIvariable\fB in \fIarray\fB ) \fIaction\fR"
.BR awk 's
.B for
statement closely resembles the
.B for
statement in the C language.
The statement
.I initial
defines actions to be performed before the loop begins; this is usually
used to initialize variables, especially counters.
The statement
.I end
defines when the loop is to end.
The statement
.I iteration
defines one or more actions that are performed on every iteration of the
loop; usually this is used to increment counters.
Finally,
.I action
can be one or more statements that are executed on every iteration of
the loop.
.I action
need not be present, in which case only the action defined in the
.I iteration
portion of the
.B for
statement is executed.
.B for
is in fact just an elaboration of the
.B while
statement, but adjusted to make it a little easier to use.
The following example writes the previous example, but replaces the
.B while
loop with a
.B for
mechanism:
.DM
	awk ' { for (i = 1 ; i <= NF ; i++)
		    if ($i == "the") j++
	      }
	END   { printf ("The word \e"the\e" occurs %d times.\en", j) }' text1
.DE
The output is the same as the previous example, but the syntax is neater
and easier to read.
.sp \n(pDu
The second form of the
.B for
loop examines the contents of an array.
It is described in the following section, which introduces arrays.
.IP \fBbreak\fR
.II "awk^break"
The statement
.B break
immediately interrupts a
.B while
or
.B for
loop.
For example, the following program is the same as the previous example,
but counts only the first occurrence of the word
.B the
in each line of
.BR text1 .
Thus, it counts the number of lines in
.B text1
that contain
.BR the :
.DM
	awk '{ for (i = 1 ; i <= NF ; i++) {
		    if ($i == "the") {
		    	j++
			break
		    }
		 }
	      }
	END   {printf ("The word \e"the\e" occurs in %d lines.\en", j)}' text1
.DE
.II "awk^continue"
.IS \fBcontinue\fR
The statement
.B continue
immediately begins the next iteration of the nearest
.B while
or
.B for
loop.
For example, the following program prints all of Babe Ruth's statistics \(em
runs scored, runs batted, and home runs \(em in which he had more than 59
in one year:
.DM
	awk ' { for (i = 3 ; i <= NF ; i++)
		    if ($i <= 59)
			continue
		    else
			printf("%d, column %d: %d\en", $1, i, $i)
	      } ' table1
.DE
This produces the following:
.DM
	1920, column 4: 158
	1920, column 5: 137
	1921, column 4: 177
	1921, column 5: 171
	1922, column 4: 94
	1922, column 5: 99
	...
.DE
.II "awk^next"
.IS \fBnext\fR
The statement
.B next
forces
.B awk
abort the processing of the current record and
skip to the next input record.
Processing of the new input record begins with the first pattern, just as
if the processing of the previous record had concluded normally.
To demonstrate this, the following program skips all records in file
.B text1
that have an odd number of fields (words):
.DM
	awk ' { if (NF % 2 == 0) next }
	      { print $0 } ' text1
.DE
This produces:
.DM
	I all alone beweep my outcast state,
	Wishing me like to one more rich in hope,
	With what I most enjoy contented least.
	Yet in these thoughts myself almost despising,
	Like to the lark at break of day arising
.DE
.II "awk^exit"
.IS \fBexit\fR
Finally, the control statement
.B exit
forces the \fBawk\fP program to skip all remaining input and
execute the \fIactions\fR at the \fBEND\fR pattern, if any.
For example, the following program prints the year in which Babe Ruth
hit his 300th home run:
.DM
	awk ' { i =  $1 }
	      (j += $3) >= 300 { exit }
	      END {print "Babe Ruth hit his 300th homer in", i "."}' table1
.DE
This produces:
.DM
	Babe Ruth hit his 300th homer in 1926.
.DE
.SH "Arrays"
.PP
.II "awk^arrays"
.B awk
has a powerful feature for managing arrays.
Unlike C,
.B awk
automatically manages the size of an array, so you do not have to declare
the array's size ahead of time.
Also, unlike C,
.B awk
lets you address each element within an array by a label, not just by its
offset within the array.
This lets you generate arrays ``on the fly,'' which can be very useful
in transforming many varieties of data.
.PP
To declare an array, simply name it within a statement.
.B awk
recognizes as an array every variable that is followed by brackets `[\ ]'.
To initialize a row within an array, you must define its value and name its
label.
A label can be either a number or a string.
A value, too, can be a number or a string; if the value is a number, then
you can perform arithmetic upon it, as will be shown in a following example.
.Sh "Initializing an Array"
.PP
To demonstrate how an array works, use the line editor
.B ed
to add a line of text to the beginning of file
.BR table1 .
Type the following; please note that the token
.B <tab>
means that you should type a tab character:
.DM
	ed table1
	1i
	Year\fB<tab>\fPBA\fB<tab>\fPHRs\fB<tab>\fPScored\fB<tab>\fPRBIs
	.
	wq
.DE
This change writes a header into \fBtable1\fR that names each column.
Now, we can read these labels into an array and use them to
describe Babe Ruth's statistics.
For example, the following prints a summary of Babe Ruth's statistics for
the year 1926:
.DM
	awk '	NR == 1 { for (i=1; i <= NF; i++) header [i] = $i }
		$1 == 1926 { 
			for (i=1; i <= NF; i++)
				print header[i] ":\et", $i
		} ' table1
.DE
This produces:
.DM
.ta 0.5i 1.5i
	Year:	 1926
	BA:	 .372
	HRs:	 47
	Scored:	 139
	RBIs:	 145
.DE
The statement
.DM
	NR == 1 { for (i=1; i <= NF; i++) header [i] = $i }
.DE
reads the first line in
.BR table1 ,
which contains the column headers, and uses the headers to initialize the array
.BR header .
Each row is labeled with the contents of the variable
.BR i .
.PP
The loop
.DM
	for (i=1; i <= NF; i++)
		print header[i] ":\et", $i
.DE
prints the contents of
.BR header .
Because we labeled each row within
.B header
with a number, we can use a numeric loop to read its contents.
.Sh "The for() Statement With Arrays"
.PP
In the previous example, each element in the array was labeled with a number.
This permitted us to read the array with an ordinary
.B for
statement, which sets and increments a numeric variable.
However, the rows within an array can be labeled with strings, instead of
numbers.
To read the contents of such an array, you must use a special form of the
.BR for
statement, as follows:
.DS
	\fBfor ( \fIoffset \fBin \fIarray \fB)\fR
.DE
.I array
names the array in question.
.I offset
is a variable that you name at the time of contructing the
.B for
statement.
You can use the value of
.I offset
in any subordinate printing actions.
.PP
The following program demonstrates this new form of
.BR for ,
and (incidentally) to demonstrate the power of
.BR awk 's
array-handling feature.
It builds an array of each unique word in the file
.BR text1 ,
and notes the number of times that word occurs within the file:
.DM
	awk '	{ for (i = 1 ; i <= NF ; i++)
			words [$i]++ }
		END { for (entry in words)
			print entry ":", words[entry] }' text1 | sort
.DE
This prints:
.DM
	-: 1
	And: 2
	Desiring: 1
	Featured: 1
	For: 1
	From: 1
	Haply: 1
	I: 4
	Like: 1
	That: 1
	When,: 1
	Wishing: 1
	With: 1
	Yet: 1
	all: 1
	almost: 1
	...
.DE
As you can imagine, a similar program in C would require many more
lines of code.
However, a few features of this program are worth noting.
.PP
First, the expression
.DM
	{ for (i = 1 ; i <= NF ; i++)
		words [$i]++ }
.DE
declares the array
.B words .
Every time
.B awk
encounters a new field (word), it automatically adds another entry to the
array, and labels that entry with the word.
No work on your part is needed for this to happen.
.II "awk^++"
The `++' operator increments the value of the appropriate entry within
.BR words .
Because we did not initialize the entry, it implicitly contains a number.
.PP
The expression
.DM
	{ for (entry in words)
		print entry ":", words[entry] }
.DE
walks through the array
.BR words .
.B awk
initializes the variable
.B entry
to the label for each row in
.BR words ;
the
.B print
statement then prints
.B entry
and the contents of that row in the array \(em in this case, the number of
times the row appears in our input file.
.PP
Finally, we piped the output of this program to the command
.B sort
to print the words in alphabetical order.
.SH "For More Information"
.PP
This tutorial just gives a brief introduction to the power of
.BR awk .
To explore the language in depth, see \fIsed & awk\fR by Dale Dougherty
(Sebastopol, Calif, O'Reilly & Associates, Inc., 1985).
This book, however, describes a more complex version of
.B awk
than that provided with \*(CO.
.PP
The Lexicon's article on \fBawk\fR gives a quick summary of
its features and options.

.TH core "" "" "System Administration"
.PC "Format of a core-dump file"
.B "#include <sys/core.h>"
.PP
.II "core dump file format"
.II "file format^core dump"
When a process terminates abnormally because a it encounters
an unrecoverable error or receives an asynchronous signal from another process,
\*(CO tries to write a copy of its image in memory into a file called
.BR core .
You can examine this file with the debugger
.B db
and other tools
.\" if we had any
to try to determine what went wrong.
.PP
.\".B core
.\"contains an image of the aborted process's code and data segments, and
.\"of the system's description segment for it.
The structure
.B ch_info
appears at the head of a
.B core
file.
The header file
.B core.h
defines it as follows:
.DM
	struct  ch_info {
		unsigned short ch_magic;
		unsigned int ch_info_len;
	};
.DE
.PP
Field
.B ch_magic
is always set to the constant
.BR CORE_MAGIC .
This ``magic'' value signifies to \*(CO that this is a core file.
Field
.B ch_info_len
gives a count of information bytes in the
core file, including the
.B ch_info
structure itself.
.PP
If the value of
.B ch_info_len
exceeds the size of the
.B ch_info
structure, this indicates that data follow the
.B ch_info
structure.
These data follow the
.B ch_info
structure, and are in the form of a
.B core_proc
structure.
Header file
.B <sys/core.h>
defines this structure as follows:
.DM
	struct core_proc {
		gregset_t cp_registers;
		int cp_signal_number;
		struct _fpstate cp_floating_point;
		dregset_t cp_debug_registers;
	};
.DE
.PP
This substitutes for a dump of the
.B u
area, whose information is reserved for the kernel alone.
.PP
This is followed by an image of each process segment.
The data for each segment consists of the following:
a header, which is a structure of type
.BR core_seg ;
.B cs_pathlen
bytes of data that give the path name of the file from the segment data
originated; and
.B cs_dumped
bytes of core-image data.
.PP
.B core.h
defines strucutre
.B core_seg
as follows:
.DM
.ta 0.5i 1.0i 4.0i
	struct core_seg {
		size_t cs_pathlen;	/* length of path name */
		off_t cs_dumped;	/* dumped size in bytes */
		caddr_t cs_base;	/* virtual base address */
		off_t cs_size;	/* full size in bytes */
		unsigned long cs_reserved[8];
	};
.DE
.PP
The order of the segments is
the text segment first (if it is present \(em usually it is omitted),
followed by the data segment, and then the stack segment.
The contents of the text segment
can usually be identified from the program being debugged.
The patchable kernel variable
.B DUMP_TEXT
allows the \*(CO kernel to dump text segments as well as data and stack
segments.
.PP
Patchable kernel variable
.B DUMP_LIM
sets the maximum size of a segment within a
.B core
file.
The system uses this limit to keep keep core files from getting out of hand.
.SH "See Also"
.Xr "Administering COHERENT," administe
.Xr "core.h," core.h
.Xr "signal()," signal
.Xr "wait()" wait.s
.SH Diagnostics
\*(CO will not write
.B core
if that file already exists as a non-ordinary file
or if there is more than one link to it.
The 0200 bit in the status returned to the parent process by
.B wait()
indicates a successful dump.
.PP
For a list of signals that automatically trigger a core dump, see the
Lexicon entry for
.BR signal() .

.ds TL "Lexicon"
.NH "Introduction to the Lexicon" 1
.PP
The following section describes the functions and macros that are
currently used in \*(CO device drivers.
These include internal kernel routines, DDI/DKI routines, and \*(ST routines.
.PP
The root article is this Lexicon the one entitled
.BR "device driver" .
If you are unfamiliar with how a Lexicon works, you should read
this article first.
It introduces the Overview articles, and discusses the families of
articles in the Lexicon.

.ds VN 11
.sp 3.5i
.ll 5.75i
.po 1i
.vs 9
.ft RS
Copyright \(co 1994 by Mark Williams Company.
.sp
All rights reserved.
.sp
This publication conveys information that is the property of Mark
Williams Company.
It shall not be copied, reproduced or duplicated
in whole or in part without the express written permission of Mark
Williams Company.
Mark Williams Company makes no warranty of any kind
with respect to this material and disclaims any implied warranties of
merchantability or fitness for any particular purpose.
.sp
The information contained herein is subject to change without notice.
.sp
COHERENT\(tm is a trademark of Mark Williams Company.
UNIX\(tm is a trademark of Unix Systems Laboratories.
MS-DOS\(tm is a trademark of Microsoft Corporation.
PostScript\(tm is a trademark of Adobe Systems Incorporated.
All other products are trademarks or registered
trademarks of the respective holders.
.sp
.ta 1.0i 2.25i 3.75i
	Revision \*(VN		Printing 5 4 3 2 1
.sp
Published by Mark Williams Company, 60 Revere Drive, Northbrook,
Illinois  60062.
.sp
.nf
.ta 0.5i 1.5i
Sales:	Phone:	(800) 636-6700 (US) \(em (708) 291-6700 (outside United States)
	FAX:	(708) 291-6750
	E-mail:	sales@mwc.com
Technical Support:
	Phone:	(708) 291-6700
	FAX:	(708) 291-6750
	E-mail:	support@mwc.com
.ta 1.0i
CompuServ:	76256,427
.sp
.fi
This manual was written under the COHERENT operating system, using the
MicroEMACS text editor.
Text formatting was performed by the
COHERENT edition of the \fBtroff\f(RS text formatter, generating PostScript.
Page design was implemented with custom-written macros written in the
\fBtroff\f(RS text-formatting language and in PostScript.
Capitals and ornaments are derived from the Paris Book of the Hours (1510),
and were supplied in encapsulated PostScript form by BBL Typographic,
137 Narrow Neck Rd., Katoomba, NSW 2780, Australia (bblart@peg.apc.org).
The key-caps font was supplied by SoftMaker, Inc., 2195 Faraday Avenue,
Suite A, Carlsbad, CA 92008.
Diagrams were drawn under the COHERENT implementation of X, using the
program \fBxfig\f(RS, which was originally written by Supoj Sutanthavibul
of the University of Texas at Austin.
Typesetting of this manual, from the table of contents
through the index, was executed by one script written in the COHERENT
Bourne shell.
Camera-ready copy was printed on a Hewlett-Packard LaserJet IIP printer
using the Pacific Page PostScript cartridge.
.bp

.ds TL "Using X"
.NH "Using the X Window System"
.PP
This chapter introduces you to the using the X Window System.
This and the following chapter are intended for novices to X Windows.
If you are experienced at using the X Window System,
we suggest that you look at the Lexicon articles
.B "X clients"
and
.B "X utiities"
to see what programs are included with this package.
.PP
This chapter first introduces a graphical-user interface (GUI) and
the window manager
.BR twm .
The window manager is responsible for the appearance of the screen,
and manages windows and icons.
This portion of the chapter assumes that you have little or no experience
with a GUI.
.II "Microsoft Windows"
Even if you have worked with other GUIs, such as Microsoft
Windows, you should look over this section to see how
.B twm
differs from what you are used to.
.PP
This chapter then gives a tour of the X Window System, to show you what
files are stored where.
It then discusses the structure of the X Window System
and the elements that comprise it.
Some of this is a little dry for a novice; however, knowing something
of what X can do and how it works will make it much easier for you to learn
how to work with X.
.PP
Finally, this chapter ends with a description of how to modify
the window manager to suit your needs and tastes.
.SH "Introduction to a Graphical Interface"
.PP
To bring up X, log into your system's console, and type
.BR startx .
If you have installed X properly, your screen will clear and within a minute
your console will appear something like this:
.PH 1 1 \*(XD/root1.eps
.PP
The actual amount of screen space that the windows take up depends upon
the mode of your physical screen and the size of the virtual screen,
as described in the installation notes.
.PP
As you can see, there are three windows on the screen:
a window that shows a clock, in the upper left corner of the screen; a
small window at the top of the screen that displays the word
.BR xvt ;
and a large, blank window that has a prompt in it.
The rest of the window is filled with a gray field.
.Sh "Using the Mouse"
.PP
To begin, try working with the mouse.
The mouse should turned so that the wire on the mouse is away from you
and the buttons are under your fingertips.
As you slide the mouse ``up'' on the desk (that is, away from you),
watch the screen.
You'll see a small cursor moving ``up'' on the screen \(em that is, toward
the top of the screen.
Now, slide the mouse toward you.
The cursor moves toward the bottom of the screen.
Slide the mouse to the right \(em the cursor slides to the right;
slide it to the left \(em the cursor moves to the left.
The principle is obvious:
the cursor moves around the screen in a manner analogous with
the movement of the mouse.
.II "mouse cursor^definition"
.II pointer^definition
This cursor is called the
.IR "mouse cursor" ;
in X nomenclature is also called the
.IR pointer .
.PP
Notice that as the cursor moves around the screen, it changes shapes.
When it is against the gray background, it is an \(mu shape; when it is
in the clock window or the little window labelled
.B xvt
it is an \(<-; while when it is the large, blank window its shape resembles
a capital I.
.II xvt
(For the sake of brevity, we will refer to the large, blank window as the
.B xvt
window.
We'll discuss below just what
.B xvt
is.)
.PP
Also, as the cursor enters and leaves windows, things happen:
when the cursor enters the
.B xvt
window, its border changes color,
the text cursor changes from outlined to solid, and the inner
border of the small window at the top of the screen also changes color.
The same things happen when you shift the cursor into the small window,
which suggests that the two windows are somehow linked.
.PP
.II "mouse buttons"
As you've noticed, your mouse has buttons on it.
(Some mice have two buttons, some have three.
For present, we'll ignore the middle-mouse button and work only with the
left and right buttons.)
By pressing the mouse button, you can tell an application to do something;
what happens depends on what programs you are running under X.
.PP
.II mouse^click
.II mouse^drag
.II clicking
.II dragging
There are two kinds of stroke on a mouse buttons:
.I clicking
and
.IR dragging .
Clicking is when you rapidly depress and release the button, just like you
press a key on your keyboard.
You often will use this stroke to press a ``button'' on the screen.
Dragging is when you depress a mouse button, slide the mouse, and then release
the mouse button.
You often use this stroke to select an item from a menu or to move or
resize a window.
(How you can do these actions is described below.)
.PP
To try this, slide the mouse so that the mouse cursor shifts
into the little window at the top of the screen.
The cursor is in the little window when the window's outline brightens.
Click the left-mouse button.
The
.B xvt
window disappears from the screen, and a small, stylized `X' appears
in the little window.
Without moving the cursor, click the left-mouse button again.
The
.B xvt
window reappears, just as it was before, and the stylized `X'
disappears.
.PP
.II icon
To explain what just happened, the small window is an
.I icon
for the
.B xvt
window.
Icons give you a way to run a large number of programs
simultaneously, without cluttering the screen with windows.
You can specifically exclude certain X programs from having an icon.
You would do this because an icon (like every other X object) consumes
memory, and some programs (such as the clock program) always appear on
the screen.
We'll discuss icons further below.
.Sh "Moving and Resizing Windows"
.PP
With the mouse you can move and resize a window.
Both involve dragging the mouse.
.PP
First, try to resize a window.
Slide the mouse so that its cursor is touching the right or bottom border
of the window.
When the cursor touches the frame, it changes shape, from an \(mu to an \(<-.
Now, press the left-mouse button and hold it down.
When you do this, three things happen:
.IP \fB1.\fR 0.3i
The mouse cursor changes to a stylized `+' sign.
.IS \fB2.\fR
The clock window is covered with a grid.
.IS \fB3.\fR
A small window pops up in the upper left corner and displays a
message that gives the X and Y dimensions of the window.
.PP
(If nothing happens, the tip of the \(<- is not touching the window's frame
but is in the inner part of the window.
Release the left-mouse button,
slide the cursor until the tip of the \(<- is touching the frame, and
then press the left button again.)
.PP
The numbers in the small pop-up window give the dimensions of the window,
in pixels.
.II pixel
(A
.I pixel
is one of the tiny dots that comprise your screen.)
While holding down the left-mouse button, slide the mouse to the right and
down until the numbers in the small window are approximately
\fB230\(mu230\fR.
(We say ``approximately'' because a mouse is not a precision instrument,
and trying to position it exactly can be a maddening task.)
Note that as you drag the mouse, the grid that was superimposed on the
window ``stretches'' to match the movement of the mouse cursor.
Now release the left-mouse button.
The clock window is now larger, and your screen looks something like this:
.PH 1 1 \*(XD/root2.eps
The clock window is now larger, the image of the clock has expanded to fill
the larger window, and the clock window now overlaps the
.B xvt
window.
.PP
.II window^background
.II window^foreground
.II background
.II foreground
Now, try moving the
.B xvt
window.
First, however, we need to shift the
.B xvt
window from behind the clock window (in X nomenclature, this is called the
.IR background )
to in front of the clock window
(in X nomenclature, the
.IR foreground ).
Move the mouse cursor into the icon and click the left-mouse button:
the
.B xvt
window vanishes from the screen.
Now, click the icon again:
the
.B xvt
window appears again, but this time in the foreground, superimposed upon
the clock window.
.PP
Now, slide mouse cursor into the
.B xvt
window.
.II "title bar"
When the cursor enters the window, observe the area at the top of the
window that has the word
.B xvt
in it \(em this area is called the
.IR "title bar" .
When the cursor enters the
.B xvt
window, a small, gray patch appears in title bar.
.II "button^screen"
.II "screen button"
The other shapes in the title bar are
.IR "screen buttons" .
.II "screen button"
.II "button^screen"
A screen button is not a physical button, like the button on your mouse;
however, it works like physical buttons in that you can ``press'' it
by moving the mouse cursor to it and then clicking a mouse button.
.PP
Slide the mouse cursor so that it is touching in the title bar, but not
touching any of the buttons.
(The gray patch is part of the title bar, not a button.)
Now, press and hold down the left-mouse button.
Once again, the mouse cursor changes to a stylized `+'.
While holding down the left-mouse button, drag the mouse up and to the
right;
while you slide the mouse, an outline of the window follows.
Keep sliding the mouse until the
.B xvt
window is positioned to the right of the clock window; then release
the left-mouse button.
When you release the mouse button, X redraws the
.B xvt
window in its new position.
Your screen should now appear something like this:
.PH 1 1 \*(XD/root3.eps
.Sh "Screen Buttons"
.PP
.II twm
As we noted earlier, the little drawings in the title bar
are screen buttons.
Moving the mouse cursor to a screen button and clicking the left-mouse
button tells X \(em or, to be more precise, the screen manager \fBtwm\fR \(em
to do something, just like pressing a button on your telephone.
.PP
The window manager displays three buttons on the title bar of
each client's window.
The following describes them in the order they appear in the title bar,
from left to right:
.IP \fB1.\fR 0.3i
.II "iconify window"
.II "de-iconify a window"
.II "window^iconify"
.II "window^de-iconify"
The leftmost button, which has a bullet `\(bu' in it, ``iconifies'' the window.
That is, it erases the window from the screen and draws the stylized `X'
in that window's icon.
The window will not appear on the screen until you ``de-iconify'' it by
clicking on its icon.
.IP
Try this.
Slide the mouse cursor so that it touches the leftmost button in the
.B xvt
window's title bar.
When it touches the button, the cursor changes to a \(rh, except pointing
to the left.
Click the left-mouse button:
this ``presses'' the screen button.
The
.B xvt
window vanishes, as before; it is now iconified.
Now, slide the mouse cursor to the icon, and click the left-mouse button again.
The
.B xvt
window is de-iconified, and reappears on the screen.
.IP \fB2.\fR
The second button from the left, which has a stylized `D' in it,
displays a drop-down menu.
We will discuss this button below, when we introduce menus.
.IP \fB3.\fR
The rightmost button, which has a staggered set of squares in it, lets you
resize the window, just as if you had clicked on the window's frame.
To resize the window, move the mouse cursor to this button; press the
left-mouse button and, while holding down the mouse button,
slide the mouse cursor
to the right and down, until the window is sized to suit your preferences.
.IP
Note that by default
.B twm
does not shrink a window until you have first
moved the mouse cursor past the window's current borders.
Thus, if you want to shrink a window, you have to first stretch the grid
out past the current borders of the window, then slide it back in.
.PP
Many applications use screen buttons to gather information from you, but
you operate each in the same way:
move the mouse cursor to it and click the left-mouse button.
.Sh Sliders
.PP
.II slider
If you look at the following figure, you'll see something different
along the left edge of the
.B xvt
window:
.PH 1 1 \*(XD/root3a.eps
The object to the left of the window is a column, with a gray patch at the
bottom.
This column is called a
.IR slider .
You can use the mouse to move the gray patch up or down.
By moving the slider, you change the value of a variable that is
associated with the slider.
.PP
To change the value of a slider, move the mouse cursor onto the gray
patch, then press the middle-mouse button and hold it down.
(If you have a two-button mouse, click both buttons simultaneously and
hold them down.)
Then drag the mouse up or down on your desk; the gray patch follows the
mouse cursor up or down.
When you release the mouse buttons, the gray patch stays fixed where you
dragged it; the corresponding value will have been raised or lowered by a
proportionate amount.
.PP
Clients often use sliders to let you set a range of integral or ratio values.
For example,
.B xvt
uses the a slider to let you set display lines of text
that had scrolled off the top of the window earlier, up to a maximum of 64.
By dragging the slider up or down, you can review text that had been displayed
in the window, but no longer fits within the window \(em in effect,
you are choosing which line will be the first line in the display.
.PP
Many applications use a slider or sliders to set numeric values of this sort.
Sliders will pop up again and again as you work with X.
.Sh "Menus"
.PP
.II menu
A
.I menu
is a list of entries, like a menu in a restaurant.
You can select one of the items on the menu; the program
then performs the action that corresponds to the item you have
selected.
.PP
Many applications use menus.
The window manager
.B twm
has three menus built into it.
This section describes how to invoke these menus and their contents.
.PP
The first menu that we will describe is the one that appears when you press
the screen button that is second from the left in a window's title bar.
(This is the button with the stylized `D' in it.)
To invoke this menu, slide the mouse cursor to this button in the title bar
for the
.B xvt
window; then press the left-mouse button and hold it down.
The window now appears something like this:
.PH 1 1 \*(XD/root4.eps
As you can see, the menu has 13 entries.
The entry at the top is the menu's title.
If you look carefully, you can see that three of the entries have
a small button on the right.
The button indicates that that entry introduces a sub-menu; a sub-menu
pops up if the mouse cursor simply touches the button \(em you don't have to
press a mouse button (which is fortunate, as you are already holding down
the left-mouse button).
For example, if the mouse cursor touches the button in the menu entry labelled
.K Properties
a three-item sub-menu drops down, and the screen appears something like this:
.PH 1 1 \*(XD/root5.eps
The contents of this sub-menu will be discussed below.
.PP
.II "menu^WINDOW OPS"
.II "WINDOW OPS"
The following describes each entry in the
.B "WINDOW OPS"
menu:
.IP "\fK(Iconify)\fR"
Iconify this window.
This is the same as clicking the leftmost button on the title bar.
.IP "\fK(Lower)\fR"
Lower this window into the background \(em that is,
if this window overlaps with any other window,
draw that window atop this window.
.IP "\fK(Move)\fR"
Move this window.
This works exactly as if you had clicked on the title bar.
.IP "\fK(Raise)\fR"
Raise this window into the foreground \(em that is,
if this window overlaps with any other window,
draw this window atop that window.
.IP "\fK(Refresh)\fR"
Redraw the window.
Do this if any ``junk'' has appeared to ``mess up'' the window.
.IP "\fK(Resize)\fR"
Change the size of the window.
This works exactly the same as if you had clicked on the window's frame.
.IP "\fK(Applications)\fR"
This entry has a button that, when touched by the mouse cursor, drops a
sub-menu that shows a selection of applications that you can run under X.
This menu will be discussed later.
.IP "\fK(Properties)\fR"
This entry has a button that, when touched by the mouse cursor, drops a
sub-menu that lets you change some of
.BR twm 's
properties.
The term
.I property
has a precise meaning under X, and will be discussed later;
for now, consider a
property as being a feature of an object that affects the object's
appearance or behavior.
.II "menu^Properties"
.II "Properties"
The
.B Properties
sub-menu has the following three entries:
.RS
.II autoraise
.IP "\fK(Autoraise)\fR"
If you turn on this property,
the window manager raises this window to the foreground whenever the
mouse cursor enters it.
To turn off this property, simply select this sub-menu entry again.
.II focus
.IP "\fK(Focus)\fR"
Focus the window manager's attention on this window.
This means that the window's frame is always bright, even when the mouse
cursor is not in this window.
Further, whatever you type on the keyboard appears in this window, regardless
of where the mouse cursor is on the screen.
.II unfocus
.IP "\fK(Unfocus)\fR"
Stop focusing the window manager's attention on this window.
This is the default.
.RE
.IP "\fK(Twm_Operations)\fR"
This menu entry drops a long sub-menu that lets you invoke many features of the
window manager
.BR twm .
This menu and its contents are discussed below.
.IP "\fK(Info...)\fR"
This menu entry opens displays information about the current
window:
its name, position on the screen, and other information.
.IP "\fK(Kill_Program)\fR"
This kills the current window dead, just the same as if you had typed the
command
.B "kill -SIGKILL"
for this program.
Do
.I not
use this option unless you absolutely must kill
an application, because a program that dies in this way often leaves memory
and the file system littered with debris.
.IP "\fK(Close_Window)\fR"
This is a kinder, gentler way of killing the program in this window.
It closes this window; in theory, an application perishes gracefully
when its last (or only) window is closed.
Unfortunately, this does not work for every application, and in some cases
you may be compelled to resort to the heavy, blunt object of the previous
menu entry.
.PP
To see how a menu works, try selecting an item from it.
Click the title-bar button that drops this menu; then, while holding
down the left-mouse button, drag your mouse down until the entry
.K Iconify
is highlighted.
Then release the mouse button.
This invokes the ``iconify'' feature, and ``iconifies'' the window.
Now, click the
.B xvt
icon at the top of the screen to redisplay the
.B xvt
window.
.PP
As we mentioned above, the menu entry
.B "Twm_Operations"
drops a menu of things that you can do to, and with,
the window manager
.BR twm .
The same menu appears if you move the mouse cursor so that it is positioned over
the screen's background (when changes shape to an \(mu) and press the
right-mouse button.
Try it; your screen should appear something like this:
.PH 1 1 \*(XD/root6.eps
If the physical screen is smaller the virtual screen, you won't be able to see
all of the menu at once.
To see the bottom of the menu, keeping sliding the mouse cursor down; the
borders of the physical screen will shift downward to keep the mouse cursor in
view.
.PP
.II "menu^TWM Operations"
.II "TWM Operations"
The following describes the entries in the
.B "TWM Operations"
menu:
.IP "\fK(Beep)\fR"
Ring the bell.
.IP "\fK(Close_Window)\fR"
Close the current window.
This is the same as the
.K "Close_Window"
entry in the previous menu.
.IP "\fK(Destroy_Application)\fR"
Kill an application.
This is the same as the
.K "Kill_Program"
entry in the previous window.
.IP "\fK(Focus)\fR"
Focus the window manager's attention on a window.
If you invoked the
.B "TWM Operations"
menu from within the
.B "WINDOW OPS"
menu,
.B twm
fixes its focus on the window from within which
you invoked
.BR "WINDOW OPS" .
If, however, you invoked
.B "TWM Operations"
by clicking the right-mouse button, then
.B twm
lets you pick the window interactively:
it changes the mouse cursor to a bull's-eye; move the mouse cursor to the
window upon which you want
.B twm
to focus, and click the left-mouse button.
.B twm
will focus on this window until you go through this procedure again for
that window, or invoke the
.B "Unfocus"
menu entry, below.
.IP "\fK(Force_Move)\fR"
Move a window, even if the window's properties specifically exclude its
being moved.
.IP "\fK(Full_Zoom)\fR"
Expand a window to fill the entire screen.
The window that
.B twm
``zooms'' is determined just as with the
.K "Focus"
entry, above.
.IP "\fK(Hide_Icon_Manager)\fR"
Erase, or ``hide,'' all icons from the screen.
The icons are kept in memory, waiting for you to ``un-hide'' them.
.IP "\fK(Iconify)\fR"
Iconify a window.
The window that
.B twm
iconifies is determined just as with the
.K "Focus"
entry, above.
.IP "\fK(Info...)\fR"
Display information about a window, such as its name, size, and position
on the screen.
The window about which
.B twm
displays information is determined just as with the
.B "Focus"
entry, above.
.IP "\fK(Lower)\fR"
Lower a window.
Again, the window that
.B twm
lowers depends upon how you invoked this menu.
.IP "\fK(Lower_Current_Window)\fR"
This lowers the window that was raised last.
.IP "\fK(Move)\fR"
Move a window.
This works just as if you had clicked on a window's frame.
.IP "\fK(Open_A_New_Window)\fR"
This invokes the application
.B xvt
to open a new window and run your shell of choice in it.
Yes, this is the same
.B xvt
whose window you have manipulated so far.
This application is introduced below; for detailed information on it,
see its entry in the Lexicon at the back of this manual.
.IP "\fK(Raise)\fR"
Raise a window.
Again, the window that
.B twm
raises depends on how you invoked this menu.
.IP "\fK(Raise_Current_Window)\fR"
Raise the window that was lowered last.
.IP "\fK(Raise_or_Lower)\fR"
Select a window interactively:
if it is lowered, raise it; if it is lowered, raise it.
.IP "\fK(Resize)\fR"
Resize a window.
This works just as if you had clicked on a window's title bar.
Again, the window that
.B twm
resizes depends on how you invoked this menu.
.IP "\fK(Refresh_Window)\fR"
Refresh a window.
.IP "\fK(Refresh_Screen)\fR"
Refresh every window on the screen.
.B twm
blanks the screen briefly, then redraws it.
.IP "\fK(Show_Icon_Manager)\fR"
Redisplay the icon manager, if it is hidden.
.IP "\fK(Unfocus)\fR"
If
.B twm
is focused on a window, unfocus it.
If
.B twm
is not focused on a window, do nothing.
.IP "\fK(Window_List)\fR"
This entry has a button on it.
If the mouse cursor touches this button, a sub-menu appears that lists
every window
.B twm
is handling at this moment, whether or not it is iconified or hidden.
.IP "\fK(Zoom)\fR"
Expand a window to fill the window vertically; do not, however, change its
horizontal dimension.
.IP "\fK(Quit_Window_Mgr.)\fR"
Finally, shut down the
.B twm
window manager.
This also shuts down the X server, and returns control to the
ordinary \*(CO console interface.
.PP
So far, we have discussed
.B twm
and how to manipulate windows:
how to move them, change their size, change their focus, hide them,
redisplay them, and so on.
Now we will discuss just what's going on within the windows themselves \(em
which is, after all, the whole point of the X Window System.
.Sh "Introduction to xvt"
.PP
.II xvt
The window we've called the ``\fBxvt\fR window'' is the window for an
X program named
.BR xvt .
.II VT-100
.II "Tektronix 4014"
This program mimics a VT-100 terminal.
\*(CO ``thinks'' that this window is another terminal,
just as if you had plugged a dumb terminal into a serial port
on your machine.
.PP
.II shell
When
.B xvt
opens its window, by default it invokes a shell through which you can
give commands to \*(CO.
You can invoke other X clients via
.BR xvt ,
dial out to another system, edit files, and play games.
.PP
You can open more than one
.B xvt
window on your screen if you wish.
The number of windows you can manage comfortably depends upon the size of your
screen; if you have a small screen, you may wish to iconify the
.B xvt
windows that you are not using at the moment.
.II Internet
If your system were on a network, you could open a number of different
windows, each logged into a different machine on the network.
In this way, users who are hooked into the Internet can simultaneously view
and manipulate data from machines that are thousands of miles apart.
.PP
To give \*(CO a command via
.BR xvt ,
simply move the mouse cursor into the
.B xvt
window (so that X knows that what you type at the keyboard is intended
for this window), and type the command as you always do.
To spawn another terminal window, simply type:
.DM
	xvt &
.DE
In a moment, X draws the outline of an
.B xvt
window, and fixes it to the mouse cursor.
Slide the mouse until the window outline is where you want the new
window to be, then click the left-mouse button.
The new terminal window appears, with a \*(CO prompt in it.
You can shrink the new terminal window so it and the original terminal
window fit together onto your screen; or you can iconify it, or use the
.B Raise
and
.B Lower
entries from the
.B twm
menus to help you work with both windows.
.PP
Note that when
.B xvt
opens a window, the window is set to 80 characters wide by 25 rows high,
just like an ordinary terminal's screen.
Most \*(CO applications expect that size of a screen, and have no idea that
they are talking to a window that can be resized.
.II MicroEMACS
.II vi
.II chase
Thus, if you shrunk an
.B xvt
window, you can expect that some visually oriented \*(CO applications \(em such
as \*(ME, \fBvsh\fR, or \fBchase\fR \(em will not work correctly.
Note, too, that if you kill an
.B xvt
window, any program that you invoked from it \(em either a \*(CO
application or an X client \(em dies as well.
.II nohup
(The \*(CO command
.B nohup
will help you get around this limitation; for details, see its entry in the
\*(CO Lexicon.)
.PP
.II write
The following screen shows one unusual application of multiple
.B xvt
windows:
the user here is conversing with himself in two different windows
via the \*(CO utility
.BR write :
.PH 1 1 \*(XD/root7.eps
.PP
.Sh "Cutting and Pasting"
.PP
X has a built-in facility with which you can cut and paste text.
This facility is impractical for moving large amounts of text, but is
handy for copying a command or a set of information from
one window into another, or into a file.
Note that this facility only works with text \(em you cannot use it to
copy a bit-mapped image or an icon.
.PP
To cut text, move the mouse cursor to the point where you want to start
cutting, then press the left-mouse button.
Drag the mouse to the end of the block of text you
wish to cut; then release the left-mouse button.
The X server copies the cut text into both its cut buffer and
into its primary selection (that is, the property
.BR PRIMARY ).
.PP
Another way to cut text is to click the left-mouse button at the beginning
of the block of text you wish to cut, then move the mouse cursor to the
end of the block and click the right-mouse button.
All text between the two clicks is highlighted, to show that you have
cut it.
.PP
To un-cut text, move the mouse and click the left-mouse button again.
The text will be un-highlighted, to show that it is no longer cut.
.PP
To paste text, move the mouse cursor to the spot where you want to
``drop'' the text, then press the middle-mouse button.
(If your mouse has only two buttons, press both buttons simultaneously.)
X handles the pasted text just as if you had typed it from the keyboard:
if the text is pasted into a window that cannot accept keyboard input, then
the pasted text goes into the bit bucket.
.II cat
To drop the cut text into a file, invoke an editor or the \*(CO command
.B cat
in an
.B xvt
window, then drop the text into that window.
The program you invoked in the window will save the text into a file, just
as if you had typed it by hand.
.Sh "Introduction to xclock"
.PP
.II xclock
The window that we've called the ``clock window'' is the window for an
X program named
.BR xclock .
This program has many options, some of which you can invoke via command-line
options, like any other \*(CO program.
.PP
For example,
.B xclock
by default displays an analogue clock \(em that is, a clock with a dial and
hands.
You can, however, request a digital clock:
to do so, just type the following command into your
.B xvt
window:
.DM
	xclock -digital -update 1 &
.DE
The option
.B "\-update 1"
tells
.B xclock
to update itself every second.
The default is every 60 seconds.
.PP
Once again, a small outline of a window appears.
Slide the mouse until the window is placed where you want, then click the
left-mouse button.
You now have a small digital clock, which displays the date as well as the
time:
.PH 1 1 \*(XD/root8.eps
To remove your new clock, select the command
.K "Close_Window"
from the menu
.BR "TWM Operations" .
.PP
For a full list of options to
.BR xclock ,
see its entry in this manual's Lexicon.
.Sh "The Applications Menu"
.PP
Earlier, we noted that
.B twm
has three menus available to you.
We have described two:
.B "WINDOW OPS"
and
.BR "TWM Operations" .
.PP
.II "menu^APPLICATIONS"
.II "APPLICATIONS"
The third menu is
.BR APPLICATIONS .
Through it, you can invoke some of the more commonly used X clients,
without having to type a command into an
.B xvt
window.
(This explains, among other things, how you can invoke an
.B xvt
window when the screen has no
.B xvt
window into which you can type the command.)
This menu appears when you position the mouse cursor over the background of
the screen (as shown by the fact that the mouse cursor changes to an \(mu),
and click the left-mouse button.
The following figure shows the menu
.BR APPLICATIONS :
.PH 1 1 \*(XD/root9.eps
.B APPLICATIONS
contains the following entries:
.IP "\fK(Font_Select)\fR" 0.75i
.II xfontsel
Invoke the X client
.BR xfontsel ,
which helps you to select a font interactively.
The description of fonts under X is something of a ``black art''; for
details, see below or see the entry for
.B xfontsel
in the Lexicon.
.IP "\fK(Puzzle)\fR"
.II puzzle
Invoke the X client
.BR puzzle ,
which lets you play a scrambled-tiles game.
.IP "\fK(XBiff)\fR"
.II xbiff
Invoke the X client
.BR xbiff ,
which displays an icon of an old-fashioned roadside mailbox.
When you receive new mail, the flag on the ``mailbox'' pops up.
.IP "\fK(XCalc)\fR"
.II xcalc
.II calculator
.II "Texas Instruments"
.II "Hewlett-Packard"
Invoke the X client
.BR xcalc ,
which displays the image of scientific calculator \(em
either a Hewlett-Packard or
a Texas Instruments model, whichever you prefer.
By clicking on the image's buttons, you can invoke all of the features
of a real scientific calculator.
As you can see from the previous figure,
this entry invokes a sub-menu, from which you can select the type of
calculator you want.
.IP "\fK(XClock)\fR"
.II xclock
Invoke the client
.BR xclock ,
described above.
.IP "\fK(Xeyes)\fR"
.II xeyes
Invoke the X client
.BR xeyes .
This client draws on the screen a pair of eyes whose pupils follow the mouse
cursor around the screen.
This can help you find the mouse cursor on a cluttered screen.
.IP "\fK(XLoad)\fR"
.II xload
Invoke the client
.BR xload .
This client displays a histogram that graphs the load on your system.
You can use this client to gain an idea of how many cycles a given
program consumes.
.IP "\fK(XLogo)\fR"
.II xlogo
Invoke the X client
.BR xlogo ,
which merely displays the X logo.
This logo is the stylized X that appears in an icon when you have iconified a
window.
.IP "\fK(XMag)\fR"
.II xmag
Invoke the X client
.BR xmag .
This client magnifies part of the screen, to help you see how a shape is
built out of individual pixels.
.IP "\fK(Xvt)\fR"
.II xvt
Invoke another
.B xvt
window.
.IP "\fK(XTetris)\fR"
.II xtetris
Invoke the X client
.BR xtetris ,
which plays the popular game Tetris.
.PP
Each of these applications is invoked with selected command-line options;
for example,
.B xclock
is invoked to display an analogue clock rather than a digital one.
Below, we will show you how to change these defaults.
.Sh "Shutting Down X"
.II "X^shut down"
.II "shutting down X"
.PP
Shutting down X is a two-stage operation:
first, you must close all
.B xvt
windows, and then you must kill the server.
.PP
To shut an
.B xvt
window, simply move the mouse pointer into the window (so that its frame
is highlighted), then type the command
.BR exit .
If nothing appears to be happening, wiggle the mouse a bit;
X often waits for you to do something before it redraws the screen to reflect
the effects of any commands you may have issued.
.PP
Once all
.B xvt
windows are closed, you can shut down the X server.
There are two ways to do this.
.PP
The first way is to do so via a menu.
Invoke the menu
.B "TWM Operations"
by moving the mouse cursor over the screen's background, then press the
right-mouse button.
Drag the mouse until the last entry in the menu, which is labelled
.K "Quit_Window_Mgr."
is highlighted.
Then release the right-mouse button.
All windows close, the X server turns itself off, and you are returned to
the standard \*(CO character-based interface.
.PP
The other way is simply to type
.BR <ctrl><alt><backspace> .
No matter when you type this combination of keys, the X server will detect
it and shut itself down.
.PP
The two methods vary in how they flush buffers and tidy up after themselves.
In general, it is better to shut down in a controlled fashion, through the
menu entry, than by pressing the magic combination of keys.
.PP
Note that you can kill the X server without closing your
.B xvt
windows.
However, this is not a good idea because \*(CO may ``think'' that you are
still logged into an
.BR xvt
window, even though that window no longer exists.
This may create problems for you at some future time.
.Sh Conclusion
.PP
This concludes the introduction to the
.B twm
screen interface.
.II GUI
We have introduced the basic ``vocabulary'' of the X GUI, discussed
.B twm
and its menus, and shown how you can invoke and operate some other
X clients under
.BR twm .
.PP
The following section gives you a ``nickel tour'' of the files and
directories that comprise the X Window System.
Subsequent sections introduce the internal structure of X.
Knowing how X is structured internally will help you grasp how to configure X.
The final section in this chapter describes how to configure
.B twm
to suit your preferences.
.SH "A Tour of the X System"
.PP
The X Window System is installed into directory
.BR /usr/X11 .
The following describes the contents of each directory in the X Window System:
.IP \fB/usr/X11/bin\fR
.II /usr/X11/bin
This directory holds the executable programs themselves.
Most are created when you install your system
from the object modules in
.BR /usr/X11/objs .
For an introduction to these program, see the following chapter,
.IR "X Windows Clients" .
.IP \fB/usr/X11/doc\fR
.II /usr/X11/doc
This directory holds public-domain documentation on the X Window System
that you may find useful.
.IP \fB/usr/X11/include/X11\fR
.II /usr/X11/include/X11
This directory holds header files and bit-mapped images that are included
in the source code of an X application.
It holds the following sub-directories:
.RS
.II "Athena widget set"
.IP \fBXaw\fR
.II /usr/X11/include/X11/Xaw
Header files used with the Athena widget set.
.IP \fBXmu\fR
.II /usr/X11/include/X11/Xmu
Header files used with miscellaneous X utilities.
.IP \fBbitmaps\fR
.II /usr/X11/include/X11/bitmaps
This holds the C source code for bit-mapped images that X Windows uses.
You can include these images in programs that you import or write.
.IP \fBextensions\fR
.II /usr/X11/include/X11/extensions
Header files for extensions to the X Window System.
.IP \fBsys\fR
.II /usr/X11/include/X11/sys
System-level header files that are used with X Windows.
.RE
.IP \fB/usr/X11/lib\fR
.II /usr/X11/lib
This directory holds libraries of X Windows routines.
Please note that these libraries do
.I not
include code to use or emulate a mathematics co-processor.
.IP
This directory also holds configuration files for the X server, in particular
.BR Xconfig .
.IP
.B /usr/X11/lib
contains the following sub-directories:
.RS
.IP \fBapp-defaults\fR
.II /usr/X11/lib/app-defaults
Files of settings, or ``resources,'' for selected X programs.
By modifying an program's resource file, you can modify its
appearance and behavior without having to modify its source code.
The next chapter describes how to do this.
.IP \fBconfig\fR
.II /usr/X11/lib/config
This holds files that describe how this implementation of the X Window System
is configured.
.II imake
They are read by the utility
.B imake
to build a correctly configured
.B Makefile
from an
.BR Imakefile .
.II xmkmf
For details, see the Lexicon entries for
.B imake
and
.BR xmkmf .
.IP \fBfonts\fR
.II /usr/X11/lib/fonts
This directory holds the fonts used by the X Window System.
X Windows for \*(CO comes with two directories of fonts:
.BR fonts/misc ,
which holds miscellaneous fonts (such as the font used by the mouse
cursor); and
.BR fonts/75dpi ;
which holds 75 dot-per-inch, proportionally spaced fonts.
For information on how to display a font, see the Lexicon entry for
.BR xfd .
.IP \fBnls\fR
.II /usr/X11/lib/nls
This holds tools used by X developers.
.IP \fBtwm\fR
.II /usr/X11/lib/twm
.II system.twmrc
.II twmrc
This directory holds the file
.BR system.twmrc ,
which is the default resource file for the
.B twm
window manager.
.B twm
reads this file if your home directory does not contain a file named
.BR .twmrc .
If you want to customize
.B twm
to your liking, copy
.B system.twmrc
into your home directory, rename it
.BR .twmrc ,
and modify it.
The following section describes how to modify
.BR $HOME/.twmrc .
.IP \fBx11perfcomp\fR
.II /usr/X11/lib/x11perfcomp
This holds scripts used to help gauge system performance
.IP \fBxinit\fR
.II /usr/X11/lib/xinit
.II xinitrc
This directory holds the file
.BR xinitrc .
The utility
.B xinit
reads this file if your home directory does not contain a file named
.BR .xinitrc .
If you want to customize
.B xinit
to your liking, copy
.B xinitrc
into your home directory, rename it
.BR .xinitrc ,
and modify it to your liking.
The following section describes how to modify
.BR $HOME/.xinitrc .
.RE
.IP \fB/usr/X11/objs\fR
.II /usr/X11/objs
The object modules for the clients and utilities included with this package.
When you install the package onto your system, they are linked with the
libraries in
.BR /usr/X11/lib
to create executable programs.
.PP
This concludes our nickel tour of the X Window System.
The next section discusses the structure of X Windows, in preparation
to discussing how you can modify X.
.SH "The Structure of X"
.PP
.II "X^history
.II MIT
This section introduces the structure of the X Window System.
If you are a beginner, you may find some of this section to be a little dry.
However, if you take a few minutes to read these descriptions,
you probably will find it easier to learn how to customize the X Window System.
.Sh Background
.PP
To begin, a little history.
What we call the
.I "X Window System"
was created at the Massachusetts Institute of Technology.
.II "X^releases"
The first edition, or
.IR release ,
of X appeared in 1984; release 11, which is the
current release of X, appeared in 1987.
.II X^revisions"
Since 1987, release 11 has been revised several times, to fix bugs and
widen its scope; the current edition of X is release 11, revision 5.
(X documentation often uses a kind of shorthand to indicate the release and
revision for which a given program is intended, e.g., ``X11R5'' or
``X11.5''.)
.PP
.II "Sun Microsystems"
MIT performed much of its work on X in partnership with Sun Microsystems;
other computer manufacturers also contributed to X.
The notes at the end of each Lexicon entry usually name the company or
person who contributed the given program to X.
The bulk of the X Window System is copyrighted by MIT; source code, however,
is available for a minimal cost from MIT, and MIT does not demand a royalty
for X.
(Some packages \(em such as X Windows for \*(CO, which you are now using \(em
contain code that is proprietary; therefore, do not assume that you can copy
and give away your X software.)
.PP
.II GUI
Unlike other graphical user interfaces (GUIs),
X makes no assumptions either about the operating
system that is running underneath it, or about the manner by which the user
communicates with the computer.
.II Motif
.II "Open Software Foundation"
.II "OPEN LOOK"
.II AT&T
This approach has a few disadvantages.
In particular, it has led manufacturers to create a number of
different user interfaces, of which the best known are Motif (created by the
Open Software Foundation) and \*(OL (created by Sun and AT&T).
Thus, the appearance and behavior of an X system can vary greatly from one
computer to another.
.PP
.II MS-DOS
However,
the disadvantages of this approach are greatly outweighted by its advantages.
Because X makes no assumptions about its underlying operating system,
X has been adopted as a
.I "de facto"
standard by a number of leading computer manufacturers.
Although it usually runs with some version of the \*(UN operating system
(or a \*(UN-like operating system, such as \*(CO), it has also been ported to
limited operating systems like \*(MD.
Its design also makes X an ideal interface for a network of computers:
even if each computer has a different architecture and operating system,
all can appear the same to the user and run in more or less the same manner,
thanks to X.
.PP
The flexibility of X also means that it is easy to port X programs from one
operating system to another.
Thus, as soon as X is brought up on an operating system,
a wealth of software quickly becomes available to users.
.Sh "X Architecture"
.PP
.II "X^architecture"
The flexibility of the X system results from the fact that X
carefully isolates into a single program
each class of tasks that it must perform.
For example, it isolates into one program, called the \fIserver\fR,
all of the work of driving the hardware.
If an X application needs to draw something onto the screen, it simply
invokes a feature of the server, which does the job.
Thus, to port X to new operating system, one must rewrite the server;
but once that is done, importing an X application
often involves no more than recompiling it.
(There are exceptions to this, of course, but on the whole an X application
that ``plays by the rules'' can be ported with very little trouble.)
.PP
Therefore, X can be compared to a well-designed machine.
Each part of the machine does one thing, and only one thing.
If one part needs to perform a task that falls into the domain of second part,
the first part sends a message to the second part and lets the second
part execute that task for it.
Any one part can be pulled out of the machine and replaced without affecting
the performance of any other part.
.II "object-oriented program design"
.II OOP
This way of fashioning a computer program is called
\fIobject-oriented program design\fR (OOP).
Although the principles of OOP lie beyond the scope of this manual,
you will find it helpful when you work with X to try to think in terms of
objects and how they fit together.
.PP
The manner in which the parts of the X machine fit together is called its
.IR architecture .
The architecture of X has three major parts:
the
.IR server ,
the
.IR "client" ,
and the
.IR "window manager" .
.IP \fBserver\fR
.II "X server^definition"
.II server
The server is the program that actually runs the X system.
It does all the low-level work of drawing images on the screen;
it manages communications among X programs;
and on networked X systems, it manages permissions.
Every other X program registers with the server when they come up;
all of its work with the screen is done via requests to the server.
.IP
.II "VGA"
X Windows for \*(CO comes with two servers:
one that supports color VGA for a set of the most popular VGA chip sets;
and one that supports monochrome images on practically every variety of
VGA or SVGA card.
Most programs run without alteration on either server.
.IP
As a rule of thumb, there is one server for each computer at which
a person works.
.II "X terminal"
.II workstation
Here, the term ``computer'' includes such devices as X terminals,
as well as PCs and workstations.
.IP \fBclients\fR
.II "client^definition"
.II "X client^definition"
A client is a program that registers with the X server,
and uses the server's facilities to work with the user.
As noted above, a client does not contain any code for manipulating
hardware \(em it does not know how to talk to the mouse or the screen.
All it does is send requests to the server and receive information from
the server.
.IP
In this manual, we speak of two types of application:
.I clients
and
.IR utilities .
In this manual, a client
is something that let you do something under X, such as play a game or
edit a file.
.II "utility"
A utility helps you to run X itself.
Both clients and utilities, however, are X clients in the broad sense:
both register with the server and do their work through it.
.IP
On a networked X system, a client can register itself with any server
on the network, provided that the user who launched the client has permission
to register with that server.
For example, a person sitting at one workstation can invoke a client
and tell it to register itself with the server on another person's workstation,
to show that other person a document or graph.
\*(CO does not yet support networking; when it does, you will be able
to tie your machine into a network of computers and work together via X.
.IP "\fBwindow manager\fR"
.II "window manager^definition"
.II "X^window manager"
The
.I "window manager"
is a special client that manages the screen for all other clients.
It allocates screen space to all other clients, and makes sure that no
client intrudes on another client's space.
It provides the tools with which you you can move a window or change its size.
.II "root window"
It also manages all parts of the screen that belong to no individual client;
these include the background of the screen
(also called the screen's
.IR "root window" ),
icons, window frames, title bars, and drop-down menus.
The window manager is largely responsible for the ``look and feel''
of a given implementation of X.
.PP
In your day-to-day work you probably will not need to concern yourself with
the architecture of X.
Its parts fit together to make one smoothly running machine.
However, you will find it helpful to bear the above descriptions in mind,
because they will help you track down the cause of any problems that you
may encounter.
.Sh "Libraries, Widgets, and Resources"
.PP
.II Xlib
Internally, X has a hierarchical design.
The lowest level of the hierarchy are the routines in the library
.BR Xlib .
These routines do all primitive tasks, such as drawing lines and shapes on
the screen, reading input from the keyboard, and polling the mouse.
.B Xlib
underlies all versions of X.
.PP
.II toolkit
On top of
.B Xlib
sit
.IR toolkits .
A toolkit is a set of routines that combine the low-level routines of
.B Xlib
into tools that applications can use directly.
For example, a toolkit routine may combine a set of
.B Xlib
routines that draws shapes into one routine that draws a button.
A toolkit sometimes includes its own low-level routines to cover tasks
that are not addressed in
.BR Xlib ;
for obvious reasons, this is discouraged.
.PP
.II Xt
Numerous toolkits have been written for X.
The tools in this package are built from the MIT toolkit
.BR Xt .
.PP
.II "widget set"
Atop a toolkit sits a
.IR "widget set" .
A widget combines a set of routines with one or more bit-mapped
shapes that can be displayed on the screen.
For example, a button widget can display a bit-mapped shape, superimpose
a button from the toolbox upon the shape, and include routines for polling
the mouse and reacting to the mouse events
(e.g., when a mouse button is pressed or released).
.PP
.II "composite widgets"
.II "widget^composite"
Widgets can be assembled to form ``composite widgets.''
Thus, a widget set has a hierarchy within itself:
whatever affects a widget that is lower in the hierarchy affects all
widgets that are built atop it.
.PP
.II Motif
.II "OPEN LOOK"
.II "Athena widget set"
A screen interface, such as Motif or \*(OL,
consists of a toolkit, a widget set,
and a screen manager that is built from the toolkit and widget set.
The interface embodies a design of how the screen should appear and how the
interface should behave.
.PP
X's widgets are designed so that you can change ``on the fly'' many of
their aspects.
For example, a button widget can let you set the text that appears in it,
its color, its position on the screen, dimensions, whether it has rounded
or square corners, and so on.
.II resource
You can do this by setting a widget's
.IR resources .
.PP
You can set resources in any, or all, of three ways:
.IP \fB1.\fR 0.3i
First, many applications read information from command-line options.
.II Xt
.II geometry
Applications that are built from the
.B Xt
toolkit take a standard set of command-line options, which (among other
things) let you set colors, the window's geometry (that is, its initial
size and position on the screen), and whether it appears in reverse video in
reaction to an event.
The suite of command-line options varies from application to application:
Some have a rich set that lets you fine-tune the application, whereas
others' are sparse.
.IP \fB2.\fR
.II "app-defaults"
.II "defaults"
Some applications read a file from directory
.BR /usr/X11/lib/app-defaults .
In this file, you set resources for that application.
.II xcalc
.II xfontsel
For some applications, such as
.B xcalc
or
.BR xfontsel ,
the application file can be quite large and complex.
The settings in an application's defaults file apply only that application.
By modifying its defaults file, you can change an application's appearance and,
in some instances, its behavior.
.IP \fB3.\fR
.II xrdb
You can use the command
.B xrdb
to build a resource data base within the X server.
Most applications read this data base as they come up.
The contents of this data base override any defaults built into any
application, or any resource settings they may have read from an
application-defaults file.
The settings in the resource data can apply either to an individual
application or to all applications, depending upon how you ``phrase'' them.
.PP
.II "widget class"
As we noted above, widgets most often are built out of other widgets.
If a widget is used to build other widgets, that first widget is said
to be a widget
.IR class .
X has a mechanism by which you can set a widget class;
if you alter a widget class,
every subordinate widget that incorporates the first widget into itself
is altered as well.
.PP
The next chapter, which introduces the X clients,
describes how to set widget classes.
X widgets and widget classes are a large and complex topic of study;
however, it is possible even for novices to make minor modifications to
a defaults file, as we will show below.
.Sh "Bit Maps"
.PP
.II "bit map"
A
.I "bit map"
is a picture that is formed by turning cells in a grid on and off.
X interprets each cell in the grid as a pixel.
The mouse cursor, for example, is a bit-mapped picture.
.PP
You can draw a bit-mapped image with a ordinary text editor, using a
pattern of pound signs `#' and hyphens `-',
or you can use one of the tools that comes with X.
You can then ``compile'' the bit map into C code that can
be included in an application, just like any other header file.
.PP
X includes tools with which you can draw, edit, and compile bit maps.
These are introduced in the next chapter.
.PP
X Windows for \*(CO comes with a selection of bit maps.
These are stored in directory
.BR /usr/X11/include/X11/bitmaps .
.Sh Fonts
.PP
.II font
A
.I font
is a collection of shapes that comprise the letters of the alphabet and
most commonly used punctuation marks.
A font has 14 attributes that describe its
size, weight, style, manufacturer, the character set it encodes, and other
information.
.PP
The characters in a font are bit-mapped images.
.II font^cursor
Thus, a ``font'' does not necessarily have to be the letters of the alphabet;
for example, the mouse cursors are stored in a special font called
.BR cursor .
.II xfd
(For a table of all available mouse cursors, see the entry in this manual's
Lexicon for the X utility
.BR xfd .)
This also means that, if you are so inclined, you can create and use
your own fonts.
.PP
.II "font path"
.II Xconfig
Fonts are stored in the directories named in the server's
.IR "font path" ,
which is set in the file
.BR /usr/X11/lib/Xconfig .
.PP
Because font files can be quite large, it is customary for them to be
compressed so they take up less space on disk.
X can use fonts in their compressed form; you do not have to uncompress
a font for X to use it.
.PP
.II fonts.dir
Each directory named in the font path must contain a file named
.BR fonts.dir .
Each entry in this file gives a font's full, 14-part name and
the file in which it resides.
If you move a new font into a font directory, you must modify this file
or X will not be able to find the font.
.PP
.II mkfontdir
The X utility
.B mkfontdir
reads all of the fonts in a directory and rebuilds that directory's
.B fonts.dir
file to show what fonts that directory actually contains.
.PP
A font's full name describes all 14 of a font's attributes.
For example, the following gives the full name of the font used for on titles:
.DM
	-adobe-times-bold-*-normal-*-*-140-*-*-*-*-*-*
.DE
.II fonts.alias
For the sake
of brevity, you can use an alias for a font's full name.
A font directory should also contain a file named
.BR fonts.alias ;
this file maps aliases to full font names.
.PP
X Windows for \*(CO comes with a selection of fonts for your applications.
It also comes with tools for selecting fonts interactively, and for
modifying a
.B fonts.dir
file.
These are introduced in the next chapter.
.II xfontsel
For more information on selecting fonts, and for more information on
the elements of a font's name, see the entry in this manual's Lexicon for
the X utility
.BR xfontsel .
.Sh Colors
.PP
.II color
X Windows includes tools for describing and managing colors.
The monochrome server also manages colors; however, it only recognizes
two colors \(em black and white.
.PP
.II rgb.txt
The file
.B /usr/X11/lib/rgb.txt
defines and names each color that the X server recognizes.
The following gives a typical entry:
.DM
	65 105 225	RoyalBlue
.DE
The three numbers give the intensity settings on the three electron
guns in your color monitor:
respectively red, green, and blue.
Each intensity can range from 0 through 255.
Setting all three guns to the maximum intensity, 255, creates white;
setting all three to zero creates black.
.PP
When you name a color in a defaults file or command-line option,
the X server looks up the name in this file and translates it into
its numeric settings.
If you wish to add a new name for a color, just edit this file.
Note that it is unwise to modify or delete any color names from this
file; otherwise, if an application requests that color by name, X will
not be able to find it.
.PP
.II palette
.II color^palette
.II VGA^palette
So far, so good.
A problem, however, arises because you can describe up to 16,777,216 colors
(that is, 256 cubed), but most VGA cards can display no more than 16 colors
at any one time.
An application usually requests a set, or
.IR palette ,
of colors from the server; the server, then, has to somehow juggle the
palettes of all of the applications it is handling into one master palette
that it can request from your system's video card.
.PP
X manages its palette automatically, and in most instances you do not have to
do anything.
X Windows for \*(CO does include tools to help you manage colors by hand,
should you wish to do so.
.PP
.II "color^set mode in Xconfig"
If you wish, you can edit
.B Xconfig
to set the mode of color display.
.B X
recognizes any of the following settings:
.DM
	DirectColor
	TrueColor
	PsuedoColor
	StaticColor
	GrayScale
	StaticGray
.DE
Place the value on a line by itself.
The default is
.BR PsuedoColor .
.PP
This concludes our brief introduction to the structure of X.
Although X is large and complex, it never departs from the principles
outlined here \(em well, hardly ever.
The following section describes how to customize the window manager
.BR twm ;
you will see some of these principles in action.
.SH "Customing the Window Manager"
.PP
As noted earlier, the window manager is the master client that manages the
appearance of the entire screen.
.II "root window"
Its window fills the entire screen;
thus, the window of the window manager
is sometimes called the screen's
.IR "root window" .
.PP
All other windows on the screen are sub-windows of the root window;
thus, the window manager positions all other windows on the screen
(or, to be more exact, within the root window),
and for supplying services within the root window such as the drop-down menus,
the window frames, icons, and window title bars.
As a rule of thumb, remember that everything within a window's frame is
defined by the client displayed within that window, whereas everything from
the frame out is the responsibility of the window manager.
You could run more than one application under X without a window manager,
but you would have no way to reposition or resize windows, or perform many
of the other actions that make X Windows so flexible and useful.
.PP
Like many other X clients, the window manager
.B twm
has a defaults file that defines the resources it uses.
We will discuss how to modify this file to change the appearance and
behavior of the window manager.
First, however, we must introduce the program
.BR xinit ,
which invokes the window manager and the other clients that appear
on your screen when you invoke X.
.Sh "Customizing xinitrc"
.PP
.II startx
.II xinit
As you recall, to invoke X you must issue the command
.BR startx .
This is actually a shell script that invokes the X utility
.BR xinit ;
this utility is responsible for invoking the X server, the window manager,
and any other utilities that you want to appear on the screen when you start
up X.
.PP
.II xinitrc
When
.B xinit
is invoked, it reads the file
.BR /usr/X11/lib/xinit/xinitrc ,
which gives the default configuration of X.
This file reads as follows:
.DM
	xclock -geometry 135x141+15+26 -fg blue -chime -update 1 &
	xvt -geometry 80x24+130+146 &
	twm
.DE
.II xsetroot
The first two commands,
.B xclock
and
.BR xvt ,
invoke the applications
.B xclock
and
.BR xvt ,
and display them on the screen.
The argument
.B \-geometry
gives the size of the window and its position on the screen.
The first two numbers, which are separated by an `x', give the size.
This can be either in pixels or, as with the
.B xvt
command, in rows and columns.
The second two numbers give, respectively, the X and Y position of the upper
left corner of the window.
If a number is positive, it is counted from the upper-left corner of the
screen; if negative, it is counted from the lower-right corner.
Note that both
.B xclock
and
.B xvt
are invoked in the background, as shown by the `&' that concludes
the command.
.PP
The last command,
.BR twm ,
invokes the window manager.
This is invoked in the foreground, because you want the X server to die when
you exit from the window manager.
Thus, when you select the command
.K "Quit_Window_Mgr."
from the menu
.BR "TWM Operations" ,
the X server also dies, and the console returns to its normal, character-based
interface.
.PP
Suppose, however, that you want the screen to appear differently.
To do so, you would first enter the command
.DM
	cp /usr/X11/lib/xinit/xinitrc $HOME/.xinitrc
.DE
This gives you a private copy of
.BR xinitrc .
When
.B xinit
is invoked, it first looks for file
.B .xinitrc
in your home directory; only if it cannot find this file does it read file
.BR /usr/X11/lib/xinit/xinitrc .
.PP
Now, you can use \*(ME or any other text editor to modify your
.B $HOME/.xinitrc
as you wish.
.II xsetroot
.II plaid
For example, if you wish to tile the root window with a plaid design
(so that it resembles a picnic tablecloth), use the command
.B xsetroot
as follows:
.DM
	xsetroot -bitmap /usr/X11/include/X11/bitmaps/plaid &
.DE
The next time you invoke X, the root window will appear like this:
.PH 1 1 \*(XD/rootA.eps
For details on the command,
.B xsetroot
see its entry in this manual's Lexicon.
.PP
.II xclock
As another example, suppose that you prefer to have a digital clock rather than
an analogue one.
Just modify the
.B xclock
command to the following:
.DM
	xclock -geometry 135x141+15+26 -digital -fg blue -chime -update 1 &
.DE
You can invoke other X clients, if you wish.
.II xbiff
For example, many users like to invoke the X client
.BR xbiff .
This client displays a picture of a mailbox; when you receive mail, the flag
on the mailbox pops up.
Try adding the command
.DM
	xbiff -geometry 91x81+476+44 &
.DE
after the
.B xsetroot
command.
The mailbox will then be displayed automatically the next time you invoke X.
.PP
.II xeyes
Many users also like to invoke the X client
.B xeyes
when they bring up X.
This command displays a pair of eyes whose pupils follow the mouse cursor
around the screen.
Inserting the command
.DM
	xeyes -geometry 150x100+286+66 &
.DE
into
.B .xinitrc
brings up the eyes near the top center of your screen.
.PP
.II geometry
Note that changing the
.B \-geometry
argument to a command can be rather difficult.
The best approach is invoke the client through
.BR xvt ;
position and size its window as you want it;
then select the
.K Info
option from the menu
.BR "WINDOW OPS" ,
to show you the size and position of the window;
and copy this information into
.BR xinit .
.Sh "Customizing .twmrc"
.PP
As shown above, the window manager
.B twm
is invoked last from within
.BR xinitrc ,
so that when it exits the X session will end as well.
.II system.twmrc
When
.B twm
comes up, it reads the file
.BR /usr/X11/lib/twm/system.twmrc ,
which sets its default behaviors.
.B twm
has many features that you can set or invoke, so
.B twmrc
can be extremely complex.
The following introduces a few of the more commonly used features that you
can set or invoke from within
.BR twmrc .
.PP
To begin, copy the file
.B /usr/X11/lib/twm/system.twm
to
.BR $HOME/.twmrc .
.B twm
reads
.B system.twmrc
only if it cannot find
.B .twmrc
in your home directory.
You can now use \*(ME or any other text editor to edit your private copy of
.B .twmrc
to suit your preferences.
.PP
.B .twmrc
is divided into three sections:
.IP \fBVariables\fR 0.8i
This section sets switches and variables within
.BR twm ,
such as the colors used with various objects, the cursor shapes used in
various circumstances, and how icons are managed.
.IP \fBBindings\fR
This binds function keys, mouse buttons, and title buttons to various actions.
It also lets you define functions.
These functions are much like shell functions, in that they consist of
one or more of
.BR twm 's
built-in functions bundled together.
.IP
Mouse buttons and function keys can be given different bindings,
depending upon the object in which the mouse cursor is positioned.
A binding can tell
.B twm
to display a menu, execute a command under the shell, invoke one of
.BR twm 's
built-in functions, or invoke a user-defined function.
.IP \fBMenus\fR
These define the contents of the menus that
.B twm
displays.
Note that the
.B Bindings
section defines what menus appear when.
.PP
The following sub-sections describe these portions of
.B .twmrc
in more detail.
For a full description of
.BR twm 's
variables, functions, and menus, see the entry for
.B twm
in this manual's Lexicon.
.Sh "Variables"
.PP
As noted above,
.B twm
has many variables that you can set to change its appearance or behavior.
Some variables are Boolean and some take a numeric value,
but most take a string value as an argument.
Some variables also take a
.IR "window list" ,
or a list of windows to which a given argument applies.
.PP
.II DontMoveOff
As an example of a Boolean variable, consider the variable
.BR DontMoveOff .
When this variable is present in
.BR .twmrc ,
the window manager will not let you move a window off the physical screen.
Thus, inserting the variable
.DM
	DontMoveOff	
.DE
into your
.B .twmrc
restricts window movement to the physical screen.
You can override this default setting, as will be described.
.PP
.II NoTitle
The variable
.B NoTitle
is another Boolean variable:
if set,
.B twm
does not display a title bar on its windows.
You can, however, use a window list with this variable to restrict it to
selected windows.
.B system.twmrc
defines
.B NoTitle
as follows:
.DM
	NoTitle
	{
		"Twm Door"
		"TWM Icon Manager"
		"oclock"
		"xbiff"
		"xclock"
		"xload"
	}
.DE
.II xclock
As you can see,
.B xclock
is on this list; and when it comes up on your screen,
it does not have a title bar.
.PP
.II BorderWidth
The variable
.B BorderWidth
is an example of a variable that takes an integer value.
This variable sets the default width, in pixels, of a window's border
(or frame).
(Note that in X, the terms ``border'' and ``frame'' are used almost
interchangeably.)
The default setting is three.
You can change this value.
For example, inserting the instruction
.DM
	BorderWidth 50
.DE
makes the window borders 50 pixels wide; and when your screen comes up,
it will look like this:
.PH 1 1 \*(XD/rootB.eps
Fifty pixels probably is too wide a border; but, if you wish, you can thicken
the border to four or five pixels to make it easier for you to resize and move
the window.
.PP
.II Cursors
Finally, as an example of a variable that takes one or more string arguments,
consider the variable
.BR Cursors .
This variable sets the shape of the cursor in various parts of the screen,
or when certain actions are occurring.
.B system.twmrc
defines this variable as follows:
.DM
.ta 0.5i 1.0i 2.0i
	Cursors 
	{
		Frame	"top_left_arrow"
		Title	"top_left_arrow"
		Icon	"top_left_arrow"
		IconMgr	"top_left_arrow"
		Move	"fleur"
		Resize	"fleur"
		Menu	"sb_left_arrow"
		Button	"hand2"
		Wait	"watch"
		Select	"dot"
		Destroy	"pirate"
	}
.DE
The terms in the left column define a portion of the screen or an action.
For the most part, these are self-explanatory:
for example,
.B Move
and
.B Resize
refer to when you are, respectively, moving and resizing a window;
whereas
.B Frame
refers to when the cursor touches the window border.
.PP
The right column names the cursor to be used.
Because the names are strings, you must enclose them within quotation marks.
.II cursorfont.h
The names of the cursors are defined in file
.BR /usr/X11/include/X11/cursorfont.h ,
with except that the prefix
.B XC_
is dropped from each name.
Read this file for suggestion on other cursors you can use;
for example, you can change the
.B Wait
cursor from
.B watch
to
.BR coffeemug ,
which shows a stylized coffee mug.
.II xfd
For a picture of what cursors are available, see the entry for the command
.B xfd
in this manual's Lexicon.
.PP
As noted above, the X cursors are stored in a font; a font, after all,
is simply a set of bit-mapped images.
A cursor actually consists of two bit-mapped images:
one draws the cursor itself, and the second (which is drawn in a constrasting
color) forms a mask around the cursor.
This is done so that the cursor will never disappear against its background.
If you wish, you can use a bit-mapped image of your own creation as a mouse
cursor.
To do so, simply replace the name of the cursor from the
.B cursor
font with the name of the bit-mapped image you want, plus its mask.
.II Frame
For example, if you replace the definition of the
.B Frame
cursor with the following:
.DM
.ta 0.5i 1.5i
	Frame	"/usr/X11/include/X11/bitmaps/star" \e
		"/usr/X11/include/X11/bitmaps/starMask"
.DE
then, the next time you restart X, the cursor will change to an asterisk
whenever the mouse cursor touches a window frame.
.PP
.II Color
Some string variables let you set specific values for one or more windows.
For example, consider the variable
.BR Color ,
which sets the window manager's color scheme under the color server.
.B system.twmrc
defines it as follows:
.DM
.ta 0.5i 1.0i 3.0i 4.0i
	Color
	{
		DefaultBackground	"#5f9ea0"	# cadet blue
		DefaultForeground	"#ffffff"	# white
		BorderColor	"#00ff00"	# green 
		{
		"xload"	"khaki"
		"xclock"	"khaki"
		"xbiff"	"red"
		}
		BorderTileBackground	"black"		# {winList}
		BorderTileForeground	"white"		# {winList}
		MenuBackground	"firebrick"
		MenuForeground	"white"
		MenuTitleBackground	"green"
		MenuTitleForeground	"black"
		IconBackground	"gray85"	# {winList}
		IconForeground	"brown"	# {winList}
		IconBorderColor	"yellow"	# {winList}
		IconManagerBackground	"blue"	# {winList}
		IconManagerForeground	"white"	# {winList}
		IconManagerHighlight	"#ffff00"	# {winList}
		MenuShadowColor	"grey40"
		TitleBackground	"firebrick3"	# {winList}
		TitleForeground	"white"	# {winList}
	}
.DE
The left column names the section of the screen being defined.
Most of these are self-explanatory.
.PP
The right column names the color to be used in that portion of the
screen.
Because these are strings, you must enclose them within quotation marks.
A color can be defined either by name or as a number.
.II rgb.txt
The color names that
.B twm
recognizes are defined in file
.BR /usr/X11/lib/rgb.txt .
A number consists of a pound sign `#' followed by six hexadecimal digits:
two each for the red, green, and blue video guns.
For example,
.B #00ff00
defines solid green.
.PP
As noted earlier,
.B Color
(like some other string variables)
lets you set colors for individual windows by name.
.II BorderColor
For example, the following sets the colors for the window border:
.DM
.ta 0.5i 2.5i 3.5i
	BorderColor	"#00ff00"	# green 
	{
	"xload"	"khaki"
	"xclock"	"khaki"
	"xbiff"	"red"
	}
.DE
The default border color is green; however, the windows for the X applications
.B xload
and
.B xclock
have a khaki border, and the X application
.B xbiff
has a red border.
.PP
If, for whatever reason, you want
.B xvt
to have a pink border, insert the line
.DM
.ta 0.5i 2.5i 3.5i
	"xvt"	"pink"
.DE
into the above list.
Then, the next time you invoke X,
.B xvt
will come up bordered in pink.
.PP
For a complete list of the variables that you can set or modify your
.BR .twmrc ,
see the entry for
.B twm
in this manual's Lexicon.
.Sh "Bindings"
.PP
The second part of
.B .twmrc
are bindings:
that is, entries that define functions,
and entries that bind functions to mouse-button events, function keys,
and title-button events.
.PP
Function bindings combine one or more existing functions into a new function.
For example, the following defines the function
.BR xrdb-color :
.DM
	Function "xrdb-color"
	{
		f.exec "xrdb -remove"
		f.exec "xrdb -DCOLOR -load $HOME/.Xdefaults"
	}
.DE
This function consists of two calls to the function
.BR f.exec ,
which is built into
.BR twm ;
this function executes its argument under a shell.
.II xrdb
The two calls to
.B f.exec
invoke the X utility
.BR xrdb ;
the first invocation
drops the current resource table, and the second loads the contents of file
.B $HOME/.Xdefaults
into the server.
(For details on what these actions accomplish,
see the Lexicon entry for
.BR xrdb .)
The section on menus, below, will show how to call a function.
.B twm
has a number of functions built into it; for a full list, see the entry for
.B twm
in this manual's Lexicon.
.PP
The binding of a title button consists of the name of the title button,
followed by the name of the bit-mapped image to be drawn on the title bar,
followed by the action to execute when it is invoked.
For example, following entry from
.B system.twmrc
binds the left-title button:
.DM
	LeftTitleButton	 ":menu"     = f.menu "LeftTitleButton" 
.DE
The
.B LeftTitleButton
is the button that appears immediately to the left of the name of the window
in the title bar.
.B :menu
is the bit-mapped image to display for that button;
it is what we have called a stylized `D'.
This menu is built into
.BR twm .
Finally, the binding indicates that when this button is ``pressed,''
.B twm
is to invoke its internal function
.B f.menu
and display the menu called
.BR LeftTitleButton .
This menu, which is described below, is the menu that on the screen has the
title
.BR "WINDOW OPS" .
.PP
A binding for a button or keyboard event consists of three parts:
the name of the key or button in question, the context in which the
binding applies, and the action to take.
The name of the key or mouse button can be combined with metakeys
(i.e., the
.B <shift>
key, the
.B <ctrl>
key, and the
.B <esc>
key) to form other key combinations.
.PP
Context gives the context in which a pressing a given button or key performs
a given action.
The following lists the possible contexts:
.DS
	\fBa\fR	All
	\fBf\fR	Frame
	\fBi\fR	Icon
	\fBm\fR	Icon Manager
	\fBr\fR	Root Window
	\fBt\fR	Title
	\fBw\fR	Window
.DE
A button or key can have more than one context; if so, the context letters
must be separated by a vertical bar `|'.
Note that with regard to the
.B w
context, this simply sets a default action; the application, of course,
governs what goes on within its own window, and can overrule this setting
should it wish.
.PP
The action calls a function, as shown above.
.PP
The following gives the bindings from
.B system.default
for mouse button 1 (that is, the left-mouse button):
.DM
.ta 0.5i 2.0i 3.5i
	Button1 = c|m	: i|f|t|w	: f.raise
	Button1 =	: root	: f.menu "Applications"
	Button1 =	: t|i	: f.move
	Button1 =	: frame	: f.resize
	Button1 =	: m|i	: f.iconify
.DE
The following discusses these lines in order:
.IP \fB1.\fR 0.3i
This first line defines Button1 with a
.B <ctrl>
or
.B <esc> 
(meta) key.
If the mouse cursor is in an icon, on the window frame, on the title bar, or
within a window, then holding down the
.B <ctrl>
key and pressing the left-mouse button invokes the
.B twm
function
.BR f.raise ,
which raises the window to the foreground.
.IP \fB2.\fR
The second and succeeding lines contain no key entries, which means that this
button is not used with metakeys.
The second line instructs
.B twm
to invoke the function
.B f.menu
to display the menu
.B Applications
should you press the left-mouse button while the mouse
cursor is positioned over the background of the root window.
.IP \fB3.\fR
Invoke the
.B twm
function
.BR f.move ,
which moves the current window, should you press the left-mouse button
while the mouse cursor is positioned over the title bar or the window's icon.
.IP \fB4.\fR
Invoke the
.B twm
function
.BR f.resize ,
which resizes a window, should you press the left-mouse button
while the mouse cursor is positioned over the window's frame.
.IP \fB5.\fR
Finally, invoke the
.B twm
function
.BR f.iconify ,
which iconifies a window, should you press the left-mouse button while the
mouse cursor is positioned over the icon manager or the window's icon.
Note that this contradicts the definition given in line 3, which told
.B twm
to raise the window should you click the left-mouse button while the cursor is
positioned over the window's icon.
In the case of contradiction like this,
.B twm
uses the last binding to appear in its resource file.
.PP
You can modify these bindings if you wish.
For example, you can modify the setting for the left-mouse button in the
context of the window's frame to the following:
.DM
	Button1 =	: frame	: f.destroy
.DE
Normally, when you click the left-mouse button while the mouse cursor
is resting on the window's frame,
.B twm
resizes the window;
this change destroys the application and closes its window.
This is an extreme case, but it shows that you can rebind the buttons and
keys to suit your preferences in almost every case.
.PP
For a complete list of the elements that you can bind, and the internal
.B twm
functions to which you can bind them, see the Lexicon entry for
.BR twm .
.Sh "Menus"
.PP
Menus are in many ways the easiest part to define in a the
.B twm
resource file.
A menu begins with the keyword
.BR Menu ,
followed by the menu's name.
Then comes the default color scheme for the menu, foreground first and then
background.
The entries for the menu follow, between braces.
Each entry consists of the stub that appears in the menu, followed by an
optional color scheme, then the action to take when this entry is selected.
.PP
.II menu^APPLICATIONS
The following gives the definition of the menu
.B Applications
from
.BR system.twmrc :
.DM
.ta 0.5i 1.0i 3.5i
	Menu "Applications" ("black":"lightseagreen")
	{
		"APPLICATIONS" ("black":"lightseagreen")	f.title
		"Font Select" ("lightseagreen":"black")	!"xfontsel &"
		"Puzzle"	!"puzzle &"
		"XBiff"	!"xbiff &"
		"XCalc"	f.menu " Calculator " 
		"XClock"	!"xclock -chime -fg blue -update 1 &"
		"Xeyes"	!"xeyes -fg red &"
		"XLoad"	!"xload &"
		"XLogo"	!"xlogo &"
		"XMag"	!"xmag &"
		"XTerm"	!"xvt -ls -cr red &"
		"XTetris" ("lightseagreen":"black")	!"xtetris &"
	}
.DE
This menu is shown in one of the figures reproduced earlier.
Most of the entries are self-explanatory.
Note that the `!' is a synonym for
.BR f.exec ,
which executes its argument under the shell.
.PP
The entry
.B APPLICATIONS
invokes the
.B twm
function
.BR f.title ,
which indicates that this is the title entry for the menu.
You cannot select it.
.PP
The entry for
.B XCalc
.DM
	"XCalc"	f.menu " Calculator " 
.DE
invokes the function
.BR f.menu .
This function displays a button at the right of the menu entry,
and displays a sub-menu when the button is touched.
Its argument is the name of the menu to drop down, in this case the
menu entitled
.BR Calculator ,
which is also defined in
.BR system.twmrc .
.PP
If you wish, you can add commands to this menu:
just insert a line in the appropriate spot.
The entries in the menu are sorted by hand;
.B twm
does not rearrange their order in any way.
.II xgas
For example, to insert into this menu the game
.BR xgas ,
shown above, just add the line
.DM
	"Xgas"	!"xgas -fg red &"
.DE
directly after the entry labelled
.BR Xeyes .
.PP
If you wish, you can also change the arguments to existing commands.
.II xclock
For example, the entry
.DM
	"XClock"	!"xclock -chime -fg blue -update 1 &"
.DE
invokes the X client
.B xclock
invokes an analogue clock with a blue face, which is updated once every second,
and chimes on the hour and half-hour.
If you wish to eliminate chiming and have a digital clock instead,
modify this command to read:
.DM
	"XClock"	!"xclock -digital -fg blue -update 1 &"
.DE
For the options available with each of these commands,
see its entry in this manual's Lexicon.
.PP
The color settings are used only by the color server.
If you wish, you can give a separate color combination to each entry in
the menu.
Note that the first and last selectable entries in this menu both have the
color settings of:
.DM
	("lightseagreen":"black")
.DE
There is a reason for giving the same colors to the first and last entries:
if the first and last color settings in the menu are not exactly the same,
.B twm
generates colors for the menu that fade from the first known pair of colors
to the last known pair.
To see this in action, try removing the first instance of:
.DM
	("lightseagreen":"black")
.DE
.II MenuBackground
.II MenuForeground
.II Monochrome
If a menu does not set any colors, the server uses the settings for
.B MenuBackground
and
.B MenuForeground
in the variable
.BR Color .
The monochrome server ignores all color settings, and uses the settings for
.B MenuBackground
and
.B MenuForeground
in the variable
.BR Monochrome .
.PP
This concludes the discussion of how to customize the window manager.
For more information, see the Lexicon entries for
.BR twm ,
.BR xinit ,
and
.BR xsetroot .
.SH "Where To Go From Here"
.PP
This concludes our introduction to the X Window System.
For more information, see the following chapter, which introduces the
clients and utilities that comes with X Windows for \*(CO.
The Lexicon discusses each client and utility in detail.
If you wish to explore X further, we suggest that you buy the books
named in the introduction to this manual.
.PP
However, there is no better teacher than experience.
We suggest that you work with X, try modifying the defaults files
(or, to be exact,
.I copies
of the defaults files),
and play with the system.
X Windows is well designed and robust.
You will become proficient quickly.
We hope that you enjoy using X Windows!

.ds TL "X Clients"
.NH "X Windows Clients"
.PP
This chapter introduces the clients and utilities
included with X Windows for \*(CO.
.PP
.II client
.II utility
.II application
Strictly speaking, a
.I client
is a program that registers with, and runs under, the X server.
``Client'' often is used as a synonym for the term
.IR application .
This manual uses the term
.I utility
to refer to a program that helps you to manage and run the X Window System
itself; and the term
.I client
to refer to a program with which you can perform some task under
the X Window System (e.g., edit a file or play a game).
.PP
This chapter introduces the utilities and clients
included with X Windows for \*(CO.
It then gives examples of how to modify an application's appearance or
behavior by changing its resources.
.SH "X Utilities"
.PP
.II utility
.II "X^utilities"
A utility helps you to run the X Window System itself.
X Windows for \*(CO includes utilities to help run every aspect of the X system.
The following introduces them by category.
.Sh "Bit Maps"
.PP
.II "bit map"
A
.I "bit map"
is an image that is composed of black and white pixels within a defined space.
X uses bit maps extensively; for example, the shapes of the mouse cursor,
fonts of alphabetic characters, buttons, and icons are all bit maps.
.PP
.II xlogo32
X stores a bit map in the form of a array.
For example, the file
.BR /usr/X11/include/X11/bitmaps/xlogo32 ,
which is a bit map of the X logo, consists of the following:
.DM
	#define xlogo32_width 32
	#define xlogo32_height 32
	static char xlogo32_bits[] = {
	   0xff, 0x00, 0x00, 0xc0, 0xfe, 0x01, 0x00, 0xc0, 0xfc, 0x03, 0x00, 0x60,
	   0xf8, 0x07, 0x00, 0x30, 0xf8, 0x07, 0x00, 0x18, 0xf0, 0x0f, 0x00, 0x0c,
	   0xe0, 0x1f, 0x00, 0x06, 0xc0, 0x3f, 0x00, 0x06, 0xc0, 0x3f, 0x00, 0x03,
	   0x80, 0x7f, 0x80, 0x01, 0x00, 0xff, 0xc0, 0x00, 0x00, 0xfe, 0x61, 0x00,
	   0x00, 0xfe, 0x31, 0x00, 0x00, 0xfc, 0x33, 0x00, 0x00, 0xf8, 0x1b, 0x00,
	   0x00, 0xf0, 0x0d, 0x00, 0x00, 0xf0, 0x0e, 0x00, 0x00, 0x60, 0x1f, 0x00,
	   0x00, 0xb0, 0x3f, 0x00, 0x00, 0x98, 0x7f, 0x00, 0x00, 0x98, 0x7f, 0x00,
	   0x00, 0x0c, 0xff, 0x00, 0x00, 0x06, 0xfe, 0x01, 0x00, 0x03, 0xfc, 0x03,
	   0x80, 0x01, 0xfc, 0x03, 0xc0, 0x00, 0xf8, 0x07, 0xc0, 0x00, 0xf0, 0x0f,
	   0x60, 0x00, 0xe0, 0x1f, 0x30, 0x00, 0xe0, 0x1f, 0x18, 0x00, 0xc0, 0x3f,
	   0x0c, 0x00, 0x80, 0x7f, 0x06, 0x00, 0x00, 0xff};
.DE
The manifest constants
.B xlogo32_width
and
.B xlogo32_height
give the width and height of the image, in pixels.
The zero-bits within the array represent white pixels, whereas the non-zero
bits represent black pixels.
.PP
If you wish, you can draw new bit maps or edit existing bitmaps.
X Windows for \*(CO includes the following tools for working with
bit maps:
.DS
.ta 0.5i 1.5i
	\fBbitmap\fR	Bit map editor
	\fBatobm\fR	Convert ASCII to an X bit-mapped image
	\fBbmtoa\fR	Convert an X bit-mapped image to ASCII
.DE
.II bitmap
.B bitmap
is a bit-map editor.
With it you can draw a bit-mapped image using the mouse.
It also has tools for copying or inverting regions of the bit map,
drawing geometric shapes, rotating bit maps, and the like.
.PP
.B bmtoa
converts a bit map to an ASCII format that you can edit with an ordinary
text editor.
For example, the command
.DM
	bmtoa /usr/X11/include/X11/bitmaps/xlogo32
.DE
turns the bit map shown above into the following:
.DM
	########----------------------##
	-########---------------------##
	--########-------------------##-
	---########-----------------##--
	---########----------------##---
	----########--------------##----
	-----########------------##-----
	------########-----------##-----
	------########----------##------
	-------########--------##-------
	--------########------##--------
	---------########----##---------
	---------########---##----------
	----------########--##----------
	-----------#######-##-----------
	------------#####-##------------
	------------####-###------------
	-------------##-#####-----------
	------------##-#######----------
	-----------##--########---------
	-----------##--########---------
	----------##----########--------
	---------##------########-------
	--------##--------########------
	-------##---------########------
	------##-----------########-----
	------##------------########----
	-----##--------------########---
	----##---------------########---
	---##-----------------########--
	--##-------------------########-
	-##---------------------########
.DE
By default,
.B bmtoa
represents a white pixel with a hyphen `-' and a black pixel with a
pound sign `#'.
.PP
Finally,
.B atobm
turns an ASCII image into a bit map that X can use.
You could, for example, use a text editor to edit the image generated by
.BR bmtoa ,
then use
.BR atobm
to re-compile the image into bit-map format.
.PP
.II xsetroot
As a side note, you can use a bit map to ``tile'' the root window of your
screen \(em simply invoke the command
.B xsetroot
with its option
.BR bitmap .
For example, the command
.DM
	xsetroot -bitmap /usr/X11/include/X11/bitmaps/xlogo32
.DE
tiles the root window with the X logo.
.Sh "Colors"
.PP
.II color
X Windows for \*(CO includes the following utilities for manipulating colors:
.DS
.ta 0.5i 1.5i
	\fBshowrgb\fR	Un-compile an RGB color-name data base
	\fBxcmsdb\fR	Manipulate xlib screen-color characterization data
	\fBxstdcmap\fR	X standard color-map utility
.DE
.II showrgb
.B showrgb
names the colors that the server recognizes.
.II rgb.txt
The file
.B /usr/X11/lib/rgb.txt
gives an example of its output,
and also shows colors that the X color server recognizes by default.
.PP
.II xcmsdb
.II xstdcmap
.B xcmsdb
and
.B xstdcmap
let you display and manipulate color information
within widgets and the server.
Using these utilities requires a detailed knowledge of X internals.
For details, see the entry in the Lexicon for each utility.
.Sh "Fonts"
.PP
.II font
A
.I font
is a set of bit-mapped images that form the letters of the alphabet
and commonly used punctuation marks.
X Windows for \*(CO includes the following utilities for manipulating text
fonts:
.DS
.ta 0.5i 1.5i
	\fBbdftopcf\fR	Generate a PCF font from a BDF file
.\"	\fBfs\fR	X font server
.\"	\fBfsinfo\fR	Display information about a font server
.\"	\fBfslsfonts\fR	Display a list of available fonts
.\"	\fBfstobdf\fR	BDF font generator
	\fBmkfontdir\fR	Create file fonts.dir from directory of font files
.\"	\fBshowfont\fR	Dump a font for the X font server
	\fBxfd\fR	Display all the characters in an X font
	\fBxfontsel\fR	Interactively select X11 fonts
	\fBxlsfonts\fR	List fonts being used on a server
.DE
.\"Because fonts vary in so many ways \(em for example,
.\"by style, weight, slant, size, and character set \(em a set of fonts for X
.\"can consume quite a bit of disk space.
.\".II fs
.\"Rather than have each machine reproduce all fonts, the X system uses the
.\"utility
.\".BR fs ,
.\"which is a font server.
.\".B fs
.\"receives requests for fonts from all of the X systems on a network, and returns
.\"the font in question.
.\".II "font^scalable"
.\".B fs
.\"can also turn a scalable font, which is kept in the form of a logical
.\"description rather than a bit map, into a normal set of bit-mapped images
.\"at a requested size, and return the bit-mapped font to the requester.
.\".PP
.\"Because X Windows for \*(CO does not yet support networking, you probably
.\"seldom need to invoke
.\".BR fs .
.\"You will need to do so, however, if you wish to change fonts on the fly,
.\"rather than just use the fonts that are invoked when the server comes up.
.\".PP
.\".II fsinfo
.\".II fslsfonts
.\".II showfont
.\".B fsinfo
.\"gives information about the font server to which your server is connected.
.\".B fslsfonts
.\"displays the fonts available to the font sever.
.\".B showfont
.\"displays a font via the font server.
.\"Normally, these utilities do
.\"nothing because you normally will not be running a font server.
.\".PP
.II Xconfig
.II FontPath
X reads fonts from the directories named in its
.BR FontPath ,
which is set in the file
.BR /usr/X11/lib/Xconfig .
.II fonts.dir
Each directory in the
.B FontPath
contains a file named
.BR fonts.dir ,
which gives the full, 14-part name of each font in the directory
and the file that holds it.
This is done because font files normally are compressed, and uncompressing
and searching all of the files in a directory to see if a given font was
available would be unacceptably time-consuming.
Thus, when you copy a new font into a font directory, you must modify
.BR fonts.dir ,
or X will not be able to find the font.
.II mkfontdir
The utility
.B mkfontdir
reads the fonts in a given font directory and rebuilds
.BR fonts.dir
automatically.
.PP
.II xlsfonts
The utility
.B xlsfonts
displays the full, 14-part of each font that is currently available to the
X server.
.PP
.II xfontsel
The utility
.B xfontsel
lets you select a font interactively.
It uses a series of 14 drop-down menus to help you build a font name, based
on the fonts that are available to your system.
The Lexicon entry for this utility also explains just what the elements of
a font name mean.
.PP
.II bdftopcf
.II "font^bitmap distribution format"
.II "font^portable compiled format"
.II "bitmap distribution format"
.II "portable compiled format"
.II BDF
.II PCF
Fonts can be encoded in a number of different ways.
X Windows for \*(CO uses fonts that are in the portable compiled format
(PCF).
Fonts, however, often are shipped in the bitmap distribution format (BDF).
The utility
.B bdftopcf
converts a BDF font into PCF so you can use it on your system.
.PP
.II xfd
Finally, the utility
.B xfd
displays a font.
For example, the command
.DM
	xfd -fd 6x10 -center
.DE
displays the font kept in file
.BR /usr/X11/lib/fonts/misc/6x10.pcf.Z .
When you click on a cell of the display,
.B xfd
displays detailed information about the character in that cell.
For an example of a displayed font (albeit a special font), see the entry for
.B xfd
in this manual's Lexicon.
.Sh "Manipulating the Console"
.PP
The following utilities let you modify the console's appearance:
.DS
.ta 0.5i 1.5i
	\fBxrefresh\fR	Refresh all or part of an X screen
	\fBxset\fR	Set preferences for the display
	\fBxsetroot\fR	Set preferences for the root window
.DE
.II xrefresh
.B xrefresh
redraws a given window or the entire screen, whichever you prefer.
You can use this to redraw a window or the screen, should it become
cluttered with stuff from other, non-X processes, or should it somehow
become confused.
.PP
.II xsetroot
.II "root window"
.II "screen^background"
.B xsetroot
lets you modify the appearance of the root window \(em that is, the window
that forms the background of the screen.
You can change the window to a solid color, a pair of stippled colors, a gray
scale, or tile it with a bit-mapped image.
It also lets you change the mouse cursor that is displayed against the
root window.
.PP
.II xset
Finally, the utility
.B xset
lets you set parameters for the display, and for other input devices.
For example,
.B xset
lets you set the acceleration rate for the mouse, and the loudness of both
the key click and the bell.
To set the key click to 50% of its maximum volume, type:
.DM
	xset c 50
.DE
Note that not every computer lets you reset the volume of the keyclick or bell.
For details, see the Lexicon entry for
.BR xset .
.Sh "Programming Tools"
.PP
X Windows for \*(CO includes the following tools for remaking X utilities:
.DS
.ta 0.5i 1.5i
	\fBimake\fR	C preprocessor interface to the \fBmake\fR utility
	\fBmakedepend\fR	Create dependencies in \fBmakefile\fRs
	\fBmkdirhier\fR	Make a directory hierarchy
	\fBxmkmf\fR	Create a \fBMakefile\fR from an \fBImakefile\fR
.DE
None of these tools interact with the X server; if you wish,
you can use them with your ordinary, character-based applications as well
as on X applications.
.PP
.II make
.II imake
.B imake
is a superset of the \*(CO utility
.BR make .
It understands a more complex set of dependencies than those encompassed by
.BR make 's
grammar.
These dependencies include widgets, operating system, and microprocessor.
.B imake
reads an
.BR Imakefile ,
which contains dependencies plus C-preprocessor directives.
You can define constants on the
.B imake
command line to determine what the resulting program will look like.
Note that you will seldom, if ever, need to invoke
.B imake
directly.
Usually, you will invoke it via the script
.BR xmkmf ,
which is described below.
.PP
.II makedepend
.B makedepend
reads a set of C source files and header files, and builds a table of
dependencies from them.
From this table, you can construct a
.B makefile
or an
.BR Imakefile .
.PP
.II mkdirhier
.B mkdirhier
creates a directory hierarchy.
That is, if the parent directories of a target directory do not exist,
.B mkdirhier
creates them first, then creates the directory you requested.
.PP
Finally,
.II xmkmf
.B xmkmf
is a script that invokes
.B imake
to build
.B Makefile
from an
.BR Imakefile .
It passes appropriate arguments to
.B imake
to ensure that it builds a
.B Makefile
that runs correctly on your system.
.PP
These utilities are discussed at greater length in the next chapter.
.Sh "Resources and Properties"
.PP
The following utilities help you examine and manage resources and properties:
.DS
.ta 0.5i 1.5i
	\fBappres\fR	List an application's resource data base
	\fBeditres\fR	Resource editor for X Toolkit applications
	\fBlistres\fR	List resources in widgets
	\fBviewres\fR	Graphical class browser for \fBXt\fR
	\fBxprop\fR	Display the X server's properties
	\fBxrdb\fR	Read/set the X server's resource data base
.DE
.II resource
.II appres
.B appres
prints on the standard output the resources that an application uses.
The following gives a portion of the output of the command
.BR "appres XTerm" :
.DM
	*VT100*color2:	green
	*VT100*font5:	9x15
	*VT100*color6:	cyan
		...
	*VT100*font1:	nil2
	*VT100*font4:	7x13
	*VT100*color5:	magenta
	*tekMenu*vtshow*Label:	Show VT Window
		...
	*tekMenu*tektext3*Label:	#3 Size Characters
	*tekMenu.Label:	Tek Options
	*fontMenu*font5*Label:	Large
	*fontMenu*font6*Label:	Huge
	*fontMenu*font2*Label:	Tiny
		...
	*mainMenu.Label:	Main Options
	*vtMenu*hardreset*Label:	Do Full Reset
	*vtMenu*scrollbar*Label:	Enable Scrollbar
	*vtMenu*scrollkey*Label:	Scroll to Bottom on Key Press
	*vtMenu*scrollttyoutput*Label:	Scroll to Bottom on Tty Output
		...
	*vtMenu*autolinefeed*Label:	Enable Auto Linefeed
	*vtMenu*altscreen*Label:	Show Alternate Screen
	*vtMenu*appcursor*Label:	Enable Application Cursor Keys
	*vtMenu*softreset*Label:	Do Soft Reset
	*vtMenu*appkeypad*Label:	Enable Application Keypad
		...
	*tek4014*fontSmall:	6x10
.DE
Resources are discussed in more detail below.
.PP
.B editres
is an interactive program that lets you edit an application's resources
on the fly.
By selecting options from buttons and menus, you can add or delete resources
from an application, or change a resource's value, then view the result and
dump the altered resources into a file.
In effect,
.B editres
gives you a way to edit an application's resource file interactively.
Playing with
.B editres
is a good way to learn about resources.
.PP
.II listres
.B listres
lists resources used in a widget.
For example
.DM
	listres -all
.DE
prints information about all known widgets.
.PP
.II property^definition
.II xprop
In the context of X, the term
.I property
means a string that holds information about an application,
such as its color or the size of its window.
Properties are stored within the server,
so they can be read by all other clients, including the window manager.
.B xprop
displays the properties associated with a given client.
The following gives the output of
.B xprop
when invoked for the X client
.BR xclock :
.DM
	WM_STATE(WM_STATE):
			window state: Normal
			icon window: 0x0
	WM_PROTOCOLS(ATOM): protocols  WM_DELETE_WINDOW
	WM_CLASS(STRING) = "xclock", "XClock"
	WM_HINTS(WM_HINTS):
			Client accepts input or input focus: False
			Initial state is Normal State.
			bitmap id # to use for icon: 0x1000001
			bitmap id # of mask for icon: 0x1000003
	WM_NORMAL_HINTS(WM_SIZE_HINTS):
			user specified location: 15, 26
			user specified size: 135 by 141
			window gravity: NorthWest
	WM_CLIENT_MACHINE(STRING) = "chelm"
	WM_COMMAND(STRING) = { "xclock", "-geometry", "135x141+15+26", \e
			"-fg", "blue", "-chime", "-update", "1" }
	WM_ICON_NAME(STRING) = "xclock"
	WM_NAME(STRING) = "xclock"
.DE
.II xrdb
.II RESOURCE_MANAGER
.II SCREEN_RESOURCES
Finally, the utility
.B xrdb
reads and sets the X server's resource data base.
It manipulates the contents of the properties
.B RESOURCE_MANAGER
and
.BR SCREEN_RESOURCES .
Applications read these properties to obtain resources that
are common to all resources under a given server.
Note that the contents of these properties usually override what an application
may read from its defaults file.
These properties are also read by applications that do not normally read
a defaults file (e.g.,
.BR xbiff ),
and so can be used to modify them.
.PP
.B xrdb
is of particular use in a networked environment.
It lets you embed resources within your machine's server, so that every
client that appears on your machine, regardless of the machine it originates
from, conforms to the way you want it to appear.
This spares you from having to store a defaults file on every
machine from which you might invoke a client.
.PP
.B xrdb
is invoked by default by the X display manager
.BR xdm ,
which is not included with X Windows for \*(CO.
If you wish to set defaults with
.BR xrdb ,
you should call it from within the file
.BR $HOME/.xinitrc .
The next sections gives some examples of how to use
.B xrdb
to set resources.
.Sh "System Monitoring"
.PP
The following utilities help you keep an eye on your system:
.DS
.ta 0.5i 1.5i
	\fBxauth\fR	Display/edit authorization information
	\fBxdpyinfo\fR	Display information about an X server
	\fBxev\fR	Print contents of X events
	\fBxlsatoms\fR	List atoms defined on server
	\fBxlsclients\fR	List client applications running on a display
	\fBxwininfo\fR	Display information about a window
.DE
.II xauth
.B xauth
lets you create or edit an authorization file.
This file determines who from what system can execute what clients on your
system.
This utility is used mainly in networked environments, where the
question of system security becomes very important.
.PP
.II xdpyinfo
.B xdpyinfo
displays information about the X server running on your system.
The following gives a portion of its output:
.DM
	name of display:    :0.0
	version number:    11.0
	vendor string:    Ready-to-Run Software, Inc.
	vendor release number:    5000
	maximum request size:  262140 bytes
	motion buffer size:  0
	bitmap unit, bit order, padding:    8, MSBFirst, 32
.DE
If your server were handling more than one display, information would be
shown for each.
.PP
.II event
An
.I event
is something that occurs on your system that sends a signal to the X server.
For example, the mouse sliding on your desk is an event, because the server
must reposition the mouse cursor.
Events are generated every time you press a mouse button,
press a key on the keyboard, or in any other way interact with your system.
.II xev
The X utility
.B xev
displays a small window on the screen, and then displays information about
every events received by the server.
.PP
.II atom
In the context of X, an
.I atom
is an elemental portion of the server that is available to clients.
For example, properties are atoms, as are the names of fonts, some static
strings, and other information.
.II xlsatoms
The X utility
.B xlsatoms
lists your server's atoms.
The following gives a portion of its output:
.DM
	1	PRIMARY
	2	SECONDARY
	3	ARC
	4	ATOM
		...
	9	CUT_BUFFER0
		...
	126	-Misc-Fixed-Medium-R-Normal--10-100-75-75-C-60-ISO8859-1
	127	EditresComm
		...
	134	-Misc-Fixed-Bold-R-Normal--13-120-75-75-C-80-ISO8859-1
.DE
.II xlsclients
The utility
.B xlsclients
displays information about all of the clients currently running under your
server.
.PP
.II xwininfo
Finally,
.B xwininfo
displays information about a window.
The following gives a sample of its output:
.DM
	xwininfo: Window id: 0x1000009 "xclock"
.sp \n(pDu
	  Absolute upper-left X:  18
	  Absolute upper-left Y:  29
	  Relative upper-left X:  0
	  Relative upper-left Y:  0
	  Width: 135
	  Height: 141
	  Depth: 1
	  Visual Class: StaticGray
	  Border width: 0
	  Class: InputOutput
		...
	  Corners:  +18+29  -647+29  -647-430  +18-430
	  -geometry 135x141+15+26
.DE
.Sh "Miscellaneous Utilities"
.PP
The following utilities do not fit neatly into any of the above categories.
These miscellaneous utilities, however, include some of the most useful and
interesting programs shipped with X Windows for \*(CO:
.DS
.ta 0.5i 1.5i
	\fBresize\fR	Set environmental variables to show window size
	\fBsessreg\fR	Manage utmp/wtmp entries for non-init clients
	\fBstartx\fR	Initiate an X session
	\fBtwm\fR	Tab Window Manager for the X Window System
	\fBxclipboard\fR	Hold multiple selections for later retrieval
	\fBxcmstest\fR	XCMS test program
	\fBxcutsel\fR	Copy text between the cut buffer and the primary selection
	\fBxinit\fR	Initiate the X Window System
	\fBxkill\fR	Kill an X client
	\fBxmodmap\fR	Modify X keymaps
.DE
.II startx
.II twm
.II xinit
.BR startx ,
.BR twm ,
and
.B xinit
were introduced in the previous chapter.
.PP
.II resize
The utility
.B resize
reads the size of the current
.B xvt
window, then prints onto the standard output
a shell script that, when run, sets the environmental variables
.B ROWS
and
.B COLUMNS
to reflect the size of the window.
These variables can be read by programs that run within that window,
such as screen editors, so they can size themselves properly.
.II MicroEMACS
.II vi
Note that most \*(CO programs, such as MicroEMACS and
.BR vi ,
cannot yet resize themselves.
.PP
.II sessreg
.II utmp
.B sessreg
assists with logging within the system file
.B /etc/utmp
all X clients that run under the X server.
It does nothing unless you have enabled process logging.
.PP
.II xclipboard
.II cut
.II paste
X includes a system-wide facility for cutting and pasting text.
With this, you can cut text from one window and paste it into another.
Normally, X has only one buffer into which you can store cut text.
The utility
.B xclipboard
stores an indefinite number of text ``cuttings'', and retrieve them for
repasting an indefinite number of times.
For more information on cutting and pasting, see the entry for
.B xclipboard
in this manual's Lexicon.
.PP
.II property^PRIMARY
.II PRIMARY
Earlier releases of X did not use the property
.B PRIMARY
to store cut text; rather, they stored cuttings only in a cut buffer.
If you cut and paste text between an up-to-date X client and an older one,
you may find that the older one does not reset the property
.B PRIMARY
correctly, and thus does not produce what you think it will when you cut
text under it.
.II xcutsel
.B xcutsel
copies text between a cut buffer and the property
.BR PRIMARY ,
to help keep different generations of applications synchronized.
All of the utilities and clients included with X Windows for \*(CO support
the latest implementation of X; therefore, you should not need this
utility unless you import an obsolete application from elsewhere.
.PP
.II xkill
.B xkill
kills an X program.
Note that a killed program often leaves debris in memory and on the file
system, so you should use
.B xkill
only in the direst extremity.
.PP
.II xmodmap
.II "keyboard^mapping"
The X server has its own internal keyboard mapping.
For most users, this does not create a problem, because both they
and the X server use the default U.S. keyboard mapping; however, if
you have used the \*(CO driver
.B nkb
to load a foreign keyboard or to customize a keyboard to your preferences,
this behavior of the server's can create serious difficulty.
The utility
.B xmodmap
lets you modify the mappings that the X server recognizes for the keyboard
and the mouse.
With this program, you can (for example) exchange the left mouse button with
the right mouse button, switch the
.B <ctrl>
key with the
.B <CapsLock>
key, and perform other tasks to help your system work as you prefer.
The file
.B /usr/X11/lib/.Xmodmap.ger
gives an example script that remaps the keyboard for X; in this case,
it remaps the keyboard to the German standard.
For details, see the entry for
.B xmodmap
in this manual's Lexicon.
.PP
This concludes our introduction of the utilities included with
X Windows for \*(CO.
The next section introduces clients.
.SH Clients
.PP
.II client
X Windows for \*(CO includes a selection of
\fIclients\fR \(em that is, programs that run under the X server and let
you do something that is not necessarily related to the running of X itself.
It is in the wealth of clients available for it that the true power, and
usefulness, of X becomes apparent.
.Sh "Games"
.PP
.II games
The following are just for fun:
.DS
.ta 0.5i 1.5i
	\fBico\fR	Animate an icosahedron or other polyhedron
	\fBmaze\fR	Create and solve a random maze
	\fBpuzzle\fR	The X scrambled-number game
	\fBxeyes\fR	Display two roving eyes
	\fBxgas\fR	Animated simulation of an ideal gas
	\fBxtetris\fR	Wildly amusing implementation of Tetris
.DE
.II ico
.B ico
draws a polyhedron, and bounces it around the screen.
The object can be either a wire-frame outline, or solid.
Note that unless you have a very robust system, the animation will
be rather jerky, and
.B ico
will ``suck up'' practically all of your system's computation cycles.
.PP
.II maze
.B maze
draws, and then solves, a random maze.
You cannot play this game interactively,
but it does appear exciting on the screen.
.PP
.II puzzle
.B puzzle
implements a scrambled-tile game.
It displays a window divided into 16 cells.
Fifteen of the cells contain numbered tiles, the 16th is empty.
Clicking one button scrambles the tiles.
When you click a tile, it (or its row or column) slides into the empty cell,
if possible; by maneuvering the tiles, you can un-scramble them.
When you give up, you can click another button and have
.B puzzle
un-scramble itself.
.PP
.II xeyes
.B xeyes
displays a pair of ``eyes'' on the screen.
The pupils of the ``eyes'' move to follow the mouse cursor around the screen.
.PP
.II xgas
.B xgas
models the random motion of gas molecules in a heated, divided chamber.
By setting command-line options, you can set parameters of the molecules'
movement, such as the degree of randomness with which they bounce off the
chamber's walls.
By dragging sliders, you can change the temperature of either of the
two sides of the chamber.
.PP
.II xtetris
Finally,
.B xtetris
is a implements the popular game Tetris.
.Sh "Observing the System"
.PP
In addition to the utilities that help you monitor the operation of X itself,
X Windows for \*(CO also includes two clients to help you observe your
\*(CO system:
.DS
.ta 0.5i 1.5i
	\fBxbiff\fR	Notify the user that mail has arrived
	\fBxload\fR	Display your system's load average
.DE
.II xbiff
.B xbiff
displays a bit map of an old-fashioned mailbox.
When you receive mail, the flag on the mailbox pops up.
.PP
.II xload
.B xload
displays a histogram \(em that is, a bar graph \(em
that shows the load on your system.
Every few seconds,
it measures activity on your system and adds a new bar to the graph.
You can use client to measure roughly how much in the way of system
resources a given program consumes.
.Sh "Pretty Pictures"
.PP
The following clients show some of the graphics capabilities of X:
.DS
.ta 0.5i 1.5i
	\fBxlogo\fR	Display the X Window System logo
	\fBxmag\fR	Magnify a part of the screen
	\fBxgc\fR	X graphics demonstration
.DE
.II xlogo
.B xlogo
simply displays the X logo in a window.
This is not a bit-mapped image, because when you resize the window, the
X logo changes size to match it.
.PP
.II xmag
.B xmag
magnifies part of the screen.
It translates each pixel of the magnified portion of the screen into a cell
in a grid.
With
.BR xmag ,
you can see exactly how an image is built of a pixel map.
.PP
.II xgc
Finally,
.B xgc
demonstrates X graphics.
It displays a screen with a great number of buttons and sliders on it.
By pressing buttons, you can construct images and play with X's graphics
capabilities.
Playing with
.B xgc
is a good way to learn about X graphics.
.Sh "Timepieces"
.PP
X helps you keep track of the time:
.DS
.ta 0.5i 1.5i
	\fBoclock\fR	Display an analogue clock
	\fBxclock\fR	Display a clock
.DE
.II xclock
.II oclock
Both of these clients display a clock on the screen, which
displays the time as your system understands it.
These clients differ mainly in the shape of their windows, and in the fact that
.B xclock
offers some extra features \(em it can display a digital clock,
and ``chime'' on the hour and half-hour, if you wish.
Most users permanently display either
.B oclock
or
.B xclock
on their X screen.
.Sh "Tools"
.PP
Finally, the following clients do not fall into any of the above categories.
These include some of the most useful and interesting of the X programs
included with X Windows for \*(CO:
.DS
.ta 0.5i 1.5i
	\fBxcalc\fR	Scientific calculator for X
	\fBxedit\fR	Simple text editor for X
	\fBxpr\fR	Print a dump of an X window
	\fBxterm\fR	Terminal emulator for X
	\fBxvt\fR	VT100 emulator
	\fBxwd\fR	Dump an image of an X window
	\fBxwud\fR	Un-dump a window image
.DE
.II xcalc
.II "Texas Instruments"
.II "Hewlett-Packard"
.II calculator
.B xcalc
displays a picture of a scientific calculator, either a
Texas Instruments 30 or a Hewlett-Packard 10C, whichever you prefer.
You can use the mouse to press the buttons on the calculator and so perform
computations, just as with a real calculator.
The virtual calculator implements most of the features of a real
scientific calculator \(em although clicking virtual buttons with a mouse
is more difficult than pressing real buttons with your fingers.
.PP
.II xedit
.B xedit
is a simple text editor for X.
Its default keystrokes closely resemble those used by \*(ME,
with the exception that
.B xedit
supports only one window and buffer at a time.
(Of course, under X this is not much of a restriction, because you can
invoke multiple
.B xedit
sessions and cut-and-paste among the windows.)
.PP
.II xvt
.II VT-100
.B xvt
emulated a DEC VT-100 terminal.
It opens a window, logs into your system from it via a pseudo-tty,
while emluating a VT-100 terminal.
Normally, you will run a shell in this window, although you can invoke
.B xvt
to run a \*(CO program (such as an editor or a data-entry program)
instead of shell \(em just as if you were logging in from another terminal.
On a networked X system, you can have, on one screen, multiple
.B xvt
windows, each logged into a different system.
You can also use X's cut-and-paste facility to cut text from one terminal
window and paste it into another.
.PP
.II xterm
.B xterm
is an expanded \(em and more robust \(em version of
.BR xvt .
It emulates a Tektronix terminal as well as a VT-100.
It also includes a number of features that let you set colors and features
more easily.
Note that unlike
.BR xvt ,
.B xterm
emulates the VT-100's graphics characters; thus, you can display such
\*(CO programs as
.B vsh
and have them appear the same (or almost the same) as they do when shown
through the ordinary, non-X console interface.
.PP
.II xwd
.II xwud
.B xwd
dumps an image of a window into a file.
You can select a window by name, or dump the root window \(em which, in effect,
saves an image of the entire screen (including menus).
The program
.B xwud
un-dumps a dumped image, by displaying it in a window.
.PP
.II xpr
.B xpr
prints an image dumped by
.BR xwd .
By default, it generates PostScript, although you can instruct it to generate
code for a variety of other printers as well.
.PP
For what it's worth, the images in this manual were captured with
.BR xwd ,
then post-processed with
.BR xpr .
The PostScript output of
.B xpr
was edited slightly by hand, then patched into the manual's
.B troff
sources by using a set of specially written
.B troff
macros.
.SH "Customizing X Programs"
.PP
As noted in the previous chapter, you can customize an X application through
any of three ways:
(1) by setting command-line options, (2) by modifying its defaults file, or
(3) by modifying the X server's resource data base.
.PP
.II resource
The Lexicon entry for an application describes the command-line options that
are available with that application.
These work in exactly the same way as with any other \*(CO application,
and are largely self-explanatory.
Methods 2 and 3, however, depend upon setting
.IR resources ,
which can be rather tricky.
.Sh "Resources"
.PP
.II widget
As explained in the previous chapter, most X applications are constructed
in whole or in part from
.IR widgets .
A widget bundles a a graphical image with a routine that
invokes an action when a selected event occur.
For example, a widget may dictate that when a button (the graphical
image) is clicked (the event), a menu appears (the invoked action).
.PP
.II "widget class"
Widgets often are built out of other widgets.
A widget that comprises part of one or more other widgets is called a
.IR "widget class" .
.PP
.II resource^definition
A
.I resource 
is an aspect of a widget, such as its color, size, or shape.
The syntax of a resource string mirrors the structure of a widget, as follows:
.DS
	\fB[\fIapp\^\fB]*|.[\fIclass\fB*|.[...*|. ...]]*|.[\fIresource\^\fB]:\fIvalue\fR
.DE
.I app
names the application in question.
If no application is named and the resource is in the X server's resource
data base, then it applies to all applications.
If, however, no application is named and the resource is in an application's
defaults file, the resource applies only to the application in question.
.PP
.I class
names a widget class.
A widget class can itself be built out of other widget classes, so a
resource string can be an indefinite number of classes.
.PP
.I resource
names the particular resource being set.
.PP
Finally,
.I value
gives the value to which you are setting
.IR resource .
This can be a Boolean setting (\fBTrue\fR or \fBFalse\fR), a number, or a
string, depending on the aspect being modified.
.PP
The elements of a resource are linked by either a period `.' or an asterisk `*'.
A period binds tightly:
that is, no widget classes can intervene between two classes named in the
resource.
An asterisk binds loosely:
that is, an indefinite number of widget classes can come between the two
widget classes so named.
.PP
.II XCalc
For example, the following gives two lines from the file
.BR /usr/X11/lib/app-defaults/XCalc :
.DM
	*Font:                  -*-helvetica-medium-r-normal--*-100-*-*-*-*-*-*
	*bevel.screen.LCD.Font: -*-helvetica-bold-r-normal--*-120-*-*-*-*-*-*
.DE
The first line sets the
.B Font
for every widget (as indicated by the single preceding asterisk)
to ten-point Helvetica medium.
The second line overrides this default to set the
.B Font
within the widget
.B bevel.screen.LCD
(which is the liquid-crystal display within calculator's ``screen'')
to 12-point Helvetica bold.
A
.B Font
widget naturally must be set to a string.
.PP
The following gives two more resources from
.BR XCalc :
.DM
	*ti.bevel.screen.LCD.width:	108
	*hp.bevel.screen.LCD.width:	180
.DE
The first line sets the width of the virtual liquid-crystal display for the
Texas Instruments calculator; the second gives the same for the
Hewlett-Packard calculator.
Here, the use of the period to bind tightly the classes of widget
ensures that the dimensions are exactly on the correct virtual calculator.
As you can see, a
.B width
resource requires a dimension, usually pixels.
.Sh "Modifying Applications"
.PP
Before we begin, the following examples involve editing files that define
how X functions.
Before you edit any file, \fImake a backup copy!\fR
.II cul-de-sac
This will let you back out of any \fIcul-de-sac\fR you may get yourself into
through error or mishap.
.PP
.II xbiff
To begin, you will recall that the client
.B xbiff
displays on the screen a small window that contains
a bit map of an old-fashioned mailbox.
When new mail arrives, the bit map changes to one with the flag popped up
that is displayed in reverse video.
.PP
X Windows for \*(CO comes with many bit-mapped images that you can use
with existing applications.
.II mailfull
.II mailempty
Two, named
.B mailfull
and
.BR mailempty ,
respectively show a full and empty mail in-tray, much like you may have
on your desk.
Suppose, for the sake of argument, that you wanted to use these bit-mapped
images in place of the default mailboxes.
You can do this by resetting the appropriate resources, and commanding
.B xbiff
to use them instead of its built-in defaults.
.PP
The first step is to check the Lexicon entry for
.BR xbiff .
Among other things, this names the resources that
.BR xbiff
uses.
This entry shows, among many others, the following resources:
.IP "\fBfullPixmap(\fRclass \fBPixmap)\fR"
Name the bit map to display when mail arrives.
.IP "\fBfullPixmapMask(\fRclass \fBPixmapMask)\fR"
Name the mask for the bit map to display when mail arrives.
.IP "\fBemptyPixmap(\fRclass \fBPixmap)\fR"
Name the bit map to display when no new mail is present.
.IP "\fBemptyPixmapMask(\fRclass \fBPixmapMask)\fR"
Name the mask for the bit map to display when no new mail is present.
.PP
.II PixMap
These look like the ones we need to modify.
The first part of each entry names the widget; its class is given in
parentheses.
.PP
The next step is to write the resources that we want to use.
These are as follows:
.DM
	xbiff*fullPixmap:mailfull
	xbiff*fullPixmapMask:mailfullmsk
	xbiff*emptyPixmap:mailempty
	xbiff*emptyPixmapMask:mailemptymsk
.DE
The prefix
.B xbiff
indicates that these settings are to apply only to this application.
The asterisk `*' means that an indefinite number of widget classes can
occur between the name of the application and the widget in which we are
interested; this spares us the trouble of having to build the entire
widget tree \(em and having to rebuild the tree should the designers of
.B xbiff
decide in the future to insert another layer or two into the widget hierarchy.
Finally, value names the file in directory
.B /usr/X11/include/X11/bitmaps
that holds the bit map we want.
.PP
.B xbiff
does not read a defaults file out of
.BR /usr/X11/lib/app-defaults ;
but we can still make
.B xbiff
use our new resources by using the X utility
.B xrdb
to load them into the X server's resources data base.
We save these resources into a file \(em we will use the conventional file
\fB$HOME/.Xdefaults\fR,
although the name of this file doesn't really matter \(em then type the
following command:
.DM
	xrdb -merge < $HOME/.Xdefaults
.DE
This command merges the contents of
.B $HOME/.Xdefaults
into the X server's resource data base.
So, the next time you invoke
.BR xbiff ,
you see:
.PH 1 1 \*(XD/xbiffnew.eps
instead of the old-fashioned mailbox.
.PP
To extend this example, the documentation for
.B xbiff
also mentions the following two resources:
.IP "\fBshapeWindow(\fRclass \fBShapeWindow)\fR"
Specify whether to shape the window to the
.B fullPixmapMask
and
.BR emptyPixmapMask .
The default is false.
.IP "\fBflip(\fRclass \fBFlip)\fR"
Invert the image when new mail arrives.
The default is true.
.PP
To change these defaults, insert the following lines into
.BR $HOME/.Xdefaults :
.DM
	xbiff*shapeWindow:True
	xbiff*flip:False
.DE
Then, type:
.DM
	xrdb -merge < $HOME/.Xdefaults
.DE
The next time you invoke
.BR xbiff ,
its window will be shaped that of the bit-mapped mask; and it will not
pop into reverse video when mail arrives.
.PP
If an application uses a defaults file, you can simply edit that file to
change a resource.
For example, the application
.B xclock
reads the defaults file
.BR /usr/X11/lib/app-defaults/XClock ,
which consists of exactly one line:
.DM
	XClock.input: false
.DE
Note that because this resource is in a defaults file, the resource
.DM
	*input: false
.DE
would behave exactly the same.
If you wanted, for whatever reason, to permit a user to type input into
.BR xclock ,
edit this line to read:
.DM
	XClock.input: true
.DE
As noted earlier, the resources in the X server's resource data base
take precedence over the contents of a defaults file.
For example, the X client
.B xgas
reads the default file
.BR /usr/X11/lib/app-defaults/XGas ,
which (among many others) contains the following resource:
.DM
	*quit.label: Quit
.DE
This resource defines the text that appears on the ``quit'' button.
If you decide that you want this button to be labelled
.BR FOO ,
you can insert the following resource into
.BR $HOME/.Xdefaults:
.DM
	xgas*quit.label:FOO
.DE
Then, type the command:
.DM
	xrdb -merge < $HOME/.Xdefaults
.DE
The next time you invoke
.BR xgas ,
the ``quit'' button will be labelled
.BR FOO ,
thus overriding the setting in
.BR XGas .
.Sh "Modifying a Font Resource"
.PP
.II resource^font
.II font^choose
Fonts are an important aspect of X.
A font incorporates textual information; thus, a well-selected font
can make your system much more useful.
.PP
For example, the defaults file
.B /usr/X11/lib/app-defaults/XTerm
sets a number of different fonts for using in different situations.
The default font is called
.BR fixed .
If you wish to change this to a larger font, try the following:
.IP \(bu 0.3i
.B cd
to directory
.BR /usr/X11/lib/fonts .
This directory holds the fonts available to the X system.
These are kept two sub-directories:
.B misc
and
.BR 75dpi .
The former holds ``miscellaneous'' fonts, such as the
.B cursor
font; the latter holds fancier fonts built in a 75 dots-per-inch format.
Most of the commonly used fonts are in
.BR misc .
.IP \(bu
.B cd
to
.BR misc .
Read file
.BR fonts.alias .
This gives the commonly used aliases for fonts used on the system.
As you can see, the font named
.B fixed
is actually the font:
.DM
	-misc-fixed-medium-r-semicondensed--13-120-75-75-c-60-iso8859-1
.DE
When you look further in
.BR fonts.alias ,
you will see that this is the same as the font named
.BR 6x13 .
The alias indicates that the font is 13 pixels high and 6 pixels wide.
(For information on how to interpret the full, 14-field font name,
see the Lexicon entry for
.BR xfontsel .)
To select a larger font, pick one whose height is greater than 13 pixels
or whose width is greater than six.
For example, the font whose alias is
.B 8x13
is the same height as the
.B fixed
font, but is two pixels wider.
.IP \(bu
Close
.BR fonts.alias .
Then edit your
.B .Xdefaults
file to insert the following entry:
.DM
	xvt*font:8x13
.DE
This sets the font resource for
.B xvt
to the font with the alias
.BR 8x13 .
.IP \(bu
Type:
.DM
	xrdb -merge < $HOME/.Xdefaults
.DE
This merges your new resource setting into the X server's
resource data base.
.PP
That's all there is to it.
The next time you invoke
.BR xvt ,
it will use font
.BR 8x13 ,
which is slightly larger and more legible.
Because the geometry of the
.B xvt
window is set to 80\(mu25 (that, 80 columns by 25 rows), the window will be
resized automatically to use the new font.
.PP
Note, by the way, that an
.B xvt
window using the
.B 8x13
font will not completely fit onto a 640\(mu480 screen \(em the last column
slips off the right edge of the screen.
If you find this to be a real problem, try using a narrower font.
.SH "Where To Go From Here"
.PP
This concludes our introduction to X applications and how to customize them.
We could only scratch the surface of resources, widgets, and the
internals of X; however, we hope that you now know enough to make minor
modifications to your system, and to begin to learn more about X.
.PP
For more information on a given application, see its entry in the Lexicon.
The books referenced in the introduction will also give you more information.
.PP
The next chapter discusses how to recompile X applications under
X Windows for \*(CO.

.ie t \{\
.\" ANSI names in pseudo-small capitals
.ds AN "\\f(SCANSI\\fP"
.ds AR "\\f(SCANSI\\fP Rationale"
.ds AS "\\f(SCANSI\\fP Standard"
.\" IBM PC, in pseudo-small capitals
.ds BM "\\f(SCIBM PC\\fP"
.ds CO \\f(SCCOHERENT\\fP
.\" down arrow, using keycaps font
.ds DA \\fK(\\XEB)\\fP
.\" ISO Standard in pseudo-small capitals
.ds IO "\\f(SCISO\\fP Standard"
.\" left arrow, using keycaps font
.ds LA \\fK(\\XF1)\\fP
.\" MS-DOS using pseudo-small capitals
.ds MD \\f(SCMS-DOS\\fP
.\" MicroEMACS, using pseudo-small capitals
.ds ME "\\f(SCM\\fPicro\\f(SCEMACS\\fP"
.\" OPEN LOOK, in pseudo-small capitals
.ds OL "\\f(SCOPEN LOOK\\fP"
.\" COHERENT, in pseudo-small capitals
.ds OS \\f(SCCOHERENT\\fP
.ds PN \\f(SCCOHERENT\\fP
.\" POSIX, in pseudo-small capitals
.ds PX "\\f(SCPOSIX\\fP"
.\" right arrow, in keycaps font
.ds RA \\fK(\\XE1)\\fP
.\" <return> key, using keycaps font
.ds RT \\fK(\\XA2)\\fP
.\" <space> bar, using keycaps font
.ds SP \\fK(space)\\fP
.\" STREAMS, in pseudo-small capitals
.ds ST \\f(SCSTREAMS\\fP
.\" up arrow, in keycaps font
.ds UA \\fK(\\XE3)\\fP
.\" UNIX, in pseudo-small capitals
.ds UN \\f(SCUNIX\\fP
.\" UUCP, in pseudo-small capitals
.ds UU \\f(SCUUCP\\fP\}
.el \{\
.\" remap keycaps and line-printer fonts to Roman
.\" .rf L  R
.\" .rf K  R
.\" .rf SC R
.ds AR "ANSI Rationale"
.ds AS "ANSI Standard"
.ds BM "IBM PC"
.ds CO COHERENT
.ds DA v
.ds IO "ISO Standard"
.ds LA \\(<-
.ds MD MS-DOS
.ds ME "MicroEMACS"
.ds OL "OPEN LOOK"
.ds OS COHERENT
.ds PN COHERENT
.ds PX "POSIX Standard"
.ds RA \\(->
.ds RT \\fB<return>\\fP
.ds SP \\fB<space>\\fP
.ds ST STREAMS
.ds UA ^
.ds UN UNIX
.ds UU "UUCP"\}
.ds CR 1993
.ds DI /v/fwb/coherent
.\" footer one inch from bottom of the page
.nr FT 10.0i
.ds KR "\\fIThe C Programming Language\\fR, second edition"
.ds MW "Mark Williams Company"
.\" page offset
.nr PO 0.75i
.\" line width 7.0 inches
.nr PW 7.0i
.ds Ql `
.ds Qr '
.ds QL ``
.ds QR ''
.\" directory where bitmapped images (as shot from X) are stashed
.ds XD /v/PostScript/manual
.\" .eps files of big initial letters is stashed
.ds XL /v/PostScript/bbl
.\" .eps clip art is stashed
.ds XA /v/PostScript/bbl

.ds TL "Writing a Device Driver"
.NH "Writing a Device Driver"
.PP
This section discusses how to go about writing a device driver.
.SH "Types of Device Driver"
.PP
Beginning with release 4.2,
\*(CO offers two methods for interfacing a driver with the kernel:
the
.I "internal-kernel (IK) interface"
and the
.IR "DDI/DKI interface" .
Each consists of functions that the driver can call, predefined constants,
types, etc.
Under \*(CO 4.2, the structures that support the calling functions
can be either from the IK interface or the DDI/DKI.
This represents a transition from the IK method toward the DDI/DKI and
\*(ST, which is the direction of future development.
.PP
The following describes the differences between these interfaces.
.IP "\fBInternal Kernel Interface\fR"
This type of driver uses the routines internal to the \*(CO kernel.
Practically all of the drivers included in the Driver Kit use this interface.
.IP "\fBDDI/DKI Interface\fR"
.II "DDI/DKI^definition"
The source code for drivers
.B loop
and
.B dump
use this interface.
All new \*(ST drivers must use this interface.
This is the preferred interface for new character drivers.
.PP
New block drivers must use the basic features of this interface; however,
the DDI/DKI interface is preferred for new character drivers.
.PP
When you begin to write a driver for \*(CO, you should pick carefully
between these strategies:
.IP \(bu 0.3i
The internal-kernel interface is proven and works; however, note that
this does not conform to published \*(UN definitions,
and a driver written in this interface
is less portable to another operating system.
.IP \(bu
The DDI/DKI interface attempts compatibility with \*(UN System V Release 4;
however, the \*(CO implementation lacks some features present in true \*(UN.
We expect that the degree of compatibility between \*(CO's DDI/DKi interface
and System V Release 4 will increase with ongoing development of \*(CO
internals, including the memory manager and the file system.
.PP
\*(ST is a flexible and powerful method of programming character drivers.
The \*(CO implementation of \*(ST was developed simultaneously with its
implementation of the DDI/DKI, and therefore the two methods of writing
drivers show a high degree of overlap.
As shipped with \*(CO 4.2, \*(ST does not yet have line discipline
or TLI modules available.
All \*(ST development should be done with the DDI/DKI interface.
.PP
Sets of routines from the DDI/DKI can be combined with those from the
internal-kernel interface.
In some cases, the DDI/DKI offers the better method of performing a given
task; in others, the internal-kernel interface offers the better (or, more
likely, the only) method to perform a task.
If you are importing a driver from \*(UN System V Release 4, then you should
use the DDI/DKI routines primarily.
Likewise, you should use them primarily if you are writing a driver that you
wish to export to \*(UN.
Note, too, that as \*(CO evolves toward the standard of System V Release 4,
the DDI/DKI interface will grow in importance.
.PP
The sources included with release 4.2.05 of the device-driver kit are in
the internal-kernel format rather than DDI/DKI.
It was simply not practical to recast these drivers in the DDI/DKI mold
at the present time;
however, we are supplying information regarding DDI/DKI interfaces
to inform developers of the future direction of \*(CO.
In the development of new drivers, DDI/DKI facilities should be used
wherever possible for greatest compatibility, e.g., with future releases
of \*(CO.
.PP
To summarize,
all else being equal, the DDI/DKI is preferred over the internal-kernel
interface.
The Lexicon entries themselves will alert you of the alternate ways of
performing a given task, to help you decide which to use.
.PP
The best way to judge which interface you should use is to read the sources
included with the \*(CO Device Driver Kit:
.IP "\fBasy\fR (\fB/etc/conf/asy/src\^\fR)"
This driver manipulates non-intelligent serial ports.
It is an example of a non-\*(ST character driver.
.IP "\fBat\fR (\fB/etc/conf/at/src\fR)"
This driver manipulates the AT hard disk.
It gives the best demonstration of writing a block driver, with
regard to compatibility with \*(UN System V Release 4.
.IP "\fBhai154x\fR (\fB/etc/conf/hai/src\fR)"
This driver manipulates SCSI devices.
It demonstrates how to use first-party DMA.
.IP "\fBss\fR (\fB/etc/conf/ss/src\fR)"
This driver manipulates the Seagate SCSI disk.
It demonstrates how to use memory-mapped I/O.
.IP "\fBfd\fR (\fB/etc/conf/fd/src\fR)"
This driver manipulates the floppy disks.
It demonstrates how to perform DMA via the Intel controllers.
.PP
Beyond this, you must use your best judgement as you gain experience in
working with \*(CO.
.SH "Planning the Device Driver"
.PP
This section discusses how to plan a device driver.
We strongly urge you to read this section carefully:
it will help you avoid many of the pitfalls that plague developers of
device drivers.
.Sh "Defensive Programming"
.II "defensive programming"
.PP
To begin, you must assume that you will damage your file systems
.I "at least once"
during development of your driver.
To avoid damaging irreplacable files, we suggest that you do the following.
.PP
First, perform a full backup of your system before you begin to test and
debug your driver.
See the Lexicon entry for
.B backups
describes how to back up to floppy disk; the entry for
.B tape
describes how to back up to tape.
.PP
Second, you should create a \*(CO system that can be run from a floppy disk.
One attractive feature of the \*(CO system is that a stripped down
version is small enough to be run from a high-density floppy disk drive.
You can then incorporate your device driver into the kernel that is
run from your floppy-disk version of \*(CO; if something goes wrong,
the files on your hard disk should be protected from damage.
See the Lexicon entry for
.B booting
for directions on how to build a bootable floppy disk.
Also, you can run the script
.B /etc/conf/bin/Floppy
(which is included with the Driver Kit) to build a bootable floppy disk.
.PP
Finally, as you plan your driver, you must bear in mind the fact
that the driver stands between the kernel and the device.
It receives input from and writes output to the kernel; it receives
input from and writes output to the device.
Because the driver
is linked into the kernel, it in effect is part of the kernel.
Therefore, when you write a driver you must think like a kernel programmer:
you must
.I always
bear in mind the context in which a driver operates.
Always ask yourself:
.I
Is this function or structure available to me in this context?
If it is not, how can I make it available?
.R
.Sh "Testing the Hardware"
.PP
Before you begin to write a driver, be sure to test the hardware.
This will involve writing a program at the user level that lets you
access the hardware via a device driver.
When this is done, you should take the user manual and, as thoroughly
as you have time and patience for, test
.I every
feature described in the manual and confirm that the hardware works as
documented.
Our experience in both writing and using technical documentation leads us
to conclude that, try as one might,
it is practically impossible to write an error-free manual.
.PP
You will save yourself much time and agony
in the debugging phase if you test the hardware ahead of time.
We also suggest that you alert the manufacturer to any errors you discover
in the manual:
this will earn you the gratitude of the manufacturer and of your fellow users.
.Sh "Major Device Number"
.PP
Once you have tested and confirmed that the hardware works as described
(or noted all the places where the hardware's behavior varies from the
documentation),
you can begin to write your driver.
.PP
The first step is to select a major device number for the device you will
be supporting.
The entry for
.I "device drivers"
in this manual's Lexicon lists the major device numbers that are currently
used under the \*(CO system.
In addition, header file
.B <sys/devices.h>
contains symbolic constants for all assigned major numbers.
Select one that is unused and assign it to your driver.
.Sh "Naming Conventions"
.II "naming conventions"
.PP
The next step is to devise some naming conventions for your driver.
The conventions will govern both how you structure your driver, and how
you name it to the \*(CO system.
It is common practice to use the first two letters of the name of the
configuration table to indicate the device.
You can, however, use a prefix of up to eight characters; it is best to be
brief but unambituous.
.PP
To create a device file for a file, append the minor device number to the
device name.
If a driver can support more than one device, they can be distinguished
by an alphabetic suffix.
For example, \*(CO's hard-disk driver is called
.BR at .
The \*(CO system supports two drives, so there are two minor numbers,
.B at0
and
.BR at1 .
Finally, each drive can have four partitions, each of which is accessed via
a different device file, plus one for the partition table.
Thus, each drive has five device files:
.BR at0a ,
.BR at0b ,
.BR at0c ,
.BR at0d ,
.BR at0x ,
.BR at1a ,
.BR at1b ,
.BR at1c ,
.BR at1d ,
and
.BR at1x .
.PP
To avoid inadvertent name-space collisions, prefix 
with the name of the device
the names of functions, variables, and arrays within your device driver,
and the constants, types, etc., defined within associated header files.
.Sh "Errors"
.PP
To report an error to the calling process, call function
.B set_user_error()
with the appropriate error code.
.II errno.h
For a list of legal error codes, see the entry for the header file
.B <errno.h>
in the \*(CO manual's Lexicon.
.SH "Coding Requirements"
The following summarizes the coding requirements for device drivers that
use the internal-kernel or DDI/DKI interfaces.
.PP
To begin, the coding requirements for the internal-kernel interface:
.IP \fB1.\fR 0.3i
Put `C' in the miscellaneous flags in the file
.BR /etc/conf/mdevice .
.IP \fB2.\fR
Do not define symbol
.B _DDI_DKI
in the driver's source file.
.IP \fB3.\fR
Place driver's entry points in a
.B CON
structure.
This structure is described below.
The functions themselves may be declared as
.BR static .
.IP \fB4.\fR
There is no distinction between internal and external major-
and minor-device numbers.
A device number (\fBdev_t\fR) is a 16-bit object.
Use internal-kernel routine
.BR minor() ,
\fIq.v.\^\fR, to obtain the minor-device number.
.IP \fB5.\fR
Either include
.BR <sys/coherent.h> ,
or explicitly define symbol
.B _KERNEL
to be one, before any other #include directives in the driver source.
.PP
The coding requirements for the DDI/DKI interface are as follows:
.IP \fB1.\fR 0.3i
Do not put a `C' into the miscellaneous-flags field in file
.BR /etc/conf/mdevice
(\fIq.v.\^\fR).
.IP \fB2.\fR
Insert the directive
.DM
	#define _DDI_DKI 1
.DE
.IP
in the driver's source file, before any
.B #include
directives.
.IP \fB3.\fR
Put an entry into the function-flags field in
.B /etc/conf/mdevice
for each of the driver's entry points;
do not put them into a
.B CON
structure.
.IP \fB4.\fR
A device number (\fBdev_t\fR) is a 32-bit object.
There is some
discussion in the literature of internal \fIvs.\fR external numbering for
device numbers and for the major and minor parts of the device number as well.
As of \*(CO 4.2.05, only external numbers are of interest
to the writer of device drivers.
Thus, when a
.B dev_t
is passed to a driver's entry point, it is an external device number.
When major numbers are entered into file
.BR /etc/conf/mdevice ,
they are external major numbers.
Unit numbers and device features are decoded from the
external minor number, which is obtained from the external device
number by calling the DDI/DKI routine
.BR geteminor() .
.IP \fB5.\fR
Define symbol
.B _KERNEL
to be one in the driver source, before any
.B #include
directives.
.PP
The rest of this section emphasizes the internal-kernel interface to
the \*(CO, as this interface is used by practically every driver that
is now shipped with \*(CO 4.2.
The bibliography given at the beginning of this manual lists several
excellent books that describe the DDI/DKI and \*(ST, and give extended
examples of how to code uses these interfaces.
Note that these interfaces will become increasingly important as \*(CO
evolves toward the standard set by \*(UN System V Release 4.
.SH "The Internal-Kernel Interface"
.PP
This section describes the internal-kernel interface between a device
driver and the \*(CO kernel.
.PP
.II kernel^functions
The \*(CO kernel contains numerous functions that perform the basic
work of driving a device.
Some are ordinary kernel system calls, which a driver can call just
like any user-level application.
Others are internal to the kernel and can be called only by drivers and
other internal kernel processes.
The following introduces some of the more frequently used calls and routines.
Each is described in more detail either in this manual's Lexicon, or
in the Lexicon that comes in the manual for the \*(CO system.
.Sh "Interface to System Calls"
.PP
.II open()
.II close()
.II read()
.II write()
.II ioctl()
.II poll()
.II CON
Each driver that uses the internal-kernel interface contains a
.B CON
structure.
This structure contains pointers to the functions that the kernel is to
execute when an application invokes the system calls
.BR open() ,
.BR close() ,
.BR read() ,
.BR write() ,
.BR ioctl() ,
or
.BR poll() .
.B CON
includes the following fields:
.IP \fBc_flag\fR
This field's bits give the ways
in which this device can be accessed, as follows:
.DS
.II poll()
.ta 0.5i 1.5i
	\fBDFBLK\fR	Block-special device
	\fBDFCHR\fR	Character-special device
	\fBDFTAP\fR	Tape device
	\fBDFPOL\fR	Accessible via \*(CO system call \fBpoll()\fR
.DE
.IP "\fBc_mind\fR"
.II devices.h
This field gives the device's major-device number.
This number is an index to the driver's place in the kernel's table of
drivers.
This number must be in the range of zero through 31,
and must be a symbolic constant found in file
.BR <sys/devices.h> .
.IP "\fBc_open\fR"
This field points to the routine within the device driver
that is executed whenever \*(CO opens the device.
This function is always called with two arguments:
the first is a
.B dev_t
that indicates the device being accessed, and the second is an integer
that indicates the mode in which it is being opened.
The mode can be
.B IPW
(write mode),
.B IPR
(read mode),
or
.BR "IRW | IRP" .
If an error occurs during execution of this function, it should set field
.B u_error
within the process's
.B UPROC
structure to an appropriate value.
.IP "\fBc_close\fR"
This field points to the routine that is executed whenever \*(CO closes
the device.
This function takes the same arguments as the
.B open
function.
.IP "\fBc_block\fR"
This field
points to the routine within the device driver that is executed
when the kernel reads a file in block mode.
.II BUF
This function is called with a pointer to the structure
.BR BUF ,
which contains the following fields:
.RS
.IP \fBb_dev\fR 1.0i
This field is of type
.BR dev_t ,
which is a structure that describes the device being buffered.
.II major()
.II minor()
The kernel macros
.B major()
and
.B minor()
translate this structure into the device's major and minor numbers.
.IS \fBb_req\fR
Type of I/O request, either
.B BREAD
or
.BR BWRITE .
.IS \fBb_bno\fR
This givesn number of the starting block.
.IS \fBb_paddr\fR
This field gives the system-global (DMA) address for the data.
.IS \fBb_count\fR
This field gives number of bytes to read or write.
.IS \fBb_resid\fR
This field gives the number of bytes that remain to be transferred.
A value of zero indicates that all data transferred correctly, i.e., that
an error did not occur.
.RE
.IP
.II bdone()
The driver function that performs block transfers of data should first
perform the I/O transfer, then set field
.B b_resid
to the appropriate number and call kernel function
.B bdone()
to clean up after itself.
.IP
Note that the function that performs block transfer must
.I never
sleep or access a process's
.B uproc
structure.
This is because this function is asynchronous and therefore not pegged to
a particular process.
.IP "\fBc_read\fR"
.II "read a device"
This field
points to the driver's routine that is called when the kernel wishes to
read data from that driver's device.
.II dev_t
.II IO
It takes two arguments:
the first argument is a
.B dev_t
that indicates the device to read;
the second points to the
.B IO
structure for that device.
This structure contains the following fields:
.RS
.IP \fBio_seek\fR 1.0i
This field gives
the number of bytes from the beginning of the file or device
whence reading should begin.
This is, of course, is meaningless for devices for devices like serial ports.
.II BSIZE
In the case of disk drives, this number must indicate the block to be read,
i.e., the number must be evenly divisible by constant
.BR BSIZE ,
which gives the size of a \*(CO block.
If this is not true, an error has occurred.
.IS \fBio_ioc\fR
The number of bytes to read or write.
When the read is completed, this should be set to the number of bytes
that remain to be read or written.
If it is not reset to zero, then an error has occurred.
.IS \fBio_base\fR
The offset of data to be transferred in the user memory space.
This is converted to a physical or virtual memory address before
performing the read.
.IS \fBio_flag\fR
Flags.
.II io.h
See header file
.B <sys/io.h>
for the flags that \*(CO recognizes.
.B IONDLY
indicates that the request is non-blocking.
.RE
.IP
Unlike a block transfer, the read function does not return until I/O is
complete.
.II x_sleep()
.II wakeup()
Your driver can use the kernel functions
.B x_sleep()
and
.B wakeup()
to surrender the processor to another process while the read is being performed.
.II ioputc()
It can also use the kernel function
.B ioputc()
to send characters to the user process and to update counter
.BR io_ioc .
.IP "\fBc_write\fR"
.II "write to a device"
This field points to the function that the kernel
invokes when it wishes to write to this device.
It behaves exactly the same as the function pointed to by field
.BR c_read ,
except that the direction of data transfer is reversed.
.II iogetc()
Your driver can use kernel function
.B iogetc()
is used to fetch characters from the user process and to update counter
.BR io_ioc .
.IP "\fBc_ioctl\fR"
.II ioctl
.II "I/O control"
This field
points to the function that the kernel executes when it wishes to exert
I/O control over a device.
This function is called to perform non-standard manipulations of a device,
e.g., format a disk, rewind a tape, or change the speed of a serial port.
.IP
The kernel always calls this function with three arguments:
the first argument is a
.B dev_t
that identifies the device to be manipulated;
the second is an integer that indicates the command to be executed;
the third points to a character array that can hold additional information,
if any, that the command may need.
.IP
This function, by its nature, uses a considerable amount of device-specific
information.
.II tty.h
.II mtioctl.h
.II lpioctl.h
The header files
.BR <sys/tty.h> ,
.BR <sys/mtioctl.h> ,
and
.B <sys/lpioctl.h>
define codes for, respectively, teletypewriter devices (i.e., terminals),
magnetic-tape devices, and line printers.
.IP "\fBc_power\fR"
.II "power-fail routine"
This field
points to the routine to be executed should power fail on the system.
This field is not yet used by \*(CO.
.II dpower()
.IP "\fBc_timer\fR"
This field
points to the routine that the kernel executes when a device driver
requests periodic scheduling.
To request that the timeout routine for device
.I dev
be called once per second, set
\fBdrvl[major(\fIdev\fB)\.d_time\fR to a nonzero value.
.II con.h
.II major()
.II stat.h
The external variable
.B drvl
is declared in header file
.BR con.h ;
macro
.B major()
is defined in header file
.BR stat.h .
.IP
The value in field
.B d_time
is not altered by the kernel's clock routines.
To stop invocations of the timeout routine, store zero in
\fBdrvl[major(\fIdev\fB)].d_time\fR.
.I dev
is a
.B dev_t
that indicates which device is being timed out.
.IP "\fBc_load\fR"
.II "loading a driver"
This field
points to the routine that is executed when this device driver is loaded.
This performs all tasks necessary to prepare the device and
the driver to exchange information.
If the driver is linked into the kernel, then this routine is executed
when \*(CO is booted.
.IP
Although \*(CO does not currently support loadable drivers, you
should still write a load routine for driver startup and driver detachment
from the kernel.
This will spare you the labor of modifying your driver once loadable
drivers are enabled.
.IP "\fBc_uload\fR"
.II "unloading a driver"
This field
points to the driver's function that the kernel invokes when the driver
is unloaded from memory.
Although \*(CO does not support loadable drivers, you
should still write an unload routine for driver startup and driver detachment
from the kernel.
This will spare you the labor of modifying your driver once loadable
drivers are enabled.
.IP "\fBc_poll\fR"
.II "polling the device"
This field
points to a function that can be accessed by commands or functions
that poll the device.
The driver's polling function is always called with three arguments.
The first argument is a
.B dev_t
that indicates the device to be polled.
The second is an integer whose bits flag which polling tasks are to be
performed, as follows:
.DS
.ta 0.5i 1.5i
	\fBPOLLIN\fR	Input data is available
	\fBPOLLPRI\fR	Priority message is available
	\fBPOLLOUT\fR	Output can be sent		
	\fBPOLLERR\fR	A fatal error has occurred
	\fBPOLLHUP\fR	A hangup condition exists
	\fBPOLLNVAL\fR	\fBfd\fR does not access an open stream
.DE
.II poll.h
These are defined in the header file
.BR <sys/poll.h> .
The third argument is an integer that gives the number of millseconds by
which the response should be delayed.
Note that the \*(CO clock timer runs at 100 Hz rather than the
approximately 18 Hz clock used by MS-DOS.
.IP
.II pollopen()
.II pollwake()
The kernel functions
.B pollopen()
and
.BR pollwake() ,
respectively, initiate and terminate a polling event.
For more information on these functions, see their entries in this
manual's Lexicon.
.Sh Timing
.PP
Sometimes a driver must delay for a period of time while doing
something in the kernel.
For example, you may want to wait within a device driver
for no more than given period of time; if that period of time elapses,
you assume that a timeout has occurred in the chain of desired events.
.II timeout()
If the delay is a given number of clock ticks, use kernel routine
.B timeout()
to call a given function after the specified number of ticks.
Interrupts must be enabled for this to work;
granularity is 0.01 sec (10 milliseconds) because
that is the current length of a clock tick.
.PP
.II read_t0()
Kernel function
.B read_t0()
helps you to compute intervals of less than one tick.
.II PIT
This function, which takes no arguments and returns an
.BR int ,
reads channel 0 (t0) of the programmable interval timer (\fBPIT\fR),
which drives the system clock.
A system clock tick is the time it takes timer t0 to decrease from 11,932
to zero.
You can read the timer any time, whether interrupts are masked or not,
and get a number between 11,932 and zero.
Each unit therefore represents a little less than a microsecond.
Overhead per call to
.B read_t0()
is about five to ten microseconds, depending on your CPU and clock.
.II busyWait()
.II busyWait2()
The kernel functions
.B busyWait()
and
.B busyWait2()
are useful for waiting briefly.
They can return early from a wait if an awaited condition has been specified
and is met.
Their timing is independent of CPU speed.
.PP
.II read_t0()
Because CPU speeds among supported equipment vary by at least an order of
magnitude, we
.I strongly
encourage all fine-timing loops to use
.B read_t0()
rather than simply counting down to zero using some empirically chosen
loop count.
.Sh "Sleeping and Waking"
.PP
.II x_sleep()
.II wakeup()
.II "sleep^caveats"
The driver will constantly call the kernel functions
.B x_sleep()
and
.B wakeup()
to synchronize your device driver with events in the operating system.
.B x_sleep()
moves the driver process to the suspended queue and sets a unique
condition under which the process will awaken;
.B wakeup()
wakes up the process associated with that event.
.PP
For example, when a driver attempts to read a floppy disk, it may take
several seconds for the floppy disk to begin to spin fast enough to be read.
This may be a relatively brief period in real time, but the machine may be
able to do much work during those few seconds.
Thus, the floppy disk driver's
.B read
routine will begin to spin up the disk, then sleep until the floppy-disk
drive signals that the disk is spinning fast enough to be read.
The process will then awaken and begin to read; in the meantime, the
\*(CO system will have been able to work productively.
When you write you driver, you should look out for such situations and use
.B x_sleep()
and
.B wakeup()
to exploit them.
.PP
.II "race condition"
Note, however, that calling
.B x_sleep()
at the wrong time will trigger a \*(QLrace condition\*(QR, which under the
wrong conditions could cause the device to hang.
The entries for
.B x_sleep()
and
.B "race condition"
in this manual's Lexicon discuss when you should use the sleep mechanism,
and when you should not.
In brief,
.B x_sleep()
is available only when the active process can be
associated with entry into the driver \(em that is, during
the functions that are invoked via system calls
.BR open() ,
.BR close() ,
.BR read() ,
.BR write() ,
.BR ioctl() ,
and
.BR poll() .
If a driver sleeps when it is not associated with a process, the kernel
will never be able to awaken it.
.II load()
.II unload()
.II block()
.II defer()
.II timeout()
Thus, a driver must not sleep 
sleep during the routines invoked by the kernel routines
.BR load() ,
.BR unload() ,
or
.BR block()
or during the functions invoked by kernel routines
.B defer()
or
.BR timeout() .
.Sh "Error Handling"
.PP
When the kernel needs to tell a process that an error condition
has occurred,
it calls function
.B set_user_error()
with the appropriate error code.
.PP
Please note that like sleeping and some other situation,
your driver can set the user error status only when
user control is valid.
A driver can sleep or call
.B set_user_error()
only from within driver functions invoked through the system calls
.BR open() ,
.BR close() ,	
.BR read() ,
.BR write() ,
.BR ioctl() ,
and
.BR poll() ,
as described above.
In particular, information specific to the calling process is
.I not
available to the
driver functions invoked via the kernel routines
.BR load() ,
.BR unload() ,
.BR block() ,
.BR defer() ,
or
.BR timeout() .
.Sh "Memory Management"
.PP
This subsection describes how the kernel manages memory, and
suggest how your driver should use memory-management to best advantage.
.PP
.II "memory^pools"
.II "kalloc() memory pool"
.II "sysmem memory pool"
\*(CO divides all of the memory that is available to the kernel
into several pools.
The two most commonly used of these are the
.B kalloc()
pool and the
.B sysmem
pool.
.PP
The
.B kalloc()
pool acts as the kernel's heap, from which the kernel allocates and
de-allocates memory for most small, temporary structures.
Use the functions
.B kalloc()
and
.B kfree()
to allocate and free memory from this pool.
These functions in the Lexicon to this manual.
.PP
The
.B sysmem
pool is a large collection of four-kilobyte ``clicks'' (memory pages).
When new processes are created, the memory they need comes from this pool.
Applications can use the functions
.B malloc()
and
.B free()
to obtain and free memory.
.PP
The kernel uses three modes of memory access:
.IR "physical memory" ,
.IR "virtual memory" ,
and
.IR "system-global memory" .
.PP
Physical-memory addresses are the addresses
set directly onto the address bus to access memory.
Some peripheral equipment, such as video boards,
communicate with the CPU through reads and writes within some specific
range of physical-memory addresses.
.II "I/O^memory mapped"
.II "memory-mapped I/O"
This arrangement is also called
.IR "memory-mapped I/O" .
.II DMA
.II "direct-memory access"
Devices that perform
.I "direct-memory access"
(DMA), including the usual AT-compatible floppy-disk controller,
also use physical-memory addresses to obtain information on the
source and destination of a DMA transfer.
.II paddr_t
A physical memory address occupies four bytes,
and is properly kept in an object of type
.BR paddr_t .
.PP
Virtual-memory addresses are those used by programs that run under \*(CO.
Paging hardware allows the operating system to remap each four-kilobyte page
of physical memory to any region of virtual memory
that is on a four-kilobyte boundary.
The kernel maintains tables that give the correspondences
between pages of physical and virtual memory.
When a context switch occurs (i.e., when one user process is shifted to the
ready queue and another is selected from the ready queue for execution),
the kernel updates these tables to unmap pages of memory for the old process,
and to map pages of memory into virtual addresses for the new process.
Virtual-memory addresses occupy four bytes, and are properly stored in type
.BR vaddr_t .
.PP
System global memory provides a third way of viewing memory resources.
.II "I/O^raw"
.II "raw I/O"
Consider a device driver that supports raw I/O to a block device.
The term
.I raw
implies that the user process supplies an I/O buffer of arbitrary length.
This introduces a problem:
when the device driver is ready to transfer data between the user buffer and
the I/O device, the user buffer may not be mapped into virtual memory.
A
.I "system global"
address is a 32-bit object that retains access to the buffer,
even when it is paged out of virtual memory.
.PP
Only a few operations are valid on system-global addresses:
.IP \(bu 0.3i
Add or subtract an offset.
.IP \(bu
.II P2P()
Apply macro
.B P2P()
to obtain the corresponding physical address.
.IP \(bu
.II dmain()
.II dmaout()
Appear as the second argument of kernel routine
.B dmain()
or
.BR dmaout() .
.IP \(bu
.II xcopy()
Appear as the second argument (destination) in a call to kernel routine
.BR xpcopy() 
.IP \(bu
.II pxcopy()
Appear as the first argument (source) in a call to kernel routine
.BR pxcopy() .
.PP
In the last two cases, the final argument in the
function call must be manifest constant
.BR "SEG_386_KD|SEG_VIRT" .
For example:
.DM
	char src[BSIZE];
	char dest[BSIZE];
.sp \n(pDu
	/* copy from kernel data to system global buffer */
	xpcopy(src, bp->b_paddr, BSIZE, SEG_386_KD|SEG_VIRT);
.sp \n(pDu
	/* copy from system global buffer to kernel data */
	pxcopy(bp->b_paddr, dest, BSIZE, SEG_386_KD|SEG_VIRT);
.DE
To get a system global address, use macro
.BR MAPIO() .
This function takes two arguments, the segment table address
(obtained from the segment-reference structure [SR]),
and the offset within the segment.
.PP
For objects in the kernel kalloc pool, use
.B allocp()
as the SR.
For objects in user space for the *current* process, the SR is
\fBu.u_segl[\fIxxx\^\fB]\fR, where
.I xxx
is the segment index, e.g.,
.B SIPDATA
or
.BR SISTACK .
The user stack segment grows down, so the lower limit of the
stack segment is computed differently than for the other user segments.
See the example, below.
.PP
If your buffer has virtual address
.IR v ,
do the following.
If
.I v
is in kalloc pool, use the following:
.DM
	sgAddr = MAPIO(allocp.sr_segp->s_vmem, v - allocp.sr_base)
.DE
If
.I v
is in user data, then:
.DM
	sgAddr = MAPIO(u.u_segl[SIPDATA].sr_segp->s_vmem,
		v - u.u_segl[SIPDATA].sr_base)
.DE
If
.I v
is in user stack:
.DM
	sgAddr = MAPIO(u.u_segl[SISTACK].sr_segp->s_vmem,
		v - u.u_segl[SISTACK].sr_base - u.u_segl[SISTACK].sr_size)
.DE
.PP
For devices that support block I/O,
a block routine takes a single argument, a pointer to a
.B BUF
structure.
.II b_paddr
The field
.B b_paddr
of this
.B BUF
structure is a system global address.
.PP
Finally, please note that drivers that use the
DDI/DDK interface will not use
.B kalloc()
or
.BR kfree() .
They will use statically allocated structures sized by tunable
parameters, or they will use the specialized resource-allocation routines
that the DDK provides.
.SH "Where To Go From Here"
.PP
The next two sections give, respectively, an example driver for a block
device and an example driver for a character device.
Each uses the internal-kernel interface.
We suggest that you study these examples carefully before you attempt to
write a driver on your own.
Finally, the Lexicon in this manual describes
the functions and macros introduced in this section.

.II "C language^tutorial"
.ds TL "The C Language"
.NH "The C Language" 1
.PP
.II "Ritchie, Dennis"
.II "Thompson, Ken"
C
is a computer language invented by Dennis Ritchie and Ken Thompson at
AT&T Bell Laboratories in the early 1970s.
In the approximately 25 years since its creation, C has become one of the
most popular computer languages in the world.
C is powerful and flexible, and it is highly portable.
It has been implemented
on practically every computer, and under practically every operating system,
in the world.
.PP
C is the ``native language'' of the \*(CO system.
\*(CO is written in C, and it includes a powerful C compiler among
its suite of language tools for your use.
You do not need to know C to use \*(CO to great advantage;
however, if you plan to program under \*(CO, you would be well
advised to become at least passably acquainted with it.
.PP
This tutorial is an introduction to the \*(CO C compiler and to the
C language itself.
The first part of this section describes how to compile programs under
\*(CO.
The second part is a brief tutorial in the C language.
.SH "Compiling C Programs under COHERENT"
.PP
.II "cc"
.II compiler
A C compiler is a program that
transforms files of C source code into machine code.
Compilation is a complex process that involves several steps;
however, \*(PN simplifies it with the command
.BR cc ,
which controls all the actions of the compiler.
.Sh "Try the Compiler"
.PP
Before we launch into a lengthy explanation of what \fBcc\fR is and what it
does, you can get a feel for it by trying it with a simple example.
To begin, type the following to create a simple C program:
.DM
	cat >hello.c
	main() {
		printf("Hello, world\en");
	}
	<ctrl-D>
.DE
This creates a simple C program called \fBhello.c\fR.
Now, compile your program by typing the following command:
.DM
	cc -V hello.c
.DE
If you typed the program correctly,
.B cc
prints something like the following on your screen:
.DM
	cc0 D2B000000201 hello.c  0x418CB8
	cc1 D2B000000201 0x418CB8 0x408CB4
	cc2a D2B000000201 0x408CB4 0x418CB8
	cc2b D2B000000201 0x418CB8 hello.o
	/bin/ld -X -o hello /lib/crts0.o hello.o /lib/libc.a -Z hello.o
.DE
What each of these messages means will be described below.
If you receive an error message, try re-typing the program, and then
re-compile it.
When compilation is successfully completed, you will now have an executable
program called \fBhello\fR.
To invoke it, type:
.DM
	hello
.DE
It should print the following on your screen:
.DM
	Hello, world
.DE
As you can see, \fBcc\fR makes it easy to transform a file of C code into
an executable program.
.Sh "Phases of Compilation"
.PP
As you noticed, \fBcc\fR printed a number of messages on your screen as it
compiled \fBhello.c\fR.
The reason you saw the messages was that compilation was performed with the
\fB\-V\fR option to \fBcc\fR; this tells \fBcc\fR to print a verbose output
that describes each of its actions.
\fBcc\fR prints numerous messages because the \*(CO C compiler
is not just one program, but a number of different programs that work together.
Each program performs a
.I phase
of compilation.
The following summarizes each phase:
.IP \fBcpp\fR 0.4i
The C preprocessor.
.II cpp
.II "C preprocessor"
This processes any of the \*(Ql#\*(Qr directives, such as
.B #include
or
.BR #ifdef ,
and expands macros.
.IP \fBcc0\fR
.II cc0
.II "parser"
The parser.
This phase parses programs.
It translates the program into a parse-tree format,
which is independent of both the language of the
source code and the microprocessor for which code will be generated.
.IP \fBcc1\fR
.II cc1
.II "code generator"
The code generator.
This phase reads the parse tree generated by
.B cc0
and translates it into machine code.
The code generation is table driven, with entries for each operator
and addressing mode.
.IP \fBcc2a\fR
.II cc2a
.II "optimizer generator"
.II optimization
The optimizer generator.
This phase optimizes the generated code.
.IP \fBcc2b\fR
.II cc2b
.II "object generator"
.II optimization
The optimizer generator.
This phase writes the object module.
.IP \fBcc3\fR
.II cc3
.II "assembly-language generator"
\*(PN also includes a fifth phase, called
.BR cc3 ,
which can be run after the object generator,
.BR cc2 .
.B cc3
generates a file of assembly language instead of a relocatable object module.
\fBcc3\fR allows you to examine the code generated by the compiler.
You did not see this phase when you compiled \fBhello.c\fR because
this phase is optional and you did not request it.
If you want \*(PN to generate assembly language, use the
.B \-S
option on the
.B cc
command line.
.PP
.II "object module"
Unless you specify the
.B \-S
option, \fBcc\fR creates an
.I "object module"
that is named after the source file being compiled.
This module has the suffix
.BR .o .
An object module is
.II "object module"
.I not
executable;
it contains only the code generated by compiling a C source file, plus
information needed to link the module with other program modules
and with the library functions.
.PP
.II linker
.II "executable program"
As the final step in its execution,
.B cc
calls the linker \fBld\fR to produce an executable program.
.Sh "Renaming Executable Files"
.II "executable files"
.PP
When \fBcc\fR compiles a source file, by default it names the executable
program after the \fIfirst\fR source file named on the \fBcc\fR command line.
If you wish, you can give the executable file a different name.
Use the
.B \-o
(output) option, followed by the desired name.
.Sh "Floating-Point Numbers"
.II "floating-point numbers"
.PP
Often, you will need to use floating-point numbers in your programs.
If you are unsure what a floating-point number is, see the Lexicon entry for
.BR float .
.PP
The routines that print floating-point numbers are large, and
most C programs do not need to print floating-point numbers;
therefore, the code to perform floating-point arithmetic is not
included in a program by default.
You must ask \fBcc\fR to include these routines with your program by using the
.B \-f
option to \fBcc\fR.
.PP
To see how this works, let's modify \fBhello.c\fR to use floating-point
numbers.
Edit \fBhello.c\fR by typing the following commands:
.DM
	ed hello.c
	2
	c
		printf("Hello, world %f\en", 123.4);
	.
	w
	q
.DE
Now, compile the program with the same command line as before:
.DM
	cc -V hello.c
.DE
When compilation has finished, type \fBhello\fR.
You'll see the following output:
.DM
	You must compile with the \-f flag
	to include printf() floating point.
	Hello, world
.DE
\*(CO is telling you that you are using
a floating-point number but that you did not compile the program to
include code to process floating-point numbers.
Now, recompile the program using the \fB\-f\fR option to \fBcc\fR:
.DM
	cc -V -f hello.c
.DE
When compilation has finished, type \fBhello\fR.
If you typed the program correctly, you will see the following:
.DM
	Hello, world 123.400000
.DE
As you can see, \fBhello\fR is now displaying the floating-point number
\fB123.4\fR for you.
For detailed information on \fBprintf()\fR, see its entry in the Lexicon;
\fBprintf()\fR is also discussed in the tutorial section below.
.Sh "Compiling Multiple Source Files"
.II "multiple source files"
.PP
Many programs are built from more than one file of C source code.
For example, the program
.BR factor ,
which is provided with \*(PN, is built from the C source files
.B factor.c
and
.BR atod.c .
To produce the executable program \fBfactor\fR, both source files
must be compiled;
the linker \fBld\fR then joins them to form an executable file.
.PP
.II factor.c
.II atod.c
To compile a program that uses more than one source file, type all
of the source files onto the
.B cc
command line.
For example, to compile \fBfactor\fR you would type the following:
.DM
	cc -o factor -f factor.c atod.c -lm
.DE
This command compiles both C source files to create the program
.BR factor .
.PP
In the above example,
.B cc
produces the non-executable object modules
.B factor.o
and
.BR atod.o ,
and then links them to produce the executable file
.BR factor .
.PP
The argument
.B \-lm
tells
.B cc
to include routines from the mathematics library
.II "mathematics library"
.II libm
when the object modules are linked.
This option must come
.I after
the names of all of the source files,
or the program will not be linked correctly.
.Sh "Linking Without Compiling"
.II "linking without compiling"
.PP
When you are writing a program that consists of several source files,
you will need to compile the program, test it, and
then change one or more of the source files.
Rather than recompile all of the source files, you can save time
by recompiling only the modified files and relinking the program.
.PP
For example, if you modify the
.B factor
program by changing the source file
.BR factor.c ,
you can recompile \fBfactor.c\fR \fIand\fR relink the
entire program with the following command:
.DM
	cc -o factor -f factor.c atod.o -lm
.DE
.II "source file"
.II "object module"
This \fBcc\fR command refers to the C source file
.B factor.c
and the
.I "object module"
.BR atod.o .
.B cc
recognizes that
.B atod.o
is an object module and simply passes it to the linker \fBld\fR
without re-compiling it.
You will find this particularly useful when your programs
consist of many source files and you need to compile only a few of them.
.PP
To simplify compiling, especially if you are developing systems
that use many source modules, you should consider using the
.B make
utility that is included with \*(PN.
For more information on
.BR make ,
see its entry in the Lexicon, or see the tutorial for
.B make
that appears later in this manual.
.Sh "Compiling Without Linking"
.II "compiling without linking"
.PP
At times, you will need to compile a source file
but not link the resulting object module to the other object modules.
You will do this, for example, to compile a module that
you wish to insert into a library.
Use \fBcc\fR's option
.B \-c
to tell
.B cc
not to link the compiled program.
This option is often used to create relocatable object
modules that can be archived into a library for later use.
.PP
For example, if you wanted just to compile
.B factor.c
without linking it, you would type:
.DM
	cc -c factor.c
.DE
To link the resulting object module with the object module
.B atod.o
and with the appropriate libraries,
type the following command:
.DM
	cc -o factor -f factor.o atod.o -lm
.DE
.Sh "Assembly-Language Files"
.II "assembly-language programs"
.PP
C makes most assembly language programming unnecessary.
However, you may wish to write small parts of your programs in
assembly language for greater speed or to access processor features that
C cannot use directly.
\*(PN includes an assembler, named
.BR as ,
which is described in detail in the Lexicon.
.PP
To compile a program that consists of the C source file
.B example.c
and the assembly-language source file
.BR example.s ,
simply use the
.B cc
command as usual:
.DM
	cc -o example example1.c example2.s
.DE
.B cc
recognizes that the suffix
.B .s
indicates an assembly-language source file, and assembles it with
.BR as ;
.II as
then it links both object modules to produce an executable file.
.Sh "Changing the Size of the Stack"
.PP
.II "stack size"
.II "altering stack size"
The \fIstack\fR is the segment of memory that holds function arguments,
local variables, and function return addresses.
\*(CO takes advantage of the 80386 microprocessor's ability to
allocate stack dynamically.
.Sh "Where To Go From Here"
.PP
This discussion of the \fBcc\fR command is by no means complete, but
it includes enough information for you to begin to compile your programs.
The Lexicon's entry for \fBcc\fR gives all of the command-line options
available with \fBcc\fR.
The Lexicon also has entries for \fBcpp\fR, the
compiler phases, and for the linker \fBld\fR, and describes them at
greater length.
All error messages generated by \fBcc\fR and by the assembler \fBas\fR
appear in the appendix to this manual.
.PP
The next section in this tutorial introduces the C programming language.
.so \*(DI/text/beginners.r
.so \*(DI/text/bibliography.r

.II "make^tutorial"
.ds TL "make Programming Discipline"
.NH "The make Programming Discipline"
.PP
\fBmake\fR is a utility that guides the building of complex things out of
one or more simpler things.
The ``complex thing'' can be practically
any sort of file that you create regularly, such as a report or a program.
.PP
Under \*(CO,
.B make
is most commonly used to control the building of complex C programs;
and it is in this context that
.B make
shows its power most easily.
This tutorial introduces the features of
.BR make ,
and discusses how to use it to help you build complex C programs easily
and efficiently.
.Sh "How Does make Work?"
.PP
To understand how
.B make
works, it is first necessary to understand how a C program
is built:
how \*(CO takes you from the C source code that you write
to the executable program that you can run on your computer.
.PP
The file of C source code that you write is called a
.IR "source module" .
When \*(CO compiles a source module, it uses the C code in
the source module, plus the code in the header files that the
code calls to produce an
.IR "object module" .
This object module is \fInot\fR executable by itself.
To create an \fIexecutable file\fR, the object module
generated from your source module must be handed to a linker,
which links the code in the object module with the appropriate
library routines that the object module calls, and adds the
appropriate C runtime startup routine.
.PP
For example, consider the following C program, called \fBhello.c\fR:
.DM
	main()
	{
		printf("Hello, world\en");
	}
.DE
When the C compiler compiles the file that contains C code shown above,
it generates an object module called \fBhello.o\fR.
This object module is not executable because it does not contain
the code to execute the function \fBprintf()\fR; that code is
contained in a library.
To create an executable program, you must hand \fBhello.o\fR
to the linker \fBld\fR,
which copies the code for \fBprintf\fR from a library and into
your program, adds the appropriate C runtime startup routine,
and writes the executable file called \fBhello\fR.
This third file, \fBhello\fR, is what you can execute on your computer.
.PP
The term
.I dependency
describes the relationship of executable file to object module
to source module.
The executable program
.I depends
on the object module and one or more libraries.
The object module, in turn, depends on the source module and
its header files (if any).
.PP
A program like \fBhello\fR has a simple set of dependencies:
the executable file is built from one object module, which in turn is
compiled from one source module.
If you changed the source module \fBhello.c\fR, creating an
updated version of \fBhello\fR would be easy:
you would simply compile \fBhello.c\fR to create \fBhello.o\fR,
which you would link with the library and the runtime startup
to create \fBhello\fR.
\*(CO, in fact, does this for you automatically:
all you need to do is type
.DM
	cc hello.c
.DE
and the C compiler takes care of everything.
.PP
On the other hand, the dependencies of a large program can be very complex.
For example, the executable file for the \*(ME screen
editor is built from several dozen object modules,
each of which is compiled from a source module plus one or more header files.
Updating a program as large as \*(ME, even when you
change only one source module, can be quite difficult.
To rebuild its executable file by hand, you must remember
the names of all of the source modules used, compile them,
and link them into the executable file.
Needless to say, it is very inefficient to recompile
several dozen object modules to create an executable when you
have changed only one of them.
.PP
.B make
automatically rebuilds large programs for you.
You prepare a file, called a \fBmakefile\fR, that describes your
program's chain of dependencies.
.B make
then reads your \fBmakefile\fR, checks to see which source
modules have been updated, recompiles only the ones that have
been changed, and then relinks all of the object modules to create
a new executable file.
.B make
both saves you time, because it recompiles only the source
modules that have changed, and spares you the drudgery of
rebuilding your large program by hand.
.Sh "Try make"
.PP
To see how \fBmake\fR works, try compiling a program called
.BR factor .
It is built from the following files:
.DM
	atod.c
	factor.c
	makefile
.DE
All three are kept in directory
.BR /usr/src/sample .
To use them, copy the following files into your current directory.
(By the way, first make sure that you do not already have a file named
.B makefile
in your current directory, or the following commands will overwrite it.)
.DM
	cp /usr/src/sample/atod.c .
	cp /usr/src/sample/factor.c .
	cp /usr/src/sample/makefile .
.DE
Now, type \fBmake\fR.
\fBmake\fR begins by reading \fBmakefile\fR, which describes
all of \fBfactor\fR's dependencies.
It then uses the \fBmakefile\fR description to create
.BR factor .
The following appear on your screen:
.DM
	cc -c factor.c
	cc -c atod.c
	cc -f -o factor factor.o atod.o -lm
.DE
Each of these messages describes an action that \fBmake\fR has
performed.
The first shows that \fBmake\fR is compiling \fBfactor.c\fR, the
second shows that it is compiling \fBatod.c\fR, and the third
shows that it is linking the compiled object modules \fBatod.o\fR
and \fBfactor.o\fR to create the executable file \fBfactor\fR.
.PP
When \fBmake\fR has finished, the shell prompt returns.
To see how your newly compiled program works, type
.DM
	factor 100
.DE
.B factor
calculates the prime factors of its argument \fB100\fR, and
print them on the screen:
.DM
	2 2 5 5
.DE
To see what happens if you try to re-make your file, type
.B make
again.
.B make
will run quietly for a moment, and then exit.
\fBmake\fR checked the dates and times of the
object modules and their corresponding source modules and saw that
the object modules had a time later than that of the source modules.
Because no source module changed, there was no need to recompile
an object module or relink the executable file, so \fBmake\fR
quietly exited.
.PP
To see what happens when one of the source modules changes, try
the following.
Use the \*(ME screen editor to open the file
.B factor.c
for editing.
Insert the following line into the comments at the top, immediately
following the \fB/*\fR:
.DM
	* This comment is for test purposes only.
.DE
Now type
.B <ctrl-Z>
to save the file and exit.
Type \fBmake\fR once again.
This time, you will see the following on your screen:
.DM
	cc -O -c factor.c
	cc -o factor factor.o atod.o -f -lm
.DE
Because you altered the source module \fBfactor.c\fR, its time
was later than that of its corresponding object module, \fBfactor.o\fR.
When
.B make
compared the times of \fBfactor.c\fR and \fBfactor.o\fR, it noted
that \fBfactor.c\fR had been altered.
It then recompiled \fBfactor.c\fR and relinked \fBfactor.o\fR and
\fBatod.o\fR to re-create the executable file \fBfactor\fR.
.B make
did not touch
the source module
.B atod.c
because \fBatod.c\fR had not been changed since the last time it was compiled.
.PP
As you can see, \fBmake\fR simplifies the construction of a
C program that uses more than one source module.
.SH "Essential make"
.PP
Although \fBmake\fR is a powerful program,
its basic features are easy to master.
This section will show you how to construct elementary \fBmakefile\fRs.
.Sh "The makefile"
.II "make^program, specification"
.II "make^specification"
.II "make^file"
.PP
When you invoke \fBmake\fR, it searches the directories named
in the environmental variable
.B PATH
for a file called \fBmakefile\fR or
.BR Makefile .
(You can tell
.B make
to read a file other than
.B makefile
or
.BR Makefile ;
see the description of \fBmake\fR's \fB\-f\fR option, below.)
As noted earlier, the \fBmakefile\fR is a text file that
describes a program's dependencies.
It also describes the type of
program you wish to build, and the commands for building it.
.PP
A \fBmakefile\fR has three basic parts.
.PP
First, the \fBmakefile\fR
describes the executable file's dependencies.
That is, it lists the object modules needed to create the executable file.
The name of the executable file is always followed
by a colon \*(Ql:\*(Qr
.II "make^colon"
and then by the names of files from which the target file is generated.
.PP
For example, if the program \fBfeud\fR
is built from the object modules \fBhatfield.o\fR and \fBmccoy.o\fR,
you would type:
.DM
	feud:    hatfield.o mccoy.o
.DE
If the files
\fBhatfield.o\fR and \fBmccoy.o\fR
do not exist, \fBmake\fR
knows to create them from the source modules \fBhatfield.c\fR and \fBmccoy.c\fR.
.PP
Second, the \fBmakefile\fR holds one or more
.I command
lines.
.II "make^command line"
The command line gives the command to
compile the program in question.
The only difference between a \fBmakefile\fR command
line and an ordinary \fBcc\fR command is
that a \fBmakefile\fR command line \fImust\fR begin with a
space or a tab character.
.PP
For example, the \fBmakefile\fR to generate the program
\fBfeud\fR must contain the following command line:
.DM
		cc -o feud hatfield.o mccoy.o
.DE
For a detailed description of the \fBcc\fR command and
its options, refer to the entry for
.B cc
in the Lexicon.
.PP
Third,
the \fBmakefile\fR lists all of the header files that your program uses.
(If you don't know what a header file is, see the entry for
.B #include
in the Lexicon.)
These files are given so that \fBmake\fR can check if
any had been modified since your program was last compiled.
For example, if the program \fBhatfield.c\fR used the header
file \fBshotgun.h\fR and \fBmccoy.c\fR used the header files
\fBrifle.h\fR and \fBpistol.h\fR, the \fBmakefile\fR to generate
\fBfeud\fR would include the following lines:
.DM
	hatfield.o: shotgun.h
	mccoy.o: rifle.h pistol.h
.DE
Thus, the entire \fBmakefile\fR to generate the program
\fBfeud\fR is as follows:
.DM
	feud: hatfield.o mccoy.o
		cc -o feud hatfield.o mccoy.o
.sp \n(PDu
	hatfield.o: shotgun.h
	mccoy.o: rifle.h pistol.h
.DE
A
.B makefile
can also contain
.I "macro definitions"
.II "make^macro, definition"
and
.IR comments .
.II "make^comment"
These are described below.
.Sh "Building a Simple makefile"
.PP
The program
.B factor
is built from two source modules,
.B factor.c
and
.BR atod.c .
No header files are used.
The \fBmakefile\fR contains the following two lines:
.DM
	factor: factor.o atod.o
		cc -o factor factor.o atod.o -f -lm
.DE
The first line describes the dependency for the executable file
\fBfactor\fR by naming the two object modules needed to build it.
The second line gives the command needed to build \fBfactor\fR.
The option \fB\-lm\fR at the end of the command line
tells \fBcc\fR that this program needs the mathematics library
.B libm
when the program is linked.
No header file dependencies are described
because these programs use no special header files.
.Sh "Comments and Macros"
.PP
.B make
ignores all lines that begin with a pound sign \*(Ql#\*(Qr.
This lets you embed comments within a \fBmakefile\fR,
to \*(QLdocument\*(QR the file so that whoever reads it will
know what it is for.
For example, you may wish to include the following comments
in your \fBmakefile\fR for \fBfactor\fR:
.DM
# This makefile generates the program "factor".
# "factor" consists of the source modules "factor.c" and
# "atod.c".  It uses the standard mathematics library
# "libm", but it requires no special header files.
# "-f" lets you use printf for floating-point numbers.
.sp \n(PDu
	factor: factor.o atod.o
		cc -f -o factor factor.o atod.o -lm
.DE
Anyone who reads this file will know immediately what it is for
by looking at the comments.
.PP
.B make
also lets you define macros within your \fBmakefile\fR.
A \fImacro\fR is a symbol that represents a string of text.
Usually, a macro is defined at the beginning of the \fBmakefile\fR
using a \fImacro definition statement\fR.
This statement uses the following syntax:
.DM
	SYMBOL = string of text
.DE
Thereafter, when you use the symbol in your \fBmakefile\fR, it
must begin with a dollar sign \*(Ql$\*(Qr and be enclosed within
parentheses.
(If the macro name is only one character long, the parentheses are not
required.)
A macro name can use both upper-case and lower-case characters.
.PP
Macros eliminate the chore of retyping long strings of file names.
For example, with the \fBmakefile\fR for the program \fBfactor\fR,
you may wish to use a macro
to substitute for the names of the object modules out of which it is
built.
This is done as follows:
.DM
# This makefile generates the program "factor".
# "factor" consists of the source modules "factor.c" and
# "atod.c".  It uses the standard mathematics library
# "libm", but it requires no special header files.
# "-f" lets you use printf for floating-point numbers.
.DE
.DM
.ta 0.5i 1.0i
OBJ = factor.o atod.o
factor: $(OBJ)
	cc -o factor $(OBJ) -f -lm
.DE
The macro \fBOBJ\fR is used in this \fBmakefile\fR.
If you use a macro that has not been defined,
\fBmake\fR substitutes an empty string for it.
The use of a macro makes sense when generating
large files out of a dozen or more source modules.
You avoid retyping the source module names, and
potential errors are avoided.
.PP
Note that you can define macros in the
.BR makefile ,
in the environment, or as a command-line argument.
A macro defined as a command-line argument always overrides a definition
of the same macro in the environment or in the
.BR makefile .
Normally, a definition in a
.B makefile
overrides a definition of the same macro name in the environment;
however, the
.B \-e
option to
.B make
forces definitions in the environment to override those in the
.BR makefile .
.Sh "Setting the Time"
.PP
As noted above, \fBmake\fR checks to see which source modules
have been modified before it regenerates your C program.
This is done to avoid wasteful
recompiling of source modules that have not been updated.
.PP
\fBmake\fR determines that a source module has been altered
by comparing its date against that of the target program.
For example, if the object module
\fBfactor.o\fR
was generated on March 16, 1992,
10:52:47 A.M., and the source module \fBfactor.c\fR was modified on
March 20, 1992, at 11:19:06 A.M., \fBmake\fR will know that \fBfactor.c\fR
needs to be recompiled because it is \fIyounger\fR than \fBfactor.o\fR.
.Sh "Building a Large Program"
.PP
As shown earlier, \fBmake\fR can ease the task of
generating a large program.
The following gives a \fBmakefile\fR that can be used to generate the
screen editor \*(ME:
.DM
# makefile for "MicroEMACS"
.sp \n(PDu
CFLAGS = -O
LFLAGS = /usr/lib/libterm.a
OBJ=ansi.o basic.o buffer.o display.o file.o \e
	fileio.o line.o main.o random.o region.o \e
	search.o spawn.o termio.o vt52.o window.o \e
	word.o tcap.o
.sp \n(PDu
me: $(OBJ)
	cc -o me $(OBJ) $(LFLAGS)
.sp \n(PDu
$(OBJ):	ed.h
.DE
Note that this
.B makefile
has been simplified for the purposes of this tutorial; the actual
.B makefile
that builds the \*(CO edition of \*(ME is considerably more complex.
.PP
The first line in the above
.B makefile
gives commentary that describes the file does.
The next five lines define macros that are used on the target and command lines.
The first macro will be discussed in the following section.
The second macro substitutes for the name of a special library that is needed
to create this program.
The third macro, which is three lines long, stands
for the names of the source modules that produce \*(ME.
A backslash \*(Ql\e\*(Qr must be used to tell \fBmake\fR
that the macro's definition extends onto the next line.
.PP
The next line names the target file (\fBme\fR) and the files
used to construct it, here represented by the macro \fBOBJ\fR.
.PP
Next comes the command line, which gives the compilation
to be performed.
This line \fImust\fR begin with a space or a tab.
.PP
The last line lists the header file \fBed.h\fR, which is
required by all of the files used to generate \*(ME.
.SH "Command-Line Options"
.II "make^command line, options"
.II "make^command line"
.II "make^-"
.II "make^hyphen"
.II "make^options"
.PP
Although \fBmake\fR is controlled by your \fBmakefile\fR,
you can also control \fBmake\fR by using command-line options.
These allow you to alter \fBmake\fR's activity without
editing your \fBmakefile\fR.
.PP
Options must follow the command name on the command line
and begin with a hyphen, \*(Ql\-\*(Qr, using the following format.
The square brackets merely indicate that you can select
any of these options;
do \fInot\fR type the brackets when you use the \fBmake\fR command:
.DM
	make [ \-deinpqrst ] [ \-f \fIfilename\fP ]
.DE
Each option is described below.
.IP \fB\-d\fR 0.4i
.II "make^debug option"
Debug option:
.B make
describes all of its decisions.
You can use this to debug your \fBmakefile\fR.
.IP \fB\-e\fR
Environment option:
force definitions in the environment to override those in the
.BR makefile .
For example, if the
.B makefile
defines
.DM
	foo=makefoo
.DE
and the environment defines
.DM
	foo=envfoo
.DE
then
.B $(foo)
expands to
.B makefoo
if you use the command
.B make
but expands to
.B envfoo
if you use the command
.BR "make \-e" .
.IP "\fB\-f \fIfilename\fR"
.II "make^file option"
File option:
Tell \fBmake\fR that its commands
are in a file other than \fBmakefile\fR.
For example, the command
.DM
	make -f smith
.DE
tells \fBmake\fR to use the file
\fBsmith\fR rather than \fBmakefile\fR.
.II "make^program, specification"
.II "make^specification"
If you do not use this option, \fBmake\fR
searches the directories named in the environmental variable \fBPATH\fR,
and then the current directory for a file entitled
.B makefile
or
.B Makefile
.II "make^Makefile"
to execute.
.II "make^file"
.IP \fB\-i\fR
Ignore errors:
.II "make^ignore errors option"
.B make
ignores error returns from commands and continues processing.
.II "make^error status"
.II "make^command, error"
Normally,
.B make
exits if a command returns an error status.
.IP \fB\-n\fR
.II "make^no execution option"
No execution:
.B make
tests dependencies and modification times but
does not execute commands.
This option is especially helpful when constructing or debugging a
.BR makefile .
.IP \fB\-p\fR
Print:
.II "make^print option"
.II "make^macro, printing"
.II "make^target, printing"
.II "make^printing"
.B make
prints all macro definitions and target descriptions.
.IP \fB\-q\fR
Quit option:
Return a zero exit status if the targets are up to date.
Do not execute any commands.
.II "make^macro, definition"
.IP \fB\-r\fR
Rules option:
.II "make^rules option"
.II "make^no rules option"
.B make
does not use the default macros and commands from
.B /usr/lib/makemacros
.II "make^/usr/lib/makemacros"
.II "make^macros"
and
.BR /usr/lib/makeactions .
.II "make^/usr/lib/makeactions"
.II "make^actions"
These files will be described below.
.IP \fB\-s\fR
Silence:
.II "make^silent option"
.II "make^command, printing"
.B make
does not print each command line as it is executed.
.IP \fB\-t\fR
Touch:
.II "make^touch option"
.B make
changes the
.II "make^modification time"
.II "make^file modification time"
modification time of each executable file and object module
to the current time.
This suppresses recreation of the executable file,
and recompilation of the object modules.
Although this option is used typically after a purely cosmetic change
to a source module or after adding a definition to a header file,
it must be used with great caution.
.Sh "Other Command Line Features"
.II "make^command line, macro definition"
.II "make^command line"
.II "make^macro, definition"
.II "make^macro"
.PP
In addition to the options listed above, you
may include other information on your command line.
.PP
First, you can define macros on the command line.
A macro definition must \fIfollow\fR all command-line options.
Arguments, including spaces, must be surrounded by quotation marks,
as spaces are significant to the shell.
For example, the command line
.DM
	make -n -f smith "OPT=-DTEST"
.DE
tells \fBmake\fR to run in the \fIno execution\fR mode, read
the file \fBsmith\fR instead of \fBmakefile\fR, and define the macro
\fBOPT\fR to mean \fB\-DTEST\fR.
.PP
The ability to define macros on the command line means that you
can create a \fBmakefile\fR using macros that are not yet defined;
this greatly increases \fBmake\fR's flexibility and makes it even
more helpful in creating and debugging large programs.
In the above example, you can define a command line as follows:
.DM
		cc $(OPT) example.c
.DE
When you define the macro \fBOPT\fR on the command line, then the
program is compiled using the \fB\-DTEST\fR option, which defines
the preprocessor variable
.BR TEST .
.PP
As noted above, a macro defined on the command line always overrides
an identically named macro defined either in the environment or in the
.BR makefile .
.PP
.II "make^command line, target specification"
.II "make^command line"
.II "make^target"
.II "make^target, specification"
.II "make^target, program"
Another command-line feature lets you change the
name of the \fItarget file\fR on the command line.
Normally, the target file is the executable file that you
wish to create, although, as will be seen, it does not have to be.
As will be discussed below,
a \fBmakefile\fR can name more than one target file.
.B make
normally assumes that the target is the first target file named in
.BR makefile .
However, the command line may name one or more
target files at the end of the line,
after any options and any macro definitions.
.PP
To see how this works, recall the program \fBfactor\fR described above.
\fBfactor\fR is generated out of the source modules \fBfactor.c\fR
and \fBatod.c\fR.
The command
.DM
	make atod.o
.DE
with the \fBmakefile\fR outlined above would produce the
following \fBcc\fR command line:
.DM
	cc -c atod.c
.DE
if the object module
\fBatod.o\fR
did not exist or were outdated.
Here,
.B make
compiles
.B atod.c
to create the target specified in the \fBmake\fR command line,
that is, \fBatod.o\fR, but it does not create
.BR factor .
This feature allows you to apply your \fBmakefile\fR to only a
portion of your program.
.PP
The use of special, or \fIalternative\fR, target files is discussed below.
.SH "Advanced make"
.PP
This section describes some of \fBmake\fR's advanced features.
For most of your work, you will not need these features; however,
if you create an extremely complex program, you will find them most helpful.
.Sh "Default Rules"
.II "make^default rules"
.PP
The operation of \fBmake\fR is governed by a set of \fIdefault rules\fR.
These rules were designed to simplify the compilation of a typical program;
however, unusual tasks may require that you bypass or alter the default rules.
.PP
To begin,
.B make
uses information from the files
.B /usr/lib/makemacros
.II "make^/usr/lib/makemacros"
.II "make^macros"
and
.B /usr/lib/makeactions
.II "make^/usr/lib/makeactions"
.II "make^usr/lib/makeactions"
.II "make^actions"
to define default macros and compilation commands.
.B make
uses the commands in \fBmakemacros\fR and \fBmakeactions\fR whenever the
.B makefile
specifies no explicit regeneration commands.
The command line option
.B \-r
tells
.B make
not to use the macros and actions defined in \fBmakemacros\fR
and \fBmakeactions\fR.
.PP
As shown in earlier examples,
.B make
knows by default to generate the object module
.B atod.o
from the source module
.B atod.c
with the command
.DM
	cc -c atod.c
.DE
The macro
.B .SUFFIXES
.II "make^.SUFFIXES"
defines the suffixes
.B make
knows about by default.
Its definition in \fBmakemacros\fR
includes both the
.B .o
and
.B .c
suffixes.
.PP
\fBmake\fR's files \fBmakemacros\fR and \fBmakeactions\fR
use pre-defined macros to increase their scope and flexibility.
These are as follows:
.IP \fB$<\fR 0.4i
.II "make^$<"
This stands for the name of the file or files that cause the action
of a default rule.
For example, if you altered the file \fBatod.c\fR and then invoked
\fBmake\fR to rebuild the executable file \fBfactor\fR,
\fB$<\fR would then stand for \fBatod.c\fR.
.IP \fB$*\fR
.II "make^$*"
This stands for the name of the target of a default rule
with its suffix removed.
If it had been used in the above example, \fB$*\fR
would have stood for \fBatod\fR.
.sp \n(PDu
\fB$<\fR and \fB$*\fR work
.I only
with default rules;
these macros will not work in a
.BR makefile .
.IP \fB$?\fR
.II "make^$?"
This stands for the names of the files that cause the action and that are
younger than the target file.
.IP \fB$@\fR
This
.II "make^$@"
stands for the target name.
.PP
You can use the macros \fB$?\fR and \fB$@\fR in a
.BR makefile .
For example, the following rule updates the archive
.B libx.a
with the objects defined by macro
.B $(OBJ)
that are out of date:
.DM
	libx.a:	$(OBJ)
		ar rv libx.a $?
.DE
.PP
For more information on archives, see the Lexicon entry for the command
.BR ar .
.PP
\fBmakemacros\fR also contains default commands that describe
how to build additional kinds of files:
.IP \(bu 0.3i
\fBAS\fR and \fBASFLAGS\fR call the
.II "make^assembler"
assembler
.B as
to assemble
.B .o
files out of files with the suffix
.BR .s ,
which
.B make
assumes hold assembly language.
.IP \(bu
.B YACC
and
.B YFLAGS
.II "make^yacc"
call \fByacc\fR to build
.B .o
or
.B .c
files from files with the suffix
.BR .y ,
which
.B make
assumes hold
.B yacc
source code.
.IP \(bu
.B LEX
and
.B LFLAGS
call
.B lex
.II "make^lex"
to build
.B .o
or
.B .c
files from files with the suffix
.BR .l ,
which
.B make
assume hold
.B lex
source code.
.PP
You can change the default rules of \fBmake\fR by changing
them in \fBmakeactions\fR
and changing the definition of any of the macros as given in
\fBmakemacros\fR.
.Sh "Source File Path"
.PP
If a file is not specified with an absolute path name beginning with `/',
.B make
first looks for the file in the current directory.
If the file is not found in the current directory,
.B make
searches for it in the list of directories specified by the macro
.BR $(SRCPATH) .
This allows you to compile a program in an object directory separate from the
source path.
.PP
For example
.DM
	export SRCPATH=/usr/src/local/me
	make
.DE
or alternatively
.DM
	make SRCPATH=/usr/src/local/me
.DE
builds objects in the current directory as specified by the
.B makefile
from sources kept in directory
.BR /usr/src/local/me .
To test changes to a program built from several source files, copy only
the files you wish to change to the current directory;
.B make
will use the local sources and find the other sources on the
.BR $(SRCPATH) .
.PP
Note that
.B $(SRCPATH)
can be a single directory, as in the above example, or a list of
directories.
In the latter case, each entry in the list must be separated by a colon `:',
as described in the Lexicon entry for the function
.BR path() .
.Sh "Double-Colon Target Lines"
.II "make^double colon"
.II "make^target, line"
.PP
.II "make^archive"
.II "make^colon"
An alternative form of target line simplifies the task of maintaining archives.
This form uses the double colon \*(QL::\*(QR
instead of a single colon \*(Ql:\*(Qr
to separate the name of the target from those of the files on which it depends.
.PP
A target name can appear on only one single-colon target line,
whereas it can appear on several double-colon target lines.
The advantage of using the double-colon target lines is that
.B make
remakes the target by executing the commands (or its default commands)
for the \fIfirst\fR such target line for which
the target is older than a file on which it depends.
.PP
For example, for the program
\fBfactor\fR described earlier,
assume that two versions of the source modules \fBfactor.c\fR
and \fBatod.c\fR exist:
fBfactora.c\fR plus \fBatoda.c\fR,
and \fBfactorb.c\fR plus \fBatodb.c\fR
The \fBmakefile\fR would appear as follows:
.DM
	OBJ1 = factora.o atoda.o
	OBJ2 = factorb.o atodb.o
.DE
.DM
	factor:: $(OBJ1)
		cc -c $(OBJ1) -lm
.sp \n(PDu
	factor:: $(OBJ2)
		cc -c $(OBJ2) -lm
.DE
This \fBmakefile\fR tells \fBmake\fR to do the following:
(1) Check if either
\fBfactora.o\fR or \fBatoda.o\fR is younger than \fBfactor\fR.
(2) If either one is, regenerate
\fBfactor\fR using this version of these files.
(3) If neither
\fBfactora.o\fR nor \fBatoda.o\fR is younger than \fBfactor\fR,
then check to see if either
\fBfactorb.o\fR or \fBatodb.o\fR is
younger than \fBfactor\fR.
(4) If either of them is, then
regenerate \fBfactor\fR using the youngest version of these files.
.PP
This technique allows you to maintain multiple versions of source
files in the same directory and selectively recompile the most
recently updated version without having to edit your \fBmakefile\fR
or otherwise trick the system.
.PP
You cannot target a file in both a single-colon and a double-colon target line.
.Sh "Special Targets"
.II "make^special targets"
.II "make^target"
.PP
A few target names have special meanings to
.BR make .
The name of each special target begins with \*(Ql.\*(Qr and
contains upper-case letters.
.PP
The target name
.B .DEFAULT
.II "make^.DEFAULT"
defines the default commands
.B make
uses if it cannot find any other way to build a target.
The special target
.B .IGNORE
.II "make^.IGNORE"
in a
.B makefile
has the same effect as the
.B \-i
command line option.
Similarly,
.B .SILENT
.II "make^.SILENT"
.II "make^silent option"
has the same effect as the
.B \-s
command line option.
.Sh Errors
.II "make^errors"
.PP
.B make
prints \*(QL\fIcommand\fR exited with status \fIn\fR\*(QR
and exits if an executed \fIcommand\fR returns an error status.
.II "make^command, error"
.II "make^error status"
.II "make^ignore errors option"
.II "make^-"
However, it ignores the error status and continues processing if the
.B makefile
command line begins with a hyphen \*(Ql\fB-\fR\*(Qr or if the
.B make
command line specifies the
.B \-i
option.
.PP
.B make
reports an error status and exits if the user interrupts it.
.II "make^interrupt"
It prints \*(QL\fBcan't open \fIfile\fR\*(QR
if it cannot find the specification
.IR file .
It prints \*(QL\fBTarget \fIfile\fB is not defined\fR\*(QR
or \*(QL\fBDon't know how to make \fItarget\fR\*(QR
if it cannot find an appropriate
.I file
or commands to generate
.IR target .
Other possible errors include syntax errors in the specification file,
macro definition errors, and running out of space.
The error messages
.B make
prints are generally self-explanatory.
The section
.BR "Error Messages" ,
at the end of this manual,
lists
.BR make's
error messages and describes them briefly.
.Sh "Exit Status"
.II "make^exit status"
.II "make^return value"
.PP
.B make
normally returns a status of zero if it succeeds, and of one if an error occurs.
With the
.B \-q
option (described above),
.B make
returns zero if all files are up to date and two if they are not up to date.
.SH "Alternative Uses"
.PP
.B make
is a program that helps you construct complex things
from a number of simpler things.
.PP
.B make
usually is used to build complex C programs:
the executable file is made from object modules,
which are made from source modules and header files.
However, you can also use \fBmake\fR to build any file that is
constructed from one or more source modules.
For example, an accountant can use \fBmake\fR
to generate monthly reports from daily inventories:
all the accountant has to do is prepare a \fBmakefile\fR that describes
the dependencies (that is, the name of the monthly report he
wishes to create and the names of the daily inventories from which it
is created), and the command required to generate the monthly report.
Thereafter, to recreate the report, all the accountant has to do to
generate a monthly report is type \fBmake\fR.
.PP
In another example, the
.B makefile
can trigger program-maintenance commands.
For example, the target name
.B backup
might define commands to copy source modules to another directory; typing
.B "make backup"
saves a copy of the source modules.
Similar uses include removing temporary files, building archives,
executing test suites, and printing listings.
A
.B makefile
is a convenient place to keep all the commands used to maintain a program.
.PP
The following example shows a
.B makefile
that defines two special target files,
.B printall
and
.BR printnew ,
to be used with the source files for the program \fBfactor\fR.
.DM
# This makefile generates the program "factor".
# "factor" consists of the source modules "factor.c" and
# "atod.c".  It uses the standard mathematics library
# libm, but it requires no special header files.
.sp \n(PDu
OBJ = factor.o atod.o
SRC = factor.c atod.c
.sp \n(PDu
factor: $(OBJ)
	cc -o factor $(OBJ) -lm
.sp \n(PDu
# program to print all the updated source modules
# used to generate the program "factor"
.DE
.DM
printall:
	pr $(SRC) | lpr
	>printnew
.sp \n(PDu
printnew: $(SRC)
	pr $? | lpr
	>printnew
.DE
In this instance, typing the command
.DM
	make printall
.DE
forces \fBmake\fR to generate the target \fBprintall\fR
rather than the target \fBfactor\fR, which is the
default as it appears first in the \fBmakefile\fR.
The
.B pr
and \fBlpr\fR commands are then used to print a listing of all files defined by
.BR SRC .
The macro \fBOBJ\fR cannot be used with these commands because it
would trigger the printing of the object files, which would not be of much use.
It also creates an empty file
.BR printnew .
This new file serves only to record the time the listing is printed.
This tactic is performed in order to record the time that the listing was
last generated so that \fBmake\fR will know what files have
been updated when you next use \fBprintnew\fR.
.PP
Typing the command
.DM
	make printnew
.DE
forces \fBmake\fR to generate the target \fBprintnew\fR
rather than the default target \fBfactor\fR.
\fBprintnew\fR prints only the files named in the macro
.B SRC
that have changed since any files were last printed.
.SH "Where To Go From Here"
.PP
The Lexicon article on \fBmake\fR summarizes \fBmake\fR's options and
features.
The source code included with the \*(CO system and with the COHware
packages include \fBmakefile\fRs.
Studying them will show you how \fBmake\fR has been used to control
the building of large, real-world applications.

.TH path() "" "" "General Function (libc)"
.PC "Path name for a file"
\fB#include <path.h>\fR
\fB#include <stdio.h>\fR
\fBchar *path(\fIpath\^\fB, \fIfilename\^\fB, \fImode\^\fB);\fR
\fBchar *\fIpath\^\fB, *\fIfilename\^\fB;\fR
\fBint \fImode\^\fB;\fR
.PP
The function
.B path()
builds a path name for a file.
.PP
.I path
points to the list of directories to be searched for the file.
You can use the function
.B getenv()
to obtain the current definition of the environmental variable
.BR PATH ,
or use the default setting of
.B PATH
found in the header file
.BR path.h ,
or, you can define
.I path
by hand.
.PP
.I filename
is the name of the file for which \fBpath\fR is to search.
.I mode
is the mode in which you wish to access the file, as follows:
.DS
.ta 0.5i 1.25i
	\fBX_OK\fR	Execute the file
	\fBW_OK\fR	Write to the file
	\fBR_OK\fR	Read the file
.DE
.PP
.B path()
calls the function
.B access()
to check the access status of
.IR filename .
If
.B path()
finds the file you requested and the file is available in the mode that you
requested, it returns a pointer to a static area in which it has built the
appropriate path name.
It returns NULL if either
.I path
or
.I filename
are NULL, if the search failed, or if the requested file is not
available in the correct mode.
.SH Example
This example accepts a file name and a search mode.
It then tries to find the file in one of the directories named in the
.B PATH
environmental variable.
.DM
#include <path.h>
#include <stdio.h>
#include <stdlib.h>
.DE
.DM
void
fatal(message)
char *message;
{
	fprintf(stderr, "%s\en", message);
	exit(1);
}
.DE
.DM
main(argc, argv)
int argc; char *argv[];
{
	char *env, *pathname;
	int mode;
.DE
.DM
	if (argc != 3)
		fatal("Usage: findpath filename mode");
.DE
.DM
	if(((mode=atoi(argv[2]))>4) || (mode==3) || (mode<1))
		fatal("modes: 1=execute, 2=write, 4=read");
.DE
.DM
	env = getenv("PATH");
	if ((pathname = path(env, argv[1], mode)) != NULL) {
		printf("PATH = %s\en", env);
		printf("pathname = %s\en", pathname);
		return;
	} else
		fatal("search failed");
}
.DE
.SH "See Also"
.Xr "access()," access
.Xr "libc," libc
.Xr "PATH," path.e
.Xr "path.h" path.h

.po 1i
.sp 1i
.ll 6.25i
.ce
\f(SBUser Evaluation Report
.sp
\f(CRIn order to keep this manual free of errors and to help us
improve the \f(CBCOHERENT Device Driver Kit\f(CR, we would
appreciate it if you sent us your reactions.  Please fill in the form
below, detach it, and mail it to:
.sp
.ce 3
Mark Williams Company
.br
60 Revere Drive
.br
Northbrook, IL  60062
.sp
.ta 1.25i
Name:	\l'5.25i'
.sp
\f(CRCompany:	\l'5.25i'
.sp
\f(CRAddress:	\l'5.25i'
.sp
\f(CRCity/State/Zip:	\l'5.25i'
.sp
\f(CRPhone:	\l'5.25i'
.sp
\f(CRDate:	\l'5.25i'
.sp 2
Version and hardware used:
.sp 2
Did you find any errors in the manual?
.sp 2
Can you suggest any improvements to the manual?
.sp 2
Did you find any bugs in the software?
.sp 2
Can you suggest any improvements or enhancements to the software?
.sp 2
Additional comments:

.NH "Table of Contents"
.C0 "Introduction" 1
.C1 "Using This Manual" 1
.C1 "Bibliography" 2
.C0 "TCP/IP History and Design" 3
.C1 "What Is A Network?" 3
.C2 "An Example of a Network" 3
.C2 "Protocols, the Internet, and TCP/IP" 4
.C1 "Basic TCP/IP Protocols" 5
.C2 "FTP: File Transfer Protocol" 5
.C2 "TELNET: Remote Login" 5
.C2 "SMTP: Simple Mail Transfer Protocol" 6
.C2 "Client/Server Architecture" 6
.C1 "Structure of the TCP/IP Protocols" 7
.C2 "TCP and IP Tasks" 9
.C2 "The TCP Level" 10
.C2 "The IP level" 12
.C2 "The Ethernet Level" 13
.C2 "The SLIP Level" 14
.C1 "Well-Known Ports and the Applications Layer" 15
.C2 "An Example Application: SMTP" 17
.C1 "Protocols other than TCP: UDP and ICMP" 18
.C2 "UDP" 19
.C2 "ICMP" 19
.C1 "TCP/IP Architecture:  A Summary" 19
.C1 "Tracking Names and Information: The Domain System" 21
.C1 "Routing" 22
.C2 "Gateways" 22
.C2 "Routing Through Gateways" 23
.C2 "Optimal Gatways" 23
.C1 "Classes of Internet Addresses" 23
.C2 "Special Addresses" 24
.C1 "Datagram Fragmentation and Reassembly" 25
.C1 "Ethernet Encapsulation: ARP" 25
.C1 "Getting More Information" 26
.C2 "How To Obtain Documents" 27
.C1 "Where To Go From Here" 27
.C0 "Installing cohulip" 29
.C1 "Phase One Ð Preliminary Information" 29
.C2 "Install Hardware and Driver" 29
.C2 "Choose Type of Network" 29
.C2 "Obtain an IP Address" 29
.C2 "Obtain the Domain-Name Server IP Address" 30
.C2 "Obtain Another Computer" 30
.C2 "Get the Dialing Sequence" 30
.C1 "Phase Two Ð Installing cohulip" 30
.C2 "De-archiving the Files" 30
.C2 "Contents of the cohulip Package" 30
.C2 "Invoking the Installation Script" 31
.C2 "Get Home Directory for cohulip" 31
.C2 "Get Local System Name" 32
.C2 "Get Internet Address" 32
.C2 "SLIP Information" 32
.C2 "Ethernet Information" 33
.C2 "Select the Default Route" 33
.C2 "Domain-Name Server" 33
.C2 "Select Servers" 34
.C2 "Final Actions" 34
.C2 "After the Dust Settles" 35
.C1 "Phase Three Ð Post-Installation Configuration" 36
.C2 "Configuring cohulip for Ethernet" 36
.C2 "Connecting to the Internet via SLIP" 37
.C2 "Startup Script" 37
.C2 "Modem Configuration" 37
.C2 "Setting Your IP Address:  Permanent Address" 38
.C2 "Setting Your IP Address:  Floating Address" 38
.C2 "Domain-Name Server Address" 39
.C2 "An Example Login Session" 39
.C2 "Writing a Script to Invoke net" 40
.C1 "Where To Go From Here" 42
.C0 "cohulip Configuration Files" 43
.C1 "startup.net" 43
.C2 "Order of Commands" 43
.C1 "ftpusers" 44
.C1 "hosts.net" 45
.C1 "Help Files" 45
.C1 "Finger Files" 45
.C0 "Running net" 47
.C1 "Starting Up" 47
.C1 "Modes of Operation" 47
.C1 "Host Names" 48
.C1 "Syntax of Commands" 48
.C2 "<return> Ð Send a Command" 48
.C2 "? Ð Print a Help Message" 48
.C2 "! Ð Send a Command to the Shell" 48
.C2 "# Ð Ignore a Command" 48
.C2 "attach Ð Attach net To a Network" 48
.C2 "cd Ð Change Directory‘R" 50
.C2 "close Ð Close a Session On Your End" 50
.C2 "dir Ð List Contents of Directory on Remote Host" 50
.C2 "domain Ð Manipulate Information About Domains" 50
.C2 "echo Ð Change Response to telnet Echo Request" 51
.C2 "eol Ð Display or Modify End-of-Line Behavior" 51
.C2 "escape Ð Display or Change the Escape Character" 51
.C2 "etherstat Ð Display Ethernet Statistics" 51
.C2 "exit Ð Exit From net‘R" 51
.C2 "finger Ð Display Information About Users" 52
.C2 "ftp Ð File Transfer Protocol" 52
.C2 "ip Ð Manipulate the IP Handler" 54
.C2 "help Ð Display a help file" 55
.C2 "hostname Ð Set the Local Host\(aas Name" 55
.C2 "kick Ð Kick Out Pending Text" 55
.C2 "log Ð Log Server Activity" 55
.C2 "ping Ð Reach Out and Touch A Remote Host" 56
.C2 "pwd Ð Print Working Directory" 56
.C2 "record Ð Record All Activity" 56
.C2 "reset Ð Blow Away a Session" 56
.C2 "route Ð Manipulate the Routing Table" 56
.C2 "session Ð Display Information About Sessions" 57
.C2 "shell Ð Invoke the COHERENT Shell" 57
.C2 "smtp Ð Simple Mail Transport Facility" 58
.C2 "start Ð Invoke a Server" 58
.C2 "stop Ð Shut Down a Server‘R" 59
.C2 "tcp Ð Manipulate TCP" 59
.C2 "telnet Ð Converse With Another System" 60
.C2 "trace Ð Trace the Handling of Datagrams" 60
.C2 "udp status Ð Display Status of UDP Receive Queues" 61
.C2 "upload Ð Write File Into Current TELNET Session" 61
.C1 "Where To Go From Here" 61
.C0 "Advanced cohulip" 63
.C1 "Sample FTP Session" 63
.C1 "Anonymous FTP" 67
.C2 "Accessing a Remote Host via Anonymous FTP" 67
.C2 "Configuring cohulip for Anonymous FTP" 68
.C1 "Tracing and Debugging a cohulip Session" 69
.C2 "Initiating a Trace" 69
.C2 "Interpreting a Packet" 69
.C2 "Reading a Tracefile" 70
.C2 "Dump of a Malformed Datagram" 71
.C1 "cohulip and DOS" 72
.C2 "cohulip and DOS via SLIP" 72
.C2 "cohulip and DOS via Netware" 72
.C1 "Routing Between Networks" 74
.C2 "Connecting Between Networks" 74
.C2 "Firewall Between Networks" 75
.C1 "telunix Ð Remote Login" 75
.C1 "Traffic Jams on the Information Superhighway" 75
.C2 "Basics of TCP" 76
.C2 "How To Tune Your TCP Timer" 76
.C2 "How To Detect Congestion" 77
.C2 "What To Do If TCP Is Jammed" 78
.C0 "Index" 79
.fi

.ds TL "Introduction"
.ds TI COHULIP
.NH "Introduction"
.PP
This manual introduces the \*(CO User-Level Internet Program (\fBcohulip\fR).
.PP
.B cohulip
is a user-level application that lets you perform TCP/IP networking tasks
under the \*(CO operating system.
It supports the IP, ICMP, TCP, UDP, FTP, and TELNET protocols,
as well as the ARP protocol for address resolution.
.PP
Please note that
.B cohulip
is no substitute for true in-kernel networking;
however, for systems that have limited networking needs (e.g., a \*(CO
system in a user's basement), it can perform some useful networking tasks.
With it, you can connect to other systems via Ethernet, serial lines, or
modem; and other users on remote systems can access your system.
.PP
.BR cohulip 's
limited capacity is also helpful if you are new to networking.
Its relatively simple structure, plus the fact that it runs as a user-level
application, makes it easy to install, configure, and learn.
We have found
.B cohulip
to be a good way to introduce beginners to the confusing but fascinating world
of networking.
.PP
.II "Wright, Randy"
.B cohulip
was written by Randy Wright (rw@rwsys.wimsey.bc.ca).
.II "Karns, Phil"
It is derived from KA9Q, a package that implements TCP/IP over a
packet-radio network, which was written by Phil Karns plus many collaborators.
.B cohulip
differs from KA9Q in the following respects:
.IP \(bu 0.3i
All 16-bit objects have been altered to 32 bits.
.IP \(bu
All code to support packet radio has been removed, including
.B ax25
and
.BR netrom .
.IP \(bu
Code has been inserted to allow the package to interact with the
device-driver
.BR ne ,
which drives the NEC NE2000 Ethernet card and its clones.
.IP \(bu
Flow-control was rewritten to a form more suited to \*(CO (and \*(UU).
.PP
The result is a simpler, faster implementation that is suitable for LAN usage.
Under \*(CO, the speed of file transfer increases
approximately by a factor of ten, but with considerly less impact on
system performance.
However, due to these changes,
.B cohulip
cannot be compiled under \*(MD.
.SH "Using This Manual"
.PP
.II "Garbee, Bdale"
.II "Buswell, Joe"
.II "Butzen, Fred"
This manual was prepared by Fred Butzen of Mark Williams Company
(fred@lepanto.mwc.com).
It is based on the documentation assembled by Bdale Garbee and
revised by Joe Buswell.
The manual has been heavily edited and rewritten, both make it conform to
.BR cohulip 's
dimensions, and to improve its organization and readability.
.II "Hedrick, Charles L."
The chapter
.IR "TCP/IP History and Design"
is based on the document
.I "Introduction to the Internet Protocols"
written by Charles L. Hedrick of Rutgers University.
The portions of that chapter taken from
his document are copyright \(co 1988 by Charles Hedrick,
and are used by permission.
.PP
The chapters
.I "Installing cohulip"
and
.I "Advanced cohulip"
include much information culled from the oral tradition among
.B cohulip
users, especially as posted to newsgroup
.BR comp.os.coherent .
.II "Chalmers, Robert"
The editor wishes especially to thank Randy Wright for his
explanations of
.BR cohulip 's
internal workings,
and Robert Chalmers
(earth@nanguo.cstpl.com.au) of Mackay, Australia, for his detailed
and humorous accounts of his grapplings with earlier releases of
.BR cohulip .
.PP
Please note that all errors in this manual are the
responsibility of its editor, not of the original authors.
.PP
This manual contains the following sections:
.IP "\fITCP/IP History and Design\fR"
This gives an overview of TCP/IP.
Although much of this chapter is dry and technical, we strongly urge you
to read it.
It will help you understand just what networking and TCP/IP are, and
therefore why
.B cohulip
does what it does.
It will also help you understand some of the many obscure terms and anagrams
that shroud every discussion of networking.
.IP "\fIInstalling cohulip\fR"
This chapter describes how to install
.B cohulip
onto your system, and how to configure it for various combinations of
networks and hardware.
It also explains
.BR cohulip 's
suite of configuration files, and walks you through modifying them.
.IP "\fIConfiguration Files\fR"
This chapter introduces the configuration files that
.B cohulip
uses.
Configuring
.B cohulip
largely consists of editing these files.
.IP "\fIRunning cohulip\fR"
This chapter describes in detail the program
.BR net .
This program actually performs the networking tasks.
You can also use this chapter as a reference for
.B net
while you are running it.
.IP "\fIAdvanced cohulip\fR"
This discusses some advanced topics with
.BR cohulip ,
such as connecting it to \*(MD or connecting with two networks simultaneously.
.PP
This manual, like
.B cohulip
itself, is a work in progress.
The editor welcomes your comments, especially if you have found an error.
Please mail your jeremiads, philippics, and panegyrics to the editor at
fred@lepanto.mwc.com.
.SH "Bibliography"
.PP
The literature on TCP/IP is vast; much of it is impenetrable.
However, we strongly recommend that you acquire the following three books:
.IP \(bu 0.3i
Kehoe, Brendan P.:
\fIZen and Art of the Internet:
A Beginner's Guide to the Internet.\fR
This free book is unpublished, but is widely available on the Internet
in various forms and editions.
It is an excellent brief introduction to the Internet and its lore.
.IP \(bu
Hunt, Craig:
\fITCP/IP Network Administration.\fR
Sebastopol, Calif., O'Reilly & Associates, Inc., 1992.
This book details how to set up and administer a large TCP/IP-based network.
You may not have such a network yourself, but this book will greatly
help you work with one.
.IP \(bu
Krol, Ed:
\fIThe Whole Internet:
User's Guide & Catalog.\fR
Sebastopol, Calif., O'Reilly & Associates, Inc., 1993.
This book is an ``instant classic''.
It is by far the best one-volume guide to the Internet, and is
worthwhile for both beginners and experienced users.
If you buy no other book on this subject, buy this one.

.ds AR "Rationale"			\" Name for rationale used in text
.ds AS "Standard"			\" Name for standard used in text
.ds bu \\(bu
.ds CP "Mark Williams C and COHERENT are trademarks of \*(MW."
.ds CR 1988-1993
.ds em \\(em
.ds IF "Mark Williams C"
.ds OB .o
.ds OS TOS
.ds KR "\fIThe C Programming Language,\fR ed. 2"
.ds PI \\(*p
.ds PN "Mark Williams C"
.ds PS \\(sc
.ds SN \fBmsh\fR
.ds SU .prg
.ds TI "Mark Williams C for the Atari ST"
.ds TL "Table of Contents"
.uf R
.\" only Roman font
.rf R I
.rf R B

.ZS
.Z ADMSHOT: utilities/admshot.tar.Z "(Disk 4)" 0.3i
A set of files and scripts that allow for the simple execution of
one\-shot procedures.
.Z ARCWTMP: utilities/arcwtm.tar.Z "(Disk 4)"
Utility for archiving login history.
.Z BANNER: misc/banner.c.Z "(Disk 4)"
Banner printing utility.
.Z BEUUCP: utilities/beuucp.c.Z "(Disk 4)"
Change the effective group and user ids to
.BR uucp .
.Z BOOZ: archives/booz.tar.Z "(Disk 4)"
Unpacker for ZOO\-format archives.
.Z CFLOW: misc/cflow.tar.Z "(Disk 4)"
Produces a listing of the program's calling hierarchy based upon
C function calls and declarations.
.Z CHESS: games/chess.tar.Z   "(Disk 1)"
This program plays a fairly respectable game of chess, although it
is not competetive with state-of-the art commercial programs.
.Z CHOOSE: misc/choose.tar.Z "(Disk 4)"
Randomly selects lines from its input.
Useful for building your own
.BR fortune -like
games.
.Z CMENU: misc/Cmenu.tar.Z "(Disk 4)"
A menu package which allows you execute commands from 
a menu.
.Z CNEWS: news/cnews.tar.Z "(Disk 2)"
A distribution of
.B cnews
for COHERENT.
Good stuff if you are patient enough to make it work for you.
Comes with everything we have and our blessings.
.Z COMB: communications/comb129.tar.Z  "(Disk 1)"
An alternative to COHERENT's standard
mailer,
.BR /bin/mail .
Features screen oriented menuing and reply functions.
Still has some bugs. The current release does not function correctly with
.BR more , 
the new COHERENT screen pager.
.Z CRC: misc/crc.c.Z "(Disk 4)"
Computes encrypted checksums.
Can improve security of your file transfers or your system.
.Z CTAGS: utilities/ctags.tar.Z "(Disk 4)"
This is the Berkeley version of
.BR ctags ,
ported to COHERENT.
.Z CURSES2: misc/curses2.h.Z "(Disk 1)"
Header with additional functions for the COHERENT
.B curses
library.
.Z FINGER: utilities/finger.tar.Z "(Disk 3)"
Displays information about a user.
If you are using COHERENT releases 3.0 or 3.1, you will need to change
.B "#include <memory.h>"
to
.BR "#include <string.h>" .
.Z FOCAL: languages/focal.tar.Z "(Disk 1)"
Focal language interpreter.
.Z FONTS: PCL/cm.tar.Z "(Disk 5)"
Computer Modern shareware font collection for
HP LaserJet and compatible printers.
.Z GETPPID: misc/getppid.c.Z "(Disk 4)"
A C program that returns your parent process id.
.Z GNEWS: news/gnews.tar.Z  "(Disk 3)"
A nice ``news'' system which includes everything you need
to receive and read news.
.Z GNUGO: games/gnugo.tar.Z "(Disk 1)"
This program plays quite a respectable game of ``go''.
.Z GOMOKU: games/gomoku.tar.Z "(Disk 4)"
An ``Othello''-style game played on a 19 by 19 grid.
.Z HD: misc/hd.c.Z "(Disk 4)"
Similar to COHERENT's ``\fBod -c\fP'',
but dumps files in a friendlier hex format.
.Z HOTEL: games/hotel.tar.Z "(Disk 1)"
A board game of hotel development.
Players take turns placing tiles on the board
and buying stock in the hotels they create.
Full instructions are available in the program.
.Z LESS: utilities/less.tar.Z "(Disk 4)"
An enhanced version of the traditional Berkeley screen pager
.BR more .
Note that if you recompile
.BR less ,
be sure to run the command
.BR "fixstack +2000 less" .
.Z LIBNDIR: previous/libndir.tar.Z "(Disk 5)"
Directory access subroutine library.
This library is required to link some of the \*(PN utilities.
.Z MC: misc/mc.tar.Z "(Disk 3)"
A powerful shareware spreadsheet program for COHERENT.
.Z MENUBAR: misc/menubar.tar.Z "(Disk 4)"
Creates a menu window.
Usefull for writing programs which prompt the user for menu choices.
.Z MONTH: misc/month.tar.Z "(Disk 4)"
An appointment calendar.
.Z MTALK: utilities/mtalk.tar.Z "(Disk 4)"
A small, simple multi-user ``chat'' program.
.Z MTERM: communications/mterm.c.Z "(Disk 1)"
A basic terminal services program.
This program utilizes the serial port handler portions of the
Kermit program supplied with COHERENT as the base for a simple
terminal package. 
.Z MWDL: communications/mwdl.tar.Z "(Disk 1)"
A simple shell script used to download files from the Mark Williams Co.
bulletin board,
.BR mwcbbs .
.Z OGRE: games/ogre.tar.Z "(Disk 1)"
A game of tank warfare in the 21st Century.
.Z ORIGAMI: editors/origami.tar.Z "(Disk 4)"
A powerful folding screen editor that is able to use the same key
bindings as MicroEMACS.
.Z PCLIST: utilities/pclist.tar.Z "(Disk 4)"
Yet another screen pager. 
.Z PS: PS/postcrpt.tar.Z "(Disk 5)"
This archive contains a collection of independent,
self\-documented PostScript programs, including
.BR pscal ,
a useful calendar printing utility.
.Z PROLOG: languages/prolog.tar.Z "(Disk 1)"
A Prolog logic programming language interpreter.
Includes a manual and some tutorial information.
.Z QUEBBS: BBS/quebbs.tar.Z "(Disk 5)"
This is a Bulletin Board System that was ported to COHERENT.
.Z RCS: utilities/rcs.tar.Z "(Disk 3)"
A revision control system.
Manages software libraries, stores and retrieves multiple revisions
of text files, and much more.
.Z RN: news/rn.tar.Z "(Disk 2)"
Larry Wall's popular news reading program.
.Z SC: misc/sc.tar.Z "(Disk 4)"
A greatly modified version of the public domain spreadsheet,
.BR vc .
.Z SDBM: libraries/sdbm.tar.Z "(Disk 1)"
A clone of the Berkeley
.B ndbm
library.
.Z SHAR: archives/sharb.tar.Z "(Disk 1)"
Combines files into ``shell archive'' (shar) files.
.Z SOKOBAN: games/sokoban.tar.Z "(Disk 1)"
A clone of the popular ``Boxxle'' game.
.Z TASS: news/tass32.tar.Z "(Disk 2)"
A full\-screen, threaded news reader.
.Z TASSGN: news/tassgn.tar.Z "(Disk 2)"
Allows you to use TASS 3.2 for reading and posting news articles with 
the GNEWS package.
.Z TETRIS: games/tetris.tar.Z "(Disk 1)"
A clone of the popular arcade game Tetris.
.Z TREK73: games/trek73.tar.Z "(Disk 1)"
A computer simulated battle based on the famous
.I "Star Trek"
television series and the game
.IR "Star Fleet Battles" .
.Z UMODEM: communications/umodem.tar.Z "(Disk 1)"
This version of
.B umodem
was modified for COHERENT (see file \fBumodem.c\fP).
It is based upon
.B umodem
version 4.0 which is also included.
.Z UUCP: misc/uucp.awk.Z "(Disk 1)"
An
.B awk
script for COHERENT which
allows you to see the cost of your UUCP communications.
.Z VTREE: utilies/vtree.tar.Z (disk5)
A utility which shows the layout of a directory tree or filesystem.
.Z WHICH: utilities/which.tar.Z "(Disk 4)"
An implementation of the Berkeley
.B which
command.
It searches your path for the  first executable file
that matches the command line argument.
.Z WMAIL: communications/wmail.tar.Z "(Disk 1)"
A
.B mailx
clone which is easy to use and one of the best mailers for small systems.
WMAIL needs SMAIL25, included in \*(PN Volume I.
.Z WNEWS: news/wnews30.tar.Z "(Disk 3)"
A small news package which resembles a subset of the original B-News package.
.Z WSH: utilities/wsh.tar.Z "(Disk 4)"
A shareware window shell for COHERENT.
.Z XCMALT: communications/xcmalt.tar.Z "(Disk 1)"
XCMALT is a massive expansion and modification of XCOMM 2.2,
a UNIX dialout telecommunications program.
.Z XLISP: languages/xlisp.tar.Z "(Disk 5)"
XLISP is an experimental programming language combining some of the
features of LISP with object\-oriented extensions.
.Z XO: games/xo.tar.Z "(Disk 4)"
A tic-tac-toe game.
.Z ZOO: archives/zoo.tar.Z "(Disk 5)"
Contains two programs,
.B zoo
and
.BR fiz .
.B zoo
manipulates archives of files in compressed form.
.B fiz
analyzes damaged
.B zoo
archives for data recovery.
.ZE

.NH Errata 1
.SH "Known Limitations"
.PP
.IP 1. 0.3i
The option
.B \-g
to commands
.B gcc
and
.B g++
is known not to work with this release of gcc for \*(CO.
.IP 2.
The ``soft float'' floating-point emulation option to
.B gcc
and
.B g++
is reported not to work as described in the
.B gcc
and
.B g++
documentation.
Because
.B gcc
and
.B g++
generate hardware floating-point instructions by default,
this should not be a problem unless targeting non-\*(CO systems.
.IP 3.
Several header files in the
.B g++
release contain constructs of the form:
.DM
	struct trick {
		// member list goes here
		char a[1];
	};
.DE
The following header files (at least) contain this trick:
.BR <BitSet.h> ,
.BR <BitString.h> ,
.BR <Fix.h> ,
.BR <Integer.h> ,
and
.BR <String.h> .
The corresponding code actually allocates space for
\fBsizeof(struct trick)+\fIn\fP-1\fR
and uses the last member above as \fBa[\fIn\fP]\fR rather
than \fBa[1]\fR.
As discussed in detail on pp. 172 ff. of
\fIThe Annotated C++ Reference Manual\fR (Ellis & Stroustrup, 1990),
this is no longer legal and the generated code may not work.
The
.B g++
test programs for the corresponding library functions
usually core dumped when executed.
\fICaveat utilitor!\fR
.IP 4.
The \fBf\fR format converter to
.B printf()
and
.B sprintf()
does not always correctly round the integer portion of the output string.
For example, the expression
.DM
	printf("%5.3f\en", (4305.0 /4307.0));
.DE
.IP
prints ``0.000'' instead of the correct value ``1.000''.
.IP 5.
Due to an apparent problem with the
.B gcc
parser, constants of type
.B float
or
.B double
should have a leading digit.
For example, the program
.DM
	#include <math.h>
	main() {
		printf("%g\en", sin(.5));
	}
.DE
.IP
prints `0', whereas the program
.DM
	#include <math.h>
	main() {
		printf("%g\en", sin(0.5));
	}  
.DE
.IP
prints the correct value.

.ds TI "RELEASE NOTES"
.ds TL "Installation"
.NH "Installing X Windows"
.PP
.II X^install
.II "install X"
This section describes how to install X onto your \*(CO system, and
how to configure X to work with your hardware.
.PP
Before you attempt to install X Windows for \*(CO,
\fIread this section completely.\fR
This will help you discover any ``snags'' that could complicate the
installation, and help you to think through the process before you
plunge into it.
.SH "Preliminary Tasks"
.PP
Before you install X Windows for \*(CO on your system,
there are some preliminary tasks that you must perform.
.Sh "Check Your Video Card"
.PP
X Windows for \*(CO comes with two X servers:
one works in monochrome, the other in color.
The monochrome server works ``out of the box'' with most varieties of
VGA graphics cards.
The color server works with many, but not all, VGA chip sets.
.PP
The X installation procedure itself attempts to sense your card's chip set,
and installs either the monochrome or color server,
based on the results of its test.
However, sometimes it is wrong; if you know what chip set your system uses,
you can correct this problem by altering the configuration file that the
install program writes.
.PP
The color X server works with video cards build around the following chip sets:
.DS
	ATI 18800
	ATI 28800
	Genoa GVGA
	Paradise VGA Professional
	Trident TVGA 8900C
	Trident TVGA 9000
	Tseng Labs ET3000
	Tseng Labs ET4000
	Western Digital WD90C00
	Western Digital WD90C10
	Western Digital WD90C11
.DE
.PP
The following gives the chip sets used by many popular cards.
Note that not all can be used by X color server:
.sp \n(pDu
.nf
.ta 3.0i
\fIVideo Card	Chip Set\fR
ARC V-16	PVGA1A
AT&T VDC 600	PVGA1A
AST VGA Plus	PVGA1A
ATI Prism Elite	TVGA8800CS
ATI Ultra	Mach 8
ATI Ultra Plus	Mach 32
ATI Ultra Pro	Mach 32
ATI Vantage	Mach 8
ATI Wonder	ATI18800
ATI Wonder PLUS	ATI28800
ATI Wonder XL	ATI28800
Boca SuperVGA	ET4000
Compuadd Hi-Rez card	ET4000
Diamond SpeedStar	ET4000
Diamond SpeedStar+	ET4000
Diamond SpeedStar 24X	WD90C31
Eizo MD-B07	ET3000
Eizo MD-B10	ET3000
Eizo Extra/EM	ET3000
Everex UltraGraphics II EV-236	TVGA8900
Everex EV-678	TVGA8900
Genoa 5300 SuperVGA	ET3000
Genoa 5400 SuperVGA	ET3000
Genoa 6100 SuperVGA	GVGA
Genoa 6200 SuperVGA	GVGA
Genoa 6300 SuperVGA	GVGA
Genoa 6400 SuperVGA	GVGA
Oak Technology OTI-067	OTI67 (not compatible)
Oak Technology OTI-077	OTI77 (not compatible)
Optima Mega/1024	ET4000
Orchid Designer VGA	ET3000
Orchid Designer 800	ET3000
Orchid ProDesigner	ET3000
Orchid ProDesigner Plus	ET3000
Orchid ProDesigner /e	ET3000
Orchid ProDesigner II/1024	ET4000
Orchid ProDesigner IIs	ET4000
Paradise VGA Plus	PVGA1A
Paradise VGA Professional	PVGA1A
Paradise VGA 1024	WD90C00
Sigma Legend	ET4000
STB EM-16 VGA	ET3000
STB EM-16+ VGA	ET3000
STB Extra-EM	ET3000
STB PowerGraph	ET4000
Swan SVGA with VCO chip	ET4000
Tecmar VGA AD	ET3000
TOPVGA EXPERT	ET4000
TRICOM Mega/1024	ET4000
TRUETECH VGA	TVGA8800CS
Trident TVGA 9000	TVGA9000
Trident TVGA 8900	TVGA8900C
Trident TVGA 8800	TVGA8800CS
Tseng Labs VGA	ET4000
Video7 VRAM VGA	Video7 (not compatible)
Video7 VRAM II VGA	Video7 (not compatible)
Video7 VGA 1024i	Video7 (not compatible)
Video7 VGA 16	Video7 (not compatible)
Western Digital VGA 16	PVGA1A
.PP
The monochrome server, as noted above, works with the above-named chip sets
as well as with most other VGA chip sets.
.PP
Please note that X Windows for \*(CO does
.I not
work at all with the following video graphics cards:
.IP \(bu 0.3i
All Diamond Viper series of cards.
.IP \(bu
All ATI 64-bit cards.
.IP \(bu
All Hercules monochrome adapters.
.PP
If you have any of the above video adapters, you must replace it
before you can use X Windows for \*(CO.
.Sh "Find the Resolution of Your Monitor"
.PP
Find the resolution of your monitor.
Resolution is in number of pixels per row, and number of rows on the screen.
For example, a 640\(mu480 monitor has 480 rows of 640 pixels each.
You can find your monitor's resolution from the documentation
that comes with it.
Some higher-resolution monitors can also be displayed in lower resolution.
X Windows for \*(CO lets you choose what resolution your tube is in.
Again, check the documentation that came with your monitor to see if your
monitor supports multiple resolutions.
.PP
If you wish to run the color X server with a 1024\(mu768 display, your
video card must have at least one megabyte of RAM on board.
If it does not, you must use a display no larger than 800\(mu600.
.Sh "Upgrade COHERENT"
.PP
Your system must be running \*(CO 4.2 or later.
If you have not upgraded your system to \*(CO 4.2, do so now.
If your system cannot run \*(CO 4.2, it cannot run X Windows for \*(CO.
.Sh "Check the Amount of RAM"
.PP
Your system must have at least four megabytes of RAM.
Eight megabytes is better, 16 megabytes is preferred.
If your system does not have sufficient RAM, you must upgrade it before you
can run X Windows.
If your system has only four megabytes of RAM, you must reconfigure
\*(CO to use minimal RAM.
This is described below.
.Sh "Check the Amount of Disk Space"
.PP
To install X Windows for \*(CO, you must have 25 megabytes
of space available on the partition of your hard disk that holds directory
.BR /usr/X11 .
.PP
To see how much space you have available, use the command
.B df
(which is described in the \*(CO Lexicon).
If you do not have enough space, you must remove or compress files
to make enough space.
As a last resort, you may have to repartition your hard disk.
For information on how to repartition your machine, see the release notes
that came with your \*(CO system or see the article
in the \*(CO Lexicon for the command
.BR fdisk .
.Sh "Purge Other X Systems"
.PP
Before you attempt to install X Windows for \*(CO on your system, you
must first purge any other implementation of X from the \*(CO partitions
on your system.
The reason is that every X Windows system uses the same file names, but
those files are not be compatible across implementations.
If you do not purge the ``foreign'' implementation of X, you run the
risk of invoking those files accidentally, and so confusing X hopelessly.
.PP
If you do not want to purge a current X Windows system from your machine,
you should consider installing \*(CO and X Windows for \*(CO onto
its own partition on your machine.
You can configure the \*(CO bootstrap to boot that partition automatically,
or to let you select a partition interactively.
For details, see the articles on
.B booting
and
.B fdisk
in the \*(CO Lexicon.
.Sh "Install Your Mouse"
.PP
X Windows for \*(CO works only with a serial mouse \(em that is,
a mouse that are plugged into a serial port.
It can work with a mouse manufactured by Logitech (MouseMan), Microsoft, or
MouseSystems; or with a mouse that emulates one of these manufacturers' mice.
.PP
X Windows for \*(CO does
.I not
work with a bus mouse.
If you only have a bus mouse, you must replace it with a serial mouse
before you can use this version of X.
.PP
If you have not yet plugged your mouse into a serial port, do so.
Note the port into which you have plugged your mouse.
If you are not sure, don't worry:
the installation program for X will help you to confirm the port.
.Sh "Running X in Four Megabytes"
.PP
If you want to run X Windows on a computer system
with only four megabytes of RAM, you must
perform the following steps to reconfigure your \*(CO
system to use minimal RAM.
Four megabytes is a very minimal configuration for X.
You will be able to run X applications, but barely.
.IP \fB1.\fR 0.3i
If your system's BIOS supports shadow RAM, disable it.
This allows \*(CO and X to use the 384 kilobytes of RAM that
would otherwise be used for shadow RAM.
.IP \fB2.\fR
In the file
.BR /etc/conf/install_conf/keeplist ,
change
.DM
	echo '-I SHMMNI:SEMMNI:NMSQID'
.DE
to
.DM
	echo '-I SHMMNI:SEMMNI:NMSQID:NBUF:NHASH'
.DE
.IP \fB3.\fR
In file
.BR /etc/conf/sdevice ,
place a `Y' in the second column, next to the entry for
the standard keyboard driver
.BR kb ,
and place an `N' in the second column next to the entries for the
following drivers:
.DS
.B
	em87
	streams
	sem
	shm
	msg
	nkb
	vtkb
	vtnkb
	rm
.DE
This will enable the standard keyboard driver
.BR kb ,
and disable the drivers listed above.
This will reduce the size of your kernel, and so make more space available
for X.
An example of a minimum configuration is given in file
.BR /etc/conf/sdevice.4MB .
Note, however,
that this sample configuration includes only the driver for an AT hard disk;
if your system uses a SCSI disk, you must alter it appropriately.
.IP \fB4.\fR
Run the script
.BR /etc/conf/console/mkdev ,
to update all system files to the new keyboard driver
(and the new configuration of virtual terminals).
.IP \fB5.\fR
After you make the above changes, type the following commands
to create and patch a new \*(CO kernel, called
.BR /testcoh :
.DM
	cd /etc/conf
	bin/idmkcoh -o /testcoh
	/conf/patch /testcoh NBUF=100 NHASH=97
.DE
.IP \fB6.\fR
Edit file
.B /usr/X11/lib/xinit/xinitrc
to comment out the lines:
.DM
	xsetroot -bitmap /usr/X11/include/X11/bitmaps/wide_weave
	xclock -geometry 135x141+15+26 -fg blue -chime -update 1 &
.DE
Change these lines to:
.DM
	# xsetroot -bitmap /usr/X11/include/X11/bitmaps/wide_weave
	# xclock -geometry 135x141+15+26 -fg blue -chime -update 1 &
.DE
This changes the appearance of the X screen you see when you type
.BR startx .
.IP \fB7.\fR
Shut down your system and boot the new kernel
.B /testcoh
before you try to run X.
To boot the kernel, press the space bar when the boot procedure prompts you
to do so to interrupt booting; when you see the `?' prompt, type
.BR testcoh .
If you configured
.B /testcoh
correctly, as described above, \*(CO will not include support for virtual
consoles, so you may need to edit
.B /etc/ttys
accordingly if you wish to go multiuser.
However, note that running multiuser consumes memory, which means fewer
X applications will run.
.\" .IP \fB8.\fR
.\" Now that you've gotten tired of this silliness, go out and buy four more
.\" megabytes, you cheapskate, or get a copy of
.\" .BR mgr .
.SH "Installing X Windows for COHERENT"
.PP
Now that you have finished the preliminary tasks and have made sure that your
system can run X Windows for \*(CO, you can install the system onto your
machine.
.PP
Installation has three parts.
The first two are easy, but the last requires that you type in
some information.
Please read this description through carefully, so you will know what to
expect.
.PP
Before you begin installation, please note that you can abort installation
at any time by typing
.BR <ctrl-C> .
In some instances you may have to do so more than once to abort installation
altogether.
Aborting installation will not harm your \*(CO system in any way, nor will
it affect your ability to install X again at a later time.
.Sh "Invoking Installation"
.PP
To begin, log into your system as the superuser
.BR root .
.PP
If you are installing from a 3.5-inch floppy-disk drive that is drive 0
(i.e., drive A:) on your system, type the command:
.DM
	/etc/install CohX /dev/fva0 2
.DE
If you are installing from a 3.5-inch floppy-disk drive that is drive 1
(i.e., drive B:) on your system, type the command:
.DM
	/etc/install CohX /dev/fva1 2
.DE
If you are installing from a 5.25-inch floppy-disk drive that is drive 0
(i.e., drive A:) on your system, type the command:
.DM
	/etc/install CohX /dev/fha0 3
.DE
Finally, if you are installing from a 5.25-inch floppy-disk drive that is
drive 1 (i.e., drive B:) on your system, type the command:
.DM
	/etc/install CohX /dev/fha1 3
.DE
The program
.B install
will prompt you to place a disk from your installation kit into the
appropriate floppy-disk drive.
.Sh "Copying Files"
.PP
For the first step of installation,
.B install
copies the X files from their floppy disks onto your hard disk.
Most go into directory
.BR /usr/X11 .
This takes only a few minutes.
.Sh "Continue Installation?"
.PP
After it copies the X files onto your hard disk,
.B install
asks you if you wish to continue installation:
.B1
	The X Windows archives have been copied onto your system.  The next stage
	of installation consists of (1) de-archiving and de-compressing these files;
	(2) linking objects with libraries to form executable applications; and
	(3) asking you some questions about your system, and using the information
	to build the file /usr/X11/lib/Xconfig.  This process will take some time;
	how much depends entirely upon how fast your system is.  If you do not wish
	to continue installation, please reply negatively to the following question.
	This will abort installation.
.sp \n(pdu
	Do you wish to continue installation?
	Enter Y or N:
.B2
.PP
As you can see, the post-processing of the X files may take a while.
If you are busy and do not wish to continue installation at this time,
type `N'.
To resume installation at a later time, log in as the superuser
.BR root ,
and execute script
.BR /conf/CohX.post .
Installation will resume as if it had never been interrupted.
.PP
If you wish to continue the installation now, type `Y'.
.Sh "Continuing Installation"
.PP
When you choose to continue installation (and we assume that you will do so,
sooner or later), you will see the following message:
.B1
	Continuing installation.  Note that you can interrupt installation at
	any time by typing <ctrl-C>.  You may have to type it more than once.
	To resume installation, su to root and execute script /conf/CohX.post.
.B2
.PP
As this message shows, you can interrupt installation at any point just by
typing
.BR <ctrl-C> .
You may have to type it more than once.
To resume installation at a later time, simply log in as the superuser
.BR root ,
and execute script
.BR /conf/CohX.post .
.Sh "De-Archiving Binaries"
.PP
The next step in installation is to uncompress and de-archive various files.
As this happens, you will see the following messages:
.B1
	Extracting servers and pre-built binaries. Please be patient ...
	Extracting unlinked objects for clients. Please be patient ...
	Extracting documentation files ...
	Extracting X header files ...
	Extracting X libraries and configuration files ...
	Uncompressing tools ...
.B2
.PP
If your system already has a file named
.B /usr/local/bin/cpp
or one named
.BR /usr/local/bin/findmouse ,
you will see a prompt of the form:
.B1
	gunzip: /usr/local/bin/cpp already exists; overwrite?
.B2
.PP
Always type `N', which preserves the current version of
.BR findmouse .
The reason is that this prompt only appears if your \*(CO already has
a copy of
.B findmouse
built into it, and if this is the case, then that version of
.B findmouse
supercedes the version that is included with the \*(CO release of X.
So, to repeat:
type `N' to save your copy of
.BR findmouse .
.PP
If you do not have an executable file named
.B csh
in any of the directories
.BR /bin ,
.BR /usr/bin ,
or
.BR /usr/local/bin ,
you will see the following message:
.B1
	Linking /bin/sh to /bin/csh, as expected by xvt ...
.B2
.PP
As the message states, the X application
.B xvt
expects to work with a shell named
.BR /bin/csh ,
so it must be created.
If you have a real version of
.B csh
in a directory other than those named above, or under a different name,
be sure to link it to
.B /bin/csh
to override this action of
.BR install .
.Sh "Link X Clients"
.PP
X Windows for \*(CO ships most of its X clients in the form of unlinked
binaries, rather than as linked executables,
Now that the X files have been uncompressed and de-archived,
.B install
will link the X applications with the X libraries to create executable
binaries.
.PP
.B install
informs you of this action with the following message:
.B1
	We will now build the X clients. This will take some time.  You can either sit
	back and watch your drive fill up, or take a break and come back later.
.B2
.PP
As each client is linked,
.B install
displays a message on your screen to announce that fact.
As the above message states, this probably is a good time to fetch a
cup of coffee or play with your cat.
.PP
Should linking fail for whatever reason, a diagnostic message will be
printed on your screen, and
.B install
will abort with the message
.B1
	Could not make the X executables.
.B2
.PP
Linking could fail for any of a number of reasons:
Your system may have run out of disk space;
or a file on your installation kit may have been corrupted;
or the version of
.B make
on your system could not cope with linking these binaries.
You should contact Mark Williams Technical Support for advice.
.PP
If all of the applications link correctly, you see the message
.B1
	The X clients have been built.
.B2
.PP
and installation continues.
.Sh "Install the Mouse"
.PP
The next step is to install your mouse.
To begin,
.B install
displays the message:
.B1
	This release of X Windows for COHERENT only works with serial mice.  Serial
	mice come in three varieties:  (1) Logitech (Mouseman) mice, (2) Microsoft,
	or (3) MouseSystems mice.  Most mice either are built by these manufacturers,
	or adhere to their standards.
.sp \n(pDu
	Please select the number of the serial mouse you will be using:
.sp \n(pDu
		1. Logitech/Mouseman or Logitech-compatible serial mouse
		2. Microsoft or Microsoft-compatible serial mouse
		3. MouseSystems or MouseSystems-compatible serial mouse
.sp \n(pDu
	Select 1, 2, or 3:
.B2
.PP
Enter 1, 2, or 3, depending on the type of mouse you have.
If you are unsure what type of mouse you have, press `2', for Microsoft,
which is the most popular type of mouse.
If you select the wrong type, don't panic \(em you
will be able to fix this later.
.PP
If you select `2', for the Microsoft mouse,
.B install
assumes that your mouse has two buttons.
If you select `1' or `3' (for Logitech or MouseSystems),
.B install
asks you how many buttons your mouse has:
.B1
	How many buttons does your mouse have?  Enter 2 or 3:
.B2
.PP
Type `2' or `3', depending on how many buttons your mouse has.
.PP
If you selected mouse types `2' or `3' (for Microsoft or MouseSystems mice),
.B install
asks you for the baud rate of your mouse:
.B1
	What baud rate does your mouse operate at?
.sp \n(pDu
		1. 1200 baud
		2. 2400 baud
.sp \n(pDu
	If you are uncertain, select 1.  Enter selection:
.B2
.PP
Enter `1' or `2'.
As the message says, enter `1' if you are unsure which baud rate to select.
Again, if you make a mistake, don't panic \(em you can correct it later.
.PP
Finally,
.B install
helps you to confirm the port into which you plugged your mouse.
It begins by displaying the following message:
.B1
	Please enter the COM port in which your mouse is plugged - 1, 2, 3,
	or 4.  We will then open the port and ask you to wiggle your mouse.  If
	you see stuff appear on your screen when you push your mouse, then you
	have the correct port.
.sp \n(pDu
	Enter the COM port into which the mouse is plugged:  1, 2, 3, or 4:
.B2
.PP
Type the number of port into which you plugged the mouse.
.B install
then invokes the program
.B findmouse
to test whether the mouse is plugged into your port.
.PP
If
.B findmouse
cannot open the port that you requested, it prints the message:
.B1
	Cannot open this device.
.B2
.PP
This will happen if the requested does not exist, or if it is enabled.
(If the problem is due to the port's being enabled, you should abort
installation, disable the port, and resume installation.)
If this happens,
.B install
again asks you to enter the port into which you have plugged your mouse,
so you can try another port.
.PP
If
.B findmouse
can open the port you requested, it displays the message:
.B1
	If you see stuff on the screen when you move the mouse, then you have
	found the mouse port.  Type <ctrl-C> to exit.
.sp \n(pDu
	Now wiggle your mouse:
.B2
.PP
Wiggle the mouse.
If you have requested the correct port, you will see a stream of messages
of the form:
.B1
	Reading /dev/\fIport\fP - type <ctrl-C> to exit: \fINN\fP
.B2
.PP
.I port
is the port being examined,
and where
.I NN
is a two-character code returned by the mouse.
When you are satisfied that you have (or have not)
identified the port into which the mouse is plugged, press
.B <ctrl-C>
to stop
.BR findmouse .
.PP
.B install
then asks you:
.B1
	Did you see screen output when you wiggled your mouse?
	Enter Y or N:
.B2
.PP
If you did not see anything when you wiggled the mouse, press `N';
.B install
again asks you to select a port.
However, if you did see output when you wigged the mouse, press `Y'.
.B install
then displays the messages
.B1
	Linking /dev/mouse to \fIport\fP
	Mouse serial port set to \fIport\fP.
.B2
.PP
where
.I port
is the COM port you selected.
.PP
The selection of the port concludes the configuration of the mouse.
.Sh "Define the Video Interface"
.PP
The next step in installation is to define the video interface.
.B install
begins this phase with the message:
.B1
	We will now install the video interface.
.sp \n(pDu
	We will now invoke the color X server to determine which chipset is used by
	your video card.  Your screen may clear and then return to normal video mode.
	When it does, it will display information about your video board.
	Type <Enter> to continue:
.B2
.PP
Press \*(RT.
The screen will clear briefly, as
.B install
interrogates the video card to find what variety of chip set it uses, and
how much video RAM it has.
If it recognizes the chip set,
.B install
prints a message of the form:
.B1
	Chipset: \fIname of chip set\fP
.B2
.PP
If it does not recognize the chip set,
.B install
prints the message:
.B1
	Chipset: Unknown chipset
.B2
.PP
If
.B install
recognizes the amount of video RAM on your card, it displays either
of the messages:
.B1
	Video RAM: 512k
	Video RAM: 1024k
.B2
.PP
depending upon how much video RAM your card has.
If it does not recognize the video RAM on your system, you will see no message.
.PP
If
.B install
recognizes the chip set on your video card,
.B install
configures X to use the color server, and displays the following message:
.B1
	Your chip set is recognized.  Using COLOR X server.
.B2
.PP
If it does not recognize the chip set on your video card,
.B install
configures X to use the monochrome server, and displays the following message:
.B1
	Your chip set is not recognized.  Using MONO X server.  If this is incorrect,
	see the release notes for directions on how to invoke the color server.
.B2
.PP
As the message states, if this is wrong, you can correct it.
Instructions on how to do so appear below.
.PP
The next step in video configuration is to select the video mode for your
board and monitor.
The
.I mode
is the the size of the display, in pixels.
The larger the mode, the more stuff your screen can display \(em but the
smaller (and coarser) that stuff will be.
.PP
.B install
asks you for your monitor's mode, as follows:
.B1
	Of the following video modes, which does your monitor AND video board support?
.sp \n(pDu
		1. 640x480 only
		2. 640x480 and 800x600
		3. 640x480 and 800x600 and 1024x768 (interlaced)
		4. 640x480 and 800x600 and 1024x768 (non-interlaced)
.sp \n(pDu
	Note that to select 1024x768, your video card must have at least one megabyte
	of RAM.  If you are unsure, select 2.  Please enter your selection:
.B2
.PP
Select the appropriate mode for your system.
As the message states, if you're not sure, select `2'.
.PP
This concludes the configuration of video.
.Sh "Install Manual Pages"
.PP
At this point,
.B install
writes the file
.BR /usr/X11/lib/Xconfig ,
and displays the following message:
.B1
	A generic /usr/X11/lib/Xconfig file has been created.  In most cases, this
	generic configuration will get you up and running.  For details on how to
	modify this file, see the manual that comes with this product.
.B2
.PP
Finally,
.B install
checks whether you have enough space on your disk to install the X manual
pages.
It begins by displaying the message:
.B1
	Finally, we will install the manual pages.
.sp \n(pDu
	The online COHERENT X manual pages in /usr/man are shipped in compressed form.
	The compressed manual pages use about 300 blocks (150 kilobytes) of disk space.
	The uncompressed manual pages use about 1,100 blocks (550 kilobytes).
.B2
.PP
If you do not have enough disk space,
.B install
displays the message
.B1
	Your system has insufficient free space on the root filesystem to store
	the uncompressed manual pages.  You may uncompress and un-tar the manual
	pages at a later date if you free up at least 1022 blocks on your root
	file system.
.B2
.PP
and aborts installation.
.PP
If you do have enough space,
.B install
displays the message:
.B1
	You can:
		1. Remove the manual pages,
		2. Leave the manual pages compressed, or
		3. Uncompress the manual pages.
.sp \n(pDu
	The "man" command will work only if you uncompress the manual pages (option 3).
	Please choose an option:
.B2
.PP
Select the option you want.
.Sh "Set a COHERENT File"
.PP
At this point,
.B install
has concluded its work, and exits.
However, one task remains before installation is complete.
.PP
The last step of installation is to edit the \*(CO system file
.BR /etc/profile .
The \*(CO shell reads
.B /etc/profile
when a user logs in, and sets some default environmental variables.
First, change the entry
.DM
	export PATH=:/bin:/usr/bin
.DE
to read:
.DM
	export PATH=:/bin:/usr/bin:/usr/X11/bin
.DE
This change will let a user find X executables regardless of what her
current directory is.
Second, add the entries:
.DM
	export DISPLAY=unix:0.0
	export IMAKECPP=/usr/local/bin/cpp
.DE
These set the environmental variable
.BR DISPLAY ,
which is read by many X programs, to point to your system;
and set the C preprocessor used by the command
.B imake
to the GNU version of
.BR cpp ,
which is installed as part of this package.
.PP
With this change, installation is complete.
.Sh "Try X"
.PP
Now that X is installed, try out your newly installed X system.
Just type the command
.BR startx .
In most instances, X will come up correctly \(em you will see a clock
on your screen, a terminal window, and cursor darts around the screen
as you shift the mouse.
.PP
.II "resolution^change"
.II "screen^change resolution"
.II "video mode^change"
If you specified more than one video mode, you can jump between modes by typing
.B <ctrl><alt>+
or
.BR <ctrl><alt>- .
You should try all modes;
it is possible for X to work well in one mode but appear ``messed up'' in
another.
.PP
If all is well, turn to the next chapter in this manual, which introduces
the X system and how to work with it.
.PP
If, however, you have encountered some problems \(em if the X system does
not ``appear correct'' \(em the rest of this chapter gives information for
troubleshooting your X system.
.SH "Troubleshooting X"
.PP
.II X^troubleshoot
.II Xconfig
In most cases, X will come up without difficulty.
Should a problem arise, however, the following should help you diagnose
and solve it.
.Sh "X Does Not Come Up"
.PP
With some problems, the X server will not come up at all:
after you type
.BR startx ,
the X server prints some messages on the screen and then exits
without doing anything.
If this happens, type the following command:
.DM
	nohup startx &
.DE
.PP
This invokes X and saves all of its output \(em including error
messages \(em into file
.BR nohup.out .
Read this file to see what the problem is.
Usually you will see a message of the form:
.DM
	Cannot open device /dev/mouse
.DE
.PP
This means that a file or a device is missing.
In most cases, the message is self-explanatory and easily solved.
.Sh "Switching the Server"
.PP
In some cases, you will have specified using the color server when you
should not have.
Either the color server does not work properly with your chip set, or you
have an incompatible monitor, or you have only four megabytes of RAM.
The following describes how to switch from one server to the other.
.PP
.II X386color
.II X386mono
X Windows for \*(CO comes with two versions of the X server:
.B X386color
and
.BR X386mono .
As their names imply, the former server is for color systems, and the latter
for monochrome.
To select a server, you must link the default server
.B X
to the server you want.
To link a server, become the superuser
.B root
and
.B cd
to directory
.BR /usr/X11/bin .
To use the monochrome server, type the command:
.DM
	ln -f X386mono X
.DE
To use the color server, type the command:
.DM
	ln -f X386color X
.DE
That's all there is to it.
.Sh "Configuring the Mouse"
.PP
Sometimes problems can arise with the mouse.
With some users, X comes up but dies as soon as the user moves the mouse.
This probably is due to having the mouse described incorrectly.
Some mice, if incorrectly described, output all sorts of codes when
moved \(em including
.BR <ctrl><alt><backspace> ,
which shuts down X.
Or, the mouse cursor jumps
across the screen when you first touch the mouse, then stay there.
The solution is to try different types of mice and different baud rates
in the server.
.PP
Usually, you can fix the situation by editing file
.BR /usr/X11/lib/Xconfig .
This file holds information about the hardware on your system, including
the mouse.
The X server reads it as it comes it, so that it can configure itself
appropriately.
To edit this file, become the superuser
.B root
and the invoke your favorite editor to edit
.BR /usr/X11/lib/Xconfig .
(Before you begin to modify this file, be sure to save a backup copy,
in case you make a mistake.)
.PP
If you told
.B install
that you had a
.B Logitech
(Mouseman)
mouse, then you will see:
.DM
.ta 0.5i 2.0i
	#Mouse configuration
	logitech "/dev/mouse"
.DE
If you said that you had Microsoft mouse you will see:
.DM
.ta 0.5i 2.0i
	#Mouse configuration
	microsoft "/dev/mouse"
	BaudRate 1200
	SampleRate 150
.DE
And if you said you have a Mouse Systems mouse, you will see:
.DM
.ta 0.5i 2.0i
	#Mouse configuration
	mousesystems "/dev/mouse"
	BaudRate 1200
	SampleRate 150
.DE
Lines that begin with a pound sign `#' are comments;
.B X
ignores them.
.PP
As you can see, the entries for Microsoft and Mouse Systems mice specify
the baud rate and sample rate, whereas the one for the Logitech (Mouseman)
device does not.
.PP
The commonest problem with a mouse is that X thinks you have one kind of
mouse, when in fact you have another.
This would happen if you selected the wrong type of mouse when you installed
X onto your system.
For example, you may have purchased a ``bargain-basement'' mouse whose
documentation does not state clearly what variety of mouse it is emulating;
and you had to guess what variety of mouse to use.
.PP
To solve this problem, comment out the line that names the type of mouse,
and enter another.
If you are switching from mouse of type
.B logitech
to one of types
.B microsoft
or
.BR mousesystems ,
remember to enter the lines for baud rate and sample rate, exactly as shown
above.
.PP
To change the device into which you plugged the mouse,
use the command
.B ln
to link the appropriate device to the device
.BR /dev/mouse .
For example, if you shift your mouse from COM1 to COM3,
use the command:
.DM
	ln -f /dev/com3pl /dev/mouse
.DE
As you can see from this example,
you must always use the
.I polled
and
.I local
versions of the serial port.
For details, see the Lexicon entries for
.B asy
and
.BR ln .
.PP
Another problem is that your mouse has only two buttons, but the emulation
of the third button doesn't seem to work correctly.
If you have only two buttons on your mouse, the description for your
mouse should contain the instruction:
.DM
	emulate3buttons
.DE
This tells the X server that pressing both buttons on a two-button mouse
is equivalent to pressing
the center button on a three-button mouse.
If your mouse has only two buttons and this instruction does not appear in
mouse section of
.BR Xconfig ,
you should add it.
.PP
If problems persist despite trying all three varieties of mouse, it may be
that the baud rate is incorrect.
Insert the instruction
.DM
	BaudRate 2400
.DE
immediately after the line that names your mouse.
If your
.B Xconfig
file already contains a
.B BaudRate
instruction, place a `#' in front of it; this comments it out; and
then insert the new
.B BaudRate
instruction.
Then again try all three varieties of mouse, until you find one that works.
.Sh "Problems With the Color Server"
.PP
The trickiest problems involve configuring the color X server.
If you are using the color server and the screen appears ``messed up'' or
out of focus, this probably is due to the X server's being misinformed about
your hardware.
You can solve this problem by editing
.BR Xconfig .
The following gives the applicable portion of that file:
.DM
.ta 0.5i 2.0i
vga256
  Virtual 800 600
  ViewPort 0 0
  Clocks 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 
  Modes "640x480" "800x600"
.DE
.DM
ModeDB
#           clock    horizontal timing      vertical timing
 "640x480"    4     640  672  768  800    480  490  492  525
             25     640  672  768  800    480  490  492  525
             28     640  672  768  800    480  490  492  525
.DE
.DM
 "800x600"    7     800  808  944 1056    600  608  610  633
              7     800  904 1064 1168    600  603  609  630
             33     800  808  944 1056    600  608  610  633
             36     800  824  896 1024    600  601  603  625
             39     800  864  896 1008    600  600  606  624
             40     800  840  968 1056    600  601  605  628
             50     800  856  976 1040    600  637  643  666
.DE
.DM
 "920x690"   62     920  952 1088 1168    690  688  718  724
.DE
.DM
 "1024x768i"  4    1024 1096 1100 1280    768  775  795  829  Interlace
             39    1024 1072 1200 1240    768  766  782  786  Interlace
.DE
.DM             
 "1024x768"   7    1024 1072 1200 1240    768  766  782  786
             62    1024 1096 1272 1328    768  776  778  808
             62    1024 1072 1176 1272    768  778  779  804
             62    1024 1072 1200 1240    768  766  782  786
.DE
The following describes these in detail:
.IP \fBvga256\fR
Name the display, in this case a 256-color VGA card.
.IP \fBVirtual\fR
.II "screen^virtual"
.II "virtual screen"
The size of the virtual screen, in raster lines; in this case, the screen
800 rasters wide by 600 high.
The installation program set the size of the virtual window the largest
mode your screen allows:
either 800\(mu600, or 1024\(mu768.
.II "screen^physical"
.II "physical screen"
Note that in some modes (described below), the ``physical screen'' (that is,
the image that is displayed on your tube at any given moment)
can be smaller than the virtual screen.
In this case, the physical screen acts as a kind of window onto the virtual
screen; menus and windows that fit onto the virtual screen may not fit onto
the physical screen.
By moving the mouse cursor, you can shift the physical screen to display a
different portion of the virtual screen.
.IP
If you have only four megabytes of RAM, you may wish to use the 800 by 600
setting, even if you have a full megabyte of video RAM.
This will save memory, and help your system run more efficiently.
.IP \fBViewPort\fR
.II "virtual screen"
The X and Y coordinates of the upper-left corner of the physical screen.
In this case, the physical screen is fixed in the upper-left corner of the
virtual screen.
As noted above, you can change the positioning of the physical screen upon
to the virtual screen simply by shifting the mouse cursor.
.IP \fBClocks\fR
A video card has a bank of either eight or 16 clocks.
These govern the video timing, and will be discussed below.
.IP \fBModes\fR
These give the modes of the display \(em that is, the size of the physical
screen \(em in raster lines.
This version of
.B Xconfig
includes default settings for five modes:
640\(mu480, 800\(mu600, 920\(mu690, and 1024\(mu768,
and 1024\(mu768i (interlaced).
You can use more than one mode, if you wish; the X server lets you
jump dynamically from one mode to another.
The rules for selecting a mode or modes are given below.
.IP \fBModeDB\fR
This is a data base of video timings for your card's clock timings and mode.
Most of the job of adjusting video timing involves modifying these settings.
.PP
Configuring your system requires that you select or modify these settings.
.PP
The first step in correcting video problems is to make sure that
.B X
is finding the correct chip set and video RAM on your video card.
To see what chip set the X server thinks your system is running, read file
.BR /usr/X11/lib/color_results .
.B install
created this file when you asked it to determine what chip set is on your
video card.
This file will contain something like this:
.DM
	chipset	et4000 (mem: 1024K numclocks 8)
	Clocks	25 28 33 39 22 24 33 39
.DE
Usually the X server is correct, but not always.
If the chip set shown in that file does not match the set described in your
video card's documentation,
you can override the server's guess by inserting a
.B chip set
instruction into
.BR Xconfig .
The following gives the chip sets that the color X server supports:
.DS
.ta 0.5i 1.75i
	\fBati\fR	ATI 18800 or ATI 28800
	\fBgvga\fR	Genoa GVGA
	\fBtvga9000\fR	Trident TVGA 9000
	\fBet3000\fR	Tseng Labs ET3000
	\fBet4000\fR	Tseng Labs ET4000
	\fBpvga1\fR	Paradise VGA Professional,
	\fBtvga8900c\fR	Trident TVGA 8900c
		Western Digital WD90C00,
		Western Digital WD90C10, or
		Western Digital WD90C11
.DE
Note that to use the Trident chip sets with the color X server,
a card must have at least one megabyte of video RAM.
.PP
If color server incorrectly identified your video board's chip set, you can
instruct the color server to use the chip set you specify.
Just insert the line
.DM
	chipset "\fIcode\^\fP"
.DE
into
.BR Xconfig ,
just below the line
.BR vga256 .
.I code
is the code for the chip set, as given above in boldface.
Note that
.I code
is surrounded by quotation marks \(em these are important!
.PP
For example, if the X server thinks that your video card's chip uses the
.B ET4000
chip set, as in the above example by the line
.DM
	chipset	et4000 (mem: 1024K numclocks 8)
.DE
but your video card actually uses the ET3000 chip set (as indicates by
the documentation that came with your system), then insert the instruction
.DM
	chipset "et3000"
.DE
into
.BR Xconfig ,
just below the line
.BR vga256 .
.PP
If your video card's chip set is not one of the ones shown above,
you must use monochrome driver.
.PP
The next step is to make sure that the X server thinks you have enough
video RAM.
The phrase
.B "mem: 1024K"
in
.B color_results
gives the amount of video RAM the X server thinks you have.
If this is incorrect, you can override the server's guess by using the
instruction
.BR videoRAM .
For example, if the server thinks you have 512 kilobytes of video RAM and
you really have a megabyte, insert the instruction
.DM
	videoRAM 1024
.DE
below the line
.BR vga256 .
Note the spelling of ``videoRAM'':
this is important!
.PP
In all probability, however, the problem resides in the
.B ModeDB
area.
This is a data base of video timings.
The server will use one set of timings for a clock speed that your
video card recognizes and a mode that you have requested.
The X server selects a set of video timings from this data base by
first finding the mode that you have requested, then reading the timing
available by clock speed, going from last setting to first.
.PP
For example,
.B ModeDB
contains the following video settings for 800\(mu600 mode:
.DM
 "800x600"    7     800  808  944 1056    600  608  610  633
              7     800  904 1064 1168    600  603  609  630
             33     800  808  944 1056    600  608  610  633
             36     800  824  896 1024    600  601  603  625
             39     800  864  896 1008    600  600  606  624
             40     800  840  968 1056    600  601  605  628
             50     800  856  976 1040    600  637  643  666
.DE
If you requested 800\(mu600, then the X server will read the entries
until it finds one that matches a clock speed on your system, beginning
from 50 megahertz and working back up toward seven megahertz.
.PP
Note that not every set of video timings will work on your equipment,
even if a clock speed matches one on your video card.
It may be that the X server has selected a set of timings that do not
work with your particular combination of video card and monitor.
One step you can take to correct this situation is to comment out
some sets of video timings, so that the X server cannot use them.
.PP
To do this, the first step is to find what clock speeds the server thinks
your video card is using.
Again check the file
.BR color_results .
The line that begins
.B Clocks
gives the clock speeds.
Usually, there are eight or 16 of them; for example:
.DM
	Clocks	25 28 33 39 22 24 33 39
.DE
In this set, there are actually only five unique clock speeds:
22, 25, 28, 33, and 39 megahertz.
.PP
Now, if you look back to the
.B ModeDB
settings for mode 800\(mu600,
you'll see that there are two sets of possible video timings:
one for 39 megahertz, and the other for 33.
The X server would have picked 39 by default, because that's the first
set it would have encountered that matched a clock speed on your card.
.PP
If the screen appeared ``messed up,'' try commenting out the entry for
39 megahertz:
.DM
 "800x600"    7     800  808  944 1056    600  608  610  633
              7     800  904 1064 1168    600  603  609  630
             33     800  808  944 1056    600  608  610  633
             36     800  824  896 1024    600  601  603  625
#            39     800  864  896 1008    600  600  606  624
             40     800  840  968 1056    600  601  605  628
             50     800  856  976 1040    600  637  643  666
.DE
That will force the server to use the entry for 33 megahertz (the next
lower clock speed used by your card).
This
.I may
work correctly.
You may have to try several sets of timings before you find one that works.
.PP
For some combinations of clock speed and mode,
.B ModeDB
has several sets of video timings.
If one set of video timings does not appear to work, try another.
Remember, the entries are read from the bottom up, so comment out the
lower entry first.
Make sure that the clock speed you are using matches one of
those in the
.B Clocks
variable listed in
.BR color_result .
.Sh "Inserting New Timings"
.PP
The
.B Xconfig
file included with X Windows for \*(CO simply may not contain a set of
timings that work with your combination of monitor and video card,
at the mode that you have requested.
.PP
.II "Wexelblat, David"
.II modes.db
David Wexelblat has compiled a data base of timings for a great variety of
monitors and card.
This data base is included in file
.BR /usr/X11/doc/modes.db .
Check this file and see if it contains a set of timings for your combination
of monitor and card.
If it does, patch the timings into
.B Xconfig
and see if they work.
.PP
.II video.timings
If all else fails, you may need to ``diddle'' with the video timings by hand.
For information on what video-timing settings mean, read the file
.BR /usr/X11/doc/video.timings .
Before you begin your ``diddling,'' however, please note that radically
changing video timings can damage some varieties of monitor.
Read the information on video timings
.I carefully
before you begin to modify anything!
.PP
If worse comes to worst and you cannot configure the color server correctly,
you can use the monochrome server.
This works as well as the color server, although it is quite not as pretty.
The monochrome server should run without requiring configuration on your part.
.SH "Where To Go From Here"
.PP
The next chapter introduces you to the
.B twm
window manager.
The chapter after that introduces the utilities and clients included
with X Windows for \*(CO.
If X is new to you, you probably find these helpful.
If you are experienced, turn to the Lexicon, look up your favorite application,
and go to it!

.NH "The Lexicon" 1
.PP
.II Lexicon^introduction
The rest of this manual consists of the Lexicon.
The Lexicon consists of more than 1,000 articles, each of which
describes a function or command, defines a term, or otherwise
gives you useful information.
The articles appear in alphabetical order.
.PP
Internally, the Lexicon has a \fItree structure\fR.
The \*(QLroot\*(QR entry is the one for
.BR Lexicon .
It, in turn, introduces (or ``branches to'')
three ``overview'':
.BR "Running COHERENT" ,
.BR "Administering COHERENT" ,
and
.BR "Programming COHERENT" .
Each overview article points to a group of related entries.
For example, the article
.B "Programming COHERENT"
points to the articles on the \*(CO C compiler and to articles that introduce
the library functions, macros, and header files included with \*(CO.
.PP
Each Lexicon entry cross-references other entries.
These cross-references point up the documentation tree,
to its overview article and, ultimately, to the entry for
.BR COHERENT ;
down the tree to subordinate entries; and across to
entries on related subjects.
For example, the entry for \fBgetchar()\fR cross-references \fBSTDIO\fR,
which is its overview article, plus \fBputchar()\fR and \fBgetc()\fR,
which are related entries of interest to the user.
The Lexicon is designed so that you can trace from any one entry to
any other, simply by following the chain of cross-references
up and down the documentation tree.
.PP
For more information on how to use the Lexicon and how it is organized,
see the Lexicon entry for
.BR COHERENT .

.NH "Xware 2: Games"
.PP
Congratulations on purchasing Xware 2, which is a package of X Games for \*(CO.
.PP
This package also holds the library
.BR libXpm.a ,
whose functions manipulate pix-mapped images;
a revised version of the \*(CO command
.BR make ;
some revised X header files;
and a manual page for every game.
.SH "What Is Xware?"
Xware is a series of packages from Mark Williams Company
that bundle some of the most popular and useful software
for the X Window System.
Each program in a Xware package comes with an executable binary;
source code;
instructions and scripts to help you recompile and install the program;
and a manual page for the program edited and formatted in the \*(CO
Lexicon format, which you can view with the \*(CO command
.BR man .
.PP
Other Xware packages are available or are being prepared.
These include packages of X window managers, graphics programs,
tools and utilities, and development tools.
Xware makes it easy and convenient for you
to enlarge your supply of X software.
.SH "System Resources"
.PP
The games in this package require eight megabytes of RAM.
.PP
When you install this package, it takes up about three megabytes.
You should assume that de-archiving and installing a game will
consume one-half to three-quarters of a megabyte.
The total amount of disk space consumed depends upon how many games you
install, and whether you leave the source archives on your system or
delete them.
Directions on how to install a game are given below.
.PP
The size of the screen required varies from game to game.
A few run on a 640\(mu480 desktop; most use 800\(mu600;
a few use 1024\(mu768.
Those that use the 1024\(mu768 desktop can, in most instances,
be run under 800\(mu600; however, you will have to shift its
window around to see all of the game's actions.
.PP
Most games recompile correctly with the \*(CO C compiler.
A few must be recompiled with the GCC compiler.
Each archive contains a file named
.BR README.Coh ,
which describes how to install the game and how to recompile it.
.SH "Contents of This Package"
.PP
The individual games are kept in the form of compressed archives;
when you install this package onto your system, all of the archives are
copied into directory
.BR /usr/X11/games .
The following describes each game included in this package:
.IP "\fBcbzone\fR"
Drive a tank around a desert battlefield.
Battle enemy tanks, supertanks, helicopters, cruise missiles, and
landers.
This game features striking animation.
It uses a 1024\(mu768 window, but you can run it on an 800\(mu600 screen.
.IP "\fBroids\fR"
This is an implementation of the arcade game ``Asteroids'':
You guide a spaceship through an asteroid field and blow up rocks.
.IP "\fBspider\fR"
This implements a sophisticated game of two-deck solitaire.
It uses a 1024\(mu768 window.
You can play it on an 800\(mu600 screen, but you will have to shift the
window from time to time to see where all the cards lie.
.IP "\fBsvb\fR"
Spy vs. Bob:
Guide your spy through a skyscraper, as he is pursued by the
evil, pipe-smoking Bobs.
.IP "\fBtetris\fR"
Yet another implementation of ``Tetris''.
This game features attractive graphics.
.IP "\fBxchomp\fR"
This implements a version of the arcade game ``PacMan'', but with
some twists \(em including a number of different mazes.
.IP "\fBxconq\fR"
Fight to dominate the world!
At the beginning of the game, you control a nation; as you guide your
nation's development, it encounters one or more other nations that are
controlled by the computer.
Each nation tries to dominate all of the others, through trade, alliances,
and warfare.
The game continues until one nation rules all.
The topography and technology can be imaginary, or modelled after a
historical setting.
.IP "\fBxhextris\fR"
Yet another implementation of ``Tetris,'' except that the shapes are
built out of hexagons instead of squares.
As a result, there are more shapes, and they are more difficult to fit
together.
Not for the timid!
.IP "\fBxlander\fR"
Your space ship is in orbit around the Moon.
You must guide it to a safe landing before it crashes or runs out of fuel.
.IP "\fBxlife\fR"
This implements Conway's game of Life under X.
Also included is a library of shapes and screens that you can patch together,
just to make Life interesting!
.IP "\fBxmahjongg\fR"
This game implements the solitaire version of the Chinese game Mah-Jongg.
It uses a 1024\(mu768 window; but
you can play it on an 800\(mu600 screen if you shift the window from time
to time to see where all the tiles lie.
.IP "\fBxminesweep\fR"
This is an X implementation of the board game ``minesweeper''.
You must deduce where the mines are hidden on an otherwise blank game board.
Guess wrong, and the mine goes off!
.IP "\fBxpipeman\fR"
The water levels are rising; and you must fit together randomly
selected sections of pipe to keep it from hitting the floor.
.IP "\fBlibXpm.a.z\fR"
This archive holds the sources for the library
.BR Xpm ,
which holds X pixmap (XPM) functions.
This archive
also contains the command
.BR sxpm ,
which demonstrates how to use and display an XPM.
.IP
Note that when you install this package onto your system,
the compiled archive
.B libXpm.a
is automatically copied into directory
.BR /usr/X11/lib .
.IP "\fBxrobots\fR"
This is an X implementation of the game ``Daleks,'' seen on the Atari ST
and other machines.
You are pursued by evil robots; and your only chance is to trick them
into crashing into each other.
.SH "Installing This Package"
.PP
To install this package onto your system, log in as the superuser
.B root
and type the installation command:
either
.DM
	/etc/install Xware2 /dev/fva0 3
.DE
if you have a 3.5-inch floppy-disk drive, or
.DM
	/etc/install Xware2 /dev/fha0 3
.DE
if your floppy-disk drive is 5.25 inches.
.B install
copies the programs into directory
.BR /usr/X11/games ,
installs the few extra tools you need to recompile these programs,
and automatically installs the manual pages for the programs.
.SH "Installing an Individual Program"
.PP
As described above, each program is kept in a compressed archive in directory
.BR /usr/X11/games .
Each archive contains a compiled version of the program, ready for running;
the sources for the program;
a file called
.BR README.Coh ,
which describes how to recompile the program, should you wish;
and a script named
.BR Install.Coh ,
which installs the program for you.
To install a program so you can play it, do the following:
.IP \(bu 0.3i
.B cd
to directory
.BR /usr/X11/games .
.IP \(bu
Use the command
.B gtar
to de-archive and uncompress the archive that holds the program you want.
For example, if you want to install program
.BR cbzone ,
type the command:
.DM
	gtar -xvzf cbzone.gtz
.DE
.IP \(bu
Change to the directory that holds the newly de-archived game.
For example, when you un-tar archive
.BR cbzone.gtz ,
the game and its source files are copied into directory
.BR cbzone .
.IP \(bu
Use the command
.B su
to become the superuser
.BR root ,
and execute script
.BR Install.Coh .
Each game has such a script, and it handles all the details of
installation for you.
.IP \(bu
After you have installed the game, you may wish to remove the source
code and other files that you do not need.
To do so,
.B cd
back to the game's parent directory, and use the command
.B "rm \-rf"
to remove the directory and its contents.
For example, after you have installed
.BR cbzone ,
you can remove this directory by typing the following commands:
.DM
	cd ..
	rm -rf cbzone
.DE
Note that the archive from which you copied the game,
.BR cbzone.gtz ,
is untouched by removing the directory
.BR cbzone .
You can always de-archive the game again should you wish to work with
its game files or re-install it.
.PP
If you wish to recompile a game, follow the directions given in file
.B README.Coh
in that game's source directory.
.SH "Copyrights"
.PP
Please note that the software in this package comes from third-party sources.
It is offered ``as is'', with no guarantee or warranty stated or implied,
whatsoever.
The copyrights on the source code and any executables built from it
belong to the persons who wrote the original code; full copyright
statements are included with the source code to each game.
Please read and respect these statements.
.SH "Technical Support"
.PP
The sources in this package have been compiled and run successfully under
\*(CO.
If you have a problem bringing up one of the games or with
compiling the source code as it is configured in this package, our
technical support team will attempt to help you.
However, because of the highly technical nature of the source
code in these packages, Mark Williams Company
.I cannot
give you technical assistance should you modify any of the source code
included in this package in any manner whatsoever.
.SH "A Final Word"
.PP
All of the source code for these games, and for all programs shipped in our
Xware packages, is available for free on the Mark Williams bulletin board
system, and on other publicly accessible archives.
The tutorial for
.B UUCP
in the \*(CO manual describes how to contact the BBS and make its services
available to you.

.tm +0Index	\n%
.nf

.ce
\fBIndex\f(RS

.ce
\fB# to _\f(RS



.ce
\fBA\f(RS

address
    0	24
    255	24
    Ethernet notation	25
address resolution protocol	25
Advanced Research Projects Agency	4
applications protocols	15
ARP
    definition	25
    protocol	27
ARPA	4
ARPAnet	4
Assigned Numbers	15
assigned numbers	26
attach	48

.ce
\fBB\f(RS

broadcasting	24
Buswell, Joe	1
Butzen, Fred	1

.ce
\fBC\f(RS

cake, layer	8
catenet model	9
Catnet modem	27
cd	50
Central University of Mars	25
Chalmers, Robert	1, 39, 72
client
    definition	6
client/server model
    definition	6
close	50
cohulip
    installation	29
commands
    attach	48
    cd	50
    close	50
    dir	50
    domain	50
    echo	51
    eol	51
    escape	51
    etherstat	51
    exit	51
    finger	52
    ftp	52
    help	55
    hostname	55
    ip	54
    kick	55
    log	55
    ping	56
    pwd	56
    record	56
    reset	56
    route	56
    session	57
    shell	57
    smtp	58
    start	58
    stop	59
    tcp	59
    telnet	60
    trace	60
    udp	61
    upload	61
CSNET	5

.ce
\fBD\f(RS

DARPA	4
datagram
    definition	9
    negotiation	25
    reassembly	27
    runt	77
DDN
    definition	5
DDN Network Information Center	27
DDN Protocol Handbook	27
default gateway	23
default routes	23
Defense Advanced Research Projects Agency	4
Defense Data Network	5
demultiplexing
    definition	10
dialing script	37
dir	50
domain
    command	50
    definition	22
domain-name server	4
domains
    protocol	26

.ce
\fBE\f(RS

echo	51
EGP	27
eol	51
escape	51
Ethernet
    address notation	25
    addresses	13
    checksum	13
    headers	13
    RFCs	15
    type code	13
etherstat	51
exit	51

.ce
\fBF\f(RS

file server	6
file transfer protocol	5
finger	52
fragmentation	25
ftp	52
    abort	53, 77
    cd	53
    cwd	53
FTP
    definition	5
ftp
    dele	53
    dir	53
    get	53
    hash	53, 77
    list	53
    ls	53
    mkdir	54
    pass	54
FTP
    protocol	26
ftp
    put	54
    pwd	54
    quit	54
    rmdir	54
    type	54
    user	54

.ce
\fBG\f(RS

Garbee, Bdale	1
gateway
    definition	22

.ce
\fBH\f(RS

Hedrick, Charles L.	1, 3
help	55
hostname	55

.ce
\fBI\f(RS

ICMP	23, 19, 54
    protocol	27
IEN 116	7, 19
IEN-116	27
IEN-48	27
Initial Round Trip Time	59
International Standards Organization	8
Internet	5
    protocol suite	5
Internet address
    definition	9
Internet Control Message Protocol	54
Internet control message protocol	19
ip
    address	54
IP
    addresses	13
    checksum	13
    definition	9
    protocol	27
    protocol for implementation	26
    protocol number	13
    RFC	15
ip
    status	54
IP
    time to live	12
    time-to-live	44
ip
    ttl	55
IP address	29
IRTT	59
ISO	8

.ce
\fBK\f(RS

Karns, Phil	1
keyboard
    cooked mode	47
    raw mode	47
kick	55, 78

.ce
\fBL\f(RS

layer cake	8
log	55
log stop	55

.ce
\fBM\f(RS

mail	6
    protocol	27
mail server	17
Martians	25
Massachusetts Institute of Technology	7
Maximum Segment Size	59
MIT	7
MS-DOS
    accessing via Ethernet	72
    accessing via SLIP	72
MSS	59

.ce
\fBN\f(RS

name server	4, 6, 21
name-server protocol	7
National Science Foundation	5
net ASCII	17
net.hlp	45
NetBIOS	5
    definition	6
netBIOS
    protocol	26
Netware	72
network
    class A	24
    class B	24
    class C	24
network file system	5
network terminal protocol	5
networking
    ARPAnet model	8
    catenet model	9
    OSI model	8
NeWS	7
NFS	5
    definition	6
NSF	5
NSFnet
    protocol	26

.ce
\fBO\f(RS

octet	9
Open Systems Interconnect model	8
OSI	8

.ce
\fBP\f(RS

packet
    definition	9
ping	56
POP2
    protocol	26
ports	10
    well known	15
Postel, Jon	26
Project Athena	7
protocol
    address resolution	25
    file transfer	5
    Internet control message	19
    name server	7
    network terminal	5
    official list	26
    remote lineprinter	6
    routing	23
    simple mail transfer	6
    TELNET	51
    user datagram	19
protocols
    applications	15
pwd	56

.ce
\fBR\f(RS

RcvQ	65
reassembly	25
receive queue	65
record	56
remote execution	6
remote lineprinter protocol	6
remote procedure calls	6
reset	56
rexec	6
RFC
    791	15
    listing	26
RFC  793	27
RFC 1001	6, 26
RFC 1002	6, 26
RFC 1009	23, 26
RFC 1010	26
RFC 1011	7, 26
RFC 1012	26
RFC 768	27
RFC 791	26-27
RFC 792	19, 23, 27
RFC 793	15, 26
RFC 813	27
RFC 814	18, 27
RFC 815	27
RFC 816	27
RFC 817	27
RFC 821	6, 17-18, 26-27
RFC 822	6-7, 17-18, 26-27
RFC 823	7
RFC 825	26
RFC 826	15, 27
RFC 827	27
RFC 854	5, 18, 27
RFC 855	5, 18, 27
RFC 879	27
RFC 882	9, 19, 22, 27
RFC 883	19, 22, 27
RFC 888	27
RFC 894	15, 26
RFC 896	27
RFC 904	27
RFC 937	26
RFC 950	24, 26
RFC 959	5, 18, 26, 52
RFC 973	22, 26-27
RFC 974	17, 22
RFC 975	27
RFC 985	27
rfc-index	26
rip.doc	27
route	56
    add	56
    drop	56
routing	76
    default gateway	23
    default routes	23
    definition	22
    protocol	23
routing table	44
rsh	6

.ce
\fBS\f(RS

script
    dialing	37
send queue	65
server
    definition	6, 44
session	57
shell	57
simple mail transfer protocol	6, 17
SLIP END	14
smoothed round-trip time	76
smtp	58
SMTP
    definition	6, 17
smtp
    gateway	58
    kick	58
    maxclients	58
    mode	58
    timer	58
    trace	58
SndQ	65
SRTT	76
standard terminal	17
start	58
stop	59
subnets
    definition	26

.ce
\fBT\f(RS

TCB	59, 77, 56
TCP
    acknowledgement number	11
    checksum	10
    definition	9
tcp
    irtt	59
    kick	59, 78
    mss	59
TCP
    port numbers	10
    protocol	27
tcp
    reset	59
TCP
    RFC	15
tcp
    rtt	59
TCP
    sequence number	10
tcp
    status	59, 77
    timertype	60
TCP
    urgent field	11
tcp
    window	60
TCP
    window field	11
TCP Control Block	56, 59
TCP control block	77
TCP/IP
    headers	10
TCP/IP stack	8
Telenet	5
telnet	60
TELNET
    definition	5
    protocol	27, 51
telunix	58
terminal server	7
time to live	12, 44
timeout value	76
trace	60

.ce
\fBU\f(RS

U.S. Department of Defense	4
udp	61
UDP
    definition	19
    protocol	27
upload	61
user datagram protocol	19
UUCP	27

.ce
\fBW\f(RS

well-known ports	27
window size	76
WinQvtnet	72
WinSoc	72
WinTrumpet	72
Wright, Randy	1, 37, 63, 69, 74, 76

.ce
\fBX\f(RS

X Window System	7

.ce
\fBY\f(RS

Yanoff, Scott	67
Yellow Pages	7
.fi

.ds VN 1
.sp 3.5i
.ll 5.75i
.po 1i
.vs 9
.ft RS
Copyright \(co 1994 by Mark Williams Company.
.sp
All rights reserved.
.sp
This publication conveys information that is the property of Mark
Williams Company.
It shall not be copied, reproduced or duplicated
in whole or in part without the express written permission of Mark
Williams Company.
Mark Williams Company makes no warranty of any kind
with respect to this material and disclaims any implied warranties of
merchantability or fitness for any particular purpose.
.sp
The information contained herein is subject to change without notice.
.sp
COHERENT\(tm is a trademark of Mark Williams Company.
UNIX\(tm is a trademark of Unix Systems Laboratories.
MS-DOS\(tm is a trademark of Microsoft Corporation.
PostScript\(tm is a trademark of Adobe Systems Incorporated.
All other products are trademarks or registered
trademarks of the respective holders.
.sp
.ta 1.0i 2.25i 3.75i
	Revision \*(VN		Printing 5 4 3 2 1
.sp
Published by Mark Williams Company, 60 Revere Drive, Northbrook,
Illinois  60062.
.sp
.nf
.ta 0.5i 1.5i
Sales:	Phone:	(800) 636-6700
	FAX:	(708) 291-6750
	E-mail:	uunet!mwc!sales
		sales@mwc.com
Technical Support:
	Phone:	(708) 291-6700
	FAX:	(708) 291-6750
	E-mail:	uunet!mwc!support
		support@mwc.com
.sp
.fi
This manual was written under the COHERENT operating system, using the
MicroEMACS text editor.
Text formatting was performed by the
COHERENT edition of the \fBtroff\f(RS text formatter, generating PostScript.
Page design was implemented with custom-written macros written in the
\fBtroff\f(RS text-formatting language and in PostScript.
Camera-ready copy was printed on a Hewlett-Packard LaserJet IIP printer
using the Pacific Page PostScript cartridge.
.sp
Printed in the U.S.A.
.bp

/v/doc/coherent/lx/fabs
/v/doc/coherent/lx/factor
/v/doc/coherent/lx/false
/v/doc/coherent/lx/fc
/v/doc/coherent/lx/fcedit
/v/doc/coherent/lx/fclose
/v/doc/coherent/lx/fcntl
/v/doc/coherent/lx/fcntl.h
/v/doc/coherent/lx/fcvt
/v/doc/coherent/lx/fd
/v/doc/coherent/lx/fd.h
/v/doc/coherent/lx/fdformat
/v/doc/coherent/lx/fdioctl.h
/v/doc/coherent/lx/fdisk
/v/doc/coherent/lx/fdisk.h
/v/doc/coherent/lx/fdopen
/v/doc/coherent/lx/feof
/v/doc/coherent/lx/ferror
/v/doc/coherent/lx/fetch
/v/doc/coherent/lx/fflush
/v/doc/coherent/lx/ffs
/v/doc/coherent/lx/fgetc
/v/doc/coherent/lx/fgetpos
/v/doc/coherent/lx/fgets
/v/doc/coherent/lx/fgetw
/v/doc/coherent/lx/field
/v/doc/coherent/lx/file
/v/doc/coherent/lx/file.c
/v/doc/coherent/lx/file.d
/v/doc/coherent/lx/file_desc
/v/doc/coherent/lx/fileno
/v/doc/coherent/lx/filsys.h
/v/doc/coherent/lx/filter
/v/doc/coherent/lx/find
/v/doc/coherent/lx/findmouse
/v/doc/coherent/lx/firstkey
/v/doc/coherent/lx/fixterm
/v/doc/coherent/lx/float
/v/doc/coherent/lx/float.h
/v/doc/coherent/lx/floor
/v/doc/coherent/lx/floppy_di
/v/doc/coherent/lx/fmap
/v/doc/coherent/lx/fmod
/v/doc/coherent/lx/fmt
/v/doc/coherent/lx/fnkey
/v/doc/coherent/lx/fnmatch
/v/doc/coherent/lx/fnmatch.h
/v/doc/coherent/lx/fopen
/v/doc/coherent/lx/for.c
/v/doc/coherent/lx/for.k
/v/doc/coherent/lx/fork
/v/doc/coherent/lx/fortune
/v/doc/coherent/lx/forward
/v/doc/coherent/lx/fpathconf
/v/doc/coherent/lx/fperr.h
/v/doc/coherent/lx/fprintf
/v/doc/coherent/lx/fputc
/v/doc/coherent/lx/fputs
/v/doc/coherent/lx/fputw
/v/doc/coherent/lx/fread
/v/doc/coherent/lx/free
/v/doc/coherent/lx/freemem
/v/doc/coherent/lx/freopen
/v/doc/coherent/lx/frexp
/v/doc/coherent/lx/from
/v/doc/coherent/lx/fscanf
/v/doc/coherent/lx/fsck
/v/doc/coherent/lx/fseek
/v/doc/coherent/lx/fsetpos
/v/doc/coherent/lx/fstat
/v/doc/coherent/lx/fstatfs
/v/doc/coherent/lx/ft
/v/doc/coherent/lx/ftbad
/v/doc/coherent/lx/ftell
/v/doc/coherent/lx/ftime
/v/doc/coherent/lx/ftok
/v/doc/coherent/lx/function
/v/doc/coherent/lx/fwrite
/v/doc/coherent/lx/fwtable

.ds TL "Running Networking"
.ds TI COHULIP
.NH "Running net"
.PP
The command
.B net
is the part of
.B cohulip
that actually performs the networking tasks.
.B net
executes all networking tasks that a true networking package would
implement as separate executable commands.
.PP
You should read this chapter carefully to see what options are available for
.BR net ,
and how to invoke its features.
You can also use this chapter as a reference while you are using
.BR net .
.PP
Please note that commands for
.B net
are case sensitive:
for example, command
.B ftp
works, but commands
.B Ftp
or
.B FTP
do not.
.SH "Starting Up"
.PP
The command
.B net
has the following syntax:
.DS
	\fBnet [ \fIstartup.file \fB]\fR
.DE
.I startup.file
holds a set of commands that initialize
.BR net .
As you will see, these commands are simply ordinary instruction to
.BR net ,
just as you could type interactively into
.BR net .
The rest of this chapter will show you what these commands mean, and how
you can modify them to suit the networking environment in which you are
working.
.PP
If you are going to use
.B cohulip
to perform a variety of networking tasks,
you may wish to have more than one startup file.
For example, you may need one startup file to SLIP into the Internet
via an Internet provider, and another to access a local network via Ethernet.
For details on how to modify your a startup file, see the chapter on installing
.BR cohulip .
.PP
If you do not name a
.I startup.file
on
.BR net 's
command line, it reads the file
.BR $NETHOME/startup.net .
If you do not name a
.I startup.file
on
.BR net 's
command line and
.B net
cannot find
.BR $NETHOME/startup.net ,
then you must give
.B net
its initialization commands by hand.
.SH "Modes of Operation"
.PP
.B net
works in either of two modes:
command mode and converse mode.
.PP
In
.I command
mode,
.B net
displays the prompt
.BR net> ,
and you can type any of the commands described below.
In
.I converse
mode, keyboard input is processed according to the
.IR "current session" ,
which may be either a TELNET or FTP session:
.IP \(bu 0.3i
In a TELNET session, keyboard input is sent to the remote system and
any output from the remote system is displayed on the console.
.IP \(bu
In an FTP session,
.B net
displays the prompt
.BR ftp> .
.B net
examines keyboard input to see if it is an FTP command.
if it is, then
.B net
executes it as such; if not, it passes it directly to the remote remote
host's FTP server.
For a list of FTP commands, see the description of the command
.BR ftp ,
below.
.PP
While you are conversing with a remote host via FTP or TELNET,
you can type a ``hot key'' to escape back into
.BR net 's
command mode.
After you have pressed the hot key,
.B net
displays the prompt
.BR net> .
You can then issue one or more commands to
.BR net .
To resume conversing with the remote host, type
.BR <return> .
You can use this to mechanism to close an interactive session,
or perform other useful tasks; these are described below.
By default,
.B net
sets the hot key to
.B <ctrl-]>
(0x1D).
.PP
The keyboard also has ``cooked'' and ``raw'' states.
.II "keyboard^cooked mode"
In cooked state,
.B net
processes input one line at a time.
Pressing
.B <return>
passes the complete line up to the application.
.II "keyboard^raw mode"
In raw mode,
.B net
passes each character to the application as you type it.
.PP
While the keyboard is in cooked mode,
you can use the following editing commands as you are typing input:
.IP \fB<ctrl-A>\fR 1.0i
Move one word to the left.
.IP \fB<backspace>\fR
Delete the previous character.
.IP \fB<ctrl-D>\fR
Move one character to the right.
.IP \fB<ctrl-E>\fR
Throw away the current line and redisplay the previous line.
.IP \fB<ctrl-F>\fR
Move one word to the right.
.IP \fB<ctrl-H>\fR
Delete the previous character.
.IP \fB<ctrl-R>\fR
Redisplay the current line.
.IP \fB<ctrl-S>\fR
Move one character to the left.
.IP \fB<ctrl-U>\fR
Delete the current line.
.IP \fB<ctrl-V>\fR
Do not interpret the following character.
Use this to pass an editing command through to the remote site.
.IP \fB<ctrl-W>\fR
Delete the previous word.
.IP \fB<ctrl-Y>\fR
Delete the current line.
.PP
.B net
is in the cooked state either when
.B net
is in command mode or when you are conversing with a remote host via FTP.
When you are conversing with a remote host via a TELNET session,
the keyboard's state depends upon whether the remote end has issued
(and the local end has accepted) the TELNET protocol's option
.BR "WILL ECHO" .
For details, see the description of the
.B net
command
.BR echo ,
below.
.SH "Host Names"
.PP
Many of the commands described below use the symbol
.I <hostid>
to represent a remote host or gateway.
You can specify the
.I <hostid>
either as a domain name (e.g., ``raven.alaska.edu''),
or as a numeric IP address written in dotted decimal notation and
enclosed by brackets (e.g., \fB[44.0.0.1]\fR).
.PP
You can use domain names in either of two ways.
The first way is to write the name and IP address of the domain into file
.BR $NETHOME/hosts.net .
(The format of this file is described in the previous chapter.)
The other way is to interrogate a remote domain-name server.
The command
.B domain
lets you set the IP address of a domain-name server that you have permission
to interrogate.
For details, see the command
.BR domain ,
described below.
.SH "Syntax of Commands"
.PP
The following describes each of the commands that
.B net
recognizes.
Square brackets enclose optional arguments.
The character `|' denotes an either-or selection.
Commands are case sensitive, and are all in lower case.
.Sh "<return> \(em Send a Command"
.PP
Return to converse mode with the current TELNET or FTP session.
If there is no current session,
.B net
remains in command mode.
.Sh "? \(em Print a Help Message"
.PP
Help:
print a list of all commands recognized.
.Sh "! \(em Send a Command to the Shell"
.PP
The command
.DS
	\fB! \fIcommand\fR
.DE
sends
.I command
to your \*(CO shell for execution.
If you give the command
.B !
without a
.IR command ,
.B net
invokes the shell.
.Sh "# \(em Ignore a Command"
.PP
Ignore the command that follows.
You can use this to write a comment into a
.I startup
file.
.\" .Sh "arp \(em Manipulate the ARP Table"
.\" .PP
.\" .II "commands^arp"
.\" .II "arp"
.\" .II ARP^definition
.\" .II "Address Resolution Protocol table"
.\" This command lets you manipulate the
.\" Address Resolution Protocol (ARP) table,
.\" which maps IP addresses to their subnet (link) addresses
.\" on subnetworks capable of broadcasting.
.\" This command takes the following form:
.\" .IP \fBarp\fR
.\" When invoked without an argument,
.\" .B arp
.\" displays the contents of the ARP.
.\" For each IP address entry, it displays the subnet type (e.g., Ethernet),
.\" subnet address, and time to expiration.
.\" If the link address is unknown,
.\" .B arp
.\" also shows the number of IP datagrams awaiting resolution.
.\" .IP "\fBarp add \fIhostid \fBether\fR"
.\" Add the entry for
.\" .I hostid
.\" into the ARP table.
.\" This is useful for ``hard-wiring'' digipeater paths,
.\" and for other paths that are not directly resolvable.
.\" Optional digipeater calls are added to the end of this line.
.\" .IP "\fBarp drop \fIhostid\fB ether\fR"
.\" Remove the entry for
.\" .I hostid
.\" from the ARP table.
.\" .IP "\fBarp publish \fIhostid\fB ether\fR"
.\" Respond to an ARP query for some other host.
.\" This is commonly referred to as
.\" .BR "proxy arp" ,
.\" and is considered a fairly dangerous tool.
.\" This way, the rest of the world does not know the second machine
.\" isn't really on the air.
.\" Use this command with caution.
.Sh "attach \(em Attach net To a Network"
.PP
.II "commands^attach"
.II attach
Command
.B attach
configures and attaches a hardware interface to your system.
It has the following syntax:
.DS
	\fBattach \fIhwtype IO_address device mode label bufsize mtu \fB[ \fIspeed \fB] \fB[ \fIscript \fB]\fR
.DE
The following details the arguments to this command:
.IP \fIhwtype\fR
the kind of I/O device that is being attached, as follows:
.RS
.IP \fBasy\fR 0.3i
An asynchronous (serial) port.
.IS \fBnx\fR
An Ethernet card, using the device driver
.B ne
to access an NEC NE2000 Ethernet board, or a clone thereof.
.RE
.IP \fIIO_address\fR
The base address of the control registers for the device.
Under
.BR cohulip ,
this is always zero.
.IP \fIdevice\fR
Name the device by which you are accessing the network.
If
.I hwtype
is
.BR asy ,
then this names the serial port you are using, e.g.,
.BR /dev/com3fr .
If
.I hwtype
is
.BR nx ,
then set this to zero.
.IP \fImode\fR
Set how IP datagrams are encapsulated.
It can be either of the following:
.RS
.IP \fBslip\fR
Enclose IP datagrams within SLIP frames, without a link header.
Use this option if
.I hwtype
is set to
.BR asy .
.IP \fBarpa\fR
Use the ARP to map an IP address to an Ethernet address.
Use this option if
.I hwtype
is set to
.BR nx .
.RE
.IP \fIlabel\fR
The name by which the interface will be known to the various commands,
such as
.BR connect ,
.BR route ,
and
.BR trace .
When you installed
.BR cohulip ,
this was set to
.B sl0
for a serial connection, or to
.B ne0
for an Ethernet connection.
.IP \fIbufsize\fR
This argument is ignored.
.IP \fImtu\fR
The size of the maximum transmission unit, in bytes.
If a datagram exceeds this limit,
.B cohulip
fragments it at the IP level.
.IP \fIspeed\fR
The speed of the serial port through which the network
is being accessed.
If the type of connection is Ethernet, this argument is ignored and is
not required.
.IP \fIscript\fR
A dialing script, through which
.B cohulip
can dial into a remote site.
You should use this option if you are using SLIP to access a remote system
via modem.
.PP
A
.I script
has the following format:
.DS
	\fB[ \- ] \fIsendstring expectstring \fB[ \fIsendstring expectstring ... \fB]\fR
.DE
If the first entry in the script is `\-',
.B cohulip
displays the send/expect strings on the screen as executes the script.
.I sendstring
and
.I expectstring
come in pairs, with the exception of the the last
.IR sendstring :
once the remote site goes into SLIP mode, no more strings are forthcoming, and
.B cohulip
waits silently for recognizable SLIP packets or a hangup.
.PP
.I sendstring
can include the following escape sequences:
.DS
	\fB\e\e\fR	Literal `\e'
	\fB\eE\fR	End of file
	\fB\eN\fR	NUL
	\fB\eb\fR	Backspace
	\fB\en\fR	Newline
	\fB\er\fR	Carriage return
	\fB\es\fR	Space character
	\fB\et\fR	Horizontal tab
.DE
You should end each
.I sendstring
with a `\er', to flush the string to the output device.
.PP
The send-expect function has a 30-second timeout.
Unlike a \*(UU chat script, a
.B cohulip
script does not support alternate-send phrases in the event of timeout.
The following gives an example
.IR script :
.DM
	ATE1V1Q0S0=0\er OK ATDP1234567\er ogin: mylogin\er ord: mypassword\er
.DE
The first pair, 
.DM
	ATE1V1Q0S0=0\er OK
.DE
sends an initialization string to the modem and
awaits the reply ``OK'' from the modem.
.PP
The second pair,
.DM
	ATDP1234567\er ogin:
.DE
dials the modem and awaits the login prompt from the remote system.
(The string ``1234567'' stands for the remote system's telephone number,
whatever it might happen to be.)
.PP
The third pair,
.BR "mylogin\er ord:" ,
sends the your login identifier and awaits the password prompt
from the remote system.
(Note that ``mylogin'' stands for your login identifier, whatever it
might happen to be.)
.PP
Finally,
.B net
sends the password string \(em in this example,
.BR mypassword\er .
.PP
Note that
.BR attach 's
scripting mechanism gives you only limited control over the port or modem.
If you are dialing out through a modem that is plugged into an enabled port,
you must disable the port by hand before you invoke
.BR net .
Also note that
.B net
has no mechanism for sending commands to the modem after a SLIP session has
concluded;
therefore, you must re-initialize the modem by hand after you
have finished working with the remote system.
Hints on how to write a script to do this appear below.
.PP
Finally, note that you can use a script to access a remote system only
if you have a permanently assigned IP number,
assigned either by an Internet authority or by your Internet provider.
Some providers assign IP addresses ``on the fly;'' in this case, you must
use a different method of dialing into the remote system.
For details, see the previous chapter, on configuring
.BR cohulip .
.Sh "cd \(em Change Directory\fR"
.PP
.II "commands^cd"
.II cd
This command changes the directory you are accessing on your local machine.
If you are running an FTP or TELNET session,
it does not change the directory that you are accessing on the remote host.
It works exactly the same as the
.B cd
command as described in the \*(CO Lexicon.
.Sh "close \(em Close a Session On Your End"
.PP
.II "commands^close"
.II "close"
Close an FTP or TELNET session.
This is an alternative to asking the remote
server to initiate a close (i.e., sending the command
.B quit
via FTP, or the command
.B logout
via TELNET.
When either FTP or TELNET sees the incoming half of a TCP connection close,
it automatically responds by closing the outgoing half of the connection.
.PP
.B close
recognizes the syntax
.DS
	\fBclose [ \fItype \fB[ \fIsession \fB] ]\fR
.DE
where
.I type
is the type of session to close (either TELNET or FTP), and
.I session
is the number of the session to close.
If you are running more than one
.I type
of session and do not specify which
.I session
to close,
.B net
closes the one that you opened most recently.
.PP
.B close
is more graceful than the command
.BR reset ,
in that it is less likely
to leave the remote TCP in a ``half-open'' state.
Note, however, that if you use
.BR net 's
.B close
command instead of closing from within a session, it be a few minutes before
the fact that your TCP session has closed percolates through the net to
your remote host and it closes the connection on its end;
so wait a few minutes before you attempt to log again into the remote host.
.Sh "dir \(em List Contents of Directory on Remote Host"
.PP
.II "commands^dir"
.II dir
The command
.B dir
resembles the command of the same name under \*(MD.
It displays on your screen the contents of a directory on the remote host;
the information displayed includes
the name of each file, its size, and the date and time it was last modified.
.PP
.B cd
recognizes the following syntax:
.DS
	\fBdir [ \fIdirectory \fB] [/w]
.DE
If no argument is given,
.B cd
displays the contents of directory you are accessing on the remote host.
The switch
.B /w
tells it to display only the name, grouped into five columns.
.PP
The command
.B ftp
also implements a version of the
.B dir
command.
It is described below.
.Sh "domain \(em Manipulate Information About Domains"
.PP
.II "commands^domain"
.II domain^command"
The command
.B domain
lets you manipulate information about domains.
Information about domains is kept in file
.BR $NETHOME/domains.txt .
For a discussion of the contents of this file, see the previous chapter
in this manual.
.PP
.B domain
takes the following forms:
.IP "\fBdomain addserver \fIip_address\fR"
Identify the site at
.I ip_address
as a domain-name server that you have permission to interrogate.
Hereafter, if
.B net
cannot find a domain in
.BR $NETHOME/domains.txt ,
it interrogates the system with
.IR ip_address .
When the domain-name server returns information about a domain,
.B net
records it in
.BR $NETHOME/domains.txt ,
to spare the trouble having to interrogate the domain-name server
repeated about the same domain.
.IP "\fBdomain dropserver \fIip_address\fR"
Drop the system at
.I ip_address
from your list of domain-name servers.
.IP "\fBdomain suffix .\fIabc\fR"
Set to \fB.\fIabc\fR the suffix used by default with a partial domain name.
For example, the command
.DM
	domain suffix .edu
.DE
sets the default suffix to
.BR .edu .
Hereafter, if you enter a partial domain name (e.g., \fBraven\fR or
\fBlepanto\fR) that
.B net
does not recognize, it will interrogate the domain-name server for that
name plus \fB.edu\fR (e.g., (\fBraven.edu\fR or \fBlepanto.edu\fR).
.IP "\fBdomain trace on|off\fR"
Turn domain-name tracing on or off.
If domain-name tracing is turned on,
.B net
displays information about its interactions with the domain-name server.
.Sh "echo \(em Change Response to telnet Echo Request"
.PP
.II "protocol^TELNET"
.II "TELNET^protocol"
.II "commands^echo"
.II echo
The TELNET protocol specifies that in the absence of a negotiated agreement
to the contrary, neither end echoes data received from the other.
In this mode, a client TELNET session echoes keyboard input locally
and performs other line-discipline tasks, but sends nothing until you type
.BR <return> .
.PP
When communicating from keyboard to keyboard,
.B net
uses the standard local-echo mode, so setting the echo parameter has no effect.
However, \*(CO sends a TELNET
.B "WILL ECHO"
instruction immediately upon receiving a request to connect from an incoming
TELNET session.
The command
.B echo
lets you set whether
.B net
accepts a request to echo.
It takes one argument:
either
.B accept
or
.BR refuse .
.B "echo accept"
tells
.B net
to return the instruction
.B "DO ECHO"
in response to a
.B "WILL ECHO"
request, and begin to echo; whereas
.B "echo refuse"
tells
.B net
to return
.B "DONT ECHO"
and refuse to echo.
.B refuse
is the normal setting, because echoing every character sent via
.B telnet
consumes a great deal of network resources.
Typing
.B echo
without an argument toggles the response.
.PP
Do not confuse the command
.B echo
with the server
.BR echo .
The latter responds to
.B ping
requests from remote hosts.
.Sh "eol \(em Display or Modify End-of-Line Behavior"
.PP
.II "commands^eol"
.II eol
The command
.B eol
manipulates the TELNET end-of-line behavior when the command
.B telnet
is in remote-echo mode.
It can take one argument:
either
.B unix
or
.BR standard .
.PP
In
.B standard
mode, each key is sent as\-is.
In
.B unix
mode,
.B net
translates carriage returns into line feeds.
This command is not necessary with all \*(UN systems;
use it only when you find that a given system
responds to line feeds but not to carriage returns.
.PP
When you installed
.BR cohulip ,
the command
.B "eol unix"
was written by default into file
.BR startup.net .
.PP
If you type
.B eol
without an argument, it displays the current end-of-line mode.
.Sh "escape \(em Display or Change the Escape Character"
.PP
.II "commands^escape"
.II escape
The command
.B escape
displays or changes the ``escape character'' \(em that is, the character
with which you can escape from conversation mode into command mode.
If you type
.B escape
without an argument, it displays the current escape character.
.PP
If you type it with a one-character argument,
.B net
makes that character the escape character.
It would not be a good idea to make a printable character the escape
character, lest you need to type that character while you are working.
If you type a control character, that character may not be echoed onto
the screen, but
.B escape
recognizes it anyway.
.PP
By default,
.B net
sets its escape character to \fB<ctrl-]>\fR (0x1D).
.Sh "etherstat \(em Display Ethernet Statistics"
.PP
.II "commands^etherstat"
.II etherstat
The command
.B etherstat
displays statistics for your NE2000 Ethernet controller,
if it is configured to keep statistics.
.Sh "exit \(em Exit From net\fR"
.PP
.II "commands^exit"
.II exit
The command
.B exit
exits you from
.B net
and returns you to the program from which you invoked it
(either the shell or a shell script).
It attempt to close all open sessions before it shuts itself down.
.Sh "finger \(em Display Information About Users"
.PP
.II "commands^finger"
.II finger
The command
.B finger
displays information about ``known users'' on a system.
To become a ``known user,'' a file named
.IB userid .txt
must reside in directory
.BR $NETHOME/finger .
For example, for user
.B fred
to become a known user, a file named
.B fred.txt
must be inserted into directory
.BR $NETHOME.finger .
The user can describe himself in this file;
the description can be serious or whimsical, as he desires.
.PP
.B finger
also recognizes the file
.BR $NETHOME/finger/all.txt .
This file usually is used to hold information about the entire system,
its users, and subordinate system; although it can, in fact,
hold anything you want.
.PP
The command
.B finger
lets you display a finger-file for a recognized user.
It takes the following forms:
.IP "\fBfinger \fIuser\fR\fR
Display information about
.IR user ,
who is a recognized user on your system.
.IP "\fBfinger @\fIhost\fR"
Display the name of each recongnized user on system
.IR host ,
which can be a remote host or your local host.
.IP "\fBfinger \fIuser\^\fB@\fIhost\fR"
Display the contents of the finger-file for
.I user
who is on system
.IR host .
.PP
Using host station \fBfarhost\fR as an example, typing the command
.DM
	finger @myhost
.DE
displays something like:
.DM
	Known users at myhost:
		alice
		joe
		all
.DE
Then typing the command
.DM
	finger all@myhost
.DE
retrieves the contents of file
.B all.txt
from the remote host's finger directory and displays it on the screen.
.PP
You can use
.B finger
to examine your own system, if you wish, to see if the connection is
working correctly.
.Sh "ftp \(em File Transfer Protocol"
.PP
.II "commands^ftp"
.II ftp
.II "RFC 959"
The command
.B ftp
implements the Internet's file-transfer protocol (FTP; RFC 959).
With it, you can log into a remote system and perform file transfers.
(The scope of what you can do and where you can work depends upon what
permissions the remote system grants you.)
.PP
When you use the command
.B ftp
to access a remote system,
.B net
established two channels to that remote host, both of which run
over one physical device.
One channel transfers data between the two hosts \(em usually
files, directory listings, or messages and prompts.
The other channel sends commands from your local host to the remote host,
and receives the remote host's reply.
Thus, you can send commands to the remote host even while the remote host
is transferring a file to your system \(em although
the variety of commands that you can send varies depending upon what the
remote host is doing at any given moment.
The commands and replies that can be sent over the command channel are
precisely defined by FTP's RFC; a number of these commands will be described
in the following paragraphs.
.PP
The
.B net
command's version of
.B ftp
implements many (though by no means all) of the commands found in a
full implementation of
.BR ftp .
Note, too, that because
.B ftp
is a sub-command of
.BR net ,
instead of as a process in its own right, you must escape from
.B ftp
back into
.BR net 's
command mode to perform some tasks; in particular, you must do so to
close an FTP session.
.PP
To open an FTP control channel to a remote host, type:
.DS
	\fBftp \fIremote.host\fR
.DE
.B net
opens the channel to the remote host.
Usually, you will see a banner, then a prompt for login and password.
Many sites permit user
.B anonymous
to log in; for information, check a published description of the site.
(For information on how to set up your machine so that others users can
log in via
.BR ftp ,
see the next chapter in this manual, which describes how to administer
.BR cohulip .)
.PP
After you have logged into the remote site,
.B net
displays the prompt
.BR ftp> ;
this indicates that you are in ``conversation mode'' with
.BR ftp .
When you type something,
.B net
checks whether it is one of the following
.B ftp
commands; if it is,
.B net
executes it; otherwise,
.B net
passes it intact to the remote site.
.B net
displays the remote server's response directly on your the screen.
Note that while
.B net
is transferring data via
.BR ftp ,
the only
.B ftp
command you can execute is
.BR abort ,
which aborts the file transfer.
.PP
If you fail to log into the remote site, or if something else goes wrong,
press the escape key to return to
.BR net 's
command mode, and from there type the command
.B close
to close the
.B ftp
session.
Then you can try again.
.PP
The following lists the commands that you can enter at the
.B ftp>
prompt:
.IP "\fBabort\fR"
.II "ftp^abort"
Aborts a transfer of data before it concludes.
The transfer of data can be initiated by the commands
.BR get ,
.BR put ,
or
.BR dir .
If invoked while
.B net
is receiving a file,
.B abort
simply resets the data connection;
the next incoming data packet generates the message TCP RST (reset)
in response, which clears the remote server.
If invoked while
.B net
is sending a file,
.B abort
sends a premature EOF (end of file) message.
In either case,
.B abort
leaves a partial copy of the file on the destination machine,
which must be removed by hand.
.IP "\fBbell\fR"
Tell
.B net
to ring your terminal's bell when it finishes transferring a file.
.IP "\fBcd \fIdirectory\fR"
.II "ftp^cd"
Change to
.I directory
on the remote host.
You must have permission to change to the target directory.
.IP "\fBcwd [ \fIdirectory \fB]\fR
.II "ftp^cwd"
This command changes the working directory \(em that is,
the directory you are using on the remote host.
It resembles the command
.BR cd ,
except that if you do not give it an argument it displays the name of the
current working directory.
.IP "\fBdele \fIfile\fR"
.II "ftp^dele"
Delete
.I file
from the host machine.
You can use this command only if the remote host has granted you ``destroy''
permission.
.IP "\fBdir [\fIremote_file \fB[ \fIlocal_file \fB] ]\fR"
.II "ftp^dir"
.B net
sets the command
.B LIST
on the control channel, to print the contents of the current working directory.
If you invoke
.B dir
with one argument, it prints information about
.BR file ,
which resides on the remote host.
Note that
.I file
can be a directory as well as an ordinary file; and that it can be either
a full path name or a relative path name.
If you invoke
.B dir
with two arguments,
.B dir
assumes that the second argument names a file on your local host,
and writes its output into that file.
.IP
You can use other options with
.BR dir ,
but which options are available vary from one remote host to another.
Many \*(UN-based hosts will let you a regular expression to
form the name of
.IR remotefile ;
for example, the command
.DM
	dir [A-M]*.gif
.DE
displays every file whose name that begins with the letters `A' through `M'
and ends with the string ``.gif''.
Likewise, many \*(UN-based remote hosts recognize the option
.BR \-t ,
which prints the files in the order in which they were last modified, from
youngest to oldest.
For details on the options that are potentially available to you, see the
entry for
.B ls
in the \*(CO Lexicon.
.IP "\fBget \fIremote_file \fB[ \fIlocal_file \fB]\fR"
.II "ftp^get"
.B net
sends the commands
.B PORT
and
.B RETR
on the control channel, to copy
.I remote_file
from the remote host into
.I local_file
on your local host.
If you do not name a
.IR local_file ,
.B net
copies
.I remote_file
into a file of the same name on your local system.
.IP \fBhash\fR
.II "ftp^hash"
Toggle hashing.
When hashing is on,
.B ftp
displays the ``hash'' character `#' for every one kilobyte of data it
processes during a file transfer.
By watching the hash marks appear on your screen, you can get a rough
idea of how well (or how poorly) the file transfer is proceeding.
If the file transfer appears to be hung, you can use the command
.B abort
to abort the file transfer, and try again some other time.
.IP \fBlist\fR
.II "ftp^list"
This is a synonym for the command
.BR dir .
.IP "\fBls \fIremote_file \fB[ \fIlocal file \fB]\fR"
.II "ftp^ls"
.B net
sends the command
.B NLST
over the control channel to print, in abbreviated form, the contents of
the current working directory on the remote host.
If you name a
.IR local_file ,
.B ls
writes its data into that file on your local host instead of to your screen.
Only the names of the files are shown, just as with the \*(CO command
.BR ls .
.IP "\fBmkdir \fIdirectory\fR"
.II "ftp^mkdir"
Create
.I directory
on the remote host.
The remote host must have granted you ``create'' permission before
you can use this command.
.IP "\fBpass \fIpassword\fR"
.II "ftp^pass"
.B net
automatically invokes this command while you are logging into the remote
system:
it requests you for your password, then passes what you type
to the remote host.
.IP
If you wish to change your identity after you have logged into a remote
host, first invoke the command
.BR user ,
then
.BR pass .
.IP "\fBput \fIlocal_file \fB[ \fIremote_file \fB]\fR"
.II "ftp^put"
.B net
sends the commands
.B PORT
and
.B STOR
over the control channel to copy
.I local_file
from your local into into
.I remote_file
on the remote host.
If you do not name a
.IR remote_file ,
.B net
writes
.I local_file
into an identically named file on the remote host.
The remote host must have granted you ``write'' permission before you can
use the command.
.IP \fBpwd\fR
.II "ftp^pwd"
Print working directory \(em that is, print the name of the directory
within which you are working on the remote host.
.IP \fBquit\fR
.II "ftp^quit"
Close the current
.B FTP
session.
.B net
notifies the remote host that you are quitting, so the connection is
closed gracefully.
This is equivalent to the command
.B bye
under most implementation of
.BR ftp .
.IP "\fBrmdir \fIdirectory\fR"
.II "ftp^rmdir"
Remove
.I directory
from the remote host.
Before you can use this command, the remote host must have granted you
``destroy'' permission, and
.I directory
must be empty.
.IP "\fBtype [a|i|l\fIbytesize\^\fB]\fR"
.II "ftp^type"
Send the command
.B TYPE
on the control channel to tell remote server the type of file to be transferred.
The following types are recognized:
.RS
.IP \fBa\fR 0.3i
ASCII mode:
the file consists of printable characters,
with the end of a line marked by a CR/LF sequence.
.IP \fBi\fR
Image mode:
send the file exactly as it appears on the remote host.
Set this mode before you download any binary data, e.g., executable
programs, object modules, images, or archives of compressed material.
.IP \fBl\fIbytesize\fR
The same as image mode, except that
.B net
notifies the remote system that the word length is
.I bytesize
(typically, eight).
Use this to download files from systems with an unusual word size
(e.g., DECSYSTEM-10s and 20s).
.RE
.IP "\fBuser \fIusername\fR"
.II "ftp^user"
This command prompts you for your user identifier, and passes it to the
remote host.
This command is invoked automatically when you are first logging into
the remote host.
.IP
You can also invoke
.B user
after you have logged in, to change you identity on the remote host.
If you do so, you must follow it with the command
.B pass
(described above).
.Sh "ip \(em Manipulate the IP Handler"
.II "commands^ip"
.PP
The following commands let you manipulate the IP handler \(em that is,
the portion of
.B net
that processes the Internet Protocol:
.IP "\fBip address [ \fImyaddress \fB]\fR"
.II "ip^address"
Set your local IP address to
.IR myaddress .
If invoked without an address, this command displays your
local host's IP address.
.IP "\fBip status [ \fIclear \fB]\fR"
.II "ip^status"
This command displays information about your local host's IP status.
The first line of output displays some SLIP information (should you be
using SLIP).
The second line displays IP statistics,
such as total packet counts and error counters of various types.
.IP
.II ICMP^definition
.II "Internet Control Message Protocol"
.B "ip status"
also displays statistics about the Internet Control Message Protocol (ICMP),
including the number of ICMP messages of each
type sent or received.
.IP "\fBip ttl [ \fIvalue \fB]\fR"
.II "ip^ttl"
Set the time-to-live of outgoing IP datagrams to
.I value
data hops.
Every time a remote system handles a datagram, it decrements that datagram's
time-to-live value; a datagram ``dies'' when its time-to-live reaches zero.
Should a datagram's address be unresolvable, the time-to-live mechanism
prevents it from circulating endlessly through the network.
If you set
.I value
to too low a value, a datagram will not live long enough to reach its
destination; if you set it too high, you could be wasting network resources.
.IP
If you invoke this command without a
.IR value ,
it displays the current value of the time-to-live parameter.
.Sh "help \(em Display a help file"
.II "commands^help"
.II help
.PP
The command
.B help
displays the contents of a help file.
It has the following syntax:
.DS
	help [ \fIsubject \fB]\fR
.DE
.B help
displays the contents of file \fB$NETHOME/\fIsubject\fB.hlp\fR,
which presumably contains information to help you with
.IR subject .
The file is displayed through a pager; to quit, type the escape character
.BR <ctrl-]> .
.PP
If you do not specify
.IR subject ,
.B help
displays the contents of file
.BR $NETHOME/net.hlp .
.B cohulip
comes with help files for some, but not all, of its commands.
You can prepare other help files if you wish.
.Sh "hostname \(em Set the Local Host's Name"
.II "commands^hostname"
.II "hostname"
.PP
.B net
uses a name to identify your local host to remote systems, when it uses
FTP or SMTP to exchange files with a remote system.
The command
.B hostname
lets you set the name of your local host.
.PP
.B hostname
recognizes the following syntax:
.DS
	\fBhostname [ \fIname \fB]\fR
.DE
.B hostname
sets the name of your local host to
.IR name .
Note that
.I name
must be a text string, not an IP address.
.PP
If invoked without an argument,
.B hostname
displays your local host's name.
.PP
You should set your local host's name to its \*(UU name,
which is recorded in file
.BR /etc/uucpname ,
although you are not required to do so.
.Sh "kick \(em Kick Out Pending Text"
.II "commands^kick"
.II "kick"
.PP
The command
.B kick
flushes the TCP buffer, and launches all datagrams that it is ``sitting on''.
You can use this if a TCP session is being ``balky'' for any reason.
.Sh "log \(em Log Server Activity"
.II "commands^log"
.II log 
.PP
The command
.B log
lets you record all activity on the servers that you launch on your local host.
It recognizes the following syntax:
.DS
	\fBlog [ \fIlogfile \fB| stop ]\fR
.DE
If invoked without an argument,
.B log
tells you whether
.B net
is logging server activity.
Logging entries appear as follows:
.DM
	Jul 28 22:02:45 198.162.16.89:1001 - open Finger
	Jul 28 22:02:57 198.162.16.89:1002 - open Telnet
	Jul 28 22:04:29 198.162.16.89:1003 - open FTP
	Jul 28 22:09:16 198.162.16.89:1004 - rw logged in, ID 
	Jul 28 22:10:14 198.162.16.89:1003 - close FTP
	Jul 28 22:11:37 198.162.16.89:1004 - RETR /projects/smail/smail3.1.28.tz
	Jul 28 22:32:29 198.162.16.89:1008 - open FTP
	Jul 28 22:32:35 198.162.16.89:1008 - rw logged in, ID 
	Jul 28 22:33:40 198.162.16.89:1004 - close FTP
.DE
.PP
If invoked with the argument
.IR logfile ,
.B log
turns on logging (if logging was not yet on), and appends the logging
information onto
.I logfile
on your local host.
You must have permission to write into
.IR logfile ,
or logging will not work.
Because entries are appended onto
.IR logfile ,
you can use the same file repeatedly, to keep a running log of your network
activity.
.PP
.II "log stop"
If invoked with the argument
.BR stop ,
.B log
stops logging.
.Sh "ping \(em Reach Out and Touch A Remote Host"
.II "commands^ping"
.II "ping"
.PP
The command
.B ping
sends a datagram to a remote host, then tells you how long it took the
remote host to respond.
This is an easy way to tell if the remote host is ``on the air,'' and, if so,
how quickly the connection between your machines is functioning.
.PP
.B ping
recognizes the following syntax:
.DS
	\fBping [ \fIremotehost \fB[ \fIinterval \fB] ] | clear\fR
.DE
The command \fBping \fIremotehost\fR ``pings''
.IR remotehost .
When it receives a reply,
.B net
displays an information reply something like the following:
.DM
	12.34.5.6: echo reply id 0 seq 124, 55 ms
.DE
This indicates the round trip time was 55 milliseconds.
(A round-trip time of zero usually indicates that the remote system was
inaccessible for some reason.)
.PP
The command \fBping \fIremotehost interval\fR
tells
.B net
to ``ping''
.I remotehost
every
.I interval
seconds.
You can use this to command to profile the connection time between your
local host and
.IR remotehost .
Also,
if your system is hooked into a network that drops a connection when activity
ceases for a given interval, you can use this command to keep your
system on the air.
.PP
To stop a continual ping, use the command
.BR "ping clear" .
.Sh "pwd \(em Print Working Directory"
.II "commands^pwd"
.II "pwd"
.PP
This command is just like the \*(CO command
.BR pwd :
it displays the directory you are accessing on your local host.
.Sh "record \(em Record All Activity"
.II "commands^record"
.II "record"
.PP
The command \fBrecord \fIlogfile\fR tells
.B net
to open
.I logfile
and append onto it all data it receives during the current session.
.B net
also appends all data it sends on the current session,
except for TELNET sessions in remote-echo mode.
.PP
The command
.B "record off" 
tells
.B net
to stop recording and close
.IR logfile .
.PP
Note that this command is not supported for FTP sessions.
.Sh "reset \(em Blow Away a Session"
.II "commands^reset"
.II "reset"
.II TCB^definition
.II "TCP Control Block"
.PP
The command
.B reset
deletes the TCP Control Block (TCB) that belongs to a given session.
This immediately terminates your half of a session \(em in effect, it
``hangs up the phone'' on a session.
.PP
If you invoke
.B reset
with a session's number as an argument,
.B net
deletes the TCB for that session; if you invoke it without an argument,
.B net
deletes the TCB of the current session, should there be one.
.PP
Use this command with caution, because it does not inform the remote host
that the connection no longer exists.
You should use it only to get rid of a lingering, half-open connection
after a remote host has crashed or otherwise gone ``off the air''.
.Sh "route \(em Manipulate the Routing Table"
.PP
.II "commands^route"
.II "route"
The command
.B route
manipulates the IP routing table \(em that is, the table that tells
.B net
how to get from here to there.
It comes in the following three basic forms:
.IP \fBroute\fR
Display the contents of the routing table.
.IP "\fBroute drop \fIremote.host\fR"
.II "route^drop"
Drop the entry for
.I remote.host
from the routing table.
If a packet arrives for the 
deleted address and a default route is in effect, the default will be used.
.IP "\fBroute add \fIremote.host\fB[/\fIbits\^\fB]|default \fIinterface \fB[ \fIgateway \fB[ \fImetric \fB] ]\fR"
.II "route^add"
Add a route to the routing table.
.I remote.host
identifies the remote system to which you wish to route datagrams.
If this system is described in file
.BR $NETHOME/hosts.net ,
you can identify it by name; otherwise, you must give its IP address.
.IP
.I interface
names the
.B net
interface you are linking to
.IR remote.host .
You must first have used the command
.B attach
to define
.I interface
before you can use the it in a
.B route
command.
.IP
If
.I remote.host
is not local and you are using Ethernet to access your network,
you must also name the
.I gateway
through which your local host accesses
.IR remote.host .
(This is not required for SLIP, because a serial connection goes
directly from your system to the remote system, with no chance for the
datagrams to go astray.)
If
.I gateway
is described in file
.BR $NETHOME/hosts.net ,
you can use its name; otherwise, you must give its IP address.
Again, if this system is described in file
.BR $NETHOME/hosts.net ,
you can identify it by name; otherwise, you must give its IP address.
.IP
The optional suffix
.BI / bits
to
.I remote.host
specifies how many bits of its IP address are to be considered significant
in routing comparisons.
If not specified,
.B net
assumes that all 32 bits are significant.
With this option, you can use a single routing-table entry
to refer to many hosts whose IP addresses begin with the same bit-string.
For example, ARPA classes A, B, and C networks would use suffixes of /8, /16,
and /24 respectively.
For example, the command
.DM
	route add [44]/8 sl0 [44.64.0.2]
.DE
tells
.B net
to route to [44.64.0.2] every IP address that begins with ``44''.
.IP
When an IP address matches more than one entry in the routing table,
.B net
selects the route that matches the IP address most tightly \(em that is,
the entry with largest
.I bits
parameter.
This lets you set a general rule for routing a large block of hosts,
then set exceptions.
.IP
The special destination
.B default
is used to route datagrams to addresses not in the routing table;
it is equivalent to specifying a
.BI / bits
suffix of 0 to any destination
.IR remote.host .
Be careful when you define default entries:
two nodes whose default entries point at each other will ``ping-pong''
datagrams until their time-to-live fields expire.
If the routing table has only one entry, that should be the default.
.IP
The following gives some more examples of the
.B route
command:
.DM
	# Station with IP address [44.0.0.10] on local channel
	# needing an explicit route for some reason
	route add [44.0.0.10] ax0
.DE
.DM
	# Route datagrams to IP address 44.0.0.3 to SLIP line #0.
	# No gateway is needed because SLIP is point-to point.
	route add [44.0.0.3] sl0
.DE
.DM
	# Route all default traffic to the gateway on the local Ethernet
	# with IP address [44.0.0.1]
	route add default ec0 [44.0.0.1]
.DE
.DM
	# The local Ethernet has an ARPA Class-C address assignment;
	# route all IP addresses beginning with 192.4.8 to it
	route add [192.4.8]/24 nx0
.DE
.Sh "session \(em Display Information About Sessions"
.PP
.II "commands^session"
.II session
The command
.B session
displays information every session that running on your local host.
The information displayed includes session number, remote TCP address,
and the address of the TCP control block.
.B net
prints an asterisk `*'  to the description of the current session;
to enter or return to conversation mode with that session, type
.BR <return> .
.PP
To enter conversation mode with a session other than the current session,
type
.B session
followed by that session's number.
.PP
If the TELNET server is enabled,
.B net
automatically notifies you when a remote user initiates a session upon your
system.
By typing
.B session
followed by the new session's number, you can enter conversation mode with
that incoming session.
.Sh "shell \(em Invoke the COHERENT Shell"
.PP
.II commands^shell
.II shell
The command
.B shell
invokes a \*(CO shell.
You can give commands directly to \*(CO;
.BR net ,
meanwhile, continues to ``mind the store.''
.PP
When you exit from the shell (either by typing
.B <ctrl-D>
or
.BR exit ),
\*(CO returns to working with
.BR net .
.PP
Note that you can also use \*(CO's virtual-console facility to give
commands to \*(CO while working with
.BR net .
This is in many ways much easier than invoking a subshell, then returning;
its main drawback is that it is quite easy to forget that you have a
network session running, and walk away and leave yourself logged into
a system thousands of miles away.
For details on virtual consoles, see the entry for
.B "virtual console"
in the \*(CO Lexicon.
.Sh "smtp \(em Simple Mail Transport Facility"
.PP
.II "smtp"
.II "commands^smtp"
The command
.B smtp
manipulates the SMTP server on your system.
It recognizes the following sub-commands:
.IP "\fBsmtp gateway [ \fIhostid \fB]\fR"
.II "smtp^gateway"
Display or sets the host to be used as a ``smart'' mail relay.
Any mail sent to a
.I hostid
not in the host table will instead be sent to the gateway for forwarding.
.IP "\fBsmtp kick\fR"
.II "smtp^kick"
Run through the outgoing-mail queue and attempt to deliver any pending mail.
This command is periodically invoked by a timer whenever
.B net
is running; this command allows the user to ``kick'' the mail system manually.
.IP
Note that if there was mail queued up and not sent when you exit
.BR net ,
there will be zero-length files with the suffix
.B .lck
extension in the directory
.BR mqueue .
These mail messages will not go when
.B net
is restarted; you must delete these files by hand.
.IP "\fBsmtp maxclients [ \fImaximum \fB]\fR
.II "smtp^maxclients"
Display or set to
.I maximum
the maximum number of simultaneous outgoing SMTP sessions
that
.B net
allows.
The default is ten; reduce it if network congestion is a problem.
.IP "\fBsmtp mode [queue|route]\fR
.II "smtp^mode"
Use
.B queue
to stage messages in the subdirectory
.B rqueue
so a mailing agent other than
.B net
can deal with it.
By default,
.B net
sets the mode to
.BR route .
.IP "\fBsmtp timer [ \fIseconds \fB]\fR"
.II smtp^timer
Display or set the interval, in seconds, between scans of the outbound
mail queue.
For example, the command
.DM
	smtp timer 600
.DE
tells
.B net
to check for outgoing mail every ten minutes and attempt to deliver anything
it finds, subject to the
.B maxclients
limit.
Setting
.I seconds
to zero disables queue-scanning altogether:
this is the default.
This value is recommended for stand-alone IP gateways that never handle mail.
.IP "\fBsmtp trace [ \fItrace_level \fB]\fR
.II "smtp^trace"
Display or set the trace level in the SMTP client.
This permits you to watch SMTP's conversations as it delivers mail.
.I trace_value
can be set to 0, 1, 5, or 7.
Zero disables tracing; this is the default.
Values 1, 5, and 7 give increasing levels of details.
.PP
Please note that this server works only with the mail-router
.BR bm .
This router works in a very non-standard way,
so you will have serious problems if you attempt to use it for your mail.
.\" .Sh "sokname \(em Toggle How Socket Names Are Displayed"
.\" .PP
.\" If compiled with the directive, SOKNAME, defined, sokname is available to 
.\" toggle between showing socket names, ports, and IP users as names or as 
.\" numbers.
.\" This option affects the tcp stat command as well as telnet, 
.\" finger, and other processes that show activity by process or user number 
.\" or name.
.\" Initially this information is shown as names.
.\" (IP addresses in 
.\" hosts.net must conform to the pattern, 44.78.0.2; not, 44.78.00.02, 
.\" because sokname does a string pattern match.)  Toggle off to reduce disk 
.\" activity.
.Sh "start \(em Invoke a Server"
.PP
.II commands^start
.II start
The command
.B start
starts a specific Internet server.
Each server services processes any requests that it receives from the
outside world.
.B start
commands usually are embedded in a
.B startup
file.
.PP
To use it, simply type
.B start
followed by the name of the server you wish to start up.
The variety of servers available depends upon how your version of
.B cohulip
was configured;
among the available servers are
.BR echo ,
.BR finger ,
.BR ftp ,
.BR smtp ,
.BR telnet ,
and
.BR telunix .
.PP
.II telunix
The command
.B "start telunix"
takes an optional third argument, which lets you set the number of the
socket to which the
.B telunix
server is attached.
By default, the
.B telunix
is attached to socket 513; however, the command
.DM
	start telunix 23
.DE
connects the
.B telunix
server to socket 23, which is the well-known port for TELNET.
Connecting
.B telunix
to port 23 lets users who access your system via TELNET log in as they
normally would, and so gain their normal suite of permissions.
For details on
.BR telunix ,
see the chapter on advanced
.B cohulip
that follows in this manual.
.Sh "stop \(em Shut Down a Server\fR"
.PP
.II "commands^stop"
.II stop
To shut down a server, type the command
.B stop
followed by the name of that server.
.PP
Note that the command \fBstop ping\fR
stops new connections from being made, but does not affect
sessions that are in progress.
To close an existing session, use the command
.BR close .
.Sh "tcp \(em Manipulate TCP"
.PP
.II "commands^tcp"
The command
.B tcp
lets you modify how
.B net
manages TCP.
It recognizes the following sub-commands:
.IP "\fBtcp irtt [ \fIseconds \fB]\fR
.II "tcp^irtt"
.II IRTT
.II "Initial Round Trip Time"
Display or set
.BR net 's
estimate initial round trip time (IRTT), in seconds.
The default is five seconds.
TCP uses this estimate for new TCP connections \(em that is, when TCP
establishes a new connection, it waits
.I seconds
before it retransmits a datagram.
As the TCP session progresses, TCP can measure how much time is needed for
a datagram round trip \(em i.e., the interval between TCP's dispatching of
a datagram, and its receipt of confirmation that the remote host received it.
.IP
If you are running a TCP session over a slow or busy channel, you should
increase the IRTT.
This helps to avoid the flurry of retransmissions that would otherwise
occur as the smoothed estimate settles down to the correct value.
.IP
You must issue this command before you start servers,
or it will not affect incoming connections.
(A typical IRTT for a
.B startup
script is 2000.)
.IP "\fBtcp kick \fItcb_address\fR"
.II TCB
.II "TCP Control Block"
.II "tcp^kick"
If there is data on the send queue of a given TCP control block (TCB),
this command forces an immediate retransmission.
.I tcb_address
gives the TCB's address; you can obtain this value by using the command
.BR "tcp status" .
.IP "\fBtcp mss [ \fIbytes \fB]\fR"
.II "tcp^mss"
.II MSS
.II "Maximum Segment Size"
When your system is establishing a TCP channel with a remote system, your
system and it negotiate the TCP Maximum Segment Size (MSS) \(em
that is, the size of the largest datagram to pass between them.
Each system offers its maximum, and the lesser of the two is selected.
.IP
The command
.B "tcp mss"
sets to
.I bytes
the MSS that your system will send to a remote system.
Changing the value of the MSS affects only future connections;
existing connections are unaffected.
This value normally is set in your
.B startup
script.
.IP
If you type
.B "tcp mss"
without a
.I bytes
argument,
.B net
displays the current size of the MSS.
.IP
By default,
.B cohulip
sets the MSS to 512 bytes.
When you installed
.B cohulip
onto your system, the command
.B "tcp mss 1500"
was written into your
.B startup
file; this is a more reasonable figure given the current state of
communications equipment.
If you find that a third-party networking scheme is handling fragmentation
incorrectly, set the MSS to 216; this allows 40 bytes for IP and TCP headers,
and so prevents fragmentation.
.IP "\fBtcp reset \fItcb_address\fR"
.II "tcp^reset"
.II "TCP Control Block"
.II TCB
Delete the TCB control block (TCB) that at
.IR tcb_address .
This is the same as issuing the
.B reset
command, and should be used just as cautiously.
.IP "\fBtcp rtt \fItcb_address milliseconds\fR"
.II "tcp^rtt"
Set the round-trip time (RTT) that is in the TCP control block (TCB)
.I tcb_address
to
.IR milliseconds .
This replaces whatever RTT that TCP computed for the session that this
TCB controls.
This command can help speed up recovery from a series of lost packets,
because it lets you manually bypass the normal retransmission-timing
mechanism.
.IP
If you set the RTT to a bogus value, you can help cause a major tie-up on
the Information Superhighway.
Therefore, use this command only if you know
.I exactly
what you are doing.
.IP "\fBtcp status [ \fItcb_address \fB]\fR
.II "tcp^status"
This command displays information about TCP sessions that are in progress.
.IP
If you enter this command without arguments, it displays a brief summary
of all sessions.
The summary includes several TCP-level statistics, plus a summary
of all existing TCP connections, including TCB address, send and receive
queue sizes, local and remote sockets, and connection state.
.IP
If you name a
.I tcb_address
on the command line,
.B net
displays a detailed dump of the TCP Control Block (TCB) at this address.
The dump includes send and receive sequence numbers, and timer information.
.IP "\fBtcp timertype \fB[ linear|exponential ] [ \fIminutes\fB ]\fR"
.II "tcp^timertype"
Display or set the method used to set the TCP retry/backoff timer
and the maximum value to which it it will back off.
.IP
When entered without an argument, the command
.B "tcp timertype"
displays the current type of timer, and the backoff time.
.IP
When entered with one argument,
.B net
attempts to set the timer's type to that argument.
The argument must be
.B linear
or
.BR exponential .
.IP
The optional argument
.I minutes
sets the maximum backoff time.
.PP
The default is exponential timing, with a maximum backoff of 30 minutes.
.IP "\fBtcp window [ \fIbytes \fB]\fR"
.II "tcp^window"
Display or set the size, in bytes, of the receive window that TCP uses
when it creates a new connection.
This command does not affect existing connections.
The default is 2,048 bytes.
If you encounter fragmentation problems with third party networking schemes,
set the TCP window to 1,080.
.Sh "telnet \(em Converse With Another System"
.PP
.II telnet
.II "commands^telnet"
The command
.B telnet
uses the TELNET protocol to connect with a remote host.
When the connection is made, you can converse with that host,
just as if your machine were a terminal plugged into it.
.PP
The command
.B telnet
takes the following syntax:
.DS
	\fBtelnet \fIremote.host \fB[ \fIport \fB]\fR
.DE
.I remote.host
names the host to contact; this can be its domain name, or an IP address.
.I port
names the port to connect to.
Some remote hosts establish special ports for special purposes; or you
may wish to contact a well-known port for another protocol (e.g., SMPT
or FTP) in order to debug a connection (or send forged mail).
If you do not name a
.IR port ,
.B telnet
connects to port 23, which is the well-known port for the TELNET protocol.
.Sh "trace \(em Trace the Handling of Datagrams"
.PP
.II trace
.II "commands^trace"
The command
.B trace
lets you establish and customize the tracking of datagrams.
You can use the information that a trace yields to help debug a connection.
.PP
.B trace
recognizes the following syntax:
.DS
	\fBtrace [ \fIinterface flags\fB [ allmode|cmdmode ] ]\fR
	\fBtrace to \fIoutputfile\fR
.DE
When invoked without arguments,
.B trace 
lists all defined interfaces and their tracing status.
.PP
The first argument,
.IR interface ,
names the interface that you wish to trace.
The interface first have been defined through the command
.B attach
before you can trace it.
.PP
The second command
.IR flags ,
is a three-digit number that controls some aspects of tracing.
The first (leftmost) digit controls the type of tracing, as follows:
.IP \fB0\fR 0.3i
Decode protocol headers, but do not display data.
.IS \fB1\fR
Decode protocol headers; display only the data.
Data are displayed as ASCII characters, 64 per line;
unprintable characters are displayed as periods.
.IS \fB2\fR
Decode protocol headers; display both data and headers.
Data and headers are displayed in hexadecimal and ASCII, 16 characters per line.
.PP
The second (middle) digit of
.I flags
controls the tracing of incoming datagrams:
one enabled tracing, whereas zero disables it.
.PP
The third (rightmost) digit of
.I flags
controls the tracing of output datagrams:
if one, tracing is enabled; if zero, it is disabled.
one enabled tracing, whereas zero disables it.
.PP
For example, setting
.I flags
to
.B 011
enables tracing of both incoming and outgoing datagrams, but displays
information only about the headers.
.PP
The optional third argument to
.B trace
lets you select whether traced packets are always displayed.
.B allmode
displays tracing all the time, regardless of whether you are in
command mode or conversation mode.
.B cmdmode
tells
.B net
to display tracing only when it is in command mode.
.PP
Finally, the command \fBtrace to \fIoutputfile\fR redirects the tracing
from the screen into
.IR outputfile .
This command lets you examining tracing information at your leisure.
.Sh "udp status \(em Display Status of UDP Receive Queues"
.PP
.II udp
.II "commands^udp"
The title says it all:
this command displays the status of every UDP receive queue.
.Sh "upload \(em Write File Into Current TELNET Session"
.PP
.II upload
.II "commands^upload"
This command opens a file and writes its contents into the current session,
just as if you had typed those contents from the keyboard.
When it has finished copying the file to the session,
.B net
displays the message,
.BR "Uploading off" .
.PP
This command is valid only with a TELNET session.
You can use it to execute on the remote host a script that resides on
your local host.
.SH "Where To Go From Here"
.PP
For some technical background of the commands used in this chapter,
see the chapter \fITCP/IP History and Design\fR, which appears earlier
in this manual.

.IP "\fBadventure\fR" 0.75i
A text-based ``adventure'' game.
.IP "\fBalmanac\fR"
Calculate the ascension and declention of the Sun,
Moon, and three major planets when given the calendar date and time.
Also calculates the azimuth and altitude for the Sun, Moon, and eight planets.
.IP "\fBbrowser\fR"
Utility for indexing and scanning files.
.IP "\fBcalls\fR"
Utility to trace hierarchy of called functions in C programs.
.IP "\fBcdiff\fR"
Similar to COHERENT \fBdiff\fP, but produces Berkeley 3.2-style \fBdiff\fP
output.
.IP "\fBclam\fR"
C shell-style shell for COHERENT.
.IP "\fBcomb\fR"
An alternative to COHERENT's standard mailer, \fB/bin/mail\fP.
Features screen oriented menuing and reply functions.
.IP "\fBcursive\fR"
Generates ``cursive'' banners based upon input from \fIstdin\fP.
.IP "\fBcut\fR"
Berkeley style \fBcut\fP and \fBpaste\fP utilities.
.IP "\fBdeliver\fR"
Local mail delivery agent to be used with a mail router, (e.g., \fBsmail\fP).
.IP "\fBdmake\fR"
Enhanced version of COHERENT \fBmake\fP utility.
.IP "\fBdtree\fR"
Formatted directory tree version of the traditional COHERENT \fBls\fP command.
.IP "\fBdumpscreen\fR"
Copies (dumps) contents of console screen.
.IP "\fBelle\fR"
EMACS-like screen editor.
Uses EMACS-style commands and can handle huge files.
.IP "\fBemacs\fR"
Enhanced binary of COHERENT MicroEMACS editor that understands eight-bit
character sets.
.IP "\fBGNUtar\fR"
Replacement for COHERENT \fBtar\fP file-archiving utility.
GNUtar format is
portable to other systems that support \fBtar\fP.
.IP "\fBkermit\fR"
Enchanced C-Kermit file transfer and terminal-emulation package.
.IP "\fBlaser\fR"
Utility for printing using a laser printer.
Lets you specify landscape or portrait layout.
.IP "\fBless\fR"
Enchanced version of Berkeley \fBmore\fP pager.
.IP "\fBlharc\fR"
File-archiving utility.
.IP "\fBlibndir\fR"
Directory-access subroutine library.
.IP "\fBllesh\fR"
Command history overlay for the COHERENT Bourne shell, \fB/bin/sh\fP.
.IP "\fBmake\fR"
Enhanced version of COHERENT \fBmake\fP utility.
.IP "\fBmaze\fR"
Multi-user maze game.
.IP "\fBmenu\fR"
A menuing package.
.IP "\fBpatch20\fR"
File-patching utility.
.IP "\fBpatches\fR"
Enhancements and patches to the Clam shell.
.IP "\fBpcmail\fR"
A menu driven \fBmail\fP utility with numerous features, including a reply
function.
.IP "\fBqq\fR"
Sample device driver which reads from and writes to the console.
Requires the COHERENT Device Driver Kit.
.IP "\fBscreen\fR"
Utility for setting screen colors.
.IP "\fBshar\fR"
Utility to create shell archives.
.IP "\fBshells\fR"
Collection of Bourne shell scripts to help format floppy disks,
create file systems, and copy diskettes.
.IP "\fBsmail\fR"
A COHERENT version of the popular \fIsmart mailer\fP utility.
.IP "\fBtools\fR"
COHERENT utilities for checking the polling rate of polled serial
ports, displaying the hard-disk drive parameters that the COHERENT
kernel is working with, etc.
.IP "\fBtools1\fR"
A series of tools that display the user's UID.
.IP "\fBunzip\fR"
Unarchiver for use with \fBzip\fP-format archives.
.IP "\fBuptime\fR"
Utility that displays the last time that COHERENT was booted.
.IP "\fBxargs\fR"
Wrapper that allows many arguments to be passed to a command.
.IP "\fBxxu\fR"
Converts DEC-20 and VAX/VMS style file names to COHERENT-style file names.
.IP "\fBzmodem\fR"
COHERENT version of popular file-transfer utility.

.ds TL Errata
.NH "READ THIS: Supplement to Release Notes"
.PP
The following describes errors in the release notes, and known
bugs in \*(CO 4.2.
.IP \(bu 0.3i
Due to a production error,
the character
.sp \n(pDu
	\*(RT
.sp \n(pDu
was rendered as:
.DM
	(\XA2)
.DE
If possible, please try to remember that the cent sign actually means
that you should press the \fB<Return>\fR key.
.IP \(bu
The section on third-party products implies the GNU C and GNU C++
are two products.
In fact, there is only one product, GNU C;
C++ is part of the package.
.IP \(bu
The price of GNU C is actually $79.95, not $49.95 as listed in the
release notes.
.IP \(bu
The price of COHware volumes IV and V is $49, not $40 as listed in the
release notes.
.IP \(bu
Udo Munk's e-mail address is \fBudo@umunk.gun.de\fR.
Axel Reinhold's e-mail address is incorrect and should not be used.
.IP \(bu
In the section on running third-party packages,
the description of selecting and de-selecting printers for WordPerfect
is no longer valid.
Printer selection now works as it should.
.IP \(bu
Command
.B fdformat
does not work with its \fB\-v\fR (verify) option if you are formatting
the block device.
It does work, however, if you use the character (raw) device.
For example, command
.DM
	fdformat -v /dev/rfva0
.DE
works, but command
.DM
	fdformat -v /dev/fva0
.DE
does
.I not
work.
This will be corrected in the near future, and a repaired version of
.B fdformat
will be posted to the MWC BBS and the Internet.
.IP \(bu
Some users who update will find that their systems retain two versions
of
.BR tar :
one in directory
.B /usr/bin
and the other in directory
.BR /bin .
Command
.B /bin/tar
will have been left over from your previous installation of \*(CO;
it has been superceded by command
.BR /usr/bin/tar ,
which is superior.
You should rename command
.B /bin/tar
to
.BR /bin/tar.old
to ensure that you use the improved
.B tar
command for your backups.
.SH "Before and After You Update"
.PP
The following gives helpful hints that you should consider before
you update to \*(CO 4.2.
.IP \(bu 0.3i
Before you update, be sure your file system is intact.
Run \fBfsck\fR on your root file system, at least, before you attempt
to update.
.IP \(bu
When you install third-party packages, we recommend that you run in
single-user mode.
This will considerably lessen the complications of installation.
.PP
After you install \*(CO, the following describes how to update your
system to enable new devices:
.IP \(bu 0.3i
To install or de-install a parallel printer:
.DM
	cd /etc/conf
	lp/mkdev
	/conf/mlpconfig
	bin/idmkcoh -o /\fIkernel_name\fP
.DE
.IP \(bu
To install STREAMS or floating-point emulation:
.DM
	cd /etc/conf
	em87/mkdev
		\fIor\fP
	streams/mkdev
	bin/idmkcoh -o /\fIkernel_name\fP
.DE
.IP \(bu
To install a driver for asynchronous ports, first edit
.B /etc/default/async
as described in the Lexicon; then:
.DM
	cd /etc/conf
	asy/mkdev
	bin/idmkcoh -o /\fIkernel_name\fP
.DE
.IP \(bu
To disable a hard-drive controller:
.DM
	cd /etc/conf
	bin/idenable -d \fIdisk_driver\fP
	bin/idmkcoh -o /\fIkernel_name\fP
.DE
where
.I disk_driver
is one of the following:
.DS
	\fBat\fR	AT disk driver
	\fBaha\fR	Old-style Adaptec driver
	\fBss\fR	Seagate/Future Domain driver
	\fBhai\fR	Host-independent Adaptec driver
.DE
.IP \(bu
To enable a hard drive:
.DM
	cd /etc/conf
	bin/idenable -e \fIdisk_driver\fP
	# if you are installing the hai driver:
	# hai/mkdev
	bin/idmkcoh -o /\fIkernel_name\fP
.DE
where
.I disk_driver
is one of the following:
.DS
	\fBat\fR	AT disk driver
	\fBaha\fR	Old-style Adaptec driver
	\fBss\fR	Seagate/Future Domain driver
	\fBhai\fR	Host-independent Adaptec driver
.DE
.IP \(bu
To change from a loadable versus a non-loadable keyboard driver,
to change the video adapter, or to add or remove virtual consoles:
.DM
	cd /etc/conf
	console/mkdev
	bin/idmkcoh -o /\fIkernel_name\fR
.DE

.ds TL "Running 3rd-Party Software"
.NH "Running Third-Party Software"
.PP
\*(CO runs many packages from third-party vendors that
were designed for use with other
operating systems, in particular SCO \*(UN.
\*(CO will run these packages, but some require some minor
reconfiguration of either the package, of \*(CO, or both, to run smoothly.
.PP
The following sections describe some of the packages that Mark Williams
Company has tested, and gives directions on how to perform these minor
reconfigurations.
Note that we continually test new packages, so the following list probably
is incomplete.
For the latest information on what packages run under \*(CO, and how you
can run them, telephone the company from which you purchased the software,
check the MWC bulletin board, or telephone Mark Williams Company.
.SH "General Directions"
.PP
To install third-party \*(UN software onto \*(CO, be aware of the following
general rules:
.IP \fB1.\fR 0.3i
\*(CO does not support the command
.BR custom .
To install, you should read the product's manual and determine what must
be done to install the product.
Some products come with a shell script that performs all the tasks of
installation; you can use the Bourne shell
.B sh
to invoke that script.
Other products use
.B tar
or
.BR cpio ;
look in your package's installation or release notes for instructions.
Please note that when un\fBtar\fRring or \fBcpio\fRing
floppy disks from other \*(UN systems, you sometimes must
use the complex \*(UN device names that are now supported in this release.
For information on floppy-disk device names, see the Lexicon entries for
.B fd
and
.BR "floppy disk" .
.IP \fB2.\fR
Some third-party packages support many different operating systems, and when
you install the package let you pick the operating system from a menu.
If this is the case, you should pick \*(CO first, if it is one of the options.
If \*(CO is not an option, pick SCO \*(UN; if SCO \*(UN is not available,
then Interactive \*(UN; and if none of those are available, then
USL \*(UN System V release 3.2.
If none of those are available, then select generic
\*(UN system V release 2.
.IP \fB3.\fR
Some packages offer a variety of console devices.
If you have a color console, select
.BR colorcons .
If this is not available, try
.BR at386 .
If neither is an option, or if you have a monochrome console,
then you should select
.BR monochrome ;
in most cases, this works correctly, even with color devices.
.IP \fB4.\fR
If possible, install all available terminal types.
Some packages require that you reinstall the entire package should you
need a terminal type that you have not yet installed.
.IP \fB5.\fR
\*(CO does not come with the utility
.BR unpack ,
which some packages require to install.
To get around this problem, simply link the program
.B gzip
to
.BR unpack .
.IP \fB6.\fR
Some packages require some features of
.B awk
that the \*(CO version does not yet implement.
To get around this problem, move the \*(CO
.B awk
to
.BR awk.old ;
then link the command
.B mawk
(the GNU version of
.BR awk )
to
.BR awk .
If your system does not have
.BR mawk ,
contact Mark Williams Company and we will send you a copy.
.IP \fB7.\fR
Some packages require the \*(UN pager
.B pg
to display the contents of some text files.
\*(CO does not come with
.BR pg ;
however, you can use the \*(CO pager
.B more
as a substitute.
To do so, type the command:
.DM
	ln -f /usr/bin/more /usr/bin/pg
.DE
.IP \fB8.\fR
The SCO impementation of the link command
.B ln
will overwrite an existing file by default.
This behavior does not comply with the \*(PX.
Under \*(CO,
you must use the option \fB\-f\fR to force
.B ln
to overwrite an existing file.
Some installation scripts, however, depending upon the non-standard behavior of
.BR ln .
If this problem arises while you are installing a package, you must edit the
installation script and insert the flag \fB\-f\fR where appropriate.
.IP \fB9.\fR
\*(CO does not support the
.B brand
utility from SCO.
This utility ``brands'' (or serializes) executables using a
serial number and license activation key.
Any package that requires
.B brand
for proper installation and execution will not work under \*(CO.
.SH "Third-Party Packages"
.PP
The following gives information on using some of the more popular third-party
\*(UN packages under \*(CO.
.Sh "Aide de Campe"
.PP
This package installs and runs correctly.
.Sh "BBX Progression/4"
.PP
The installation of this package requires that you use the command
.BR cpio .
Because the installation program does not prompt for the two supplementary
disks, you must re-issue the command
.DM
	cpio -icB
.DE
for each disk in the distribution.
.PP
The newest version from BASIS runs BASIS International's
regression suite without error.
.Sh "Blast"
.PP
The package works correctly; however, some of its graphic displays do not
work correctly because of limitations in the \*(CO console driver.
We are working to correct this problem.
If this is a problem for you, contact Mark Williams Company, and we will send
you a corrected version of the console driver as soon as it is ready.	
.Sh "ccsh"
.PP
As of this writing, the shell-script compiler
.B ccsh
does not run under \*(CO 4.2.
That is due to the fact that its internal library
.B /usr/lib/libccsh.a
is not in the COFF format.
It does run, however, on release 3.2 of \*(CO.
.PP
For details, please contact the publisher of
.BR ccsh .
.Sh "Codebase"
.PP
The Kernighan and Ritchie source compiles.
.Sh "Dataflex"
.PP
This package installs and runs correctly.
.Sh "dBASE III"
.PP
The package works correctly; however, some of its graphic displays do not
work correctly because of limitations in the \*(CO console driver.
We are working to correct this problem.
If this is a problem for you, contact Mark Williams Company, and we will send
you a corrected version of the console driver as soon as it is ready.	
.Sh "dBASE IV"
.PP
To install dBASE IV under \*(CO, do the following:
.IP \fB1.\fR 0.3i
Type the command
.DM
	cd /
.DE
.IP
to change to the root directory.
.IP \fB2.\fR
Insert System Disk 1 into a floppy-disk drive.
.IP \fB3.\fR
Type the command
.DM
	tar -xvf /dev/rfva\fIX\fP ./tmp/install
.DE
where
.I X
is `0' or `1', depending upon whether you have inserted the system disk
into drive 0 (i.e., A:) or 1 (i.e., B:).
.IP \fB4.\fR
When the file is extracted, issue the following command:
.DM
	cp ./tmp/install ./tmp/coh-install
.DE
.IP
Then, use the editor of your choice to edit file
.BR ./tmp/coh-install .
Change line 33 from:
.DM
	label=`dd if=$disk count=1 | dd bs=100 count=1 2>/dev/null | tr`
.DE
.IP
to
.DM
	label=`dd if=$disk count=1 | dd bs=100 count=1 2>/dev/null`
.DE
.IP
Save the edited file.
.IP \fB5.\fR
.I
Make sure you are in the root directory!
.R
This is crucial at this stage to installing correctly.
.IP \fB6.\fR
Execute the new install script by typing:
.DM
	/bin/sh ./tmp/coh-install /dev/rfva\fIX\fP
.DE
.IP
Once again, substitute `0' or `1' for
.I X
depending upon which floppy-disk drive you have inserted the system disk.
.IP \fB7.\fR
Continue doing the installation normally, as described in the documentation
that comes with the dBASE-IV package.
.IP \fB8.\fR
When you have concluded installing dBASE IV, you must execute the following
final commands:
.DM
	cd /usr/local/lib/dbaseiv
	rm dbase1.res
	ln ./dbase1.res.us ./dbase1.res
	rm /tmp/coh-install
.DE
.PP
You should now have a working implementation of dBASE IV!
.PP
Some users have encountered problems with this package's license manager.
They report that the first time they added a license to the
data base, the license manager corrupted the entry, thus prompting some
surly behavior from dBASE when they attempted to use the package.
.PP
To correct this problem, use the dBASE utility
.B editlic
to add a second license entry.
It appears that dBASE stores and processes this second entry correctly.
After you confirm that the new entry functions properly,
re-invoke
.B editlic
and remove the original entry.
After that, all appears to work as it should.
.PP
You may experience some problems with console output and the handling of
function keys.
If this is the case, you need a version of the dBASE terminal-description
file that is corrected for \*(CO.
You can obtain this file from site \fBraven\fR on the Intenet,
or from the Mark Williams bulletin board.
If all else fails, send mail to \fBsupport@mwc.com\fR, and we will mail a copy
to you.
.PP
Some users of dBASE IV have reported that the package, for whatever reason,
does not recognize directory or file names that contain capital letters.
If dBASE IV has trouble saving files, check the name of the directory,
and make sure it is all in lower-case letters.
.Sh "FilePro"
.PP
The package works correctly; however, some of its graphic displays do not
work correctly because of limitations in the \*(CO console driver.
We are working to correct this problem.
If this is a problem for you, contact Mark Williams Company, and we will send
you a corrected version of the console driver as soon as it is ready.	
.Sh "Flexilint"
.PP
The tool
.B Flexilint
does compile and run under \*(CO release 4.2.
.PP
To install the package, you must make one small change:
edit header file
.B custom.h
and change the prototype for
.B void
to
.BR int .
.Sh "Lotus 1-2-3"
.PP
To install Lotus 1-2-3, do the following:
.IP \fB1.\fR 0.3i
Before you begin installation, invoke the following commands:
.DM
	su root rm /bin/awk
	su root ln /usr/gnu/bin/mawk /bin/awk
.DE
.IP \fB2.\fR
Install Lotus by hand with
.B tar
(not with
.BR custom ),
as described in the Lotus documentation.
.IP \fB3.\fR
Before you run the command
.BR setup123 ,
type the following command:
.DM
	echo -n '\033[?8l'
	ln -f /usr/bin/more /usr/bin/pg
	ln -f /usr/bin/gzip /usr/bin/unpack
.DE
The first command set erase mode on the console.
The other two commands links \*(CO utilities to \*(UN utilities that
Lotus requires.
.PP
The sample files as stored in
.B /u/lotus/123.v11/smpfiles/misc
will fail if the current working directory is not
.BR /u/lotus/123.v11/smpfiles/misc .
To enter this directory from within Lotus, use the following command:
.DM
	/WGDD/u/lotus/123.v11/smpfiles/misc
.DE
As of this writing, graphs did not work because of limitations of the \*(CO
console driver.
We are working to correct this problem.
.\"If this is a problem for you, contact Mark Williams Company, and we will send
.\"you a corrected version of the console driver as soon as it is ready.	
.Sh "mc \(em MacroCALC"
.PP
MacroCALC installs and runs correctly under \*(CO 4.0 and 4.2.
Users should have no problems installing this package.
If you are installing MacroCALC onto \*(CO 4.2, do
.I not
copy onto your system the
.B ansipc
termcap entry that comes with the package:
the one included with \*(CO 4.2 already works correctly
.Sh "RMCobol"
.PP
RMCobol works out of the box, without modification.
You may notice some slight discrepancies with regard to colors and
the number of lines on the screen, which are easily corrected by resetting
the \*(CO console device.
.Sh "SlickEdit"
.PP
This editor works properly.
However, it comes with an internal language that it uses for enhanced editing,
macros, etc., that requires a compiled named
.BR st .
This compiler is on the SlickEdit's distribution disks; however, it is in
Microsoft
.B a.out
binary format, which cannot be executed under \*(CO.
.PP
SlickEdit works best with a customized terminal-information file that has
been prepared by Mark Williams Company.
To obtain a copy, contact the Mark Williams BBS as described earlier in these
notes.
.Sh "TERM Communications Package"
.PP
Because the distribution disks are not high density, you must use
device \fB/dev/fqa\fIX\fR (where \fIX\fR is \fB0\fR or \fB1\^\fR)
to load the distribution.
.PP
When you execute the
.B install
script after you have loaded the distribution, you
must to choose the first option in the index:
.DM
	UNIX System V/386 (Including Altos, AT&T and Interactive)
.DE
Once installed, our tests show that the package works well.
.Sh "WordPerfect and WordPerfect Office"
.PP
Before you can print anything on your \*(CO system, you must start up and
configure the MLP print spooler.
Do this before you attempt to install WordPerfect.
For details on MLP, see the Lexicon entry for
.BR printer .
.PP
When you load the initial boot disk,
if you choose to un-\fBtar\fR the disk using the device
.BR /dev/fva0 ,
.B tar
complains:
.DM
	This doesn't look like a tar archive.
	Skipping to next file...
.DE
.PP
This behavior also occurs with devices
.BR /dev/fva0 ,
.BR /dev/dsk/f03h ,
.BR /dev/dsk/f0q18dt ,
and
.BR /dev/fd0135ds18 .
Note that this does not affect the installation:
it is just a curiosity.
.PP
When you perform the actual installation, in some instances the installation
program exhibits strange behavior.
It will say:
.DM
	*Please Wait*    0% complete
.DE
It then prints what appears to be a process id on top of the fragment
.BR *Plea ,
moves the cursor down another line, and prints:
.DM
	*Please Wait*   1% complete
.DE
The
.B 1%
stage continues for a lengthy period of time;
the floppy-disk drive's light glows, to show that the disk is being read,
but otherwise the installation program displays nothing to indicate that
useful activity is occurring.
Do not panic:
the installation program is working; it simply is not updating the screen
properly.
.PP
.\"Once you have gone through the command
.\".BR "wpinstall" ,
.\"you have performed initial installation.
.\"At this point, you must install additional printers.
.\"The installation program by default selects 299 printers for installation.
.\"These include the printers that were installed initially, and others that
.\"appear to have been selected at random from the list of available printers.
.\"Go through the entire list; un-select the printers you do not have, and
.\"select others (if any) that you do have but that were not selected by default.
.\".PP
If your console is monochrome, insert the command
.DM
	export WPTERM51=scocons
.DE
into file
.BR /etc/profile .
If you console is color, insert the command:
.DM
	export WPTERM51=scoconscol
.DE
WordPerfect expects this variable to be set before it can run correctly.
Note that after you insert it, you must log out and log in again before
that variable can become part of your environment.
.PP
If you wish to run either package under X Windows, use the terminal type
.B VT102
and insert the following instructions into the file
.BR $HOME/.Xdefaults :
.DM
	xterm*VT102.Translations: #override \e
		<Key> F1 : string(0x1b) string("OP") \en \e
		<Key> F2 : string(0x1b) string("OQ") \en \e
		<Key> F3 : string(0x1b) string("OR") \en 
.DE
.PP
Some systems have experienced problems with printing under the
.B lp
spooler, when logged in as anyone other than the superuser.
This should not be a problem, but if it is, try switching the WordPerfect
spooler command from
.B lp
to
.B "hpr -B"
or
.BR "lpr -B" ,
respectively, depending upon whether you have a laser printer or a
dot-matrix printer.
If all else fails, try the following workaround:
.PP
.IP \fB1.\fR 0.3i
Set WordPerfect's spool command to:
.DM
	cat -u > /tmp/PRINT.ME
.DE
.IP
When WordPerfect prints, it will dump its output into file
.BR /tmp/PRINT.ME ,
instead of sending it directly to the spooler.
.IP \fB2.\fR
To print WordPerfect's output, open another virtual console and type the
command:
.DM
	cat /tmp/PRINT.ME > /dev/lp
.DE
With WordPerfect Office, you cannot receive mail from within the
application because it expects either SCO's MMDF, or
a version of
.B smail
that \*(CO does not support.

.ds TL "Using COHERENT"
.NH "Using the COHERENT System"
.PP
This tutorial introduces the \*(CO system.
It introduces such basic concepts as \fIcommand\fR and \fIfile system,\fR
and walks you through simple exercises to help you gain some familiarity
with the dimensions of \*(CO.
If you are new to \*(CO, you should read through this tutorial first.
Not every section in here will be immediately useful to every user; for
example, a beginner will probably not need to study the section on
system administration, at least at first.
But sooner or later, you will need to work with all of the material in
this tutorial.
.PP
If you are unfamiliar with what an \fIoperating system\fR is, or if
you are unsure how \*(CO differs from other operating systems
(such as \*(MD), turn to the Lexicon article for \*(CO.
There, you will find a brief description of what an operating system is
and what makes \*(CO special.
.PP
Before you can begin to use this tutorial, you must install \*(CO
on your computer.
If you have not yet done so, turn to the Release Notes that came with
this manual and follow the directions in them.
.SH "How Do I Begin?"
.PP
For everyone, there's that first time.
You have installed \*(CO on your computer, you've checked the file system,
mounted all of your file systems, and have gone into multi-user mode.
Now you are sitting in front of your computer and all you see on your
screen is the enigmatic phrase:
.DM
	Coherent 386 login:
.DE
``What,'' you ask yourself, ``do I do now?''
Well, the rest of this section will tell you how to get started with \*(CO.
.Sh "Logging in"
.PP
To begin, you must \fIlog in\fR.
Unlike \*(MD, \*(CO is a multi-user system:
many people can use the same computer.
They can access it either via terminals that you plug into your
computer's serial ports, or via modem.
Each user owns his personal set of files,
his special way of setting up his environment,
his own mailbox, and other things which are special to him alone.
Because many people can use \*(CO, before you begin to work with
\*(CO you must tell it who you are.
This process of identifying yourself to \*(CO is called \fIlogging in\fR.
.II "logging in^definition"
That mysterious prompt
.DM
	Coherent 386 login:
.DE
is \*(CO's way of asking you who you are.
.PP
To log in, type your personal login identifier.
You set this identifier when you installed \*(CO onto your computer.
Most people set their login identifier to their initials or their
first names, usually all in lower-case letters.
Once you type your login identifier,
press the \*(RT key (sometimes labelled \fB<Enter>\fR or \fB<Return>\fR).
If you did not set up a login for yourself during
installation, log in as the superuser \fBroot\fR and add one for yourself.
For information on how to log in as the superuser, see below.
For information on how to add a new user, see the section on \fBAdding
a New User\fR, below, or see the Lexicon article for the command \fBnewusr\fR.
.PP
While you were installing \*(CO on your system,
you were given the option of setting a password for your login identifier.
.II crackers
This is done to stop other users from logging in as you \(em and
to keep ``crackers'' from dialing into your system and vandalizing it.
If you did set a password, after you enter your login identifier \*(CO
prompts you for it with the following prompt:
.DM
	Password:
.DE
Type your password.
Note that \*(CO does \fInot\fR display the password on the screen as you
type it;
this is to prevent bystanders from seeing your password over your
shoulder as you type it.
After you type your password, again type \*(RT.
.PP
If you entered your login identifier and passwords correctly, \*(CO
will display the command prompt:
.DM
	$
.DE
This is \*(CO's way of saying, ``Give me a command, I'm ready to go!''
If you made a mistake while logging in, either with your login
identifier or your password, \*(CO will reply,
.DM
	Login incorrect:  try again.
.DE
and again display its login prompt:
.DM
	Coherent 386 login:
.DE
Try again, until you do manage to log in.
If you have received the `$' prompt, congratulations!
\*(CO is now ready to work with you.
.Sh "Special Terminal Keys"
.PP
.II eol
.II enter
.II linefeed
.II return
The next sections will introduce you to some elementary \*(CO commands.
Before we continue, however, you must first become familiar with a few
special keys on your computer's keyboard, and with the special meanings
they have to the \*(CO system.
.PP
One special key on the keyboard will be used frequently in your work:
the \*(RT key.
As noted above, this key is sometimes labelled \fB<Enter>\fR.
.PP
You must conclude every command you type into \*(CO by pressing \*(RT.
This tells \*(CO that you have finished typing, and that you now want it
to execute your command.
\*(CO will not execute your command until you press this key.
.PP
.II cont
.II "control key"
.II "ctrl key"
Another special key is the \fBcontrol\fR key.
This key is usually labelled \fBCtrl\fR or \fBcntl\fR or \fBcont\fR.
Most terminals place it to the left of the keyboard.
This key is used to send certain special characters.
.PP
The \fBctrl\fR key is like another kind of shift key:
to use it, hold it down while you press another key.
For example,
to send the computer a \fB<ctrl-D>\fR character, hold down the \fBctrl\fR
key, strike the \fBD\fR key, then release both keys.
.PP
Because control characters have no corresponding printable characters,
in this tutorial they will be represented in the form:
.DM
	<ctrl-D>
.DE
for the character \fBctrl-D\fR.
.PP
.II stty
.II <kill>
While you are typing information into the \*(CO system, you can correct what
you type before \*(CO processes it.
Two keys will help you do this.
The first is the \fB<kill>\fR
character, which erases the line entirely and allows you to begin again.
This is usually \fB<ctrl-U>\fR.
.PP
.II <ctrl-H>
.II <erase>
The other key is the \fB<erase>\fR character, normally
.B <ctrl-H>
or the
.B <backspace>
key.
This moves the cursor one character to the left, to erase the most recently
typed character.
.PP
.II <interrupt>
.II "rub out key"
.II "del key"
One more special key is the \fB<interrupt>\fR key.
This key aborts a command before it normally finishes.
By default, \fB<ctrl-C>\fR is the abort key on your keyboard.
.Sh "Try Some COHERENT Commands"
.PP
.II cat
.II <Return>
Now that you've logged in to your \*(CO system, try a few simple
\*(CO commands to get a feel for \*(CO.
Type the following examples just as they are shown, and observe
what \*(CO does in response to each.
Be sure to press \*(RT to end each line.
.PP
The first example uses the command
.BR cat ,
to let you type a small chunk of text and save it in a file.
.DM
	cat >file01
	This is a sample COHERENT file.
	<ctrl-D>
.DE
Remember, don't type \fB<ctrl-D>\fR literally \(em rather, hold down the
\fBctrl\fR key and press `D' at the same time.
.PP
In the above script, the characters
.B cat
tell \*(CO to invoke its concatenation program.
The characters \fB>file01\fR tells \*(CO to write what you type into a file
that you name \fBfile01\fR.
The line
.DM
	This is a sample COHERENT file.
.DE
is the text that \*(CO writes into \fBfile01\fR.
Finally, \fB<ctrl-D>\fR signals \*(CO that you have finished typing.
.PP
Now type:
.DM
	cat file01
.DE
This command again invokes the concatenation program \fBcat\fR, but this
time tell it to print on your screen the contents of \fBfile01\fR, which you
just created.
In reply to your command, \*(CO should print on your screen:
.DM
	This is a sample COHERENT file.
.DE
which is the text you typed in the previous exercise.
.PP
Finally, type the command:
.DM
	lc
.DE
This command lists all of the files that you have in the current directory.
In reply to your command, \*(CO should print on your screen:
.DM
	Files:
	    file01
.DE
which is the file you just created.
(You may see other files as well.)
.PP
Congratulations!
You have just made \*(CO work for you.
.PP
.II lc
To review:
The first command, \fBcat\fR, created a file and filled it with some text.
The second \fBcat\fR command copied the file onto your terminal's screen.
Finally, the command \fBlc\fR printed the name of each of your files.
The following sections of this tutorial describe each of these commands
in more depth.
Each command also has its own entry in the Lexicon, which appears in the
second half of this manual; look there for a full description of each
command, what it does, and how you can use it.
.Sh "Giving Commands to COHERENT"
.PP
Once you have logged into \*(CO, all of its resources are yours to command.
\*(CO's \fIcommands\fR give you control over these resources.
.II command^definition
.PP
Every \*(CO command has the same structure:
the \fIcommand name\fR, which tells \*(CO the command you want it
to execute; and the \fIarguments\fR, which detail what you want the
command to do, how you want it to do it, and to what you want it done.
.PP
.II "commands^first part"
Some commands consist only of the command name, and do not take arguments.
For example, the command
.DM
	lc
.DE
which was introduced in the previous section, has
.B lc
as the first part and prints the names of
all files in the current directory, in columns.
If you have no files, \fBlc\fR prints nothing.
.PP
.II argument
.II parameter
The second part of the command consists of the \fIarguments\fR
given to the command.
(These are also known by the term \fIparameters\fR.)
Arguments are separated from each other by spaces or tab characters.
.PP
.II option
The arguments of the command are further divided into
\fIoptions\fR and \fInames\fR.
\fINames\fR usually name files;
\fIoptions\fR modify the action of the command.
An option is usually prefixed by a hyphen `-'.
.PP
.II cat
.II parameter^name
An example of a \fIname\fR argument is shown in this example of a
\fBcat\fR command:
.DM
	cat file01
.DE
This command types the contents of \fBfile01\fR on your terminal.
The name argument is \fBfile01\fR.
.PP
.II option
.II ls
.II parameter^option
For an example of options, consider the command
.BR ls .
\fBls\fR lists your file names one name per line.
Thus, typing
.DM
	ls
.DE
produces a list of the form:
.DM
	file01
.DE
However, \fBls\fR can tell you more about a file than just its name.
To see additional information about each file, type:
.DM
	ls -l
.DE
The `\-l' option to \fBls\fR prints a ``long'' output, of the following form:
.DM
	-rw-r--r-- 1 \fIyou\fP    17 Sat Aug 15 17:20 file01
.DE
This listing shows the size of the file, the date it was created or last
modified, and its degree of protection.
The letters to the left of the listing give the permissions for the
file; these describe who is allowed to do what to the file.
These are described in detail in the Lexicon articles
for the commands \fBls\fR and \fBchmod\fR.
The other entries on that line respectively name the owner of the file
(in this case, \fIyou\fR); the size of the file, in bytes;
the date and time the file was last modified; and, finally, the file's name.
.PP
As an example of combining an option parameter with a name parameter,
consider the command:
.DM
	ls -l file01
.DE
This invokes the command \fBls\fR, tells it to print a long listing,
and tells it to list only the file \fBfile01\fR.
.PP
As you will see in the following sections, almost all \*(CO commands
have this syntax.
.Sh "help, man, apropos: Help with Commands"
.PP
.II help
The \*(CO system has three commands that give information about
other commands:
\fBhelp\fR, which prints a brief summary of
how to use a command;
\fBman\fR, which prints the full Lexicon entry
for that command on your screen; and
.BR apropos ,
which shows all commands (all Lexicon entries, really) which relate to
a given subject.
.PP
To find out about the \fBhelp\fR command, type
.DM
	help
.DE
by itself, or type:
.DM
	help help
.DE
The latter command tells \fBhelp\fR to print the help entry for the
\fBhelp\fR command itself.
.PP
To get information on the \fBlc\fR command, type:
.DM
	help lc
.DE
You will see something very like the following:
.DM
	lc -- List directory's contents in columnar format
.sp \n(pDu
	lc [ -1abcdfp ] [ directory ...]
.sp \n(pDu
	Options:
	     -1        List files one per line instead of in columns
	     -a        List all files in directory (including `.' and `..')
	     -b        List block-special files only
	     -c        List character-special files only
	     -d        List directories only
	     -f        List regular files only
	     -p        List pipe files only
.sp \n(pDu
	Options can be combined.  If no directory is specified, the current
	directory is used.
.DE
.II man
To obtain detailed information on a command, use the \fBman\fR command.
(\fBman\fR is short for ``manual''.)
As noted above, the \fBman\fR prints on your screen a duplicate of that
command's entry in the Lexicon.
To learn more about the \fBhelp\fR command, type:
.DM
	man help
.DE
If your screen fills with information, \fBman\fR
will wait for you to press the spacebar to continue.
This is to prevent you from missing information should it scroll too fast.
.PP
Finally, the command
.B apropos
print information about all Lexicon articles that are
.I "a propos"
a given topic.
For example, if you want to know what Lexicon articles are
.I "a propos"
the subject of printers, type the command:
.DM
	apropos printer
.DE
\*(CO replies by printing something like the following:
.DM
	chreq	Change priority, lifetime, or printer for a job
	epson	Prepare files for Epson printer
	hp	Prepare files for Hewlett-Packard LaserJet printer
	hpd	Spooler daemon for laser printer
	lp	Spool a job for printing
	lpd	Spooler daemon for line printer
	lpioctl.h	Definitions for line-printer I/O control
	lpr	Spool a job for printing on a dot-matrix printer
	lpshut	Turn off the printer daemon despooler
	lpskip	Abort/restart current job on line printer
	lpstat	Give status of printer or job
	printer	How to attach and run a printer
	prps	Prepare files for PostScript-compatible printer
	route	Show or reset a user's default printer
.DE
Read the summary descriptions of each Lexicon article to see which ones
look promising; then either look them up in this manual, or use the
.B man
command to display them on your screen.
.PP
Our survey of elementary commands will conclude by describing two
important tasks:
how to reboot the computer, and how to log out.
.Sh "Shutting Down COHERENT and Rebooting"
.II "COHERENT^shutting down"
.II "shutting down COHERENT"
.II "COHERENT^rebooting"
.II "rebooting COHERENT"
.PP
Under many operating systems, such as \*(MD, rebooting is as simple
as pressing a couple of keys or cycling power on the computer.
The \*(CO system, however, is a multi-user, multi-tasking operating
system that is more sophisticated than \*(MD or similar operating systems.
\*(CO maintains an elaborate system of internal buffers that are
designed to reduce the frequency with which a program has to read data
from, or write data to, the hard disk.
If you were just to turn the computer off and turn it on again, all of
the data in those buffers would be lost.
At the very least, each user would lose whatever data he was working
with at the time; at worst, the \*(CO file system could be damaged
and files lost.
.PP
For this reason, it is extremely important that you
shut down \*(CO properly.
You \fImust\fR follow these procedures if you want to shut off the
computer, or if you wish to reboot \*(MD.
.PP
To shut down \*(CO, do the following:
.IP \(bu 0.3i
When you see the \*(CO command prompt, type either
.B <ctrl-D>
or the command
.BR exit .
This will log you out of your system.
(Logging out is described in more detail in the following section.)
.IP \(bu 0.3i
When you see the prompt
.DM
	Coherent 386 login:
.DE
type
.BR root ,
to log in as the superuser
.BR root .
\*(CO will ask you for the superuser's password; type the password
that you assigned to the superuser when you installed \*(CO onto your computer.
The Lexicon article on \fBsuperuser\fR describes what the superuser is;
as will later sections of this tutorial.
.IP \(bu
Once you have logged in as the superuser, type the following command:
.DM
	/etc/shutdown halt 0
.DE
As its name implies, this command shuts down the \*(CO system.
The command will ask you if you really, truly wish to shut down \*(CO;
reply `y', for ``yes''.
.IP \(bu
Now, you can turn the computer off.
Or, you can type \fB<ctrl><alt><del>\fR, or press the reset button on
your computer (should it have one).
.IP
After you have rebooted your computer,
just sit back and wait until you receive the \fBCoherent 386 login:\fR prompt
on your screen.
.IP
If you wish to reboot \*(MD, watch the computer:
wait until you see the computer attempting to read from the floppy-disk drive.
At that moment, press the number key that corresponds to the hard-disk
sector on which you stored \*(MD, from 0 to 7.
For example, if \*(MD is kept on partition 2, then press \fB2\fR when
the computer is attempting to read the floppy-disk drive.
Be sure to press the number key that is on the main bank of keys,
\(em \fInot\fR the key on the numeric keypad.
.PP
That's all there is to it.
Shutting down is relatively simple and straightforward;
but if you do not take the time to shut \*(CO down properly,
you will find that you have destroyed some or all of your data.
.PP
By the way, the Lexicon articles on
.B booting
and
.B login
describe in detail the processes of booting and logging into your \*(CO system.
.Sh "Logging Out"
.PP
.II "logging out"
As noted above, \fIlogging in\fR tells \*(CO who you are and that
you wish to work with \*(CO for a while.
When you have finished working with \*(CO, you must tell \*(CO
that you are done for now.
This process is called \fIlogging out\fR.
.PP
.II <ctrl-D>
.II exit
There are two ways to log out.
Each involves typing a special command to the \*(CO prompt.
The first way is to type \fB<ctrl-D>\fR at the \*(CO prompt.
The second is to type the command:
.DM
	exit
.DE
Each of these commands has the same effect:
the \*(CO system flushes all buffers that you ``own'' and prints the prompt
.DM
	Coherent 386 login:
.DE
on your screen.
At this point, you cannot issue any commands to \*(CO; but you
(or someone else) can log into \*(CO from your terminal.
.PP
Please note that logging out is \fInot\fR the same as shutting down \*(CO.
When you shut down \*(CO, you are shutting down the entire system.
When you log out, however, you are simply ceasing to work with \*(CO.
After you log out, however, \*(CO continues to work on its own:
organizing files, exchanging information with other computers via modem,
executing programs for users who have logged in via modem or other terminals,
and in general making itself useful.
If you shut off the computer after you log out, you will damage the
file system, just the same as if you shut it off while you were logged in.
.PP
The following sections in this tutorial will go into \*(CO's commands
in more detail.
All, however, build on the elementary actions presented here:
logging into \*(CO;
issuing commands;
receiving responses from \*(CO;
and logging out.
.SH "Working With Files and Directories"
.PP
.II file
.II directory
The \fIfile\fR and the \fIdirectory\fR are the cornerstones of
the \*(CO system.
Practically everything you do on the system will involve files:
changing files, invoking files, transmitting or receiving files,
filling files up or emptying files out.
And, directories let you organize masses of files into a rational hierarchy.
.PP
This section discusses manipulating files and directories under the
\*(CO system.
It covers the following:
.IP \(bu 0.3i
What \fIfile\fR and \fIdirectory\fR mean to \*(CO
.IP \(bu
Introduces the commands for manipulating files, directories and their contents
.IP \(bu
Discusses more advanced topics,
such as creating and mounting new file systems
.IP \(bu
Tours the \*(CO file system
.PP
This section of the tutorial covers much ground in a relatively brief space.
Readers who are new to personal computers should concentrate on the
earlier sub-sections, which cover elementary topics;
whereas more experienced readers may wish to concentrate on the later
sub-sections, which cover the more technical material.
.Sh "File Names"
.PP
.II file^name
A \fIfile\fR is a mass of electronic impulses that is given a name
and stored on a disk.
Files are given names to make them easy for you to retrieve.
\*(CO has rules about how files can be named, to ensure that each
file's name is unique.
.PP
The following are examples of legal file names:
.DM
	.profile
	File01
	cmd.sh
	file01
	test.c
.DE
.II "case sensitivity^in file names"
.II "lower case^in file names"
File names are generally made up of upper-case and lower-case letters and
numbers.
\*(CO, unlike \*(MD, distinguishes capital letters from lower-case letters;
therefore, to \*(CO the file names \fBFile01\fR and \fBfile01\fR are different.
.PP
Any character can be used to name a file, including a control character.
We recommend, however, that you name files using only
upper- or lower-case alphabetic characters, numerals, and the
punctuation marks `.' or `_'.
.PP
The file name must not be more than 14 characters long.
If you specify a longer name, characters beyond the 14th will be
lopped off and thrown away.
For example, \*(CO regards the file names
.DM
	this_is_very_long_file_name_1
.DE
and
.DM
	this_is_very_long_file_name_2
.DE
as being identical.
.Sh "Introduction to Directories"
.PP
.II directory
A \fIdirectory\fR is a group of files that have been given a name.
Directories let you organize files systematically.
This may not seem important now, but as you work with \*(CO you will
find that you accumulate hundreds, or even thousands, of files; without
system of directories to organize files, you would quickly lose track of
what each file held, and find it nearly impossible to find any given file
within your system.
.PP
Because files are stored within directories, the complete name of a file
actually consists of its name plus the name of the directory in which it
is stored.
This lets \*(CO distinguish files that have the same name but are stored
in different directories.
\*(CO uses the slash character `/' to distinguish a directory name
from a file name; for example, to view the contents of file \fBjunk\fR
in directory \fBtext_files\fR, you would use the command:
.DM
	cat text_files/junk
.DE
This system of naming will be described in full in the next sub-section;
for the moment, just bear in mind that for \*(CO to find a file, you
must tell \*(CO not only the name of the file, but the name of the
directory in which it is kept.
.PP
.II "home directory"
.II directory^home
When you work with \*(CO, you are always ``in'' a directory.
The directory you happen to be ``in'' at any given moment is called the
\fIcurrent directory\fR.
The current directory is the one whose files you are working with
at this moment.
When you type the name of a file and do not mention what directory it is
stored in, \*(CO assumes that the file is kept in the current directory.
\*(CO includes commands that let you shift from one directory to another.
.PP
When you log into \*(CO, \*(CO places you ``in''
a directory that you ``own''.
This directory is called your \fIhome directory\fR.
You control all of the files in your home directory; it is your
``base of operations'' for working within \*(CO.
.Sh "Path Names"
.PP
.II root
.II "path name"
As you may have deduced by now, a directory can contain both
files and other directories.
The directories within a directory may themselves contain
both files and directories; which then may contain other files
and directories; and so on.
.PP
This design of directories branching into other directories,
which in turn branch into still other directories, is called
\fItree structured\fR.
As the tree-metaphor implies, the \*(CO system of directories
has a \fIroot directory,\fR that is, a directory that is not
contained in any other directory but from which all other directories
descend, directly or indirectly.
The name of the root directory is simply:
.DM
	/
.DE
.II usr
One subdirectory of the root directory is called \fBusr\fR.
This subdirectory contains the home directories of all users.
Other common paths for home directories are
.B /u
and
.BR /usr/acct .
To list the names of all user directories, type the command:
.DM
	lc /usr
.DE
If your login name is \fBhenry\fR, then the command
.DM
	lc /usr/henry
.DE
lists the names of the files in your home directory.
Please note that in the argument \fB/usr/henry\fR, the first slash
names the root directory; all subsequent slashes serve simply
to separate one directory name from the next.
.PP
.II "path name"
.II "path name^fully specified"
The name \fB/usr/henry\fR is called a \fIpath name\fR.
The term ``path name'' means the full name of a given file or
directory \(em including all the directories that lead from the
root directory to it.
.PP
Path names may be full or partial.
All full path names begin with \fB/\fR
for root, and continue with further subdirectory names.
Path names that do not begin with a slash are partial;
\*(CO automatically
prefixes them with the path name of the current
directory to make them complete before it uses them.
.PP
.II "slash^in path name"
The elements of path names are separated by slashes, so if there were a file in
\fBnewdirectory\fR named \fBnewfile\fR, you would refer to it as
.DM
	newdirectory/newfile
.DE
.II "home directory"
.II directory^home
The absence of a beginning slash indicates that the path name begins in the
current directory.
Thus, if your home directory name is \fBhenry\fR, then another
way to name the path to \fBnewfile\fR is to type:
.DM
	/usr/henry/newdirectory/newfile
.DE
The following diagram gives a rough description of the structure of the
\*(CO file system:
.ie p .PH 1 1 \\*(XD/using.eps
.el \{
.DM
                   /
          ==================
         bin              usr
                  ==================
                henry            other
.DE
\}
Please note that unlike a real tree, the root of a tree structure
has its root at the top rather than at the bottom.
Here, the root directory `/' is at the top of the structure.
It contains the directories \fBbin\fR and \fBusr\fR (among many others).
Directory \fBusr\fR contains directories \fBhenry\fR and \fBother\fR
(again, among many others.
These directories can contain many other directories and subdirectories.
.PP
.II root
.II "path name"
.II directory^root
In summary, a path name lists all the subdirectories leading from the
root directory to the file in question.
In the above example, \fBnewfile\fR is a file in subdirectory
\fBnewdirectory\fR, which in turn is a file in the home directory \fBhenry\fR,
which is further a file in the directory \fBusr\fR.
The directory \fBusr\fR
is a file in the master or \fBroot\fR directory for the system.
.PP
You don't need to specify all of this, fortunately, whenever you want to
specify a file in a subdirectory.
\*(CO assumes that
partially specified path names are within the current directory.
Therefore, you can specify a subdirectory by specifying the name of the
directory first, followed by the rest of the path name.
.PP
\*(CO also allows two special abbreviations for directories.
The abbreviation  `..' always represents the current directory's \fIparent\fR
directory.
In the case of the directory \fB/usr/henry\fR, directory \fBusr\fR
is the parent of directory \fBhenry\fR.
In other words, `..' stands for the directory in which the current directory
resides.
Every directory in the system except the root directory has a parent.
For the root directory, `..' refers to itself.
.PP
.II "current directory"
.II directory^current
Another
directory abbreviation is \*(Ql.\*(Qr, which means the \fIcurrent\fR directory.
.PP
The following sub-sections describe the commands that \*(CO includes
for manipulating files and directories.
As you work with \*(CO, you will use these commands continually, so it
would be worth your while to spend a little time learning them.
.Sh "ls, lc: Listing Your Directory"
.PP
.II lc
.II ls
This sub-section introduces two of the more commonly used commands:
\fBls\fR and \fBlc\fR.
Both
.B ls
and
.B lc
list the files in a directory.
.PP
To see how these commands work,
presume that your directory has the files created in previous sections and
that you did not remove directory \fBnewdirectory\fR.
.II /bin
To list the files in your directory, simply use the command with no parameters:
.DM
	 ls
.DE
This produces a list of files, such as:
.DM
	another
	backup
	doc1
	doc2
	file01
	file02
	newdirectory
	stuff
.DE
The command
.B lc
also lists file names, but it prints the files and directories separately,
in columns across the screen.
For example, typing
.DM
	lc
.DE
gives something of the form:
.DM
	Directories:
	   backup newdirectory
	Files:
	   another doc1 doc2 file01 file02
	   stuff
.DE
If you want to list files in a directory other than your own,
name that directory as an argument to the command.
For example, \fB/bin\fR
is a directory in the \*(CO system that contains commands.
Type
.DM
	lc /bin
.DE
and \fBlc\fR will print the contents of \fB/bin\fR.
.PP
.II options
Both
.B ls
and
.B lc
can take options.
An option is indicated by a hyphen `-'.
The option must appear before any other argument.
For example, to list only the files in the directory for user \fBcarol\fR,
leaving out any directories, use the \fBf\fR option with \fBlc\fR:
.DM
	lc -f /usr/carol
.DE
Or, if you type the command
.DM
	lc -f
.DE
the \*(CO system prints all of the files in the current directory.
The following gives the commonly used options to the command \fBlc\fR:
.DS
	\fB-d\fR	List directories only, omitting files
	\fB-f\fR	List files only, omitting directories
	\fB-1\fR	List files in single-column format
.DE
\fBls\fR produces a list of file names, one per line,
and optionally much more information.
To produce all the information, use the \fB-l\fR option
(note that this is an \*(QLel\*(QR, not a numeral 1):
.DM
	ls -l
.DE
The following gives a sample of the long list that this option produces.
Headings have been added to show the meaning of each column:
.II mode
.DM
.ta 0.9i 1.1i 2.2i 2.75i 3.7i 4.3i
\fI			Size,	      Modification
   Mode	#	Owner	Bytes	Date	Time	Name\fP
-rw-r--r--	1	you	17	Wed Aug 19	17:51	file01
drwxrwxrwx	2	you	32	Wed Aug 19	17:53	backup
-rw-r--r--	1	you	17	Wed Aug 19	17:53	doc1
.DE
The meaning of each column will be explained later.
For now, note that the last column gives the name of each file,
and the fourth column from the left gives the size of each file, in bytes.
.Sh "cat: Print Contents of a File"
.PP
.II cat
The command
.B cat
opens and prints the contents of a text file \(em that is, a
file of source code, a document, or a message file.
For example, to list the contents of file \fBfile01\fR, type:
.DM
	cat file01
.DE
.II "standard output"
This command types the file's contents on the terminal
(sometimes also called the \fIstandard output\fR\^).
.PP
.II redirection
.II file^concatenation
Another use for \fBcat\fR \(em the use from which it gets its
name \(em is to \fIconcatenate\fR several files on the standard output.
For example, the command
.DM
	cat one two three
.DE
prints the files \fBone\fR, \fBtwo\fR, and \fBthree\fR,
one after the other, on your screen.
.PP
.II "I/O redirection"
.II >
You can use
.B cat
to concatenate several files into one file by
\fIredirecting\fR the standard output into a file.
The special character `>' tells \*(CO
to redirect the standard output into a file.
For example, the command
.DM
	cat one two three >four
.DE
concatenates files \fBone two three\fR into file \fBfour\fR.
\fBfour\fR need not exist prior to this command; if it does,
its contents are replaced by the data redirected into it.
.PP
Redirection is a very useful feature of \*(CO that will be used
through the rest of this tutorial.
The `>' operator also gives an example of the set of operators that
can be used with \*(CO commands.
These operators, which increase the power of each \*(CO command,
will be described in detail later in this tutorial.
.Sh "more: List Files on the Screen"
.PP
.II more
If the file you list with \fBcat\fR
is more than 24 lines long,
the beginning lines of the file scroll off the
screen too quickly for you to read them.
To ensure that you see all of the lines in the file, use the
command \fBmore\fR.
.PP
.B more
prints a file in 24-line chunks.
After it has listed a chunk of text, it pauses
and waits for you to press \fB<space>\fR.
If you call \fBmore\fR with an option of \fB-s\fR,
.DM
	more -s file
.DE
it will skip all blank lines that are in the text file.
.Sh "mkdir: Create a Directory"
.PP
.II mkdir
The command
.B mkdir
creates a new directory.
For example,
to create a new directory named \fBnewdirectory\fR, type the following command:
.DM
	mkdir newdirectory
.DE
If you follow this command with \fBlc\fR, it lists your regular files,
but it also lists \fBnewdirectory\fR separately as a directory:
.DM
	Directories:
	    newdirectory
	Files:
	    file01	 file02
.DE
To refer to any files in
.BR newdirectory ,
use its name in specifying the path name.
.PP
.II file^creation
Now, create a file in the new directory:
.DM
	cat >newdirectory/newfile
	lines to be
	contained in newfile
	<ctrl-D>
.DE
This command copies lines to the file described by the partial path name
\fBnewdirectory/newfile\fR.
.Sh "cd: Change Directory"
.PP
.II cd
The command
.B cd
changes the current working directory.
For example, the command
.DM
	cd newdirectory
.DE
moves you into directory
.B newdirectory
that you created in the previous sub-section.
Now, if you type the command \fBlc\fR, to show the contents of the current
directory, it will show the following:
.DM
	Files:
	    newfile
.DE
To return to the previous directory, use the command:
.DM
	cd ..
.DE
As noted earlier, the abbreviation `..' always indicates the current
directory's parent directory.
.Sh "pwd: Print Working Directory"
.PP
.II pwd
The command
.B pwd
prints the name of the current, or \fIworking,\fR directory.
For example, if your login name is \fBhenry\fR, then if you type
.DM
	pwd
.DE
you will see:
.DM
	/usr/henry
.DE
Now, use the \fBcd\fR command to switch to directory \fBnewdirectory\fR,
as follows:
.DM
	cd newdirectory
.DE
When you type
.DM
	pwd
.DE
you will see:
.DM
	/usr/henry/newdirectory
.DE
Finally, use the \fBcd\fR command to return to the previous directory,
as follows:
.DM
	cd ..
.DE
When you type
.DM
	pwd
.DE
you now see:
.DM
	/usr/henry
.DE
If you are ever unsure what directory you are in, use the
.B pwd
command.
.Sh "mv, cp: Move and Copy Files"
.PP
.II mv
.II "move files"
.II "file^move"
.II "rename files"
.II "file^rename"
The command
.B mv
moves files.
You can move a file from one name to another within the current directory
(in effect rename the file), or you can move a file from one directory
to another.
.B mv
takes two parameters:
the first names the file to be moved;
the second names either the new name that you are giving to the file,
or the directory into which you are moving the file.
.PP
For example, to move file \fBfile01\fR into directory \fBnewdirectory\fR, type:
.DM
	mv file01 newdirectory
.DE
To see where \fBfile01\fR is now, type the following command:
.DM
	lc newdirectory
.DE
The result is:
.DM
	Files:
	    newfile
.DE
To move \fBnewfile\fR back into the current directory, use the command:
.DM
	mv newdirectory/newfile .
.DE
Remember, the abbreviation `.' always stands for the current directory.
.PP
As noted above, the \fBmv\fR command can also be used to rename files
within the current directory.
For example, to change the name of \fBnewfile\fR to \fBoldfile\fR, use
the following command:
.DM
	mv newfile oldfile
.DE
If the current directory already has a file named \fBoldfile\fR, it will
be thrown away and replaced with the file that used to be named \fBnewfile\fR.
.PP
.II cp
.II file^copying
The command
.B cp
copies a file.
This command has two parameters:
the first names the file to be copied, and
the second names the file or directory into which it is to be copied.
For example, to copy \fBoldfile\fR in the current directory back into
\fBnewfile\fR, use the following command:
.DM
	cp oldfile newfile
.DE
If \fBnewfile\fR already exists, it will be replaced by a copy of
.BR oldfile .
.PP
If you wished to copy \fBnewfile\fR into directory \fBnewdirectory\fR,
use the command:
.DM
	cp newfile newdirectory
.DE
Now, when you type the command
.DM
	lc newdirectory
.DE
you will see:
.DM
	Files:
	    newfile
.DE
As you can see, \fBnewfile\fR has been copied into \fBnewdirectory\fR.
If \fBnewdirectory\fR had already contained a file called \fBnewfile\fR,
that file would have been replaced with the newer \fBnewfile\fR being
copied into \fBnewdirectory\fR.
.PP
The following example summarizes what's been presented so far about
files and directories.
For purposes of the example, assume that your login name is \fBhenry\fR,
and that you have in your home directory files \fBdoc1\fR and \fBdoc2\fR
that you wish to back up for safekeeping.
.PP
Before you can back up these files, you must first create them.
First, use the command \fBcat\fR to create file \fBfile01\fR, as follows:
.DM
	cat >doc1
	a few
	lines of
	text
	<ctrl-D>
.DE
Likewise, create file \fBdoc2\fR:
.DM
	cat >doc2
	second file
	with some text
	<ctrl-D>
.DE
(Don't forget that \fB<ctrl-D>\fR
means to hold the control key down and simultaneously type \fBD\fR.)
.PP
The command \fBlc\fR will now show you the files and directories in your
current directory:
.DM
	Directories:
	    newdirectory
	Files:
	    doc1    doc2    newfile    oldfile
.DE
The next step is to create the directory to hold the back-up copies.
To help remind yourself what the directory is for, name it \fBbackup\fR.
.DM
	mkdir backup
.DE
Now, \fBlc\fR shows you:
.DM
	Directories:
	    backup	 newdirectory
	Files:
	    doc1    doc2    newfile    oldfile
.DE
The next step is to use \fBcp\fR to copy your files into \fBbackup\fR:
.DM
	cp doc1 backup
	cp doc2 backup
.DE
After you issue these commands, \fBlc\fR still says:
.DM
	Directories:
	    backup	 newdirectory
	Files:
	    doc1    doc2    newfile    oldfile
.DE
However, if you list the contents of subdirectory \fBbackup\fR
.DM
	lc backup
.DE
you will see:
.DM
	Files:
	    doc1 doc2
.DE
The files have been successfully copied into the back-up directory.
.PP
For a full description of these commands and the options available with each,
see their respective entries in the Lexicon.
.Sh "rm, rmdir: Remove Files and Directories"
.PP
.II rm
.II "file^removal of"
The command
.B rm
removes a file.
For example, if you wish to remove file
.B doc2
in directory
.BR backup ,
type the following command:
.DM
	rm backup/doc2
.DE
After typing this command, use the command \fBlc\fR to show the contents
of directory \fBbackup\fR, as follows:
.DM
	lc backup
.DE
You should see:
.DM
	Files:
	    doc1
.DE
As you can see, file \fBdoc2\fR has been removed.
.PP
You can remove several files at once, simply by listing them on the
.B rm
command's command line.
For example:
.DM
	rm file01 file02
.DE
removes files
.B file01
and
.BR file02 .
.PP
Note that once you remove a file with \fBrm\fR, it is gone forever.
The \*(CO system does not warn you if you \fBrm\fR several files
at once; it will assume that you know what you're doing and carry out
your command silently.
For this reason, be careful when you use the \fBrm\fR command, or you
may receive a rude surprise.
.PP
.II rmdir
.II "directory^removing"
.II "remove a directory"
You cannot use the command
.B rm
to remove a directory.
\*(CO does this to help prevent you from wiping out an entire
file system with one simple \fBrm\fR command.
To remove a directory, use the command
.BR rmdir .
For example, to remove the directory
.BR newdirectory ,
type:
.DM
	rmdir newdirectory
.DE
Note that before you can delete a directory, that directory must not
have any files or directories in it.
If you try to remove a directory that has files or directories in it,
\*(CO will print an error message on your screen and refuse to
remove the directory.
.PP
For a full description of these commands and the options available with each,
see their respective entries in the Lexicon.
.Sh "du, df: How Much Space?"
.PP
Files occupy space on your hard disk.
.II "Parkinson's law"
(A corollary to Parkinson's law states that files expand
to fill the disk allotted to them.)
It is somewhat disconcerting to
attempt to save a large file, only to find that you have run out of disk space.
To help you manage your hard disk, \*(CO includes the commands
.B du
and
.BR df .
.PP
.II du
.II "disk usage"
The disk-usage command
.B du
tells you how much disk space the files in the current directory
occupy.
If the directory has sub-directories, these are listed separately.
.II disk^block
.II "block, disk"
.B du
prints disk usage in blocks; each block is 512 bytes (half a kilobyte).
.PP
.II df
The disk-free command
.B df
tells you how many blocks are left free on your disk.
By default it prints information only about the file system you are now in.
.PP
If you find that you are running low on disk space, you must free up some
space.
You can do that by removing files you no longer need; by \fIcompressing\fR
files that you do not use often; or by backing files up to floppy disk and
then removing them.
We have already described how to remove files.
Look in the Lexicon entry for the command \fBcompress\fR for information on
how to compress and uncompress files.
Following sections in this tutorial will describe how to copy files to floppy
disk.
.PP
For more information on these commands, see their respective entries in the
Lexicon.
.Sh "ln: Link Files"
.PP
.II links
\*(CO allows a file to have more than one name.
When you create a file, you give it a name; \*(CO \fIlinks\fR the
name you give the file with its internal system of managing files.
(For more information on how \*(CO identifies files, see the Lexicon
entry for \fBi-node\fR.)
\*(CO allows you to give a file more than one name; another way of
expressing this is to say that
you can give a file \fImultiple links\fR.
.PP
.II ln
.II file^links
To create a new link to an existing file, use the command \fBln\fR.
This command takes two arguments:
the first names the file to which you wish to give a new link, and the
second gives the name that you wish to link to that file.
If the name you are linking to a file is already being used by a
file, \*(CO will not let you link the file to that name.
.PP
For example to link the file \fBdoc1\fR to the name \fBanother\fR,
use the following command:
.DM
	ln doc1 another
.DE
The ``new'' file has the same data in it as the ``old'' file;
in fact, the names \fBdoc1\fR and \fBanother\fR are synonyms for the same file.
.PP
.II rm
.II file^links
The next point is somewhat subtle.
When you use the command \fBrm\fR to remove a file, what you are
actually doing is breaking the link between that file and its name.
The file is not actually removed from disk until all links are broken
between it and all of its names.
In the above example, if you use the command
.DM
	rm another
.DE
to remove the file \fBanother\fR, the file
.B doc1
remains in existence, and the data to which the names \fBanother\fR
and \fBdoc1\fR pointed remains on the disk.
If you then use the command
.DM
	rm doc1
.DE
to remove \fBdoc1\fR, then you will have broken all links between that
file and the \*(CO system, and \*(CO removes it from the disk.
.PP
Links are useful if you wish a file to be used in two different contexts
but have the same data.
For example, if you use file \fBdoc1\fR in two different manuscripts, you can
create links to the file in two different directories, one for each
manuscript.
Thus, any changes you make to the file under either its names appear
automatically in both manuscripts.
.PP
As always, see the Lexicon for a full description of the
.B ln
command.
.Sh "File Permissions"
.PP
As you recall, the command
.B "ls -l"
prints a mass of information about each file.
The following repeats the information that appeared when you
typed \fBls -l\fR:
.DM
.ta 0.9i 1.1i 2.2i 2.75i 3.7i 4.3i
\fI			Size,	      Modification
   Mode	#	Owner	Bytes	Date	Time	Name\fP
-rw-r--r--	1	you	17	Wed Aug 19	17:51	file01
drwxrwxrwx	2	you	32	Wed Aug 19	17:53	backup
-rw-r--r--	1	you	17	Wed Aug 19	17:53	doc1
.DE
Column 3 names the owner; in this example, \fByou\fR represents
your login name, whatever you have set it to.
Column 4 gives the size of the file, in bytes.
Columns 5 through 7 give the day of the week and the date on which
the file was last modified.
Column 8 gives the time the file was last modified or, if the file
was last modified more than a year ago, the year it was last modified.
Column 9 gives the name of the file.
.PP
.II permission^access
.II "access permission"
Column 1 gives the \fImode\fR of the file.
The mode summarizes the \fIpermissions\fR attached to this file.
.PP
Before going further, the concept of file permissions should be reviewed.
\*(CO is a multi-user operating system, which means that more than one
person can log into the system, walk through its file system, execute
commands, and manipulate files.
Every user has files that she ``owns'' \(em that is, that she has created
and that she wishes to protect against being altered or removed by others.
After all, it would be disconcerting if you were to log into your system,
only to find that some of your key files had been trashed by another user,
without your knowledge or permission.
.PP
The \*(CO system protects files by its system of file permissions.
Permissions have two aspects:
the \fItype\fR of permission, and the \fIscope\fR of permission.
There are three \fItypes\fR of permission:
.IP "\fBread permission\fR"
Permission to read a file.
.IP "\fBwrite permission\fR"
Permission to write into a file.
.IP "\fBexecute permission\fR"
Permission to execute a file, assuming that file contains executable
code instead of text.
.PP
Likewise, there are also three types of \fIscope:\fR
.IP "\fBuser\fR"
The permissions extended to the owner of the file.
.IP \fBgroup\fR
The permissions extended to the group of users to which the owner belongs.
For more information on what \fIgroup\fR is, see the Lexicon entry for
.BR group .
.IP \fBother\fR
The permissions extended to all other users.
.PP
The \fImode\fR column describes all permissions attached to a file.
It also gives other information about a file, such as whether the
file is a directory.
Taking the entry for file \fBfile01\fR as an example, we see:
.DM
1 2  3  4   # Owner            Size      Date         Time    File name
-rw-r--r--  1 you         17 Sat Aug 15 17:20  file01
.DE
As you can see, the mode field is divided into four subfields, in this
example labelled `1' through `4'.
.PP
Subfield 1 indicates whether this file is a directory.
If the file were a directory, this
would contain a \fBd\fR; otherwise, it contains a hyphen.
.PP
.II "mode field"
Subfields 2 through 4 describe the type of permission extended to,
respectively, the owner, the owner's group, and other users.
Each subfield consists of three characters.
The first character indicates whether the file is readable; if it is,
then the character is an `r'; otherwise, it's a hyphen.
The second character indicates whether the file is writable; if it is,
then the character is a `w'; otherwise, it's a hyphen.
The third character indicates whether the file is executable; if it is,
then the character is an `x'; otherwise, it's a hyphen.
.PP
In the above example, file \fBfile01\fR has permissions:
.DM
	-rw-r--r--
.DE
These grant read and write permission to its owner,
read permission to the other members of the owner's group,
and read permission to all other users.
.PP
The \*(CO system has a set of default permissions that it applies to
every file when it's created.
To change this default set of permissions, use the command \fBumask\fR.
For information about this command, see its entry in the Lexicon.
To change the permissions of an existing file, use the command \fBchmod\fR,
as described in the following sub-section.
.Sh "chmod: Change File Permissions"
.PP
.II chmod
.II permission^write
.II "write permission"
To change the mode of a file, use the change-mode command \fBchmod\fR.
For example, to protect file \fBdoc1\fR in directory \fBbackup\fR
from being overwritten, use the command:
.DM
	chmod -w backup/doc1
.DE
where the \fB-w\fR means ``remove write permission''
and is followed by the file name.
Henceforth, if you try to write into this file, the \*(CO system
will refuse to do so and will print an error message on your screen.
.PP
.II permission^read
.II "read permission"
To allow other users to read the backup file \fBdoc2\fR, type:
.DM
	chmod o+r backup/doc2
.DE
where the letter \fBo\fR signifies ``other users'', and the \fB+r\fR tells
\fBchmod\fR to grant read permission.
.PP
To see the new set of permissions, type the command:
.DM
	ls -l backup
.DE
As you can see, the mode string has changed from what it was above.
.PP
Directory access permissions are similar to file access permissions
in that they can easily be changed via command
.BR chmod .
However, the permission bits have different meanings for directories.
Permitting reads on a directory allows the user to see
the contents of the directory via commands such as
.B lc
or
.BR ls ;
permitting execution on a directory allows access to the files
in the directory;
and permitting writes on a directory allows the user to create
or delete files in the directory, regardless of the permissions
on the actual file.
The latter causes the most difficulty for new users since
they mistakenly associate file deletion permissions with the
actual file rather than with the directory that contains the file.
.Sh "Creating and Mounting a File System"
.PP
Earlier, we described how the \*(CO system consists of a tree of
directories; and how that tree branches from the root directory `/'.
This is a useful description, and true as far as it goes; but the full
situation is a little more complex.
.PP
The tree of \*(CO directories in fact consists of any number of
\fIfile systems,\fR each of which exists on its own physical device.
A \fIphysical device\fR may be a partition on your hard disk, a floppy
disk, or even a chunk of RAM.
.PP
The \*(CO system contains a suite of commands that let you create
a new file system on a physical device, and graft (or \fImount\fR) that
new file system onto the \*(CO directory tree.
The following few sub-sections will walk you through the steps of creating
a new file system on a floppy disk and mounting it onto your existing
\*(CO directory tree.
These descriptions may be a bit too advanced for beginners; but most users
will find them to be interesting and helpful.
.Sh "fdformat: Format a Floppy Disk"
.PP
The first step in creating our new file system is to format a floppy disk.
The command
.B fdformat
formats a diskette.
When a diskette is formatted, \*(CO writes information on each
track that makes it possible for the floppy disk to hold a file system.
.PP
.B fdformat
uses the following syntax:
.DM
	/etc/fdformat \fIdevice\fR
.DE
where
.I device
is the name of the device to be formatted.
To format a high-density, 5.25-inch diskette, use the command:
.DM
	/etc/fdformat /dev/rfha0
.DE
To format a high-density, 3.5-inch diskette, type:
.DM
	/etc/fdformat /dev/rfva0
.DE
To format a low-density, 5.25-inch diskette, type:
.DM
	/etc/fdformat /dev/rf9a0
.DE
For this example, we'll assume that you have a high-density, 5.25-inch
floppy disk.
Insert into drive 0 (that is, drive A) of your computer, and type the
command:
.DM
	/etc/fdformat -v /dev/rfha0
.DE
The \fB\-v\fR option to \fBfdformat\fR tells it to verify that the disk
is sound.
This option means that the command will take longer to execute, but
in the long run it's worth it as it will ensure that you do not waste
time to trying to copy data onto a flawed disk.
For details on the command
.BR fdformat ,
see its entry in the Lexicon.
.PP
When this command has finished executing, leave the floppy disk in drive 0.
.Sh "mkfs: Create a File System"
.PP
.II mkfs
.II file^prototype
The command
.B mkfs
creates a file system on a physical device.
This command has the following syntax:
.DM
	/etc/mkfs \fIspecial proto\fR
.DE
\fIspecial\fR names the physical device on which the file system is
to be built.
\fIproto\fR is either a number or a file name.
If it is a number, \fBmkfs\fR builds a file system of that size in blocks.
.PP
For our example, type the command:
.DM
	/etc/mkfs /dev/fha0 2400
.DE
This command writes a file system onto device \fB/dev/fha0\fR, which
in this case represents the floppy disk in drive 0 that we just formatted.
The number 2400 represents the number of blocks that fits onto such a disk.
Please note that the above example is for a 5.25-inch, high-density floppy
disk.
For directions on how to create a file system on a floppy disk of different
size or density, see the Lexicon articles for
.B "floppy disks"
or
.BR mkfs .
.PP
.II prototype
If \fIproto\fR is not a number,
.B mkfs
assumes that it is a prototype file.
The command
.B badscan
scans a physical device for bad blocks and writes such a prototype file for
you.
Prototype files are beyond the scope of this example; but for information
on them see the Lexicon entry for \fBbadscan\fR or the Lexicon entry for
\fBfloppy disks\fR.
The latter article summarizes all the ways in which floppy disks are used
by the \*(CO system.
.Sh "mount: Mount a File System"
.PP
.II mount
Now that you have formatted your floppy disk and built a file system
on it, you can \fImount\fR the newly created file system.
\fIMounting\fR grafts this device's file system onto the \*(CO system's
directory tree.
Thereafter, you can write files onto that device, read them, remove them,
or do anything else that you wish with that device and its contents.
.PP
.B mount
has the following syntax:
.DM
	/etc/mount \fIdevice directory\fR
.DE
.I device
names the physical device whose file system is to be mounted.
.I directory
names the \fIbase directory\fR for that file system.
The base directory is the directory by which the file system is accessed.
For example, directory \fB/usr\fR is the base directory for the file system
that holds all users' home directories.
We'll describe base directories a little further in a few paragraphs.
.PP
For purposes of our example, type the following command:
.DM
	/etc/mount /dev/fha0 /f0
.DE
This mounts the file system on the disk in drive 0 onto base directory
\fB/f0\fR.
.PP
The base directory by convention is a directory in the root directory `/'.
You do not have to do this, however.
For example, if your user name was \fBhenry\fR and you wished to mount
the file system on the floppy disk in your home directory, you could type:
.DM
	/etc/mount /dev/fha0 /usr/henry/backup
.DE
This will mount the file system on the floppy disk onto directory
.B /etc/henry
and name its base directory as
.BR backup .
Note that if directory
.B backup
already existed in directory
.BR /usr/henry ,
its contents will be inaccessible until you unmount the file system
on the floppy disk.
Unmounting is discussed in the following sub-section.
.PP
For more information on mounting a file system, see the Lexicon
article \fBmount\fR.
.Sh "Using a Newly Mounted File System"
.PP
Now that you have created and mounted a file system, you can use it like
any other directory.
To see how this works, type the following command:
.DM
	cat >/f0/testfile
	Here's some text we're writing onto the
	newly mounted file system on a floppy disk.
	<ctrl-D>
.DE
Here you can use the \fBcat\fR command to write some text into file
.BR testfile ,
which lives on the floppy disk you just mounted.
To see that this text has been written there, type:
.DM
	cat /f0/textfile
.DE
You should see the floppy-disk drive whirl briefly, and the following
appear on your screen:
.DM
	Here's some text we're writing onto the
	newly mounted file system on a floppy disk.
.DE
You can now use this file system like any other, even though it lives on
a floppy disk rather than your hard disk.
As you can see, this is an easy way to extend the size of your \*(CO
system's file system.
.Sh "umount: Unmount a File System"
.PP
.II umount
Finally, when you have finished working with a file system, you must use
the command
.B umount
to un-mount it.
This command prunes the file system on a given physical
device from the \*(CO system's directory tree.
You will use this command frequently as you use floppy disks.
.PP
.B umount
takes one argument:
the name of the physical device being unmounted.
In our example, the command
.DM
	/etc/umount /dev/fha0
.DE
unmounts the file system on the high-density, 5.25-inch floppy disk
insert into drive 0 (that is, drive A) on your computer.
.PP
Under unsophisticated operating systems like \*(MD, you can insert or
remove floppy disks without giving the matter a second though.
The \*(CO system, however, uses a complex set of buffers to speed
the reading and writing of information to the floppy disk; for this
reason, if you simply yank a floppy disk out of its drive, all of the
information in the \*(CO system's buffers will be lost.
Worse, if you yank out a floppy disk and insert a \*(CO-formatted
floppy disk, the \*(CO system will write the data in its buffers onto
that new floppy disk \(em and probably destroy its file system in the process.
Unmounting a file system tells the \*(CO system to flush all information
in its buffers and write it onto the disk.
.PP
To emphasize this point, please read the following carefully:
.PP
.I
If you mount a floppy disk, you must use the \fBumount\fP command
to unmount it before you remove the disk from its drive.
If you do not, data will be destroyed.
.R
.PP
This concludes the discussion of how to mount create a file system,
mount it, and use it.
See the Lexicon article \fBfloppy disks\fR for further information on
how to do this task.
.PP
The following two sub-sections discuss how to check a file system,
to ensure its integrity.
.Sh "fsck: Check a File System"
.PP
The command
.B fsck
checks a file system, to ensure its integrity.
For example:
.DM
	fsck /dev/root
.DE
where \fB/dev/root\fR is a disk device, checks the file system
located on device \fB/dev/root\fR.
.PP
.II "root^file system"
.II "file system^root"
.II umount
.II fsck
If possible, you should
.B umount
the file system before you check it.
You cannot \fBumount\fR the root file system.
If you can't unmount it, be sure that no other users are on the system
(i.e., that you are in single-user mode),
then reboot the system immediately \fIwithout\fR performing a
.BR sync .
.II sync
If other users are creating or expanding files
while the file systems are being checked,
.B fsck
will report false errors.
.PP
.II i-node^list
If \fBfsck\fR finds any discrepancies,
it writes appropriate messages onto the console (that is, the screen
directly plugged into your computer).
An absence of messages indicates that there are no
problems with the file system.
The appendix to this manual gives all of \fBfsck\fR's error messages,
and suggests how you should respond to each.
.PP
\*(CO's boot routines run \fBfsck\fR automatically, and will rerun it
if necessary to fix problems with the file system.
For more information on \fBfsck\fR, see its entry in the Lexicon.
.Sh "Devices, Files, and Drivers"
.PP
The next few sub-sections introduce the topic of special files and devices.
You brushed this topic in the earlier section that described how to format
and mount a file system on a floppy disk; the following few sections go into
it more systematically.
Beginners will probably find that much of this sub-section is
mystifying, but experienced users and ambitious beginners probably
will find much of value here.
.PP
.II "device-independent I/O"
To begin, the \*(CO system is designed to provide device-independent I/O.
Devices and files are handled in a consistent way.
Each I/O device is represented as a \fIspecial file\fR in directory \fB/dev\fR.
For example, if your system has a line printer device named \fBlp\fR,
you can list a file, named \fBprog\fR for example, on the printer by saying:
.DM
	cat prog >/dev/lp
.DE
Another example is to copy the file \fBprog\fR with the \fBcp\fR command to
your terminal:
.DM
	cp prog /dev/tty
.DE
There are two types of special files represented in
.B /dev ,
and when you list
.B /dev
with \fBlc\fR it will separate them.
.PP
.II "special file^block"
.II "file^block special"
The first type is a \fIblock special\fR file.
This type includes disks and magnetic tape.
These devices are read and written in blocks of 512 bytes,
and can be randomly accessed.
(As a practical note, note that magnetic tape can be
read in a random fashion only by positioning backwards and forwards one
record at a time; disks can be read or written in a totally random fashion.)
.PP
The I/O to and from block devices is buffered to improve overall system
performance.
When a program writes a block of data, the data are held
in a buffer to be written at a later time.
If the same block is read twice in a row,
the data for it is still available in memory and do not
have to be fetched from the physical device.
.PP
.II /etc/update
.II sync
A special program named
.B /etc/update
forces all buffered data to the physical device periodically by calling the
command
.B sync ,
to protect against losing data in the case of an accident,
such as a power failure.
If you must bring the system down, you must force the latest data
to be written by typing the command \fBsync\fR.
.Sh "Character-Special Files"
.PP
.II "special file^block"
.II "file^block special"
.II "file^special character"
The second kind of special file is called a \fIcharacter-special\fR file.
Included in this class are devices that are not block special:
terminals, printers, and so on.
Disks and tapes can also be treated as character special files.
For every block special file for a disk, such as
.DM
	/dev/at0c
.DE
there is usually a character-special file:
.DM
	/dev/rat0c
.DE
.II "raw files"
.II file^raw
.II fsck
.II dump
Character-special files are sometimes called \fIraw\fR files, hence the prefix
\fBr\fR in \fBrat0c\fR.
A raw file has no buffering
or other intermediate processing performed on its information.
This difference is an efficient benefit to commands such as
.B dump
and
.BR fsck ,
which do their own buffering.
.Sh "tty Processing"
.PP
.II terminal^mode
.II "cooked files"
.II files^cooked
One special set of devices has other processing \(em the \fBtty\fR or
terminal files.
A terminal-special file with this special processing is
called a \fIcooked\fR device.
The processing includes handling the \fBkill\fR,
\fBerase\fR, \fBinterrupt\fR, \fBquit\fR, \fBstop\fR, \fBstart\fR, and
\fBend-of-file\fR characters.
Processing can be disabled with the command
.B stty
so the program deals with the raw device.
However, using a raw \fBtty\fR device generally has negative effects
on performance of the \*(CO system.
.Sh "A Tour Through the File System"
.PP
.II "file system^layout"
Our introduction to \*(CO's system of files and directories
concludes with a tour of the \*(CO file system.
Much of this material has been described earlier.
.Sh "General File System Layout"
.PP
.II directory^root
.II root^directory
.II /
The base of the file system is the \fBroot\fR directory, whose name is simply:
.DM
	 /
.DE
Most of the files in the root are directories.
To list the files in the \fBroot\fR directory, type:
.DM
	lc /
.DE
.Sh "/bin"
.PP
.II /bin
Most of the commonly used commands are programs contained in
.BR /bin ,
such as the command \fBlc\fR used in the above example.
Foreign commands, such as \*(ME and
.BR kermit ,
are placed in directory
\fB/usr/bin\fR.
.PP
.II directory^current
.II "current directory"
.II /
.II shell
.II sh
.II PATH
The shell
does not automatically look in \fB/bin\fR for commands, but consults
the variable
.B PATH
to determine where commands are to be found.
A typical value for \fBPATH\fR is:
.DM
	/bin:/usr/bin:.
.DE
This tells the shell to look for commands in three places (in this order):
.BR /bin ,
.BR /usr/bin ,
and finally \fB.\fR, the current directory.
The shell does not consult
.B PATH
if the command contains one or more \fB/\fR characters, indicating a complete
or partial path specification.
.Sh "/dev"
.PP
.II /dev
Devices in the \*(CO system are accessed through files in the directory
.BR /dev .
If there is a line printer available on the system named \fBlp\fR,
you can print characters from a file named \fBtestdata\fR by typing
the command:
.DM
	cat testdata >/dev/lp
.DE
All devices on the system are represented in the \fB/dev\fR directory.
Note that it is not recommended you access devices directly, but use the
\*(CO system's utilities that \fIspool\fR files to them.
This will prevent two users attempting to write material to a device
simultaneously, and so garbling the output.
For example, to access the line-printer device, use the spooler \fBlp\fR.
See the Lexicon's entries on \fBprinter\fR and \fBdevice drivers\fR.
.Sh "/drv"
.PP
.II /drv
A unique feature of the \*(CO system is the concept of loadable
device drivers.
This feature lets \*(CO system programmers write
their own device drivers without modifying the rest of the system.
Drivers can be unloaded, modified,
and reloaded without halting and rebooting the system.
Loadable drivers are kept in directory
.BR /drv .
To load a driver, type:
.II /etc/drvld
.II drvld
.DM
	/etc/drvld /drv/\fIdriver\fR
.DE
where
.I driver
is the driver to load.
See the Lexicon's entry on
.B drvld
for more information.
.Sh "/etc"
.PP
.II /etc
Several commands that you will use in your role as system administrator
are kept in directory
.BR /etc .
These are described in detail elsewhere in this guide.
They include commands for system accounting, booting the system,
mounting the system, create file systems, and control system time.
.PP
.II passwd
.II /etc/passwd
.II /etc/ttys
Also in
.B /etc
are several data files used in system administration.
These include \fB/etc/passwd\fR, the file containing user
names, ids, and passwords; news files; and file
.BR /etc/ttys ,
which describes the properties of each user terminal attached to the system.
.Sh "/lib"
.PP
.II "standard I/O"
.II /lib
The \*(CO system provides
many useful functions for performing input and output (I/O) and
mathematics, for use in your C programs.
These and other libraries, along with the
phases of the C compiler itself, are kept in directory
.BR /lib .
This directory includes files containing standard system calls,
standard I/O, and mathematical routines such as \fBsin\fR, \fBcos\fR,
and \fBlog\fR.
.Sh "/usr"
.PP
.II /usr
The directory
.B /usr
contains user directories, along with a few system directories.
.PP
.II /usr/adm
.B /usr/adm
contains additional information of interest to the system administrator.
.PP
.II /usr/bin
.B /usr/bin
contains commands that were not entirely created by Mark Williams Company.
.PP
.II /usr/games
.B /usr/games
contains computer games.
.II /usr/games/lib/fortunes
.B /usr/games/lib/fortunes
holds a set of \fIbon mots\fR; the game \fBfortune\fR
selects one at random and prints it on your screen.
A call to this game can be placed in a user's
.BR .profile ,
so he will see a new fortune each time that he logs on.
To add fortunes of your own, just edit the file
.BR /usr/games/lib/fortunes .
.PP
.II /usr/include
The directory
.B /usr/include
contains header files for C programs, such as
.BR stdio.h .
Other header files define formats of files and
other important data structures in the system.
.PP
.II "nroff macros"
.II ms
.II man
.II nroff
.II units
.II /usr/lib/crontab
.II cron
.B /usr/lib
contains the macro files
.B ms
and
.B man
used the \fBnroff\fR text processor; the unit conversion tables for the
command
.BR units ;
and the file
.B /usr/lib/crontab
used to hold commands for
.BR cron .
This directory also holds the C libraries.
.PP
.II /usr/man
.B /usr/man
contains manual sections referenced by the commands \fBman\fR
and \fBhelp\fR commands.
.PP
.II /usr/msgs
.B /usr/msgs
stores messages displayed by the command
.BR msgs .
.PP
.II /usr/pub
.B /usr/pub
contains public files, such as telephone numbers and a copy of the ASCII table.
.PP
.II /usr/spool
.B /usr/spool
contains information for line-printer spooling, and
mail that has not yet been delivered.
.Sh "/u"
.PP
.II /u
In some systems, users' directories are placed on a separate device to
save space.
Because a separate device has a separate file system, the
directory on that device is called
.BR /u .
.Sh "Files: Conclusion"
.PP
This concludes this tutorial's discussion of files and directories.
The rest of this tutorial introduces \*(CO's suite of commands,
and discusses topics of special interest to persons who are administering
\*(CO systems.
.SH "Introduction to COHERENT Commands"
.PP
This section introduces \*(CO's commands.
The \*(CO system comes with more than 200 commands, which perform a
variety of work, from formatting text, to editing files, to performing
low-level administration of the system.
The commands that manipulate files and directories were introduced in
the previous section;
there are, however, many other varieties of commands, many of which
will be introduced here.
To begin, we'll introduce the \*(CO system's master command, the
.IR shell .
.Sh "The Shell"
.PP
.II sh
.II shell
When you type commands into the \*(CO system, it appears that you
are communicating directly with the computer.
This is not exactly true, however.
When you type into the \*(CO system, you are actually working with
a special \*(CO program, the shell.
This program reads, interprets, and executes every
command that you type into the system.
The shell can also interpret, expand, and otherwise flesh out what you type;
this is done to help spare you unnecessary typing, and to permit you to
assemble powerful commands with only a few keystrokes.
.PP
Please note, in passing, that the \*(CO system comes with two shells:
the Korn shell \fBksh\fR and the Bourne shell \fBsh\fR.
These shells have somewhat different features.
The descriptions in this section assume that you are using \fBsh\fR,
which is \*(CO's default shell.
.PP
The shell is so powerful that mastering it is a major accomplishment;
however, you can take advantage of much of what the shell offers by
learning a few simple commands and procedures.
.PP
This section introduces some commands commonly used by \*(CO users.
For more information on these or other commands see \fBhelp\fR and \fBman\fR.
Also, consult the Lexicon.
.PP
Please note the following special punctuation characters:
.DM
	* ? [ ] | ; { }
	( ) $ = : \(ga ' " < > << >>
.DE
These characters have special meaning to the shell, and typing them can
cause the shell to behave quite differently from what you may expect.
Do not use these characters until you have read the following section,
which discusses their use, or until they are presented in examples.
.Sh "Redirecting Input and Output"
.PP
.II cat
.II >
.II who
.II "I/O redirection"
.II standard^output
.II "user name"
Most \*(CO commands write their output to the
\fIstandard output\fR device, which is normally your terminal's screen.
For example, \fBwho\fR prints on your terminal the name of each user
currently logged into your \*(CO system:
.DM
	who
.DE
By using the special character \fB>\fR,
you can redirect the output of \fBwho\fR into a file.
The command
.DM
	who >whofile
.DE
writes this information into \fBwhofile\fR.
The operator \fB>\fR tells \*(CO to \fIredirect\fR the standard output.
Later, you can list the information on your terminal using \fBcat\fR:
.DM
	cat whofile
.DE
Once the information is in a file, you can process it in other ways.
For example
.DM
	sort whofile
.DE
sorts the contents of
.B whofile
and prints the results on your screen.
In this way, you can display the users' names on your terminal
in alphabetical order.
.PP
.II mail
.II <
.II standard^input
You can also redirect the \fIstandard input\fR
to accept input from a file rather than from your terminal.
To redirect the standard input, use the special character \fB<\fR
before the name of the file that you want read as the standard input.
For example, the command \fBmail\fR
sends electronic mail to another user; normally, it \*(QLmails\*(QR
what you type on the standard input, but you can use \*(Ql<\*(Qr to
tell it to mail the contents of a file instead.
.DM
	mail fred < whofile
.DE
mails the contents of \fBwhofile\fR to user \fBfred\fR.
.Sh "Pipes"
.PP
.II pipe
.II |
The \fIpipe\fR is an important feature of the \*(CO system.
Pipes allow you to hook several programs together by redirecting
the output of one into the input of the next.
A pipe is represented by the character \*(Ql|\*(Qr in the command line.
.PP
.II filter
Most \*(CO programs are written to act as \fIfilters\fR.
A filter is a program that reads its input one line at a time or one
character at a time, performs some transformation upon what it has read,
and then writes the transformed data to the standard output device.
You can easily perform complex transformations on data by hooking a number
of simple filters together with pipes.
Consider, for example, the command:
.DM
	who | sort
.DE
Here, the command \fBwho\fR generates a list of persons who are
logged into the system.
The output of \fBwho\fR is then piped to the program \fBsort\fR, which
sorts the list of users into alphabetical order and prints them on the
standard error device.
.PP
The power and flexibility of the \*(CO operating system owes much to
the pipe.
.Sh "Superuser"
.PP
.II superuser
A special user in the \*(CO system, called the \fIsuperuser\fP,
has privileges greater than those of other users.
The superuser can read all files (except encrypted files) and execute
all programs.
You must be logged in as the superuser during certain
phases of your work as system administrator.
.PP
.II root
There are two ways to access the \*(CO system as the superuser.
The first is to login under the user name
.BR root .
When the system prompts
.DM
	Coherent 386 login:
.DE
reply:
.DM
	root
.DE
This automatically makes you
.BR superuser .
To remind you that you are superuser, the
\*(CO system prompts you with \fB#\fR instead of the usual \fB$\fR.
.PP
The second way to acquire the privileges of superuser is to issue the command
.DM
	su
.DE
when you are logged in as a user other than \fBroot\fR.
You must have privileges to access \fBroot\fR to do this,
and you must know the password for \fBroot\fR.
When you type
.DM
	<ctrl-D>
.DE
in this mode, \*(CO returns you to your previous identity.
.PP
To be the superuser for only one command, use the form of the command
.DM
	su root \fIcommand\fR
.DE
\fIcommand\fR is the command to be executed as superuser.
For example, to edit
the message of the day file \fB/etc/motd\fR if you are not the superuser, type
.DM
	su root me /etc/motd
.DE
When you finish using \*(ME, your original user id will be unchanged.
.PP
To limit access to privileged resources, the \*(CO system requires
users to enter \fIpasswords\fR before being granted that privilege.
Users may be required to enter passwords before logging in.
.PP
.II prompt
.II password
If the
.B root
user has a password, you will be prompted for it.
If you do not enter it correctly, the system will tell you
.DM
	Sorry
.DE
and not allow you to become the
.BR superuser .
.PP
It is normal practice to protect access to superuser status by setting the
password.
If you are the only user of your \*(CO system, or if you deeply trust
all other users, you do not have to do so.
However, because the superuser can perform any sort of mayhem on your system,
it is advisable to set the password, especially if outsiders can dial into
your system via modem.
.Sh "vsh:  The Visual Shell"
.PP
.II vsh
Some users prefer to work visually rather than type explicit commands on a
command line.
For these users, \*(CO offers the command
.BR vsh ,
its
.IR "visual shell" .
.PP
.B vsh
does
.I not
give you a true windowing system, like X or Microsoft Windows; nor does
it use a mouse.
However,
.B vsh
does give you a visual desktop for your files and commands.
You can use the arrow keys on your terminal or console to select a command
or a file; execute commands with one keystroke; program your function keys
to execute commands automatically; and in general make \*(CO easier to use.
.PP
.B vsh
is described in full in its Lexicon entry.
However, to get the flavor of
.BR vsh ,
try the following exercises:
.IP \(bu 0.3i
Before you begin, make sure that \*(CO knows what kind of terminal you
are working at.
To check that type the command:
.DM
	echo $TERM
.DE
If you are working at your computer's console, you should
.B ansipc
on your screen; whereas if you have logged in from an \*(BM plugged into
your computer's serial port, you should see the response
.BR vt100 .
If you do not see the correct response, do
.I not
do the following exercises, because all you will on your screen is a jumble.
.IP \(bu
If your terminal's type is set correctly, invoke the visual shell
by typing
.B vsh
on your command line.
.IP \(bu
In a moment,
.B vsh
draws its desktop on your screen.
You will see five windows:
Two long, narrow windows across the top of your screen;
a big window on the left;
and two small windows stacked on top of each other on the right.
The top narrow window has a number of commands in it; the large
window on the left displays all of the files in the current directory.
The top file displayed in the large, left window is highlighted.
.IP \(bu
The two stacked windows on the right of the screen give information
about your system.
They give, for example, the name of your system, the number of bytes
in the current directory, your login identifier, whether you have
mail waiting for you, and other information.
.IP \(bu
Press the arrow key \(da.
The bar of highlighting moves to the next name displayed in the
large, left window.
The scroll bar in the large, left window also creeps down a little.
Now, press the arrow key \(ua.
The highlighting bar moves up again.
.IP \(bu
Press
.B E
(for Exit).
.B vsh
opens a pop-up window and asks if you want to really exit.
Press \*(RT to accept the underlined option, `y'.
When you do so,
.B vsh
then exits and returns you to the \*(CO command line.
.PP
.B vsh
is a powerful command that makes \*(CO much easier for the average user.
See its Lexicon entry for details on its features and how to use it.
.Sh "Manipulating Text Under COHERENT"
.PP
The \*(CO system includes a number of commands and utilities with
which you can process text.
The phrase
.I "process text"
means to edit it and prepare it for printing.
.Sh "MicroEMACS: Text Screen Editor"
.PP
.II "MicroEMACS"
.II "me"
.II "screen editor"
\*(PN includes a full-featured screen editor, called \*(ME.
\*(ME allows you to divide the screen into sections, called
.IR windows ,
and display and edit a different file in each one.
It has a full search-and-replace function,
allows you to define keyboard macros, and has a large set of commands
for killing and moving text.
.PP
Also, \*(ME has a full help function for C programming.
Should you need information about any macro or library function that
is included with \*(PN, all you need to do is move the text cursor over
that word and press a special combination of keys; \*(ME will then
open a window and display information about that macro or function.
.PP
For a list of the \*(ME commands, see the Lexicon entry for
.BR me ,
the \*(ME command.
A following section of this manual gives a full tutorial on \*(ME.
In the meantime, however, you can begin to use \*(ME by learning a
half-dozen or so commands.
.PP
To invoke \*(ME, type the command
.DM
	me hello.c
.DE
at the \*(PN prompt.
This invokes \*(ME to edit a file called \fBhello.c\fR.
Now, type the following text, as it is shown here.
If you make a mistake, simply backspace over it and type it correctly;
the backspace key will wrap around lines:
.DM
	main()
	{
		printf("hello, world\en");
	}
.DE
When you have finished, \fIsave\fR the file by typing
.B "<ctrl-X><ctrl-S>"
(that is, hold down the control key and type `X', then hold down
the control key and type `S').
\*(ME will tell you how many lines of text it just saved.
Exit from the editor by typing
.BR "<ctrl-X><ctrl-C>" .
.PP
Now, re-invoke \*(ME by typing
.DM
	me hello.c
.DE
The text of the file you just typed is now displayed on the screen.
Try changing the word
.B hello
to
.BR Hello ,
as follows:
First, type
.B <ctrl\-N> .
That moves you to the
.I next
line.
(The command
.B <ctrl-P>
would move you to the \fIprevious\fR line, if there were one.)
Now, type the command
.BR <ctrl-F> .
As you can see, the cursor moved \fIforward\fR one space.
Continue to type
.B <ctrl-F>
until the cursor is located over the letter `h' in
.BR hello .
If you overshoot the character, move the cursor \fIbackwards\fR by typing
.BR <ctrl-B> .
.PP
When the cursor is correctly positioned, delete the `h' by typing the
.I delete
command
.BR <ctrl-D> ;
then type a capital \*(QlH\*(Qr to take its place.
.PP
With these few commands, you can load files into memory, edit them, create
new files, save them to disk, and exit.
This just gives you a sample of what \*(ME can do, but it is enough
so that you can begin to do real work.
.PP
Now, again \fIsave\fR the file by typing
.BR <ctrl-X><ctrl-S> ,
and exit from \*(ME by typing
.BR <ctrl-X><ctrl-C> .
.PP
Just as a reminder, the following table gives the \*(ME commands
presented above:
.DS
.ta 0.4i 1.75i
	\fB<ctrl-N>\fR	Move cursor to the \fInext\fP line
	\fB<ctrl-P>\fR	Move cursor to the \fIprevious\fP line
.sp \n(PDu
	\fB<ctrl-F>\fR	Move cursor \fIforward\fR one character
	\fB<ctrl-B>\fR	Move cursor \fIbackward\fR one character
.sp \n(PDu
	\fB<ctrl-D>\fR	\fIDelete\fR a character
.sp \n(PDu
	\fB<ctrl-X><ctrl-S>\fR	\fISave\fR the edited file
	\fB<ctrl-X><ctrl-C>\fR	Exit from \*(ME
	\fB<ctrl-Z>\fR	Save a file and exit
.DE
Note that on some terminals, the arrow keys will not work.
Note, too, that some remote terminals may have trouble using
.BR <ctrl-S> ,
if they use XON/XOFF to control flow.
In this case, use \fB<ctrl-Z>\fR instead.
.PP
For more information, see the tutorial for \*(ME included with
in this manual.
.Sh "pr, prps, lp: Print Files"
.PP
The command \fBlp\fR prints files for you, making sure that your request
does not conflict with other uses of the printer.
To print a file, type the command
.DM
	lp \fIfile\fR
.DE
substituting the name of the file to be printed for ``file''.
If you don't name a file on the command line,
.B lp
prints what it receives from the standard input.
Thus, you can use \fBlp\fR in pipes; this allows you to print immediately
matter that you type on your keyboard.
.PP
.B lp
will take your file and try to print it on any printer you have plugged into
your computer's parallel port.
If you do not have a printer plugged in, or if it is not turned on,
.B lp
will hold onto your files until the printer becomes ready;
it will wait days, if necessary, until the printer becomes available.
.PP
.B lp
is also intelligent enough to handle requests from several different users:
if more than one user wants to print a file,
.B lp
will print them one at a time.
In this way, the \*(CO system lets several users share one printer.
.PP
.II pr
.B lp
does nothing to the file other than print it.
This means that it does not attach page heading to a file,
nor does it break up the file into page-sized chunks.
Another command, \fBpr\fR, does this for you.
It paginates the standard input, giving a header with date, file name,
page number, and line numbers.
The paginated output appears on the standard output.
.PP
To print a paginated file on the line printer, type:
.DM
	pr \fIfile\fR | lp
.DE
Note the use of the pipe `|', which passes the output of
.B pr
as input to
.BR lp .
.PP
The command
.B prps
is like
.BR pr ;
however, it writes a file in the PostScript page-description language,
suitable for printing on a PostScript printer.
If you have PostScript on your system, you should use
.B prps
instead of
.B pr
to paginate text for printing.
.PP
\*(CO has many more features for printing files than can be covered here.
For more details on
.B lp
and on how to print text, see the Lexicon entry for
.BR printer .
.Sh "nroff, troff: Text Formatters"
.PP
.II nroff
.II troff
The commands
.B nroff
and
.B troff
format text for display or printing.
They are, in fact, text-formatting languages:
you type commands into your text file, and
.B nroff
or
.B troff
interprets the commands to format the text in the manner that you want.
.PP
.B nroff
and
.B troff
differ in the style of formatting that they perform.
.B nroff
formats text into monospaced font, like that on an ordinary typewriter,
Its output is suitable for display on the screen.
.B troff
formats text into proportionally spaced fonts, like those seen on this
page.
Its output is suitable for printing on a laser printer or other
sophisticated typesetting device.
The commands for
.B nroff
and
.B troff
closely resemble each other.
The following descriptions will assume that you are using
.BR nroff ,
but they apply to
.B troff
as well.
.PP
.BR nroff 's
programming language is quite complex and sophisticated.
This manual includes a tutorial that introduces \fBnroff\fR's
language.
You can, however, use \fBnroff\fR to perform simple formatting
tasks by using the \fBms\fR macro package.
The following describes some of the more commonly used \fBnroff\fR
commands.
.PP
To see how \fBnroff\fR works, type the following script:
.DM
	cat >script.r
	.ds CF "Print on Bottom of Each Page"
	Here is some text.
	Here is some more text.
	.PP
	The above command set a new paragraph.
	Yet more text.
	.SH
	Here is a Section Heading
	.PP
	More text.
	\efBThis is printed in bold face.\efR
	This printed in Roman.
	\efIThis is printed in italics or underlined.\efR
	.PP
	Here's some more text.
	Here's yet more text.
	And more text yet.
	<ctrl-D>
.DE
Now, format and display the text with the following command:
.DM
	nroff -ms script.r | more
.DE
You will see the text formatted for your screen.
The string \fB Print on Bottom of Each Page\fR appears at the bottom
of the display.
The following describes the \fBnroff\fR commands with which this formatting
was performed.
.PP
.BR nroff 's
commands are introduced in either of two ways:
by a period `.' in the \fIfirst\fR column of a line; or by a backslash `\e'
occurring anywhere in a line.
The following reviews this script in detail.
.IP "\fB.ds CF\fR"
This defines the text to appear on the bottom of each page.
If the text is more than one word long, it must be enclosed within quotation
marks.
.IP "\fB.PP\fR"
Begin a new paragraph.
.B nroff
skips one line and indents the following line by five spaces (one-half inch).
.IP "\fB.SH\fR"
Print a section heading.
.B nroff
skips one line and prints in boldface
the line of text that follows this command.
.IP \fB\efB\fR
Print the following text in \fBboldface\fR.
.IP \fB\efR\fR
Print the following text in Roman.
.IP \fB\efI\fR
Print the following text in \fIitalics\fR.
.PP
With these few commands, you can perform simple formatting of your text.
.PP
To print the formatted text, use the command
.BR lp .
For example, to print \fBscript.r\fR on a line printer, use the command:
.DM
	nroff -ms script.r | lp
.DE
This discussion is sufficient to get you started, but it just scratches the
surface of what you can do with \fBnroff\fR and \fBtroff\fR.
See their respective entries in the Lexicon for details of what these commands
can do.
See the tutorial for \fBnroff\fR that appears later in this manual for a
thorough introduction to the formatting language used by these commands.
.Sh "Miscellaneous Commands"
.PP
\*(CO includes numerous commands that perform miscellaneous tasks.
These include some of the most useful, and entertaining,
commands in the \*(CO system.
.Sh "who: Who Is on the System"
.PP
.II who
To find who is logged into the system, use the \*(CO command \fBwho\fR.
This command lists who is logged into the \*(CO system, one name per line.
You will see your own user name there as well.
.PP
If you sit down at a terminal that is not in use, but at which
someone has already logged in, the following
command tells you who is logged in:
.DM
	who am i
.DE
\*(CO replies with the name of the user logged in at that terminal.
.Sh "write: Electronic Dialogue"
.PP
.II msg
.II write
.II <ctrl-D>
The command \fBwrite\fR lets you carry on a ``conversation'' with another user.
The conversation continues until you or the other user type
\fB<ctrl-D>\fR on his terminal.
.PP
.II write
For example, user \fBfred\fR
can begin a conversation with user \fBanne\fR by typing:
.DM
	write anne
.DE
On \fBanne\fR's terminal, the message
.DM
	Message from fred...
.DE
will appear.
To establish the other half of the communication, \fBanne\fR should then say
.DM
	write fred
.DE
and a similar notification appears on \fBfred\fR's terminal.
.PP
.II write
At this point, both users simply type lines on their terminal and \fBwrite\fR
sends the message to the other user.
To avoid typing at the same time, each user should end
a ``speech'' by typing a line that has the single letter
.DM
	o
.DE
to signify ``over'', or ``go ahead''.
When the other user sends you this, you know it is your turn to ``talk'',
and vice versa.
.PP
.II write
When your communication is finished, you should type
.DM
	oo
	<ctrl-D>
.DE
Here, \fBoo\fR means ``over and out'',
and the \fB<ctrl-D>\fR terminates the \fBwrite\fR command.
Note that \fBo\fR and \fBoo\fR are polite conventions,
and are not necessary to using \fBwrite\fR.
.Sh "mail: Send an Electronic Letter"
.PP
.II mail
You can send electronic mail to another user on your \*(CO system by using
the command
.BR mail .
This command works whether or not that person is logged into the system at
the time you type your message.
The message is stored in an electronic \*(QLmailbox\*(QR, and the user will be
notified that a message is waiting for him the next time he logs into your
system.
.PP
Before you can use \fBmail\fR on your system, you must run the program
\fBuuinstall\fR.
This program will ask you some questions about how you have configured
your \*(CO system, and will write files of information that \fBmail\fR
and the communications protocol \*(UU need to deliver your mail.
For detailed directions on how to run \fBuuinstall\fR, see the section
\fIInstalling UUCP\fR in the \*(UU tutorial that appears later in this manual.
.PP
Among other things, this program will ask you to name your ``site'' and
your ``domain''.
Without going into too much detail at this point, the site is
\fInom de plume\fR by which your machine is known to other \*(CO or
\*(UN systems.
Site names generally are not computer-ese; \fBconan\fR, \fBterminator\fR,
\fBlepanto\fR, \fBchelm\fR, and \fBsmiles\fR are all examples of site names.
If you don't intend to communicate with other systems, use your first name
as the site name.
The domain is the name by which a group of related machines are together known.
If you and a number of other local \*(CO systems wish to be known together,
you can establish a domain and register it with the network.
Domain names, too, should be descriptive.
If you don't intend to use a domain, set the domain name to \fBUUCP\fR.
.PP
To mail a message to user \fBanne\fR, just type:
.DM
	mail anne
.DE
.B mail
immediately prompts you for a title for your message:
.DM
	Subject:
.DE
You can type the message's subject, which will be used to title the message,
or you can just press \*(RT.
.PP
Once you have titled your message, type the body of the message.
You can conclude your message in any of three ways:
you can type \fB<ctrl-D>\fR, type a period `.' at the beginning of a line,
or a question mark `?' at the beginning of a line.
The first two methods end the message immediately; the last method, however,
invokes an editor, and lets you edit the message further before sending
it on to the intended recipient.
Environmental variable
.BR EDITOR ,
if defined, selects the editor to be used.
.PP
For example, to send your message to user \fBanne\fR, you might do the
following.
First, invoke \fBmail\fR:
.DM
	mail anne
.DE
Next, give your message a title:
.DM
	Subject:  I'll be working late
.DE
Finally, type the body of the message:
.DM
	I'll be working late.  I hope to get home before Catherine
	and George go to bed.  Please remind Ivan and Marian to do
	their homework.  Marian should remember to practice her
	violin.
	\fB<ctrl-D>\fR
.DE
If you wish, you can first type your message into a file and then mail it.
For example:
.DM
	cat >hb.msg
	All come to the birthday party at four
	next to the pump room.
	<ctrl-D>
.DE
To mail the message to user \fBjill\fR, type:
.DM
	mail jill <hb.msg
.DE
You can send a mail message to several users at one time by listing each
user's name on the command line.
For example, the command
.DM
	mail jill jack ted barb < hb.party
.DE
mails the contents of file
\fBhb.party\fR to \fBjill\fR, \fBjack\fR, \fBted\fR, and \fBbarb\fR.
To illustrate the use of the mail command, send yourself a mail message.
Type the following;
substitute your user name for ``you'' in the mail command:
.DM
	mail you
	Subject:  test the COHERENT mail system
	This is a note to
	myself to test
	mail.
	.
.DE
.II mail^receiving
.II "receiving mail"
If someone has sent you mail, the \*(CO system will tell you:
.DM
	You have mail.
.DE
when you log in.
.PP
To receive mail, type the \fBmail\fR command with no parameters:
.DM
	mail
.DE
If you have no mail, \*(CO will tell you:
.DM
	No mail.
.DE
If you do have mail, the system will print
each message on your terminal, along
with the user name of the sender, and the date and time that the message
was mailed.
.PP
.II mail
.II <Return>
After each message, the \fBmail\fR program types a question
mark \fB?\fR and waits for your reply.
You can type any of the following commands in reply to the prompt:
.IP \fBd\fR
Delete the message.
.IP \fB<Return>\fR
Proceed to the next message.
.IP "\fBs \fIfile\fR"
Save, or copy, the message into
.IR file .
.IP \fBq\fR
Quit \(em exit from \fBmail\fR and return to the shell.
.PP
You will know that you are finished with all of your messages when
\fBmail\fR sends you a \fB?\fR without typing anything before it.
.PP
.B mail
can also send messages to other \*(CO or \*(UN systems via the \*(UU utility.
See the accompanying tutorial on \*(UU to see how you can set up
\*(CO to do this.
.Sh "msgs: Cumulative Message Board"
.PP
.II msgs
The message of the day disappears when a new message is inserted.
If a user does not log in for several days,
the message of the day may no longer be there.
For items that you want everyone to see,
such as hours of operation or new operating procedures, you should use
.B msgs
instead of
.BR motd .
.PP
.B msgs
helps users get all important messages, even if they don't log in every day.
The system remembers which users have seen each message.
After a user logs in, invoking
.B msgs
will show the number, date, and author of each message
written since the user last logged in.
Therefore it is easy for the
user to stay up to date with the system-wide messages.
.PP
To add a message to the file, simply mail the message to
.BR msgs .
To title the message, write it as the first line in the message,
after the ``Subject:'' prompt from
.BR mail .
.PP
The home directory for \fBmsgs\fR will grow over time, as more and more
messages accumulate.
Also, if a new user is enrolled on your \*(CO system, he may have to
wade through several hundred messages when he first logs in.
Therefore, you should purge the home directory for \fBmsgs\fR every now
and again; you may wish to throw away the announcements of office parties
three Christmases ago, and save important information on diskette.
.PP
.B msgs
keeps track of what messages each user has read by recording the number
of the last message read in the file
.BR $HOME/.msgsrc .
When each user logs on, his version of
.B \&.msgsrc
is inspected to determine the last message seen.
If messages were added after that,
.B msgs
prints the ones the user wants to see, and then updates
.BR \&.msgsrc .
.Sh "grep: Find Patterns in Text Files"
.PP
.II grep
.II patterns
.II "regular expressions"
The command
\fBgrep\fR lets you find lines that contain a \fIpattern\fR within one
or more files.
Patterns are sometimes called \fIregular expressions\fR.
.PP
.II grep
To illustrate \fBgrep\fR, create file \fBdoc1\fR by typing:
.DM
	cat >doc1
	a few lines
	of text.
	<ctrl-D>
.DE
Then the command
.DM
	grep text doc1
.DE
prints the second line of file \fBdoc1\fR:
.DM
	of text.
.DE
.II patterns
The first parameter to \fBgrep\fR is the \fIpattern\fR
for which you are looking;
the rest of the arguments are the names of files to be examined.
\fBtext\fR is the pattern and \fBdoc1\fR is the file.
.PP
To find if a particular user is on the system, pipe \fBwho\fR into \fBgrep\fR:
.DM
	who | grep you
.DE
(Substitute the user name in question for \fByou\fR.)
Try it with your user name.
The pattern is \fByou\fR, but no file name is specified.
\fBgrep\fR reads input from the standard input, which in this example
is connected to the output of the \fBwho\fR command.
.PP
You can specify several files to be searched;
simply put the additional file names after the first:
.DM
	grep pattern doc1 doc2
.DE
Or, you can search all files in the current directory for the pattern with
.DM
	grep pattern *
.DE
The asterisk will be interpreted to mean all files,
and grep will look for \fIpattern\fR in each.
.PP
.II grep
.II patterns
The search pattern can be a \fIpattern\fR.
Patterns are fully discussed in the tutorial for
.BR ed .
.PP
You can also locate lines that do \fInot\fR contain given patterns by using
the \fBgrep\fR option \fB-v\fR.
.DM
	grep -v bugs prog1 prog2
.DE
This command finds and prints all lines in files \fBprog1\fR and
\fBprog2\fR that do not contain the pattern \fBbugs\fR.
.Sh "date: Print the Date"
.PP
.II date
.II time
The \*(CO system keeps track of the time and date.
To find the date and time, use the command:
.DM
	date
.DE
\*(CO responds with the day of the week, the month day and year,
and the time of day.
.PP
.II GMT
.II timezone
Internally, the \*(CO system records
the date and time as the number of seconds since January 1, 1970,
00:00:00 Greenwich Mean Time (GMT).
This means that files created in one time zone and
referenced in another time zone will bear the correct time.
The time and date printed out is converted from the internal form to the
local time.
.Sh "passwd: Change Your Password"
.PP
.II password
You should change your password from time to time, to ensure that no
unauthorized person can gain access to your files (or to the system as a whole).
.PP
It is easy to change passwords on the \*(CO system:
.II passwd
just type the command \fBpasswd\fR.
.B passwd
first asks you for your current password (if you have one),
and then asks you to enter your new password twice.
Entering the new password twice helps ensure that the system gets the
password as you want it.
If you do not type it the same way both times, \*(CO will say:
.DM
	Password not changed.
.DE
You must then begin again with the command \fBpasswd\fR.
.PP
Be sure the password is something that you can remember.
It is recommended that the password be at least six characters long.
Do not write it down, but memorize it.
You can use a four-letter password, but if you do, you
should mix upper-case and lower-case letters to make it more difficult
for outsiders to guess.
.Sh "stty: Change Terminal Behavior"
.PP
.II terminal
Because a wide variety of terminals can be used with the \*(CO
system, you must pass some information to
the \*(CO system so it can handle your terminal correctly.
.PP
.II stty
The command
.B stty
describes the information \*(CO currently has for you;
you can then use
.B stty
with arguments to change how \*(CO handles your terminal.
.PP
For example,
\*(CO normally echoes each character you type, as you type it.
However, if your terminal also echoes what you type,
you will see double characters.
To prevent this, issue the command:
.DM
	stty -echo
.DE
The program
.B login
uses this feature when you type your password, to help keep it secret
from anyone who is kibbitzing at your desk.
.PP
To set the echo feature again, type:
.DM
	stty echo
.DE
.II tab
When you first log in, the system presumes that your terminal does not
directly handle the \fBtab\fR character, so when \*(CO sends a \fBtab\fR to
your terminal it simulates it with spaces.
If your terminal does handle tabs, issue the command:
.DM
	stty tabs
.DE
The \*(CO system will no longer substitute spaces for tabs.
To go back to substitution,
.DM
	stty -tabs
.DE
.II kill
.II erase
.II <kill>
.II <erase>
The
.B <erase>
character lets you delete the previously typed character.
The \fB<kill>\fR character lets you delete the line that you have been
typing but have not yet finished.
By default, \*(CO sets these to, respectively, \fB<ctrl-H>\fR and
\fB<ctrl-U>\fR.
To change them to, respectively, \fB<ctrl-E>\fR and \fB<ctrl-K>\fR,
use the \fBstty\fR command as follows:
.DM
	stty erase ^E kill ^K
.DE
The carat `^' tells \fBstty\fR that you want to specify a control character.
.PP
.II kill
.II erase
To reset erase and kill to the default values at login, the command
.DM
	stty ek
.DE
suffices.
This is equivalent to:
.DM
	stty erase ^H kill ^U
.DE
To see what your current terminal parameter settings are, type
.DM
	stty
.DE
with no arguments.
.Sh "Scheduling Commands For Regular Execution"
.PP
.II "event scheduling"
The command \fBcron\fR is a valuable tool for using your \*(CO system.
With it, you can instruct \*(CO to execute commands at various times of
the day or night, even if nobody is logged into the system.
.PP
To specify a command to be executed at some later time, simply enter
one line of information in a ``cron'' file.
(Where the cron file lives will described below.)
For example, assume that you want to greet user
.BR norm ,
if he is logged into the system on Monday morning.
You can do this by sending him a message at 8:13 on Monday.
Use \*(ME to add the following line to the cron file:
.DM
	13 8 * * 1	msg norm%You are sure in early!
.DE
The numbers and \fB*\fR at the beginning specify the time:
.DM
	13 8 * * 1
.DE
The \fB13\fR means ``13 minutes past the hour''.
(\fBcron\fR numbers the minutes zero through 59.)
The \fB8\fR means ``8 AM''.
(\fBcron\fR numbers the hours of the day zero through 23, with zero
indicating 12 AM.)
The positions containing
.B *
normally specify the day and month.
The two \fB*\fR characters mean ``any day'' and ``any month''.
Finally, the \fB1\fR means ``day 1 of the week,'' which is Monday.
(\fBcron\fR numbers the days of the week zero
through six, with zero indicating Sunday.)
The breakdown of this command is shown as follows:
.DS
.ta 0.5i 1.5i
	minute	13
	hour	8
	day of month	* \(em all days
	month	* \(em all months
	day of week	1 \(em Monday
.DE
Because each entry in the cron file must be on one line, the symbol
.B %
represents the beginning of the input string.
If the information is too long for one line, type a backslash character
before you press \*(RT to end the line.
The backslash tells
.B cron
to ignore the \fB<Return>\fR character.
.PP
With this information in the file, \fBcron\fR executes the command
.DM
	msg norm
	Am Monday!
.DE
at 8:13 every Monday morning.
.PP
.II "24-hour time"
.II cron
.B cron
expects time to be in the 24-hour clock,
so 1 PM is represented as \fB13\fR hours.
If you need to print a literal percent sign `%', precede it with a backslash:
.DM
	\e%
.DE
The times for
.B cron
commands can be even more complex than the numbers and \fB*\fR shown above.
.PP
.II "- (hyphen)"
You can express a range for any of the five parts
of a time by separating two numbers with a hyphen.
For example, to send user
.B marianne
a humorous message on week days, use the command:
.DM
	59 11 * * 1-5	 /usr/games/fortune | msg marianne
.DE
.II ", (comma)"
To list a choice of times, separate single numbers
or ranges with commas but no spaces.
To send notification about a meeting on Monday, Wednesday,
and Friday at 3 PM, use:
.DM
	0 15 * * 1,3,5	 echo Meeting at 3:30 ... | mail fred anne joe
.DE
The time specification
.DM
	0 15 * * 1,3,5
.DE
represents the time 1500 (3 PM) on every Monday, Wednesday, and Friday.
.PP
.B mail
and
.B msg
are just some examples of commands that can be used with
.BR cron ;
many others can be used.
For example, \fBcron\fR is commonly used to execute \*(UU commands late at
night, when telephone rates are low.
See the Lexicon article on \fBcron\fR for more information about this command.
If you wish to schedule commands to be run but not on a regular basis,
use command
.BR at .
See its Lexicon article for further details.
.PP
As was mentioned above, you must edit a cron file for the \fBcron\fR
daemon to execute a command automatically.
\*(CO uses a complex scheme of cron files.
If the file \fB/usr/lib/crontab\fR exists, the \fBcron\fR daemon will read
it \(em and only it.
However, if \fB/usr/lib/crontab\fR does not exist,
the \fBcron\fR daemon will look in directory \fB/usr/spool/cron/crontabs\fR
for the set of cron files located there.
Each user can have his own cron file.
All commands in a user's cron file are executed with the suite of permissions
granted to that user; thus, a user cannot use \fBcron\fR to delete files that
do not belong to him.
If a user wishes to create or update his own cron file, use the command
\fBcrontab\fR; see its entry in the Lexicon for details.
.PP
Please note that each flavor of cron file uses the syntax described above.
.Sh "Managing Processes"
.PP
A
.I process
is a command that is undergoing execution.
Because \*(CO is a multi-tasking operating system, numerous processes
can be undergoing execution at the same time.
The following commands let you monitor and, within limits,
affect the operation of the processes your \*(CO system is executing.
.Sh "ps: List Active Processes"
.PP
.II process
.II process^id
.II PID
Each process in the system is assigned a number called the \fIprocess id\fR,
or \fIPID\fP.
Each user logged into the system has one or more processes.
Except in special circumstances,
the first process that he has is the shell, or command-line interpreter.
The commands he types are run by the shell.
.PP
The shell normally waits for a command to terminate
before it begins to process the next command.
.II &
However, if you use the `&' operator,
the shell creates simultaneous processes:
that is, while it executes one command it will let you type another.
Thus, you can execute two or more commands simultaneously.
.PP
.II ps
.II process^id
You can examine the processes associated with your login, or all
processes in the system, with the command
.BR ps .
Type:
.DM
	ps
.DE
The result will resemble:
.DM
	TTY       PID  COMMAND
	color0     36  ksh
	color0   4004  mail
	color0   4005  me
	color0   4009  sh
	color0   4010  ps
.DE
The first column
names the terminal you are running on, in this case the virtual console
.BR color0 .
.II /etc/ttys
This identifier is taken from the file
.BR /etc/ttys ,
with the prefix \fBtty\fR removed from name.
The \fBtty\fR identifier is also printed by the command \fBwho\fR.
The second column
lists the corresponding process identifier (PID).
The third column names each command and gives its parameters, if any.
.B ksh
represents the shell process,
and \fBps\fR represents the \fBps\fR command itself.
.PP
To see all the processes, type:
.DM
	ps -a
.DE
The result will resemble:
.DM
	TTY       PID  COMMAND
	null        1  init
	color3     33  ksh
	color2     34  ksh
	color1     35  ksh
	color0     36  ksh
	com3l      37  login
	color3   3629  sh
	color3   3630  kermit
	color3   3631  kermit
	color0   4004  mail
	color0   4005  me
	color0   4011  sh
	color0   4012  ps
.DE
This display will, of course, differ quite a bit from system to system
and from minute to minute.
.PP
For a full description of all options to
.BR ps ,
see its entry in the Lexicon.
.Sh "kill: Signal Processes"
.PP
.II kill
Occasions will arise when the system administrator
must log other users out of the system.
For example, you may need to bring the system down quickly; or
perhaps a user forgot to log out before leaving the terminal and
did not see your broadcast message requesting that all users log out.
.PP
.II superuser
.II kill
.II root
.II su
The command
.BR kill ,
when used by the superuser, terminates processes.
To log out a user whose shell has process number 300, use the command:
.DM
	kill -9 300
.DE
You must be logged in as
.B root
or use the command
.B su
to
.B kill
a process that belongs to another user.
Each user can kill all processes that he owns, including his own shell
process (which automatically logs him out).
.PP
.B kill
has other uses as well \(em see the Lexicon's entry for \fBkill\fR
for more information.
.SH "Programming Under COHERENT"
.PP
.II C
.II "assembly language"
The \*(CO system provides a number of languages in which you can
write programs.
.PP
The shells included with \*(CO \(em \fBsh\fR, the Bourne shell, and
\fBksh\fR, the Korn shell \(em not only process commands, but are powerful
programming languages in their own right.
For details on how to program in these languages, see their respective
entries in the Lexicon; and see the tutorial \fIIntroducing sh, the Bourne
Shell\fR, which follows in this manual.
.PP
\*(CO includes a full-featured assembler, with which you can
assemble your assembly-language programs.
Assembly language is sometimes required for operations that require
you to work very closely with the operating system or hardware.
For more information on the \*(CO assembler, see the Lexicon entry
for \fBas\fR.
.PP
Most programming that cannot be executed efficiently by a shell language
is done in C, the language in which the \*(CO
system was written.
The \*(CO system comes with a full-featured C compiler, with which
you can compile the program you write in that language.
If you are new to C, the tutorial \fIThe C Language\fR,
which follows in this manual, will introduce you to it.
The following sub-sections briefly describe the tools available
under \*(CO with which you can write, compile, and debug your
C programs.
.Sh "Basic Steps in COHERENT Programming"
.PP
The steps that are necessary to generate a program are:
.DS
	1. Create the program source file
	2. Compile the source program, correcting any errors
	3. Test and debug the program
	4. Run the program
.DE
If you have compilation errors in step 2, or program errors in step 3 or
4, return to step 1.
.PP
.II macro
.II C
.II m4
.II db
.II cc
.II ed
Use your favorite editor to build and change the source program, the \fBcc\fR
command to compile the source program and produce an object program, and
\fBdb\fR to help debug the program.
Although the C compiler provides a macro facility, other languages do not.
Therefore, if the source program uses macros, you can use \fBm4\fR
to expand the macros.
.PP
This section covers each of these steps and provides some example programs.
.Sh "Create the Program Source"
.PP
The first step is to use \*(ME, \fBvi\fR, \fBed\fR, or some other
editor to create the program's source file.
Details on the use of \fBed\fR and \*(ME are covered in their respective
tutorials, which follow in this manual.
Each editor's commands are summarized in its Lexicon article.
.PP
For the first program, try a simple program that prints a short message on
your terminal.
For the sake of simplicity, we'll enter text using \fBcat\fR instead of
invoking an editor.
To build the program, type the following:
.DM
	cat > small.c
	main ()
	{
		printf ("The COHERENT operating system\en");
	}
	<ctrl-D>
.DE
The first line invokes the concatenation program \fBcat\fR to enter the
program's source code.
The \fB<ctrl-D>\fR signals that you have finished entering text.
.PP
.II parentheses
.II main
.II brace
.II {}
The program itself begins with the special word \fBmain\fR
which defines a function and must appear in every C program.
The parentheses, here with
nothing between them, enclose any arguments that are passed to the function.
They are required even if there are no arguments.
The body of the program appears between the braces \fB{\fR and \fB}\fR.
.PP
.II printf
.II library^C
.II "newline^in C strings"
The function \fBprintf\fR is part of the standard library of C programs.
It prints formatted information on the terminal.
In this case it will produce the string enclosed between quotation marks.
The special character string
.DM
	\en
.DE
means ``newline''.
Two lines of output to the terminal can be produced by
.DM
	"line 1\enline 2\en"
.DE
as an argument to \fBprintf\fR.
This appears in the output as:
.DM
	line 1
	line 2
.DE
.II "output formatting"
For a fuller introduction to the C language, see the tutorial on the
\fIThe C Language\fR, which follows in this manual.
.Sh "cc: Compile the Program"
.PP
.II C
.II cc
.II ld
.II compiler^C
.II "C^program linker"
The command \fBcc\fR compiles C programs.
It executes all the parts of the C compiler and the associated linker \fBld\fR.
The linker combines pieces of programs
and includes necessary elements from the library, such as \fBprintf()\fR.
The linker is occasionally called from the command line, but only for more
complex problems than you are trying here.
To compile our test program, type the command
.DM
	cc small.c
.DE
If the compiler detects any errors, it prints a message on the
terminal, along with the line number that contains the error.
You can use this line number to find the error with your editor and fix it.
You can now use the program by simply typing:
.DM
	small
.DE
The tutorial on \fIThe C Language\fR describes \fBcc\fR in greater detail;
also see its entry in the Lexicon for a full summary of its many capabilities.
.Sh "m4: Macro Processing"
.PP
.II m4
To extend the capabilities of all languages, the \*(CO system provides
a macro processor, called \fBm4\fR.
.PP
.II m4
.II parameter^substitution
.II "substitution^of parameters"
Program source for all languages consists of character strings.
Macro processors perform string replacement, whereby a string in the input file
may be replaced by another string.
\fBm4\fR provides parameter substitution, as well as testing values of
currently available strings and conditional processing.
\fBm4\fR is unique in that you can rearrange large
sections of the input text by using the macros.
For more information on \fBm4\fR, see the tutorial
\fIIntroduction to the m4 Macro Processor\fR, which follows in this manual.
.Sh "make: Build Larger Programs"
.PP
.II make
.II program^modularity
All the examples of programs thus far have been self-contained.
As programs grow larger, it is usual to divide the source
program into smaller files.
This simplifies editing, speeds compilation,
increases modularity, and lets several different programs
share common functions.
.PP
.II file^include
Thus, in developing the larger program, you may have several source files
in your directory, possibly a header file or two, and the object files that
result from compilation.
From these are built the executable file that runs when you type its name.
.PP
To change or fix the program, you must edit the source programs or
header files in question with \fBed\fR, recompile the required source, and
relink all the modules.
But, with a change that affects several modules, it can be tricky to
remember exactly which modules need recompilation, and it can be
time-consuming to recompile all modules.
.PP
.II make
.II "file^modification time"
\*(CO provides a command called \fBmake\fR, which solves this problem.
\fBmake\fR examines the time a file was last modified, and the time of
modification of files that it depends upon, and performs the necessary
compilation or other processing.
(\*(CO file system directories
contain the time that each file was created or modified.)
.PP
The tutorial \fIThe make Programming Discipline\fR, which follows in
this manual, fully introduces this powerful and useful program.
.Sh "db: Debug the Program"
.PP
.II debugging
.II program^debugging
.II structured^programming
.II programming^structured
The first and most critical step to debugging
programs is to not put bugs in them!
The methods of structured analysis, design, and programming, or the method of
stepwise refinement can substantially reduce the number of errors in a program.
.PP
One can also place \fBprintf\fR statements at strategic points throughout
the program to display logic flow and key data values.
These display statements should be designed
so that they can be turned off for normal
operation without removing them from the program.
.PP
.II db
On occasion, however, you may find that it is necessary to debug at
the machine level.
If you must, \*(CO's \fBdb\fR will make it possible to do so.
.PP
.II db
.II "machine instructions"
\fBdb\fR provides tools that make the machine
program instructions visible in the most natural notation.
That is, instructions are displayed in a fashion that resembles
assembly language, numbers can be displayed in hexadecimal,
octal, or decimal as needed, and strings of characters
displayed in familiar graphic form.
\fBdb\fR can also patch a program to be run again, as well as to control the
execution of a program with breakpoints and one step at a time.
.PP
.II db
Briefly, to use \fBdb\fR
on a program like our sample \fBsmall\fR above, use the command:
.DM
	db small
.DE
Now you can inspect and display instructions and data in the system,
control execution, and even change the instructions in the program if you
are bold enough.
.PP
To examine a data segment location in the program, simply type the
address of the location.
\fBdb\fR knows about symbols in the program, so if
you want to examine the location corresponding to \fBmain\fR, type:
.DM
	main
.DE
\fBdb\fR types out the value in hexadecimal or octal (depending upon which
is appropriate for your machine).
.PP
You can expand the display command to print many locations at one time,
and choose the format of printout.
To print five locations interpreted as instructions, type
.DM
	main,5?i
.DE
where the format character \fBi\fR follows the question mark indicating format,
and 5 is the count of locations to be printed.
To exit
.BR db ,
type
.DM
	:q
.DE
For a complete list of the format that \fBdb\fR recognizes,
and other details about \fBdb\fR, see its entry in the Lexicon.
.SH "Administering the COHERENT System"
.PP
The \*(CO system can be used by many people at the same time.
One person must coordinate its use, like a key operator
does for an office copier.
This person is called the \fIsystem administrator\fR,
and he sees to it that the \*(CO system runs smoothly every day.
The administrator can also customize the \*(CO
system to the needs of an individual installation.
.PP
Although you may be the only person to use your \*(CO system,
many of the ideas
discussed here are important for making your system work at its best.
Please spend a few minutes reading this manual to familiarize yourself
with the elementary concepts of \*(CO system maintenance.
.Sh "Adding a New User"
.PP
.II user^name
.II user^id
.II password
Each user allowed to use your \*(CO system must have a \fIuser name\fR
and a \fIuser id\fR; the user may also have a
.IR password .
The user name is usually the user's initials or a nickname.
The \fIuser id\fR is an integer number used to identify the
user internally to the system.
As system administrator, you will assign both of these for each user.
This section tells you how.
.PP
.II /etc/passwd
To log in to the system, a user must have an entry in the \fIpassword\fR file
.BR /etc/passwd .
The password file contains each user's name, id, and password if any.
As system administrator, you will maintain this file.
.PP
.II group^name
.II group^id
Likewise, each group of users is assigned a \fIgroup name\fR,
as well as a \fIgroup id\fR.
Groups are not necessary to use the \*(CO
system, but some installations prefer to set up
groups by project or department.
.PP
.II newusr
It is simple to add a new user to the system.
The command
.B newusr
takes care of all the details, and makes an entry in the password file.
You must be logged in as
.BR root .
For example, to create an entry for a user named Henry, log in as
.BR root ,
and then issue the command:
.DM
	/etc/newusr henry "Henry Smith" /usr
.DE
This creates an entry in \fB/etc/passwd\fR for \fBhenry\fR,
creates his home directory in the \fB/usr\fR file system,
creates all appropriate files for him (such as his \fB.profile\fR
and his mailbox), and sets all permissions correctly.
.Sh "System Security"
.PP
One of the most important tasks in running your \*(CO system is
maintaining its security.
Basically, security means two things:
keeping outsiders from logging into your system, and keeping your
system's users from doing untoward things.
This section describes some steps you can take to ensure that your system
is secure.
.Sh "Passwords"
.PP
.II protection
.II password
Passwords provide the first level of \*(CO system security.
.PP
.II login
For systems with passwords,
each user with a password must type his password as part of the login process.
If he enters the password incorrectly, he cannot log in.
.PP
.II password
Your system's administrator can assign a password when she creates a
user's log-in account, as described above.
If you do not assign a password, anyone will be able to log in as that user.
.PP
In any system with passwords, it is especially important to assign a
password to the \fBroot\fR, or \fIsuperuser\fR.
If the superuser does not require a password,
any user can log in as \fBroot\fR and automatically have access to
the powerful tools that control the operation of the system.
.PP
.II passwd
Any user with a password can restrict access to his files.
Once you assign him his password, he can change it with the command
.BR passwd .
However, because of higher privileges,
.B root
can always access everyone's files.
.PP
.II /etc/passwd
The passwords are kept in file
.BR /etc/passwd ,
with the rest of the user login information.
Passwords are encrypted, so reading \fB/etc/passwd\fR will not reveal passwords.
.Sh "File Protection"
.PP
.II file^protection
.II protection
The second level of \*(CO system security is \fIfile protection\fR.
A user can set each of three categories of protection for each of his files.
A standard protection, or \fIaccess permission\fR,
is given to each file when it is created.
.PP
The three categories of permissions are for the user himself,
for other users in his group, and for all other users.
To see the levels of protection of your files, type the command
.DM
	ls -l
.DE
For more details on the meaning of each column in this printout,
see the Lexicon entry for the change-mode command
.BR chmod .
.Sh "Encryption"
.PP
.II crypt
The command
.B crypt
provides a third level of system security.
It lets a user encode and decode information in a file.
The superuser has access to every file in the system; so to protect
sensitive information even from his prying eyes, a user can disguise
it with encryption.
Sensitive system information, such as passwords, are also encrypted
for security purposes; and the
.B mail
command lets users send encrypted mail to each other.
For details about encryption, see the entry on \fBcrypt\fR in the Lexicon.
.Sh "Dumping and Saving Files"
.PP
You should regularly copy your files on floppy disk, to protect your
valuable files against a catastrophic system failure.
The Lexicon article
.B backups
describes in detail how to do this.
.\".II backups^strategies
.\"This section discusses how you can copy files to floppy disk.
.\"You should do this regularly, both to
.\"free up disk space and to back up valued files
.\"to protect them against catastrophe.
.\".PP
.\"There are two general strategies for dumping files.
.\".PP
.\"One strategy uses the commands \fBustar\fR or \fBtar\fR
.\"to create archives of files on a floppy disk.
.\"This strategy is fine for systems that are used by a handful of users,
.\"and that are not used for ``real-world'' jobs, such as running a business.
.\".PP
.\"The other strategy uses the command \fBcpio\fR to implement a system of
.\"regular dumps.
.\"This strategy is preferred for systems that daily amass data of importance
.\"for a real-world job, such as running a business or managing a research
.\"project.
.\".PP
.\"You should always have a system of back-ups for your system.
.\"Which strategy you use depends on how you are using your system.
.\"The following sub-sections describe how to implement each strategy of
.\"back-ups.
.\".PP
.\"Please note that the following descriptions assume that you are using a
.\"5.25-inch, high-density floppy disks set in drive 0 (drive A).
.\".Sh "Back-ups Using ustar"
.\".PP
.\".II ustar
.\".II fdformat
.\"This sub-section describes how to back-up files using the \*(CO command
.\".BR ustar .
.\".PP
.\"The first step is to prepare floppy disks to receive files.
.\"Insert a 5.25-inch floppy disk into drive 0, and then type the following
.\"command:
.\".DM
.\"	/etc/fdformat -v /dev/fha0
.\".DE
.\"The command
.\".B fdformat
.\"formats the diskette, verifying that no media defects exist.
.\"You must perform this task of formatting a floppy disk
.\"only before you use it the first time.
.\".PP
.\"The next step is to create an archive of the files you wish to back up.
.\"Use the portable archive command
.\".B ustar
.\"to collect a mass of files into an archive on the floppy disks.
.\"For example, to archive all files in directory \fBsource\fR, use the
.\"following command:
.\".DM
.\"	ustar cvf /dev/rfha0 source
.\".DE
.\"The options \fBcvf\fR tell \fBustar\fR to create an archive, run in verbose
.\"mode, and write the archive onto the device or into the file
.\"named in the next argument.
.\"\fB/dev/rfha0\fR names the floppy device onto which
.\"you wish to write the archive.
.\"Finally, \fBsource\fR is the directory whose files you wish to back up.
.\".PP
.\"To perform a listing of the contents of the newly created archive, enter
.\".DM
.\"	ustar tvf /dev/rfha0
.\".DE
.\"The options \fBtvf\fR tell \fBustar\fR to list the contents
.\"of the archive, run in verbose mode,
.\"and read the archive from the device or file named in the next argument.
.\".PP
.\"To extract several files from the archive, enter a command of the form
.\".DM
.\"	ustar xvf /dev/rfha0 source/myfile 'source/*.c'
.\".DE
.\"The options \fBxvf\fR tell \fBustar\fR to extract or unarchive
.\"the specified files, run in verbose mode,
.\"and read the archive from the device or file named in the next argument.
.\"Note that the second file argument contains a ``wildcard'' character
.\"and thus must be quoted to prevent expansion by the shell.
.\".PP
.\"For more information on how to use
.\".BR ustar ,
.\"see its entry in the Lexicon.
.\".Sh "Back-ups Using cpio"
.\".PP
.\"The following sub-sections describe how to perform back-ups using the
.\"\*(CO command
.\".BR cpio .
.\".II USENIX
.\".II "Colburn, Mark H."
.\".II cpio
.\"\fBcpio\fR is a public domain program written by Mark H. Colburn for
.\"the USENIX association, which is included with the \*(CO system.
.\"This program performs mass dumps and restores of files using a
.\"universally recognized file format.
.\"In general, \fBcpio\fR is easier to use than \fBdump\fR
.\"and \fBrestor\fR, and its output can be portable among other \*(CO and
.\"\*(UN systems.
.\".PP
.\"In this example, dumps are performed monthly, weekly, and daily.
.\"You should prepare at least three sets of floppy disks for the monthly saves,
.\"giving you three months of full backup.
.\"You will use the diskettes in rotation, with the oldest always used next.
.\".PP
.\"Once a week, you should dump
.\"information in the system that is new or has been changed since the
.\"end of the previous week.
.\"You will need five sets of diskettes,
.\"since some months have five weekends in them.
.\".PP
.\"Finally, every day you should save information that has changed that day.
.\"For these dumps, you will need five sets of diskettes:
.\"one for each working day.
.\"You may need extras in case of weekend work.
.\".PP
.\"Label each set of disks carefully as
.\"\fImonthly\fR, \fIweekly\fR, or \fIdaily\fR.
.\"Label the daily diskettes Monday through Friday,
.\"the weekly diskettes Week 1 through
.\"Week 5, and the monthly diskettes Month 1 through Month 3.
.\"When you do the dump, write the date on the label.
.\".PP
.\"The following gives a step-by-step description of how to use
.\".B cpio
.\"to back up files.
.\".IP 1. 0.3i
.\"Log into the system as
.\".B root .
.\"You must have superuser privileges to perform a dump.
.\".IP 2.
.\"If you have not yet done so, use the command
.\".B fdformat
.\"to format a set of diskettes, as shown above.
.\"With high-density, 5.25-inch diskettes, a rule of thumb is to prepare
.\"one diskette for each megabyte of data to be dumped.
.\".IP 3.
.\"Tell other users to log off the system by typing:
.\".DM
.\".II wall
.\"	/etc/wall
.\"	Please log off.
.\"	Time for file dump.
.\"	<ctrl-D>
.\".DE
.\".sp \n(pDu
.\"If you are the only user on your system, skip this and the following
.\"step.
.\".IP 4.
.\"Be sure that all users are logged off the system by typing the command:
.\".DM
.\".II who
.\"	who
.\".DE
.\"This command names all users who are still on the system.
.\".sp \n(pDu
.\"If they have not logged off in a few minutes, send another message.
.\"Repeat the process until
.\".B who
.\"shows no users except yourself.
.\".IP 5.
.\"When all other users have logged off, execute
.\".B /etc/shutdown
.\"as described near the beginning of this tutorial.
.\".IP 6.
.\"If this is the last workday of the month, perform a \fImonthly\fR dump,
.\"to back up the entire system.
.\"Insert the first volume of the correct monthly dump
.\"floppy disk into the floppy drive, after adding today's
.\"date to the label, and type the commands:
.\".DM
.\"	cd /
.\"	find . -type f -print | cpio -oc >/dev/rfha0
.\".DE
.\"This will dump all files
.\"to the raw, 2400-block, floppy-disk device \fB/dev/rfha0\fR.
.\".B cpio
.\".sp \n(pDu
.\"As more floppies are needed,
.\".B cpio
.\"will ask you to insert them.
.\"After you insert the floppy disk, you will have to type the
.\"device name, e.g.,
.\".BR /dev/rfha0 ,
.\"at \fBcpio\fR's prompt.
.\"Be sure to label each floppy disk with its volume number.
.\".IP 7.
.\"If this is the last work day of the week, but not the last
.\"workday of the month, perform a \fIweekly\fR dump.
.\"Prepare the correct weekly dump diskettes, add today's date to the label,
.\"insert the first diskette, and type the command:
.\".DM
.\"	cd /
.\"	find . -type f -newer cpio.weekly -print | cpio -oc >/dev/rfha0
.\"	touch cpio.weekly
.\".DE
.\"This will dump all files that are younger than file
.\".BR cpio.weekly .
.\".IP 8.
.\"If this is neither the last workday of the month nor the last
.\"workday of the week, you will perform a \fIdaily\fR dump.
.\"Prepare the daily dump diskette
.\"with today's day of the week, add today's date to the label,
.\"insert the first diskette into the drive, and type the command:
.\".DM
.\"	cd /
.\"	find . -type f -newer cpio.daily -print | cpio -oc >/dev/rfha0
.\"	touch cpio.daily
.\".DE
.\"This will dump files that are younger than file
.\".BR cpio.daily .
.\".IP 9.
.\".II sync
.\"Type
.\".B sync
.\"to ensure that all buffers are flushed.
.\".IP 10.
.\".II reboot
.\"When you are finished dumping data, reboot the system by typing the
.\"command:
.\".DM
.\"	/etc/reboot
.\".DE
.\".PP
.\"For more information on how to use \fBcpio\fR and
.\".BR find ,
.\"see their respective entries in the Lexicon.
.\".Sh "Restoring Information"
.\".PP
.\".II restore^files
.\".II file^restoring
.\"If you find that a file has been inadvertently destroyed,
.\"you can restore the information to disk from backup
.\"floppy disk.
.\".PP
.\"To restore a file from a compressed \fBtar\fR archive, use the following
.\"commands.
.\"First, select the appropriate back-up disk, insert it into its drive, and
.\"mount it with the following command:
.\".DM
.\"	/etc/mount /dev/fha0 /f0
.\".DE
.\"Next, use the commands \fBzcat\fR and \fBtar\fR to extract the file you want.
.\"For example, if your archive is called \fBbackup.tar.Z\fR
.\"and the file wish to restore is called \fBmyfile\fR, use the following
.\"command to extract it from its archive:
.\".DM
.\"	zcat /f0/backup.tar.Z | tar xf - myfile
.\".DE
.\"The \fBzcat\fR command reads the compressed archive without requiring
.\"that you uncompress it.
.\"The \fBtar\fR command reads the standard input (as indicated by the hyphen `-')
.\"and extracts \fBmyfile\fR from what it reads.
.\".PP
.\"Once you have extracted your file or files, you can unmount the floppy disk
.\"in the usual way and put it away.
.\".PP
.\"To restore information from back-ups created with \fBcpio\fR, the process is
.\"a little more complicated.
.\"To begin, you must first determine the date and time
.\"that the file was last known to have been modified.
.\"From this date, determine on which set of disks
.\"the file was last correctly dumped.
.\"Find the set of floppy disks labeled with that date,
.\"and mount the first one in the set.
.\"For example, if you wish to restore the file
.\".BR myfile ,
.\"use the command:
.\".DM
.\"	cpio -icdv myfile < /dev/rfha0
.\".DE
.\"This assumes that the disks high-density, 5.25-inch floppies that are
.\"in drive 0 (drive A).
.\"See the Lexicon article
.\".B "floppy disk"
.\"for a table that shows which \*(CO device is associated with which
.\"size and density of disk, and which disk drive.
.\"You may have to insert more than one disk from the set of backups
.\"until you find the one that holds the file you want.
.Sh "System Accounting"
.PP
.II "computer time accounting"
.II accounting
.II accounting^reports
The \*(CO system provides two types of computer time
.I accounting
to help you track the use of the system.
Three commands control the accounting and provide reports at various levels of
detail.
.PP
Note that system accounting adds overhead to your system, because your
system has to do more work to record everything it does, and because
the accounting files can quickly grow to unmanageable sizes.
System accounting is useful for \*(CO systems that are being used
by multiple users who must account for (i.e., pay for) their use of the
system, or in other circumstances where it is important to note each user's
activity.
For most systems that support a handful of users, system accounting simply
isn't worth the bother.
.PP
If, however, you decide that you need system accounting, read on.
.Sh "ac: Login Accounting"
.PP
.II accounting^login
Whenever a user logs into the \*(CO system, it records the user's name,
the terminal number, and the date and time of the login.
It also records when he logs out.
.PP
.II login^time
You can use this information to compute the time
each user, or all users, were logged into the system.
The command
.B ac
prints the total of all login times recorded in the accounting file.
An example of the result is
.DM
	Total:	 8357:00
.DE
You can ask for a summary of total login times for each day by typing:
.DM
	ac -d
.DE
An example result would be:
.DM
	Friday November 13:
		Total:	 53:08
	Saturday November 14:
		Total:	 75:36
	Sunday November 15:
		Total:	 73:15
.DE
Finally, you can summarize the times for individual users with the command:
.DM
	ac -p jack ted fred
.DE
This will show the total login times for these users:
.DM
.ta 0.5i 1.5i
	fred	1100:42
	jack	910:41
	ted	641:58
	Total:	2653:21
.DE
Also,
.DM
	ac -pd
.DE
gives the time for each user, for each day that he logged in.
.PP
.II /usr/adm/wtmp
.II "accounting^starting login"
Login accounting is not automatically operational.
The login information is collected only if the file
.B /usr/adm/wtmp
exists.
.PP
To start login accounting if it is not working, type the command
.DM
	>/usr/adm/wtmp
.DE
while logged in as \fBroot\fR.
This creates the file
.B /usr/adm/wtmp
if it does not exist (and destroys existing information if it does) and
thereby enables login accounting.
.PP
To turn off login accounting while it is running, you can type:
.DM
	rm /usr/adm/wtmp
.DE
After you activate login accounting, you should purge
.B /usr/adm/wtmp
periodically as it grows continuously, and on an
active system will eventually consume much disk space.
To purge the current information but leave accounting turned on, type:
.DM
	>/usr/adm/wtmp
.DE
.Sh "sa: Processing Accounting"
.PP
.II accounting^process
.II system^time
.II user^time
.II "real time"
While login accounting tells you how much time a user spends logged into the
system, it does not tell you the individual commands used.
\fIProcess accounting\fR does so.
Under \*(CO, each execution of each command constitutes a separate process.
(\*(CO's ability to maintain a list of processes and swap each
in and out of memory until all are executed, is what gives \*(CO
its multi-tasking capability.)
Process accounting records system time, user time, and real time for each
command executed by each user on the system.
The command \fBsa\fR reports this information for you,
using a format that you set.
.PP
.B sa
has several options, to generate different reports.
When used with no options,
.B sa
lists the number of times each call is made,
the total CPU time, and the total
real time used by the command, ordered by decreasing CPU time.
This is a summary by command; the following gives an example:
.DM
.ta 0.5i 1.25i 1.75i 2.25i
		#CALL	CPU	REAL
	sh	61	1	832
	ld	5	1	7
	ar	5	0	1
	ranlib	3	0	1
	p	16	0	11
	dld	2	0	1
	lc	19	0	1
	cc	4	0	8
	atrun	43	0	1
	find	1	0	0
	ed	1	0	2
		...
.DE
This report has been truncated to save space.
The listing will depend on what commands are used in your system, and the
characteristics of your hardware.
To summarize by user, use the \fB\-m\fR option:
.DM
	sa -m
.DE
The option \fB\-l\fR separates CPU time expended by users
from that expended by the system.
This command
.DM
	sa -l
.DE
produces:
.DM
.ta 0.5i 1.25i 1.75i 2.25i
		#CALL	USER	SYS	REAL
	sh	61	0	1	832
	ld	5	0	0	7
	ar	5	0	0	1
	ranlib	3	0	0	1
	p	16	0	0	11
	dld	2	0	0	1
	lc	19	0	0	1
	cc	4	0	0	8
	atrun	43	0	0	1
	find	1	0	0	0
	ed	1	0	0	2
	cat	4	0	0	1
	rm	3	0	0	0
		...
.DE
This report has been truncated to save space.
To list the user name and the command name, use \fBsa\fR with the option
\fB\-u\fR.
No times or counts are given.
The command:
.DM
	sa -u
.DE
produces output of the form:
.DM
	tj		p
	tj		lc
	tj		find
	tj		pr
	bin		lc
	tj		spin
	tj		sh
	bin		cc
	...
.DE
This report has been truncated and edited to save space.
In practice, it is longer.
The \fB\-u\fR option overrides other options.
.PP
.II "accounting^starting process"
Process accounting is on only if you turn it on.
To turn on process accounting, type the command:
.DM
	/etc/accton /usr/adm/acct
.DE
while logged in as \fBroot\fR.
.II /usr/adm/acct
The file \fB/usr/adm/acct\fR holds the raw accounting information.
.PP
To turn off process accounting, use the same command with no file name:
.DM
	/etc/accton
.DE
If accounting is not on when you type this command, you will get an error
message.
No information is gathered when accounting is turned off.
.PP
When process accounting is in use, the file
.B /usr/adm/usracct
grows with each user command issued.
You should regularly condense or remove the information, to keep the
file from devouring all free space on your disk.
To condense the information, invoke \fBsa\fR with the \fB\-s\fR option.
You must turn off accounting while condensing information.
.PP
.II /usr/adm/savacct
The information summarized by user will appear in
.BR /usr/adm/usracct ,
and information saved by command is placed in
.BR /usr/adm/savacct .
These summarized files are used in future requests to
.BR sa .
After condensing, you can turn accounting back on.
.PP
Additional options give flexibility to the report.
See the entry for \fBsa\fR in the Lexicon for
additional details on these options.
.SH Conclusion
.PP
The following sections of this manual give tutorials to teach you
how to use many of \*(CO's tools and commands.
The Lexicon contains brief synopses of all commands, library routines,
system calls, and macros available under the \*(CO system.
It also includes many technical references and definitions, to help you
with terminology throughout this manual.

.IP \fBadmshot\fR 0.75i
A set of files and scripts that allow for the simple execution of
one\-shot procedures.
.IP \fBarcwtmp\fR
Utility for archiving login history.
.IP \fBbanner\fR
Banner printing utility.
.IP \fBbeuucp\fR
Change the effective group and user ids to
.BR uucp .
.IP \fBbooz\fR
Unpacker for ZOO\-format archives.
.IP \fBcflow\fR
Produces a listing of the program's calling hierarchy based upon
C function calls and declarations.
.IP \fBchess\fR
This program plays a fairly respectable game of chess, although it
is not competetive with state-of-the art commercial programs.
.IP \fBchoose\fR
Randomly selects lines from its input.
Useful for building your own
.BR fortune -like
games.
.IP \fBcmenu\fR
A menu package that lets you execute commands from a menu.
.IP \fBcnews\fR
A distribution of
.B cnews
for COHERENT.
.IP \fBcomb\fR
An alternative to COHERENT's standard
mailer,
.BR /bin/mail .
Features screen-oriented menuing and reply functions.
.IP \fBcrc\fR
Computes encrypted checksums.
Can improve security of your file transfers or your system.
.IP \fBctags\fR
This is the Berkeley version of
.BR ctags ,
ported to COHERENT.
.IP \fBcurses2\fR
Header with additional functions for the COHERENT
.B curses
library.
.IP \fBfinger\fR
Displays information about a user.
.IP \fBfocal\fR
.B focal
language interpreter.
.IP \fBfonts\fR
Computer Modern shareware font collection for
HP LaserJet and compatible printers.
.IP \fBgetppid\fR
A C program that returns your parent process id.
.IP \fBgnews\fR
A nice ``news'' system which includes everything you need
to receive and read news.
.IP \fBGNUgo\fR
This program plays quite a respectable game of
.IR go .
.IP \fBgomoku\fR
An 
.IR Othello -style
game played on a 19 by 19 grid.
.IP \fBhd\fR
Similar to COHERENT's command \fBod -c\fP,
but dumps files in a friendlier hexadecimal format.
.IP \fBhotel\fR
A board game of hotel development.
Players take turns placing tiles on the board
and buying stock in the hotels they create.
.IP \fBless\fR
An enhanced version of the traditional Berkeley screen pager
.BR more .
.IP \fBlibndir\fR
Directory-access subroutine library.
.IP \fBmc\fR
A powerful shareware spreadsheet program for COHERENT.
.IP \fBmenubar\fR
Creates a menu window.
Usefel for writing programs that prompt the user for menu choices.
.IP \fBmonth\fR
An appointment calendar.
.IP \fBmtalk\fR
A small, simple multi-user ``chat'' program.
.IP \fBmterm\fR
A basic terminal-services program.
This program utilizes the serial-port handler portions of the
.B kermit
program supplied with COHERENT as the base for a simple terminal package. 
.IP \fBmwdl\fR
A simple shell script used to download files from the Mark Williams Company
bulletin board,
.BR mwcbbs .
.IP \fBogre\fR
A game of tank warfare in the 21st Century.
.IP \fBorigami\fR
A powerful folding screen editor that is able to use the same key
bindings as MicroEMACS.
.IP \fBpclist\fR
Yet another screen pager.
.IP \fBps\fR
This archive contains a collection of independent,
self\-documented PostScript programs, including
.BR pscal ,
a useful calendar printing utility.
.IP \fBprolog\fR
A Prolog logic programming language interpreter.
Includes a manual and some tutorial information.
.IP \fBquebbs\fR
This is a Bulletin Board System that was ported to COHERENT.
.IP \fBrcs\fR
A revision control system.
Manages software libraries, stores and retrieves multiple revisions
of text files, and much more.
.IP \fBrn\fR
Larry Wall's popular news reading program.
.IP \fBsc\fR
A greatly modified version of the public domain spreadsheet,
.BR vc .
.IP \fBsdbm\fR
A clone of the Berkeley
.B ndbm
library.
.IP \fBshar\fR
Combines files into shell archive (shar) files.
.IP \fBsokoban\fR
A clone of the popular
.B Boxxle
game.
.IP \fBTASS\fR
A full\-screen, threaded news reader.
.IP \fBtassgn\fR
Allows you to use TASS 3.2 for reading and posting news articles with 
the GNEWS package.
.IP \fBtetris\fR
A clone of the popular arcade game Tetris.
.IP \fBtrek73\fR
A computer simulated battle based on the famous
.I "Star Trek"
television series and the game
.IR "Star Fleet Battles" .
.IP \fBumodem\fR
This version of
.B umodem
was modified for COHERENT.
It is based upon
.B umodem
version 4.0 which is also included.
.IP \fBuucp\fR
An
.B awk
script for COHERENT that
lets you to see the cost of your UUCP communications.
.IP \fBvtree\fR
A utility which shows the layout of a directory tree or file system.
.IP \fBwhich\fR
An implementation of the Berkeley
.B which
command.
It searches your path for the  first executable file
that matches the command line argument.
.IP \fBwmail\fR
A
.B mailx
clone which is easy to use and one of the best mailers for small systems.
WMAIL needs SMAIL25, included in \*(PN Volume I.
.IP \fBwnews\fR
A small news package which resembles a subset of the original B-News package.
.IP \fBwsh\fR
A shareware window shell for COHERENT.
.IP \fBxcmalt\fR
XCMALT is a massive expansion and modification of XCOMM 2.2,
a UNIX dialout telecommunications program.
.IP \fBxlisp\fR
XLISP is an experimental programming language combining some of the
features of LISP with object\-oriented extensions.
.IP \fBxo\fR
A tic-tac-toe game.
.IP \fBzoo\fR
Contains two programs,
.B zoo
and
.BR fiz .
.B zoo
manipulates archives of files in compressed form.
.B fiz
analyzes damaged
.B zoo
archives for data recovery.

.ds TL Installation
.NH "Installing GNU Sources"
.PP
This kit contains sources for the tools in the GNU Software Development System.
With these sources, you can recompile these GNU tools on your \*(CO system
and modify them to suit your preferences.
.Sh "Requirements"
.PP
The following is required before you can install and recompile these
sources successfully:
.IP \(bu 0.3i
Your system must be running \*(CO release 4.2.10 or later.
Persons who have \*(CO 4.2.05 are eligible for a free upgrade to 4.2.10.
If you have \*(CO 4.2.05, contact Mark Williams Technical Support to
arrange to have a upgrade sent to you.
.IP \(bu
You must have a binary of GNU C release 2.5.6 or later.
This is available from Mark Williams Company, or from various public-domain
sources.
.IP \(bu
You should have GNU versions of the following tools:
.BR awk ,
.BR sed ,
.BR make ,
and
.BR bash .
Most of these sources will not rebuild correctly with the \*(CO versions
of these tools.
.IP 
You should install GNU
.B bash
as
.BR /bin/sh .
You should then make
.B /bin/sh
your login shell, so that GNU
.B bash
is used throughout the compilation process, instead of a native \*(CO shell.
.IP \(bu
As explained below, the sources in this package are organized into modules.
The disks in each module are separately labeled and numbered; this lets you
install the sources for one tool without having to fill your disk with the
sources for them all.
.IP
Every module is installed into directory
.BR /u1/gnu/src .
The disk requirements for each module are given below.
To install all of the modules onto your system, the file system that holds
directory
.B /u1/gnu/src
must have 60 megabytes of free space.
To recompile all of the packages, the file system that holds directory
.B /u1/gnu/src
must have an additional 40 megabytes of free space.
Thus, to install and recompile all of the sources, the file system
that holds directory
.B /u1/gnu/src
must have a total of 100 megabytes of free space.
.Sh "Documentation"
.PP
Rebuilding a major GNU tool, such a compiler or debugger, is not a trivial
task.
Before you begin, you should read all available documentation on the tool
you wish to rebuild.
.PP
Each module contains the documentation for its tool, in binary form.
You can read this documentation using a text editor; or you can use
the \*(CO commands
.B pr
or
.BR prps
to print them.
.PP
Directory
.B /u1/gnu/man
contains manual pages for many of the GNU tools whose source code
is in this kit.
Note that this directory is simply for your convenience:
it is redundant, and can be removed should you wish to save the
disk space.
.PP
Printed manuals for these tools are
available from the Free Software Foundation.
For information, contact the Free Software
Foundation, 675 Mass Avenue, Cambridge, MA 02139.
The manuals are reasonably priced and well written; and by
purchasing the you can help support the Free Software Foundation in its
work of maintaining and extending these products.
.Sh "Copyright Information"
.PP
Please note that the GNU sources are covered by the Free Software
Foundation's ``copyleft.''
A copy is included in the file
.BR COPYING ,
which is included with each module of sources.
The Free Software Foundation permits you to give copies of the GNU sources
to other users; however, it demands that certain conditions be met before
you do so.
Please read the GNU documentation carefully before you give away
copies of the GNU sources.
.bp
.SH "Installing and Recompiling GNU Sources"
.PP
As mentioned above, this package is organized into modules.
Each module holds the sources, documentation, and ancillary files for
one of the following GNU tools:
GNU C;
the GNU assembler
.BR gas ;
the GNU
.B bin
utilities;
the GNU C-source debugger
.BR gdb ;
and
the GNU C++ run-time library.
.PP
We organized the sources in this manner so that you can install just the
sources that interest you, without having to install the entire package.
The disks for each module are separated labeled and numbered.
When you install a module, be careful to use the correct set of disks.
.PP
The following sub-sections describe how to install and recompile each module.
.Sh "Installing and Recompiling GNU C"
.PP
GNU C sources are installed into directory
.BR /u1/gnu/src/gcc-2.5.6 .
Installing the sources requires 23 megabytes of
free disk space on the file system that holds this directory.
Compiling all of the stages of GNU C requires an additional 27 megabytes
of disk space on this file system, for a total of 50 megabytes.
Please note that it is not necessary to build the stage-3 compiler,
as described in the file
.BR README :
the compilers from the GNU Development Tools binary distribution
already are tested stage-3 compilers.
.PP
To install GNU C, use the command:
.DM
	/etc/install -c COHgcc /dev/fva\fIN\fP 5
.DE
.I N
is the number of the 3.5-inch floppy-disk drive from which you are installing
the sources, either `0' or `1'.
.PP
To compile the C compiler, use the command:
.DM
	make CC=gcc CFLAGS=-O2
.DE
To compile the Objective-C run-time library, use the command:
.DM
	make objc-runtime CC=gcc CFLAGS=-O
.DE
Note that you must
.I not
compile Objective-C programs with the compiler option
.BR -O2 :
the optimizer for Objective C has a known bug, and the programs will core dump.
.PP
To install the binaries, libraries, and support files, use the command:
.DM
	make install
.DE
To configure the C compilers for Coherent 4.2, use the command:
.DM
	configure --target=i386-coh --with-stabs --prefix=/u1/gnu
.DE
The configure procedure builds modified header files in the directory
.BR /usr/include .
Note that with the exception of the header files installed into directory
.BR /usr/include/objc ,
these header files are
.I not
required because the \*(CO header files are compatible with GNU C.
We strongly recommend that you remove these header files before
you build the compiler, so that the \*(CO header files are used.
.Sh "Installing and Recompiling the GNU Assembler"
.PP
The sources for the GNU assembler
.B gas
are installed into directory
.BR /u1/gnu/src/gas-2.2 .
Installing the sources requires eight megabytes of free disk space
on the file system that holds this directory.
Compiling
.B gas
requires an additional three megabytes of disk space on this file system,
for a total of 11 megabytes of disk space.
.PP
To install
.BR gas ,
use the command:
.DM
	/etc/install -c COHgas /dev/fva\fIN\fP 2
.DE
.I N
is the number of the 3.5-inch floppy-disk drive from which you are installing
the sources, either `0' or `1'.
.PP
To compile
.BR gas ,
use the command:
.DM
	make CC=gcc CFLAGS=-O2
.DE
To install
.BR gas ,
use the command:
.DM
	make install
.DE
Finally, to configure
.B gas
for \*(CO release 4.2, use the command:
.DM
	configure --target=i386-coh --prefix=/u1/gnu
.DE
.Sh "Installing and Compiling GNU Binary Utilities"
.PP
Sources for the GNU bin utilities are installed into directory
.BR /u1/gnu/src/binutils-2.4 .
Installing the sources requires eight megabytes of disk space
on the file system that holds this directory.
Compiling these utilities requires an additional four megabytes of disk space
on this file system,
for a total of 12 megabytes of disk space.
.PP
To install the GNU bin utilities, use the command:
.DM
	/etc/install -c COHbin /dev/fva\fIN\fP 2
.DE
.I N
is the number of the 3.5-inch floppy-disk drive from which you are installing
the sources, either `0' or `1'.
.PP
To compile the GNU utilities, use the command:
.DM
	make CC=gcc CFLAGS=-O2
.DE
To install the utilities, use the command:
.DM
	make install
.DE
This command installs the binaries into directory
.BR /u1/gnu/i386-coh/bin .
It does so because it assumes that you wish to use the tools for
cross-development.
To make the tools available for use on your system, copy the tools that
interest you into directory
.BR /u1/gnu/bin .
Once you have verified that a tool has been copied from
.B /u1/gnu/i386-coh/bin
into
.BR /u1/gnu/bin ,
you should remove the tool from
.B /u1/gnu/i386-coh/bin
to save disk space.
You do not have to copy every tool; in particular, you should
.I not
copy the tools
.B strip
and
.B granlib
because they do not work correctly under \*(CO.
.PP
If you wish to use the GNU binary utilities by default (instead of their
\*(CO counterparts),
you must name directory
.B /u1/gnu/bin
at the
.I beginning
of the environmental variable
.BR PATH .
.PP
Finally, to configure the bin utilities for \*(CO 4.2, use the command:
.DM
	configure --target=i386-coh --with-stabs --prefix=/u1/gnu
.DE
.Sh "Installing and Compiling the GNU Debugger"
.PP
Sources for
.BR gdb ,
the GNU C source debugger, are installed into directory
.BR /u1/gnu/src/gdb-4.9 .
Installing the sources requires 12 megabytes of disk space
on the file system that holds this directory.
Compiling these utilities requires an additional three megabytes of disk space
on this file system,
for a total of 15 megabytes of disk space.
.PP
To install
.BR gdb ,
use the command:
.DM
	/etc/install -c COHgdb /dev/fva\fIN\fP 3
.DE
.I N
is the number of the 3.5-inch floppy-disk drive from which you are installing
the sources, either `0' or `1'.
.PP
To compile
.BR gdb ,
use the command:
.DM
	make CC=gcc CFLAGS=-O2
.DE
To install
.BR gdb ,
use the command:
.DM
	make install
.DE
Finally, to configure
.B gdb
for \*(CO 4.2, use the command:
.DM
	configure --target=i386-coh --prefix=/u1/gnu
.DE
.Sh "Installing and Compiling C++ Run-time Library"
.PP
Sources for the GNU C++ run-time library are installed into directory
.BR /u1/gnu/src/libg++-2.5.3 .
Installing the sources requires six megabytes of disk space
on the file system that holds this directory.
Compiling these utilities requires an additional three megabytes of disk space
on this file system,
for a total of nine megabytes of disk space.
.PP
To install this library, use the command:
.DM
	/etc/install -c COHlibg /dev/fva\fIN\fP 2
.DE
.I N
is the number of the 3.5-inch floppy-disk drive from which you are installing
the sources, either `0' or `1'.
.PP
To compile the library, use the command:
.DM
	make CC=gcc CFLAGS=-O2
.DE
To install the library, use the command:
.DM
	make install
.DE
Finally, to configure the GNU C++ library for \*(CO 4.2, use the command:
.DM
	configure --target=i386-coh --prefix=/u1/gnu
.DE
.SH Conclusion
.PP
Technical support is available to help you install these programs, and
recompile them as they are shipped, ``out of the box''.
However, due to the highly technical nature of these programs,
Mark Williams Company cannot provide technical support for any GNU program
if you have made any modification to it whatsoever.
.PP
We hope that you enjoy working with these sources!

. PostScript/spine.r 5/7/91
. Print notebook spine with MWC logo
. assumes Landscape mode: troff -l spine.r
.rb /u/steve/PostScript/lib/box.ps
.rb /u/steve/PostScript/lib/mwc2.ps
.ll 11i
.co
/inch { 72 mul } bind def
.1 0 .5 1.2 inch 10.5 inch .25 inch .25 inch box
.1 0 1  1.0 inch 10.3 inch .35 inch .35 inch box
0 1 .8 inch .85 inch 10 inch mwclogo2
.co
.ps 60
.ft B
.in 1i
.sp |1.1i
i386 C Compiler

.SH "Third-Party Software Packages for COHERENT 4.2"
.PP
What follows is a list of companies that have ported their
software to \*(CO, or whose software runs under \*(CO unchanged from
other \*(UN implementations.
Also listed are the names and a brief description of each product.
Please note that this list is growing all the time.
For the latest information on third-party products that run under \*(CO,
dial into the \*(CO bulletin board, or telephone Mark Williams Company.
.IP "\fBACC Corporation\fR"
.nf
SWiM 1.2.3, a port of OSF Motif to \*(CO
(203) 454-3242 (voice)
info@acc-corp.com
.fi
.IP "\fBAcucobol Inc.\fR"
.nf
Acucobol (COBOL compiler)
1-619-689-7220 (voice)
1-800-262-6585 (voice)
1-619-566-3071 (FAX)
.fi
.IP "\fBAppgen Business Software\fR"
.nf
Appgen (Accounting 4GL and RDBMS)
1-516-471-3200 (voice)
1-516-471-3291 (FAX)
.fi
.IP "\fBArosoft\fR"
.nf
ADFprofi (Office Automation and RDBMS, in German)
49-30-525-2150 (voice)
49-30-525-3461 (FAX)
.fi
.IP "\fB/ARX Cleanware\fR"
.nf
MacroCALC (Spreadsheet)
WindowSHell (User Interface)
Voice: ++49-9287/87446
FAX: ++49-9287/87232
.fi
.IP "\fBBasis International\fR"
.nf
BBxPROGRESSION/4 (BASIC compiler)
1-505-345-5232 (voice)
1-505-345-5082 (FAX)
.fi
.IP "\fBBasmark Corp.\fR"
.nf
QuickBASIC Compiler  (BASIC compiler, compatible with Microsoft BASIC)
1-216-621-7650 (voice)
1-216-621-7652 (FAX)
.fi
.IP "\fBBerkeley Decision/Systems\fR"
.nf
Shellware GLS (Accounting and bookkeeping)
1-408-458-9708 (voice)
1-408-458-2721 (FAX)
.fi
.IP "\fBBorland International\fR"
.nf
dBASE IV
408-438-8400 (voice)
.fi
.IP "\fBCamber Roth Caucus\fR"
.nf
Caucus Link (Groupware computer conferencing)
1-518-273-0983 (voice)
1-518-276-6380 (FAX)
.fi
.IP "\fBCentury Software\fR"
.nf
TERM (Communications and terminal-emulation package)
1-801-268-3088 (voice)
1-801-268-2772 (FAX)
.fi
.IP "\fBCET Software\fR"
.nf
CET BASIC (BASIC compiler)
1-206-883-8142 (voice)
1-206-885-5717 (FAX)
.fi
.IP "\fBCoconut Computing, Inc.\fR"
.nf
COCONET Server v4.0 (Conferencing and bulletin board package)
Cocotalk\(rg API C Library v2.0
CocoMedia\(tm v1.0 multimedia enhancements
1-619-456-2002 (voice)
1-619-456-1905 (FAX)
.fi
.IP "\fBComeau Computing\fR"
.nf
Comeau C++ 3.0 with Templates (C++ compiler)
1-718-945-0009 (voice)
1-718-441-2310 (FAX)
.fi
.IP "\fBCreative Programming\fR"
.nf
Vitamin C (User-interface builder)
1-214-245-9139 (voice)
1-214-245-9717 (FAX)
.fi
.IP "\fBCyberstore Online Information Systems, Inc.\fR"
.nf
Cyberstore (BBS package)
1-604-526-3373 (voice)
1-604-526-3373 (FAX)
.fi
.IP "\fBData Access\fR"
.nf
Dataflex (relational DBMS)
305-238-0012 (voice)
800-451-3539 (voice)
305-238-0017 (FAX)
.fi
.IP "\fBELMAS GmbH I. G.\fR"
.nf
LanguagePak 1 (Selected languages)
LanguagePak 2 (More language)
DeskPak (Edit and text formatting plus office automation)
OfficePak (Office automation)
TextPak (Editing and text formatting)
UtilityPak (\*(UN utilities)
CommPak (Communications utilities)
XPak (X utilities)
XtraPak (Additional X utilities)
FunPak (Games)
SourcePak (Source code)
49-303-936-784 (voice)
49-303-922-355 (FAX)
.fi
.IP "\fBFaircom Corporation\fR"
.nf
r-tree (RDBMS package)
c-tree (C interface to the r-tree DBMS)
1-314-445-6833 (voice)
1-314-445-9698 (FAX)
39-357-730-23 (European support)
.fi
.IP "\fBGimpel Software\fR"
.nf
FlexeLint 4.0 (Debugger and programming tool)
1-215-584-4261 (voice)
1-215-584-4261 (FAX)
.fi
.IP "\fBInformation Ink, Ltd.\fR"
.nf
Adaptive Software for the Disabled
1-718-278-8181 (voice)
1-718-278-8268 (FAX, Monday-Thursday, 10 PM-6 AM)
.fi
.IP "\fBInfoflex, Inc.\fR"
.nf
Infoflex and Accountflex (4GL and DBMS)
1-415-340-0220 (voice)
1-415-697-7696 (FAX)
.fi
.IP "\fBIntegration Technologies, Inc.\fR"
.nf
INTEK C++ (C/C++ compiler and programming package)
1-206-455-9935 (voice)
1-206-455-9935 (FAX)
.fi
.IP "\fBJust Logic Technologies\fR"
.nf
Just Logic/SQL (SQL DBMS)
1-514-642-6480 (voice)
1-514-642-6480 (FAX)
.fi
.IP "\fBLasermoon Ltd.\fR"
.nf
SWiM 1.2.3, a port of OSF Motif to \*(CO
(+44) 329 826444 (voice)
info@lasermoon.co.uk
.fi
.\".IP "\fBLiant Software\fR"
.\".nf
.\"RM/COBOL-85 RM/CO* RM/PANELS RM Companion (COBOL compiler)
.\"1-800-762-6265 (voice)
.\"1-512-343-1010 (voice)
.\"1-512-343-9487 (FAX)
.\".fi
.IP "\fBLotus Development Corporation\fR""
Lotus 1-2-3 for UNIX (Spreadsheet)
.fi
.IP "\fBmbp Software, Inc.\fR"
.nf
Visual Cobol (COBOL compiler)
1-800-231-6342 (voice, USA)
49-231-9441605 (voice, Germany)
1-510-769-4746 (voice, international)
1-510-769-5333 (FAX, USA)
1-510-769-5735 (FAX, USA)
49-231-9442413 (FAX, Germany)
.fi
.IP "\fBMMB Development Corporation\fR"
.nf
TEAMate (client-server BBS software)
310-318-1322 (voice)
310-318-2162 (FAX)
.fi
.IP "\fBMicro Focus\fR"
.nf
Micro Focus Cobol (COBOL compiler)
1-415-496-7215 (voice)
1-415-856-6134 (FAX)
.fi
.IP "\fBMicroEdge Inc.\fR"
.nf
SlickEdit (Configurable editor)
1-800-934-3348 (voice)
1-919-790-1691 (FAX)
1-919-872-5586 (FAX)
.fi
.IP "\fBMicroway\fR"
.nf
Microway Pascal Compiler for \*(CO
1-508-746-7341
.fi
.IP "\fBMultisoft Datentechnik GMBH\fR"
.nf
Flagship (Clipper-like data-base management system)
+49-89-641-7904 (voice)
+49-89-641-2974 (FAX)
303-699-5736 (U.S. agent)
.fi
.IP "\fBOn Top Systems\fR"
.nf
di-ogix  (DBMS and spreadsheet)
1-708-271-0200 (voice)
1-708-271-0206 (FAX)
.fi
.IP "\fBOpen Systems, Inc.\fR"
.nf
Open Systems Accounting Software
1-612-829-0011 (voice)
1-612-829-1493 (FAX)
.fi
.IP "\fBPacific Micro\fR"
.nf
Common-Link (COHERENT/UNIX-DOS-MAC file-transfer utility)
1-415-948-6200 (voice)
1-415-948-6296 (FAX)
.fi
.IP "\fBPacific Software Group\fR"
.nf
Task Manager for UNIX (desktop organizer, productivity software)
909-681-2623 (voice)
.fi
.IP "\fBPRO-C Limited\fR"
.nf
PRO-C Lite (RDBMS C development library)
1-519-725-5143 (voice)
1-519-725-5143 (FAX)
.fi
.IP "\fBPromula\fR"
.nf
Promula Fortran Compiler and FORTRAN to C Translator
1-614-263-5454 (voice)
1-614-263-5573 (FAX)
.fi
.IP "\fBRaima Corp.\fR"
.nf
Raima Data Manager (RDM) (RDBMS and development tool)
206-747-5570 (voice)
206-747-1991 (FAX)
.fi
.IP "\fBRasmussen Software, Inc.\fR"
.nf
ICE (Intelligent COBOL editor)
503-624-0360 (voice)
503-624-0760 (FAX)
.fi
.IP "\fBRevolutionary Software\fR"
.nf
/rdb (RDBMS package)
408-429-6229 (voice)
408-427-0342 (FAX)
.fi
.IP "\fBRoundhill Computer Systems\fR"
.nf
PANEL Plus II (User-interface library)
44-672-84535 (voice)
1-708-690-3737 (voice, USA)
44-672-84525 (FAX)
1-708-665-9841 (FAX, USA)
.fi
.IP "\fBRSYS\fR"
.nf
R Word, RO Plus, RW Plus (Word processors)
1-214-343-9210 (voice)
1-214-343-9218 (FAX)
.fi
.IP "\fBSan Souci Consulting\fR"
.nf
COM/MENT (Fully configurable BBS package)
1-805-327-1172 (voice)
1-805-327-9299 (FAX)
.fi
.IP "\fBSCS Compute Inc.\fR"
.nf
Tax Machine (Tax preparation and accounting package)
1-206-643-2050 (voice)
1-206-562-1783 (FAX)
.fi
.IP "\fBSequiter Software\fR"
.nf
CodeBase 5.0 (C-Language DBMS package)
1-403-437-2410 (voice)
1-403-436-2999 (FAX)
.fi
.IP "\fBSINC Inc.\fR"
.nf
Flex Gen Cobol 4GL (4GL, data base, and code generator)
1-513-438-5553 (voice)
1-513-438-5377 (FAX)
.fi
.IP "\fBSoftfocus\fR"
.nf
BTree/ISAM (File-Access and DBMS package)
1-416-825-0903 (voice)
1-416-825-1025 (FAX)
.fi
.IP "\fBSovereign Technologies\fR"
.nf
Cu/Extended V2.1 (Communications package)
1-800-428-1272 (voice)
.fi
.IP "\fBSynergetic Data Systems\fR"
.nf
Filix (Flat-file DBMS)
Filix General (Report Writer)
1-800-446-7374 (voice)
1-916-933-0120 (voice)
1-916-933-5793 (FZX)
.fi
.IP "\fBSyntactics\fR"
.nf
Crystal Writer Plus (Word processor)
1-408-727-6400 (voice)
1-408-727-0309 (FAX)
.fi
.IP "\fBThe Case Group\fR"
.nf
PC Curses Formation Desktop (User-interface tool)
1-615-352-2146 (voice)
.fi
.IP "\fBThe Small Computer Company\fR"
.nf
filePro (RDBMS)
1-914-769-3160 (voice)
1-914-769-3653 (FAX)
.fi
.IP "\fBThinking Software\fR"
.nf
ROTA (Office automation and scheduling package)
44-993-824-144 (voice)
44-993-823-629 (FAX)
.fi
.IP "\fBThoroughbred\fR"
.nf
Basic Word Query-IV Idol-IV Report-IV Solution-IV
1-908-560-1377 (voice)
1-908-560-1377 (FAX)
.fi
.IP "\fBTrueBASIC Inc.\fR"
.nf
TrueBASIC for \*(CO (BASIC compiler)
1-603-298-8517 (voice)
1-603-298-8517 (FAX)
.fi
.IP "\fBUniCache Systems\fR"
.nf
RealWorld Accounting & Public Safety Software
1-815-968-8026 (voice)
.fi
.IP "\fBUniTrends Software Corp.\fR"
.nf
CTAR (Backup and archiving utility)
1-803-626-2878 (voice)
1-803-626-5202 (FAX)
.fi
.IP "\fBUS Robotics\fR"
.nf
BLAST 10.7.2 (Communications package and terminal emulation)
1-708-933-5561 (voice)
1-708-982-5235 (FAX)
.fi
.IP "\fBVermont Creative Software\fR"
.nf
Vermont Views 3.05 (User-interface library)
1-802-848-7731 (voice)
1-802-848-3502 (FAX)
.fi
.IP "\fBVersasoft Corp.\fR"
.nf
dBMAN V (DBMS, clone of dBASE III Plus)
1-408-723-9044 (voice)
1-408-723-9046 (FAX)
.fi
.IP "\fBWild Hare Computer Systems Inc.\fR"
.nf
Axis Choice HareStylist VS COBOL/INFOS (COBOL compiler)
1-303-530-2221 (voice)
1-303-530-9637 (FAX)
.IP "\fBWordPerfect Corporation\fR"
.nf
WordPerfect for UNIX 5.1 (Word processor)
.fi
.IP "\fBZ/MAX Computer Solutions\fR"
.nf
Z/MAX XChange (BBS package)
1-315-635-1882 (voice)
1-315-635-1908 (FAX)
sales@zmax.xom
.fi

.\" /usr/lib/roff/troff_ps/fonts.r 10/10/91
.\" Default fonts for PostScript troff.
.lf R Bookman_R.fwt
.lf B Bookman_B.fwt
.lf I Bookman_I.fwt
.lf TR Times_R.fwt
.lf TB Times_B.fwt
.lf TI Times_I.fwt
.lf M Courier_R.fwt
.lf DB Dingbats.fwt
.lf S Symbol.fwt
.\" end of /usr/lib/roff/troff_ps/fonts.r

Jay Alter	Riyaz Asaria	Norman Bartek
Bob Beals	James Behr	Chris Berrios
Luddyne Blue	Barry Bowen	Eduardo Bravo
Nigel Bree	Denise Buirge	Fred Butzen
Henry Cejtin	David Conroy	Allan Cornish
Roger Critchlow	Richard Critchlow	Ella Dashevsky
Stephen Davis	John R. Dennison	Mimi Diaz
Tom Duff	Mark Epstein	Michael Farley
Charles Fiterman	Charles Forsyth	Kim Fruin
Johann George	Louis J. Giliberto, Jr.	Daniel Glasser
Michael Griffin	Walter Grogan	Robert Hemedinger
Scott Hermes	Chris Hilton	Randall Howard
Owen Jacobsen	Mary Karabatsos	Michael Kaufman
Nancy Kenston	J.T. Kittridge	William Lederer
Irene Lee	James Leonard	Dave Levine
Jeanne Lewis	Karen McBride	Scott Moody
Udo Munk	Esther Munoz	Tim Murphy
Alex Nash	Asia Negron	Gerson Negron
Steve Ness	Ciaran O'Donnell	Douglas Peterson
Frank Pfeiffer	Norma Reyes	Vladimir Smelyansky
Abner Snell III	Addison Snell	Hal Snyder
Michael Spertus	Julie Stewart	Robert Swartz
Angus Telfer	Trevor Thompson	Diane Tracey
Rico Tudor	Bernard Wald	Bill Witt
La Monte Yarroll	Jim Yonan

.ds TL "Additional Software"
.NH "Software for COHERENT"
.PP
Numerous software products are available for \*(CO.
These include industry-standard products, such as Lotus 1-2-3, WordPerfect,
Basmark QuickBASIC, the MBP Visual Cobol compiler, and many others.
.PP
Your \*(CO package included a catalogue of third-party software
that describes some of the third-party products available for \*(CO.
You can order these through Mark Williams Company by using the order form
in the middle of the catalogue.
Or, if you prefer, you can telephone the Mark Williams sales department at
1-800-636-6700 or 1-708-291-6700, or you can FAX us your order
at 1-708-291-6750.
Members of the \*(CO Club receive special discounts on most items.
The \*(CO command
.B phone
comes with a ``phonebook'' that gives the names, telephone numbers, and
a brief description for many software vendors who sell software for \*(CO.
If you are looking for a particular item, check there first.
For example, if you are looking for implementations of the BASIC language
under \*(CO, type the command:
.DM
	phone BASIC
.DE
This prints on your screen the name and telephone number of each third-party
vendor who has published a version of BASIC \(em at least, that we knew about
when you purchased \*(CO.
.PP
Mark Williams Company also publishes products for \*(CO.
These include X Windows for \*(CO;
the five volumes of COHware, which give some the best of the
public-domain software for \*(CO;
the \*(CO Device-Driver Kit;
the \*(CO port of GNU C/C++;
source code for GNU C/C++;
and GNU Tools, a collection of GNU tools and utilities ported to \*(CO.
An order form is available in the catalogue
for ordering the products produced by, or available through,
Mark Williams.
Or you can order by calling 1-800-636-6700, or 1-708-291-6700.
.PP
The following sections introduce the products available from Mark Williams
Company, and some of the third-party suppliers of software.
.SH "X Windows for COHERENT"
.PP
Beginning with release 4.2, \*(CO supports the X Window System,
the industry-standard computer windowing system.
X Windows for \*(CO is Mark Williams port of X Windows.
With X Windows for \*(CO,
you can open multiple windows on your screen, and use icons,
pop-up menus, graphics on your \*(CO system.
.PP
X Windows for \*(CO includes a generous selection of X utilities,
clients, and games.
It also includes libraries, header files, fonts, and bit-mapped images, so
you can begin to import the wealth of X applications that are now available
in the public domain.
.PP
X Windows for \*(CO, like all Mark Williams products, is reasonably priced,
and comes with full technical support.
Also included is a 200-page manual that introduces X Windows and documents
every utility, client, and game included in the package.
.PP
Note that X Windows for \*(CO requires four megabytes of RAM (eight is
preferred), a serial mouse, and a VGA video card and monitor.
.PP
To order X Windows for \*(CO, call 1-800-636-6700 or 1-708-291-6700,
or use the order form at the end of these notes.
.SH "Introducing COHware"
.PP
The amount of contributed software appearing on our Bulletin Board System
is already much, much more than we ever imagined
it would be \(em and it keeps on growing.
This software can be downloaded freely from our BBS.
However, assuming that you have a 2400-baud modem,
downloading can easily cost $30 per megabyte, not to
mention the time and inconvenience.
So, we have come up with the answer:
COHware!
.PP
Now the best of the contributed software from our BBS is available on
floppy disk.
Almost every program comes both compiled, and with its full source code.
You can use the programs as is, or you can modify them for your own
applications.
Don't waste your time on a problem that has already been solved
within one of these programs, and don't tie up your modem for hours on end.
COHware opens up the world of C programming under \*(UN \(em
take a look at how a sophisticated shell is built from the inside out \(em
find out how a text editor is written \(em all this and much
more can be found within COHware.
.PP
Volumes I and II of COHware were designed for \*(CO 286, with its
limited address space.
However, COHware volumes III, IV, and V are
filled with software that has been ported
to, or rewritten for, the \*(CO-386 32-bit addressing space.
It also holds many of the favorite programs that appeared in the first
two volumes.
.PP
COHware volume III contains the following:
.so /v/fwb/coherent/rel.notes/coherent/coh4.2/contents.CW3.r
.PP
COHware volume IV contains the following:
.so /v/fwb/coherent/rel.notes/coherent/coh4.2/contents.CW4.r
.PP
COHware volume V contains the following:
.so /v/fwb/coherent/rel.notes/coherent/coh4.2/contents.CW5.r
.PP
You can order volume III of COHware for only $40;
and you can order volumes IV and V for only $49.
Use the order form in the catalogue, or call 1-800-636-6700 for
fast service.
Remember, if you are a member of the \*(CO Club, you will receive
a discount on this product.
.SH "The COHERENT Device Driver Kit"
.PP
The
.B "COHERENT Device Driver Kit"
contains everything that an
experienced programmer needs to write a device driver for \*(CO,
including source code for over a dozen \*(CO drivers.
The Kit brings a new level of support
for writing drivers and has greater detail than UNIX versions.
.PP
Release 4.2 of the Kit documents the \*(CO implementation of
\*(ST, which now makes it easier than ever to write a device driver
for \*(CO, \*(UN, and any other operating system that supports \*(ST.
.PP
The Kit also includes full source code for
almost all device drivers shipped with the \*(CO system
(excluding only a few that use proprietary information from third-party
suppliers), including the following:
.nf
.sp \n(pDu
	Console driver
	Virtual consoles driver
	Keyboard drivers, both non-loadable and loadable
	Serial-port driver, including non-intelligent multi-port cards
	Parallel-port driver
	AT hard-disk driver
	Host-adapter-independent SCSI driver
	Floppy-disk driver
	Memory driver
.fi
.PP
Just reading the source code can be very helpful in learning how to cope
with real-world problems in writing device drivers for
multi-tasking environments like \*(CO and \*(UN.
These are supplemented in the manual by tutorials and a detailed example.
.PP
The price is right, too.
Like all Mark Williams software, our Device Driver Kit is extremely affordable.
Use the form at the end of this manual to order the
best value in driver kits \(em yet one more reason why
\*(CO is on the way to becoming the most widely used PC-based
development system in the world.
.SH "GNU C and GNU Tools"
.PP
Mark Williams Company offers
.BR "GNU C" ,
from the Free Software Foundation.
GNU C offers full support for the ANSI C standard, plus numerous extensions
and features not found in most C compilers.
.\" Including ours.
It also implements a full-featured implementation of the C++ language,
with which you can explore the world of C++ and object-oriented
programming, all under your \*(CO system.
With
.BR "GNU C" ,
you can begin to work with the wealth of source code available
through Free Software Foundation.
.PP
Mark Williams also offers the
.BR "GNU C Source Kit" .
This gives full sources to GNU C and its libraries
in a ready-to-compile form.
With it, you can rebuild GNU C on your system and study the design of
this major piece of software.
Note that the
.B "GNU C Source Kit"
requires that you have
.BR "GNU C" .
.PP
Finally, Mark Williams offers
.BR "GNU Tools" ,
a set of tools from the Free Software Foundation.
.B "GNU Tools"
includes the following:
.so /v/fwb/coherent/rel.notes/coherent/coh4.2/contents.GW1.r
.PP
.B "GNU C"
costs only $79.95.
.B "GNU Tools"
costs only $49.95.
The
.B "GNU C Source Kit"
is $99.95.
To order, use the form at the end of this pamphlet; or you can order by
calling 1-800-636-6700 or 1-708-291-6700.
Members of the \*(CO Club save even more.
.PP
We know how you value Mark Williams Company's commitment to user support.
However, because of the nature of these products, we cannot
offer technical support on the Device Driver Kit, COHware, GNU Tools,
or GNU C.
.SH "The COHERENT Club"
.PP
The \*(CO Club offers great savings on third-party software.
For a one-time payment of $49.95,
you can get significant discounts from Mark Williams Company
on such third-party software products as WordPerfect,
other \*(CO products sold by Mark Williams, and discounts on future
enhancements and updates to \*(CO.
For a listing of the discounts you can receive, see the order form
at the back of this pamphlet.
.PP
To join, fill out the form at the end of these notes, or you can call
1-800-636-6700 or 1-708-291-6700.
.SH "Third-Party Software Packages for COHERENT 4.2"
.PP
What follows is a preliminary list of companies that have ported their
software to \*(CO, or whose software runs under \*(CO unchanged from
\*(UN implementations.
Also listed are the names and a brief description of each product.
Please note that this list is growing all the time.
For the latest information on third-party products that run under \*(CO,
dial into the \*(CO bulletin board, or telephone Mark Williams Company.
.IP "\fBAcucobol Inc.\fR"
.nf
Acucobol (COBOL compiler)
1-619-689-7220 (voice)
1-800-262-6585 (voice)
1-619-566-3071 (FAX)
.fi
.IP "\fBAppgen Business Software\fR"
.nf
Appgen (Accounting 4GL and RDBMS)
1-516-471-3200 (voice)
1-516-471-3291 (FAX)
.fi
.IP "\fBArosoft\fR"
.nf
ADFprofi (Office Automation and RDBMS, in German)
49-30-525-2150 (voice)
49-30-525-3461 (FAX)
.fi
.IP "\fB/ARX Cleanware\fR"
.nf
MacroCALC (Spreadsheet)
WindowSHell (User Interface)
Voice: ++49-9287/87446
FAX: ++49-9287/87232
.fi
.IP "\fBBasis International\fR"
.nf
BBxPROGRESSION/4 (BASIC compiler)
1-505-345-5232 (voice)
1-505-345-5082 (FAX)
.fi
.IP "\fBBasmark Corp.\fR"
.nf
QuickBASIC Compiler  (BASIC compiler, compatible with Microsoft BASIC)
1-216-621-7650 (voice)
1-216-621-7652 (FAX)
.fi
.IP "\fBBerkeley Decision/Systems\fR"
.nf
Shellware GLS (Accounting and bookkeeping)
1-408-458-9708 (voice)
1-408-458-2721 (FAX)
.fi
.IP "\fBBorland International\fR"
.nf
dBASE IV
408-438-8400 (voice)
.fi
.IP "\fBCamber Roth Caucus\fR"
.nf
Caucus Link (Groupware computer conferencing)
1-518-273-0983 (voice)
1-518-276-6380 (FAX)
.fi
.IP "\fBCentury Software\fR"
.nf
TERM (Communications and terminal-emulation package)
1-801-268-3088 (voice)
1-801-268-2772 (FAX)
.fi
.IP "\fBCET Software\fR"
.nf
CET BASIC (BASIC compiler)
1-206-883-8142 (voice)
1-206-885-5717 (FAX)
.fi
.IP "\fBCoconut Computing, Inc.\fR"
.nf
COCONET Server v4.0 (Conferencing and bulletin board package)
Cocotalk\(rg API C Library v2.0
CocoMedia\(tm v1.0 multimedia enhancements
1-619-456-2002 (voice)
1-619-456-1905 (FAX)
.fi
.IP "\fBComeau Computing\fR"
.nf
Comeau C++ 3.0 with Templates (C++ compiler)
1-718-945-0009 (voice)
1-718-441-2310 (FAX)
.fi
.IP "\fBCreative Programming\fR"
.nf
Vitamin C (User-interface builder)
1-214-245-9139 (voice)
1-214-245-9717 (FAX)
.fi
.IP "\fBCyberstore Online Information Systems, Inc.\fR"
.nf
Cyberstore (BBS package)
1-604-526-3373 (voice)
1-604-526-3373 (FAX)
.fi
.IP "\fBData Access\fR"
.nf
Dataflex (relational DBMS)
305-238-0012 (voice)
800-451-3539 (voice)
305-238-0017 (FAX)
.fi
.IP "\fBELMAS GmbH I. G.\fR"
.nf
LanguagePak 1 (Selected languages)
LanguagePak 2 (More language)
DeskPak (Edit and text formatting plus office automation)
OfficePak (Office automation)
TextPak (Editing and text formatting)
UtilityPak (\*(UN utilities)
CommPak (Communications utilities)
XPak (X utilities)
XtraPak (Additional X utilities)
FunPak (Games)
SourcePak (Source code)
49-303-936-784 (voice)
49-303-922-355 (FAX)
.fi
.IP "\fBFaircom Corporation\fR"
.nf
r-tree (RDBMS package)
c-tree (C interface to the r-tree DBMS)
1-314-445-6833 (voice)
1-314-445-9698 (FAX)
39-357-730-23 (European support)
.fi
.IP "\fBGimpel Software\fR"
.nf
FlexeLint 4.0 (Debugger and programming tool)
1-215-584-4261 (voice)
1-215-584-4261 (FAX)
.fi
.IP "\fBInformation Ink, Ltd.\fR"
.nf
Adaptive Software for the Disabled
1-718-278-8181 (voice)
1-718-278-8268 (FAX, Monday-Thursday, 10 PM-6 AM)
.fi
.IP "\fBInfoflex, Inc.\fR"
.nf
Infoflex and Accountflex (4GL and DBMS)
1-415-340-0220 (voice)
1-415-697-7696 (FAX)
.fi
.IP "\fBIntegration Technologies, Inc.\fR"
.nf
INTEK C++ (C/C++ compiler and programming package)
1-206-455-9935 (voice)
1-206-455-9935 (FAX)
.fi
.IP "\fBJust Logic Technologies\fR"
.nf
Just Logic/SQL (4GL/SQL DBMS)
1-514-642-6480 (voice)
1-514-642-6480 (FAX)
.fi
.IP "\fBLiant Soft\fR"
.nf
RM/COBOL-85 RM/CO* RM/PANELS RM Companion (COBOL compiler)
1-800-762-6265 (voice)
1-512-343-1010 (voice)
1-512-343-9487 (FAX)
.fi
.IP "\fBLotus Development Corporation\fR""
Lotus 1-2-3 for UNIX (Spreadsheet)
.fi
.IP "\fBmbp Software, Inc.\fR"
.nf
Visual Cobol (COBOL compiler)
1-800-231-6342 (voice, USA)
49-231-9441605 (voice, Germany)
1-510-769-4746 (voice, international)
1-510-769-5333 (FAX, USA)
1-510-769-5735 (FAX, USA)
49-231-9442413 (FAX, Germany)
.fi
.IP "\fBMMB Development Corporation\fR"
.nf
TEAMate (client-server BBS software)
310-318-1322 (voice)
310-318-2162 (FAX)
.fi
.IP "\fBMicro Focus\fR"
.nf
Micro Focus Cobol (COBOL compiler)
1-415-496-7215 (voice)
1-415-856-6134 (FAX)
.fi
.IP "\fBMicroEdge Inc.\fR"
.nf
SlickEdit (Configurable editor)
1-800-934-3348 (voice)
1-919-790-1691 (FAX)
1-919-872-5586 (FAX)
.fi
.IP "\fBMicroway\fR"
.nf
Microway Pascal Compiler for \*(CO
1-508-746-7341
.fi
.IP "\fBMultisoft Datentechnik GMBH\fR"
.nf
Flagship (Clipper-like data-base management system)
+49-89-641-7904 (voice)
+49-89-641-2974 (FAX)
303-699-5736 (U.S. agent)
.fi
.IP "\fBOn Top Systems\fR"
.nf
di-ogix  (DBMS and spreadsheet)
1-708-291-0212 (voice)
1-708-291-0597 (FAX)
.fi
.IP "\fBOpen Systems, Inc.\fR"
.nf
Open Systems Accounting Software
1-612-829-0011 (voice)
1-612-829-1493 (FAX)
.fi
.IP "\fBPacific Micro\fR"
.nf
Common-Link (COHERENT/UNIX-DOS-MAC file-transfer utility)
1-415-948-6200 (voice)
1-415-948-6296 (FAX)
.fi
.IP "\fBPacific Software Group\fR"
.nf
Task Manager for UNIX (desktop organizer, productivity software)
909-681-2623 (voice)
.fi
.IP "\fBPRO-C Limited\fR"
.nf
PRO-C Lite (RDBMS C development library)
1-519-725-5143 (voice)
1-519-725-5143 (FAX)
.fi
.IP "\fBPromula\fR"
.nf
Promula Fortran Compiler and FORTRAN to C Translator
1-614-263-5454 (voice)
1-614-263-5573 (FAX)
.fi
.IP "\fBRaima Corp.\fR"
.nf
Raima Data Manager (RDM) (RDBMS and development tool)
206-747-5570 (voice)
206-747-1991 (FAX)
.fi
.IP "\fBRasmussen Software, Inc.\fR"
.nf
ICE (Intelligent COBOL editor)
503-624-0360 (voice)
503-624-0760 (FAX)
.fi
.IP "\fBRevolutionary Software\fR"
.nf
/rdb (RDBMS package)
408-429-6229 (voice)
408-427-0342 (FAX)
.fi
.IP "\fBRoundhill Computer Systems\fR"
.nf
PANEL Plus II (User-interface library)
44-672-84535 (voice)
1-708-690-3737 (voice, USA)
44-672-84525 (FAX)
1-708-665-9841 (FAX, USA)
.fi
.IP "\fBRSYS\fR"
.nf
R Word, RO Plus, RW Plus (Word processors)
1-214-343-9210 (voice)
1-214-343-9218 (FAX)
.fi
.IP "\fBSan Souci Consulting\fR"
.nf
COM/MENT (Fully configurable BBS package)
1-805-327-1172 (voice)
1-805-327-9299 (FAX)
.fi
.IP "\fBSCS Compute Inc.\fR"
.nf
Tax Machine (Tax preparation and accounting package)
1-206-643-2050 (voice)
1-206-562-1783 (FAX)
.fi
.IP "\fBSequiter Software\fR"
.nf
CodeBase 5.0 (C-Language DBMS package)
1-403-437-2410 (voice)
1-403-436-2999 (FAX)
.fi
.IP "\fBSequoia Software\fR"
.nf
Motif for \*(CO (window manager)
305-784-9576 (voice)
305-784-0324 (FAX)
.fi
.IP "\fBSINC Inc.\fR"
.nf
Flex Gen Cobol 4GL (4GL, data base, and code generator)
1-513-438-5553 (voice)
1-513-438-5377 (FAX)
.fi
.IP "\fBSoftfocus\fR"
.nf
BTree/ISAM (File-Access and DBMS package)
1-416-825-0903 (voice)
1-416-825-1025 (FAX)
.fi
.IP "\fBSovereign Technologies\fR"
.nf
Cu/Extended V2.1 (Communications package)
1-800-428-1272 (voice)
.fi
.IP "\fBSynergetic Data Systems\fR"
.nf
Filix (Flat-file DBMS)
Filix General (Report Writer)
1-800-446-7374 (voice)
1-916-933-0120 (voice)
1-916-933-5793 (FZX)
.fi
.IP "\fBSyntactics\fR"
.nf
Crystal Writer Plus (Word processor)
1-408-727-6400 (voice)
1-408-727-0309 (FAX)
.fi
.IP "\fBThe Case Group\fR"
.nf
PC Curses Formation Desktop (User-interface tool)
1-615-352-2146 (voice)
.fi
.IP "\fBThe Small Computer Company\fR"
.nf
filePro (RDBMS)
1-914-769-3160 (voice)
1-914-769-3653 (FAX)
.fi
.IP "\fBThinking Software\fR"
.nf
ROTA (Office automation and scheduling package)
44-993-824-144 (voice)
44-993-823-629 (FAX)
.fi
.IP "\fBThoroughbred\fR"
.nf
Basic Word Query-IV Idol-IV Report-IV Solution-IV
1-908-560-1377 (voice)
1-908-560-1377 (FAX)
.fi
.IP "\fBTrueBASIC Inc.\fR"
.nf
TrueBASIC for \*(CO (BASIC compiler)
1-603-298-8517 (voice)
1-603-298-8517 (FAX)
.fi
.IP "\fBUniCache Systems\fR"
.nf
RealWorld Accounting & Public Safety Software
1-815-968-8026 (voice)
.fi
.IP "\fBUniTrends Software Corp.\fR"
.nf
CTAR (Backup and archiving utility)
1-803-626-2878 (voice)
1-803-626-5202 (FAX)
.fi
.IP "\fBUS Robotics\fR"
.nf
BLAST 10.7.2 (Communications package and terminal emulation)
1-708-933-5561 (voice)
1-708-982-5235 (FAX)
.fi
.IP "\fBVermont Creative Software\fR"
.nf
Vermont Views 3.05 (User-interface library)
1-802-848-7731 (voice)
1-802-848-3502 (FAX)
.fi
.IP "\fBVersasoft Corp.\fR"
.nf
dBMAN V (DBMS, clone of dBASE III Plus)
1-408-723-9044 (voice)
1-408-723-9046 (FAX)
.fi
.IP "\fBWild Hare Computer Systems Inc.\fR"
.nf
Axis Choice HareStylist VS COBOL/INFOS (COBOL compiler)
1-303-530-2221 (voice)
1-303-530-9637 (FAX)
.IP "\fBWordPerfect Corporation\fR"
.nf
WordPerfect for UNIX 5.1 (Word processor)
.fi
.IP "\fBZ/MAX Computer Solutions\fR"
.nf
Z/MAX XChange (BBS package)
1-315-635-1882 (voice)
1-315-635-1908 (FAX)
sales@zmax.xom
.fi
.SH "Freeware and Shareware"
.PP
The University of Alaska's Internet site
.B raven
maintains an archive of public-domain and shareware software that has been
ported to \*(CO.
You can access this site via the Internet and download
software for the price of the connection.
.PP
To access
.BR raven ,
you must have access to a system that
connects to the Internet via TCP/IP.
When you log into this system, type:
.DM
	ftp raven.alaska.edu
.DE
.PP
All files are under the directory
.BR /pub/coherent .
.PP
For other sources of shareware and public-domain software,
see the bulletin boards listed in the next section of these notes.

/v/fwb/doc/mwc/lx/ANSI/fabs
/v/fwb/doc/mwc/lx/ANSI/false
/v/fwb/doc/mwc/lx/TOS/fattrib
/v/fwb/doc/mwc/lx/TOS/fclose
/v/fwb/doc/mwc/lx/ANSI/fclose
/v/fwb/doc/mwc/lx/TOS/fcreate
/v/fwb/doc/mwc/lx/MULTI/fcvt
/v/fwb/doc/mwc/lx/TOS/fdatime
/v/fwb/doc/mwc/lx/TOS/fdelete
/v/fwb/doc/mwc/lx/MULTI/fdopen
/v/fwb/doc/mwc/lx/TOS/fdup
/v/fwb/doc/mwc/lx/ANSI/feof
/v/fwb/doc/mwc/lx/ANSI/ferror
/v/fwb/doc/mwc/lx/ANSI/fflush
/v/fwb/doc/mwc/lx/TOS/fforce
/v/fwb/doc/mwc/lx/ANSI/fgetc
/v/fwb/doc/mwc/lx/TOS/fgetdta
/v/fwb/doc/mwc/lx/ANSI/fgetpos
/v/fwb/doc/mwc/lx/ANSI/fgets
/v/fwb/doc/mwc/lx/MULTI/fgetw
/v/fwb/doc/mwc/lx/MULTI/field
/v/fwb/doc/mwc/lx/MULTI/file
/v/fwb/doc/mwc/lx/ANSI/file
/v/fwb/doc/mwc/lx/ANSI/file_
/v/fwb/doc/mwc/lx/MULTI/filedescriptor
/v/fwb/doc/mwc/lx/ANSI/filename_max
/v/fwb/doc/mwc/lx/MULTI/fileno
/v/fwb/doc/mwc/lx/ANSI/float
/v/fwb/doc/mwc/lx/ANSI/float.h
/v/fwb/doc/mwc/lx/ANSI/floatingconsta
/v/fwb/doc/mwc/lx/ANSI/floor
/v/fwb/doc/mwc/lx/TOS/flopfmt
/v/fwb/doc/mwc/lx/TOS/floprd
/v/fwb/doc/mwc/lx/TOS/flopver
/v/fwb/doc/mwc/lx/TOS/flopwr
/v/fwb/doc/mwc/lx/ANSI/fmod
/v/fwb/doc/mwc/lx/ANSI/fopen
/v/fwb/doc/mwc/lx/TOS/fopen
/v/fwb/doc/mwc/lx/ANSI/for
/v/fwb/doc/mwc/lx/ANSI/fpos_t
/v/fwb/doc/mwc/lx/ANSI/fprintf
/v/fwb/doc/mwc/lx/ANSI/fputc
/v/fwb/doc/mwc/lx/ANSI/fputs
/v/fwb/doc/mwc/lx/MULTI/fputw
/v/fwb/doc/mwc/lx/ANSI/fread
/v/fwb/doc/mwc/lx/TOS/fread
/v/fwb/doc/mwc/lx/ANSI/free
/v/fwb/doc/mwc/lx/TOS/frename
/v/fwb/doc/mwc/lx/ANSI/freopen
/v/fwb/doc/mwc/lx/ANSI/frexp
/v/fwb/doc/mwc/lx/ANSI/fscanf
/v/fwb/doc/mwc/lx/ANSI/fseek
/v/fwb/doc/mwc/lx/TOS/fseek
/v/fwb/doc/mwc/lx/TOS/fsetdta
/v/fwb/doc/mwc/lx/ANSI/fsetpos
/v/fwb/doc/mwc/lx/TOS/fsfirst
/v/fwb/doc/mwc/lx/TOS/fsnext
/v/fwb/doc/mwc/lx/MULTI/fstat
/v/fwb/doc/mwc/lx/ANSI/ftell
/v/fwb/doc/mwc/lx/ANSI/function
/v/fwb/doc/mwc/lx/ANSI/functioncall
/v/fwb/doc/mwc/lx/ANSI/functiondeclar
/v/fwb/doc/mwc/lx/ANSI/functiondefini
/v/fwb/doc/mwc/lx/ANSI/functiondesign
/v/fwb/doc/mwc/lx/ANSI/functionprotot
/v/fwb/doc/mwc/lx/ANSI/fwrite
/v/fwb/doc/mwc/lx/TOS/fwrite

.IP \fBafio\fR 1.0i
A `smart'
.BR cpio -format
archiver.
.IS \fBbasic\fR
A BASIC interpreter.
.IS \fBbyacc\fR
A Berkeley-style
.BR yacc .
.IS "\fBckermit 1.88\fR"
The latest version of the popular
.B kermit
communications package from Columbia University.
.IS "\fBcomb 1.48\fR"
The popular alternative to \*(CO's mail program.
.IS \fBdte\fR
A screen editor that uses WordStar-style command sequences.
.IS \fBelvis\fR
The full source kit used to build
.BR elvis ,
the clone of the \*(UN editor
.B vi
that is included with \*(CO.
.IS \fBempire\fR
A war game between you and the computer, in which your
war efforts are supported by the various cities you own.
.IS "\fBminicom 1.33\fR"
A popular communcations package that features
VT-100 emulation and supports external file-transfer protocols.
.IS \fBtcsh\fR
A popular clone of the Berkeley C shell.
.IS \fBtex2roff\fR
A utility that translates
texinfo documents into a format printable by
.B nroff
or
.BR troff .
.IS "\fBtin 1.18\fR"
A news reader and posting program.
.IS "\fBTaylor UUCP 1.04\(*g\fR
The latest version of the Taylor UUCP package.
It features an implementation of the Berkeley utility
.B cu
and supports various \*(UU file-transfer protocols.
Note that \*(CO 4.2 uses Taylor \*(UU as its default \*(UU utility.
.IS \fBwanderer\fR
Wander through a magical cave as you pick up riches and
fight monsters along the way.
.IS \fBworld\fR
A text-based adventure that takes place on another world.
.IS \fBxscheme\fR
An interpreter of the SCHEME language.

.IP \fBbackgammon\fR 1.0i
\fBgames/games.zip\fR
(disk 1, 5.25''; disk 4, 3.5'')
.br
A computer implementation of the Middle-Eastern game.
.IP \fBbattle\fR
\fBgames/battle.tar.Z\fR
(disk 5, 5.25'';
disk 1, 3.5'')
.br
A clone of the popular game ``battleship''.
.IP \fBcastle\fR
\fBgames/castle.tar.Z\fR
(disk 3, 5.25'';
disk 2, 3.5'')
.br
A \fBcurses\fR-based, Dungeons & Dragons-style adventure game.
.IP \fBchess\fR
\fBgames/chess.tar.Z\fR
(disk 3, 5.25'';
disk 2, 3.5'')
.br
How about a nice game of chess...?
This implementation plays a fairly respectable game.
.IP \fBckermit\fR
\fBcommunications/ckermit.zip\fR
(disk 1, 5.25'';
disk 4, 3.5'')
.br
This is version 1.79 of the communications package from
Columbia University.
.IP \fBcu\fR
\fBcommunications/cu.tar.Z\fR
(disk 1, 5.25 and 3.5'')
An implementation of the \fBcu\fR communications utility, for those
familiar with UNIX.
.IP \fBdash\fR
\fBshells/dash.tar.Z\fR
(disk 2, 5.25'';
disk 3, 3.5'')
.br
An advanced shell for COHERENT.
.B dash
offers advanced command history and other functions.
.IP \fBdmake\fR
\fBmisc/dmake.tar.Z\fR
(disk 3, 5.25'';
disk 2, 3.5'')
.br
An advanced \fImake\fR utility.
This utility is required to compile many public-domain packages,
including the
.B sc
spreadsheet that is also included in this volume of COHware.
.IP \fBelm\fR
\fBmailers/elm.zip\fR
(disk 2, 5.25 and 3.5'')
This is an implementation of the
mailer and utilies used on many UNIX systems.
.IP \fBforth\fR
\fBlanguages/forth.tar.Z\fR
(disk 3, 5.25 and 3.5'')
.br
The popular development language.
.IP \fBgomoku\fR
\fBgames/gomoku.tar.Z\fR
(disk 3, 5.25'';
disk 2, 3.5'')
.br
An ``Othello''-style game played on a 19x19 grid.
.IP \fBhexed\fR
\fBfile_utils/hexed.tar.Z\fR
(disk 4, 5.25 and 3.5'')
.br
A hexadecimal file-editing utility.
.IP \fBlander\fR
\fBgames/lander.tar.Z\fR
(disk 5, 5.25'';
disk 1, 3.5'')
.br
A clone of the popular arcade game, ``Lunar Lander''.
.IP \fBmc\fR
\fBspread_sheet/mc.tar.Z\fR
(disk 5, 5.25'';
disk 3, 3.5'')
.br
A powerful spreadsheet program developed for COHERENT.
.IP \fBogre\fR
\fBgames/ogre.tar.Z\fR
(disk 1, 5.25'';
disk 4, 3.5'')
.br
A game of tank warfare in the 21st century.
.IP \fBpatch20\fR
\fBfile_utils/patch20.tar.Z\fR
(disk 4, 5.25'';
disk 1, 3.5'')
.br
Utility for merging
.B diff
files with source.
Required for
.BR quebbs .
.IP \fBquebbs\fR
\fBcommunications/quebbs.tar.Z\fR
(disk 1, 5.25 and 3.5'')
.br
An interactive bulletin board package.
.IP \fBrogue\fR
\fBgames/games.zip\fR
(disk 1, 5.25'';
disk 4, 3.5'')
.br
A popular \fBcurses\fR-based, Dungeons & Dragons-style adventure game.
.IP "\fBsc 6.16\fR"
\fBspread_sheet/sc616.tar.Z\fR
(disk 5, 5.25'';
disk 3, 3.5'')
.br
A popular spreadsheet developed for various flavors of UNIX.
.IP "\fBscreen 3.2\fR"
\fButils/screen.zip\fR
(disk 5, 5.25'';
disk 4, 3.5'')
.br
A package for managing virtual consoles and terminals.
.IP \fBsokoban\fR
\fBgames/sokoban.tar.Z\fR
(disk 3, 5.25'';
disk 2, 3.5'')
.br
A clone of the popular game ``Boxie''.
.IP \fBsolitaire\fR
\fBgames/games.zip\fR
(disk 1, 5.25'';
disk 4, 3.5'')
.br
A \fBcurses\fR-based implementation of the popular card game.
.IP \fBtetris\fR
\fBgames/games.zip\fR
(disk 1, 5.25'';
disk 4, 3.5'')
.br
A clone of the popular arcade game.
.IP \fBunzip\fR
\fBfile_utils/unzip.tar.Z\fR
(disk 4, 5.25'';
disk 3, 3.5'')
.br
Utility for unarchiving
.B zip
archives.
.IP \fBuucp\fR
\fBcommunications/uucp.zip\fR
(disk 4, 5.25'';
disk 1, 3.5'')
.br
The popular Taylor UUCP package.
.IP "\fBxcomm 3.3\fR"
\fBcommunications/xcomm33.zip\fR
(disk 1, 5.25 and 3.5'')
.br
Communications package featuring a scripted language.
.B xcomm
includes support for
Xmodem and CompuServe B+.
.IP \fBzip\fR
\fBfile_utils/zip.tar.Z\fR
(disk 5, 5.25'';
disk 4, 3.5'')
.br
Utility for creating
.B zip
archives.
.IP \fBzoo\fR
\fBfile_utils/zoo.tar.Z\fR
(disk 3, 5.25 and 3.5'')
.br
Utility for creating
.B zoo
archives.

.IP \fBbackgammon\fR 1.0i
A computer implementation of the Middle-Eastern game.
.IS \fBbattle\fR
A clone of the popular game ``battleship''.
.IS \fBcastle\fR
A \fBcurses\fR-based, Dungeons & Dragons-style adventure game.
.IS \fBchess\fR
How about a nice game of chess ... ?
This implementation plays a fairly respectable game.
.IS \fBckermit\fR
This is version 1.79 of the communications package from Columbia University.
.IS \fBcu\fR
An implementation of the \fBcu\fR communications utility, for those
familiar with UNIX.
.IS \fBdash\fR
An advanced shell for COHERENT.
.B dash
offers advanced command history and other functions.
.IS \fBdmake\fR
An advanced \fImake\fR utility.
This utility is required to compile many public-domain packages, including the
.B sc
spreadsheet also included with COHware.
.IS \fBelm\fR
This is an implementation of the
mailer and utilies used on many UNIX systems.
.IS \fBforth\fR
The popular development language.
.IS \fBgomoku\fR
An ``Othello''-style game played on a 19\(mu19 grid.
.IS \fBhexed\fR
A hexadecimal file-editing utility.
.IS \fBlander\fR
A clone of the popular arcade game, ``Lunar Lander''.
.IS \fBmc\fR
A powerful spreadsheet program developed for COHERENT.
.IS \fBogre\fR
A game of tank warfare in the 21st century.
.IS \fBpatch20\fR
Utility for merging
.B diff
files with source.
Required for
.BR quebbs .
.IS \fBquebbs\fR
An interactive bulletin board package.
.IS \fBrogue\fR
A popular \fBcurses\fR-based, Dungeons & Dragons-style adventure game.
.IS "\fBsc 6.16\fR"
A popular spreadsheet developed for various flavors of UNIX.
.IS "\fBscreen 3.2\fR"
A package for managing virtual consoles and terminals.
.IS \fBsokoban\fR
A clone of the popular game ``Boxie''.
.IS \fBsolitaire\fR
A \fBcurses\fR-based implementation of the popular card game.
.IS \fBtetris\fR
A clone of the popular arcade game.
.IS \fBunzip\fR
Utility for unarchiving
.B zip
archives.
.IS \fBuucp\fR
The popular Taylor UUCP package.
.IS "\fBxcomm 3.3\fR"
Communications package featuring a scripted language.
.B xcomm
includes support for
Xmodem and CompuServe B+.
.IS \fBzip\fR
Utility for creating
.B zip
archives.
.IS \fBzoo\fR
Utility for creating
.B zoo
archives.

.ds RN "COHERENT"
.ds TL "Updating"
.NH "Updating COHERENT"
.PP
If you are already running the \*(CO system and are not yet running release
4.2 of \*(CO, you need to
.I update
your system rather than
.I install
\*(CO.
Updating \*(CO basically involves copying a new image of the \*(CO
system into your system's root partition.
This process is fast and easy, but please read this section in its
entirety before you begin, in order to spare yourself unpleasant surprises.
.PP
The following description assumes that, as an experienced \*(CO user,
you understand what a \fIpartition\fR and a \fIfile system\fR is.
If you are unsure of what these are, see the sub-section
\fIHow a Disk Is Organized\fR, in the installation portion of these notes.
.SH "Before You Begin"
.PP
Before you begin to update your \*(CO system, you must make a few
decisions and check a few facts.
The following will help you prepare for updating.
.Sh "Get Your Serial Number"
.PP
Because you are updating \*(CO rather than installing it, your copy of
\*(CO 4.2 did
.I not
include a card with a serial number on it.
.I
During updating, when you are asked to enter your system's nine-digit serial
number, you must enter the serial number of your current system.
.R
.PP
Your \*(CO system's serial number is kept in file
.BR /etc/serialno .
To read it, simply type the command:
.DM
	cat /etc/serialno
.DE
Before you continue,
be sure to write down your serial number on a piece of paper.
Be careful to write the number correctly; if you make a mistake,
\*(CO will complain when you attempt to update it.
.Sh "Select a Partition"
.PP
Your first task is to select a partition into which you want to install \*(CO.
.PP
First, you must see if you have a partition that is large enough to hold
\*(CO 4.2.
.B su
to the superuser \fBroot\fR.
Then, if you have an ordinary AT-style disk, type the command:
.DM
	/etc/fdisk -r /dev/at0x
.DE
If you have a SCSI device, type the command:
.DM
	/etc/fdisk -r /dev/sd0x
.DE
This prints information about how your hard disk is partitioned.
The following shows the layout of a typical SCSI hard disk:
.DM
	Drive 0 currently has the following logical partitions:
	                 [ In Cylinders ]  [    In Tracks    ]
	Number     Type  Start  End  Size  Start    End   Size Mbytes  Blocks Name
	0       Coherent     0   19    20      1   1279   1279  20.96   40928 /dev/sd0a
	1       Coherent    20   79    60   1280   5119   3840  62.91  122880 /dev/sd0b
	2       Coherent    80  139    60   5120   8959   3840  62.91  122880 /dev/sd0c
	3 Boot  Coherent   140  197    58   8960  12671   3712  60.82  118784 /dev/sd0d
.DE
As you can see, this disk drive has four partitions,
each of which holds a \*(CO file system.
Device
.B /dev/sd0d
holds the root file system, as shown by the fact that it is marked as being
the ``Boot'' partition.
The size of the partition is in the next-to-last column, in blocks.
.PP
Now, you must select which partition you wish to use to hold the new
root file system.
The root partition must hold at least 20 megabytes (about 40,000 blocks),
of which at least 17,000 blocks must be free.
You can use a \*(CO partition other than the one that holds the current
\*(CO root file system,
although this will complicate the installation process.
.PP
If the device you wish to use as the root partition does not have at least
17,000 free blocks, you must free up some space by deleting or
compressing files.
.PP
Many \*(CO users choose to install \*(CO 4.2 onto a partition other than
their current root partition, rather than update their current root
partition.
This lets them run \*(CO 4.2 side-by-side with \*(CO 4.0, and gradually
configure \*(CO 4.2 to suit their preferences.
If you wish to do this, you should first back up all
files on that partition that were not part of the \*(CO 4.0 release,
as well as any files that you created.
This will ensure that your important files are not accidentally destroyed
during the installation process.
You must then perform a \fIfull installation\fP, as detailed in the first
section of these notes.
Only after you have successfully installed \*(CO 4.2 can you restore
your backups.
\fIDo not attempt to update a partition that does not hold
a \*(CO root file system!\fR
.PP
If you do not have a \*(CO root partition that is 20 megabytes or greater,
you must \fIinstall\fR \*(CO rather than \fIupdate\fR it.
The installation process will let you reconfigure your hard disk
to create a partition large enough to run \*(CO 4.2.
Before you begin installation, however, read the sub-section below entitled
\fISave System Files\fR, and follow its directions.
Then turn to the previous section in these notes, on installation,
and follow the directions there.
.PP
The update program will ask you for the device name
and partition number of your current \*(CO root partition.
Write down the device name and partition number.
.Sh "System Hardware"
.PP
During the update process, you will be asked a number of questions
about the hardware that your system has installed.
Make note of the following:
.IP \(bu 0.3i
Every monitor you have plugged into the system, and whether it is
plugged into a color or monochrome display card (i.e., video adapter).
\*(CO lets you have up to two monitors on your system, with
one plugged into a monochrome (e.g., MDA) display card and the other
into a color (CGA, EGA, or VGA) display card.
.IP \(bu
The number of printers you have,
the type of each printer (e.g., PostScript, LaserJet compatible),
and the port into which each is plugged.
.IP \(bu
The number of serial ports you have.
Note also which ones have local devices (e.g.,
terminals) plugged into them, and which have remote devices (e.g., modems).
Note whether you want the ports to be polled or interrupt-driven.
Write down your hardware configuration.
.Sh "System and Domain Name"
.PP
To use the mail and UUCP system under \*(CO, you must set the machine
name of your system.
If you have not yet named your system, select a name now.
The name should not exceed eight characters,
must consist of letters and numbers, and should begin with a letter.
.PP
If you have already named your system, you do not need to do so again.
For more information on the naming
conventions of machine and domain names,
along with suggestions on how to select a name for your system,
refer to sections \fISystem Name\fP and \fIDomain Name\fP in the
Installation chapter of these notes, as well as Lexicon articles
.B uucpname
and
.BR domain .
.PP
Write down the system and domain name.
.Sh "Turn Off Shadow Passwords"
.PP
Some users have installed shadow passwords on their system.
This stores users passwords in
.B /etc/shadow
rather
.BR /etc/passwd .
The
.B login
program included \*(CO 4.2 assumes that passwords are in
.BR /etc/passwd .
Therefore, if you are running shadow passwords, you should restore
.B /etc/passwd
before you attempt to update \*(CO.
.Sh "Save System Files"
.PP
The update program will make its best attempt to save all system files that
you have customized for yourself.
These files are saved by the update program into a
directory tree contained under directory
.B /old_coh
in your existing root file system.
The update program creates this directory prior to backing up \(em
\fIdo not create the directory yourself!\fP
In addition, for safety's sake, you should back up these files by
copying them to a floppy disk.
For further details,
see the Lexicon articles for
.B gnucpio
(included in these notes)
and
.BR tar .
.PP
The update command knows about the following files, and will try to
preserve them:
.DM
.ta 0.25i 2.25i 4.25i
	/.profile	/etc/.profile	/etc/brc
	/etc/checklist	/etc/domain	/etc/drvld.all
	/etc/modemcap	/etc/mount.all	/etc/passwd
	/etc/profile	/etc/serialno	/etc/termcap
	/etc/timezone	/etc/ttys	/etc/umount.all
	/etc/uucpname	/usr/lib/mail/aliases	/usr/lib/mail/paths
	/usr/lib/uucp/L-devices	/usr/lib/uucp/L.sys	/usr/lib/uucp/Permissions
	/usr/pub/phonebook
.DE
For safety's sake, you should back them up anyway.
Note that files
.BR L-devices ,
.BR L.sys ,
and
.B Permissions
will be replaced by
.BR port ,
.BR sys ,
and
.B dial
as UUCP is converted to Taylor UUCP.
.PP
.B update
will also attempt to save your old \*(CO 4.0 kernel by copying it into file
.BR /coh.B4.420 .
Note, however, that if updating should be interrupted and then restarted,
.B update
may overwrite your saved 4.0 kernel with the interim kernel it created
during the first, failed attempt at updating.
Therefore, you are well advised to save your \*(CO 4.0 kernel into
a file of your old naming (e.g.,
.BR /coherent.bak ),
before you begin to update your system.
.PP
.B update
overwrites all system files that (1) are in your root partition,
(2) come with the \*(CO system, and that
(3) do not appear on the above list.
You should save them, or their contents will be lost or modified.
For example, you may have modified the file
\fB/usr/games/lib/fortunes\fR.
Back it up, or your added words of wisdom will be lost.
If, however, you added a new fortune file to \fB/usr/games/lib\fR,
it will not be overwritten because it was not
originally included with your \*(CO distribution.
.PP
The point is, if you are doubtful about the status of any file
in your root partition \(em back it up!
If you find you do not need to reinstall it later,
you have a backup for future use.
.Sh "Manual Pages"
.PP
.B update
removes all files from directory
.BR /usr/man/COHERENT .
It also replaces the file
.BR /usr/man/man.index .
If you have installed into
.BR /usr/man/COHERENT
any non-\*(CO manual pages,
.B update
erases them.
You should save them into a directory of their own, e.g.,
.BR /usr/man/LOCAL ,
or they will be lost.
.PP
Note, too, that you must add to the file
index entries for those manual pages
.BR /usr/man/man.index ,
or the command
.B man
cannot find them.
The format of
.B man.index
has changed from release 4.0.
For details, see the Lexicon entry for the command
.BR man .
.Sh "C Code and Private Programs"
.PP
Almost all programs that run under \*(CO 4.0 will run
under \*(CO 4.2 without modification.
.PP
\*(CO 4.2 uses a new version of the header file
.B <stdio.h>
and of the standard I/O library.
This was done to achieve greater compatibility
with iBCS and \fBgcc\fR/\fBg++\fR libraries.
As a result of this, if you wish to modify a program, you must rebuild
.I all
existing
.B \&.o
and
.B \&.a
files, not just the modules that you modify.
If you do not, you may experience unresolved references from
the linker or programs may link but not work as expected.
However, linked binaries (that is, executable files)
are fine because they do not use the new headers or libraries
and thus do not need to be rebuilt.
.PP
In addition,
some programs that compile correctly under \*(CO 4.0 may need to be
modified to be compilable under \*(CO 4.2.
For example, the suite of header files changed under \*(CO 4.2, and your program
may need to include different files.
.PP
See the Lexicon entry \fBC language\fR for a summary of how the C language
is implemented under \*(CO 4.2.
The entry \fBheader files\fR names all header files, and notes which is
included with which implementation of \*(CO.
In addition, refer to section \fINotes and Errata\fP in these notes.
.SH "Updating COHERENT"
.PP
Now that you've finished your preparation, you're ready to begin.
Log in as the superuser
.B root
and type the command:
.DM
	/etc/shutdown
.DE
This will bring the system into single-user mode.
Then enter the command:
.DM
	sync
.DE
Before attempting to update your system, be sure to verify that enough
free space exists on your existing \*(CO root file system.
To do so, enter the command:
.DM
	df /dev/root
.DE
Command
.B df
display a line similar to:
.DM
	/dev/root   16794/ 75198 = 22.3%
.DE
The number before the slash indicates the number of free disk
blocks on the root file system.
The number after the slash indicates the maximum number of
data blocks on the file system.
In the above example, there are 16,794 free
blocks (about eight megabytes) on the root partition.
Because the update requires that the root file system have at least
10,000 free blocks, the example root file system has sufficient
free space to contain the \*(CO 4.2 update.
.PP
Next, enter the command:
.DM
	fsck
.DE
This will ensure that your file systems are in good shape.
Installing an update of \*(CO into a damaged file system could cause serious
problems, so be sure that your file systems are intact before you continue.
.PP
Next, take the \fBBoot\fR disk from your \*(CO installation kit, and
insert it into drive A on your computer.
Then press the reset button.
The screen will clear, and you will see the following prompt:
.DM
	COHERENT Tertiary boot Version 1.2.7
	If installing COHERENT, please type "begin".
	?
.DE
Type the following:
.DM
	update
.DE
This invokes the \*(CO update program, which begins the updating process.
\fIDo not type ``begin'' as that will invoke the installation program!\fR
.PP
Your system will then boot a miniature version of \*(CO 386
from the floppy disk.
This miniature \*(CO executes a script that controls the updating process.
.PP
The rest of the updating process is straightforward, and consists mainly
of answering the few questions described above.
The previous section in these notes, on installation, describes the
questions you will be asked and gives the text of most every prompt and message.
We suggest that you read it for a preview of updating.
.PP
Many users have updated their \*(CO systems with few problems.
We expect that your experience will be the same.
Should a problem arise, however, review the previous section's final
part, which discusses the commoner problems and what you can do to
cope with them.
If your system cannot boot \*(CO 4.2 from the floppy disk, chances
are that you cannot run it on your computer.
Refer to the Copyright page of these notes for information on contacting
the Mark Williams Technical Support department.
.SH "Restarting Updating"
.PP
Some users have, for one reason or another, been forced to interrupt
updating their \*(CO systems midway throught he updating process.
These users will need to restart the updating process.
.PP
To restart
.BR update ,
do the following:
.IP \fB1.\fR
First boot your \*(CO 4.0 kernel.
.B update
will have saved it in file
.BR /coh.B4.420 .
.IP \fB2.\fR
Bring up your system in single-user mode.
You can do this by pressing
.B <ctrl-C>
while the command
.B fsck
is checking your file systems, before your system has entered multi-user
mode.
.IP \fB3.\fR
If you had completed copying all of the disks of your \*(CO 4.2 release
onto your system, cd to directory
.B /conf
and invoke the script
.BR Coh_420.post .
This will walk you through the process of configuring your system for
\*(CO 4.2.
.IP \fB4.\fR
If you had
.I not
completed copying all of the disks of your \*(CO 4.2 release onto your
system, type the command:
.DM
	rm /Coh_420.?
.DE
Then insert the boot disk from your installation kit into drive A and
reboot your system.
.PP
Note that if you are having trouble updating your \*(CO system for whatever
reason, you can
.I install
\*(CO 4.2 onto a partition other than your current root partition.
Then, you can run \*(CO 4.0 and \*(CO 4.2 side by side, and gradually migrate
from one system to the other.

.ds TL "User Groups"
.NH "User Groups and Bulletin Board"
.PP
\*(CO user groups are found throughout the world.
Most groups sponsor meetings and electronic bulletin-board services.
.PP
If there is not a \*(CO user group in your area, we can help you establish one.
If you are in a user group that is not listed below,
please write to the User Group Co-ordination Director at Mark Williams
Company so that your group can be registered and listed in our future
publications.
.PP
Mark Williams Company makes every effort to keep the listings in this section
up to date.
However, we cannot guarantee that all the user groups listed are
still active, nor can we guarantee that the BBS information is current.
If you do discover a discrepancy,
please contact the User Group Co-ordination Director at Mark Williams Company.
.SH "User Groups Bulletin Boards"
.PP
The following lists registered \*(CO user groups.
It also lists bulletin boards that offer material of interest to \*(CO users.
Each entry gives the address of the group and way in which you can contact
its administrator.
.PP
Please note that these groups are administered by people who volunteer time
and equipment to help you.
Please respect this:
for example, do not telephone administrators late at night with questions.
.Sh Australia
.DS
	Australian Coherent Users Group/BBS
	Richard Lindner (rjl@spectre.apana.org.au)
	P.O.Box 1555
	Wodonga, Vic. 3689
	Australia
		Data: 61 60 208773
		FAX: 61 60 562105
.DE
.DS
	Robert Chalmers
	22 Minster Street
	Mackay.	4740
	Queensland
	Australia
		Site Name:
			nanguo (cstpl.com.au)
		Data:	+61 79 524527 (Mackay, 24 hours)
			+61  7 8011737 (Brisbane, 24 hours)
		Voice:	+61 79 524395 (9 AM \(em 5 PM Australian EST)
		FAX:	+61 79 524032 (24 hours)
		e-mail:	robert@cstpl.com.au
			paul@cstpl1.cstpl.com.au
		Info-Server:
			info@cstpl.com.au (Subject: list)
.DE
.Sh Germany
.DS
	Olaf Matthaei
	Luckenwalderstrasse 38
	15711 Koenigswusterhausen
	Germany
		e-mail: \fBmailserver@kwcom.in-berlin.de\fR
.DE
.DS
	Udo Munk (udo@umunk.gun.de)
	Udo Munk's Private BBS
	Oberstrasse 21, 41460 Neuss
	Germany
		Data: +49 2131 278869
		Login: uucp
		passwd: public (Only for the first call)
.DE
.DS
	Axel Reinhold (Axel_Reinhold@wun.maus.de)
	ARXBBS
	Untere Bergstrasse 9
	95100 Selb
	Germany
		Data: +49-9287/87446
		FAX:  +49-9287/87232
		BBS:  +49-9287/8244 (V22-V32bis N/8/1)
		Hours: 22:00 \(em 06:00 CET Daily
		       07:00 \(em 12:00 CET Monday \(em Friday
		Modem: 14.4k \(em 1200 baud V.42Bis & MNP-5
.DE
.\".Sh Japan
.\".DS
.\"	Japanese \*(CO Users Group 
.\"	Yoshihisa Suda
.\"	924-111
.\"	Misawa Hino-City
.\"	Tokyo, Japan T191
.\"		Fax: +81 425 92 4646
.\".DE
.Sh "The Netherlands"
.DS
	First Dutch COHERENT Users' Group & BBS
	Aart Van Erven (aart@fdcbbs.iaf.nl)
	Mezenhof 119
	1742 GJ
	Schagen
	The Netherlands
		Data: +31 2240 97099 (14.4 kilobaud)
		UUCP test login: guest		
.DE
.Sh "New Zealand"
.DS
	ACME BBS
	Craig Harding
	P.O. Box 128
	Palmerston North
	New Zealand
.DE
.Sh "United States"
.DS
	Good News BBS and Users Group
	Timothy G. Wells
	3740 Boudinot Ave.
	Cincinnati, OH  45211
.DE
.DS
	Bay Area \*(CO Users Group
	Viki Tamaradze
	P.O. Box 622
	El Cerrito, CA 94530
		Telephone: 510-549-1876
.DE
.DS
	COHERENT Support BBS
	Dmitry L. Gringauz (dmitry@golem.com)
	Data: 415-312-8751, login as ``guest''
.DE
.\".SH "Preferred COHERENT Bulletin Boards"
.\".PP
.\"The following lists the preferred bulletin boards throughout the world.
.\"These bulletin boards are authorized to carry updates to \*(CO software,
.\"among other services.
.\".PP
.\".I Note:
.\"The hardworking administrators of these systems are volunteers, who
.\"donate their time and expertise to \*(CO users in your area.
.\"\fIPlease do not abuse their generosity!\fR
.\"If you truly need advice, please send electronic mail:
.\"do \fInot\fR telephone.
.\".Sh Australia
.\".PP
.\".DS
.\"	Australian \*(CO Users Group BBS
.\"	System Administrator:  Richard Lindner
.\"	E-mail:  rjl@spectrum.pub.uu.oz.au
.\"	Telephone:  +61-3-882-4690
.\"	FAX:  +61-3-824-0655
.\".DE
.\".Sh Germany
.\".PP
.\".DS
.\"	ARXBBS
.\"	System Administrator: Axel Reinhold
.\"	Untere Bergstrasse 9
.\"	W-8672 Selb, Germany
.\"	Modem: +49-9287-814400 (1200 Baud V42.BIS + MNP-5)
.\"	22:00 - 06:00 CET Daily
.\"	07:00 - 12:00 CET Monday - Friday
.\".DE
.\".DS
.\"	Udo Munk's private BBS
.\"	Udo Munk
.\"	Oberstrasse 21
.\"	4040 Neuss 1, Germany
.\"	Telephone: +49-2131-275348
.\".sp \n(pDu
.\"	Modem: +49-2131-278869
.\"	system name: umunk
.\"	login: uucp
.\"	passwd: public
.\".sp \n(pDu
.\".fi
.\".B /usr/lib/uucp/Permissions
.\"must have the field
.\".B MYNAME=bbsuser
.\"for first connect.
.\"At the first connect, download the file
.\".BR /usr/spool/uucppublic/info .
.\".DE
.\".Sh "New Zealand"
.\".DS
.\"	ME BBS
.\"	Contact: Craig Harding
.\"	P.O. Box 128, Palmerston North, New Zealand
.\".DE
.SH "Registering Your COHERENT User Group"
.PP
If you are the member of a \*(CO user group or special interest group and
your group is not listed above, you can register your group with Mark Williams
Company by writing to the User Group Co-ordination Director.
By doing so, you ensure your group's inclusion in the next listing.
When you register your group, please include the following information:
.IP \(bu 0.3i
The name and address of the group.
.IP \(bu
The name of the group's administrator (if any).
.IP \(bu
Size of the group.
.IP \(bu
Date group was established.
.IP \(bu
Frequency and nature of group meetings.
.SH "Mark Williams Bulletin Board"
.PP
Mark Williams Company has set up a \*(CO \*(UU node for dial-up
use by our customers.
It serves three major purposes:
.IP \fB1.\fR 0.3i
As a remote site with which you can test your \*(UU configuration.
.IP \fB2.\fR
As a source of news, bug fixes, and public-domain software for you to download.
In addition, the BBS lists new \*(QLthird party\*(QR
software and hardware that work with \*(CO.
.IP \fB3.\fR
As a mail drop for customers who request an account.
If you wish,
you can can exchange electronic mail with MWC and other \*(CO users.
.Sh "Accessing the MWC BBS"
.PP
Before you try to access the MWC BBS, note that you
.I must
use \*(UU.
You cannot use
.BR ckermit ,
.BR Procomm ,
or any other communications utility.
.PP
Before you proceed, please review the tutorial on \*(UU in the \*(CO manual.
It includes an exhaustive tutorial on this powerful utility and uses
.B mwcbbs
throughout it.
In most cases, the tutorial gives you all the information you need.
.PP
You can access
.B mwcbbs
through the following three telephone numbers:
.DS
.ta 0.5i 3.5i
	1200/2400-baud generic modem:	559-0412
	9600-baud Trailblazer modem:	559-0445
	9600-baud V.32 or HST modem:	559-0452
.DE
.Sh "Downloading Files"
.PP
Once you have succeeded in contacting
.BR mwcbbs ,
you can begin to exchange files and mail with Mark Williams personnel,
and with other \*(CO users.
.PP
For your initial contact with \fBmwcbbs\fR, we recommend that you download
the introductory message \fBhowto.start\fR from directory
.BR /usr/spool/uucppublic/mwcnews .
For example, the command:
.DM
	uucp  -r mwcbbs!/usr/spool/uucppublic/mwcnews/howto.start  /tmp
.DE
queues up a request to copy file \fBhowto.start\fR into directory
.B /tmp
on your system.
This file contains information on available downloads, new \*(CO
developments, and how to obtain an individual account on the system.
If the time at which you type the \fBuucp\fR command is within the range
of times allowed in the entry for
.B mwcbbs
in
.BR /usr/lib/uucp/sys ,
your modem will call \fBmwcbbs\fR immediately \(em
you can check this with the commands \fBps\fR or \fBuulog\fR.
If you wish to force polling of mwcbbs at a time not specified in
.BR /usr/lib/uucp/sys ,
you can do so with the command:
.DM
	su uucp /usr/lib/uucp/uucico -Smwcbbs  &
.DE
You can then monitor the progress of the transfer via the command:
.DM
	uulog -f mwcbbs
.DE
To stop monitoring the call, type
.BR <ctrl-C> .
.Sh "Electronic Mail Access"
.PP
The following electronic mail addresses are available to customers.
.PP
For issues relating to administration of the BBS node, send mail to
.BR mwcbbs!admin .
.PP
For matters relating to support of \*(CO and related
products, send mail to
.BR mwcbbs!support .
.PP
Additional mail aliases may appear from time to time.
Please remember that mail sent to either of the aforementioned addresses
will be sent to \fBmwcbbs\fR only when you invoke
.BR uucico .
You can do this interactively from the \*(CO shell,
as shown in the example above, or at regular intervals as a \fBcron\fR task.
The following gives a sample line for your
.B cron
file:
.DM
	15 20 * * * su uucp /usr/lib/uucp/uucico -smwcbbs
.DE
This line will check every day at 8:15 PM for
.B uucp
and
.B mail
requests which have been queued for
.BR mwcbbs ,
and, if any are found, will call \fBmwcbbs\fR.
See the Lexicon article
.B cron
for further information.
.PP
Please note that while the BBS supports inbound electronic mail from
your system to
.B mwcbbs
via anonymous \*(UU,
we cannot reply to your electronic mail messages unless
you have an account on
.BR mwcbbs .
To request an account on
.BR mwcbbs ,
download the file
.B howto.start
from directory
.B /usr/spool/uucppublic/mwcnews
on
.BR mwcbbs ,
and follow its directions.

.ds TL Introduction
.ds TI "RELEASE NOTES"
.NH "Introduction"
.PP
Congratulations on your purchase of \*(CO release 4.2.14!
\*(CO gives your 80386- or 80486-based system a fully multi-tasking,
multi-user operating system \(em at a fraction of the cost of other systems.
We think you will appreciate the fact that \*(CO is powerful
yet inexpensive, efficient, and easy to install.
.PP
This booklety shows you how to install \*(CO on your system.
It also includes information you should find helpful in using \*(CO.
This includes information on how to contact Mark Williams Technical
Support, and how to access the Mark Williams Bulletin Board.
.I
Read these notes carefully before you attempt to install or update
\*(CO on your computer.
.R
.SH "Frequently Asked Questions"
.PP
Before we begin, please note the following:
.IP \fB1.\fR 0.3i
If you need to telephone Mark Williams Technical Support,
dial 1-708-291-6700.
Please do not telephone on the Mark Williams sales number.
.IP \fB2.\fR
If you are updating your \*(CO system, you will
.I not
have received a card with a serial number on it.
Updating your system does not require that you enter your system's
serial number, so this will not be a problem.
.SH "How to Use This Booklet"
.PP
This booklet consists of the following sections:
.IP \fB1.\fR 0.3i
The introduction \(em that is, the section you are reading right now.
.IP \fB2.\fR
List of hardware.
This section lists hardware that we know works with \*(CO, and
equipment that we know does \fInot\fR work with \*(CO.
Check your equipment against this list
.I before
you begin installation.
.IP \fB3.\fR
Installation guide.
This section walks you through the process of installing \*(CO
on your computer.
\fIThis section is for users who do not yet have \*(CO
on their computers.\fR
In the off chance that something goes wrong during installation,
this section also describes problems that have occurred to some
users, and how to work around them.
.IP \fB4.\fR
Update guide.
This section is for users who already have \*(CO,
and are upgrading to \*(CO release 4.2.14.
.IP \fB5.\fR
Third-party software.
This section details software available for \*(CO,
including those available from Mark Williams Company and
from third-party vendors.
This chapter also describes how to get free \*(CO software from the
Internet and from the Mark Williams bulletin board.
.IP \fB6.\fR
Running third-party software.
This gives directions on to make any necessary minor configuration changes
so you can install and run the most popular third-party packages.
.\".IP \fB7.\fR
.\"Bulletin board and user groups.
.\"This section describes how to dial into the Mark Williams Bulletin Board.
.\"This BBS gives you access to public-domain software that has been
.\"ported to \*(CO.
.\"It gives new versions of device drivers,
.\"technical-support bulletins, product announcements, and bug fixes.
.\"You can also exchange mail with the Mark Williams technical support staff
.\"and other \*(CO users.
.\".IP
.\"This section also introduces \*(CO user groups.
.\"This section describes \*(CO user groups throughout the world,
.\"and how you can contact them.
.\"It also describes how you can form a \*(CO user group and register it
.\"with Mark Williams Company.
.IP \fB7.\fR
Notes and errata.
This section describes helpful hints
that were discovered after the manual went to press.
This section also lists bugs that have been found in this version of \*(CO,
but have not yet been fixed.
Please note that as soon as a bug is fixed, you can download the corrected
version of the program in question from the Mark Williams BBS.
.PP
Read these notes through before you do anything else.
Then check your hardware against the machines listed in the following section.
If you do not find a discrepancy between your machine and what is given in
this section, then continue on to the installation or upgrade section,
and load \*(CO onto your system.
.SH "Contacting Mark Williams Technical Support"
.PP
Mark Williams Company
has a team of technical support specialists who are skilled at helping you
solve the problems you encounter with \*(CO.
.PP
The technical support staff try to respond promptly to
all inquiries, whether by telephone, FAX, e-mail, or ordinary mail.
Sometimes, however,
we receive e-mail from a customer only to find that our reply message
is undeliverable.
Therefore, if you send us e-mail,
please also include a FAX number or telephone number, or mailing address.
This will help ensure that we can contact you with our reply;
after all, if we can't reach you, we can't help you solve your problem.
.PP
To get the most out of
your discussion with Technical Support, please follow these guidelines:
.IP \fB1.\fR 0.3i
Have your \*(CO serial number at hand.
.IP \fB2.\fR
Know the hardware configuration you are using.
This includes make and model for your motherboard, BIOS, hard drive,
and any add-in cards.
.IP \fB3.\fR
Have an exact description of the problem.
If you are getting an error message or \*(QLpanic\*(QR message,
write down \fIexactly\fR what appears on the screen.
If a certain file, such as a C program or \fBnroff\fR document,
causes a problem, try to whittle the file down to the smallest size that
duplicates the problem, then mail the file on a floppy disk to Mark Williams
Company.
.IP \fB4.\fR
If you are having problems with \*(UU, please log in as
.B root
(the super-user) and enter the command
.BR uulog .
If you continue to have problems, have available (and if possible, FAX
to us) the contents of the following files:
.BR /etc/ttys ,
.BR /usr/lib/uucp/sys ,
.BR /usr/lib/uucp/port ,
and
.BR /usr/lib/uucp/dial .
Also, execute the following command to log file permissions on
key \*(UN files:
.DM
	ls -lR /dev/com* /usr/lib/uucp /usr/spool/uucp >/tmp/MWC.info
.DE
Fax a hardcopy of file
.B /tmp/MWC.info
or copy the file onto a floppy
and mail it to the Mark Williams Company Technical Support department.
.IP \fB6.\fR
If possible, call us when you are at your computer, with the
computer turned on, so we can ``walk you through''
any diagnostic or repair measures needed.
.IP \fB7.\fR
For information on how to contact Mark Williams Company,
see the copyright page of this booklet.

.II "bc^tutorial"
.ds TL "bc Desk Calculator"
.NH "bc Desk Calculator Language" 1
.PP
This tutorial introduces
.BR bc ,
the calculator language for \*(OS.
If you have not used
.B bc
before, this tutorial will introduce you to its
features and functions.
If you are familiar with
.BR bc ,
you can use it as a reference.
.PP
\fBbc\fR is a language that can calculate
to high precision.
It automatically adjusts
the number of digits in a number to represent it correctly.
It is like having a powerful calculator at your fingertips.
.Sh "Entry and Exit"
.PP
The \fBbc\fR calculator for \*(OS is easy to use.
Whenever you wish to invoke
.B bc ,
all you do is type its name (\fBbc\fR), followed by
a stroke of the carriage return key.
When you are finished using the calculator and wish to exit,
just type the word \*(Qlquit\*(Qr or
.if \nX=0 \fB<ctrl-D>\fR.
.if \nX=1 \fB<ctrl-Z>\fR.
.B bc
exits and returns control to \*(OS.
.Sh "Example of Simple Use"
.PP
\fBbc\fR performs calculations on formulas that you type into it.
The formulas are laid out as you would naturally write them.
For example, to invoke \fBbc\fR, have it add 
2+2, and then exit, type:
.DM
	bc
	2 + 2
.DE
.B bc
replies:
.DM
	4
.DE
Then, leave \fBbc\fR by typing:
.DM
	quit
.DE
.B bc
is an arbitrary precision calculator:
the number of digits carried by \fBbc\fR depends upon 
the requirements of the calculation,
and is automatically expanded by \fBbc\fR.
Thus, \fBbc\fR will never overflow.
The number of digits it carries is 
limited only by the amount of available computer memory.
For example, invoke
.B bc
and then try this calculation:
.DM
	2^500
.DE
The circumflex \*(Ql^\*(Qr character signifies a superscript; thus,
we are asking \fBbc\fR to raise 2 to the 500th power.
After a moment, \fBbc\fR will reply:
.DM
	327339060789614187001318969682759915221664\e
	204604306478948329136809613379640467455488\e
	327009232590415715088668412756007100921725\e
	6545885393053328527589376
.DE
.II "bc^exponentiation operator"
You have probably already noticed one nice thing about this calculator:
you don't have to include a print statement as part of your command, because
.B bc
automatically prints the results onto your terminal screen.
When \fBbc\fR sees any expression, like \*(QL2+2\*(QR or \*(QL37\-7\*(QR,
it prints the result.
.PP
.B bc
provides the
common arithmetic operators
for add, subtract, multiply, and divide, as
illustrated by the following commands:
.DM
	7 + 5
	7 - 5
	7 * 5
	7 / 5
.DE
.PP
\fBbc\fR also provides the
remainder operator
\*(Ql\fB%\fR\*(Qr.
To get a sense of how it works, type:
.DM
	7 % 5
	5 % 7
.DE
Here, \fBbc\fR prints the \fIremainder\fR of the first number
divided by the second; in the case of the first example,
\fBbc\fR prints 2, and in the second prints 5.
As you saw above, \fBbc\fR also includes
the exponentiation operator \*(Ql\fB^\fR\*(Qr.
.PP
With \fBbc\fR, you can also enter numbers with fractional parts.
Type the following to illustrate:
.DM
	9.999 * 9.999
.DE
\fBbc\fR replies:
.DM
	99.980
.DE
You can save temporary calculations or repeated constants in
\fIvariables\fR.
The following example shows you first how to define variables,
and second how to use them:
.DM
	a = 1.1
	b = 2.2
	a
	b
	a * b
.DE
Variable names can be longer than one letter.
.PP
The basic calculations in the above examples show only part of what
.B bc
can do.
The following section describes simple statements \(em the assignment of
variables and abbreviations \(em that allow you to perform
complex calculations easily.
.SH "Simple Statements"
.PP
Although you can use \fBbc\fR as a simple calculator
for manipulating numbers, you 
can take advantage of its greater power by using \fIvariables\fR.
Variables, as noted above, store parts of calculations or constants that 
you will use repeatedly in calculations.
Variable names are simply \*(QLwords\*(QR that you make up.
Here are some examples of possible variable names:
.DM
	a
	b
	totaltaxesdue
	ratio
.DE
To use variables, simply give them a value, use
them in a calculation in place of a number, or print them out.
.PP
To see how a variable can save you repetitive typing, and protect
you from possible errors, invoke \fBbc\fR and type the following:
.DM
	x = 9.999
	x
	x * x
	x = x * x
	x
.DE
The following gives the example with \fBbc\fR's replies \fIin italics\^\fR:
.DM
	x = 9.999
	x
	\fI9.999\fP
	x * x
	\fI99.980\fP
	x = x * x
	x
	\fI99.980\fP
.DE
.II bc^assignment
.B bc
did not reply to the
assignment statements \fBx=9.999\fR and \fBx=x*x\fR.
However, it did print the value of \fBx\fR when requested,
and the results of arithmetic using \fBx\fR.
.PP
Calculations executed with hand-held calculators,
with programming languages like C, or with \fBbc\fR
often use the following formula:
.DM
	x = x + 1
.DE
To decrease the likelihood of error,
\fBbc\fR offers you a shorthand expression for this common phrase:
.DM
	x += 1
.DE
What it means is, \*(QLadd one to \fBx\fR\*(QR.
Type the following example into \fBbc\fR to see how this expression works:
.DM
	x = 1
	x * x
	x += 1
	x * x
	x += 1
.DE
Likewise, \fBbc\fR provides an abbreviation for:
.DM
	x = x - 2
.DE
The form should now be familiar:
.DM
	x \(mi= 2
.DE
The number to the right of the \fB-=\fR or \fB+=\fR operator can be replaced
with a variable or even another calculation.
When you type:
.DM
	i = 4
	x = 48
	x \(mi= i
	x
.DE
\fBbc\fR replies:
.DM
	44
.DE
Alternatively, if you type:
.DM
	i = 4
	x = 48
	x \(mi= i * i
	x
.DE
then \fBbc\fR replies:
.DM
	32
.DE
Similar abbreviations are provided for multiplication,
division, remainder, and exponentiation.
Here is a summary of this class of operation.
.DS
.ta 0.5i 1.5i
	\fIa \fB+=\fR 2	Replace \fIa\fR with a plus 2
	\fIb \fB+= \fIa\fR	Replace \fIb\fR with \fIb\fR plus \fIa\fR
	\fIb \fB\(mi=\fR \fIa\fR	Replace \fIb\fR with \fIb\fR minus \fIa\fR
	\fIc \fB*= \fIb\fR	Replace \fIc\fR with \fIc\fR multiplied by \fIb\fR
	\fIc \fB/= \fIa\fR	Replace \fIc\fR with \fIc\fR divided by \fIa\fR
	\fIc \fB%= \fIb\fR	Replace \fIc\fR with remainder of \fIc\fR divided by \fIb\fR
	\fId \fB^= \fI3\fR	Replace \fId\fR with \fId\fR raised to the third power
.DE
.B bc
also has an operator that increases a variable by one:
\*(Ql\fB++\fR\*(Qr.
When you type:
.DM
	a = 1
	++a
.DE
then \fBbc\fR replies:
.DM
	2
.DE
To use this operator in an expression, combine it
with a variable anywhere that a variable would normally be used.
For example, entering
.DM
	b = 1
	a = 3
	b = ++a
	a
	b
.DE
yields:
.DM
	4
	4
.DE
The \*(Ql\fB++\fR\*(Qr operator can also be put after a name.
The resulting value in the expression is the value of the
name \fIbefore\fR it is incremented.
However, after the expression is evaluated,
the name will have an incremented value.
The following example shows the use of \*(Ql\fB++\fR\*(Qr
both before and after a name:
.DM
	a = 1
	b = 1
	a++
	++b
	a
	b
.DE
\fBbc\fR replies:
.DM
	1
	2
	2
	2
.DE
Operators are used in this manner:
.DM
	a = 1
	b = 2
	c = a++ + ++b
.DE
Similar to \*(Ql\fB++\fR\*(Qr is \*(Ql\fB\(mi\(mi\fR\*(Qr.
It behaves the same way, except that rather than adding one,
it subtracts one.
.SH "Numbers with Fractions"
.PP
Most of the examples presented earlier use whole numbers (integers).
However, \fBbc\fR can use numbers with fractional parts.
This section discusses the use of fractional numbers in \fBbc\fR and their
precision
under different operations.
.Sh "The Scale of Numbers"
.PP
The number of digits to the left of the decimal point carried by
.B bc
depends upon the requirements of the calculation.
If you calculate a large number, as in:
.DM
	2^500
.DE
the result will contain as many digits as needed to express the product.
.PP
The number of digits to the right of a decimal point is
called the
.I scale
of the number.
Scale depends upon the operation that produces the
number of digits, and a variable called
.B scale
that will be described shortly.
.PP
To illustrate simple uses of numbers with fractions, invoke
.B bc
and then type:
.DM
	a = .01
	b = 0.99
	a + b
.DE
\fBbc\fR replies:
.DM
	1.00
.DE
.Sh "Addition and Subtraction"
.PP
\fBbc\fR will dynamically adjust the number of digits in the calculation.
It deals similarly with fractional numbers.
To the following example
.DM
	a = 0.01
	b = 0.001
	a + b
.DE
\fBbc\fR reply:
.DM
	.011
.DE
In addition and subtraction, the scale of the result
is the \fIlarger\fR of the scales of the two numbers involved.
Results are not truncated in addition or subtraction operations.
.Sh "Scale During Multiplication"
.PP
Other arithmetic operations act differently with numbers 
that contain fractions.
In the multiplication of two numbers, the scale of 
the product will at least equal the larger of the scales of the two numbers.
For example, the input:
.DM
	1.1 * 1.11
.DE
results in:
.DM
	1.22
.DE
.Sh "Setting the Scale of Results"
.PP
To increase the number of fractional digits for higher accuracy,
.B bc
provides the built-in variable \fBscale\fR.
The following example illustrates the \fBscale\fR variable:
.DM
	scale = 3
	1.1 * 1.11
.DE
The result from this example is:
.DM
	1.221
.DE
Note, however, the scale of the product of a multiplication procedure
never exceeds the sum of the scales of the two numbers being multiplied.
For example,
.DM
	scale = 10
	1.1 * 1.11
.DE
yields the result:
.DM
	1.221
.DE
If the variable \fBscale\fR is less than the 
sum of the scales of the numbers being multiplied, then the product
will have a scale equal to that of the variable \fBscale\fR.
For example,
.DM
	scale = 4
	1.11 * 2.222
.DE
yields:
.DM
	2.4664
.DE
The scales of the operands are 2 and 3.
The larger scale is 3, so the result of a multiplication 
will have a scale of at least 3, no matter what \fBscale\fR is set to.
Also, the sum of the scales is 5, so the result will never
have more than 5 digits to the right of the decimal point.
In this example, \fBscale\fR has been set to a scale of 4.
Therefore, the result has four digits to the right of the decimal point.
.Sh "Scale for Divisions"
.PP
For division and remainder, the scale of the result is determined 
only by the value of the variable \fBscale\fR.
For example,
.DM
	scale = 13
	14 / 13
	14 % 13
.DE
yields:
.DM
	1.0769230769230
	.0000000000010
.DE
For non-whole numbers, as well as for integers,
the definition of remainder is chosen so that the relationship
.DM
	dividend = (divisor * quotient) + remainder
.DE
is true.
.Sh "Scale From Exponentiation"
.PP
.B bc
sets the \fBscale\fR of a result of exponentiation as
if repeated multiplications had been performed.
Thus, for
.DM
	5.992 ^ 5
.DE
the scale is chosen as if you typed:
.DM
	n = 5.992
	n * n * n * n * n
.DE
That is, the default is the scale of the largest (or, in this case,
the only) number being multiplied; and scale cannot exceed the
sum of the scales of the numbers being multiplied.
Thus, the scale of the product in this example
has a default setting of 3, and can be reset up to 15.
.Sh "What Is the Current Scale?"
.PP
The variable \fBscale\fR is just like other variables:
you can assign values to it, as above.
Because it is like regular variables, you can also use it
in operations, as in this example:
.DM
	scale += 1
.DE
You can also print its value:
.DM
	scale
.DE
The value of the \fBscale\fR variable is zero until you explicitly change it.
.SH "The if Statement"
.PP
The statements shown so far have been either assignment statements, 
giving a new value to a variable; or an expression, which prints 
the resulting value.
Several other kinds of statements are available.
These give you power to write programs that make
decisions and perform iterative computations.
.Sh "Using the if Statement"
.PP
To see the
.B if
statement in action, type the following example into \fBbc\fR:

.DM
	x = 3
	if (x < 5) x
	if (x > 5) -x
.DE
.B bc
replies:
.DM
	3
.DE
If the input is:
.DM
	x = 6
	if (x < 5) x
	if (x > 5) -x
	<return>
.DE
\fBbc\fR replies:
.DM
	-6
.DE
The part of the
.B if
statement in parentheses, such as \fB(x > 5)\fR, determines whether
.B bc
executes the statement that follows it, such as
.BR -x .
If the expression is false, the following statement is not executed.
If the expression is true, the following statement is executed.
.Sh "Comparisons"
.PP
The decision expression in an \fBif\fR statement is enclosed in parentheses.
The decision can be based upon a comparison of two operands, or numbers.
The kinds of comparisons that can be done are:
.DS
	\fB==\fR	First operand equal to second
	\fB!=\fR	First operand not equal to second
	\fB<=\fR	First operand less than or equal to second
	\fB<\fR	First operand less than second
	\fB>=\fR	First operand greater than or equal to second
	\fB>\fR	First operand greater than second
.DE
The \fBif\fR statement can include the sorts of
the simple statements already shown.
You can also include an \fBif\fR statement, as well as the \fBwhile\fR,
\fBdo\fR, and \fBfor\fR statements, 
which will be discussed below.
The following example illustrates the use of an \fBif\fR
statement within an \fBif\fR statement:
.DM
	a = 2
	b = 6
	if (a >= 2) if (b > a) a + b
	<return>
.DE
\fBbc\fR replies, simply:
.DM
	8
.DE
Because both of the \fBif\fR conditions were true,
\fBbc\fR proceeded to add \fBa\fR and \fBb\fR.
Note that nested
.B if
statements must appear on the same line.
Therefore, 
.DM
	if (a == 3) if (b > a) a + b
.DE
does not print the result of
.B "a + b"
because not both conditions were true.
However
.DM
	if (a == 3)
	if (b > a) a + b
.DE
prints the result of
.B "a + b"
because
.B bc
treats
.B if
statements one by one, and the second
.B if
statement's condition is true.
.Sh "Grouped Statements"
.PP
You can place more than one statement after the expression part of the 
\fBif\fR statement by using grouping braces \*(Ql\fB{\fR\*(Qr
and \*(Ql\fB}\fR\*(Qr.
This can be useful if you want to perform several calculations 
based on the result of an \fBif\fR statement comparison.
The following example prints the value of \fBa\fR and 
\fBb\fR if the value of \fBb\fR is less than the value of \fBa\fR:
.DM
	a = 1
	b = .99
	if (a > b) {
	    a
	    b
	}
.DE
\fBbc\fR replies:
.DM
	1
	.99
.DE
Any statement may be enclosed within the group braces, as
the following example shows:
.DM
	a = 1
	b = .99
	if (a > b) {
	    a
	    b
	    if ((a + b) >= 2) a + b
	}
.DE
.Sh "Many Statements Per Line"
.PP
To this point, all of our examples typed each statement on its own line.
This includes the group braces \*(Ql\fB{\fR\*(Qr and \*(Ql\fB}\fR\*(Qr,
the latter of which must appear on a line by itself.
You can, however, place several statements on one line if you separate them
with semicolons.
If you do this, remember that the semicolon rather than the
carriage return separates the statements.
For example, if you type:
.DM
	a = 1;b = 2;c = 3
	a;b;c
.DE
\fBbc\fR replies:
.DM
	1
	2
	3
.DE
You can use this in combination with the group braces:
.DM
	a = 1;b = 2;c = 3
	if ((a + b) >= c) {
	    a; b; c; a + b; }
.DE
The reply from \fBbc\fR is:
.DM
	1
	2
	3
	3
.DE
This example can be compressed even further by putting all of the \fBif\fR
statement on one line:
.DM
	a = 1;b = 2;c = 3
	if ((a + b) >= c) { a; b; c; a + b; }
.DE
You do not need to follow the \*(Ql\fB}\fR\*(Qr with a semicolon.
.SH "The while Statement"
.PP
The \fBwhile\fR statement repeats calculations.
This is useful in successive approximation calculations.
The following example of the \fBwhile\fR loop 
prints the numbers one through ten:
.DM
.ta 1.0i 1.5i
	i = 1
	while (i <= 10) {
		i
		i = i + 1
	}
.DE
.B bc
replies:
.DM
	1
	2
	3
	4
	5
	6
	7
	8
	9
	10
.DE
The statement
.DM
	i = i + 1
.DE
adds 1 to the variable \fBi\fR.
The expression
.DM
	(i <= 10)
.DE
compares \fBi\fR with ten.
While \fBi\fR is less than or equal to ten, the \fBwhile\fR 
loop executes.
When \fBi\fR is increased to greater than ten, the loop stops executing.
.PP
.B bc
checks the comparison expression for the \fBwhile\fR loop
before the loop is entered for the first time.
If the comparison fails, the loop is not executed at all;
otherwise the processing repeats as long as the comparison is true.
For example, the following statements do not print anything:
.DM
	i = 0
	while (i > 1) i
	quit
.DE
.Sh "Abbreviations in the while Statement"
.PP
If we recall the assignment statements from the previous section,
we can shorten
the \fBwhile\fR counting-to-ten example to:
.DM
	i = 1
	while (i <= 10) {
		i
		i += 1
	}
.DE
The result remains the same \(em a list of numbers from one to ten.
.PP
Another abbreviation of the example uses the \*(Ql\fB++\fR\*(Qr operator.
The variable \fBi\fR is incremented, then tested in the \fBwhile\fR
expression, which simplifies the entire example to:
.DM
	i = 0
	while (++i <= 10) i
.DE
Before the \fBwhile\fR is executed, \fBi\fR is set to zero.
Then, the \fBwhile\fR expression increments the
value of \fBi\fR before it is used or compared,
Thus, the first value compared, then printed, is one.
.PP
Finally, the example calculation can be shortened to one line.
If a variable in \fBbc\fR is used before it is initialized, it will
have the value of zero.
For example:
.DM
	zip
.DE
prints:
.DM
	0
.DE
Using this in our counting-to-ten example yields:
.DM
	while (++n <= 10) n
.DE
.SH "The for Statement"
.PP
.B for
is a statement that controls the execution of other
.B bc
statements.
You should use
\fBfor\fR to write a formula 
to control the number of times a value is computed.
.PP
The previous section demonstrated how to print the numbers one to 
ten using a \fBwhile\fR statement.
The following does the same task with a \fBfor\fR statement:
.DM
	for (i=1; i <= 10; ++i) i
.DE
.Sh "Three Parts of the for Statement"
.PP
The \fBfor\fR statement is more complex than the \fBwhile\fR statement;
its controlling expressions have three parts.
.PP
The first part, shown here in italics
.DM
	for (\fIi=1\^\fP; i <= 10; ++i) i
.DE
sets up the initial condition.
The second part
.DM
	for (i=1; \fIi <= 10\^\fP; ++i) i
.DE
tests whether more iterations should be performed.
.B bc
performs this test
.I before
it executes the statements that are subordinate to the
.B for
statement.
If the test fails, no more iterations are performed.
.PP
The third part
.DM
	for (i=1; i <= 10; \fI++i\^\fP) i
.DE
is performed at the end of each iteration.
In practically every instance, this part of the
.B for
statement modifies the value of the variable that the second part tests.
.PP
Taken together, these statements (1) set \fBi\fR to zero; (2) check whether
\fBi\fR is less than or equal to ten; (3) if \fBi\fR proves to be so,
prints \fBi\fR, and then increases it by one.
.PP
The following example of the \fBfor\fR statement adds
the squares of the numbers one through ten, prints each square,
and then prints the sum of the squares at the end.
.DM
	sum = 0
	for (n=1; n <= 10; ++n) {
	    sq = n * n
	    sq
	    sum += sq
	}
	sum
.DE
The result is:
.DM
	1
	4
	9
	16
	25
	36
	49
	64
	81
	100
	385
.DE
.Sh "Similarities Between the for and while Statements"
.PP
To illustrate the similarity between the \fBfor\fR statement and
the simpler \fBwhile\fR statement, the following rewrites the
above example, substituting the \fBwhile\fR for the \fBfor\fR:
.DM
	sum = 0
	n = 0
	while (++n <= 10) {
		sq = n * n
		sq
		sum += sq
	}
	sum
.DE
.SH "Functions in bc"
.PP
.B bc
allows you to name routines that you use repeatedly.
You can then call them by name without having to retype them;
obviously, this can be a great time-saver.
These named routines are called
.IR functions .
This section shows you how to define and use functions
for your \fBbc\fR calculations.
.Sh "Example of Function Use"
.PP
The following example defines a function that calculates the area of
a circle from its radius.
.DM
	scale = 5
	pi = 3.14159
	define area (radius) {
		r2 = radius * radius
		return (pi * r2);
	}
	area (1.00)
	area (2.00)
	area (56)
.DE
The results will be:
.DM
	3.14159
	12.56636
	9852.02624
.DE
The \fBdefine\fR keyword tells \fBbc\fR that you are defining a function.
The name of the function follows.
Then, in parentheses, come the \fIparameters\fR of the function.
In this example, the only parameter, or \fIargument\fR,
of the function is \fBradius\fR.
Most functions have arguments, but they are not mandatory.
.PP
The \fBreturn\fR statement defines the value of the function.
In the
.B area
example, the expression
.DM
	area (1.00)
.DE
references the function \fBarea\fR.
\fBbc\fR then performs the calculation described by your definition
of the function
.BR area .
The number
.DM
	1.00
.DE
is substituted wherever the parameter \fBradius\fR is shown.
.PP
The statement
.DM
	r2 = radius * radius
.DE
is then executed, yielding this result:
.DM
	1.00
.DE
Then, the statement
.DM
	return (pi * r2)
.DE
calculates the area and returns its value.
The statement
.DM
	area (1.00)
.DE
then has the value calculated in the return statement.
.Sh "Functions Using Other Functions"
.PP
Functions in \fBbc\fR perform calculations using the
same expressions as the rest of the \fBbc\fR program.
This includes the use of functions.
The \fBarea\fR program can be written using another function,
\fBsq\fR, to calculate the square of a number:
.DM
	scale = 5
	pi = 3.14159
	define sq (number) {
		return (number * number)
		}
	define area (radius) {
		return (sq (radius) * pi)
		}
	area (1.00)
	area (2.00)
	area (56)
.DE
Again, the results will be identical:
.DM
	3.14159
	12.56636
	9852.02624
.DE
.Sh "Functions That Call Themselves"
.PP
Not only can functions call other functions and perform
regular calculations; a function can use itself in calculations.
An example of this is the Fibonacci calculation:
.DM
	define fib (f) {
		if (f == 0) return (0)
		if (f == 1) return (1)
		if (f > 1) return (fib (f - 1) + fib (f - 2))
	}
	fib (5)
	fib (20)
.DE
Fibonacci numbers are defined in the following way:
Fibonacci number zero is zero; similarly, Fibonacci number one is one.
Any other Fibonacci number is defined as the sum of the two previous
Fibonacci numbers.
Fibonacci numbers are defined only for non-negative integers.
.PP
The defined function \fBfib\fR follows this definition by 
returning zero if the number requested is zero and one if the argument is one.
If the number is neither of these, then the function calls itself to
calculate the previous two numbers of the series and adds them together.
.Sh "The auto Statement"
.PP
Many functions that call other functions, including themselves, may require
variables that are not changeable by the rest of the program.
This is signalled to \fBbc\fR by the \fBauto\fR statement:
.DM
	auto var1, var2
.DE
This declares \fBvar1\fR and \fBvar2\fR as local to
the function that contains them.
.PP
To illustrate the use of \fBauto\fR, the following \fBbc\fR
program calculates the factorial of a number:
.DM
	define factorial (number) {
		auto value, i
		value = 1
		for (i = 1; i <= number; ++i) value *= i
		return (value)
	}
	value = 3
	factorial (value)
	i = 99
	factorial (20)
	value
	i
.DE
The result is:
.DM
	6
	2432902008176640000
	3
	99
.DE
The first number, 6, results from:
.DM
	factorial (value)
.DE
The second number is from:
.DM
	factorial (20)
.DE
The last two numbers are from \fBvalue\fR and \fBi\fR,
and are included to demonstrate that the variables in the function
\fBfactorial\fR appearing in this statement:
.DM
	 auto value, i
.DE
are separate from the variables of the same name in the rest of the program.
.PP
If the function calls itself, as the \fBfib\fR example does
above, any variable names noted in the \fBauto\fR statement are
handled separately for each call of the function.
.SH "Programs in a File"
.PP
Because its programs can be quite complex, 
\fBbc\fR lets you keep them in files.
This lets you build a library of \fBbc\fR programs and 
functions that can be called up easily.
.Sh "Using a Program From a File"
.PP
To illustrate the use of programs stored in a file,
type the following example into file \fBfib.bc\fR using the
editor of your choice.
The program defines the function \fBfib\fR:
.DM
	define fib (f) {
		if (f == 0) return (0)
		if (f == 1) return (1)
		if (f > 1) return (fib (f - 1) + fib (f - 2))
	}
.DE
To use a \fBbc\fR program that has been stored in a file, enter
the file name on the \fBbc\fR command line, like this:
.DM
	bc fib.bc
.DE
The function definition will be read in by \fBbc\fR and ready for your use.
To use the function, simply type the function name with parameters.
.PP
So, if you type:
.DM
	bc fib.bc
	fib (6)
.DE
\fBbc\fR will reply:
.DM
	8
.DE
.Sh "Using Libraries"
.PP
You can enter several useful programs in their own files and call them
into \fBbc\fR at the same time.
The following example creates another function
that calculates the sum of the squares of integers up to a given number.
Use an editor to type the following into a file named \fBsumsq.bc\fR:
.DM
	define sumsq (number) {
		auto i, sum
		sum = 0
		for (i = number; i > 0; --i) sum += i ^ 2
		return (sum)
	}
.DE
Now, you can use the \fBsumsq\fR function to print the sum of
the squares for each number from one to ten:
.DM
	bc sumsq.bc
	for (i = 1; i <= 10; ++i) sumsq (i)
.DE
The result is:
.DM
	1
	5
	14
	30
	55
	91
	140
	204
	285
	385
	quit
.DE
You can use the two functions stored in a file to print the difference
between the sum of the squares of numbers, and the
Fibonacci number:
.DM
	bc fib.bc sumsq.bc
	for (i = 1; i <= 10; ++i) sumsq (i) - fib (i)
	quit
.DE
The result of this questionable computation is:
.DM
	0
	4
	12
	27
	50
	83
	127
	183
	251
	330
.DE
.Sh "The bc Library"
.II bc^library
.PP
\*(OS provides
an extended library to go with \fBbc\fR.
It includes the following functions:
.DS
	\fBatan\fP(\fIz\fP)	arctangent of \fIz\fP
	\fBcos\fP(\fIz\fP)	cosine of \fIz\fP
	\fBexp\fP(\fIz\fP)	exponential function of \fIz\fP
	\fBj\fP(\fIn,z\fP)	\fIn\fPth order Bessel function of \fIz\fP
	\fBln\fP(\fIz\fP)	natural logarithm of \fIz\fP
	\fBpi\fP	the value of pi to 100 digits
	\fBsin\fP(\fIz\fP)	sine of \fIz\fP
.DE
The library is stored in file
.if \nX=0 \fB/usr/lib/lib.b\fR.
.if \nX=1 \fB\eBIN\eLIB.B\fR.
To use the library, invoke the \fBbc\fR
command with the \fB-l\fR option.
.PP
To show how the library can be used in your work
the following example computes the sine of an angle of
one-third radian with scale set to 20:
.DM
	bc -l
	scale = 20
	sin (1/3)
	quit
.DE
The result is:
.DM
	.32719469679615224418
.DE
.SH Summary
.PP
The Lexicon entry for
.B bc
summarizes its commands, features, and libraries.
It will also refer you to related commands and functions.

.NH "Preface"
.sp
\*(CO is the work of a large number of exceptionally talented people.
The development of a multi-user, multi-tasking operating system is a
daunting task.
Creating \*(CO took an enormous effort by all involved.
The system and manual are dedicated to those who dedicated themselves to
\*(CO.
.sp
These people include the following:
.sp
.tc
.nf
.ta 2.25i 4.5i
.so \*(DI/text/names.r
.fi
.sp 2
The ``port'' of the \*(CO kernel to the 80386 was implemented using
software provided by Ciaran O'Donnell, Bievres, France.

.ds TI "RELEASE NOTES"
.ds TL "Additional Software"
.NH "Software for X Windows"
.PP
Once you have the X Window System up and running on your computer,
you are going to want to explore the wealth of software that is available.
Many of the most popular and useful X programs can be purchased from Mark
Williams Company and from other suppliers.
You can also download these packages for free from the Mark Williams
Bulletin Board, and from other sources on the Internet.
.PP
The following some of the software you can obtain for your \*(CO system.
.SH "The COHERENT Club"
.PP
The \*(CO Club offers great savings on third-party software.
For a one-time payment of $49.95,
you can get significant discounts from Mark Williams Company
on such third-party software products as WordPerfect,
other \*(CO products sold by Mark Williams, and discounts on future
enhancements and updates to \*(CO.
The order form at the back of this booklet shows some of the discounts
you can receive
.PP
To join, fill out the form at the end of these notes, or call Mark Williams
Company at 1-800-636-6700 or 1-708-291-6700.
.SH Xware
.PP
The X Window System has a wealth of software available for it.
To help make this software available to you under \*(CO,
Mark Williams Company offers
.BR Xware !
.PP
Each Xware package is a collection of carefully selected X programs.
Almost every program comes with both an executable binary and source
code, plus rewritten and formatted manual pages that you can read with
the \*(CO
.B man
command.
.PP
Six Xware packages are available to you:
.IP "\fBXware 1\fR: Window Managers"
This package offers the window managers \*(OL, from Sun Microsystems; and
.BR fvwm ,
a small, efficient window manager that looks like Motif.
Also included are several hundred fonts, to further improve the appearance
of your X environment.
.IP "\fBXware 2\fR: Games\fR"
This package is just for fun.
Battle deadly tanks, struggle with your computer for control of the world,
play Mah-Jongg and solitaire \(em all in the X Windows graphical
environment.
.IP "\fBXware 3\fR: Graphics\fR"
This package offers a wealth of graphics programs for X.
View GIF files, display animations, model and display the evolution of
an imaginary planet, plug entertaining screen-savers into your system \(em
and much more.
Also included are a generous selection of GIF images from Project Apollo
and from the newly repaired Hubble Space Telescope.
.IP "\fBXware 4\fR: Tools and Utilities\fR"
This package assembles a number of helpful utilities.
Included are a powerful spreadsheet, including matrix algebra functions
and graphing; an interactive file manager;
utilities for attaching notes to your screen; tools for displaying system
load, and for viewing manual pages interactively; and more.
.IP "\fBXware 5\fR: Development Tools\fR"
This package offers Tcl, the hot new development language; and Tk,
a large collection of widgets and function that you can use interactively.
Also included are
.BR wish ,
the interactive shell built from Tcl and Tk; and
.BR xf ,
an interactive tool with which you can easily build X front ends for your
programs.
You can also use Tcl with your non-X programs.
.IP "\fBXware 6\fR: Ghostscript\fR"
With this package, you can display your PostScript files and clip art
directly within an X window, without having to print them.
Also included are drivers for a variety of output devices, including
a number of printers.
.PP
To order an Xware package, use the order form at the back of this booklet,
or call Mark Williams Company.
.PP
.SH "Freeware and Shareware"
.PP
The University of Alaska's Internet site
.B raven
maintains an archive of public-domain and shareware software
for X that has been ported to \*(CO.
You can access this site via the Internet and download
software for the price of the connection.
.PP
To access
.BR raven ,
you must have access to a system that
connects to the Internet via TCP/IP.
When you log into this system, type:
.DM
	ftp raven.alaska.edu
.DE
.PP
All files are under the directory
.BR /pub/coherent .
.PP
You can also download X software for free from the Mark Williams Bulletin
Board, or from other bulletin boards maintained around the world by
\*(CO users.
For details on how to contact these boards, see the release notes that
came with your copy of \*(CO.

.NH "Xware 1:  Window Managers"
.PP
Congratulations on purchasing Xware 1 Window managers package for \*(CO.
This package contains the X window managers
.BR olwm ,
which uses the \*(OL interface to X;
.BR olvwm ,
which is \*(OL plus a virtual desktop;
.BR fwm ,
a window manager whose appearance resembles that of Motif,
and that is derived from
.BR twm ;
and
.BR fvwm ,
which is
.B fwm
plus a virtual desktop.
.PP
Also included in this package are more than 150 X fonts that can be used
by these window managers, as well as by
.B twm
and other X applications; tools for rebuilding these programs; resource
files; and documentation.
.SH "What Is Xware?"
The Xware is a series of packages from Mark Williams Company
that bundle some of the most popular and useful software
for the X Window System.
Each program in an Xware package comes with executable binary;
source code;
instructions and scirpt to help you recompile and install the program;
and a manual page for the program edited and formatted in the \*(CO
Lexicon format, which you can view with the \*(CO command
.BR man .
.PP
Other Xware packages are available or are being prepared.
These include packages of X games, graphics programs, tools and utilities,
and a kit for developing X applications of your own.
Xware makes it easy and convenient to enlarge your supply of X software.
.SH "Contents of This Package"
.PP
This package contains source code for the window managers, executable binary
files, ancillary and resource files, fonts, and the tools you need to recompile
them.
(The only exception is that to recompile the window managers
.B fwm
and
.BR fvwm ,
you must have the GCC C compiler installed on your system.
You can purchase
a copy of this C compiler from Mark Williams Company,
or from any of a number of public-domain sources.
It is not included with this package.)
The following describes the contents in detail:
.PP
Executable binaries:
.DS
.B
	/usr/X11/bin/fvwm
	/usr/X11/bin/fwm
	/usr/X11/bin/olvwm
	/usr/X11/bin/olwm
.DE
Archives of source code:
.DS
.B
	/usr/X11/window_manage/fvwm.gtz
	/usr/X11/window_manage/xpm.gtz
	/usr/X11/window_manage/olwm.gtz
	/usr/X11/window_manage/olvwm.gtz
.DE
Archives of fonts:
.DS
.B
	/usr/X11/lib/fonts/font.char.tar
	/usr/X11/lib/fonts/font.cour.tar
	/usr/X11/lib/fonts/font.helv.tar
	/usr/X11/lib/fonts/font.lu.tar
	/usr/X11/lib/fonts/font.lub.tar
	/usr/X11/lib/fonts/font.lut.tar
	/usr/X11/lib/fonts/font.misc.tar
	/usr/X11/lib/fonts/font.ncen.tar
	/usr/X11/lib/fonts/font.symb.tar
	/usr/X11/lib/fonts/font.tim.tar
.DE
Bit-mapped images used by
.B fwm
and
.BR fvwm :
.DS
.B
	/usr/X11/include/X11/bitmaps/fvwm.bitmap
	/usr/X11/include/X11/bitmaps/fvwm.xpm
	/usr/X11/include/X11/bitmaps/default.xbm
.DE
Manual pages:
.DS
.B
	/usr/man/Win.managers/fvwm
	/usr/man/Win.managers/fwm
	/usr/man/Win.managers/olvwm
	/usr/man/Win.managers/olvwmrc
	/usr/man/Win.managers/olwm
	/usr/man/win.man.index
.DE
Libraries, defaults files, and resource files:
.DS
.B
	/usr/X11/lib/fvwm/system.fvwmrc
	/usr/X11/lib/fvwm/mwmlike.fvwmrc
	/usr/X11/lib/openwin-menu
	/usr/X11/lib/app-defaults
	/usr/X11/lib/libXpm.a
.DE
Finally, a revised version of
.B make
to help you recompile your programs.
.SH "System Resources"
.PP
To run this package, you need the following:
.IP \fB1.\fR 0.3i
A computer system capable of running X Windows for \*(CO, and that has
X Windows for \*(CO installed on it.
.IP \fB2.\fR
Approximately five megabytes of free disk space on the device that holds
directory
.BR /usr/X11 .
To see how much space is available, type the following commands:
.DM
	cd /usr/X11
	df .
.DE
\*(CO will display the disk space available, in blocks.
Because one block is 512 bytes of storage (one-half kilobyte), you must
have at least 10,000 blocks available before you can install this package.
.PP
If you do not yet have X Windows for \*(CO installed on your system, you
must install it first before you install this package.
Likewise, if the device that holds directory
.B /usr/X11
does not have at least five megabytes of space on it, you must remove or
compress files until sufficient space is available.
.PP
With regard to the amount of RAM needed,
the window managers vary greatly.
The following table compares sizes of these window managers with that of
.BR twm ,
the window managers included with X Windows for \*(CO:
.DS
.ta 0.5i 1.5i
	\fBtwm\fR	300 kilobytes
	\fBfwm\fR	220 kilobytes
	\fBfvwm\fR	289 kilobytes
	\fBolwm\fR	297 kilobytes
	\fBolvwm\fR	401 kilobytes
.DE
.B fvwm
and
.B olvwm
also use more memory for their virtual desktops.
Note, too, that
some applications may use more memory than before,
because more bit-mapped fonts will be available for them to pull into memory.
You should take the size of each window manager into account when you select
the one to use by default.
.SH "How to Install This Package"
.PP
Installation is very simple.
Log in as the superuser
.BR root .
If your drive A is 5.25 inches, then insert the first disk
of the package into drive A and type the command:
.DM
	/etc/install Xware1 /dev/fha0 3
.DE
Note the capital letter in ``Xware''.
.PP
If, however, your drive A is 3.5 inches, then insert the first disk
of the package into drive A and type the command:
.DM
	/etc/install Xware1 /dev/fva0 3
.DE
Again, note the capital letters in ``Xware''.
.PP
That's all there is to it.
.B install
will ask you a few questions, then place all of the appropriate files
automatically.
.SH "Invoking a Window Manager"
.PP
To invoke one of your new window managers, you must edit your
.B xinitrc
file \(em either
.B $HOME/.xinitrc
or
.BR /usr/X11/lib/xinit/xinitrc ,
depending upon how you have configured your system.
When you edit the file, you must comment out
.BR twm ,
and insert the name of the new window manager.
.PP
For example, assume that your
.B xinitrc
file reads as follows:
.DM
	sunclock -iconic &
	xterm  -geometry 80x25+26+23 -e hmon &
	xterm -ls -geometry 80x25+3+133 &
	twm
.DE
To use the window manager
.B fwm
instead of
.BR twm ,
edit this file to read as follows:
.DM
	sunclock -iconic &
	xterm  -geometry 80x25+26+23 -e hmon &
	xterm -ls -geometry 80x25+3+133 &
	#twm
	fwm
.DE
Then type
.B startx
to invoke X, as you usually do.
That's all there is to it.
.SH "Recompiling a Window Manager"
.PP
Source files for all four window managers are kept in directory
.BR /usr/X11/window_manage .
.Sh "Recompiling fvwm and fwm"
.PP
The window managers
.B fvwm
and
.B fwm
are both built from the same set of sources.
The following gives directions on how to build either.
.PP
Note that
.B fvwm
and
.B fwm
are written in ANSI C; therefore, you must have the GCC C compiler installed
on your system before you can recompile either.
.PP
Before you can use GCC to recompile
.B fvwm
or
.BR fwm ,
you must edit its
.B specs
file, and replace line
.DM
	%scrt1.o %scrtbegin.o -u _dtefg -L/lib/ndp -L/usr/lib/ndp
.DE
with:
.DM
	%scrt1.o %scrtbegin.o -u _dtefg -L/lib -L/usr/lib
.DE
This instructs GCC to link the program with the \*(CO libraries that do
.I not
use hardware floating-point processing.
After you have finished compiling the window manager, you should re-edit
.B specs
to return it to its original configuration.
.PP
Before you build either window manager, you must de-archive the sources.
To do so,
.B cd
to directory
.BR /usr/X11/window_manage ,
and then type the command:
.DM
	gtar -xvzf fvwm.gtz
.DE
When this is done,
.B cd
to directory
.BR fvwm .
.PP
To rebuild
.BR fwm ,
type:
.DM
	make -f Makefile.fwm
.DE
.PP
To build
.BR fvwm ,
type the command:
.DM
	make -f Makefile.fvwm
.DE
When your window manager is re-compiled, move it into directory
.BR /usr/X11/bin .
Then, edit your
.B xinitrc
as described above.
.Sh "Recompiling olwm"
.PP
.B olwm
compiles correctly with the default \*(CO compiler
.BR cc .
You do
.I not
need to use GCC, although you can use it if you wish.
(Note that if you do use GCC, you must modify its
.B specs
file as described above.)
.PP
To recompile
.BR olwm ,
do the following:
.IP \fB1.\fR 0.3i
.B cd
to directory
.BR /usr/X11/window_manage .
.IP \fB2.\fR
Type the following command to de-archive the sources:
.DM
	gtar -xvzf olwm.gtz
.DE
.IP \fB3.\fR
.B cd
to directory
.BR olwm/olgx .
.IP \fB4.\fR
Type
.BR make .
This rebuilds the \*(OL graphics library.
.IP \fB5.\fR
.B cd
to directory `..'.
.IP \fB6.\fR
Type
.BR make .
This rebuilds the application.
.PP
To install the package, copy the newly compiled file
.B olwm
into directory
.BR /usr/X11/bin .
Then, edit your
.B xinitrc
as described above, so that it invokes
.B olwm
instead of
.BR fwm .
.Sh "Recompiling olvwm"
.PP
.B olvwm
compiles correctly with the default \*(CO compiler
.BR cc .
You do
.I not
need to use GCC, although you can use it if you wish.
(Note that if you do use GCC, you must modify its
.B specs
file as described above.)
.B olvwm
also uses the tools
.B lex
and
.BR yacc ,
which are included as part of \*(CO.
.PP
To recompile
.BR olvwm ,
do the following:
.IP \fB1.\fR 0.3i
.B cd
to directory
.BR /usr/X11/window_manage .
.IP \fB2.\fR
Type the following command to de-archive the sources:
.DM
	tar xvzf olvwm.gtz
.DE
.IP \fB3.\fR
.B cd
to directory
.BR olvwm/olgx .
.IP \fB4.\fR
Type
.BR make .
This rebuilds the \*(OL graphics library.
.IP \fB5.\fR
.B cd
to directory `..'.
.IP \fB6.\fR
Type
.BR "make -f Makefile.Coh" .
This rebuilds the application.
.PP
To install the package, copy the newly compiled file
.B olvwm
into directory
.BR /usr/X11/bin .
Then, edit your
.B xinitrc
as described above, except that it should invoke
.B olvwm
instead of
.BR fwm .
.SH Fonts
This package installs a number of fonts that are required by the
window managers.
You will find that
.B twm
also looks more attractive with them.
.PP
The following describes the entire suite of fonts.
Note that all use the ISO Latin 1 character set (U.S. English) unless
otherwise marked:
.sp \n(pDu
.nf
.B /usr/X11/lib/fonts/75dpi:
.sp \n(pDu
.ta 1.5i
.tc . 0.1i
\fBcharB08.pcf.Z\fR	Bitstream Charter, bold Roman normal, 8 point
\fBcharB10.pcf.Z\fR	Bitstream Charter, bold Roman normal, 10 point
\fBcharB12.pcf.Z\fR	Bitstream Charter, bold Roman normal, 12 point
\fBcharB14.pcf.Z\fR	Bitstream Charter, bold Roman normal, 14 point
\fBcharB18.pcf.Z\fR	Bitstream Charter, bold Roman normal, 18 point
\fBcharB24.pcf.Z\fR	Bitstream Charter, bold Roman normal, 24 point
\fBcharBI08.pcf.Z\fR	Bitstream Charter, Bold Italic normal, 8 point
\fBcharBI10.pcf.Z\fR	Bitstream Charter, Bold Italic normal, 10 point
\fBcharBI12.pcf.Z\fR	Bitstream Charter, Bold Italic normal, 12 point
\fBcharBI14.pcf.Z\fR	Bitstream Charter, Bold Italic normal, 14 point
\fBcharBI18.pcf.Z\fR	Bitstream Charter, Bold Italic normal, 18 point
\fBcharBI24.pcf.Z\fR	Bitstream Charter, Bold Italic normal, 24 point
\fBcharI08.pcf.Z\fR	Bitstream Charter, Medium Italic normal, 8 point
\fBcharI10.pcf.Z\fR	Bitstream Charter, Medium Italic normal, 10 point
\fBcharI12.pcf.Z\fR	Bitstream Charter, Medium Italic normal, 12 point
\fBcharI14.pcf.Z\fR	Bitstream Charter, Medium Italic normal, 14 point
\fBcharI18.pcf.Z\fR	Bitstream Charter, Medium Italic normal, 18 point
\fBcharI24.pcf.Z\fR	Bitstream Charter, Medium Italic normal, 24 point
\fBcharR08.pcf.Z\fR	Bitstream Charter, Medium Roman normal, 8 point
\fBcharR10.pcf.Z\fR	Bitstream Charter, Medium Roman normal, 10 point
\fBcharR12.pcf.Z\fR	Bitstream Charter, Medium Roman normal, 12 point
\fBcharR14.pcf.Z\fR	Bitstream Charter, Medium Roman normal, 14 point
\fBcharR18.pcf.Z\fR	Bitstream Charter, Medium Roman normal, 18 point
\fBcharR24.pcf.Z\fR	Bitstream Charter, Medium Roman normal, 24 point
\fBcourB08.pcf.Z\fR	Adobe Courier, Bold Roman normal, 8 point
\fBcourB10.pcf.Z\fR	Adobe Courier, Bold Roman normal, 10 point
\fBcourB12.pcf.Z\fR	Adobe Courier, Bold Roman normal, 12 point
\fBcourB14.pcf.Z\fR	Adobe Courier, Bold Roman normal, 14 point
\fBcourB18.pcf.Z\fR	Adobe Courier, Bold Roman normal, 18 point
\fBcourB24.pcf.Z\fR	Adobe Courier, Bold Roman normal, 24 point
\fBcourBO08.pcf.Z\fR	Adobe Courier, Bold slated Roman normal, 8 point
\fBcourBO10.pcf.Z\fR	Adobe Courier, Bold slated Roman normal, 10 point
\fBcourBO12.pcf.Z\fR	Adobe Courier, Bold slated Roman normal, 12 point
\fBcourBO14.pcf.Z\fR	Adobe Courier, Bold slated Roman normal, 14 point
\fBcourBO18.pcf.Z\fR	Adobe Courier, Bold slated Roman normal, 18 point
\fBcourBO24.pcf.Z\fR	Adobe Courier, Bold slated Roman normal, 24 point
\fBcourO08.pcf.Z\fR	Adobe Courier, Medium slated Roman normal, 8 point
\fBcourO10.pcf.Z\fR	Adobe Courier, Medium slated Roman normal, 10 point
\fBcourO12.pcf.Z\fR	Adobe Courier, Medium slated Roman normal, 12 point
\fBcourO14.pcf.Z\fR	Adobe Courier, Medium slated Roman normal, 14 point
\fBcourO18.pcf.Z\fR	Adobe Courier, Medium slated Roman normal, 18 point
\fBcourO24.pcf.Z\fR	Adobe Courier, Medium slated Roman normal, 24 point
\fBcourR08.pcf.Z\fR	Adobe Courier, Medium Roman normal, 8 point
\fBcourR10.pcf.Z\fR	Adobe Courier, Medium Roman normal, 10 point
\fBcourR12.pcf.Z\fR	Adobe Courier, Medium Roman normal, 12 point
\fBcourR14.pcf.Z\fR	Adobe Courier, Medium Roman normal, 14 point
\fBcourR18.pcf.Z\fR	Adobe Courier, Medium Roman normal, 18 point
\fBcourR24.pcf.Z\fR	Adobe Courier, Medium Roman normal, 24 point
\fBhelvB08.pcf.Z\fR	Adobe Helvetica, Bold Roman normal, 8 point
\fBhelvB10.pcf.Z\fR	Adobe Helvetica, Bold Roman normal, 10 point
\fBhelvB12.pcf.Z\fR	Adobe Helvetica, Bold Roman normal, 12 point
\fBhelvB14.pcf.Z\fR	Adobe Helvetica, Bold Roman normal, 14 point
\fBhelvB18.pcf.Z\fR	Adobe Helvetica, Bold Roman normal, 18 point
\fBhelvB24.pcf.Z\fR	Adobe Helvetica, Bold Roman normal, 24 point
\fBhelvBO08.pcf.Z\fR	Adobe Helvetica, Bold slanted Roman normal, 8 point
\fBhelvBO10.pcf.Z\fR	Adobe Helvetica, Bold slanted Roman normal, 10 point
\fBhelvBO12.pcf.Z\fR	Adobe Helvetica, Bold slanted Roman normal, 12 point
\fBhelvBO14.pcf.Z\fR	Adobe Helvetica, Bold slanted Roman normal, 14 point
\fBhelvBO18.pcf.Z\fR	Adobe Helvetica, Bold slanted Roman normal, 18 point
\fBhelvBO24.pcf.Z\fR	Adobe Helvetica, Bold slanted Roman normal, 24 point
\fBhelvO08.pcf.Z\fR	Adobe Helvetica, Medium slanted Roman normal, 8 point
\fBhelvO10.pcf.Z\fR	Adobe Helvetica, Medium slanted Roman normal, 10 point
\fBhelvO12.pcf.Z\fR	Adobe Helvetica, Medium slanted Roman normal, 12 point
\fBhelvO14.pcf.Z\fR	Adobe Helvetica, Medium slanted Roman normal, 14 point
\fBhelvO18.pcf.Z\fR	Adobe Helvetica, Medium slanted Roman normal, 18 point
\fBhelvO24.pcf.Z\fR	Adobe Helvetica, Medium slanted Roman normal, 24 point
\fBhelvR08.pcf.Z\fR	Adobe Helvetica, Medium Roman normal, 8 point
\fBhelvR10.pcf.Z\fR	Adobe Helvetica, Medium Roman normal, 10 point
\fBhelvR12.pcf.Z\fR	Adobe Helvetica, Medium Roman normal, 12 point
\fBhelvR14.pcf.Z\fR	Adobe Helvetica, Medium Roman normal, 14 point
\fBhelvR18.pcf.Z\fR	Adobe Helvetica, Medium Roman normal, 18 point
\fBhelvR24.pcf.Z\fR	Adobe Helvetica, Medium Roman normal, 24 point
\fBluBIS08.pcf.Z\fR	B&H Lucida, Bold Italic normal sans serif, 8 point
\fBluBIS10.pcf.Z\fR	B&H Lucida, Bold Italic normal sans serif, 10 point
\fBluBIS12.pcf.Z\fR	B&H Lucida, Bold Italic normal sans serif, 12 point
\fBluBIS14.pcf.Z\fR	B&H Lucida, Bold Italic normal sans serif, 14 point
\fBluBIS18.pcf.Z\fR	B&H Lucida, Bold Italic normal sans serif, 18 point
\fBluBIS19.pcf.Z\fR	B&H Lucida, Bold Italic normal sans serif, 19 point
\fBluBIS24.pcf.Z\fR	B&H Lucida, Bold Italic normal sans serif, 24 point
\fBluBS08.pcf.Z\fR	B&H Lucida, Bold Roman normal sans serif, 8 point
\fBluBS10.pcf.Z\fR	B&H Lucida, Bold Roman normal sans serif, 10 point
\fBluBS12.pcf.Z\fR	B&H Lucida, Bold Roman normal sans serif, 12 point
\fBluBS14.pcf.Z\fR	B&H Lucida, Bold Roman normal sans serif, 14 point
\fBluBS18.pcf.Z\fR	B&H Lucida, Bold Roman normal sans serif, 18 point
\fBluBS19.pcf.Z\fR	B&H Lucida, Bold Roman normal sans serif, 19 point
\fBluBS24.pcf.Z\fR	B&H Lucida, Bold Roman normal sans serif, 24 point
\fBluIS08.pcf.Z\fR	B&H Lucida, Medium Italic normal sans serif, 8 point
\fBluIS10.pcf.Z\fR	B&H Lucida, Medium Italic normal sans serif, 10 point
\fBluIS12.pcf.Z\fR	B&H Lucida, Medium Italic normal sans serif, 12 point
\fBluIS14.pcf.Z\fR	B&H Lucida, Medium Italic normal sans serif, 14 point
\fBluIS18.pcf.Z\fR	B&H Lucida, Medium Italic normal sans serif, 18 point
\fBluIS19.pcf.Z\fR	B&H Lucida, Medium Italic normal sans serif, 19 point
\fBluIS24.pcf.Z\fR	B&H Lucida, Medium Italic normal sans serif, 24 point
\fBluRS08.pcf.Z\fR	B&H Lucida, Medium Roman normal sans serif, 8 point
\fBluRS10.pcf.Z\fR	B&H Lucida, Medium Roman normal sans serif, 10 point
\fBluRS12.pcf.Z\fR	B&H Lucida, Medium Roman normal sans serif, 12 point
\fBluRS14.pcf.Z\fR	B&H Lucida, Medium Roman normal sans serif, 14 point
\fBluRS18.pcf.Z\fR	B&H Lucida, Medium Roman normal sans serif, 18 point
\fBluRS19.pcf.Z\fR	B&H Lucida, Medium Roman normal sans serif, 19 point
\fBluRS24.pcf.Z\fR	B&H Lucida, Medium Roman normal sans serif, 24 point
\fBlubB08.pcf.Z\fR	B&H Lucida Bright, Demibold Roman normal, 8 point
\fBlubB10.pcf.Z\fR	B&H Lucida Bright, Demibold Roman normal, 10 point
\fBlubB12.pcf.Z\fR	B&H Lucida Bright, Demibold Roman normal, 12 point
\fBlubB14.pcf.Z\fR	B&H Lucida Bright, Demibold Roman normal, 14 point
\fBlubB18.pcf.Z\fR	B&H Lucida Bright, Demibold Roman normal, 18 point
\fBlubB19.pcf.Z\fR	B&H Lucida Bright, Demibold Roman normal, 19 point
\fBlubB24.pcf.Z\fR	B&H Lucida Bright, Demibold Roman normal, 24 point
\fBlubBI08.pcf.Z\fR	B&H Lucida Bright, Demibold Italic normal, 8 point
\fBlubBI10.pcf.Z\fR	B&H Lucida Bright, Demibold Italic normal, 10 point
\fBlubBI12.pcf.Z\fR	B&H Lucida Bright, Demibold Italic normal, 12 point
\fBlubBI14.pcf.Z\fR	B&H Lucida Bright, Demibold Italic normal, 14 point
\fBlubBI18.pcf.Z\fR	B&H Lucida Bright, Demibold Italic normal, 18 point
\fBlubBI19.pcf.Z\fR	B&H Lucida Bright, Demibold Italic normal, 19 point
\fBlubBI24.pcf.Z\fR	B&H Lucida Bright, Demibold Italic normal, 24 point
\fBlubI08.pcf.Z\fR	B&H Lucida Bright, Medium Italic normal, 8 point
\fBlubI10.pcf.Z\fR	B&H Lucida Bright, Medium Italic normal, 10 point
\fBlubI12.pcf.Z\fR	B&H Lucida Bright, Medium Italic normal, 12 point
\fBlubI14.pcf.Z\fR	B&H Lucida Bright, Medium Italic normal, 14 point
\fBlubI18.pcf.Z\fR	B&H Lucida Bright, Medium Italic normal, 18 point
\fBlubI19.pcf.Z\fR	B&H Lucida Bright, Medium Italic normal, 19 point
\fBlubI24.pcf.Z\fR	B&H Lucida Bright, Medium Italic normal, 24 point
\fBlubR08.pcf.Z\fR	B&H Lucida Bright, Medium Roman normal, 8 point
\fBlubR10.pcf.Z\fR	B&H Lucida Bright, Medium Roman normal, 10 point
\fBlubR12.pcf.Z\fR	B&H Lucida Bright, Medium Roman normal, 12 point
\fBlubR14.pcf.Z\fR	B&H Lucida Bright, Medium Roman normal, 14 point
\fBlubR18.pcf.Z\fR	B&H Lucida Bright, Medium Roman normal, 18 point
\fBlubR19.pcf.Z\fR	B&H Lucida Bright, Medium Roman normal, 19 point
\fBlubR24.pcf.Z\fR	B&H Lucida Bright, Medium Roman normal, 24 point
\fBlutBS08.pcf.Z\fR	B&H Lucida Typewriter, Bold Roman normal sans serif, 8 point
\fBlutBS10.pcf.Z\fR	B&H Lucida Typewriter, Bold Roman normal sans serif, 10 point
\fBlutBS12.pcf.Z\fR	B&H Lucida Typewriter, Bold Roman normal sans serif, 12 point
\fBlutBS14.pcf.Z\fR	B&H Lucida Typewriter, Bold Roman normal sans serif, 14 point
\fBlutBS18.pcf.Z\fR	B&H Lucida Typewriter, Bold Roman normal sans serif, 18 point
\fBlutBS19.pcf.Z\fR	B&H Lucida Typewriter, Bold Roman normal sans serif, 19 point
\fBlutBS24.pcf.Z\fR	B&H Lucida Typewriter, Bold Roman normal sans serif, 24 point
\fBlutRS08.pcf.Z\fR	B&H Lucida Typewriter, Medium Roman normal sans serif, 8 point
\fBlutRS10.pcf.Z\fR	B&H Lucida Typewriter, Medium Roman normal sans serif, 10 point
\fBlutRS12.pcf.Z\fR	B&H Lucida Typewriter, Medium Roman normal sans serif, 12 point
\fBlutRS14.pcf.Z\fR	B&H Lucida Typewriter, Medium Roman normal sans serif, 14 point
\fBlutRS18.pcf.Z\fR	B&H Lucida Typewriter, Medium Roman normal sans serif, 18 point
\fBlutRS19.pcf.Z\fR	B&H Lucida Typewriter, Medium Roman normal sans serif, 19 point
\fBlutRS24.pcf.Z\fR	B&H Lucida Typewriter, Medium Roman normal sans serif, 24 point
\fBncenB08.pcf.Z\fR	Adobe New Century Schoolbook, Bold Roman normal, 8 point
\fBncenB10.pcf.Z\fR	Adobe New Century Schoolbook, Bold Roman normal, 10 point
\fBncenB12.pcf.Z\fR	Adobe New Century Schoolbook, Bold Roman normal, 12 point
\fBncenB14.pcf.Z\fR	Adobe New Century Schoolbook, Bold Roman normal, 14 point
\fBncenB18.pcf.Z\fR	Adobe New Century Schoolbook, Bold Roman normal, 18 point
\fBncenB24.pcf.Z\fR	Adobe New Century Schoolbook, Bold Roman normal, 24 point
\fBncenBI08.pcf.Z\fR	Adobe New Century Schoolbook, Bold Italic normal, 8 point
\fBncenBI10.pcf.Z\fR	Adobe New Century Schoolbook, Bold Italic normal, 10 point
\fBncenBI12.pcf.Z\fR	Adobe New Century Schoolbook, Bold Italic normal, 12 point
\fBncenBI14.pcf.Z\fR	Adobe New Century Schoolbook, Bold Italic normal, 14 point
\fBncenBI18.pcf.Z\fR	Adobe New Century Schoolbook, Bold Italic normal, 18 point
\fBncenBI24.pcf.Z\fR	Adobe New Century Schoolbook, Bold Italic normal, 24 point
\fBncenI08.pcf.Z\fR	Adobe New Century Schoolbook, Medium Italic normal, 8 point
\fBncenI10.pcf.Z\fR	Adobe New Century Schoolbook, Medium Italic normal, 10 point
\fBncenI12.pcf.Z\fR	Adobe New Century Schoolbook, Medium Italic normal, 12 point
\fBncenI14.pcf.Z\fR	Adobe New Century Schoolbook, Medium Italic normal, 14 point
\fBncenI18.pcf.Z\fR	Adobe New Century Schoolbook, Medium Italic normal, 18 point
\fBncenI24.pcf.Z\fR	Adobe New Century Schoolbook, Medium Italic normal, 24 point
\fBncenR08.pcf.Z\fR	Adobe New Century Schoolbook, Medium Roman normal, 8 point
\fBncenR10.pcf.Z\fR	Adobe New Century Schoolbook, Medium Roman normal, 10 point
\fBncenR12.pcf.Z\fR	Adobe New Century Schoolbook, Medium Roman normal, 12 point
\fBncenR14.pcf.Z\fR	Adobe New Century Schoolbook, Medium Roman normal, 14 point
\fBncenR18.pcf.Z\fR	Adobe New Century Schoolbook, Medium Roman normal, 18 point
\fBncenR24.pcf.Z\fR	Adobe New Century Schoolbook, Medium Roman normal, 24 point
\fBsymb08.pcf.Z\fR	Adobe Symbol, Medium Roman normal, 8 point
\fBsymb10.pcf.Z\fR	Adobe Symbol, Medium Roman normal, 10 point
\fBsymb12.pcf.Z\fR	Adobe Symbol, Medium Roman normal, 12 point
\fBsymb14.pcf.Z\fR	Adobe Symbol, Medium Roman normal, 14 point
\fBsymb18.pcf.Z\fR	Adobe Symbol, Medium Roman normal, 18 point
\fBsymb24.pcf.Z\fR	Adobe Symbol, Medium Roman normal, 24 point
\fBtech14.pcf.Z\fR	DEC Terminal, Medium Roman normal, 14 point
\fBtechB14.pcf.Z\fR	DEC Terminal, Bold Roman normal, 14 point
\fBterm14.pcf.Z\fR	DEC Terminal, Medium Roman normal, 14 point
\fBtermB14.pcf.Z\fR	DEC Terminal, Bold Roman normal, 14 point
\fBtimB08.pcf.Z\fR	Adobe Times, Bold Roman normal, 8 point
\fBtimB10.pcf.Z\fR	Adobe Times, Bold Roman normal, 10 point
\fBtimB12.pcf.Z\fR	Adobe Times, Bold Roman normal, 12 point
\fBtimB14.pcf.Z\fR	Adobe Times, Bold Roman normal, 14 point
\fBtimB18.pcf.Z\fR	Adobe Times, Bold Roman normal, 18 point
\fBtimB24.pcf.Z\fR	Adobe Times, Bold Roman normal, 24 point
\fBtimBI08.pcf.Z\fR	Adobe Times, Bold Italic normal, 8 point
\fBtimBI10.pcf.Z\fR	Adobe Times, Bold Italic normal, 10 point
\fBtimBI12.pcf.Z\fR	Adobe Times, Bold Italic normal, 12 point
\fBtimBI14.pcf.Z\fR	Adobe Times, Bold Italic normal, 14 point
\fBtimBI18.pcf.Z\fR	Adobe Times, Bold Italic normal, 18 point
\fBtimBI24.pcf.Z\fR	Adobe Times, Bold Italic normal, 24 point
\fBtimI08.pcf.Z\fR	Adobe Times, Medium Italic normal, 8 point
\fBtimI10.pcf.Z\fR	Adobe Times, Medium Italic normal, 10 point
\fBtimI12.pcf.Z\fR	Adobe Times, Medium Italic normal, 12 point
\fBtimI14.pcf.Z\fR	Adobe Times, Medium Italic normal, 14 point
\fBtimI18.pcf.Z\fR	Adobe Times, Medium Italic normal, 18 point
\fBtimI24.pcf.Z\fR	Adobe Times, Medium Italic normal, 24 point
\fBtimR08.pcf.Z\fR	Adobe Times, Medium Roman normal, 8 point
\fBtimR10.pcf.Z\fR	Adobe Times, Medium Roman normal, 10 point
\fBtimR12.pcf.Z\fR	Adobe Times, Medium Roman normal, 12 point
\fBtimR14.pcf.Z\fR	Adobe Times, Medium Roman normal, 14 point
\fBtimR18.pcf.Z\fR	Adobe Times, Medium Roman normal, 18 point
\fBtimR24.pcf.Z\fR	Adobe Times, Medium Roman normal, 24 point
.sp \n(pDu
\fB/usr/X11/lib/fonts/misc:\fR
.sp \n(pDu
\fB10x20.pcf.Z\fR	Misc Fixed, Medium Roman normal
\fB12x24.pcf.Z\fR	Sony Fixed, Medium Roman normal
\fB5x7.pcf.Z\fR	Misc Fixed, Medium Roman normal
\fB5x8.pcf.Z\fR	Misc Fixed, Medium Roman normal
\fB6x10.pcf.Z\fR	Misc Fixed, Medium Roman normal
\fB6x12.pcf.Z\fR	Misc Fixed, Medium Roman semicondensed
\fB6x13.pcf.Z\fR	Misc Fixed, Medium Roman semicondensed
\fB6x13B.pcf.Z\fR	Misc Fixed, Bold Roman semicondensed
\fB6x9.pcf.Z\fR	Misc Fixed, Medium Roman normal
\fB7x13.pcf.Z\fR	Misc Fixed, Medium Roman normal
\fB7x13B.pcf.Z\fR	Misc Fixed, Bold Roman normal
\fB7x14.pcf.Z\fR	Misc Fixed, Medium Roman normal
\fB7x14B.pcf.Z\fR	Misc Fixed, Bold Roman normal
\fB7x14rk.pcf.Z\fR	Misc Fixed, Medium Roman normal (Japanese)
\fB8x13.pcf.Z\fR	Misc Fixed, Medium Roman normal
\fB8x13B.pcf.Z\fR	Misc Fixed, Bold Roman normal
\fB8x16.pcf.Z\fR	Sony Fixed, Medium Roman normal
\fB8x16rk.pcf.Z\fR	Sony Fixed, Medium Roman normal (Japanese)
\fB9x15.pcf.Z\fR	Misc Fixed, Medium Roman normal
\fB9x15B.pcf.Z\fR	Misc Fixed, Bold Roman normal
\fBclB6x10.pcf.Z\fR	Schumacher Clean, Bold Roman normal
\fBclB6x12.pcf.Z\fR	Schumacher Clean, Bold Roman normal
\fBclB8x10.pcf.Z\fR	Schumacher Clean, Bold Roman normal
\fBclB8x12.pcf.Z\fR	Schumacher Clean, Bold Roman normal
\fBclB8x13.pcf.Z\fR	Schumacher Clean, Bold Roman normal
\fBclB8x14.pcf.Z\fR	Schumacher Clean, Bold Roman normal
\fBclB8x16.pcf.Z\fR	Schumacher Clean, Bold Roman normal
\fBclB8x8.pcf.Z\fR	Schumacher Clean, Bold Roman normal
\fBclB9x15.pcf.Z\fR	Schumacher Clean, Bold Roman normal
\fBclI6x12.pcf.Z\fR	Schumacher Clean, Medium Italic normal
\fBclI8x8.pcf.Z\fR	Schumacher Clean, Medium Italic normal
\fBclR4x6.pcf.Z\fR	Schumacher Clean, Medium Roman normal
\fBclR5x10.pcf.Z\fR	Schumacher Clean, Medium Roman normal
\fBclR5x6.pcf.Z\fR	Schumacher Clean, Medium Roman normal
\fBclR5x8.pcf.Z\fR	Schumacher Clean, Medium Roman normal
\fBclR6x10.pcf.Z\fR	Schumacher Clean, Medium Roman normal
\fBclR6x12.pcf.Z\fR	Schumacher Clean, Medium Roman normal
\fBclR6x13.pcf.Z\fR	Schumacher Clean, Medium Roman normal
\fBclR6x6.pcf.Z\fR	Schumacher Clean, Medium Roman normal
\fBclR6x8.pcf.Z\fR	Schumacher Clean, Medium Roman normal
\fBclR7x10.pcf.Z\fR	Schumacher Clean, Medium Roman normal
\fBclR7x12.pcf.Z\fR	Schumacher Clean, Medium Roman normal
\fBclR7x14.pcf.Z\fR	Schumacher Clean, Medium Roman normal
\fBclR7x8.pcf.Z\fR	Schumacher Clean, Medium Roman normal
\fBclR8x10.pcf.Z\fR	Schumacher Clean, Medium Roman normal
\fBclR8x12.pcf.Z\fR	Schumacher Clean, Medium Roman normal
\fBclR8x13.pcf.Z\fR	Schumacher Clean, Medium Roman normal
\fBclR8x14.pcf.Z\fR	Schumacher Clean, Medium Roman normal
\fBclR8x16.pcf.Z\fR	Schumacher Clean, Medium Roman normal
\fBclR8x8.pcf.Z\fR	Schumacher Clean, Medium Roman normal
\fBclR9x15.pcf.Z\fR	Schumacher Clean, Medium Roman normal
\fBcursor.pcf.Z\fR	Cursor (cursors)
\fBdeccurs.pcf.Z\fR	DEC cursor (cursors)
\fBdecsess.pcf.Z\fR	DEC session
\fBheb6x13.pcf.Z\fR	Misc Fixed, Medium Roman semicondensed (Hebrew)
\fBheb8x13.pcf.Z\fR	Misc Fixed, Medium Roman normal (Hebrew)
\fBnil2.pcf.Z\fR	Misc nil, Medium Roman normal
\fBolcursor.pcf.Z\fR	Sun Open Look cursor (cursors)
\fBolgl10.pcf.Z\fR	Sun Open Look glyph, 10 point (glyphs)
\fBolgl12.pcf.Z\fR	Sun Open Look glyph, 12 point (glyphs)
\fBolgl14.pcf.Z\fR	Sun Open Look glyph, 14 point (glyphs)
\fBolgl19.pcf.Z\fR	Sun Open Look glyph, 19 point (glyphs)
.fi
.SH "Copyrights"
.PP
Please note that the software in this package comes from third-party
sources.
It is offered ``as is'', with no guarantee or warranty stated or implied,
whatsoever.
The copyrights on the source code and any executables built from it
belong to the persons who wrote the original code; full copyright
statements are included with the source code to each window manager.
We ask that you read and respect these statements before you modify or
redistribute any of the sources or binaries in these packages.
.SH "Technical Support"
.PP
The sources in this package have been compiled and run successfully under
\*(CO.
If you have a problem bringing up one of the window managers or with
compiling the source code as it is configured in this package, our
technical support team will attempt to help you.
However, because of the highly technical nature of the source
code in these packages, Mark Williams Company
.I cannot
give you technical assistance should you modify any of the source code
included in this package in any manner whatsoever.
.SH "A Final Word"
.PP
All of the source code for these games, and for most programs shipped in our
Xware packages, is available for free on the Mark Williams bulletin board
system, and on other publicly accessible archives.
The tutorial for
.B UUCP
in the \*(CO manual describes how to contact the BBS and make its services
available to you.

.ie t \{\
.ds AR "\\f(SCANSI\\fP Rationale"
.ds AS "\\f(SCANSI\\fP Standard"
.\" IBM PC, in small capitals
.ds BM "\\f(SCIBM PC\\fP"
.ds CO \\f(SCCOHERENT\\fP
.\" down arrow, using keycaps font
.ds DA \\fK(\\XEB)\\fP
.\" left arrow, using keycaps font
.ds LA \\fK(\\XF1)\\fP
.\" MS-DOS using small capitals
.ds MD \\f(SCMS-DOS\\fP
.\" MicroEMACS, using small capitals
.ds ME "\\f(SCM\\fPicro\\f(SCEMACS\\fP"
.\" OPEN LOOK, in small capitals
.ds OL "\\f(SCOPEN LOOK\\fP"
.\" COHERENT, in small capitals
.ds OS \\f(SCCOHERENT\\fP
.ds PN \\f(SCCOHERENT\\fP
.\" POSIX Standard, in small capitals
.ds PX "\\f(SCPOSIX\\fP Standard"
.\" right arrow, in keycaps font
.ds RA \\fK(\\XE1)\\fP
.\" <return> key, using keycaps font
.ds RT \\fK(\\XA2)\\fP
.\" STREAMS, in small capitals
.ds ST \\f(SCSTREAMS\\fP
.\" up arrow, in keycaps font
.ds UA \\fK(\\XE3)\\fP
.\" UNIX, in small capitals
.ds UN \\f(SCUNIX\\fP
.\" UUCP, in small capitals
.ds UU \\f(SCUUCP\\fP\}
.el \{\
.\" remap keycaps and line-printer fonts to Roman
.\" .rf L  R
.\" .rf K  R
.\" .rf SC R
.ds AR "ANSI Rationale"
.ds AS "ANSI Standard"
.ds BM "IBM PC"
.ds CO COHERENT
.ds DA v
.ds LA \\(<-
.ds MD MS-DOS
.ds ME "MicroEMACS"
.ds OL "OPEN LOOK"
.ds OS COHERENT
.ds PN COHERENT
.ds PX "POSIX Standard"
.ds RA \\(->
.ds RT \\fB<return>\\fP
.ds ST STREAMS
.ds UA ^
.ds UN UNIX
.ds UU "UUCP"\}
.ds CR 1993
.ds DI /v/fwb/doc/coherent
.\" footer one inch from bottom of the page
.nr FT 10.0i
.ds KR "\\fIThe C Programming Language\\fR, second edition"
.ds MW "Mark Williams Company"
.\" page offset
.nr PO 0.75i
.\" line width 7.0 inches
.nr PW 7.0i
.ds Ql `
.ds Qr '
.ds QL ``
.ds QR ''
.\" directory where images are stashed
.ds XD /v/PostScript/manual

.ds TL "Installation"
.NH "Installing COHERENT" 1
.PP
This section describes how to install COHERENT onto your computer.
Installation of COHERENT is straightforward, and Mark Williams Company
has prepared a suite of programs that automate much of the work for you.
Tens of thousands of users have successfully installed COHERENT onto their
computers.
Most have found the process to be easy and quick.
A few have experienced problems with installation; so if
installation does not go as smoothly as you would like, the end of this
section describes the more common problems and how you can fix them.
If all else fails, telephone Mark Williams Technical Support, as described
in the introduction to this pamphlet.
.PP
Installation requires that you make a few decisions regarding
how you want your system to be configured.
We strongly urge you to read this section through at least once before you
begin, so you can decide correctly whenever an installation program
asks you to make a decision.
.PP
Before you begin, please note the following caveats:
.PP
First, the following conditions must be met if COHERENT is to work
on your system:
.RS
.IP 1. 0.3i
COHERENT is designed for use on the IBM AT, or on computers that
are totally compatible with the IBM AT.
These include IBM-compatible systems built around the Intel 80286, 80386,
or 80486 microprocessors.
It does not work on any MicroChannel computer
(although a MicroChannel version of COHERENT is currently under development);
nor does it work on any
computer that is not 100% compatible with the IBM AT.
.IP 2.
Your system must have at least 640K of memory,
and at least one high-density, 3.5-inch or
5.25-inch floppy-disk drive installed as drive A.
The distribution disks for COHERENT cannot be read by a low-density
floppy-disk drive, nor can they be converted from 3.5-inch to 5.25-inch,
or vice versa.
.IP 3.
Your system must have a hard disk, and the hard disk must have at least
ten megabytes of space free on it.
More is recommended, but ten megabytes is the minimum space required
by COHERENT.
If you do not have enough space on your hard disk, you will have to clear
space by removing or compressing existing files.
.IP 4.
COHERENT can only be installed onto all of a DOS partition, or into any
part of a non-DOS partition on your hard disk.
If you claim all of a DOS partition for COHERENT, COHERENT will format
that partition and turn it into a COHERENT partition \(em and in the
process, erase all MS-DOS data on that partition.
.sp \n(pDU
.I
If you do not wish to convert an MS-DOS partition to COHERENT and you do
not have a non-DOS partition of at least ten megabytes, then you must
back up your data, use the MS-DOS version of 
\fBfdisk\fP and make your MS-DOS partition smaller by at least ten
megabytes or however much space you wish to allocate to COHERENT.
.R
.IP 5.
COHERENT works with RLL, MFM, IDE and most ESDI hard-disk controllers.
It also works with some SCSI host adapters.
Please check the previous section for a list of supported hard disk
controllers and host adapters.
.IP 6.
If you intend to install COHERENT on a system which uses one of the
supported SCSI host adapters,
be sure that your host adapter is jumpered to enable interrupts
and that the interrupt number and other configuration
information is available prior to beginning the installation of COHERENT.
See Lexicon articles
.B aha154x
and
.B ss
for further details.
.PP
If you are unsure whether your system meets any or all of these conditions,
check the documentation that came with your system, or contact the dealer
from whom you purchased your system.
Section 2 of this pamphlet lists the hardware that is known to
be compatible, as well as known incompatibilities.
Check there before you begin installation.
If you believe that your computer cannot run COHERENT, please contact Mark
Williams Company.
.PP
Second, Mark Williams Company has made every effort to ensure that the
installation process will not destroy data on your hard disk.
Note, however, that the installation process requires that you assign
at least one partition of your hard disk to COHERENT.
.I
If you have any files on that partition that you wish to save, you
must back them up or they will be lost.
.ft R
It is also recommended that you keep a copy, on paper, of your
computer's partition table.
If you do not know how to obtain a copy of the partition table, one will
be displayed for you during installation.
We recommend that you jot it down at that time; if something should go
wrong, this information will help to recover the data on your disk.
.PP
Note, too, that installation may require that the entire disk be
repartitioned; in this case, you must back up all of your hard disk, or
your data will be lost.
The installation program will walk you through this process, so you do not
have to decide ahead of time what partitions, if any, need to be backed up.
.PP
With these caveats in mind, please continue \(em and we hope you
enjoy working with COHERENT!
.SH "What Does Installation Do?"
.PP
The point of the installation procedure is to create one or more partitions on
your hard disk to contain COHERENT and its files.
.PP
When you (or your dealer) installed MS-DOS on your computer, you (or he)
divided your computer's hard disk into \fIpartitions\fR.
A hard disk on the IBM AT can have anywhere from one to four
partitions.
Not every partition has to be used \(em your hard disk may be divided
into four partitions, but have MS-DOS file systems in only two of them,
with the third and fourth partitions being idle.
Note, too, that the four partitions do not necessarily have to
encompass the entire hard disk \(em a disk may have space that is outside
any partition and so just sits there unused.
.PP
The file systems for COHERENT and MS-DOS are very different, so it is not
possible to have both systems use the same partition \(em each
must have one or more partitions completely to itself.
.PP
As you can see, installation must cope with a number of variables:
the size of your disk,
the number of partitions into which it is divided,
the size of each partition,
and the number of partitions that are in use.
Installation thus will follow any of a number of possible scenarios,
depending on how your disk is organized and how much space you wish
to give over to COHERENT.
The installation process will walk you through these decisions, to make
them as painless as possible.
.PP
It may well be that you do not know the configuration of your hard disk.
COHERENT can figure this out, and the
information will be displayed for you at the appropriate point in installation.
.PP
You can abort the installation procedure at any time by typing
\fB<ctrl-C>\fR.
Note, however, that
aborting installation does \fInot\fR mean that your hard disk will be returned
to the state it was in before installation was begun.
.I
When a disk is repartitioned, the files that were on any
modified partitions are gone forever!
.ft R
.PP
The following sections describe the installation process in some detail.
Be sure to read them through before you begin.
.PP
During the installation, COHERENT will give you easily understandable prompts,
and it will notify you about all actions that could destroy data on your disk
before they are run.
You will always be asked to confirm that you wish to run an action that
destroys data before COHERENT executes that action.
.\".SH "BIOS Disk Parameters"
.\".PP
.\"Some disk controller and drive combinations use disk
.\"parameters other than the physical drive parameters.
.\"These parameters are called BIOS parameters or ``translation mode''
.\"parameters.
.\"If you do not know the BIOS parameters for your hard disk drives,
.\"you will need to invoke command
.\".BR dpb ,
.\"as described in the following section,
.\"prior to starting the COHERENT installation.
.\"Be sure to copy down all displayed parameters, as you may need
.\"to enter them during installation.
.SH "Getting Started"
.PP
To begin installation, reboot the system by pressing the reset button,
or cold-boot your system by turning it off, waiting 30 seconds, and
turning it on again.
Insert the \fBBoot\fR disk from your installation
kit into drive A on your system.
In a moment, you will be prompted with a question mark \*(Ql?\*(Qr.
Type:
.\".DM
.\"	dpb
.\".DE
.\"and press the
.\".B <enter>
.\"key.
.\"Copy down all the displayed information and keep it with your
.\"COHERENT distribution disks.
.\".PP
.\"After you finish copying down the disk information, enter
.DM
	begin
.DE
followed by the \fB<enter>\fR key.
The installation program will clear the screen and display some copyright
information.
After you press \fB<enter>\fR, you will see the following greeting:
.DM
	Welcome to the COHERENT operating system!
.sp \n(pDu
	Your computer is now running COHERENT from the floppy disk.
	This program will install COHERENT onto your hard disk.
	You can interrupt installation at any time by typing <Ctrl-C>;
	then reboot to begin the installation procedure again.
	Please be patient and read the instructions on the screen
	carefully.
.DE
As the instructions say, you can interrupt installation at any point by
typing \fB<ctrl-C>\fR.
Be sure, as well, to read the instructions carefully.
.SH "Selecting a Keyboard"
.PP
The next menu asks you to select a keyboard table from the list shown.
There are approximately 19 choices of keyboard tables.
.PP
The menu entries marked
.B "(not loadable)"
are the traditional COHERENT keyboard drivers, which are linked
directly into the kernel.
These include the traditional US, German, and French keyboards.
These traditional keyboard drivers work with all keyboards,
even the inferior ones sold with some ``clones''.
.PP
The other 16 or so menu entries represent loadable tables.
These use the
.B nkb
driver and thus allow you to customize the tables to your liking,
as well as load new tables at run time.
Please note, however, that the
.B nkb
driver (and loadable tables) only work with well-engineered
keyboards, such as those built by IBM, Cherry, MicroSwitch, or Keytronic;
when used with an inferior ``clone'' keyboard, it may not work correctly.
.PP
When the menu appears, the line for the non-loadable
US keyboard table is highlighted.
This table will satisfy the needs of all users in the United States, and
many users abroad.
To select this entry, simply press
.BR <enter> ;
COHERENT will do the rest.
.PP
If you live outside the United States and so need
a specialized keyboard table,
press the
.B <space>
bar or the arrow keys
until the table you want is highlighted; then press
.B <enter>
to select the highlighted entry.
.I
The new keyboard layout takes effect as soon as COHERENT reboots to read the
rest of the installation disks.
.R
.PP
Note that if you choose one of the entries marked
.BR "not loadable" ,
you can use only that keyboard layout; the only way to select another
keyboard layout is to re-install COHERENT.
Please note, too, that loadable keyboard tables will not work with
inferior ``clone'' keyboards; these keyboards work only with the menu entries
marked
.BR "not loadable" .
Loadable keyboard tables are known to work correctly with keyboards
manufactured by IBM, Cherry, MicroSwitch and Keytronic.
.PP
If your keyboard's layout does not correspond to one of the
entries from the menu, select a loadable keyboard table
layout that resembles your keyboard.
After installation, you will be able to modify that
entry to make it correspond to your keyboard.
See Lexicon articles
.B "keyboard tables"
and
.B nkb
for further details on creating a new keyboard layout,
or modifying an existing one.
In addition,
the Mark Williams Company BBS system contains additional keyboard tables.
See the following sections of this manual for details on accessing
the MWC BBS system and on contacting satellite COHERENT BBS systems
around the world.
.SH "Entering the Serial Number"
.PP
The next screen will ask you to enter a nine-digit serial number.
This number is included on a paper supplied with your copy of the
COHERENT system.
The installation process cannot continue until you enter this number
correctly.
.SH "Setting the Date and Time"
.PP
The next screen asks you to set the date and time for COHERENT.
Setting the date and time is vital to the correct operation of
COHERENT; however, COHERENT records the date and time quite differently
from the way MS-DOS does.
.PP
Time under COHERENT is recorded as the number of seconds since January 1, 1970,
at exactly midnight.
Internally, COHERENT always stores time as Greenwich Mean Time.
GMT is used
to make it easy for COHERENT systems around the globe to coordinate time with
each other.
When COHERENT
time-stamps a file or displays the time, it converts Greenwich Mean Time to
your local time, depending on what time zone you live in and whether
Daylight Savings Time is in effect.
(For a detailed discussion of this topic, see the Lexicon's entry for
.BR TIMEZONE .)
.PP
The installation program will display the following text:
.DM
	It is important for the COHERENT system to know the
	correct date and time.  You must provide information
	about your timezone and daylight savings time.
.sp \n(pDu
	According to your computer system clock, your current
	local date and time are:
	\fIdate and time\fR
.DE
You will be asked if this is correct.
If it is not correct, the installation program will prompt you for the
correct date and time.
.PP
You will then be asked about daylight savings time:
.DM
	You can run COHERENT with or without daylight savings
	time conversion.  You should normally run with daylight
	savings time conversion. However, if you are going to use
	both COHERENT and MS-DOS and you choose to run with daylight
	savings time conversion, your time will be wrong (by one
	hour) during daylight savings time while you are running
	under MS-DOS.
.DE
You will be asked if you want to run in daylight-savings mode.
You should answer yes unless you have an overwhelming reason not to.
.PP
The installation program then describes the default daylight-savings
settings:
.DM
	By default, COHERENT assumes daylight savings time begins
	on the first Sunday in April and ends on the last Sunday
	in October.  If you want to change the defaults, edit the
	file "/etc/timezone" after you finish installing COHERENT.
.DE
The default settings are those enacted by law for the United States.
COHERENT will then
display a timezone menu similar to the following
and then ask you what time zone you live in:
.DM
	Please choose one of the following timezones:
		0	Central European
		1	Greenwich
		2	Newfoundland
		3	Atlantic
		4	Eastern
		5	Central
		6	Mountain
		7	Pacific
		8	Yukon
		9	Alaska
		10	Bering
		11	Hawaii
		12	Other
.DE
If you select 0 through 11, COHERENT will set your local time automatically.
If you select \*(QLOther\*(QR, you will be asked how many minutes of time
you live east or west of Greenwich, and then asked to name your time zone.
If you are unclear on these concepts, consult the Lexicon article on
.BR TIMEZONE .
If you are unsure about how your local time relates to Greenwich time,
consult an atlas, check with your local library, or telephone a
local radio station.
.PP
COHERENT will then display the corrected local time and ask if it is correct.
If not, you can repeat the process until the time is correct.
.SH "Installing Onto a SCSI Hard Disk"
.PP
If you are installing COHERENT onto a SCSI disk drive,
you will will be prompted with a menu resembling:
.DM
	COHERENT currently supports the following SCSI host adapters:
.sp
	(1) Adaptec AHA-154x series
	(2) Seagate ST01 or ST02
	(3) Future Domain TMC-845/850/860/875/885
	(4) Future Domain TMC-840/841/880/881
.sp
	Enter a number from the above list or 0 to exit:
.DE
If you intend to install COHERENT on a system which uses one of these
supported SCSI host adapters,
be sure that your host adapter is jumpered to enable interrupts
and that the interrupt number and other configuration
information is available.
See Lexicon articles
.B aha154x
and
.B ss
for further details.
.SH "Back Up the Hard Disk"
.PP
After the time is set, installation moves on to its next phase,
partitioning the hard disk.
Before you become seriously involved in partitioning, however, you have
one last chance to back up your hard disk.
As you enter the partition phase of installation, you will see the following
text:
.DM
	This installation procedure allows you to create one
	or more partitions on your hard disk to contain the
	COHERENT system and its files.  Each disk drive may
	contain no more than four logical partitions.  If all
	four partitions on your disk are already in use, you will
	have to overwrite at least one of them to install COHERENT.
	If your disk uses fewer than four partitions and has enough
	unused space for COHERENT (ten megabytes), you can install
	COHERENT into the unused space.  If you intend to install
	MS-DOS, you should install it \fBbefore\fP you install COHERENT.
.sp \n(pDu
	The next part of the installation procedure will let you
	change the partitions on your hard disk.  Data on unchanged
	hard disk partitions will not be changed.  However, data
	already on your hard disk may be destroyed if you change
	the base or the size of a logical partition, or if you
	change the order of the partition table entries.  If you
	need to back up existing data from the hard disk, type
	<Ctrl-C> now to interrupt COHERENT installation; then
	reboot your system and back up your hard disk data onto
	diskettes.
.DE
If you need to back up your hard disk and have not yet done so, please
do so now.
.SH "Use the COHERENT Bootstrap?"
.PP
If you have already backed up your hard disk, continue to the next phase,
which is to decide whether to use the COHERENT master bootstrap.
When you press \fB<return>\fR, you will see the following text:
.DM
	COHERENT initialization normally writes a new master
	bootstrap program onto your hard disk.  The COHERENT
	master boot allows you to boot the operating system on
	one selected disk partition automatically; it also allows
	you to boot the operating system on any disk partition by
	typing a key when you reboot.  However, the COHERENT master
	boot may not work with all operating systems.  If you do
	not use the COHERENT boot, you must understand how to
	boot the COHERENT partition using your existing bootstrap
	program.
.DE
As explained in the prompt text, a \fIbootstrap\fR is a program that
pulls an operating system into memory and sets it to running \(em the
name relates to the fact that the operating system \*(QLpulls itself up
by its boot straps\*(QR.
The COHERENT master bootstrap can boot COHERENT as well as many other
operating systems, including MS-DOS (at least, the many versions of MS-DOS
that have been tested).
If you choose not to use the COHERENT master bootstrap, you must consult
the documentation that came with your system to see how you can use your
operating system's current bootstrap routine to boot another operating system.
If, however, you choose to use the COHERENT master bootstrap and find that
it has trouble booting your current operating system, you should be able to
boot your current operating system by using a boot floppy disk; you will not
be able to boot it off of the hard disk, but at least it will be available
to you.
For these reasons, we strongly suggest that you use the COHERENT master
bootstrap routine.
.PP
Prior to overwriting the bootstrap, the COHERENT installation procedure
will ask:
.DM
	Do you want to save the original boot block?
.DE
If you wish to save a copy of your existing bootstrap, you will need
to have a \fIhigh density formatted floppy\fP available.
The floppy disk may have been formatted using MS-DOS.
The boot block is not saved as a file \(em it is merely written into the
first sector on the floppy disk.
You will need to save your original boot block should you ever want to
remove COHERENT from your system.
While we cannot imagine why anyone would want to do such a thing,
you may want to save your original boot block, just in case.
.PP
.B install
then asks:
.DM
	Do you want to restore a previously saved boot block?
.DE
You should answer yes only if you are removing COHERENT from your
system and need to restore a previously saved boot block.
.PP
After you answer this prompt, you will move into the next phase,
partitioning the disk.
.SH "Partitioning the Hard Disk"
.PP
Installation then moves into the next phase:
selecting a disk partition for COHERENT.
As described above, partitioning can vary greatly from disk to disk;
how the disk is partitioned will determine how much space is allocated
to COHERENT and how much to MS-DOS.
This is the trickiest part of installation, so be sure to read carefully.
.Sh "How a Disk Is Organized"
.PP
This phase begins by displaying the current layout of your hard disk:
the number of partitions, the size of each partition, and the operating
system associated with each partition.
Note that the partition table is displayed in \fIphysical\fP order (i.e., the
actual order in which the partition table entries occur).
Some operating systems display the table in \fIlogical\fP or sorted order.
.PP
The following gives the printout for a typical hard disk.
This hard disk, called disk \fB0\fR,
has approximately 33 megabytes on it organized into
two MS-DOS partitions, as follows:
.DM
Drive 0 Current has the following configuration:
              [In Cylinders] [  In Tracks  ]   
Number  Type  Start End Size Start  End Size Mbyte Blocks Name
0 Boot MS-DOS    0  149  150     0  899  900  7.83  15300 /dev/at0a
1     EXT-DOS  150  614  464   900 3684 2784 24.28  47430 /dev/at0b
2      UNUSED    0    0    0     0    0    0     0      0 /dev/at0c
3      UNUSED    0    0    0     0    0    0     0      0 /dev/at0d
.DE
If you have more than one hard disk on your machine, then
you will see the table for the second disk after you have finished
partitioning the first.
.PP
Note that MS-DOS names each ``drive'' by a letter of the alphabet,
beginning with C.
(This nomenclature is a hold-over from the days when MS-DOS only ran on
floppy disks, with `A' and `B' reserved for the two floppy-disk drives.)
Because MS-DOS allows you to have only two DOS partitions on any
given hard disk, then if an MS-DOS system has more than two ``drives'' on
one hard disk, the additional drives are \fIlogical\fR drives and are a
division of the EXT-DOS partition.
COHERENT cannot be installed onto a logical drive.
.PP
As mentioned above, we suggest that you copy down this table before
continuing; if an error were to occur, this information will help you
recover the data on your disk.
.PP
As you can see, this disk has four partitions, numbered 0 through 3.
Partition 0 is marked as the boot partition; what this means is
explained below.
COHERENT has given each partition a name, \fB/dev/at0a\fR through
\fB/dev/at0d\fR; you will not be working with these, however, so you can
safely ignore them for now.
.PP
Note that the middle columns of the table give
the size of each partition in three ways:
in cylinders, in tracks, and in megabytes.
How do these differ?
Megabytes is the easiest to understand:
that the number of bytes that can be written into the partition.
Cylinders and tracks, however relate to the way a hard disk is built.
A moment spent here on background can make what is to come much easier
to understand.
.Sh "Cylinders and Tracks"
.PP
Consider a high-density floppy disk.
Its surface is organized into 80 concentric rings, or \fItracks\fR,
numbered 0 through 79.
Each track holds a fixed amount of data, with the amount
depending upon the density of the disk.
When the disk is in your disk drive, a \fIhead\fR
moves back and forth, reading tracks as directed.
Unlike a phonograph cartridge, however,
the head jumps from track to track discretely \(em it does not spiral in.
Thus, you can measure space on a disk simply by counting the tracks.
Note, too, that
the term \*(QLhead\*(QR is often used to describe one surface of a
multi-sided disk.
.PP
As you've probably noticed, a floppy disk has two surfaces:
the top and the bottom.
The top is usually refered to as side 0, the bottom as side 1.
Each surface has its own system of tracks, each numbered 0 through 79,
giving a floppy disk a total of 160 tracks.
Also, to read the disk a floppy disk drive actually has two heads,
one for each surface.
.PP
A \fIcylinder\fR is the set of identically numbered tracks from both
surfaces of the disk.
A floppy disk organizes its 160 tracks into 80 cylinders:
side 0 track 0 plus side 1 track 0 form cylinder 0; side 0 track 1
plus side 1 track 1 form cylinder 1, etc.
If you think of a track as being a ring on the disk, then origin of
the term \*(QLcylinder\*(QR should be obvious.
.PP
Now, consider a hard disk.
The term \*(QLhard disk\*(QR is somewhat incorrect, because one
hard disk actually contains many hard disks, or \fIplatters\fR,
inside itself.
The platters are stacked on a spindle, much like a set of 45-rpm
records stacked on a record changer \(em except that heads move
between the platters, one head for each platter surface (or two per
platter).
The number of platters and the number of tracks on each platter determine
both the number of cylinders and the amount of data that can be written to
the disk.
Consider the disk described in the above table, which is a fairly
typical device.
It has three platters (six heads).
Each head has 615 tracks, each of which holds 8,704 bytes.
Thus, the device has a total of 3,690 tracks (6 times 615), organized into
615 cylinders, with each cylinder holding 52,224 bytes (6 times 8,704).
.PP
Different operating systems organize disk partitions in different ways.
MS-DOS, for historical reasons, organizes partitions along track boundaries;
under this scheme, the tracks of a cylinder can
be divided between two partitions.
UNIX, COHERENT, and similar operating systems prefer to organize partitions
along cylinder boundaries:
all of the tracks of a cylinder belong to only one partition.
This lessens movement of the heads, which in turn speeds up reading of the
disk.
Note that, strictly speaking, \*(QLmegabytes\*(QR has no meaning when
thinking about disk partitioning:
partitioning must be done either in tracks, or in cylinders.
Humans tend to think of partitions in terms of megabytes, that is, in terms
of the amount of data we can write into a partition, but when organizing your
disk it is much easier to think in terms of cylinders.
However, it is simple to translate cylinders into megabytes, which gives
you the best of both worlds; this will be discussed in the following
sub-section.
.Sh "Partitioning the Disk"
.PP
When you enter the partitioning phase of installation, the installation
programs will display the configuration of your hard disk for you, using
a table like the one shown above.
It then displays the following menu:
.DM
	Possible actions:
	   0 = Quit	
	   1 = Change active partition (or make no partition active)
	   2 = Change one logical partition
	   3 = Change all logical partitions
	   4 = Delete one logical partition
	   5 = Change drive characteristics
	   6 = Display drive information
	   7 = Proceed to next drive
.DE
Before we discuss what these options do, note that you must
.I not
alter the
.I size
of an MS-DOS partition using any of the above options.
You must install COHERENT into
.I all
of an MS-DOS partition,
or into any part of the drive that has space unallocated to MS-DOS.
Changing the
.I size
of an MS-DOS partition at this point, to make room for COHERENT,
will invalidate the MS-DOS partition table, may corrupt MS-DOS data, and
may make it unbootable from the hard drive.
If you do wish to change the
.I size
of an MS-DOS partition, abort installation of COHERENT, back up all of your
MS-DOS data, use the MS-DOS version of
.B fdisk
to change the layout of your hard disk, restore your MS-DOS data, and only
then install COHERENT.
.PP
The following describes each option in detail.
.RS
.IP 0. 0.3i
Option 0 is self-explanatory.
.IP 1.
The \fIactive partition\fR is the partition that the bootstrap
program reads by default.
When a partition is made the active partition, the operating system mounted
on that partition is booted automatically when your turn on your computer.
This option allows you to change the active partition,
or to designate \fBno\fP active partition,
in which case the computer will prompt you at boot time
for the partition number to boot.
You will need this option only if your hard disk has more than one logical
partition, and the partitions contain different operating systems.
Note that if later you wish to change the active partition, you can use the
COHERENT command \fBfdisk\fR to do so.
See the Lexicon entry on \fBfdisk\fR for details.
.IP 2.
This option lets you change one logical partition \(em in effect, it lets
you select a logical partition for COHERENT.
You should use this option if your hard disk has more than one partition
and you wish to install COHERENT on only one of them.
The partition you select must hold at least ten megabytes.
Note that the contents of the partition will be deleted.
.IP 3.
This reconfigures the entire disk.
You can reset the number of partitions, and the size of each.
.IP 4.
Option 4 is self-explanatory.
.IP 5.
This option allows you to change the drive parameters
associated with each drive on your system.
.IP 6.
Give summary information about the disk.
.IP 7.
This option will only appear if you have more than one hard disk drive.
Use this option to select the next hard disk drive.
.PP
Begin by entering option 6, to receive more information about your disk.
The following display gives the display for the hard disk described in
the above table:
.DM
	Drive 0 has 615 cylinders, 6 heads, and 17 sectors per track.
	It contains:
		615 cylinders of 52224 bytes each,
		3690 tracks of 8704 bytes each,
		62730 sectors of 512 bytes each
	or a total of 32117760 bytes (32.12 megabytes).
.DE
If the owner of this hard disk wanted to organize his hard disk by
megabytes, all he would have to do is divide 1 million by 52,224 to find
that one megabyte is approximately equal to 20 cylinders; thus, to make
a ten-megabyte partition, he would assign it 200 cylinders.
The size of a cylinder may be different on your system, but the principle
is the same.
.PP
The next step depends on two factors:
the current organization of your hard disk, and the amount of space you
wish to give to COHERENT.
The current limit for a COHERENT partition is 95 megabytes,
but 70 to 80 megabytes is more realistic.
If your disk has only one logical partition, you must use option 3
to create at least one new logical partition.
If your disk already has more than one logical partition, you can
use option 2 to assign one to COHERENT
or use option 3 to assign more than one,
reserving the rest for your current operating system.
Of the partition(s) that you assign to COHERENT, one must hold at least
ten megabytes \(em you cannot use two five-megabyte partitions;
thus, if no partition on your disk holds ten megabytes, you must use option 3.
.PP
How much space should you give COHERENT?
COHERENT is a multi-user, multi-tasking operating system; the more space
you assign to it on your disk, the more users and the more processes it
can support.
COHERENT, via UUCP and other communications programs, also gives you access to
information on other COHERENT and UNIX systems throughout the world; you will
want to exchange mail with other users and possibly download news and
information.
All of this takes up space.
You must have one ten-megabyte partition to hold COHERENT's root file system
(that is, the file system that holds the files that make COHERENT go), and
you would be well advised to assign at least one more partition of at least
half the size to hold users' accounts and
their files.
.PP
If you have a large disk drive that is organized into one partition
that you wish to assign to COHERENT, you are well advised to divide it
into two smaller partitions.
For example,
if you wish to allocate 40 megabytes to COHERENT, you should
create two 20-megabyte partitions rather than one 40-megabyte partition.
In addition, if you anticipate wanting to perform a full restore
of a dumped root partition, you are well advised to have a spare
COHERENT partition in addition to the root partition.
An alternative strategy would be to boot from the COHERENT Boot diskette
and then restore your root partition.
This assumes that the device you dump and restore from is different
than your boot floppy!
.PP
The following two sub-sections describe what happen when you invoke options
2 or 3.
.Sh "Changing One Logical Partition"
.PP
You will first be asked which partition you wish to change.
Reply by entering the partition you want.
The system replies with the following text:
.DM
	Existing data on a partition will be lost if you change
	the base or the size of the partition.  Be sure you have
	backed up all data from any partition which you are going
	to change.
.sp \n(pDu
	You may specify partition bases in cylinders or in tracks.
.DE
Reply \*(Qly\*(Qr, to use cylinders.
The system then asks:
.DM
	You may specify partition sizes in cylinders or
	in megabytes.
.DE
Reply \*(Qly\*(Qr, again to use cylinders.
Next, the system says whether the partition is initialized to MS-DOS
or is unused.
It then asks you whether you wish to install COHERENT into the partition,
leave the partition unchanged, or mark the partition as unused.
You must select one of these possibilities:
\fBinstall\fR cannot install any operating system other than COHERENT
into a partition.
To install COHERENT into this partition, reply \*(Qly\*(Qr when asked if you
want this to be a COHERENT partition.
.PP
The final two questions ask you to enter the new base cylinder for the
partition and the size of the partition in cylinders.
Each question will prompt you with the current value for the partition.
Simply pressing \fB<return>\fR would leave this current value unchanged.
It is possible to make the partition smaller, but this serves no
practical purpose if you simply intend to install COHERENT into this
partition.
.PP
If you have made a mistake during this process, the system will prompt
you and ask you to correct it.
Otherwise, you will proceed to the next phase of installation, which is
to scan for bad blocks (described below).
.PP
One last word of warning:
you should \fInever\fR use the COHERENT version of \fBfdisk\fR to change
the size of an MS-DOS partition.
Use it to change the size of an unused partition, or of a partition that
contains an operating system other than MS-DOS; these include COHERENT
itself.
If you wish to change the size of an MS-DOS partition, back up all data
in that partition, then use the MS-DOS version of \fBfdisk\fR.
.Sh "Changing All Logical Partitions"
.PP
This process mirrors what occurs when only one partition is changed,
except that it is iterated for every existing partition.
If you have four partitions and wish to eliminate one, simply set its
size to zero.
If you have fewer than four partitions, you will be asked if you wish
to create any additional ones.
.PP
Note one additional feature:
the table that displays the layout of partitions (an example of which is
shown above) is redisplayed after every partition, showing the changes
you have made (if any).
By looking at the table, you will find it easy to keep straight just what
you have done \(em when you work with this table, you will see the value of
working in cylinders.
.PP
If you make a mistake, the system will prompt you to correct it.
A common error is requesting overlapping partitions \(em that is,
setting the base cylinder of a partition within an area already
allocated to another partition.
Another error would be to request an impossibly large partition.
.PP
It is strongly recommended that you \fInot\fP include the last
cylinder of your hard disk in any partition.
This cylinder is often used by diagnostic programs, and, as such,
is not available for general use.
.PP
This concludes the discussion of partitioning the disk.
The system will then move to the next phase of installation.
.SH "Scanning for Bad Blocks"
.PP
When a partition on an MFM, RLL or IDE interface disk drive
is assigned to COHERENT, it must be scanned for
bad blocks.
(The terms \fIblock\fR and \fIsector\fR are often used
interchangeably.)
Most hard disks have at least a few blocks in which the disk's surface
is flawed and therefore cannot be trusted to hold data reliably.
Note that scanning is not required on SCSI interface devices.
.PP
COHERENT keeps a list of bad blocks for each partition, to ensure
that it does not write data into an unreliable area.
This checking is performed automatically, but takes a few minutes.
Patience is recommended.
.SH "Creating COHERENT File Systems"
.PP
Once COHERENT has created a list of bad blocks, it can generate a
file system for each of the partitions that you have assigned to it.
One partition must be assigned the root file system; the root file
system is the one that holds the files owned by COHERENT itself,
the files that make the system go.
If you are
assigning more than one partition to COHERENT, you will be asked
which you want to hold the root file system.
.SH "Mounting File Systems"
.PP
The next step is to mount the file system assigned to the physical
partition.
You are not required to mount any file system except the root file
system, although for most purposes there is no reason not to mount
a file system that you have created.
The system will ask you to assign a name to each file system.
For historical reasons, a file system is usually given the name of a single
letter from the end of the alphabet, such as \*(Qlv\*(Qr
or \*(Qlx\*(Qr, although there's no reason not to name a file system
\*(Qlwork\*(Qr or \*(Qlusr\*(Qr.
Each name must be preceded by a slash \*(Ql/\*(Qr.
.SH "Rebooting"
.PP
Now that partitions have been allocated and file systems have
been created and mounted,
the next step requires that COHERENT be booted from the hard disk.
If you have elected to use the COHERENT bootstrap, and if you have
the COHERENT boot partition the active partition, all you have to do is
remove the \fBBoot\fR disk from the floppy-disk drive when
prompted, and then reset your computer.
.PP
If you have made an MS-DOS partition the active partition, you must
perform one additional step:
type the number of the partition that holds the COHERENT root file
system as the system is attempting to access the floppy disk for the
bootstrap program.
The number must be typed from the numeric keys at the top of the keyboard,
\fInot\fR from the keypad.
Before it begins the rebooting process, the system
will tell you which number to press.
.PP
You can reconfigure the bootstrap at any time after installation.
For more information on booting, see the Lexicon article
.BR boot .
.SH "Copying Files"
.PP
If rebooting occurs correctly,
you will then be running COHERENT off of the hard disk.
Now comes the event for which all of this preparation has occurred:
the system copies the COHERENT files onto your hard disk.
The system will prompt you to insert the three remaining disks that hold
the COHERENT files, one after the other.
.PP
The system will ask you whether you want the full set of manual pages
on line in uncompressed form, and whether you want the dictionaries used
by the COHERENT spelling checker also in uncompressed form.
These files must be uncompressed before they can be used, but take up
much more room on the disk.
You must decide whether the extra convenience of having on-line manual
pages and a spelling checker is worth the extra space they require.
.SH "Touring the COHERENT File System"
.PP
Finally, for the last step in installation the system will ask you if
you wish to take a tour of the COHERENT file system.
We suggest you answer yes, for this is the best way to become familiar
with the layout of your newly installed COHERENT system.
.PP
And with that, the installation of COHERENT is finished!
.PP
If at some later time you wish to review the tour, simply run
\fB/etc/coh_intro\fP.
.SH "In Case of Difficulty"
.PP
As we mentioned earlier, tens of thousands of users have
successfully installed COHERENT onto their computers.
Most encountered no difficulties whatsoever during installation;
chances are you will not encounter any either.
If problems do arise, however, the Mark Williams support staff will gladly
help you.
Before you call, however, be sure to check the following sub-sections.
They describe many of the more commonly encountered problems,
and gives advice on how to overcome them.
If your problem is not covered in this chapter \(em or if you've tried
what it suggests and it does not work \(em call Mark Williams.
Information about contacting Mark Williams Technical Support is given in
the introduction to this pamphlet.
.Sh "Are you booting COHERENT Disk 1 via <ctrl-alt-del> (warm boot)?"
.PP
It may help to cold boot your system;
turn power off, wait at least 30 seconds, then turn power back on.
Rebooting via cold boot is more resistant to
getting a virus from something you have already loaded, and avoids
a family of bugs in the AMI BIOS, MS-DOS, and Windows that relate
to warm boots.
.Sh "Do you have a defective RAM chip?"
.PP
We have seen cases in which computers go through normal startup and
even run MS-DOS without difficulty, but give panic errors or stack
overflow errors randomly when running in protected mode.
Weak memory chips and some defective or poorly designed
motherboards can be found by
running a thorough, protected-mode diagnostic program on memory,
then replacing all defective parts that it discovers.
.Sh "Are you running in Turbo mode?"
.PP
Sometimes customers, especially those experiencing panic traps, can
install when they change processor speed.
Although the improvement, when it occurs, usually happens when the CPU
is slowed down, we have seen one case where it helped to speed up the processor.
In general, panics that vanish or significantly change their pattern of
appearance when CPU speed is changed, strongly suggest that the problem
is due to a poorly designed or incompatible motherboard (see below).
.Sh "Will it help to change the master boot procedure?"
.PP
If you are having trouble selecting the partition your computer boots from,
it may help to modify the master boot sequence, as follows.
(1) Use the command
.B /etc/fdisk
to select \fIno\fR active partition, or,
during startup, hold down the key corresponding to the root COHERENT
partition (over the alpha keyboard, \fInot\fR on the numeric keypad) until
startup halts with a keyboard error.
(2) Press \fB<F1>\fR to continue.
Boot should progress to COHERENT.
.Sh "Is CMOS configured correctly for drive A?"
.PP
Some customers who ordered the wrong size of diskettes
switched floppy-disk drives A and B,
but failed to update the setup for the computer.
This often produces an error message of the form
.DM
	fsminit:  no root dev (4,14)
.DE
The solution is to configure the CMOS correctly.
See your computer's technical documentation for details on how to do this.
.Sh "Do you have an incompatible hard-drive controller?"
.PP
If you have a Western Digital controller model WD1006V-SR2 and it is a
Feature 3 board, you may need to replace it.
Some of these controllers have defects that cause them to latch up.
.PP
If you have a Western Digital controller model WD1006V-SR2 and it is a
Feature 5 board (Feature 5 boards have all the
jumper headers installed), install
the ``non-latched'' mode jumper, which is the first one (J1).
.PP
If you have an old machine such as an IBM XT-286, you may have an eight-bit
XT controller rather than a 16-bit AT controller.
The eight-bit XT controllers are not compatible with COHERENT.
.PP
The following Western Digital controller types are eight-bit XT devices,
and are therefore incompatible with COHERENT:
.DS
	1004-27X
	1004-WX1
	1002-anything
	XTGEN, XTGEN+, XTGEN-2, XTGEN-R
.DE
In any case, please contact Mark Williams Technical Support
with the make and model of the controller.
It may lead us to a new pattern that we can accommodate.
Some customers have Perstor, IDE, ESDI, or SCSI controllers
and did not know it until they checked the controller type;
there are known compatibility issues
with some controllers of all the above types.
.Sh "Do you have incompatible hard-drive parameters?"
.PP
If you were
.I unable
to install COHERENT,
check the contents of \fBCONFIG.SYS\fR from the MS-DOS
root directory on drive C.
If you find one of the following \fBDEVICE=\fR entries there
that configures the hard drive,
it may be an indication that your hard disk layout is non-standard.
However, many users of the following device drivers have successfully
installed COHERENT, so please be sure that you have attempted installation
\fIprior\fR to contacting Mark Williams Technical Support.
.DS
	DMDRVR.BIN
	EDVR.SYS
	SSTOR.SYS
	HARDRIVE.SYS
	FIXT_DRV.SYS
.DE
Before you call,
note your hard-drive's make, model number and
parameters (i.e., number of heads, cylinders,
and sectors per track) from the documentation supplied with the hard drive.
Most drives are configured with 17 sectors per track when used with
MFM encoding, 26 sectors per track with RLL encoding, and 31 sectors per
track with Perstor controllers.
Check these parameters against what is in the CMOS setup:
CMOS specifies parameters by storing the drive type number, which
specifies an entry in the BIOS disk parameter table.
If there is a setup program in the BIOS, it may give drive parameters
explicitly;
or, it may be necessary to look up the entry in the manual for the BIOS.
.PP
If the number of cylinders is greater than 1,024, you may have an incompatible
drive:
the standard PC partition table format does not allow cylinder numbers
greater than 1,024.
However, some disk controllers and most IDE drives
support a ``translation mode'' that allows them to
operate with BIOS parameters that do not match the actual parameters of
the disk drive (i.e., physical drive geometry).
For example, the following table lists the physical and translation mode
parameters for the Western Digital WD93044-A IDE drive:
.DS
.ta 0.5i 1.5i 2.5i
.I
		Physical	Translation
.ft R
	Cylinders:	782	977
	Heads:	4	5
	Sectors:	27	17
	Landing Zone:	862	977
.DE
The Adaptec 2372 and Western Digital 1006V-SR2 series controllers
simulate the presence of valid drive parameters when the drive type is set
to \*(Ql1\*(Qr in the system setup.
With these controllers, it is possible to install COHERENT when the drive
parameters do not correspond to any drive type in the BIOS, but you must
be sure to set the drive type to \*(QL1\*(QR in the CMOS setup.
.PP
Some instances of incompatible hard drives do not permit installation of
older releases of COHERENT, but do allow version \*(VN to be installed.
In version \*(VN, drive parameters can be entered manually from the keyboard
during installation.
.Sh "Do you have an incompatible keyboard?"
.PP
If you are experiencing problems with respect to key mappings,
and you installed one of the loadable keyboard mapping tables
from the keyboard selection menu,
you may have an incompatible keyboard.
Please note that the COHERENT
.B nkb
driver (and loadable tables) only work with well-engineered
keyboards, such as those built by IBM, Cherry, MicroSwitch, or Keytronic;
when used with an inferior ``clone'' keyboard, it may not work correctly.
If you wish to use an incompatible keyboard with COHERENT,
you will need to re-install COHERENT and specify one
of the keyboard entries marked
.B "not loadable"
from the keyboard menu.
.PP
Most of the incompatible keyboards exhibit one or more of the
following symptoms:
.PP
	\(bu SHIFT, CONTROL, or CAPS LOCK keys are transposed
.br
	\(bu CAPS LOCK, NUM LOCK, or SCROLL LOCK keys do not function
.br
	\(bu the system hangs when trying to load the keyboard mapping table
.PP
If your keyboard works correctly except for one key, such as the key
containing the `\fB|\fP' or the '\fB\e\fP', you only need update
the keyboard mapping table for your particular keyboard layout.
See Lexicon articles
.B nkb
and
.B "keyboard tables"
for further details.
.Sh "Do you have an incompatible video board?"
.PP
If you are using a Zenith Z449 series CGA/VGA video adapter and are
experiencing panic traps, there is a known defect in this board.
Contact Zenith Data Systems, or try a different video board.
.PP
Some (unlabeled) monochrome boards do not work in protected mode.
Symptoms include immediate panic or loss of video when booting from disk 1.
If possible, try exchanging video boards.
.Sh "Do you have a system incompatible with the MWC master boot program?"
.PP
The Mark Williams master boot program is known \fInot\fR to work with
certain Zenith 241- and 248-series computers using Zenith's BIOS.
It should be possible to install and run COHERENT as long as the master boot
program is \fInot\fR used.
.Sh "Do you have an incompatible clock device?"
.PP
If the install process fails when trying to set the system time and date
(\fBATclock\fR failure), please contact Mark Williams Technical Support.
.PP
It is common to see an
.B ATclock
failure when a computer has less than megabytes of RAM.
If you have less than 640 megabytes of RAM, you should upgrade your memory.
Not only will the clock problem be solved, but your system's performance
will improve as well.
.Sh "Is your system extremely slow?"
.PP
If you are running COHERENT on a SCSI disk drive and your system
is running very slowly,
odds are that your host adapter is not correctly configured.
Some non-COHERENT systems ``busy wait'' the host adapter
when performing SCSI I/O.
Since COHERENT is a multi-tasking, multi-user system, it requires
the use of interrupts to signal when the host adapter
has completed an I/O operation and is ready for the next request.
If your host adapter is not correctly configured, it may not
be asserting the correct interrupt, or it may not be asserting
any interrupt.
Please check the jumpers on your host adapter to verify that
the correct interrupt is being asserted.
If you have further questions, see Lexicon articles
.B aha154x
and
.B ss
for further details, or contact the hardware manufacturer.
.Sh "Do you have an incompatible system?"
.PP
If you have problems that cannot be helped by any of the above, 
then your computer system may not be capable of running COHERENT.
Note that it is possible for a system that cannot run COHERENT to be
made up entirely of components known to work on other systems running COHERENT.
The greatest number of these cases is seen with customers running
an AMI BIOS, IDE hard drives, or any kind of DTK motherboard.
Please record as much information as possible about make and model of
motherboard, BIOS, hard drive controller, hard drive, and all other equipment
installed; then contact Mark Williams Technical Support.

.II "m4^tutorial"
.ds TL "m4 Macro Processor"
.NH "Introduction to the m4 Macro Processor" 1
.PP
.B m4
is a macro processor for the \*(CO system.
It is a powerful and flexible text processing tool.
You can tell it, with a great degree of generality,
to search for macro names and replace them with other strings.
Macros can also take arguments.
.PP
.II 4GL
.II "fourth-generation language"
.B m4
provides a useful front end for programming languages such as
fourth-generation lanaguages (4GLs)
which commonly have no built-in macro facility.
.B m4
also has powerful facilities for manipulating files,
making decisions conditionally,
selecting substrings, and performing arithmetic,
so it is useful for processing forms.
.PP
The command
.DS
	\fBm4\fR [ \fIfile\fR ... ]
.DE
invokes \fBm4\fR.
\fBm4\fR reads each \fIfile\fR in the order given on the command line;
if no \fIfile\fR is given, \fBm4\fR reads from the standard input.
The \fIfile\fR `\-' also indicates the standard input;
this allows you to perform interactive input while
.B m4
is processing files.
.B m4
reports any
.I file
that it cannot open, and eliminates it from the input stream.
.PP
.B m4
writes its output to the standard output stream.
As with other \*(CO commands,
the optional output redirection specification \fB>\fIoutfile\fR
on the command line redirects the output into
.I outfile.
To leave
.BR m4 ,
type
.BR <ctrl-D> .
.Sh "Definitions and Syntax"
.PP
.B m4
reads text one line at a time from its input stream.
When it reads a line of text, it scans the line for a macro
that you have defined.
A legal macro name is a string of alphanumeric characters
(letters, digits, underscore `_'), the first of which is not a digit.
.B m4
recognizes the macro name only if it is surrounded by
nonalphanumeric characters (i.e., spaces or newline characters)
on both sides.
.PP
When
.B m4
finds a macro, it removes it from the input stream and
replaces it with its definition.
It then writes the resulting modified text (called
\fIreplacement text\^\fR), onto the input stream.
.B m4
then reads another line from the input stream, and continues processing.
.PP
.II "m4^quoted text"
.II "m4^unquoted text"
Text that is contained within single quotation marks is quoted
(i.e., is contained between
a grave mark \(ga on the left and an apostrophe \' on the right).
All other text is \fIunquoted\fR.
.B m4
searches only unquoted text for macros.
.PP
A
.I "macro call"
can be either a macro or a macro immediately followed by a set of
arguments:
.DM
	macroname(arg1, ..., argn)
.DE
A set of arguments must start with a left parenthesis
that follows the macro immediately (i.e., no space can come between
the macro and the left parenthesis).
The entire argument set must be enclosed by balanced, unquoted parentheses:
parentheses may appear within the text of an argument, but they must
always come in balanced pairs.
A single left or right parenthesis may be passed
by quoting it, e.g. \(ga\^(\^\' or \(ga\^)\^\'.
.PP
Arguments are separated by commas
that are neither within apostrophes nor
within an inner set of unquoted parentheses.
.B m4
strips from each argument all leading unquoted spaces, tabs, and newlines.
It processes the text of each argument in the same manner that it
processes ordinary text; that is,
it removes, evaluates, and replaces any recognized macro calls
.I before
it stores the argument text
for possible use within the replacement text.
If you wish
to pass a macro name or an entire macro call as an argument, it must be quoted.
.B m4
stores the values of the first nine arguments for possible use
in the replacement text.
It processes arguments after the ninth, but throws away the results.
.PP
.II "m4^nestable quotes"
.II "m4^quote marks^removing"
.B m4
does not search quoted text for macros.
Instead, it removes the quotation marks and copies the text to the
standard output unchanged.
Quotes can be nested; that is, quoted text can contain other blocks
of quoted text.
.B m4
removes only the outermost level of quotation marks
each time it reads a piece of quoted text.
This aids in delaying macro expansion in text
until the second (or later) time the text is read by
.BR m4 .
.PP
.B m4
includes numerous predefined macros,
which perform various functions.
The remainder of this document describes the predefined macros in detail.
The Lexicon entry for
.B m4
summarizes each predefined macro.
.Sh "Defining Macros"
.PP
.II "m4^define"
The macro
.DM
	define(\(ganame\', \(gadefinition\')
.DE
defines a macro
.I name
and its replacement text
.IR definition .
.B m4
replaces every subsequent unquoted occurrence of
.I name
with
.IR definition ,
as described above.
For example, the
.B m4
input
.DM
	define(\(gaher\', \(gaCOHERENT\')
	To know, know, know her
	Is to love, love, love her ...
.DE
produces the output
.DM
	To know, know, know COHERENT
	Is to love, love, love COHERENT ...
.DE
.I name
should usually be quoted.
If it is not quoted and it is being redefined,
.B m4
sees its old
.I definition
as the first argument to
.BR define ,
which will not have the intended effect.
Similarly,
.I definition
should be quoted if the macro names that occur in it should not be replaced.
.PP
Any legal macro name may be the first argument of a
.BR define .
If you redefine a predefined macro,
its original function is lost and cannot be recovered.
.PP
.II "m4^macro name recognition"
As noted above,
.B m4
recognizes a macro name only if it is surrounded by non-alphanumeric
characters.
For example,
.DM
	define(\(gaher\', \(gaCOHERENT\')
	Coherent software is reliable software.
.DE
produces the output
.DM
	Coherent software is reliable software.
.DE
.B m4
does not recognize the characters
.B her
in the word
.B Coherent
as a macro name.
.PP
The value of the
.B define
macro is the null or empty string (the string which contains no characters).
In other words,
.B m4
puts nothing (the null string) back on its input stream when it processes a
.B define
call.
.PP
.II "m4^argument"
Like predefined macros, user-defined macros may take arguments.
.B m4
replaces the string
.I $n
in the macro definition with the value of the \fIn\fRth argument,
where
.I n
is a digit (1 to 9).
It replaces $0 with the macro name.
If the argument set contains fewer than
.I n
arguments,
.B m4
replaces
.I $n
with the null string.
.B m4
uses functional notation to specify argument sets.
Unlike a normal function, however, an
.B m4
macro does not require a fixed number of arguments.
The same macro may be called with or without an argument set,
or with argument sets containing different numbers of arguments.
.PP
.II "m4^argument substitution"
The following macro concatenates its arguments:
.DM
	define(\(gacat\', $1$2$3$4$5$6$7$8$9)
.DE
Then
.DM
      cat(one, \(gatwo\', \(ga\(gathree\'\', \(gafour, four \',
          five(also,),,seven)
.DE
becomes
.DM
	onetwothreefour, four five(also,)seven
.DE
A more complex definition is:
.DM
	define(\(gacomma\', \(ga\(ga$0 (which looks like \(ga,\')\'\')
.DE
This turns each subsequent unquoted occurrence of
.DM
	comma
.DE
into
.DM
	comma (which looks like \(ga,\')
.DE
Two sets of quotation marks around the replacement text are necessary.
When
.B m4
reads this call to macro
.BR define ,
the resultant argument text is:
.DM
	comma
.DE
for the \fIname\fR and
.DM
	\(ga$0 (which looks like \(ga,\')\'
.DE
for the \fIdefinition\fR.
When
.B m4
sees the text
.DM
	comma that is not quoted
.DE
it evaluates and replaces the now-defined macro name
.B comma
to produce the text
.DM
	\(gacomma (which looks like \(ga,\')\' that is not quoted
.DE
on the \fIinput\fR stream.
Because
.B comma
appears inside a set of quotation marks,
.B m4
does not treat it as a macro name.
For the same reason, the string `,' also passes through unmodified.
The final output is:
.DM
	comma (which looks like \(ga,\') that is not quoted
.DE
.II "m4^dumpdef"
When the predefined macro
.B dumpdef
is used without arguments,
it returns the names and definitions of all defined macros.
For each macro, it returns its quoted name, a tab character,
and then its quoted definition;
no definition is given for a predefined macro.
When used with arguments,
.DM
	dumpdef(name)
.DE
returns the quoted definition of each macro name that
appears as an argument.
.PP
.II "m4^undefine"
The predefined macro
.DM
	undefine(\(ganame\')
.DE
removes a macro definition.
As noted for
.B define
above, the argument must be quoted to have the desired effect.
\fBundefine\fP ignores arguments which are not defined macro names.
The value of the
.B undefine
call is the null string.
If a predefined macro is undefined, its original function cannot be recovered.
.Sh "Input Control"
.PP
.II "m4^changequote"
The predefined macro \fBchangequote\fP
changes the quote characters.
For example:
.DM
	changequote( {, })
.DE
makes the quote characters the left and right braces.
It also removes the effect of the previously defined
quotation characters.
Missing arguments default to \(ga for open quotation and \'
for close quotation.
Thus, \fBchangequote\fP without arguments restores the
original quote characters \(ga and \'\^.
If the arguments are identical, the nesting ability
of quotation marks is temporarily lost.
Instead, the first instance of the new quote character turns on quoting
and the next instance turns off quoting.
The value of the
.B changequote
call is the null string.
.PP
.II "m4^dnl"
The predefined macro \fBdnl\fP
(delete to newline) ``eats'' all characters from the input stream
up to and including the next newline
and returns the null string.
It is particularly useful in a string of \fBdefine\fP macro calls.
Although
.B m4
replaces each
.B define
by the null string, newlines often separate macro definitions, and
.B m4
copies the newlines to the output stream unchanged.
Two ways of using
.B dnl
are:
.DM
	define(this, that)dnl
	define(something, else)dnl
.sp
	dnl(define(this, that), define(something, else))
.DE
.II "m4^extra newlines"
The first examples use \fBdnl\fR without arguments.
The final example uses
.B dnl
with an argument set, which
.B m4
processes (performing each
.BR define )
and subsequently ignores.
The following section describes an alternative
(and generally preferable)
method of eliminating extraneous newlines in a
sequence of \fBdefine\fP calls.
.PP
.II "m4^decision-making macro"
.II "m4^ifdef"
.B m4
includes two decision-making macros:
.B ifdef
and
.BR ifelse .
.PP
.B ifdef
checks whether a macro is defined.
It has the following form:
.DM
	ifdef(macro,defvalue,undefvalue)
.DE
If
.I macro
is defined,
.B ifdef
returns
.IR defvalue ;
otherwise, it returns
.IR undefvalue .
.PP
.B ifelse
compares pairs of arguments.
It has the following form:
.DM
	ifelse(arg1,arg2,arg3, ... , arg9)
.DE
.B ifelse
compares
.I arg1
with
.IR arg2 .
If they are the same,
it returns
.IR arg3 .
If not, and if
.I arg4
is the last argument, it returns
.IR arg4 .
Otherwise, it repeats the process, comparing
.I arg4
with
.IR arg5 ,
and so on.
Like other
.B m4
macros, this takes a maximum of nine arguments.
.PP
.II "m4^sinclude"
In addition to each
.I file
specified in the command line,
any other accessible file may be included in the input stream
with the predefined macro
.DM
	include(file)
.DE
.II "m4^include"
.B m4
replaces this macro call on the input stream with the entire
contents of the specified
.IR file .
If
.I file
cannot be accessed, \fBinclude\fP causes a fatal error;
.B m4
prints an error message and exits.
The alternative predefined macro
.DM
	sinclude(file)
.DE
functions exactly like
.BR include ,
except that it does not print an error message and stop processing if
.I file
is inaccessible.
.Sh "Output Control"
.PP
.II "m4^output stream"
.II "m4^divert"
.B m4
maintains ten output streams, numbered zero through nine.
Stream 0 is the standard output, where
.B m4
normally directs its output.
Streams 1 through 9 are temporary files.
The predefined macro
.DM
	divert(n)
.DE
diverts output away from stream 0,
appending it instead to stream
.IR n .
Any
.I n
outside the range 0 to 9 causes output to be thrown
away until the next \fBdivert\fP call.
.B divert
without any arguments or with a nonnumeric argument is equivalent to
.BR divert(0) .
The value of a
.B divert
call is the null string.
.PP
.II "m4^extra newlines"
The preceding section described the use of
.B dnl
to eliminate extraneous newlines on the output stream when
processing a sequence of
.B define
calls.
A more readable method of eliminating the newlines is to precede
the definitions with
.B "divert(\-1)"
and follow them with
.BR "divert" .
.B m4
then diverts the extraneous newlines to the nonexistent stream \-1.
.PP
.II "m4^undivert"
The predefined macro
.DM
	undivert(streams)
.DE
fetches text diverted to one or more temporary streams.
It appends the text from the specified
.I streams
in the given order to the
.I current
output stream.
.B m4
does not allow diverted text to be undiverted back to the same stream.
.B undivert
with no arguments undiverts all diversions in numerical order.
The value of
.B undivert
is the null string; undiverted text is
.I not
scanned for macro calls, but is simply moved from one place to another.
.B m4
automatically undiverts all diversions in numerical order
to the standard output (stream 0) at the end of processing.
.PP
To illustrate the use of
.B divert
and
.BR undivert ,
invoke
.B m4
and type:
.DM
	define(\(gacount', $1$2)
.DE
And to see what macro
.B count
does, type:
.DM
	count(one, three)
.DE
The output on the screen reads:
.DM
	onetwo
.DE
Now type:
.DM
	divert(1)
.DE
This diverts device 1 (the standard output)
into a temporary file.
Now type:
.DM
	count(one, three)
.DE
Nothing appears on the screen.
.B divert
sent the output of the macro
.B "count(one, three)"
into a temporary file.
Thus, the output is not lost, as you might have thought.
To demonstrate the existence of that output, type:
.DM
	divert
.DE
to reset the standard output to be the screen.
See for yourself.
Now, when you type
.DM
	count(one, four)
.DE
.B m4
replies on the screen:
.DM
	onefour
.DE
As you can see, the standard output is again directed to the screen.
To retrieve the diverted
output of
.BR "count(one, three)" ,
and send it to the screen, type:
.DM
	undivert(1)
.DE
which produces:
.DM
	onethree
.DE
.II "m4^divnum"
The predefined macro \fBdivnum\fP returns the current diversion number.
.PP
The predefined macro
.DM
	errprint(message)
.DE
sends the given
.I message
to the standard error stream.
.II "m4^errprint"
The value of \fBerrprint\fP is the null string.
.Sh "String Manipulation"
.PP
.II "m4^substr"
The predefined macro
.DM
	substr(string, start, count)
.DE
returns a substring of a string of characters.
The first argument
.I string
can be anything.
The second argument
.I start
is a number giving the starting position of the desired substring in
.IR string .
Position 0 is the leftmost character of
.IR string ,
position 1 is the next character to the right, and so on.
If
.I start
is negative, the orientation switches to the right.
Position \-1 is the rightmost character of
.IR string ,
position \-2 is the character to its left, and so on.
The third argument
.I count
specifies the length and direction of the substring.
Zero returns the null string.
A positive
.I count
returns a substring consisting of the character addressed by
.I start
and \fIcount\fR\-1 characters to the right of it.
A negative number does the same thing, but to the left.
If
.I count
is omitted, it is assumed to be of the same sign as
.I start
and large enough to extend to the end of
.I string
in that direction.
If
.I start
is omitted, it is assumed to be 0 if
.I count
is positive or omitted, or \-1 if
.I count
is negative.
For example:
.DM
	define(\^\(ga\^alpha\^\'\^, \(ga\^abcdefghijklmnopqrstuvwxyz\^\'\^)
	substr(alpha, , )
.DE
returns
.DM
	abcdefghijklmnopqrstuvwxyz
.DE
Here both
.I start
and
.I count
are omitted and are therefore assumed to be 0 and 26, respectively.
.DM
	substr(alpha, 0, 6)
	substr(alpha, , 6)
.DE
both return
.DM
	abcdef
.DE
Similarly,
.DM
	substr(alpha, , -6)
	substr(alpha, 21, )
.DE
both return
.DM
	uvwxyz
.DE
Finally,
.DM
	substr(alpha, -6, )
	substr(alpha, 0, 21)
.DE
both return
.DM
	abcdefghijklmnopqrstu
.DE
.PP
.II "m4^translit"
The predefined macro
.DM
	translit(string, characters, replacements)
.DE
transliterates single characters within a string.
It returns
.I string
with every occurrence of a character specified in
.I characters
replaced with the corresponding character from
.IR replacements .
If there is no corresponding character, \fBtranslit\fP
simply deletes the character.
For example:
.DM
	define(liquorjugs, \(gapack my box with five dozen liquor jugs')
	translit(liquorjugs, aeiou, 1234)
.DE
returns:
.DM
	p1ck my b4x w3th f3v2 d4z2n l3q4r jgs
.DE
.Sh "Numeric Manipulation"
.PP
.B m4
can simulate the long integer variables typical of most programming languages
by using
.B define
as the assignment operator.
Whenever the defined macro name appears unquoted,
.B m4
immediately replaces it by its numeric value.
.PP
.II "m4^incr"
.II "m4^decr"
The predefined macros \fBincr\fP
and \fBdecr\fP return their argument incremented or decremented by 1.
Thus,
.DM
	define(\(gax\', 1234)
	incr(x)
.DE
returns:
.DM
	1235
.DE
Note that
.B incr
and
.B decr
do not change the value of the simulated variable
.BR x ,
or of any other variable.
They return only that value plus or minus 1;
.B x
itself retains its value of
.BR 1234 .
.PP
.B incr
and
.B decr
initialize to zero all arguments that are omitted or not a valid number.
Thus, the example
.DM
 	incr(a34/87)
.DE
returns
.BR 1 ;
but
.DM
	incr(123.67)
.DE
returns
.BR 124 .
As you can see,
.B incr
truncates floating-point numbers.
The same applies to a variable that you have
.BR define d
to have a floating-point value.
.PP
.II "m4^eval"
.II "m4^expression evaluation"
More generally, the predefined macro
.DM
	\fBeval\fR(\fIexpression\fR)
.DE
evaluates an integer-value arithmetic
.I expression
and returns the resulting value.
The operators available, in order of decreasing precedence, are:
.DS
.ta 0.5i 2.0i
	( )	Parentheses for grouping
	+ \-	Unary plus, negation
	^ **	Exponentiation
	* / %	Multiplication, division, modulus
	+ \-	Addition, subtraction
	> < >= <= == !=	Comparisons
	!	Logical negation
	&& &	Logical and
	|| |	Logical or
.DE
.II "m4^eval"
The comparisons and logical operators return either 0 (false) or 1 (true).
\fBeval\fP performs all arithmetic in
.B long
integers.
.B eval
reports an error if its argument is not a well-formed expression.
.PP
.II "m4^string length"
The predefined macro
.DM
	\fBlen\fR(\fIstring\fR)
.DE
returns a numeric value corresponding to the length of
.IR string .
.PP
.II "m4^index"
The predefined macro
.DM
	\fBindex\fR(\fIstring\fR, \fIpattern\fR)
.DE
returns a numeric value corresponding to the first position where
.I pattern
appears in
.IR string .
If it does not appear, \fBindex\fP returns \-1.
Both
.I pattern
and
.I string
may be arbitrary strings of any length.
.PP
.II "m4^repeat"
The following example defines a macro \fBrepeat\fP
that repeats its first argument the number of times specified
by its second argument.
.DM
   define(\(garepeat\',
	\(gaifelse(eval($2<=0),1,,\(garepeat($1,decr($2) )'$1)')
.DE
.II "m4^ifelse"
.II "m4^eval"
The definition is recursive;  that is, \fBrepeat\fP
calls itself within its own definition.
The entire definition is quoted to defer the evaluation of \fBifelse\fP
from when
.B m4
encounters the definition to when it encounters a
.B repeat
macro call.
Similarly, the recursive
.B repeat
call is quoted to defer its evaluation within the
.BR ifelse .
\fBeval\fP checks if the first argument is less than or equal to 0;
if so, it returns 1 (true) and
.B ifelse
returns the null string.
.II "m4^decr"
Otherwise, \fBdecr\fP decrements the count,
so each successive recursive call has a smaller second argument,
and each call appends a copy of the first argument to the
previous result.
For example:
.DM
	repeat(\(gaHo! \',3)
.DE
produces
.DM
	Ho! Ho! Ho! 
.DE
From this example, you can see that the lowered value of the second
argument \(em generated by the macro
.BR decr \(em
is ``kept in mind'' successively.
Nevertheless,
.B decr 
and
.B incr
never change the value of a variable.
For example, consider:
.DM
	define(\(gaturns', 10)
.DE
We now have a variable called
.B turns
whose value is ten.
Typing
.DM
	repeat(\(gaHo! ', turns)
.DE
produces:
.DM
	Ho! Ho! Ho! Ho! Ho! Ho! Ho! Ho! Ho! Ho!
.DE
Within
.BR repeat ,
.B decr
lowered the current value of the second
argument (i.e., \fBturns\fR), until it becomes zero.
But when we type
.DM
	turns
.DE
we see:
.DM
	10	
.DE
As you can see, the value of
.B turns
remained ten, despite that variable's having been used in a
.B decr
statement.
.SH "COHERENT System Interface"
.PP
.II "m4^maketemp"
The predefined macro
.DM
	maketemp(string)
.DE
creates a unique file name for a temporary file.
.I string
is a six-character string that is normally initialized to \fBXXXXXX\fR;
.B maketemp
replaces all of the \fBX\fRs with a pattern of six numerals
that form a unique file name in the directory where temporary
files are being written.
It is the same as the C library routine
.BR mktemp .
It returns the null string if its argument is less than six characters long.
.PP
.II "m4^syscmd"
The predefined macro
.DM
	syscmd(command)
.DE
performs the given \*(CO
.I command
and returns the null string.
It is the same as the C library routine
.BR system .
.PP
A common use of
.B syscmd
is to create a file which
.B m4
subsequently reads with an
.BR include .
For example, to get the output from the \*(CO
.B date
command:
.DM
	define(\(gatempfile\', maketemp(/tmp/m4XXXXXX))
	define(\(gaget_date\',
		\(gasyscmd(date >tempfile)\'\(gainclude(tempfile)\')
.DE
In subsequent input,
.B m4
replaces each occurrence of
.B get_date
with the system date information.
The definition of
.B tempfile
is unquoted, so
.B m4
executes the
.B maketemp
call only once (when it processes the
.BR define ),
and it creates only one temporary file.
On the other hand, the definition of
.B getdate
is quoted, so
.B m4
executes
.B syscmd
and
.B include
to get the current time and date each time it processes a call to
.BR get_date .
The temporary file should be removed with
.DM
	syscmd(rm tempfile)
.DE
at the end of the
.B m4
program.
.PP
The following example is more complex.
It defines a macro
.BR save ,
which appends a macro definition to a file:
.DM
	define(\(gasave',\(gasyscmd(\(gacat>>$2 <<\e#
	define(\(ga$1\',\'dumpdef(\(ga$1\')\(ga)
	#
	\')\')
.DE
The arguments to
.B define
are the
.I name
.DM
	save
.DE
and the
.I definition
.DM
	syscmd(\(gacat >>$2 <<\e#
	define(\(ga$1\',\'dumpdef(\(ga$1\')\(ga)
	#
	\')
.DE
(Note that the body of macro
.B syscmd
uses the shell operator \fB<<\fR to create a ``here document''.
For more information on here documents, see the tutorial
\fIIntorducing sh, the Bourne Shell\fR.)
A typical call of this macro is:
.DM
	save(\(gasample\',\(gadefs.m4\')
.DE
which saves the macro definition of
.B sample
in a \*(CO file
.B defs.m4
containing macro definitions.
.II "m4^dumpdef"
When
.B m4
processes this call, the argument of
.B syscmd
becomes
.DM
	cat >>defs.m4 <<\e#
	define(\(gasample\',
.DE
followed by the definition of
.B sample
returned by \fBdumpdef\fP, followed by
.DM
	)
	#
.DE
.II "m4^syscmd"
Then \fBsyscmd\fP executes the \*(CO
.B cat
command to append the here document delimited by #
to the macro definition file
.BR defs.m4 .
The leading # delimiter of the here document is quoted with \e
to prevent interpretation by the \*(CO shell.
Because
.B save
uses the character # to delimit the here document,
it does not work correctly for macro definitions containing #.
For example,
.DM
	save(\(gasave\',\(gadefs.m4\')
.DE
does not work as expected.
.PP
Note that you can only use
.B save
when you run
.B m4
interactively \(em you cannot use it in a script.
Furthermore,
.B save
does not always save a definition literally.
For example:
.DM
	save(\(gatempfile', \(gadefs.m4')
.DE
saves the
.B tempfile
definition in
.B defs.m4
as:
.DM
	define(\(gatempfile', \(ga/tmp/m400074a') #
.DE
where, as you can see, the
.B XXXXXX
has been replaced with a hexadecimal number
(which may differ from the one you ).
Likewise, the definition of
.B get_date
will look like this:
.DM
	define(\(gaget_date', \(gasyscmd(date >tempfile)include(tempfile)') #
.DE
To load a saved definition into
.BR m4 ,
simply type
.B m4
at the shell's command-line prompt to invoke it interactively; and then type:
.DM
	sinclude(defs.m4)
.DE
From now on, you can use any definition that you had saved into file
.BR defs.m4 .
.Sh "Errors"
.PP
.B m4
reports all errors to the standard error stream.
An error produces a line of the form
.DM
	m4: line: message
.DE
where
.I line
is a decimal line number and
.I message
describes the error.
For example, the error message
.DM
	m4:  7:  illegal macro name: ab*c
.DE
indicates an attempt to
.B define
a macro with the illegal macro name
.B ab*c
in line 7 of the input stream.
.PP
The following error messages may occur:
.DM
	cannot open file
	eval: invalid expression
	eval: missing or unknown operator
	eval: missing value
	illegal macro name: name
	out of space
	/tmp open error
	unexpected EOF
.DE
The
.I file
or
.I name
will be the file name or macro name which caused the error, or
.B {NULL}
if the required argument is omitted.
.PP
.B m4
does not recognize (and therefore does not report) the most common of
.B m4
errors, namely invoking recursive macro definitions that
never terminate.
A simple example is the definition
.DM
	define(\(garecursive\', \(garecursive\')
.DE
.II "m4^endless loop"
When
.B m4
subsequently encounters a call of
.B recursive
in its input stream, it replaces it on the input stream with its definition.
Because the definition is another call to
.BR recursive ,
.B m4
replaces it in turn with its definition;
the process never terminates.
More complicated examples may involve many macro definitions
and may be difficult to discover.
If
.B m4
enters an endless loop, you can terminate it from the keyboard
by typing the interrupt character (normally
.BR <ctrl-C> )
or the kill character (normally <\fBctrl-\e\fR>).
If
.B m4
enters an endless loop while being run in the background, you
can terminate it with the
.B kill
command.
.SH "For More Information"
.PP
The Lexicon entry for
.B m4
gives a summary of its functions and options.

.ds VN 1
.sp 3.5i
.ll 5.75i
.po 1i
.vs 9
.ft RS
Copyright \(co 1994 by Mark Williams Company.
.sp
All rights reserved.
.sp
This publication conveys information that is the property of Mark
Williams Company.
It shall not be copied, reproduced or duplicated
in whole or in part without the express written permission of Mark
Williams Company.
Mark Williams Company makes no warranty of any kind
with respect to this material and disclaims any implied warranties of
merchantability or fitness for any particular purpose.
.sp
The information contained herein is subject to change without notice.
.sp
COHERENT is a trademark of Mark Williams Company.
All other products are trademarks or registered
trademarks of the respective holders.
.sp
.ta 1i 2.25i 3.75i
	Revision \*(1.0		Printing 5 4 3 2 1
.sp
Published by Mark Williams Company, 60 Revere Drive, Northbrook,
Illinois  60062.
.sp
.nf
.ta 0.5i 1.5i
Sales:	Phone:	(800) 636-6700 (U.S.)
		(708) 291-6700 (outside U.S.)
	FAX:	(708) 291-6750
	E-mail:	sales@mwc.com
Technical Support:
	Phone:	(708) 291-6700
	FAX:	(708) 291-6750
	E-mail:	support@mwc.com
.ta 1.0i
CompuServe:	76256,427
.sp
.fi
These notes were written under the COHERENT operating system, using the
MicroEMACS text editor.
Text formatting was performed by the
COHERENT edition of the \fBtroff\f(RS text formatter,
using its PostScript output function.
Page design was implemented with custom-written macros written in the
\fBtroff\f(RS text-formatting language and in PostScript.
Typesetting of this manual, from the table of contents
through the index, was performed by one script written in the COHERENT
Korn shell.
Camera-ready copy was printed on a Hewlett-Packard LaserJet IIP printer
using the Pacific Page PostScript cartridge.
.sp
Printed in the U.S.A.
.bp

.NH "Changes to COHERENT for Release 4.2.14"
.PP
The following describes how \*(CO release 4.2.14 differs from release
4.0.
.SH "Changes From Release 4.0 to 4.2.05"
.PP
Release 4.2.05 added the following new features to \*(CO:
.IP \(bu 0.3i
Improved support for third-party packages.
The UNIX System-V editions of Lotus and WordPerfect work out of the box.
.IP \(bu
Support for X Windows.
An X Windows package is now available for \*(CO from Mark Williams Company.
.IP \(bu
A rewritten version of the \*(CO kernel.
The kernel now includes \*(ST, the \*(UN system for portable device drivers.
.IP \(bu
Many new system calls, including support for the
.B sigset()
and
.B sigaction()
families of signal-handling system calls;
and \*(UN System-V interprocess comunications, including shared memory,
semaphores, and messages queues.
.IP \(bu
Tools for configuring and rebuilding the kernel.
Beginning with release 4.2.05, you can change kernel variables,
add or delete drivers, and modify driver variables,
then build a new kernel and boot it.
.IP \(bu
Support for peripheral devices has been expanded.
Devices support now include SCSI tape and a variety of SCSI devices.
The console has been rewritten to be more robust and to conform more closely
to accepted \*(UN standards.
The keyboard driver has been expanded and now
supports more languages, including Greek.
.IP \(bu
An improved compiler, linker, and assembler.
These include a completely restructured set of header files,
which bring \*(CO closer to the \*(PX standard;
support for mathematics co-processors;
and a greatly improved version of the \*(CO debugger
.BR db .
.IP \(bu
The visual shell
.BR vsh .
This shell uses drop-down menus, function keys, and single-key commands
to give you a simple, clear interface to the \*(CO system; yet it works
on a character-based terminal.
.IP \(bu
The Taylor \*(UU package.
This is a more robust and flexible version of \*(UU.
.IP \(bu
The MLP print spooler.
This spooler is modelled after the \*(UN command
.BR lp .
You now can have multiple printers of any type
plugged into your \*(CO systems, and access them via parallel ports,
serial ports, or the auxiliary port on a terminal.
.IP \(bu
A more robust version of the
.B curses
library, including support for eight-bit characters and color.
.IP \(bu
.B troff
now supports eight-bit character sets.
.B troff
now comes with tools to ``cook'' loadable PostScript fonts, and to
access fonts built into the Hewlett-Packard LaserJet III.
.IP \(bu
Improved versions of the Bourne shell
.B sh
and the Korn shell
.BR ksh .
Many bugs have been fixed, and the Bourne shell now supports shell functions.
.PP
The following new commands have been added to \*(CO:
.nf
.sp \n(pDu
.tc . 0.1i
.ta 1.25i
\fBalmanac\fR	Print a listing of events on today's date in history
\fBapropos\fR	Find the Lexicon entries that relate to a given topic
\fBasymkdev\fR	Create a node for asynchronous devices
\fBcancel\fR	Cancel a print job
\fBchreq\fR	Change a job's priority, life expectancy, or output device
\fBcohtune\fR	Change the value of a flag or variable in a \*(CO device driver
\fBcu\fR	\*(UN-style communications program
\fBfmt\fR	Adjust the length of lines in a file of text
\fBfwtable\fR	Build a \fBtroff\fR font-width table from a PCL or PostScript ``soft font''
\fBgnucpio\fR	GNU version of the \fBcpio\fR archiver
\fBgtar\fR	GNU version of the \fBtar\fR tape archiver
\fBgzip\fR	Industry-standard compression tool from the Free Software Foundation
\fBidenable\fR	Add a device driver to the \*(CO kernel, or delete a driver from it
\fBidmkcoh\fR	Build a new bootable kernel
\fBlcasep\fR	Convert text to lower case
\fBidtune\fR	Set the value of a ``tunable'' variable in the \*(CO kernel
\fBipcrm\fR	Remove an interprocess-communication item from memory
\fBipcs\fR	Display a snapshot of interprocess communications
\fBlp\fR	Spool a job for printing via the MLP spooler
\fBlpadmin\fR	Administer the MLP spooler
\fBlpsched\fR	Turn on the \fBlp\fR print spooler
\fBlpshut\fR	Turn off the \fBlp\fR print spooler
\fBlpstat\fR	Give the status of a printer or job spooled through the MLP spooler
\fBpclfont\fR	Prepare a PCL for downloading via MLP
\fBPSfont\fR	Cook an Adobe font into downloadable PostScript
\fBreprint\fR	Reprint a spooled job
\fBroute\fR	Show or reset a user's default printer
\fBtape\fR	Manipulate the tape device
\fBttytype\fR	Set the default types of remote terminals
\fBvsh\fR	Invoke the \*(CO visual shell
.PP
For more information on any command, see its entry in the Lexicon.
.SH "Changes From Release 4.2.05 to 4.2.10"
.PP
The following describes how \*(CO release 4.2.10 differs from
\*(CO release 4.2.05.
.Sh "Changes to the Kernel"
.PP
The following changes have been made to the \*(CO kernel and drivers:
.IP \(bu 0.3i
Some kernel bugs have been corrected that caused panics under
special conditions.
In particular, the bug that causes the ``Ring 1 Panic' has been traced
to the AT driver, and changes made to correct it.
.IP \(bu
Under \*(CO 4.2.05, the driver
.B asy
attempted to test for the presence of a UART.
However, the test did not always work correctly
because some newer 16550's no longer follow specification of IIR = xx00 xxxx.
The test has been rewritten to take this into account.
.IP \(bu
The driver
.B vtnkb
now supports Greek keyboards.
.IP \(bu
The driver
.B hai
has been changed to make its resetting more robust.
It now supports 255-head hard disks correctly.
Its default timeout has also been increased, to eliminate bogus
timeout messages when running slow drives.
.IP \(bu
The driver
.B at
has been modified to address a bug that caused panics and timeouts.
.IP \(bu
The kernel now clears the U area upon startup.
This problem had caused \*(CO installation to fail on a few systems.
.IP \(bu
Under certain circumstances, the kernel would crash if given a bad
physical address; it now complains and keeps running.
.IP \(bu
The kernel now recognizes Cyrix parts.
You can optionally enable the internal cache on the
SRx, SRx2, DRx, and DRx2 upgrade parts.
.IP \(bu
The file system has been changed to be more robust.
.IP \(bu
Global variable
.B RLOCKS
is now tunable.
.IP \(bu
In some instances, kernel error messages would print a bogus
number for a system call.
This has been fixed.
.IP \(bu
In some circumstances, the kernel used
.B rep
I/O instructions instead of explicit loops.
On some motherboards, this can cause the CPU to outrun the I/O bus.
The kernel has now removed all
.B rep
instructions and uses loops instead.
.IP \(bu
Variables
.B MSGQID_SPEC
and
.B MSGQSZ_SPEC
have been added to file
.BR /conf/install_conf/src/mtune .
.IP \(bu
Routines that report CPU idle times have been upgraded.
.IP \(bu
Under certain circumstances,
signalling did not work correctly.
This has been fixed.
.IP \(bu
Under \*(CO 4.2.05,
some screen contents would be lost
when the user switched sessions on a system with two video adapters.
This has been repaired.
.IP \(bu
Routines
.BR __kdenabio() ,
.BR __kddisabio() ,
.BR __kdaddio() ,
and
.B __kddelio()
have been added to the \*(CO device-driver kit.
.IP \(bu
Invoking
.B brk()
twice consecutively with the same arguments would cause a
.B PTOV
fault.
This has been fixed.
.IP \(bu
Changes to the kernel now permit
.B reboot
to reboot the system, rather than just bring it down and wait for the user
to press the reset the button.
.IP \(bu
The instruction
.DM
	while (sbrk(4096))
.DE
.IP
would crash the system under some circumstances.
This has been fixed.
.IP \(bu
The memory manager erroneously rounded down
byte lengths not a multiple of a page size,
which under some circumstances created problems.
This has been corrected.
.IP \(bu
The memory manager returned filler below the alignment address.
This has been corrected.
.Sh "Changes to Commands and Scripts"
.PP
The following changes have been made to \*(CO commands and scripts:
.IP \fB/bin/cc\fR
This version (4.5.1) fixes a bug in sign extension, which affected
the compilation of some X applications.
It also fixes option \fB\-g\fR, which generates debugging information.
Under previous releases, this option would break the COFF output.
Other changes correct inappropriate extension of arguments from
.B short
to
.BR int .
.IP \fB/bin/df\fR
This command now uses
.B fstat
and
.B fstatfs
instead of opening raw device.
Environmental variables
.BR DF_OLD ,
.BR OLDSTYLE,
etc., now no longer affect its behavior.
.IP \fB/bin/fwtable\fR
This version (1.6) fixes a bug that caused it to generate bogus tables under
certain conditions.
.IP \fB/bin/ld\fR
This version (4.2.3) fixes some minor bugs.
.IP \fB/bin/login\fR
This has been recompiled to use the latest version of
.BR ctime() .
.IP \fB/bin/make\fR
This command now correctly handles
.BR Makefile s
generated by
.BR imake .
.IP \fB/bin/man\fR
The version of this command shipped with \*(CO 4.2.05 could run out
of memory if it attempted to read too many index files.
This has been fixed:
now it can read an indefinite number of index files.
.IP \fB/bin/newgrp\fR
The version of this program under 4.2.05 incorrectly set no password in a
newly created group, thus creating a security hole.
This has been fixed.
Its default permissions have also been set to \fBr-s-x-x root bin\fR.
.IP \fB/bin/ps\fR
This now returns the proper exit status.
.IP \fB/bin/qfind\fR
This command would page fault under certain circumstances.
It has been repaired.
.IP \fB/bin/sed\fR
This command
features improved error reporting.
.IP \fB/bin/sh\fR
.B exec
has been repaired.
.IP \fB/bin/test\fR
This command now correctly handles empty arguments, and reacts correctly
when handed no arguments.
.IP \fB/bin/troff\fR
This command's suite of font-width tables have been rebuilt using new
.B .tfm
tables supplied by Hewlett-Packard.
These tables are stored in directory
.BR /usr/lib/roff/troff_pcl/fwt .
.IP \fB/bin/wc\fR
This now returns the proper exit status.
.IP \fB/etc/build\fR
This script now allow lets you skip running
.B badscan
on AT drives.
It also allows you to
.B badscan
SCSI drives; this is now allowed because of problems with bad blocks
reported by users who have removable SCSI media.
.IP \fB/etc/build.u\fR
Corrected the word ``Owervite'' to ``Overwrite'' in an error message.
.IP \fB/etc/fsck\fR
This command would page fault if accidentally run on a
.B cpio
backup disk.
This has been fixed.
.IP
The ``memory allocation failed'' error message has been expanded.
.IP \fB/etc/install\fR
This command now correctly handles partial installations.
If it finds a tag file in the root directory, it asks you whether to
continue, rather than simply aborting installation.
.IP \fB/etc/mklost+found\fR
This script is a new command that lets you build a larger
.B lost+found
directory than \*(CO utilities build by default.
.IP \fB/etc/newusr\fR
This script had a problem whereby it mistakenly used the identifier
.BR add_user .
This has been repaired.
.IP
Because
.B vsh
is not a login shell, this has been removed from the list of login shells
presented to the user.
.IP \fB/etc/profile\fR
This file now uses
.B cat
to display the file
.B /etc/motd
by default.
This is not done if
.B $HOME
is
.BR /etc .
.IP
Instruction
.DM
	[ -f /etc/motd ...
.DE
.IP
has been changed to:
.DM
	[ -s /etc/motd ...
.DE
.IP \fB/etc/reboot\fR
Changes to the kernel now permit
.B reboot
to reboot the system, rather than just bring it down and wait for the user
to press the reset the button.
Note that it still prompts you to press the reset button, but if you wait
a few moments it will (in all probability) reboot your system automatically.
.IP \fB/etc/wall\fR
This command has been changed so that it no longer hangs when
it encounters a bogus entry in
.BR /etc/utmp .
This corrects the problem that caused the script
.B /etc/shutdown
to hang after a user had run X.
.IP \fB/etc/conf/aha/mkdev\fR
This script has been added.
It walks you through the process of describing your SCSI devices to the driver
.B aha
(the alternate driver for Adaptec SCSI disks).
.IP \fB/etc/conf/asy/mkdev\fR
This scipt now walks you through the process of configuring a modem, as well
as describing a serial port.
Its prompts have been reworded to make them clearer.
.IP \fB/etc/conf/at/mkdev\fR
This script has been added.
It walks you through the process of describing your AT disks to the driver
.BR at .
.IP \fB/etc/conf/bin/devadm\fR
Identifier
.B STARTUP
has been corrected to
.BR START .
.IP \fB/etc/conf/cohmain/mkdev\fR
This script now asks you whether you wish to enable the Cyrix upgrade cache,
should your system have a Cyrix part.
A new global variable identifies CPU type.
.IP \fB/etc/conf/hai/mkdev\fR
The initial version of this script confused variables
.B ID
and
.BR i ,
which created problems under certain circumstances.
This has been repaired.
.IP
This script has also been modified to permit you to install a tape driver
even if you do not have a SCSI hard disk.
.IP
Its prompts have been reworded to make them clearer.
.IP \fB/etc/conf/install_conf/sdevice\fR
Defaults for drivers
.BR echo ,
.BR loop ,
and
.B dump
were incorrectly set to `Y'; now correctly set to `N'.
.IP \fB/etc/conf/lp/mkdev\fR
This script's prompts have been reworded to make them clearer.
.IP \fB/etc/conf/pty/mkdev\fR
This script has been added to the release.
It walks you through the task of configuring the driver
.BR pty ,
which handles pseudo-TTYs.
.IP \fB/etc/conf/ss/mkdev\fR
This script has been added.
It walks you through the configuring of the driver
.B ss
(the alternate driver for Seagate SCSI disks).
.IP \fB/etc/conf/bin/idbld\fR
This new script walks you through the process of building an entirely
new kernel.
It invokes each
.B mkdev
script in turn, then invokes
.BR /etc/conf/bin/idmkcoh
to build the newly reconfigured kernel.
.\".IP \fB/etc/install\fR
.\"This command now supports pre-files.
.\"That is, it executes file \fB/conf/\fItag\fB.pre\fR
.\"before
.IP \fB/usr/bin/cancel\fR
This now correctly cancels a job for the MLP spooler.
.IP \fB/usr/bin/elvis\fR
This has been updated to release 1.8.
.IP
The command
.B cc
in this editor did not work properly.
This has been repaired.
.IP
.B elvis
now invokes
.B elvprsv
from
.BR /etc/rc .
.B elvprsv
and
.B elvrec
have permissions \fB4755 root root\fR, and
.B /usr/preserve
now has permissions \fB755 root root\fR.
.IP \fB/usr/bin/gzip\fR
This has been updated to use the latest GNU sources.
.IP \fB/usr/bin/ksh\fR
The previous release of this shell dropped argument 1; this has
been fixed.
Its handling of
.B SIGINT
and
.B SIGQUIT
have also been fixed.
.IP \fB/usr/bin/lp\fR
.IS \fB/usr/bin/lpsched\fR
Several bugs have been fixed in the MLP spooler and daemon.
In particular, the option \fB\-m\fR now works.
.Sh "Changes to Library Routines and Macros"
.PP
The following library routines and macros have been changed or repaired.
.IP \fBftime()\fR
This has been restored as a COFF system call.
.IP \fBlibcurses\fR
This library has been updated to fix bugs and incorporated some previously
unsupported routines.
.IP \fBva_start()\fR
This routine, in header file
.BR <stdarg.h> ,
has been rewritten so that it can be used with the GNU C++ compiler
.BR g++ .
.IP \fBdiv()\fR
In-lining of this routine, which lives in header file
.BR <stdlib.h> ,
has been conditionalized.
This is done because
.B gcc
correctly handles such in-lined routines, but
.B g++
does not.
.IP \fBldiv()\fR
In-lining of this routine, which lives in header file
.BR <stdlib.h> ,
has been conditionalized.
This is done because
.B gcc
correctly handles such in-lined routines, but
.B g++
does not.
.IP \fBprintf()\fR
This has been updated to correct some minor errors.
.IP \fB/lib/ndp/libm.a\fR
This library lacked some floating-point op-codes for hardware floating-point
arithmetic.
This has been corrected.
.Sh "Changes to Header Files"
.PP
.IP \fB/usr/include/float.h\fR
The values for
.B DBL_MAX
and
.B DBL_MIN
have been corrected.
.IP \fB/usr/include/limits.h\fR
.B __SCHAR_MIN
was misspelled.
This has been corrected.
.IP \fB/usr/include/math.h\fR
This file now contains the following corrected prototypes for
.B frexp
and
.BR ldexp :
.DM
	double	frexp	__PROTO ((double _x, int * _iptr));
	double	ldexp	__PROTO ((double _x, int _i));
.DE
.IP \fB/usr/include/stdlib.h\fR
This header file has had the line
.DM
	#include <common/xdebug.h>
.DE
.IP
removed.
.IP \fB/usr/include/common/__stat.h\fR
The R4
.B stat
structure in this header file has been suppressed, so that it
works with the latest release of GNU C.
.IP \fB/usr/include/coh/proc.h\fR
.IS \fB/usr/include/coh/timeout.h\fR
These header files have been added to make the kernel more compatible with GCC.
.IP \fB/usr/include/sys/confinfo.h\fR
Added
.B EXTERN_CLOSE
declaration to
.BR DECLARE_OPEN_CLOSE .
.IP \fB/usr/include/sys/cyrix.h\fR
This header file has been added to help support the Cyrix part.
.IP \fB/usr/include/sys/mmu.h\fR
Symbols
.B SEG_PWT
and
.B SEG_PCD
have been added to this header file.
.IP \fB/usr/include/sys/stat.h\fR
The R4
.B stat
structure in this header file has been suppressed, so that it
works with the latest release of GNU C.
.IP \fB/usr/include/sys/msg.h\fR
.IS \fB/usr/include/sys/sem.h\fR
.IS \fB/usr/include/sys/shm.h\fR
BCS-compatible pid length has been restored.
.IP \fB/usr/include/sys/types.h\fR
Type
.B u_long
et al. have been added.
.Sh "Miscellaneous Changes"
.PP
The following miscellaneous changes have been made:
.IP  "Floppy-Disk Device Nodes\fR"
A number of changes have been made to floppy-disk device nodes.
The following nodes have been deleted:
.DM
	/dev/f9d0
	/dev/f9d1
	/dev/rf9d0
	/dev/rf9d1
.DE
.IP
The following nodes have been deleted and remade:
.DM
.ta 0.5i 2.0i
	/dev/dsk/f03d	/dev/rdsk/f03d
	/dev/dsk/f13h	/dev/rdsk/f13h
	/dev/dsk/f03d	/dev/rdsk/f03d
	/dev/dsk/f13h	/dev/rdsk/f13h
.DE
.IP "\fBSCSI Disk Device Nodes\fR"
Permissions on devices \fB/dev/{r}sd[a-d]\fR have been changed
\fB600 sys sys\fR.
Permissions on devices \fB/dev/{r}sdx\fR have been changed to
\fB600 root root\fR.
This matches the permissions for the \fBat\fR devices.
The
.B mkdev
scripts for these devices have also been updated to enforce these changes.
.IP \fB/lib/libc.a\fR
.IS \fB/lib/ndp/libc.a\fR
This version (4.2.3) fixes some bugs in some library routines, and include
a few routines that had been left out.
.IP \fB/lib/yyparse.c\fR
This has been updated to correct some minor bugs.
.IP "\fBManual Pages\fR"
These have been updated to include the latest changes and updates to the
software.
.IP \fB/usr/lib/makeactions\fR
.IS \fB/usr/lib/makemacros\fR
These have been updated to conform more closely to published standards.
.IP \fB/usr/lib/shell_lib.sh\fR
The routine
.B split_path
has had a minor bug corrected.
.IP \fB/usr/lib/uucp/sys\fR
The default version of this file
now includes the instructions
.DM
	remote-send
	remote-receive
	local-send
	local-receive
.DE
.IP
for the entry for site
.BR mwcbbs .
.IP \fB/usr/lib/libcurses.a\fR
.IS \fB/usr/lib/ndp/libcurses.a\fR
These incorporate fixes to minor bugs in the
.B curses
routines.
.IP \fBterminfo\fR
.IS \fBtermcap\fR
Some terminal descriptions have been repaired, in particular, the
.B xterm
entry in
.BR termcap .
.IP
Regional scrolling has been fixed in the
.B termcap
description for the console;
.B Blast
and GNU Emacs now scroll correctly.
.SH "Changes From Release 4.2.10 to 4.2.14"
The following describes how \*(CO release 4.2.14 differs from
\*(CO release 4.2.10.
.Sh "Changes to the Kernel"
.PP
The following changes have been made to the \*(CO kernel and drivers:
.IP \(bu 0.3i
The floppy-tape driver
.B ft
has been added to the kernel.
This supports floppy tapes in the QIC-40 or QIC-80 formats.
.IP \(bu
The AT driver has been rewritten to support large IDE drives \(em that is,
drives with more than 1,024 cylinders.
.\".IP \(bu
.\"Release 4.2.14 includes CD-ROM drivers.
.\"Driver
.\".B mcd
.\"supports a variety of Mitsumi drives, plugged into the Mitsumi interface card.
.\"Driver
.\".B cdu
.\"supports a variety of Sony drives, again plugged into their own interface
.\"card.
.\"The SCSI driver
.\".B hai
.\"now supports CD-ROM drives plugged into Adaptec, Seagate, or Future Domain
.\"host adapters.
.\"For details, use the
.\".B man
.\"command to view the manual page
.\".BR CD-ROM .
.\"Applications are also included to read CD-ROMs and play audio CDs.
.IP \(bu
Release 4.2.14 includes the trace driver
.BR tr .
This driver enables you to cat the output of the function
.B cmn_err()
from a trace buffer into a file; to do so, read the contents of device
.BR /dev/trace .
The trace buffer can hold up to four megabytes of traces and error messages.
This driver should be of great assistance to persons who are developing
device drivers.
.IP \(bu
The driver
.B hai
has been rewritten to use multi-sector transfers, thus increasing its
speed significantly.
.IP \(bu
.B hai
now includes modules to support tape devices and CD-ROMs plugged into
Future Domain and Seagate host adapters.
For details, use the command
.B man
to view the manual page for
.BR hai .
.IP \(bu
The driver
.B at
has been updated to increase its speed and make it more robust.
.IP \(bu
The System V features
.BR semaphores ,
.BR messages ,
and
.B "shared memory" 
have been rewritten to be more robust.
.IP \(bu
Device
.B /dev/freemem
has been added.
This device returns the amount of RAM that is free.
For details, use the command
.B man
to view the Lexicon entry
.BR freemem .
.IP \(bu
The kernel's handling of end-of-volume codes has been repaired.
This means, among other things, that multi-volume
.B tar
archives are now handled correctly.
.IP \(bu
The \*(CO kernel's scheduler has been rewritten.
The scheduler is the module which is responsible for allocating CPU time
to the various processes that are being executed.
The old scheduler would allocate CPU time to each process in turn, without
regard to the amount of resources it consumed.
Partially as a result of this scheme, the performance of programs that made
light use of the CPU (e.g., editors) would degrade when CPU-intensive programs
were invoked.
The new scheduler tends to favor programs that make light use of the CPU.
.IP \(bu
The kernel now supports the DDI/DKI routines
.BR physiock() ,
.BR getrbuf() ,
and
.BR freerbuf() .
.IP \(bu
The console driver now prints italicized text as white text on a red field.
This change was made to help the console driver conform to published standards.
.IP \(bu
The console driver used to lose track of cursor invisibility when the user
switched virtual consoles.
This has been repaired.
.IP \(bu
A bug in the polling routines has been fixed.
This bug could cause applications that attempted to perform I/O through
a pseudo-tty to hang under some circumstances.
Under X, this bug would cause keyboard lockups and cause the mouse
occasionally to enter ``jumping-bean'' mode.
It has been repaired.
.IP \(bu
A bug in the kernel could cause an imbalance in the lock count.
This has been repaired.
.IP \(bu
A bug in the kernel's signal handler would sometimes cause programs to
crash with an error message that indicated a problem in the signal frame buffer.
This has been repaired.
.IP \(bu
The signal
.B usigsuspend
did not work correctly in previous releases.
This has been corrected.
.IP \(bu
The tunable kernel variables
.B CON_BEEP_SPEC
and
.B SEP_SHIFT
have been added.
The former variable lets you turn off beeping on the console.
The latter lets each virtual console have its own shift-key settings.
For details on how to set and these variables, use the command
.B man
to view the Lexicon entry
.BR console .
.\".IP \(bu
.\"The drivers
.\".B kb
.\"and
.\".B nkb
.\"are no longer included with \*(CO.
.\"The need for them has vanished as the drivers
.\".B vtkb
.\"and
.\".B vtnkb
.\"have been made more robust.
.\"They are still available throught the Internet or the MWC BBS should you
.\"still need them.
.Sh "Changes to the Header Files"
.PP
The following changes have been made to \*(CO's suite of header files:
.IP \(bu 0.3i
Header files
.BR <coh/bio.h> ,
.BR <coh/defer.h> ,
.BR <coh/i386lib.h> ,
.BR <coh/misc.h> ,
.BR <coh/proc.h> ,
and
.B <coh/timeout.h>
have been added to \*(CO.
These prototype the internal-kernel routines used in the kernel.
.IP \(bu
Header file
.B <shadow.h>
has been added.
This supports the functions that manipulate the shadow-password file
.BR /etc/shadow .
These functions are described below.
.IP \(bu
Header file
.B <termios.h>
has been added.
This supports the \*(PX-compatible extended
.B termio
routines.
.IP \(bu
Header files
.BR <gdbm.h> ,
.BR <dbm.h> ,
and
.B <ndbm.h>
have been added.
These support the library
.BR libgdbm ,
which implements functions for building and manipulating a \*(UN-style DBM
data base.
.IP \(bu
Header file
.B <netdb.h>
and related header files have been added.
These prototype and support the routines in the socket library
.BR libsocket.a .
.IP \(bu
Header file
.B utime.h
has been moved from
.B /usr/include/sys
to
.BR /usr/include ,
to conform with standard usage.
.IP \(bu
Minor fixes have been made to header files
.B <sys/dmac.h>
and
.BR <sys/fdc765.h> .
.IP \(bu
Constant
.B OPEN_MAX
has been added to header file
.BR <limits.h> .
.Sh "Changes to Compiler and Libraries"
.PP
The following changes have been made to the \*(CO compiler and libraries:
.IP \(bu 0.3i
The functions
.BR endspent() ,
.BR getspent() ,
.BR getspnam() ,
and
.B setspent()
have been added to
.BR libc .
This manipulate the shadow-password file
.BR /etc/shadow .
.IP \(bu
A bug in the function
.B ctime()
caused systems in the southern hemisphere not to set daylight savings time
correctly.
This has been fixed.
.IP \(bu
Routines
.BR getutent() ,
.BR getutline() ,
et al. have been added to
.BR libc .
These manipulate the archiving files
.BR utmp .
For details, use the command
.B man
to view the Lexicon entry for
.BR getutline() .
.IP \(bu
Functions have been added to
.B libc
to implement the
.B termios
routines.
For details, use the command
.B man
to view the Lexicon entry for
.BR termios .
.IP \(bu
The regular-expression (\fBregexp\fR) routines have been moved from library
.B libmisc
into library
.BR libc .
Programs that use these routines no longer have to link in
.B libmisc
to obtain them.
.IP
.IP \(bu
The Berkeley functions
.BR bcopy() ,
.BR bcmp() ,
and
.B bzero()
have been added to
.BR libc .
These are included to support existing code.
.IP \(bu
A set of routines to generate 48-bit random numbers have been added to
.BR libc .
For details, use the command
.B man
to view the Lexicon entry
.BR drand48() .
.IP \(bu
Under \*(CO release 4.2.10, the version of the library
.BR /usr/lib/libl.a ,
which is used by the application
.BR lex ,
was incorrect.
The correct version is included in release 4.2.14.
.IP \(bu
The compiler
.B cc
had a bug that caused it to write incorrect output when invoked with its option
.BR \-g .
This has been fixed.
.Sh "Changes to Applications"
.PP
The following changes have been made to \*(CO's applications:
.IP \(bu 0.3i
The mail system has been updated to
.B smail
release 3.1.28.
This release is more robust than the older version of
.B smail
that had been included with \*(CO, and includes many more features.
.IP \(bu 0.3i
The \*(UU implementation has been upgraded to Taylor \*(UU release 1.05.
For a fuller description of how this implementation works, use the command
.B man
to view the Lexicon entry
.BR UUCP .
.IP \(bu
The command
.B ideinfo
has been added.
This command displays information about the configuration of an IDE drive.
For details, use the
.B man
command to view its manual page.
.\".IP \(bu
.\"The command
.\".B cdplayer
.\"has been added.
.\"This lets you play an audio CD on your CD-ROM drive.
.\".IP \(bu
.\"The commands
.\".B cdv
.\"and
.\".B cdview
.\"have been added.
.\"They let you read files from a CD-ROM.
.IP \(bu
Command
.B makedepend
has been added to the release.
This command builds a table of dependencies that can be used by
.BR make .
For details, use
.B man
to view its manual page.
.IP \(bu
Command
.B findmouse
has been added to \*(CO.
This command is used during installation of the \*(CO version of X Windows,
and supercedes the version that is included with that package.
.IP \(bu
Commands
.B sort
and
.B diff
have been recompiled as 32-bit binaries.
Users can now use them to sort or compare extremely large files.
The extremely annoying ``jackpot'' message has been removed from
.BR sort .
.IP \(bu
The editor
.B elvis
has been updated to release 1.8pl3.
As part of this update, the commands
.B elvprsv
and
.B elvrc
have been added; these help you recover modifications to a file
in the case of a catastrophic failure of the system during an editing session.
Manual pages for each can be viewed with the
.B man
command.
.IP \(bu
.B gnucpio
has been updated to release 2.3.
.IP \(bu
The command
.B ftbad
is now included.
This lets you edit the list of bad blocks on a floppy-tape cartridge.
It works with the floppy-tape driver
.BR ft .
.IP \(bu
Command
.B /etc/conf/bin/idbld
is now included in this release.
This command walks you through all configuration scripts for the kernel;
in effect, you can entirely reconfigure your kernel with one command.
.IP \(bu
Command
.B makeboot
builds a bootable floppy disk for \*(CO system.
We strongly suggest you build such a disk and put it into a safe place,
to help your system recover from a catastrophic error.
.IP \(bu
Commands
.BR zcmp ,
.BR zdiff ,
.BR zforce ,
.BR zgrep ,
.BR zmore ,
and
.B znew
manipulate compressed and ``zipped'' files.
They let you compare or read compressed files without having to go through
the trouble of uncompressing them first.
.IP \(bu
As part of the updating the \*(UU package, the command
.B uucheck
has been replaced with the command
.B uuchk .
.IP \(bu
The \*(CO implementation of
.B awk
has been replaced by
.BR gawk ,
from the Free Software Foundation.
This a fuller, more robust implementation of the AWK language.
For details, use the
.B man
command to view the manual page for
.BR gawk .
.IP \(bu
The shells
.B sh
and
.B ksh
have been repaired:
they no longer ``leak'' file descriptors.
.IP \(bu
The MLP print spooler has been revised.
Numerous bugs have been fixed; in particular, the spooler daemon no longer
dies when asked to print a large number of files simultaneously.
The daemon has also been revised to pass a fourth argument to the backend
scripts.
This fourth argument normally is used for the title of the document being
printed, but you can use it pass all manner of information as well, thus
greatly increasing the flexibility of MLP backend scripts.
For details, use
.B man
to view the Lexicon entry for
.BR lpsched .
.IP \(bu
Commands
.B man
and
.B apropos
have been rewritten; they are now shell scripts instead of C programs.
Both now support the environmental variable
.BR MANPATH ,
and so can now read manual pages kept in locations other than
.BR /usr/man .
For details, use
.B man
to read the Lexicon entry for
.BR man .
.IP \(bu
The command
.B epson
has been revised to write its output to the standard output instead of
to device
.B /dev/lp .
You can now use it as a filter within an MLP backend script.
.IP \(bu
Program
.B cdmp
has been revised to fix some bugs.
.IP \(bu
Command
.B tape
has been added to the release.
This command lets you manipulate tape devices, either floppy or SCSI;
for example, you can use it rewind a tape.
.IP \(bu
.B nroff
had a bug that caused it to interpret the escape sequence \fB\es0\fR
incorrectly.
This has been repaired.
.IP \(bu
Commands
.B nroff
and
.B troff
now support the primitive
.BR .sy ,
which executes a command under the shell.
For details, use
.B man
to view the Lexicon page for
.BR nroff .
.IP \(bu
Command
.B hmon
has been added to \*(CO.
This command uses a graphical display to show you what processes are running;
you can interactively send signals to a process just by selecting it from
the display and pressing a single key.
For details, use the command
.B man
to view its Lexicon entry.
.IP \(bu
Command
.B hpfilter
has been dropped from the MLP package, as have backend scripts
.B hppar
and
.BR hpserial .
The filter did not work properly, and is obviated by the commands
.B prps
and
.BR hp .
.IP \(bu
Minor bugs in commands
.B prps
and
.B fwtable
have been fixed.
.IP \(bu
Commands
.B unmkfs
and
.B cvmail
have been dropped from the \*(CO release.
.Sh "Miscellaneous Changes"
.PP
The following miscellaneous changes have been made:
.IP \(bu 0.3i
The macro package
.B tmac.an
has been rewritten.
When used with \*(CO's implementation of
.BR nroff ,
it now correctly formats most \*(UN manual pages without modification.
.IP \(bu
The file
.B specials.r
used by
.B troff
and
.B nroff
has been modified to encode many of the extended characters defined in
the character set ISO Latin 1.
Each extended character is named after its hexadecimal value in ISO Latin 1.
For details, read the file
.BR /usr/lib/roff/*/specials.r .
.IP \(bu
Both MicroEMACS and
.B help
now read files
.BR /usr/lib/help* .
This eliminates the need to link these files into directory
.BR /etc .
.IP \(bu
Command
.B almanac
is now included in the default
.BR /etc/profile .
.IP \(bu
User
.B remacc
has been removed from the default version of
.BR /etc/passwd .
That ``user'' used to govern romote access to the system, but has been
replaced by the shadow-password mechanism.
For details, use the command
.B man
to view the Lexicon entry for
.BR login .
.IP \(bu
A number of entries have been added to the on-line version of the
\*(CO Lexicon, or have been revised heavily.
Each can be viewed through \*(CO's command
.BR man .
For a complete list of additions to the Lexicon, use the
.B man
command to view the Lexicon entry
.BR Lexicon .

.\" font settings for the Mark Williams COHERENT manuals.
.\" by fwb, 6/91.
.\"
.\" copyright (c) 1991 by Mark Williams Company, Northbrook, Ill.
.\"
.lf B	Bookman_B.fwt   9
.lf I	Bookman_I.fwt   9
.lf K	I_keyb.fwt	9
.lf L	Courier_R.fwt   8
.lf R	Bookman_R.fwt   9
.lf S	Symbol.fwt      9
.lf DB	Dingbats.fwt    9
.lf HB	HelvNar_BI.fwt 12
.lf HC	Avant_B.fwt    24
.lf HH	HelvNar_B.fwt  18
.lf HR	HelvNar_R.fwt  12
.lf HL	HelvNar_BI.fwt 14
.lf IS  Bookman_I.fwt   8
.lf RS  Bookman_R.fwt   8
.lf SC	Bookman_R.fwt   8
.\" include keycap font in the output file
.\".rb /usr/typeface/ps/keyfont.ps2

.SH "Bibliography"
.II "bibliography"
.PP
The following books may be helpful in developing your skills with C.
This list also contains all books that are referenced in this manual.
It is by no means exhaustive;
however, it should prove helpful to both beginners and experienced
programmers.
.PP
American National Standards Institute:  \fIDraft Programming
Language C (October 1986 Draft)\fR.  Washington, D.C.: X3 Secretariat,
Computer and Business Equipment Manufacturers Association, 1986.
.PP
AT&T Bell Laboratories:  \fIThe C Programmer's Handbook\fR.
Englewood Cliffs, N.J.:  Prentice-Hall, Inc., 1985.
.PP
Bentley, J.:  \fIProgramming Pearls\fR.
Reading, Mass.:  Addison-Wesley Publishing Company, 1986.
\fINot, strictly speaking, about C \(em but
belongs on every programmer's bookshelf.\fR
.PP
Brooks, F.P., Jr.:
\fIThe Mythical Man-Month:
Essays on Software Engineering.\fR
Reading, Mass.:
Addison-Wesley Publishing Company, Inc., 1975.
\fINot about programming,
but should be read by every programmer.\fR
.PP
Chirlin, P.M.:  \fIIntroduction to C\fR.
Beaverton, Or.:  Matrix Publishers, Inc., 1984.
.PP
Derman, B. (ed.):  \fIApplied C\fR.  New York: Van Nostrand Reinhold Co.,
Inc., 1986.
.PP
Feuer, A.R.:  \fIThe C Puzzle Book\fR.
Englewood Cliffs, N.J.:  Prentice-Hall, Inc., 1982.
.PP
Gehani, G.:  \fIAdvanced C:  Food for the Educated Palate\fR.
Rockville, Md.:  Computer Science Press, 1985.
.PP
Hancock, L.: Krieger, M.:  \fIThe C Primer\fR.
New York:  McGraw-Hill Book Publishers, Inc., 1982.
.PP
Harbison, S.; Steele, G.:  \fIC: A Reference Manual\fR.
Englewood Cliffs, NJ: Prentice-Hall, Inc., 1984.
.PP
Haviland, K.F., Salama, B.:
\fIUNIX System Programming.\fR
Reading, Mass.:
Addison-Wesley Publishing Company, Inc., 1987.
.PP
Hogan, T.:  \fIThe C Programmer's Handbook\fR.
Bowie, Md.:  Brady Publishing, 1984.
.PP
Kelley, A.; Pohl, I.:  \fIC by Dissection:
The Essentials of C Programming\fR.
Menlo Park, Ca.: The Benjamin/Cummings Publishing Company, Inc.,
1987.
.PP
Kernighan, B.W.; Ritchie, D.M.:  \fIThe C Programming Language\fR.
Englewood Cliffs, N.J.:  Prentice-Hall, Inc., 1978.
.PP
Kernighan, B.W.; Plauger, P.J.:  \fIThe Elements of Programming Style\fR,
ed. 2.  New York:  McGraw-Hill Book Co., 1978.
.PP
Kochan, S.G.:  \fIProgramming in C\fR.
Hasbrouck Heights, N.J.: Hayden Book Co., Inc., 1983.
.PP
Knuth, D.E.:  \fIThe Art of Computer Programming\fR, vol. 1:  \fIBasic
Algorithms.\fR  Reading, Ma.:  Addison-Wesley Publishing Co., 1969.
.PP
Knuth, D.E.:  \fIThe Art of Computer Programming\fR, vol. 2:  \fISeminumerical
Algorithms.\fR  Reading, Ma.:  Addison-Wesley Publishing Co., 1969.
.PP
Knuth, D.E.:  \fIThe Art of Computer Programming\fR, vol. 3:  \fISorting
and Searching.\fR  Reading, Ma.:  Addison-Wesley Publishing Co., 1969.
.PP
Lapin, J.E.:
\fIPortable C and UNIX System Programming.\fR
Englewood Cliffs, N.J.:
Prentice-Hall, Inc., 1987.
.PP
Mark Williams Company:  \fIANSI C: A Lexical Guide.\fR
Englewood Cliffs, NJ: Prentice-Hall, 1988.
.PP
Plum, T.:  \fIC Programming Guidelines\fR.
Cardiff, N.J.:  Plum Hall, Inc., 1984.
.PP
Plum, T.; Brodie, J.:  \fIEfficient C\fR.
Cardiff, NJ:  Plum Hall, Inc., 1985.
.PP
Purdum, J.:  \fIC Programming Guide\fR.
Indianapolis:  Que Corp., 1983.
.PP
Purdum, J.; Leslie, T.C.; Stegemoller, A.L.:  \fIC Programmer's Library\fR.
Indianapolis:  Que Corp., 1984.
.PP
Rochkind, M.J.:
\fIAdvanced UNIX Programming.\fR
Englewood Cliffs, N.J.:
Prentice-Hall, Inc., 1985.
.PP
Traister, R.J.:  \fIGoing from BASIC to C\fR.
Englewood Cliffs, N.J.:  Prentice-Hall, Inc., 1984.
.PP
Traister, R.J.:  \fIMastering C Pointers\fR.
New York: Academic Press, Inc., 1990.
.PP
Traister, R.J.:  \fIProgramming in C for the Microprocessor User\fR.
Englewood Cliffs, N.J.:  Prentice-Hall, Inc., 1984.
.PP
Vile, R.C., Jr.:  \fIProgramming in C with Let's C\fR.
Glenview, IL: Scott, Foresman and Company, 1988.
.PP
Waite, M.; Prata, S.; Martin, D.: \fIC Primer Plus\fR.
Indianapolis: Howard W. Sams, Inc., 1984.
.PP
Weber Systems, Inc.:  \fIC Language User's Handbook\fR.
New York:  Ballantine Books, 1984.
.PP
Zahn, C.T.:  \fIC Notes\fR.
New York:  Yourdan Press, 1979.

.ds TL Errata
.ds TI "RELEASE NOTES"
.NH "Notes and Errata"
.PP
The following notes limitations that have been discovered with \*(CO.
It also notes errors that have been found in the \*(CO manual, and
describes extensions to the \*(CO Lexicon that have been since the manual
was printed (but are available in the on-line Lexicon).
Try as we might, no system the size and complexity of \*(CO will ever
be entirely free of errors.
We hope that you will note these problems in your manual, and that you will
accept our apologies for any inconvenience they may have caused you.
.SH "Known Limitations"
.PP
\*(CO 4.2 contains the following limitations:
.IP \(bu 0.3i
Program
.B uuconv
converts \*(UU files from the format used by \*(CO prior to release 4.0
into that used by Taylor \*(UU.
If you are installing \*(CO, or updating to release 4.2.14 from releases
4.0 or 4.2, you will not use this program.
However, if you are updating from a release of \*(CO prior to 4.0,
you will use
.BR uuconv ,
and you may run into some problems.
.B uuconv
makes a number of assumptions about the form and content of your files.
If those assumptions are not met, the program may write something
non-functional into one of the new \*(UU files.
Please note the following in particular:
.RS
.IP \(bu 0.3i
On occasion, times are converted without a day of week into the
.B sys
file.
.IP \(bu
Some commands that the old
.B Permissions
file allowed do not always make it into
.BR sys .
.RE
.IP
Be sure to read the generated files
.BR sys ,
.BR dial ,
and
.B port
in directory
.B /usr/lib/uucp
to make sure that all is correct.
For details, check the Lexicon entries for these files.
.RE
.IP \(bu
The command
.B uumvlog
manages the log files that are kept in directory /usr/spool/uucp/.Log.
However, it does not touch the files kept in directory
.BR /usr/spool/uucp/.Admin .
These files log all \*(UU connections to your system, and can grow quite large.
You must manage the files by hand.

.NH "GNU Software Development System"
.PP
Thank you for purchasing the \*(CO release of the GNU Software Development
System.
This package bundles a number of excellent GNU compilers and utilities
from the Free Software Foundation, ported to \*(CO by Mark Williams
Company.
.SH "Before You Install"
.PP
Please note the following:
.PP
.B
If you have purchased both the GNU Tools and GNU C from Mark Williams,
you \fImust\fP install GNU C first!
.R
.PP
If you have already installed GNU Tools onto your system, do the following:
.IP \(bu
Log in as the superuser
.BR root .
.IP \(bu
.B cd
to directory
.BR /usr/man .
.IP \(bu
.B mv
directory
.B gnu
to
.BR gnu.back .
.IP \(bu
.B mv
file
.B gnu.index
to
.BR gnu.index.back .
.PP
This will preserve files that otherwise would be overwritten by the
installation of GNU C.
A later section of these notes will show you how to reassemble these files
back together.
.SH "Contents of This Package"
.PP
This package consists of the following tools and utilities:
.DS
	\fBar\fR, the GNU archiver
	\fBas\fR, the GNU assembler
	\fBbison\fR, the GNU implementation of \fByacc\fR
	\fBflex\fR, the GNU implementation of \fBlex\fR
	\fBg++\fR, the GNU C++ compiler
	\fBgcc\fR, the GNU ANSI/Objective C compiler, release 2.5.6
	\fBgdb\fR, the GNU source-code debugger
	\fBgprof\fR, the GNU program profiler
	\fBident\fR, the GNU C beautifier
	\fBinfo\fR, the interactive documentation reader
	\fBld\fR, the GNU linker
	\fBmake\fR, the GNU implementation of the \*(UN programming discipline
	\fBnm\fR, the GNU symbol-table utility
	\fBobjcopy\fR, GNU tool to copy an object module
	\fBobjdump\fR, GNU tool to dump an object module
	\fBprotoize\fR, proto-ize a C program
	\fBranlib\fR, built a ranlib header on a library
	\fBsize\fR, display the size of a program and its components
	\fBunprotoize\fR, de-protoize a C program
.DE
.PP
This package also includes the following:
.IP \(bu 0.3i
A manual page for nearly every command.
.IP \(bu
C++ run-time libraries.
.IP \(bu
``info'' files for reading with the command
.BR info .
.SH "System Requirements"
.PP
To install this package, you must have 15 megabytes of disk space,
of which 11 megabytes are filled permanently and four megabytes
hold files temporarily.
You must also have at least eight megabytes of RAM.
.SH "How to Install"
.PP
Installation is in two parts.
The first updates \*(CO; and the second install the GNU development package.
.Sh "Updating COHERENT"
.PP
If you have \*(CO release 4.2.05, you must update your \*(CO system before
you install the GNU development package.
To see what version of \*(CO you have, type the command:
.DM
	uname -r
.DE
This command displays the version of \*(CO that you are using.
If the version is earlier than release 4.2.10,
then you must update \*(CO to release 4.2.10 or later
.I before
you install GNU C.
If, however, the version shown is release 4.2.10 or later, do
.I not
update your \*(CO system; instead, put aside the update disk and jump
to the next section of these notes, which describes how to install the GNU
developent package onto your system.
.PP
If you are reading this paragraph, we assume that you are running
\*(CO release 4.2.05.
To install the supplemental-update disk, insert into your disk drive the disk
that is labelled ``COHERENT Supplement''; then log in as the superuser
.B root
and type the following command:
.DM
	/etc/install CohSupl /dev/\fIdevice\fP 1
.DE
.I device
should name the floppy-disk device from which you are installing the update.
For example, if you are installing from a 3.5-inch floppy disk that is drive
0 on your machine, you would use the command:
.DM
	/etc/install CohSupl /dev/fva0 1
.DE
For a list of available floppy-disk drives, see the entry
.B "floppy disk"
in the \*(CO Lexicon.
.Sh "Installing GNU Package"
.PP
At this point, we assume that either you are running a release of \*(CO
that is later than release 4.2.05, or that you have installed the
supplemental-update disk, as described above.
.PP
Most of this package is installed into directory
.BR /u1/gnu .
The only exception are the manual pages, which are
installed into directory
.BR /usr/man/GNU .
If you have a spare partition available on your system, you should
consider giving it to this package:
simply build a new file system on the partition and mount it on
directory
.B /u1
before you install the package.
(For details on how to do this, see the Lexicon entries for the commands
.B mfks
and
.BR mount .)
.PP
To install this package from 3.5-inch disks on drive 0, use the
command:
.DM
	/etc/install CohGCC /dev/fva0 4
.DE
.PP
To install from 5.25-inch disks on drive 0, use the command:
.DM
	/etc/install CohGCC /dev/fha0 5
.DE
That's all there is to it.
.SH "Removing the Previous Release"
.PP
After you have installed the current release of GNU C, you may wish to
remove previous installations.
If your previous installation of GNU C came from Mark Williams Company,
remove the files:
.DM
	/usr/bin/g++
	/usr/bin/gcc
	/usr/bin/gdb
	/usr/bin/gmake
.DE
Then, remove the directory
.DM
	/usr/local/lib/gcc-lib
.DE
as well as all of the files and sub-directories under it.
.PP
If you do not remove the old release, be sure that you include
directory
.B /u1/gnu/bin
in your
.BR PATH ,
to ensure that you use the latest verison of the compiler.
.SH "Re-assembling Documentation"
.PP
If you had installed the GNU Tools for \*(CO
.I before
you installed GNU C, we assume that you followed the directions given at the
beginning of these notes to back up the manual pages that accompany that
package.
We will now describe how to reassemble the manual pages of the two
packages.
.IP \(bu 0.3i
Log in as the superuser
.B root
and
.B cd
to directory
.BR /usr/man .
.IP \(bu
Issue the following command to move all files from directory
.B gnu.back
to
.BR gnu :
.DM
	mv gnu.back/* gnu
	rmdir gnu.back
.DE
Directory
.B gnu.back
is removed because it is no longer needed.
.IP \(bu
Concatenate the indices of the two packages, as follows:
.DM
	cat gnu.index gnu.index.back | sort | uniq > tempfile
	mv tempfile gnu.index
	rm gnu.index.back
.DE
.PP
That's all there is to it.
.SH "Running GCC"
.PP
Please note the following twists before you attempt to use this
package on your \*(CO system.
.PP
First, many of the tools in this GNU package have the same names as
their \*(CO counterparts:
for example, both the GNU assembler and the \*(CO assembler are named
.BR as ,
both the GNU linker and the \*(CO linker are named
.BR ld ,
and so on.
Therefore, which tool is used by default depends upon which directory
is searched first when you issue a command; and this, in turn, depends
upon where you place directory
.B /u1/gnu/bin
in your
.BR PATH .
.PP
Assume, for example, that your
.B PATH
is as follows:
.DM
	/usr/bin:/bin:/usr/local/bin:/usr/X11/bin:.
.DE
.PP
If you wish to use the GNU tools as your default development tools,
you should place
.B /u1/gnu/bin
.I before
.B /bin
and
.B /usr/bin
in your
.BR PATH ,
so the GNU tools are used by default; and your
.B PATH
appears as follows:
.DM
	/u1/gnu/bin:/usr/bin:/bin:/usr/local/bin:/usr/X11/bin:.
.DE
.PP
If, however, you wish to use the \*(CO tools by default, change your
.B PATH
so that it appears as follows:
.DM
	/usr/bin:/bin:/u1/gnu/bin:/usr/local/bin:/usr/X11/bin:.
.DE
You may have to use direct path names if you use one set of tools by
default and wish to use the other for a special job.
.PP
The second twist is that although the GNU tools
can, in general, do everything the \*(CO tools can do, there is one
special job it cannot do:
you cannot use them to rebuild the \*(CO kernel.
If you wish to rebuild the \*(CO, you
.I must
use the \*(CO versions of
.BR make ,
of the linker
.BR ld ,
and of the assembler
.BR as .
.PP
If you are using the \*(CO tools by default, this is not a problem.
If, however, you are using the GNU tools by default, you must do one of
the following to ensure that you invoke the \*(CO tools instead of their
GNU counterparts:
.IP \fB1.\fR 0.3i
.B cd
to directory
.B /u1/gnu/bin
and rename
.BR ld ,
.BR as ,
and
.B make
to, respectively,
.BR ld.not ,
.BR as.not ,
and
.BR make.not .
.IP \fB2.\fR
Modify your
.B PATH
and remove directory
.B /u1/gnu/bin
from it.
.IP \fB3.\fR
If directory
.B /u1/gnu
is on its own partition, un-mount that partition.
.PP
After you have rebuilt your kernel, be sure to undo what you did,
so you can resume using the GNU tools by default.
.PP
Please note that a future release of \*(CO will simplify this process.
.SH "Documentation"
.PP
This package comes with two sets of documentation:
manual pages and info files.
.PP
The manual pages are installed into directory
.BR /usr/man/GNU .
You can read them with the \*(CO command
.BR man ,
just like any other manual page installed on your system.
.PP
The manual pages, however, do not contain much detail.
To study these tools in-depth, you must use the GNU command
.BR info ,
which is included with this package.
.B info
uses a Hyperscript-like structure that makes it easy for you to thread
your way through the documentation and find exacctly the information
you need.
.PP
The best way to learn about
.B info
is to use it.
To begin, just type:
.DM
	info
.DE
The command will display information about itself.
We suggest that you browse
.BR info 's
help files until you become familiar with this command; a little time
invested in studying this command will save you a great deal of time
later on, when you wish to use these GNU tools to their best advantage.
.SH "Objective C"
.PP
Objective C is an object-oriented version of C that is gaining
popularity.
This package has no special front end for Objective C;
rather, the source files have the extension
.B .m
and one invokes
.B gcc
to compile them.
.B gcc
does not have an option by which you can tell it that you
want to compile Objective C and not ANSI C.
.PP
To give you a taste of Objective C, the following implements
``hello world'' in that language.
Copy the following code into file
.B hello.m
and compile it with
.BR gcc :
.DM
#include <objc/objc.h>
#include <objc/Object.h>
.DE
.DM
static char     *p;
.DE
.DM
@interface Object (Private)
.DE
.DM
+ initialize;
- show;
@end
.DE
.DM
@implementation Object (Private)
.DE
.DM
+ initialize
{
	p = "Hello, the world\en";
	return self;
}
.DE
.DM
- show
{
	fprintf (stderr, "%s\en", p);
	return self;
}
.DE
.DM
@end
.DE
.DM
main (void)
{
	id  this_object;
.DE
.DM
	this_object = [Object new];
	[this_object show];
.DE
.DM
	exit (0);
}
.DE
.SH "Notes"
.PP
Please note that
.B gdb
cannot yet read a \*(CO dump file.
.PP
Mark Williams has designed this package to be easy to install onto your
system.
If you have a problem with installing this package or invoking its tools,
please contact our technical support team, and they will be glad to help
you.
Due to the highly technical nature of this product, we
cannot offer technical support for any program that you are attempting
to write, recompile, or debug with these tools.
.\" Caveat utilitor.
However,
if you enounter what you think is a bug in any of these tools, please mail
a detailed bug report to our technical support team.
You can reach them at the telephone number given the copyright page;
or you can send electronic mail to
.BR support@mwc.com .
We will do what we can to fix this problem, or forward your report to the
Free Software Foundation for correction.
.\" Don't hold your breath, however.
.PP
Finally, the binaries included with this package are protected by the GNU
``copyleft''.
The text of this agreement is kept in files
.B /u1/gnu/COPYING_2.0
and
.BR /u1/gnu/COPY.LIB .
We urge you to read these files to see what rights the Free Software
Foundation has granted you, and what restrictions it has placed upon
these products.
.PP
Finally, printed documentation on GNU C and its ancillary tools are
available from the Free Software Foundation.
If you are interested, we suggest that you contact the Free Software
Foundation, 675 Mass Avenue, Cambridge, MA 02139.
These documents are reasonably priced and well written; and by
purchasing them you can help support the Free Software Foundation in its
work of maintaining and extending their products.

.ds TL "Block Driver"
.NH "Example of a Block Driver"
.PP
This section gives an example driver for a block device:
the \*(CO driver for the AT hard disk.
This driver is described in the article
.B at
in the \*(CO Lexicon.
The source is kept in directory
.BR /etc/conf/at/src/at.c .
.PP
In the following, code appears in monospaced font; comments appear in Roman.
.SH "Preliminaries"
.PP
The following code prefaces the driver.
.Sh "Header Files"
.PP
.B at
uses the following header files.
Because header files have changed drastically for \*(CO 4.2, you should note
carefully the suite included here:
.DM
#include <sys/cmn_err.h>
#include <sys/inline.h>
#include <sys/stat.h>
#include <sys/errno.h>
#include <stdlib.h>
.DE
.DM
#include <kernel/typed.h>
#include <sys/coherent.h>
#include <sys/uproc.h>
#include <sys/fdisk.h>
#include <sys/hdioctl.h>
#include <sys/buf.h>
#include <sys/con.h>
#include <sys/devices.h>
.DE
.Sh "Manifest Constants"
.PP
.B at
uses the following gives manifest constants and macros:
.DM
#define	LOCAL
.DE
.DM
.tm 3.0i
#define	HDBASE 0x01F0	/* Port base */
#define	SOFTLIM 6	/*  (7) num of retries before diag */
#define	HARDLIM 8	/* number of retries before fail */
#define	BADLIM 100	/* num to stop recov if flagged bad */
.DE
.DM
.tm 3.0i
#define	BIT(n)	(1 << (n))
.DE
.DM
.tm 3.0i
#define	CMOSA 0x70	/* write cmos address to this port */
#define	CMOSD 0x71	/* read cmos data through this port */
.DE
.DM
.ta 2.0i 3.5i
/*
 * I/O Port Addresses
 */
#define DATA_REG	(HDBASE + 0)	/* data (r/w) */
#define AUX_REG	(HDBASE + 1)	/* error(r), write precomp cyl/4 (w) */
#define NSEC_REG	(HDBASE + 2)	/* sector count (r/w) */
#define SEC_REG	(HDBASE + 3)	/* sector number (r/w) */
#define LCYL_REG	(HDBASE + 4)	/* low cylinder (r/w) */
#define HCYL_REG	(HDBASE + 5)	/* high cylinder (r/w) */
#define HDRV_REG	(HDBASE + 6)	/* drive/head (r/w) (D <<4)+(1 << H) */
#define CSR_REG	(HDBASE + 7)	/* status (r), command (w) */
#define HF_REG	(HDBASE + 0x206)	/* Usually 0x3F6 */
.DE
.DM
.ta 2.0i 3.5i
/*
 * Error from AUX_REG (r)
 */
#define DAM_ERR	BIT(0)	/* data address mark not found */
#define TR0_ERR	BIT(1)	/* track 000 not found */
#define ABT_ERR	BIT(2)	/* aborted command */
#define ID_ERR	BIT(4)	/* id not found */
#define ECC_ERR	BIT(6)	/* data ecc error */
#define BAD_ERR	BIT(7)	/* bad block detect */
.DE
.DM
.ta 2.0i 3.5i
/*
 * Status from CSR_REG (r)
 */
#define ERR_ST	BIT(0)	/* error occurred */
#define INDEX_ST	BIT(1)	/* index pulse */
#define SOFT_ST	BIT(2)	/* soft (corrected) ECC error */
#define DRQ_ST	BIT(3)	/* data request */
#define SKC_ST	BIT(4)	/* seek complete */
#define WFLT_ST	BIT(5)	/* improper drive operation */
#define RDY_ST	BIT(6)	/* drive is ready */
#define BSY_ST	BIT(7)	/* controller is busy */
.DE
.DM
.ta 2.0i 3.5i
/*
 * Commands to CSR_REG (w)
 */
#define RESTORE(rate)	(0x10 +(rate))	/* X */
#define SEEK(rate)	(0x70 +(rate))	/* X */
#define READ_CMD	(0x20)	/* X */
#define WRITE_CMD	(0x30)	/* X */
#define FORMAT_CMD	(0x50)	/* X */
#define VERIFY_CMD	(0x40)	/* X */
#define DIAGNOSE_CMD	(0x90)	/* X */
#define SETPARM_CMD	(0x91)	/* X */
.DE
.DM
.ta 2.0i 3.5i
/*
 * Device States.
 */
#define SIDLE	0	/* controller idle */
#define SRETRY	1	/* seeking */
#define SREAD	2	/* reading */
#define SWRITE	3	/* writing */
.DE
.Sh "Function Declarations"
.PP
The following declares the functions used in the driver.
.DM
.ta 2.0i 3.5i
/*
 * Forward Referenced Functions.
 */
LOCAL void	atreset ();
LOCAL int	atdequeue ();
LOCAL void	atstart ();
LOCAL void	atdefer ();
LOCAL int	aterror ();
LOCAL void	atrecov ();
LOCAL void	atdone ();
.DE
.Sh "Macros"
.PP
.B at
uses the following macros:
.DM
.ta 2.0i 3.5i
#define NOTBUSY()	((inb (ATSREG) & BSY_ST) == 0)
#define DATAREQUESTED()	((inb (ATSREG) & DRQ_ST) != 0)
#define ATDRQ()	(DATAREQUESTED () ? 1 : atdrq ())
#define ATBSYW(u)	(NOTBUSY () ? 1 : myatbsyw (u))
.DE
.Sh "Global and Static Variables"
.PP
.B at
uses the following global and static variables:
.DM
extern typed_space	boot_gift;
extern short	at_drive_ct;
.DE
The following are used throughout the driver:
.IP \fBATSECS\fR
This is number of seconds to wait for an expected interrupt.
.IP \fBATSREG\fR
This must be 3F6 for most new IDE drives; or
1F7 for Perstor controllers and some old IDE drives.
Either value works with most drives.
.IP \fBatparm\fR
This holds drive parameters.
If initialized to zero,
the driver will try to use values it read from the BIOS during real-mode
startup.
.DM
extern unsigned ATSECS;
extern unsigned ATSREG;
extern struct hdparm_s atparm [];
.DE
.PP
The next line gives the global variable that holds the partition parameters,
as copied from the disk.
There are
.B "N_ATDRV * NPARTN"
positions for the user partitions,
plus
.B N_ATDRV
additional partitions to span each drive.
.PP
When aligning partitions on cylinder boundaries, the 
optimal partition size is 14,280 blocks (2 * 3 * 4 * 5 * 7 * 17); whereas
an acceptable partition size is  7,140 blocks (3 * 4 * 5 * 7 * 17).
.DM
static struct fdisk_s pparm [N_ATDRV * NPARTN + N_ATDRV];
.DE
The following structure
.B at
holds information about the disk controller.
There exists one copy of this structure for each AT controller.
.DM
.ta 0.5i 3.5i
static struct at {
	BUF *at_actf;	/* Link to first */
	BUF *at_actl;	/* Link to last */
	paddr_t at_addr;	/* Source/Dest virtual address */
	daddr_t at_bno;	/* Block # on disk */
	unsigned at_nsec;	/* # of sectors on current transfer */
	unsigned at_drv;
	unsigned at_head;
	unsigned at_cyl;
	unsigned at_sec;
	unsigned at_partn;
	unsigned char at_dtype [N_ATDRV];	/* drive type, 0 if unused */
	unsigned char at_tries;
	unsigned char at_state;
	unsigned at_totalsec;
} at;
.DE
Finally, this last variable holds the template of the message
to be displayed when an AT drive times out.
.DM
static char timeout_msg [] = "at%d: TO\en";
.DE
.SH "Load Routine"
.PP
.B atload()
is the routine that the kernel executes when this driver is loaded.
Under \*(CO 4.2, it is executed once, when the kernel is booted.
.PP
This function resets the controller, grabs the interrupt vector, and
sets up the drive characteristics.
.DM
LOCAL void
atload ()
{
	unsigned int u;
	struct hdparm_s * dp;
	struct { unsigned short off, seg; } p;
.DE
.DM
	if (at_drive_ct <= 0)
		return;

	/* Flag drives 0, 1 as present or not. */
	at.at_dtype [0] = 1;
	at.at_dtype [1] = at_drive_ct > 1 ? 1 : 0;
.DE
.DM
.DE
.DM
	/* Obtain Drive Characteristics. */
	for (u = 0, dp = atparm; u < at_drive_ct; ++ dp, ++ u) {
		struct hdparm_s int_dp;
		unsigned short ncyl = _CHAR2_TO_USHORT (dp->ncyl);
.DE
.DM
		if (ncyl == 0) {
			/*
			 * Not patched.
			 *
			 * If tertiary boot sent us parameters,
			 *   Use "fifo" routines to fetch them.
			 *   This only gives us ncyl, nhead, and nspt.
			 *   Make educated guesses for other parameters:
			 *   Set landc to ncyl, wpcc to -1.
			 *   Set ctrl to 0 or 8 depending on head count.
			 *
			 * Follow INT 0x41/46 to get drive static BIOS drive
			 * parameters, if any.
			 *
			 * If there were no parameters from tertiary boot,
			 * or if INT 0x4? nhead and nspt match tboot parms,
			 *   use "INT" parameters (will give better match on
			 *   wpcc, landc, and ctrl fields, which tboot can't
			 *   give us).
			 */
.DE
.DM
			FIFO * ffp;
			typed_space * tp;
			int found, parm_int;
.DE
.DM
if (F_NULL != (ffp = fifo_open (& boot_gift, 0))) {
			for (found = 0; ! found && (tp = fifo_read (ffp)); ) {
				BIOS_DISK * bdp = (BIOS_DISK *)tp->ts_data;
				if ((T_BIOS_DISK == tp->ts_type) &&
				    (u == bdp->dp_drive) ) {
					found = 1;
					_NUM_TO_CHAR2(dp->ncyl,
					  bdp->dp_cylinders);
					dp->nhead = bdp->dp_heads;
					dp->nspt = bdp->dp_sectors;
					_NUM_TO_CHAR2(dp->wpcc, 0xffff);
					_NUM_TO_CHAR2(dp->landc,
					  bdp->dp_cylinders);
					if (dp->nhead > 8)
						dp->ctrl |= 8;
				}
			}
			fifo_close (ffp);
}
.DE
.DM
			if (u == 0)
				parm_int = 0x41;
			else /* (u == 1) */
				parm_int = 0x46;
			pxcopy ((paddr_t)(parm_int * 4), & p, sizeof p, SEL_386_KD);
			pxcopy ((paddr_t)(p.seg <<4L)+ p.off,
				& int_dp, sizeof (int_dp), SEL_386_KD);
.DE
.DM
			if (! found || (dp->nhead == int_dp.nhead &&
			     		dp->nspt == int_dp.nspt)) {
				* dp = int_dp;
				printf ("Using INT 0x%x", parm_int);
			} else
				printf ("Using INT 0x13(08)");
.DE
.DM
		} else {
			printf ("Using patched");
			/*
			 * Avoid incomplete patching.
			 */
			if (at.at_dtype [u] == 0)
				at.at_dtype [u] = 1;
			if (dp->nspt == 0)
				dp->nspt = 17;
		}
.DE
.DM
#if VERBOSE > 0
	printf (" drive %d parameters\en", u);

	cmn_err (CE_CONT,
		 "at%d: ncyl=%d nhead=%d wpcc=%d eccl=%d ctrl=%d landc=%d "
		 "nspt=%d\en", u, _CHAR2_TO_USHORT (dp->ncyl), dp->nhead,
		 _CHAR2_TO_USHORT (dp->wpcc), dp->eccl, dp->ctrl,
		 _CHAR2_TO_USHORT (dp->landc), dp->nspt);
#endif
	}
.DE
.DM
	/* Initialize Drive Size. */
	for (u = 0, dp = atparm; u < at_drive_ct; ++ dp, ++ u) {
		if (at.at_dtype [u] == 0)
			continue;

.DE
.DM
		pparm [N_ATDRV * NPARTN + u].p_size =
			(long) _CHAR2_TO_USHORT (dp->ncyl) * dp->nhead *
				dp->nspt;
	}
.DE
.DM
	/* Initialize Drive Controller.	 */
	atreset ();
}
.DE
.SH "Unload Routine"
.PP
Function
.B atunload()
is called when this driver is unloaded from memory \(em or would be, if
\*(CO 4.2 supported loadable drivers.
.DM
LOCAL void
atunload ()
{
}
.DE
.SH "Reset the Controller"
.PP
Function
.B atreset()
resets the hard-disk controller and defines drive characteristics.
.DM
LOCAL void
atreset ()
{
	int u;
	struct hdparm_s * dp;
.DE
.DM
	/* Reset controller for a minimum of 4.8 microseconds. */
	outb (HF_REG, 4);
	for (u = 100; -- u != 0;)
		/* DO NOTHING */ ;
	outb (HF_REG, atparm [0].ctrl & 0x0F);
	ATBSYW (0);
.DE
.DM	if (inb (AUX_REG) != 0x01) {
		/*
		 * Some IDE drives always timeout on initial reset.
		 * So don't report first timeout.
		 */
		static one_bad;
.DE
.DM
		if (one_bad)
			printf ("at: hd controller reset timeout\en");
		else
			one_bad = 1;
	}
.DE
.DM
	/* Initialize drive parameters. */
	for (u = 0, dp = atparm; u < at_drive_ct; ++ dp, ++ u) {
		if (at.at_dtype [u] == 0)
			continue;
		ATBSYW (u);
.DE
.DM
		/* Set drive characteristics. */
		outb (HF_REG, dp->ctrl);
		outb (HDRV_REG, 0xA0 + (u << 4) + dp->nhead - 1);
.DE
.DM
		outb (AUX_REG, _CHAR2_TO_USHORT (dp->wpcc) / 4);
		outb (NSEC_REG, dp->nspt);
		outb (SEC_REG, 0x01);
		outb (LCYL_REG, dp->ncyl [0]);
		outb (HCYL_REG, dp->ncyl [1]);
		outb (CSR_REG, SETPARM_CMD);
		ATBSYW (u);
.DE
.DM
		/* Restore heads. */
		outb (CSR_REG, RESTORE (0));
		ATBSYW (u);
	}
}
.DE
.SH "Open Routine"
.PP
Function
.B atopen()
is called when a user's application invokes the system call
.B open()
for an AT device.
A pointer to this function appears in field
.B c_open
of the
.B CON
structure at the end of this driver.
.PP
This function validating the minor device (that is, ensures that the
user is attempting to open a devices that exists), and updates
the paritition table if necessary.
.DM
LOCAL void
atopen (dev, mode)
dev_t dev;
{
	int d;		/* drive */
	int p;		/* partition */
.DE
.DM
	p = minor (dev) % (N_ATDRV * NPARTN);
	if (minor (dev) & SDEV) {
		d = minor (dev) % N_ATDRV;
		p += N_ATDRV * NPARTN;
	} else
		d = minor (dev) / NPARTN;
.DE
.DM
	if (d >= N_ATDRV || at.at_dtype [d] == 0) {
		printf ("atopen: drive %d not present ", d);
		set_user_error (ENXIO);
		return;
	}
	if (minor (dev) & SDEV)
		return;
.DE
.DM
	/* If partition not defined read partition characteristics. */
	if (pparm [p].p_size == 0)
		fdisk (makedev (major (dev), SDEV + d), & pparm [d * NPARTN]);
.DE
.DM
	/* Ensure partition lies within drive boundaries and is non-zero size. */
	if (pparm [p].p_base + pparm [p].p_size >
	    pparm [d + N_ATDRV * NPARTN].p_size) {
		printf ("atopen: p_size too big ");
		set_user_error (EINVAL);
	} else if (pparm [p].p_size == 0) {
		printf ("atopen: p_size zero ");
		set_user_error (ENODEV);
	}
}
.DE
.SH "Read Routine"
.PP
Function
.B atread()
is called when a user's application invokes the system call
.B read()
for an AT device.
A pointer to this function appears in field
.B c_read
of the
.B CON
structure at the end of this driver.
This function simply invokes the common code for processing raw I/O.
.DM
LOCAL void
atread (dev, iop)
dev_t dev;
IO *iop;
{
	ioreq (NULL, iop, dev, BREAD, BFRAW | BFBLK | BFIOC);
}
.DE
.SH "Write Routine"
.PP
Function
.B atwrite()
is called when a user's application invokes the system call
.B write()
for an AT device.
A pointer to this function appears in field
.B c_write
of the
.B CON
structure at the end of this driver.
This function simply invokes the common code for processing raw I/O.
.DM
LOCAL void
atwrite (dev, iop)
dev_t dev;
IO *iop;
{
	ioreq (NULL, iop, dev, BWRITE, BFRAW | BFBLK | BFIOC);
}
.DE
.SH "ioctl Routine"
.PP
Function
.B atioctl()
is called when a user's application invokes the system call
.B ioctl()
for an AT device.
A pointer to this function appears in field
.B c_ioctl
of the
.B CON
structure at the end of this driver.
This function validates the minor device and
updates the paritition table if necessary.
.DM
LOCAL void
atioctl (dev, cmd, vec)
dev_t dev;
int cmd;
char *vec;
{
	int d;
.DE
.DM
	/* Identify drive number. */
	if (minor (dev) & SDEV)
		d = minor (dev) % N_ATDRV;
	else
		d = minor (dev) / NPARTN;
.DE
.DM
	/* Identify input / output request. */
	switch (cmd) {
	case HDGETA:
		/* Get hard disk attributes. */
		kucopy (atparm + d, vec, sizeof (atparm [0]));
		break;
.DE
.DM
	case HDSETA:
		/* Set hard disk attributes. */
		ukcopy (vec, atparm + d, sizeof (atparm [0]));
		at.at_dtype [d] = 1;	/* set drive type nonzero */
		pparm [N_ATDRV * NPARTN + d].p_size =
			  (long) _CHAR2_TO_USHORT (atparm [d].ncyl) *
			  atparm [d].nhead * atparm [d].nspt;
		atreset ();
		break;
.DE
.DM
	default:
		set_user_error (EINVAL);
		break;
	}
}
.DE
.SH "Watch for Interrupts"
.PP
Function
.B atwatch()
watches for interrupts.
If
.B drvl[AT_MAJOR]
is greater than zero, this function decrements it.
If it decrements to zero, it simulates a hardware interrupt.
.DM
LOCAL void
atwatch()
{
	BUF * bp = at.at_actf;
	int s;
.DE
.DM
	s = sphi ();
	if (-- drvl [AT_MAJOR].d_time > 0) {
		spl (s);
		return;
	}
.DE
.DM
	/* Reset hard disk controller, cancel request. */
	atreset ();
	if (at.at_tries ++ < SOFTLIM) {
		atstart ();
	} else {
		printf ("at%d%c: bno=%lu head=%u cyl=%u nsec=%u tsec=%d "
			"dsec=%d <Watchdog Timeout>\en", at.at_drv,
			(bp->b_dev & SDEV) ? 'x' : at.at_partn % NPARTN + 'a',
			bp->b_bno, at.at_head, at.at_cyl, at.at_nsec,
			at.at_totalsec, inb (NSEC_REG));
.DE
.DM
		at.at_actf->b_flag |= BFERR;
		atdone (at.at_actf);
	}
	spl (s);
}
.DE
.SH "Block Function"
.PP
Function
.B atblock()
queues a block to the disk.
It also ensures that the transfer is within the disk partition.
.DM
LOCAL void
atblock (bp)
BUF	* bp;
{
	struct fdisk_s * pp;
	int partn = minor (bp->b_dev) % (N_ATDRV * NPARTN);
	int s;
.DE
.DM
	bp->b_resid = bp->b_count;
	if (minor (bp->b_dev) & SDEV)
		partn += N_ATDRV * NPARTN;
	pp = pparm + partn;
.DE
.DM
	/* Check for read at end of partition. */
	if (bp->b_req == BREAD && bp->b_bno == pp->p_size) {
		bdone (bp);
		return;
	}
.DE
.DM
	/* Range check disk region. */
	if (bp->b_bno + (bp->b_count / BSIZE) > pp->p_size ||
	    bp->b_count % BSIZE != 0 || bp->b_count == 0) {
		bp->b_flag |= BFERR;
		bdone (bp);
		return;
	}
.DE
.DM
	s = sphi ();
	bp->b_actf = NULL;
	if (at.at_actf == NULL)
		at.at_actf = bp;
	else
		at.at_actl->b_actf = bp;
	at.at_actl = bp;
	spl (s);
.DE
.DM
	if (at.at_state == SIDLE)
		if (atdequeue ())
			atstart ();
}
.DE
.SH "Dequeue a Request"
.PP
Function
.B atdequeue()
obtains the next request for disk I/O.
.DM
LOCAL int
atdequeue ()
{
	BUF * bp;
	struct fdisk_s * pp;
	struct hdparm_s * dp;
	unsigned int nspt;
	ldiv_t		addr;
	unsigned short	secs;
	unsigned short	newsec;
.DE
.DM
	at.at_tries = 0;
	if ((bp = at.at_actf) == NULL)
		return 0;
.DE
.DM
	at.at_partn = minor (bp->b_dev) % (N_ATDRV * NPARTN);
	if (minor (bp->b_dev) & SDEV) {
		at.at_partn += N_ATDRV * NPARTN;
		at.at_drv = minor (bp->b_dev) % N_ATDRV;
	} else
		at.at_drv = minor (bp->b_dev) / NPARTN;
.DE
.DM
	nspt = atparm [at.at_drv].nspt;
	at.at_addr = bp->b_paddr;
	pp = pparm + at.at_partn;
	at.at_bno = pp->p_base + bp->b_bno;
.DE
.DM
	dp = atparm + at.at_drv;
	addr = ldiv (at.at_bno, dp->nspt);
	at.at_sec = addr.rem + 1;
	addr = ldiv (addr.quot, dp->nhead);
	at.at_cyl = addr.quot;
	at.at_head = addr.rem;
.DE
The following code was added to the driver for \*(CO 4.2, to speed I/O
on the AT disk.
The following explains how this speed-up works.
.PP
It is unclear why, but IDE writes appear always to lose a revolution,
even though reads work comfortably.
This may be caused by IDE drives trying to maintain the synchronous
semantics of the write, or it may be due to
the \*(CO kernel's not making the read time and the
slack being taken up by track-buffering.
.PP
In either case, \*(CO gains a vast improvement in throughput for writes and
a modest gain for reads by looking ahead in the request chain and
coalescing separate requests to consecutive blocks into a single
multi-sector request.
.DM
	newsec = secs = bp->b_count / BSIZE;
	while (bp->b_actf != NULL && bp->b_actf->b_bno == bp->b_bno + secs &&
	       bp->b_actf->b_req == bp->b_req &&
	       bp->b_actf->b_dev == bp->b_dev) {
		/*
		 * Take care to bound the length of the combined request to a
		 * single byte count of sectors.
		 */
		bp = bp->b_actf;
.DE
.DM
		if (newsec + (secs = bp->b_count / BSIZE) > 256)
			break;
		newsec += secs;
	}
	at.at_totalsec = at.at_nsec = newsec;
	return 1;
}
.DE
.SH "Send Data to the Disk"
.PP
Function
.B atsend()
actually moves data onto the disk.
.DM
LOCAL void
atsend (addr)
paddr_t addr;
{
	addr = P2P (addr);
	repoutsw (DATA_REG, (unsigned short *) __PTOV (addr), BSIZE / 2);
}
.DE
.SH "Receive Data from the Disk"
.PP
Function
.B atrecv()
actually receives data from the disk.
.DM
LOCAL void
atrecv (addr)
paddr_t addr;
{
	addr = P2P (addr);
	repinsw (DATA_REG, (unsigned short *) __PTOV (addr), BSIZE / 2);
}
.DE
.SH "Abandon a Request"
.PP
Function
.B atabandon()
abandons a request for disk I/O.
.DM
LOCAL void
atabandon ()
{
	buf_t *bp;
.DE
.DM
	/* Abandon this operation. */
	while ((bp = at.at_actf) != NULL) {
		at.at_actf = bp->b_actf;
		bp->b_flag |= BFERR;
		bdone (bp);
	}
	at.at_state = SIDLE;
}
.DE
.SH "Start a Read/Write Operation"
.PP
Function
.B atstart()
starts or restarts the next disk read/write operation.
.DM
LOCAL void
atstart ()
{
	struct hdparm_s * dp;
.DE
.DM
	/* Check for repeated access to most recently identified bad track. */
	ATBSYW (at.at_drv);
	dp = atparm + at.at_drv;
	outb (HF_REG, dp->ctrl);
	outb (HDRV_REG, (at.at_drv << 4) + at.at_head + 0xA0);
.DE
.DM
	outb (NSEC_REG, at.at_nsec);
	outb (SEC_REG, at.at_sec);
	outb (LCYL_REG, at.at_cyl);
	outb (HCYL_REG, at.at_cyl >> 8);
.DE
.DM
	if (inb (NSEC_REG) != (at.at_nsec & 0xFF)) {
		/*
		 * If we get here, things are confused. We should reset the
		 * controller and retry whatever operation we want to start
		 * now.
		 */
		drvl [AT_MAJOR].d_time = 1;
		return;
	}
.DE
.DM
	if (at.at_actf->b_req == BWRITE) {
		outb (CSR_REG, WRITE_CMD);
		while (ATDRQ () == 0) {
			atabandon ();
			return;
		}
		atsend (at.at_addr);
		at.at_state = SWRITE;
	} else {
		outb (CSR_REG, READ_CMD);
		at.at_state = SREAD;
	}
.DE
.DM
	drvl [AT_MAJOR].d_time = ATSECS;
}
.DE
.SH "Interrupt Handler"
.PP
Function
.B atintr()
handles interrupts.
It clears the interrupt, and defers its processing until a more suitable time.
.DM
void
atintr ()
{
	(void) inb (CSR_REG);	/* clears controller interrupt */
	atdefer ();
}
.DE
.SH "Defer Service of an Interrupt"
.PP
Function
.B atdefer()
actually services the hard-disk interrupt.
It transfers the required data, and updates the state of the device.
.DM
LOCAL void
atdefer ()
{
	BUF * bp = at.at_actf;
	switch (at.at_state) {
	case SRETRY:
		atstart ();
		break;
.DE
.DM
	case SREAD:
		/* Check for I/O error before waiting for data. */
		if (aterror ()) {
			atrecov ();
			break;
		}
.DE
.DM
		/* Wait for data, or forever. */
		if (ATDRQ () == 0) {
			atabandon ();
			break;
		}
.DE
.DM
		/* Read data block.*/
		atrecv (at.at_addr);
.DE
.DM
		/* Check for I/O error after reading data. */
		if (aterror ()) {
			atrecov ();
			break;
		}
.DE
.DM
		/*
		 * Every time we transfer a block, bump the timeout to prevent
		 * very large multisector transfers from timing out due to
		 * sheer considerations of volume.
		 */
		drvl [AT_MAJOR].d_time = ATSECS * 2;
.DE
.DM
		at.at_addr += BSIZE;
		bp->b_resid -= BSIZE;
		at.at_tries = 0;
		at.at_bno ++;
.DE
.DM
		/*
		 * Check for end of transfer (total, or simply part of a large
		 * combined request).
		 */
		if (-- at.at_nsec == 0)
			atdone (bp);
		else if (bp->b_resid == 0) {
			at.at_addr = (at.at_actf = bp->b_actf)->b_paddr;
			bdone (bp);
		}
		break;
.DE
.DM
	case SWRITE:
		/* Check for I/O error. */
		if (aterror ()) {
			atrecov ();
			break;
		}
.DE
.DM
		/* bump timeout again, for reasons given above. */
		drvl [AT_MAJOR].d_time = ATSECS * 2;
.DE
.DM
		at.at_addr += BSIZE;
		bp->b_resid -= BSIZE;
		at.at_tries = 0;
		at.at_bno ++;
.DE
.DM
		/*
		 * Check for end of transfer, either the real end or the end
		 * of a block boundary in a combined transfer.
		 */
		if (-- at.at_nsec == 0) {
			atdone (bp);
			break;
		} else if (bp->b_resid == 0)
			at.at_addr = bp->b_actf->b_paddr;
.DE
.DM
		/* Wait for ability to send data, or forever. */
		while (ATDRQ () == 0) {
			atabandon ();
			break;
		}
.DE
.DM
		/* Send data block. */
		atsend (at.at_addr);
		if (bp->b_resid == 0) {
			at.at_actf = bp->b_actf;
			bdone (bp);
		}
	}
}
.DE
.SH "Check for an Error"
.PP
Function
.B aterror()
checks for drive error.
If it finds an error, it increments the error count and prints a
message that reports the error.
It returns zero if it did not find an error, and one if it did.
.DM
LOCAL int
aterror ()
{
	BUF * bp = at.at_actf;
	int csr;
	int aux;
.DE
.DM
	if ((csr = inb (ATSREG)) & (ERR_ST | WFLT_ST)) {
		aux = inb (AUX_REG);
.DE
.DM
		if (aux & BAD_ERR) {
			at.at_tries	= BADLIM;
		} else if (++ at.at_tries < SOFTLIM)
			return 1;
.DE
.DM
		printf ("at%d%c: bno =%lu head =%u cyl =%u",
			at.at_drv,
			(bp->b_dev & SDEV) ? 'x' : at.at_partn % NPARTN + 'a',
			(bp->b_count / BSIZE) + bp->b_bno - at.at_nsec,
			at.at_head, at.at_cyl);
.DE
.DM
		if ((csr & (RDY_ST | WFLT_ST)) != RDY_ST)
			printf (" csr =%x", csr);
		if (aux & (DAM_ERR | TR0_ERR | ID_ERR | ECC_ERR | ABT_ERR))
			printf (" aux =%x", aux);
.DE
.DM
		if (aux & BAD_ERR)
			printf (" <Block Flagged Bad>");
		if (at.at_tries < HARDLIM)
			printf (" retrying...");
		printf ("\en");
		return 1;
	}
	return 0;
}
.DE
.SH "Attempt to Recover from an Error"
.PP
Function
.B atrecov()
attempts to recover from a reported error.
.DM
LOCAL void
atrecov ()
{
	BUF * bp = at.at_actf;
	int cmd = SEEK (0);
	int cyl = at.at_cyl;
.DE
.DM
	switch (at.at_tries) {
	case 1:
	case 2:
		/* Move in 1 cylinder, then retry operation */
		if (--cyl < 0)
			cyl += 2;
		break;
.DE
.DM
	case 3:
	case 4:
		/* Move out 1 cylinder, then retry operation */
		if (++ cyl >= _CHAR2_TO_USHORT (atparm [at.at_drv].ncyl))
			cyl -= 2;
		break;
.DE
.DM
	case 5:
	case 6:
		/* Seek to cylinder 0, then retry operation */
		cyl = 0;
		break;
.DE
.DM
	default:
		/* Restore drive, then retry operation */
		cmd = RESTORE (0);
		cyl = 0;
		break;
	}
.DE
.DM
	/* Retry operation [after repositioning head] */
	if (at.at_tries < HARDLIM) {
		drvl [AT_MAJOR].d_time = cmd == RESTORE (0) ? ATSECS * 2 :
							      ATSECS;
		outb (LCYL_REG, cyl);
		outb (HCYL_REG, cyl >> 8);
		outb (HDRV_REG, (at.at_drv << 4) + 0xA0);
		outb (CSR_REG, cmd);
		at.at_state = SRETRY;
	} else {
.DE
.DM
		/* Give up on block. */
		bp->b_flag |= BFERR;
		atdone (bp);
	}
}
.DE
.SH "Release the Current I/O Buffer"
.PP
Function
.B atdone()
releases the current I/O buffer.
.DM
LOCAL void
atdone (bp)
BUF * bp;
{
	at.at_actf = bp->b_actf;
	drvl [AT_MAJOR].d_time = 0;
	at.at_state = SIDLE;
.DE
.DM
	if (atdequeue ())
		atstart ();
	bdone (bp);
}
.DE
.SH "Indicate the Drive Is Not Busy"
.PP
Function
.B notBusy()
indicates that the drive is not busy.
See macro
.BR NOTBUSY() ,
defined above.
.DM
int
notBusy ()
{
	return NOTBUSY ();
}
.DE
.SH "Indicate Whether Data Have Been Requested"
.PP
Function
.B dataRequested()
indicates whether data have been requested.
See macro
.BR DATAREQUESTED() ,
defined above.
.DM
int
dataRequested ()
{
	return DATAREQUESTED ();
}
.DE
.SH "Report a Timeout, First Version"
.PP
Function
.B _report_timeout()
actually prints the message that reports that an I/O operation has
timed out.
.DM
static	int report_scheduled;
static	int report_drv;
LOCAL void
_report_timeout ()
{
	printf (timeout_msg, report_drv);
	report_scheduled = 0;
}
.DE
.SH "Report a Timeout, Second Version"
.PP
Function
.B report_timeout()
manages the task of reporting that an I/O request has timed out.
.DM
LOCAL void
report_timeout (unit)
int unit;
{
	short s = sphi();
	if (report_scheduled == 0) {
		report_scheduled = 1;
		spl(s);
.DE
.DM
		report_drv = unit;
		defer (_report_timeout);
	} else
		spl (s);
}
.DE
.SH "Wait Until the Controller Is Freed"
.PP
Function
.B myatbsyw()
waits while the controller is busy.
It returns zero if the driver timed out while executing this I/O task;
or a non-zero value if it did not.
.DM
int
myatbsyw (unit)
int unit;
{
	if (busyWait (notBusy, ATSECS * HZ))
		return 1;
	report_timeout (unit);
	return 0;
}
.DE
.SH "Wait for Controller to Initiate Request"
.PP
Function
.B atdrq()
waits for the controller to initiate a request.
It returns zero if the driver timed out while waiting; or one if it
did not.
.DM
int
atdrq ()
{
	if (busyWait (dataRequested, ATSECS /* * HZ */))
		return 1;
	report_timeout (at.at_drv);
	return 0;
}
.DE
.SH "The CON Structure"
.PP
Finally, the following gives the
.B CON
structure for this driver.
This structure contains pointers to the functions to be invoked by
the kernel's system calls.
For details on this structure, see the entry for
.B CON
in this manual's Lexicon.
.DM
CON	atcon	= {
	DFBLK | DFCHR,			/* Flags */
	AT_MAJOR,			/* Major index */
	atopen,				/* Open */
	NULL,				/* Close */
	atblock,			/* Block */
	atread,				/* Read */
	atwrite,			/* Write */
	atioctl,			/* Ioctl */
	NULL,				/* Powerfail */
	atwatch,			/* Timeout */
	atload,				/* Load */
	atunload			/* Unload */
};
.DE
.SH "Where To Go From Here"
.PP
The following section gives an example of a driver for a character device.
The kernel functions invoked in this driver are described in this manual's
Lexicon.

.ds TL Errata
.NH "Notes and Errata"
.PP
The following notes limitations that have been discovered with \*(CO.
It also notes errors that have been found in the \*(CO manual, and
describes extensions to the \*(CO Lexicon that have been since the manual
was printed (but are available in the on-line Lexicon).
Try as we might, no system the size and complexity of \*(CO will ever
be entirely free of errors.
We hope that you will note these problems in your manual, and that you will
accept our apologies for any inconvenience they may have caused you.
.SH "Before and After You Update"
.PP
The following gives helpful hints that you should consider before
you update to \*(CO 4.2.
.IP \(bu 0.3i
Before you update, be sure your file system is intact.
Run \fBfsck\fR on your root file system, at least, before you attempt
to update.
.IP \(bu
When you install third-party packages, we recommend that you run in
single-user mode.
This will considerably lessen the complications of installation.
.PP
After you install \*(CO, the following describes how to update your
system to enable new devices:
.IP \(bu 0.3i
To install or de-install a parallel printer:
.DM
	cd /etc/conf
	lp/mkdev
	/conf/mlpconfig
	bin/idmkcoh -o /\fIkernel_name\fP
.DE
.IP \(bu
To install STREAMS or floating-point emulation:
.DM
	cd /etc/conf
	em87/mkdev
		\fIor\fP
	streams/mkdev
	bin/idmkcoh -o /\fIkernel_name\fP
.DE
.IP \(bu
To install a driver for asynchronous ports, first edit
.B /etc/default/async
as described in the Lexicon; then:
.DM
	cd /etc/conf
	asy/mkdev
	bin/idmkcoh -o /\fIkernel_name\fP
.DE
.IP \(bu
To disable a hard-drive controller:
.DM
	cd /etc/conf
	bin/idenable -d \fIdisk_driver\fP
	bin/idmkcoh -o /\fIkernel_name\fP
.DE
where
.I disk_driver
is one of the following:
.DS
	\fBat\fR	AT disk driver
	\fBaha\fR	Old-style Adaptec driver
	\fBss\fR	Seagate/Future Domain driver
	\fBhai\fR	Host-independent Adaptec driver
.DE
.IP \(bu
To enable a hard drive:
.DM
	cd /etc/conf
	bin/idenable -e \fIdisk_driver\fP
	# if you are installing the hai driver:
	# hai/mkdev
	bin/idmkcoh -o /\fIkernel_name\fP
.DE
where
.I disk_driver
is one of the following:
.DS
	\fBat\fR	AT disk driver
	\fBaha\fR	Old-style Adaptec driver
	\fBss\fR	Seagate/Future Domain driver
	\fBhai\fR	Host-independent Adaptec driver
.DE
.IP \(bu
To change from a loadable versus a non-loadable keyboard driver,
to change the video adapter, or to add or remove virtual consoles:
.DM
	cd /etc/conf
	console/mkdev
	bin/idmkcoh -o /\fIkernel_name\fR
.DE
.SH "Known Limitations"
.PP
\*(CO 4.2 contains the following limitations:
.IP \(bu 0.3i
The program that converts old \*(UU files into the Taylor format makes
a number of assumptions about the form and content of the old files.
If those assumptions are not met, the program may write something
non-functional into one of the new \*(UU files.
Please note the following in particular:
.RS
.IP \(bu 0.3i
On occasion, times are converted without a day of week into the
.B sys
file.
.IP \(bu
Some commands that the old
.B Permissions
file allowed do not always make it into
.BR sys .
.IP
Be sure to read the generated files
.BR sys ,
.BR dial ,
and
.B port
to make sure that all is correct.
For details, check the Lexicon entries for these files.
.RE
.IP \(bu
The command
.B uumvlog
manages the log files that are kept in directory /usr/spool/uucp/.Log.
However, it does not touch the files kept in directory
/usr/spool/uucp/.Admin.
These files log all UUCP connections to your system, and can grow quite large.
You must manage the files by hand.
.SH "Notes"
.PP
The following should be noted prior to using \*(CO.
.IP \(bu 0.3i
This release of \*(CO does not include the floppy tape driver.
It is under development, but was not ready in time to be included in this
release.
It will be available shortly and will be posted on the
Mark Williams Company Bulletin Board System.
If you require the driver on floppy disk
please contact our Sales Department at 1-800-636-6700 or 708-291-6700.
We apologize for this delay and thank you for your patience and understanding.
.IP \(bu
The archiving utility
.B pax
has been removed from \*(CO.
This command (which was linked to the commands
.BR cpio ,
.BR tar ,
and
.BR ustar )
has been replaced by the commands
.B gnucpio
and
.BR gtar .
The former is linked to the command
.B tar
and the latter to
.BR cpio .
Both are robust utilities that are supplied by the Free Software Foundation
under its ``copyleft''.
For information on these utilities, see their manual pages in these notes,
or through the command
.BR man .
.SH "Documentation Revisions"
.PP
The following notes errors in revision 10 of the \*(CO manual.
The on-line Lexicon contains corrected entries, which you can view with the
command
.BR man .
.\".IP \(bu 0.3i
.\"The second paragraph of section `LICENSE' in the \*(CO Software License
.\"Agreement printed on the back cover of revision 10 of the COHERENT manual
.\"contains the following sentence:
.\".QS
.\"You shall, however, include in each
.\"Composite Program, and on the exterior label of every diskette, a copyright
.\"notice in this form: ``Portions of this program, copyright 1982, 1993, Mark
.\"Williams Company.''.
.\".QE
.\".IP
.\"The phrase ``and on the exterior label of every diskette''
.\"was included in the Software License
.\"Agreement in error, and should be regarded as void.
.IP \(bu 0.3i
The Lexicon entry for
.B signame[\^]
states that the signal numbers are offset by one within the array.
This is incorrect:
the signal numbers are not offset at all.
.IP \(bu
The Lexicon entry for
.B fopen()
states that the maximum number of
files structures that can be opened at any one time is 20.
Actually, maximum number of files is set by the manifest constant
.B FOPEN_MAX ,
which is defined in header file
.BR stdio.h .
For release 4.2, this is set to 60.
.IP \(bu
The default entry separator
for the command
.B help
is now the at-sign `@' instead of the pound sign `#'.
This permits us to include information on library routines and system
calls in the help file; using the `#' as a separator would cause
.B help
to abort when it read the string
.BR #include .
.IP \(bu
The command
.B man
recognizes index entries in either the new, 4.2 style, or in the old 4.0 style.
The former uses three fields, which are separated by tab characters;
the latter has two fields which are separated by one or more space characters.
.IP \(bu
The command
.B uuinstall
does not always work correctly:
on some terminals, the arrow keys do not move the cursor.
In this case, use
.BR vi -style
cursor-movement keys:
.DS
	\fBH\fR	Move the cursor left
	\fBK\fR	Move the cursor up
	\fBL\fR	Move the cursor right 
	\fBJ\fR	Move the cursor down
.DE
.IP \(bu
The Lexicon entry for the function
.B setgrent()
is wrong:
it actually returns nothing.
.PP
The following notes changes and revisions to the \*(CO documentation
that have occurred since revision 10 was printed.
To read them, use the
.B man
command to view the Lexicon entries in question:
.IP \(bu
As noted above, \*(CO release 4.2 includes System V-style tools for modifying
and rebuilding the kernel.
For information on how to use these tools,
see the articles
.BR cohtune ,
.BR idenable ,
.BR idmkcoh ,
and
.BR idtune .
.IP \(bu
The \*(CO console driver has been revised and extended.
It now supports something like the \*(PX's command set for consoles.
.IP \(bu
\*(CO now includes the tools
.B gnucpio
and
.BR gtar .
The on-line Lexicon entries for them give details on how to use them.
.IP \(bu
The Lexicon entry for
.B ioctl()
has been rewritten to list all commands that this system call recognizes.
.IP \(bu
.B make
has been drastically extended and revised.
The on-line Lexicon entry for
.B make
summarizes these changes.
.IP \(bu
The Korn shell
.B ksh
now supports
.BR vi -style
command-line editing.
The on-line Lexicon entry for
.B ksh
describes how to use this feature.
.IP \(bu
\*(CO now includes release 1.7 of the editor
.BR elvis .
The on-line Lexicon entry for
.B elvis
summarizes the changes from release 1.6.
.IP \(bu
The on-line Lexicon entry for
.B terminfo
describes several hundred instructions that were added since the manual
was printed.
.IP \(bu
The on-line entries for
.B tape
summarize \*(CO's tape facilities and describe the
.B tape
command, which lets you manipulate tape devices.
.IP \(bu
Where applicable, the on-line Lexicon's entries
for library routines, header files,
and system calls now include cross-references to the \*(PX.
.IP \(bu
The command
.B shutdown
now uses the script written by Udo Munk, which offers many more features
to users.
The on-line Lexicon entry for
.B shutdown
describes them.
.IP \(bu
The on-line Lexicon entry for the visual shell
.B vsh
now describes number of recently added features.
.IP \(bu
The Bourne shell
.B sh
now supports functions.
Its entry in the on-line Lexicon gives details and examples.
.IP \(bu
The Lexicon also contains many new articles in addition to the ones
mentioned above.
Some describe new library functions and system calls; others give
technical information or describe new commands.
New articles are being added constantly; for a canonical list, use
.B man
to read the latest version of the article
.BR Lexicon .

.II "nroff^tutorial"
.ds PN \\fBnroff\\fR
.ds TL "nroff Text-Formatting Language"
.NH "nroff, The Text-Formatting Language" 1
.PP
.B nroff
is the \*(CO system's text-formatting language.
You write a file that mingles the text you want formatted with commands
to control the formatting.
\fBnroff\fR then uses the commands to format the text, and writes the formatted
text onto the standard-output device.
.PP
This tutorial describes how to work with
.B nroff.
It assumes you are familiar with the basic features of the \*(CO system.
In particular, you should know what a
.I command
is, what a
.I file
is, and how to create and edit a file.
If you are not familiar with these concepts, read
.I "Using the COHERENT System"
before you read this tutorial.
.PP
The Lexicon also contains a number of articles that relate to
.BR nroff .
In particular, you should read the article for
.BR printer ,
which describes how you can print text under the \*(CO system.
.Sh "What is nroff?"
.PP
\*(PN is the text processor for \*(CO.
A \fItext processor\fR is a utility that accepts commands and text,
and uses the commands to format the text on a page.
The commands may call for simple formatting, such as indenting
each new paragraph five spaces, to complex formatting of columns
and entire pages.
.PP
A file that contains text mixed with \*(PN commands is called a
\fIscript\fR.
For example, the following \*(PN script
.DM
.II "Belloc, Hilaire"
	.nr Z 0 5
	.nf
	I tire of love,
	.ti \en+Z
	I sometimes tire of rhyme;
	.ti \en-Z
	But money makes me happy
	.ti \en+Z
	All the time!
	.fi
.DE
produces the following printed text:
.DM
.ta 0.5i 1.0i 1.5i 2.0i
	I tire of love,
		I sometimes tire of rhyme;
	But money makes me happy
		All the time!
.DE
An \*(PN script allows you to change your output very easily.
For example, change the minus sign \*(Ql\fB\-\fR\*(Qr in line 7
of the \*(PN to a plus sign \*(Ql+\*(Qr, and the formatted
text suddenly becomes:
.DM
.ta 0.5i 1.0i 1.5i 2.0i
	I tire of love,
		I sometimes tire of rhyme;
			But money makes me happy
				All the time!
.DE
As you can see, \*(PN is a powerful and versatile formatter.
.PP
In truth, however, \*(PN is both a text formatter and a text
formatting \fIlanguage\fR.
With \*(PN, you can
write your own text-formatting commands to handle automatically
the unique requirements of whatever formatting you need.
.Sh "nroff Input and Output"
.PP
.I Input
is what you give to \*(PN.
.I Output
is what \*(PN returns to you.
If you simply type
.DM
	nroff
.DE
then
.B nroff
accepts input from your keyboard, and prints its output on your screen.
For example, if you want \*(PN to process the contents of a file named
.BR script.r ,
type the command line
.DM
	nroff script.r
.DE
\*(PN then takes the file \fBscript.r\fR, processes it,
and in a few moments it displays the formatted text on your screen.
Note that the suffix
.B .r
is used by convention to indicate that a file contains an unprocessed
.B nroff
script.
.PP
You can save \*(PN's output by \fIredirecting\fR it into another file.
For example, you can redirect \*(PN's processed
output of the file \fBscript.r\fR into the file named
.B target
by using the following command:
.DM
	nroff script.r > target
.DE
.Sh "Printing nroff Output"
.PP
The \*(CO system's implementation of \fBnroff\fR currently
can be used with any variety of printer.
\*(CO, however, fully supports three varieties of printer:
Epson-compatible dot-matrix printers, printers that use the Hewlett-Packard
Page Control Language (PCL) (including the Hewlett-Packard LaserJet and
DeskJet
families of printers), and any printer that has implemented the PostScript
page-control language.
The following descriptions assume that you have plugged your printer into
a parallel port on your computer, and have installed \*(CO correctly
so that it can access your printer.
.PP
To print \fBnroff\fR output on an Epson-compatible printer, use the
commands \fBepson\fR and \fBlpr\fR.
For example, to print the \fBnroff\fR output that you have directed into
file \fBtext.out\fR, use the following command:
.DM
	epson text.out | lpr
.DE
Or, you can pipe the output of \fBnroff\fR directly into \fBepson\fR,
as follows:
.DM
	nroff -ms text.r | epson | lpr
.DE
In the above example, \fBtext.r\fR is your input, and \fB\-ms\fR invokes
the \fBms\fR package of macros.
.PP
To print on a printer that uses PCL, use the commands \fBhp\fR and \fBhpr\fR.
For example, to print the file \fBtext.out\fR on a PCL printer,
use the command:
.DM
	hp text.out | hpr -B
.DE
The option \fB\-B\fR to \fBhpr\fR suppresses 
the printing of a banner page.
If you wish, you can pipe the output of \fBnroff\fR directly into \fBhp\fR,
as follows:
.DM
	nroff -ms text.r | hp | hpr -B
.DE
To access a printer that uses PostScript, use the command \fBhpr\fR, but do
not use the command \fBhp\fR.
Also, you use must the \fB\-p\fR switch to \fBnroff\fR, which tells it to
generate PostScript output.
For example, the following command processes file \fBtext.r\fR into
PostScript output, and passes that output to a PostScript printer:
.DM
	nroff -p -ms text.r | hpr -B
.DE
All of the above commands are described in their respective entries in the
Lexicon.
.PP
You can also print the output of
.B nroff
through the
.B lp
spooler.
For information on that spooler, see its entry in the Lexicon.
For a summary of how the \*(CO system manages printers, see the Lexicon
entry for
.BR printer .
.Sh "nroff Limitations"
.PP
Because \fBnroff\fR is a text-formatting language rather than a text-formatter
\fIper se,\fR it makes no assumptions about how you want to lay out your page.
It does not automatically leave margins at the top and bottom of pages;
it does not automatically number pages;
it does not automatically format paragraphs.
You must use or create a set of formatting commands, called
.I macros,
to generate these features.
This tutorial will teach you how to write macros that can solve
nearly every conceivable formatting problem.
As you have seen, too, your copy of \*(CO
comes with a set of predefined macros, the \fB\-ms\fR macro package.
.Sh "The ms Macro Package"
.PP
.II "nroff^ms macros"
A macro package called
.B \-ms
is included with your copy of \*(PN.
It provides macros to format paragraphs, produce headers
and footers (the areas at the top and bottom of pages, respectively),
and perform most other page-formatting tasks.
\fB\-ms\fR is easy to use.
The command
.DM
	nroff \-ms
.DE
tells \*(PN to accept input from your keyboard, process it using the \fB\-ms\fR
macro package, and print the output on your screen.
The command
.DM
	nroff \-ms script.r
.DE
tells \*(PN to process
.B script.r
with the \fB\-ms\fR package and print the output on your terminal;
while the command
.DM
	nroff \-ms script.r >target
.DE
redirects the output of
.B nroff
into the file
.BR target ;
and
.DM
	nroff -ms script.r | lpr
.DE
prints the output on the line printer.
.PP
.II "nroff^macro definition"
Working with the \fB\-ms\fR macro package is
a good way to gain confidence in working with
.B nroff
commands.
Soon you will learn the correct way to encode \*(PN commands in your scripts.
.Sh "Using this Tutorial"
.PP
The only way to learn about
.B nroff
is to use it.
You should type all the examples in this tutorial into your computer and
observe how they work.
You should also alter the example and examine how
your changes affect what \*(PN produces.
Don't hesitate to experiment!
You can learn more from analyzing why something unexpected happens
than you can from simply copying an example that
works as you were told it would.
.PP
The first section describes how to use
.B nroff
with the
.B \-ms
macro package.
The second section describes how to perform sophisticated formatting.
For most users, this chapter contains all the information they need to know.
.PP
The rest of the tutorial describes how
.B nroff
actually works with the input text to produce its output.
This will teach you how to write your own \*(PN
macros for your special word processing needs.
.SH "The ms Macro Package"
.PP
As explained above,
.B nroff
is the text formatter for \*(CO.
You give \*(PN a \fIscript\fR \(em that is,
text interspersed with commands that control its processing;
\*(PN, in turn, formats your text in the manner dictated by your commands.
.PP
\*(PN's most outstanding feature is its flexibility:
you can control line length, page offset, page length, paragraph format,
beginning-  and end-of-page format,
and every other aspect of formatting a document.
.PP
.II "nroff^.PP macro"
\*(PN has built into it a set of basic commands,
called \fIprimitives\fR, that are used to control formatting.
A basic formatting function might require several primitives.
For example, formatting a new paragraph requires one
primitive to force the printing of the fragment
of a line left at the end of the previous paragraph;
another primitive to skip a blank line;
and a third primitive to indent the first line of the new paragraph.
If you were to type directly into your script all the primitives required to
control every feature of your document, formatting
would be a very difficult task, and mistakes would be common.
.PP
Fortunately, another feature of
.B nroff
makes it easier for you to prepare input:
\*(PN allows you to bundle together a group of primitives
and give the bundle its own name.
Such a bundle is called a
.IR macro .
Whenever you want all the commands in that bundle to be executed,
you simply insert the name of the macro into the text.
For example, you might group the primitives needed
to format a paragraph, and call that bundle \fBPP\fR.
Then, instead of retyping the primitives,
all you need to do is insert the command
.B .PP
before the start of a paragraph.
.PP
\fB\-ms\fR is a package of macros that are ready for you to use.
When you include the option \fB\-ms\fR on the \*(PN command line,
.B nroff
automatically uses the
the macros that have been defined in the \fB\-ms\fR package.
These macros will take
care of setting line length and page length, numbering pages,
formatting paragraphs, and all other formatting tasks.
You do not need to know how \*(PN's primitives
are used in the macros; you only need to know the names of the macros
and what they do, so that you can insert them correctly into your text.
.PP
Using the \fB\-ms\fR
package is a good way to become accustomed to preparing input for
.B nroff,
so that the features of the primitives will not seem so
alien when you eventually choose to work with them.
When you become familiar with \*(PN, you may wish to your own macro packages,
to handle the unique requirements of different types of documents.
For now, however, you will find that the \fB\-ms\fR package
will get you up and running with \*(PN.
.Sh "Text and Commands"
.PP
.B nroff
input includes both
.I text
and
.I commands.
The commands control the processing of the text.
.B nroff
distinguishes between text and commands by looking at the
first character of each input line.
If that character is a period or an apostrophe, the line is a \fIcommand\fR;
otherwise, it is \fItext\fR.
.PP
Earlier in this tutorial, you used the \fB\-ms\fR
package to format a text file that had already been prepared for you.
To become more accustomed to using
.B nroff,
try entering the following text into a file that can be
formatted later.
Use a text editor (either \fBed\fR or \*(ME) to create a file named
.B script2.r
that contains the following text.
It is important for this exercise that you
break up the lines as they are shown here:
.DM
.II "Dickens, Charles"
	London.  Michaelmas Term lately over,
	and the Lord Chancellor sitting in
	Lincoln's Inn Hall.  Implacable November weather.
	As much mud in the streets, as if the waters
	had but newly retired from the face of the
	earth, and it would not be wonderful to meet
	a Megalosaurus, forty feet long or so, waddling
	like an elephantine lizard up Holborn Hill.
.DE
Note that this file contains no commands;
every line is a text line.
Process the file with the command:
.DM
	nroff script2.r | more
.DE
The output is piped to
.B more
so that it will not all rush past your screen.
\*(PN will process the text, and
in a moment you will see the following:
.EX
London.  Michaelmas Term lately over,
and the Lord Chancellor sitting in
Lincoln's Inn Hall.  Implacable November weather.
As much mud in the streets, as if the waters
had but newly retired from the face of the
earth, and it would not be wonderful to meet
a Megalosaurus, forty feet long or so, waddling
like an elephantine lizard up Holborn Hill.
.EE
.II "nroff^justify text"
When you see this example, the spacing will be
different;
the spacing for the examples in this tutorial is adjusted to conform to
the rest of the tutorial text.
Notice that
.B nroff
automatically adjusts the spacing between words to
justify the right margin, even though the input
text has a ragged right margin.
Each output line contains 65 characters,
and each output page contains 66 lines.
.PP
Now try processing
.B script.r
again, this time with the
.B \-ms
macro package.
Type
.DM
	nroff \-ms script.r | more
.DE
.II "nroff^margin, right"
As you can see,
.B nroff
again adjusted the spacing to keep a strict right margin.
Each line was indented with ten leading spaces, followed by
65 characters of text.
The pages output by both the \fBnroff\fR command
and the \fBnroff \-ms\fR command both contain 66 lines, but
the page built with the \fB\-ms\fR package
left blank lines at the top of the page and
printed the page number in a blank space at the bottom of the page.
When \*(PN constructs its output, it assumes that your printer prints
ten characters per inch (Pica, or 10-pitch spacing) and six lines per inch.
Given these assumptions, each page of output from
.B "nroff \-ms"
fits onto an 8.5 by 11 inch page, with an inch of blank
space at the top, at the bottom, and on each side.
.PP
As this example shows,
.B nroff
adjusts the spacing between words to keep a strict right margin.
When you type in the text, don't worry about the right margin.
You must, however, keep a strict left margin, because when
.B nroff
encounters a line of text that begins with blank spaces,
it breaks the line it was working on and begins a new, indented line.
.II "nroff^breaking line"
.PP
.II "nroff^hyphenation"
Also, do not hyphenate words; if you do,
.B nroff
treats each part as a separate \*(QLword\*(QR
(the first ending with the hyphen character),
rather than keeping them joined, as you want.
.PP
.B nroff
normally interprets as a command every line
that begins with a \fIperiod\fR or an \fIapostrophe\fR.
However, to include an initial apostrophe or period as a literal part
of your document, you must place
the characters \fB\e&\fR before the period or apostrophe.
.PP
The remainder of this will show you how to use commands in input text
to change the appearance of the output.
You can control many aspects of the printed document
simply by including the appropriate commands within your text.
.PP
.II "nroff^.sp primitive"
.II "nroff^space, vertical"
.Sh "Command Names"
.PP
The name of every
.B nroff
primitive consists of two lower-case letters.
Some commands can also include additional information, or \fIarguments\fR.
For example,
.B .sp
is the command to leave vertical space between output lines.
The command line
.DM
	.sp
.DE
leaves one space, whereas
.DM
	.sp 2
.DE
leaves two spaces.
.II "nroff^command, argument"
The information that follows the command name on the command line is an
argument.
.II "nroff^macro, name"
Each macro defined in the
.B \-ms
macro package is named with one or two upper-case letters.
For example,
.B .PP
is the name of the macro that begins a new paragraph.
.Sh "Paragraphs"
.PP
.II "nroff^paragraph"
.II "nroff^.PP macro"
Every time you want to begin a new paragraph, enter the
.I paragraph
command
.B .PP;
that is, place the command line
.B .PP
in the text.
To test this macro, enter the following text under the name \fBscript3.r\fR:
.DM
.II "Austen, Jane"
	.PP
	It is a truth universally acknowledged,
	that a single man in possession of a good fortune,
	must be in want of a wife.
	.PP
	However little known the feelings or views of such
	a man may be on first entering a neighbourhood, the
	truth is so well fixed in the minds of the surrounding
	families, that he is considered as the rightful
	property of some one or the other of their daughters.
.DE
When you process this text with
the command
.DM
	nroff \-ms script3.r | more
.DE
the result resembles the following:
.EX
.ti 1.3i
It is a truth universally acknowledged,
that a single man in possession of a good fortune,
must be in want of a wife.
.sp
.ti 1.3i
However little known the feelings or views of such
a man may be on first entering a neighbourhood, the
truth is so well fixed in the minds of the surrounding
families, that he is considered as the rightful
property of some one or the other of their daughters.
.EE
As the output shows, the
.B .PP
command inserts a blank line before beginning a new
paragraph, and indents the first line of the new paragraph
by half an inch.
.PP
.II "nroff^.IP macro"
.II "nroff^paragraph, indented"
The
.B \-ms
package also provides another paragraph format:
the
.B .IP
command.
This macro creates an
.I "indented paragraph."
The
.B .PP
macro indents only the first line of each paragraph;
however,
.B .IP
indents every line \fIexcept\fR the first.
For example,
.DM
	.IP
	This is an indented paragraph.
	All the lines are indented by
	the same amount.
	.PP
	This is a normal paragraph.
	nroff indents the first line
	but does not indent the following lines.
.DE
gives the output
.EX
.in +0.5i
This is an indented paragraph.
All the lines are indented by
the same amount.
.in -0.5i
.sp
.ti +0.5i
This is a normal paragraph.
nroff indents the first line
but does not indent the following lines.
.EE
.II "nroff^tag on paragraph"
.II "nroff^paragraph tag"
Several options are available for the basic
.B .IP
macro.
You can add two
.I arguments
to it.
.B nroff
interprets the first argument after the
.B .IP
as a
.I tag
to the paragraph, and it interprets the second argument as the amount
of indentation you want.
For example,
.DM
	.IP A. 8
	This is the first line of text.
	nroff indents the following lines by the same
	amount as the first.
	The indent is eight spaces.
	The paragraph includes a tag in the indent.
.DE
produces
.EX
.IP \fLA.\fL 0.5i
This is the first line of text.
nroff indents the following lines by the same
amount as the first.
The indent is eight spaces.
The paragraph includes a tag in the indent.
.EE
.PP
You must make sure the indent leaves enough spaces for the tag.
If the tag contains blank spaces, enclose it within quotation marks.
To see how this works, enter the following script under the title
\fBscript4.r\fR:
.II "King Lear"
.II "Shakespeare, William"
.DM
	.IP "King Lear:" 16
	Is man no more than this?
	Consider him well.
	Thou owest the worm no silk,
	the beast no hide,
	the sheep no wool,
	the cat no perfume...
	Unaccommodated man is no more
	but such a poor, bare, forked
	animal as thou art.
.DE
When processed with
the command
.DM
	nroff \-ms script4.r >script4.p
.DE
you see:
.EX
.IP "\fLKing Lear:\fL" 1.0i
Is man no more than this?
Consider him well.
Thou owest the worm no silk,
the beast no hide,
the sheep no wool,
the cat no perfume...
Unaccommodated man is no more
but such a poor, bare, forked
animal as thou art.\fR
.EE
.PP
As this example shows, this form of the
.B .IP
macro can be used to format the script for a play.
.PP
If you do not want a tag, but merely wish to set the indentation to
something other than the default setting of five spaces, then use
a pair of quotation marks with nothing between them for the first field:
.DM
	.IP "" 8
.DE
If you forget the quotation marks, you will not get what you expect:
.B nroff
will interpret \*(Ql8\*(Qr as a tag and use the normal indentation
of five spaces.
.PP
Once you set the amount of indentation, the new indentation
stays in effect until you change it again.
For example, if you format a paragraph with
.DM
	.IP "" 8
.DE
and follow it with another paragraph that begins with \fB.IP\fR,
.B nroff
will also indent the second paragraph by eight spaces.
The indentation will remain in effect until you explicitly change it \(em for
example, by beginning a paragraph with
.DM
	.IP "" 6
.DE
which resets the indent to six spaces.
.PP
.II "nroff^.RS macro"
.II "nroff^.RE macro"
.II "nroff^relative indent"
.II "nroff^indentation, relative"
Normally,
.B nroff
measures the paragraph indentation from the left margin.
Another variation of
.B IP
allows you to measure the indentation of a new indented paragraph from
the left-hand edge of a previous indented paragraph, thus producing
.IR "relative indentation" .
To do this, enclose the new paragraph between the macros
.B RS
and
.B RE
(for \fBr\fRelative indent \fBs\fRtart and \fBr\fRelative indent \fBe\fRnd).
Copy the following script into the file \fBscript5.r\fR:
.II "Bathsheba"
.II "King David"
.II "Uriah the Hittite"
.DM
	.IP
	And it came to pass in an eveningtide,
	that David arose from off his bed ...
	and from the roof he saw a woman washing
	herself; and the woman was very beautiful
	to look upon.  And David sent and enquired
	after the woman.  And one said,
	.RS
	.IP
	Is not this Bathsheba, the daughter of Eliam,
	the wife of Uriah the Hittite?
	.RE
	.IP
	And David sent messengers and took her; and
	she came in unto him, and he ...
	and she returned unto her house.
.DE
When processed through \*(PN with
the command
.DM
	nroff \-ms script5.r >script5.p
.DE
the output resembles the following:
.EX
And it came to pass in an eveningtide,
that David arose from off his bed ...
and from the roof he saw a woman washing
herself; and the woman was very beautiful
to look upon.  And David sent and enquired
after the woman.  And one said,
.sp
.in +0.5i
Is not this Bathsheba, the daughter of Eliam,
the wife of Uriah the Hittite?
.sp
.in -0.5i
And David sent messengers and took her; and
she came in unto him, and he ...
and she returned unto her house.\fR
.EE
You can include
any number of indented paragraphs between \fB.RS\fR
and \fB.RE\fR.
Also, you can specify tags and different indents just as for
ordinary indented paragraphs.
You can even nest
.B .RS
and
.B .RE
pairs inside each other to produce multiple relative indents.
Just remember that an
.B .RS
must always be balanced by an
.BR .RE .
Type the following into the file \fBscript6.r\fR to see
how \*(PN handles nested flashbacks:
.DM
	.IP
	In England during World War II, a captain tells the
	story of his Free French bomber squadron.
	.RS
	.IP
	In the early days of the war, a French ship picks up
	five men adrift in a small boat.  One tells of their
	life on Devil's Island.
	.RS
	.IP
	A convict tells others of his past.
	.RS
	.IP
	Publication of anti-Nazi material leads to arrest on
	false charges.
	.RE
	.IP
	The convicts escape to help France in the war.
	.RE
	.IP
	When France surrenders, the crew overpowers pro-Vichy
	officers and heads for England instead of Marseilles.
	.RE
	.IP
	The captain concludes his story as the bombers return
	from a mission.
.DE
When you process this file with the \fB\-ms\fR package, the output
file \fBscript6.p\fR should
resemble the following:
.EX
In England during World War II, a captain tells the
story of his Free French bomber squadron.
.sp
.in +0.5i
In the early days of the war, a French ship picks up
five men adrift in a small boat.  One tells of their
life on Devil's Island.
.sp
.in +0.5i
A convict tells others of his past.
.sp
.in +0.5i
Publication of anti-Nazi material leads to arrest on
false charges.
.sp
.in -0.5i
The convicts escape to help France in the war.
.sp
.in -0.5i
When France surrenders, the crew overpowers pro-Vichy
officers and heads for England instead of Marseilles.
.sp
.in -0.5i
The captain concludes his story as the bombers return
from a mission.
.EE
.PP
As you can see, each \fB.RE\fR command peels away the current
layer of indentation and moves you into the previous one.
To return to an even earlier level, you must input
the appropriate number of \fB.RE\fR commands before you begin
a paragraph.
.PP
.II "nroff^quoted paragraph"
.II "nroff^paragraph, quoted"
.II "nroff^.QE macro"
.II "nroff^.QS macro"
A third type of paragraph is the \fIquoted\fR paragraph.
It produces a paragraph that is
indented on both on the right side and on the left side,
in order to set off a quotation from the surrounding text.
To produce such a paragraph, precede it with the
.B .QS
macro
and follow it with the
.B .QE
macro.
To break the quotation into different sections,
insert a blank line in the text before each line that you
want to begin a new section.
For example, type the following example as \fBscript7.r\fR:
.DM
.II "Twain, Mark"
	Form of Tender of Rescue from Strange Young Gentleman
	to Strange Young Lady at a Fire.
	.QS
	Although through the fiat of a cruel fate, I have been
	debarred the gracious privilege of your acquaintance,
	permit me, Miss [here insert name, if known], the
	inestimable honor of offering you the aid of a true
	and loyal arm against the fiery doom which now
	o'ershadows you with its crimson wing.  [This form
	to be memorized, and practiced in private.]
	.QE
	Should she accept, the young gentleman should offer
	his arm - bowing, and observing "Permit me" -
	and so escort her to the fire escape and deposit
	her in it.
.DE
After processing with the \fB\-ms\fR package, the output file
\fBscript7.p\fR should resemble the following:
.EX
Form of Tender of Rescue from Strange Young Gentleman
to Strange Young Lady at a Fire.
.sp
.in +0.5i
.ll -0.5i
Although through the fiat of a cruel fate, I have been
debarred the gracious privilege of your acquaintance,
permit me, Miss [here insert name, if known], the
inestimable honor of offering you the aid of a true
and loyal arm against the fiery doom which now
o'ershadows you with its crimson wing.  [This form
to be memorized, and practiced in private.]
.sp
.in -0.5i
.ll +0.5i
Should she accept, the young gentleman should offer
his arm - bowing, and observing "Permit me" -
and so escort her to the fire escape and deposit
her in it.
.EE
.Sh "Section Headings"
.PP
.II "nroff^.SH macro"
.II "nroff^section heading"
.II "nroff^headings, section"
The
.I "section heading"
macro
.B .SH
prints a heading or title.
For example:
.DM
	.SH
	Section Headings
.DE
The heading may be more than one line long;
consequently, you should follow a section heading with a
.B .PP
or an
.B .IP
macro.
.B nroff
leaves a blank line before the heading and prints the heading
flush with the left margin in
.B boldface
type, as described below in the section on Fonts.
.PP
.II "nroff^.NH macro"
.II "nroff^numbered heading"
The
.I "numbered heading"
macro
.B .NH
produces consecutively numbered section headings.
For example:
.DM
	.NH
	Guess What's Coming to Dinner?
	.NH
	Guess Why I Won't be There?
.DE
produces
.DM
	1.   Guess What's Coming to Dinner?
.sp
	2.   Guess Why I Won't Be There?
.DE
You can number subsection headings by entering a number from two
to five to the
.B .NH
macro.
The number indicates the level
of section headings; for example,
.B ".NH 2"
numbers subsection headings,
.B ".NH 3"
numbers sub\-subsection headings.
For example:
.DM
	.NH
	Guess What's Coming to Dinner?
	.NH 2
	Guess What it Looks Like?
	.NH 3
	Teeth Like That Might Frighten the Children!
	.NH 2
	What Does it Eat?
	.NH
	Guess Why I Won't be There?
.DE
produces:
.DM
	1.   Guess What's Coming to Dinner?
.sp \n(pDu
	1.1   Guess What it Looks Like?
.sp \n(pDu
	1.1.1   Teeth Like That Might Frighten the Children!
.sp \n(pDu
	1.2   What Does it Eat?
.sp \n(pDu
	2.   Guess Why I Won't be There?
.DE
The number on the
.B .NH
command line is
.I not
the number that appears before the heading; instead, it
controls how many \*(QLparts\*(QR appear in the number.
For example,
.B ".NH 3"
produces a three-part number, such as \fB2.5.3\fR,
whereas
.B ".NH 4"
produces a four-part number, such as \fB7.4.5.2\fR.
.PP
You can reset the entire numbering scheme by using the command
\fBNH 0\fR; for example,
.DM
	.NH 0
	Through The Mandelbrot Set With Rod and Gun
.DE
produces
.DM
	1.   Through The Mandelbrot Set With Rod and Gun
.DE
with numbering starting at one.
.Sh "Title Page"
.PP
.II "nroff^.TL macro"
.II "nroff^.AU macro"
.II "nroff^.AB macro"
.II "nroff^.AE macro"
.II "nroff^.AI macro"
If you want your output to begin with a title page, begin the input
with the following.
.DM
	.TL
	Title of Document (may be more than one line)
	.AU
	Name(s) of Author(s) (may be more than one line)
	.AI
	Institution(s) of Author(s)
	.AB
	Abstract (line length 5.5 inches)
	.AE
.DE
.PP
The
.B .TL
macro indicates the
.I title,
the
.B .AU
macro indicates the
.I author,
the
.B .AI
macro indicates the
.I "author's institution,"
and the
.B .AB
macro precedes the
.IR abstract .
The
.B .AE
macro, for \fBa\fRbstract \fBe\fRnd, marks the end of the abstract.
If you do not want some of these headings to appear,
simply omit the relevant macros.
Begin the body of the document immediately after the
.B .AE
macro.
The body must begin with a formatting command, such as
.B .PP
or
.B .SH.
.PP
Note that the \fIend abstract\fR macro \fB.AE\fR also
prints today's date automatically.
To do so, \*(PN reads the date as encoded in \*(CO.
Before you use these macros, be sure that you have set
the correct date in \*(CO.
.PP
To see how these macros work, type the following script
into file \fBscript8.r\fR:
.ID
	.TL
	Tickling in the Therapy of
	von Muenchausen's Syndrome
	.AU
	P. R. Sanserif
	.AI
	The Department of Parapsychology
	The University of Southern North Dakota
	at Hoople
	.AB
	Study of 150 subjects (75 men and 76 women)
	indicated that hard tickling may prove beneficial
	to patients with von Muenchausen's syndrome.
	Applications for a seven-figure grant have been
	made to continue research in this area.
	.AE
	.PP
	Due to complications in our experiment, this paper
	has now been withdrawn.
.IE
After processing with the \fB\-ms\fR macro package,
you will see that in the outputfile \fBscript8.p\fR, \*(PN placed the
text on the same page as the title information.
You may or may not want this to happen.
If you do not, one solution is to insert two
additional commands between the
.B .AE
macro and the body of your text:
.DM
	.PP
	.bp
.DE
.II "nroff^.bp primitive"
.Sh "Headers and Footers"
.PP
.II "nroff^header"
.II "nroff^footer"
The
.I header
macro controls the format of the top of each page.
It automatically skips one inch at the top of the page.
The
.I footer
macro controls the format of the bottom of each page.
It stops printing text one inch above the bottom of the page,
and prints the page number.
.PP
.II "nroff^title"
.II "nroff^LT string"
.II "nroff^CT string"
.II "nroff^RT string"
It is easy to print either a page header or a page footer.
Both the page header and the page footer are three-part titles:
.B nroff
prints the first part on the left side of the page, the second part
in the middle, and the third part on the right side of the page.
The parts of the header title are named:
.DS
	\fBLT\fR:  left, top
	\fBCT\fR:  center, top
	\fBRT\fR:  right, top
.DE
and the parts of the footer title are named:
.DS
	\fBLF\fR:  left, footer
	\fBCF\fR:  center, footer
	\fBRF\fR:  right, footer
.DE
.II "nroff^strings"
.II "nroff^.ds primitive"
These parts are called
.I strings.
A later section of this tutorial describes strings in detail.
Normally, these strings are undefined,
except for \fBCF\fR, which prints the current page number;
therefore, the header macro normally prints nothing, and the footer
macro prints only the page number in the center of the block of space at the
bottom of each page.
However, you can set any portion of the
header or footer to print what you like.
To set the left portion of the header, for example, type
the following:
.DM
	.ds LT "Walnuts in History"
.DE
Note that you do \fInot\fR type a period before the \fBLT\fR.
After you define
.B LT
in this fashion,
.B nroff
will print
.DM
	Walnuts in History
.DE
at the top of each page on the left-hand side.
If you want the date to appear on the right-hand side
of the header, type:
.DM
	.ds RT "\e*(Ds"
.DE
The string \fBDs\fR is automatically initialized to today's date,
as set on your \*(CO system.
A later section of this tutorial will present strings in detail.
For now, all you need to know is that whenever you want \*(PN to insert today's
date into your script automatically, just type the entry \fB\e*(Ds\fR.
This entry does \fInot\fR have to be at the beginning of a line to work.
.PP
Use the same procedure to define the strings in the footer title.
If you want something
other than the page number to appear in the position allocated to \fBCF\fR,
use the
.B .ds
primitive to redefine
.BR CF .
If you want nothing to appear there, type
.DM
	.ds CF ""
.DE
.II "nroff^%, page number"
.II "nroff^page number"
Wherever you want the current page number to appear in the header or
footer, use the symbol \*(Ql%\*(Qr.
For example,
if you want the page number to appear in the upper right-hand corner of each
page, type
.DM
	.ds RT "Page %"
.DE
Be sure to type in all of the macros to define headers and footers
\fIbefore\fR you begin to type in your text.
Otherwise, your headers and footers will not appear on the first
page of the formatted output.
.PP
To see how this works, try editing the file \fBscript1.r\fR.
At the top, insert the macro
.DM
	.ds RT "\e*(Ds"
.DE
and reprocess the file using the \fB\-ms\fR macro package.
Each output page should have today's date written in the
upper right-hand corner.
.Sh "Fonts"
.PP
.II "nroff^fonts"
.II "nroff^boldface"
.II "nroff^italic"
.II "nroff^Roman"
.B nroff
normally prints ordinary,
or \*(QLRoman\*(QR, characters.
In addition,
.B nroff
can print
.B boldface
and
.I italic
characters.
Each of the three styles of type \(em
Roman, boldface, and italic \(em is called a
.IR font ,
in keeping with typesetting terminology.
.PP
.B nroff
prints each boldface and italic character by generating
a special three-character output sequence.
It prints the boldface character
.BR c ,
for example,
by printing a \*(Qlc\*(Qr, then the backspace character
.BR <ctrl-H> ,
and then another \*(Qlc\*(Qr.
This sequence emaphasizes \*(Qlc\*(Qr by forcing your
printer to print it twice.
.B nroff
represents an italic character
.I c
with the underscore character \*(Ql_\*(Qr,
followed by the backspace character
.B <ctrl-H>,
followed by \*(Qlc\*(Qr.
.PP
Because of these special representations, the appearance of
.B nroff
boldface and italic fonts depends on the device on which you see the output.
On your terminal, the
.B <ctrl-H>
backspaces the cursor, and the third character of each
sequence replaces the first;
therefore, boldface and italic characters appear the same as Roman characters.
On a printer, the appearance depends on the characteristics of the printer.
The \*(CO system provides programs to print boldface and italic characters
appropriately on certain devices.
.PP
The
.B \-ms
macro package includes three commands for easy printing in specific fonts:
the
.I boldface
command
.BR .B ,
the
.I italic
command
.BR .I ,
and the
.I Roman
command
.BR .R .
To print a single word in boldface, do the following:
.DM
	The last word is printed in
	.B boldface.
.DE
Likewise for italics:
.DM
	The last word is printed in
	.I italics.
.DE
These example printed a word in a different font.
You can print several words in a different font by
enclosing the words within quotation marks on the command line:
.DM
	This sentence ends with
	.B "three bold words".
.DE
You can also switch fonts by using one of the font commands
with nothing after it on the command line.
For example,
.DM
	.B
	This entire sentence is printed in boldface.
	.R
.DE
or
.DM
	.I
	This entire sentence is printed in italics.
	.R
.DE
In these examples, the Roman font command
.B .R
is needed to return to the
normal font after completing the boldface or italic text.
.PP
On rare occasions, you might want different parts of one word
to be in different fonts.
You cannot use the
.B \-ms
macros to produce mixed-font words directly.
A later section of this tutorial gives additional information about
.B nroff
fonts.
As explained there, the input
.DM
	This manual describes \efBnroff\efR's powerful features.
.DE
produces the output:
.DM
	This manual describes \fBnroff\fP's powerful features.
.DE
The word
.B nroff
is boldface but the following apostrophe and \*(Qls\*(Qr are Roman.
.Sh "Special Characters"
.PP
.II "nroff^characters, special"
A few characters have special meaning to
.B nroff.
You should be aware of these characters if you want
.B nroff
to process your text properly.
.PP
As mentioned earlier, the period and the apostrophe introduce
.B nroff
command lines.
Each is a special character if it is the \fIfirst non-space
character\fR on an input line.
If you wish to use a period or an apostrophe at the start of an input line
simply as part of your text,
you must precede it with a backslash and ampersand \*(QL\fB\e&\fR\*(QR.
For example, the input
.DM
	The footnote command
	.DS
	\e&.FT
	.DE
	generates footnotes for you automatically.
.DE
produces the output
.DM
.ta 0.5i
	The footnote command
.sp \n(pDu
	.FT
.sp \n(pDu
	generates footnotes for you automatically.
.DE
Neither the period nor the apostrophe is a special character unless it is
the first non-space character on a line.
.PP
The most important special character for
.B nroff
is the backslash \*(Ql\e\*(Qr.
It changes the meaning of the following character or characters.
If you simply want a backslash to appear as part of your text,
you must follow it with the letter \*(Qle\*(Qr;
that is, use \*(QL\ee\*(QR in your input to
have \*(Ql\e\*(Qr appear in your output.
Later sections of this tutorial describe other special uses for backslash.
.Sh "Footnotes"
.PP
.II "nroff^footnote"
.II "nroff^.FS macro"
.II "nroff^.FE macro"
You can place footnotes between the
.I "footnote start"
command
.B .FS
and
the
.I "footnote end"
command
.B .FE,
as in the following example:
.II "MicroKVETCH Electronic Nag"
.DM
	.FS
	*MicroKVETCH Electronic Nag is a
	copyrighted trademark of Caveat Emptor
	Software, Inc.
	.FE
.DE
You should insert
each footnote into your text where the
reference to it occurs;
.B nroff
will see to it that the footnote
appears at the bottom of the correct page.
Footnotes should be inserted as follows:
.DM
	The notion that we have been visited
	by visitors from outer space may seem
	outlandish(1)
	.FS
	1. Raucus J, O'Hooligan R: "Viruses
	from Venus?" \efIJ Earth Med Assoc\efR,
	1985;36:412-414.
	.FE
	but reason compels us to exclude no ...
.DE
The journal article cited in the footnote will
appear at the bottom of the page, with the journal name in italics.
.Sh "Displays and Keeps"
.PP
.II "nroff^display"
.II "nroff^keep"
A
.I display
is a portion of text, such as a graph or a table, that should appear in the
output exactly as it is typed in the input.
.B nroff
normally alters the spacings between elements
in your text, which, of course, would destroy the appearance
of a display.
Therefore,
.B nroff
has macros to tell it that a portion of text is a display,
and so not to alter spacings between elements or split it between two pages.
.II "nroff^.DS macro"
.II "nroff^.DE macro"
These macros are the
.I "display start"
macro
.B .DS
and the
.I "display end"
macro
.BR .DE .
You should place your display between these macros, as follows:
.DM
	.DS
	The text of the display goes here,
	exactly
	as
	you
	want
	it
	to appear in the output.
	.DE
.DE
The
.B .DS
macro comes in three varieties.
.II "nroff^centered display"
The
.I "display start centered"
macro 
.B ".DS C"
centers every line of your display.
Because
.B nroff
centers each line individually, both right and left margins are ragged.
.II "nroff^display, block-centered"
.II "nroff^block-centered display"
The
.I "display start block-centered"
macro
.B ".DS B"
takes the entire display at once and centers it.
You can think of this as simply shifting the
display to the right by an appropriate amount.
.II "nroff^display indented"
.II "nroff^indented, display"
The
.I "display start indented"
macro 
.B ".DS I"
indents the entire display by half an inch.
.PP
If your display is longer than one page, do not use
.B .DS
or any of its variants.
Instead, begin the display with one of the following.
.PP
.II "nroff^.CD macro"
.II "nroff^centered display"
.II "nroff^display, centered"
The
.I "centered display"
macro
.B ".CD"
centers each line of the display.
.II "nroff^.BD macro"
.II "nroff^block-centered display"
.II "nroff^display, block-centered"
The
.I "block-centered display"
macro
.B ".BD"
considers the entire display as a block and centers it.
.II "nroff^.LD macro"
.II "nroff^display, left"
.II "nroff^left display"
The
.I "left display"
macro
.B ".LD"
performs no indenting or centering, but simply begins each line
at the left margin.
.II "nroff^.ID macro"
.II "nroff^indented display"
.II "nroff^display, indented"
Finally, the
.I "indented display"
macro
.B ".ID"
indents each line by half an inch.
If you begin the display with one of these macros, do \fInot\fR end it
with
.BR .DE ;
rather, just type
.B .PP
or
.B .SH
or whatever other
macro is needed at that point.
.PP
To see how displays work, type the following into the file
\fBscript9.r\fR and process it with the \fB\-ms\fR macro package:
.DM
.II "Blake, William"
.II "Burma Shave"
	.PP
	.DS C
	Tyger! Tyger! burning bright
	In the forests of the night,
	What immortal hand or eye
	Could frame thy fearful symmetry?
	Burma Shave
	.DE
.DE
When the output file \fBscript9.p\fR is read, the results will
appear as follows:
.EX
.ce 5
Tyger! Tyger! burning bright
In the forests of the night,
What immortal hand or eye
Could frame thy fearful symmetry?
Burma Shave
.EE
You must remember one important fact when you use display macros:
the normal length of output lines is 6.5 inches, but if the
display contains lines longer than this
.B nroff
simply prints them as they are.
If a line is too long to fit onto the page,
what occurs afterwards depends upon the output device.
If you are displaying the output on the screen, the text will
be displayed as far as possible to the right, then the remainder
will be wrapped around onto the next line, without indentation.
On most printers, however, the chunk of text that extends past
the right margin will simply be lopped off and thrown away.
In any event, the effect is usually quite unsightly.
The only restriction on what you can safely put in a display,
then, is that lines should be no longer than 6.5 inches.
If you are using an indented display,
lines should be no longer than six inches.
.PP
.II "nroff^.KE macro"
.II "nroff^.KS macro"
.II "nroff^keep"
A
.I keep
is a
display macro:
you put text between the
.I "keep start"
macro
.B .KS
and the
.I "keep end"
macro
.B .KE
when you want it all kept on the same page.
If you put a block of text between these macros that
proves to be longer than one page,
.B nroff
moves the excess text onto a new page.
.PP
The major difference between the keep and the display is that normal
processing occurs in the keep:
.B nroff
adjusts spacings between words, hyphenates words,
justifies lines, and performs all other formatting tasks,
just as it normally does.
.Sh "Other Commands"
.PP
.II "nroff^.bp primitive"
.II "nroff^.sp primitive"
.II "nroff^skip lines"
.II "nroff^begin page"
.II "nroff^new page"
.II "nroff^page, break"
Several of
.BR nroff 's
primitives can be used with the
.B \-ms
macro package.
The primitive
.DM
	.sp \fIN\fP
.DE
skips
.I N
lines on the output page; for example,
.B ".sp 4"
skips four lines.
.PP
The
.I "begin page"
primitive
.B .bp
tells
.B nroff
to begin a new page, no matter where it is on the current page.
.PP
The remaining sections of this tutorial provide more information
about these other
.B nroff
primitives.
.SH "Introducing nroff's Primitives"
.PP
The rest of this tutorial describe \*(PN's
\fIbasic commands\fR \(em the commands that are \*(QLbuilt into\*(QR
\*(PN, and from which macros are assembled.
These basic commands, or \fIprimitives,\fR
form \*(PN's text formatting language.
Once you have mastered the primitives,
you will be able to write macros to control automatically
even the most difficult text formatting tasks.
.PP
The rest of this tutorial includes a number of exercises.
You should type them into your system and execute them as described
in the tutorial; this will greatly increase the rate at which you
master \fBnroff\fR.
None of the following examples should be processed
with the \fB\-ms\fR macro package; the purpose of this portion of
the tutorial is to teach you how to create you own text processing
routines, rather than how to use ones that have already been written.
.Sh "Page Format"
.PP
When deciding how to process text, you must first decide
how to position the text on the printed page.
You must control line length, left and right margins,
page offset (i.e., how far from
the left edge of the page each line begins), and page length.
Controlling these functions is quite easy with the appropriate
.B nroff
commands.
.PP
.II "nroff^line, length"
.II "nroff^.ll primitive"
.II "nroff^.po primitive"
.II "nroff^page, offset"
.II "nroff^command, line length"
.II "nroff^command, page offset"
The
.I "line length"
primitive
.B .ll
controls the line length; and the
.I "page offset"
command
.B .po
controls the page offset.
If you are writing an
.B nroff
script, you should include these commands before the beginning of your
text, so that
.B nroff
can put them into effect immediately.
The following example uses a line length of three inches and a page
offset of two inches.
Type this into your system under the name \fBex1.r\fR.
Note, by the way, that the text to the right of the characters
\*(Ql\e"\*(Qr is a \fIcomment\fR, and there is no need for you
to type it into your system:
.ID
.II "hoop snake"
.II "Aunt Patsy"
.II "Twain, Mark"
.ta 0.5i 1.5i
	.ll 3i	\e" set line length
	.po 2i	\e" set page offset
	Along outside of the front fence ran the country
	road, dusty in the summertime, and a good place for
	snakes -- they liked to lie in it and sun themselves;
	when they were rattlesnakes or puff adders, we killed
	them; when they were black snakes, or racers, or belonged
	to the fabled "hoop" breed, we fled, without shame; when
	they were "house snakes", or "garters", we carried them
	home and put them in Aunt Patsy's work basket for a
	surprise; for she was prejudiced against snakes, and
	always when she took the basket in her lap and they
	began to climb out of it it disordered her mind.
.IE
.II "nroff^specification"
Process this script by
typing the command
.DM
	nroff ex1.r >ex1.p
.DE
From this point on, you should \fInot\fR use the
\fB\-ms\fR macro package with your \*(PN examples.
When you display the output stored in the file \fBex1.p\fR,
you will see that the length of each line is three inches, and
each line begins two inches from the left-hand margin.
.PP
As you noticed, line length and page offset were set in \fIinches\fR.
.B nroff
output can be controlled using a number of different
units of measurements, including inches, number of characters, or
lines, or \fImachine units\fR.
A following section discusses
.B nroff
units of measurement in detail.
.PP
.II "nroff^comments"
As noted above, this example contains two \fIcomments\fR.
.B nroff
ignores any text that appears on a line
after \*(QL\e"\*(QR.
You should use comments, for the benefit of anyone who must
read your
.B nroff
script (including yourself).
The above example used the comments
.DM
	\e" set line length
	\e" set page offset
.DE
to help you understand the \fB.ll\fR and \fB.po\fR commands.
Judicious comments can make a complex
script much easier to understand.
.Sh "Breaks"
.PP
.II "nroff^break"
Before you look at the \fIbreak\fR primitive
.BR .br ,
it is helpful to examine how
.B nroff
constructs a finished line of output.
Suppose, for example, that you tell
.B nroff
that you want each output line to be five inches long.
.B nroff
takes your input one word at a time, and attempts to squeeze that
word into the space that has not yet been taken up in the line.
.II "nroff^margins"
.II "nroff^break"
.II "nroff^.br primitive"
.II "nroff^command, break"
When 
.B nroff
finally picks up a word that is
too large to fit into the amount of space left in the line,
it either puts the word aside entirely, or hyphenates
the word and places the hyphenated portion into the line.
.B nroff
then inserts extra blank spaces between the words to justify the line.
The
.I break
primitive
.BR .br ,
however, tells
.B nroff
to print whatever words have already been put into the line,
even if they do not form a complete line, and without
performing right justification.
.PP
The idea of a break might seem strange at first, but
you are familiar with a simple example:
the end of a paragraph.
You do not want the start of a new
paragraph to be on the same line as the end of the previous
paragraph:
you want to print the end of the previous paragraph
whether or not it fills a complete line;
and you want to begin the new paragraph on a new line.
As you will learn later, some
.B nroff
commands cause breaks automatically;
you should be aware of this when you use them.
.Sh "Fill and Adjust Modes"
.PP
.II "nroff^fill"
.II "nroff^justify"
.II "nroff^adjust"
Two terms describe how
.B nroff
processes your input to create its output:
.IR filling ,
and
\fIadjusting\fR or \fIjustifying\fR.
Unless you order it not to,
.B nroff
operates in the \fIfill\fR and \fIadjust\fR modes.
.II "nroff^command, fill"
.II "nroff^.fi primitive"
.II "nroff^.nf primitive"
.II "nroff^.ad primitive"
.II "nroff^.na primitive"
The
.I "no-fill"
primitive
.B .nf
tells
.B nroff
to stop using fill mode.
The
.I "fill"
primitive
.B .fi
tells it to resume using the fill mode.
In a similar way, the
.I adjust
primitive
.B .ad
tells
.B nroff
to use adjust mode, whereas the
.I "no adjust"
primitive
.B .na
tells it to use no-adjust mode.
.PP
As mentioned above,
.B nroff
by default is in both fill mode and adjust mode, so you do not need
to begin your script with
.B .fi
and
.B .ad
if you want \*(PN to fill and adjust your text.
However, if you turn off filling and adjusting by using the
.B .nf
and
.B .na
commands,
you must use the
.B .fi
and
.B .ad
commands to turn filling and adjusting back on.
.PP
.II "nroff^no-fill"
When you use
.B .nf
to turn off fill mode,
.B nroff
no longer tries to fill lines to a fixed line length.
It prints each line of input text exactly as received.
However, a sufficiently long line of
text would run off the right-hand edge of the page if
.B nroff
were to print it as entered.
If the input line cannot fit on one line,
.B nroff
prints as much as it can fit on one line,
then breaks the line and prints the rest
on the next line with no page offset.
.PP
In adjust mode,
.B nroff
inserts extra spaces between words to justify lines of text, as
described above.
When
.B nroff
is in no-fill mode, it is automatically in no-adjust mode:
with no fixed line length, there is no need to insert extra spaces.
.I Moral:
you can fill without adjusting, but you cannot adjust without filling.
.PP
If you request filling but not adjusting,
.B nroff
fills the output line as described earlier, but
does not insert extra spaces between words;
that is, it does not try to keep an even right margin.
Every output line either is shorter than the line length you
specified, or exactly as long.
.PP
.II "nroff^.ad primitive"
The
.B .ad
primitive includes several options.
If you use the command
.B .ad
without an argument,
.B nroff
keeps strict left and right margins.
The primitive
.B ".ad l"
justifies the left margin only;
.B ".ad r"
justifies the right margin only; and
.B ".ad b"
justifies both margins (this, of course, is the default).
Finally,
.B ".ad c"
centers output lines while keeping their lengths less than
or equal to the line length, as set with the \fB.ll\fR
command.
.PP
Remember that
.B nroff
ignores adjustment requests if you are in no-fill mode.
If
.B nroff
is in fill mode and you request any variety of adjustment, it
adjusts accordingly until you issue either a no-fill or a no-adjust command.
If you give a no-fill command, only a fill command restores
adjustment; any plea for a
different kind of adjustment is ignored while \*(PN is in no-fill mode.
.PP
To see how this works, type the following script
under the name \fBex2.r\fR, and process it as above:
.ID
.II "Boswell, James"
.II "Johnson, Samuel"
.II "Hume, David"
.ta 0.5i 1.5i
	.ll 6.75i
	.sp	\e" space
	When we were alone, I introduced the subject
	of death, and endeavored to maintain that the fear
	of it might be got over.  I told [Johnson] that
	David Hume said to me, he was no more uneasy to
	think that he should not be after this life, than
	that he had not been before he began to exist.
	.sp
	.na	\e"no adjust
	JOHNSON:  "Sir, if he really thinks so,
	his perceptions are disturbed;
	he is mad: if he does not think so, he
	lies .... When he dies, he at
	least gives up all he has."
	.sp
	.ad r	\e"right-adjust
	BOSWELL:  "Foote, sir, told me that
	he was not afraid to die."
	.sp
	.nf	\e"no-fill
	JOHNSON:  "It is not true, sir.
	Hold a pistol to Foote's
	breast or to Hume's breast,
	and threaten to kill them,
	and you'll see how they behave."
	.sp
	.fi	\e"fill
	BOSWELL:  "But may we not fortify our minds for
	the approach of death?"
	.sp
	JOHNSON:  "No, sir, let it alone.  It matters not
	how a man
	dies, but how he lives.  The act of dying is not of
	importance, it lasts so short a time .... A man
	knows it must be so, and submits.
	It will do him no good to whine."
.IE
When you process this input with
.B nroff,
your output should look like this:
.EX
When we were alone, I introduced the subject
of death, and endeavored to maintain that the fear
of it might be got over.  I told [Johnson] that
David Hume said to me, he was no more uneasy to
think that he should not be after this life, than
that he had not been before he began to exist.
.sp
.na
JOHNSON:  "Sir, if he really thinks so,
his perceptions are disturbed;
he is mad: if he does not think so, he
lies .... When he dies, he at
least gives up all he has."
.sp
.ad r
BOSWELL:  "Foote, sir, told me that
he was not afraid to die."
.sp
.nf
JOHNSON:  "It is not true, sir.
Hold a pistol to Foote's
breast or to Hume's breast,
and threaten to kill them,
and you'll see how they behave."
.sp
.fi
BOSWELL:  "But may we not fortify our minds for the approach
of death?"
.sp
JOHNSON:  "No, sir, let it alone.  It matters not
how a man
dies, but how he lives.  The act of dying is not of
importance, it lasts so short a time .... A man
knows it must be so, and submits.
It will do him no good to whine."
.EE
.fi
.ad b
.II "nroff^.ad primitive"
.II "nroff^.na primitive"
.II "nroff^.fi primitive"
After the
.B .na
primitive,
\*(PN fills but does not adjust the second paragraph.
After
.BR ".ad r" ,
it fills and right adjusts the third paragraph.
After
.BR .nf ,
it neither fills nor adjusts the fourth paragraphs.
Finally, after
.BR .fi ,
it fills the fifth and sixth paragraphs and uses the
.B ".ad r"
adjust option that was in effect previously.
.PP
Under certain extreme conditions,
.B nroff
cannot adjust a line even though it is in adjust mode.
If, for example, you specified a line length of one inch,
a seven-letter or eight-letter word would then take up most of a line.
When such a word was then followed by
a word that could not fit into the line after it,
\*(PN would begin a new line with the second word
rather than violate the right margin by inserting the into the line.
When a line has only one word in it,
.B nroff
obviously cannot adjust the line by inserting extra spaces between words;
therefore, the right margin is left uneven,
as though \*(PN were in no-adjust mode.
.Sh "Defining Paragraphs"
.PP
.II "nroff^paragraph"
What happens if you copy text from several pages of a book into a file
without adding any formatting commands, and then process the file with
.BR nroff ?
There is no page offset, because
.BR nroff 's
default page-offset setting is zero;
and the processed lines are set to the default length of 6.5
inches (65 Pica characters).
.PP
More interesting things happen with paragraphs.
Suppose you skip a line between paragraphs and
begin each paragraph by indenting five spaces.
The blank line in the input text causes a break, and forces
.B nroff
to print a blank line.
The last line of each paragraph is unadjusted,
and a blank line appears before the next paragraph.
.II "nroff^break"
Initial blank spaces in a line of input also cause a break.
In this example, the breaks caused by initial
blank spaces at the beginning of each paragraph do
nothing, because the preceding blank line forces out
the last line of the preceding paragraph.
.B nroff
always considers initial blank
spaces in a line to be significant, and preserves them
in the output.
.PP
To see how blank lines and initial spaces affect \*(PN's output,
copy the following example and run it through
.B nroff:
.DM
.ta 0.8i
	     Here is a little text so you can see
	whether nroff will ignore the initial
	indentation
	            in this very very long sentence.
	Here is a little bit more text.

	     And here is something to mimic
	the beginning of a new paragraph.
.DE
The output should look like this:
.EX
     Here is a little text so you can see
whether nroff will ignore the initial
indentation
            in this very very long sentence.
Here is a little bit more text.

     And here is something to mimic
the beginning of a new paragraph.
.EE
.II "nroff^.sp primitive"
Instead of leaving a blank line in the text, you could use the
.I space
primitive
.B ".sp 1,"
which causes a break and inserts one blank line into the output.
In a similar way,
.B ".sp 5"
causes a break and inserts five blank lines in the output.
Edit the example and replace the blank line with the
command line:
.DM
	.sp 1
.DE
You will see that it has the same effect.
You can also use the form
.BR .sp ;
.B nroff
assumes you want one space if you omit the argument.
.PP
Most
.B nroff
input consists of many paragraphs that contain text, and
you probably want each paragraph to have the same format in the output.
Rather than formatting each paragraph explicitly, as in this example,
you can use the
.I macro
facility of
.B nroff
to define a sequence of commands to format a paragraph.
Macros are described in detail later in this tutorial.
.Sh "Centering"
.PP
.II "nroff^.ce primitive"
The
.I center
primitive
.B .ce
centers one or more lines of text.
For example, you can center a two-line heading as follows:
.DM
	.ce 2
	Heading Printed
	In Center of Page
.DE
If you use the
.B .ce
command with no argument,
.B nroff
assumes a default argument of one, and centers only the next line of input.
The command \fBce 0\fR cancels any earlier centering command that
is in operation.
.Sh "Tabs"
.PP
.II "nroff^tab"
If your
.B nroff
input includes tables, you may find it convenient to use tabs to
separate items in a line of the table.
.B nroff
recognizes the
.B <tab>
character
and expands it into spaces.
If you use tabs to format a table, remember to use no-fill mode;
otherwise,
.B nroff
tries to fill and adjust your output lines.
.PP
.II "nroff^.ta primitive"
By default,
.B nroff
sets a tab stops after every eight characters.
You can use the
.I tab
primitive
.B .ta
to change the positions of the tab stops.
For example,
.DM
	.ta 10 20 30 40 50 60
.DE
sets tab stops ten characters apart rather than eight.
.B .ta
can also be used to fix tab stops in inches
rather than after a number of characters;
for example,
.DM
	.ta 0.8i 2.0i
.DE
sets tab stops after 0.8 inches and 2.0 inches on the output line.
This is quite helpful when you are designing a
table.
.PP
.II "nroff^.tc primitive"
You can use the
.I "tab character"
command
.B .tc
to change the character
.B nroff
prints between its current position and the next tab stop.
Enter the following text to see how this primitive works:
.DM
	.ta 9 19 29 39
	.tc *
	.nf
	<tab>1<tab>2<tab>3<tab>4
.DE
The output file, \fBex3.p\fR, should appear as follows:
.DM
	*********1*********2*********3*********4
.DE
.Sh "Page Breaks" 
.PP
.II "nroff^.bp primitive"
.II "nroff^.pl primitive"
The
.I "begin page"
primitive
.B .bp
causes a break and forces
.B nroff
to the next output page.
By default,
.B nroff
assumes a page length of 11 inches (66 lines).
You can change the page length with the
.I "page length"
command
.B .pl.
For example,
.DM
	.pl 2i
.DE
specifies a two-inch page length.
.PP
At this point, the question arises about how \*(PN
handles top and bottom page margins, number pages,
and other aspects of page layout.
The answer is it merely keeps track of the current output page number and
the current line number on the current output page;
designing top and bottom margins, page headers and footers,
and other aspects of page layout is up to you.
.PP
.II "nroff^traps"
Can
.B nroff
execute a set of commands whenever it reaches a certain position on the page?
This would
solve the problem of producing top and bottom margins, and you would not
have to guess where to insert the commands in your script.
In fact, you can tell \*(PN to do this, by using
.I traps.
The next section of this tutorial
describes macros and traps and how to use them to format a page.
.SH "Macros and Traps"
.PP
.II "nroff^macro"
This section presents \*(PN macros:
how to write them, how to tell \*(PN to execute them
at a give point on every output page, and how to install
a macro file under the \*(CO system
.PP
As with previous sections, this one uses a number of exercises.
Working the exercises will help you master \*(PN quickly.
When you format the exercise scripts, do not use the \fB\-ms\fR option.
Also, it is not necessary for you to copy the comments into your
system; they are here to help you understand what each \*(PN
command does, but they have no effect on how the script executes.
.Sh "What Is a Macro?"
.PP
To become familiar with the idea of a
.IR macro ,
consider the problem of formatting a paragraph.
Whenever you come to a new paragraph, you want
\*(PN to skip a line and indent the first line five spaces.
Because
.B nroff
preserves blank lines and initial indentations, you could force
.B nroff
to break your text into paragraphs
simply by inserting a blank line and spaces directly into your text.
The same effect, however, can be achieved by inserting
following set of \*(PN commands
.DM
.ta 0.8i 2.0i
	.br	\e" break
	.sp	\e" skip a line
	.ti 5	\e" indent next line 5 spaces
.DE
between the end of each paragraph and the start of the next paragraph.
.II "nroff^.br primitive"
.II "nroff^.ti primitive"
.II "nroff^.sp primitive"
You should recognize the first two commands:
.B .br
causes a break, so that
.B nroff
prints the last line of the previous paragraph even
though it might not be a complete line;
.B .sp
skips a line before the next paragraph begins.
The third command is the
.I "temporary indent"
command
.BR .ti ,
which tells \*(PN to indent the next line;
the number indicates how many spaces to indent.
The following exercise, \fBex4.r\fR, demonstrates
how this works:
.ID
.II "Twain, Mark"
.II Adam
.II peach
.II almond
.II cabbage
.II cauliflower
.ta 0.8i 2.0i
	.ll 3i	\e" line length
	.po 3i	\e" page offset
	.ti 5	\e" indent next line
	Adam was human--this explains it all.  He did
	not want the apple for the apple's sake, he
	wanted it because it was forbidden.  The mistake
	was in not forbidding the serpent; then he would
	have eaten the serpent.
	.br	\e" break
	.sp	\e" skip a line
	.ti 5	\e" indent next line
	Training is everything.  The peach was once a bitter
	almond; cauliflower is nothing but cabbage with a
	college education.
	.br
	.sp
	.ti 5
	Habit is habit, and not to be flung out of the window
	by any man, but coaxed downstairs a step at a time.
.IE
After you have processed this file, the output file \fBex4.p\fR
should resemble the following:
.EX
.ti 10
Adam was human--this explains it all.  He did
not want the apple for the apple's sake, he
wanted it because it was forbidden.  The mistake
was in not forbidding the serpent; then he would
have eaten the serpent.
.br
.sp
.ti 10
Training is everything.  The peach was once a bitter
almond; cauliflower is nothing but cabbage with a
college education.
.br
.sp
.ti 10
Habit is habit, and not to be flung out of the window
by any man, but coaxed downstairs a step at a time.
.EE
Now, in a small file it would be easy to type all of the \*(PN primitives
directly into your input text;
however, what if
your file is very long, with hundreds of paragraphs?
Every time you wanted to begin a paragraph, you would have to include that
set of commands within the text.
You would save considerable agony if you could
bundle these commands together under a common
.IR name ;
then you could simply put that \fIname\fR into
your text whenever you wanted
.B nroff
to perform these commands, rather than typing the commands themselves over
and over again.
.PP
.II "nroff^.PP macro"
As you probably have guessed by now, you can do just that;
the set of commands is called a
.I macro.
.II "Puddnhead Wilson"
The following shows the selections from Pudd'nhead Wilson's
calendar set with a macro called
.B .PP
that takes care of formatting each paragraph.
The following exercise, \fBex5.r\fR, shows how to bundle together
the \*(PN primitives for formatting paragraphs into the \fB.PP\fR macro:
.ID
.ta 0.5i 1.8i
	.de PP	\e" define the PP macro
	.br	\e" break the line
	.sp	\e" insert a blank line
	.ti 5	\e" indent next line 5 spaces
	..	\e" two periods ends the macro definition
	.PP	\e" execute PP macro
	Adam was human--this explains it all.  He did
	not want the apple for the apple's sake, he
	wanted it because it was forbidden.  The mistake
	was in not forbidding the serpent; then he would
	have eaten the serpent.
	.PP
	Training is everything.  The peach was once a bitter
	almond; cauliflower is nothing but cabbage with a
	college education.
	.PP
	Habit is habit, and not to be flung out of the window
	by any man, but coaxed downstairs a step at a time.
.IE
As you can see, using a macro can save you a considerable amount of work
when you prepare your script.
.Sh "Introducing Traps"
.PP
Now, consider the problem of formatting the beginning and ending of each page
of output.
You could define what are traditionally called
.I header
and
.I footer
macros, which contain the commands you want performed at the top and
bottom of each page.
However, how can you tell \*(PN when to execute these macros?
You cannot possibly know where
to call these macros in the input text, because you cannot know
where any given text line will appear in the output until you
have processed it through \*(PN.
This problem is solved by using
.I traps.
.PP
.B nroff
keeps track of its vertical position on each output page.
You can set a
.I trap
that tells
.B nroff
to execute a macro at a particular vertical position on every page.
When a line of output reaches or extends past the position that is specified
in your
.IR trap ,
.B nroff
then executes the commands named in the trap command
before processing any more input text.
.PP
.II "nroff^.wh primitive"
.II "nroff^.hd primitive"
.II "nroff^command, when"
You can set a trap by using the
.I when
command
.BR .wh .
For example, if you want
.B nroff
to call your header macro
.B .HD
at the very top of each page, the command
.DM
.ta 0.5i 1.8i
	.wh 0 HD	\e" set header trap
.DE
sets a trap for the macro
.B .HD
at vertical position 0 (the very top of the page) of every output page.
The macro
.B .HD
will then be executed every time \*(PN begins a new page.
.II "nroff^.FO macro"
.II "nroff^measurement, units"
To have your footer macro
.B .FO
execute one inch from the bottom of each page, use the command
.DM
.ta 0.5i 1.8i
	.wh -1i FO	\e" set footer trap
.DE
The negative number tells
.B nroff
to measure distance from the \fIbottom\fR
of the page rather than from the top;
the \fBi\fR is an abbreviation for inches.
(\*(PN recognizes various units of measurement; this will be
described in more detail later.)
.Sh "Headers and Footers"
.PP
.II "nroff^% number register"
Suppose you want to design the output page by defining the header and footer
macros.
A simple header macro merely skips an inch of space at the
top of each page; a simple footer macro forces printing to stop an
inch from the bottom of each page and prints the page number.
.B nroff
does not print page numbers automatically, but
it does automatically keep track of which output page it is on.
It stores the page number internally in a
.I "number register"
that you can access with the symbol \*(Ql%\*(Qr.
(A later section gives more information about number
registers and how to use them.)
.PP
.II "nroff^footer"
The following gives a simple footer macro that prints the page number:
.DM
.ta 0.5i 1.8i
	.de FO	\e" define footer macro FO
	'sp 4v	\e" skip four vertical lines (no break)
	.tl ''- % -''	\e" print hyphen, page number, hyphen
	'bp	\e" jump to new page
	..	\e" end macro definition
.DE
There are several points of interest raised by this macro.
.PP
First, notice that some
commands are preceded with an apostrophe rather than with a period.
The use of the apostrophe instead of
the period tells \*(PN to suppress the break these commands normally cause.
You might run into problems if you define your header macro
as follows:
.DM
.ta 0.8i 2.0i
	.de HD	\e" header macro
	.sp 1i	\e" skip an inch (break)
	..
.DE
You want this to leave a blank space of one inch
at the top of each page; however, the
.B .sp
command causes a break, so that if a word were left over
from the last line on the preceding page,
.B nroff
would print it at the very top of the next page.
The effect would be quite unsightly.
However, if you use
.B 'sp
instead of
.B .sp
in the macro,
.B nroff
suppresses the break and does not print the partial word
until \fIafter\fR it performs the macro commands.
The same is true for the footer macro:
you do not want anything
unplanned to be printed in the blank space at the bottom of the page.
You should always be conscious of these considerations when you use
commands that cause breaks.
.PP
.II "nroff^.tl primitive"
Another new item in the above example is the
.I title
command
.B .tl,
which prints a three-part title.
A three-part title contains a left part
(aligned to the left margin of the page),
a center part (centered),
and a right part (aligned to the right margin).
The command name
.B .tl
is followed by four apostrophes:
.B nroff
prints the characters
between the first two apostrophes
as the left part of the
title line, those between the second and third apostrophes
as the center part,
and those
between the third and fourth apostrophes
as the right part of the three-part title.
If you do not want
.B nroff
to print anything in one of these positions, simply put nothing between the
appropriate pair of quotes.
In the above example, the
.B .tl
primitive tells
.B nroff
to print nothing in the left and right portions of the footer title line, but
to print the page number in the center.
If you want an apostrophe to appear as a part of the title,
precede it with the backslash character \*(Ql\e\*(Qr.
.PP
.II "nroff^.lt primitive"
.II "nroff^command, title length"
\*(PN considers the length of the title line to be independent of the length of
normal output lines; therefore, you must set it with the
.I "length of title"
primitive
.B .lt
unless you want
.B nroff
to use the default title length of 6.5 inches.
For example, to set the length of the title to five inches, use the command
.DM
	.lt 5i
.DE
In light of all you now know, you should give Pudd'nhead Wilson's
calendar the treatment it deserves:
.ID
.ta 0.5i 1.8i
	.ll 3i	\e" set line length to 3 inches
	.po 2i	\e" set page offset to 3 inches
	.pl 9i	\e" set page length to 9 inches
	.wh 0 HD	\e" set the header trap
	.wh -1i FO	\e" set the footer trap
	.de HD	\e" define header macro HD
	'sp 1i	\e" skip 1 inches of space
	..	\e" end macro definition
	.de FO	\e" define footer macro
	'sp 2	\e" skip 2 lines
	.tl ''- % -''	\e" define footer title
	'bp	\e" begin new page
	..	\e" end macro definition
	.de PP	\e" define paragraph macro
	.sp 1	\e" skip 1 line of space
	.ti 5	\e" indent the first line 5 characters
	..	\e" end macro definition
	.PP
	Adam was human--this explains it all.  He did
	not want the apple for the apple's sake, he
	wanted it because it was forbidden.  The mistake
	was in not forbidding the serpent; then he would
	have eaten the serpent.
	.PP
	Training is everything.  The peach was once a bitter
	almond; cauliflower is nothing but cabbage with a
	college education.
	.PP
	Habit is habit, and not to be flung out of the window
	by any man, but coaxed downstairs a step at a time.
.IE
.PP
.II "nroff^traps"
As a point of technique, always set header and footer traps
early in your input script; otherwise, \*(PN may not
print the header on the first page.
.Sh "Macro Arguments"
.PP
.II "nroff^macro, arguments"
You can affect how macros function by passing
them modifiers, called \fIarguments\fR.
An argument may be a bit of text that is arranged in a special
way by the macro, or it may be a number or other parameter that
dictates exactly what the macro does.
.PP
As an example of how a macro can handle arguments,
consider a macro to format the list of ingredients for a recipe.
You want the ingredients to be printed as follows:
.DM
	3 cups of pumpkin
	1 cup of milk
	1 cup of sugar
	1 tsp of ground ginger
	1 tbl of cinnamon
.DE
.PP
.II "nroff^macro, definition"
Each of these lines has the same format: the amount of
ingredient, the unit of
measurement, the word \*(QLof\*(QR, and the name of the ingredient.
You can create a macro (call it
.BR .RE ,
for \fBre\fRcipe)
that encodes the format of these lines and
contains three \*(QLslots\*(QR:
one slot for the amount, one for the unit of
measurement, and one for the name of the ingredient.
Each time you use the macro, you
indicate what you want to go into each slot, and
.B nroff
substitutes it for you.
The macro \fB.RE\fR can be constructed as follows:
.ID
.ta 0.5i 1.8i
	.de RE	\e" define macro RE
	\e\e$1 \e\e$2 of \e\e$3	\e" set RE's arguments
	..	\e" end definition
	Here is some text.
	.nf	\e" don't fill the recipe
	.RE 3 cups pumpkin
	.RE 1 cup milk
	.RE 1 cup sugar
	.RE 1 tsp "ground ginger"
	.RE 1 tbl cinnamon
	.fi	\e" resume filling
	Here is some more text.
	.bp	\e" begin a new page, to force printing
.IE
.II "nroff^macro, arguments"
When you call a macro that takes arguments, the arguments
must appear on the same line as the macro command itself.
A macro may have up to nine arguments; they are denoted by \fB\e$1\fR,
through \fB\e$9\fR, respectively:
the first field after the macro name
is called \fB\e$1\fR, the second \fB\e$2\fR, and so on.
.PP
If you want to use as an argument a string of characters that includes
blank spaces, you must enclose the string within quotation marks, as
with the words \*(QLground ginger\*(QR, in the example above.
If you forget to include the quotation marks,
.B nroff
regards each word in the string
as a separate argument, and treats them accordingly.
.PP
Note that
macros that are called by traps cannot accept arguments.
.Sh "Double vs. Single Backslashes"
.PP
If you carefully examine the definition of
.BR RE ,
you will see that it identifies
each argument with two backslashes:
.DM
	\e\e$1 \e\e$2 of \e\e$3
.DE
Whenever you identify an argument within a macro,
always preface it with two backslashes, rather than one.
The reason is that \*(PN in effect processes a macro \fItwice\fR:
when it first reads it, and later when you call it within your text.
Prefacing an argument with \fIone\fR backslash tells \*(PN that you
want to expand that argument when the macro is first read; prefacing
it with two backslashes tells \*(PN that you want to expand it when
the macro is called in your text.
In nearly every circumstance, you want to expand the arguments
in your text, so you should use two backslashes.
As you will see, this rule also applies to the use of \fIstrings\fR
and \fInumber registers\fR within macros.
.PP
To see how this works, consider again the \fB.RE\fR macro:
.ID
	.de RE
	\e\e$1 \e\e$2 of \e\e$3
	..
	Here is some text.
	.nf
	.RE 3 cups pumpkin
	.RE 1 cup milk
	.RE 1 cup sugar
	.RE 1 tsp "ground ginger"
	.RE 1 tbl cinnamon
	.fi
	Here is some more text.
	.bp
.IE
Using two backslashes, as above, allows you to redefine
what \fB$1\fR, \fB$2\fR, and \fR$3\fR mean many times
throughout your text, to generate the following output:
.DM
	Here is some text.
	3 cups of pumpkin
	1 cup of milk
	1 cup of sugar
	1 tsp of ground ginger
	1 tbl of cinnamon
	Here is some more text.
.DE
If you used only one backslash, however, your output
would appear as follows:
.DM
	Here is some text.
	  of
	  of
	  of
	  of
	  of
	Here is some more text.
.DE
\*(PN could not expand the argument calls (\fB\e$1\fR etc.), because
you had not yet defined them; therefore, it threw them away;
and because all of the argument calls
had been thrown away, \*(PN then threw all the arguments away.
All that was left was word \fBof\fR.
.SH "Designing and Installing Macros"
.PP
Now that you have been shown how to write a macro, the next step
is to design some macros and install them, so you can call them
over and over again.
.PP
The first step in designing a macro is to analyze the problem that
you want to solve.
Suppose that in this instance you want to print a list of names.
Each name will consist of a first name, a last name, and the
department with which he is associated, and the list will
be printed in columns; for example:
.DM
.ta 0.5i 1.5i 2.5i
	Firstname	Lastname	Department
.DE
Moreover, you want to be able to switch the order in which the
columns appear without having to retype your list; for example:
.DM
.ta 0.5i 1.5i 2.5i
	Lastname	Firstname	Department
.DE
or
.DM
.ta 0.5i 1.5i 2.5i
	Department	Lastname	Firstname
.DE
In effect, then, you want three macros:
one for each of the three orders of columns shown above.
.PP
When you have finished designing your macros, they should
look something the following.
Type the following into the file \fBtmac.lst\fR; note that
the symbol \fB<tab>\fR represents a \fItab\fR character, and
should not be entered literally:
.ID
	.\e" List macros. $1 represents first name,
	.\e" $2 last name, $3 department
	.de LA
	.nf
	.ta 1.5i 2.75i
	\e\e$1<tab>\e\e$2:<tab>\e\e$3
	.Rt
	..
	.de LB
	.nf
	.ta 1.5i 2.75i
	\e\e$2,<tab>\e\e$1:<tab>\e\e$3
	.Rt
	..
	.de LC
	.nf
	.ta 1.5i 2.75i
	\e\e$3:<tab>\e\e$2,<tab>\e\e$1
	.Rt
	..
.IE
The first lines are \fIcomments\fR, so that
anyone who looks at these macros will know
what they do.
The first command line, introduced with the \fB.de\fR
command, names each macro.
These names were selected after checking the file \fBtmac.s\fR,
which is where the \fB\-ms\fR macro package is kept, to confirm
that they are not used elsewhere.
Naturally, using the same macro name in two different
places can lead to a great deal of trouble.
.PP
The next command, \fB.nf\fR, turns off the \*(PN's normal right
justification, which otherwise would smear a table.
The \fB.ta\fR command sets the tab characters at certain
points on the page, measured from the left margin.
.PP
The next line gives the order in which the arguments appear.
The arguments are separated by tab characters, and punctuation is inserted.
The last command, \fB.Rt\fR, calls a macro in the file \fBtmac.s\fR;
this macro resets \fBnroff\fR to its normal fill mode and returns
the tab settings to normal.
Note that these macros can be used only when you also use
the \fB\-ms\fR macro package.
.PP
After you have typed the macros into \fBtmac.lst\fR,
carefully read over what you type to ensure that no there are
no errors; if you find any, be sure to correct them.
The final step is to move \fBtmac.lst\fR into
the directory \fB/usr/lib\fR, which is where \fBtmac.s\fR is also kept.
.PP
To test your new macros, type the following text into the file
\fBex6.r\fR:
.ID
	The following lists give the personnel who are involved in
	this project: 
	.sp
	.LA Ivan Morgan Engineering
	.LA Marian Gusman Design
	.LA George Meyer Electrical
	.LA Catherine Scanlon "Metal Shop"
	.LA Fred McElroy Carpentry
	.LA Anne Assenmacher "Machine Shop"
	.sp
	.LB Ivan Morgan Engineering
	.LB Marian Gusman Design
	.LB George Meyer Electrical
	.LB Catherine Scanlon "Metal Shop"
	.LB Fred McElroy Carpentry
	.LB Anne Assenmacher "Machine Shop"
	.sp
	.LC Ivan Morgan Engineering
	.LC Marian Gusman Design
	.LC George Meyer Electrical
	.LC Catherine Scanlon "Metal Shop"
	.LC Fred McElroy Carpentry
	.LC Anne Assenmacher "Machine Shop"
	.sp
	We expect that they will receive your full cooperation.
.IE
The same set of names is used three times; the only difference
is the macro call employed.
.PP
Now, process this file with the following command:
.DM
	nroff -ms -mlst ex6.r >ex6.p
.DE
As you can see, when you installed \fBtmac.list\fR into \fB/usr/lib\fR,
you could invoke it in the same way that you invoke
\fBtmac.s\fR with \fB\-ms\fR.
.PP
When you look at the output file \fBex6.p\fR, you should see
something that resembles the following:
.EX
.de LA
.nf
.ta 1.25i 2.5i
\\$1	\\$2:	\\$3
.fi
..
.de LB
.nf
.ta 1.25i 2.5i
\\$2,	\\$1:	\\$3
.fi
..
.de LC
.nf
.ta 1.25i 2.5i
\\$3:	\\$2,	\\$1
.fi
..
The following lists give the personnel who are involved in
this project: 
.sp
.LA Ivan Morgan Engineering
.LA Marian Gusman Design
.LA George Meyer Electrical
.LA Catherine Scanlon "Metal Shop"
.LA Fred McElroy Carpentry
.LA Anne Assenmacher "Machine Shop"
.sp
.LB Ivan Morgan Engineering
.LB Marian Gusman Design
.LB George Meyer Electrical
.LB Catherine Scanlon "Metal Shop"
.LB Fred McElroy Carpentry
.LB Anne Assenmacher "Machine Shop"
.sp
.LC Ivan Morgan Engineering
.LC Marian Gusman Design
.LC George Meyer Electrical
.LC Catherine Scanlon "Metal Shop"
.LC Fred McElroy Carpentry
.LC Anne Assenmacher "Machine Shop"
.sp
We expect that they will receive your full cooperation.
.EE
As you grow proficient in writing \*(PN macros,
you will probably find it most efficient to keep
special macros in their own files; this will save
time by ensuring that \*(PN does not have
to process macros that are never called.
.SH "Strings"
.PP
.II "nroff^string"
Suppose you are writing a script for
.B nroff
and, to relieve the tedium, decide to punctuate the text
occasionally with a rousing cry of \*(QLFOOD FIGHT!!\*(QR.
If you plan to interject this
phrase more than a few times in your script, you can
take advantage of another labor-saving device, called a
.I string.
You can use a string name as an abbreviation for
a long string of characters you use frequently.
Like a macro, a string is a
.I name
that
.B nroff
associates with a
.I definition
that you supply.
Wherever you put the name in your text,
.B nroff
prints the definition.
Although macros refer to sets of \fIcommands\fR that you define, strings refer
to strings of \fIcharacters\fR that you define.
.PP
.II "nroff^.ds primitive"
You define a string with the
.I "define string"
primitive
.B .ds:
.DM
	.ds FF "FOOD FIGHT!!"
.DE
The first field after the
.B .ds
gives the name of the sting, in this case
.B FF.
Like a macro name, a string name may be either one or two characters.
The second field after the
.B .ds
gives the definition of the string, in this case
.DM
	"FOOD FIGHT!!"
.DE
As in this example, you must enclose the definition within
quotation marks if it contains spaces.
.PP
Be careful whenever you define a macro or a string.
If you already have a macro or a string named
.B X
and you define a new macro or string named
.B X,
.B nroff
forgets the previous meaning of
.B X.
.PP
Once you have defined a string, you can refer to it
anywhere in your text.
The string itself appears in the output text wherever a reference to it
appears in the input text.
You refer to the string
.B FF
in the following fashion:
.DM
        \e*(FF
.DE
Use the left parenthesis \*(Ql(\*(Qr only when the name of the string
is two characters long.
If the string name is only a single character,
such as
.B S,
refer to it as follows:
.DM
	\e*S
.DE
As an example, type the following script into \fBex7.r\fR,
and process it through
.BR nroff ;
do \fInot\fR use the \fB\-ms\fR macro package:
.DM
.II Aristotle
	.ds FF "FOOD FIGHT!!"
	.ds W "WHOOPEE!!"
	.ce
	From Aristotle's "Poetics"
	.br
	.sp
	A tragedy is the imitation of an action \e*(FF
	that is serious and also, \e*W as having magnitude,
	complete in itself, with incidents \e*(FF
	arousing pity and fear, wherewith to accomplish \e*W
	\e*(FF its purgation of such emotions \e*(FF \e*(FF.
	.bp
.DE
.B nroff
adjusts the spacings between words in a string but does not
hyphenate any word that is within a string.
If you use a very short line length, such as two inches, and define a
string that includes a three-inch long word, that word would
not be hyphenated but would extend past the right-hand margin.
.PP
You cannot include a newline character in a string.
However, you can
spread the definition of a string out over more than one line with the
aid of \fIconcealed\fR newlines (preceded by the backslash character
\*(Ql\e\*(Qr).
.B nroff
ignores each concealed newline.
For example, add the following string to the previous example:
.DM
	.ds PR "GO TEAM \e
	GO!!!"
.DE
As you can see,
.B nroff
ignores concealed newlines anywhere in its input.
.Sh "Strings Within Strings"
.PP
.II "nroff^string, within strings"
You can define a string that has embedded within it a
reference to another string.
Whenever you refer to the bigger string in your text,
.B nroff
substitutes the definition of the smaller string for any reference
to the smaller string.
When you embed strings, though, you should use \fItwo\fR backslashes
to refer to the embedded string, for the same reason
that you should use two backslashes to refer to
an argument within a macro:
.DM
	.ds S "This string \e\e*x has embedded \e\e*y strings"
.DE
To help understand this better, type following three scripts
into your computer and format them with \*(PN.
The first script contains proper references
to embedded strings (using double backslashes); it works as
expected:
.DM
	.ds S "strings \e\e*X, strings \e\e*Y, strings \e\e*Z"
	.ds X "here"
	.ds Y "there"
	.ds Z "everywhere"
	\e*S
.DE
The next script contains embedded references that use only
single backslashes.
Because the embedded strings are defined
after the larger string, they are not available when
.B nroff
defines the larger string, and so the references are ignored:
.DM
	.ds S "strings \e*X, strings \e*Y, strings \e*Z"
	.ds X "here"
	.ds Y "there"
	.ds Z "everywhere"
	\e*S
.DE
The third
script again contains embedded references using single backslashes.
This time, the embedded strings are defined \fIbefore\fR the
larger string, and so are available when the larger
string is defined:
.DM
	.ds X "here"
	.ds Y "there"
	.ds Z "everywhere"
	.ds S "strings \e*X, strings \e*Y, strings \e*Z"
	\e*S
.DE
To avoid unnecessary worry, you should always play it safe and use
double backslashes to refer to embedded strings.
.SH "Number Registers"
.PP
.II "nroff^register, number"
You learned in previous sections that
.B nroff
keeps track of the output page number while it prints its output.
You made use of this fact when you created a footer macro that printed page
numbers.
.B nroff
also keeps track of other housekeeping information,
such as the current line length, page offset,
page length, and vertical position of the last output line.
It keeps this information in
storage locations called \fInumber registers\fR.
.PP
You can use the \fIname\fR of a number register to refer to the number that is
stored in it.
When you place a reference to a number register in your text,
.B nroff
substitutes for the name whatever number is currently in the register.
.PP
Number register names are one or two characters long, just like
macro and string names.
You can have a number register with the same name as a string
or a macro without confusing
.BR nroff ,
even though you cannot give a macro and a string the same name.
However,
.I you
might become confused;
.B nroff
scripts usually are easier to understand
if you keep all macro names, string names, and register names distinct.
.PP
Another difference between number registers, macros, and strings is that
.B nroff
itself does not define any macros or strings (although the
.B \-ms
macro package does), but it does automatically
define and update quite a few number registers.
You can use these predefined number registers
in much the same way that you use registers you define yourself,
except that you cannot change their values.
.PP
.II "nroff^.nr primitive"
To define a number register, you must specify the
.I "register name"
and the
.I "initial value"
for the register.
The
.I "number register"
primitive
.B .nr
looks like this:
.DM
	.nr X 5
.DE
Here
.B X
is the name of the register and
.B 5
is the initial value to store in it.
To refer to number register
.B X
in your text, use \fB\enX\fR; if the name is two characters long
(for example, \fBXY)\fR, use \fB\en(XY\fR.
This is exactly like the way you refer to a string,
except that you use the letter \*(Qln\*(Qr instead of
an asterisk \*(Ql*\*(Qr.
When
.B nroff
sees a reference to number register
.BR X ,
it automatically substitutes the value stored in
.BR X .
As you will see shortly,
.B nroff
can do arithmetic, and learning to use number registers is an
important part of learning to take advantage of \fBnroff\fR's
arithmetic abilities.
.PP
A reference to a number register can occur anywhere a number would
normally occur.
For example, if you set register
.B X
to 5, as above,
you can set the line length to five inches as follows:
.DM
	.ll \enXi
.DE
This command is essentially the same as
.DM
	.ll 5i
.DE
if the current value of register
.B X
is 5.
.PP
A familiar problem arises when you refer
to a number register inside a macro or a string definition.
If you use just one backslash,
.B nroff
substitutes the value in the register
for the reference when it first processes the macro or string.
If you have not yet defined the number register in your script,
.B nroff
inserts
.B 0
into the macro or string.
Normally, you should use a
a double backslash, such as \fB\e\enX\fR or
\fB\e\en(XY\fR, when referring to a number register
within a macro or string.
Using the double backslash is
particularly important if you \fIchange\fR the value of the register
throughout your script, and want the current value to
appear in the macro or string each time you call it.
.PP
Try typing the following examples into your computer,
and processing them with \*(PN.
See if you can describe why
.B nroff
prints what it does in each case.
The first example defines a string with a register reference
preceded by a single backslash.
.DM
	.ds S "Here is a number \enX"
	.nr X 55
	\e*S
	\enX
.DE
You should see the following output:
.DM
	Here is number 0
	55
.DE
\*(PN printed what it did because number register X had not
yet been defined when it was called in string S;
\*(PN
therefore erased the reference to X and substituted zero for it.
Number register X was then set to 55, which was
printed when the register was specifically called later in the script.
.PP
The second example is similar, but now the number register is set
\fIbefore\fR the string is called:
.DM
	.nr Y 56
	.ds T "Here is a number \enY"
	\e*T
	\enY
.DE
Now the output is
.DM
	Here is a number 56
	56
.DE 
The third example uses a double backslash for the register reference.
.DM
	.ds U "Here is a number \e\enZ"
	.nr Z 57
	\e*U
	.nr Z 58
	\e*U
.DE
This script produces the following:
.DM
	Here is a number 57
	Here is a number 58
.DE
The final example uses a single backslash again.
.DM
	.nr W 59
	.ds V "Here is a number \enW"
	\e*V
	.nr W 60
	\e*V
.DE
The following is produced:
.DM
	Here is a number 59
	Here is a number 59
.DE
The last example illustrates the danger of using a single backslash
to refer to a number register within a string definition.
You defined the number register
.B W
before you defined the string
.BR V ,
so the value for
.B W
was available when
.B nroff
read the definition of
.BR V .
.B nroff
substituted the value when it reads the definition; the reference to the
number register
.B W
is no longer there.
You then change the value of
.BR W ,
but as you see in the next call of
.BR V ,
the change does not affect the number that appears in
.BR V .
In contrast to this, notice in the third example that the double
backslash in the definition of
.B U
allows the reference to number register
.B Z
to remain within the definition of string
.BR U .
Whenever you change the value of
.B Z
and then call
.BR U ,
.B nroff
substitutes the new value of
.B Z
for the reference to
.B Z
within
.BR U .
.PP
You can also use the
.B .nr
primitive to increase or decrease the value in a number register.
For example, suppose you initially store the value
five in \fBX\fR:
.DM
	.nr X 5
.DE
.Sh "Incrementing and Decrementing"
.PP
You can change the value of
.B X
to 9 by adding 4, as follows:
.DM
	.nr X +4
.DE
You can then change the value of
.B X
to 7 by subtracting 2:
.DM
	.nr X -2
.DE
A plus or minus sign before a number on the
.B .nr
command line tells
.B nroff
to add or subtract the given amount to or from the value in the register.
Because a negative number is always preceded by a minus sign
whereas a positive number usually is not preceded by a plus sign,
you can use
.B .nr
to set a register to a positive value in
a way that cannot be imitated for negative values.
For example, suppose you again start out with number register \fBX\fR set to
a value of 5:
.DM
	.nr X 5
.DE
If you immediately follow this with
.DM
	.nr X 7
.DE
then
.B nroff
replaces the value of 5 with 7.
The second
.B .nr
does not increase the value of
.B X
by 7 to produce 12;
rather, it wipes out the previous value of 5 and replaces it by the value 7.
The command line to increase
.B X
by 7 is
.DM
	.nr X +7
.DE
If you again start with a value of 5 in
.B X
and want to change the value to -4, you cannot use the following command line:
.DM
	.nr X -4
.DE
.B nroff
interprets this as a command to \fIdecrease\fR the current value of
.B X
by 4,
which is not what you intended.
This command places the value 1 in \fBX\fR, since 5-4=1.
If
.B X
initially has a value of 5 and you want to change the value to
\-4, you could use the command
.DM
	.nr X \-9
.DE
You can also
increase or decrease the value of a number register without using
.BR .nr .
If number register
.B X
currently has the value 10, the reference \fB\en+X\fR increases the value in
.B X
by 1 to 11 and substitutes the new value for the reference.
The value in
.B X
becomes 11;
.B nroff
replaces the next reference \fB\enX\fR by 11, whereas another
reference \fB\\n+X\fR increments the value in
.B X
to 12 and replaces the reference by 12.
Similarly, if number register
.B XY
currently has the value 15, the reference \fB\\n+(XY\fR increases the
value in
.B XY
to 16 and replaces the reference by 16.
.PP
You can also decrease a register's value.
The reference \fB\en-X\fR decreases the current value in
.B X
by 1 and substitutes the new value for the reference.
Likewise, the reference \fB\en-(XY\fR decreases the current value in
.B XY
by 1 and substitutes the new value for the reference.
.PP
You can change the size of the increment or decrement by means
of another option to the
.B nr
command.
If you define
.B X
with
.DM
	.nr X 1 5
.DE
then
.B nroff
sets the value of
.B X
to 1 and sets the increment value for
.B X
to 5.
The next reference \fB\en+X\fR increments the value in
.B X
from 1 to 6 (the \*(Ql+\*(Qr now causes
.B nroff
to add 5 to the current value of
.B X
rather than adding 1) and substitutes 6 for the reference.
In the
same manner, \fB\en-X\fR subtracts 5 from the current value of
.B X
and substitutes the new value for the reference.
This is convenient if you plan to repeatedly increment or decrement
.B X
by the same fixed amount.
If you wish to change the size of the increment, simply redefine
.B X
with another
.B .nr
that specifies the new initial and
increment values.
If you define a number register but do not specify an increment value,
.B nroff
assumes the increment value to be 1.
.PP
The following example of a macro illustrates a typical use of a number
register and incrementing.
.ID
.ta 0.5i 3.5i
	.nr W 1	\e" set W to 1, inc by 1
	.ds X "Here's Wrestler No. \e\enW,"	\e" define string X
	.de B	\e" define macro B
	.br
	\e\e*X \e\e$1!!!	\e" define arg to macro B
	.nr b \e\en+W	\e" increment W
	..	\e" end definition
	.B "Alex 'Killer' Bovine"	\e" call B with arguments
	.B "William 'Crusher' Risible"
	.B "Vlad 'the Impaler' Acephalous"
	.bp	\e" force printing of page
.IE
to produce the following output:
.DM
	Here's Wrestler No. 1, Alex 'Killer' Bovine!!!
	Here's Wrestler No. 2, William 'Crusher' Risible!!!
	Here's Wrestler No. 3, Vlad 'the Impaler' Acephalous!!!
.DE
.PP
A reference to a number register may appear any place a number
can normally appear.
For example:
.DM
	.nr X \enY \enZ
.DE
sets register
.B X
to the value of register
.B Y
and sets the increment for
.B X
to the value of register
.B Z.
.PP
As mentioned before,
.B nroff
performs arithmetic.
It understands and evaluates properly formed
arithmetic expressions involving numbers,
references to number registers,
the arithmetic operators \*(Ql+\*(Qr, \*(Ql-\*(Qr,
\*(Ql*\*(Qr, \*(Ql/\*(Qr, \*(Ql%\*(Qr, and parentheses.
The first four operators represent addition, subtraction, multiplication,
and division.
The \*(Ql%\*(Qr is the \fImodulus\fR or \fIremainder\fR operator:
the value of 7%3 is 1, which is the remainder when 7 is divided by 3.
.PP
.II "nroff^expression"
One word of caution:
.B nroff
evaluates expressions from left to right without
any preference for performing some operations before others.
For example,
.DM
	.nr X 5+4*3/9
.DE
stores 3 in
.B X.
.B nroff
does not perform the multiplication and division before the addition,
as you might expect.
.PP
Another important fact is that number registers hold only integers.
If you write
.DM
	.nr X 3.6
.DE
.B nroff
truncates the value 3.6 and stores 3 in
.BR X .
Also, an assignment such as
.DM
	.nr X 3.9*3.9
.DE
stores 9 in
.BR X ;
.B nroff
truncates each factor before it performs the multiplication.
The assignment
.DM
	.nr X 0.4*8
.DE
stores 0 in
.B X
rather than 3:
truncation occurs before
.B nroff
performs the multiplication rather than after.
.PP
.II "nroff^units"
.II "nroff^measurement, units"
A final word of caution:
when you use numbers with commands other than
.B .nr,
the results may
.I not
be what you expect.
.B nroff
understands several different units of measurement
and converts between units automatically.
The next section explains units and conversion in detail.
.Sh "Units of Measurement"
.PP
.II "nroff^.ll primitive"
As mentioned above,
.B nroff
maintains many number registers during processing.
For example, it stores the current page length in the
register
.B .l
(Note that the period \*(Ql.\*(Qr
is actually part of the name of this register.)
If you set the line length to five inches with the command
.DM
	.ll 5i
.DE
.B nroff
stores the length in register
.B .l
automatically; however, if you print the value in register
.B .l
by entering \fB\en(.l\fR, you find the value is 600.
What does this mean?
.PP
.II "nroff^measurement"
Many
.B nroff
commands require that you specify lengths or measurements as arguments.
You are already familiar with many of these commands: for example,
.B .ll,
.B .po,
.B .pl,
and
.BR .lt .
.B nroff
accepts various units of measurement, but
for purposes of calculation, it converts each into a basic unit called a
.IR "machine unit" ,
which is abbreviated
.BR u .
A machine unit is 1/120 of an inch long.
Because one inch is 120 machine units, the length of a
five-inch line is 5 times 120, or 600 machine units.
.PP
The conversion table for units of measurement is as follows:
.DS
.ta 0.8i 2.5i
	inch:	1\fBi\fR = 120\fBu\fR
	vertical line space:	1\fBv\fR = 20\fBu\fR
	centimeter:	1\fBc\fR = 47\fBu\fR
	em:	1\fBm\fR = 12\fBu\fR
	en:	1\fBn\fR = 6\fBu\fR
	pica:	1\fBP\fR = 20\fBu\fR
	point:	1\fBp\fR = 1\fBu\fR
.DE
Most of these are traditional typesetting terms.
.PP
As noted briefly earlier,
.BR nroff 's
output actually consists of a sequence of characters.
It is useful, though, to
think of the output as being \*(QLprinted\*(QR
at ten characters per inch (Pica or 10-pitch spacing) and six lines per inch.
Many output devices use this spacing.
With these assumptions, \fB5i\fR is equivalent to five inches of printed output.
.PP
.II "nroff^unit, default"
Every
.B nroff
command has a default unit of measurement.
For example, the default unit for
.B .ll
is
.BR m ,
whereas the default unit for
.B .sp
is
.BR v .
If you type
.DM
        .ll 5
.DE
.B nroff
interprets it not as five inches or five centimeters, but as 5\fBm\fR,
which it converts to 5 times 12, or 60 machine units (60\fBu\fR).
.PP
.B nroff
always assumes
a unit specification as part of each number and automatically converts each
number and its unit specification into machine units.
If you append an explicit unit specification to the number,
.B nroff
uses it; if you do not,
.B nroff
uses the default unit for the command.
.PP
For example, suppose you write the following commands:
.DM
        .nr X 2i
        .ll \enX
.DE
What line length results?
The first command stores the number 2 times 120, or 240, in register
.B X.
The second command is therefore equivalent to typing
.DM
	.ll 240
.DE
However, the default unit for
.B .ll
is
.B m.
Because 1\fBm\fR equals 12\fBu\fR,
.B nroff
sets the line length to 12 times 240, or 2,880 machine units.
If you wanted a line length of two inches
to result from the above commands, you will be unpleasantly surprised,
because 2\fBi\fR equals only 240\fBu\fR.
Instead, you should write:
.DM
        .nr X 2i
        .ll \enXu
.DE
By including the
.B u
in the
.B .ll
primitive, you do not accidentally multiply your results by 12,
as happened earlier.
.PP
You should think of the unit specification as a part of a number.
Because
.B nroff
accepts so many different units of measurement,
a number without a unit specification is ambiguous.
What does \*(Ql5\*(Qr mean?
Five inches?
Centimeters?
Ems?
.B nroff
must know what unit of measurement you are using.
If you think of the unit specification as a part of the number,
you will have less trouble with
potentially mystifying situations like the following.
As mentioned, number registers store only integers and
.B nroff
truncates each number in an arithmetic
expression to an integer before evaluating the expression.
Therefore, the following stores 0 in register
.BR X :
.DM
	.nr X 0.4*9
.DE
But now try the following:
.DM
	.nr X 0.4i
	\enX
.DE
This does not store 0 in
.B X
like the previous command; it stores 0.4 times 120, or 48 in
.BR X .
The 0.4 is not truncated to 0 here!
Truncation occurs
.I after
conversion to machine units, so
.B nroff
truncates 0.4\fBu\fR in the first example.
But the number in the second example is given in inches
.B i
instead of machine units
.BR u .
.B nroff
converts it to
.B u
before truncating to get an integer.
.PP
As another example, the following stores 1 in
.BR X :
.DM
	.nr X 0.01i
.DE
.B nroff
converts 0.01 inches to 0.01 times 120, or 1.2\fBu\fR, and then truncates 1.2
to 1.
.PP
The following command illustrates that
.B nroff
understands
.I each
number in an arithmetic expression
to have an attached unit specification, whether you supply one or not.
.DM
	.ll 2*8
.DE
Recall that
.B nroff
stores the current line length in the register
.B .l;
if you type
.DM
	\en(.l
.DE
you will receive the number 2,304.
.B nroff
interprets the 2 as
2\fBm\fR and the 8 as 8\fBm\fR, because the default unit for
.B .ll
is
.B m.
Then it converts each to machine units and multiplies
to give the result: (2*12)*(8*12), or 2,304.
.PP
.II "nroff^.po primitive"
Consider one final example that
illustrates the unusual consequences of seemingly innocent assignments.
Suppose you set the page offset as follows:
.DM
	.po 8/3
.DE
.B nroff
stores the current page offset in register
.BR .o .
To see what number it stores there, type
.DM
	\en(.o
.DE
You see that the page offset is 2.
Because the default unit for
.B .po
is
.B m,
the calculation is (8*12)/(3*12)=8/3, which
.B nroff
truncates to 2.
Two machine units is equivalent to only 1/60 of an inch.
This is not a physically reasonable value for most typewriter-like
devices, so a page offset of 0 characters results.
On the other hand,
.DM
	.po 8/3u
.DE
produces a page offset of approximately 1/4 of an inch.
.SH "Conditional Input"
.PP
.II "nroff^command, conditional"
.II "nroff^conditional input"
Now that you have been introduced to number registers, you can use them in
conjunction with powerful
.I "conditional commands"
to create more elaborate
.B nroff
scripts.
.PP
To see how conditional statements help you construct
an \*(PN script,
consider again the problem of creating header and footer macros.
Earlier, you constructed macros
that skipped space at the top of the page and
printed the page number at the bottom of each page.
.PP
Suppose, however, that you are formatting a paper that has a title.
You want to print the page
number for page 1 at the bottom of the page, and to print the rest of the
page numbers at the top of the page.
Both the header and the footer need some kind of conditional mechanism
to perform differently on the first page than on subsequent pages.
On page 1, the header should skip to where the
title will be printed; on other pages, the header should
print the page number.
On page 1, the footer should print the page number; on other pages,
the footer should leave a block of blank space at the bottom of the page.
.PP
.II "nroff^.ie primitive"
.II "nroff^.el primitive"
To execute commands conditionally, use the
.I "if/else"
commands
.B .ie
and
.BR .el ,
which are demonstrated in the following example.
Note that the formation \fL''\fR, which is used with
the \fB.tl\fR command, represents two apostrophes, 
\fInot\fR a quotation mark.
.ID
.ta 0.5i 1.75i
	.de HD	\e" define header
	.ie \e\en%=1 .A	\" if page no. is 1 then do A
	.el .B	\e" else do B
	..
	.de A	\e" define macro A
	.sp |1.0i	\e" space down to 1 inches from top of page
	..
	.de B	\e" define macro B
	'sp 2v	\e" skip 2 spaces
	.tl ''- % -''	\e" print page no.
	'sp |1.0i	\e" skip to 1 inch from top of page
	..
	.de FO	\e" define footer
	.ie \e\en%=1 .C	\e" if page no. is 1 then do C
	.el .D	\e" else do D
	..
	.de C	\e" define macro C
	'sp |-4v	\e" move to 4 in. above bottom of page
	.tl ''- % -''	\e" print page no.
	'bp	\e" begin new page
	..
	.de D	\e" define macro D
	'bp	\e" begin new page
	..
.IE
As you can see, the
.B .ie
and
.B .el
commands always occur in pairs.
.B .ie
consists of three parts:
the command name
.BR .ie ,
then a
.I condition
that
.B nroff
tests, followed by a
.I command
.B nroff
performs if the condition is true.
If the condition on the
.B .ie
command line is not true,
.B nroff
performs the command on the
.B .el
line instead.
.PP
In the example, each conditional invokes a macro on the command line.
Actually, the conditional can specify \fIinput\fR text rather than the
command after the condition.
If you want to execute several commands
or include several text lines conditionally,
enclose the lines with the special sequences \*(Ql\e{\*(Qr and
\*(Ql\e}\*(Qr.
.PP
Note, too, that one other new element was introduced in
the construction of these macros.
Some of the
.B .sp
commands have a vertical bar immediately in front of the measurement; for
example,
.DM
	.sp |1.0i
.DE
.II "nroff^measurement, absolute"
Normally, when
.B nroff
sees a command like
.B ".sp 1.0i,"
it moves down one inch on the output page.
The movement is relative to where
.B nroff
happens to be on the output page when it received the request.
The vertical bar tells
.B nroff
that the following measurement is an
.I absolute
measurement, measuring either from the top of the page (if
positive) or from the bottom of the page (if negative).
Therefore,
.DM
	.sp |1.0i
.DE
tells
.B nroff
to move to one inch from the top of the page;
.DM
	.sp |(-4v)
.DE
tells it to move to four vertical spaces from the bottom of the page.
.PP
The
.B .if
primitive
is formed exactly like
.BR .ie .
Unlike
.BR .ie ,
which must always be used with
.BR .el ,
the
.B .if
command may be used by itself.
If the condition on the
.B .if
line is true,
.B nroff
performs the command that follows the condition;
if the condition is false, it ignores the command altogether.
.PP
This chapter ends with two substantial examples
that incorporate most of what you have studied so far.
To illustrate the use
of conditionals, the first example begins each even paragraph of
output with the phrase
.B "Even Paragraph:"
and begins each odd paragraph
with the phrase \fBOdd Paragraph:\fR.
Type this into the file \fBex8.r\fR, and process it through
\*(PN without using the \fB\-ms\fR macro package, and as before,
there is no need to copy the comments:
.ID
.II "Bierce, Ambrose"
.ta 0.5i 1.75i
	.wh 0 HD	\e" set header trap
	.wh -2i FO	\e" set footer trap
	.nr EO 1	\e" set EO register to 1
	.po 2i	\e" page offset 2 inches
	.pl 6i	\e" page length 6 inches
	.lt 4i	\e" title length 4 inches
	.ll 4i	\e" line length 4 inches
	.de HD	\e" define header
	'sp |(1i-1v)	\e" space down to 1 inch minus 1 line
	.tl ''\e\e*(WS''	\e" set WS macro in title
	'sp |1.5i	\e" space down to 1.5 inches
	..
	.de FO	\e" define footer
	'sp |(3i+3v)	\e" space down to 3 inches plus 3 lines
	.tl ''- % -''	\e" set page number in footer
	'bp	\e" begin new page
	..
	.ds WS "From the Devil\e's Dictionary"
	.	\e" define string WS
	.de PP	\e" define paragraph macro
	.ie \e\en(EO=0 .EP	\e" if EO = 0 (even) then do EP
	.el .OP	\e" else do OP
	..
	.de EP	\e" define EP (even paragraph)
	.br
	.nr EO 1	\e" set register EO to 1
	.sp 1v	\e" skip 1 line
	.ll 4i	\e" set line length to 4 inches
	.lt 4i	\e" set title length to 4 inches
	\e\e*E	\e" insert string E
	..
	.ds E "Even Paragraph:"
	.	\e" define string E
	.de OP	\e" define macro OP (odd paragraph)
	.br
	.nr EO 0	\e" set register EO to 0
	.sp 1v
	.ll 3i	\e" set line length to 3 inches
	.lt 3i	\e" set title length to 3 inches
	\e\e*O	\e" insert string O
	..
	.ds O "Odd Paragraph:"
	.	\e" define string O
	.PP
	Debt, n. An ingenious substitute for the whip
	and chain of the slave-driver.
	.PP
	Bore, n. One who talks when you wish him to listen.
	.PP
	Brandy, n. A cordial composed of one part
	thunder-and lightning, one part remorse, two parts
	bloody murder, one part death-hell-and-the-grave,
	and four parts clarified Satan.
	.PP
	Responsibility, n. A detachable burden easily
	shifted onto the shoulders of God, Fate, Fortune,
	Luck, or one's neighbor.
.IE
This example
uses an \*(QLeven/odd\*(QR register called \fBEO\fR
to determine whether you are beginning an even or an odd paragraph.
To distinguish between even and odd paragraphs, it uses a line length
of four inches for even paragraphs and one of of three inches for
odd paragraphs.
It changes the title length with each paragraph, so
.B nroff
centers the page number with respect to whichever kind of
paragraph happens to occur at the bottom of a page.
.PP
The final example illustrates a loop constructed with
the \fBif\fR/\fBelse\fR commands.
The first paragraph is six inches long with no
page offset; each succeeding paragraph is one inch shorter with a
page offset one inch longer.
The line length of the sixth paragraph is one inch;
the next paragraph renews the cycle with a
six-inch line length.
Type this into file \fBex9.r\fR, and process it as you did
the above example:
.II guillotine
.II gallows
.ID
.ta 0.5i 1.75i
	.nr PO 0 1	\e" set register PO to 0, increment by 1
	.de PP	\e" define paragraph macro
	.ie \e\en(PO=6 .A	\e" if register PO=6 then do A
	.el .B	\e" else do B
	..
	.de A	\e" define macro A
	.br
	.nr PO 0	\e" set register PO to 0
	.nr LL 6-\e\en(PO	\e" set register LL to 6 minus PO
	.ll \e\en(LLi	\e" set line length to LL inches
	.po \e\en(POi	\e" set page offset to PO inches
	.nr PO \e\en+(PO	\e" increment register PO
	.sp	\e" skip a space
	..
	.de B	\e" define macro B
	.br
	.nr LL 6-\e\en(PO	\e" set LL to 6 minus PO
	.ll \e\en(LLi	\e" set line length to LL inches
	.po \e\en(POi	\e" set page offset to PO inches
	.nr PO \e\en+(PO	\e" increment register PO
	.sp	\e" skip a space
	..
	.PP
	Future, n. That period of time in which our affairs prosper,
	our friends are true, and our happiness is assured.
	.PP
	Gallows, n. A stage for the performance of miracle plays, in
	which the leading actor is translated into heaven.
	.PP
	Geneaology, n. An account of one's descent from an ancestor
	who did not particularly care to trace his own.
	.PP
	Guillotine, n. A machine which makes a Frenchman shrug
	his shoulders with good reason.
	.PP
	History, n. An account most false, of events
	most unimportant, which are brought about by
	rulers mostly knaves, and soldiers mostly fools.
	.PP
	Idiot, n. A member of a large and powerful tribe
	whose influence in human affairs has always been
	dominant and controlling.
	.PP
	Kiss, n. A word invented by the poets as a rhyme
	for "bliss".
.IE
You should try this example
to see verify that \*(QLloop\*(QR works as advertised.
.SH "Environments and Diversions"
.PP
Another aspect of \*(PN's power is the ability to shift from one
.I environment
to another.
.PP
The
\*(PN
.I environment
is the overall manner in which
.B nroff
processes your input text.
The environment's definition includes such aspects as
line length, fill and adjust modes, and indentation.
.PP
.II "nroff^.ev primitive"
.II "nroff^command, environment"
.B nroff
allows you to define three independent environments, called \fB0\fR,
\fB1\fR, and \fB2\fR.
In each, you can set as you wish such parameters as line length,
filling, adjustment, and indentation.
You can call a different environment with the
.B .ev
command; the parameters you define for the new environment control
text processing until you change them within the present
environment or shift to another environment.
.PP
.II "nroff^command, page offset"
.II "nroff^.po primitive"
Not all
.B nroff
parameters change when you switch to a new environment.
For example, different environments do
.I not
have independent page offsets; the
.B .po
command affects all environments.
Parameters that may be set to different values in different environments are
.IR "environmental parameters" ;
parameters that cannot be switched according to environment, like page offset,
are
.IR "global parameters" .
Macro and string definitions are global.
.PP
When you first call
.B nroff,
you are by default in environment 0.
In all the examples used in this tutorial thus far,
everything happened in environment 0.
The following example illustrates how to switch back and forth
between environments.
Type in the following \fBex10.r\fR and process it to
see the output as you go along.
.ID
.II "Book of Proverbs"
.ta 0.5i 1.75i
	.po 1i	\e" set global page offset to 1 inch
	.ll 4i	\e" set line length in ev 0 to 4 inches
	.de PP	\e" define paragraph macro
	.sp
	.ti 0.5i	\e" indent first line 1/2 inch
	..
	.PP
	The heart of the righteous studieth to answer,
	but the mouth of the wicked poureth out evil things.
	.br
	.ev 1	\e" switch to environment 1
	.ll 3i	\e" set line length to 3 inches
	.ls 2	\e" line spacing now double space
	.PP
	A froward man soweth strife, and a whisperer
	separateth chief friends.
	.br
	.ev	\e" return to previous ev (0)
	.PP
	It is naught, it is naught, sayeth the buyer;
	but when he is gone his way, then he boasteth.	
	.br
	.ev 1	\e" switch to ev 1
	.PP
	Wealth maketh many friends; but the poor is separated
	from his neighbors.
	.br
	.ev	\e" return to ev 0
.IE
The first
.B .ll
command sets a line length of four inches in environment 0.
After defining the paragraph macro
.B .PP
and an initial paragraph in environment 0, you switched to environment 1
with the command
.DM
	.ev 1
.DE
You now enter a new environment.
If you do not explicitly set environmental parameters, such as line length,
.B nroff
automatically uses default values for them.
.B nroff
assigns the same default values in environments 1 and 2 as it does in
environment 0.
.PP
.II "nroff^.ls primitive"
.II "nroff^command, line space"
The line length in environment 1 is set to three inches with
the output text double-spaced.
The
.I "line space"
primitive
.DM
	.ls 2
.DE
leaves one blank line between each output line.
Thus, paragraphs processed in environment 0 have four-inch single-spaced lines,
whereas paragraphs processed in environment 1 have three-inch
double-spaced lines.
.PP
The example used the command line
.DM
	.ev
.DE
without an argument to \fIleave\fR environment 1.
This leaves environment 1 and restores (or \*(QLpops\*(QR) the previous
environment \(em in this case, environment 0.
The next time you enter environment 1, you will not need to
set the line length to three inches again:
the value stays in effect in environment 1 until you specifically change it.
The same is true of all environmental parameters.
.PP
To understand how
.B nroff
switches between environments, imagine that you
have a set of plates, each marked with either a \fB0\fR, a \fB1\fR,
or a \fB2\fR.
You have as many plates of each type as you wish.
You stack the plates on a table;
the top plate represents your current environment.
You begin with a \*(Ql0\*(Qr plate on the table, to
represent the initial environment when you enter
.BR nroff .
.PP
.II "nroff^stack, environment"
Switching to environment 1 with the command
.B ".ev 1"
corresponds to placing a \*(Ql1\*(Qr plate on top of the \*(Ql0\*(Qr plate.
You can again change the stack of two plates either by
placing a new plate on top of the stack,
or by removing the top plate from the stack:
the former corresponds to calling a new environment, whereas the latter
corresponds to restoring the previous environment with the command line
.BR .ev .
.PP
Because you can have as many plates of each type as you wish,
you can call environment 1, then call environment 2, then
restore environment 1, then call environment 0, and so on.
The command \fB.ev\fI N\fR, where
.I "N"
is 0, 1, or 2, places (or \*(QLpushes\*(QR) a plate
onto the stack; the command
.B ".ev"
removes (or \*(QLpops\*(QR) the top plate from the stack.
.PP
To illustrate this, add the following text to the end of the previous example.
Use a piece of paper and pencil to keep track of how the
.B .ev
commands add or remove environments.
Because the line lengths are different in each environment,
it should be easy to tell in which environment
.B nroff
has processed each paragraph:
.ID
.II "Book of Proverbs"
.ta 0.5i 1.75i
	.ev 2	\e" introduce environment 2
	.ll 5i	\e" set line length
	.in 1i	\e" set indentation
	.PP	\e" paragraph in ev 2
	A poor man that oppresseth the poor is like
	a sweeping rain which leaveth no food.
	.br
	.ev 0	\e" push ev 0
	.PP
	As a roaring lion, and a ranging bear; so is
	a wicked ruler over the poor people.
	.br
	.ev 1	\e" push ev 1
	.PP
	Wrath is cruel, and anger is outrageous;
	but who is able to stand before envy?
	.br
	.ev 2	\e" push ev 2
	.PP
	A good name is rather to be chosen than
	great riches; and loving favour rather than
	silver and gold.
	.br
	.ev 0	\e" push ev 0
	.PP
	Pride goeth before destruction, and an haughty
	spirit before a fall.
	.br
	.ev	\e" return to ev 2
	.ev	\e" return to ev 1
	.PP
	He that answereth a matter before he heareth it,
	it is folly and shame unto him.
	.br
	.ev	\e" return to ev 0
	.ev	\e" return to ev 2
	.PP
	A merry heart doeth good like a medicine, but a
	broken spirit drieth the bones.
	.br
.IE
.SH "Buffers"
.PP
Earlier, it was shown that
.B nroff
uses a buffer to assemble words from its input into output lines.
Actually, each environment has its own buffer.
Switching to a new environment does
.I not
cause a break.
Suppose you are currently in environment 1 with an
unfinished line in the buffer.
When you give the command \fB.ev 2\fR, the unfinished line
remains undisturbed in the environment 1 buffer until you return to
environment 1.
Text you process in the meantime in environment 2 or in
environment 0 has no effect on the partial line in the environment 1 buffer,
because
.B nroff
assembles text processed in other environments in different buffers.
.PP
In the following example, you process some text in environment 0 and then
switch to environment 2.
Any partial line collected in
environment 0 when you switch to environment 2 waits patiently in
the buffer until you return to environment 0 and issue the break command
to flush the buffer.
You then return to environment 2 and flush any partially filled
line left when you restored environment 0.
Enter the following into the file \fBex11.r\fR and process it
through \*(PN:
.DM
.ta 0.5i 1.75i
	.ll 3i	\e" set line length in ev 0
	.po 2i	\e" set page offset in ev 0
	This is environment 0.
	.ev 2	\e" introduce ev 2
	This is environment 2
	.br	\e" flush ev 2 buffer
	.ev	\e" return to ev 0
	.br	\e" flush ev 0 buffer
.DE
As you can see, the order of the two sentences is reversed
from the way you entered them.
If you were to delete the \fB.br\fR commands after the
texts in \fBex10.r\fR, the output would be very badly affected.
.Sh "Headers and Footers"
.PP
.II "nroff^.lt primitive"
A common use of environment switching is for the creation of header and
footer macros.
As the following example demonstrates, the length of title set by the
\fB.lt\fR command
is an environmental parameter.
The following constructs
header and footer macros that print strings of asterisks in the margins
above and below the text; type it into your computer as \fBex12.r\fR:
.ID
.ta 0.5i 1.75i
	.wh 0 HD	\e" set header trap 
	.wh |2.5i FO	\e" set footer trap
	.de HD	\e" define header macro
	.ev 1	\e" define ev 1
	.lt 5i	\e" set title length to 5 inches
	'sp 3v	\e" move down three spaces
	.tl '****''****'	\e" define header title
	'sp 2v	\e" skip two more spaces
	.ev	\e" pop environment
	..
	.de FO	\e" define footer macro
	'sp 2
	.ev 1	\e" push ev 1
	.tl '****'%'****'	\e" define footer title
	.ev	\e" pop environment
	'bp	\e" begin new page
	..
	.ll 4i	\e" set line length in ev 0
	.pl 3i	\e" set page length
	.in 1i	\e" set indentation
	.po 2i	\e" set page offset
	.de PP	\e" define paragraph macro
	.sp 1
	.ti 0.5i	\e" indent 1st line 1/2 inch
	..
	.PP
	When in the course of human events ...
.IE
The following section explains why header and footer
macros often use a different environment.
.Sh "More About Fonts"
.PP
As earlier described in some detail,
.B nroff
output includes representations for
.B boldface
and
.I italic
characters,
in addition to the normal Roman characters.
The visual appearance of boldface and italic characters depends
on the device you use to print your
.B nroff
output.
.PP
If you want a word or a phrase to appear in boldface,
enclose the word or phrase between \fB\efB\fR and \fB\efR\fR:
.DM
	The last word of this sentence appears in \efBboldface\efR.
.DE
The sequence \fB\efB\fR tells
.B nroff
to print in boldface, whereas the sequence \fB\efR\fR tells
.B nroff
to return to the Roman font.
Italics are used in a similar manner:
.DM
	An entire phrase \efIappears in italics\efR.
.DE
.II "nroff^.ft primitive"
To print more than a few words in a different font, you should use the
.I font
command
.B .ft:
.DM
	.ft I
	Here is text you want to
	appear in italics.
	.ft R
.DE
The initial
.B ".ft I"
switches the print to italic font, and the concluding
.B ".ft R"
returns it to Roman font.
As you might have suspected, the command
.B ".ft B"
switches to boldface.
.PP
You have two additional options when you use the
.B .ft
primitive.
The command
.B ".ft P"
returns to the
.I previous
font.
You can use
.B ".ft P"
within a macro or a string to return to the previous output font,
even though you do not know which font was previously in effect.
You can also use the sequence \fB\efP\fR to return to the previous font.
The
.B .ft
primitive without an argument tells
.B nroff
to return to the Roman font.
.PP
In scripts that frequently change fonts,
you should switch to a new environment for header and footer macros,
in order to protect their font settings.
.Sh "Diversions"
.PP
.II "nroff^diversion"
The
.I diversion
is a powerful feature that allows you to suspend outputting lines
until \*(PN has collected all of a block of text.
For example, suppose you use
.B nroff
to format a chapter of a book.
The chapter includes footnotes at various places in the text; you want
.B nroff
to collect these footnotes and print at the end of the chapter.
To do this, \*(PN must store the processed footnote text somewhere
until the end of the chapter, when you want it printed.
Where do you store the text until the time comes for it to appear?
To handle situations like this,
.B nroff
provides a
.I diversion
mechanism:
you can
.I divert
text into temporary storage within a macro.
.PP
Diversion normally involves passing to a new environment to process the
footnote without causing a break in the main environment.
When the text of the diversion ends,
.B nroff
returns to the main environment,
again without causing a break, and continues processing
just as if the text of the note had never been in the input.
.PP
.II "nroff^.di primitive"
However, before you attempt to write a footnote macro,
type the following text into the file \fBex13.r\fR, and process it with \*(PN.
This example illustrates the basic features of diversion.
The example exchanges two paragraphs of text, so that
.B nroff
prints the second before the first.
.ID
.II "Book of Proverbs"
.ta 0.5i 1.75i
	.di X	\e" divert the following to macro X
	.sp
	A soft answer turneth away wrath:
	but grievous words stir up anger.
	.br	\e" send last line of paragraph to X
	.di	\e" end diversion
	.sp
	He that is slow to anger is better than the
	mighty; and he that ruleth his spirit than he
	that taketh a city.
	.br
	.sp
	.X	\e" print the paragraph diverted to X
.IE
.II "nroff^command, divert"
The new command here is the
.I divert
primitive
.BR .di .
The command
.B ".di X"
tells
.B nroff
to divert the text that follows into macro
.BR X ;
the matching
.B .di
with no argument marks the end of the diversion.
.PP
The break is necessary before the end of the diversion because
.B nroff
diverts
.I processed
text into the macro.
Without the break,
.B nroff
would not divert any partially filled line in its buffer to
.BR X ;
the last few words of diverted text might not form a complete line in the
buffer, so
.B nroff
might not divert them.
However, if you break the input before you end the diversion,
.B nroff
will also divert those last few words.
.PP
As you saw earlier, the \fB.br\fR command
must be used to flush that environment's buffer
before switching environments.
.PP
The next example, \fBex14.r\fR, illustrates a similar point.
.DM
.ta 0.5i 1.75i
	.br	\e" clear buffer
	testword	\e" put 'testword' into buffer
	.di X	\e" divert to X
	Piracy, n. Commerce without its folly-swaddles,
	just as God made it.
	.br	\e" divert last line
	.di	\e" end diversion
	.X	\e" print text in X
.DE
.II "nroff^.di primitive"
Here
.B nroff
diverts
.B testword
into
.B X
along with the text between
.B ".di X"
and \fB.di\fR.
Why did this happen?
The command
.B ".di X"
does \fInot\fR cause a break.
Because you did not pass to a new environment in this example before
you diverted,
.B nroff
formed the diversion text in the same buffer in which it stored
.BR testword .
You did not break the input, so
.B nroff
appended the diverted text to
.BR testword .
.PP
To make sure
.B nroff
diverts only text between
.B ".di X"
and
.B .di
into
.BR X ,
do one of the following:
If you want to process the diverted
text within the current environment, empty the buffer by inserting the
.B .br
command before you start the diversion.
If you switch to a new environment before starting the diversion, flush
the buffer for the new environment before you begin to process
diverted text.
.PP
.II "nroff^.da primitive"
Diverting processed text into a macro that already holds material
will erase whatever had already been stored there.
In some cases, such as the footnote example, you need to append
information into the same macro.
The
.I "divert and append"
variation
.B .da
of the diversion construction allows you to do so.
The following example, \fBex15.r\fR, demonstrates this command:
.ID
.II "Bierce, Ambrose"
.ta 0.5i 1.75i
	.ll 3i	\e" set line length
	.po 2i	\e" set page offset
	.de PP	\e" define paragraph macro
	.br
	.sp 1
	.ti 0.5i	\e" indent first line 1/2 inch
	..
	.di X	\e" divert the following into X
	.PP
	Litigation, n. A machine which you go into as a pig
	and come out of as a sausage.
	.br
	.di	\e" end diversion
	.X	\e" print what is in X
	.br
	.da X	\e" divert and append material into X
	.PP
	Inventor, n. A person who makes an ingenious arrangement
	of wheels, levers and springs, and believes it
	civilization.
	.br
	.di	\e" end diversion
	.X	\e" print what is now in X
.IE
In this example, you first diverted a single paragraph into the macro \fBX\fR.
.B nroff
stored in
.B X
the
.I processed
paragraph; in other words, the command line
.B .PP
is
.I not
stored in
.BR X ;
its
.I output
is.
When you invoke
.B X
with the command line \fB.X\fR,
.B nroff
takes the processed text in
.B X
as input.
To
.B nroff,
there is no difference between processed text and unprocessed text as input:
it processes the contents of
.B X
in the current environment, just like any other text.
Therefore,
.B nroff
processes diverted text \fItwice\fR: first when it
stores the text within the macro, and again when you invoke the macro.
.PP
The fact that
.B nroff
processes diverted text twice can cause problems if you are not careful.
Fortunately, nothing strange happens in the example above.
You store a processed paragraph with lines three inches long in
.BR X .
When you invoke
.BR X ,
the line length is three inches.
Because each line in
.B X
is already exactly three inches long, nothing happens to it when
reprocessed; the layout of the output paragraph is unchanged.
.PP
But now, consider what happens in the following example, \fBex16.r\fR:
.ID
.II "Bierce, Ambrose"
.ta 0.5i 1.75i
	.ll 3i	\e" set line length
	.po 2i	\e" set page offset
	.de PP	\e" define PP macro
	.sp 1
	.ti 0.5i	\e" indent first line 1/2 inch
	..
	.di X	\e" divert following into X
	.ev 2	\e" push environment 2
	.ll 4i	\e" set line length to 4 inches
	.PP
	Justice, n. A commodity which in a more or less
	adulterated condition, the State sells to the
	citizen as a reward for his allegiance, taxes
	and personal service.
	.br
	.ev	\e" pop environment (return to ev 0)
	.di	\e" end diversion
	.X
.IE
A pargraph processed in environment 0 in this example
has three-inch lines; you want your diverted paragraph to have
four-inch lines.
However, when you print the diverted paragraph with the command line
\fB.X\fR, what happened?
.B nroff
did
.I not
print four-inch lines.
The four-line text lines set in environment 2 were
reprocessed into three-inch lines when the diversion
macro is called in environment 0.
.PP
There are two ways to prevent such disasters.
First, if you wish to invoke
.B X
in the main environment, use no-fill mode:
.DM
.ta 0.5i 1.75i
	.nf	\e" begin no-fill mode
	.X
	.fi	\e" return to fill mode
.DE
In no-fill mode,
.B nroff
outputs lines of input exactly as it receives
them, so it keeps four-inch lines four inches long and does not change the
format of the diverted text.
The second strategy is to return to environment 2 and then invoke
.BR X ;
again, the format of the diverted paragraph does not change, because the line
length in environment 2 is four inches.
.DM
.ta 0.5i 1.75i
	.ev 2	\e" push environment 2
	.X
	.ev	\e" restore original environment
.DE
.Sh "A Footnote Macro"
.PP
The footnote macro that follows
does not print notes at the bottom of each page;
rather, it prints everything at the end of the chapter.
In the processed text, number register \fBFn\fR is
used to keep track of the footnote number;
the footnote number will be printed in
square brackets where the footnote originally appeared in the text.
.PP
Type this macro into the file \fBex17.r\fR.
If you wish to use it in your text processing, transfer it to
the directory \fB/usr/lib\fR under the name \fBtmac.fn\fR.
Then, whenever you wish to use this macro, be sure to include the option
.DM
	\-mfn
.DE
when you invoke \*(PN:
.DM
.ta 0.5i 1.75i
	.de FN	\e" define macro FN
	[\e\en+(Fn]	\e" print footnote no. in main text
	.ev 1	\e" push environment 1
	.da Z	\e" divert and append following into Z
	.sp
	\e\en(Fn. \e\e$2, \e\efI\e\e$1\e\efR,
	    \e\e$3, \e\e$4.	\e" format & print footnote in Z
	.br	\e" flush diversion buffer
	.di	\e" end diversion
	.ev	\e" pop environment (return to ev 0)
	..
.DE
Note that requests to change fonts are preceded by double backslashes,
because they are within a macro.
The change to the italic font prints the first
macro argument, which should be the title of the work, in italics.
Number register
.B Fn
contains the number of the last footnote;
you should initialize it with the command
.DM
	.nr Fn 0 1
.DE
As shown above, each footnote entry in your text should have
four arguments.
In your input text, each footnote will look like this:
.DM
.II "Burton, Sir Richard"
	.FN "Personal narrative of a pilgrimage to\e
	El-Medinah and Mecca" "Richard F. Burton"\e
	London 1856.
.DE
When you print the diversion
.B .Z
at the end of the chapter,
each footnote will be laid out as follows:
.nf
.sp \n(pDu
.ft L
.ta 0.5i 1.0i
	8.	Richard F. Burton,
.ul
		Personal narrative of a pilgrimage to
.ul
		El_Medinah and Mecca,
		London, 1856.
.sp \n(pDu
.fi
.R
.SH "Command Line Options"
.PP
In the previous sections, you learned how to control
.B nroff
by including
.I commands
in the input along with the
.I text.
You can also supply information
in another way:  on the command line you type to call
.BR nroff .
Unlike the commands discussed above, this information is
.I not
part of the script you input into \*(PN.
.PP
You already know about some simple
.B nroff
command lines.
For example, the command
.DM
	nroff
.DE
forces \*(PN to accept input from the keyboard (sometimes called the
.I "standard input)"
and print output on the terminal (the
.I "standard output)."
Type
.B <ctrl-D>
(that is, hold down the
.B ctrl
key and type
.BR D )
to exit from
.B nroff
if it is reading input from your terminal.
.PP
The command line
.DM
	nroff script1.r
.DE
forces \*(PN to take accept input from the file
.B script1.r
instead of from your terminal, while
the command
.DM
	nroff \-ms script.r
.DE
processes
.B script1.r
with the
.B \-ms
macro package.
You can also redirect
.B nroff
output to another file
.B target:
.DM
	nroff \-ms script1.r >target
.DE
.PP
The general form of the
.B nroff
command line is:
.DM
	\fBnroff\fI [ option ... ] [ file ... ]\fR
.DE
This means that the command line consists of the \*(PN
command, followed by zero or more \fIoption\fRs, followed by zero
or more \fIfile\fRs.
.B nroff
processes each named
.I file
and prints the result on the standard output
(the terminal, unless redirected).
If no
.I file
argument is given,
as in the first example above,
.B nroff
reads from the standard input.
.PP
Each
.I option
on the command line must begin with a hyphen \*(Ql\-\*(Qr
to distinguish it from a
.I file
specification.
Using
.B nroff
with the
.B \-ms
macro package is one example of entering an option.
.II "nroff^/usr/lib/tmac"
In general, the
.B \-m
option takes the form
.DM
	\-\fBm\fIname\fR
.DE
which means the option consists of the characters
.B \-m
immediately followed by a
.I name.
This tells
.B nroff
to process the macro package found in the
\*(CO file
.DM
        \fB/usr/lib/tmac.\fIname\fR
.DE
For example, the
.B ms
macro package discussed in chapter 2 is in the file
.B /usr/lib/tmac.s,
whereashe
.B man
macro package used
for the
.B man
command and to process manual pages
is in the file
.B /usr/lib/tmac.an.
.PP
Any macro packages that you customize for your own use
should be stored in the directory \fB/usr/lib\fR
under such a name if you wish to use
them with the \fB\-m\fIname\fR option.
.PP
The
.B \-i
option tells
.B nroff
to read input from the standard input
after processing each given
.I file.
This allows you to supply additional input interactively from your terminal.
.PP
The
.B \-x
option tells
.B nroff
not to move to the bottom of the last output page when done.
This is especially useful if you want to see
the output on the screen of a CRT terminal.
.PP
The \-\fBn\fIN\fR option
sets the page number of the first output page to the number
.I N,
rather than starting at page 1.
This is useful for processing large documents
with input text in several files which
.B nroff
processes separately.
.PP
The \-\fBr\fIXN\fR option sets the value of number register
.I X
to
.I N.
This option lets you initialize number registers when you invoke
.BR nroff .
.PP
The \*(CO system provides many useful features which
can be helpful while you are using
.B nroff.
In particular, you can use a number of special characters.
The
.I "stop-output"
and
.I "start-output"
characters, usually
.B <ctrl-S>
and
.B <ctrl-Q>,
stop and restart output on your terminal.
The
.I interrupt
character, usually
.BR <ctrl-C> ,
interrupts program execution;
you can use it to stop an
.B nroff
command if you typed the command line incorrectly.
The
.I kill
character, usually \fB<ctrl-\fR\\>,
also terminates program execution.
Some \*(CO systems use different characters than those
mentioned above;
consult
.I "Using the COHERENT System"
for details.
.SH "For Further Information"
.PP
The Lexicon entry for \fBnroff\fR summarizes its primitives, dedicated
number registers, escape sequences, and command-line options.
.PP
For example, this manual was typeset by \*(CO
.BR troff .
The program \fBtroff\fR also performs text formatting.
Unlike
.BR nroff ,
however,
.B troff
produces proportionally spaced output that can be
printed on printers that support the Hewlett-Packard Page Control Language
(including the LaserJet and DeskJet families of printers) or on any
printer that implements the PostScript page-control language.
This manual (including the positioning of the fancy capital letters and
ornaments) was typeset by
.B troff
under the \*(CO system.
See the Lexicon entry for \fBtroff\fR for details on how to use this
command.
.PP
The Lexicon also has entries for two macros packages that are included
with the \*(CO system:
.B man ,
which produces manual pages similar to those that appear in the Lexicon;
and
.BR ms ,
which performs formatting somewhat similar to that seen in this tutorial.
You will find that these two packages already perform practically all
of the formatting tasks that you will commonly need to do.
.PP
The error messages generated by
.B nroff
are given in the appendix at the rear of this manual.

. PostScript/titlepage.r 5/7/91
. Print title page with MWC logo
.rb /u/steve/PostScript/lib/box.ps
.rb /u/steve/PostScript/lib/mwc2.ps
.ll 8.5i
.co
/inch { 72 mul } bind def
.1 0 .5 7.5 inch 10  inch .5 inch .5 inch box
.1 0 1  7.3 inch 9.8 inch .6 inch .6 inch box
1 0 1 inch 1 inch 1 inch mwclogo2
.co
.ce 1000
.ps 100
.vs 110
.sp |3i
i80386
C
Compiler
Source

.ds TL Introduction
.NH "Introduction"
.PP
.B gcc
for \*(CO
is a port of the popular GNU C/C++ compiler and
related tools to the \*(CO 386 operating system.
It offers a powerful and flexible compiler with many features that are
not found in most C compilers.
.\" Too damn many, if you ask me.
It is also the basis for many other products available from the
Free Software Foundation, including
.B groff
and
.BR perl .
.PP
This pamphlet introduces
.B gcc
for \*(CO.
It describes the contents of the package, tells you how to install it,
and introduces the documentation that is included on disk.
.SH "Contents of the Package"
.PP
The
.B gcc
distribution holds the GNU C compiler,
GNU C++ preprocessor, the GNU debugger, and related tools.
It consists of three disks.
.PP
Note that this package contains no source code.
It contains only headers, libraries, executables, and documentation.
The source code for this release of GNU C is available
through Mark Williams Company as a separate package.
.SH "Requirements"
.PP
.B gcc
for \*(CO will run only on release 4.2 of \*(CO or any subsequent release.
It will not run on any release of \*(CO prior to release 4.2.
If you have any release of \*(CO prior to release 4.2, you must update
to release 4.2 before you can run
.B gcc
on your system.
.PP
In addition to running \*(CO 386, your system must have the following:
.IP \(bu 0.3i
At least four megabytes of RAM; eight megabytes or more is preferred.
.IP \(bu
At least 20,000 blocks (ten megabytes) of free space on your hard disk
partition which contains directory
.BR /usr .
If you do not have a file system with that much free space, you must
create free space or you will not be able to install the release.
.SH "Warranties and Support"
.PP
Mark Williams Company cannot offer support for the portions of this
product that come from the Free Software Foundation.
These include the
.B gcc
compiler itself, its preprocessor, and derived products.
These are supplied on an \fIas-is\fR basis only.
.\" We suggest you call the MacArthur Foundation
.\" and ask for Richard Stallman's phone number.
.PP
With these caveats in mind, we hope that you enjoy working with
.B gcc
for \*(CO!
.SH "Kudos"
.PP
We at Mark Williams Company warmly thank
.I "Kent Galbraith"
for his invaluable help with this product.
.SH Installation
.PP
The following describes how to install
.B gcc
for \*(CO 4.2 onto your system.
.PP
Note that unlike
.B gcc
for \*(CO 4.0, you do not need to install a supplemental update kit.
The
.B gcc
package works with \*(CO 4.2 just as they come out of the box.
To install the
.B gcc
package, you must have roughly 17,000 blocks (8.5 megabytes) free on
your root file system if you intend to uncompress the documentation,
or 15,000 blocks (7.5 megabytes) if you leave the documentation compressed.
.PP
To install the package from 5.25-inch floppy disks in floppy-disk drive 0
(i.e., drive A), use the following command:
.DM
	/etc/install COHgcc /dev/fha0 3
.DE
To install the package from 3.5-inch floppy disks in floppy-disk drive 0,
use the following command:
.DM
	/etc/install COHgcc /dev/fva0 3
.DE
.B install
will prompt you to insert each floppy disk in turn into drive A.
It will then copy each disk's contents onto your hard disk.
Finally, it will de-compress and un-archive all files that are shipped
in compressed or archived form.
.PP
.B install
will copy the files into directories
.BR /usr/bin ,
.BR /usr/local/lib ,
and
.BR /usr/local/docs .
The first two directories hold executable and support files; the last holds
GNU documentation.
The installation script also installs into
.B /usr/bin
the
.B gdb
debugger and stubs for
.B gcc
and
.BR g++ ,
so you do not have to alter your search
.B PATH
to use
.BR gcc .
.SH "Contents"
.PP
The
.B gcc
for \*(CO release consists of file installed into the following directories:
.IP "\fB/usr/bin\fP" 0.5i
This directory contains the following tools:
.BR c++ ,
.BR g++ ,
.BR gcc ,
.BR gdb ,
.BR gmake ,
.BR protoize ,
and 
.BR unprotoize .
.IP "\fB/usr/local/docs\fP"
This directory contains GNU documentation for the
.B gcc
and
.BR g++ ,
the debugger
.BR gdb ,
and the library
.BR libg++ .
.IP "\fB/usr/local/lib/gcc-lib/i386-coh/2.\fI*\fR"
This directory contains the actual compiler phases, run-time startup
modules, and the C and C++ libraries.
.IP "\fB/usr/local/lib/gcc-lib/i386-coh/2.\fI*\fB/g++-include\fR"
This directory, along with any subdirectories, contains all header
files needed by the
.B g++
compiler or the
.B libg++
library.

.ds TL Introduction
.NH "Introduction"
.PP
Congratulations on your purchase of \*(CO release 4.2!
\*(CO gives your 80386- or 80486-based system a fully multi-tasking,
multi-user operating system \(em at a fraction of the cost of other systems.
We think you will appreciate the fact that \*(CO is powerful
yet inexpensive, efficient, and easy to install.
.PP
This pamphlet shows you how to install \*(CO on your system.
It also includes information you should find helpful in using \*(CO.
This includes information on how to contact Mark Williams Technical
Support, and how to access the Mark Williams Bulletin Board.
\fIRead these notes carefully before you attempt to install or update
\*(CO on your computer.\fR
.SH "Frequently Asked Questions"
.PP
Before we begin, please note the following:
.IP \fB1.\fR 0.3i
If you need to telephone Mark Williams Technical Support, dial
1-708-291-6700.
Please do not telephone on the Mark Williams sales number.
.IP \fB2.\fR
If you are updating your \*(CO system, you will
.I not
have received a card with a serial number on it.
This is because you must use the serial number of your current \*(CO system.
If you do not know your system's serial number, read the file
.BR /etc/serialno
and write down its contents on a piece of paper.
Be sure to write the number correctly, or \*(CO will complain when you
attempt to update it.
.SH "Recent Enhancements"
.PP
\*(CO includes many new features:
.IP \(bu 0.3i
Improved support for third-party packages.
The UNIX System-V editions of Lotus and WordPerfect now work out of the box.
.IP \(bu
Support for X Windows.
An X Windows package is now available for \*(CO from Mark Williams Company.
.IP \(bu
A rewritten version of the \*(CO kernel.
The kernel now includes
\*(ST, the \*(UN system for portable device drivers;
.IP \(bu
Many new system calls, including support for the
.B sigset()
and
.B sigaction()
families of signal-handling system calls;
and \*(UN System-V interprocess comunications, including shared memory,
semaphores, and messages queues.
.IP \(bu
Tools for configuring and rebuilding the kernel.
With release 4.2, you can change kernel variables, add or delete drivers,
and modify driver variables, then build a new bootable kernel.
.IP \(bu
Support for peripheral devices has been expanded.
Devices support now include
SCSI tape and a variety of SCSI devices.
The console has been rewritten to be more robust and to conform more closely
to accepted \*(UN standards.
The keyboard driver has been expanded and now
supports more languages, including Greek.
.IP \(bu
An improved compiler, linker, and assembler.
These include a completely restructured set of header files,
which bring \*(CO closer to the \*(PX standard;
support for mathematics co-processors;
and a greatly improved version of the \*(CO debugger
.BR db .
.IP \(bu
The visual shell
.BR vsh .
This shell uses drop-down menus, function keys, and single-key commands
to give you a simple, clear interface to the \*(CO system; yet it works
on a character-based terminal.
.IP \(bu
The Taylor \*(UU package.
This is a more robust and flexible version of \*(UU.
.IP \(bu
The MLP print spooler.
This spooler is modelled after the \*(UN command
.BR lp .
You now can have multiple printers of any type
plugged into your \*(CO systems, and access them via parallel ports,
serial ports, or the auxiliary port on a terminal.
.IP \(bu
A more robust version of the
.B curses
library, including support for eight-bit characters and color.
.IP \(bu
.B troff
now supports eight-bit character sets.
.B troff
now comes with tools to ``cook'' loadable PostScript fonts, and to
access fonts built into the Hewlett-Packard LaserJet III.
.IP \(bu
Improved versions of the Bourne shell
.B sh
and the Korn shell
.BR ksh .
Many bugs have been fixed, and the Bourne shell now supports shell functions.
.PP
The following new commands have been added to \*(CO:
.nf
.sp \n(pDu
.tc . 0.1i
.ta 1.25i
\fBalmanac\fR	Print a listing of the events on today's date in history
\fBapropos\fR	Find the Lexicon entries that relate to a given topic
\fBasymkdev\fR	Create a node for asynchronous devices
\fBcancel\fR	Cancel a print job
\fBchreq\fR	Change a job's priority, life expectancy, or output device
\fBcohtune\fR	Change the value of a flag or variable in a \*(CO device driver
\fBcu\fR	\*(UN-style communications program
\fBfmt\fR	Adjust the length of lines in a file of text
\fBfwtable\fR	Build a \fBtroff\fR font-width table from a PCL or PostScript ``soft font''
\fBgnucpio\fR	GNU version of the \fBcpio\fR archiver
\fBgtar\fR	GNU version of the \fBtar\fR tape archiver
\fBgzip\fR	Industry-standard compression tool from the Free Software Foundation
\fBidenable\fR	Add a device driver to the \*(CO kernel, or delete a driver from it
\fBidmkcoh\fR	Build a new bootable kernel
\fBlcasep\fR	Convert text to lower case
\fBidtune\fR	Set the value of a ``tunable'' variable in the \*(CO kernel
\fBipcrm\fR	Remove an interprocess-communication item from memory
\fBipcs\fR	Display a snapshot of interprocess communications
\fBlp\fR	Spool a job for printing via the MLP spooler
\fBlpadmin\fR	Administer the MLP spooler
\fBlpsched\fR	Turn on the \fBlp\fR print spooler
\fBlpshut\fR	Turn off the \fBlp\fR print spooler
\fBlpstat\fR	Give the status of a printer or job spooled through the MLP spooler
\fBpclfont\fR	Prepare a PCL for downloading via MLP
\fBPSfont\fR	Cook an Adobe font into downloadable PostScript
\fBreprint\fR	Reprint a spooled job
\fBroute\fR	Show or reset a user's default printer
\fBtape\fR	Manipulate the tape device
\fBttytype\fR	Set the default types of remote terminals
\fBvsh\fR	Invoke the \*(CO visual shell
.PP
For more information on any command, see its entry in the Lexicon.
.SH "How to Use These Notes"
.PP
This pamphlet consists of the following sections:
.IP \fB1.\fR 0.3i
The introduction \(em that is, the section you are reading right now.
.IP \fB2.\fR
List of hardware.
This section lists hardware that we know works with \*(CO, and
equipment that we know does \fInot\fR work with \*(CO.
Check your equipment against this list
.I before
you begin installation.
.IP \fB3.\fR
Installation guide.
This section walks you through the process of installing \*(CO
on your computer.
\fIThis section is for users who do not yet have \*(CO
on their computers.\fR
In the off chance that something goes wrong during installation,
this section also describes problems that have occurred to some
users, and how to work around them.
.IP \fB4.\fR
Update guide.
\fIThis section is for users who already have \*(CO,
and are upgrading to \*(CO release 4.2.\fR
.IP \fB5.\fR
Third-party software.
This section details software available for \*(CO,
including those available from Mark Williams Company and
from third-party vendors.
Because \*(CO can run many packages
designed for \*(UN, the list of software
that runs on \*(CO is growing daily.
Check the Mark Williams BBS for the latest list of available software.
.IP \fB6.\fR
Running third-party software.
This gives directions on to make any necessary minor configuration changes
so you can install and run the most popular third-party packages.
.IP \fB7.\fR
Bulletin board and user groups.
This section describes how to dial into the Mark Williams Bulletin Board.
This BBS gives you access to public-domain software that has been
ported to \*(CO.
It gives new versions of device drivers,
technical-support bulletins, product announcements, and bug fixes.
You can also exchange mail with the Mark Williams technical support staff
and other \*(CO users.
.IP
This section also introduces \*(CO user groups.
This section describes \*(CO user groups throughout the world,
and how you can contact them.
It also describes how you can form a \*(CO user group and register it
with Mark Williams Company.
.IP \fB8.\fR
Notes and errata.
This section describes helpful hints
that were discovered after the manual went to press.
This section also lists bugs that have been found in this version of \*(CO,
but have not yet been fixed.
Please note that as soon as a bug is fixed, you can download the corrected
version of the program in question from the Mark Williams BBS.
It also summarizes corrections and changes in the Lexicon that have been
made since the manual was last printed, and that are available in the
on-line Lexicon.
.PP
Read these notes through before you do anything else.
Then check your hardware against the machines listed in the following section.
If you do not find a discrepancy between your machine and what is given in
this section, then continue on to the installation or upgrade section,
and load \*(CO onto your system.
.SH "Contacting Mark Williams Technical Support"
.PP
Mark Williams Company
has a team of technical support specialists who are skilled at helping you
solve the problems you encounter with \*(CO.
.PP
The technical support staff try to respond promptly to
all inquiries, whether by telephone, FAX, e-mail, or ordinary mail.
Sometimes, however,
we receive e-mail from a customer only to find that our reply message
is undeliverable.
Therefore, if you send us e-mail,
please also include a FAX number or telephone number, or mailing address.
This will help ensure that we can contact you with our reply;
after all, if we can't reach you, we can't help you solve your problem.
.PP
To get the most out of
your discussion with Technical Support, please follow these guidelines:
.IP \fB1.\fR 0.3i
Have your \*(CO serial number at hand.
.IP \fB2.\fR
Know the hardware configuration you are using.
This includes make and
model for your motherboard, BIOS, hard drive, and any add-in cards.
.IP \fB3.\fR
Have an exact description of the problem.
If you are getting an error message or \*(QLpanic\*(QR message,
write down \fIexactly\fR what appears on the screen.
If a certain file, such as a C program or \fBnroff\fR document,
causes a problem, try to whittle the file down to the smallest size that
duplicates the problem, then mail the file on a floppy disk to Mark Williams
Company.
.IP \fB4.\fR
If you are having problems with \*(UU, please log in as
.B root
(the super-user) and enter the command
.BR uulog .
If you continue to have problems, have available (and if possible, FAX
to us) the contents of the following files:
.BR /etc/ttys ,
.BR /usr/lib/uucp/sys ,
.BR /usr/lib/uucp/port ,
and
.BR /usr/lib/uucp/dial .
Also, execute the following command to log file permissions on
key \*(UN files:
.DM
	ls -lR /dev/com* /usr/lib/uucp /usr/spool/uucp >/tmp/MWC.info
.DE
Fax a hardcopy of file
.B /tmp/MWC.info
or copy the file onto a floppy
and mail it to the Mark Williams Company Technical Support department.
.IP \fB6.\fR
If possible, call us when you are at your computer, with the
computer turned on, so we can ``walk you through'
any diagnostic or repair measures needed.
.IP \fB7.\fR
For information on how to contact Mark Williams Company,
see the copyright page of this pamphlet.

.ds TL "Installation"
.ds TI "RELEASE NOTES"
.NH "Installing COHERENT"
.PP
The following describes how to install \*(CO onto your computer.
Installation of \*(CO is straightforward, and Mark Williams Company
has prepared a suite of programs that automate much of the work for you.
.PP
Tens of thousands of users have successfully installed \*(CO onto their
computers.
Most have found the process to be easy and quick.
An uncomplicated installation will take approximately 30 minutes.
.PP
A few users have experienced some problems with installation;
so if installation does not go as smoothly as you would like, the end of this
section describes the commoner problems and how you can fix them.
If all else fails, telephone Mark Williams Technical Support, as described
in the introduction to this booklet.
.SH "Installing Vs. Updating"
.PP
Before you continue any further, please note that this section is for
users who are not yet running \*(CO on their computers.
If you already are running \*(CO and are updating to \*(CO 4.2,
\fRskip\fI this section and instead read the following section,
.IR "Updating COHERENT" .
If you re-install \*(CO over an existing \*(CO system, all \*(CO
files you already have will be wiped out!
.PP
We do not mean to frighten you.
However, we do know that you may well have spent a great deal of customizing
your \*(CO system; and we would hate to see all that work lost due to a
simple mistake.
So, we'll say it once again:
\fIIf you already are running \*(CO, you want to \fBupdate\fI \*(CO \(em
not \fBinstall\fI it.
Skip this section and instead
read the following section, on updating \*(CO!\fR
.SH "Before You Install"
.PP
As you have read this far, we assume that you are \fInot\fR now running
\*(CO, and that you do wish to \fIinstall\fR \*(CO onto your system.
Before you begin installation, you must make a few decisions about how
you want to configure your computer; and you must collect some information
about your system.
We suggest that you make a checklist and fill it in before you begin
installation.
.PP
If you wish to have \*(CO reside on the same hard disk as \*(MD,
OS/2, or Windows NT,
be sure to read the section below entitled \fIInstalling COHERENT
With Other Operating Systems\fR.
.Sh "Caveats"
.PP
Although \*(CO is a flexible system that can run on a wide variety
of machines, it cannot run on everything.
The following conditions must apply before you can install
\*(CO on your system:
.IP \fB1.\fR 0.3i
Your system hard disk must have a free partition with at least
20 megabytes of space free on it.
More is recommended, but 20 megabytes is the minimum space required
to install \*(CO.
You need at least 45 megabytes if you also wish to install X Windows for \*(CO.
.IP
If your system does not have a free partition, you must either take one away
from \*(MD, or you must split an existing DOS partition into two and
give one to \*(CO.
In either case, all data on that partition will be destroyed.
How to do this is described below.
.IP \fB2.\fR
Your system must be based upon the Intel 80386 or 80486 processor,
or an exact clone.
.IP \fB3.\fR
Your system must have at least four megabytes of available RAM.
If you wish to run X Windows for \*(CO, you must have at least eight
megabytes; more is recommended.
.\".IP
.\"Please note that some clone motherboards do not
.\"``map'' the region of RAM which lies between 640K (0xA0000) and one
.\"megabyte (0x100000).
.\"If your system uses one of these motherboards and contains only
.\"one megabyte of RAM chips,
.\"you effectively have a 640K system and will not be able to install \*(CO.
.IP \fB4.\fR
Your system components must be 100% IBM compatible in order to run \*(CO.
The system bus can be based upon either the Industry Standard Architecture (ISA)
or the Extended Industry Standard Architecture (EISA).
MicroChannel (MCA) machines are not yet supported.
.IP \fB5.\fR
If you are installing \*(CO onto a notebook or other
computer system that uses a modified 83-key layout rather than the
industry standard 101-key or 102-key layout, you may experience
key transpositions and other anomalies.
If you are using the keyboard driver that uses loadable tables,
read Lexicon article
.B vtnkb
for information on how to modify the keyboard-mapping tables for your system.
.IP \fB6.\fR
Your system must have at least one high-density, 3.5-inch or
5.25-inch floppy-disk drive installed as drive A.
The distribution disks for \*(CO cannot be read by a low-density
floppy-disk drive, nor can they be converted from one size of disk to
the other.
.IP
Due to limitations in the BIOS of the IBM PC and its clones,
\*(CO can be installed \fIonly\fR from drive A.
Thus, if your system has both sizes of floppy-disk drive, your release of
\*(CO must be for the disk drive that your system knows as drive A.
.PP
If your system meets these criteria, then you probably can install and
run \*(CO, as tens of thousands of other users have done.
Check the list of compatible and incompatible hardware in the second
section of this booklet to see if any of your hardware is listed.
If your system does not appear on either list, you probably can still install
and run \*(CO \(em but Mark Williams Company will be interested in your
experience.
.PP
The following sections discuss your preparations in more detail.
.Sh "Hard-Disk Partitioning"
.PP
The hard disk and its controller is one of the most important elements
with which \*(CO must work.
\*(CO continually works with the hard disk:
it loads programs, creates temporary files, updates existing data files,
uses information stored on disk to access peripheral devices, and so on.
Thus, how you configure your hard disk will make a great difference to
your system.
.PP
A \*(CO system can have several hard disks:
up to two AT-style (IDE, RLL, MFM, or ESDI) disks, and up to eight SCSI disks.
You can have either one AT controller on your system, or one SCSI
controller, or one AT controller plus one SCSI controller.
.PP
The point of the installation procedure is to create
one or more partitions on a hard disk to hold \*(CO and its files.
When you (or your dealer) installed \*(MD on your computer, you (or he)
divided your computer's hard disk (or disks) into \fIpartitions\fR.
Each hard disk can has four partitions.
Partitions are numbered sequentially, beginning with partition 0:
If you have one hard disk, the partitions are numbered 0 through 3;
if you have two hard disks, the partitions on the first hard disk are numbered
0 through 3, the partitions on the second are numbered 4 through 7; and so on.
.PP
Although a hard disk has four partitions, you can modify the amount
of disk space that each partition holds.
Each disk has a written on it a
.IR "partition table" ,
which records where each partition begins and where it ends \(em and
thus, how much space each partition holds.
A partition can even be set to have zero space, thus making it unused.
Further, special rules govern how you must configure very large IDE
drives (that is, IDE drives that have more than 1,024 cylinders).
These rules are discussed below.
Both \*(CO and \*(MD come with a program named
.BR fdisk ,
which lets you edit a disk's partition table to reset the beginning and
end points of each disk's partitions.
Later in this chapter, we will discuss how you can use \*(CO's version of 
to change the dimensions of a partition on your disk, should you wish to.
.PP
Please note that not every partition must be
used \(em a hard disk can be divided into four partitions,
but have \*(MD file systems in only two of them,
with the third and fourth partitions being idle.
Note, too, that the four partitions do not necessarily have to
encompass the entire hard disk \(em a disk may have space that is outside
any partition and so remains unused.
.PP
The file systems for \*(CO and \*(MD are very different, so it is not
possible to have both systems use the same partition \(em each
must have one or more partitions completely to itself.
(Note, however, that \*(CO comes with tools that let you copy files
between an \*(MD file system \*(CO.)
.Sh "MS-DOS Parititions on the Hard Disk"
.PP
Another factor that installation must cope with is how many partitions
have you already given to \*(MD.
If you have one hard disk, you may have either one or two \*(MD partitions.
The first partition is the \*(MD primary partition, and
the second (if there is one) is the \*(MD extended partition.
\*(MD lets you sub-divide the extended partition into logical drives D, E, F,
and so on.
.PP
\*(CO
.I cannot
be installed onto a logical drive.
In this scenario, you have these options:
.IP \fB1.\fR 0.3i
Install \*(CO onto
.I all
of the \*(MD extended partition.
You will lose drives D, E, F, etc., and
.I all
data in them.
.IP \fB2.\fR
Use the \*(MD version of the command
.B fdisk
to delete an existing partition, then make it smaller
by however much disk space you wish to allocate to \*(CO.
Remember that \*(CO requires at least 20 megabytes;
while \*(CO plus X requires at least 45 megabytes.
This step frees disk space from \*(MD.
\*(CO will see this freed space and allow you to turn this into a \*(CO
partition (or partitions).
.IP \fB3.\fR
If your hard drive has space that lies outside of any existing partition,
\*(CO will let you turn it into a \*(CO partition.
.PP
These options apply even if you already have \*(MD plus any other operating
system (e.g., OS/2 or Windows NT) on your system.
.PP
It may well be that you do not know the configuration of your hard disk
(or disks).
\*(CO's installation program will figure this out automatically, then
displayed this information to you at the appropriate point in installation.
.Sh "Hard-Disk Controller"
.PP
Another variable is the type of hard-disk controller you have.
\*(CO works with AT-style (IDE, RLL, MFM, and most ESDI) hard-disk controllers.
It also works with many SCSI host adapters.
Please check the previous section in this booklet
for a list of supported hard\-disk controllers and host adapters.
.PP
If you intend to install \*(CO onto a system that uses one of the
supported SCSI host adapters, be sure that your host adapter is jumpered
to enable interrupts.
Make sure that you know the interrupt number and other configuration
information before you begin to install \*(CO.
.PP
If you have a SCSI drive, \*(CO will ask you during installation for
the following information about your SCSI drive.
You should jot down the requested information before you begin installation:
.IP \fB1.\fR 0.3i
The number of SCSI drives you have.
.IP \fB2.\fR
Manufacturer of host adapter, and parameters:
Adaptec, Seagate, or Future Domain.
.IP \fB3.\fR
If you have an Adaptec host adapter, whether your device's BIOS uses
a 64-head translation mode.
This is the default.
.IP \fB4.\fR
The IRQ the host adapter uses.
The default is 11 for Adaptec, five for Seagate or Future Domain devices.
.IP \fB5.\fR
The hexadecimal host adapter base-port address.
The default is 0x330 for Adaptec, 0xCA00 for Seagate or Future Domain devices.
.IP \fB6.\fR
The DMA channel the host adapter uses.
The default is five.
.IP \fB7.\fR
For each SCSI device you have, you must assign a SCSI ID, zero through seven.
If you have only one SCSI device, the default is zero.
.PP
If for some reason you cannot find out this information for your device,
don't panic.
The default value for each of these parameters is carefully chosen,
and in all probability will work with your device.
.Sh "Hard Disk Summary"
.PP
To summarize, when you install \*(CO, you must cope with the following
variables:
.IP \(bu 0.3i
The number of disk controllers on your system.
.IP \(bu
The type of each controller.
.IP \(bu
The number of disks plugged into each controller.
.IP \(bu
The size of each disk (with special rules for IDE drives that have more
than 1,024 cylinders).
.IP \(bu
The size of each partition on each partition.
.IP \(bu
The number partitions you have already given to \*(MD, and the size
of each.
.PP
Installation thus will follow any of a number of possible scenarios,
depending on how your system is organized, how much space you've given
to \*(MD, and how much disk space you wish to give to \*(CO.
However, \*(CO's installation program will walk you through these decisions,
to make this process as easy as possible.
.PP
On a side note,
we recommend that you keep a copy, on paper, of your computer's partitioning.
This information can be vital in helping you to recover from a catastrophic
error with your hard disk.
.PP
For an overview of how \*(CO handles hard disks, see the article entitled
.B hard disk"
in the \*(CO manual's Lexicon.
.Sh "Peripheral Devices"
.PP
You should note the port into which you have plugged each your printers and
modems.
If you have a SCSI tape device, note the SCSI identifier that it uses.
The installation program will ask you for this information so it can
configure your system correctly.
.PP
The installation program will also ask you if you wish to have one or more
of your serial ports in polled mode.
For information on what this means, see the Lexicon article on
.BR asy .
.PP
You will also be asked about what console devices you have on your system.
Currently, the \*(CO install procedure lets you install up to a total of
eight virtual-console sessions on each of two physical consoles.
Note the number of video cards plugged into your system, and whether the
cards are monochrome or color.
.Sh "System Name"
.PP
When you install \*(CO you will be asked to name your system.
You must do this to use electronic mail under \*(CO;
this will permit other systems to identify your system.
You should pick a name that is easy to remember, yet probably unique.
No name should be longer than seven characters.
.PP
See the Lexicon article
.B uucpname
for details on system names, and examples.
.Sh "Domain Name"
.PP
Finally, when you install \*(CO you will be asked to name your system's
electronic mail domain.
If you will be adding your system to a \*(UU domain, you should enter its
name; otherwise, you should select the default domain name \fBUUCP\fP.
If you join a \*(UU domain later, or change domains, you can name that
domain simply by editing the file \fB/etc/domain\fR.
.PP
See the Lexicon article
.B domain
for details on domains.
.Sh "Information Form"
.PP
The following page gives a form that summarizes the information you need
before you install \*(CO onto your system.
We suggest that you fill it out, then refer to it as you install \*(CO
onto your system.
This will help you ensure the accuracy and completeness of the information
you enter during installation, and help spare you from experiencing that
``sinking feeling'' one gets when one realizes half-way through installation
that you've forgetten something important.
.bp
.B1
.so install.form
.sp
.B2
.bp
.SH "Installing COHERENT"
.PP
Now that the preliminaries are over, we can begin to install \*(CO
onto your system.
This assumes that you have done the following:
.IP \(bu 0.3i
Filled out the form on the preceding page.
.IP \(bu
Backed up your disk.
.IP \(bu
If necessary, used \*(MD's version of
.B fdisk
to free up enough space for \*(CO.
.PP
You can abort the installation procedure at any time by typing
.BR <ctrl-C> .
However, aborting installation does \fInot\fR mean that
your hard disk will be returned
to the state it was in before installation was begun.
\fIWhen a disk is repartitioned, the files that were on any
modified partitions are gone forever!\fR
.PP
During the installation, \*(CO explains what it is doing.
It asks your permission before it executes any action
that could destroy data on your disk.
However, read the following directions carefully before you begin,
so you know
.I exactly
what is going on before you begin.
Please read them through before you begin.
.Sh "Beginning Installation"
.PP
To begin installation, turn your system off.
Take the \fBBoot\fR disk from your installation
kit (i.e., disk 1) and insert it into floppy-disk drive A.
(The disk
.I must
be placed into drive A.
Installation will not work if you put it into drive B.)
.PP
Now, turn your system on.
Your system reads the boot disk and boots a mini-version of \*(CO from it.
In a moment, you see a question mark `?', which is a prompt.
Type:
.DM
	begin
.DE
and press the \*(RT key.
This loads \fBbuild\fR, the \*(CO installation program, into memory and
begins execution.
As \*(CO loads
.BR build ,
it displays a spinning character for your amusement.
.PP
When
.B build
is loaded into memory and begins execution, it displays a copyright notice:
.B1
.sp 2
                              The COHERENT System
.sp
                Copyright (c) 1982, 1995 by Mark Williams Company
.sp
                     60 Revere Drive, Northbrook, IL  60062
.sp
                        708-291-6700, 708-291-6750 (FAX)
.sp 2
.B2
.PP
Press \*(RT.
You will see the following greeting:
.B1
.sp
	Welcome to the COHERENT operating system!
.sp \n(pDu
	Your computer is now running COHERENT 386 from the floppy disk.
	This program will install COHERENT onto your hard disk.
.sp \n(pDu
	If you are already running COHERENT on your hard disk, you must perform an
	update rather than a full installation.  To do so, please REBOOT NOW and
	follow the detailed update instructions in the COHERENT release notes supplied
	with this release.
.sp \n(pDu
	You can interrupt installation at any time by typing <Ctrl-C>;
	then reboot and start the installation procedure again.
	Please be patient and read the instructions on the screen carefully.
.sp
.B2
.PP
As the instructions say, you can interrupt installation at any point by
typing \fB<ctrl-C>\fR.
.Sh "Enter the Serial Number"
.PP
.B begin
asks you to enter a nine-digit serial number:
.B1
.sp
	A card included with your distribution gives the serial number
	of your copy of COHERENT.
.sp \n(pDu
	Type in the serial number from the card:
.sp
.B2
.PP
This number is included on the registration card
supplied with your copy of \*(CO.
The installation process cannot continue until you enter this number
correctly.
If you type the wrong number three times, installation will abort;
so type carefully.
.Sh "Configuration of Hard Disks"
.PP
We now enter the most important phase of installation:
describing and configuring your hard disks.
.PP
.B build
begins this phase by asking you how many hard-disk controllers you have,
and what their types are:
.B1
.sp
	Most PC compatible computer systems use MFM, RLL, IDE, or ESDI disk
	controllers and disk drives.  Others use SCSI disk drives.
	Please indicate the type(s) of disk drive(s) used in your computer system.
	If you are uncertain of the type, please select choice 1.
.sp \n(pDu
	Are you using:
.sp \n(pDu
	1.  AT-compatible hard drive controller (IDE/RLL/MFM/ESDI).
	2.  SCSI hard drive controller.
	3.  Both.
.sp \n(pDu
	Enter your choice:
.sp
.B2
.PP
Select the appropriate entry:
1, 2, or 3.
As the above message implies, you can have one AT-type controller, one
SCSI controller, or one of each type.
You cannot have more than one of either type of controller.
.Sh "Installing an AT Disk"
.PP
If your system has an AT-compatible hard-drive controller
(i.e., IDE, RLL, MFM, or ESDI controller),
.B build
will ask you about polling:
.B1
.sp
	Most AT-compatible controllers work with NORMAL polling.
.sp \n(pDu
	Some IDE hard drives require ALTERNATE polling.
.sp \n(pDu
	If you get "<Watchdog Timeout>" or "at0:TO" errors with normal polling,
	use alternate polling.
.sp \n(pDu
	Use NORMAL polling ? [y]
.sp
.B2
.PP
Throughout installation, the default response to a prompt appears in
square brackets after the prompt.
To select the default, simply press \*(RT.
In this, press \*(RT to select the default response, `Y' (for ``yes'').
To use alternate polling, press `N'; however, you should not
do so unless you are absolutely certain that normal polling does not work.
.PP
.B build
then asks for the number of AT-type hard-disk drives you have:
.B1
.sp
	How many IDE hard drives are on your system ? (1-2) [1]
.sp
.B2
.PP
To select the default \(em in this case, one hard drive \(em press \*(RT.
Press `2' if you have two AT-style hard-disk drives.
Note that you can have no more than two AT-type hard drives
plugged into your one AT-type controller.
.PP
Finally,
.B build
asks:
.B1
.sp
	Are you installing on an IBM PS1 or ValuePoint ? [n]
.sp
.B2
.PP
Press \*(RT to select the default, which is `N'.
Press `Y' if you are installing onto a PS/1 or ValuePoint machine.
Also answer `Y' if you are installing onto an IBM ThinkPad machine.
.B build
will ask you a few additional questions that apply only to those machines.
.PP
At this point,
.B build
writes some information to reflect what you have entered so far.
You may see some vaguely comprehensible text on your screen.
Do not be alarmed.
.Sh "Installing a SCSI Hard Disk"
.PP
If you indicated that your system has one or more SCSI hard disks,
.B build
at this point asks for information about them.
If you do not have a SCSI hard disk, but you do have a SCSI controller
with other peripherals (e.g., tape drive), you will be asked about
these at a later point in installation.
.PP
First, it asks what type of SCSI controller you have:
.B1
.sp
	COHERENT currently supports the following SCSI host adapters:
.sp \n(pDu
	(1) Adaptec AHA-154x series
	(2) Seagate ST01 or ST02
	(3) Future Domain TMC-845/850/860/875/885
	(4) Future Domain TMC-840/841/880/881
.sp \n(pDu
	Your choice ? (1-4)
.sp
.B2
.PP
.B build
then walks you through a dialogue to gather information.
If you do not know what your disk uses, or if you do not understand
what the question is asking, select the default \(em
it nearly always is correct.
.PP
A SCSI controller can have up to eight peripheral devices plugged into it.
Each peripheral device (hard disk, CD-ROM, or tape device) that is plugged
into a SCSI controller has its own unique SCSI ID number.
Some devices set you set this by setting a dial;
others require that you set a jumper.
At this point in installation,
.B build
asks you which SCSI identifiers you have assigned to the hard disk or disks
that are plugged into your SCSI controller:
.B1
.sp
	Hard disk drives are configures at the following SCSI IDs
	0
	Is this correct ? [y]
.sp
.B2
.PP
It is customary to assign SCSI ID hard disks beginning with ID zero;
however, you are not required to do so.
.B build
displays one default number for each SCSI hard disk.
If the default is correct, press \*(RT.
If it is not, press `N';
.B build
will then prompt you to enter the SCSI ID number (or numbers) for each
hard disk that is plugged into your SCSI controller.
.PP
The next four questions display information that is specific to the
host adapter.
The prompts will vary, depending upon which host adapter you are using.
.PP
The first of the host-adapter-specific questions
asks you to name the I/O port for your host adapter.
Each family of supported host adapters has its own range of ports
and defaults; for example, if you have an Adaptec AHA-154x controller,
the prompt will appear as follows:
.B1
.sp
	The AHA-154x can use IO port:
	0x130, 0x134, 0x230, 0x234, 0x330, 0x334
.sp \n(pDu
	Your choice: ? (0x100-0xfff) [0x330]
.sp
.B2
.PP
If you are not sure of the correct port for your controller,
select the default:
in most instances, it will be correct.
.PP
The next question asks you to enter the interrupt channel.
Again, each family of controllers will have its own channel; if you are
using an Adaptec AHA-154x controller, the prompt appears as follows:
.B1
.sp
	The AHA-154x can use Interrupt Channel: 9, 10, 11, 12, 14, 15.
.sp \n(pDu
	Your choice: ? (2-15) [11]
.sp
.B2
.PP
Again, if you do not know which channel to use, select the default; it
probably is correct.
.PP
The third question asks you to enter the host adapter's DMA channel.
If you have an Adaptec AHA-154x controller, the prompt appears as follows:
.B1
.sp
	The AHA-154x can use DMA channel: 0, 5, 6, 7.
.sp \n(pDu
	Your choice: ? (0-7) [5]
.sp
.B2
.PP
Again, select the default if you are not sure which channel to use.
.PP
The last host-adapter-question question asks you to enter the SCSI ID for the
host adapter itself.
If you have an Adaptec AHA-154x controller, the prompt appears as follows:
.B1
.sp
	The AHA-154x host adapter may have SCSI ID 0 through 7.
.sp \n(pDu
	Your choice: ? (0-7) [7]
.sp
.B2
.PP
As you would expect, you should select the default if you are not sure
which SCSI ID to use.
.PP
At this point,
.B build
records the information you have entered.
You will again see some barely comprehensible text on the screen.
This is normal; do not be alarmed.
.Sh "Back Up the Hard Disk"
.PP
After you have entered information about time and your disk,
installation moves on to its next phase,
partitioning the hard disk.
Before you become seriously involved in partitioning, however, you have
one last chance to back up your hard disk.
As you enter the partition phase of installation, you will see the following
text:
.B1
.sp
	This installation procedure allows you to create one or more partitions
	on your hard disk to contain the COHERENT system and its files.
	Each disk drive may contain no more than four logical partitions.
	If all four partitions on your disk are already in use, you will
	have to overwrite at least one of them to install COHERENT.
	If your disk uses fewer than four partitions and has enough unused space
	for COHERENT (\fIN\fP megabytes), you can install COHERENT into the unused space.
	If you intend to install MS-DOS after installing COHERENT,
	you must leave the first physical partition free for MS-DOS.
.sp \n(pDu
	The next part of the installation procedure will let you change the
	partitions on your hard disk.  Data on unchanged hard disk partitions
	will not be changed.  However, data already on your hard disk may be
	destroyed if you change the base or the size of a logical partition,
	or if you change the order of the partition table entries.
	If you need to back up existing data from the hard disk,
	type <Ctrl-C> now to interrupt COHERENT installation; then reboot your
	system and back up your hard disk data onto diskettes.
.sp
.B2
.PP
If you need to back up your hard disk and have not yet done so, please abort
.B build
and do so now.
.Sh "Use the COHERENT Bootstrap?"
.PP
If you have already backed up your hard disk, continue to the next phase,
which is to decide whether to use the \*(CO master bootstrap.
When you press \*(RT, you will see the following text:
.B1
.sp
	COHERENT initialization normally writes a new master bootstrap program onto
	your hard disk.  The COHERENT master boot allows you to boot the operating
	system on one selected disk partition (the active partition) automatically;
	it also allows you to boot the operating system on any disk partition by
	typing a key when you reboot.  Mark Williams strongly recommends that you
	use the COHERENT master boot.  However, the COHERENT master boot may not
	work with some operating systems (for example, Xenix) if you make the
	COHERENT partition active; instead, leave the other partition (e.g. Xenix)
	active and boot COHERENT by typing a key.  If you do not use the COHERENT
	bootstrap, you must understand how to boot the COHERENT partition using your
	existing bootstrap program.
.sp \n(pDu
	Do you want to use the COHERENT master boot [y or n] ?
.sp
.B2
.PP
As explained in the prompt text, a \fIbootstrap\fR is a program that
pulls an operating system into memory and sets it to running \(em the
name relates to the fact that the operating system \*(QLpulls itself up
by its boot straps\*(QR.
The \*(CO master bootstrap can boot \*(CO as well as many other
operating systems, including \*(MD, OS/2, and Windows NT.
.PP
If you choose not to use the \*(CO master bootstrap, you must consult
the documentation that came with your system to see how you can use your
operating system's current bootstrap routine to boot another operating system.
If, however, you choose to use the \*(CO master bootstrap and find that
it has trouble booting your current operating system, you should be able to
boot your current operating system by using a boot floppy disk; you will not
be able to boot it off of the hard disk, but at least it will be available
to you.
For these reasons, we strongly suggest that you use the \*(CO master
bootstrap routine.
.Sh "Partitioning the Hard Disk"
.PP
.B build
then moves into the next phase:
selecting one or more disk partitions for \*(CO.
As described above, partitioning can vary greatly from disk to disk;
how the disk is partitioned will determine how much space is allocated
to \*(CO and how much to other systems.
This is the trickiest part of installation, so be sure to read carefully.
.Sh "How a Disk Is Organized"
.PP
This phase begins by displaying the current layout of your hard disk:
the number of partitions, the size of each partition, and the operating
system that ``owns'' each partition.
Note that the partition table is displayed in \fIphysical\fP order (i.e., the
actual order in which the partition table entries occur).
Some operating systems display the table in \fIlogical\fP or sorted order.
.PP
The following gives the printout for a typical hard disk.
This hard disk, called disk \fB0\fR,
has approximately 33 megabytes on it organized into
two \*(MD partitions, as follows:
.B1
.sp
	Drive 0 Currently has the following logical partitions:
	              [In Cylinders] [  In Tracks  ]
	Number  Type  Start End Size Start  End Size Mbyte Blocks Name
	0 Boot MS-DOS    0  149  150     0  899  900  7.83  15300 /dev/at0a
	1     EXT-DOS  150  614  464   900 3684 2784 24.28  47430 /dev/at0b
	2      UNUSED    0    0    0     0    0    0     0      0 /dev/at0c
	3      UNUSED    0    0    0     0    0    0     0      0 /dev/at0d
.sp
.B2
.PP
As you can see, this disk has four partitions, numbered 0 through 3.
Partition 0 is marked as the boot partition; what this means is
explained below.
\*(CO has given each partition a name, \fB/dev/at0a\fR through
\fB/dev/at0d\fR; you will not be working with these, however, so you can
safely ignore them for now.
.PP
Note that the middle columns of the table give
the size of each partition in three ways:
in cylinders, in tracks, and in megabytes.
How do these differ?
Megabytes is the easiest to understand:
that is the number of bytes that can be written into the partition.
Cylinders and tracks, however, relate to the way a hard disk is built.
A moment spent here on background can make what is to come much easier
to understand.
.Sh "Cylinders and Tracks"
.PP
Consider a high-density floppy disk.
Its surface is organized into 80 concentric rings, or \fItracks\fR,
numbered 0 through 79.
Each track holds a fixed amount of data; the amount held
depends upon the density of the disk.
When the disk is in your disk drive, a \fIhead\fR
moves back and forth, reading tracks as directed.
Unlike a phonograph cartridge, however,
the head jumps from track to track discretely \(em it does not spiral in.
Thus, you can measure space on a disk simply by counting the tracks.
Note, too, that
the term \*(QLhead\*(QR is often used to describe one surface of a
multi-sided disk.
.PP
As you've probably noticed, a floppy disk has two surfaces:
the top and the bottom.
The top is usually refered to as side 0, the bottom as side 1.
Each surface has its own system of tracks, each numbered 0 through 79,
giving a floppy disk a total of 160 tracks.
Also, to read the disk a floppy disk drive actually has two heads,
one for each surface.
.PP
A \fIcylinder\fR is the set of identically numbered tracks from both
surfaces of the disk.
A floppy disk organizes its 160 tracks into 80 cylinders:
side 0 track 0 plus side 1 track 0 form cylinder 0; side 0 track 1
plus side 1 track 1 form cylinder 1, etc.
If you think of a track as being a ring on the disk, then origin of
the term \*(QLcylinder\*(QR should be obvious.
.PP
Now, consider a hard disk.
The term \*(QLhard disk\*(QR is somewhat incorrect, because one
hard-disk drive actually contains many hard disks, or \fIplatters\fR,
inside itself.
The platters are stacked on a spindle, much like a set of 45-rpm
records stacked on a record changer \(em except that heads move
between the platters, one head for each platter surface (or two per platter).
The number of platters and the number of tracks on each platter determine
both the number of cylinders and the amount of data that can be written to
the disk.
Consider the disk described in the above table, which is a fairly
typical device.
It has three platters (six heads).
Each head has 615 tracks, each of which holds 8,704 bytes.
Thus, the device has a total of 3,690 tracks (6 times 615), organized into
615 cylinders, with each cylinder holding 52,224 bytes (6 times 8,704).
.PP
Different operating systems organize disk partitions in different ways.
\*(MD, for historical reasons, organizes partitions along track boundaries;
under this scheme, the tracks of a cylinder can
be divided between two partitions.
\*(UN, \*(CO, and similar operating systems prefer to organize partitions
along cylinder boundaries:
all of the tracks of a cylinder belong to only one partition.
This lessens movement of the heads, which in turn speeds up reading of the disk.
Note that, strictly speaking, ``megabytes'' has no meaning for the task of
disk partitioning:
partitioning must be done either in tracks, or in cylinders.
Humans tend to think of partitions in terms of megabytes, that is, in terms
of the amount of data we can write into a partition;
but when you organize your disk,
it is much easier to think in terms of cylinders.
It is simple to translate cylinders into megabytes, which gives you
the best of both worlds; this will be discussed below.
.Sh "Partitioning the Disk"
.PP
Now that we have discussed partitioning in theory, here's how
.B build
walks you through this process.
.PP
.B build
begins by displaying the following message:
.B1
.sp
	This program will let you change partition information for each disk drive.
	A disk drive can be divided into one to four logical partitions.
	You can change the active partition (the partition which your
	system boots by default) or change the layout of logical partitions.
	Other programs which change hard disk partition information
	may list logical partitions in a different order.
	Hit <Esc><Enter> to return to the main menu at any time.
	Now hit <Enter>.
.sp
.B2
.PP
.B build
then displays a summary of information about the first hard-disk drive
on your system (what \*(CO calls drive 0).
The following gives an example of this summary:
.B1
.sp
	According to your computer system:
	Drive 0 has 615 cylinders, 6 heads, and 17 sectors per track.
	It contains:
		615 cylinders of 52224 bytes each,
		3690 tracks of 8704 bytes each,
		62730 sectors of 512 bytes each
	or a total of 32117760 bytes (32.12 megabytes).
	Do you think the above values are correct [y or n] ?
.sp
.B2
.PP
If you this this information is correct, press `Y'; otherwise press `N'.
Your confirmation shows that
.B build
is reading information from your system correctly.
.PP
.B build
then displays the configuration of the hard disk, followed by a menu of options:
.B1
.sp
	Drive 0 Currently has the following logical partitions:
	              [In Cylinders] [  In Tracks  ]
	Number  Type  Start End Size Start  End Size Mbyte Blocks Name
	0 Boot MS-DOS    0  149  150     0  899  900  7.83  15300 /dev/at0a
	1     EXT-DOS  150  614  464   900 3684 2784 24.28  47430 /dev/at0b
	2      UNUSED    0    0    0     0    0    0     0      0 /dev/at0c
	3      UNUSED    0    0    0     0    0    0     0      0 /dev/at0d
.sp \n(pDu
	Possible actions:
	   0 = Quit	
	   1 = Change active partition (or make no partition active)
	   2 = Change one logical partition
	   3 = Change all logical partitions
	   4 = Delete one logical partition
	   5 = Change drive characteristics
	   6 = Display drive information
	   7 = Proceed to next drive
.sp
.B2
.PP
Before we discuss what these options do, note that you must
.I not
use any of the above options to alter the size of an \*(MD partition.
You can either install \*(CO into
.I all
of an \*(MD partition, or into any part of the drive
that is not allocated to \*(MD.
If you use
.B build
to change the size of an \*(MD partition to make room for \*(CO,
will (1) invalidate the \*(MD partition table, (2) corrupt your \*(MD data,
and (3) make \*(MD unbootable from the hard drive.
If you wish to change the
size of an \*(MD partition, abort installation of \*(CO, back up all of your
\*(MD data, use the \*(MD version of
.B fdisk
to change the layout of your hard disk, restore your \*(MD data, and only
then install \*(CO.
.PP
The following describes each option in detail.
.RS
.IP \fB0.\fR 0.3i
Quit this phase of installation.
This option does not alter the disk's partition table in any way;
and it moves into the next phase of installation.
Use this option if you do not wish to alter your disk's partitioning
in any way.
.IP \fB1.\fR
The \fIactive partition\fR is the partition whose operating system
the \*(CO bootstrap program boots by default when you turn on your computer.
This option allows you to change which partition is the active partition.
.IP
You can also say that you system has
.I no
active partition.
If you do so, the computer will prompt you at boot time
for the partition to boot.
Note that if later you wish to change the active partition, you can use the
\*(CO command \fBfdisk\fR to do so.
See the Lexicon entry on \fBfdisk\fR for details.
.IP \fB2.\fR
This option lets you change one logical partition \(em in effect, it lets
you select a logical partition for \*(CO.
You should use this option if your hard disk has more than one partition
and you wish to install \*(CO onto only one of them.
The partition you select must hold at least 15 megabytes.
Note that the contents of the partition will be deleted.
.IP \fB3.\fR
This reconfigures the entire disk.
You can reset the number of partitions, and the size of each.
.IP \fB4.\fR
This options lets you delete an partition.
.IP \fB5.\fR
This option lets you to change the drive parameters
associated with each drive on your system.
.IP \fB6.\fR
Give summary information about the disk.
.IP \fB7.\fR
This option appears only if you have more than one hard disk drive.
Use this option to select the next hard disk drive.
.PP
If the owner of this hard disk wanted to organize her hard disk by
megabytes, all she would have to do is divide 1 million by 52,224 to find
that one megabyte is approximately equal to 20 cylinders; thus, to make
a 15-megabyte partition, she would assign it 300 cylinders.
The size of a cylinder may be different on your system, but the principle
is the same.
.PP
The next step depends on two factors:
the current organization of your hard disk, and the amount of space you
wish to give to \*(CO.
The limit for a \*(CO partition is 500 megabytes,
but up to several hundred megabytes is more realistic.
If your disk has only one logical partition, you must use option 3
to create at least one new logical partition.
If your disk already has more than one logical partition,
use option 2 to assign one to \*(CO
or use option 3 to assign more than one,
reserving the rest for your current operating system.
Of the partition(s) that you assign to \*(CO, one must hold at least
20 megabytes \(em you cannot use two ten-megabyte partitions;
thus, if no partition on your disk holds 20 megabytes, you must use option 3.
.PP
How much space should you give \*(CO?
\*(CO is a multi-user, multi-tasking operating system:
the more space you assign to it on your disk,
the more users and the more processes it can support.
\*(CO, via \*(UU and other communications programs, also gives you access to
information on other \*(CO and \*(UN systems throughout the world; you will
want to exchange mail with other users and possibly download news and
information.
All of this takes up space.
You must have one 20-megabyte partition to hold \*(CO's root file system
(that is, the file system that holds the files that make \*(CO go), and
you would be well advised to assign at least one more partition of at least
half that size to hold users' accounts and their files.
.PP
If you have a large disk drive that is organized into one partition
that you wish to assign to \*(CO, you are well advised to divide it
into two smaller partitions.
For example, if you wish to allocate 500 megabytes to \*(CO, you should
create two 250-megabyte partitions rather than one 500-megabyte partition.
In addition, if you anticipate wanting to perform a full restore
of a dumped root partition, you are well advised to have a spare
\*(CO partition in addition to the root partition.
An alternative strategy would be to boot from the \*(CO boot floppy disk
and then restore your root partition.
This assumes that the device you dump and restore from is different
than your boot floppy!
.PP
We will discuss options 2 and 3 in a moment.
First, however, we must discuss a special situation in partitioning
a disk \(em that is, partitioning an extended IDE disk.
.Sh "Large IDE Drives"
.PP
Earlier, we mentioned that special rules govern how \*(CO manages large
IDE drives.
.PP
The design of the IBM PC limits to 1,024 the number of cylinders that an
AT-style hard disk can have.
This puts practical limitations on how large a hard disk can be;
however, some IDE drives perform use some special routines so they
can address more than 1,024 cylinders.
.PP
Beginning with release 4.2.14, \*(CO supports this extended addressing on
an IDE drive; however, there is one restriction on this support:
\fIthe root partition for \*(CO must lie entirely within the disk's first
1,024 cylinders.\fR
If you have such an extended IDE hard disk, bear this rule in mind as you
partition your disk and assign a partition to \*(CO for its root file system.
If you do so, all will be well.
.PP
The following two sub-sections describe what happen when you invoke options
2 or 3 from the
.B fdisk
menu.
.Sh "Changing One Logical Partition"
.PP
You will first be asked which partition you wish to change.
Reply by entering the partition you want.
.B build
replies with the following text:
.B1
.sp
	Existing data on a partition will be lost if you change
	the base or the size of the partition.  Be sure you have
	backed up all data from any partition which you are going
	to change.
.sp \n(pDu
	You may specify partition bases in cylinders or in tracks.
	Do you want to specify bases in cylinders?
.sp
.B2
.PP
Reply \*(QlY\*(Qr, to use cylinders.
.B build
then asks:
.B1
.sp
	You may specify partition sizes in cylinders or in megabytes.
	Do you want to specify partition sizes in cylinders?
.sp
.B2
.PP
Reply \*(QlY\*(Qr, again to use cylinders.
Next, the system says whether the partition is initialized to another
operating system (that is, to Xenix, OS/2, or MS-DOS), or is unused.
It then asks you whether you wish to install \*(CO into the partition,
leave the partition unchanged, or mark the partition as unused.
For example:
.B1
.sp
	The current operating system type is MS-DOS.
	Do you want this to be a COHERENT partition?
.sp
.B2
.PP
Answer `Y' if you want this to be a \*(CO partition.
If you answer `N',
.B build
asks:
.B1
.sp
	Do you want the partition marked as unused?
.sp
.B2
.PP
Answer `Y' if you want it to be unused.
If you answer `N',
.B build
displays the following message:
.B1
.sp
	This program can mark a partition as a COHERENT partition
	or mark it as unused.  It CANNOT initialize a partition for
	use by any other operating system.  To do so, you must mark
	it as unused now and subsequently use the disk partitioning
	program provided by the other system to initialize it correctly.
	Do you still want to modify this partition?
.sp
.B2
.PP
As this message notes,
.B build
cannot install any operating system other than \*(CO into a partition.
You can, of course, leave the partition unchanged.
.PP
The final two questions ask you to enter the new base cylinder for the
partition and the size of the partition in cylinders.
Each question prompts you with the current value for the partition.
Simply pressing \*(RT leaves this current value unchanged.
You could make the partition smaller, but this serves no
practical purpose if you intend to install \*(CO into this partition.
.PP
If you have made a mistake during this process,
.B build
asks you to correct it.
Otherwise, you will proceed to the next phase of installation, which is
to scan for bad blocks (described below).
.PP
We've said it before, but just to make sure we'll say it once again:
\fINever\fR use the \*(CO version of \fBfdisk\fR to change
the size of an \*(MD partition!
Use it to change the size of an unused partition,
or of partitions that contain \*(CO.
If you wish to change the size of an \*(MD partition, back up all data
in that partition, then use the \*(MD version of \fBfdisk\fR.
.Sh "Changing All Logical Partitions"
.PP
This option is identical to the one that changes only one partition, except that
.B build
repeats it for every partition.
If you have four partitions and wish to eliminate one,
just set its size to zero.
If you have fewer than four partitions, you will be asked if you wish
to create any additional ones.
.PP
Note one additional feature:
the table that displays the layout of partitions (an example of which is
shown above) is redisplayed after every partition, showing the changes
you have made (if any).
By looking at the table, you will find it easy to keep straight just what
you have done \(em when you work with this table, you will see the value of
working in cylinders.
.PP
If you make a mistake, the system will prompt you to correct it.
A common error is requesting overlapping partitions \(em that is,
setting the base cylinder of a partition within an area already
allocated to another partition.
Another common error is to request an impossibly large partition.
.PP
We strongly recommend that you
.I not
include the last cylinder of your hard disk in any partition.
This cylinder is often used by diagnostic programs, and, as such,
is not available for general use.
.PP
Once you have made your selection of partition strategy,
.B build
displays the altered partition table and asks you if you wish to proceed
with partitioning.
Answer `Y' if you do, `N' if you do not.
.Sh "Selecting the Root File System"
.PP
At this point, you have finished describing how your disk drive (or drives)
is partitioned.
.PP
If your newly partitioned disk has more than one partition assigned
to \*(CO,
.B build
displays information about the \*(CO partitions and asks which you want
to hold the root file system.
The following display is for a system with two hard-disk drives (one
IDE and one SCSI);
the IDE drive has two \*(CO partitions and the SCSI has four:
.B1
.sp
	Your system includes 6 COHERENT partitions:
	Drive  Partition    Device     Megabytes
	  0        0      /dev/at0a      31.01
	  0        1      /dev/at0b      75.20
	  1        4      /dev/sd0a      20.96
	  1        5      /dev/sd0b      62.91
	  1        6      /dev/sd0c      62.91
	  1        7      /dev/sd0d      60.82
.sp \n(pDu
	You must specify one COHERENT partition as the root filesystem.
	The root filesystem contains the files normally used by COHERENT.
	The root filesystem should be at least 20 megabytes.
.sp \n(pDu
	Which partition do you want to be the root filesystem?
.sp
.B2
.PP
Select the number of the partition you want to hold the root file system.
You must boot \*(CO from the partition that holds the root file system;
however, you are not obliged to make that partition the active partition.
If you do not make the root partition the active partition,
you must select that partition by hand when you wish to boot \*(CO.
This is easy to do, and in a moment we'll show you how to do it.
.Sh "Scanning for Bad Blocks"
.PP
Next, you must decide whether to scan each \*(CO partition for bad blocks.
.PP
\*(CO keeps a list of bad blocks for each partition, to ensure
that it does not write data into an unreliable area.
(NB, the terms \fIblock\fR and \fIsector\fR are often used interchangeably.)
Most hard disks have at least a few blocks in which the disk's surface
is flawed and therefore cannot be trusted to hold data reliably.
.PP
.B build
asks you the following question for each partition that you have set aside
for \*(CO:
.B1
.sp
	The next step in installation is to scan each COHERENT partition on the
	drives for bad blocks.  This will not write to the partition being scanned.
	Be patient.  This will take a few minutes.
.sp \n(pDu
	Do you wish to scan /dev/\fIdevice\fP for bad blocks [y/n] ?
.sp
.B2
.PP
Answer `Y' if you wish to examine the partition for bad blocks;
answer `N' if you do not.
Scanning is not usually performed for SCSI devices; however, some users
with removable SCSI media have encountered problems with bad blocks,
regardless of the promises of their devices' manufacturers.
.PP
Scanning a partition takes a few minutes, so patience is recommended.
.Sh "Creating COHERENT File Systems"
.PP
Once you have selected the root file system and (and, optionally,
scanned the selected partitions for bad blocks),
.B build
asks you if you wish to create a new \*(CO file system for each
partition that you have assigned to \*(CO.
.PP
.B build
asks you the following question for each partition that you have
assigned to \*(CO:
.B1
.sp
	Do you want to create a new COHERENT filesystem on partition \fIn\fP [y or n]?
.sp
.B2
.PP
Answer `Y' if you wish to build a new file system; otherwise, answer `N'.
Note that if, for some reason, you are re-installing \*(CO onto a system
that already has existing \*(CO partitions, answering `Y' for a given
partition will wipe out all files that may exist on that partition.
You are obliged to create a new file system only for the root partition.
You do not have to do so for other, non-root \*(CO partitions.
.PP
When it comes to the partition that you have marked as holding the root
file system,
.B build
displays the following message:
.B1
.sp
	WARNING!!!
.sp \n(pDu
	The installation process expects a NEW file system in the root partition.
	If you are trying to update an existing COHERENT partition, you must run
	the COHERENT update.  If you are trying to install again after a partial
	or failed installation, a new root filesystem must be created again now.
.sp
.B2
.PP
The message is clear:
you
.I must
create a new file system upon the root partition.
.PP
Creating a file system takes a few minutes.
Patience is recommended.
.Sh "Copying Files"
.PP
The next step is to copy some key files from the boot floppy disk to your
hard disk.
.B build
displays the following message:
.B1
.sp
	The next step is to copy some COHERENT files from the diskette to the
	root filesystem of your hard disk.  This will take a few minutes...
.sp
.B2
.PP
.B build
copies a set of files it needs to run the operating system.
As the message states, this takes a few minutes.
.Sh "Mounting File Systems"
.PP
After it copies key files into the root partition, \*(CO asks you about
each \*(CO partition in turn:
.B1
.sp
	Do you want /dev/\fIdev\fP mounted [y or n]?
.sp
.B2
.PP
Answer `Y' for each partition whose file system you want to mount
automatically when you boot your \*(CO system.
If you are a novice \*(CO user, you probably should mount all file systems.
.PP
Please note that even if you answer `N' to this question, you can change
your mind later on, and either mount a partition by hand (using the command
.BR mount ),
or change a configuration file so that the partition is mounted automatically.
For details on what it means to
.I mount
a file system, see the entry for
.B mount
in the \*(CO manual's Lexicon.
.Sh "Cohabitating with MS-DOS"
.PP
.B build
now asks if \*(CO will cohabitate with \*(MD on your system:
.B1
.sp
	Do you use both COHERENT and MS-DOS on your hard disk [y or n]?
.sp
.B2
.PP
If you answer `Y',
.B build
then guides you through
the process of ensuring that \*(CO and \*(MD cohabitate peacefully.
.Sh "Naming File Systems"
.PP
If you have chosen to mount more than one \*(CO partition,
.B build
now displays the following prompt:
.DM
	Your system includes \fIN\fP partition[s] in addition to the root partition.
	These partitions are usually mounted on directories in the COHERENT
	root filesystem when the system goes into multiuser mode.
	For example, one non-root partition might be mounted on
	directory "/u", another on "/v", and so on.
	You now may specify where you want each partition mounted.
.sp
.B2
.PP
.B build
is asking you to name each file system.
The name is actually the name of the directory upon which
\*(CO mounts that partition's the file system.
Historically, a file system's directory is named using a single
letter from the end of the alphabet, such as `v' or `u'.
There's no reason, however, not to give the directory a descriptive name,
such as ``work'' or ``data''.
Each name must be preceded by a slash `/'.
.Sh "Default MS-DOS Partition"
.PP
If you have an \*(MD partition on one of your hard disks,
.B build
asks if you intend to use both operating systems.
If you answer `Y',
.B build
then asks you to enter the number of the partition that holds the
\*(MD file system \(em from 0 through 3 (if you have one hard disk),
or from 0 through 7 (if you have two hard disks).
.B build
creates a device called
.BR /dev/dos .
You can use this device to read files from the
\*(MD partition, or write files onto it.
.Sh "Patch the Kernel"
.PP
.B build
now displays the message:
.B1
.sp
	The kernel on your hard drive will now be patched to run on your system.
.sp
.B2
.PP
This step patches the kernel that
.B build
has copied onto your hard disk, so that the kernel will be able to read your
hard disk (or disks) when
.B build
reboots your system.
.PP
You will see a mass of obscure text on your screen.
Do not be alarmed.
.Sh "First Reboot"
.PP
Now that you have allocated a partition on your hard disk to \*(CO,
created a file system on it, and copied some key files onto it,
the next step requires that you boot \*(CO from the hard disk.
This is the first of two reboots that the installation of \*(CO requires;
the other will come after you have described to
.B build
your configuration of serial and parallel ports, and other peripheral devices.
.PP
.B build
prints the following message:
.B1
.sp
	You have installed the COHERENT operating system onto your hard disk.
	To install files from the remaining diskettes in the installation kit,
	you must boot the COHERENT system from the hard disk.  It will prompt
	you to install the remaining diskettes in the installation kit.
.sp \n(pDu
	After you have finished reading this information, remove the floppy disk.
.sp
.B2
.PP
As the prompt says, remove the boot disk from your floppy-disk drive.
.PP
If you have assigned \*(CO to a partition other than the boot partition \(em or
if you chose not to make any partition the boot partition \(em
.B build
displays the following:
.B1
.sp
	If you type a partition number (0-7) while
	the boot procedure is trying to read the floppy disk,
	your system will boot the operating system on that partition.
	If you type nothing, your system will boot active partition \fIN\fP (\fIsystem\fP).
.sp \n(pDu
	Now remove the floppy disk so your system does not boot from the floppy.
	You MUST type \fIN\fP when the system tried to read the floppy disk during the boot
	procedure to boot the partition containing the new COHERENT root filesystem.
	Preparing to reboot system.  Hit <Enter> ...
.sp
.B2
.PP
where
.I N
is the number of the partition that holds your root file system.
In this case, press
.I N
on the row of number of keys on the main set of keys (\fInot\fR on the keypad)
when the floppy disk's light comes on while the system is booting.
After you install \*(CO, you can at any time change the partition that
the master bootstrap boots automatically.
For more information on how to do this, see the Lexicon entries for
.B booting
and
.BR fdisk .
.PP
Note that if you have made \*(CO the operating system you boot normally,
you can use this procedure to boot \*(MD or any other operating system
that's on your machine.
The section at the end of this chapter describes how to make \*(CO
cohabitate on your machine with \*(MD, OS/2, or Windows NT.
.Sh "Copying Files"
.PP
Rebooting will take a few moments.
.PP
Once \*(CO has rebooted itself from your hard disk,
.B build
copies the \*(CO files onto your hard disk.
It prompts you to insert the remaining disks that hold
the \*(CO files, one after the other.
.PP
This process will take a few minutes.
Patience is recommended.
.Sh "Confirming Configuration of AT Controller"
.PP
Now that you have booted \*(CO from your hard disk and copied the rest of
the release disks onto your system,
.B build
resumes the job of configuring your system.
.PP
.B build
begins this phase of installation by asking you to confirm how you
have described your system's hard-disk controller (or controllers).
.PP
If your system has an AT-style hard-disk controller,
.B build
displays the following message:
.B1
.sp
	AT-type hard drive (IDE, RLL, MFM, or compatible).
.sp \n(pDu
	Device IS enabled.
	Do you want this device enabled ? [y]
.sp
.B2
.PP
To leave the AT-style hard disk enabled, which is the default,
simply press \*(RT.
If, however, you want to disable the hard disk (for whatever reason),
press `N'.
.PP
.B build
then asks:
.B1
.sp
	Change AT-type hard disk controller configuration ? [n]
.sp
.B2
.PP
Press \*(RT if the controller is configured correctly; this leaves the
current configuration alone.
If you have reason to believe that the configuration is wrong, press `Y'.
.B build
will walk you through the process of configuring your controller.
Do this only if you have strong evidence that the controller
is formatted improperly.
.Sh "Confirm and Complete SCSI Configuration"
.PP
If you earlier indicated that you have a SCSI hard-disk controller,
.B build
now asks you to confirm that that controller's configuration is correct.
For example, if you indicated that you have an Adaptec controller,
and you selected the first (main) driver for that controller,
.B build
displays the following message:
.B1
.sp
	HAI: Host adapter independent SCSI driver
.sp \n(pDu
	Device IS enabled.
	Do you want this device enabled ? [y]
.sp
.B2
.PP
Press \*(RT to accept this default, which is to leave the device enabled.
Answer `Y' if you wish to change the status \(em in this case, if you
wish to disable the SCSI controller.
.PP
.B build
now asks you to confirm the configuration of your controller:
.B1
.sp
	Change configuration of host adapter or target devices ? [n]
.sp
.B2
.PP
Press \*(RT to accept the default \(em that is, to leave the controller's
configuration alone.
However, you should press `Y' either if you suspect that the controller's
configuration is wrong,
.I or
if you wish to use a SCSI tape device on your system.
In either case,
.B build
again asks you for information on your SCSI peripheral devices.
.PP
If you answered `Y',
.B build
first asks you to confirm the SCSI identifiers you entered for the hard disks:
.B1
.sp
	Hard drives are configured at the following SCSI id numbers:
	\fInumbers\fP
	Is this correct ? [y]
.sp
.B2
.PP
If the SCSI identifiers are assigned correctly to your SCSI hard disk
(or disks), press \*(RT.
Otherwise, press `N'.
.B build
will again walk you through the process of assigning SCSI IDs to your
SCSI hard disks.
.PP
.B build
now asks you about SCSI tape:
.B1
.sp
	No SCSI tape drives are configured.
	Is this correct ? [y]
.sp
.B2
.PP
If you do
.I not
have a SCSI tape device, press \*(RT.
If, however, you have a SCSI tape device plugged into your SCSI controller,
press `N';
.B build
in reply will ask you to assign SCSI identifiers to your tape device or
devices:
.B1
.sp
	Enter all tape drive SCSI ID's separated by spaces, or <Enter> if none
.sp
.B2
.PP
Enter one SCSI identifier for each tape device that you have.
The SCSI identifier that you give is set by the hardware.
Some tape drives require that you set jumpers; others let you set
switch or dial to select the SCSI ID.
Note that a SCSI tape drive usually is given SCSI identifier 2;
however, the only requirement is that you not give it an identifier
already assigned to another SCSI device \(em either a hard disk or another
tape device.
.B build
will complain if you enter a SCSI ID that you have already assigned to
another device.
.PP
For details on how to use your tape device, use the command
.B man
to view the Lexicon entry
.BR tape .
.Sh "Configuring Serial Ports"
.PP
At this point,
you have confirmed the configuration of your controller (or controllers),
.B build
configures your suite of serial ports.
.B build
asks whether you wish to enable your serial ports:
.B1
.sp
	Configuring serial ports Com1-Com4.
.sp \n(pDu
	See "asy" in the COHERENT Lexicon for configuring serial ports beyond
	Com1-Com4.
.sp \n(pDu
	If your computer system uses both COM1 and COM3, one of these must
	be run in polled mode rather than interrupt-drive. Similarly, if your
	computer system uses both ports COM2 and COM4, one must be run in polled
	mode rather rather than interrupt-drive.
.sp \n(pDu
	Your BIOS identifies the following serial ports:
	Com1: \fIaddress\fP  COM2: \fIaddress\fP  COM3: \fIaddress\fP  COM4: \fIaddress\fP
.sp \n(pDu
	Enable serial port driver ? [y]
.sp
.B2
.PP
.I address
in the message is the address of the serial port in question.
If
.B build
could not detect a given port, it displays ``NONE'' for that port's
address.
Press \*(RT if you wish to enable the ports; if you do not, press `N'.
.PP
.B build
now asks whether your default printer is plugged into a serial port:
.B1
.sp
	The default printer on COHERENT is /dev/lp.
	This device may be linked to any valid serial or parallel port.
.sp \n(pDu
	Link /dev/lp to one of COM1 through COM4 ? [n]
.sp
.B2
.PP
If your printer is plugged into a parallel port
(or if you do not have a printer), press \*(RT.
If, however, your printer is plugged into a serial port, press `Y';
.B build
will ask you for the number of that port.
.PP
.B build
now asks you about your default modem:
.B1
.sp
	The default modem on COHERENT is /dev/modem.
	This device may be linked to any valid serial port.
.sp \n(pDu
	Link /dev/modem to COM1 through COM4 ? [y]
.sp
.B2
.PP
If you wish to link
.B /dev/modem
to a serial port, press \*(RT; if you do not, press `N'.
If you chose to link
.B /dev/modem
to a serial port,
.B build
now asks you which one:
.B1
.sp
	Enter 1 to 4 for COM1 through COM4 for /dev/modem ?
.sp
.B2
.PP
Enter the number of the port into which you have plugged your modem.
.PP
Again, if you have stated that you have a modem plugged into a serial port,
.B build
asks you if you wish to run the port in polled mode:
.B1
.sp
	Do you want to run COM1 in polled mode ? [n]
.sp
.B2
.PP
Note that running a modem in polled mode is much less efficient than
having it run in interrupt mode, and it will probably slow down your
entire system.
If at all possible, you should
.I not
run your modem in polled mode.
Press `Y' if you wish to run your modem in polled mode.
If you do not wish to run it in polled mode, and prefer instead to run it
in interrupt mode, press \*(RT.
.Sh "Keyboard and Console: Use Virtual Consoles?"
.PP
Now that you have configured your serial port,
.B build
walks you through the process of configuring your keyboard and console.
This process involves (1) selecting a keyboard and keyboard driver;
(2) installing virtual consoles, should you want them;
and (3) selecting the appropriate video controller.
Because the video display and the keyboard work together intimately,
you must configure both at the same time.
.PP
To begin this process,
.B build
asks you whether you wish to use virtual consoles.
With virtual consoles, you can have more than one console session functioning
at the same time;
\*(CO will think that it is dealing with multiple separate console devices.
You can flip from one console session to another by pressing a control key;
or you can have two different physical consoles \(em one monochrome and one
color \(em and run multiple sessions on each.
.B build
displays the following information about virtual consoles:
.B1
.sp
	This release of COHERENT supports multiple simultaneous sessions on the
	system console.  This feature, known as virtual consoles, supports both
	monochrome and color video cards (text mode only) with multiple "login"
	sessions on each, depending upon your hardware configuration.  If you have
	both color and monochrome adapters on your system, you can run multiple
	sessions on each of them at the same time.
.sp \n(pDu
	You may choose a loadable keyboard table or a non-loadable keyboard table.
	Loadable keyboard tables allow you to remap keys and load new tables while
	your system is active. This requires keyboards that are 100% IBM AT compliant.
.sp \n(pDu
	If you chose a non-loadable keyboard, you will not have this flexibility.
.sp \n(pDu
	Not all keyboards are 100% IBM AT compliant and will not work with loadable
	keyboard tables.  If your keyboard is not 100% IBM AT compliant, it may result
	in COHERENT not booting properly after the installation process is completed,
	or you may find that your keyboard keys are not mapped as they are labelled and
	that some keys cease to function at all.  For this reason, the default selection
	is the non-loadable keyboard.
.sp \n(pDu
	Greek keyboard support is available only if virtual consoles are selected.
.sp \n(pDu
	Do you wish to include support for virtual consoles ? [y or n]
.sp
.B2
.PP
If you answer `Y',
.B build
prompts you later for more information on your video card.
.Sh "Keyboard and Console: Select Keyboard"
.PP
The next step is in the process of configuring the keyboard and console
is to select a keyboard.
.B build
asks you to select a keyboard table from the following list:
.B1
.sp
	Belgian 102-key AT keyboard table
	Canadian French 102-key AT keyboard table
	Danish 102-key AT keyboard table
	Dutch 102-key AT keyboard table
	French 101-key standard AT keyboard (not loadable)
	French 102-key AT keyboard table
	German 102-key standard AT keyboard (not loadable)
	German 102-key AT keyboard table
	Italian 102-key AT keyboard table
	Latin American 102-key AT keyboard table
	Norwegian 102-key AT keyboard table
	Portuguese 102-key AT keyboard table
	Spanish 102-key AT keyboard table
	Swedish/Finnish 102-key AT keyboard table
	Swiss French 102-key AT keyboard table
	Swiss German 102-key AT keyboard table
	U.K. 102-key AT keyboard table
	U.S. 101-key standard AT keyboard (not loadable)
	U.S. 101-key AT keyboard table
.sp
.B2
.PP
The menu entries marked
.B "(not loadable)"
are linked directly into the kernel.
These include U.S., German, and French keyboards.
These keyboard drivers work with all keyboards,
even the non-standard ``clones''.
If you choose one of the ``not loadable'' keyboards,
you can use only that keyboard layout; the only way to select another
keyboard layout is to use the commands
.B cohtune
and
.B idmkcoh
to modify the kernel configuration and build a new kernel.
This sounds complex, but actually is rather easy;
for details, see the Lexicon entries for these commands.
.PP
The other 16 or so menu entries represent loadable tables.
These allow you to customize the tables to your liking,
as well as load new tables at run time, without having
to build a new kernel.
Please note, however, that they work only with well-engineered
keyboards, such as those built by IBM, Cherry, MicroSwitch, 
NMB Technologies, or Keytronics;
when used with an non-standard ``clone'' keyboard, they may not work correctly.
.PP
When the menu appears, it highlights the line for the non-loadable U.S.
keyboard.
This table will satisfy the needs of all users in the United States, and
many users abroad.
To select this entry, simply press \*(RT:
\*(CO will do the rest.
.PP
If you want another keyboard, press the space bar
until the table you want is highlighted;
then press \*(RT to select the highlighted entry.
Note that the new keyboard layout takes effect as soon as \*(CO
reboots itself.
.PP
If your keyboard's layout does not correspond to one of the
entries from the menu, select a loadable keyboard table
whose layout resembles your keyboard.
After installation, you can modify that
entry to make it correspond to your keyboard.
See Lexicon article
.B vtnkb
for details on how to create a new keyboard layout, or modify an existing one.
.Sh "Keyboard and Console: Select Video Adapter"
.PP
The next step in configuring the keyboard and console is to select
the type of video adapter you have.
Note that you can have a monochrome (text) adapter, a color (graphics)
adapter, or both a monochrome and a color adapter.
You cannot have two monochrome or two color adapters.
.PP
.B build
displays the following prompt:
.B1
.sp
	Please indicate the type of video adapter you are using.
	Many portable computers now use VGA video adapters, even though the
	the display is monochrome. For these systems, select (1) below:
.sp \n(pDu
		1. Color or VGA monochrome.
		2. Monochrome, (non-VGA).
		3. Both (two video adapters, two displays).
.sp \n(pDu
	Your choice:
.sp
.B2
.PP
Select the option that matches the hardware on your system.
.Sh "Keyboard and Console: Select Video Adapter"
.PP
The last step in configuring your keyboard and console is to select the
number of virtual consoles you want for each display device.
.B build
skips this step if you indicated that you did not want to use virtual
consoles.
.PP
.B build
asks you in the following manner:
.B1
.sp
	You may select a total of up to 8 virtual console sessions.
.sp \n(pDu
	How many active virtual console sessions would you like on your
	\fItype\fP video display [1-8] ?
.sp
.B2
.PP
.I type
is the type of video display you have, either color or monochrome.
If you have two video displays, you will see this prompt twice.
Enter the appropriate number, from `1' through `8'.
As each virtual console consumes memory, you should request only as
many as you think you need; in most instances, four is sufficient.
.PP
This concludes the configuration of keyboard and console.
.Sh "Emulation of Hardware Floating-Point Processing"
.PP
If your system does not have a mathematics co-processor
(i.e., an 80387 or an 80486),
.B build
asks you if you want to add emulation of hardware floating-point arithmetic
to your system:
.B1
.sp
	System is not equipped for floating point support.
	Floating point operations are used by WordPerfect, 123, and gcc.
	Enable software emulation of floating point [y]?
.sp
.B2
.PP
Press \*(RT if you intend to run any software that requires that your system
have a mathematics co-processor or emulate one;
these include WordPerfect, Lotus 1-2-3, and the GNU C compiler.
If you are not going to run any of these packages, you do not need
hardware floating-point emulation.
If you do not have a floating-point processor on your system, we strongly
recommend that include this module in your kernel:
it makes the kernel a little larger,
but greatly increases the usefulness of your system.
.PP
.B build
asks you to confirm your choice:
.B1
.sp
	Floating point will be ENABLED.
	Is this correct ? [y]
.sp
.B2
.PP
If this is correct, press \*(RT.
If not, press `N';
.B build
will walk you through this process again.
.Sh "Configure Floppy Tape"
.PP
The next step in configuration of your system is to configure your
system's floppy-tape device, should you have one.
.B build
begins by asking you the following question:
.B1
.sp
	QIC-80/QIC-40 Tap Drive Attached to Diskette Controller (Floppy Tape)
.sp \n(pDu
	Device is NOT enabled.
	Do you want this device enabled ? [n] 
.sp
.B2
.PP
Press \*(RT if you do
.I not
have a floppy-tape drive on your system.
If you do have such a tape, however, type `Y';
.B build
will then ask you some questions about your floppy-tape device.
.PP
It first asks you if you wish to configure the floppy-tape drive:
.B1
.sp
	Configure floppy tape ? [n]
.sp
.B2
.PP
If you press \*(RT,
.B build
will use its default configuration for floppy tape.
To perform your configuration by hand, press `Y'.
.PP
If you do press `Y',
.B build
asks you some detailed questions about floppy tape.
First, it asks about tape buffers:
.B1
.sp
	Number of 32 Kbyte tape buffers ? [32]
.sp
.B2
.PP
Enter the number of tape buffers you wish to use.
By default, \*(CO uses 32 such buffers.
The minimum number of buffers you can use is two; the maximum is 127.
.PP
Next,
.B build
asks you whether you wish to configure the driver manually, or
to let the tape drive configure itself:
.B1
.sp
	0 - manual configuration (if you know unit number or soft select mode)
	1 - auto configuration of tape drive select
.sp \n(pDu
	Your choice ? [1]
.sp
.B2
.PP
The default is to let the tape drive configure itself.
If you select that,
.B build
replies:
.B1
.sp
	Tape drive select method will be automatically determined.
	Is this correct ? [y]
.sp
.B2
.PP
Press \*(RT to accept automatical configuration.
In most instances, this will give you accept results.
If, however, you wish to enter configuration information by hand,
enter `0' to the question about manual configuration.
.B build
then asks you two additional questions about your floppy-tape drive's
configuration.
The first question concerns mode of selection:
.B1
.sp
	0 - hard select
	1 - soft select, Archive/Conner/Mountain/Summit
	2 - soft select, Colorado Memory Systems
.sp \n(pDu
	Your choice ? [1]
.sp
.B2
Press \*(RT to select the default, which is Archive soft selection.
.PP
The second question asks the unit number of your drive:
.B1
.sp
	Which unit number (0..3) is the tape drive assigned to ?
.sp
.B2
.PP
Enter the number of the tape drive's unit number.
.Sh "Configure Parallel Ports"
.PP
.B build
now asks you about your parallel ports.
The process resembles that of configuring your serial ports, but is
simpler.
.PP
.B build
begins by displaying the following:
.B1
.sp
	Your BIOS identifies the following parallel printer ports:
	LPT1: \fIaddress\fP LPT2: \fIaddress\fP LPT3: \fIaddress\fP
.sp \n(pDu
	Device is enabled.
	Do you want this device enabled ? [y]
.sp
.B2
.PP
Press \*(RT if you want your \*(CO system to be able to use the parallel ports.
If you do not, press `N'.
.PP
If you did not earlier indicate that your printer is plugged into a serial
port,
.B build
now asks which port your printer is plugged into:
.B1
.sp
	Do you want /dev/lp to refer to LPT1?
.sp
.B2
.PP
.B build
asks you this for each parallel port, until either you answer `Y' or
.B build
runs out of ports about which to inquire.
.PP
If you are not sure which port you have your printer plugged into, answer
`Y' for LPT1.
The Lexicon entry for
.B printer
tells you how to find out the port into which your printer is plugged;
it also contains much useful information on how to configure your printer,
and the printer-related software that comes with \*(CO.
.PP
After you have entered your information about parallel ports,
.B build
asks you to confirm it:
.B1
.sp
	/dev/lp will be linked to /dev/lpt\fIN\fP.
	Parallel ports will be enabled.
	Is this correct ? [y]
.sp
.B2
.PP
.I N
is the number of the port into which your printer is plugged (if any).
If this information is correct, press \*(RT.
If it is not, press `N';
.B build
will walk you again through the process of describing your parallel ports.
.Sh "Advanced Configuration of Parallel Ports"
.PP
Some printers require that a parallel port be configured in a special manner.
If this is the case with your printer \(em and if you have the information
at hand \(em then you can use this information to refine the configuration
of your printer's port.
.PP
.B build
begins by asking you if you wish to perform advanced configuration:
.B1
.sp
	Perform parallel printer advanced configuration ? [n]
.sp
.B2
.PP
If you do not wish to perform advanced configuration (and in all
probability, you will not), press \*(RT and jump to the next section
in these notes.
If you later learn that you must reconfigure your printer's port, you can
do so easily.
For details, see the Lexicon entry for the device driver
.BR lp .
.PP
If you do choose to perform advanced configuration,
.B build
begins by asking you about timings:
.B1
.sp
	The driver uses a hybrid busy-wait/timeout discipline to support printers
	efficiently that have varying buffer sizes in a multi-tasking environment.
.sp \n(pDu
	Parameter LPWAIT sets the time for which the processor waits for the
	printer to accept the next character.  If the printer is not ready
	within the LPWAIT period, the processor then resumes normal processing
	for the number of ticks set by parameter LPTIME.  Thus, setting LPWAIT
	to an extremely large number (e.g., 1000) and LPTIME to a very small
	number (e.g., 1) results in a fast printer, but leaves very few cpu
	cycles available for anything else.  Conversely, setting LPWAIT to a
	small number (e.g., 50) and LPTIME to a large number (e.g., 5) results
	in efficient multi-tasking but also results in a slow printer unless the
	printer itself contains a buffer (as is normal with all but the least
	expensive printers).  By default, LPWAIT is set to 400 and LPTIME to 4.
.sp \n(pDu
	We recommend that you set LPWAIT to no less than 50 and no more than 1000
	and LPTIME to no less than 1.
.sp \n(pDu
	LPWAIT setting:
	LPTIME setting:
.sp
.B2
.PP
Enter the settings you want.
.PP
.B build
now asks about driver checks:
.B1
.sp
	Parameter LPTEST determines whether the device driver checks
	to see if the printer is on-line before it uses the device.  If your
	printer does not support this signal, you must set LPTEST to zero.
.sp \n(pDu
	LPTEST setting:
.sp
.B2
.PP
Enter the setting you want.
.PP
Finally,
.B build
asks about hard control signals:
.B1
.sp
	Finally, some ports do not assert hardware control signal LP0 reliably.
	If port LPT1 has this problem, set LPT1_LP0_BUG to 1, otherwise set it to 0.
	Set LPT2_LP0_BUG and LPT3_LP0_BUG similarly for ports LPT2 and LPT3.
.sp \n(pDu
	LPT1_LP0_BUG setting:
	LPT2_LP0_BUG setting:
	LPT3_LP0_BUG setting:
.sp
.B2
.PP
Enter the settings you want.
.PP
This concludes the configuration of parallel ports.
.Sh "Set Number of Pseudo-ttys"
.PP
A
.I tty
is the software with which \*(CO sessions on your computer.
When a user logs into your system either through a modem
or through a terminal plugged directly into a serial port,
\*(CO uses a tty to manage her interaction with the system as a whole.
.PP
\*(CO also uses a system of
.I pseudo-ttys
(or ``ptys'') to manage user sessions that do not involve a physical device.
For example, when you use the X Window System, you can display a number
of windows on your screen, each of which runs a separate login session.
Even though you are using one physical device for all of those sessions,
\*(CO must manage each separately; and it uses pseudo-ttys to do so.
.PP
The next step in installation is to tell
.B build
how many pseudo-tty sessions you want.
.B build
requests this information from you as follows:
.B1
.sp
	To use the X windowing system or the screens package
	you must have the pty driver installed.
.sp \n(pDu
	The more pty devices you have, the more windows
	you can open, but each pty device uses memory.
.sp \n(pDu
	You may specify from 0 to 128 pty devices.
	Your system is currently configured for 8 ptys.
	How many pty devices would you like? [8]
.sp
.B2
.PP
Enter the number you want:
the default, eight, is a good, workable number.
.PP
.B build
then asks you to confirm your choice:
.B1
.sp
	Pty driver will be enabled with \fIN\fP ptys.
	Is this correct ? [y]
.sp
.B2
.PP
where
.I N
is the number of ptys that you requested.
If this is correct, press \*(RT.
If it is not, press `N'; and
.B build
will again walk you through the process of setting the number of
pseudo-ttys.
.Sh "Enable STREAMS?"
.PP
The next step in configuring your system is to decide whether you
wish to \*(ST to your kernel.
\*(ST is a system for managing peripheral devices that was introduced
with \*(UN System V, release 4.
At present, no \*(CO drivers require \*(ST; however, this will change
in the near future, with the release of networking and networked X
for \*(CO.
.PP
.B build
asks you about \*(ST as follows:
.B1
.sp
	Enable STREAMS ? [n]
.sp
.B2
.PP
Press \*(RT if you do not want \*(ST included in your kernel.
Press `Y' if you do want it included.
Note that if you do not include \*(ST in your kernel, you can easily
build a kernel at a later time that does include \*(ST.
For details on how to do so, see the Lexicon entry for
.BR STREAMS .
.PP
.B build
asks you to confirm your choice:
.B1
.sp
	STREAMS will be DISABLED.
	Is this correct ? [y]
.sp
.B2
.PP
If you had chosen to include \*(ST in your kernel,
the word ``DISABLED'' in the above message would have been
replaced by ``ENABLED''.
If this is incorrect, press `N';
.B build
will again ask you whether you want to include \*(ST in your kernel.
If, however, everything is to your satisfaction, press \*(RT.
.Sh "Trace Driver"
.PP
The \*(CO trace driver buffers kernel error messages within the kernel.
You can then dump these messages into a file, for later review.
Most users will not need this driver; however, if you are developing
device drivers or other programs that inhabit the kernel, you will
find this driver to be an invaluable debugging tool.
.PP
.B build
asks you:
.B1
.sp
	Device is NOT enabled.
	Do you want this device enabled ? [n]
.sp
.B2
.PP
As always, press \*(RT to accept the default, which in this instance is
.I not
to have the trace driver in your kernel.
To include the trace driver in your kernel, type `Y'.
.PP
If you answer `Y', to include the trace driver in your kernel,
.B build
asks you one additional question:
.B1
.sp
	Number of bytes in trace ring buffer [65536]
.sp
.B2
.PP
The ring buffer is the memory set aside to hold error messages.
The default is a good, workable amount of memory.
To accept the default, press \*(RT; to change the amount of space,
type the number of bytes that you want to set aside for the buffer.
After you enter this figure,
.B build
will ask you to confirm it:
.B1
.sp
	Is this correct ? [y]
.sp
.B2
.PP
If the amount of memory shown is correct, press \*(RT; otherwise, press `N',
and
.B build
will again ask you how much memory you wish to reserve for the trace buffer.
.Sh "Rebuilding the Kernel"
.PP
Up to this point,
.B build
has been asking you questions about your system's hardware, and about
how you wish to configure \*(CO's kernel.
.B build
now has all the information it needs;
so it now builds a new kernel that incorporates this information.
.PP
You will see much incomprehensible stuff on your screen during this phase.
Do not worry about it \(em if something goes serious wrong,
.B build
will tell you about it explicitly.
.PP
Once the new kernel is built, you will be able to boot \*(CO on your
system.
The rest of the installation process involves questions about where you
are in the world, and who will be using your system.
.Sh "Setting the Date and Time"
.PP
.B build
next sets the date and time for \*(CO.
Setting the date and time is vital to the correct operation of
\*(CO; however, \*(CO records the date and time quite differently
from the way \*(MD does.
.PP
Time under \*(CO is recorded as the number of seconds since January 1, 1970,
at midnight.
Internally, \*(CO always stores time as Greenwich Mean Time.
GMT is used
to make it easy for \*(CO systems around the globe to coordinate time with
each other.
When \*(CO
time-stamps a file or displays the time, it converts Greenwich Mean Time to
your local time, depending on what time zone you live in and whether
Daylight Savings Time is in effect.
(For a detailed discussion of this topic, see the Lexicon's entry for
.BR TIMEZONE .)
.PP
.B build
first asks you if you wish to convert system time to daylight-savings time:
.B1
.sp
	You can run COHERENT with or without conversion for daylight savings time
	(summer time).  You should normally run with daylight savings time
	conversion.  However, if you are going to use both COHERENT and MS-DOS
	and you choose to run with daylight savings time conversion,
	your time will be wrong (by one hour) during daylight savings time
	while you are running under MS-DOS.
.sp \n(pDu
	Do you want COHERENT to use daylight savings time conversion [y or n]?
.sp
.B2
.PP
Answer `Y' if you wish to use daylight-savings time, or `N' if you do not.
If you answer `Y',
.B build
then asks you about when daylight-savings time begins and ends:
.B1
.sp
	By default, COHERENT assumes daylight savings time begins on the
	first Sunday in April and ends on the last Sunday in October.
	If you want to change the defaults, edit the file "/etc/timezone"
	after you finish installing COHERENT.
.sp \n(pDu
	Is daylight savings time currently in effect?
.sp
.B2
.PP
The default settings are those enacted by law for the United States.
For information on how to reset the file \fB/etc/timezone\fR, see the
entry for
.B TIMEZONE
in the Lexicon.
.PP
.B build
then asks you to confirm your system's date and time:
.B1
.sp
	According to your system clock, your local date and time are:
	\fI[date and time]\fP
	Is this correct?
.sp
.B2
.PP
Answer `Y' if the date and time are correct, `N' if they are not.
If the date and time are not correct,
.B build
asks you to enter the current date and time, in the form \fIYYMMDDHHMM\fR.
.PP
If
.B build
cannot read or alter your system's clock (for whatever reason), it displays the
following message:
.B1
.sp
	The command which sets the internal real-time clock of your system is
	failing repeatedly.  Either you are entering the date and time incorrectly
	or your clock hardware is not completely AT-compatible.  If your clock
	hardware is incompatible, you can continue with the installation without
	setting the clock correctly.  However, if you do so, subsequent clock
	references (including file access and modification time information) will be
	incorrect and some commands (such as "date") will not function correctly.
.sp \n(pDu
	Do you want to proceed without setting the clock correctly?
.sp
.B2
.PP
If you answer `N',
.B build
aborts entering date and time information.
You should carefully examine your system's hardware, to ensure that the clock
is working correctly (that its battery, for example, is still charged).
Many of \*(CO's features do not work if it cannot read the system's clock.
.PP
Next,
.B build
displays the following menu and asks you what time zone you live in:
.B1
.sp
	Please choose one of the following timezones:
		0	Central European
		1	Greenwich
		2	Newfoundland
		3	Atlantic
		4	Eastern
		5	Central
		6	Mountain
		7	Pacific
		8	Yukon
		9	Alaska
		10	Bering
		11	Hawaii
		12	Other
.sp
.B2
.PP
If you select 0 through 11,
.B build
sets your local time automatically.
If you select ``Other'',
.B build
displays the following:
.B1
.sp
	You need to specify an abbreviation for your timezone,
	whether you are east or west of Greenwich, England,
	and the difference in minutes between your timezone
	and Greenwich Time (called UTC or GMT).  For example,
	Germany is 60 minutes of time east of Greenwich.
.sp \n(pDu
	Abbreviation for your timezone:
.sp \n(pDu
	Is your timezone east of Greenwich?
.sp \n(pDu
	Difference in minutes from GMT:
.sp \n(pDu
	Abbreviation for your daylight savings timezone:
.sp
.B2
.PP
If you are unclear on these concepts, consult the Lexicon article on
.BR TIMEZONE .
If you are unsure about how your local time relates to Greenwich time,
consult an atlas, check with your local library, or telephone a
local radio station.
.PP
.B build
then displays the corrected local time and asks if it is correct.
If not, you can repeat the process until the time is correct.
.Sh "System and Domain Names"
.PP
.B build
now asks you for the name of your system, and of your domain.
You must give your system a name if you wish to use electronic mail
on your system.
.PP
.B build
begins by displaying the following message and asking you for the name of
your system:
.B1
.sp
	In order to use COHERENT's electronic mail facility and UUCP subsystem,
	you must choose a "site name" for your computer system.  In general, a site
	name consists of lower case letters or digits and should be at most seven
	characters in length.  The name you choose should be unique if you intend
	to access any other computer systems.  Some of the more well known site
	names include "mwc", "uunet", "clout", "decwrl", "hp", "kgbvax", "prep",
	"seismo", and "ucbvax".
.sp \n(pDu
	Please enter the site name for this system:
.sp
.B2
.PP
See the Lexicon article
.B uucpname
for details on what sort of name you should give your system.
.PP
A
.I domain
is a group of systems that can be addressed collectively by other
computer systems.
Most domains are registered with the groups that administer e-mail collectives
nationally and have their addresses recorded.
Thus, by enrolling in a domain, computer users from around the
world will be able to exchange electronic mail with you.
For more information, see the Lexicon entry
.BR domain .
.PP
.B build
now asks you to enter your system's domain:
.B1
.sp
	The COHERENT mail subsystem supports "domain addressing" in addition to
	traditional "bang paths".  Until your system becomes part of a registered
	domain, you may use the UUCP pseudo-domain.  Domain names consist of groups
	of letters and digits separated by periods (dots).  Some of the more well
	known domains include "com", "edu", "gov", "org", "net", as well as domains
	covering a geographical area, such as the Chicago area "chi.il.us" domain.
	If you are not registered in a domain, or if you are uncertain about this
	question, simply press the <Enter> key to default to the UUCP pseudo-domain.
.sp \n(pDu
	Please enter the domain name for this system:
.sp
.B2
.PP
If you have arranged to have your system join a domain, enter its name.
If you have not, press \*(RT to select the default domain
.BR UUCP .
.PP
For more information on domains and electronic mail, see the tutorial for
UUCP, and the Lexicon entry for \fBmail\fR.
.Sh "Install the Dictionary"
.PP
Next,
.B build
asks if you want to uncompress the dictionary used by the command
.BR spell :
.B1
.sp
	The COHERENT dictionary in /usr/dict is shipped in compressed form.
	The compressed dictionary uses about 350 blocks (.175 MB) of disk space.
	The uncompressed dictionary uses about 1700 blocks (.85 MB).
	You can either:
		1) Remove the dictionary,
		2) Leave the dictionary compressed, or
		3) Uncompress the dictionary.
	The "spell" command will work only if you uncompress the dictionary (option 3).
.sp
.B2
.PP
You should uncompress the dictionary only if you wish to use
.B spell
to check your text documents.
.Sh "Install the Print Spooler"
.PP
\*(CO version 4.2 includes the MLP print spooler.
This spooler implements a version of the \fBlp\fR spooler used by \*(UN
System V.
To set up MLP correctly, you need to enter some information about
what printers you have plugged into your system, and the ports into which
they are plugged.
.B build
begins with the following message:
.B1
.sp
	COHERENT includes print spooling software which allows you to use
	multiple printers.  Earlier we asked you about your printer to determine
	which port it used.  Now we will complete printer spooler configuration.
.sp
.B2
.PP
.B build
then asks:
.B1
.sp
	Is your printer a laser printer [y/n]?
.sp
.B2
.PP
Answer `Y' if it is, and `N' if it is not.
.PP
.B build
then asks:
.B1
.sp
	Is your printer a PostScript printer [y/n]?
.sp
.B2
.PP
Again, answer `Y' if it is, and `N' if it is not.
.PP
That's all there is to it.
.B build
will configure the spooler correctly, so you can begin to print as soon
as you have completed installation.
.PP
Note that the above procedure supports only one printer on one port.
You can configure MLP to support an indefinite number of printers, plugged
into serial ports, parallel ports, or even into the auxiliary ports of
dumb terminals.
For details, see the Lexicon entry for
.BR printer .
.Sh "Adding Additional Users"
.PP
The final step in installation is to tell
.B build
about the other people who will be using your system.
.PP
.B build
begins this process with the following message:
.B1
.sp
	Your COHERENT system initially allows logins by users "root" (superuser) and
	"bin" (system administrator).  In addition, the password file contains special
	entries for "daemon" (the spooler), "sys" (to access system information),
	and "uucp" (for communication with other COHERENT systems).
.sp \n(pDu
	If your system has multiple users or allows remote logins, you should require
	a password for all accounts.
	Do you want to require accounts to have passwords ? [n]
.sp
.B2
.PP
Press \*(RT if you do not want every account to have a password.
If you do want every account to have a password, press `Y'.
Regardless of what you press
.B build
now displays the following message:
.B1
.sp
	If you enter a password for an account, you will be required to enter it twice
	in order to be sure that you typed it correctly, since passwords are never
	printed to the screen when they are being entered.
.sp \n(pDu
	If you change your mind, you can change the setting of a password later with
	the 'passwd' utility. Note that if you set a password for the super-user
	'root' (and it is generally a good idea to do so), then you must take great
	care NEVER to lose or forget the password, otherwise you will be locked out
	from your own computer.
.sp
.B2
.PP
.B build
now asks you the following:
.B1
.sp
	Do you want to assign a password for user "root" ? [n]
	Do you want to assign a password for user "bin" ? [n]
	Do you want to assign a password for user "uucp" ? [n]
.sp
.B2
.PP
For each of the above users for whom you answered `Y',
.B build
prompts you for a password.
As we noted before, don't forget those passwords.
In particular, do not forget the password for the superuser
.BR root .
.PP
Next,
.B build
displays the following message about users who may dial into your system:
.B1
.sp
	You should consider setting up a password for remote users dialing into your
	system. In order to do this, you should consult the documentation for "login"
	to see how to create "/etc/d_passwd" and /etc/dialup" files.
.sp
.B2
.PP
The last in this process (and in installation) is to add new users to your
system.
.B build
begins by asking for the name \(em that is, the login identifier \(em of
a user:
.B1
.sp
	If you want, you can create additional logins on your system now, or you
	can simply press <enter> to indicate that you don't wish to create any
	additional user accounts.
.sp \n(pDu
	User name to add, or a blank line to finish adding users ? 
.sp
.B2
.PP
The login identifier is a brief name, usually all in lower-case letters.
Often, it's the user's first name, or first initial and last name;
e.g., user John Smith would receive the login identifier
``john'' or ``jsmith''.
Each user's login identifier can be simple;
but it must be unique on your system.
.PP
After you enter the login identifier,
.B build
asks you for the user's full name:
.B1
.sp
	Full name of user, or !! to abandon ?
.sp
.B2
.PP
Enter the user's full name, e.g., ``John Smith''.
.PP
Now, enter the file system that will hold your user's home directory:
.B1
.sp
	Parent directory of user's home directory, or !! to abandon ? [/home]
.sp
.B2
.PP
Press \*(RT to select the default.
.PP
Now, you must select a shell for your new user:
.B1
.sp
	There are two shells available for use as login shells; choose one of
	  1) the Bourne shell, /bin/sh
	  2) the Korn shell, /usr/bin/ksh.
	Choose a shell for user \fIname\fP, or !! to abandon ?
.sp
.B2
.PP
Press `1' to give your user the Bourne shell, or `2' to give him the
Korn shell.
If you are not sure which to use, select the Bourne shell.
For information on these shell, see the Lexicon entries for
.B sh
and
.BR ksh .
You can also change a user's shell at a later time; for details on how
to do so, see the Lexicon entry for file
.BR passwd .
.PP
.B build
asks you if you wish to set a password for your new user:
.B1
.sp
	Do you want set a password for user \fIname\fP  [n]
.sp
.B2
.PP
If you do wish to set a password, press `Y'; otherwise, press \*(RT.
If you choose to set a password for your user, you will see the prompts:
.B1
.sp
	New password:
	Verification:
.sp
.B2
.PP
Enter the password at each prompt.
.PP
That concludes the information you must enter for a user.
.B build
again asks you if you wish to add a new user.
When you finished entering new users, press \*(RT.
.Sh "Second Reboot and Conclusion"
.PP
.B build
has now completed its work:
it has copied \*(CO onto your hard disk, built file systems,
used information you entered to configure a kernel for you,
added users, and performed all of the other miscellaneous tasks
needed to establish a multi-user,
multi-tasking operating system on your machine.
.PP
The final task that
.B build
performs is to reboot your system a second time.
This invoke the kernel it built after the first time it rebooted your system.
After the system has rebooted, you can log in and begin to use your new system.
.PP
Before
.B build
reboots, it displays the following message:
.B1
.sp
	For a list of changes to the Lexicon since the manual was last printed,
	type
		man Lexicon
.sp \n(pDu
	System configuration done, will take effect after reboot.
.sp \n(pDu
	Installation complete.
	Don't forget to remove the last diskette from the disk drive.
.sp \n(pDu
	You must reboot your system in order to allow the preceding
	configuration steps to take effect.
	Preparing to halt system.  Hit <Enter> ...
.sp
.B2
.PP
If your system does not immediately reboot after you see this message,
press the reset button.
.PP
Your newly installed \*(CO system will use the utility
.B fsck
to examine and (possibly) correct any minor flaws in your system's file systems.
It will then go into multi-user mode.
You can log in and begin to use \*(CO.
.PP
If you are a novice to \*(CO, we urge you to turn to the tutorial
.IR "Using the COHERENT System" ,
which is located near the beginning of your \*(CO manual.
This will help you become acquainted with \*(CO.
.PP
If you are experienced with \*(CO or \*(UN,
you may wish simply to see what comprises \*(CO.
Invoke the command
.BR /etc/coh_intro .
This gives you a ``guided tour'' of \*(CO, so you can see what is in it.
The Lexicon entry
.B commands
also summarizes all commands that are in the \*(CO system.
.PP
This concludes the installation of your \*(CO system.
The next sections of this chapter describe how you can have \*(CO
co-habitate with other operating systems on your machine.
The final section describes some problems that can arise with installation
and suggests how you can deal with them.
.SH "Installing COHERENT With Other Operating Systems"
.PP
Many users wish to run \*(CO but keep \*(MD, OS/2, or Windows NT
on their machines as well.
The following describes how to do this.
.Sh "MS-DOS in One Partition; OS/2 in Another; Boot Manager Installed"
.PP
IBM's OS/2 Boot Manager is a program that resides in its own partition on
the hard drive.
If the OS/2 Boot Manager is installed, then that probably means
that \*(MD is the first partition, and that OS/2 was installed as a
.I logical
or
.I extended
partition, which can only be booted from Boot Manager.
With the first three partitions taken up by \*(MD, Boot Manager, and OS/2,
\*(CO can be installed only into the fourth partition.
To install \*(CO:
.IP \fB1.\fR 0.3i
If the whole drive is taken up, you must back up the \*(MD
partition, delete it, and re-create it
(minus the amount of space you wish to reserve for \*(CO).
.IP \fB2.\fR
Install \*(CO normally:
Place the boot disk into drive A and reboot.
.IP \fB3.\fR
When you see the question
.DM
	Would you like to install the Coherent Master Bootstrap?
.DE
answer `Y'.
.IP \fB4.\fR
A little later,
.B build
invokes \*(CO's
.B fdisk
utility.
Choose the partition into which you will install \*(CO.
Choose as you would normally; however, before you leave
.BR fdisk ,
\fImake the \*(CO partition active.\fR
This bypasses the OS/2 Boot Manager program and boots \*(CO automatically.
\fIThis is essential to completing installation!\fR
.PP
To boot \*(MD or \*(CO, use the \*(CO Master Bootstrap to boot the
partitions normally:
upon turning on the computer,
press the number key that corresponds to the partition whose operating
system you wish to boot.
.PP
To start OS/2, boot the Boot Manager partition by pressing the number key
that corresponds to its partition;
and when Boot Manager starts, select OS/2.
.Sh "MS-DOS and OS/2 in the Same Partition"
.PP
OS/2 users can install OS/2 into the same partition as \*(MD.
To boot OS/2, users type a command that swaps the
\*(MD boot files with the OS/2 boot files.
Due to the location, placement, and
attributes of these boot files, only the \*(MD files and
directory structures can be backed up; therefore, your options are
limited to the following:
.IP \fB1.\fR 0.3i
Back up the \*(MD\(emOS/2 partition.
This is to preserve your data and directory structure.
.IP \fB2.\fR
Boot \*(MD and run the \*(MD version of
.BR fdisk .
.IP \fB3.\fR
Delete the \*(MD\(emOS/2 partition, then re-create it minus the amount of
space you wish to reserve for \*(CO.
After rebooting out of the \*(MD version of
.BR fdisk ,
reinstall \*(MD.
.IP \fB4.\fR
Install \*(CO normally.
.IP \fB5.\fR
After you have installed \*(CO,
reinstall OS/2 back onto the \*(MD partition.
To help restore the previous OS/2 setup, run OS/2's
.B migrate
program.
.PP
To boot \*(CO when you boot your computer,
press the number key that corresponds to the number of
its partition.
To boot either \*(MD or OS/2,
press the number key that corresponds to the number of their partition \(em
usually `0'.
.Sh "Windows NT and MS-DOS with COHERENT"
.PP
The following describes how to install \*(CO, \*(MD 6.0, and Windows NT onto
the same system.
.IP \fB1.\fR
First install \*(MD 6.0 into its own partition.
.IP \fB2.\fR
Install Windows NT into its own partition.
Use the Dual-Boot facility in
Windows NT to select either Windows NT or \*(MD to boot when powering up.
.IP \fB3.\fR
Install \*(CO into its own partition.
This can either be on the same drive as \*(MD and Windows NT, or, if your
system has two hard disks, onto its own disk.
Use the \*(CO Master Bootstrap to be the boot manager.
In this way, you can boot any partition on your system, and so easily
boot any of the three operating systems.
.PP
Because you will be working with three operating systems, you may wish to
use the \*(CO
.B fdisk
command to configure the master bootstrap, so that it does not boot any
partition by default.
In that way, you can select whatever partition \(em and therefore,
whatever operating system \(em you want at boot time.
If you want to boot either \*(MD or Windows NT, select the partition for
Windows NT; its Dualboot will take over and boot either Windows NT or
\*(MD, whichever you choose.
.Sh "COHERENT and MS-DOS 6.0"
.PP
Release 6.0 of \*(MD offers a feature of dynamic file compression that
creates some difficulties for machines that have both \*(CO and \*(MD on
their systems.
.PP
To begin, \*(MD 6.0 assumes that it is the only operating system on your
computer.
When you install \*(MD 6.0, by default it overwrites the COHERENT master boot
block.
If at all possible, you should install \*(MD 6.0
.IR first ,
and then install \*(CO to ensure that the \*(CO Master Bootstrap is in
control of system, so that you can boot either operating system.
.PP
Second, \*(MD 6.0 offers a compression utility called
.BR dblspace ,
which compresses \*(MD file systems on the fly.
\*(CO's
.B dos
commands do not understand compressed \*(MD file systems created by the
\*(MD 6.0 utility
.B dblspace ,
or by such programs as
.BR Stacker .
If you are running \*(MD 6.0 with file compression,
you must copy files to an uncompressed file system
(for example, to an uncompressed floppy disk or to the uncompressed
host for a compressed file system) to make them accessible to the \*(CO
.B dos
commands.
.SH "Problem With Installation"
.PP
As we mentioned earlier, tens of thousands of users have
successfully installed \*(CO onto their computers.
Most encountered no difficulty whatsoever during installation;
chances are you too will not encounter any.
.PP
If problems do arise, the Mark Williams support staff will gladly
help you.
Before you call, however, be sure to read the following sub-sections
and follow their directions.
Each describes a commonly encountered problem,
and gives advice on how to overcome it.
.PP
If your problem is not covered in this chapter \(em or if you have tried
what it suggests and it does not work \(em call Mark Williams.
Information about contacting Mark Williams Technical Support is given in
the introduction to this booklet.
.Sh "Did the system go multi-user prematurely?"
.PP
With some configurations of hardware,
.B build
does not initiate the second rebooting of the system; rather, it attempts
to go multiuser immediately, and displays a cascade of errors on the system
console.
.PP
This problem is due to the fact that kernel being used at that stage of
installation does not yet support the full suite of peripheral devices.
You need to reboot your system to invoke the kernel that was built during
the final stage of installation.
Just press the reset button on your system; this will reboot your computer
and invoke the newly built kernel.
Thereafter, all should be well.
.Sh "System hangs on the second reboot"
.PP
Under some rare circumstances,
first reboot of \*(CO goes well, but the final reboot
(to boot the whole system for the first time)
hangs just before or after the screen clears.
To fix this problem, do the following:
.IP \fB1.\fR 0.3i
Press the space bar when you see the message: 
.DM
	COHERENT Tertiary boot Version 1.2.7
	Press <SPACE> to abort boot.
.DE
.IP \fB2.\fR
Type
.BR coherent.min .
.IP \fB3.\fR
Type
.B <ctrl-C>
when you see the message:
.DM
	Checking filesystems...
.DE
This drops you into single-user mode.
.IP \fB4.\fR
Type the command:
.DM
	/conf/patch -p /coherent.min rootdev:s pipedev:s
.DE
Record the values that are displayed.
(They will resemble ``0x0D00'' or ``0x0B00''.)
.IP \fB5.\fR
Type the command
.DM
	/conf/patch -v /coherent rootdev=\fIXXXX\fP:s pipedev=\fIXXXX\fP:s
.DE
where
.I XXXX
stands for the values you recorded previously.
.IP \fB6.\fR
Finally, type the command
.BR sync ,
then reboot your system and let it boot normally.
.Sh "Printing does not work"
.PP
In some cases, attempts to print via the parallel ports generates
messages of the form
.DM
	Cannot open /dev/lpt1
.DE
even though that device exists and has its permissions set correctly.
This probably is due to the fact that in a few rare instances,
.B build
program did not include the driver
.B lp
in the kernel that it built during the final stage of installation.
.PP
To get around this problem, use the command
.B idenable
to enable the driver
.BR lp ;
then use the command
.B idmkcoh
to build a new kernel.
Once a new kernel is built, reboot your system and all should be well.
For details, see the Lexicon entries for
.B idenable
and
.BR idmkcoh .
.Sh "Does your system hang instead of reboot?"
.PP
In rare instances, the \*(CO command
.B reboot
does not reboot the system; rather, it stops current processing but does
not initiate rebooting.
If this happens, just press the reset button on your system to reboot;
doing so will not harm your system in any way.
.Sh "Are you using incorrect chipset parameters?"
.PP
If your system ``hangs'' when it attempts to boot from the \*(CO
boot disk, your motherboard's CMOS setup parameters may be incorrect.
Many systems use chipsets that support user-configurable bus speeds
and timing.
On these systems, if you attempt to run the bus clock at too high a rate,
certain peripherals will not function correctly.
For example,
on systems using the OPTI chipset and the AMI BIOS, you should verify
that the system's ``bus speed'' is set to
.B CLKIN/4
rather than
.B CLKIN/3
or
.BR CLKIN/2 .
In addition, if parameter ``AT STRETCH'' is available, it should be
set to
.BR ENABLED .
If the aforementioned parameters are not set correctly,
you will experience incorrect system behavior.
.Sh "Are you booting COHERENT Disk 1 via <ctrl-alt-del> (warm boot)?"
.PP
It may help to cold boot your system:
that is, turn power off, wait at least 30 seconds, then turn power back on.
The waiting helps ensure that all buffered data truly ``vanish'' from your
system.
Rebooting via cold boot is more resistant to
getting a virus from something you have already loaded, and avoids
the family of bugs in the AMI BIOS, \*(MD, and Windows that relate
to warm boots.
.Sh "Do you have a defective RAM chip?"
.PP
We have seen cases in which computers go through normal startup and
even run \*(MD without difficulty, but give panic errors or stack
overflow errors randomly when running in protected mode.
Weak memory chips and some defective or poorly designed
motherboards can be found by
running a thorough, protected-mode diagnostic program on memory,
then replacing all defective parts that it discovers.
.Sh "Are you running in Turbo mode?"
.PP
Sometimes customers, especially those experiencing panic traps, can
install when they change processor speed.
Although the improvement, when it occurs, usually happens when the CPU
is slowed down, we have seen one case where it helped to speed up the processor.
In general, panics that vanish or significantly change their pattern of
appearance when CPU speed is changed, strongly suggest that the problem
is due to a poorly designed or incompatible motherboard (see below).
.Sh "Will it help to change the master boot procedure?"
.PP
If you are having trouble selecting the partition from which
your computer boots,
it may help to modify the master boot sequence, as follows.
(1) Use the command
.B /etc/fdisk
to select \fIno\fR active partition, or,
during startup, hold down the key corresponding to the root \*(CO
partition (over the alpha keyboard, \fInot\fR on the numeric keypad) until
startup halts with a keyboard error.
(2) Press \fB<F1>\fR to continue.
Boot should progress to \*(CO.
.Sh "Is CMOS configured correctly for drive A?"
.PP
Some customers who ordered the wrong size of floppy disks
switched floppy-disk drives A and B,
but failed to update the setup for the computer.
This often produces an error message of the form
.DM
	fsminit:  no root dev (4,14)
.DE
The solution is to configure the CMOS correctly.
See your computer's technical documentation for details on how to do this.
.Sh "Do you have an incompatible hard-drive controller?"
.PP
If you have a Western Digital controller model WD1006V-SR2 and it is a
Feature 3 board, you may need to replace it.
Some of these controllers have defects that cause them to latch up.
.PP
If you have a Western Digital controller model WD1006V-SR2 and it is a
Feature 5 board (Feature 5 boards have all the
jumper headers installed), install
the ``non-latched'' mode jumper, which is the first one (J1).
.PP
In any case, please contact Mark Williams Technical Support
with the make and model of the controller.
It may lead us to a new pattern that we can accommodate.
Some customers have Perstor, IDE, ESDI, or SCSI controllers
and did not know it until they checked the controller type;
there are known compatibility issues
with some controllers of all the above types.
.Sh "Do you have incompatible hard-drive parameters?"
.PP
If you were
.I unable
to install \*(CO,
check the contents of \fBCONFIG.SYS\fR from the \*(MD
root directory on drive C.
If you find one of the following \fBDEVICE=\fR entries there
that configures the hard drive,
it may be an indication that your hard disk layout is non-standard.
However, many users of the following device drivers have successfully
installed \*(CO, so please be sure that you have attempted installation
\fIprior\fR to contacting Mark Williams Technical Support.
.DS
	DMDRVR.BIN
	EDVR.SYS
	SSTOR.SYS
	HARDRIVE.SYS
	FIXT_DRV.SYS
.DE
Before you call,
note your hard-drive's make, model number and
parameters (i.e., number of heads, cylinders,
and sectors per track) from the documentation supplied with the hard drive.
Most drives are configured with 17 sectors per track when used with
MFM encoding, 26 sectors per track with RLL encoding, and 31 sectors per
track with Perstor controllers.
Check these parameters against what is in the CMOS setup:
CMOS specifies parameters by storing the drive type number, which
specifies an entry in the BIOS disk parameter table.
If there is a setup program in the BIOS, it may give drive parameters
explicitly;
or, it may be necessary to look up the entry in the manual for the BIOS.
.PP
If the number of cylinders is greater than 1,024, you may have an incompatible
drive:
the format of the standard PC partition table does not allow more than
1,024 cylinders.
However, some disk controllers and most IDE drives
support a ``translation mode'' that allows them to
operate with BIOS parameters that do not match the actual parameters of
the disk drive (i.e., physical drive geometry).
For example, the following table lists the physical and translation mode
parameters for the Western Digital WD93044-A IDE drive:
.DS
.ta 0.5i 1.5i 2.5i
		\fIPhysical	Translation\fR
	Cylinders:	782	977
	Heads:	4	5
	Sectors:	27	17
	Landing Zone:	862	977
.DE
The Adaptec 2372 and Western Digital 1006V-SR2 series controllers
simulate the presence of valid drive parameters when the drive type is set
to \fB1\fR in the system setup.
With these controllers, it is possible to install \*(CO when the drive
parameters do not correspond to any drive type in the BIOS, but you must
be sure to set the drive type to \*(QL1\*(QR in the CMOS setup.
.Sh "Do you have an incompatible video board?"
.PP
If you are using a Zenith Z449 series CGA/VGA video adapter and are
experiencing panic traps, there is a known defect in this board.
Contact Zenith Data Systems, or try a different video board.
.PP
Some (unlabeled) monochrome boards do not work in protected mode.
Symptoms include immediate panic or loss of video when booting from disk 1.
If possible, try exchanging video boards.
.Sh "Do you have an incompatible keyboard?"
.PP
If you are experiencing problems with respect to key mappings,
and you installed one of the loadable keyboard mapping tables
from the keyboard selection menu, you may have an incompatible keyboard.
Please note that the \*(CO
.B nkb
driver (and loadable tables) only work with standard
keyboards, such as those built by IBM, Cherry, MicroSwitch,
NMB Technologies, or Keytronics;
when used with a poorly engineered ``clone'' keyboard,
it may not work correctly.
.PP
The preferred action is to replace the non-standard
keyboard with one made by one of the above-named manufacturers.
If, however, you wish to use a non-standard keyboard with \*(CO,
your best bet is to re-install \*(CO and select the
.B kb
(non-loadable) driver instead of
.BR nkb .
.B kb
is not loadable and supports only the U.S., German, and French
keyboard layouts.
.PP
If you do not wish to replace your keyboard or re-install \*(CO,
then the following
.I may
help you cope with your keyboard's problems.
.IP \fB1.\fR 0.3i
If the shift or control key seems to ``stick'' in the
.B on
or
.B down
position, you can try to fix the keyboard mapping table that
corresponds to your country.
For example, if you selected the U.S. keyboard mapping table
during installation but find that the right shift
or control key seems to stay down after you press it for the first time,
edit file
.BR /conf/kbd/us.c .
To fix the right shift key, change the line that reads:
.DM
	{K_57,rshift,rshift,rshift,rshift,rshift,rshift,rshift,rshift,rshift, S|MB },
.DE
to
.DM
	{K_57,none, none, none, none, none, none, none, none, none, O|MB },
.DE
To fix the right control key, change the line that reads
.DM
	{K_64, rctrl, rctrl, rctrl, rctrl, rctrl, rctrl, rctrl, rctrl, rctrl, S|MB },
.DE
to
.DM
	{K_64,none, none, none, none, none, none, none, none, none, O|MB },
.DE
This makes these keys inoperative.
This, of course, is less than desirable,
but it will at least prevent you from accidently
forcing your keyboard into a shift or control state from which you cannot exit.
.IP
Once you have modified the keyboard table, rebuild the keyboard executable that
corresponds to the modified table, as described in Lexicon articles for
.B nkb
and
.BR "keyboard tables" .
Thereafter, you can enter the name of the 
newly created executable and it will load the modified keyboard table into
the keyboard driver.
This also happens automatically at boot time.
.IP \fB2.\fR
If one or two keys are transposed, have no output, or output the incorrect
value, you must (a) figure out which key location is incorrect,
(b) decide what the correct value should be for all key states, (c) edit
the file in directory
.B /conf/kbd
that corresponds to your selection,
(d) rebuild the keyboard table executable (as described in the Lexicon articles
.B nkb
and
.BR "keyboard tables" )
and (e) reload the keyboard table by invoking the newly created executable.
.PP
As noted above, the easiest solution is to replace the keyboard.
.Sh "Do you have a system incompatible with the MWC master boot program?"
.PP
The Mark Williams master boot program is known \fInot\fR to work with
certain Zenith 241- and 248-series computers using Zenith's BIOS.
It should be possible to install and run \*(CO as long as the master boot
program is \fInot\fR used.
.Sh "Do you have an incompatible clock device?"
.PP
If the install process fails when trying to set the system time and date
(\fBATclock\fR failure), please contact Mark Williams Technical Support.
.PP
It is common to see an
.B ATclock
failure when a computer has less than one megabyte of RAM.
If your system has less than one megabyte of RAM, you must upgrade your memory.
.Sh "Is your system extremely slow?"
.PP
If you are running \*(CO on a SCSI disk drive and your system
is running very slowly,
odds are that your host adapter is not correctly configured.
Some non-\*(CO systems ``busy wait'' the host adapter
when performing SCSI I/O.
Because \*(CO is a multi-tasking, multi-user system,
it uses interrupts to signal when the host adapter
has completed an I/O operation and is ready for the next request.
If your host adapter is not correctly configured, it may not
be asserting the correct interrupt, or it may not be asserting any interrupt.
Please check the jumpers on your host adapter to verify that
the correct interrupt is being asserted.
If you have further questions, contact the hardware manufacturer.
.Sh "Is the setup of your system incorrect?"
.PP
.B build
will occasionally warm boot during initialization
if your system's BIOS has an incorrect notion of your system's configuration
of hardware.
One symptom of this problem is if your system prompts you to run a setup
program when you cold-boot your system.
.PP
To fix this problem, run the setup program that comes with your system.
Make sure that your system's clock setting and configuration of hardware
is correct.
\fIBe extremely careful not to change your hard disk's partitioning!\fR
.Sh "Are you running Extradrive?"
.PP
The disk-doubling utility Extradrive
writes material into sector 0 on your hard disk, where \*(CO writes its
master boot program.
If you have trouble booting \*(CO, try removing Extradrive, then
re-install \*(CO.
.PP
Note that for \*(MD, Extradrive, and \*(CO to work together on the same
machine, you must first install \*(MD, then configure Extradrive, and
finally install Extradrive.
If you do not follow this order, \*(MD or Extradrive will overwrite the
\*(CO master boot because each assumes that \*(MD is the only operating
system residing on the computer.
.Sh "Does your system have six megabytes of RAM?"
.PP
On some AMI 386SX/25 motherboards, \*(CO requires that your system's amount
of RAM be a power of two \(em that is, two, four, eight, or 16 megabytes.
If your system has this motherboard and has six megabytes, booting may fail.
The solution is either to remove two megabytes of memory,
or add two megabytes.
.Sh "Is your video card incompatible?"
.PP
Some makes of video card are incompatible with \*(CO's virtual consoles.
In this instance, the console may exhibit bizarre behavior, such as moving
the cursor around the screen but not printing any text.
This problem can also arise if you told \fBbuild\fR that you have a
monochrome card when in fact you have a color card, or vice versa.
.PP
Check the make of your video card and make sure you described it correctly to
.BR build .
Daredevil \*(CO hackers may wish to log in via a serial port and try to
change the configuration of the console driver; the Lexicon article
\fBconsole\fR gives information on this driver.
For most users, however, the only solution is to re-install \*(CO and
not install virtual consoles.
.Sh "Does your system use wait states?"
.PP
One user succeeded in installing \*(CO on his system by changing memory
to one wait state.
Normally, \*(CO should work correctly with zero wait states, but introducing
wait states may be necessary on some systems.
If all else fails, you may wish to try this.
.Sh "Do you have the Opti chip set?"
.PP
Some users have received panic dumps on clone PC built around
the Opti chip set.
One helpful tactic is to
use the setup routine of the AMI BIOS to disable the keyboard reset control.
.Sh "Do you have a notebook computer?"
.PP
During installation,
some notebook computers display a message like the following:
.DM
	Panic:  Parity error:  cs=FFC00018  ip=FFC0038E
.DE
This problem rests in the computer's power management.
For example, the Siemens notebook computer
has three features to increase the lifetime of the battery:
.IP \fB1.\fR 0.3i
It switches the hard disk off after a predetermined time has passed with no
disk access.
This technique works with \*(CO, but in multiuser mode the disk very seldom
shuts down because of disk accesses from sync and other running daemons.
It might happen that the time to spin the disk on to normal speed is too
long and \*(CO reports a bad track.
The timeout can be patched in the kernel to avoid this problem.
.IP \fB2.\fR
It switches off the backlight for the LCD after a predetermine time has
some time without keyboard input.
This technique works without complication under \*(CO.
.IP \fB3.\fR
It decreases clock frequency for the CPU and the refresh rate for the memory
after a predetermine time of inactivity.
This strategy, unfortunately, creates problems with \*(CO.
The power management hardware generates a non-maskable interrupt and
requests service from the BIOS.
\*(CO, however, switches the CPU into protected mode and the BIOS
no longer is available for such a service.
The only know reason for COHERENT to receive a non-maskable interrupt is a
memory parity error.
.PP
Fortunately this feature can be switched off in the BIOS setup of the
Siemens notebook computer.
If the BIOS of your notebook allows you to switch off this feature, do so.
If it does not, try setting the inactivity time in the BIOS to an extremely
Note that this problem should not arise with \*(CO 4.2.
.Sh "Do you have an incompatible system?"
.PP
If you have problems that cannot be helped by any of the above, 
then your computer system may not be capable of running \*(CO.
Note that it is possible for a system that cannot run \*(CO to be
made up entirely of components known to work on other systems that
run \*(CO.
The greatest number of these cases is seen with customers running
an AMI BIOS, IDE hard drives, or any kind of DTK motherboard.
Please record as much information as possible about make and model of
motherboard, BIOS, hard drive controller, hard drive, and all other equipment
installed; then contact Mark Williams Technical Support.

.ds TL "Installing cohulip"
.ds TI COHULIP
.NH "Installing cohulip"
.PP
.II cohulip^installation
This chapter describes how to install
.B cohulip
onto your system.
.PP
Installation of
.B cohulip
is a three-step process;
.IP \fB1.\fR 0.3i
Decide how you are going to tie your system into a network \(em either
by modem or by Ethernet, and gather some preliminary information.
.IP \fB2.\fR
Un\fBtar\fR the
.B cohulip
archive, and run the installation script to install
.B cohulip
onto your system.
.IP \fB3.\fR
Modify some configuration files by hand,
depending upon the type of network with which
.B cohulip
will be communicating.
.PP
None of these steps is particularly difficult; but each requires
that you pay attention to detail.
We urge you to read the following descriptions carefully
.I before
you begin to install
.BR cohulip ;
if you do not, you may waste time wrestling with a problem that has
already been solved.
.SH "Phase One \(em Preliminary Information"
.PP
Before you begin installation, you need to make some decisions and gather
some information.
.Sh "Install Hardware and Driver"
.PP
If you are going to use Ethernet, install your Ethernet card, and add the
.B ne
device driver to your \*(CO kernel.
Follow the directions included with your card and the driver.
.PP
If you are using SLIP, install your modem and configure your serial port.
For information how to do this, see the documentation that came with your
port; and check the entries for
.B asy
and
.B modem
in the \*(CO Lexicon.
.Sh "Choose Type of Network"
.PP
First, you must decide what type of
.B cohulip
will be communicating.
There are three possibilities:
.IP \fB1.\fR 0.3i
With an Internet provider via modem and SLIP.
.IP \fB2.\fR
With a local Ethernet network that has access to the Internet.
.IP \fB3.\fR
With a local mini-Ethernet network that does not have access to the Internet.
.PP
The rest of this chapter
assumes that you will be working with only one type of network.
It is possible to configure
.B cohulip
to work with more than one type of network simultaneously;
this is described in a later chapter.
.Sh "Obtain an IP Address"
.PP
.II "IP address"
An IP address is a 32-bit number that uniquely identifies a given machine
(or ``host'') that is running the suite of TCP/IP protocols.
As noted in earlier in the chapter on TCP/IP basics, sites send datagrams
to each other's ``IP address.''
Thus, before your machine can participate in a TCP/IP network,
it must have its IP number.
.PP
If you are using
.B cohulip
to hook your machine into an established Ethernet network, you must
talk with the person who administers the network and obtain an IP number
from her.
.PP
If you are creating a stand-alone mini-network, you can make up
a pseudo-IP number.
The only requirements are (1) that the number does not duplicate the IP
number on any other machine on your mini-network;
and (2) that it does not end in `0' or ``255''.
(These addresses have a special meaning to TCP/IP, and selecting one of them
for your pseudo-address will create all manner of problems.)
.PP
If you will be interfacing
.B cohulip
an Internet provider via SLIP, you must obtain the IP number from your
provider.
Internet providers assign IP numbers in either of two ways:
either they assign your system a permanent IP number, or they
assign you a different IP number every time you log in.
How the number is assigned affects how you configure and use
.BR cohulip ;
this is discussed in more detail below.
Note that if your provider offers you the choice of a permanent address
and a floating address,
.I always
take the permanent address.
.Sh "Obtain the Domain-Name Server IP Address"
.PP
Before TCP/IP can send a datagram to a remote site,
it must know that site's IP address.
People, however, usually prefer to remember sites by their names; therefore,
one of TCP's major tasks is to find the IP number that is linked to a given
site's name.
There are two ways to do this:
either by reading the contents of file
.BR $NETHOME/hosts.net ,
or by interrogating a domain-name server.
.PP
A
.I "domain-name server"
is a host that has a large data base of IP addresses and names, and
that you have permission to interrogate.
If you cannot find the address of the domain-name server, you will be limited
to accessing the systems whose names and IP addresses are listed in file
.BR hosts.net .
.PP
If you are hooking into an established Ethernet network, ask the system
administrator for the IP address of the domain-name server for that
network.
If you are accessing the Internet via SLIP, ask your Internet provider
for that address.
.PP
If you are using a local mini-network, you cannot use a domain-name server.
You must find the IP address of every other system on your mini-network,
and write it into file
.BR hosts.net .
The format of this file is discussed below.
Even if you have domain-name service, you may wish to write into this file
the addresses of systems that you contact frequently, to spare
.B cohulip
the trouble of interrogating the domain-name server.
.Sh "Obtain Another Computer"
.PP
If you are going to run
.B cohulip
over a local mini-network, you need another machine to talk to, if only
to see that your installation is working correctly.
You may be able to borrow such a system \(em these machines are very
common now.
If you are at work, you may be able to plug into a TCP/IP network there.
.Sh "Get the Dialing Sequence"
.PP
If you are going to access an Internet provider via SLIP, you must
find how to dial into your provider's modem.
You must obtain from the provider the telephone number to call;
the baud rate, parity, etc., for the modem; and your login identifier
and password.
Also note the port into which your modem is plugged, and the command
sequence with which you must initialize the modem.
.PP
You must also obtain the exact wording of each prompt that
.B cohulip
will encounter as it dials the provider, and what the proper response should
be.
The best way to obtain this information is to use the command
.B ckermit
to dial the remote provider by hand.
At every step (initializing the modem, entering your login identifier,
entering your password, etc.), write on a piece of paper what you will
send down the serial line, and what you see in response.
It is important that you write
.I exactly
what you see and what you enter.
You will use this information to write a ``dialing script'' for
.BR cohulip .
.SH "Phase Two \(em Installing cohulip"
.PP
Installing
.B cohulip
requires that you de-archive the
.B cohulip
package, then run an installation script.
.Sh "De-archiving the Files"
.PP
.B cohulip
comes in the form of a compress
.B tar
archive.
Move the archive into a directory where you store sources, e.g.,
.BR /usr/src ;
then type the following command:
.DM
	gtar -xvzf cohulip.tgz
.DE
De-archiving the files should take less than a minute, depending upon
the speed of your hard disk.
.PP
Dearchiving the files does not affect the archive
.B cohulp.tgz
itself.
You may wish to keep this archive intact as a backup copy, should you
accidentally damage or destroy some
.B cohulip
files.
.Sh "Contents of the cohulip Package"
.PP
When you un-\fBtar\fR the archive
.BR cohulip.tgz ,
its contents are written into directory
.BR cohulip .
This directory contains the following sub-directories and files:
.IP \fBInstall.sh\fR
This file holds a shell script that automates installation.
.IP \fBcohulip/README\fR
This file gives a general description of
.B cohulip 
and how to install it.
.IP \fBbin\fR
This sub-directory holds the executable program
.BR net ,
which is the executable program that actually performs networking tasks.
.IP \fBdoc\fR
This directory holds this manual, both in viewable and in
printable (PostScript) version.
It also holds the original K5JB documentation.
.IP \fBhelp.tar\fR
This archive holds help files read by
.BR net .
These files are de-archived when you install
.B cohulip
onto your system.
.IP \fBnet.tar\fR
This holds example configuration files that are used by the application
.BR net .
These files are described in a later chapter of this manual.
.IP \fBsrc\fR
This gives the sources for the application
.BR net .
.Sh "Invoking the Installation Script"
.PP
To install
.BR cohulip ,
log in as the superuser
.BR root ;
then enter the directory
.B cohulip
and invoke the script
.BR Install.sh .
This script performs the task of installation.
.PP
.B Install.sh
begins its work with the following message:
.B1
	                         WELCOME TO COHULIP
.sp \n(pDu
	This script installs the COHERENT user-level IP package (cohulip) onto your
	system.
.sp \n(pDu
	We strongly suggest that you read the document ./doc/install.p *before* you
	attempt to install cohulip onto your system.  If you wish to stop installation
	and review this chapter, answer 'n' to the following question.
.sp \n(pDu
	Do you wish to continue installation? [y]
.B2
.PP
Because you are reading this chapter you, you probably should answer `y' to
this question.
.B Install.sh
continues with this message:
.B1
	We assume that you have read the chapter on cohulip installation, and are
	continuing installation.  Please note that you can interrupt this program
	at any time without damaging your system in any way.  To interrupt
	installation, just type <ctrl-C>.  You may have to type it more than once.
	To resume installation, su to root and execute script Install.sh again.
.B2
.Sh "Get Home Directory for cohulip"
.PP
After the introductory messages, the first item of business is to name the
directory into which you want
.B cohulip
installed:
.B1
	The first step in installation is to select a home directory for cohulip.
	By default, cohulip is installed into directory $NETHOME.  To accept this
	default, simply press <return>.
.sp \n(pDu
	Home directory for cohulip: [/usr/net]
.B2
.PP
To accept the default directory
.BR /usr/net ,
simply press
.BR <return> .
If you want to install into another directory, type it at the prompt.
.B Install.sh
then asks you to confirm your choice:
.DM
	Install into directory /usr/net? [y]
.DE
To accept the default reply of `y', press
.BR <return> ;
if, however, you have changed your mind or if you see something wrong with
the directory's name, type `n' to cancel your choice.
.B Install.sh
will continue to ask you until you answer `Y' to some directory's name.
.PP
Once you have selected a directory for
.BR cohulip ,
.B Install.sh
then copies some files and archives into it, then processes the archives.
It also copies the executable
.B net
into directory
.BR /usr/bin .
.Sh "Get Local System Name"
.PP
The next step is to name your local system:
.B1
	The next step in installation is set your system's name.  Normally, this is
	the name set in the file /etc/uuname, although you can use another name if
	you wish.  Again, to accept the default, simply press <return>.
.sp \n(pDu
	Set the system name to \fIsystemname\^\fP? [y]
.B2
.PP
.I systemname
is the name of your system, as set in the file
.BR /etc/uuname .
If you wish to use another name, reply `n' to the above prompt.
.B Install.sh
displays the prompt
.DM
	Enter the name of your system:
.DE
and waits for you to type your system's name.
The cycle continues until you have entered and confirmed a name for your
system.
.Sh "Get Internet Address"
.PP
The next step is to enter your system's IP address:
.B1
	The next step is to enter your system's IP address.  As the manual states,
	some users are assigned an IP address when they log into their Internet
	provider's machine, and so may not know it at this time.
.sp \n(pDu
	Enter your IP address now ? [y]
.B2
.PP
If you do not yet know your IP address \(em or if you are accessing an
Internet provider that assigns your IP address only when you log in \(em
type `n'.
.B Install.sh
will then skip to the next item of business.
.PP
To accept the default response of `y', press
.BR <return> .
When you do so,
.B Install.sh
asks:
.DM
	Enter your IP address (e.g., 123.456.789.012):
.DE
Enter your system's IP address.
.B Install.sh
then asks you to confirm it:
.DM
	Is your IP address \fIaddress\^\fP?
.DE
where
.I address
is the address you typed.
Enter `y' if
.I address
is correct; if it is not, type `n' and
.B Install.sh
will try again.
.Sh "SLIP Information"
.PP
.B Install.sh
now asks you whether you intend to use SLIP:
.B1
	Use a serial port or modem for SLIP? [y]
.B2
.PP
Press `n' if you are
.I not
going to use SLIP.
If you press
.BR <return> ,
.B Install.sh
assumes that you are using SLIP, and proceeds to ask you some further
questions.
First, it asks you to name the serial port:
.DM
	Enter the serial port (e.g., com3fl):
.DE
Enter the port.
(This should be the local port, i.e., the port that ends with the
letter `l'.)
.B Install.sh
then asks you to confirm your entry:
.DM
	Serial port is \fIport\^\fP? [y]
.DE
If you enter `n',
.B Install.sh
tries again.
.PP
.B Install.sh
next asks you to enter the speed of the port:
.DM
	Enter the port's speed (e.g., 19200):
.DE
Do so.
.B Install.sh
then asks you to confirm what you typed:
.DM
	The serial port's speed is \fI\^\fP? [y]
.DE
If you type `n' in reply,
.B Install.sh
tries again.
.PP
This ends the information you must enter for SLIP.
.B Install.sh
displays the name it assigns to the SLIP interface:
.DM
	Your SLIP interface is named sl0
.DE
.Sh "Ethernet Information"
.PP
.B Install.sh
asks you whether you are going to use
.B cohulip
with an Ethernet connection:
.B1
	Use an NE1000 or NE2000 ethernet card? [y]
.B2
.PP
If you are
.I not
using Ethernet, answer `n';
.B Install.sh
skips to the next section.
If you press
.BR <return> ,
.B Install.sh
assumes that you will be using Ethernet and asks you to name the device
by which
.B cohulip
can access your Ethernet card:
.DM
	Enter the Ethernet card name (e.g., ne0):
.DE
Enter the name of the Ethernet device; do not prefix it with
.BR /dev/ .
.B Install.sh
asks you to confirm your entry:
.DM
	Your Ethernet card is named \fIcard\^\fP? [y]
.DE
If you enter `n',
.B Install.sh
tries again.
.PP
This ends the information you must enter for Ethernet
.B Install.sh
displays the name it assigns to the Ethernet interface:
.DM
	Your Ethernet interface is called 'ne0'
.DE
.Sh "Select the Default Route"
.PP
If you have indicated that you will be using both Ethernet and SLIP,
.B Install.sh
asks you to select which will be the default route:
.B1 
	Because you wish to use cohulip with both an Ethernet network and a SLIP
	network, you must select a default route.  This is the interface over which
	packets will be sent when a route cannot be located locally.  This is normally
	the interface that connects to the nearest gateway or router.
.sp \n(pDu
	Enter 'sl0' for SLIP or 'ne0' for Ethernet:
.B2
.PP
As the message states, you must select which network \(em the one you
access by Ethernet or the one you access via SLIP \(em should receive
data by default.
Enter ``sl0'' for SLIP, or ``ne0 for Ethernet,
depending upon which network you prefer.
.PP
.B Install.sh
asks you to confirm your choice:
.DM
	Use \fIroute\fP as default route?
.DE
where
.I route
is SLIP or Ethernet.
If you answer `n',
.B Install.sh
asks you to try again.
.PP
When you confirm your choice, or if you selected only SLIP or Ethernet,
.B Install.sh
states your system's default route:
either
.DM
	Your default route is \fIroute\fR
.DE
.Sh "Domain-Name Server"
.PP
.B Install.sh
now asks if you wish to use a domain-name server:
.B1
	As noted in the installation manual, you can enter the IP address or name
	of the domain-name server (DNS) that is available to your system.  Note that
	you should NOT enter this information if (1) you do not have it, or
	(2) your system does not have a permanently assigned IP address.
.sp \n(pDu
	Do you wish to enter the name or address of your domain-name server? [y]
.B2
.PP
As the message notes, you must take the following into mind when you decide
whether to enter the address of the domain-name server:
.IP \(bu 0.3i
If you do not know the address, answer `N'.
.IP \(bu
If you are using a local mini-network, and do not have access to a
domain-name server, answer `N'.
.IP \(bu
If you are using SLIP
.I and
your Internet provider assigns your IP address when you log in, answer `N'.
Do so even if you know the address of your Internet provider's domain-name
server.
The reason for this are explained below.
.IP \(bu
If you are using Ethernet on an established netowrk and you know the
address of that network's domain-name server, answer `Y'.
.IP \(bu
If you are using SLIP
.I and
your Internet provider has assigned you a permanent IP address
.I and
you know the address of your Internet provider's domain-name server,
answer `Y'.
.PP
If you answer `Y',
.B Install.sh
asks you to enter the name or address of the domain-name server:
.DM
	Please enter the correct name or dotted-decimal address of your DNS:
	e.g., '192.48.234.1' or 'myserver.com'.
	Enter name or address of your DNS:
.DE
Enter either the address of your domain-name server, or its name.
(Note that if you enter the name, you must put its name and address
into file
.BR $NETHOME/hosts.net ,
as described below.)
.B Install.sh
asks you confirm this:
.DM
	Your DNS has name or address \fIidentifier\^\fB? 
.DE
where
.I identifier
is the name or address you entered.
If you answer `n',
.B Install.sh
asks you to try again.
.Sh "Select Servers"
.PP
.B Install.sh
now asks you for the servers you wish to start up by default:
.B1
	The next step will be to ask you about the servers that you wish to turn on.
	Note that if you turn on a server, cohulip provides that service to people who
	are accessing into your system.  If you do not turn on a given server, you will
	still be able to use that service on other machines.
.B2
.PP
As the message states, a
.I server
provides service to people who are accessing your system;
it does not affect what you can do on other systems.
For example, if you decide to ``turn on'' the TELNET server, users on
other systems will be able to use the TELNET server to access your system.
If you decide not to do so, other users will not be able to do so, but you
will still be able to use the TELNET client to access other systems.
.PP
Note that ``turning on'' a server does not affect how your system performs:
a
.B cohulip
server does not occupy additional memory.
This is because all servers are already compiled into the application
.BR net ;
so invoking a server simply ``turns on'' one of
.BR net 's
feature.
.PP
.B Install.sh
goes through the following routine for four of its servers.
First, it asks you wish to turn on the server:
.DM
	Turn on the server for \fIserver\^\fP? [y]
.DE
where
.I server
is the server in question.
To accept the server, simply press
.BR <return> ;
.B Install.sh
displays the following to confirm your choice:
.DM
	Turning on server \fIserver\fP
.DE
If you do not want the server, answer `n'.
.PP
.B Install.sh
asks you about four servers:
.BR telnet ,
.BR echo ,
.BR finger ,
and
.BR ftp .
Note that the
.B echo
server services the command
.BR ping ;
if you select no other server, you should select this one, so that other
machines on your network can at least tell when you are on-line.
.Sh "Final Actions"
.PP
With those inquiries,
.B Install.sh
has finished asking you for information.
It displays the following messages:
.B1
	We have created a file called $STARTUP based upon
	the information you have enter.  For the application 'net' to use this
	information, you must invoke it with the following syntax:
.sp \n(pDu
		net startup.new
.sp \n(pDu
	We have also set the environmental variables NETHOME and NETSPOOL within the
	system-wide profile file '/etc/profile'.  However, this will not take effect
	until you next log in.  The network software needs these variables to locate
	its files.
.B2
.PP
.B Install.sh
then gives some information about configuration files:
.B1
	The file $NETHOME/hosts.net allows you assign aliases to IP addresses.
	Some examples are included in $NETHOME/hosts.net already.  The file
	$NETHOME/domain.txt is maintained by the domain-name client application
	if you have specified a name server.
	The file $NETHOME/hosts.net allows you assign aliases to IP addresses.
	Some examples are included in $NETHOME/hosts.net already.  The file
	$NETHOME/domain.txt is maintained by the domain-name client application
	if you have specified a name server.
.sp \n(pDu
	File $NETHOME/ftpusers controls access to ftp services.  There are examples
	in $NETHOME/ftpusers
.sp \n(pDu
	If you find that $NETHOME/startup.new is suitable for your system as
	we have created it, you can change its name to startup.net; it will then
	be automatically executed each time you start net.
.sp \n(pDu
	This concludes the installation of cohulip.
.B2
.PP
As the message states, that message concludes the work of
.BR Install.sh .
.Sh "After the Dust Settles"
.PP
The following describes what
.B Install.sh
has done to your system.
.PP
To begin,
.B Install.sh
created directory
.B $NETHOME
(default,
.BR /usr/net ).
It copied
.BR cohulip 's
configuration and help files into that directory.
.PP
Most importantly, it built script
.BR startup.new .
This script holds commands that reflect the information you entered when
you installed
.B cohulip
onto your system.
As you work with
.BR cohulip ,
you will find yourself copying and modifying this file rather frequently.
It is described in detail below.
.PP
.B Install.sh
also created sub-directory
.BR finger .
If you have enabled the
.B finger
server, you must write description files for your users and
copy them into that directory.
.PP
Finally,
.B Install.sh
copied the executable program
.B net
into directory
.BR /usr/bin .
.PP
.B cohulip
uses two environmental variables:
.IP \fBNETHOME\fR
This variable names the directory where
.BR net 's
configuration files are stored, e.g.,
the startup scripts,
.B finger
files, and
.B help
files.
.IP \fBNETSPOOL\fR
This names the file into which
.B net
writes files that it receives from other systems.
This is set to
.BR /usr/spool/uucppublic .
.PP
.B Install.sh
inserted these variables into file
.BR /etc/profile .
Note that you must log out and log in again before these
variables are added to your run-time environment.
.PP
.B net
also uses the environmental variable
.BR TZ .
This variable was set when you installed \*(CO onto your computer;
you do not need to worry about it.
.PP
.B net
requires that its files have the following permissions:
.DM
	-r-x--x--x   1 bin      bin     $NETHOME
	-rw-rw-rw-   1 bin      bin     domain.txt
	drwxrwxrwx   2 bin      bin     finger
	-rw-r--r--   1 bin      bin     ftpusers
	-rw-r--r--   1 bin      bin     hosts.net
	-rw-r--r--   1 bin      bin     startup.new
.DE
As you can see, all files should be owned by user and group
.BR bin .
Note, too that file
.B $NETHOME/domain.txt
should be writable by all users.
This file is updated automatically by the domain-name server, so it must
be open to every user who may use
.BR cohulip .
.PP
If the permissions on the
.B cohulip
files are not correct, you can set them with the following commands:
.DM
	chmog 511 bin bin /usr/bin/net
	chmog 644 bin bin $NETHOME/*
	chmog 666 bin bin $NETHOME/domain.txt
.DE
.SH "Phase Three \(em Post-Installation Configuration"
.PP
In some instances, you may have to perform some post-installation
configuration to get
.B cohulip
up and running.
.PP
The following discusses first Ethernet, then SLIP.
It walks you through the post-installation configuration you may have
to perform and simple tests to see if the system is working properly.
.Sh "Configuring cohulip for Ethernet"
.PP
Although Ethernet is a more sophisticated technology than a
serial line \(em or perhaps
.I because
it is more sophisticated \(em setting up
.B cohulip
on an Ethernet connection is much simpler than establishing it for SLIP.
The following describes the steps you must perform to configure
.B cohulip
for Ethernet.
It is adapted from mail by Bob Chalmers (earth@nanguo.cstpl.com.au).
.PP
First, copy
.B /usr/net/startup.new
to
.BR /usr/net/startup.net .
It should look like the following:
.DM
	# the name of your local host:
	hostname nanguo
	# the IP address of your local host:
	ip address 203.1.96.1
	# attach a TCP session to the Ethernet device:
	attach nx 0 0 arpa ne0 5 1500
.DE
.DM	
	# add the remote site's IP address to the routing
	# table for this session:
	route add 203.1.96.5 ne0
.DE
.DM
	# IP address of your network's domain-name server (DNS)
	# not present if entered no DNS address:
	domain addserver 123.456.789.012
.DE
.DM
	# these lines are boilerplate
	ip ttl 32
	tcp mss 1500
	tcp window 1500
	tcp irtt 2000
	eol unix
.DE
.DM
	# start the servers you selected; this shows them all
	start telnet
	start echo
	start finger
	start ftp
.DE
You may wish to replace line
.B "start telnet"
with the line
.BR "start telunix 23" .
.B telunix
is the server that manages logins; this command hangs it onto port 23,
which is the well-know port for TELNET.
It is described in the last chapter to this manual.
.PP
If you are using a mini-network, invoke TCP/IP on your other machine.
(A later section of this manual discusses how to bring up TCP/IP under
\*(MD.)
.PP
Now, try
.BR cohulip :
type
.B net
at your \*(CO prompt.
You will see some messages, then see the prompt
.BR net> .
.PP
To see if the networking is actually working, try
.BR ping ing
another machine on your network.
For example, if another system on your network is named
.BR lepanto ,
try the command:
.DM
	ping lepanto
.DE
Note that to access another machine by name, you must either have access
to a domain-name server or have entered its name and IP address into file
.BR hosts.net .
(This file is described in another section of this manual.)
Otherwise, you must use the other system's IP address with the
.B ping
command, instead of the system's name.
.PP
If the network is working correctly, you will see information from
.B ping
that describes how long it took to send a datagram to the remote system
and receive an acknowledgement.
Once this happens, you know that you can contact the remote system.
The next step is to invoke FTP and TELNET, and start to use your network.
For details on how to do this, see the chapter entitled \fIRunning net\fR,
which appears a little later in this manual.
.Sh "Connecting to the Internet via SLIP"
.PP
The following describes how to configure
.B cohulip
to connect to the Internet via an Internet provider.
Because of the complexity of this task, it requires a fair bit of
post-installation configuring.
Do not be discouraged if it does not work the first time:
after all, SLIP combines all of the complexity of a
network with that of a \*(UU link.
This will try your patience, but stick with it because the reward is great:
full access to the Internet and its wealth of information.
.PP
.II "Wright, Randy"
The following instructions, which are
adapted from mail by Randy Wright, should help make matters easier for you.
.Sh "Startup Script"
.PP
As with configuring for Ethernet,
the first step is to move file
.B $NETHOME/startup.new
to
.BR $NETHOME/startup.net .
.Sh "Modem Configuration"
.PP
Earlier in this chapter, we asked you to write exactly the steps
needed to initialize your modem and dial into your provider's system.
We will now use that information to write a script with which
.B net
can dial the provider's system.
If you are familiar with \*(UU and its ``chat scripts,'' then writing a
dialing script will be easy for you; if you are not, well,
you are about to learn how.
.PP
.II "script^dialing"
.II "dialing script"
A
.I "dialing script"
consists of an indefinite number of pairs of send/expect strings:
.B net
sends
.I send
half of the pair to the serial port; and it expects to see the
.I expect
string in response.
If, in response to a given send string,
it receives anything other than given the expect string,
.B net
assumes that something has gone wrong and aborts networking session.
.PP
A dialing script must perform the following tasks:
.IP \fB1\fR 0.3i
Initialize the modem to dial out.
.IP \fB2\fR
Dial the modem.
.IP \fB3\fR
Send your login identifier to the remote system.
.IP \fB4\fR
Send your password to the remote system.
.PP
You may also need to capture the IP address that your provider assigns you,
but that will be discussed in the following sub-section.
.PP
To initialize the modem, the first send/expect pair should read something
like the following:
.DM
	ATE1V1Q0S0=0\er OK
.DE
In standard Hayes notation, the send string turns on echoing,
turns on text-based messages, and turns off dial-in support.
The string ``\er'' tells
.B net
to send a carriage return at the end of the send string; this is needed to
flush the send the string out to the serial port.
The expect string states that you expect the modem to reply
.BR OK ,
which is the standard modem response.
For details on how you should initialize your modem, check the documentation
that came with it.
.PP
The next send/expect string dials the modem:
.DM
	ATDT1234567\er ogin:
.DE
The string
.B ATDT
is the standard Hayes command to dial a Touch-Tone telephone line.
``1234567'' stands for the telephone number to dial.
.B ogin:
is the
.I end
of the string with which your Internet provider's system prompts you to log in.
This prompt will, of course, change from system to system.
.PP
The next send/expect pair sends your login identifier to your provider's
system, and awaits the prompt for your password:
.DM
	mylogin\er ssword:
.DE
The send string
.I mylogin
stands for your actual login identifier.
As always, it ends with the string ``\er''.
The expect string
.B ssword:
is the
.I end
of the prompt for your password.
This prompt will, of course, change from system to system.
.PP
The final send/expect pair is actually just a send string:
.DM
	mypassword\er
.DE
where
.I mypassword
is your password.
Note that this is not followed by an expect string:
once
.B net
has processed the last send or expect string in the script,
it expects to start exchanging SLIP datagrams with your provider.
.PP
Thus, the entire script reads as follows:
.DM
	ATE1V1Q0S0=0\er OK ATDT1234567\er ogin: mylogin\er ssword: mypassword\er
.DE
To make the script available to
.BR net ,
edit file
.BR startup.net
and attach the script to the end of the command
.BR attach .
Note that all of
.B attach
command, including the dialing script, must appear on one line within the
.B startup
script.
If you are using MicroEMACS to edit
.BR startup.net ,
do not be alarmed if the
.B attach
command extends far past the right margin of your screen.
.PP
For more information on how to handle a modem or serial port, see the
entries
.B asy
and
.B modem
in the \*(CO Lexicon.
For a more elaborate of writing such a script, see the entry for
.B sys
in the Lexicon, or see the tutorial for \*(UU that is in the front portion
of your \*(CO manual.
For a detailed description of the
.B net
command
.BR attach ,
see the chapter \fIRunning net\fR, which appears later in this manual.
.Sh "Setting Your IP Address:  Permanent Address"
.PP
As we noted at the beginning of this chapter,
your Internet provider can give you an IP address in either of two ways:
.IP \(bu 0.3i
A ``permanent'' IP address, one that is assigned to you alone.
.IP \(bu
A ``floating'' IP address, which is assigned only when you dial in.
.PP
If you have a permanent IP address, you gave that address to
.B Install.sh
when you installed
.B cohulip
onto that system; and
.BR Install.sh ,
in turn, copied it into
.B startup.net
in a form of the command
.BR "ip address" .
For example, if your Internet provider has assigned your local host IP
address 123.456.789, then command
.DM
	ip address 123.456.789
.DE
should already be embedded within
.BR startup.net .
There is nothing more that you need to do.
.Sh "Setting Your IP Address:  Floating Address"
.PP
If, however, your Internet provider uses ``floating'' IP addresses,
the situation becomes much more complex.
.PP
When an Internet provider assigns an IP number, she flashes it on the screen
as the last item of text to be shown before entering SLIP mode.
You must somehow ``capture'' that address, so that you can type it into
.BR net .
To do so, you must add one final ``expect'' string to the end of the
dialing script that you added to the command
.BR attach ,
one that describes how the provider displays the IP address.
This forces
.B net
to display that address, so you can jot it down and then type it into
.BR net .
(Alas, there is as yet no automated way to capture this address.)
.PP
Unfortunately, there is no standard by which the provider displays this
information:
it varies from provider to provider.
For example, one provider ends her login messages with something like this:
.DM
	Your IP address 123.456.789 .....
.DE
To ``capture'' this address, add the string
.DM
	...
.DE
to the end of your dialing script.
This tells
.B net
to expect a string that ends with ``...'', and to display it.
When you see this, you can jot down the IP address.
.PP
Remember that the ``expect'' string must unique identify the
.I end
of the string that holds the IP address.
You may need to be creative to find such a string.
.PP
Once you have captured the IP address being assigned,
when you see the prompt
.B net>
you must type the command:
.DS
	\fBip address \fIip_address\fR
.DE
where
.I ip_address
is the IP address that you jotted down.
This tells
.B net
the address that has been assigned to you.
.Sh "Domain-Name Server Address"
.PP
Your Internet provider normally will have a name server that you can access.
This is needed so you can convert names of hosts into IP addresses (as
described in the previous chapter).
You should have obtained the address of this server as part of your
preparation for installing
.BR cohulip .
.PP
When you installed
.BR cohulip ,
the program
.B Install.sh
asked you for the address of your domain-name server.
At that time, we said that you should enter the address
.I only
if your Internet provider had given you a permanent IP address.
The reason is as follows:
When you address of the domain-name server,
.B net
initializes the domain-name software with the IP address for your
system that is current at the present moment.
If you have not yet set your IP address, the domain-name software
will be improperly set, and domain-name service will not work correctly.
.PP
If you have a permanent IP address, you entered the address of the
domain-name server when you installed
.BR cohulip .
The program
.B Install.sh
embedded this information in file
.B startup.net
in the form of the command
.DS
	\fBdomain addserver \fIip_address\fR
.DE
where
.I ip_address
is the address of your domain-name server.
This problem is solved, and you can move on to the next sub-section.
.PP
If, however, you use a floating IP address,
you must type the command
.DS
	\fBdomain addserver \fIip_address\fR
.DE
at the
.B net>
prompt to set the IP address of your name server.
Note that you must type this command
.I after
you have typed the command
.B "ip address"
to set your system's IP address, for the reason described above.
.PP
If you do not have access to any name server, you can still use SLIP,
but you cannot use the Internet's domain-name services.
Thus, you will be able to access by name only those sites that
are described in files
.B host.net
or
.BR domain.txt .
These files are described in detail in the next chapter.
.Sh "An Example Login Session"
.PP
At this point, you have finished your post-installation
configuration of
.BR cohulip ,
and you are ready to try it out.
.II "Chalmers, Robert"
The following example, which was supplied by Robert Chalmers,
walks through one such test session.
.PP
To begin, when you use
.B net
to dial into a remote system,
it displays on your screen your dialing script as it is executed.
.PP
To begin, this example uses the following version of
.BR startup.net :
.DM
	hostname nanguo
	ip address [203.1.96.1]
	attach asy 0 /dev/asy01l slip sl0 0 1500 9600 AT&F\er \e
		OK AT&Q6DT1234567\er ogin: MYLOGIN\er ord: PASSWORD\er
	route add default sl0
	domain addserver [192.160.127.125]
	ip ttl 32
	tcp mss 1500
	tcp window 1500
	tcp irtt 2000
	eol unix
	start telunix 23
	start echo
	start finger
	start ftp
.DE
Note that the
.B attach
command must appear on one line.
It is broken across two lines in the above display to make it legible.
.PP
As you can see, this user has a permanent IP address; so this script
automatically sets the IP addresses of both his local host and the
domain-name server.
.PP
When you invoke the command
.BR net ,
it logs its actions as follows:
.DM
	startup: [/usr/net/startnet.net]
	asy_init: tty name = /dev/asy01l
.DE
This shows that
.B net
is executing the start-up script
.BR startup.net ,
and that it is initializing device
.BR asy01l ,
as named in the
.B attach
command.
.PP
The next lines walk through the dialing script that is appended onto the
.B attach
command.
The first sequence initializes the modem:
.DM
	I'm sending  : 'AT&F\er'
	I'm expecting: 'OK'
	AT&F
	OK
.DE
The next lines dial the modem, and invoke the login prompt on the remote
system:
.DM
	I'm sending  : 'AT&Q6DT1234567\er'
	I'm expecting: 'ogin:'
	AT&Q6DT1234567
	login:
.DE
In the above sequence, ``1234567'' stands for the telephone number.
.PP
The next lines log you into the system:
.DM
	I'm sending : 'MYLOGIN\er'
	I'm expecting: 'ord:'
	MYLOGIN
	Password:
	I'm sending  : 'MYPASSWORD\er'
.DE
In the above, ``MYLOGIN'' represents the login identifier, and
``MYPASSWORD'' represents the password.
.PP
At this point, you are logged into the remote system,
and has begun to exchange SLIP datagrams with the remote system.
.PP
If the user had had a floating IP address, his dialing script would
have had one more string attached to it:
a string that matched the end of the string with which the provider
displayed his IP address.
He would have jotted it down; and when he saw the
.B net>
prompt, he would have typed the commands
.DS
	\fBip address \fIip_address\fR
	\fBdomain addserver \fIip_address\fR
.DE
in that order.
.PP
Perhaps the lesson here is:
if you can get a permanent IP address,
.IR "grab it!"
.Sh "Writing a Script to Invoke net"
.PP
If you are using
.B cohulip
to access one or more Internet providers via SLIP,
you may wish to wrap the command
.B net
within a shell script.
This is because the command
.B net
is very limited in how it can manipulate a serial port:
it can dial out, but it cannot enable or disable a port, or even hang
up the telephone after the
.B net
session has concluded.
You can handle such details in a script.
.PP
The following gives an example of a shell script called
.BR Net .
This script dials two different Internet providers, one called
.B MCS
and the other called
.BR SIS .
Each has its own startup script \(em called, respectively,
.B startup.mcs
and
.BR startup.sis .
.DM
	#!/bin/sh
	RMODEM=com3fr
	LMODEM=com3fl
.DE
.DM
	case $1 in
		mcs)	TARGET=mcs;;
		sis)	TARGET=sis;;
		*)	echo "Usage: Net mcs|sis";
			exit 1;;
	esac
.DE
.DM
	# disable the port
	echo Disabling port $RMODEM
	/etc/disable $RMODEM
.DE
.DM
	# invoke "net" for the target network
	net startup.$TARGET
.DE
.DM
	# reset the modem and port after a "net" session:
	echo Resetting the modem
.DE
.DM
	# get the modem's attention
	echo "+++" > /dev/$LMODEM
	sleep 2
	echo "+++" > /dev/$LMODEM
	sleep 2
.DE
.DM
	# hang up the phone
	echo "ath" > /dev/$LMODEM
	sleep 2
.DE
.DM
	# reload the standard modem settings
	echo "atz" > /dev/$LMODEM
	sleep 2
.DE
.DM
	# bump modem into high-speed mode; needed with 14.4 modems under COHERENT
	echo "at" > /dev/$LMODEM
	sleep 2
.DE
.DM
	# re-enable the port
	echo Re-enabling port $RMODEM
	/etc/enable $RMODEM
.DE
.DM
	# end of Net
.DE
Note that you must have permission to use the commands
.B enable
and
.B disable
before you can run this script successfully.
For details, see their entries in the Lexicon.
.PP
Please note that with some modems, simply echoing a string to the modem's
device does not work.
The following version of
.BR Net ,
which is taken from the \*(CO script
.BR /etc/modeminit ,
should work correctly with such modems:
.DM
	#!/bin/sh
	RMODEM=com3fr
	LMODEM=com3fl
.DE
.DM
	case $1 in
		mcs)	TARGET=mcs;;
		sis)	TARGET=sis;;
		*)	echo "Usage: Net mcs|sis";
			exit 1;;
	esac
.DE
.DM
	# disable the port
	echo Disabling port $RMODEM
	/etc/disable $RMODEM
.DE
.DM
	# invoke "net" for the target network
	net startup.$TARGET
.DE
.DM
	# reset the modem and port after a "net" session:
	echo Resetting the modem
.DE
.DM
	# get the modem's attention
	{
	  sleep 2
	  cat >&1 <<\!
	  +++
	  !
	} <$LMODEM
.DE
.DM
	# hang up the phone
	{ 
	  sleep 3
	  cat >&1 <<\!
	  ATH0
	  !
	} <$LMODEM
.DE
.DM
	# reload the standard modem settings
	{ stty 9600
	  sleep 2
	  cat >&1 <<\!
	  ATZ
	  !
	} <$LMODEM
.DE
.DM
	# re-enable the port
	echo Re-enabling port $RMODEM
	/etc/enable $RMODEM
.DE
.DM
	# end of Net
.DE
.SH "Where To Go From Here"
.PP
The next chapter in this manual describes
.BR cohulip 's
configuration files in some detail.
.PP
The chapter after that, \fIRunning net\fR, summarizes all of the commands
that the program
.B net
recognizes.
You may wish to use this chapter as a reference while you run
.BR cohulip .
.PP
Finally, the last chapter in this manual, \fIAdvanced cohulip\fR,
discusses advanced topics.
It discusses elaborate configuration, such as using
.B cohulip
as a firewall between two networks; and gives extended examples of
FTP session and debugging TCP datagrams.

.NH "Recompiling X Applications"
.PP
.II "X^recompile"
.II "compiling X applications"
.II "importing X applications"
A wealth of X source code is available to the public.
In all probability, somebody has already written the X program that you want.
By checking publically accessible archives, you will find many interesting,
useful, and amusing programs.
The following gives hints on how to recompile X source code under \*(CO.
.PP
In many cases, importing an X application to \*(CO is simply matter of
recompiling its source code.
This section describes how to do so.
It also discusses some problems that are commonly encountered
during recompilation.
.SH "Imakefiles and Makefiles"
.PP
.II make
.II Makefile
The \*(UN/\*(CO application
.B make
manages the building of programs.
It reads the contents of a
.BR Makefile ,
which describes how to build the program, and names the source modules
from which the program is created.
If you are not familiar with
.BR make ,
see tutorial for it that appears in your \*(CO manual.
.PP
Although
.B make
is the programmer's best friend, adapting a
.B Makefile
from one operating system to another can be difficult.
This is because different operating systems \(em even different
flavors of \*(UN or \*(UN-like systems like \*(CO \(em can vary
quite a bit in their capacities, in the functions available in their
libraries, and in how they have structured their header files and libraries.
.PP
.II Imakefile
.II xmkmf
.II imake
To help you avoid this problem, most X applications use the utility
.B imake
to build a
.BR Makefile .
.B imake
reads the contents of an
.B Imakefile
that is written by the programmer, invokes the C preprocessor
.B cpp
to combine the
.B Imakefile
with a set of configuration files designed for your operating system,
and writes a
.B Makefile
from which you can build the application.
In many instances, the
.B Imakefile
simply names the application you wish to build and the source files
from which it is built.
An example
.B Imakefile
is shown below.
.PP
The script
.B xmkmf
invokes
.B imake
with the arguments and configuration files that are appropriate for \*(CO.
In most instances, all you have to do to build a
.B Makefile
is type
.BR xmkmf ;
and once the
.B Makefile
is built, all you have to do to build the application is type
.BR make .
.PP
Naturally, some problems may arise during this process.
The commonest ones are discussed below.
.SH "Modifications to Makefiles"
.PP
Some applications come with a
.B Makefile
instead of an
.BR Imakefile .
If this is the case, you probably will need to modify this
.B Makefile
so that the program will compile correctly under \*(CO.
.PP
The following changes must be made to most
.BR Makefile s:
.IP \(bu 0.3i
X Windows for \*(CO keeps X header files in directory
.BR /usr/X11/include/X11 .
Most other releases of X keep their header files in directory
.BR /usr/include/X11 ;
therefore, you must add an instruction to the
.B Makefile
to tell it to look in the correct directory.
.IP
A
.B Makefile
must use the option -I to name this directory explicitly:
.DM
	-I/usr/X11/include
.DE
.IP
This tells the C compiler to look in
.B /usr/X11/include
for any header file whose name is prefixed with X11, such as:
.DM
	#include <X11/Xos.h>
.DE
Often, this is done as part of the macro
.BR CCFLAGS .
Therefore, if you see an instruction of the form:
.DM
	-I/usr/include/X11
.DE
.IP
change it to read:
.DM
	-I/usr/X11/include
.DE
.IP \(bu
X Windows for \*(CO keeps its X libraries in directory
.BR /usr/X11/lib .
A
.B Makefile
must name that directory explicitly.
Many
.BR Makefile s
use a macro named something like
.B LIBFLAGS
to set linking options and name libraries.
Before the list of libraries, you must add the option:
.DM
	-L/usr/X11/lib
.DE
.IP \(bu
Add
.B \-lXbsd
to the end of the list of libraries to be linked into the application.
This tells the linker to link in library
.BR libXbsd.a ,
which holds the socket-emulation routines.
.IP \(bu
If the option
.B \-lsocket
appears on the list of libraries, remove it.
This library holds the Berkeley socket functions; these are emulated in
.B libXbsd.a
and so are not needed.
.IP \(bu
Add the option
.B \-DCOHERENT
to the macro
.BR CCFLAGS .
If you make any \*(CO-specific changes to the source code, you can bracket
them with the preprocessor directives
.DM
	#ifdef COHERENT
	    ...
	#endif
.DE
.IP
and the instruction
.B \-DCOHERENT
will ensure that they appear in the compiled program.
.PP
Once you have made these changes, you can begin compiling.
.SH "Problems Seen During Compilation"
.PP
The following discusses problems that can come up during compilation.
.IP \(bu 0.3i
The \*(CO compiler is not ANSI compliant, although it recognizes some ANSI
extensions to the C language.
If the X application is written using ANSI-specific grammar (in particular,
function prototypes), you must compile it with an ANSI-compliant compiler,
e.g., GNU C.
When doing so, modify the
.B Makefile
or
.B Imakefile
to define the macro
.B CC
to
.BR gcc .
.IP \(bu
During the link phase, you may see the linker complain about the
undefined symbol
.BR select .
This indicates that one of the source modules has called the socket function
.BR select() .
Under X Windows for \*(CO, this function is named
.BR soselect() .
.IP
To fix this problem, go through the sources and conditionally replace every
instance of
.DM
	select( [arguments] );
.DE
.IP
with:
.DM
	#if defined(COHERENT)
		soselect ( [arguments] );
	#else
		select ( [arguments] );
	#endif
.DE
.IP
Note that this is the proper way to add new \*(CO-specific code to X sources.
If the application comes only with a
.BR Makefile ,
you must make sure the instruction
.B \-DCOHERENT
appears as part of the macro
.BR CFLAGS ;
however, this is not necessary if you have built a
.B Makefile
from an
.BR Imakefile ,
as
.B xmkmf
ensures that this instruction is included automatically.
.IP \(bu
The \*(CO C compiler does
.I not
include by default the code to print floating-point numbers,
as this code increases the size of the linked executable noticeably.
If your X application uses any of the options
.BR %e ,
.BR %f ,
or
.B %g
with the function
.BR printf() ,
and if you are compiling with \*(CO's
.B cc
command, you
.I must
add the option
.B \-f
to the macro
.BR CFLAGS .
Note that you must do this in either a
.B Makefile
or an
.BR Imakefile ,
as
.B xmkmf
does not add this option by default.
.\" got that?
.IP
You do not need to do this if you are compiling with GNU C.
.IP \(bu
Some applications redeclare the manifest constant
.BR PI ;
\*(CO declares this constant in header file
.BR <math.h> .
The \*(CO C compiler will abort if manifest constants are redeclared
(GNU C does not);
so if this problem arises,
conditionalize out the declaration of
.B PI
within the application, as shown above.
.IP \(bu
You may find problems with the following routines:
.BR bcopy() ,
.BR bcmp() ,
.BR bzero() ,
.BR index() ,
and
.BR rindex() .
The problems usually consist of a clash
between the manner in which these routines are declared or defined within
the application, and they way they are declared or defined in the \*(CO
header files.
In most instances, you should conditionalize out the
declaration within the application, and ensure that the proper \*(CO
header file is included.
For details, use the command
.B man
command to view the manual entries for the routine in question.
.IP \(bu
Some versions of \*(UN declare string-handling functions in the header file
.BR <strings.h> .
\*(CO, however, keeps them in
.BR <string.h> .
If the compiler complains that it cannot open
.BR strings.h ,
conditionally replace it in the sources with
.BR <string.h> ,
as described above.
.IP \(bu
If you are compiling with GNU C, the linker may complain of a number of
undefined symbols of the form
.BR _dmul .
This is due to the fact that GNU C always creates code that performs hardware
floating-point arithmetic and by default attempts to link in the \*(CO
libraries that contain hardware floating-point routines,
but the \*(CO X libraries were compiled
to use software floating-point arithmetic.
To get around this problem, you must modify the file
.B specs
for GNU C:
change the line that reads
.DM
	%scrt1.o %scrtbegin.o -u _dtefg -L/lib/ndp -L/usr/lib
.DE
to:
.DM
	%scrt1.o %scrtbegin.o -u _dtefg -L/lib -L/usr/lib
.DE
.IP
Note that this is a work-around for GNU C, and may create problems of its own.
For example, when you link software floating-point code with modules
compiled to use hardware floating-point arithmetic, the function
.B atof()
will always return
.BR NAN .
.IP
For a fuller description of how \*(CO manages floating-point arithmetic,
see the Lexicon entry for
.BR cc .
.PP
If other problems arise that are not described here, please send a
detailed description to MWC Technical Support, as described at the beginning
of this manual.
.SH "Recompiling an Example Application"
.PP
.II "Friedman, Mike"
.II "Riddle, Paul"
.II "McBeath, Jim"
The following walks you through the recompilation of the X application
.BR xwave .
This application, whose source code is included with X Windows for \*(CO,
was written by
Mike Friedman, Paul Riddle, and Jim McBeath.
It draws a three-dimensional animation of a wave.
By setting command-line parameters, you can dictate the size of the
grid used and the type of wave to be plotted.
The following steps describe how to recompile this program:
.IP \(bu 0.3i
.B cd
to directory
.BR /usr/X11/src .
.IP \(bu
De-archive the sources by typing the command:
.DM
	gtar -xvzf xwave.gtz
.DE
.IP \(bu
.B cd
to directory
.BR xwave .
.IP \(bu
Type the command
.BR xmkmf .
This builds a
.B Makefile
from the
.B Imakefile
included with this package.
.IP \(bu
To recomile, type
.BR make .
.IP \(bu
When compilation has finished, install the program as follows:
.DM
	mv xwave /usr/X11/bin
.DE
.IP \(bu
To test the program, invoke X as described in an earlier section;
then type
.BR xwave .
The application opens a window and animates a sample wave.
.PP
That's all there is to it.
A formatted manual page for
.B xwave
is included in directory
.BR /usr/X11/src/xwave/man .
.PP
The following gives the contents of
.BR xwave 's
.BR Imakefile :
.DM
	LOCAL_LIBRARIES = $(XLIB)
	OBJS = xwave.o force.o plot.o prop.o
	SRCS = xwave.c force.c plot.c prop.c
	SYS_LIBRARIES = -lm
	ComplexProgramTarget(xwave)
.DE
When
.B xmkmf
and
.B imake
process this five-line
.BR Imakefile ,
it expands in a 370-line
.BR Makefile .
The following describes each line in the
.BR Imakefile .
.PP
.B LOCAL_LIBRARIES
names the libraries to be linked into the program.
The macro
.B XLIB
means that the programmer wants to include the standard suite of
X libraries for your system.
The configuration files included with X Windows for \*(CO give the information
that
.B imake
needs to expand
.B XLIB
into the correct set of libraries.
.PP
.B OBJS
and
.B SRCS
name, respectively, the object modules from which the application is built,
and the source files from which those objects are compiled.
.PP
.B SYS_LIBRARIES
names the system libraries to be included, apart from the X libraries.
The programmer has included the argument
.BR \-lm ,
which indicates that the program needs routines within the mathematics library
.BR libm.a .
For details on the contents of this library, see its entry in the \*(CO Lexicon.
.PP
Finally, the line
.DM
	ComplexProgramTarget(xwave)
.DE
is a macro whose body is kept in file
.BR /usr/X11/lib/config/Imake.rules .
This macro contains all of the instructions and commands that
.B make
needs to build a complex X program.
The argument
.B xwave
names the application to be built.
.PP
For a discussion of the macros that can be included in an
.BR Imakefile ,
see the Lexicon entry for
.B imake
in this manual.
.SH "Building Your Own Makefile"
.PP
If you do not want to use
.B xmkmf
and
.BR imake ,
you can build a
.B Makefile
by hand.
You probably will never need to do this, but knowing how to do so
may come in handy some time:
.IP \fB1.\fR 0.3i
Build a skeletal
.BR Makefile .
Place the following declarations at its beginning:
.DM
	CFLAGS  = -I/usr/X11/include
	LIBS    = -L/usr/X11/lib -lX11 -lXbsd
.DE
.IP
Follow this with a declaration of the object modules from which this
application is built.
As a rule of thumb, there is one object for each source module.
For example, if the application consists of source modules
.BR foo.c ,
.BR bar.c ,
and
.BR baz.c ,
write the following into your
.BR Makefile :
.DM
	OBJS    = foo.o bar.o baz.o
.DE
.IP 
Finally, add the target line for the executable you wish to build.
If the application is to be called
.BR xapp ,
add the following to your skeletal
.BR Makefile :
.DM
	xapp: $(OBJS)
		$(CC) $(CFLAGS) $(OBJS) $(LIBS)
.DE
.IP \fB2.\fR
Use the command
.DM
	cc -c -I/usr/X11/include/X11 \fIsource\fP.c
.DE
.IP
for each
.I source
module.
Some modules will compile correctly on the first try; others will
require several attempts.
Those that require several attempts may require that you use the
.B cc
option
.B \-D
to set one or more switches within the source module.
Use the command
.B grep
to find every instance with the source module of the C preprocessor directive
.BR #if .
These will indicate the options that are available within the source code,
and suggest which switches you should set.
.IP \fB3.\fR
.II nm
Once you have succeeded in compiling all of the source files to objects, type
.BR make .
Because all of the objects already exist,
.B make
will attempt to link an executable.
.IP
At this stage, you probably will see errors about undefined symbols.
Note which symbols are undefined; then use the
\*(CO utility
.B nm
to list the symbols in all of the X libraries and find which libraries
contains the symbols you need.
Include them in your
.BR Makefile .
.IP
.II libX11.a
.II libXbsd.a
Note that an X application always need the libraries
.B libX11.a
and
.BR libXbsd.a ;
the declarations given above invoke those libraries automatically.
The difficulty is in arranging the other libraries in the proper order
in the
.BR Makefile .
This can be done only by trial and error:
sometimes many trials and many errors.
When you have the correct order, copy the information into your
.BR Makefile .
.IP
Unresolved identifiers within the program may also be manifest constants
that the programs expects to be set with the
.B \-D
option to the
.B cc
command.
.PP
When you have finished linking the program, you should have a working
executable.
Thereafter, you can use the
.B Makefile
you just created to
rebuild the application, should you decide to modify the source code.
.PP
Most applications come with a manual page that describe the program and
how to run it.
You may, for example, need to install a font or a resource file in the
appropriate directory.
You will, of course, need to test the program to make sure that it runs
correctly.
We have found that, in most instances, if a program can be compiled and
linked under \*(CO, it will also run correctly.
.SH "Where To Get X Sources"
.PP
Numerous X programs have already been ported to \*(CO.
Archives of sources are available for free on the Mark Williams BBS.
For directions on how to contact the MWC BBS, see the directions in the
tutorial for UUCP that appears in the \*(CO manual.
.PP
If you have access to the Internet, you can retrieve source files from
the site
.BR raven.alaska.edu .
Use
.B ftp
to access that site; then log in as ``anonymous''.
New sources are added continually.
.PP
The master site for X software is
.BR ftp.x.org .
If you have access to the Internet, you can log into that system via
anonymous
.BR ftp .
This site contains many megabytes of sources, so you would be well
advised to think about what you would like to retrieve before you
enter this site.
.PP
Finally, Mark Williams Company sells packages of X applications
that have been ported to \*(CO.
Called
.BR Xware ,
these packages bring together interesting, useful, and amusing programs
for your \*(CO X system.
Each has been ported to \*(CO; most include full source code and a formatted
manual page that can be viewed with the \*(CO
.B man
command.
For details on
.BR Xware ,
see the release notes that come with this manual.

.ds TL "Advanced cohulip"
.ds TI COHULIP
.NH "cohulip Configuration Files"
.PP
This chapter describes the configuration files that
.B cohulip
uses to hold networking information.
.SH "startup.net"
.PP
When
.B net
first starts up, it attempts to read a startup script.
You can name a startup script as an argument to the command
.BR net .
For example, to invoke
.B net
with the startup script
.BR startup.foo ,
use the command:
.DM
	net startup.foo
.DE
If you do not name a startup script on
.BR net 's
command line,
.B net
attempts to read the file
.BR $NETHOME/startup.net .
.PP
If it finds a startup script (either one you name on the
.B net
command line, or
.BR startup.net ),
.B net
executes all of the commands that file contains,
just as if you had typed them from the keyboard.
Thus, you can use the startup script to load key information into
.BR net ,
such as your system's IP address and the address of your system name-service
provider; and you can use it to start up the suite of servers that you wish
to support during this session.
.PP
When you installed
.B cohulip
onto your system, the installation program wrote a startup script named
.BR $NETHOME/startup.new .
After you have read this chapter and the chapter \fIRunning cohulip\fR, which
appears later in this manual, you should check
.BR startup.new ;
and if it appears to be correct, you should rename it
.BR startup.net .
.Sh "Order of Commands"
.PP
The order of the commands is important within a startup script.
Some commands depend upon information supplied by other commands.
If you modify a startup script, be sure that the commands appear in the
following order.
.PP
The following gives the usual order of commands within a startup script:
.DS
	# set your machine's name
	\fBhostname \fIname\fR
	# set your machine's IP address
	\fBip address \fIaddress\fR
.DE
.DS
	# attach a session to a physical device; can have multiple sessions
	\fBattach \fIarguments\fR
		.\^.\^.
	# commands to tune IP:
	\fBip ttl \fItime-to-live\fR
.DE
.DS
	# commands to tune TCP:
	\fBtcp mss \fIbytes\fR
	\fBtcp window \fIbytes\fR
	\fBtcp irtt \fIbytes\fR
	# set the IP address of domain-name server(s):
	\fBdomain addserver \fIip_address\fR
		.\^.\^.
.DE
.DS
	# add one or more routes to the routing table:
	\fBroute add \fIarguments\fR
		.\^.\^.
	# fire up servers to use during this networking session:
	\fBstart\fR \fIserver\fR
		.\^.\^.
	# miscellaneous commands:
	\fBlog $NETHOME/net.log\fR
.DE
Each of these commands is explained in detail in the chapter
\fIRunning net\fR, which appears later in this manual.
The following summarizes each briefly:
.IP "\fBhostname \fIname\fR"
This command sets your machine's name, as it will be known to the other
machines on the network.
You should set this to your system's \*(UU name, which is set in file
.BR /etc/uuname ;
however, this is not required.
.IP "\fBip address \fIaddress\fR"
Set your system's IP address.
By custom, this is set at the beginning of a startup script;
however, this is not required.
If you are using SLIP to access an Internet provider that assigns an IP
addresses when you log in, you will have to type in this command by hand
after the startup script has executed and you log in.
.IP "\fBattach \fIarguments\fR"
Attach a networking session to a physical device, either a serial port
(for SLIP) or your Ethernet card.
You can attach more than one session simultaneously; but
a physical device can have only one session attached to it at any given time.
For example, if your system has an Ethernet card, you can attach one session
to the Ethernet card and another to a serial port.
If you are attaching to a serial port that has a modem plugged into it, the
you can add a script to the
.B attach
command that dials the modem and logs you into the remote system.
.IP "\fBip ttl\fR"
.II "IP^time-to-live"
.II "time to live"
This command sets the time-to-live of IP datagrams \(em that is, it sets the
number of systems that can handle this datagram before it ``perishes.''
The command
.B ip
has a number of other sub-commands that let you tune the behavior of IP under
.BR net .
.IP "\fBtcp mss\fR"
.IS "\fBtcp window\fR"
.IS "\fBtcp irtt\fR"
These commands tune TCP.
They set, respectively, TCP's maximum segment size, its ``window'' (or maximum
number of bytes it can receive at any one time), and its initial round-trip
time (or time it will wait to receive the remote host's acknowledgement of
receipt of a datagram).
The command
.B tcp
has numerous other options as well; for details, see the chapter \fIRunning
net\fR, which follows in this manual.
.IP "\fBdomain addserver\fR"
Set the IP address of a domain-name server \(em that is, a remote system that
you can interrogate to translate systems' names into their IP addresses.
You can set more than one domain-name server at once.
.IP "\fBroute add\fR"
.II "routing table"
Set the IP address of the system to which a given session should route its
datagrams \(em that is, add its address to
.BR net 's
.IR "routing table" .
Each session must be linked to at least one remote system; and it may be
linked to more than one.
If a session is linked to more than one remote system,
.B net
uses an elaborate set of internal rules to decide which system to which
it should send the datagrams.
.IP \fBstart\fR
This command invokes one of the servers that is built into
.BR net .
.II server^definition
A
.I server
handles requests from a remote system for a given service.
The servers built into
.B net
include
.BR ftp ,
.BR telnet ,
.BR ping ,
.BR echo ,
and
.BR smtp .
.IP \fBlog\fR
At the end of the startup script, you add any number of miscellaneous
commands.
The command
.B log
logs activity that is generated when remote systems access your system.
It appends its output onto the file that you name on its command line, so
you can use this command to keep a running log of activity on your system.
.PP
For a full discussion of
.BR net 's
commands and their options, see the chapter \fIRunning net\fR, which follows
in this manual.
.SH "ftpusers"
.PP
When a user accesses your system via FTP, she bypasses \*(CO's normal login
routines.
However, you need to control who can access your system and what each person
can do; therefore,
.B net
provides the file 
.BR ftpusers .
This file names every user who can access your system via FTP,
sets the directories that that user can access, and the permissions
that she has in each.
.PP
.B ftpusers
consists of an indefinite number of rows.
Each row names one user who can access your system, and sets her password
and permissions.
It has the following format:
.DS
	\fIuser password directory permissions \fB[ \fIdirectory permissions ... \fB]\fR
.DE
There must be exactly one space character between each field.
If a line begins with a pound-sign character `#',
.B net
ignores it; you can use such lines to hold comments.
.PP
.I user
and
.I password
gives the user's name and password.
When a user attempts to access your system via FTP,
.BR net 's
FTP server asks her to identify herself, and to enter her password.
If the user enters a name that does not appear in
.BR ftpusers ,
or does not enter the correct password, then the FTP server refuses that user
access to your system.
.PP
A password of `*' tells the FTP server to accept any password.
Note that the passwords in this file are
.I not
encrypted.
Therefore, this file should be readable only by user
.BR bin ,
and user
.B bin
on your system should have a password.
.PP
.I directory
names a directory that the user can access.
When you name a directory, the user has access to that directory and all
of its subdirectories.
.I permissions
gives the permissions that
.I user
has in this directory.
This is a single-digit integer that sums the following permission values:
.DS
	\fB1\fR	Permission to read files within \fIdirectory\fR
	\fB2\fR	Permission to write new files within \fIdirectory\fR
	\fB4\fR	Permission to overwrite or delete files within \fIdirectory\fR
.DE
For example, a
.I permission
of `3' sums one and two, and thus grants
.I user
permission to read and write files within
.IR directory ,
but does not grant her permission to overwrite or remove files.
.PP
Each
.I directory
argument must be followed by a
.I permission
argument.
You can name up to eight
\fIdirectory\-permission\fR pairs for any given
.I user
within
.BR ftpusers .
.PP
File
.B ftpusers
is always kept in directory
.BR $NETHOME .
If
.B ftpusers
does not exist, no user will be granted access to your system via FTP
(not even yourself), and therefore
.BR net 's
FTP server will be useless.
.SH "hosts.net"
.PP
File
.B hosts.net
maps an IP address to the name or names of a host.
.B net
reads this file to transform a host name into that host's IP address.
.PP
The entries within
.B hosts.net
have the following format:
.DS
	\fIip_address\fR \fIhostname \fB[ \fIalias_hostname ... \fB]\fR
.DE
.I ip_address
gives the host's four-byte IP address.
The same IP address can appear in more than entry within
.BR hosts.net .
.PP
.I hostname
names the host.
Note that
.I hostname
does
.I not
have to give the host's full domain name; however,
.I hostname
must be unique within
.BR hosts.net .
.PP
.I hostname
can be followed by one or more
.IR alias_hostname s.
These are alternative names for the host, or abbreviations.
Note that each
.I alias_hostname
must be unique within
.BR hosts.net ,
or trouble will result.
.PP
The following gives an example entry from
.BR hosts.net :
.DM
	137.229.10.39	raven raven.alaska raven.alaska.edu
.DE
This entry links the IP address 137.229.10.39 to three host names:
.BR raven ,
.BR raven.alaska ,
and
.BR raven.alaska.edu .
All three are aliases for the same site.
You can also break these three host names into three separate entries within
.BR hosts.net ,
as follows:
.DM
	137.229.10.39	raven
	137.229.10.39	raven.alaska
	137.229.10.39	raven.alaska.edu
.DE
Some users find the latter format to be more legible;
however, if a site's IP address changes, you must be careful to update each
of its entries within
.BR hosts.net ,
or trouble will result.
.SH "Help Files"
.PP
.BR net 's
command \fBhelp \fIsubject\fR displays the contents of file
\fB$NETHOME/\fIsubject\fB.hlp\fR.
Normally,
.I subject
is one of
.BR net 's
commands or configuration files; but it can be anything you like,
so long as it fits into a file.
.PP
.II net.hlp
If you do not specify a
.IR subject ,
.B net
displays the contents of
.BR net.hlp .
.PP
.B cohulip
comes with a help file for each of
.BR net 's
commands.
You can modify or add to them if you wish.
.SH "Finger Files"
.PP
The command
.B finger
lets you read information about a user who is on a remote system.
It takes three forms:
.IP "\fBfinger \fIuser\fR\fR
Display information about
.IR user ,
who is a recognized user on your system.
.IP "\fBfinger @\fIhost\fR"
Display the name of each recongnized user on system
.IR host ,
which can be a remote host or your local host.
.IP "\fBfinger \fIuser\^\fB@\fIhost\fR"
Display the contents of the finger-file for
.I user
who is on system
.IR host .
.PP
.B cohulip
also supports a server for
.BR finger ,
so that other users can find information about the users on your system.
To enable
.B finger
on your system, do the following.
.PP
First, prepare a file in directory
.B $NETHOME/finger
for each user about whom you wish to release information.
Name the file after the user's login identifier plus the suffix
.BR .txt .
For example,
to release information about user
.BR fred ,
create file
.BR $NETHOME/finger/fred.txt .
You can put into that file anything that you like; presumably
it should describe that user, and not be slanderous.
.PP
Second, create file
\fB$NETHOME/finger/\fIhostname\fB.txt\fR, where
.I hostname
is the name of your local host.
This file should name all users on your system.
When a remote host tried to find the known users on your system,
it will be handed the contents of this file.
(You can also create a named pipe of this name,
and pump the output of the command
.BR who
through it.
For details on how to do this, see the entry for
.B "named pipe"
in the \*(CO Lexicon.)
.PP
Finally, invoke the
.B net
command
.BR "start finger" .
You can embed this in your startup script.
.PP
That's all there is to it.
Now, when someone accesses into your system via TCP/IP, she'll be able
to see information about selected users.

.NH "COHERENT X Games Disk"
.PP
The following describes the disk of X games that comes with your copy of
the \*(CO operating system and the X Window System.
It describes how to install the disk, and introduces each game.
.SH "System Requirements"
.PP
Before you install your X Games, please note the following:
.IP \(bu 0.3i
You must first have installed X Windows for \*(CO on your system.
X Windows is required for these games to link and run.
.IP \(bu
You must have at least ten megabytes of disk space free on the file
system that holds directory
.BR /usr/X11 .
If you are not sure whether you have enough disk space,
.B cd
to directory
.B /usr/X11
and type the command:
.DM
	df .
.DE
\*(CO will display the amount of free space, in blocks:
one block equals 512 bytes, or 0.5 kilobyte.
(For details, see the Lexicon entry for
.BR df .)
You must have at least 20,000 blocks free before you can install your
games disk.
If you do not, you must free up space before you can install.
.IP \(bu
These games require that you have eight megabytes of RAM on your system.
If you wish,
you can install the games disk even if you do not have eight megabytes of RAM,
but you will not be able to play any of the games.
.IP \(bu
Most of the games require that your screen have at least 800\(mu600 resolution.
Four (\fBxconq\fR,
.BR spider ,
.BR xmahjongg ,
and
.BR cbzone )
use a 1024\(mu768 screen by default, but are playable in 800\(mu600 if you
are patient.
For details on how to set and change resolution on your screen, see the
manual for X Windows for \*(CO.
.SH "Installing the Games"
.PP
To install the games, place the disk into your A floppy-disk drive
(either 3.5 inch or 5.25 inch).
Then log in as the superuser
.BR root .
If you have a 3.5-inch disk, type the command:
.DM
	/etc/install CohXGames /dev/fva0 1
.DE
If, on the other hand, you have a 5.25-inch disk, type the command:
.DM
	/etc/install CohXGames /dev/fha0 1
.DE
The
.B install
program will copy all of the files onto your hard disk, then ask you
whether you have installed X Windows, whether you have ten megabytes
of disk space free, and whether you have at least eight megabytes of RAM.
If you answer ``No'' to any of these questions, it aborts the installation.
You can install again later when the problem has been cleared up.
.PP
After
.B install
asks you its three questions, it proceeds to de-archive and link the games.
This will take approximately 15 minutes; of course, the actual time taken
depends upon how fast your system is and how much other activity is on it.
Should a problem occur,
.B install
aborts with an error message that describes the problem, so you can fix
it and try again.
.SH "The Games"
.PP
This games disk includes the following 12 games:
.IP \fBcbzone\fR
You guide a tank around a desert battle zone, and fight alien invaders
who have tanks, helicopters, landers, and cruise missiles.
The game features excellent animation.
It uses a 1024\(mu768 screen, but is usable on a 800\(mu600 screen.
.IP \fBspider\fR
Play two-deck solitaire.
This is a game of thought and strategy, rather than luck.
This game uses a 1024\(mu768 screen, although you can play it in 800\(mu600
mode by shifting the window back and forth.
.IP \fBsvb\fR
Spy vs. Bob:
Try to maneuver your spy to the top of a tall building, while dodging the
evil, pipe-smoking Bobs.
.IP \fBxchomp\fR
Race your little man through a maze while he is chased by ghosts.
It resembles the popular arcade game PacMan, but uses more than one maze.
.IP \fBxconq\fR
This is a game of long-term strategy.
You struggle against your computer to control the world,
by exploring, developing your economy, and waging war.
.IP \fBxhextris\fR
Like Tetris, except that the blocks are six-sided and the shapes more
numerous.
A game for those who like a challenge.
.IP \fBxlander\fR
Land your spacecraft on the Moon before you run out of fuel or crash.
.IP \fBxlife\fR
Play the Game of Life.
You can draw a pattern on the screen, then animate it:
as the game progresses, you can watch your pattern ``evolve'',
grow, develop, and die.
The game has numerous features, and comes with a library of shapes
that you can patch into your patterns to make them more interesting.
.IP \fBxmahjongg\fR
An implementation of the Chinese tile game, in solitaire mode.
The design of the tiles is quite attractive, and the game also lets you
devise your own formations.
This uses a 1024\(mu768 window, although you can play in 800\(mu600 by
moving the window around the screen.
.IP \fBxmandel\fR
Explore the Mandelbrot set and Julia sets.
.IP \fBxminesweep\fR
An X implementation of the game ``minesweeper'':
Try to deduce where the mines are hidden on a blank game board.
.IP \fBxpipeman\fR
Connect randomly selected sections of pipe, while staying ahead of
the flow of liquid.
.PP
Each game is described in its own manual page, which was installed
automatically from the games disk.
To read these, use the command
.BR man ;
for example, to read the manual page for the game
.BR xpipeman ,
type the command:
.DM
	man xpipeman
.DE
To print this manual page on a PostScript printer, type the command:
.DM
	man xpipeman | prps | lp
.DE
.SH "Playing the Games"
.PP
All of the games are installed into directory
.BR /usr/X11/bin .
If this directory is in your
.BR PATH ,
then all you have to do to play a game
start up X, as described in the \*(CO X Windows
manual; then type the name of the game into your
.B xvt
or
.B xterm
window.
It's that simple.
If you do not have these directories in your
.BR PATH ,
then prefix the name of the game with the path name of the directory
in which the game resides.
For details on
.BR PATH ,
see its entry in the \*(CO Lexicon.
.PP
When you become more experienced with X Windows, you probably will
want to modify the menus for your window manager, so you can invoke a game
without having to use a terminal window.
For details on how to do this, see the chapter on customizing X Windows in
your X Windows manual.
.SH "More X Packages"
.PP
Other X Windows packages are available from Mark Williams Company, or are
in preparation; we call these
.BR XWare .
These include a package of games, a package of graphics programs, a
package of window managers and fonts, and a package of X utilities and tools.
Every
.B XWare
package includes executables and full source code for every program it
includes.
.PP
Also under preparation is an X Developers' Package.
This will include tools to help you build an X application, and documentation
for the Xlib and Xt libraries.
.PP
For details on these and other Mark Williams products, telephone Mark
Williams Company, or send e-mail to sales@mwc.com.
.PP
We hope you enjoy your X games \(em and that you enjoy using the \*(CO system!

.ds VN 2
.sp 2.0i
.ll 5.75i
.po 1.5i
.vs 9
.ft RS
Copyright \(co 1994 by Mark Williams Company, Northbrook, Illinois.
.br
Copyright \(co 1994 by Ready-to-Run Software, Incorporated, Reading,
Massachusetts.
.sp
All rights reserved.
.sp
Portions of this manual are based on reference materials provided on the
X11 tape, which is copyrighted \(co 1985-1994 the Massachusetts Institute of
Technology, Cambridge, Massachusetts, and Digital Equipment Corporation,
Maynard, Massachusetts.
These materials are supplied under terms of its copyright, subject to the
following conditions:
.sp
.ll -1.0i
.po +0.5i
``Permission to use, copy, modify and distribute this documentation for
any purpose and without fee is hereby granted, provided that the above
copyright notice appears in all copies and that both the copyright notice
and this permission notice appear in supporting documentation, and that the
name of MIT or Digital not be used in advertising or publicity pertaining
to distribution of the software without specific, written prior permission.
MIT and Digital make no representations about the suitability of the
software described herein for any purpose.
It is provided `as is' without expressed or implied warranty.''
.sp
.po -0.5i
.ll +1.0i
This manual significantly rewrites much of the documentation supplied by
MIT and Digital, and has reformatted it for this publication.
These revisions and reformattings are
copyright \(co 1993,1994 by Mark Williams Company.
This manual shall not be copied, reproduced or duplicated
in whole or in part without the express written permission of Mark
Williams Company.
Mark Williams Company makes no warranty of any kind
with respect to this material and disclaims any implied warranties of
merchantability or fitness for any particular purpose.
.sp
The information contained herein is subject to change without notice.
.sp
COHERENT\(tm is a trademark of Mark Williams Company.
Microsoft Windows\(tm is a trademark of Microsoft Corporation.
UNIX\(tm is a trademark of Unix System Laboratories.
PostScript\(tm is a trademark of Adobe Systems Incorporated.
All other products are trademarks or registered
trademarks of the respective holders.
.sp
.ta 1.0i 2.25i 3.75i
	Revision \*(VN		Printing 5 4 3 2 1
.sp
Published by Mark Williams Company, 60 Revere Drive, Northbrook,
Illinois  60062.
.sp
.nf
.ta 0.5i 1.5i
Sales:	Phone:	(800) MARK-WMS
	FAX:	(708) 291-6750
	E-mail:	sales@mwc.com
Technical Support:
	Phone:	(708) 291-6700
	FAX:	(708) 291-6750
	E-mail:	support@mwc.com
.ta 1.0i
CompuServ:	76256,427
.sp
.fi
This manual was written under the COHERENT operating system, using the
MicroEMACS text editor.
Text formatting was performed by the
COHERENT edition of the \fBtroff\f(RS text formatter,
using its PostScript output function.
Capitals and ornaments are derived from the Golden Bible of Augsburg,
and were supplied in encapsulated PostScript form by BBL Typographic,
137 Narrow Neck Rd., Katoomba, NSW 2780, Australia.
The key-caps font was supplied by SoftMaker, Inc., 2195 Faraday Avenue,
Suite A, Carlsbad, CA 92008.
Page design was implemented with custom-written macros written in the
\fBtroff\f(RS text-formatting language and in PostScript.
Typesetting of this manual, from the table of contents
through the index, was performed by one script written in the COHERENT
Bourne shell.
Camera-ready copy was printed on a Hewlett-Packard LaserJet IIP printer
using the Pacific Page PostScript cartridge.
.bp

.ds TL "Additional Software"
.ds TI "RELEASE NOTES"
.NH "Additional Software for COHERENT"
.PP
Numerous software products are available for \*(CO.
These include industry-standard products, such as Lotus 1-2-3, WordPerfect,
Basmark QuickBASIC, the MBP Visual Cobol compiler, and many others.
.PP
You can order some of these packages through Mark Williams Company
by calling Mark Williams sales department at 1-800-636-6700 or 1-708-291-6700.
.PP
The \*(CO command
.B phone
comes with a ``phonebook'' that gives the names, telephone numbers, and
a brief description for many software vendors who sell software for \*(CO.
If you are looking for a particular item, check there first.
For example, if you are looking for implementations of the BASIC language
under \*(CO, type the command:
.DM
	phone BASIC
.DE
This prints on your screen the name and telephone number of each third-party
vendor who has published a version of BASIC \(em at least, that we knew about
when you purchased \*(CO.
.PP
Mark Williams Company also publishes products for \*(CO.
These include X Windows for \*(CO;
the five volumes of COHware, which give some the best of the
public-domain software for \*(CO;
the \*(CO Device-Driver Kit;
the \*(CO GNU Development Kit;
GNU Tools, a collection of GNU tools and utilities ported to \*(CO;
source code for GNU C and the GNU tools;
and GNU Emacs, a full implementation of the famous Emacs editor.
.PP
An order form is available at the back of these notes
for ordering the products produced by, or available through,
Mark Williams.
Or you can order by calling 1-800-636-6700, or 1-708-291-6700.
.PP
The following sections introduce the products available from Mark Williams
Company, and some of the third-party suppliers of software.
.SH "The COHERENT Club"
.PP
The \*(CO Club offers great savings on third-party software.
For a one-time payment of $49.95,
you can get significant discounts from Mark Williams Company
on such third-party software products as WordPerfect,
other \*(CO products sold by Mark Williams, and discounts on future
enhancements and updates to \*(CO.
The order form at the back of this booklet shows some of the discounts
you can receive.
.PP
To join, fill out the form at the end of these notes, or call Mark Williams
Company at 1-800-636-6700 or 1-708-291-6700.
.SH "X Windows for COHERENT"
.PP
Beginning with release 4.2, \*(CO supports the X Window System,
the industry-standard computer windowing system.
X Windows for \*(CO is Mark Williams port of X Windows.
With X Windows for \*(CO, you can open multiple windows on your screen,
and use icons, pop-up menus, graphics on your \*(CO system.
.PP
X Windows for \*(CO includes a generous selection of X utilities,
clients, and games.
It also includes libraries, header files, fonts, and bit-mapped images, so
you can begin to import the wealth of X applications that are now available
in the public domain.
.PP
X Windows for \*(CO, like all Mark Williams products, is reasonably priced,
and comes with full technical support.
Also included is a 200-page manual that introduces X Windows and documents
every utility, client, and game included in the package.
.PP
Note that X Windows for \*(CO requires eight megabytes of RAM,
a serial mouse, and a VGA video card and monitor.
.PP
To order X Windows for \*(CO, call 1-800-636-6700 or 1-708-291-6700,
or use the order form at the end of these notes.
.SH XWare
.PP
The X Window System has a wealth of software available for it.
To help make this software available to you under \*(CO,
Mark Williams Company offers
.BR Xware !
.PP
Each Xware package is a collection of carefully selected X programs.
Almost every program comes with both an executable binary and source
code, plus rewritten and formatted manual pages that you can read with
the \*(CO
.B man
command.
.PP
Six Xware packages are available to you:
.IP "\fBXware 1\fR: Window Managers"
This package offers the window managers \*(OL, from Sun Microsystems; and
.BR fvwm ,
a small, efficient window manager that looks like Motif.
Also included are several hundred fonts, to further improve the appearance
of your X environment.
.IP "\fBXware 2\fR: Games\fR"
This package is just for fun.
Battle deadly tanks, struggle with your computer for control of the world,
play Mah-Jongg and solitaire \(em all in the X Windows graphical environment.
.IP "\fBXware 3\fR: Graphics\fR"
This package offers a wealth of graphics programs for X.
View GIF files, display animations, model and display the evolution of
an imaginary planet, plug entertaining screen-savers into your system \(em
and much more.
Also included are a generous selection of GIF images from Project Apollo
and from the newly repaired Hubble Space Telescope.
.IP "\fBXware 4\fR: Tools and Utilities\fR"
This package assembles a number of helpful utilities.
Included are a powerful spreadsheet, including matrix algebra functions
and graphing; an interactive file manager;
utilities for attaching notes to your screen; tools for displaying system
load, and for viewing manual pages interactively; and more.
.IP "\fBXware 5\fR: Development Tools\fR"
This package offers Tcl, the hot new development language; and Tk,
a large collection of widgets and function that you can use interactively.
Also included are
.BR wish ,
the interactive shell built from Tcl and Tk; and
.BR xf ,
an interactive tool with which you can easily build X front ends for your
programs.
You can also use Tcl with your non-X programs.
.IP "\fBXware 6\fR: Ghostscript\fR"
With this package, you can display your PostScript files and clip art
directly within an X window, without having to print them.
Also included are drivers for a variety of output devices, including
a number of printers.
.PP
To order an Xware package, use the order form at the back of this booklet,
or call Mark Williams Company.
.SH "Introducing COHware"
.PP
The amount of contributed software appearing on our Bulletin Board System
is already much, much more than we ever imagined
it would be \(em and it keeps on growing.
You could go through the inconvenience and expense
of downloading the packages one by one via modem;
but we have come up with a better answer:
COHware!
.PP
Now the best of the contributed software from our BBS is available on
floppy disk.
Almost every program comes both compiled, and with its full source code.
You can use the programs as is, or you can modify them for your own
applications.
Don't waste your time on a problem that has already been solved
within one of these programs, and don't tie up your modem for hours on end.
COHware opens up the world of C programming under \*(UN \(em
take a look at how a sophisticated shell is built from the inside out \(em
find out how a text editor is written \(em all this and much
more can be found within COHware.
.PP
Volumes I and II of COHware were designed for \*(CO 286, with its
limited address space.
However, COHware volumes III, IV, and V are
filled with software that has been ported
to, or rewritten for, the \*(CO-386 32-bit addressing space.
It also holds many of the favorite programs that appeared in the first
two volumes.
.PP
.\"COHware volume III contains the following:
.\".so /v/fwb/coherent/rel.notes/coherent/coh4.2.10/contents.CW3.r
.\".PP
.\"COHware volume IV contains the following:
.\".so /v/fwb/coherent/rel.notes/coherent/coh4.2.10/contents.CW4.r
.\".PP
.\"COHware volume V contains the following:
.\".so /v/fwb/coherent/rel.notes/coherent/coh4.2.10/contents.CW5.r
.\".PP
You can order volume III of COHware for only $40;
and you can order volumes IV and V for only $49.
Use the order form in the catalogue, or call 1-800-636-6700 for
fast service.
Remember, if you are a member of the \*(CO Club, you will receive
a discount on these packages.
.SH "The COHERENT Device Driver Kit"
.PP
The
.B "COHERENT Device Driver Kit"
contains everything that an
experienced programmer needs to write a device driver for \*(CO,
including source code for almost every driver included with \*(CO.
The Kit brings a new level of support
for writing drivers and has greater detail than \*(UX versions.
.PP
Release 4.2.14 of the Kit documents the \*(CO implementation of
\*(ST, which now makes it easier than ever to write a device driver
for \*(CO, \*(UN, and any other operating system that supports \*(ST.
.PP
The Kit also includes full source code for
almost all device drivers shipped with the \*(CO system
(excluding only a few that use proprietary information from third-party
suppliers), including the following:
.nf
.sp \n(pDu
	Console driver
	Virtual consoles driver
	Keyboard drivers, both non-loadable and loadable
	Serial-port driver, including non-intelligent multi-port cards
	Parallel-port driver
	AT hard-disk driver
	Host-adapter-independent SCSI driver
	Floppy-disk driver
	Memory driver
.fi
.PP
Just reading the source code can be very helpful in learning how to cope
with real-world problems in writing device drivers for
multi-tasking environments like \*(CO and \*(UN.
These are supplemented in the manual by tutorials and a detailed example.
.PP
The price is right, too.
Like all Mark Williams software, our Device Driver Kit is very affordable.
Use the form at the end of this manual to order the
best value in driver kits.
.SH "GNU Tools"
.PP
Mark Williams Company has ported to \*(CO many of the GNU software tools,
from the Free Software Foundation.
.Sh "GNU Development System"
.PP
The GNU Development System packages a fine selection of GNU
software development tools:
.IP \(bu 0.3i
Release 2.5.6 of the GNU C compiler.
GNU C offers full support for the ANSI C standard,
plus numerous extensions and features not found in most C compilers.
.\" Including ours.
.IP \(bu
GNU implementation of the C++ and Objective C languages.
With these, you can explore the world of object-oriented programming.
.IP \(bu
GNU linker and assembler.
.IP \(bu
.BR gdb ,
the GNU source-level debugger.
With
.BR gdb ,
you can debug your C programs using your C code \(em you don't have to
resort to assembly language.
.B gdb
also works with the standard \*(CO C compiler.
.IP \(bu
.BR info ,
the advanced information command.
.B info
offers tutorials and thorough help information for all GNU tools.
.PP
With
.BR "GNU C" ,
you can begin to work with the wealth of source code available
through Free Software Foundation.
.Sh "GNU Tools"
.PP
Mark Williams offers
.BR "GNU Tools" ,
a set of tools from the Free Software Foundation.
These include the GNU versions of many \*(UN or \*(CO tools.
.Sh "GNU Sources"
.PP
Mark Williams also offers the
.BR "GNU Source Kit" .
This gives you full source code for the GNU C compiler and the GNU tools
in a ready-to-compile form.
With it, you can rebuild the GNU packages on your system
and study the design of this major piece of software.
NB, this kit requires that you have GNU C.
.Sh "GNU Emacs"
Finally, Mark Williams offers GNU Emacs, the full implementation of
the famous Emacs editor.
Users who have used \*(CO's version of the \*(ME editor have had a taste
of the power of this tool.
However, GNU Emacs is truly a programming environment, not just an editor.
It offers many features not available in \*(ME, including
the ability to write editor extensions in LISP.
.Sh "Ordering Information"
.PP
To order, use the form at the end of this pamphlet; or you can order by
calling 1-800-636-6700 or 1-708-291-6700.
.PP
We know how you value Mark Williams Company's commitment to user support.
However, because of the nature of these products, we cannot offer
technical support on the Device Driver Kit, COHware, GNU Tools, or GNU C.
.SH "Third-Party Software Packages for COHERENT 4.2"
.PP
What follows is a list of companies that have ported their
software to \*(CO, or whose software runs under \*(CO unchanged from
other \*(UN implementations.
Also listed are the names and a brief description of each product.
Please note that this list is growing all the time.
For the latest information on third-party products that run under \*(CO,
dial into the \*(CO bulletin board, or telephone Mark Williams Company.
.IP "\fBACC Corporation\fR"
.nf
SWiM 1.2.3, a port of OSF Motif to \*(CO
(203) 454-3242 (voice)
info@acc-corp.com
.fi
.IP "\fBAcucobol Inc.\fR"
.nf
Acucobol (COBOL compiler)
1-619-689-7220 (voice)
1-800-262-6585 (voice)
1-619-566-3071 (FAX)
.fi
.IP "\fBAppgen Business Software\fR"
.nf
Appgen (Accounting 4GL and RDBMS)
1-516-471-3200 (voice)
1-516-471-3291 (FAX)
.fi
.IP "\fBArosoft\fR"
.nf
ADFprofi (Office Automation and RDBMS, in German)
49-30-525-2150 (voice)
49-30-525-3461 (FAX)
.fi
.IP "\fB/ARX Cleanware\fR"
.nf
MacroCALC (Spreadsheet)
WindowSHell (User Interface)
Voice: ++49-9287/87446
FAX: ++49-9287/87232
.fi
.IP "\fBBasis International\fR"
.nf
BBxPROGRESSION/4 (BASIC compiler)
1-505-345-5232 (voice)
1-505-345-5082 (FAX)
.fi
.IP "\fBBasmark Corp.\fR"
.nf
QuickBASIC Compiler  (BASIC compiler, compatible with Microsoft BASIC)
1-216-621-7650 (voice)
1-216-621-7652 (FAX)
.fi
.IP "\fBBerkeley Decision/Systems\fR"
.nf
Shellware GLS (Accounting and bookkeeping)
1-408-458-9708 (voice)
1-408-458-2721 (FAX)
.fi
.IP "\fBBorland International\fR"
.nf
dBASE IV
408-438-8400 (voice)
.fi
.IP "\fBCamber Roth Caucus\fR"
.nf
Caucus Link (Groupware computer conferencing)
1-518-273-0983 (voice)
1-518-276-6380 (FAX)
.fi
.IP "\fBCentury Software\fR"
.nf
TERM (Communications and terminal-emulation package)
1-801-268-3088 (voice)
1-801-268-2772 (FAX)
.fi
.IP "\fBCET Software\fR"
.nf
CET BASIC (BASIC compiler)
1-206-883-8142 (voice)
1-206-885-5717 (FAX)
.fi
.IP "\fBCoconut Computing, Inc.\fR"
.nf
COCONET Server v4.0 (Conferencing and bulletin board package)
Cocotalk\(rg API C Library v2.0
CocoMedia\(tm v1.0 multimedia enhancements
1-619-456-2002 (voice)
1-619-456-1905 (FAX)
.fi
.IP "\fBComeau Computing\fR"
.nf
Comeau C++ 3.0 with Templates (C++ compiler)
1-718-945-0009 (voice)
1-718-441-2310 (FAX)
.fi
.IP "\fBCreative Programming\fR"
.nf
Vitamin C (User-interface builder)
1-214-245-9139 (voice)
1-214-245-9717 (FAX)
.fi
.IP "\fBCyberstore Online Information Systems, Inc.\fR"
.nf
Cyberstore (BBS package)
1-604-526-3373 (voice)
1-604-526-3373 (FAX)
.fi
.IP "\fBData Access\fR"
.nf
Dataflex (relational DBMS)
305-238-0012 (voice)
800-451-3539 (voice)
305-238-0017 (FAX)
.fi
.IP "\fBELMAS GmbH I. G.\fR"
.nf
LanguagePak 1 (Selected languages)
LanguagePak 2 (More language)
DeskPak (Edit and text formatting plus office automation)
OfficePak (Office automation)
TextPak (Editing and text formatting)
UtilityPak (\*(UN utilities)
CommPak (Communications utilities)
XPak (X utilities)
XtraPak (Additional X utilities)
FunPak (Games)
SourcePak (Source code)
49-303-936-784 (voice)
49-303-922-355 (FAX)
.fi
.IP "\fBFaircom Corporation\fR"
.nf
r-tree (RDBMS package)
c-tree (C interface to the r-tree DBMS)
1-314-445-6833 (voice)
1-314-445-9698 (FAX)
39-357-730-23 (European support)
.fi
.IP "\fBGimpel Software\fR"
.nf
FlexeLint 4.0 (Debugger and programming tool)
1-215-584-4261 (voice)
1-215-584-4261 (FAX)
.fi
.IP "\fBInformation Ink, Ltd.\fR"
.nf
Adaptive Software for the Disabled
1-718-278-8181 (voice)
1-718-278-8268 (FAX, Monday-Thursday, 10 PM-6 AM)
.fi
.IP "\fBInfoflex, Inc.\fR"
.nf
Infoflex and Accountflex (4GL and DBMS)
1-415-340-0220 (voice)
1-415-697-7696 (FAX)
.fi
.IP "\fBIntegration Technologies, Inc.\fR"
.nf
INTEK C++ (C/C++ compiler and programming package)
1-206-455-9935 (voice)
1-206-455-9935 (FAX)
.fi
.IP "\fBJust Logic Technologies\fR"
.nf
Just Logic/SQL (SQL DBMS)
1-514-642-6480 (voice)
1-514-642-6480 (FAX)
.fi
.IP "\fBLasermoon Ltd.\fR"
.nf
SWiM 1.2.3, a port of OSF Motif to \*(CO
(+44) 329 826444 (voice)
info@lasermoon.co.uk
.fi
.\".IP "\fBLiant Software\fR"
.\".nf
.\"RM/COBOL-85 RM/CO* RM/PANELS RM Companion (COBOL compiler)
.\"1-800-762-6265 (voice)
.\"1-512-343-1010 (voice)
.\"1-512-343-9487 (FAX)
.\".fi
.IP "\fBLotus Development Corporation\fR""
Lotus 1-2-3 for UNIX (Spreadsheet)
.fi
.IP "\fBmbp Software, Inc.\fR"
.nf
Visual Cobol (COBOL compiler)
1-800-231-6342 (voice, USA)
49-231-9441605 (voice, Germany)
1-510-769-4746 (voice, international)
1-510-769-5333 (FAX, USA)
1-510-769-5735 (FAX, USA)
49-231-9442413 (FAX, Germany)
.fi
.IP "\fBMMB Development Corporation\fR"
.nf
TEAMate (client-server BBS software)
310-318-1322 (voice)
310-318-2162 (FAX)
.fi
.IP "\fBMicro Focus\fR"
.nf
Micro Focus Cobol (COBOL compiler)
1-415-496-7215 (voice)
1-415-856-6134 (FAX)
.fi
.IP "\fBMicroEdge Inc.\fR"
.nf
SlickEdit (Configurable editor)
1-800-934-3348 (voice)
1-919-790-1691 (FAX)
1-919-872-5586 (FAX)
.fi
.IP "\fBMicroway\fR"
.nf
Microway Pascal Compiler for \*(CO
1-508-746-7341
.fi
.IP "\fBMultisoft Datentechnik GMBH\fR"
.nf
Flagship (Clipper-like data-base management system)
+49-89-641-7904 (voice)
+49-89-641-2974 (FAX)
303-699-5736 (U.S. agent)
.fi
.IP "\fBOn Top Systems\fR"
.nf
di-ogix  (DBMS and spreadsheet)
1-708-271-0200 (voice)
1-708-271-0206 (FAX)
.fi
.IP "\fBOpen Systems, Inc.\fR"
.nf
Open Systems Accounting Software
1-612-829-0011 (voice)
1-612-829-1493 (FAX)
.fi
.IP "\fBPacific Micro\fR"
.nf
Common-Link (COHERENT/UNIX-DOS-MAC file-transfer utility)
1-415-948-6200 (voice)
1-415-948-6296 (FAX)
.fi
.IP "\fBPacific Software Group\fR"
.nf
Task Manager for UNIX (desktop organizer, productivity software)
909-681-2623 (voice)
.fi
.IP "\fBPRO-C Limited\fR"
.nf
PRO-C Lite (RDBMS C development library)
1-519-725-5143 (voice)
1-519-725-5143 (FAX)
.fi
.IP "\fBPromula\fR"
.nf
Promula Fortran Compiler and FORTRAN to C Translator
1-614-263-5454 (voice)
1-614-263-5573 (FAX)
.fi
.IP "\fBRaima Corp.\fR"
.nf
Raima Data Manager (RDM) (RDBMS and development tool)
206-747-5570 (voice)
206-747-1991 (FAX)
.fi
.IP "\fBRasmussen Software, Inc.\fR"
.nf
ICE (Intelligent COBOL editor)
503-624-0360 (voice)
503-624-0760 (FAX)
.fi
.IP "\fBRevolutionary Software\fR"
.nf
/rdb (RDBMS package)
408-429-6229 (voice)
408-427-0342 (FAX)
.fi
.IP "\fBRoundhill Computer Systems\fR"
.nf
PANEL Plus II (User-interface library)
44-672-84535 (voice)
1-708-690-3737 (voice, USA)
44-672-84525 (FAX)
1-708-665-9841 (FAX, USA)
.fi
.IP "\fBRSYS\fR"
.nf
R Word, RO Plus, RW Plus (Word processors)
1-214-343-9210 (voice)
1-214-343-9218 (FAX)
.fi
.IP "\fBSan Souci Consulting\fR"
.nf
COM/MENT (Fully configurable BBS package)
1-805-327-1172 (voice)
1-805-327-9299 (FAX)
.fi
.IP "\fBSCS Compute Inc.\fR"
.nf
Tax Machine (Tax preparation and accounting package)
1-206-643-2050 (voice)
1-206-562-1783 (FAX)
.fi
.IP "\fBSequiter Software\fR"
.nf
CodeBase 5.0 (C-Language DBMS package)
1-403-437-2410 (voice)
1-403-436-2999 (FAX)
.fi
.IP "\fBSINC Inc.\fR"
.nf
Flex Gen Cobol 4GL (4GL, data base, and code generator)
1-513-438-5553 (voice)
1-513-438-5377 (FAX)
.fi
.IP "\fBSoftfocus\fR"
.nf
BTree/ISAM (File-Access and DBMS package)
1-416-825-0903 (voice)
1-416-825-1025 (FAX)
.fi
.IP "\fBSovereign Technologies\fR"
.nf
Cu/Extended V2.1 (Communications package)
1-800-428-1272 (voice)
.fi
.IP "\fBSynergetic Data Systems\fR"
.nf
Filix (Flat-file DBMS)
Filix General (Report Writer)
1-800-446-7374 (voice)
1-916-933-0120 (voice)
1-916-933-5793 (FZX)
.fi
.IP "\fBSyntactics\fR"
.nf
Crystal Writer Plus (Word processor)
1-408-727-6400 (voice)
1-408-727-0309 (FAX)
.fi
.IP "\fBThe Case Group\fR"
.nf
PC Curses Formation Desktop (User-interface tool)
1-615-352-2146 (voice)
.fi
.IP "\fBThe Small Computer Company\fR"
.nf
filePro (RDBMS)
1-914-769-3160 (voice)
1-914-769-3653 (FAX)
.fi
.IP "\fBThinking Software\fR"
.nf
ROTA (Office automation and scheduling package)
44-993-824-144 (voice)
44-993-823-629 (FAX)
.fi
.IP "\fBThoroughbred\fR"
.nf
Basic Word Query-IV Idol-IV Report-IV Solution-IV
1-908-560-1377 (voice)
1-908-560-1377 (FAX)
.fi
.IP "\fBTrueBASIC Inc.\fR"
.nf
TrueBASIC for \*(CO (BASIC compiler)
1-603-298-8517 (voice)
1-603-298-8517 (FAX)
.fi
.IP "\fBUniCache Systems\fR"
.nf
RealWorld Accounting & Public Safety Software
1-815-968-8026 (voice)
.fi
.IP "\fBUniTrends Software Corp.\fR"
.nf
CTAR (Backup and archiving utility)
1-803-626-2878 (voice)
1-803-626-5202 (FAX)
.fi
.IP "\fBUS Robotics\fR"
.nf
BLAST 10.7.2 (Communications package and terminal emulation)
1-708-933-5561 (voice)
1-708-982-5235 (FAX)
.fi
.IP "\fBVermont Creative Software\fR"
.nf
Vermont Views 3.05 (User-interface library)
1-802-848-7731 (voice)
1-802-848-3502 (FAX)
.fi
.IP "\fBVersasoft Corp.\fR"
.nf
dBMAN V (DBMS, clone of dBASE III Plus)
1-408-723-9044 (voice)
1-408-723-9046 (FAX)
.fi
.IP "\fBWild Hare Computer Systems Inc.\fR"
.nf
Axis Choice HareStylist VS COBOL/INFOS (COBOL compiler)
1-303-530-2221 (voice)
1-303-530-9637 (FAX)
.IP "\fBWordPerfect Corporation\fR"
.nf
WordPerfect for UNIX 5.1 (Word processor)
.fi
.IP "\fBZ/MAX Computer Solutions\fR"
.nf
Z/MAX XChange (BBS package)
1-315-635-1882 (voice)
1-315-635-1908 (FAX)
sales@zmax.xom
.fi
.SH "Freeware and Shareware via Phone"
.PP
Freeware and share is available from the Internet and from the Mark Williams
bulletin board (MWC BBS).
The following introduce these sources, and how you can get access to them.
.Sh "Software from the Internet"
.PP
System
.B silver.cstpl.com.au
maintains an archive of public-domain and shareware software that has been
ported to \*(CO.
You can access this site via the Internet and download
software for the price of the connection.
.PP
To access
.BR silver ,
you must have access to a system that connects to the Internet via TCP/IP.
When you log into this system, type:
.DM
	ftp silver.cstpl.com.au
.DE
.PP
All files are under the directory
.BR /coherent .
.Sh "The Mark Williams Bulletin Board"
.PP
Mark Williams Company has set up a \*(CO \*(UU node for dial-up
use by our customers.
.PP
Before you try to access the MWC BBS, note that you
.I must
use \*(UU.
You cannot use
.BR ckermit ,
.BR Procomm ,
or any other communications utility.
.PP
Before you proceed, please review the tutorial on \*(UU in the \*(CO manual.
It includes a tutorial on this powerful utility and uses
.B mwcbbs
throughout it.
In most cases, the tutorial gives you all the information you need.
.PP
You can access
.B mwcbbs
through the following three telephone numbers:
.DS
.ta 0.5i 3.5i
	1200/2400-baud generic modem:	559-0412
	9600-baud Trailblazer modem:	559-0445
	9600-baud V.32 or HST modem:	559-0452
.DE
.PP
Once you have succeeded in contacting
.BR mwcbbs ,
you can begin to exchange files.
.PP
For your initial contact with \fBmwcbbs\fR, we recommend that you download
the introductory message \fBhowto.start\fR from directory
.BR /usr/spool/uucppublic/mwcnews .
For example, the command:
.DM
	uucp  -r mwcbbs!/usr/spool/uucppublic/mwcnews/howto.start  /tmp
.DE
queues up a request to copy file \fBhowto.start\fR into directory
.B /tmp
on your system.
This file contains information on available downloads, new \*(CO
developments, and how to obtain an individual account on the system.
If the time at which you type the \fBuucp\fR command is within the range
of times allowed in the entry for
.B mwcbbs
in
.BR /usr/lib/uucp/sys ,
your modem will call
.B mwcbbs
immediately \(em you can check this with the commands
.B ps
or
.BR uulog .
If you wish to force polling of mwcbbs at a time not specified in
.BR /usr/lib/uucp/sys ,
you can do so with the command:
.DM
	su uucp /usr/lib/uucp/uucico -Smwcbbs  &
.DE
You can then monitor the progress of the transfer via the command:
.DM
	uulog -f mwcbbs
.DE
To stop monitoring the call, type
.BR <ctrl-C> .
.\".Sh "Electronic Mail Access"
.\".PP
.\"The following electronic mail addresses are available to customers.
.\".PP
.\"For issues relating to administration of the BBS node, send mail to
.\".BR mwcbbs!admin .
.\".PP
.\"For matters relating to support of \*(CO and related
.\"products, send mail to
.\".BR mwcbbs!support .
.\".PP
.\"Additional mail aliases may appear from time to time.
.\"Please remember that mail sent to either of the aforementioned addresses
.\"will be sent to \fBmwcbbs\fR only when you invoke
.\".BR uucico .
.\"You can do this interactively from the \*(CO shell,
.\"as shown in the example above, or at regular intervals as a \fBcron\fR task.
.\"The following gives a sample line for your
.\".B cron
.\"file:
.\".DM
.\"	15 20 * * * su uucp /usr/lib/uucp/uucico -smwcbbs
.\".DE
.\"This line will check every day at 8:15 PM for
.\".B uucp
.\"and
.\".B mail
.\"requests which have been queued for
.\".BR mwcbbs ,
.\"and, if any are found, will call \fBmwcbbs\fR.
.\"See the Lexicon article
.\".B cron
.\"for further information.
.\".PP
.\"Please note that while the BBS supports inbound electronic mail from
.\"your system to
.\".B mwcbbs
.\"via anonymous \*(UU,
.\"we cannot reply to your electronic mail messages unless
.\"you have an account on
.\".BR mwcbbs .
.\"To request an account on
.\".BR mwcbbs ,
.\"download the file
.\".B howto.start
.\"from directory
.\".B /usr/spool/uucppublic/mwcnews
.\"on
.\".BR mwcbbs ,
.\"and follow its directions.
.\".SH "On-Line Services"
.\".PP
.\"You can talk with fellow \*(CO users and Mark Williams developers
.\"both through the Internet and CompuServe.
.\".Sh "Internet News Group"
.\".PP
.\"The Internet news group
.\".B comp.os.coherent
.\"presents an on-going discussion of issues that relate
.\"to the \*(CO operating system.
.\"These include technical issues, requests for information, discussions
.\"of new \*(CO-related products, and other useful \(em and occasionally
.\"entertaining \(em exchanges from \*(CO users around the world.
.\".PP
.\"To participate, you must have a news feed from the Internet.
.\"As the administrator of the site from which you receive your feed to
.\"sign you up for
.\".BR comp.os.coherent .
.\"To post a message, either use your news software or
.\"send mail to \fBcoherent@vma.cc.nd.edu\fR.

.ds TL "Hardware"
.NH "Compatibility Information"
.PP
It is impossible for Mark Williams Company to test more than
a small fraction of the many computers, controllers, BIOSes, disks,
and other devices that purport to be compatible with the IBM PC.
The \*(CO system has been installed on tens of thousands of computers
throughout the world, and we have received reports from many of
our customers who have successfully installed and run \*(CO on
their systems (as well as from the few who could not do so).
.PP
This section names the machines, add-on cards, and BIOSes
that have been reported either to work or not to work
with the \*(CO operating system.
.PP
Before you continue, please note the following caveats:
.PP
First, this is only a partial list of the hardware on which \*(CO runs.
We receive confirmation of new machine configurations almost daily.
If you believe that you have a machine, BIOS, or add-on board that
is \fBnot\fR compatible with \*(CO but is listed below,
please telephone our technical support department.
.PP
Second, manufacturers change their hardware as part of redesign or
product improvement.
These changes can include logic, timing, firmware, or functionality.
Although we do try to support tested
products, Mark Williams Company cannot guarantee compatibility
with products not under its control.
.PP
If you believe that your computer cannot run \*(CO,
please contact the Mark Williams Company technical support department.
\fIIf you do not find your machine in this section, that does not mean
that it will not run \*(CO; odds are that it will.\fR
Whatever happens, please contact Mark Williams Company and
let us know what happened, so we can make your experience available
to future users of \*(CO.
.SH "Compatible Systems"
.PP
The following 386/486 systems have been tested, and have
been found to have been compatible with \*(CO.
Note that configurations vary, especially with respect to disk controllers,
so not all possible configurations have been tested.
.nf
.sp \n(pDu
.ta 3.5i
ACROS 325SE Notebook	ALR PowerFlex, 386SX, 386/220
ALR VEISA Tower 486/33	AMI 386SX, 386
Arche 386/25	AST NB4/25s
AST Premium 386/33	AST Premium 486/33E (EISA)	
AT&T 6386	Austin 386SX, 386/33
AUVA VIP, 300, 350/25	Bitwise 33-386 Portable
Cheetah International i486/25	Compaq 386, 386 Portable
CompuAdd 320, 325	Compudyne 386
Computer Directions 386SX	Comtex 386/20
Dataworld 386	Dell System 300, 310, 325
Dyna 386/20	EDP 386SX
EPS 386	Five Star 386/20
Gateway 2000 (RLL and ESDI)	Gateway 486, 33MHz (IDE)
GCH 386 AT	Giga-Byte 386-33
Hauppauge 386	Intel 301
Jameco 3550	JDR M386
Leading Edge 386, D3	Leading Technology 386SX
Logix 386-25	MAXAR 386
Micro-1 386	Micro-Designs 386, 25MHz
Micro Express 386	Micronics 386
Micronics 386SX	Mitsubishi 386
Mitsubishi MAXY 386NOTE	MTEK MS-35, MS-37, MS-41
MYLEX MAE486, 33 MHz EISA	MYLEX MNE486, 33 MHz EISA
MYLEX MWS386, 25 MHz ISA	MYLEX MTX386, 16/20 MHz ISA
MYLEX MTI386, 25/33 MHz ISA	NCR 386	NEC 386/25, Powermate 386/20, 386SX
Northgate 386/16, 486	Northgate Elegance 386/25 ISA
Northgate Elegance 433e EISA	Novex 386
Olivetti M380	Omega 386/20
Opti 486 WB, 493 chipset motherboard	Optima 386
Packard Bell 610, Axcel 386SX	PC Brand 386/20, 386/25
PC Pros 486	PC Systems 386-20
Philips P3302	Pulse 386-SX
SEFCO 16 MHz 386SX	Smart Micro 386
Solution 386	Standard Brands 386-25, 386/SX
Sunnytech 386-20	Sys Technologies 386
Tandon 386/20, 386/33	Tandy 4000DX, 4000SX
Tera-Tek 386	Texas Instruments Notebook
Tri-Star 386	Unibit DS316
UTI 386	Victor 386, V386S
Wyse 3216	Zenith Mastersport 386SL
Zenith TurboSport 386, 386/33	ZEOS 386, 386SX, 386 Portable
ZEOS Notebook 386SX
.fi
.SH "Compatible Serial Cards"
.PP
The \*(CO driver
.B asy
supports up to 32 devices (i.e., serial ports) using the same card and driver.
This lets \*(CO support a wealth of serial cards.
The following serial cards, both intelligent and dumb, have been tested with
\*(CO and have been found to work.
.nf
.sp \n(pDu
.ta 3.5i
Applied Digital SIO4
Arnet Multiport 4/8
Arnet TwinPort 2
Bocaboard BB1008
Comtrol Hostess 550 08
Comtrol Hostess 550 16
Connect Tech DFlex-4/8 serial card
Digiboard PC/16 serial card
DigiCHANNEL PC/X	
Gtek PCSS-8TX serial card
Sea Level Systems Turbo Comm+2/4/8 serial card
SEFCO serial adapter
Sritek FastCom
Sritek FastCom Plus
Stargate Plus 8 serial card
.fi
.SH "Compatible Disk Controllers and Drives"
.PP
\*(CO supports a variety of disk controllers and drives,
in a variety of formats.
The following controllers and drives
have been tested with \*(CO and have been found to work.
.nf
.sp \n(pDu
.ta 3.5i
Adaptec AHA-1540A SCSI Host Adapter
Adaptec AHA-1542A SCSI Host Adapter
Adaptec AHA-1540B SCSI Host Adapter
Adaptec AHA-1542B SCSI Host Adapter
Adaptec AHA-1542C SCSI Host Adapter
ADD Adaptec AHA-174X SCSI Host Adapter (when jumpered to 154X mode)
Adaptec 2372B RLL Controller
Adaptec 2372C RLL 1:1 Controller
AMI SCSI FAST Controller (100% Adaptec 154X compatible)
Bustek SCSI Host Adapter (100% Adaptec 154X compatible)
Data Technology DTC7287 1:1 RLL 1:1
DPT Smart Cache Plus SCSI controller #PM2012B/90/95 (Western Digital emulation)
DPT Smart Connex SCSI Host Adapter (Western Digital  emulation)
DTK PTI-217 IDE HD/FD
Future Domain TMC-840/841/880/881 SCSI Host Adapter
Future Domain TMC-845/850/860/875/885 SCSI Host Adapter
Galaxy DC 600B Cache (alternate polling only)
Hedaka HED-827-02 IDE controller
Kalok KL3100 IDE drive
Maxtor 7080AT IDE hard-disk drive
Micropolis 1684-07 SCSI hard-disk drive
MYLEX DCE376DR EISA SCSI Adapter (WD emulation)
National Computer Ltd NDC545 MFM
Perstor PS180-16FN RLL disk
Seagate ST01, ST02 SCSI Host Adapter
Seagate ST-225, ST-4096 MFM disk
Seagate ST-4144 RLL disk
Seagate ST-296N SCSI disk
Ultrastore Ultra 12 ESDI
Western Digital 930xx series IDE hard disks
Western Digital Caviar 2200 IDE hard disks
Western Digital Piranha hard disks
Western Digital WD1006V-MM2 1:1 MFM
Western Digital WD1006V-SR2 1:1 RLL
Western Digital WD1007-WAH ESDI (feature level F001 with on-board BIOS)
Western Digital WD1007-WAH2 ESDI (feature level F003 with on-board BIOS)
.fi
.PP
Please note that for the DPT Caching ESDI Controller, you must use
alternate polling.
For details on alternate polling, see the chapter on installation in these
notes.
.SH "Compatible Tape Devices"
.PP
\*(CO works with the following tape devices:
.PP
Archive Viper 60, 150, 250, and 525 SCSI-tape drives.
Conner CS250Q, CS525Q, CS1350Q, CS2000DAT, and CS4000DAT drives.
Other SCSI-tape drives may work as well, but have not yet been tested.
(Please note that Archive/Maynard was purchased by Conner in 1993.)
.PP
QIC-40 and QIC-80 floppy-tape
drives from Colorado, Archive, Mountain, and Summit.
.SH "Compatible Video Cards"
.PP
\*(CO supports virtually all EGA, VGA, and SVGA video cards
in both standard and Local Bus versions.
Exceptions
are noted in the incompatible list.
Please note that this following applies
.I only
to \*(CO itself:
it does
.I not
applies to the X Window System, which at present supports
a much narrow range of video cards.
.PP
Video cards by the following manufacturers
have been tested with \*(CO, and have been found to work:
.nf
.sp \n(pDu
ATI
BOCA
BTC 1505 Monochrome Graphic Printer Card (does \fInot\fR work with X)
Diamond Speedstar (does \fInot\fR work with X)
DTK Graphicsmith
Genoa
Oak Technologies (does \fInot\fR work with X)
Orchid
Paradise
SEFCO monochrome adapter
Trident
Video 7
Western Digital
.fi
.SH "Compatible Peripherals"
.PP
The following peripheral devices have been tested with \*(CO and have
been found to work.
.nf
.sp \n(pDu
.ta 3.5i
Cherry keyboards
DTK PEI-301 32-bit memory expansion
Honeywell keyboards
IBM monochrome printer card
IBM keyboards
Keytronic KB101 PLUS keyboard
Linksys Parallel Link HLP-100
Linksys Parallel Link HPL-100
MicroSwitch keyboards
NMB Technologies keyboards
Northgate Omnikey 102 keyboard
Syquest SCSI removable cartridge disks
.fi
.SH "Compatible BIOS ROMs"
.PP
The following BIOS ROMs have been tested with \*(CO,
and have been found to be compatible.
.nf \n(pDu
.sp 
.ta 3.5i
AMI 386, 486
DTK 386
Mylex 386, 486
OPTI-Modular
PHOENIX 386, 486
PHOENIX 386SX
.fi
.PP
.I
Please note that the AMI 386 BIOS does not present a problem during
installation.
.R
However, due to a bug in the BIOS, certain versions of the AMI 386 BIOS
fail to reset the system correctly when you reboot your system by typing
.BR "<ctrl><alt><del>" .
If you have this BIOS,
press the \fB<reset>\fR button to reboot your system.
.PP
Certain releases of the AMI BIOS fail to correctly
reset the keyboard controller until after the memory test has completed.
On these systems,
you will not be able to prematurely exit from the memory test by using the
.B <Esc>
key, but you may be able to exit by using the
.B "<Num Lock>"
key.
.PP
Certain releases of the AMI 486 BIOS incorrectly diagnose
external cache memory as being bad after rebooting \*(CO via
.B /etc/reboot
or a
.B <ctrl><alt><del>
key sequence.
If your system exhibits these symptoms, press the
reset button to reboot your system.
.PP
Versions of the Award BIOS have an option to load the BIOS into RAM
at start-up.
Enabling this option causes the \*(CO installation to abort at the point
where it attempts to generate a new system.
You should disable this option and restart your system before you attempt
to install \*(CO.
.SH "Incompatible Hardware"
.PP
The following hardware is known \fInot\fP to work with this
release of \*(CO.
.nf
.sp \n(pDu
All mice that use a bus port rather than a COM port
All 8088-, 8086-, and 80286-based computers
All 80386DX-based computers that have a CPU chip labeled ``16-bit only''
ALR Venture 386SX Laptop \(em boot disk fails to install keyboard driver
American Multi-Source model 1004 MFM/RLL
Chicony 101B IDE adapter
Chicony keyboards (cannot be used with \fBnkb\fR loadable keyboard driver)
Dataworld 386/33 (video incompatibility)
Dataworld Laptop 386 model NM325SX (disk incompatibility)
DTK 386 machines
Fujitsu 2612ET IDE hard disk
Gateway NOMAD 425DXL (486 notebook)
IBM MicroChannel PS/1 and PS/2 computers
JETkey v3.0 Fasttest Keyboard BIOS (on some inexpensive clone motherboards)
Laser computers; they use the VTEK BIOS, which has problems associated with it
Microsoft InPort Mouse
Miniscribe IDE interface
NEC G8BUT ESDI disk controller; uses proprietary, on-board BIOS
NEC VGB video card; requires configuration for eight-bit transfer mode
OMTI 8620 disk controller
Orchid Privilege 386SX-16 motherboard
Western Digital 1004-27X, 1004-WX1, 1002 series
Western Digital XTGEN, XTGEN+, XTGEN-2, XTGEN-R
VTEK BIOS
XT (i.e., all eight-bit) disk controllers
Zenith Z449 video card (older versions cause panics)
.fi

.II "MicroEMACS^tutorial"
.II "me^tutorial"
.ds TL "MicroEMACS Screen Editor"
.NH "Introduction to MicroEMACS" 1
.PP
This section introduces \*(ME, the interactive screen editor
for \*(PN.
.SH "What is MicroEMACS?"
.PP
\*(ME is an interactive screen editor.
An \fIeditor\fR lets you type text into your computer,
name it, store it, and recall it later for editing.
\fIInteractive\fR means that \*(ME accepts an
editing command, executes it, displays the results for
you immediately, then waits for your next command.
\fIScreen\fR means that you can use nearly the
entire screen of your terminal as a writing surface:
you can move your cursor up, down, and around your
screen to create or change text, much as you move your
pen up, down, and around a piece of paper.
.PP
These features, plus the others that will be described in
the course of this tutorial, make \*(ME powerful yet easy to use.
You can use \*(ME to create or change computer programs
or any type of text file.
.PP
This version of \*(ME was developed by \*(MW from the public-domain
program written by David G. Conroy.
This tutorial is based on the descriptions in his essay
.IR "MicroEMACS: Reasonable Display Editing in Little Computers" .
\*(ME is derived from the mainframe display editor
EMACS, created by Richard Stallman.
.PP
For a summary of \*(ME and its commands, see the entry for
\fBme\fR in the Lexicon.
.SH "Keystrokes: <ctrl>, <esc>"
.PP
The \*(ME commands use \fBcontrol\fR characters and \fBmeta\fR characters.
Control characters use the \fIcontrol\fR key, which is marked \fBControl\fR
or \fBctrl\fR on your keyboard.
Meta characters
use the \fIescape\fR key, which is marked \fBEsc\fR.
.PP
.II "MicroEMACS^<ctrl>"
\fBControl\fR
works like the \fIshift\fR key:
you hold it down \fIwhile\fR you strike the other key.
This tutorial represent it with a hyphen; for
example, pressing the control key and the letter \*(QlX\*(Qr
key simultaneously will be shown as follows:
.DM
	<ctrl-X>
.DE
The \fBesc\fR key, on the other hand, works like an ordinary character.
You strike it first, \fIthen\fR strike the letter character you want.
This tutorial does \fInot\fR represent the
\fIEscape\fR codes with a hyphen; for example, it represents
\fBescape X\fR as:
.DM
	<esc>X
.DE
.SH "Becoming Acquainted with MicroEMACS"
.PP
Now you are ready for a few simple exercises that will help
you get a feel for how \*(ME works.
.PP
To begin, type the following command to \*(OS:
.DM
	me sample
.DE
Within a few seconds, your screen will have been cleared of writing,
the cursor will be positioned in the upper left-hand corner of
the screen, and a command line will appear at the bottom of your
screen.
.PP
Now type the following text.
If you make a mistake, just backspace over it and
retype the text.
Press the carriage return or enter key
after each line:
.DM
	main()
	{
		printf("Hello, world!\en");
	}
.DE
Notice how the text appeared on the screen character by character
as you typed it, much as it would appear on a piece
of paper if you were using a typewriter.
.PP
Now, type
\fB<ctrl-X><ctrl-S>\fR;
that is, type \fB<ctrl-X>\fR,
and then type \fB<ctrl-S>\fR.
It does not matter whether you type capital or lower-case letters.
Notice that this message has appeared at the bottom of your
screen:
.DM
	[Wrote 4 lines]
.DE
This command has permanently stored, or \fIsaved\fR, what you
typed into a file named \fBsample\fR.
.PP
Type the next few commands, which demonstrate some of the tasks that
\*(ME can perform for you.
These commands will be explained in full in the sections
that follow; for now, try them to get a feel
for how \*(ME works.
.PP
Type \fB<esc><\fR.
Be sure that you type a less-than symbol
\&\*(Ql<\*(Qr, which on most keyboards
is located just above the comma.
Notice that the cursor has returned to the upper left-hand corner
of the screen.
Type \fB<esc>F\fR.
The cursor has jumped forward by one word, and is now on the left parenthesis.
.PP
Type \fB<ctrl-N>\fR.
Notice that the cursor has jumped to the next line, and is now
just to the right of the left brace \*(Ql\fB{\fR\*(Qr.
.PP
Type \fB<ctrl-A>\fR.
The cursor has jumped to the \fIbeginning\fR of the second line of your text.
.PP
Type \fB<ctrl-N>\fR again.
Now the cursor is at the beginning of the
third line of the program, the \fBprintf\fR statement.
.PP
Now, type \fB<ctrl-K>\fR.
The third line of text has disappeared, leaving an empty space.
Type \fB<ctrl-K>\fR again.
The empty space where the third line of text had been has now
disappeared.
.PP
Type \fB<esc>>\fR.
Be sure to type a greater-than symbol
\&\*(Ql>\*(Qr, which on most keyboards is just above the period.
The cursor has jumped to the space just below the last line of text.
Now type \fB<ctrl-Y>\fR.
The text that you erased a moment ago has reappeared, but in a
new position on the screen.
.PP
By now, you should be feeling more at ease with typing
\*(ME's \fIcontrol\fR and \fIescape\fR codes.
The following sections will explain what these commands mean.
For now, exit from \*(ME by typing \fB<ctrl-X><ctrl-C>\fR, and
when the message
.DM
	Quit [y/n]?
.DE
appears type \fBy\fR and then \fB<return>\fR.
This will return you to the shell.
.Sh "Beginning a Document"
.PP
This tutorial practices on file \fBexample1.c\fR,
\fBexample2.c\fR, and \fBexample3.c\fR.
They are stored in the directory \fB/usr/src/example\fR.
Before beginning, type the following commands to copy these files
into the current directory and change their permissions:
.DM
	cp /usr/src/sample/example?.c .
	chmod +w example?.c
.DE
Now, type the following command to invoke \*(ME:
.DM
	me example1.c
.DE
In a moment, the following text will appear on your screen:
.B1
.ta 0.4i 0.8i 1.2i 2.5i
	/*
	 * This is a simple C program that computes the results
	 * of three different rates of inflation over the
	 * span of ten years.  Use this text file to learn
	 * how to use MicroEMACS commands
	 * to make creating and editing text files quick,
	 * efficient and easy.
	 */
	#include <stdio.h>
	main()
	{
		int i;		/* count ten years */
		float w1, w2, w3;	/* three inflated quantities */
		char  *msg = " %2d\et%f %f %f\en";	/* printf string */
		i = 0;
		w1 = 1.0;
		w2 = 1.0;
		w3 = 1.0;
		for (i = 1; i<= 10; i++) {
			w1 *= 1.07;	/* apply inflation */
			w2 *= 1.08;
			w3 *= 1.10;
			printf (msg, i, w1, w2, w3);
		}
	}
.B2
.sp \n(pDu
When you invoke \*(ME, it \fIcopies\fR that file into memory.
Your cursor also moved to the upper left-hand corner of the screen.
At the bottom of the screen appears the \fIstatus line\fR, as follows:
.DM

-- Coherent MicroEMACS -- example1.c -- File: example1.c --
.sp \n(pDu
.DE
The word to the left, \*(ME, is the name of the editor.
The word in the center, \fBexample1.c\fR, is the name of the \fIbuffer\fR
that you are using.
(We will describe later just what a buffer is and how you use it.)
The name to the right is the name of the text file that you are editing.
.SH "Moving the Cursor"
.PP
.II "MicroEMACS^backspace key"
.II "MicroEMACS^<return>"
.II "MicroEMACS^arrow keys"
Now that you have read a text file into memory, you are ready to edit it.
The first step is to learn to move the cursor.
.PP
Try these commands for yourself as we described them.
That way, you will quickly acquire a feel for handling \*(ME's commands.
.II "MicroEMACS^movement commands"
.II "MicroEMACS^cursor movement display"
.Sh "Moving the Cursor Forward"
.PP
.II "MicroEMACS^<ctrl-F>"
.II "MicroEMACS^<esc>F"
.II "MicroEMACS^<ctrl-E>"
.II "MicroEMACS^right"
.II "MicroEMACS^forward, one space"
.II "MicroEMACS^forward, one word"
.II "MicroEMACS^forward, end of line"
This first set of commands moves the cursor forward:
.DS
.ta 0.5i 1.5i
	\fB<ctrl-F>\fR	Move forward one space
	\fB<esc>F\fR	Move forward one word
	\fB<ctrl-E>\fR	Move to end of line
.DE
To see how these commands work, do the following:
Type the \fIforward\fR command \fB<ctrl-F>\fR.
As before, it does not matter whether the letter \*(Ql\fBF\fR\*(Qr is
upper case or lower case.
The cursor has moved one space to the right, and now is over
the character \*(Ql\fB*\fR\*(Qr in the first line.
.PP
Type \fB<esc>F\fR.
The cursor has moved one \fIword\fR to the right,
and is now over the space after the word \fBThis\fR.
\*(ME considers only alphanumeric characters when it moves from word to word.
Therefore, the cursor moved from under the \fB*\fR to the space
after the word \fBThis\fR, rather than to the space after the \fB*\fR.
Now type the \fIend of line\fR command \fB<ctrl-E>\fR.
The cursor has jumped to the end of the line and is now
just to the right of the \fBs\fR of the word \fBresults\fR.
.Sh "Moving the Cursor Backwards"
.PP
.II "MicroEMACS^<ctrl-B>"
.II "MicroEMACS^<esc>B"
.II "MicroEMACS^<ctrl-A>"
.II "MicroEMACS^back"
.II "MicroEMACS^left"
.II "MicroEMACS^backward, one space"
.II "MicroEMACS^backward, one word"
.II "MicroEMACS^backward, end of line"
The following summarizes the commands for moving the
cursor backwards:
.DS
.ta .5i 1.5i
	\fB<ctrl-B>\fR	Move back one space
	\fB<esc>B\fR	Move back one word
	\fB<ctrl-A>\fR	Move to beginning of line
.DE
To see how these work, first type the \fIbackward\fR command \fB<ctrl-B>\fR.
As you can see, the cursor has moved one space to the left,
and now is over the letter \fBe\fR of the word \fBthree\fR.
Type \fB<esc>B\fR.
The cursor has moved one \fIword\fR to the left and now
is over the \fBt\fR in \fBthree\fR.
Type \fB<esc>B\fR again, and the cursor will be positioned on the \fBo\fR in
\fBof\fR.
.PP
Type the \fIbeginning of line\fR command \fB<ctrl-A>\fR.
The cursor jumps to the beginnning of the line,
and once again is resting over the \*(Ql\fB/\fR\*(Qr character
in the first line.
.Sh "From Line to Line"
.PP
.II "MicroEMACS^<ctrl-N>"
.II "MicroEMACS^next line"
.DS
.ta .5i 1.5i
	\fB<ctrl-P>\fR	Move to previous line
	\fB<ctrl-N>\fR	Move to next line
.DE
These two commands move the cursor up and down the screen.
Type the \fInext line\fR command \fB<ctrl-N>\fR.
The cursor jumps
to the space before the \*(Ql\fB*\fR\*(Qr in the next line.
Type the \fIend of line\fR command \fB<ctrl-E>\fR, and the cursor moves
to the end of the second line to the right of the period.
.PP
.II "MicroEMACS^line position"
Continue to type \fB<ctrl-N>\fR until the cursor reaches the
bottom of the screen.
As you reached the first line in your text, the
cursor jumped from its position at the right of the period
on the second line to just right of the
brace on the last line of the file.
When you move your cursor up or down the screen, \*(ME
tries to keep it at the same position within each line.
If the line to which you are moving the cursor is not long enough
to have a character at that position,
\*(ME moves the cursor to the end of the line.
.PP
.II "MicroEMACS^previous line"
.II "MicroEMACS^<ctrl-P>"
Now, practice moving the cursor back up the screen.
Type the \fIprevious line\fR command \fB<ctrl-P>\fR.
When the cursor jumped to the previous
line, it retained its position at the end of the line.
\*(ME remembers the cursor's position on the line,
and returns the cursor there when it jumps to a line
long enough to have a character in that position.
.PP
Continue pressing \fB<ctrl-P>\fR.
The cursor will move up the screen until it reaches the top of your text.
.Sh "Repetitive Motion"
.PP
.II "MicroEMACS^repetition"
Some computers repeat a command automatically
if you \fIhold down\fR the control key and the character key.
Try holding down \fB<ctrl-N>\fR for a moment,
and see if it repeats automatically.
If it does, that will speed moving your cursor around the screen,
because you will not have to type the same command repeatedly.
.Sh "Moving Up and Down by a Screenful of Text"
.PP  
.II "MicroEMACS^screen up"
.II "MicroEMACS^screen down"
The next two cursor movement commands allow you to roll forward
or backwards by one screenful of text.
.DS
.ta .5i 1.5i
	\fB<ctrl-V>\fR	Move forward one screen
	\fB<esc>V\fR	Move back one screen
.DE
If you are editing a file with \*(ME that is too big
to be displayed on your screen all at once, \*(ME
displays the file in screen-sized portions
(on most terminals, 22 lines at a time).
The \fIview\fR commands \fB<ctrl-V>\fR and \fB<esc>V\fR allow you
to roll up or down one screenful of text at a time.
.PP
.II "MicroEMACS^<ctrl-V>"
Type \fB<ctrl-V>\fR.
Your screen now contains only the last three lines of the file.
This is because you have rolled forward by the equivalent of one
screenful of text, or 22 lines.
.PP
.II "MicroEMACS^<esc>V"
Now, type \fB<esc>V\fR.
Notice that your text rolls back onto the screen, and your
cursor is positioned in the upper left-hand corner of the
screen, over the character \*(Ql\fB/\fR\*(Qr in the first line.
.Sh "Moving to Beginning or End of Text"
.PP
.II "MicroEMACS^end of text"
.II "MicroEMACS^<esc>>"
These last two cursor movement commands allow you to jump immediately
to the beginning or end of your text.
.DS
.ta .5i 1.5i
	\fB<esc><\fR	Move to beginning of text
	\fB<esc>>\fR	Move to end of text
.DE
The \fIend of text\fR command \fB<esc>>\fR moves the cursor to the
end of your text.
Type \fB<esc>>\fR.
Be sure to type a greater-than symbol \*(Ql>\*(Qr.
Your cursor has jumped to the end of your text.
.PP
.II "MicroEMACS^beginning of text"
.II "MicroEMACS^<esc><"
The \fIbeginning of text\fR command \fB<esc><\fR will move the cursor
back to the beginning of your text.
Type \fB<esc><\fR.
Be sure to type a less-than symbol 
\*(Ql<\*(Qr.
The cursor has jumped back to the upper left-hand corner
of your screen.
.PP
These commands move you immediately to the beginning or the end
of your text, regardless of whether the text is one page or 20
pages long.
.Sh "Saving Text and Quitting"
.PP
.II "MicroEMACS^<ctrl-X><ctrl-C>"
.II "MicroEMACS^quit"
.II "MicroEMACS^saving text"
.II "MicroEMACS^<ctrl-X><ctrl-S>"
If you do not wish to continue working at this time,
you should \fIsave\fR your text, and then \fIquit\fR.
.PP
It is good practice to save your text file every so often while you
are working on it.
If an accident occurs, such as a power failure,
you will not lose all of your work.
You can save your text with the \fIsave\fR command \fB<ctrl-X><ctrl-S>\fR.
Type \fB<ctrl-X><ctrl-S>\fR \*(Em that 
is, first type \fB<ctrl-X>\fR, then type \fB<ctrl-S>\fR.
If you had modified this file, the following message would appear:
.DM
	[Wrote 23 lines]
.DE
The text file would have been saved to your computer's disk.
(\*(ME sends you messages from time to time.
The messages enclosed in square brackets \*(Ql[\*(Qr \*(Ql]\*(Qr are for your
information, and do not necessarily mean that something is wrong.)
To exit from \*(ME, type the \fIquit\fR command \fB<ctrl-X><ctrl-C>\fR.
This will return you to the shell.
.SH "Killing and Deleting"
.PP
.II "MicroEMACS^erase text"
Now that you know how to move the cursor, you are ready to edit your text.
.PP
To return to \*(ME, type the command:
.DM
	me example1.c
.DE
Within a moment, \fBexample1.c\fR will be restored to your screen.
.PP
By now, you probably have noticed that \*(ME is always ready to insert material
into your text.
Unless you use the \fB<ctrl>\fR or \fB<esc>\fR
keys, \*(ME assumes that whatever you type is
text and inserts it onto your screen where your cursor is positioned.
.PP
The simplest way to erase text is simply to position the
cursor to the right of the text you want to erase and backspace over it.
\*(ME, however, also has a set of commands that
allow you to erase text easily.
These commands, \fIkill\fR and \fIdelete\fR,
behave differently; the distinction
is important, and will be explained in a moment.
.II "MicroEMACS^killing and deleting"
.Sh "Deleting Vs. Killing"
.PP
.II "MicroEMACS^kill text, versus deleting"
.II "MicroEMACS^delete text, versus killing"
When \*(ME \fIdeletes\fR text, it is erased completely and
disappears forever.
However, when \*(ME \fIkills\fR text,
the text is copied into a temporary storage area in memory.
This storage area is overwritten when you
move the cursor and then kill additional text.
Until then, however, the killed text is saved.
This aspect of killing allows you to restore text that you
killed accidentally, and it also allows you to move or copy portions
of text from one position to another.
.PP
.II "MicroEMACS^erase text, erasing spaces"
\*(ME is designed so that when it erases text, it does so beginning
at the \fIleft edge\fR of the cursor.
This left edge is called the \fIcurrent position\fR.
.PP
You should imagine that an invisible vertical bar separates the cursor from
the character immediately to its left.
As you enter the various kill and delete commands,
this vertical bar moves to the right or the left with the cursor, and
erases the characters it touches.
.Sh "Erasing Text to the Right"
.PP
.II "MicroEMACS^<ctrl-D>"
.II "MicroEMACS^<del>"
.II "MicroEMACS^text, erase to right"
.II "MicroEMACS^erase text, to the right"
The first two commands to be presented erase text to the \fIright\fR.
.DS
.ta .5i 1.8i
	\fB<ctrl-D>\fR	Delete one character to the right
	\fB<del>\fR	Delete one character to the right
	\fB<esc>D\fR	Kill one word to the right
.DE
The keystrokes
.B <del>
and
\fB<ctrl-D>\fR both
delete one \fIcharacter\fR to the right of the current position.
\fB<esc>D\fR deletes one \fIword\fR to the right of the current position.
.PP
To try these commands, type \fB<ctrl-D>\fR or
.BR <del> .
\*(ME erases the character \*(Ql\fB/\fR\*(Qr in the first line,
and shifted the rest of the line one space to the left.
.PP
.II "MicroEMACS^<esc>D"
Now, type \fB<esc>D\fR.
\*(ME erases
the \*(Ql\fB*\fR\*(Qr character and the word \fBThis\fR,
and shifts the line six spaces to the left.
The cursor is positioned at the \fIspace\fR before the word \fBis\fR.
Type \fB<esc>D\fR again.
The word \fBis\fR vanishes along with the \fIspace\fR that preceded it,
and the line shifts \fIfour\fR spaces to the left.
.PP
Remember that
\fB<ctrl-D>\fR \fIdeletes\fR text, but \fB<esc>D\fR \fIkills\fR text.
.Sh "Erasing Text to the Left"
.PP
.II "MicroEMACS^erase text, to the left"
.II "MicroEMACS^<backspace>"
.II "MicroEMACS^text, erase to left"
You can erase text to the \fIleft\fR with the following commands:
.DS
.ta 0.5i 2.5i
	\fB<backspace>\fR	Delete one character to the left
	\fB<esc><backspace>\fR	Kill one word to the left
.DE
To see how to erase text to the left, first type the
\fIend of line\fR command \fB<ctrl-E>\fR; this will move the
cursor to the right of the word \fBthree\fR on the first line of text.
Now, type
.BR <backspace> .
The second \fBe\fR of the word \fBthree\fR has vanished.
.PP
To erase the \fIword\fR that lies to the left of the cursor, type
.BR <esc><backspace> :
that is, type
.B <esc>
and then type
.BR <backspace> .
\*(ME
defines a word as a string delimited by white space.
For example, if you type
.BR <esc><backspace> ,
the rest of the word \fBthree\fR vanishes, and the cursor moves to the
white space that lies to the left of that word.
If the cursor is at the beginning of a line, then this command kills the
last word on the previous line of text.
.PP
Please note that erasing text with
.B <backspace>
.I deletes
the text; that is, the text is thrown away and gone forever.
Erasing text with
.BR <esc><backspace> ,
however,
.I kills
text; which means that the text is stored internally and can be retrieved.
The distinction between
.I deleting
text and
.I killing
is described in detail below.
.Sh "Erasing Lines of Text"
.PP
.II "MicroEMACS^erase text, by line"
.II "MicroEMACS^text, kill by lines"
Finally, the following command erases a line of text:
.DS
.ta .5i 1.8i
	\fB<ctrl-K>\fR	Kill from cursor to end of line
.DE
This command kills a line of text, from the line beginning
from immediately to the left of the cursor to the end of the line.
.PP
To see how this works, move the cursor to the beginning
of line 2.
Now, strike \fB<ctrl-K>\fR.
All of line 2 has vanished and been replaced with an empty space.
Strike \fB<ctrl-K>\fR again.
The empty space has vanished, and the cursor
is now positioned at the beginning of what used to be
line 3, in the space before \fB* Use\fR.
.Sh "Yanking Back (Restoring) Text"
.PP
.II "MicroEMACS^restore (yank back) killed text"
.II "MicroEMACS^yank back text"
.II "MicroEMACS^text, restore (yank back)"
.II "MicroEMACS^text, yank back (restore)"
.II "MicroEMACS^<ctrl-Y>"
The following command allows you restore material that you have killed:
.DS
.ta .5i 1.5i
	\fB<ctrl-Y>\fR	Yank back (restore) killed text
.DE
Remember that when you kill text, \*(ME
temporarily stores it elsewhere.
You can return this material to the screen
by using the \fIyank back\fR command \fB<ctrl-Y>\fR.
Type \fB<ctrl-Y>\fR.
All of line 2 has returned; the cursor, however,
remains at the beginning of line 3.
.Sh "Quitting"
.PP
.II "MicroEMACS^<ctrl-X><ctrl-C>"
.II "MicroEMACS^quit without saving text"
When you are finished, do not save the text.
If you do so, the undamaged copy of the text that
you made earlier will be replaced with the present mangled copy.
Rather, use the \fIquit\fR command \fB<ctrl-X><ctrl-C>\fR.
Type \fB<ctrl-X><ctrl-C>\fR.
On the bottom of your screen, \*(ME responds:
.DM
	Quit [y/n]?
.DE
Reply by typing \fBy\fR and a carriage return.
If you type \fBn\fR, \*(ME will
return you to where you were in the text.
\*(ME will now return you to the shell.
.SH "Block Killing and Moving Text"
.PP
.II "MicroEMACS^move text"
.II "MicroEMACS^text, move"
.II "MicroEMACS^buffer, for killed text"
As noted above, text that is killed is stored temporarily within memory.
You can yank killed text back onto your screen,
and not necessarily in the spot where it was originally killed.
This feature allows you to move text from one position to another.
.PP
.II "MicroEMACS^block-kill text"
.II "MicroEMACS^move text"
.II "MicroEMACS^kill and move commands"
.Sh "Moving One Line of Text"
.PP
You can kill and move one line of text with the following commands:
.DS
.ta .5i 1.5i
	\fB<ctrl-K>\fR	Kill text to end of line
	\fB<ctrl-Y>\fR	Yank back text
.DE
To test these commands, invoke \*(ME for the file \fBexample1.c\fR
by typing the following command:
.DM
	me example1.c
.DE
When \*(ME appears, the cursor will be positioned in the
upper left-hand corner of the screen.
.PP
To move the first line of text, begin by
typing the \fIkill\fR command \fB<ctrl-K>\fR twice.
Now, press \fB<esc>>\fR to move the cursor to the bottom of text.
Finally, yank back the line by typing \fB<ctrl-Y>\fR.
The line that reads
.DM
	/* This is a simple C program that computes the results
.DE
is now at the bottom of your text.
.PP
Your cursor has moved to the point on your screen that is
\fIafter\fR the line you yanked back.
.Sh "Multiple Copying of Killed Text"
.PP
When text is yanked back onto your screen, it is \fInot\fR deleted
from memory.
Rather, it is simply copied back onto the screen.
This means that killed text can be reinserted into the text more than once.
To see how this is done, return to the top of the text by typing \fB<esc><\fR.
Then type \fB<ctrl-Y>\fR.
The line you just killed now appears as both the first and last line of
the file.
.PP
The killed text will not be erased from its temporary
storage until you move the cursor and then kill additional text.
If you kill several lines or portions of lines in a row, all of the
killed text will be stored in the buffer; if you are not careful,
you may yank back a jumble of accumulated text.
.Sh "Kill and Move a Block of Text"
.PP
.II "MicroEMACS^kill text, block"
.II "MicroEMACS^<ctrl-@>"
.II "MicroEMACS^<ctrl-W>"
.II "MicroEMACS^text, block kill"
If you wish to kill and move more than one line of text at a time,
use the following commands:
.DS
.ta .5i 1.5i
	\fB<ctrl-@>\fR	Set mark
	\fB<esc>.\fR	Set mark
	\fB<ctrl-W>\fR	Kill block of text
	\fB<ctrl-Y>\fR	Yank back text
.DE
If you wish to kill a block of text, you can either
type the \fIkill\fR command \fB<ctrl-K>\fR repeatedly
to kill the block one line at a time, or you can
use the \fIblock kill\fR command \fB<ctrl-W>\fR.
To use this command, you must first set a \fImark\fR on the screen,
an invisible character that acts as a signal to the computer.
The mark can be set with either \fB<esc>.\fR or \fB<ctrl-@>\fR.
.PP
Once the mark is set, you must move your cursor to the
other end of the block of text you wish to kill, and then strike
\fB<ctrl-W>\fR.
The block of text will be erased, and will be ready to be
yanked back elsewhere.
.PP
Try this out on \fBexample1.c\fR.
Type \fB<esc><\fR to move the cursor to the upper left-hand
corner of the screen.
Then type the \fIset mark\fR command \fB<ctrl-@>\fR.
\*(ME will respond with the message
.DM
	[Mark set]
.DE
at the bottom of your screen.
Now, move the cursor down six lines, and type \fB<ctrl-W>\fR.
Note how the block of text you marked out has disappeared.
.PP
Move the cursor to the bottom of your text.
Type \fB<ctrl-Y>\fR.
The killed block of text has now been reinserted.
.PP
When you yank back text, be sure
to position the cursor at the \fIexact\fR point
where you want the text to be yanked back.
This will ensure that the text will be yanked back in the proper place.
To try this out, move your cursor up six lines.
Be careful that the cursor is at the \fIbeginning\fR of the line.
Now, type \fB<ctrl-Y>\fR again.
The text reappeared \fIabove\fR where the cursor
was positioned, and the cursor has not moved from
its position at the beginning of the line \*(Em which is not
what would have happened had you positioned it in the middle
or at the end of a line.
.PP
Although the text you are working with has only 23 lines,
you can move much larger portions of text using only
these three commands.
Remember, too, that you can use this technique to duplicate
large portions of text at several positions to save
yourself considerable time in typing and reduce the number of possible
typographical errors.
.SH "Capitalization and Other Tools"
.PP
The next commands perform a number of tasks to help with your editing.
Before you begin this section, destroy the old text on
your screen with the \fIquit\fR command \fB<ctrl-X><ctrl-C>\fR,
and read into \*(ME a fresh copy of the program,
as you did earlier.
.Sh "Capitalization and Lowercasing"
.PP
The following \*(ME commands automatically
capitalize a word (that is, make the first letter
of a word upper case), or make an entire word upper case or
lower case.
.DS
.ta .5i 1.5i
	\fB<esc>C\fR	Capitalize a word
	\fB<esc>L\fR	Lowercase from cursor to end of word
	\fB<esc>U\fR	Uppercase from cursor to end of word
.DE
To try these commands, do the following:
.II "MicroEMACS^uppercase"
.II "MicroEMACS^lowercase"
.II "MicroEMACS^capitalization"
.II "MicroEMACS^<esc>C"
.II "MicroEMACS^text, capitalize"
First, move the cursor to the letter \fBd\fR of
the word \fIdifferent\fR on line 2.
Type the \fIcapitalize\fR command \fB<esc>C\fR.
The word is now capitalized, and
the cursor is now positioned at the space after the word.
Move the cursor forward so that it is over the letter \fBt\fR in \fBrates\fR.
Press \fB<esc>C\fR again.
The word changes to \fBraTes\fR.
When you press \fB<esc>C\fR, \*(ME capitalizes
the \fIfirst\fR letter the cursor meets.
.PP
\*(ME can also change a word to all upper case or all lower case.
(There is very little need for a command that will
change only the first character of an upper-case word
to lower case, so it is not included.)
.PP
.II "MicroEMACS^<esc>U"
.II "MicroEMACS^text, uppercase"
Type \fB<esc>B\fR to move the cursor so that it is again to the left of the
word \fBDifferent\fR.
It does not matter if the cursor is directly over the \fBD\fR
or at the space to its left; as you will see, this means
that you can capitalize or
lowercase a number of words in a row without having to move the cursor.
.PP
Type the \fIuppercase\fR command \fB<esc>U\fR.
The word is now spelled \fBDIFFERENT\fR, and the
cursor has jumped to the space after the word.
.PP
.II "MicroEMACS^<esc>L"
.II "MicroEMACS^text, lowercase"
Again, move the cursor to the left of the word \fBDIFFERENT\fR.
Type the \fIlowercase\fR command \fB<esc>L\fR.
The word has changed back to \fBdifferent\fR.
Now, move the cursor to the space at the beginning of line 3 by typing
\fB<ctrl-N>\fR then \fB<ctrl-A>\fR.
Type \fB<esc>L\fR once again.
The character \*(QL\fB*\fR\*(Qr is not affected by the command,
but the letter \fBU\fR is now lower case.
\fB<esc>L\fR not only shifts a word that is all upper case to
lower case: it can also un-capitalize a word.
.PP
The \fIuppercase\fR and \fIlowercase\fR commands
stop at the first punctuation mark they meet
\fIafter\fR the first letter they find.
This means that, for example,
to change the case of a word with an apostrophe in it
you must type the appropriate command twice.
.Sh "Transpose Characters"
.PP
.II "MicroEMACS^<ctrl-T>"
.II "MicroEMACS^transpose characters"
\*(ME allows you to reverse the position of two characters,
or \fItranspose\fR them, with the \fItranspose\fR command
\fB<ctrl-T>\fR.
.PP
Type \fB<ctrl-T>\fR.
\*(ME transposes the character that is under the cursor
with the character immediately to its \fIleft\fR.
In this example,
.DM
	* use this
.DE
in line 3 now appears:
.DM
	* us ethis
.DE
The space and the letter \fBe\fR have been transposed.
Type \fB<ctrl-T>\fR again.
The characters have returned to their original order.
.Sh "Screen Redraw"
.PP
.II "MicroEMACS^<ctrl-L>"
.II "MicroEMACS^screen redraw"
.II "MicroEMACS^redraw screen"
.DS
.ta .5i 1.8i
	\fB<ctrl-L>\fR	Redraw screen
.DE
Occasionally, while you are working on a text another \*(CO
user will write or mail you a message.
\*(OS will write the message directly on your
screen, which scrambles your screen.
A message sent from another user or a message from
the \*(CO system is \fInot\fR recorded into your
text; however, you may wish to erase the message and
continue editing.
The \fIredraw screen\fR command \fB<ctrl-L>\fR will redraw your screen to
the way it was before it was scrambled.
.PP
Type \fB<ctrl-L>\fR.
Notice how the screen flickers and the text is rewritten.
Had your screen been spoiled by extraneous material,
that material would have been erased and the original
text rewritten.
.PP
.II "MicroEMACS^center line on screen"
.II "MicroEMACS^<ctrl-U><ctrl-L>"
The \fB<ctrl-L>\fR command also has another use:
it can move the line on which the cursor is positioned to the
center of the screen.
If you have a file that contains more than one screenful
of text and you wish to have that particular line in the center
of the screen, position the cursor on that line and type
\fB<ctrl-U><ctrl-L>\fR.
You will see a prompt that says
.DM
	Arg: 4
.DE
The meaning of this prompt is explained below; for now,
ignore it and press
.BR <return> .
Immediately, \*(ME redraws the screen and places the line you
selected in the center of the screen.
.Sh "Return Indent"
.PP
.II "MicroEMACS^return indent"
.DS
.ta .5i 1.8i
	\fB<ctrl-J>\fR	Return and indent
.DE
.II "MicroEMACS^block indentation"
You may often be faced with a situation in which, for the sake of
programming style, you need to indent many lines of text:
before every line you must tab the correct number of
times before typing the text.
These \fIblock indents\fR can be a time-consuming typing chore.
The \*(ME \fB<ctrl-J>\fR command makes this task easier.
\fB<ctrl-J>\fR moves the cursor to the next line on the screen and
automatically positions the cursor at the previous line's level of indentation.
.PP
To see how this works, first move the cursor to the line that reads
.DM
	w3 *= 1.10:
.DE
Press \fB<ctrl-E>\fR, to move the cursor to the end of the line.
Now, type \fB<ctrl-J>\fR.
.PP
As you can see, a new line opens up and the cursor is indented the same
amount as the previous line.
Type
.DM
	/* Here is an example of auto-indentation */
.DE
This line of text begins directly under the previous line.
.Sh "Word Wrap"
.PP
.II "MicroEMACS^word wrap"
.DS
.ta .5i 1.8i
	\fB<ctrl-X>F\fR	Set word wrap
.DE
Although you have not yet had much opportunity to use it,
\*(ME will automatically wrap text that you are typing.
.II "MicroEMACS^<ctrl-X>F"
Word-wrapping is controlled with the \fIword wrap\fR command
\fB<ctrl-X>F\fR.
To see how the word wrap command works, first exit from \*(ME
by typing \fB<ctrl-X><ctrl-C>\fR; then reinvoke \*(ME by typing
.DM
	me cucumber
.DE
When \*(ME re-appears,
type the following text; however, do \fInot\fR type
any carriage returns:
.DM
	A cucumber should be
	well sliced, and dressed
	with pepper and vinegar,
	and then thrown out, as
	good for nothing.
.DE
When you reached the edge of your screen,
a dollar sign was printed and you were allowed to continue typing.
\*(ME accepted the characters you typed, but it placed
them at a location beyond the right edge of your screen.
.PP
Now, move to the beginning of the next line and type \fB<ctrl-U>\fR.
\*(ME will reply with the message:
.DM
	Arg: 4
.DE
Type \fB30\fR.
The line at the bottom of your screen now appears as follows:
.DM
	Arg: 30
.DE
(The use of the \fIargument\fR command \fB<ctrl-U>\fR will be
explained in a few minutes.)
Now type the \fIword-wrap\fR command \fB<ctrl-X>F\fR.
\*(ME will now say at the bottom of your screen:
.DM
	[Wrap at column 30]
.DE
This sequence of commands has set the word-wrap function, and
told it to wrap to the next line all words that extend beyond
the 30th column on your screen.
.PP
The \fIword wrap\fR feature automatically moves your cursor to the
beginning of the next line once you type past a preset border on your
screen.
When you first enter \*(ME, that limit is automatically set
at the first column, which in effect means that word wrap has
been turned off.
.PP
When you type prose for a report or a letter of some sort, you
probably will want to set the border at the 65th column, so that
the printed text will fit neatly onto a sheet of paper.
If you are using \*(ME to type in a program, however, you probably
will want to leave word wrap off, so you do not
accidentally introduce carriage returns into your code.
.PP
To test word wrapping, type the above text again,
without using the carriage return key.
When you finish, it should appear as follows:
.DM
	A cucumber should be well
	sliced, and dressed with
	pepper and vinegar, and then
	thrown out, as good for
	nothing.
.DE
\*(ME automatically moved your cursor to the next line when you typed
a space character after the 30th column on your screen.
.PP
If you wish to fix the border at some special point on your screen
but do not wish to go through the tedium of figuring out how many
columns from the left it is, simply position the cursor where you
want the border to be, type \fB<ctrl-X>F\fR, and then type a carriage
return.
When \fB<ctrl-X>F\fR is typed without being preceded by a \fB<ctrl-U>\fR
command, it sets the word-wrap border at the point your cursor
happens to be positioned.
When you do this, \*(ME will then print a message at the bottom
of your terminal that tells you where the word-wrap border is now set.
.PP
To re-word wrap the text between the cursor and the mark, type
.BR <ctrl-X>H .
.PP
If you wish to turn off the word wrap feature again, simply set the
word wrap border to one.
.SH "Search and Reverse Search"
.PP
When you edit a large text, you may wish to change particular
words or phrases.
To do this, you can roll through the text and read each
line to find them; or you can have \*(ME find them for you.
.II "MicroEMACS^searching"
.II "MicroEMACS^commands"
Before you continue, close the present file by typing
\fB<ctrl-X> <ctrl-C>\fR;
then reinvoke the editor to edit the file \fBexample1.c\fR,
as you did before.
The following sections perform some exercises with this file.
.Sh "Search Forward"
.PP
.II "MicroEMACS^search, forward"
.II "MicroEMACS^<esc>S"
.DS
.ta .5i 1.5i
	\fB<ctrl-S>\fR	Search forward incrementally
	\fB<esc>S\fR	Search forward with prompt
.DE
As you can see from the display, \*(ME has two ways to search
forward:
incrementally, and with a prompt.
.PP
An
.I incremental
search is one in which the search is performed as you type the characters.
To see how this works, first type the \fIbeginning of text\fR
command \fB<esc><\fR to move the cursor to the
upper left-hand corner of your screen.
Now, type the \fIincremental search\fR command \fB<ctrl-S>\fR.
\*(ME will respond by prompting with the message
.DM
	i-search forward []
.DE
at the bottom of the screen.
.PP
We will now search for the pointer
.BR *msg .
Type the letters \fB*msg\fR one at a time, starting with \fB*\fR.
The cursor has jumped to the first place that a \fB*\fR was found:
at the second character of the first line.
The cursor moves forward in the text file and the message at the bottom
of the screen changes to reflect what you have typed.
.PP
Now type \fBm\fR.
The cursor has jumped ahead to the letter \fBs\fR in \fB*msg\fR.
Type \fBs\fR.
The cursor has jumped ahead to the letter \fBg\fR in \fB*msg\fR.
Finally, type \fBg\fR.
The cursor is over the space after the token \fB*msg\fR.
Finally, type \fB<esc>\fR to end the string.
\*(ME replies with the message
.DM
	[Done]
.DE
which indicates that the search is finished.
.PP
If you attempt an incremental search for a word that is not in the file,
\*(ME will find as many of the letters as it can, and then give you
an error message.
For example, if you tried to search incrementally for the word
\fB*msgs\fR, \*(ME would move the cursor to the phrase \fB*msg\fR;
when you typed \*(Qls\*(Qr, it would tell you
.DM
	failing i-search forward: *msgs
.DE
.II "MicroEMACS^<return>"
With the
.IR "prompt search" ,
however, you type in the word all at once.
To see how this works, type
.BR <esc>< ,
to return to the top of the file.
Now, type the
.I "prompt search"
command
.BR <esc>S .
\*(ME responds by prompting with the message
.DM
	Search [*msgs]:
.DE
at the bottom of the screen.
The word \fB*msgs\fR is shown because that was
the last word for which you searched, and so it is kept in the search buffer.
.PP
Type in the words \fBediting text\fR, then press the carriage return.
Notice that the cursor has jumped to the period after the
word \fBtext\fR in the next to last line of your text.
\*(ME searched for the words \fBediting text\fR, found them, and moved
the cursor to them.
.PP
If the word you were searching for was not in your text,
or at least was not in the portion that lies between
your cursor and the end of the text, \*(ME
would not have moved the cursor, and would have displayed the message
.DM
	Not found
.DE
at the bottom of your screen.
.Sh "Reverse Search"
.PP
.II "MicroEMACS^search, reverse"
.II "MicroEMACS^reverse search"
.II "MicroEMACS^<esc>R"
.DS
.ta .5i 1.5i
	\fB<ctrl-R>\fR	Search backwards incrementally
	\fB<esc>R\fR	Search backwards with prompt
.DE
The search commands, useful as they are,
can only search forward through your text.
To search backwards, use the reverse search commands
.B <ctrl-R>
and \fB<esc>R\fR.
These work exactly the same as their forward-searching counterparts,
except that they search toward the beginning of the file rather than
toward the end.
.PP
For example, type \fB<esc>R\fR.
\*(ME replies with the message
.DM
	Reverse search [editing text]:
.DE
at the bottom of your screen.
The words in square brackets are the words you
entered earlier for the \fIsearch\fR command;
\*(ME remembered them.
If you wanted to search for \fBediting text\fR again, you would just
press the carriage return.
For now, however, type the word \fBprogram\fR and press
the carriage return.
.PP
Notice that the cursor has jumped so that it is under the
letter \fBp\fR of the word \fBprogram\fR in line 1.
When you search forward, the cursor moves to the
\fIspace after\fR the word for which you are searching, whereas
when you reverse search the cursor moves to the
\fIfirst letter\fR of the word for which you are searching.
.Sh "Cancel a Command"
.PP
.II "MicroEMACS^cancel a command"
.II "MicroEMACS^<ctrl-G>"
.DS
.ta .5i 1.5i
	\fB<ctrl-G>\fR	Cancel a search command
.DE
As you have noticed, the commands to move the cursor
or to delete or kill text all execute immediately.
Although this speeds your editing, it also means that
if you type a command by mistake, it executes before you can stop it.
.PP
The
.I search
and
.I "reverse search"
commands, however, wait for you to respond to their prompts before they execute.
If you type \fB<esc>S\fR or \fB<esc>R\fR by accident,
\*(ME will interrupt your editing and
wait for you to initate a search that you do not want to perform.
You can evade this problem, however, with the \fIcancel\fR
command \fB<ctrl-G>\fR.
This command tells \*(ME to ignore the previous command.
.PP
To see how this command works, type \fB<esc>R\fR.
When the prompt appears at the bottom of your screen, type \fB<ctrl-G>\fR.
Three things happen:
your terminal beeps,
the characters \fB^G\fR appear at the bottom of your screen,
and the cursor returns to where it was before you first typed \fB<esc>R\fR.
The \fB<esc>R\fR command has been cancelled, and you
are free to continue editing.
.PP
If you cancel an
.I "incremental search"
command,
.B <ctrl-S>
or
.BR <esc-S> ,
the cursor returns to where it was before you began the search.
For example, type
.B <esc><
to return to the top of the file.
Now type
.B <ctrl-S>
to begin an incremental search, and type
.BR m .
When the cursor moves to the
.B m
in
.BR simple ,
type
.BR <ctrl-G> .
Your cursor returns to the top of the
file, where you began the search.
.Sh "Search and Replace"
.PP
.DS
.ta .5i 1.5i
	\fB<esc>%\fR	Search and replace
.DE
\*(ME also gives you a powerful function that allows you
to search for a string and replace it with a keystroke.
You can do this by executing
the \fIsearch and replace\fR command \fB<esc>%\fR.
.II "MicroEMACS^<esc>%"
.II "MicroEMACS^search and replace"
.PP
To see how this works, move to the top of the
text file by typing \fB<esc><\fR; then type \fB<esc>%\fR.
You will see the following message at the bottom of your screen:
.DM
	Old string [m]
.DE
As an exercise, type \fBmsg\fR, and then press
.BR <return> .
\*(ME will then ask:
.DM
	New string:
.DE
Type \fBmessage\fR, and press the carriage return.
As you can see, the cursor jumps to the first occurrence of
the string \fBmsg\fR, and prints the following message
at the bottom of your screen:
.DM
	Query replace: [msg] -> [message]
.DE
\*(ME is asking if it should proceed with the replacement.
Type a carriage return:
this displays the options that are available to you at the
bottom of your screen:
.DM
.in 0
.ta 0.4i
	<SP>[,] replace, [.] rep-end, [n] dont, [!] repl rest <C-G> quit
.DE
The options are as follows:
.PP
Typing a space or a comma executes the replacement, and moves the cursor
to the next occurrence of the old string; in this case, it replaces
\fBmsg\fR with \fBmessage\fR, and moves the cursor to the next occurrence
of \fBmsg\fR.
.PP
Typing a period \*(Ql.\*(Qr replaces this one occurrence of the old
string and ends the search and replace procedure.
In this example, typing a period replaces this one occurrence of \fBmsg\fR
with \fBmessage\fR and ends the procedure.
.PP
Typing the letter \*(Qln\*(Qr tells \*(ME \fInot\fR to replace
this instance of the old string, but move to the next occurrence of
the old string.
In this case, typing \*(Qln\*(Qr does \fInot\fR
replace \fBmsg\fR with \fBmessage\fR, and the cursor jumps
to the next place where \fBmsg\fR occurs.
.PP
Typing an exclamation point \*(Ql!\*(Qr tells \*(ME to replace
all instances of the old string with the new string automatically,
without checking with you any further.
In this example, typing \*(Ql!\*(Qr replaces all instances
of \fBmsg\fR with \fBmessage\fR without further queries from \*(ME.
When you finish searching and replacing,
\*(ME displays a message that tells how many replacements it made.
.PP
Typing \fB<ctrl-G>\fR aborts the search and replace procedure.
.SH "Saving Text and Exiting"
.PP
.II "MicroEMACS^text, saving"
.II "MicroEMACS^exit"
.II "MicroEMACS^saving text"
This set of basic editing commands allows you to save your
text and exit from the \*(ME program.
They are as follows:  
.DS
.ta .5i 2.3i
	\fB<ctrl-X><ctrl-S>\fR	Save text
	\fB<ctrl-X><ctrl-W>\fR	Write text to a new file
.sp \n(PDu
	\fB<ctrl-Z>\fR	Save text and exit
	\fB<ctrl-X><ctrl-C>\fR	Exit without saving text
.DE
.II "MicroEMACS^extended commands"
.II "MicroEMACS^<ctrl-X>"
You have used two of these commands already:
the \fIsave\fR command \fB<ctrl-X><ctrl-S>\fR
and the \fIquit\fR command \fB<ctrl-X><ctrl-C>\fR,
which respectively allow you to save text or to exit
from \*(ME without saving text.
(Commands that begin with \fB<ctrl-X>\fR are called \fIextended\fR
commands; they are used frequently in the commands described later
in this tutorial.)
.Sh "Write Text to a New File"
.PP
.II "MicroEMACS^text, write to new file"
.II "MicroEMACS^<ctrl-X><ctrl-W>"
.DS
.ta .5i 2.3i
	\fB<ctrl-X> <ctrl-W>\fR	Write text to a new file
.DE
If you wish, you can copy the text you are currently
editing to a text file other than the one from which you originally
read the text.
Do this with the \fIwrite\fR command \fB<ctrl-X><ctrl-W>\fR.
.PP
To test this command, type \fB<ctrl-X><ctrl-W>\fR.
\*(ME displays the following message on the bottom of your screen:  
.DM
	Write file:  
.DE
\*(ME is asking for the name of the file into which you wish to write the text.
Type \fBsample\fR.
\*(ME replies:
.DM
	[Wrote 23 lines]
.DE
The 23 lines of your text have been copied to a new file called \fBsample\fR.
The status line at the bottom of your screen has changed to read as follows:
.DM

-- Coherent MicroEMACS -- example1.c -- File: sample --------------

.DE
The significance of the change in file name will be discussed in the
second half of this tutorial.
.PP
Before you copy text into a new file, be sure that you have not
selected a file name that is already being used.
If you do, \*(ME will erase whatever is stored under that file name,
and the text created with \*(ME will be stored in its place.
.Sh "Save Text and Exit"
.PP
.II "MicroEMACS^<ctrl-Z>"
.II "MicroEMACS^store command"
Finally, the \fIstore\fR command
\fB<ctrl-Z>\fR will save your text \fIand\fR move you out of
the \*(ME editor.
To see how this works, watch the bottom line of your terminal
carefully and type \fB<ctrl-Z>\fR.
\*(ME
has saved your text, and now you can issue commands directly to the shell.
.SH "Advanced Editing"
.PP 
The second half of this tutorial introduces
the advanced features of \*(ME.
.PP
The techniques described here will help you
execute complex editing tasks with minimal trouble.
You will be able to edit more than one text at a time,
display more than one file on your screen at a time,
enter a long or complicated phrase repeatedly with only
one keystroke, and give commands to \*(OS
without having to exit from \*(ME.
.PP
Before beginning, however, you must prepare a new text file.
Type the following command:
.DM
	me example2.c
.DE
In a moment, \fBexample2.c\fR will appear on your screen,
as follows:
.B1
	/* Use this program to get better acquainted
	 * with the MicroEMACS interactive screen editor.
	 * You can use this text to learn some of the
	 * more advanced editing features of MicroEMACS.
	 */
.sp \n(pDu
	#include <stdio.h>
	main()
	{
		FILE *fp;
		int ch;
		int filename[20];
.sp \n(pDu
		printf("Enter file name: ");
		gets(filename);
.sp \n(pDu
		if ((fp =fopen(filename,"r")) !=NULL) {
			while ((ch = fgetc(fp)) != EOF)
				fputc(ch, stdout);
		} else
			printf("Cannot open %s.\en", filename);
		fclose(fp);
	}	
.B2
.sp \n(pDu
.SH "Arguments"
.PP
.II "MicroEMACS^arguments"
.II "MicroEMACS^arguments"
.II "MicroEMACS^<ctrl-U>"
Most of the commands already described in this
tutorial can be used with \fIarguments\fR.
An argument is a subcommand that tells \*(ME to
execute a command a given number of times.
With \*(ME, arguments are introduced by typing \fB<ctrl-U>\fR.
.Sh "Arguments: Default Values"
.PP
.II "MicroEMACS^arguments, default value"
By itself, \fB<ctrl-U>\fR sets the argument at \fIfour\fR.
To illustrate this, first type the \fInext line\fR command \fB<ctrl-N>\fR.
By itself, this command moves the cursor down one
line, from being over the \*(Ql\fB/\fR\*(Qr at the beginning
of line 1, to being over the \fIspace\fR at the beginning of line 2.
.PP
Now, type \fB<ctrl-U>\fR.
\*(ME replies with the message:
.DM
	Arg: 4
.DE
Now type \fB<ctrl-N>\fR.
The cursor jumps down \fIfour\fR
lines, from the beginning of line 2 to the 
letter \fBm\fR of the word \fBmain\fR at the beginning of line 6.
.PP
.II "MicroEMACS^arguments, increasing or decreasing"
Type \fB<ctrl-U>\fR.
The line at the bottom of the screen again shows that
the value of the argument is four.
Type \fB<ctrl-U>\fR again.
Now the line at the bottom of the screen reads:
.DM
	Arg: 16
.DE
Type \fB<ctrl-U>\fR once more.
The line at the bottom of the screen now reads:
.DM
	Arg: 64
.DE
Each time you type \fB<ctrl-U>\fR, the value of the argument
is \fImultiplied\fR by four.
Type the \fIforward\fR command \fB<ctrl-F>\fR.
The cursor has jumped ahead 64 characters, and is now
over the \fBi\fR of the word \fBfile\fR in the \fIprintf\fR statement in
line 11.
.Sh "Selecting Values"
.PP
.II "MicroEMACS^arguments, selecting values"
Naturally, an argument does not have to be a power of four.
You can set the argument to whatever number you wish,
simply by typing \fB<ctrl-U>\fR and then typing the number you want.
.PP
For example, type \fB<ctrl-U>\fR, and then type \fB3\fR.
The line at the bottom of the screen now reads:
.DM
	Arg: 3
.DE
Type the \fIdelete\fR command \fB<esc>D\fR.
\*(ME has deleted three words to the right.
.PP
You can use
arguments to increase the power of any
\fIcursor movement\fR command, or any \fIkill\fR or \fIdelete\fR command.
The sole exception is \fB<ctrl-W>\fR, the \fIblock kill\fR command.
.Sh "Deleting With Arguments: An Exception"
.PP
.II "MicroEMACS^yank back text"
.II "MicroEMACS^arguments, deleting"
\fIKilling\fR and \fIdeleting\fR were described in the first
part of this tutorial.
They were said to differ in that text that was killed was
stored in a special area of the computer and could be
yanked back, whereas text that was deleted was erased outright.
However, there is one exception to this rule:
any text that is deleted using an argument can also be yanked back.
.PP
To see how this works, first
type the \fIbegin text\fR command \fB<esc><\fR to
move the cursor to the upper left-hand corner of the screen.
Then, type \fB<ctrl-U> 5 <ctrl-D>\fR.
The word \fBUse\fR has disappeared.
Move the cursor to the right until it is between
the words \fBbetter\fR and \fBacquainted\fR, then
type \fB<ctrl-Y>\fR.
The word \fBUse\fR has been moved within the line
(although the spaces around it have not been moved).
This function is very handy, and should greatly speed your editing.
.PP
Remember, too, that unless you move the cursor between
one set of deletions and another,
the computer's storage area will not be erased, and
you may yank back a jumble of text.
.SH "Buffers and Files"
.PP
Before beginning this section, replace the edited copy
of the text on your screen with a fresh copy.
Type the \fIquit\fR command 
\fB<ctrl-X><ctrl-C>\fR to exit from \*(ME without
saving the text; then return to \*(ME to edit the file
\fBexample2.c\fR, as you did earlier.
.PP
Now, look at the status line at the bottom of your screen.
It should appear as follows:  
.DM

-- Coherent MicroEMACS -- example2.c -- File: example2.c --------------

.DE
As noted in the first half of this tutorial, 
the name on the left of the command line is that of the program.
The name in the middle is the name of the \fIbuffer\fR with
which you are now working, and the name to the right is
the name of the \fIfile\fR from which you read the text.
.Sh "Definitions"
.PP
.II "MicroEMACS^buffer, definition"
.II "MicroEMACS^file, definition"
.II "MicroEMACS^buffer, how differs from file"
.II "MicroEMACS^file, how differs from buffer"
A \fIfile\fR is a mass of text that has been given a name and has been
permanently stored on your disk.
A \fIbuffer\fR is a portion of the computer's
memory that has been set aside for you to use, which may be given a name,
and into which you can put text temporarily.
You can place text into the buffer either by typing it at
your keyboard or by \fIcopying\fR it from a file.
.PP
Unlike a file, a buffer is not permanent:
if your computer were to stop working
(because you turned the power off, for example),
a file would not be affected, but a buffer would be erased.
.PP
.II "MicroEMACS^file, naming"
.II "MicroEMACS^buffer, naming"
You must \fIname\fR your files because you work with many
different files, and you must have some way to tell them apart.
Likewise, \*(ME allows you to \fIname\fR your buffers,
because \*(ME allows you to work with more than one buffer at a time.
.Sh "File and Buffer Commands"
.PP
\*(ME gives you a number of commands for handling files and buffers.
These include the following:
.II "MicroEMACS^file and buffer commands"
.DS
.ta 0.5i 2.3i
	\fB<ctrl-X><ctrl-W>\fR	Write text to file
	\fB<ctrl-X><ctrl-F>\fR	Rename file
.sp \n(PDu
	\fB<ctrl-X><ctrl-R>\fR	Replace buffer with named file
	\fB<ctrl-X><ctrl-V>\fR	Switch buffer or create a new buffer
.sp \n(PDu
	\fB<ctrl-X>K\fR	Delete a buffer
	\fB<ctrl-X><ctrl-B>\fR	Display the status of each buffer
.DE
.Sh "Write and Rename Commands"
.PP
.II "MicroEMACS^<ctrl-X><ctrl-W>"
.II "MicroEMACS^write text to new file"
The \fIwrite\fR command \fB<ctrl-X><ctrl-W>\fR was introduced earlier when
the commands for saving text and exiting were discussed.
To review, \fB<ctrl-X><ctrl-W>\fR changes the name of the
file into which the text is saved, and then copies the text into that file.
.PP
Type \fB<ctrl-X><ctrl-W>\fR.
\*(ME responds by printing
.DM
	Write file:
.DE
on the last line of your screen.
.PP
Type \fBjunkfile\fR, then \fB<return>\fR.
Two things happen:
First, \*(ME writes the message
.DM
	[Wrote 21 lines]
.DE
at the bottom of your screen.
Second, the name of the file shown on the status line changes from
\fBexample2.c\fR to \fBjunkfile\fR.
\*(ME is reminding you that your text is now being saved
into the file \fBjunkfile\fR.
.PP
.II "MicroEMACS^<ctrl-X><ctrl-F>"
.II "MicroEMACS^rename file"
.II "MicroEMACS^file, rename"
The \fIfile rename\fR command \fB<ctrl-X><ctrl-F>\fR allows you rename the
file to which you are saving text, \fIwithout\fR automatically
writing the text to it.
Type \fB<ctrl-X><ctrl-F>\fR.
\*(ME will reply with the prompt:
.DM
	Name:
.DE
Type \fBexample2.c\fR and \fB<return>\fR.
\*(ME does \fInot\fR send you a message that
lines were written to the file; however, the name of the
file shown on the status line has changed from
\fBjunkfile\fR back to \fBexample2.c\fR.
.Sh "Replace Text in a Buffer"
.PP
.II "MicroEMACS^<ctrl-X><ctrl-R>"
.II "MicroEMACS^replace buffer with named file"
.II "MicroEMACS^buffer, replace with named file"
.II "MicroEMACS^file, replace buffer with named f."
The \fIreplace\fR command \fB<ctrl-X><ctrl-R>\fR allows
you to replace the text in your buffer with the text from another file.
.PP
Suppose, for example, that you had edited \fBexample2.c\fR
and saved it, and now wished to edit \fBexample1.c\fR.
You could exit from \*(ME, then re-invoke \*(ME
for the file \fBexample1.c\fR, but this is cumbersome.
A more efficient way is to simply replace the \fBexample2.c\fR
in your buffer with \fBexample1.c\fR.
.PP
Type \fB<ctrl-X><ctrl-R>\fR.
\*(ME replies with the prompt:  
.DM
	Read file:  
.DE
Type \fBexample1.c\fR.
Notice that \fBexample2.c\fR has rolled away and been replaced with
\fBexample1.c\fR.
Now, check the status line.
Notice that although the name of the \fIbuffer\fR is still
\fBexample2.c\fR, the name of the \fIfile\fR has changed to \fBexample1.c\fR.
You can now edit \fBexample1.c\fR; when you save the edited
text, \*(ME will copy it back into the file \fBexample1.c\fR \*(Em unless,
of course, you again choose to rename the file.
.Sh "Visiting Another Buffer"
.PP
.II "MicroEMACS^<ctrl-X><ctrl-V>"
.II "MicroEMACS^switch buffers"
.II "MicroEMACS^visit command"
.II "MicroEMACS^buffer, switch b."
The last command of this set, the \fIvisit\fR command 
\fB<ctrl-X><ctrl-V>\fR, allows you to create more than
one buffer at a time, to jump from one buffer to another,
and move text between buffers.
This powerful command has numerous features.
.PP
Before beginning, however, straighten up your buffer
by replacing \fBexample1.c\fR with \fBexample2.c\fR.
Type the \fIreplace\fR command 
\fB<ctrl-X><ctrl-R>\fR; when \*(ME replies
by asking
.DM
	Read file:
.DE
at the bottom of your screen, type \fBexample2.c\fR.
.PP
You should now have the file \fBexample2.c\fR read into
the buffer named \fBexample2.c\fR.
.PP
Now, type the \fIvisit\fR command \fB<ctrl-X><ctrl-V>\fR.
\*(ME replies with the prompt
.DM
	Visit file:
.DE
at the bottom of the screen.
Now type \fBexample1.c\fR.
Several things happen.
\fBexample2.c\fR rolls off the screen and is replaced
with \fBexample1.c\fR; the status line changes to show
that both the buffer name and the file name are now
\fBexample1.c\fR; and the message 
.DM
	[Read 23 lines]
.DE
appears at the bottom of the screen.
.PP
This does \fInot\fR mean that your previous buffer
has been erased, as it would have been had you used the
\fIreplace\fR command \fB<ctrl-X><ctrl-R>\fR.
\*(ME is still keeping \fBexample2.c\fR \*(QLalive\*(QR in a buffer
and it is available for editing;
however, it is not being shown on your screen at the present moment.
.PP
Type \fB<ctrl-X><ctrl-V>\fR again, and when the prompt
appears, type \fBexample2.c\fR.
\fBexample1.c\fR scrolls off your screen and is replaced
by \fBexample2.c\fR, and the message
.DM
	[Old buffer]
.DE
appears at the bottom of your screen.
You have just jumped from one buffer to another.
.Sh "Move Text From One Buffer to Another"
.PP
.II "MicroEMACS^text, move from one buffer to another"
The \fIvisit\fR command \fB<ctrl-X><ctrl-V>\fR not only allows you to jump
from one buffer to another:
it allows you to \fImove text\fR from one buffer to another as well.
The following example shows how you can do this.
.PP
First, kill the first line of \fBexample2.c\fR by typing the \fIkill\fR command
\fB<ctrl-K>\fR twice.
This removes both the line of text \fIand\fR the space that it occupied.
If you did not remove the space as well the line itself, no new line would be
created for the text when you yank it back.
Next, type \fB<ctrl-X><ctrl-V>\fR.
When the prompt
.DM
	Visit file:
.DE
appears at the bottom of your screen, type \fBexample1.c\fR.
When \fBexample1.c\fR has rolled onto your screen,
type the \fIyank back\fR command \fB<ctrl-Y>\fR.
The line you killed in \fBexample2.c\fR has now been moved
into \fBexample1.c\fR.
.Sh "Checking Buffer Status"
.PP
.II "MicroEMACS^number of buffers allowed"
.II "MicroEMACS^buffers, number allowed"
The number of buffers you can use at any one time is limited
only by the size of your computer.
You should create only as many buffers as you need
to use immediately; this will help the computer run efficiently.
.PP
.II "MicroEMACS^buffer status command"
.II "MicroEMACS^buffer status"
.II "MicroEMACS^<ctrl-X><ctrl-B>"
.II "MicroEMACS^buffer status window"
To help you keep track of your buffers, \*(ME has the
\fIbuffer status\fR command \fB<ctrl-X><ctrl-B>\fR.
Type \fB<ctrl-X><ctrl-B>\fR.
The status line moves up to the middle
of the screen, and the bottom half of your screen
is replaced with the following display:  
.DM
        C    Size Lines   Buffer         File
        -    ---- -----   ------         ----
        *     655    24   example1.c     example1.c
        *     403    20   example2.c     example2.c
.DE
This display is called the \fIbuffer status window\fR.
The use of windows will be discussed more fully in the following section.
.PP
The letter \fBC\fR over the leftmost column stands for \fBChanged\fR.
An asterisk indicates that that buffer has been changed
since it was last saved, whereas
a space means that the buffer has not been changed.
\fBSize\fR indicates the buffer's size, in number of characters;
\fBBuffer\fR lists the buffer name, and \fBFile\fR lists the file name.
.PP
Now, kill the second line of \fBexample1.c\fR by typing the \fIkill\fR command
\fB<ctrl-K>\fR.
Then type \fB<ctrl-X><ctrl-B>\fR once again.
The size of the buffer \fBexample1.c\fR shrinks from
657 characters to 595 to reflect the decrease in the size of the buffer.
.PP
.II "MicroEMACS^<ctrl-X>1"
To make this display disappear, type the \fIone window\fR command
\fB<ctrl-X>1\fR.
This command will be discussed in full in the next section.
.Sh "Renaming a Buffer"
.PP
.II "MicroEMACS^buffer, prompting for new name"
.II "MicroEMACS^buffer, need unique names"
One more point must be covered with the \fIvisit\fR command.
\*(OS does not allow you to have more than one file with the same name.
For the same reason, \*(ME does not allow you to have more than one
\fIbuffer\fR with the same name.
.PP
Ordinarily, when you visit a file that is not already
in a buffer, \*(ME creates a new buffer and gives it the
same name as the file you are visiting.
However, if for some reason you already have a buffer
with the same name as the file you wish to visit,
\*(ME stops and asks you to give a new, different name to
the buffer it is creating.
.PP
For example, suppose that you wanted to visit a new
\fIfile\fR named \fBsample\fR,
but you already had a \fIbuffer\fR named \fBsample\fR.
\*(ME would stop and give you this prompt at the bottom of the screen:
.DM
	Buffer name:
.DE
You would type in a name for this new buffer.
This name could not duplicate the name of any existing buffer.
\*(ME would then read the file \fBsample\fR into the newly named buffer.
.Sh "Delete a Buffer"
.PP
.II "MicroEMACS^<ctrl-X>K"
.II "MicroEMACS^delete buffer command"
.II "MicroEMACS^buffer, delete"
If you wish to delete a buffer, simply type the \fIdelete buffer\fR command
\fB<ctrl-X>K\fR.
This command allows you to delete only a buffer that
is hidden, not one that is being displayed.
.PP
Type \fB<ctrl-X>K\fR.
\*(ME will give you the prompt:
.DM
	Kill buffer:
.DE
Type \fBexample2.c\fR.
Because you have changed the buffer, \*(ME asks:
.DM
	Discard changes [y/n]?
.DE
Type \fBy\fR, then
.BR <return> .
Now, type the \fIbuffer status\fR command \fB<ctrl-X><ctrl-B>\fR.
The buffer status window no longer shows the buffer \fBexample2.c\fR.
Although the prompt refers to \fIkilling\fR
a buffer, the buffer is in fact \fIdeleted\fR and cannot be yanked back.
.SH "Windows"
.PP
Before beginning this section, it will be necessary to create a new text file.
Exit from \*(ME by typing the \fIquit\fR command \fB<ctrl-X><ctrl-C>\fR;
then reinvoke \*(ME for the text file \fBexample1.c\fR as you did earlier.
.PP
Now, copy \fBexample2.c\fR into a buffer by typing
the \fBvisit\fR command \fB<ctrl-X><ctrl-V>\fR.
When the message
.DM
	Visit file:
.DE
appears at the bottom of your screen, type \fBexample2.c\fR.
\*(ME reads \fBexample2.c\fR into a buffer, and shows the message
.DM
	[Read 21 lines]
.DE
at the bottom of your screen.
.PP
Finally, copy a new text, called \fBexample3.c\fR, into a buffer.
(You copied this file into the current directory when you began this
tutorial.)
Type \fB<ctrl-X><ctrl-V>\fR again.
When \*(ME asks which file to visit, type \fBexample3.c\fR.
The message
.DM
	[Read 123 lines]
.DE
appears at the bottom of your screen.
.PP
The first screenful of text appears as follows:
.B1
.ta .3i 
	/*
	 * Factor prints out the prime factorization of numbers.
	 * If there are any arguments, then it factors these.  If
	 * there are no arguments, then it reads stdin until
	 * either EOF or the number zero or a non-numeric
	 * non-white-space character.  Since factor does all of
	 * its calculations in double format, the largest number
	 * which can be handled is quite large.
	 */
	#include <stdio.h>
	#include <math.h>
	#include <ctype.h>
.sp \n(pDu
	#define NUL '\e0'
	#define ERROR 0x10 /* largest input base */
	#define MAXNUM 200 /* max number of chars in number */
.sp \n(pDu
	main(argc, argv)
	int argc;
	register char *argv[];
.sp \n(pDu
	-- Coherent MicroEMACS -- example3.c -- File: example3.c --------------
.B2
.PP
At this point, \fBexample3.c\fR is on your screen,
and \fBexample1.c\fR and \fBexample2.c\fR are hidden.
.PP
You could edit first one text and then another, while remembering
just how things stood with the texts that were hidden; but
it would be much easier if you could display all three texts on your
screen simultaneously.
\*(ME allows you to do just that by using \fIwindows\fR.
.Sh "Creating Windows and Moving Between Them"
.PP
.II "MicroEMACS^<ctrl-X>2"
A \fIwindow\fR is a portion of your screen that can
be manipulated independent of the rest of the screen.
The following commands let you create windows and move between them:
.II "MicroEMACS^window manipulation"
.DS
.ta .5i 2.3i
	\fB<ctrl-X>2\fR	Create a window
	\fB<ctrl-X>1\fR	Delete extra windows
.sp \n(PDu
	\fB<ctrl-X>N\fR	Move to next window
	\fB<ctrl-X>P\fR	Move to previous window
.DE
The best way to grasp how a window works is to create one and work with it.
To begin, type the \fIcreate a window\fR command \fB<ctrl-X>2\fR.
.PP
Your screen is now divided into two parts, an upper and a lower.
The same text is in each part, and the command lines
give \fBexample3.c\fR for the buffer and file names.
Also, note that you still have only one cursor, which is in
the upper left-hand corner of the screen.
.PP
.II "MicroEMACS^<ctrl-X>N"
.II "MicroEMACS^<ctrl-X>P"
.II "MicroEMACS^window, shifting between"
The next step is to move from one window to another.
Type the \fInext window\fR command \fB<ctrl-X>N\fR.
Your cursor has now jumped to the upper left-hand corner
of the \fIlower\fR window.
.PP
Type the \fIprevious window\fR command \fB<ctrl-X>P\fR.
Your cursor has returned to the upper left-hand corner of the top window.
.PP
.II "MicroEMACS^window, number possible"
Now, type \fB<ctrl-X>2\fR again.
The window on the top of your screen is
now divided into two windows, for a total of three on your screen.
Type \fB<ctrl-X>2\fR again.
The window at the top of your screen has again
divided into two windows, for a total of four.
.PP	
.II "MicroEMACS^arguments, with create window"
It is possible to have as many as 11 windows
on your screen at one time, although each window will
show only the control line and one or two lines of text.
Neither \fB<ctrl-X>2\fR nor \fB<ctrl-X>1\fR can
be used with arguments.
.PP
.II "MicroEMACS^<ctrl-X>1"
Now, type the \fIone window\fR command \fB<ctrl-X>1\fR.
All of the extra windows have been eliminated, or \fIclosed\fR.
.Sh "Enlarging and Shrinking Windows"
.PP
.II "MicroEMACS^<ctrl-X>Z"
.II "MicroEMACS^window, enlarge"
When \*(ME creates a window, it divides into half the window in which the
cursor is positioned.
You do not have to leave the windows at the size \*(ME creates them, however.
If you wish, you may adjust the relative size of each window on
your screen, using the \fIenlarge window\fR and \fIshrink window\fR
commands:
.DS
.ta 0.5i 2.0i
	\fB<ctrl-X>Z\fR	Enlarge window
	\fB<ctrl-X><ctrl-Z>\fR	Shrink window
.DE
To see how these work, first type \fB<ctrl-X>2\fR twice.
Your screen is now divided into three windows:
two in the top half of your screen, and the third in the bottom half.
.PP
Now, type the \fIenlarge window\fR command \fB<ctrl-X>Z\fR.
The window at the top of your screen is now one line bigger:
it has borrowed a line from the window below it.
Type \fB<ctrl-X>Z\fR again.
Once again, the top window has borrowed a line from the middle window.
.PP
Now, type the \fInext window\fR command
\fB<ctrl-X>N\fR to move your cursor into the middle window.
Again, type the \fIenlarge window\fR command \fB<ctrl-X>Z\fR.
The middle window has borrowed a line from the bottom
window, and is now one line larger.
.PP
The \fIenlarge window\fR command \fB<ctrl-X>Z\fR
allows you to enlarge the window your cursor is
in by borrowing lines from another window,
provided that you do not shrink that other window out of existence.
Every window must have at least two lines in it:
one command line and one line of text.
.PP
.II "MicroEMACS^<ctrl-X><ctrl-Z>"
.II "MicroEMACS^window, shrink"
The \fIshrink window\fR command
\fB<ctrl-X><ctrl-Z>\fR allows you to decrease the size of a window.
Type \fB<ctrl-X><ctrl-Z>\fR.
The present window is now one line smaller, and
the lower window is one line larger because the line
borrowed earlier has been returned.
.PP
The \fIenlarge window\fR and \fIshrink window\fR commands can also be used
with arguments introduced with \fB<ctrl-U>\fR.
However, remember that \*(ME will not accept
an argument that would shrink another window out of existence.
.Sh "Displaying Text Within a Window"
.PP
Displaying text within the limited area of a window can
present special problems.
The \fIview\fR commands \fB<ctrl-V>\fR and \fB<esc>V\fR roll
window-sized portions of text up or down, but
you may become disoriented when a window shows only
four or five lines of text at a time.
Therefore, three special commands are available for displaying
text within a window:
.DS
.ta 0.5i 2.0i
	\fB<ctrl-X><ctrl-N>\fR	Scroll down
	\fB<ctrl-X><ctrl-P>\fR	Scroll up
.sp \n(PDu
	\fB<esc>!\fR	Move within window
.DE
.II "MicroEMACS^<ctrl-X><ctrl-N>"
.II "MicroEMACS^window, scroll down"
.II "MicroEMACS^<ctrl-X><ctrl-P>"
.II "MicroEMACS^scroll up"
.II "MicroEMACS^scroll down"
Two commands allow you to move your text by one line at a time, or
\fIscroll\fR it:
the \fIscroll up\fR command \fB<ctrl-X><ctrl-N>\fR,
and the \fIscroll down\fR command \fB<ctrl-X><ctrl-P>\fR.
.PP
Type \fB<ctrl-X><ctrl-N>\fR.
The line at the top of your window has vanished,
a new line has appeared at the bottom of your window, and
the cursor is now at the beginning of what had been the
second line of your window.
.PP
Now type \fB<ctrl-X><ctrl-P>\fR.
The line at the top that had vanished earlier has now returned, the
cursor is at the beginning of it, and
the line at the bottom of the window has vanished.
These commands allow you to move forward in your text
slowly so that you do not become disoriented.
.PP
Both of these commands can be used with arguments introduced by \fB<ctrl-U>\fR.
.PP
.II "MicroEMACS^<esc>!"
.II "MicroEMACS^window, move within"
The third special movement command is the
\fImove within window\fR command \fB<esc>!\fR.
This command moves the line your cursor is on to the top of the window.
.PP
To try this out, move the cursor down three lines by
typing \fB<ctrl-U>3<ctrl-N>\fR;
now type \fB<esc>!\fR.
(Be sure to type an exclamation point \*(Ql!\*(Qr, not a
numeral one \*(Ql1\*(Qr, or your window will vanish.
The command \fB<esc>1\fR is explained below.)
The line to which you had moved the cursor
is now the first line in the window, and three new
lines have scrolled up from the bottom of the window.
You will find this command to be very useful as you
become more experienced at using windows.
.PP
All three special movement commands can also be used when your
screen has no extra windows, although you will not need them as much.
.Sh "One Buffer"
.PP
.II "MicroEMACS^window, use with editing"
.II "MicroEMACS^window, using multiple buffers"
Now that you have been introduced to the commands
for manipulating windows, you can begin
to use windows to speed your editing.
.PP
To begin with, scroll up the window you are in
until you reach the top line of your text.
You can do this either by typing the \fIscroll up\fR command
\fB<ctrl-X><ctrl-P>\fR several times, or by typing \fB<esc><\fR.
.PP
Kill the first line of text with the \fIkill\fR command \fB<ctrl-K>\fR.
The first line of text has vanished from all three windows.
Now, type \fB<ctrl-Y>\fR to yank back the text you just killed.
The line has reappeared in all three windows.
.PP
.II "MicroEMACS^buffer, with windows"
.II "MicroEMACS^file, with windows"
.II "MicroEMACS^switch buffer command"
.II "MicroEMACS^<ctrl-X>B"
The main advantage to displaying one buffer with more than one window
is that each window can display a different portion of the text.
This can be quite helpful if you are editing or moving a large text.
.PP
To demonstrate this, do the following:
First, move to the end of the text in your
present window by typing the \fIend of text\fR command \fB<esc>>\fR,
then typing the \fIprevious line\fR command \fB<ctrl-P>\fR four times.
Now, kill the last four lines.
.PP
You could move the killed lines to the beginning of your text
by typing the \fIbeginning of text\fR command \fB<esc><\fR;
however, it is more convenient simply to type the \fInext
window\fR command \fB<ctrl-X>N\fR, which moves you to
the beginning of the text as displayed in the next window.
\*(ME remembers a different cursor position for each window.
.PP
Now yank back the four killed lines by typing \fB<ctrl-Y>\fR.
You can simultaneously observe that the lines have been
removed from the end of your text and that they have been
restored at the beginning.
.Sh "Multiple Buffers" 
.PP
Windows are especially helpful when they display more than one text.
Remember that at present you are working with \fIthree\fR buffers, named
\fBexample1.c\fR,
\fBexample2.c\fR, and \fBexample3.c\fR, although your screen
is displaying only the text \fBexample3.c\fR.
To display a different text in a window, use the
\fIswitch buffer\fR command \fB<ctrl-X>B\fR.
.PP
Type \fB<ctrl-X>B\fR.
When \*(ME asks 
.DM
	Use buffer:
.DE
at the bottom of the screen, type
\fBexample1.c\fR.
The text in your present window is replaced with \fBexample1.c\fR.
The command line in that window
changes, too, to reflect the fact that the buffer and the file names are now
\fBexample1.c\fR.
.Sh "Moving and Copying Text Among Buffers"
.PP
.II "MicroEMACS^window, moving text among"
.II "MicroEMACS^window, copying text among"
.II "MicroEMACS^copying text"
It is now very easy to copy text among buffers.
To see how this is done, first kill the first line of \fBexample1.c\fR
by typing the \fB<ctrl-K>\fR command twice.
Yank back the line immediately by typing \fB<ctrl-Y>\fR.
Remember, the line you killed has \fInot\fR been
erased from its special storage area, and may be
yanked back any number of times.
.PP
Now, move to the previous window by typing \fB<ctrl-X>P\fR,
then yank back the killed line by typing \fB<ctrl-Y>\fR.
This technique can also be used with the \fIblock kill\fR command
\fB<ctrl-W>\fR to move large amounts of text from one buffer to another.
.Sh "Checking Buffer Status"
.PP
.II "MicroEMACS^window, buffer status command use"
.II "MicroEMACS^buffer status command, with windows"
The \fIbuffer status\fI command \fB<ctrl-X><ctrl-B>\fR can
be used when you are already displaying more than one window on your screen.
.PP
When you want to remove the buffer status window, use either
the \fIone window\fR command \fB<ctrl-X>1\fR, or move your
cursor into the buffer status window using the \fInext window\fR
command \fB<ctrl-X>N\fR and replace it with another buffer
by typing the \fIswitch buffer\fR command \fB<ctrl-X>B\fR.
.Sh "Saving Text From Windows"
.PP
The final step is to save the text from your windows and buffers.
Close the lower two windows with the \fIone window\fR
command \fB<ctrl-X>1\fR.
Remember, when you close a window, the text that it displayed
is still kept in a buffer that is \fIhidden\fR from your 
screen.
For now, do \fInot\fR save any of these altered texts.
.PP
.II "MicroEMACS^window, saving text"
When you use the \fIsave\fR command \fB<ctrl-X><ctrl-S>\fR, 
only the text in the window in which the cursor
is positioned is written to its file.
If only one window is displayed on the screen, the \fIsave\fR
command will save only its text.
.PP
If you made changes to the text in another buffer,
such as moving portions of it to another buffer, \*(ME would ask
.DM
	Quit [y/n]:
.DE
If you answer \*(Ql\fBn\fR\*(Qr, \*(ME will \fIsave\fR
the contents of the buffer you are currently displaying
by writing them to your disk, but it will ignore the
contents of other buffers, and your cursor will be returned
to its previous position in the text.
If you answer \*(Ql\fBy\fR\*(Qr, \*(ME again will save the
contents of the current buffer and ignore the other buffers,
but you will exit from \*(ME and return to the shell.
Exit from \*(ME by typing the \fIquit\fR command \fB<ctrl-X><ctrl-C>\fR.
.SH "Keyboard Macros"
.PP
A \fIkeyboard macro\fR is a set of \*(ME commands that are stored
in memory and given a name.
After you create a keyboard macro, you can execute it again and again
just by typing its name.
If you are revising a big file, you will find that keyboard macros are
one of the most useful features in \*(ME, and one that you will use
often.
.PP
The following table summarizes \*(ME's keyboard-macro commands:
.DS
.ta 0.5i 2.0i
	\fB<ctrl-X>(\fR	Open a keyboard macro
	\fB<ctrl-X>)\fR	Close a keyboard macro
	\fB<ctrl-X>E\fR	Execute a keyboard macro
.sp \n(pDu
	\fB<ctrl-X>M\fR	Rename a keyboard macro
	\fB<ctrl-X>I\fR	Bind current macro as initialization macro
.DE
.Sh "Creating a Keyboard Macro"
.PP
.II "MicroEMACS^end macro command"
.II "MicroEMACS^<ctrl-X>E"
.II "MicroEMACS^execute macro command"
To begin to create a macro, type the \fIbegin macro\fR
command \fB<ctrl-X>(\fR.
Be sure to type an open parenthesis \*(Ql(\*(Qr, not a numeral \*(Ql9\*(Qr.
\*(ME will reply with the message
.DM
	[Start macro]
.DE
Type the following phrase:
.DM
	MAXNUM
.DE
Then type the \fIend macro\fR command \fB<ctrl-X>)\fR.
Be sure you type a close parenthesis \*(Ql)\*(Qr, not a numeral \*(Ql0\*(Qr.
\*(ME will reply with the message
.DM
	[End macro]
.DE
Move your cursor down two lines and execute the macro
by typing the \fIexecute macro\fR command \fB<ctrl-X>E\fR.
The phrase you typed into the macro has been inserted
into your text.
.PP
If you give these commands in the wrong order, \*(ME
warns you that you are making a mistake.
For example, if you open a keyboard macro by typing \fB<ctrl-X>(\fR,
and then attempt to open another keyboard macro by again typing
\fB<ctrl-X>(\fR, \*(ME will say:
.DM
	Not now
.DE
Should you accidentally open a keyboard macro, or enter the
wrong commands into it, you can cancel the entire macro simply
by typing \fB<ctrl-G>\fR.
.Sh "Execute a Macro Repeatedly"
.PP
As with most \*(ME commands,
you can use a keyboard macro with an argument to execute it repeatedly.
For example, if you have defined a keyboard macro, then typing
.DS
	\fB<ctrl-U><ctrl-X>E\fR
.DE
executes that macro four times.
(Remember, four is the default value for
\fB<ctrl-U>\fR.)
.PP
As described above, \fB<ctrl-U>\fR normally is used with a positive number,
to indicate how often \*(ME should execute a given command or macro.
With keyboard macros, however, you can use a special value for \fB<ctrl-U>\fR:
\-1.
This tells \*(ME to repeatedly execute a keyboard macro until it fails.
.PP
For example, consider that you define the following keyboard macro:
.DS
	\fB<ctrl-S>\fR foo \fB<ctrl-K>\fR
.DE
This macro searches for the string ``foo'', then kills the rest of line
that that string is on.
Now, when you type the command
.DS
	\fB<ctrl-U>\fR \-1 \fB<ctrl-X>E\fR
.DE
executes this macro until \*(ME can no longer find the string ``foo'';
it then quits.
.PP
Obviously, you should define your macro carefully before you execute it
with this \-1 option to \fB<ctrl-U>\fR; otherwise, you can commit tremendous
mayhem on your file with one keystroke.
.Sh "Replacing a Macro"
.PP
To replace this macro with another, go through the same
process.
Type \fB<ctrl-X>(\fR.
Then type the \fIbuffer status\fR command
\fB<ctrl-X><ctrl-B>\fR, and type \fB<ctrl-X>)\fR.
Remove the buffer status window by typing the \fIone window\fR
command \fB<ctrl-X>1\fR. 
.PP
Now execute your keyboard macro
by typing the \fBexecute macro\fR command \fB<ctrl-X>E\fR.
The \fIbuffer status\fR command has executed once more.
.Sh "Renaming a Macro"
.PP
Many times during a long editing session, you will find that you
use one keyboard macro, then use a second keyboard macro, then find that
you need the first macro again.
In previous releases of \*(ME, the only way to do this work was to
type the first macro, replace it with the second macro, then retype
the first macro when you need it again.
The present edition of \*(ME, however, lets you define any number of
keyboard macros, and save them by giving each one a unique ``name'' \*(Em
that is, its own unique keyboard binding.
.PP
To rename a keyboard macro that you have already created, use the
\fIrename macro\fR command \fB<ctrl-X>M\fR.
To see how this works, do the following:
(1) Type \fB<ctl-X>(\fR to open the keyboard macro.
(2) Type \fB<esc>S\fR xyz \fB<ctrl-U> <ctrl-D>\fR
to fill the macro with something.
(3) Finally, type \fB<ctrl-X>)\fR to close the macro.
.PP
Now, type \fB<ctrl-X>M\fR, to rename the macro.
\*(ME will reply with the prompt:
.DM
	enter keybinding for macro
.DE
Type \fB<esc>L\fR.
This tells \*(ME to take the keyboard macro you created and link it to the
keystrokes \fB<esc>L\fR.
.PP
Now, whenever you type \fB<esc>L\fR, \*(ME will execute
\fB<esc>\fRs xyz \fB<ctrl-U> <ctrl-D>\fR.
You can now define another keyboard macro without wiping out the one
you have renamed.
There is no theoretical limit to the number of keyboard macros you can
create, although there are practical limits imposed by the amount of
memory available to \*(ME.
.Sh "Renaming Macros:  A Few Caveats"
.PP
Please note that if you name a keyboard macro with a keystroke that is
already defined, \*(ME will no longer be able to access
that keystroke's functionality.
.PP
For example, if instead of naming your new macro \fB<esc>L\fR you named it
\fB<ctrl-A>\fR, then every time you typed \fB<ctrl-A>\fR \*(ME would execute
\fB<esc>S\fR xyz \fB<ctrl-U> <ctrl-D>\fR and you would no longer be able
to jump to the beginning of a line (which \fB<ctrl-A>\fR normally does).
.PP
The only exceptions are \fB<ctrl-X>\fR, \fB<esc>\fR, and the
\fB<ctrl-X>R\fR command (described below),
which \*(ME will not let you reassign.
Obviously, you should be very careful when you assign a name to a keyboard
macro, or you could easily clobber much of the editor's functionality.
.PP
Note, too, that \*(ME lets you define reflexive keybindings, but these
never work.
For example, if you named the above example macro
.B <ctrl-D>
instead of
.BR <esc>L ,
then every time you typed \fB<ctrl-D>\fR \*(ME would try to execute a macro
that included \fB<ctrl-D>\fR in it.
Obviously, this can tie \*(ME into knots in no time.
Again, please be very careful when you assign names to keyboard macros.
.PP
The commands \fB<ctrl-X>S\fR and \fB<ctrl-X>L\fR let you save
all named keyboard macros into a file, and restore them during a later
editing session.
These commands are described in the next section.
.Sh "Setting the Initialization Macro"
.PP
\*(ME allows one macro to be specified which will be executed every time
\*(ME is invoked.
This ``initialization macro'' can be set using the key sequence
\fB<ctrl-X>I\fP and causes \*(ME to ``bind'' the currently defined macro
to the initialization macro.
.SH "Flexible Key Bindings"
.PP
As you have noticed by now, \*(ME works through standard \fIkey bindings:\fR
that is, one keystroke or combination of keystrokes tells \*(ME to perform
a particular task.
For example, typing \fB<ctrl-A>\fR tells \*(ME to move the cursor to the
beginning of the line; typing \fB<ctrl-E>\fR tells \*(ME to move the cursor
to the end of the line; and so on.
.PP
\*(ME
allows you to change its key bindings, so you can bind a given keystroke or
combination of keystrokes to a task other than the default one documented
in this tutorial.
In this way, you can reconfigure \*(ME so that it resembles another editor
with which you are more familiar.
.PP
To perform this magic, \*(ME
uses two tables for keybindings:
a \fIdefault table\fR that is loaded at compile time and never changes,
and a \fIdynamic table\fR
that you can modify with \*(ME's keybinding commands.
.PP
The following table summarizes \*(ME's commands for flexible keybindings:
.DS
.ta 0.5i 2.0i
	\fB<ctrl-X>R\fR	Replace one binding with another
	\fB<ctrl-X>X\fR	Rebind metakeys
.sp \n(pDu
	\fB<ctrl-X>S\fR	Save flexible bindings and macros into file
	\fB<ctrl-X>L\fR	Load flexible bindings and macros from file
.DE
.Sh "Changing a Keybinding"
.PP
The \fIreplace binding\fR command \fB<ctrl-X>R\fR replaces one binding with
another.
For example, if you wished to replace the \fIbeginning of line\fR command
\fB<ctrl-A>\fR with \fB<esc>Z\fR, you would do the following:
.RS
.IP \fB1.\fR
Type \fB<ctrl-X>R\fR to invoke the rebinding command.
.IP \fB2.\fR
When you see the prompt
.DM
	Enter old keybinding
.DE
type the keybinding you wish to change \*(Em in this case, \fB<ctrl-A>\fR.
.IP \fB3\fR
When you then see the prompt
.DM
	Enter new keybinding
.DE
type the keybinding to which you wish to change it \*(Em in this case,
\fB<esc>Z\fR.
.PP
Note that you cannot rebind the command \fB<ctrl-X>R\fR itself; otherwise,
you would paint yourself into a corner.
Also, note that if you rebind a command to itself (that is, if you type the
same keybinding in response to both prompts), then that keybinding is
bound to the old meaning of the keybindings, should there be any.
.II "MicroEMACS^metakey"
.Sh "Rebinding Metakeys"
.PP
\*(ME's keybindings depend on several pre-defined metakeys.
A \fImetakey\fR is a keystroke that introduces a further set of commands.
\*(ME's default keybindings use two metakeys:
.B <ctrl-X>
and
.BR <esc> .
Other editors use other keystrokes as metakeys.
If you wish to rebind a metakey, use the \fIrebind metakey\fR
command \fB<ctrl-X>X\fR.
This command prompts you to bind up to three metakeys, and the
argument key \fB<ctrl-U>\fR.
.PP
For example, suppose that you wish to change the metakey \fB<ctrl-X>\fR
to \fB<ctrl-Q>\fR.
To begin, type the command \fB<ctrl-X>X\fR.
You will see the prompt
.DM
	Enter prefix character 1 or space
.DE
``Prefix character 1'' is \fB<ctrl-X>\fR in the default bindings.
Type \fB<ctrl-Q>\fR.
You will then see the prompt:
.DM
	Enter prefix character 2 or space
.DE
``Prefix character 2'' is \fB<esc>\fR in the default bindings.
Since you do not want to change it, type \fB<space>\fR.
You will then see the prompt:
.DM
	Enter prefix character 3 or space
.DE
There is no ``prefix character 3'' in the default bindings, but you can
set a third one for your keybindings if you wish.
Since (for the sake of this example) you do not wish to set one, type
\fB<space>\fR.
Finally, you will see the prompt:
.DM
	Enter repeat code or space
.DE
The ``repeat code'' executes a command repeatedly; in this tutorial, it is
often called the ``argument key'' or ``argument command''.
Since (in this example) you do not wish to change it, type \fB<space>\fR.
.PP
Now that you have reset the \fB<ctrl-X>\fR metakey, you must now type
\fB<ctrl-Q>\fR every time in place of \fB<ctrl-X>\fR throughout all of
the \*(ME commands.
For example, if you wished to change the metakey back from
\fB<ctrl-Q>\fR to \fB<ctrl-X>\fR, you would have to type \fB<ctrl-Q>X\fR
to invoke the \fIrebind metakey\fR command.
.PP
Note that because \fB<ctrl-Q>\fR already is bound in the \*(ME keybindings,
when you rebind it the command
to which it was bound is no longer available to you.
However, if you un-rebind the key, then it automatically is rebound to its
old command.
In the above example, \fB<ctrl-Q>\fR is bound to the \fIinsert literal
character\fR command, which lets you insert control characters into your
file.
When you rebound the \fB<ctrl-X>\fR metakey to \fB<ctrl-Q>\fR, then the
\fIinsert literal character\fR command was no longer available to you.
However, when you re-rebound the \fB<ctrl-Q>\fR metakey to \fB<ctrl-X>\fR,
then \fB<ctrl-Q>\fR was automatically rebound to the \fIinsert literal
character\fR command.
.\" Got that?
.PP
To change the first prefix character back to
.BR <ctrl-X> ,
type
.BR <ctrl-Q>X ,
then enter
.B <ctrl-X>
when you see the prompt for prefix character 1.
This restores the original metacharacter.
Note, however, that the original function of
.B <ctrl-Q>
(which is to let you embed control characters within a file)
is no longer available to you:
\*(ME ``forgot'' its original function when you made
.B <ctrl-Q>
into a prefix character.
.Sh "Save and Restore Keybindings"
.PP
\*(ME lets you save your rebound keybindings into a file, and reload
them during another editing session.
To save your keybindings into a file, type the \fIsave keybindings\fR command
\fB<ctrl-X>S\fR.
Try it.
You will see the prompt:
.DM
	Store bindings file:
.DE
Type the name of a file.
\*(ME then writes its keybindings into that file.
This command saves all named keyboard macros that you
have created.
It also saves other aspects of the \*(ME environment that you have set;
for example, if you have turn on word-wrapping, that fact will be saved.
.PP
To restore a set of keybindings, use the \fIrestore keybindings\fR command
\fB<ctrl-X>L\fR.
Try it.
You will see the prompt:
.DM
	Load bindings file:
.DE
Type the name of the file in which you saved \*(ME' keybindings
and all named keyboard macros.
\*(ME will then load them into memory for you.
.PP
These commands let you prepare several sets of customized keybindings
and macros.
You can customize keybindings to suit your preference, or create custom
sets of macros to suit any
number of specialized editing tasks.
.PP
.II .emacs.rc
.II "MicroEMACS^.emacs.rc"
By default, \*(ME checks for the existence of file
.B "$HOME/.emacs.rc"
and executes it if found.
You can generate a copy of
.B .emacs.rc
using the save-keybindings command \fB<ctrl-X>S\fR.
The \*(ME command-line option \fB\-f\fR lets you specify an alternate file of
keybindings macros.
After it load \fB.emacs.rc\fR,
\*(ME then executes the initialization macro, if one exists.
For example, if you wish to use the set of keybindings saved in file
\fBkeybind\fR to edit file \fBtextfile\fR, then you would type the following:
.DM
	me -f keybind textfile
.DE
As you can see, \*(ME's system of keyboard macros and flexible key bindings
help make it an extremely flexible and powerful editor.
.SH "Sending Commands to COHERENT"
.PP
.II "MicroEMACS^program interrupt"
.II "MicroEMACS^<ctrl-X>!"
The only remaining commands you need to learn are
the \fIprogram interrupt\fR commands \fB<ctrl-X>! and \fB<ctrl-C>\fR.
These commands allow you to interrupt your editing, give a command
directly to the shell,
and then resume editing without affecting your text in any way.
.PP
The command \fB<ctrl-X>!\fR allows you to send \fIone\fR
command line (one command, or several commands plus separators)
to the operating system.
To see how this command works, type \fB<ctrl-X>!\fR.
The prompt
\fB!\fR
has appeared at the bottom of your screen.
Type
\fBlc\fR.
Observe that the directory's table of contents scrolls across your
screen, followed by the message \fB[end]\fR.
To return to your editing, simply type a carriage return.
.II "MicroEMACS^<ctrl-C>"
The \fIinterrupt\fR command \fB<ctrl-C>\fR suspends editing
indefinitely, and allows you to send an unlimited number
of commands to the operating system.
To see how this works, type \fB<ctrl-C>\fR.
After a moment, the \*(CO system's prompt will
appear at the bottom of your screen.
Type \fBtime\fR.
The \*(CO system replies by printing the time and date.
To resume editing, then simply type \fB<ctrl-D>\fR. 
.PP
If you wish, you can suspend \*(ME's operation, tell the
\*(CO system to invoke another copy of the \*(ME program,
edit a file, then return to your previous editing.
To see how this is done, type \fB<ctrl-C>\fR.
When the prompt appears at the bottom of your screen, type
.DM
	me example1.c
.DE
It doesn't matter that you are already editing \fBexample1.c\fR.
\*(ME will simply copy the \fBexample1.c\fR file into a new
buffer and let you work as if the other \*(ME program
you just interrupted never existed.
.PP
Exit from this second \*(ME program by typing the \fIquit\fR command 
\fB<ctrl-X><ctrl-C>\fR.
Then type \fB<ctrl-D>\fR.
Your original \*(ME program has now been resumed.
However, none of the changes you made in the
secondary \*(ME program will be seen here.
.PP
It is not a good idea to use multiple \*(ME programs to edit
the same program:  it is too easy to become confused as to
which edits were made to which version.
.PP 
The only time this is advisable is if you wish to test to see
how a certain edit would affect your text:
you can create a new \*(ME program,
test the command, and then destroy the altered buffer and return
to your original editing program without having to worry that you
might make errors that are difficult to correct.
.PP
Now type \fB<ctrl-X><ctrl-C>\fR to exit.
.Sh "Compiling and Debugging Through MicroEMACS"
.II "MicroEMACS^compiling and debugging"
.II "cc^MicroEMACS mode"
.II "MicroEMACS^automatic mode"
.PP
\*(ME can be used with the compilation command
.B cc
to give you a reliable system for debugging new programs.
.PP
Often, when you're writing a new program, you face the situation in which
you try to compile, but the compiler produces error messages
and aborts the compilation.
You must then invoke your editor, change the program, close the editor,
and try the compilation over again.
This cycle of compilation \*(Em editing \*(Em recompilation can be quite
bothersome.
.PP
To remove some of the drudgery from compiling, the
.B cc
command has the
.IR automatic ,
or
\*(ME option,
.BR \-A .
When you compile with this option, the \*(ME screen editor will
be invoked automatically if any errors occur.
The error or errors generated during compilation will be displayed in
one window, and your text in the other, with the cursor set at the
number of the line that the compiler indicated had the error.
.PP
Try the following example.
Use \*(ME to enter the following program, which you should call
.BR error.c :
.DM
	main() {
		printf("Hello, world!\en")
	}
.DE
The semicolon was left off of the
.B printf()
statement, which is an error.
Now, save the file and exit from \*(ME; then
try compiling
.B error.c
with the following
.B cc
command:
.DM
	cc -A error.c
.DE
You should see no messages from the compiler because they are all being
diverted into a buffer to be used by \*(ME.
Then \*(ME will appear automatically.
In one window you should see the message:
.DM
	3: error.c : missing ';'
.DE
and in the other you should see your source code for
.BR error.c ,
with the cursor set on line 3.
.PP
If you had more than one error, typing
.B <ctrl-X>>
.II "MicroEMACS^<ctrl-X>>"
.II "MicroEMACS^next error"
would move you to the next line with an error in it; typing
.B <ctrl-X><
.II "MicroEMACS^<ctrl-X><"
.II "MicroEMACS^previous error"
would return you to the previous error.
With some errors, such as those for missing braces or
semicolons, the compiler cannot always tell exactly which line the
error occurred on, but it will almost always point to a line that
is near the source of the error.
.PP
Now, correct the error by typing a semicolon at the end of line 2.
Close the file by typing
.BR <ctrl-Z> .
.B cc
will be invoked again automatically.
.PP
.B cc
will continue to compile your program either until the program compiles
without error,
or until you exit from \*(ME by typing
.B <ctrl-U>
followed by
.BR <ctrl-X><ctrl-C> .
.Sh "The MicroEMACS Help Facility"
.II "MicroEMACS^help, in MicroEMACS"
.II "MicroEMACS^help window"
.PP
\*(ME has a built-in help function.
With it, you can ask for information either for a word that you
type in, or for a word over which the cursor is positioned.
The \*(ME help file contains the bindings for all library
functions and macros included with \*(PN.
.PP
For example, consider that you are preparing a C program and want more
information about the function
.BR fopen .
.II "MicroEMACS^<ctrl-X>"
Type \fB<ctrl-X>?\fR.
At the bottom of the screen will appear the prompt
.DM
	Topic:
.DE
Type \fBfopen\fR.
\*(ME will search its help file, find its entry for
.BR fopen ,
then open a window and print the following:
.DM
	fopen - Open a stream for standard I/O
	#include <stdio.h>
	FILE *fopen (name, type) char *name, *type;
.DE
If you wish, you can kill the information in the help window
and yank it into your program to ensure that you prepare the
function call correctly.
.PP
Consider, however, that you are checking a program written earlier,
and you wish to check the call to \fBfopen\fR.
Simply move the cursor until it is positioned over one of the letters in
\fBfopen\fR, then type \fB<esc>?\fR.
.II "MicroEMACS^<esc>?"
\*(ME will open its help window, and show the same information it
did above.
.PP
.II "MicroEMACS^<esc>2"
To erase the help window, type \fB<esc>1\fR.
.SH "Where To Go From Here"
.PP
For a complete summary of \*(ME's commands, see
the entry for
.B me
in the Lexicon.
The \*(CO system includes three other editors: the stream editor \fBsed\fR,
the popular screen editor \fBvi\fP,
and the interactive line editor \fBed\fR.
Each can help you accomplish editing tasks that may not be well suited for
\*(ME.
For more information on these editors, see their tutorials or check their
entries in the Lexicon.

.ds PN "GNU Tools for COHERENT"
.ds T2 "Release  Notes"
.ds CR "1994"
.ds VN 2.0
.ds OS COHERENT
.ll 6.5i
.wh 0 HD
.wh -1.5i FO
.de HD
.sp |3i
..
.de FO
.bp
..
.po 1i
.sp
.ce
\f(HH\*(PN \*(VN\fR
.sp
.ce
\f(HH\*(T2\fR
.sp 2
.ce 1
Copyright \(co \*(CR
.sp 3
.ce 5
\*(MW
60 Revere Drive
Northbrook, Illinois  60062
Telephone:  (708) 291-6700
Fax:  (708) 291-6750
.sp 7
.ce 10
.fi
Mark Williams Company makes no warranty of any kind with respect
to this material and disclaims any implied warranties of
merchantability or fitness for any particular purpose.
.sp
The information contained herein is subject to change without notice.
.sp 3
.ce 1
Printed in U.S.A.

.ds TL "TCP/IP Commands"
.NH "Introduction to TCP/IP Commands"
.PP
This chapter introduces the commands with which
you can interact with other hosts on your network.
You can use these commands to communicate
with any other host that supports TCP/IP.
.PP
For information on terminology and the concepts that underlie TCP/IP, see the
previous chapter,
.IR "Administering TCP/IP" .
.SH "ftp:  Transfer Files"
.PP
The command
.B ftp
lets you to transfer files between your local COHERENT host
and any remote host that runs an
.B ftp
server.
.PP
To use
.BR ftp ,
invoke the
.B ftp
client on your local system.
It will establish connection with the
.B ftp
server on the remote host.
After you log into the remote host, you can issue
.B ftp
subcommands to exchange files with that host.
.PP
The remote server can be the one supplied by NCM.
In this section, it is assumed that all
.B ftp
server messages come from a Racal InterLan server running on a remote UNIX host.
If the remote host is running another type of server,
the messages you see may be different.
If the remote host runs a different operating system,
.B ftp
uses the format for that system
(for example, directory listings appear in the style of the remote host).
.Sh "How to Invoke ftp"
.PP
To invoke this command, type
.B ftp
followed by the name of the remote host.
You can name the host by either its host name or its Internet address.
For example, to connect to host
.B whouse
whose Internet address is 89.0.0.1, type either
.DM
	ftp whouse
.DE
or
.DM
	ftp 89.0.0.1
.DE
If
.B ftp
can make the connection, you see messages similar to the following:
.DM
	Connected to whouse ftp server
	(Version 1.00 Mon Sep 26 00:36:28 EDT 1986) ready
.DE
The first message comes from the
.B ftp
client on your system; it verifies that the
server has succeeded in connecting to the remote host.
The message echoes the host's name or its Internet address, whichever you used.
The second message comes from the
.B ftp
server on the remote host;
it uses a numbered response to identify itself and indicate its status.
(The server also displays its version number and date of creation.)
The significance of the server's numbered responses is described below.
.PP
If you invoke
.B ftp
without an argument,
you enter
.BR ftp 's
command interpreter;
this is signified by the prompt
.BR ftp>> .
You can then connect to a remote host by issuing the
.B ftp
command
.BR open .
.BR ftp 's
suite of commands is introduced below.
.PP
You can include various options on the
.B ftp
command line.
For a complete list of
.BR ftp 's
command-line options, see its entry in the Lexicon at the back of this manual.
.Sh "Connection Error Messages"
.PP
Sometimes
.B ftp
cannot contact a server on the remote host:
the remote host may not be up
or not running an
.B ftp
server.
.PP
Your
.B ftp
client tries for a reasonable time
to connect to the remote host, then quits
and sends you the error messages:
.DM
	Connection timed out.
.DE
After you get this error message, the
.B ftp
prompt
.B ftp>
appears.
You can then try to connect again by using the
.B ftp
command
.BR open .
.PP
You will also fail to connect if you type an invalid Internet address
or an invalid host name (for example, if you type
.B badrock
instead of
.BR whouse ).
In this case, you get the following error message:
.DM
	badrock: Unknown host.
.DE
When you get this error message, issue the
.B open
command with the correct host name at the
.B ftp
prompt.
.Sh "Logging in to the Remote Host"
.PP
After the
.B ftp
client establishes a connection with a remote host,
you must log into the remote host.
.B ftp
then prompts you for your user name and password.
.PP
For example, assume that you have connected to a remote host called
.BR whouse .
By default,
.B ftp
also uses the name you gave on the local host (for example,
.BR hillary )
as the user name on the remote host.
You therefore see
.DM
	Name (whouse:hillary):
	331 Password required for hillary
	Password (whouse:hillary):
.DE
To use the default login name that
.B ftp
displays, simply press the
.B <Return>
key; if you wish to log under a different user name, type that instead and
then press
.BR <Return> .
.B ftp
then prompts you for your password; enter that and press
.BR <Return> .
.PP
After
.B ftp
accepts your password, it displays a message that verifies that
you have logged into the remote system, then the
.B ftp
prompt.
Once you see the prompt, you can issue any of the
.B ftp
commands to exchange files with the remote host,
obtain information,
or alter the behavior of
.B ftp
itself.
.PP
If you do not give the correct password, the login
process fails and you receive the following messages:
.DM
	530 Login incorrect.
	Login failed.
.DE
These messages display the two types of error messages you can get while using
.BR ftp .
The first message, preceded by the three-digit number,
comes from the server;
the second comes from the client.
To try to log in again, issue the
.B user
command described in the next section.
.Sh "Issuing ftp Commands"
.PP
Under
.BR ftp ,
you must connect to a remote host and log in before you can issue
the full suite of
.B ftp
commands.
For a complete list of its commands, see the entry for
.B ftp
in the Lexicon at the end of this manual.
.PP
If, for example, you try to give a command like
.B ascii
before you have established a connection, you see the following error message:
.DM
	Not connected.
.DE
To connect to a remote host, you must
first issue the command
.BR open ,
as described below.
.PP
Type all
.B ftp
commands in lower-case letters.
You can abbreviate the subcommands, as long as the
abbreviation is unambiguous; for example, the subcommand
.B binary
can be abbreviated to
.BR bi ,
to distinguish it from
.BR bell ,
which can be abbreviated to
.BR be .
.PP
If you make a mistake when you issue an
.B ftp
subcommand, you receive the message:
.DM
	Invalid command.
.DE
The following subsections introduce some of the most important
.B ftp
commands.
.Sh "open:  Connect to a Remote Host"
.PP
If you have not already connected to a remote host,
or wish to connect to another remote host after you have
closed a connection, use the command
.B open
followed by a host name or Internet address.
If you issue the command without specifying a host name or Internet address,
.B ftp
prompts you for an entry.
The following commands opens a connection to remote host
.BR whouse :
.DM
	open whouse
.DE
If you type a valid host name or Internet address and
.B ftp
can make the connection, you receive the connection
messages shown above, and are prompted to log into the remote host.
.Sh "user:  Log into a Remote Host"
.PP
The command
.B user
lets you log into a remote host.
Just type
.B user
at the
.B ftp
prompt, followed by your login identifier.
.B ftp
will prompt you for your password.
.B ftp
will then send you a message to indicate if you have succeeded in
logging into the remote host.
.Sh "ascii, binary, and type:  Choose a File-Transfer Type"
.PP
.B ftp
can transfer both
ASCII and binary (or ``image'') files.
.BR ftp ,
however, uses different methods to transfer each type of file;
you must tell it what type of file you wish to transfer at any given time.
To select a file type, use the commands
.BR ascii ,
.BR binary ,
and
.BR type .
.PP
The command
.B ascii
tells
.B ftp
that you wish to transfer text files.
This is the default.
.PP
The command
.B binary
tells
.B ftp
that you wish to transfer binary files.
You then receive the following message:
.DM
	200 Type set to I.
.DE
The letter `I' in the message stands ``image''.
.PP
The command
.B type
also changes the file-transfer type.
You can specify
.BR ASCII ,
.BR binary ,
or
.BR image .
For example, the command
.DM
	type image
.DE
changes the file type to image (i.e., binary).
.PP
If you do not specify a type, the
.B type
command displays the current file-transfer type.
.Sh "dir and ls:  Read Directory Contents"
.PP
.B ftp
provides commands with which you can read and manipulate directories.
The commands
.B dir
and
.B ls
print the contents of a directory on the remote host \(em
by default, the directory that you are in.
.PP
Both commands can be invoked with an argument that names a directory
or files on the remote host.
For example, the command
.DM
	dir /bin
.DE
prints the contents of directory
.B /bin
on the remote host.
You can use wildcards in an argument; for example, the command
.DM
	ls /bin/uu*
.DE
prints the name of every file in
.BR /bin
that begins with the string
.BR uu .
For details on how to use wildcards, see the article
.B wildcards
in the COHERENT manual's Lexicon.
.PP
These commands differ in that
.B dir
prints the name of each file, its size, and the date it was last modified,
whereas
.B ls
just prints its name.
.PP
When you read the contents of a directory on the remote system,
the remote system's server sends you numbered
responses to show how it has handled your request.
For example, the message
.DM
	Opening data connection for /bin/ls (89.0.0.1, 1166).
.DE
names the directory that you are reading, and
(in parentheses) the Internet address and the port number,
respectively, separated by a comma.
.Sh "cd and pwd:  Change Directory, Print Working Directory"
.PP
.B ftp
also lets you change your directory.
To change to another directory on the remote host, type
.B cd
followed by the name of the new directory.
As with the COHERENT shell, the abbreviation `..' stands for the
parent directory of the current directory.
To change directories on your local host, type
.B lcd
(for ``change local directory'')
followed by the name of the directory to which you wish to switch.
.PP
For example, to change from directory
.B /usr1/tony
on the remote host to
.BR /usr1/tony/junk ,
for example, type:
.DM
	cd junk
.DE
When
.B ftp
changes the directory to the one you specify, it prints the message:
.DM
	200 CWD okay.
.DE
The command
.B pwd
tells you what directory you are in on the remote host.
.Sh "get and put: Transfer Files"
.PP
The commands
.BR get ,
.BR mget ,
.BR put ,
and
.B mput
copy files between your local host and the remote host.
The
.B get
commands copy files from the remote host to your local host; whereas the
.B put
commands copy them from your local host to the remote host.
The syntax of these commands closely resembles that of the COHERENT command
.BR cp .
.PP
To transfer one file from the remote host to your local host,
use the command
.BR get ,
followed by the name of the file on the remote host that you wish to copy
and the name of the file on your local host into which you wish to copy it.
If you do not name a file on your local system,
.B ftp
gives the copied file the same name it had on the remote host.
If your system already has a file by that name in your current directory,
.B ftp
overwrites it.
If you type
.B get
without an argument,
.B ftp
prompts you for a remote file, and then for the local file.
.PP
For example, to copy file
.B myfile
from the remote host to your local host, type:
.DM
	get myfile
.DE
To copy the file
.B work1
into file
.B morework
on your local system, issue the following:
.DM
	get work1 morework
.DE
If
.B ftp
does not encounter any errors, you will see the following messages:
.DM
	150 Opening data connection for work1 (89.0.0.2, 1124).
	226 Transfer complete.
.DE
To copy one file from your system to the remote system, use the command
.BR put ,
followed by the name of the file you are transferring and the name of
the file into which it will be written.
If you do not name a file on the remote host,
.B ftp
gives it the same name it has on the local host.
If the current directory on the remote host already has a file
by that name, the
.B ftp
server on the remote system will change its version number,
notify you that a file already exists under that name,
or overwrite the existing file,
depending upon the implementation of the server.
If you simply type the command
.BR put ,
.B ftp
first prompts you for a local file, and then for the name of the remote file.
.PP
For example, to transfer file
.B lanplan.p1
to the remote host under the name
.BR lanplan.p2 ,
type:
.DM
	put lanplan.p1 lanplan.p2
.DE
Assuming there are no errors,
.B ftp
prints the message:
.DM
	Opening data connection
.DE
The commands
.B mget
and
.B mput
copies multiple files.
.B mget
copies the files you name on its command line from the remote host to
your local host; whereas
.B mput
copies them from your local host to the remote host.
These commands also let you use wildcards to name multiple files, assuming
that you have turned on wildcards for
.B ftp
(as described below).
.PP
For example, to transfer the files
.BR profits ,
.BR taxes ,
and
.B lawyer.fee
to the remote host's current directory, type:
.DM
	mput profits taxes lawyer.fee
.DE
To copy every file with the suffix \fB.c\fR
from the current directory on the remote host into your
current directory on the local host, type:
.DM
	mget *.c
.DE
When
.B ftp
copies files (whether ASCII or binary)
from your local COHERENT host to a remote host,
the files retain their contents.
They may not, however, retain all of their original attributes.
This problem arises because COHERENT has file attributes
that do not correspond to the attributes assigned on other
operating systems.
For example, if you
copy your COHERENT files to
a remote VMS host system and then back to your local COHERENT host,
.B ftp
cannot guarantee that the returned files will
have all of their original attributes.
.PP
Even between two COHERENT systems, there is the possibility that file
attributes will be lost during file transfers.
For example, an executable file that is
.BR ftp 'd
from one COHERENT system
to another will not have execute status on the remote system.
.PP
.B ftp
does not have any way to restoring file attributes lost during transfer.
However, you can use the COHERENT commands
.BR chmod ,
.BR chown ,
and
.B chgrp
to restore the attributes of all files copied onto your local host.
See these commands' entries
in the COHERENT manual's Lexicon for details on how to use them.
.Sh "!:  Give a Command to the Local Shell"
.PP
To issue a command to your local COHERENT system while
connected to a remote host, use the command
.B !
followed by the command you want to execute.
For example, to delete the local file
.BR pcnotes ,
type:
.DM
	ftp>> !rm pcnotes
.DE
When the command has finished executing, you automatically return to
.BR ftp .
.PP
If you type
.B !
without a command,
.B ftp
spawns a new shell on your local host.
You can issue multiple commands to your local COHERENT system, while
.B ftp
maintains your connection to the remote host.
When you exit from the shell,
you return to the
.B ftp
session.
.PP
Note that when you use
.B !
to create a new shell,
any directory operations you perform do not affect your current directory in
.BR ftp .
When you return to
.BR ftp ,
your current directory returns to being what it was before you issued the
.B !
command.
.Sh "help and ?:  Get Help"
.PP
The command
.B help
displays information about an
.B ftp
command.
For example, if you type
.DM
	help mput
.DE
.B ftp
prints a message on how to use
.BR mput .
.PP
If you do not name a command,
.B ftp
simply lists its commands.
.PP
The command
.B ?
is a synonym for
.BR help .
.Sh "status:  Check the Status of ftp"
.PP
The command
.B status
displays the current settings of the
.B ftp
client.
For example,
if you have not changed any of the default settings and you are
connected to remote host
.BR whouse ,
.B status
would display the following:
.DM
	Connected to whouse.
	Mode:stream; Type:ascii; Form:non-print; Structure:file;
	Verbose:on; Bell:off; Prompting:on; Globbing:on;
	Hash-mark printing:off; Use of PORT cmds:on
.DE
As shown,
.B ftp
has various settings that you can toggle on or off.
To toggle a setting, simply issue the appropriate command.
For example, to turn verbose mode off (when you do not
want to see any server messages), issue the verbose command.
.PP
Please note that
.B ftp
allows you to change the file-transfer type
(by using the commands \fBascii\fR and \fBbinary\fR, as described above);
.B ftp
does
.I not
let you change the settings
.BR mode ,
.BR form ,
and
.B structure
because they define how
.B ftp
transmits data.
The mode
.B stream
transmits all data as a stream of bytes,
instead of as a block or as compressed data.
The format
.B non-print
specifies that
.B ftp
should not interpret the vertical-format information
that normally are used when a file is printed.
This format is designed for files that are processed or just stored using
.BR ftp .
The file-structure setting determines that a file in
.B ftp
will have no internal structure (instead of a record or page structure)
and will be considered a continuous stream of bytes.
.Sh "close, bye, and quit:  Close a Connection and Exit from ftp"
.PP
The command
.B close
closes a connection to a particular host but does not end your
.B ftp
session.
When you have closed a connection, you are free either to exit from
.BR ftp ,
or to
.B open
a connection with another remote host.
Note that you cannot
.B open
a connection to a new remote host until you have
.BR close d
the connection to the host to which you are currently connected.
.PP
To exit from
.BR ftp ,
type the command
.BR bye .
This command closes
the connection with the remote host, and return you to the COHERENT shell.
The command
.B quit
is a synonym for
.BR bye .
.Sh "Interpreting ftp Server Messages"
.PP
During the course of an
.B ftp
session, you will receive messages from both the
.B ftp
client (which is running on your local host), and the
.B ftp
server (which is running on the remote host).
Messages that consist of a three-digit number followed by text
come from the server.
Although most messages are self-explanatory, you should find it helpful to
know what the three-digit numbers mean.
.PP
Although each digit has its own meaning, the first digit is the most
important.
The following explains what each first digit signifies:
.IP \fB1\fR 0.3i
A positive preliminary reply.
This means that probably you will receive another message before you can
issue another command.
An example is the message
.DM
	150 Opening data connection
.DE
that appears after you issue the commands
.BR dir ,
.BR get ,
or
.BR put .
.IP \fB2\fR
The
.B ftp
server succeeded in carrying out your command
and you are free to issue a new command.
An example is the message:
.DM
	200 PORT command okay
.DE
.IP \fB3\fR
Your command is fine, but the
.B ftp
server needs more information before it can execute the command.
An example is the message:
.DM
	331 Password required for hillary
.DE
.IP \fB4\fR
The
.B ftp
server did not accept your command,
but that this error condition is not permanent:
you can try again later.
An example is the message:
.DM
	425 Can't build data connection
.DE
.IP \fB5\fR
A permanent error condition:
you probably made a mistake when specifying the command or answering a prompt.
An example is the message:
.DM
	530 Login incorrect
.DE
.Sh "Sample Session"
.PP
In the following session, user
.B beowulf
wants to connect to a remote host called
.BR denmark .
User input appears in
.IR italic ;
system output appears in Roman.
.DS
	\fIftp denmark\fR
	Connected to denmark.
	220 denmark FTP server (Version 1.00 Tues Oct 1600:32:21 EDT 1986) ready
	Name (denmark:beowulf):
	331 Password required for beowulf.
	Password (denmark:beowulf): \fIpassword\fR
	230 User beowulf logged in.
.DE
.DS
	ftp>> \fIpwd\fR
	250 /usr/beowulf is current directory.
.DE
.DS
	ftp>> \fIcd heorot\fR
	200 CWD okay.
.DE
.DS
	ftp>> \fIpwd\fR
	250 /usr/beowulf/heorot is current directory.
.DE
.DS
	ftp>> \fIls\fR
	200 PORT command okay.
	150 Opening data connection for /bin/ls	(89.0.0.3,1216)
	grendel
	grendelsmom
	hrothgar
	hrunting
	hunferth
	226 Transfer complete.
.DE
.DS
	ftp>> \fIget grendel\fR
	150 Opening data connection for grendel (129.0.0.34,1124)
	226 Transfer complete.
.DE
.DS
	ftp>> \fIclose\fR
	221 Goodbye.
	ftp>>
.DE
.SH "rcpy:  Copy Files Among Remote Hosts"
.PP
The command
.B rcpy
lets you copy one file, multiple files, or entire directories
among hosts on which you have login accounts.
.PP
For you to use this command, the
remote host
must be running the
.B rshl
server.
You must have an account on the remote host,
and the remote host must name your local host in its copy of the file
.BR /etc/hosts.equiv .
If your login on the remote host does not have the same name as your
login on your local host, then the file
.B \&.rhosts
in your home directory on the remote host must name your local host and
your login identifier on the local host.
This is described more fully below.
.PP
.B rcpy
has a number of advantages over
.BR ftp .
For example, it can handle third-party transfers:
that is, it can transfer a file from one remote host to another, without
having to use your local host as a go-between.
It does not require that you log into the system to which you are
copying files, nor does it have
.BR ftp 's
long list of commands.
However,
.B rcpy
does not confirm a successful transfer \(em it assumes you will do so
on your own.
.Sh "How to Invoke rcpy"
.PP
To invoke
.BR rcpy ,
type the command followed by the names of the source file and the
destination file.
Each argument specifies a file's name and host, in the form:
.DM
	host:filename
.DE
If you omit
.IR host: ,
.B rcpy
assumes that you mean the local host.
Remote file names are interpreted relative to your home directory on
the remote host; to override this default, use full path names.
You should not use a literal colon in a file name,
because
.B rcpy
will think that the colon is the separator between the host and file names.
.PP
For example, to copy file
.B hrunting
from your home directory on host
.B denmark
to file
.B sword
in your home directory on host
.BR sweden ,
use the command:
.DM
	rcpy denmark:hrunting sweden:sword
.DE
If
.B sword
already exists in your home directory on host
.BR sweden ,
.BR rcpy
overwrites it.
.Sh "Copying Directories and Multiple Files"
.PP
To copy an entire directory, issue
.B rcpy
with the option
.B \-r
(recursion), followed by arguments that name the source and
target directories.
When you specify
.BR \-r ,
.B rcpy
traverses the source directory and transfers all files and subdirectories.
.PP
For example, to copy the directory
.B /usr/siegfried/dragon
on system
.B nibelung
to your home directory on system
.BR sweden ,
type the command:
.DM
	rcpy -r nibelung:/usr/siegfried/dragon sweden:
.DE
.PP
You can also use the option
.B \-r
to copy multiple individual files.
For example, to copy files
.B sword
and
.B shield
into your home directory on host
.BR sweden ,
type:
.DM
	rcpy -r sword shield sweden:
.DE
As with all COHERENT commands, you can use wildcards on the
.B rcpy
command line to name multiple files.
If a file name contains a literal wildcard character, be sure to
quote it before you name it on the
.B rcpy
command line.
For information on wildcards, see the entry
.B wildcards
in the COHERENT manual's Lexicon; and for information quoting wildcards, see
the entries for
.B sh
and
.B ksh
again in the COHERENT manual's Lexicon
.Sh "Specifying a Different Remote User name"
.PP
By default,
.B rcpy
assumes that you have the same login identifier on all of the
hosts among which you are copying files.
However,
.B rcpy
permits you to copy files even if your login identifiers differ.
For this mechanism to work, your local host and local login identifier must
appear in the file
.B \&.rhosts
in your home directory on the remote host.
.PP
For example, assume that on the local host
.B lepanto
your login identifier is
.BR fred ,
whereas on the remote host
.B mwc
your login identifier is
.BR fwb .
In your home directory on
.BR mwc ,
you should have a file \fB.rhosts\fR, which should contain the entry:
.DM
	lepanto	fred
.DE
You can use this mechanism to allow other users to masquerade as yourself
when they communicate with a host;
however, such a person assumes all of your privileges on that host, so you
would be wise not to do that unless you absolutely had to.
.PP
To transfer to a host on which you have a different login identifier,
use the form
.DM
	host.ruser:filename
.DE
for file arguments, where
.I ruser
is your name on the remote host.
.PP
To extend the above example, to transfer file
.B docfiles
from your local system to your home directory on system
.BR mwc ,
use the command:
.DM
	rcpy docfiles mwc.fwb:docfiles
.DE
.Sh "Error Messages"
.PP
Under certain conditions,
.B rcpy
may not be able to connect with a remote host.
An attempt to connect will fail if, for example,
the remote host is not operating
or if remote host is not running the server
.BR rshl .
.B rcpy
tries to make the connection for a reasonable period of time,
then sends you the error message
.DM
	Connection timed out.
.DE
and quits.
.PP
You will also get an error message if you specify an
invalid host name or make a typing error in the host name.
.SH "rlogin:  Log into a Remote Host"
.PP
The command
.B rlogin
lets you log into a remote host as if you were directly connected to it.
When you invoke
.BR rlogin ,
the client connects with the
.B rlogind
server that is running on the remote host.
.PP
.B rlogin
makes certain assumptions about the remote host, and observes
various login conventions.
For example, if the remote host identifies your local host in its file
.BR /etc/hosts.equiv ,
.B rlogin
automatically uses your local user name to identify you to the remote host.
.PP
When you use
.B rlogin
to log into a remote host, that remote host executes your
.B \&.profile
automatically, just as if you had logged directly into that host.
Before you use
.B rlogin
to log into a remote host, make sure that your account on the remote system
will support your connection into your local host \(em for example, that the
terminal type is set correctly.
.Sh "How to Invoke rlogin"
.PP
If your local system shares user names with the
remote host to which you want to connect, invoke
.B rlogin
from the COHERENT shell:
type
.B rlogin
followed by the host name of the remote system.
.PP
Assume, for example, that a user called
.B beowulf
has accounts under that name on two hosts,
.B denmark
and
.BR geatland .
He is logged in locally to
.BR geatland ,
and wants to log in to the remote host
.BR denmark .
If
.B denmark
names
.B geatland
in its file
.BR /etc/hosts.equiv ,
.B beowulf
can connect to
.B denmark
by issuing the following
.B rlogin
command:
.DM
	rlogin denmark
.DE
If
.B rlogin
can make the connection,
.B beowulf
is logged into
.BR denmark ;
depending on the configuration of the remote host, he may be prompted for
the password to his account on the remote host.
When the login process completes, he gets the shell prompt from
.B denmark
and can proceed as if he were directly connected.
.Sh "Specifying a Different Remote User Name"
.PP
If you want to log into the remote host under a different user name,
use the option
.B \-l
on the
.B rlogin
command line, followed by the name by which you wish to log into the remote
host.
For example, if user
.B beowulf
wants to log into
the remote host
.B denmark
under the account
.BR hygelac ,
he gives the
.B rlogin
command as follows:
.DM
	rlogin denmark -l hygelac
.DE
If
.B rlogin
connects with host
.BR denmark ,
it prompts
.B beowulf
for the password to account
.BR hygelac .
.PP
The process can be even simpler.
The remote user can maintain in his login directory a file called
.B \&.rhosts
that names the users on other hosts who can log into his account.
For information on how to use this file, see its entry in the Lexicon
at the back of this manual.
.Sh "Error Messages"
.PP
Under certain conditions,
.B rlogin
may not be able to make the connection.
An attempt to connect fails, for example,
if the remote host is down, or is not running the
.B rlogin
server.
.B rlogin
waits a reasonable period of time before
it quits and sends you the following error message:
.DM
	Connection timed out.
.DE
You also receive an error message if you specify an
invalid host name \(em either by naming a host that is not on the
network, or by misspelling a host's name.
.Sh "Spawning a Local Shell"
.PP
Once you are logged into a remote host, you may
wish to suspend the session to perform local operations.
To do so, type:
.DM
	~!
.DE
This spawns a shell on your local host.
You can issue one or more commands to your local host.
However, if you invoke
.B rlogin
under this new shell, you must break that connection
before you can return to your original
.B rlogin
session.
When you exit from the shell, you return to your
.B rlogin
session.
.Sh "Ending an rlogin Session"
.PP
To close your connection to the remote host, simply log out from that host.
.B rlogin
closes the connection automatically, and displays the message
.DM
	Connection closed.
.DE
on your screen.
.PP
To abort a
.B rlogin
session before you have logged into a remote host,
type the escape sequence:
.DM
	~.
.DE
For a summary of
.BR rlogin 's
capabilities and syntax, see its entry in the Lexicon at the back of this
manual.
.SH "rshl:  Execute a Command on a Remote Host"
.PP
The command
.B rshl
executes a command (or command file) on a remote host that is running the
.B rshl
server.
Its name is a contraction of the phrase ``remote shell'';
as the name implies, it executes a command or script under a shell
on a remote system.
Functionally,
.B rshl
resembles the 4.3BSD utility
.BR rsh ;
it has been renamed to avoid colliding with the UNIX System-V utility
.BR rsh ,
which implements a restricted shell.
.PP
To execute a command on a remote host, invoke the
.B rshl
client on your local host and establish a connection with the
.B rshl
server on the remote host.
Because
.B rshl
performs the function
.B rlogin
when you do not specify a command to execute, any
host to which you want to connect should be running the
.B rlogin
server as well as the
.B rshl
server.
.PP
Like
.BR rlogin ,
.B rshl
makes certain assumptions about the remote system and has
various login requirements.
For example, the remote host must identify your local host in the file
.BR /etc/hosts.equiv .
With your local host listed in the remote host's file,
your user identifier on your local host is used
as the remote user name and you do not need a password.
Unlike
.BR rlogin ,
.B rshl
does not prompt you for a password if your local user name does not exist
on the remote host:
it just denies you permission to execute the command.
.Sh "How to Invoke rshl"
.PP
In most circumstances, you will use
.B rshl
to execute a command on a remote host on which you have an account
under the same user name as on your local host.
For example, if your login identifier is
.B fred
on your local host, it should be
.B fred
on the remote host as well.
.PP
In this case, type
.B rshl
followed by the name of the remote system
and the command to be executed on that system.
For example, assume that your login identifier is
.BR fred ,
your local host is named
.BR lepanto ,
and that you want execute script
.B jobs
that resides in your home directory on the remote host
.BR mwc .
Give the
.B rshl
command as follows:
.DM
	rshl mwc cat jobs
.DE
If
.B rshl
can make the connection,
it
.BR cat s
file
.B jobs
and displays the contents onto your screen.
However, if the remote host did not recognize
.B lepanto
as a host with which it shares account names,
it would have denied you permission to execute the command.
.PP
If you invoke
.B rshl
without telling it what command to execute on the remote host,
then it will attempt to log you into that remote host, just as if
you had invoked the command
.BR rlogin .
.PP
.B rshl
sets some restrictions on the commands you can give.
You cannot, for example, specify an interactive command like
.BR vi ;
nor can you run commands for which you have no permission, e.g.,
.BR /etc/shutdown .
.PP
The arguments to the command that you wish to execute on the remote host
may include wildcards.
You must be careful, however, to ensure that the wildcards are quoted so
that they are not expanded by the shell on your local host before they
are passed to the remote host.
To extend the above example,
if you wished to concatenate every file with the suffix
.BR \&.c ,
you would type the command:
.DM
	rshl mwc cat '*.c'
.DE
Enclosing the string
.B *.c
within apostrophes protects it from being expanded by your local shell.
For more information on wildcards, see the entry for
.B wildcards
in the COHERENT Lexicon; for information on quoting, see the COHERENT Lexicon's
entries for
.B ksh
and
.BR sh .
.PP
Finally,
.B rshl
sets file names relative to your home directory on the remote system \(em
just as if you were logged into that system.
To bypass this default, use absolute path names.
.Sh "Specifying a Different Remote User Name"
.PP
If you wish to execute a command on a remote host under a user identifier
that differs from the one you use on the local host,
use the \fB\-l\fR option to
.BR rshl .
Every user controls who can log into his
account from other hosts by means of a file named
.B \&.rhosts
that resides in his home directory.
For information on this file, see the entry for
.B rhosts
in the Lexicon at the back of this manual.
.Sh "Error Messages"
.PP
.B rshl
may not be able to connect with a remote host;
for example,
the remote host may be down, or may not be running the
.B rshl
server.
.B rshl
tries for a reasonable period of time to make the connection,
then quits and sends you the message:
.DM
	Connection timed out.
.DE
You will also get an error message if you name a host that is not on your
network, or if you misspell the name of a host.
.SH "ruptime:  Get Information About Remote Hosts"
.PP
To obtain information about other hosts on the network,
use the command
.BR ruptime .
This command
lists every host on the network that is running the
.B rwho
server, and gives information about its status.
.PP
This example demonstrates the output of
.B ruptime
in its simplest form:
.DM
.ta 0.5i 1.5i 2.5i
	kalamazoo	up	3+02:09, 6 users, load 0.00, 0.00, 0.00
	paris	down	2+23:11
	wobegon	up	4+01:42, 7 users, load 0.00, 0.00, 0.00
	planetx	down	4+05:57
	metropolis	up	4+03:52, 9 users, load 1.10, 0.42, 0.22
.DE
The first column gives the host name.
The next columns indicate whether the host is up or down;
the time that the host has been up or down in \fIdays+hours:minutes\fR;
the number of users logged in;
and load averages.
.PP
Through command options, you can tell
.B ruptime
to display the list of hosts in order of uptime, number of
users, or load averages.
For a fuller description of
.BR ruptime ,
see its entry in the Lexicon at the back of this manual.
.SH "rwho:  Information About Users on Remote Hosts"
.PP
The command
.B rwho
prints the name and other information about
users who are logged into the hosts on your network.
Note that it can return information only about the hosts that
are running an
.B rwho
server.
.PP
By default,
.B rwho
lists users alphabetically by user name, as in this example:
.DM
.ta 0.5i 1.5i 3.0i
	auntie	paris:ttyn0	May 29 10:22
	charlie	paris:ttyn1	May 29 10:58 :01
	donna	gotham:ttyp0	May 29 06:54 :05
	elmer	wobegon:VTA142	May 29 10:36 
	fawn	nome:tty03	May 29 10:24 :02
	gary	wobegn:VTA148:	May 29 12:13
	mack	gotham:ttyp1	May 29 12:21 :09
.DE
The first four columns show the user's name,
the name of the host into which the user is logged,
the name of the port into which the user is logged,
and the date and time that the user logged in.
If a user has not typed at his terminal for one minute or more,
.B rwho
displays this idle time in the last column.
.PP
Normally, the list does not include users who have
been idle for one hour or more.
To tell
.B rwho
to show all users,
regardless of idle time, use the option
.BR \-a .
For a summary of this command's options, see its entry in the Lexicon at the
back of this manual.
.SH "telnet:  Network Terminal Emulator"
.PP
The final section in this chapter introduces the command
.BR telnet .
This command lets you log into a remote host via the network.
Unlike the command
.BR rlogin ,
.B telnet
gives you a virtual terminal through which you can connect
to the remote host as if you were directly connected to that host.
.Sh "How to Invoke telnet"
.PP
To invoke
.B telnet
from within the COHERENT shell,
type the command followed by the name of the host to which you wish to connect.
For example, to connect to a remote host whose name is
.BR scotty ,
type the following command at your shell prompt:
.DM
	telnet scotty
.DE
You can identify the remote host either by its name (as shown above) or by
its Internet address, in standard dot notation.
For example:
.DM
	telnet 89.0.0.2
.DE
When you connect to the remote host,
.B telnet
automatically enters input mode;
this means that it passes all text you type to the remote host.
However, if you issue the
.B telnet
command without an argument, you enter
.BR telnet 's
command mode.
In this mode, you can give commands to
.B telnet
to modify its behavior.
This is described below.
.PP
When
.B telnet
succeeds in connecting with the remote host,
you see the following messages:
.DM
	Trying...
	Connected to scotty.
	Keepalive is disabled
	Escape character is '^]'.
.DE
These messages verify that the connection has been made and identify
the escape character that enables you to move from
.B telnet
input mode to telnet command mode.
(The escape character is described later in this section.)
Note that when you specify an Internet
address, the connected message echoes the address instead of the host name.
.Sh "Error Messages"
.PP
.B telnet
may not be able to make a connection
if the remote host is not up or is not running the
.B telnet
server.
It also fails if you enter an
invalid Internet address, or misspell the name of the remote host.
.B telnet
waits for reasonable period of time,
then sends you the error message:
.DM
	Trying...
	telnet: connection: Connection timed out.
.DE
.B telnet
then automatically enters command mode, as shown by the fact that it
displays the prompt
.BR telnet>> .
To try again to connect to a remote host,
use the
.B telnet
command
.BR open ,
as described below.
.Sh "Input Mode"
.PP
When
.B telnet
connects to the remote host, it automatically enters input mode.
In this mode,
.B telnet
sends all text that you type to the remote host.
In this mode, you must follow the conventions of the remote host's operating
system, just as if you were logged directly into that system.
.Sh "Command Mode"
.PP
.B telnet
also has a command mode.
In this mode, you can issue commands directly to
.BR telnet .
These commands can change its default settings, or tell it to perform
some task or other.
.PP
.B telnet
enters command mode automatically if you invoke the
.B telnet
server without naming a remote host or Internet address.
You can also enter command mode while logged into a remote host,
by typing the
.B telnet
escape character.
(\fBtelnet\fR displays its escape character when you connect to a
remote host; the default is \fB<ctrl-]>\fR.)
When you enter command mode,
.B telnet
displays the prompt
.BR telnet>> ,
which indicates that it is ready to receive commands from you.
.PP
You must type all of
.BR telnet 's
commands in lower-case letters.
You can abbreviate a command as long as the abbreviation is unambiguous;
for example, you can abbreviate the command
.B close
as
.BR cl .
.PP
If you make a mistake when you issue a
.B telnet
command, it displays the message:
.DM
	Invalid command
.DE
If entered command mode by pressing the
.B telnet
escape character, you can return to input mode by pressing
the \fB<Return>\fR key a few times.
If you entered command mode by invoking
.B telnet
without an argument, then you will enter input mode automatically as soon
as you connect to a remote host.
.PP
The following introduces a few of the more important
.B telnet
commands:
.IP \fBopen\fR
Open a connection with a remote system.
If you issue
.B open
without specifying a host name or Internet address,
.B telnet
prompts you for that information.
.IP
For example,
to connect to a remote host called
.BR sesame ,
type the following at the
.B telnet
prompt:
.DM
	open sesame
.DE
.IP
After you log in, enter input mode, as described earlier.
.IP "\fBescape\fR"
Change the escape character.
To use it, type
.BR escape ,
then enter the new character at the prompt.
The character does not appear on the screen when you type it.
After you enter the character and press \fB<Return>\fR,
.B telnet
displays the new escape character.
.IP
The following example changes the escape character to \fB<ctrl-E>\fR:
.DM
	telnet>> escape
	new escape character:	\fB<ctrl-E>\fP
	Escape character is '^E'.
.DE
.IP
Note that \fB<ctrl-E>\fR in the above example is not typed literally.
.IP
Once you change the escape character, you must use
the new character to re-enter command mode.
.IP "\fB!\fR"
Spawn a shell on your local system.
Your
.B telnet
session goes into suspended animation,
and you can give commands directly
to your system via the newly spawned shell.
If you wish, you can even invoke another
.B telnet
session.
Once you have finished working with your shell, type \fBexit\fR to return
the suspended
.B telnet
session.
.IP \fB?\fR
Ask
.B telnet
for help.
When you type a question mark without an argument,
.B telnet
prints a list of its commands.
To obtain information about a given command, type a question mark followed
by that command.
For example, to get information about the command
.BR open ,
type:
.DM
	? open
.DE
.IP
.B telnet
replies:
.DM
	connect to a site
.DE
.Sh "Closing a Connection and Quitting"
.PP
When you are done with your work on the remote host,
log out in the manner acceptable to that host (for example, by typing
\fB<ctrl-D>\fR or
.BR exit ).
The host then breaks the connection and you get the following message:
.DM
	Connection closed by foreign host.
.DE
You then return to COHERENT command level.
.PP
To close the connection and remain in
.BR telnet ,
return to command mode and issue the
.B close
command.
You then get the following message and the
.B telnet
prompt:
.DM
	Connection closed.
	telnet>>
.DE
To connect to a different host, you can then issue another
.B open
command.
Note that you must close your current
connection before you try to establish a new connection.
.PP
If you are in command mode and wish to leave
.B telnet
(and thereby break your connection with the remote host), use the command
.BR quit .
This command closes the
.B telnet
session, and returns you to the COHERENT shell.
Note that you should explicitly log off the remote host before you break
the
.B telnet
session.
A rational operating system will automatically log you off when it
detects that the connection is dropped, but you should not count on this
happening.
.Sh "A Sample telnet Session"
.PP
The following gives a sample
.B telnet
session.
In this session, user
.B hillary
invokes the
.B telnet
client program to log into a remote host called
.BR whouse .
The text in Roman shows what the user typed, the text in
.I italic
shows what
.B telnet
says to the user, and the text in
.B bold
shows what the remote system says to the user:
.DS
	telnet
	\fItelnet>>\fR open whouse
	\fITrying...\fR
	\fIConnected to whouse.\fR
	\fIEscape character is '^]'\fR
.DE
.DS
	\fB4.3BSD (whouse)\fR
	\fBlogin:\fR hillary
	\fBPassword:\fR [password]
	\fBLast login: Mon Aug 22 20:28:15 on ttyh2\fR
	\fB4.3BSD #86: Wed Sept 10 15:39:08 EST 1986\fR
.DE
.DS
.ta 0.5i 2.0i 3.5i
	\fB%\fRls
	\fBcabinet	congress	defense\fR
	\fBeconomy	foreign.policy	health\fR
.DE
.DS
	\fB%\fRmkdir socks
.DE
.DS
.ta 0.5i 1.5i
	\fB% \fR[escape character]
	\fItelnet>>\fR ?
	\fICommands may be abbreviated. Commands are:\fR
	\fIopen 	connect to a site\fR
	\fIclose	close current connection\fR
	\fIquit	exit telnet\fR
	\fI!	spawn local shell\fR
	\fIescape	set escape character\fR
	\fIstatus	print status information\fR
	\fIoptions	toggle viewing of options processing\fR
	\fIcrmod	toggle mapping of received carriage returns\fR
	\fI?	print help information\fR
	\fItelnet>>\fR escape
	\fInew escape character:\fR	<ctrl-E>
	\fIEscape character is '^E'.\fR
.DE
.DS
	\fB%\fRexit
	\fIConnection closed by foreign host.\fR
.DE
.SH "Where to Go From Here"
.PP
As has been noted several times in this chapter,
the Lexicon at the back of this manual summarizes the commands
supported by the NCM implementation of TCP/IP.

.ds TL Installation
.NH Installation
.PP
This describes how to install the kernel-enhancement kit for COHERENT.
Note that you must have 5,000 blocks (that is, 2.5 megabytes)
of space free on your root file system to install this kit.
.PP
To install the kernel-enhancement kit, type the following command:
.DM
	/etc/install CohUpd \fIdrive\fP 2
.DE
where
.I drive
is the floppy-disk drive from which you are installing the kit.
For example, if you are installing from drive 0 (or A) and that
drive is a high-density, 5.25-inch floppy disk, use the following command:
.DM
	/etc/install CohUpd /dev/fha0 2
.DE
For a list of the names of all recognized floppy-disk drives, see the
Lexicon entry
.BR "floppy disk" .
.PP
.B install
will prompt you to insert each floppy disk in turn into drive A.
It will then copy each disk's contents onto your hard disk.
.B install
installs all items of the kernel-update kit into their usual places
in your COHERENT system.
For example, it installs the new version of the command
.B cc
into directory
.BR /bin .

.ds TL "Installation"
.NH "Installing COHERENT"
.PP
The following describes how to install \*(CO onto your computer.
Installation of \*(CO is straightforward, and Mark Williams Company
has prepared a suite of programs that automate much of the work for you.
.PP
Tens of thousands of users have successfully installed \*(CO onto their
computers.
Most have found the process to be easy and quick.
An uncomplicated installation will take less than an hour.
.PP
A few users have experienced some problems with installation;
so if installation does not go as smoothly as you would like, the end of this
section describes the commoner problems and how you can fix them.
If all else fails, telephone Mark Williams Technical Support, as described
in the introduction to this pamphlet.
.SH "Installing Vs. Updating"
.PP
Before you continue any further, please note that this section is for
users who are not yet running \*(CO on their computers.
\fIIf you already are running \*(CO and are updating to \*(CO 4.2,
\fRskip\fI this section and instead read the following section, \fRUpdating
\*(CO.\fI
If you re-install \*(CO over an existing \*(CO system, any \*(CO
files you already have will be wiped out!\fR
.PP
We do not mean to frighten you.
However, we do know how much time you can spend customizing your \*(CO
system; and we would hate to see all that work lost due to a few
moments' carelessness.
So, we'll say it once again:
\fIIf you already are running \*(CO, you want to \fRupdate\fI \*(CO
rather than \fRinstall\fI it.
\fRSkip\fI this section and instead
read the following section, on updating \*(CO!\fR
.SH "Before You Install"
.PP
As you have read this far, we assume that you are \fInot\fR now running
\*(CO, and that you do wish to \fIinstall\fR \*(CO onto your system.
Before you begin installation, you need to make a few decisions about how
you want to configure your computer;
and you need to collect some information
about your system.
We suggest that you make a checklist and fill it in before you begin
installation.
.PP
If you wish to have \*(CO reside on the same hard disk as \*(MD,
OS/2, or Windows NT,
be sure to read the section below entitled \fIInstalling COHERENT
With Other Operating Systems\fR.
.Sh "Caveats"
.PP
Although \*(CO is a flexible system that can run on a wide variety
of machines, it cannot run on everything.
The following conditions must apply before you can install
\*(CO on your system:
.IP \fB1.\fR 0.3i
Your system hard disk must have a free partition with at least
15 megabytes of space free on it.
More is recommended, but 15 megabytes is the minimum space required
to install \*(CO.
You need at least 40 megabytes if you wish to install X Windows for \*(CO
also.
.sp \n(pDu
If your system does not have a free partition, you must either take one away
from \*(MD, or you must split an existing DOS partition into two and
give one (or both) to \*(CO.
In either case, all data on that partition will be destroyed.
This is detailed below.
.IP \fB2.\fR
Your system must be based upon the Intel 80386 or 80486 processor,
or an exact clone.
.IP \fB3.\fR
Your system must have at least two megabytes of available RAM.
If you wish to run X Windows for \*(CO, you must have at least four
megabytes, at least eight is recommended.
.\".sp \n(pDu
.\"Please note that some clone motherboards do not
.\"``map'' the region of RAM which lies between 640K (0xA0000) and one
.\"megabyte (0x100000).
.\"If your system uses one of these motherboards and contains only
.\"one megabyte of RAM chips,
.\"you effectively have a 640K system and will not be able to install \*(CO.
.IP \fB4.\fR
Your system components must be 100% IBM compatible in order to run \*(CO.
The system bus can be based upon either the Industry Standard Architecture (ISA)
or the Extended Industry Standard Architecture (EISA).
MicroChannel (MCA) machines are not yet supported.
.IP \fB5.\fR
If you are installing \*(CO on a notebook or other
computer system that uses a modified 83-key layout rather than the
industry standard 101-key or 102-key layout, you may experience
key transpositions and other anomalies.
If you are using the
.B nkb
loadable keyboard driver, read Lexicon articles
.B "keyboard tables"
and
.B nkb
for information on how to modify the keyboard-mapping tables for your system.
.IP \fB6.\fR
Your system must have at least one high-density, 3.5-inch or
5.25-inch floppy-disk drive installed as drive A.
The distribution disks for \*(CO cannot be read by a low-density
floppy-disk drive, nor can they be converted from one size of disk to
the other.
.sp \n(pDu
Due to limitations in the BIOS of the IBM PC and its clones, \*(CO
can be installed \fIonly\fR from drive A.
Thus, if your system has both sizes of floppy-disk drive, your release of
\*(CO must be for the disk drive that your system knows as drive A.
.PP
If your system meets these criteria, then you probably can install and
run \*(CO, as tens of thousands of other users have done.
Check the list of compatible and incompatible hardware in the second
section of this pamphlet to see if any of your hardware is listed.
If your system does not appear on either list, you probably can still install
and run \*(CO \(em but Mark Williams Company will be interested in your
experience.
.PP
The following sections discuss your preparations in more detail.
.Sh "Hard Disk"
.PP
The hard disk and its controller is one of the most important elements
with which \*(CO must work.
\*(CO continually works with the hard disk:
it loads programs, creates temporary files, updates existing data files,
uses information stored on disk to access peripheral devices, and so on.
Thus, how you configure your hard disk will make a great difference to
your system.
.PP
A \*(CO system can have several hard disks:
up to two IDE (AT-style) disks, and an indefinite number of SCSI disks.
You can have up to two controllers on your system; if you have more than
one controller, one must be IDE and the other SCSI.
.PP
The point of the installation procedure is to create one or more partitions on
a hard disk to contain \*(CO and its files.
When you (or your dealer) installed \*(MD on your computer, you (or he)
divided your computer's hard disk (or disks) into \fIpartitions\fR.
Each hard disk can have from one to four partitions.
Partitions are numbered sequentially:
If you have one hard disk, the partitions are numbered 0 through 3;
if you have two hard disks, the partitions on one hard disk are numbered
0 through 3 and on the other are numbered 4 through 7; and so on.
.PP
Not every partition has to be used \(em a hard disk can be divided
into four partitions, but have \*(MD file systems in only two of them,
with the third and fourth partitions being idle.
Note, too, that the four partitions do not necessarily have to
encompass the entire hard disk \(em a disk may have space that is outside
any partition and so just remains unused.
.PP
The file systems for \*(CO and \*(MD are very different, so it is not
possible to have both systems use the same partition \(em each
must have one or more partitions completely to itself.
(Note, however, that \*(CO comes with tools that let you copy files
from an \*(MD file system to \*(CO and back again.)
.PP
As you can see, installation must cope with a number of variables:
the number of hard disks on your system,
the type of controller or controllers on your system,
the size of each disk,
the number of partitions into which each disk is divided,
the size of each partition,
and the number of partitions that are in use.
Installation thus will follow any of a number of possible scenarios,
depending on how your system is organized and how much disk space you wish
to give to \*(CO.
The installation process will walk you through these decisions, to make
them as painless as possible.
.PP
If you have one hard disk, you may have either one or two \*(MD partitions.
The first partition is the \*(MD primary partition, and
the second is the \*(MD extended partition.
.PP
\*(MD lets you sub-divide the extended partition into logical drives D, E, F,
and so on.
\*(CO
.I cannot
be installed onto a logical drive.
In this scenario, you have these options:
.IP \fB1.\fR
Install \*(CO onto
.I all
of the \*(MD extended partition.
You will lose drives D, E, F, etc., and
.I all
data in them.
.IP \fB2\fR
Use the \*(MD version of the command
.B fdisk
to delete an existing partition, then re-create it
while making it smaller by however much disk space you wish to allocate
to \*(CO.
Remember that \*(CO requires at least 15 megabytes; while \*(CO plus X
requires at least 40 megabytes.
.IP
This step frees disk space from \*(MD.
.B build
will see this freed space and allow you to turn this into a \*(CO
partition (or partitions).
.IP \fB3.\fR
If your hard drive has space that lies outside of any existing partition,
.B build
will allow you to turn it into a \*(CO partition.
.PP
These options apply even if you already have \*(MD plus any other operating
system (e.g., OS/2 or Windows NT) on your system.
.PP
Why is this neccessary?
Because \*(CO, like \*(UN, is a
stand-alone operating system that requires its own bootable partition.
.PP
It may be that you do not know the configuration of your hard disk (or disks).
\*(CO can figure this out, and the
information will be displayed for you at the appropriate point in installation.
We recommend that you keep a copy, on paper, of your
computer's partitioning.
This information can be vital in helping you to recover from a catastrophic
error with your hard disk.
.PP
For an overview of how \*(CO handles hard disks, see the Lexicon article
\fBhard disk\fR.
.Sh "Hard-Disk Controller"
.PP
Another variable is the type of hard-disk controller you have.
\*(CO works with RLL, MFM, IDE, and most ESDI hard-disk controllers.
It also works with some SCSI host adapters.
Please check the previous section for a list of supported hard disk
controllers and host adapters.
.PP
If you intend to install \*(CO on a system that uses one of the
supported SCSI host adapters, be sure that your host adapter is jumpered
to enable interrupts and that the interrupt number and other configuration
information is available prior to beginning the installation of \*(CO.
.PP
If you have a SCSI drive, \*(CO will ask you during installation for
the following information about your SCSI drive.
You should jot down the requested information before you begin installation:
.IP \fB1.\fR 0.3i
The number of SCSI drives you have.
.IP \fB2.\fR
Manufacturer of host adapter, and parameters:
Adaptec, Seagate, or Future Domain.
.IP \fB3.\fR
If you have an Adaptec host adapter, does your device's BIOS uses
a 64-head translation mode?
This is the default.
.IP \fB4.\fR
Which IRQ does the host adapter use?
The default is 11 for Adaptec, 5 for Seagate or Future Domain devices.
.IP \fB5.\fR
What is the hexadecimal host adapter base-port address?
The default is 0x330 for Adaptec, 0xCA00 for Seagate or Future Domain devices.
.IP \fB6.\fR
Which DMA channel does the host adapter use?
The default is 5.
.IP \fB7.\fR
For each SCSI device you have, you must assign a SCSI ID, zero through seven.
If you have only one SCSI device, the default is zero.
.Sh "Peripheral Devices"
.PP
You should note which ports you have plugged
your printers, modems, and other devices.
The installation program will ask you for this information so it can
correctly configure your system.
.PP
The installation program will also ask you if you wish to have one or more
of your serial ports in polled mode.
For information on what this means, see the Lexicon article on
.BR asy .
.PP
You will also be asked about what console devices you have on your system.
Currently, the \*(CO install procedure lets you install up to a total of
eight virtual-console sessions between two physical consoles.
For example, if you have two consoles, you could have six virtual consoles
on the color device and two on the monochrome; whereas if you have only a color
video card, you could have all eight console sessions on that console.
Note the number of video cards plugged into your system, and whether the
cards are monochrome or color.
.Sh "System Name"
.PP
When you install \*(CO you will be asked what the name of your
system is.
You must do this to use electronic mail under \*(CO; this will permit
other systems to identify your system.
You should pick a name that is easy to remember, yet probably unique;
and no name should be longer than eight characters.
.PP
See the Lexicon article
.B uucpname
for details on system names, and examples.
.Sh "Domain Name"
.PP
Finally, when you install \*(CO you will be asked to name your system's
electronic mail domain.
If you will be adding your system to a \*(UU domain, you should enter its
name; otherwise, you should select the default domain name \fIUUCP\fP.
If you join a \*(UU domain later, or change domains, you can name that
domain simply by editing the file \fB/etc/domain\fR.
.PP
See the Lexicon article
.B domain
for details on domains.
.SH "Installing COHERENT"
.PP
Once you have jotted down the information about your system and,
if necessary, backed up your data and used \*(MD \fBfdisk\fR
to free up a partition for \*(CO, you are ready to begin installation.
.PP
You can abort the installation procedure at any time by typing
\fB<ctrl-C>\fR.
However,
aborting installation does \fInot\fR mean that your hard disk will be returned
to the state it was in before installation was begun.
\fIWhen a disk is repartitioned, the files that were on any
modified partitions are gone forever!\fR
.PP
The following sections describe the installation process in some detail.
Once again, read them through before you begin.
.PP
During the installation, \*(CO explains what it is doing.
It asks your permission to execute any action
that could destroy data on your disk.
.Sh "Beginning Installation"
.PP
To begin installation, turn your system off.
Take the \fBBoot\fR disk from your installation
kit and insert it into floppy-disk drive A.
(The disk
.I must
be placed into drive A.
Installation will not work if you put it into drive B.)
.PP
Now, turn your system on.
Your system will boot a mini-version of \*(CO from the boot disk;
in a moment, you see a question mark \*(Ql?\*(Qr, which is a prompt.
Type:
.DM
	begin
.DE
and press the \*(RT key.
This loads \fBbuild\fR, the \*(CO installation program, into memory and
begins execution.
As \*(CO loads
.BR build ,
it entertains you with a spinning character,
with an occasional ``subliminal'' message that urges you to purchase COHware.
.PP
When
.B build
is loaded into memory and begins execution, it displays a copyright notice.
Press \*(RT.
You will see the following greeting:
.B1
	Welcome to the COHERENT operating system!
.sp \n(pDu
	Your computer is now running COHERENT 386 from the floppy disk.
	This program will install COHERENT onto your hard disk.
.sp \n(pDu
	If you are already running COHERENT on your hard disk, you must perform an
	update rather than a full installation.  To do so, please REBOOT NOW and
	follow the detailed update instructions in the COHERENT release notes supplied
	with this release.
.sp \n(pDu
	You can interrupt installation at any time by typing <Ctrl-C>;
	then reboot and start the installation procedure again.
	Please be patient and read the instructions on the screen carefully.
.B2
.PP
As the instructions say, you can interrupt installation at any point by
typing \fB<ctrl-C>\fR.
.Sh "Entering the Serial Number"
.PP
The next screen will ask you to enter a nine-digit serial number:
.B1
	A card included with your distribution gives the serial number
	of your copy of COHERENT.
.sp \n(pDu
	Type in the serial number from the card:
.B2
.PP
This number is included on the registration card
supplied with your copy of \*(CO.
The installation process cannot continue until you enter this number
correctly.
If you type the wrong number three times, installation will abort;
so type carefully.
.Sh "Configuration of Hard Disks"
.PP
At the next step,
.B install
asks you for the number and type of hard disks you have:
.B1
	Most PC compatible computer systems use MFM, RLL, IDE, or ESDI disk
	controllers and disk drives.  A few percent use SCSI disk drives.
	Please indicate the type(s) of disk drive(s) used in your computer system.
	If you are uncertain of the type, please select choice 1.
.sp \n(pDu
	Are you using:
.sp \n(pDu
	1.  AT-compatible hard drive controller (IDE/RLL/MFM/ESDI).
	2.  SCSI hard drive controller.
	3.  Both.
.sp \n(pDu
	Enter your choice:
.B2
.PP
Select the appropriate entry:
1, 2, or 3.
.Sh "Installing an AT Disk"
.PP
If your system has an AT-compatible hard-drive controller
(i.e., IDE, RLL, MFM, or ESDI controller),
.B build
will ask you about polling:
.B1
	Most AT-compatible controllers work with NORMAL polling.
	Perstor controllers and some IDE hard drives require ALTERNATE polling.
	If you get "<Watchdog Timeout>" or "at0:TO" errors with normal polling,
	use alternate polling.
.sp \n(pDu
	Use NORMAL polling?
.B2
.PP
In nearly every case, you should answer ``Yes''.
.B build
then asks:
.B1
	Enter number of non-SCSI hard drives:
.B2
.PP
Please do so.
If you have another non-SCSI hard drive,
.B build
repeats the above routine for that second drive.
.PP
Finally,
.B build
asks:
.B1
	Are you installing on an IBM PS1 or ValuePoint?
.B2
.PP
If you are, answer `Y'.
.B build
will ask you a few additional questions that apply only to those machines.
.Sh "Installing a SCSI Disk"
.PP
If you indicated that
you are installing \*(CO onto a SCSI disk drive, at this point
.B build
asks for information about your SCSI device.
(If you do not have a SCSI device, skip to the next section.)
.PP
First, it asks what type of device you are using:
.B1
	COHERENT currently supports the following SCSI host adapters:
.sp \n(pDu
	(1) Adaptec AHA-154x series, with or without tape support
.sp \n(pDu
	(2) Adaptec AHA-154x series, no tape support (alternate driver)
	(3) Seagate ST01 or ST02
	(4) Future Domain TMC-845/850/860/875/885
	(5) Future Domain TMC-840/841/880/881
.sp \n(pDu
	Enter a number from the above list or 0 to exit:
.B2
.PP
If you intend to install \*(CO on a system which uses one of these
supported SCSI host adapters,
be sure that your host adapter is jumpered to enable interrupts
and that the interrupt number and other configuration
information is available.
.PP
.B build
then walks you through a dialogue to gather the information described
in the earlier section entitled \fIHard Disk\fR.
If you do not know what your disk uses, or if you do not understand
what the question is asking, you should select the default.
.PP
.B build
first requests the IRQ for your host adapter:
.DM
	Which IRQ does the host adapter use? 
.DE
.PP
.B build
then asks for the base port's address:
.DM
	What is the hexadecimal host adapter base port address? 
.DE
.PP
Use the default if you do not know the address.
.PP
.B build
then asks about the DMA channel:
.DM
	Which DMA channel does the host adapter use? 
.DE
.PP
Again, the default is your best bet if you are not sure.
.PP
If you are using an Adaptec disk,
.B build
then asks:
.DM
	How many heads will be used for translation mode?
.DE
.PP
If you're not sure, press \*(RT to select the default.
.B build
then asks about the number of sectors per track:
.DM
	How many sectors per track will be used for translation mode?
.DE
.PP
Unless you're certain of a different value, press \*(RT to select the default.
.PP
.\".B build
.\"then asks about the IRQ number:
.\".DM
.\"	Which IRQ number does the host adapter use [\fIN\fP]? 
.\".DE
.\".PP
.\"Press \*(RT to accept the default.
.\".PP
.\".B build
.\"then asks for base-segment address:
.\".DM
.\"	Your host adapter is configured for a base segment address.  Possible
.\"	values are: C800, CA00, CC00, CE00, DC00, and DE00.
.\"	What is your 4-digit hexadecimal base address [\fIN\fP]? 
.\".DE
.\".PP
.\"If (like most people) you do not know what the base-segment address is,
.\"press \*(RT to select the default.
.\"In all probability, this will work fine.
.\".PP
.\"Finally,
.B build
asks you to name a SCSI ID for each device that you have plugged into your
SCSI board.
This ID, which is any integer from zero through seven,
represents the device's address on the SCSI bus.
You do not need these addresses to assign a SCSI ID.
Most host-adapter BIOSes work best if SCSI hard drives are given IDs that begin
at zero and go up by increments of one.
A system might not boot properly otherwise.
SCSI tape is often at ID 2.
.PP
If you just have a hard disk plugged into your SCSI controller, you see:
.B1
	You must specify a SCSI-ID (0 through 7) for each SCSI hard disk device.
	Each SCSI hard disk device can contain up to four partitions.
.sp \n(pDu
	1) Enter SCSI ID for SCSI hard disk (fixed or removable media)
	2) End entering SCSI ID values.
.sp \n(pDu
	Your choice:
.B2
.PP
You must enter a unique SCSI ID number for each SCSI hard disk
(\fInot\fR to each partition).
If you have a tape device, you must enter a SCSI ID number for it as well.
We suggest that you assign SCSI ID numbers beginning with zero.
Start with your hard disk or disks, and then assign an ID to each tape drive.
.Sh "Back Up the Hard Disk"
.PP
After you have entered information about time and your disk,
installation moves on to its next phase,
partitioning the hard disk.
Before you become seriously involved in partitioning, however, you have
one last chance to back up your hard disk.
As you enter the partition phase of installation, you will see the following
text:
.B1
	This installation procedure allows you to create one or more partitions
	on your hard disk to contain the COHERENT system and its files.
	Each disk drive may contain no more than four logical partitions.
	If all four partitions on your disk are already in use, you will
	have to overwrite at least one of them to install COHERENT.
	If your disk uses fewer than four partitions and has enough unused space
	for COHERENT (\fIN\fP megabytes), you can install COHERENT into the unused space.
	If you intend to install MS-DOS after installing COHERENT,
	you must leave the first physical partition free for MS-DOS.
.sp \n(pDu
	The next part of the installation procedure will let you change the
	partitions on your hard disk.  Data on unchanged hard disk partitions
	will not be changed.  However, data already on your hard disk may be
	destroyed if you change the base or the size of a logical partition,
	or if you change the order of the partition table entries.
	If you need to back up existing data from the hard disk,
	type <Ctrl-C> now to interrupt COHERENT installation; then reboot your
	system and back up your hard disk data onto diskettes.
.B2
.PP
If you need to back up your hard disk and have not yet done so, please abort
.B build
and do so now.
.Sh "Use the COHERENT Bootstrap?"
.PP
If you have already backed up your hard disk, continue to the next phase,
which is to decide whether to use the \*(CO master bootstrap.
When you press \*(RT, you will see the following text:
.B1
	COHERENT initialization normally writes a new master bootstrap program onto
	your hard disk.  The COHERENT master boot allows you to boot the operating
	system on one selected disk partition (the active partition) automatically;
	it also allows you to boot the operating system on any disk partition by
	typing a key when you reboot.  Mark Williams strongly recommends that you
	use the COHERENT master boot.  However, the COHERENT master boot may not
	work with some operating systems (for example, Xenix) if you make the
	COHERENT partition active; instead, leave the other partition (e.g. Xenix)
	active and boot COHERENT by typing a key.  If you do not use the COHERENT
	bootstrap, you must understand how to boot the COHERENT partition using your
	existing bootstrap program.
.sp \n(pDu
	Do you want to use the COHERENT master boot?
.B2
.PP
As explained in the prompt text, a \fIbootstrap\fR is a program that
pulls an operating system into memory and sets it to running \(em the
name relates to the fact that the operating system \*(QLpulls itself up
by its boot straps\*(QR.
The \*(CO master bootstrap can boot \*(CO as well as many other
operating systems, including \*(MD (at least, the many versions of \*(MD
that have been tested).
If you choose not to use the \*(CO master bootstrap, you must consult
the documentation that came with your system to see how you can use your
operating system's current bootstrap routine to boot another operating system.
If, however, you choose to use the \*(CO master bootstrap and find that
it has trouble booting your current operating system, you should be able to
boot your current operating system by using a boot floppy disk; you will not
be able to boot it off of the hard disk, but at least it will be available
to you.
For these reasons, we strongly suggest that you use the \*(CO master
bootstrap routine.
.SH "Partitioning the Hard Disk"
.PP
.B build
then moves into the next phase:
selecting one or more disk partitions for \*(CO.
As described above, partitioning can vary greatly from disk to disk;
how the disk is partitioned will determine how much space is allocated
to \*(CO and how much to \*(MD.
This is the trickiest part of installation, so be sure to read carefully.
.Sh "How a Disk Is Organized"
.PP
This phase begins by displaying the current layout of your hard disk:
the number of partitions, the size of each partition, and the operating
system associated with each partition.
Note that the partition table is displayed in \fIphysical\fP order (i.e., the
actual order in which the partition table entries occur).
Some operating systems display the table in \fIlogical\fP or sorted order.
.PP
The following gives the printout for a typical hard disk.
This hard disk, called disk \fB0\fR,
has approximately 33 megabytes on it organized into
two \*(MD partitions, as follows:
.B1
	Drive 0 Currently has the following logical partitions:
	              [In Cylinders] [  In Tracks  ]
	Number  Type  Start End Size Start  End Size Mbyte Blocks Name
	0 Boot MS-DOS    0  149  150     0  899  900  7.83  15300 /dev/at0a
	1     EXT-DOS  150  614  464   900 3684 2784 24.28  47430 /dev/at0b
	2      UNUSED    0    0    0     0    0    0     0      0 /dev/at0c
	3      UNUSED    0    0    0     0    0    0     0      0 /dev/at0d
.B2
.PP
If you have more than one hard disk on your machine, then
you will see the table for the second disk after you have finished
partitioning the first.
If you do not wish to change the partition table on the first drive and
you wish to install \*(CO onto the second, selection option 7,
.IR "Proceed to next drive" .
Note that you
.I must
respond
.B yes
to the question ``Do you wish to update the partition table,'' or
.B build
will not continue to the next drive.
.PP
Note that \*(MD names each ``drive'' by a letter of the alphabet,
beginning with C.
(This nomenclature is a hold-over from the days when \*(MD only ran on
floppy disks, with `A' and `B' reserved for the two floppy-disk drives.)
Because \*(MD allows you to have only two DOS partitions on any
given hard disk, then if an \*(MD system has more than two ``drives'' on
one hard disk, the additional drives are \fIlogical\fR drives and are a
division of the EXT-DOS partition.
\*(CO cannot be installed onto a logical drive.
.PP
As mentioned above, we suggest that you copy down this table before
continuing; if an error were to occur, this information will help you
recover the data on your disk.
.PP
As you can see, this disk has four partitions, numbered 0 through 3.
Partition 0 is marked as the boot partition; what this means is
explained below.
\*(CO has given each partition a name, \fB/dev/at0a\fR through
\fB/dev/at0d\fR; you will not be working with these, however, so you can
safely ignore them for now.
.PP
Note that the middle columns of the table give
the size of each partition in three ways:
in cylinders, in tracks, and in megabytes.
How do these differ?
Megabytes is the easiest to understand:
that is the number of bytes that can be written into the partition.
Cylinders and tracks, however, relate to the way a hard disk is built.
A moment spent here on background can make what is to come much easier
to understand.
.Sh "Cylinders and Tracks"
.PP
Consider a high-density floppy disk.
Its surface is organized into 80 concentric rings, or \fItracks\fR,
numbered 0 through 79.
Each track holds a fixed amount of data; the amount held
depends upon the density of the disk.
When the disk is in your disk drive, a \fIhead\fR
moves back and forth, reading tracks as directed.
Unlike a phonograph cartridge, however,
the head jumps from track to track discretely \(em it does not spiral in.
Thus, you can measure space on a disk simply by counting the tracks.
Note, too, that
the term \*(QLhead\*(QR is often used to describe one surface of a
multi-sided disk.
.PP
As you've probably noticed, a floppy disk has two surfaces:
the top and the bottom.
The top is usually refered to as side 0, the bottom as side 1.
Each surface has its own system of tracks, each numbered 0 through 79,
giving a floppy disk a total of 160 tracks.
Also, to read the disk a floppy disk drive actually has two heads,
one for each surface.
.PP
A \fIcylinder\fR is the set of identically numbered tracks from both
surfaces of the disk.
A floppy disk organizes its 160 tracks into 80 cylinders:
side 0 track 0 plus side 1 track 0 form cylinder 0; side 0 track 1
plus side 1 track 1 form cylinder 1, etc.
If you think of a track as being a ring on the disk, then origin of
the term \*(QLcylinder\*(QR should be obvious.
.PP
Now, consider a hard disk.
The term \*(QLhard disk\*(QR is somewhat incorrect, because one
hard disk actually contains many hard disks, or \fIplatters\fR,
inside itself.
The platters are stacked on a spindle, much like a set of 45-rpm
records stacked on a record changer \(em except that heads move
between the platters, one head for each platter surface (or two per platter).
The number of platters and the number of tracks on each platter determine
both the number of cylinders and the amount of data that can be written to
the disk.
Consider the disk described in the above table, which is a fairly
typical device.
It has three platters (six heads).
Each head has 615 tracks, each of which holds 8,704 bytes.
Thus, the device has a total of 3,690 tracks (6 times 615), organized into
615 cylinders, with each cylinder holding 52,224 bytes (6 times 8,704).
.PP
Different operating systems organize disk partitions in different ways.
\*(MD, for historical reasons, organizes partitions along track boundaries;
under this scheme, the tracks of a cylinder can
be divided between two partitions.
\*(UN, \*(CO, and similar operating systems prefer to organize partitions
along cylinder boundaries:
all of the tracks of a cylinder belong to only one partition.
This lessens movement of the heads, which in turn speeds up reading of the disk.
Note that, strictly speaking, ``megabytes'' has no meaning for the task of
disk partitioning:
partitioning must be done either in tracks, or in cylinders.
Humans tend to think of partitions in terms of megabytes, that is, in terms
of the amount of data we can write into a partition, but when organizing your
disk it is much easier to think in terms of cylinders.
However, it is simple to translate cylinders into megabytes, which gives you
the best of both worlds; this will be discussed in the following sub-section.
.Sh "Partitioning the Disk"
.PP
Now that we have discussed partitioning in theory, here's now
.B build
walks you through the process.
.PP
.B build
begins by displaying a summary of information about disk 0 on your system.
.B1
	Drive 0 has 615 cylinders, 6 heads, and 17 sectors per track.
	It contains:
		615 cylinders of 52224 bytes each,
		3690 tracks of 8704 bytes each,
		62730 sectors of 512 bytes each
	or a total of 32117760 bytes (32.12 megabytes).
.B2
.PP
It then asks you to confirm if this is correct.
Your confirmation shows that
.B build
is reading information from your system correctly.
.PP
When you enter the partitioning phase of installation, the installation
programs displays the following message:
.B1
	This program will let you change partition information for each disk drive.
	A disk drive can be divided into one to four logical partitions.
	You can change the active partition (the partition which your
	system boots by default) or change the layout of logical partitions.
	Other programs which change hard disk partition information
	may list logical partitions in a different order.
	Hit <Esc><Enter> to return to the main menu at any time.
.sp \n(pDu
	Now hit <Enter>.
.B2
.PP
It then displays the configuration of your hard disk for you, using
a table like the one shown above, and the following menu:
.B1
	Possible actions:
	   0 = Quit	
	   1 = Change active partition (or make no partition active)
	   2 = Change one logical partition
	   3 = Change all logical partitions
	   4 = Delete one logical partition
	   5 = Change drive characteristics
	   6 = Display drive information
	   7 = Proceed to next drive
.B2
.PP
Before we discuss what these options do, note that you must
.I not
alter the
.I size
of an \*(MD partition using any of the above options.
You must install \*(CO into
.I all
of an \*(MD partition,
or into any part of the drive that has space unallocated to \*(MD.
Changing the
.I size
of an \*(MD partition at this point, to make room for \*(CO,
will invalidate the \*(MD partition table, may corrupt \*(MD data, and
may make it unbootable from the hard drive.
If you do wish to change the
.I size
of an \*(MD partition, abort installation of \*(CO, back up all of your
\*(MD data, use the \*(MD version of
.B fdisk
to change the layout of your hard disk, restore your \*(MD data, and only
then install \*(CO.
.PP
The following describes each option in detail.
.RS
.IP \fB0.\fR 0.3i
Quit this phase of installation.
This option does not alter the disk's partition table in any way;
and it moves into the next phase of installation.
Use this option if you do not wish to alter your disk's partitioning
in any way.
.IP \fB1.\fR
The \fIactive partition\fR is the partition that the bootstrap
program reads by default.
When a partition is made the active partition, the operating system mounted
on that partition is booted automatically when you turn on your computer.
This option allows you to change the active partition,
or to designate \fIno\fP active partition,
in which case the computer will prompt you at boot time
for the partition number to boot.
You will need this option only if your hard disk has more than one logical
partition, and the partitions contain different operating systems.
Note that if later you wish to change the active partition, you can use the
\*(CO command \fBfdisk\fR to do so.
See the Lexicon entry on \fBfdisk\fR for details.
.IP \fB2.\fR
This option lets you change one logical partition \(em in effect, it lets
you select a logical partition for \*(CO.
You should use this option if your hard disk has more than one partition
and you wish to install \*(CO on only one of them.
The partition you select must hold at least ten megabytes.
Note that the contents of the partition will be deleted.
.IP \fB3.\fR
This reconfigures the entire disk.
You can reset the number of partitions, and the size of each.
.IP \fB4.\fR
Option 4 is self-explanatory.
.IP \fB5.\fR
This option allows you to change the drive parameters
associated with each drive on your system.
.IP \fB6.\fR
Give summary information about the disk.
.IP \fB7.\fR
This option will only appear if you have more than one hard disk drive.
Use this option to select the next hard disk drive.
.PP
If the owner of this hard disk wanted to organize her hard disk by
megabytes, all she would have to do is divide 1 million by 52,224 to find
that one megabyte is approximately equal to 20 cylinders; thus, to make
a ten-megabyte partition, he would assign it 200 cylinders.
The size of a cylinder may be different on your system, but the principle
is the same.
.PP
The next step depends on two factors:
the current organization of your hard disk, and the amount of space you
wish to give to \*(CO.
The limit for a \*(CO partition is 500 megabytes,
but up to several hundred megabytes is more realistic.
If your disk has only one logical partition, you must use option 3
to create at least one new logical partition.
If your disk already has more than one logical partition, you can
use option 2 to assign one to \*(CO
or use option 3 to assign more than one,
reserving the rest for your current operating system.
Of the partition(s) that you assign to \*(CO, one must hold at least
20 megabytes \(em you cannot use two ten-megabyte partitions;
thus, if no partition on your disk holds ten megabytes, you must use option 3.
.PP
How much space should you give \*(CO?
\*(CO is a multi-user, multi-tasking operating system; the more space
you assign to it on your disk, the more users and the more processes it
can support.
\*(CO, via UUCP and other communications programs, also gives you access to
information on other \*(CO and \*(UN systems throughout the world; you will
want to exchange mail with other users and possibly download news and
information.
All of this takes up space.
You must have one 20-megabyte partition to hold \*(CO's root file system
(that is, the file system that holds the files that make \*(CO go), and
you would be well advised to assign at least one more partition of at least
half that size to hold users' accounts and their files.
.PP
If you have a large disk drive that is organized into one partition
that you wish to assign to \*(CO, you are well advised to divide it
into two smaller partitions.
For example, if you wish to allocate 500 megabytes to \*(CO, you should
create two 250-megabyte partitions rather than one 500-megabyte partition.
In addition, if you anticipate wanting to perform a full restore
of a dumped root partition, you are well advised to have a spare
\*(CO partition in addition to the root partition.
An alternative strategy would be to boot from the \*(CO Boot floppy disk
and then restore your root partition.
This assumes that the device you dump and restore from is different
than your boot floppy!
.PP
The following two sub-sections describe what happen when you invoke options
2 or 3.
.Sh "Changing One Logical Partition"
.PP
You will first be asked which partition you wish to change.
Reply by entering the partition you want.
The system replies with the following text:
.B1
	Existing data on a partition will be lost if you change
	the base or the size of the partition.  Be sure you have
	backed up all data from any partition which you are going
	to change.
.sp \n(pDu
	You may specify partition bases in cylinders or in tracks.
	Do you want to specify bases in cylinders?
.B2
.PP
Reply \*(QlY\*(Qr, to use cylinders.
The system then asks:
.DM
	You may specify partition sizes in cylinders or in megabytes.
	Do you want to specify partition sizes in cylinders?
.DE
Reply \*(QlY\*(Qr, again to use cylinders.
Next, the system says whether the partition is initialized to another
operating system (that is, to Xenix, OS/2, or MS-DOS), or is unused.
It then asks you whether you wish to install \*(CO into the partition,
leave the partition unchanged, or mark the partition as unused.
For example:
.DM
	The current operating system type is MS-DOS.
	Do you want this to be a COHERENT partition?
.DE
.PP
Answer `Y' if you want this to be a \*(CO partition.
If you answer `N',
.B build
asks:
.DM
	Do you want the partition marked as unused?
.DE
.PP
Answer `Y' if you want it to be unused.
If you answer `N',
.B build
displays the following message:
.B1
	This program can mark a partition as a COHERENT partition
	or mark it as unused.  It CANNOT initialize a partition for
	use by any other operating system.  To do so, you must mark
	it as unused now and subsequently use the disk partitioning
	program provided by the other system to initialize it correctly.
	Do you still want to modify this partition?
.B2
.PP
As this message notes,
.B build
cannot install any operating system other than \*(CO into a partition.
You can, of course, leave the partition unchanged.
.PP
The final two questions ask you to enter the new base cylinder for the
partition and the size of the partition in cylinders.
Each question will prompt you with the current value for the partition.
Simply pressing \*(RT leaves this current value unchanged.
You could make the partition smaller, but this serves no
practical purpose if you intend to install \*(CO into this partition.
.PP
If you have made a mistake during this process, the system will prompt
you and ask you to correct it.
Otherwise, you will proceed to the next phase of installation, which is
to scan for bad blocks (described below).
.PP
We've said it before, but just to make sure we'll say it once again:
\fINever\fR use the \*(CO version of \fBfdisk\fR to change
the size of an \*(MD partition!
Use it to change the size of an unused partition, or of a partition that
contains an operating system other than \*(CO.
If you wish to change the size of an \*(MD partition, back up all data
in that partition, then use the \*(MD version of \fBfdisk\fR.
.Sh "Changing All Logical Partitions"
.PP
This process mirrors what occurs when only one partition is changed,
except that it is iterated for every existing partition.
If you have four partitions and wish to eliminate one, simply set its
size to zero.
If you have fewer than four partitions, you will be asked if you wish
to create any additional ones.
.PP
Note one additional feature:
the table that displays the layout of partitions (an example of which is
shown above) is redisplayed after every partition, showing the changes
you have made (if any).
By looking at the table, you will find it easy to keep straight just what
you have done \(em when you work with this table, you will see the value of
working in cylinders.
.PP
If you make a mistake, the system will prompt you to correct it.
A common error is requesting overlapping partitions \(em that is,
setting the base cylinder of a partition within an area already
allocated to another partition.
Another error would be to request an impossibly large partition.
.PP
It is strongly recommended that you \fInot\fP include the last
cylinder of your hard disk in any partition.
This cylinder is often used by diagnostic programs, and, as such,
is not available for general use.
.PP
Once you have made your selection of partition strategy,
.B build
displays the altered partition table and asks you if you wish to proceed
with partitioning.
Answer `Y' if you do, `N' if you do not.
.Sh "Scanning for Bad Blocks"
.PP
When a partition on an MFM, RLL, or IDE disk drive
is assigned to \*(CO, it must be scanned for
bad blocks.
(The terms \fIblock\fR and \fIsector\fR are often used
interchangeably.)
Most hard disks have at least a few blocks in which the disk's surface
is flawed and therefore cannot be trusted to hold data reliably.
.PP
\*(CO keeps a list of bad blocks for each partition, to ensure
that it does not write data into an unreliable area.
This checking is performed automatically, but takes a few minutes.
Patience is recommended.
.PP
Note that scanning is usually not required on SCSI interface devices.
However, some users have reported problems with bad blocks on SCSI drives
that use removeable media.
We recommend that you scan your SCSI devices, just to be sure, especially
if they use removeable media; but this is not required.
.Sh "Selecting the Root File System"
.PP
If your newly partitioned disk has more than one partition assigned
to \*(CO,
.B build
displays information about the \*(CO partitions and asks you to make
one the root file system.
The following displays is for a system with two hard-disk drives (one
IDE and one SCSI):
the IDE drive has two \*(CO partitions and the SCSI has four:
.B1
	Your sytem includes 6 COHERENT partitions:
	Drive  Partition    Device     Megabytes
	  0        0      /dev/at0a      31.01
	  0        1      /dev/at0b      75.20
	  1        4      /dev/sd0a      20.96
	  1        5      /dev/sd0b      62.91
	  1        6      /dev/sd0c      62.91
	  1        7      /dev/sd0d      60.82
.sp \n(pDu
	You must specify one COHERENT partition as the root filesystem.
	The root filesystem contains the fies normally used by COHERENT.
	The root filesystem should be at least 10 megabytes.
	COHERENT partition 1 is marked as active in the partition table.
	If you choose it as the root, you can boot COHERENT automatically.
.sp \n(pDu
	Which partition do you want to be the root filesystem?
.B2
.PP
Select the partition number that you want to make the root file system.
Note that you are not obliged to make the boot partition the root file system;
this means that when you wish to boot \*(CO, you must select the partition
to boot by hand.
In a moment, you will be shown how to do this.
.Sh "Creating COHERENT File Systems"
.PP
Once you have selected the root file system,
.B build
displays the following message:
.B1
	You must create an empty COHERENT filesystem on each COHERENT partition
	before you can use it.  Creating an empty filesystem will destroy all
	previously existing data on the partition.
.B2
.PP
You must create
file system for each of the partitions that you have assigned to \*(CO.
You are not obliged to create a new file system for each \*(CO partition.
For example, some users who already have \*(CO may prefer to install the
new version of \*(CO onto an empty partition, rather than use \*(CO's
.B update
utility.
If this is the case with you, be careful not to build a new file system
onto a partition whose files you wish to save; for if you do so, all
existing files will be wiped out.
.PP
If you have more than one \*(CO partition,
.B build
asks you about each in turn.
When it comes to the partition that you have marked as holding the root
file system,
.B build
displays the following:
.B1
	WARNING!!!
.sp \n(pDu
	The installation process expects a NEW file system in the root partition.
	If you are trying to update an existing COHERENT partition, you must run
	the COHERENT update.  If you are trying to install again after a partial
	or failed installation, a new root filesystem must be created again now.
.B2
.PP
The message is clear:
build a new file system onto the root partition.
.Sh "Copying Files"
.PP
The next step is to copy some key files from the boot floppy disk to your
hard disk.
.B build
displays the following message:
.B1
	The next step is to copy some COHERENT files from the diskette to the
	root filesystem of your hard disk.  This will take a few minutes...
.B2
.PP
.B build
will copy a set of files for running the operating system.
It will also copy a set of configuration files and devices, to match
the information that you have entered so far.
As the message states, this does take a few minutes.
.Sh "Mounting File Systems"
.PP
After it copies key files into the root partition, \*(CO asks you about
each \*(CO partition in turn:
.B1
	Do you want /dev/\fIdev\fP mounted [y or n]?
.B2
.PP
Answer `y' for each partition whose file system you want to mount
automatically when you boot your \*(CO system.
If you are a novice \*(CO user, you probably should mount all file systems.
For details on what it means to
.I mount
a file system, see the entry for
.B mount
in the Lexicon.
.Sh "Cohabitating with MS-DOS"
.PP
.B build
now asks if \*(CO will cohabitate with \*(MD on your system:
.B1
	Do you use both COHERENT and MS-DOS on your hard disk?
.B2
.PP
If you answer `y',
.B build
then guides the process of ensuring that \*(CO and \*(MD cohabitate
peacefully.
.Sh "Naming File Systems"
.PP
If you have assigned more than one partition to \*(CO,
.B build
will display the following prompt:
.DM
	Your system includes \fIN\fP partition[s] in addition to the root partition.
	These partitions are usually mounted on directories in the COHERENT
	root filesystem when the system goes into multiuser mode.
	For example, one non-root partition might be mounted on
	directory "/u", another on "/v", and so on.
	You now may specify where you want each partition mounted.
.B2
.PP
.B build
is asking you to name each file system.
The name is actually the name of the directory upon which
\*(CO mounts that partiton's the file system.
Historically, a file system's directory has been named using a single
letter from the end of the alphabet, such as \*(Qlv\*(Qr
or \*(Qlu\*(Qr.
There's no reason, however,
not to give the directory a descriptive name, such as
``work'' or ``data''.
Each name must be preceded by a slash \*(Ql/\*(Qr.
.PP
When you name a file system,
.B build
asks if you wish to mount that file system automatically
when \*(CO enters multi-user mode.
There is no reason not to mount a file system at that time, so you
should answer `Y'.
.PP
Finally, if you have an \*(MD partition on one of your hard disks,
.B build
will ask if you intend to use both operating systems.
If you answer `Y',
.B build
will then you to enter the number of the partition that holds the
\*(MD file system \(em from 0 through 3 (if you have one hard disk),
or from 0 through 7 (if you have two hard disks).
.B build
creates a device called
.BR /dev/dos .
You can use this device to read files from the
\*(MD partition, or write files onto it.
.Sh "Patch the Kernel"
.PP
.B build
now displays the message:
.B1
	The kernel on your hard drive will now be patched to run on your system.
.B2
.PP
This step patches the kernel that
.B build
has copied onto your hard disk, so that the kernel will be able to read your
hard disk (or disks) when
.B build
reboots your system.
.Sh "First Reboot"
.PP
Now that the keyboard has been selected,
partitions have been allocated, and file systems have been created,
the next step requires that \*(CO be booted from the hard disk.
This is the first of two reboots that the installation of \*(CO requires;
the other will come after you have described to
.B build
your configuration of serial and parallel ports, and other peripheral
devices.
.PP
If you have elected to use the \*(CO bootstrap, and if you have
the \*(CO boot partition the active partition, all you have to do is
remove the \fBBoot\fR disk from the floppy-disk drive when
prompted, and then reset your computer.
.PP
.B build
prints the following message:
.B1
	You have installed the COHERENT operating system onto your hard disk.
	To install files from the remaining diskettes in the installation kit,
	you must boot the COHERENT system from the hard disk.  It will prompt
	you to install the remaining diskettes in the installation kit.
.sp \n(pDu
	After you have finished reading this information, remove the floppy disk.
.B2
.PP
If you have assigned \*(CO to a partition other than the boot partition (that
is, the partition that boots automatically when you power up your system),
.B build
displays the following:
.B1
	If you type a partition number (0-7) while
	the boot procedure is trying to read the floppy disk,
	your system will boot the operating system on that partition.
	If you type nothing, your system will boot active partition \fIN\fP (\fIsystem\fP).
.sp \n(pDu
	Now remove the floppy disk so your system does nto boot from the floppy.
	You MUST type \fIN\fP when the system tried to read the floppy disk during the boot
	procedure to boot the partition containing the new COHERENT root filesystem.
	Preparing to halt system.  Hit <Enter> ...
.B2
.PP
In this case, press
.I N
on the row of number of keys on the main set of keys (\fInot\fR on the keypad)
when the floppy disk's light comes on while the system is booting.
This tells \*(CO's master boot routine to boot the operating system on
partition
.I N
instead of the operating system
.I OS
that is on the partition booted automatically.
After you install \*(CO, you can at any time change the partition that
the master bootstrap boots automatically.
For more information on how to do this, see the Lexicon entries for
.B booting
and
.BR fdisk .
.PP
Note that if you have made \*(CO the operating system you boot normally,
you can use this procedure to boot \*(MD or any other operating system
that's on your machine.
The section at the end of this chapter describes how to make \*(CO
cohabitate on your machine with \*(MD, OS/2, or Windows NT.
.Sh "Copying Files"
.PP
Rebooting will take a few moments.
.PP
Once \*(CO has rebooted itself from your hard disk,
.B build
copies the \*(CO files onto your hard disk.
The system will prompt you to insert the remaining disks that hold
the \*(CO files, one after the other.
If you are installing from 5.25-inch floppy disks, you will be prompted for
five additional disks; whereas
if you are installing from 3.5-inch floppy disks, you will prompted for
four addition disks.
The discrepancy is due to the fact that each 3.5-inch floppy disk can hold
more data, so fewer of them are needed.
.PP
The system will ask you whether you want the full set of manual pages
on line in uncompressed form, and whether you want the dictionaries used
by the \*(CO spelling checker also in uncompressed form.
These files must be uncompressed before they can be used, but take up
much more room on the disk.
.PP
We urge you to install the manual pages if at all possible; these contain
the latest version of all Lexicon, including all entries written or revised
after the \*(CO manual was printed.
However,
the dictionary is probably not of much use to you unless you intend to use
the commands
.B spell
and
.BR typo .
.Sh "Installation Continues"
.PP
After your system reboots, \*(CO invokes a script that continues the
installation process.
After it installing the remaining set of disks,
.B build
asks if you wish to add additional users to your system:
.B1
	Your COHERENT system initially allows logins by users "root" (superuser)
	and "bin" (system administrator).  In addition, the password file contains
	special entries for "remacc" (to control remote access, e.g. via modem),
	"daemon" (the spooler), "sys" (to access system information), and
	"uucp" (for communication with other COHERENT systems).
.sp \n(pDu
	If your system has multiple users or allows remote logins, you should assign
	a password to each user.
.sp \n(pDu
	Do you want to assign passwords to users?
.B2
.PP
You should assign a password to each of these special users.
Be sure you remember the password you give to the superuser
.BR root ,
because that user controls the entire system.
If you answer `Y',
.B build
asks you the following:
.B1
	You must enter each password twice.
	Do you want to assign a password for user "root"?
	Do you want to assign a remote access password?
	Do you want to assign a password for user "bin"?
	Do you want to assign a password for user "uucp"?
.B2
.PP
For each of the above users for whom you answered `Y',
.B build
prompts you for a password.
As we noted before, don't forget those passwords.
In particular, do not forget the password for the superuser
.BR root .
.PP
Next,
.B build
ask you to create logins for every other person on your system.
You should create a login for every person who will be using your system,
including yourself:
.B1
	You should create a login for each additional user of your system.
.sp \n(pDu
	Do you want to create another login?
.B2
.PP
If you indicate that you want to create one or more logins,
.B build
displays the following:
.B1
	You must specify a login name, a full name and a shell for each user.
	Joe Smith might have login name "joe" and full name "Joseph H. Smith."
	His home directory would be in "/usr" by default, namely "/usr/joe".
	Do not type quotation marks around the names you enter.
.sp \n(pDu
	Do you want home directories in "/usr"?
.B2
.PP
The first question asks you for the name of the directory system that will
hold your users' home directories.
Traditionally, these go into
.BR /usr ,
although you can put them into any file system that you created earlier.
.PP
Now, for each user,
.B build
asks the following questions:
.B1
	Login name:
.sp \n(pDu
	Full name:
.B2
.PP
These questions are self-explanatory.
.PP
.B build
then asks you for the shell that you want the user to use.
It explains the situation as follows:
.B1
	COHERENT includes three different command line interpreters, or shells.
	A command line interpreter is a program which reads and executes each
	command which the user types.  The available command line interpreters
	are the Bourne shell (/bin/sh), the Korn shell (/usr/bin/ksh) and the
	visual (full screen) shell (/usr/bin/vsh).
.sp \n(pDu
	Use the visual shell if you prefer a menu-driven interface.  Use the
	Bourne shell if you are not sure which shell to use.
.sp \n(pDu
	After you have finished installing COHERENT, you can change the shell
	for any user by editing the password file /etc/passwd.
.sp \n(pDu
	Do you want to user \fIuser\fP to use the Bourne shell (/bin/sh)?
.B2
.PP
.B build
then asks you in turn whether you wish to assign
.BR sh ,
.BR vsh ,
or
.BR ksh .
As the message says, if you do not know which shell to use, select
.BR sh .
.PP
Finally,
for each user
.B build
asks you if you wish to assign a password to that user.
If you say yes, it prompts you for the password.
.Sh "Describe Serial Ports"
.PP
.B build
now asks you about your serial ports and modems:
.DM
	Does your computer system have a modem?
.DE
.PP
If you answer `Y',
.B build
asks:
.B1
	You must specify which asychronous serial line your modem will use.
	See the article "asy" in the COHERENT documentation for details.
.sp \n(pDu
	Enter 1 to 4 for COM1 through COM4:
.B2
.PP
Enter the serial port into which you have plugged your modem, as shown above.
.PP
The next question concerns whether you wish to run a serial port in polled
or interrupt mode.
Under the architecture of the IBM PC, serial ports are linked in pairs:
port 1 is linked to port 3, and port 2 to port 4.
If you use both ports in a pair, only one can interrupt-driven; the other must
be polled.
Polling a port consumes much more in the way of system resources than having
the port interrupt driven.
The lesson is that if you have two devices plugged into serial ports on your
system, you should plug one into an even-numbered port and the other into an
odd-numbered one; in this way, both can interrupt-driven.
.PP
If you use both even-numbered or odd-numbered ports,
.B build
asks you which should be interrupt-driven, as follows:
.B1
	If your computer system uses both ports COM\fIx\fP and COM\fIy\fP,
	one must be run in polled mode rather than interrupt-driven
.sp \n(pDu
	Do you want to run COM\fIx\fP in polled mode?
.B2
.PP
where
.I x
and
.I y
are either 1 and 3, respectively, or 2 and 4.
Respond appropriate to the prompts.
When you have finished,
.B build
links the file
.B /dev/modem
to the port that has your modem plugged into it.
The command
.B ckermit
will use this by default.
For information on how to plug more than one modem into your system, see
the Lexicon article
.BR modem .
.PP
.B build
then asks if you wish to ``turn on'' your serial ports:
.B1
	Enable use of serial ports?
.B2
.PP
Unless you have a serious reason not to do so, you should answer `y'.
.PP
Finally,
.B build
asks you whether your printer is plugged into a serial port:
.B1
	The default printer on COHERENT is /dev/lp.
	This device may be linked to any valid parallel or serial port.
.sp \n(pDu
	Do you want /dev/lp to refer to COM1?
.B2
.PP
It asks you this question for each serial port until you either answer
`y' or until it runs out of ports.
If your printer is plugged into a parallel port, answer `n' to each prompt.
.B build
will configure parallel ports in a moment.
.Sh "Virtual Consoles, Part 1"
.PP
As noted earlier, \*(CO supports virtual consoles.
This means that you can have more than one console functioning at the same
time; the system will think that it is dealing with multiple separate console
devices.
You can flip from one console session to another by pressing a \fIhot key\fP;
or you can have two different physical devices \(em one monochrome and one
color, if you wish \(em and run multiple sessions on each.
This is useful if, for example, you wish to debug a program
by running it from one console session and sending the output to another.
You should decide how many virtual consoles you want:
from one to four per physical device.
.PP
At this point in installation, you will see the following prompt:
.B1
	This release of COHERENT supports multiple simultaneous sessions on the
	system console.  This feature, known as virtual consoles, supports both
	monochrome and color video cards (text mode only) with multiple "login"
	sessions on each, depending upon your hardware configuration.  If you have
	both color and monochrome adapters on your system, you can run multiple
	sessions on each of them at the same time.
.sp \n(pDu
	Virtual console support only works with systems which have at least one
	megabyte of usable system memory.  You may choose a loadable keyboard table
	or a non-loadable keyboard table.  Loadable keyboard tables will give you the
	flexibility of remapping your keys and to load new tables at any time while
	your system is active.  This requires keyboards that are 100% IBM AT compatible.
	If you chose a non-loadable keyboard you will not have this flexibility.
.sp \n(pDu
	Not all keyboards are 100% IBM AT compliant and will not work with loadable
	keyboard tables.  If your keyboard is not 100% IBM AT compliant, it may result
	in COHERENT not booting properly after the installation process is completed,
	or you may find that your keyboard keys are not mapped as they are labelled and
	that some keys cease to function at all.  For this reason, the default selection
	is the non-loadable keyboard.
.sp \n(pDu
	Do you wish to include support for virtual consoles?
.B2
.PP
If you answer `y',
.B build
will prompt you later for more information on your video card.
In either case, the next step is to select your keyboard.
.Sh "Selecting a Keyboard"
.PP
The next menu asks you to select a keyboard table from the following list:
.nf
.sp \n(pDu
	Belgian 102-key AT keyboard table
	Canadian French 102-key AT keyboard table
	Danish 102-key AT keyboard table
	Dutch 102-key AT keyboard table
	French 101-key standard AT keyboard (not loadable)
	French 102-key AT keyboard table
	German 102-key standard AT keyboard (not loadable)
	German 102-key AT keyboard table
	Italian 102-key AT keyboard table
	Latin American 102-key AT keyboard table
	Norwegian 102-key AT keyboard table
	Portuguese 102-key AT keyboard table
	Spanish 102-key AT keyboard table
	Swedish/Finnish 102-key AT keyboard table
	Swiss French 102-key AT keyboard table
	Swiss German 102-key AT keyboard table
	U.K. 102-key AT keyboard table
	U.S. 101-key standard AT keyboard (not loadable)
	U.S. 101-key AT keyboard table
.fi
.PP
The menu entries marked
.B "(not loadable)"
are the traditional \*(CO keyboard drivers, which are linked
directly into the kernel.
These include the traditional US, German, and French keyboards.
These traditional keyboard drivers work with all keyboards,
even the non-standard ones sold with some ``clones''.
These drivers cannot be used with virtual consoles,
and so will not appear on the list if you are using these consoles.
.PP
The other 16 or so menu entries represent loadable tables.
These use the
.B nkb
driver and thus allow you to customize the tables to your liking,
as well as load new tables at run time.
Please note, however, that the
.B nkb
driver (and loadable tables) only work with well-engineered
keyboards, such as those built by IBM, Cherry, MicroSwitch, 
NMB Technologies, or Keytronic;
when used with an non-standard ``clone'' keyboard, it may not work correctly.
.PP
When the menu appears, it highlights the line for the non-loadable U.S.
keyboard.
This table will satisfy the needs of all users in the United States, and
many users abroad.
To select this entry, simply press \*(RT:
\*(CO will do the rest.
.PP
If you want another keyboard, press the space bar
until the table you want is highlighted; then press \*(RT
to select the highlighted entry.
Note that the new keyboard layout takes effect as soon as \*(CO reboots
itself to read the rest of the installation disks.
.PP
If you choose one of the entries marked
.BR "not loadable" ,
you can use only that keyboard layout; the only way to select another
keyboard layout is to use the commands
.B cohtune
and
.B idmkcoh
to modify the kernel configuration and build a new kernel.
This sounds complex, but actually is rather easy;
for details, see the Lexicon entries for these commands.
.PP
If your keyboard's layout does not correspond to one of the
entries from the menu, select a loadable keyboard table
layout that resembles your keyboard.
After installation, you will be able to modify that
entry to make it correspond to your keyboard.
See Lexicon articles
.B "keyboard tables"
and
.B nkb
for further details on creating a new keyboard layout,
or modifying an existing one.
In addition,
the Mark Williams Company BBS system contains additional keyboard tables.
See the following sections of this manual for details on accessing
the MWC BBS system and on contacting satellite \*(CO BBS systems
around the world.
.Sh "Virtual Consoles, Part 2"
.PP
If you earlier decided to install virtual consoles,
.B build
asks you for information about the number and type of video cards that
you have in your system.
.PP
First, you will be asked:
.B1
	Does this system have a monochrome (i.e., MDA) video adapter
.B2
.PP
Answer `y' or `n'.
If you answer `y', you will then be asked:
.B1
	How many active virtual console sessions would you like on your
	monochrome video adapter card [1-8]?
.B2
.PP
Enter the number of sessions.
.PP
Next,
.B build
will ask:
.B1
	Does this system have a color (i.e., CGA/EGA/VGA) video adapter?
.B2
.PP
Answer `y' or `n'.
If you answer `y',
.B build
then asks:
.DM
	How many active virtual console sessions would you like on your
	color video adapter card [1-8]?
.DE
Enter the number of sessions you would like to have on this device.
.Sh "Installing Floating Point"
.PP
The next issue that
.B build
addresses is that of floating point:
.B1
	System is not equipped for floating point support.
	Floating point operations are used by WordPerfect, 123, and other programs.
	Enable software emulation of floating point?
.B2
.PP
.B build
asks this if your system does not have a mathematics co-processor.
(If your system does have a coprocessor, you will not see this prompt;
and \*(CO will use hardware floating point by default.)
Answer `Y' if you intend to run any software that requires that your system
have a mathematics co-processor or emulate one; these packages include
WordPerfect, Lotus 1-2-3, and also the GNU C compiler.
If you are not going to run any of these packages, you do not need floating
point emulation.
If you are not sure, you probably are better off to have it; it makes the
kernel somewhat larger, but otherwise does not affect the operation of
your system.
.Sh "Identifying the SCSI Devices"
.PP
If you have a SCSI controller, you earlier were asked to give a SCSI
identifier to each SCSI hard disk that you have plugged into that controller.
At this point,
.B build
asks you to confirm this:
.B1
	Hard drives are configured at the follow SCSI id numbers:
	\fInumbers\fP
	Is this correct?
.B2
.PP
If this is not correct, press `n'.
.B build
will walk you through entering the correct numbers.
.PP
If earlier you selected option 1 from the menu of possible SCSI devices
(that is, the Adaptec controller with one or more hard disks and tape),
.B build
now asks you about the SCSI identifier for the tape device:
.B1
	Tape drives are configured at the following SCSI id number:
	2
	Is this correct?
.B2
.PP
Practically every SCSI tape device is jumpered by default for SCSI identifier
2.
It `2' is the correct identifier, press `y';
.B build
will move on to the next topic.
However, if `2' is not the correct idenifier, press `n';
.B build
will then walk you through entering the correct number.
.Sh "Describe Parallel Ports"
.PP
Unlike the serial ports,
you do not have to tell the \*(CO kernel how it should read your system's
parallel ports.
However, as with the serial ports,
.B build
asks you if you have your printer plugged into a parallel port:
.B1
	The default printer on COHERENT is /dev/lp.
	This device may be linked to any valid parallel or serial port.
.sp \n(pDu
	Do you want /dev/lp to refer to LPT1?
.B2
.PP
.B build
asks you this for each parallel port, until either you answer `y' or
.B build
runs out of ports about which to inquire.
.PP
If you are not sure which port you have your printer plugged into, answer
`y' for LPT1.
The Lexicon entry for
.B printer
tells you how to find out the port into which your printer is plugged;
it also contains much useful information on how to configure your printer,
and the printer-related software that comes with \*(CO.
.PP
.B build
then displays the following information:
.B1
	Your BIOS identifies the following parallel printer ports:
	LPT1: \fIaddress\fP LPT2: \fIaddress\fP LPT3: \fIaddress\fP
	Enable use of parallel ports?
.B2
.PP
Press `y' if you want your \*(CO system to be able to use the parallel ports.
Press `n' if you do not, or if these addresses are bogus.
Note that if something is wrong (such as a wrong address being used),
you should be able to modify the kernel
after installation to correct the problem.
.Sh "Rebuilding the Kernel"
.PP
After
.B build
has asked you about your parallel ports, it builds a new kernel on your system.
This new kernel reflects the information you entered about your serial and
parallel ports, and about floating-point emulation.
.PP
You may see much incomprehensive stuff on your screen during this phase.
Do not worry about it \(em if
something goes serious wrong,
.B build
will tell you about it explicitly.
.Sh "Setting the Date and Time"
.PP
.B build
next sets the date and time for \*(CO.
Setting the date and time is vital to the correct operation of
\*(CO; however, \*(CO records the date and time quite differently
from the way \*(MD does.
.PP
Time under \*(CO is recorded as the number of seconds since January 1, 1970,
at exactly midnight.
Internally, \*(CO always stores time as Greenwich Mean Time.
GMT is used
to make it easy for \*(CO systems around the globe to coordinate time with
each other.
When \*(CO
time-stamps a file or displays the time, it converts Greenwich Mean Time to
your local time, depending on what time zone you live in and whether
Daylight Savings Time is in effect.
(For a detailed discussion of this topic, see the Lexicon's entry for
.BR TIMEZONE .)
.PP
.B build
first asks you if you wish to convert system time to daylight-savings time:
.B1
	You can run COHERENT with or without conversion for daylight savings time
	(summer time).  You should normally run with daylight savings time
	conversion.  However, if you are going to use both COHERENT and MS-DOS
	and you choose to run with daylight savings time conversion,
	your time will be wrong (by one hour) during daylight savings time
	while you are running under MS-DOS.
.sp \n(pDu
	Do you want COHERENT to use daylight savings time conversion?
.B2
.PP
Answer `Y' if you wish to use daylight-savings time, or `N' if you do not.
If you answer `Y',
.B build
then asks you about when daylight-savings time begins and ends:
.B1
	By default, COHERENT assumes daylight savings time begins on the
	first Sunday in April and ends on the last Sunday in October.
	If you want to change the defaults, edit the file "/etc/timezone"
	after you finish installing COHERENT.
.sp \n(pDu
	Is daylight savings time currently in effect?
.B2
.PP
The default settings are those enacted by law for the United States.
For information on how to reset the file \fB/etc/timezone\fR, see the
entry for
.B TIMEZONE
in the Lexicon.
.PP
.B build
then asks you to confirm your system's date and time:
.B1
	According to your system clock, your local date and time are:
	\fI[date and time]\fP
	Is this correct?
.B2
.PP
Answer `Y' if the date and time are correct, `N' if they are not.
If the date and time are not correct,
.B build
asks you to enter the current date and time, in the form \fIYYMMDDHHMM\fR.
.PP
If
.B build
cannot read or alter your system's clock (for whatever reason), it displays the
following message:
.B1
	The command which sets the internal real-time clock of your system is
	failing repeatedly.  Either you are entering the date and time incorrectly
	or your clock hardware is not completely AT-compatible.  If your clock
	hardware is incompatible, you can continue with the installation without
	setting the clock correctly.  However, if you do so, subsequent clock
	references (including file access and modification time information) will be
	incorrect and some commands (such as "date") will not function correctly.
.sp \n(pDu
	Do you want to proceed without setting the clock correctly?
.B2
.PP
If you answer `N',
.B build
aborts entering date and time information.
You should carefully examine your system's hardware, to ensure that the clock
is working correctly (that its battery, for example, is still charged).
Many of \*(CO's features do not work if it cannot read the system's clock.
.PP
Next,
.B build
displays the following menu and asks you what time zone you live in:
.B1
	Please choose one of the following timezones:
		0	Central European
		1	Greenwich
		2	Newfoundland
		3	Atlantic
		4	Eastern
		5	Central
		6	Mountain
		7	Pacific
		8	Yukon
		9	Alaska
		10	Bering
		11	Hawaii
		12	Other
.B2
.PP
If you select 0 through 11,
.B build
sets your local time automatically.
If you select ``Other'',
.B build
displays the following:
.B1
	You need to specify an abbreviation for your timezone,
	whether you are east or west of Greenwich, England,
	and the difference in minutes between your timezone
	and Greenwich Time (called UTC or GMT).  For example,
	Germany is 60 minutes of time east of Greenwich.
.sp \n(pDu
	Abbreviation for your timezone:
.sp \n(pDu
	Is your timezone east of Greenwich?
.sp \n(pDu
	Difference in minutes from GMT:
.sp \n(pDu
	Abbreviation for your daylight savings timezone:
.B2
.PP
If you are unclear on these concepts, consult the Lexicon article on
.BR TIMEZONE .
If you are unsure about how your local time relates to Greenwich time,
consult an atlas, check with your local library, or telephone a
local radio station.
.PP
.B build
then displays the corrected local time and asks if it is correct.
If not, you can repeat the process until the time is correct.
.Sh "System and Domain Names"
.PP
.B build
now asks you for the name of your system, and of your domain.
You must give your system a name if you wish to use electronic mail
on your system.
.PP
.B build
begins by displaying the following message and asking you for the name of
your system:
.B1
	In order to use COHERENT's electronic mail facility and UUCP subsystem,
	you must choose a "site name" for your computer system.  In general, a site
	name consists of lower case letters or digits and should be at most seven
	characters in length.  The name you choose should be unique if you intend
	to access any other computer systems.  Some of the more well known site
	names include "mwc", "uunet", "clout", "decwrl", "hp", "kgbvax", "prep",
	"seismo", and "ucbvax".
.sp \n(pDu
	Please enter the site name for this system:
.B2
.PP
See the Lexicon article
.B uucpname
for details on what sort of name you should give your system.
.PP
A
.I domain
is a group of systems that can be addressed collectively by other
computer systems.
Most domains are registered with the groups that administer e-mail collectives
nationally and have their addresses recorded.
Thus, by enrolling in a domain, computer users from around the
world will be able to exchange electronic mail with you.
For more information, see the Lexicon entry
.BR domain .
.PP
.B build
now asks you to enter your system's domain:
.B1
	The COHERENT mail subsystem supports "domain addressing" in addition to
	traditional "bang paths".  Until your system becomes part of a registered
	domain, you may use the UUCP pseudo-domain.  Domain names consist of groups
	of letters and digits separated by periods (dots).  Some of the more well
	known domains include "com", "edu", "gov", "org", "net", as well as domains
	covering a geographical area, such as the Chicago area "chi.il.us" domain.
	If you are not registered in a domain, or if you are uncertain about this
	question, simply press the <Enter> key to default to the UUCP pseudo-domain.
.sp \n(pDu
	Please enter the domain name for this system:
.B2
.PP
If you have arranged to have your system join a domain, enter its name.
If you have not, press \*(RT to select the default domain
.BR UUCP .
.PP
For more information on domains and electronic mail, see the tutorial for
UUCP, and the Lexicon entry for \fBmail\fR.
.Sh "Installing Taylor UUCP Files"
.PP
At this point,
.B build
installs the files used by the Taylor UUCP system.
This system performs remote, automated communication with other \*(CO and
\*(UN systems.
When this is finished, press \*(RT to continue with installation.
.\".Sh "Uncompress Manual Pages"
.\".PP
.\"The next issue that
.\".B build
.\"addresses is the installation of on-line manual pages:
.\".B1
.\"	The online COHERENT manual pages in /usr/man are shipped in compressed form.
.\"	The compressed manual pages use about 2000 blocks (1 MB) of disk space.
.\"	The uncompressed manual pages use about 5000 blocks (2.5 MB).
.\".B2
.\".PP
.\"If your system has less than 5,000 blocks (2.5 megabytes) free,
.\".B build
.\"will show you the following warning:
.\".B1
.\"	Your system has insufficient free space on the root filesystem to store
.\"	the uncompressed manual pages.  You may uncompress and un-tar the manual
.\"	pages at a later date if you free up at least 5000 blocks on your root
.\"	filesystem.
.\".B2
.\".PP
.\"If you do have sufficient space,
.\".B build
.\"gives you the following choices:
.\".B1
.\"	You can either:
.\"		1) Remove the manual pages,
.\"		2) Leave the manual pages compressed, or
.\"		3) Uncompress the manual pages.
.\"	The "man" command will work only if you uncompress the manual pages (option 3).
.\".B2
.\".PP
.\"If you have enough space to spare, you should install the manual pages.
.\"These give the most up-to-date version of the \*(CO Lexicon pages.
.Sh "Install the Dictionary"
.PP
Next,
.B build
asks if you want to uncompress the dictionary used by the command
.BR spell :
.B1
	The COHERENT dictionary in /usr/dict is shipped in compressed form.
	The compressed dictionary uses about 350 blocks (.175 MB) of disk space.
	The uncompressed dictionary uses about 1700 blocks (.85 MB).
	You can either:
		1) Remove the dictionary,
		2) Leave the dictionary compressed, or
		3) Uncompress the dictionary.
	The "spell" command will work only if you uncompress the dictionary (option 3).
.B2
.PP
You should uncompress the dictionary only if you wish to use
.B spell
to check your text documents.
.Sh "Install the Print Spooler"
.PP
\*(CO version 4.2 includes the MLP print spooler.
This spooler implements a version of the \fBlp\fR spooler used by \*(UN
System V.
To set up MLP correctly, you need to enter some information about
what printers you have plugged into your system, and the ports into which
they are plugged.
.B build
begins with the following message:
.B1
	COHERENT includes print spooling software which allows you to use
	multiple printers.  Earlier we asked you about your printer to determine
	which port it used.  Now we will complete printer spooler configuration.
.B2
.PP
.B build then asks:
.B1
	Is your printer a laser printer?
.B2
.PP
Answer `y' if it is, and `n' if it is not.
.PP
.B build
then asks:
.B1
	Is your printer a PostScript printer?
.B2
.PP
Again, answer `y' if it is, and `n' if it is not.
.PP
That's all there is to it.
.B build
will configure the spooler correctly, so you can begin to print as soon
as you have completed installation.
.PP
Note that
the above procedure supports only one printer on one port.
You can configure MLP to support an indefinite number of printers, plugged
into serial ports, parallel ports, or even into the auxiliary ports of
dumb terminals.
For details, see the Lexicon entries for
.B printer
and
.BR controls .
.Sh "Second Reboot"
.PP
At this point,
.B build
has completed its work.
It has copied \*(CO onto your hard disk, built file systems,
used information you entered to configure a kernel for you,
added users, and performed all of the other miscellaneous tasks
needed to establish a multi-user, multi-tasking operating system on
your machine.
.PP
The final task that
.B build
performs is to reboot your system a second time.
This invoke the kernel it built after the first time
it rebooted your system.
After the system has rebooted, you can log in and begin to use your new
system.
.PP
Before
.B build
reboots, it displays the following message:
.B1
	System configuration done, will take effect after reboot.
.sp \n(pDu
	You have completed the installation procedure successfully.
	Don't forget to remove the last diskette from the disk drive.
.sp \n(pDu
	You must reboot your system in order to allow the preceding
	configuration steps to take effect.
	Preparing to halt system.  Hit <Enter> ...
.B2
.PP
If your system does not immediately reboot after you see this message, press
the reset button.
.PP
Your newly installed \*(CO system will use the utility
.B fsck
to examine and (possibly) correct any minor flaws in your system's file systems.
It will then go into multi-user mode.
You can log in and begin to use \*(CO.
.PP
If you are a novice to \*(CO, we urge you to turn to the tutorial
.IR "Using the COHERENT System" ,
which is located near the beginning of your \*(CO manual.
This will help you become acquainted with \*(CO.
.PP
If you are experienced with \*(CO or \*(UN, you may wish simply to
see what comprises \*(CO
Invoke the command
.BR /etc/coh_intro .
This gives you a ``guided tour'' of \*(CO, so you can see what is in it.
The Lexicon entry
.B commands
also summarizes all commands that are in the \*(CO system.
.PP
This concludes the installation of your \*(CO system.
The next sections of this chapter describe how you can have \*(CO
co-habitate with other operating systems on your machine.
The final section describes some problems that can arise with installation
and suggests how you can deal with them.
.SH "Installing COHERENT With Other Operating Systems"
.PP
Many users wish to run \*(CO but keep \*(MD, OS/2, or Windows NT
on their machines as well.
The following describes how to do this.
.Sh "MS-DOS in One Partition; OS/2 in Another; Boot Manager Installed"
.PP
IBM's OS/2 Boot Manager is a program that resides in its own partition on
the hard drive.
If the OS/2 Boot Manager is installed, then that probably means
that \*(MD is the first partition, and that OS/2 was installed as a
.I logical
or
.I extended
partition, which can only be booted from Boot Manager.
With the first three partitions taken up by \*(MD, Boot Manager, and OS/2,
\*(CO can be installed only into the fourth partition.
To install \*(CO:
.IP \fB1.\fR 0.3i
If the whole drive is taken up, you must back up the \*(MD
partition, delete it, and re-create it
(minus the amount of space you wish to reserve for \*(CO).
.IP \fB2.\fR
Install \*(CO normally:
Place the boot disk into drive A and reboot.
.IP \fB3.\fR
When you see the question
.DM
	Would you like to install the Coherent Master Bootstrap?
.DE
answer `y'.
.IP \fB4.\fR
A little later,
.B build
invokes \*(CO's
.B fdisk
utility.
Choose the partition into which you will install \*(CO.
Choose as you would normally; however, before you leave
.BR fdisk ,
\fImake the \*(CO partition active.\fR
This bypasses the OS/2 Boot Manager program and boots \*(CO automatically.
\fIThis is essential to completing installation!\fR
.PP
To boot \*(MD or \*(CO, use the \*(CO Master Bootstrap to boot the
partitions normally:
upon turning on the computer,
press the number key that corresponds to the partition whose operating
system you wish to boot.
.PP
To start OS/2, boot the Boot Manager partition by pressing the number key
that corresponds to its partition;
and when Boot Manager starts, select OS/2.
.Sh "MS-DOS and OS/2 in the Same Partition"
.PP
OS/2 users can install OS/2 into the same partition as \*(MD.
To boot OS/2, users type a command that swaps the
\*(MD boot files with the OS/2 boot files.
Due to the location, placement, and
attributes of these boot files, only the \*(MD files and
directory structures can be backed up; therefore, your options are
limited to the following:
.IP \fB1.\fR 0.3i
Back up the \*(MD\(emOS/2 partition.
This is to preserve your data and directory structure.
.IP \fB2.\fR
Boot \*(MD and run the \*(MD version of
.BR fdisk .
.IP \fB3.\fR
Delete the \*(MD\(emOS/2 partition, then re-create it minus the amount of
space you wish to reserve for \*(CO.
After rebooting out of the \*(MD version of
.BR fdisk ,
reinstall \*(MD.
.IP \fB4.\fR
Install \*(CO normally.
.IP \fB5.\fR
After you have installed \*(CO,
reinstall OS/2 back onto the \*(MD partition.
To help restore the previous OS/2 setup, run OS/2's
.B migrate
program.
.PP
To boot \*(CO when you boot your computer,
press the number key that corresponds to the number of
its partition.
To boot either \*(MD or OS/2,
press the number key that corresponds to the number of their partition \(em
usually `0'.
.Sh "Windows NT and MS-DOS with COHERENT"
.PP
The following describes how to install \*(CO, \*(MD 6.0, and Windows NT onto
the same system.
.IP \fB1.\fR
First install \*(MD 6.0 into its own partition.
.IP \fB2.\fR
Install Windows NT into its own partition.
Use the Dual-Boot facility in
Windows NT to select either Windows NT or \*(MD to boot when powering up.
.IP \fB3.\fR
Install \*(CO into its own partition.
This can either be on the same drive as \*(MD and Windows NT, or, if your
system has two hard disks, onto its own disk.
Use the \*(CO Master Bootstrap to be the boot manager.
In this way, you can boot any partition on your system, and so easily
boot any of the three operating systems.
.PP
Because you will be working with three operating systems, you may wish to
use the \*(CO
.B fdisk
command to configure the master bootstrap, so that it does not boot any
partition by default.
In that way, you can select whatever partition \(em and therefore,
whatever operating system \(em you want at boot time.
If you want to boot either \*(MD or Windows NT, select the partition for
Windows NT; its Dualboot will take over and boot either Windows NT or
\*(MD, whichever you choose.
.Sh "COHERENT and MS-DOS 6.0"
.PP
Release 6.0 of \*(MD offers a feature of dynamic file compression that
creates some difficulties for machines that have both \*(CO and \*(MD on
their systems.
.PP
To begin, \*(MD 6.0 assumes that it is the only operating system on your
computer.
When you install \*(MD 6.0, by default it overwrites the COHERENT master boot
block.
If at all possible, you should install \*(MD 6.0
.IR first ,
and then install \*(CO to ensure that the \*(CO Master Bootstrap is in
control of system, so that you can boot either operating system.
.PP
Second, \*(MD 6.0 offers a compression utility called
.BR dblspace ,
which compresses \*(MD file systems on the fly.
\*(CO's
.B dos
commands do not understand compressed \*(MD file systems created by the
\*(MD 6.0 utility
.B dblspace ,
or by such programs as
.BR Stacker .
If you are running \*(MD 6.0 with file compression,
you must copy files to an uncompressed file system
(for example, to an uncompressed floppy disk or to the uncompressed
host for a compressed file system) to make them accessible to the \*(CO
.B dos
commands.
.SH "Problem With Installation"
.PP
As we mentioned earlier, tens of thousands of users have
successfully installed \*(CO onto their computers.
Most encountered no difficulty whatsoever during installation;
chances are you too will not encounter any.
.PP
If problems do arise, the Mark Williams support staff will gladly
help you.
Before you call, however, be sure to read the following sub-sections
and follow their directions.
Each describes a commonly encountered problem,
and gives advice on how to overcome it.
.PP
If your problem is not covered in this chapter \(em or if you have tried
what it suggests and it does not work \(em call Mark Williams.
Information about contacting Mark Williams Technical Support is given in
the introduction to this pamphlet.
.Sh "Did the system go multi-user prematurely?"
.PP
With some configurations of hardware,
.B build
does not initiate the second rebooting of the system; rather, it attempts
to go multiuser immediately, and displays a cascade of errors on the system
console.
.PP
This problem is due to the fact that kernel being used at that stage of
installation does not yet support the full suite of peripheral devices.
You need to reboot your system to invoke the kernel that was built during
the final stage of installation.
Just press the reset button on your system; this will reboot your computer
and invoke the newly built kernel.
Thereafter, all should be well.
.Sh "Printing does not work"
.PP
In some cases, attempts to print via the parallel ports would generate
messages of the form
.DM
	Cannot open /dev/lpt1
.DE
even though that device exists and has its permissions set correctly.
This is probably due to the fact that in a few rare instances,
.B build
program did not include the driver
.B lp
in the kernel that it built during the final stage of installation.
.PP
To get around this problem, use the command
.B idenable
to enable the driver
.BR lp ;
then use the command
.B idmkcoh
to build a new kernel.
Once a new kernel is built, reboot your system and all should be well.
For details, see the Lexicon entries for
.B idenable
and
.B idmkcoh
in these notes.
.Sh "Does your system hang instead of reboot?"
.PP
In rare instances, the \*(CO command
.B reboot
does not reboot the system; rather, it stops current processing but does
not initiate rebooting.
If this happens, just press the reset button on your system to reboot;
doing so will not harm your system in any way.
.Sh "Are you using incorrect chipset parameters?"
.PP
If your system ``hangs'' when it attempts to boot from the \*(CO
boot disk, your motherboard's CMOS setup parameters may be incorrect.
Many systems use chipsets that support user-configurable bus speeds
and timing.
On these systems, if you attempt to run the bus clock at too high a rate,
certain peripherals will not function correctly.
For example,
on systems using the OPTI chipset and the AMI BIOS, you should verify
that the system's ``bus speed'' is set to
.B CLKIN/4
rather than
.B CLKIN/3
or
.BR CLKIN/2 .
In addition, if parameter ``AT STRETCH'' is available, it should be
set to
.BR ENABLED .
If the aforementioned parameters are not set correctly,
you will experience incorrect system behavior.
.Sh "Are you booting COHERENT Disk 1 via <ctrl-alt-del> (warm boot)?"
.PP
It may help to cold boot your system:
that is, turn power off, wait at least 30 seconds, then turn power back on.
Rebooting via cold boot is more resistant to
getting a virus from something you have already loaded, and avoids
the family of bugs in the AMI BIOS, \*(MD, and Windows that relate
to warm boots.
.Sh "Do you have a defective RAM chip?"
.PP
We have seen cases in which computers go through normal startup and
even run \*(MD without difficulty, but give panic errors or stack
overflow errors randomly when running in protected mode.
Weak memory chips and some defective or poorly designed
motherboards can be found by
running a thorough, protected-mode diagnostic program on memory,
then replacing all defective parts that it discovers.
.Sh "Are you running in Turbo mode?"
.PP
Sometimes customers, especially those experiencing panic traps, can
install when they change processor speed.
Although the improvement, when it occurs, usually happens when the CPU
is slowed down, we have seen one case where it helped to speed up the processor.
In general, panics that vanish or significantly change their pattern of
appearance when CPU speed is changed, strongly suggest that the problem
is due to a poorly designed or incompatible motherboard (see below).
.Sh "Will it help to change the master boot procedure?"
.PP
If you are having trouble selecting the partition from which
your computer boots,
it may help to modify the master boot sequence, as follows.
(1) Use the command
.B /etc/fdisk
to select \fIno\fR active partition, or,
during startup, hold down the key corresponding to the root \*(CO
partition (over the alpha keyboard, \fInot\fR on the numeric keypad) until
startup halts with a keyboard error.
(2) Press \fB<F1>\fR to continue.
Boot should progress to \*(CO.
.Sh "Is CMOS configured correctly for drive A?"
.PP
Some customers who ordered the wrong size of floppy disks
switched floppy-disk drives A and B,
but failed to update the setup for the computer.
This often produces an error message of the form
.DM
	fsminit:  no root dev (4,14)
.DE
The solution is to configure the CMOS correctly.
See your computer's technical documentation for details on how to do this.
.Sh "Do you have an incompatible hard-drive controller?"
.PP
If you have a Western Digital controller model WD1006V-SR2 and it is a
Feature 3 board, you may need to replace it.
Some of these controllers have defects that cause them to latch up.
.PP
If you have a Western Digital controller model WD1006V-SR2 and it is a
Feature 5 board (Feature 5 boards have all the
jumper headers installed), install
the ``non-latched'' mode jumper, which is the first one (J1).
.PP
In any case, please contact Mark Williams Technical Support
with the make and model of the controller.
It may lead us to a new pattern that we can accommodate.
Some customers have Perstor, IDE, ESDI, or SCSI controllers
and did not know it until they checked the controller type;
there are known compatibility issues
with some controllers of all the above types.
.Sh "Do you have incompatible hard-drive parameters?"
.PP
If you were
.I unable
to install \*(CO,
check the contents of \fBCONFIG.SYS\fR from the \*(MD
root directory on drive C.
If you find one of the following \fBDEVICE=\fR entries there
that configures the hard drive,
it may be an indication that your hard disk layout is non-standard.
However, many users of the following device drivers have successfully
installed \*(CO, so please be sure that you have attempted installation
\fIprior\fR to contacting Mark Williams Technical Support.
.DS
	DMDRVR.BIN
	EDVR.SYS
	SSTOR.SYS
	HARDRIVE.SYS
	FIXT_DRV.SYS
.DE
Before you call,
note your hard-drive's make, model number and
parameters (i.e., number of heads, cylinders,
and sectors per track) from the documentation supplied with the hard drive.
Most drives are configured with 17 sectors per track when used with
MFM encoding, 26 sectors per track with RLL encoding, and 31 sectors per
track with Perstor controllers.
Check these parameters against what is in the CMOS setup:
CMOS specifies parameters by storing the drive type number, which
specifies an entry in the BIOS disk parameter table.
If there is a setup program in the BIOS, it may give drive parameters
explicitly;
or, it may be necessary to look up the entry in the manual for the BIOS.
.PP
If the number of cylinders is greater than 1,024, you may have an incompatible
drive:
the format of the standard PC partition table does not allow more than
1,024 cylinders.
However, some disk controllers and most IDE drives
support a ``translation mode'' that allows them to
operate with BIOS parameters that do not match the actual parameters of
the disk drive (i.e., physical drive geometry).
For example, the following table lists the physical and translation mode
parameters for the Western Digital WD93044-A IDE drive:
.DS
.ta 0.5i 1.5i 2.5i
		\fIPhysical	Translation\fR
	Cylinders:	782	977
	Heads:	4	5
	Sectors:	27	17
	Landing Zone:	862	977
.DE
The Adaptec 2372 and Western Digital 1006V-SR2 series controllers
simulate the presence of valid drive parameters when the drive type is set
to \fB1\fR in the system setup.
With these controllers, it is possible to install \*(CO when the drive
parameters do not correspond to any drive type in the BIOS, but you must
be sure to set the drive type to \*(QL1\*(QR in the CMOS setup.
.Sh "Do you have an incompatible video board?"
.PP
If you are using a Zenith Z449 series CGA/VGA video adapter and are
experiencing panic traps, there is a known defect in this board.
Contact Zenith Data Systems, or try a different video board.
.PP
Some (unlabeled) monochrome boards do not work in protected mode.
Symptoms include immediate panic or loss of video when booting from disk 1.
If possible, try exchanging video boards.
.Sh "Do you have an incompatible keyboard?"
.PP
If you are experiencing problems with respect to key mappings,
and you installed one of the loadable keyboard mapping tables
from the keyboard selection menu, you may have an incompatible keyboard.
Please note that the \*(CO
.B nkb
driver (and loadable tables) only work with standard
keyboards, such as those built by IBM, Cherry, MicroSwitch,
NMB Technologies, or Keytronics;
when used with a poorly engineered ``clone'' keyboard,
it may not work correctly.
.PP
The preferred action is to replace the non-standard
keyboard with one made by one of the above-named manufacturers.
If, however, you wish to use a non-standard keyboard with \*(CO,
your best bet is to re-install \*(CO and select the
.B kb
(non-loadable) driver instead of
.BR nkb .
.B kb
is not loadable and supports only the U.S., German, and French
keyboard layouts.
.PP
If you do not wish to replace your keyboard or re-install \*(CO,
then the following
.I may
help you cope with your keyboard's problems.
.IP \fB1.\fR 0.3i
If the shift or control key seems to ``stick'' in the
.B on
or
.B down
position, you can try to fix the keyboard mapping table that
corresponds to your country.
For example, if you selected the U.S. keyboard mapping table
during installation but find that the right shift
or control key seems to stay down after you press it for the first time,
edit file
.BR /conf/kbd/us.c .
To fix the right shift key, change the line that reads:
.DM
	{K_57,rshift,rshift,rshift,rshift,rshift,rshift,rshift,rshift,rshift, S|MB },
.DE
to
.DM
	{K_57,none, none, none, none, none, none, none, none, none, O|MB },
.DE
To fix the right control key, change the line that reads
.DM
	{K_64, rctrl, rctrl, rctrl, rctrl, rctrl, rctrl, rctrl, rctrl, rctrl, S|MB },
.DE
to
.DM
	{K_64,none, none, none, none, none, none, none, none, none, O|MB },
.DE
This makes these keys inoperative.
This, of course, is less than desirable,
but it will at least prevent you from accidently
forcing your keyboard into a shift or control state from which you cannot exit.
.IP
Once you have modified the keyboard table, rebuild the keyboard executable that
corresponds to the modified table, as described in Lexicon articles for
.B nkb
and
.BR "keyboard tables" .
Thereafter, you can enter the name of the 
newly created executable and it will load the modified keyboard table into
the keyboard driver.
This also happens automatically at boot time.
.IP \fB2.\fR
If one or two keys are transposed, have no output, or output the incorrect
value, you must (a) figure out which key location is incorrect,
(b) decide what the correct value should be for all key states, (c) edit
the file in directory
.B /conf/kbd
that corresponds to your selection,
(d) rebuild the keyboard table executable (as described in the Lexicon articles
.B nkb
and
.BR "keyboard tables" )
and (e) reload the keyboard table by invoking the newly created executable.
.PP
As noted above, the easiest solution is to replace the keyboard.
.Sh "Do you have a system incompatible with the MWC master boot program?"
.PP
The Mark Williams master boot program is known \fInot\fR to work with
certain Zenith 241- and 248-series computers using Zenith's BIOS.
It should be possible to install and run \*(CO as long as the master boot
program is \fInot\fR used.
.Sh "Do you have an incompatible clock device?"
.PP
If the install process fails when trying to set the system time and date
(\fBATclock\fR failure), please contact Mark Williams Technical Support.
.PP
It is common to see an
.B ATclock
failure when a computer has less than one megabyte of RAM.
If your system has less than one megabyte of RAM, you must upgrade your memory.
.Sh "Is your system extremely slow?"
.PP
If you are running \*(CO on a SCSI disk drive and your system
is running very slowly,
odds are that your host adapter is not correctly configured.
Some non-\*(CO systems ``busy wait'' the host adapter
when performing SCSI I/O.
Because \*(CO is a multi-tasking, multi-user system,
it uses interrupts to signal when the host adapter
has completed an I/O operation and is ready for the next request.
If your host adapter is not correctly configured, it may not
be asserting the correct interrupt, or it may not be asserting any interrupt.
Please check the jumpers on your host adapter to verify that
the correct interrupt is being asserted.
If you have further questions, contact the hardware manufacturer.
.Sh "Is the setup of your system incorrect?"
.PP
.B build
will occasionally warm boot during initialization
if your system's BIOS has an incorrect notion of your system's configuration
of hardware.
One symptom of this problem is if your system prompts you to run a setup
program when you cold-boot your system.
.PP
To fix this problem, run the setup program that comes with your system.
Make sure that your system's clock setting and configuration of hardware
is correct.
\fIBe extremely careful not to change your hard disk's partitioning!\fR
.Sh "Are you running Extradrive?"
.PP
The disk-doubling utility Extradrive
writes material into sector 0 on your hard disk, where \*(CO writes its
master boot program.
If you have trouble booting \*(CO, try removing Extradrive, then
re-install \*(CO.
.PP
Note that for \*(MD, Extradrive, and \*(CO to work together on the same
machine, you must first install \*(MD, then configure Extradrive, and
finally install Extradrive.
If you do not follow this order, \*(MD or Extradrive will overwrite the
\*(CO master boot because each assumes that \*(MD is the only operating
system residing on the computer.
.Sh "Is your video card incompatible?"
.PP
Some makes of video card are incompatible with \*(CO's virtual consoles.
In this instance, the console may exhibit bizarre behavior, such as moving
the cursor around the screen but not printing any text.
This problem can also arise if you told \fBbuild\fR that you have a
monochrome card when in fact you have a color card, or vice versa.
.PP
Check the make of your video card and make sure you described it correctly to
.BR build .
Daredevil \*(CO hackers may wish to log in via a serial port and try to
change the configuration of the console driver; the Lexicon article
\fBconsole\fR gives information on this driver.
For most users, however, the only solution is to re-install \*(CO and
not install virtual consoles.
.Sh "Does your system use wait states?"
.PP
One user succeeded in installing \*(CO on his system by changing memory
to one wait state.
Normally, \*(CO should work correctly with zero wait states, but introducing
wait states may be necessary on some systems.
If all else fails, you may wish to try this.
.Sh "Do you have the Opti chip set?"
.PP
Some users have received panic dumps on clone PC built around
the Opti chip set.
One helpful tactic is to
use the setup routine of the AMI BIOS to disable the keyboard reset control.
.Sh "Do you have a notebook computer?"
.PP
During installation,
some notebook computers display a message like the following:
.DM
	Panic:  Parity error:  cs=FFC00018  ip=FFC0038E
.DE
This problem rests in the computer's power management.
For example, the Siemens notebook computer
has three features to increase the lifetime of the battery:
.IP \fB1.\fR 0.3i
It switches the hard disk off after a predetermined time has passed with no
disk access.
This technique works with \*(CO, but in multiuser mode the disk very seldom
shuts down because of disk accesses from sync and other running daemons.
It might happen that the time to spin the disk on to normal speed is too
long and \*(CO reports a bad track.
The timeout can be patched in the kernel to avoid this problem.
.IP \fB2.\fR
It switches off the backlight for the LCD after a predetermine time has
some time without keyboard input.
This technique works without complication under \*(CO.
.IP \fB3.\fR
It decreases clock frequency for the CPU and the refresh rate for the memory
after a predetermine time of inactivity.
This strategy, unfortunately, creates problems with \*(CO.
The power management hardware generates a non-maskable interrupt and
requests service from the BIOS.
\*(CO, however, switches the CPU into protected mode and the BIOS
no longer is available for such a service.
The only know reason for COHERENT to receive a non-maskable interrupt is a
memory parity error.
.PP
Fortunately this feature can be switched off in the BIOS setup of the
Siemens notebook computer.
If the BIOS of your notebook allows you to switch off this feature, do so.
If it does not, try setting the inactivity time in the BIOS to an extremely
Note that this problem should not arise with \*(CO 4.2.
.Sh "Do you have an incompatible system?"
.PP
If you have problems that cannot be helped by any of the above, 
then your computer system may not be capable of running \*(CO.
Note that it is possible for a system that cannot run \*(CO to be
made up entirely of components known to work on other systems that
run \*(CO.
The greatest number of these cases is seen with customers running
an AMI BIOS, IDE hard drives, or any kind of DTK motherboard.
Please record as much information as possible about make and model of
motherboard, BIOS, hard drive controller, hard drive, and all other equipment
installed; then contact Mark Williams Technical Support.

.II "ed^tutorial"
.ds TL "ed Interactive Line Editor"
.NH "Introduction to the ed Line Editor" 1
.PP
This tutorial introduces the interactive editor \fBed\fR.
It is intended both for readers who want a
tutorial introduction to \fBed\fR, and those who want to use specific
sections as a reference.
.PP
Related tutorials include those for \fBsed\fR,
the stream editor, and for \fBme\fR, the \*(ME screen editor.
This tutorial assumes that you already understand the basics of
using the \*(CO system, such as what a file is, what it means
to edit text, and how to issue commands to the operating system.
If you not yet know your way around the \*(CO system, we
suggest that you first study the
\fIUsing the COHERENT System\fR, which
appears in the front of this manual.
It covers the basics of using \*(CO and introduces many useful programs.
.Sh "Why You Need an Editor"
.PP
A significant feature of computers is the capacity to store, retrieve,
and operate upon information.
A computer can store many different kinds of information:
programs, computer commands and instructions, data for programs, financial
information, electronic mail, or natural-language text (e.g., French,
English) destined for a manuscript or book.
.PP
\fBed\fR is a
program with which you can enter and edit text on your computer.
You can use \fBed\fR to create or change computer programs,
natural-language manuscripts, files of commands, or any other file
that consists of text that you can read.
.PP
\fBed\fR is designed to be easy to use, and requires little
training to get started.
The fundamental commands are simple, but have
enough flexibility to perform complex tasks.
.Sh "Learning To Use the Editor"
.PP
Practice on your part will help you learn quickly.
The following sections contain examples that illustrate each topic
discussed.
We strongly recommend that you type each example presented
as you encounter it in the text.
Even if you understand the concept presented, performing the example
reinforces the lesson, and you will learn more quickly how to use \fBed\fR.
.PP
In addition to reading the text and doing the examples as you encounter
them in the text, try your own variations on the commands,
and branch out on your own.
Try things that you suspect might work, but are not shown as examples.
.SH "General Topics"
.PP
This section presents the background information you will need
to understand how \fBed\fR works.
.PP
To help illustrate the discussion to follow, log into your \*(CO
system and type the following commands:
.DM
	ed
	a
	this is a sample
	ed session
	.
	w test
	q
.DE
.PP
This example calls \fBed\fR, then uses the \fBa\fR command to add lines to
the text kept in memory.
The period signals the end of the additions.
The \fBw\fR command writes the lines of text to file \fBtest\fR, and
the command \fBq\fR tells \fBed\fR to return to \*(CO.
You will notice that after you type the \fBw\fR command,
\fBed\fR will respond with
.DM
	28
.DE
which is the number of characters in the file.
.PP
Thus, to enter \fBed\fR, simply type
.DM
	ed
.DE
and to exit, type
.DM
	q
.DE
You can also exit by typing
.II "ed^<ctrl-D>"
.BR <ctrl-D> :
that is, hold down the \fBcontrol\fR key on your keyboard,
and at the same time strike the \fBD\fR key.
.PP
Notice that you are issuing two different kinds of commands in the above
example:
the command
.B ed
is given to the \*(CO shell, to invoke the editor;
the rest of the commands are given to the editor.
After \fBed\fR is given the \fBq\fR command, it exits, and
following commands are processed by \*(CO.
.Sh "ed, Files, and Text"
.PP
\fBed\fR works with one file at a time.
With \fBed\fR, you can create a file, add to a file, or
change a file previously created.
.PP
As you use \fBed\fR to create or change files, you will type both
\fItext\fR and controlling \fIcommands\fR into the editor.
Text is, of course, the matter that you are creating or changing.
Commands, on the other hand, tell \fBed\fR what you want it to do.
As you will see shortly, there is a simple way to tell \fBed\fR
whether what you are typing is text or commands.
.PP
\fBed\fR has about two dozen commands.
Almost every one is only one letter long.
Although they may seem terse, they are easy to learn.
You will appreciate the brevity of the commands
once you begin to use \fBed\fR regularly.
.PP
.II "ed^carriage return"
You must end
each command to \fBed\fR by striking the
.B <return>
key.
.if \nX=0 \{\
This key is present on all terminals.
However, the labeling of the key may vary.
It may be called
\fBnewline\fR, \fBlinefeed\fR, \fBenter\fR, or \fBeol\fR, and is larger
than any key on the keyboard except for the space bar. \}
.if \nX=1 \{\
On the IBM PC, it is labeled with an arrow pointing to the left,
and is positioned where the carriage return on an electric typewriter
is usually found. \}
This key will be called
the \fB<return>\fR key in the remainder of this document.
.Sh "Creating a File"
.PP
The example shown above created a file.
Here is another example of file creation \(em here, creating
a file called \fBtwoline\fR:
.DM
	ed
	a
	Two line Example,
	thank you.
	.
	w twoline
	q
.DE
The letter \fBa\fR tells \fBed\fR to add lines to the file.
You are creating a new file with this example; and when \fBed\fR
creates a new file, it is initially empty.
The \fBw\fR command writes the lines you have added to file \fBtwoline\fR.
The command \fBq\fR tells the editor that you
are finished, whereupon it returns to \*(CO.
You can use the \*(CO command
.if \nX=0 \fBcat\fR
.if \nX=1 \fBtype\fR
to list the contents of the new file:
.DM
	cat twoline
.DE
the reply will be:
.DM
	Two line Example,
	thank you.
.DE
Each command used here will be described in detail in later
sections.
.Sh "Changing an Existing File"
.PP
Suppose that a manuscript file of yours needs a few spelling corrections.
\fBed\fR will help you make them.
To begin, simply name the file to correct when you issue the \*(CO command:
.DM
	ed \fIfilename\fR
.DE
where \fIfilename\fR stands for the name of the file that you wish to edit.
For example, the following adds a line to the file \fItwoline\fR, which
we just created:
.DM
	ed twoline
	$a
	This is the third line of the file.
	.
	w
	q
.DE
Listing the file with
.if \nX=0 \fBcat\fR
.if \nX=1 \fBtype\fR
gives:
.DM
	Two line Example,
	thank you.
	This is the third line of the file.
.DE
The command \fB$a\fR tells \fBed\fR to add one or more
lines at the end of the file.
.PP
Correcting the spelling of a misspelled word is easy with \fBed\fR.
You can rearrange groups of words in a manuscript, and you can
move or copy larger portions of text,
such as a paragraph, from one spot to another.
.Sh "Working on Lines"
.PP
\fBed\fR uses the \fIline\fR as the basic unit of
information; for this reason, it is called a \fIline-oriented\fR editor.
A line is defined as a
group of characters followed by an end-of-line character, which is invisible.
When you type out a file on your terminal, each line in the file will be
shown on your terminal as one line.
The commands for \fBed\fR are based upon lines.
When you add material to a file, you will be adding lines.
If you remove or change items, you will do so to groups of lines.
.PP
.II "ed^line, number"
\fBed\fR knows each line by its number.
A line's number, in turn, indicates its position within the file:
the first line is number 1, the second line is number 2, and so on.
.PP
\fBed\fR remembers the line you worked on most recently.
This can help shorten the commands you type,
as well as reduce the need for you to remember line numbers.
The line most recently worked on is called the \fIcurrent\fR line.
\fBed\fR commands use
a shorthand symbol for the current line:
the period \*(Ql\fB.\fR\*(Qr.
.PP
Another shorthand symbol used in \fBed\fR commands is \fB$\fR,
which represents the number of the last line in the file.
.PP
Many of the \fBed\fR commands operate on more than one line at a time.
Groups of lines are denoted by a range of line numbers, which
appears as a prefix to the command.
.Sh "Error Messages"
.PP
If you type a command to \fBed\fR incorrectly, \fBed\fR respond with:
.DM
	?
.DE
This indicates that it has detected an error.
Many times, this error will
be evident to you when you review the command that you just typed.
.PP
If you do not see what the error is, you can get a more lengthy
description by typing to \fBed\fR:
.DM
	?
.DE
It will reply with an error message.
.SH "Basic Editing Techniques"
.PP
This section discusses in more detail
the elementary techniques and commands that you
need to use \fBed\fR.
With the material presented in this
section, you will be able to do most basic editing tasks.
.PP
Again, it is recommended that you type each example.
This will help you understand each example, as well as remember the technique
it demonstrates.
.Sh "Creating a New File"
.PP
To begin, let us presume that you need to create an entirely new file
named \fBfirst\fR.
Perhaps you only want one line in the file, and it is to read
.DM
	This is my first example
.DE
.II "ed^prompt character"
These are the steps that you will need to go through to create this file.
.PP
.PP
The first step is to invoke the \fBed\fR program.
To do this, simply type
.DM
	ed
.DE
Remember that you must end each line of commands or text line by
pressing the \fB<return>\fR key,
because \fBed\fR will not act upon it until you do.
Thus, you invoke the editor by typing \fBed\fR
and a \fB<return>\fR.
Notice that these two characters must be lower case.
.PP
.II "ed^adding lines"
\fBed\fR is now ready for commands.
The first command that you will use is the append command
.BR a .
This tells \fBed\fR to add lines to the text in memory,
which will later be written to the file.
The number of lines that \fBed\fR can hold in memory depends upon
the amount of memory in your computer.
.II "ed^sed"
For editing very large files, you should use
.BR sed ,
the \*(CO stream editor, which is described in its own tutorial.
.PP
\fBed\fR will continue to add lines until you type a line
that contains \fIonly\fR a period.
While it is adding lines, \fBed\fR does not recognize commands.
.PP
.II "ed^. (dot)"
After you issue the \fBa\fR command, you can type the lines to be
included, concluding with a line that consists only of a period.
This special line signals \fBed\fR that you want to stop appending lines.
The information that you have typed so far is:
.DM
	ed
	a
	This is my first example
	.
.DE
Next, you must tell \fBed\fR to write the edited text into a file.
Do so by issuing the write command
.BR w ,
plus the name of the file that is to hold the edited text.
For example,
if you wish to store this example in a file named
\fBfirst\fR, issue the command:
.DM
	w first
.DE
\fBed\fR will write the file and tell you how many characters were
written, in this case 25.
.PP
Finally, to quit the editor issue the quit command:
.DM
	q
.DE
The commands you type after this will be interpreted
and acted upon by \*(CO.
.PP
Now, review the example in its entirety.
First you invoked \fBed\fR by typing
.BR ed
at the \*(CO prompt.
Then you issued the add command \fBa\fR
to add lines to the file.
added lines with the \fBa\fR command,
and finished the adding by typing a line that consists only of a period.
You then wrote the editing text into a file by issuing the write command
.BR w ,
and finally you exited from \fBed\fR by issuing the quit command \fBq\fR.
The complete example is:
.DM
	ed
	a
	This is my first example
	.
	w first
	q
.DE
\fBed\fR replied to the
.B w
command by printing the number of characters it wrote into the file.
After you typed
.B q ,
\*(CO prompted you for a command again.
.Sh "Changing a File"
.PP
Suppose that you wish to change the file that you have just created:
you want to add two more lines to the file so that the original line
will be sandwiched between the new lines.
You want the file to contain:
.DM
	Example two, added last
	This is my first example
	Example two, added first
.DE
You will do this with \fBed\fR using two new commands.
.PP
.II "ed^file, name, in ed command"
Again, you start by telling \*(CO to run \fBed\fR.
This time, however, you must type the name of the
file that you are changing after the characters \fBed\fR:
.DM
	ed first
.DE
\fBed\fR will remember this file name for later use with the \fBw\fR command.
.PP
\fBed\fR reads the file in preparation for editing, and tells you the number
of characters that it read in, again 25.
.PP
.II "ed^current, line"
After reading the file, \fBed\fR automatically sets the
current line to the last line read in.
.PP
Now, add the third line shown in the second example by entering:
.DM
	a
	Example two, added first
	.
.DE
This resembles the first example.
In that case, however, the file had no information, whereas now it does.
How did \fBed\fR know where to add the lines?
.PP
.II "ed^current, line"
The \fBa\fR command adds lines after the \fIcurrent line\^\fR.
When \fBed\fR reads a file, it initially sets the current line to the
last line read in;
therefore, the \fBa\fR command added the new line after the last line.
.PP
The current line is used implicitly or explicitly by most
commands, so it is helpful to know where it is.
In general, the current line is left at the last line \fBed\fR has processed.
If you lose track of the current line,
you can ask \fBed\fR to tell you where it is, as you will see shortly.
.PP
To add the very first line to the second example, you will use yet
another command, the insert command \fBi\fR.
This command is identical to
the \fBa\fR command, except that it inserts lines \fIbefore\fR the
current line rather than after it.
.PP
Another word about the current line.
After an \fBa\fR
command finishes, the current line is the last line added.
Thus, after the
addition of \*(QLExample two, added first\*(QR above, the current line is
now the last line in the file.
So, if you were to do the \fBi\fR command immediately, you would
be adding lines just before the last line, which is not what you want to do.
.PP
Nearly every \fBed\fR command is flexible enough to allow you to specify the
line upon which the command is to operate.
Now you can complete the second example:
.DM
	1i
	Example two, added last
	.
.DE
.II "ed^inserting lines"
The numeral \fB1\fR before the \fBi\fR tells \fBed\fR to
insert lines before the first line in the file.
The line-number prefix is used frequently, and applies to nearly every command.
.PP
Now, to finish the second example and save it into the same file, type:
.DM
	w
	q
.DE
Note that the file name was left off the \fBw\fR command.
\fBed\fR remembers the name of the file that you began with,
and uses that name if none is used with the \fBw\fR command.
Therefore, the edited text is written back into file \fBfirst\fR.
Note, too, that the previous contents of the
file \fBfirst\fR are lost when you write the new file \fBfirst\fR.
Alternatively, you can type:
.DM
	w second
.DE
This leaves the contents of \fBfirst\fR unchanged and creates a new file called
\fBsecond\fR.
.PP
In case you forget, \fBed\fR can tell you the name of the file
with which you began.
Simply type the command:
.DM
	f
.DE
If you had used \fBf\fR any time while working on this second example,
\fBed\fR would have replied:
.DM
	first
.DE
Remember to use the
.B q
command to leave \fBed\fR and return to \*(CO.
.Sh "Printing Lines"
.PP
As you use \fBed\fR to edit a file, you will find it most useful to print
sections of the file on your terminal.
This helps you see what you
have done (and sometimes what you have not done), and helps you pinpoint where
you wish to make changes.
.PP
.II "ed^print command"
The print command \fBp\fR
prints the current line unless you specify a line number.
.PP
Continuing with the example begun above, when you type the commands
.DM
	ed first
	p
.DE
\fBed\fR replies by printing
.DM
	Example two, added first
.DE
which is the last line in the file named \fBfirst\fR from the previous
example.
.PP
Again, like the commands
.B i
and
.BR a ,
if you want \fBed\fR to print a line
other than the current one, just prefix the \fBp\fR
command with a line number.
Thus, if you want to print the second line in the file, type:
.DM
	2p
.DE
\fBed\fR will reply with:
.DM
	This is my first example
.DE
.II "ed^line, number ranges"
If you wish to print more than one line of a file,
you can tell \fBed\fR to print a \fIrange\fR of line numbers:
type the numbers of the first and last lines you wish to see,
separated by a comma.
For example, to print all three lines in the second example, type:
.DM
	1,3p
.DE
\fBed\fR responds by printing all lines.
This same principle applies to other commands.
The print command can also appear after other commands such as \fBs\fR or
.BR d ,
which are discussed later in this section.
.Sh "Abbreviating Line Numbers"
.PP
.II "ed^$"
.II "ed^*"
\fBed\fR recognizes some shorthand descriptions for certain line numbers.
The number of the last line can be represented by the dollar sign
.BR $ .
Thus, the command
.DM
	1,$p
.DE
prints every line in the file.
The advantage of this shorthand is that
the command as typed works for any file, regardless of its size.
This construct of \fB1,$p\fR is used often enough that it has an
abbreviation of its own:
.DM
	*p
.DE
The number of the current line can also be abbreviated by using the
period or dot in the place of a line number.
To print all lines from the beginning of the file through the current line,
type:
.DM
	1,.p
.DE
To print all lines from the current line through the end of the file, type:
.DM
	.,$p
.DE
The special symbol
.B &
prints one screenful of text.
Simply type:
.DM
	&
.DE
This is equivalent to:
.DM
	.,.+22p
.DE
If there are fewer than 23 lines between the current line and the end
of the file,
it is equivalent to
.DM
	.,$p
.DE
.II "ed^$"
All forms of the \fBp\fR command change the current
line to the last line printed.
The command
.DM
	.,$p
.DE
after printing changes the current line to the last line of the file.
.Sh "How Many Lines?"
.PP
You can easily see the current line with \fBp\fR.
Type:
.DM
	p
.DE
This tells \fBed\fR to print the current line.
On your terminal, try the command:
.DM
	.p
.DE
You will see that it does the same thing as \fBp\fR.
.PP
.II "ed^="
To discover how large your file is,
just type:
.DM
	=
.DE
\fBed\fR will reply by typing the number of lines in the file.
.PP
.II "ed^.="
To find the number of the current line, use the \fBdot equals\fR command:
.DM
	.=
.DE
\fBed\fR responds with the number of the current line.
.Sh "Removing Lines"
.PP
.II "ed^removing lines"
Editing means removing lines of text, as well as adding them.
To illustrate how \fBed\fR lets you remove lines of text,
create another example file with \fBed\fR:
.DM
	ed
	a
	This is the first line.
	The second line is good.
	However, line three is bad.
	line four wishes to go away.
	line 5 similarly wants to be forgotten,
	as does line 6.
	the next to last line stays.
	as does the last line in the file.
	.
	w example3
	q
.DE
This creates a file named \fBexample3\fR.
.PP
Now, you can practice removing lines that you no longer want.
Begin editing the file by typing:
.DM
	ed example3
.DE
Now, print the contents of the file by typing:
.DM
	1,$p
.DE
Our first task is to delete lines 3 through 6.
First, delete line 3, then print the entire file again.
.DM
	3d
	1,$p
.DE
and \fBed\fR will respond with
.DM
	This is the first line.
	The second line is good.
	line four wishes to go away.
	line 5 similarly wants to be forgotten,
	as does line 6.
	the next to last line stays.
	as does the last line in the file.
.DE
.II "ed^deleting lines"
Notice that the original file's third line is no longer there.
Line 3 is now what used to be line 4.
Remember that the line
numbers \fIalways\fR begin with 1 for the first line of the file and
progress consecutively even after the file has been changed.
Thus, deleting a line will change the line number of each line from the deleted
line to the the last line in the file.
.PP
You still need to remove three more lines.
You can do this with one command:
.DM
	3,5d
.DE
Again, type
.B *p
to print the contents of the file:
.DM
	This is the first line.
	The second line is good.
	the next to last line stays.
	as does the last line in the file.
.DE
Finally, write the updated file and quit:
.DM
	w
	q
.DE
This illustrates how to delete lines, both singly and in a group.
.Sh "Abandoning Changes"
.PP
Sometimes, you may make a mistake;
rather than damage your file with badly edited text,
you may wish to abandon what you have done and begin all over again.
You can do so by using the \fBq\fR
command in a different fashion than is shown above.
.PP
If you tell \fBed\fR to
.B q
before you tell it to write the file with \fBw\fR,
you abandon any changes made since beginning editing.
However, to prevent you from accidentally selecting this option, \fBed\fR
checks to see if you have made any changes to the file; and if you have,
it responds with a question mark \*(Ql\fB?\fR\*(Qr.
To tell \fBed\fR that you know what you are doing and really do wish
to abandon the edited file,
reply with a second \fBq\fR.
\fBed\fR will then quit and return you to \*(CO.
.PP
You can avoid the question mark prompt by typing the upper-case
.B Q
rather than lower-case \fBq\fR:
\fBed\fR will exit without regard to unsaved changes.
You can also exit from \fBed\fR by typing the end-of-file key
\fB<ctrl-D>\fR.
.Sh "Substituting Text Within a Line"
.PP
.II "ed^changing lines"
If you type a line incorrectly, or later wish to
rearrange some words or symbols within it, you know enough about \fBed\fR
now to do so.
You only need to delete the line with the delete command \fBd\fR
and re-type the line with the insert command \fBi\fR.
To see how this is done, prepare the file
.BR example4 ,
as follows:
.DM
	ed
	a
	Software technology today has
	adbanced to the point that large
	software projects unherd of in
	earlier times are undertaken and
	.
	w example4
	q
.DE
This example has two misspelled words.
We will correct each of them using different \fBed\fR features.
.PP
The first method will be the direct way that you probably can anticipate.
Give the following commands to the editor exactly as shown:
.DM
	ed example4
	2d
	i
	advanced to the point that large
	.
.DE
These commands use the delete command \fBd\fR to delete the second line,
and then uses the insert command \fBi\fR to insert the correct new line
in its place.
.PP
Use the command
.DM
	*p
.DE
to verify that the file now contains:
.DM
	Software technology today has
	advanced to the point that large
	software projects unherd of in
	earlier times are undertaken and
.DE
.II "ed^substitute command"
You can also use
a second method to change the spelling of a word.
This is the substitute command
.BR s .
This command is very powerful, and probably is used more frequently
than any other \fBed\fR command.
.PP
.II "ed^pattern"
The substitute command
.B s
is more complex than commands we have discussed so far, in
that it has more elements, as follows:
First is a line number or optional range of line numbers.
Then comes the letter \fBs\fR, to invoke the substitute command itself.
Third comes two \fIpatterns\fR or \fIstrings\fR, which
are set off from the rest of the command and
from each other with the \fBslash\fR character.
For example:
.DM
	1,$s/pattern1/pattern2/
.DE
Here, \fIpattern1\fR represents the string that you want \fBed\fR to
replace, and \fIpattern2\fR is the string that \fBed\fR is to substitute
in place of \fIpattern1\fR.
Note that three slashes separate the two patterns from
the \fBs\fR, from each other, and from the end of the line.
These slashes must always be present.
.PP
With this command, you can correct the second spelling error in the
example4:
.DM
	3s/herd/heard/
	p
.DE
\fBed\fR replies:
.DM
	software projects unheard of in
.DE
Note that these two command lines can be condensed to one:
.DM
	3s/herd/heard/p
.DE
The meaning of these commands is:
on the third line of the file,
change \fBherd\fR to \fBheard\fR and, when finished, print the entire line.
Without the \fBp\fR command, \fBed\fR will change the line as you
direct, but will not show you the new line.
It is a good idea to
print lines that you substitute in this manner until you gain in
confidence with \fBed\fR.
Some \fBed\fR experts always print the lines after substitution.
.PP
Type
.DM
	.
	w sample.text
	q
.DE
to stop entering text, then save the newly typed text into file
.B sample.text
and exit (``quit'') from
.BR ed .
.PP
After these two changes, the file looks like this:
.DM
	Software technology today has
	advanced to the point that large
	software projects unheard of in
	earlier times are undertaken and
.DE
Although the above example substitutes one word for another,
note that the \fBs\fR command can replace any consecutive group
of characters with any other:
it may be one word, several words (including the space characters
that separate them), or a fragment of a word.
.PP
Because \fBed\fR looks for patterns rather words, you should keep in mind
that it may find the wrong pattern.
For example, assume that the current line in a file is
.DM
	let not rain fall on a parade
.DE
and instead you want to say:
.DM
	let not rain fall on the parade
.DE
You command \fBed\fR to:
.DM
	s/a/the/p
.DE
and are shocked to discover that the result is:
.DM
	let not rthein fall on a parade
.DE
A better command to
give \fBed\fR would have been a substitute command that substituted the
letter \fBa\fR preceded and followed by a space:
.DM
	s/ a / the /p
.DE
Another correct way to do this task is to indicate within the
substitution command which of several possible matches within the line is
to be substituted.
In our example, it is actually the third \fBa\fR that we
are trying to match, so we could have used the special form of the command
.DM
	s3/a/the/p
.DE
to get \fBed\fR to select the one we wanted.
.Sh "Undoing Substitutions"
.PP
If you did change \fBa\fR to \fBthe\fR inappropriately, you can retract the
substitution by issuing the undo command
.DM
	u
.DE
before you move on to another current line.
.PP
To illustrate this, enter this example:
.DM
	ed
	a
	let not rain fall on a parade
	.
	w undo
	q
.DE
Now, perform the substitution with
.DM
	ed undo
	s/a/the/p
.DE
which will result in:
.DM
	let not rthein fall on a parade
.DE
To retract the substitution, simply type:
.DM
	u
	p
.DE
This undoes the substitution and prints the result.
.PP
Note that the undo command
undoes the substitution only on the current line.
Remember that if your substitution command operated over a range of lines,
when it finishes the current line is the last one upon which the substitution
was made.
Thus,
if you made an inappropriate substitution over a range of lines,
the undo command will fix only the last line.
.Sh "Global Substitutions"
.PP
As you saw with the above examples, the
.B s
command substitutes only the \fIfirst\fR occurrence of the requested pattern
on a given line.
.PP
.II "ed^global substitute"
A different form of the substitute command finds
every occurrence of the indicated string on a line.
Simply add the letter
.B g
for \fIglobal\fR after the third slash in the substitute command,
and \fBed\fR finds and changes every one:
.DM
	s/pattern1/pattern2/g
.DE
So, if the current line contains a phrase:
.DM
	a rose is a rose is a rose
.DE
and we tell \fBed\fR to substitute
.DM
	s/a/the/g
.DE
the line is changed to:
.DM
	the rose is the rose is the rose
.DE
Again, be careful that your command does not inadvertently match
all or part of a word that you wish to keep untouched.
.Sh "Special Characters"
.PP
.II "ed^characters, special"
In its first two parts, the substitute command uses
some special punctuation characters.
They will be discussed below in detail.
However, you should be aware of these
characters and avoid them until you progress to the advanced section, for
unless used properly, they will give you undesired results.
The characters are:
.DM
	[ ^ $ * . \e &
.DE
They are used
.if \nX=0 in \fBed\fR and other \*(CO programs
to form complex patterns.
.Sh "Ranges of Substitution"
.PP
Perhaps you need to change several lines that have the same misspelling
or need the same editorial change.
\fBs\fR can do that for you also.
Simply prefix the command \fBs\fR with the line-number range as
you would do with \fBp\fR.
Borrowing the \*(QLrose\*(QR example again, if the saying were typed:
.DM
	a rose is
	a rose is
	a rose
.DE
then you could do the same change as before, but across the entire file by
typing
.DM
	1,$s/a/the/
.DE
Note that the
.B g
after the
.B s
command has been omitted here, because you know that the string that
you want to change appears only once on each line.
.PP
If some of the lines do not have the string you want to change,
\fBed\fR will not complain that the string is missing.
However, if none of the lines in the
range has the requested string, \fBed\fR will print a \fB?\fR.
.SH "Intermediate Editing"
.PP
.II "ed^commands, advanced"
This section introduces the more advanced command features of \fBed\fR.
Although you have already learned enough about \fBed\fR
to become productive, this section covers additional
features that will increase your editing power considerably.
.PP
This section discusses the following topics:
relative line numbering, moving blocks of text,
finding strings, using special characters in substitution
and search commands, processing global commands, and marking lines.
.Sh "Relative Line Numbering"
.PP
.II "ed^line, numbers, relative"
As discussed in the previous section, most
commands allow you to use
line numbers to control their range of operation.
Before the command you can enter a single line number; for example:
.DM
	1p
.DE
This, of course, prints the first line of the file.
You may also specify a \fIrange\fR of line numbers,
by entering two numbers separated by a comma.
For example,
if the file contains at least ten lines, the command
.DM
	1,10p
.DE
prints the first ten lines of the file.
.PP
.II "ed^. (dot)"
The period (dot) always represents the number of the current line.
For example, to print the file from the first line through the
current line, just type:
.DM
	1,.p
.DE
A command used without a line number always acts on the current line only.
For example, typing
.DM
	p
.DE
is equivalent to typing:
.DM
	.p
.DE
.PP
.II "ed^+"
.II "ed^-"
There is yet another level of shorthand to line numbering \(em
the plus and minus characters.
These characters indicate \fIoffsets\fR from the current line.
For example, the command
.DM
	.+3p
.DE
prints the third line after the current line.
Likewise, the command
.DM
	.-1p
.DE
prints the line that precedes the current line.
Note that using a line offset changes the current line to the one
addressed.
Thus, after the above command is executed, the current line will
be the one that preceded the original current line.
.PP
You can abbreviate this notation still further by leaving out the dot.
The commands
.DM
	+p
	-p
.DE
do the following:
First, 
.B ed
advances to the next line and prints it;
then it backs up to the previous line (which was the
original current line) and printing it.
.PP
You can place several of these commands on one line to move the
current line multiple lines.
To back up three lines and then print, type:
.DM
	---p
.DE
Note that
in the absence of any other command,
\fBed\fR defaults to the \fBp\fR command.
Thus
.DM
	---
.DE
is equivalent to
.DM
	---p
.DE
and
.DM
	5
.DE
is identical to:
.DM
	5p
.DE
The print command has one more abbreviation.
If \fBed\fR is expecting a command from you
and you type nothing except \fB<return>\fR, \fBed\fR interprets this as a
command to advance the current line to the next line and print it.
This action is equivalent to
.DM
	+
.DE
or
.DM
	.+1
.DE
\fB<return>\fR is the shortest command in \fBed\fR.
.PP
All of the abbreviations for line numbers can be used by other commands that
expect a range of line numbers.
For example, if you want to delete five lines
centered about the current line, you could type:
.DM
	.-2,.+2d
.DE
and you would get your wish.
.PP
Note that
.B ed
does not allow you to specify a line number that is beyond the range of the
file; this is regardless of whether you are typing a line number or any
form of abbreviated line numbering.
For example,
suppose the current line is the last line in the file
and you type:
.DM
	+
.DE
This tells \fBed\fR to \*(QLadvance one line then print\*(QR;
however, this is impossible
because you are at the last line of the file, so there is no next line
to print.
When you request an impossible line number,
\fBed\fR replies by printing a question mark.
Note, however, that the current line is always be valid so
long as the file has at least one line in it.
Thus, unless the file is empty, the command
.DM
	.
.DE
will never give an error message.
.Sh "Changing Lines"
.PP
Earlier, an example of spelling correction was solved two ways.
The first way was the clumsy way of deleting a line and
retyping the entire line.
This strategy means much work to change a single letter,
so the substitute command was introduced instead.
.PP
On occasion, however, it is handy to be able to
change lines en masse \(em as was done by deleting then inserting.
\fBed\fR provides this power with the change command
.BR c .
In general terms,
.DM
	\fIm\^\fP,\fIn\fPc
	new lines
	to be inserted
	.
.DE
removes lines \fIm\fR through \fIn\^\fR, and insert new lines up to
the period in place of them.
.Sh "Moving Blocks of Text"
.PP
.II "ed^move, blocks of text"
When handling text, you will often need to shift a block of text from
one position to another.
In a manuscript, for example, you may need to rearrange the order of
paragraphs to increase clarity.
In a program, you may need to rearrange the order in which
procedures appear.
.PP
To allow you to do this easily, \fBed\fR provides a move command
.B m
that moves a block of text from one point in the file to another.
.PP
.B m
is different from the other commands that we have discussed
so far, in that line numbers follow as well as precede the \fBm\fR
command itself.
The line number that follows the command
gives the line \fIafter\fR which the text is to be moved.
So, the general form of the move command is
.DM
	\fIb\^\fP,\fIe\^\fPm\fId\fP
.DE
which means \*(QLmove lines \fIb\fR through
\fIe\fR to after line \fId\^\fR\*(QR.
.PP
To see how this works, first build the following file:
.DM
	ed
	a
	    This is a paragraph of natural language
	text. Due to stylistic considerations, it
	really should be the second paragraph.
	    If you can read this paragraph first,
	the text has been properly arranged, and
	our move example has been successfully done.
	.
	w example5
	q
.DE
The file \fBexample5\fR contains two paragraphs, each three lines long.
We will now move the first paragraph to after the second paragraph.
.PP
You can do this in either of two ways:
you can move the first paragraph to after the second paragraph, or you
can move the second paragraph to before the first paragraph.
Either gives the same result, but the commands are somewhat different.
To shift the first paragraph to after the second paragraph, type:
.DM
	ed example5
	1,3m$
	*p
	Q
.DE
Remember that \fB$\fR always represents the last line in the file.
The result is:
.DM
	    If you can read this paragraph first,
	the text has been properly arranged, and
	our move example has been successfully done.
	    This is a paragraph of natural language
	text. Due to stylistic considerations, it
	really should be the second paragraph.
.DE
To move the second paragraph to before the first, type:
.DM
	4,6m0
.DE
.II "ed^line, number zero"
Note that the destination is 0, which means that the text is
to be moved to immediately after line 0.
Because there is no line number 0,
the move command interprets this to mean the beginning of the file.
.PP
Of course, in our small example, line
number abbreviations and knowledge of the current line
may be used in a number of different ways to perform exactly the same action.
For example,
.DM
	1,3m.
.DE
says to move lines 1 through 3 of the file to the line after the current
line.
When you invoke \fBed\fR, it always sets the line number to the last
line in the file.
Thus, this form of the command has the same effect as the previous forms.
.PP
If the destination of a move command is not specified, \fBed\fR assumes the
current line.
Therefore, the command
.DM
	1,3m
.DE
also repositions the first paragraph correctly.
.PP
The move command changes the line numbers in the file,
although the number of lines in the file remains the same.
The different forms of the move command will, however, yield different
settings for the current line.
.PP
After a move command, the current line becomes the number of the last line
moved.
Thus, if you moved the first paragraph to after the second paragraph,
the current line will be reset to the last line in the file \(em
the original line 3.
However, if you moved the second paragraph to before the first paragraph,
the current line would be reset to line 3 \(em which was originally
the last line in the file.
.Sh "Copying Blocks of Text"
.PP
.II "ed^copying blocks of texts"
The transfer command \fBt\fR resembles
the move command, except that it copies text rather than moving it.
When you move text, it is erased from its original position.
When you copy text, however, the text then appears both in its
original position and in the position to which you copied it.
\fBed\fR uses the term \fItransfer\fR rather than \fIcopy\fR
because the command \fBc\fR is already used as the change command.
.PP
The form of the transfer command is as follows:
.DM
	\fIb\^\fP,\fIe\^\fPt\fId\fP
.DE
This means to transfer (copy) the group of lines that begins
with \fIb\fR and that ends with \fIe\fR (inclusive) to after line \fId\fR.
.PP
After copying the text, \fBed\fR sets the current line to the last line copied.
.Sh "String Searches"
.PP
.II "ed^line, locators"
The methods of line location that have been discussed
to this point all involve line numbers.
They specified an absolute line number, a relative line number,
or a shorthand symbol such as \fB.\fR or \fB$\fR.
.PP
Often, however, line numbers are not useful, because there is
no easy way to tell what number a line has,
how many lines ago a block of text began, and so on.
.PP
\fBed\fR's solution to this problem is to
locate a line by asking \fBed\fR to search for a pattern of text.
\fBed\fR begins searching on the line that follows the current line, and
looks for a line that matches the specified pattern.
If it finds a line that contains the requested pattern, \fBed\fR
resets the current line to that line.
.PP
If \fBed\fR encounters
the end of the file before it finds a match, \fBed\fR jumps to the
first line in the file, and continues its search from there.
If it finds no match by
the time it returns to the line where the search began,
\fBed\fR gives up and issues an error message \(em
the question mark \fB?\fR.
.II "ed^?"
Remember, if you type a question mark in response to an error message,
\fBed\fR will tell you in more detail what the error is.
.PP
What does it mean to \*(QLmatch\*(QR a pattern?
The simplest meaning is that two patterns are the
same \(em the strings have exactly the same characters in
exactly the same order.
To see how this works, type the following to create file
.BR example6 :
.DM
	ed
	a
	    This is an example that we will
	use for string searching.  There
	is much natural language here as well
	as some genuine arbitrary strings.
	890,;+	 foxtrot
	qwertyuiop ##
	.
	w example6
	q
.DE
Now, to locate and print
any line contains the pattern \fBfox\fR, type:
.DM
	ed example6
	/fox/p
.DE
In response, \fBed\fR prints the line:
.DM
	890,;+	 foxtrot
.DE
Also, you can use string expressions to print a range of lines.
For example:
.DM
	/This/,/much/p
.DE
This prints:
.DM
	  This is an example that we will
	use for string searching. There
	is much natural language here as well
.DE
That is, it printed all lines from the first line that contains the
pattern \fBThis\fR through the first line that contains the pattern
\fBmuch\fR.
.PP
Pattern searches can also be combined with relative line numbers.
If you have a Pascal program file with several
procedures in it, but you find that you need to rearrange the procedures,
you can combine the power of the move command with the string searches.
.DM
	PROCEDURE A;
	...
	...
	PROCEDURE B;
	...
	...
	PROCEDURE C;
.DE
Assume that the section of text that begins with \fBPROCEDURE A\fR should
follow the line that contains \fBPROCEDURE B\fR.
The following command moves the text properly:
.DM
	/PROCEDURE A/,/PROCEDURE B/-1m/PROCEDURE C/-1
.DE
This commands \fBed\fR (1) to locate the chunk of text that begins
with a line containing the pattern \fBPROCEDURE A\fR and ends with the
line just before the first line that contains the pattern \fBPROCEDURE B\fR,
and then (2) move that text to just before the first line that contains
the pattern \fBPROCEDURE C\fR.
As you can see, you can pack a lot of information into one \fBed\fR command.
.PP
Let's look at this command in more detail, to see exactly how it works.
First, remember that the move command \fBm\fR is defined as
.DM
	\fIb\^\fP,\fIe\^\fPm\fId\fP
.DE
where \fIb\fR indicates the first line of the text to be moved, \fIe\fR
indicates the last line of the text to be moved, and \fId\fR indicates the
line that the moved text is to follow.
Thus, \fIb\fR corresponds to the number
of the line that contains
\fBPROCEDURE A\fR and is the first line of the procedure
in question.
\fIe\fR, however, corresponds to the line before
the \fBPROCEDURE B\fR begins, by virtue of the \-1.
Here is an example of mixing pattern searches with relative line
numbers, as mentioned above.
Thus, you have found the beginning and ending lines of procedure A.
.PP
The final string search locates the first line of subroutine C.
The move command normally moves text to \fBafter\fR the given line;
and because we wish to move the text to \fIbefore\fR the line
that contains \fBPROCEDURE C\fR, we must include the \-1 to move the
text up one line.
.Sh "Remembered Search Arguments"
.PP
As discussed earlier, line numbers may be abbreviated in many ways.
They may be entered as \fB.\fR, or \fB+\fR, or \fB-\fR, and certain
combinations of these.
With some commands, pressing \fB<return>\fR tells
.B ed
to use the current line number.
.PP
\fBed\fR encourages you to abbreviate the search string.
If you enter no string between the slashes
in a search or substitution, then \fBed\fR
uses the last-used search string.
A common use is
in the global substitution command (which will be discussed
in detail later in this section):
.DM
	g/please remove this string/s// /p
.DE
This does not quite remove it, but replaces it with a blank.
The last-used
string can be specified by a string search, a substitute command, or a reverse
string search (also discussed later in this section).
Also, the remembered search argument may also be used in any one of these.
You can use the
remembered search feature to \*(QLwalk\*(QR through the file, finding the next
occurrence of a remembered search pattern.
.Sh "Uses of Special Characters"
.PP
As powerful as the line locator seems, some features are even
even more powerful.
These will be discussed in the Expert Editing section, below.
However, these more
powerful capabilities depend upon certain punctuation marks used in a
special way.
As you use the line locator (as well as the substitute
command), be aware of these following characters:
.DM
	[ ^ $ * . \e &
.DE
They have special significance to \fBed\fR when they appear in a string
search or a substitution pattern.
.PP
If you need to use one of these characters without invoking its special
meaning, precede it with a backslash \*(Ql\e\*(Qr.
This tells \fBed\fR not to interpret the character in a special way.
.PP
For example, to find a backslash character, type the search
command:
.DM
	/\e\e/
.DE
.II "ed^backslash"
If any of these characters is to be used in another context,
for example,
within lines that you are adding with the \fBa\fR command, it should
.I not
be preceded with the backslash.
Only use the backslash to hide the meaning when
it appears within the string search command, or within the first part
of the substitution command.
.Sh "Global Commands"
.PP
.II "ed^global, command"
The global commands
.B g
and
.B v
let you repeat commands on all lines within a specified range.
For example, to print all lines that contain the
word \fBexample\fR, type:
.DM
	g/example/p
.DE
The global command can prefix almost any command.
For example, the following
command deletes all lines that contain three consecutive plus signs:
.DM
	g/+++/d
.DE
Likewise, the command
.DM
	g/foxtrot/.-2,.+2p
.DE
prints the five lines that surrounds any line that contains the word
\fBfoxtrot\fR.
.PP
A common use of the global command is to perform global substitution.
The command
.DM
	g/PROCEDURE/s/PROCEDURE/PROC/gp
.DE
performs the substitution on each line that contains the string
\fBPROCEDURE\fR and prints the resulting line.
.PP
This may appear similar to the command
.DM
	1,$s/PROCEDURE/PROC/gp
.DE
but is different in that the global command prints each of the changed
lines, whereas the substitute command prints only the last line changed.
Also, the method of operation of these two commands is different.
.PP
A related command
.B v
performs much the same task, but
executes the commands only for lines that do \fInot\fR contain
the specified string.
Thus, to print all the lines that do not have the letter \fBw\fR, use:
.DM
	v/w/p
.DE
For more sophisticated uses of the \fBg\fR and \fBv\fR commands and how
they work, see the section on Expert Editing.
.Sh "Joining Lines"
.PP
.II "ed^joining lines"
What do you do if you inadvertently hit \fB<return>\fR as you are adding
lines and need to combine the two lines?
.DM
	ed
	a
	Look out, I seem to have hit ret
	urn in the
	middle of a word and don't know
	what to do!
	.
	w rid
	q
.DE
Rather that retyping the entire line, you can use the join command \fBj\fR:
.DM
	ed rid
	1,2j
	1,$p
.DE
This gives:
.DM
	Look out, I seem to have hit return in the
	middle of a word and don't know
	what to do!
.DE
If no line number is specified, \fBj\fR joins the current line and the
following line.
If a single line number is specified, join operates on
that and the following line.
.PP
Several lines can be joined by using the form of the command:
.DM
	\fIa\^\fP,\fIb\fPj
.DE
This joins lines \fIa\fR through \fIb\fR into one line.
Likewise, the command
.DM
	1,$j
.DE
joins all the lines in the file into one line.
Then, the command \fB.p\fR or
.B p
prints the entire file.
.PP
Note that the command
.DM
	3j
.DE
does the same job as the command
.DM
	3,4j
.DE
The join command generates its own second line number if none is
specified, so that the command
.DM
	\fIn\^\fPj
.DE
is equivalent to
.DM
	\fIn\^\fP,\fIn\^\fP+1j
.DE
where \fBn\fR is a line number.
This command is the only one that
interprets a missing line number this way.
.Sh "Splitting Lines"
.PP
.II "ed^spliting lines"
You can split one line into two with the substitute command
.BR s .
To illustrate, suppose you typed in the following commands:
.DM
	ed
	a
	This line wants to be two, with this second.
	.
	w split
	q
.DE
To perform the split, type:
.DM
	ed split
	s/two, /two,\e
	/p
	*p
	w
	q
.DE
The line split is caused by the backslash that precedes the \fB<return>\fR.
This tells \fBed\fR that the \fB<return>\fR does not terminate the
command, but that it is part of the substitution.
The contents of file \fBsplit\fR are now:
.DM
	This line wants to be two,
	with this second.
.DE
.Sh "Marking Lines"
.PP
As you edit a manuscript or program,
it is sometimes handy to be able to leave a
``bookmark'' in the text for later reference.
\fBed\fR provides this feature with the mark command
.BR k .
To mark the next line that has the word \fBfind\fR, use
.DM
	/find/ka
.DE
where the letter \fBa\fR is the mark.
To print the line that has been so marked, use:
.DM
	'ap
.DE
You can place
these references anywhere that a line number is expected.
.PP
The mark must be one lower-case letter.
Also, each mark is associated with one line.
Marking a line with the \fBk\fR command does not
change the current line.
.PP
Marks can be especially handy when you move paragraphs with the
\fBm\fR command.
They give you a chance to review the sections
that you will be moving before you do the move.
.PP
For example,
suppose that you have a manuscript with a paragraph that must be
moved to a different part of the document.
Create the following example:
.DM
	ed
	a
	    This is a paragraph, first line, that
	needs to be moved.
	text
	text
	And this is the last sentence of the paragraph.
	    Next paragraph begins here.
	text
	text
	text
	    This is the spot that we want the paragraph
	to precede.
	.
	w example7
	q
.DE
Now, place three marks to help with the move:
.DM
	ed example7
	/first line,/ka
	/Next paragraph/kb
	/is the spot/kc
.DE
This marks the first line to be moved with \fBa\fR, the line after the last
to be moved with \fBb\fR, and the paragraph's destination with \fBc\fR.
But
you can see that the move command moves lines to the line \fIafter\fR the third
number specified, so let's change the third mark:
.DM
	'c-1kc
.DE
Now we can use \fBc\fR in the move command without arithmetic.
Now, print
the paragraph to be moved to be sure that the marks are correct.
.DM
	'a,'bp
.DE
\fBed\fR replies with
.DM
	    This is a paragraph, first line, that
	needs to be moved.
	text
	text
	And this is the last sentence of the paragraph.
	    Next paragraph begins here.
.DE
You can see that we would move one line too many if we used the marks as they
are.
So, change \fBb\fR also.
.DM
	'b-1kb
.DE
Now, do the move:
.DM
	'a,'bm'c
	1,$p
.DE
The file now contains:
.DM
	    Next paragraph begins here.
	text
	text
	text
	    This is a paragraph, first line, that
	needs to be moved.
	text
	text
	And this is the last sentence of the paragraph.
	    This is the spot that we want the paragraph
	to precede.
.DE
Marking sections of text can increase the ease with which you solve your
complex \fBed\fR problems.
.Sh "Searching in Reverse Direction"
.PP
.II "ed^reverse searching"
All scanning, processing, and searching has been
shown going from the beginning of the file toward the end.
Sometimes it
is useful to find some word that occurs \fBbefore\fR the current line.
.PP
You can get \fBed\fR to do string searching in the reverse direction by
specifying the search with question marks
.B ?
rather than slashes
.BR / .
To find the previous occurrence of the word \fBlast\fR, use:
.DM
	?last?
.DE
This form of searching can be useful in finding the beginning and end of
a \fBrepeat/until\fR statement.
For example,
if the current line is in the
middle of a Pascal \fBrepeat/until\fR group, you can print the group with
the command:
.DM
	?repeat?,/until/p
.DE
The reverse search is like the forward search in every way except the
direction of search.
The search begins one line before the current or
specified line, and proceeds toward the beginning of the file.
If the
string is not found by the time that the search reaches the beginning of
the file, the search resumes at the end of the file, and progresses
towards the starting point of the search.
If the string is not found
when the search reaches the original starting point, the question-mark
error message is issued signifying no match.
.PP
Also, the command
.DM
	??
.DE
uses the remembered search argument.
.SH "Expert Editing"
.PP
.II "ed^advanced commands"
.II "ed^commands, advanced"
This section describes the most
advanced \fBed\fR commands.
.Sh "File Processing Commands"
.PP
.II "ed^file, editing commands"
Earlier, we discussed the commands
.DM
	ed
.DE
and:
.DM
	ed filename
.DE
.B ed
also has file-handling commands that go beyond those already discussed.
.PP
Suppose that you entered the command
.DM
	ed file1
.DE
only to discover when you examined the contents of
.B file1
that you really wish to edit file
.BR file2 .
You could correct this error by exiting from
.B ed
and then re-invoking it for
.BR file2 .
However, \fBed\fR command
.B e
lets you close out the current file and begin to edit a new file
without exiting from the editor.
For example, to stop editing
.B file1
and begin to edit
.BR file2 ,
simply issue the command:
.DM
	e file2
.DE
If you had made any changes to
.BR file1 ,
.B ed
will prompt you with a
.BR ? ,
which is its way of asking if you wish to throw away the changes you have
made to this file.
If you immediately repeat the command, \fBed\fR proceeds even if
there are unsaved changes.
The command
.DM
	E new
.DE
commands
\fBed\fR to edit the new file, whether or not there are unsaved changes.
.PP
.BR ed 's
``read'' command
.B r
also reads a new file, but adds it to the file being edited
instead of replacing the current file with it.
This can be handy for copying one file into another one.
For example,
if you have a manuscript prefix stored in the file \fBprefix\fR
to include the prefix at the beginning of the file you are editing,
type:
.DM
	0r prefix
.DE
\fBr\fR inserts the file being read
after the line number specified;
in this case, line 0 means at the beginning of the file.
If used
without a line number, \fBr\fR appends the newly read lines
to the end of the file.
.PP
.BR ed 's
command
.B w
writes the entire file if no line number is
specified; however, you can specify line numbers.
For example
.DM
	1,3w new
.DE
writes the first three lines to file \fBnew\fR.
If the file name is
omitted, the lines are written to the remembered file name.
.PP
The \fBw\fR command is unique in that it never changes the current
line.
This is true regardless of what line numbers are specified in the
range for the command, or how those line numbers were developed.
.PP
The
.B W
command resembles the \fBw\fR command, except that it
appends lines to the end of the file, whereas \fBw\fR creates a new file
and erases any previous contents.
.PP
The
.B f
command prints the remembered file name that was set in
.DM
	ed filename
.DE
or
.DM
	e filename
.DE
or
.DM
	w filename
.DE
commands.
You can also use \fBf\fR to reset the remembered name, by typing:
.DM
	f newname
.DE
This form of the command tells you what the new remembered file name is,
even though you just typed it in.
.PP
Note that the command
.DM
	w filename
.DE
changes the remembered name only if there is currently no remembered name,
as does the \fBr\fR command.
.Sh "Patterns"
.PP
.II "ed^special characters"
.II "ed^characters, special"
Earlier, you were cautioned that certain punctuation characters have
special effect in search and substitute commands.
These characters are:
.DM
	[ ^ $ * . \e &
.DE
They are used to form powerful substitute and locator commands.
An orderly combination of these special characters is called a
.IR pattern ,
sometimes called a \fIregular expression\^\fR.
You can use a pattern
to find or \fImatch\fR a variety of strings with one search argument.
.PP
The simplest patterns use alphabetic characters and numeric digits, which
match themselves.
For example,
.DM
	/ab/
.DE
finds and prints the next line containing the string \fBab\fR.
.PP
The next simplest character to use in a pattern is the period or dot.
It matches any character except the \fBnewline\fR
character that separates lines.
Two periods in succession match any
two consecutive characters, and so on.
For example, if you have a file that contains algebraic
statements of the form
.DM
	a+b
	c+e
	a-b
	a/b
	d*e
.DE
and wanted to find and print any line involving \fBa\fR and \fBb\fR
(in that order), then use the search statement:
.DM
	/a.b/
.DE
The \fB.\fR in this example matches \fB+\fR, \fB\-\fR, and \fB/\fR.
.PP
Then, you ask, how do I find a string that contains a period?
For example, if you want to find all the sentences that ended with ``lost.''
(that is, the word \fBlost\fR followed by a period), you might first try:
.DM
	/lost./p
.DE
This, however, also matches the string ``lost\ '' (the word \fBlost\fR
followed by a space), which is not what you want.
.PP
This is where the special character backslash comes in
handy.
A backslash tells \fBed\fR to treat the next
character as a regular character, even if it usually is a special character.
Thus, to find ``lost.'', you need only type:
.DM
	/lost\e./p
.DE
This will not incorrectly find ``lost\ ''.
If you want to find backslashes in your file, simply say:
.DM
	/\e\e/p
.DE
.Sh "Matching Many With One Character"
.PP
The asterisk
.B *
matches an indefinite number of characters.
For example, to remove extra spaces between words in a document, type
.DM
	g/##*/s//#/p
.DE
(The character \fB#\fR has been substituted here for the space character to
make the example more readable.)
This replaces each series of spaces
by one space.
.PP
Note that there are two spaces before the \fB*\fR in the search string.
This is necessary because the \fB*\fR matches any length of string,
including zero.
Therefore, searching for a space followed by any number
of spaces finds strings that are at least one space long.
.PP
The \fB*\fR matches the longest possible string of the previous character.
This requires careful attention on your part, because the string matched by
\fB*\fR might be longer than your required string, or even zero in length.
Either way could give you unexpected results.
.PP
If you have a line
.DM
	a+b-c
.DE
in your file and want to change it to
.DM
	a+c
.DE
type the command:
.DM
	s/a.*c/a+c/p
.DE
However, if the line read instead
.DM
	a+b-c*d+c
.DE
and you applied the command, the result would be
.DM
	a+c
.DE
since the \fB.*\fR matches the longest string between any
\fBa\fR and any \fBc\fR.
.Sh "Beginning and Ending of Lines"
.PP
.II "ed^caret"
The characters 
.B ^
and
.B $
match, respectively, the beginning and ending of a line.
Thus, you can find and print all lines that end with a bang:
.DM
	g/bang$/p
.DE
or those that begin with a whimper:
.DM
	g/^whimper/p
.DE
These two characters can also help you find lines of specific length.
If you need to see all lines exactly five characters long, the command
.DM
	g/^.....$/p
.DE
does the trick.
To find and delete all blank lines, type:
.DM
	g/^ *$/d
.DE
Note that this time the
.B *
matches a string of zero spaces.
However, this is correct, because
a blank line includes lines that have nothing in
them, as well as lines that contain only spaces.
.Sh "Replacing Matched Part"
.PP
.II "ed^&"
In many cases of substituting, you find yourself extending a word, or
adding information to the end of a phrase.
This can lead to extensive retyping of characters.
The special \fB&\fR character can help out.
.PP
This character is special only when used in the right part, or \fIpattern2\fR
of the substitute command.
It means ``the string that matched the left part''.
For example, to add \fBing\fR to the word \fBhelp\fR in the
current line, use:
.DM
	s/help/&ing/
.DE
The ampersand may appear more than once in the right side.
.PP
This can be more interesting if the left part has a non-trivial
.IR pattern .
For every word in a line that is preceded by two or more spaces,
double the number of spaces before it:
.DM
	s/###*/&&/gp
.DE
(Again, spaces have been replaced with \fB#\fR for clarity.)
.Sh "Replacing Parts of Matched String"
.PP
A more sophisticated feature, which is similar to the ampersand,
helps you to rearrange parts of a line.
To see how this works, create a file by typing:
.DM
	ed
	a
	first part=second part
	.
	w eql
	q
.DE
Two special bracket symbols, \fB\e(\fR and \fB\e)\fR can be used
to delineate patterns in the left part of a substitution expression.
Then, you can use the special symbols
\fB\e1\fR, \fB\e2\fR, etc., to insert the delimited parts.
The symbol
\fB\e(\fR marks the beginnning of the pattern, and \fB\e)\fR marks the end.
For example,
to delete everything in the line except the characters to the left of the
\fB=\fR, type
.DM
	ed eql
	s/^\e(.*\e)=.*/\e1/p
	Q
.DE
In the substitute command, the \^^\^ matches the beginning of the line,
\fB.*\fR matches ``first part'', and \fB=.*\fR matches the rest of the line.
The symbol \fB\e1\fR signifies the matched characters between the
first \fB\e(\fR (the only one in this example) and \fB\e)\fR.
The
.B p
then prints the result, which will be:
.DM
	first part
.DE
To interchange the two parts, type
.DM
	ed eql
	s/\e(.*\e)=\e(.*\e)/\e2=\e1/
	p
	wq
.DE
The result is
.DM
	second part=first part
.DE
The first portion of the substitution expression,
.DM
	\e(.*\e)=\e(.*\e)
.DE
can be thought of as being in three parts.
The first part
.DM
	\e(.*\e)
.DE
matches all characters up to but not including the \fB=\fR, which are
.DM
	first part
.DE
The second part
.DM
	=
.DE
matches the \fB=\fR in the line, and finally the third part
.DM
	\e(.*\e)
.DE
matches all characters following the ``='', or
.DM
	second part
.DE
The remainder of the substitution expression
.DM
	\e2=\e1
.DE
which is the replacement part, rebuilds the line in interchanged order.
The symbol \fB\e2\fR replaces the matched string enclosed in the second pair
of \fB\e(\fR \fB\e)\fR delimiters, and the symbol \fB\e1\fR inserts the
matched string enclosed in the first pair of \fB\e(\fR \fB\e)\fR.
.PP
The right side of the substitution inserts the second matched expression
(from \fB\e2\^\fR), then inserts the \fB=\fR sign again, followed finally with
the first part of the line from \fB\e1\fR.
.PP
This may appear involved, but can be immensely valuable in situations
that require rearrangement of a large number of lines.
.PP
The next special characters for patterns that we will consider are the
bracket characters
.B [
and
.BR ] .
These are used to define the character class.
Inside the brackets, put a group of characters;
\fBed\fR will match any of them if it appears.
For example, to print a line that contains any odd digit, say:
.DM
	g/[13579]/p
.DE
For even more power and flexibility, you can combine character classes
with the asterisk.
For example, the following command
finds and prints all lines that contain a negative number
followed by a period:
.DM
	g/-[0123456789]*\e./p
.DE
This matches lines containing the following example strings:
.DM
	-1.
	-666.
	-3.7.77
.DE
You can also match all lower-case letters by listing them in brackets,
but the following abbreviation simplifies this:
.DM
	g/[a-z]/p
.DE
This can also be used for the negative number example above:
.DM
	g/-[0-9]*\e./p
.DE
Most special characters lose their original meaning within the
brackets, but one of the special characters,
.B caret
\|^\|, gets a new meaning.
In this context, it matches all characters \fIexcept\fR
those listed in the brackets.
For example, the following pattern
matches a string that begins with \fBK\fR and continues
with any character except a number:
.DM
	/K[^0-9]/
.DE
This matches:
.DM
	KQ
	KK
	KK9
.DE
but not:
.DM
	K7
	kK0
.DE
.PP
Other special characters may be part of a character class, but lose
their special meaning when used in that context.
Remember,
however, that if you want to match the right bracket, it
must appear first in the list.
So, to find all occurrences of special characters in the file, type:
.DM
	g/[]^\e.*[&]/p
.DE
.Sh "Listing Funny Lines"
.PP
The \fBp\fR command prints lines with graphic characters in them.
It also prints lines with non-graphic (or \fIcontrol\fR\^) characters,
but these do not appear on the screen.
For example, printing a line that contains
the BEL character \fB<ctrl-G>\fR will
ring your terminal's bell, but you will not see where
the BEL character occurs within the line.
.PP
The
.B l
command behaves like the \fBp\fR command, except that it also
decodes and prints control characters.
For example, if you use the \fBl\fR command to print
a line that containing the word \fBbell\fR followed by a
BEL character, you would see:
.DM
	bell\e007\en
.DE
Note that ``007'' is the ASCII value for \fB<ctrl-G>\fR.
(ASCII is the system of encoding characters within your computer;
see \fBASCII\fR in the Lexicon for the full ASCII table.)
The \fBl\fR command displays the
backspace character \fB<ctrl-H>\fR as a hyphen
first overstruck with a \fB<\fR and then a newline, which appears as
\fB\en\fR on your screen.
It displays a tab character as a \fB-\fR, first overstruck with a \fB>\fR
and followed by a newline character, which appears as \fB>\en\fR.
If the line being listed with \fBl\fR is too long
to be displayed on one line on your screen,
\fBl\fR separates it into two lines, with the backslash character
placed at the end of the first line to indicate the split.
.PP
All other features of the
.B p
command apply to the
.B l
command.
.Sh "Keeping Track of Current Line"
.PP
.II "ed^current, line"
The most commonly used abbreviation in \fBed\fR is the dot,
or period, which stands for the current line.
Many commands can
change the value of the dot, and it is useful to you to be able
to anticipate this change when using the abbreviation.
.PP
Different classes of commands affect the value of the dot in different
ways; in general, however, the simple explanation is usually correct:
the current line is the last line processed by the last command to be
executed.
.PP
Consider, for example, how the substitution command \fBs\fR
changes the current line:
.DM
	1,$s/flow/change/
	p
.DE
In this example,
the current line will be the last line modified by the substitutions;
and that will be the line that the \fBp\fR command prints.
.PP
The
.B w
command is an exception to this rule.
It does not change the current line,
regardless of any line range selection or how these ranges are developed.
.PP
The
.B r
command changes the current line to the last of the
lines read.
.PP
The
.B d
command sets the current line to the line after the last
line deleted unless the last line in the file was deleted, in which case the
new last line becomes the current line.
.PP
The line insertion commands
.BR i ,
.BR c ,
and
.B a
all leave the current line as the last line added.
If no lines are added, however, their behaviors differ:
\fBi\fR and \fBc\fR effectively back up the last line by one,
whereas \fBa\fR leaves it the same.
.Sh "When Current Line Is Changed"
.PP
When the current line changes is also important.
Normally, the current line does not change until the command is completed.
.PP
To illustrate, create a file \fBsemi\fR by typing:
.DM
	ed
	a
	begin
	second
	first
	in between
	second
	last
	.
	w semi
	q
.DE
Now, edit the file and type all lines from \fBfirst\fR to \fBsecond\fR:
.DM
	ed semi
	/first/,/second/p
	Q
.DE
This will cause an error!
The reason is that the search command begins
with current line set to \fB$\fR, so ``first'' is found on line 3.
But the
search for ``second'' also begins with the current line set at \fB$\fR, and
finds ``second'' on line 2.
Thus, the command translates to
.DM
	3,2p
.DE
which is clearly invalid.
.PP
.II "ed^;"
To do what was intended, use the
.B semicolon
\fB;\fR instead of the comma to separate the two searches.
This forces \fBed\fR to change
the current line to be changed after the search for \fBfirst\fR
rather than after the entire command.
Thus, the commands
.DM
	ed semi
	/first/;/second/p
	Q
.DE
are correct and will do what is intended.
The result will be:
.DM
	first
	in between
	second
.DE
The search for \fBfirst\fR still begins with the current line set at
.BR $ .
However, after it finds \fBfirst\fR,
.B ed
resets the current line to 3, and
begins the search for \fBsecond\fR there, and succeeds on line 5.
.PP
Finally, to be sure of where the current line is, you can use the
.B p
command to show you the line;
or you can have \fBed\fR tell you the number of the current line by typing:
.DM
	.=
.DE
To give you a perspective on where you are with respect to the end of the
file, type
.DM
	&=
.DE
and \fBed\fR will tell you the number of the last line in the file.
.PP
You can put any line number expression before \fB=\fR and it will type the
result.
For example
.DM
	/next/=
.DE
types the number of the next line to contain ``next'' (if there is one).
The command
.B =
never changes the line number.
.Sh "More About Global Commands"
.PP
.II "ed^global, command"
.II "ed^commands, global"
All the global commands discussed thus far have been
followed by only one command \(em substitute, print, and delete.
You can, however, put several commands after a global command,
and execute each of those commands for each line that matches.
.PP
To change all occurrences of the word \fBcacophonous\fR to the word
\fBnoisy\fR and print the three lines that follow, issue the command:
.DM
	g/cacophonous/s//noisy/\e
	.+1,.+3p
.DE
Here, the additional commands are separated by the backslash before the
\fB<return>\fR.
Several commands can be added, and all but the last need
the backslash at the end.
.PP
This will work for the line-adding commands, as well.
To insert a
spelling warning before each line that contains the word \fBoccurrance\fR,
issue the command:
.DM
	g/occurrance/i\e
	((the following line needs spelling check))\e
	.
.DE
Note that the last line of the \fBi\fR group can be entered without a
backslash, in which case the line containing only the period must be
omitted.
This has the same effect as:
.DM
	g/occurrance/i\e
	((the following line needs spelling check))
.DE
You should not depend upon the setting of the current line in any
multiline global command.
There are two reasons for this.
First, if one of the commands is a substitute
and the string is not found in the
matched line, the current line will not be changed.
.PP
Second, the global command operates in two phases.
The first part scans the file for lines that match the string argument.
.B ed
marks these lines
internally in a manner similar to the \fBk\fR command.
The second phase then executes the commands on each of the marked lines.
Therefore, you cannot count on a string search following the \fBg\fR to set
the current line number.
.PP
Again, the
.B v
command behaves in the same way, except that it selects lines that do
\fInot\fR match the pattern.
.PP
Caution is advised when using remembered search arguments, for a
similar reason.
A search argument is remembered only if the search has been executed.
Thus, in a command of the form
.DM
	g/backup/s//reverse/\e
	s/backin /backing/
.DE
the first remembered search may use \fBbackup\fR on some occasion, and
``\fBbackin\fR\'' on others.
The reason for this is that the second phase of the \fBg\fR
command begins with a remembered search argument of \fBbackup.\fR
After the
second line of the multiline command executes, the remembered search
argument is ``\fBbackin\fR\ ''.
This remains throughout the remainder of the second
.B g
phase.
.PP
Thus, it is recommended that you avoid remembered search arguments when
using multiline global commands.
.Sh "Issuing COHERENT Commands Within ed"
.PP
While you are using \fBed\fR, you can issue \*(CO
commands by prefixing them with the
.B !
command.
.PP
This can be useful if, for example,
you need to discover a file name while in
the middle of an edit, and you want
to find it without leaving \fBed\fR.
Thus, to list your directory while in \fBed\fR, type:
.DM
	!lc
.DE
\fBed\fR sends the command to \*(CO and echoes a \fB!\fR character
when the command is finished.
.PP
There is no limitation on the type of command that you may issue with
this feature.
It is even plausible that you want to start another \fBed\fR.
.SH "For More Information"
.PP
The Lexicon article on \fBed\fR summarizes its commands and options.
The \*(CO system also includes three other useful editors:
\fBsed\fR, the stream editor; \*(ME, the screen editor; and
\fBvi\fR, a clone of the standard UNIX screen editor.
\*(ME and \fBsed\fR are introduced with their own tutorials, and
each is summarized in the
Lexicon.

.ds TL "Network Administration"
.NH "Administering TCP/IP"
.PP
TCP/IP is a networking protocol \(em that is, a description of how
computers can communicate with each other.
The acronym
.I TCP/IP
stands for ``Transmission Control Protocol/Internet Protocol''.
It consists of protocol, plus a set of user-level programs that let
you and other users of your system communicate easily with every
other computer that is hooked into your network.
As the name implies, TCP/IP was devised for use on the Internet, which
is a global computer network built and maintained by the Department
of Defense's Advanced Research Projects Agency (DARPA).
With TCP/IP, it is possible to
.\"send mail among the computers on your network;
log into each computer easily; upload or download files;
and do other useful tasks.
And if your network is linked into the Internet, your network effectively
becomes every Internet machine throughout the world.
.PP
Your NP-series network-protocol package is a networking tool that
implements TCP/IP and a set of selected tools.
The NP-series package lets you communicate over an
Ethernet local-area network with other computers that run TCP/IP-based software.
.PP
This tutorial will help you to set up your TCP/IP network, and will help
you get started in savoring the pleasures (and coping with the frustrations)
of your network.
However, the subject of how to set up and run a TCP/IP network, and how to
work with the Internet, is far too broad to cover in one brief manual.
If you intend to manage a network on your own, we suggest you obtain the
following book:
.QS
Hunt, Craig: \fITCP/IP Network Administration.\fR
Sebastopol, Calif., O'Reilly and Associates Inc., 1990.
.QE
.PP
If you wish to explore the Internet at all (and we urge that you
look into this possibility), we strongly recommend the following book:
.QS
Krol, Ed: \fIThe Whole Internet:
User's Guide & Catalog.\fR
Sebastopol, Calif., O'Reilly and Associates Inc., 1992.
.QE
.PP
Another useful source of information is the column ``Net Worth,'' which is
written by Steven Baker and which appears monthly in \fIUNIX Review\fR.
The rest of this chapter will refer continually to these publications.
.SH "How the Package Works"
.PP
TCP/IP provides the underlying protocols for the set
of commands in the NP-series network-protocol package.
These commands perform such functions as letting you log into remote systems,
transfer files, and execute commands remotely on other systems.
The commands are as follows:
.IP \fBtelnet\fR
To log into another system on your network, as if you were
using a terminal directly connected to that system.
If your local network is attached directly to the Internet, you can use
.B telnet
to log into any system on the Internet, anywhere in the world,
that grants access to outsiders.
.IP \fBftp\fR
The name
.B ftp
stands for ``file transfer protocol''.
It lets you transfer files between your local system and any system on
your network that also supports
.BR ftp .
.IP \fBtftp\fR
This is a specialized file-transfer utility.
It is usually used by intelligent peripheral devices rather than by humans.
.IP \fBrlogin\fR
This lets you log into a remote system as if it were your own,
as defined under the Berkeley UNIX release 4.3 (4.3BSD).
.IP \fBrshl\fR
This lets you execute a command (or a command file)
on a remote host that supports the 4.3BSD conventions for remote execution.
.IP \fBrcpy\fR
This lets you perform a ``remote copy,'' that is,
let you copy files from another system as defined under 4.3BSD.
Unlike
.BR ftp ,
.B rcpy
can handle ``third-party transfers'' \(em that is, copy files from one remote
system to another.
Under other implementations of TCP/IP, this utility is called
.BR rcp .
.IP \fBruptime\fR
Display the status of every system on your network
that uses the 4.3BSD conventions for reporting such information.
.IP \fBrwho\fR
List every user on every computer on your network that
uses the 4.3BSD conventions to report such information.
.PP
All of the utilities are functionally similar to the
4.3BSD commands
.BR telnet ,
.BR ftp ,
.BR tftp ,
.BR rlogin ,
.BR rsh ,
.BR rcp ,
.BR ruptime ,
and
.BR rwho .
Note, however, that
.B rsh
and
.B rcp
have been renamed, respectively,
.B rshl
and
.BR rcpy .
.PP
Because they use the standard DARPA protocols, you can use
.BR telnet ,
.BR ftp ,
and
.B tftp
to communicate with the wide variety of systems that support these protocols;
these include most flavors of UNIX and some software packages that run under
MS-DOS.
.PP
The other commands are derived from 4.3BSD,
and are supported on other, similar operating systems, including COHERENT.
Because of their origin, these utilities make certain assumptions
about the hosts with which they communicate (for example,
.B rcpy
assumes that your local user name exists on the remote host
and assumes UNIX/COHERENT file-naming conventions)
and have special features, such as a provision for recognizing
user names shared by different hosts (thus simplifying the login process).
It is easier to use this group of utilities if you plan to communicate with
remote systems that support them.
.PP
Each of these commands is summarized in the Lexicon at the back of this
manual.
All are introduced in the following chapter, entitled
.IR "TCP/IP Commands" .
.Sh "Clients and Servers"
.PP
The network commands are built
on the concept of clients and servers.
A
.I client
is a program that requests service from another computer system;
a
.I server
is a program that processes the requests of a client.
Each computer system runs both clients and servers:
the clients to request information from remote systems, and servers to
process requests that remote systems make on it.
.PP
When you invoke a program on your system to communicate with a remote system,
you are invoking a client.
When that client communicates with a remote system, it actually talks
with its server counterpart on that system.
The client interprets your requests, initiates
communication with a server, and directs the requests to the server.
The server typically runs continually on a system,
and waits for requests from clients.
The client passes your request to the server,
which determines whether the request is acceptable;
if it is, the server executes the request and sends the results back to
the client, which in turn reports them to you.
.PP
As you can see, an appropriate server must be running on the remote host
before any of the client programs can work:
.IP \(bu 0.3i
The commands
.BR telnet ,
.BR ftp ,
and
.B tftp
require, respectively, the servers
.BR telnetd ,
.BR ftpd ,
and
.BR tftpd .
.IP \(bu
.B rlogin
requires that the remote system run the
.B rlogin
server
.BR rlogind .
.IP \(bu
Depending on how you invoke it,
.B rshl
tries to contact either an
.B rsh
server or an
.B rlogin
server.
.IP \(bu
.B rcpy
uses the
.B rsh
server.
.PP
The utilities
.B ruptime
and
.B rwho
work slightly differently.
They do not contact remote servers when invoked, but
instead read files containing information collected by a local
.B rwho
server from other
.B rwho
servers on the network.
.PP
Your NP package also includes servers to handle incoming requests from
other users on the network, so a remote user can access to your files.
.Sh Terminology
.PP
Before we proceed, please note the following terms.
.IP \(bu 0.3i
Any computer system on your network that runs one or more servers is called a
.IR host .
This term was chosen to indicate that the computer system can host inquiries
from other systems on the network.
.IP \(bu
Your computer system \(em that is, the one upon which you invoke a client to
dispatch inquiries to other systems on the network \(em is sometimes called the
.IR "local host" .
Please do not confuse this term with the term
.IR "local network" ,
which is set of hosts that are in the same physical locale and that
share the same physical network.
.IP \(bu
A
.I gateway
is a computer that is hooked into more than one network.
Hosts on one network can pass information or requests to hosts on another
network via a gateway that is hooked into both networks.
A request from one host to another may cross an indefinite number of
networks, and pass through one or more gateways along the way.
You (or your network's chief administrator) will have to tell your
network which systems are gateways to other networks, plus the addresses
of those networks.
.IP \(bu
A
.I packet
is a bundle of information that may be up to several kilobytes long.
Ethernet passes information among the hosts on the network in the form of
packets; the host that is broadcasting the information breaks up the
transmission into packets, and the host receiving the information reassembles
the packets.
Each packet contains the Ethernet address of the system that broadcast it
and the system that is its intended destination.
A packet can also be called a
.IR frame .
.Sh "Data bases and Files"
.PP
The TCP/IP clients and servers continually read a
number of files on your system.
These files hold such information as the addresses of remote hosts,
the names of users on remote hosts, and the permissions (if any) that
individuals on remote hosts have on your system.
The following lists the files that define how TCP/IP operates on your system:
.IP \fB/etc/ftpusers\fR
This file
names the users who are \fInot\fR allowed access to your system via
.BR ftp .
.IP \fB/etc/hosts\fR
This file lists the names and Internet
addresses of remote systems that your system knows.
.IP \fB/etc/hosts.equiv\fR
This file names ``equivalent hosts'' \(em that is, the hosts with which
your system shares account names.
.IP \fB/etc/networks\fR
This file names the remote networks with which you want to communicate.
.IP \fB/etc/protocols\fR
This file names the communication protocols used on your local network.
.IP \fB$HOME/.rhosts\fR
This file names the remote users who can log into the account of
the user whose home directory this is.
If
.B $HOME
is directory \fB/\fR, then
.B \&.rlogin
names the remote systems whose superusers
have superuser privileges on this system.
.IP \fB/etc/services\fR
This file lists services provided by your local network.
.PP
The following section describes how to set up and maintain these files.
.SH "Setting Up and Administering TCP/IP"
.PP
Before you use the TCP/IP utilities, you must meet the
following requirements:
.IP \(bu 0.3i
The NP TCP/IP package is installed and running on your computer.
.IP \(bu
Your host computer's location, users, and services
have been identified to other hosts on the network.
.IP \(bu
The remote hosts on your network are running the appropriate servers.
.IP \(bu
You have the required privileges on your local system.
.IP \(bu
You know the names by which the various hosts are known on your network,
and their Internet addresses.
.IP \(bu
You know the names of users and their passwords you must
supply to each remote host.
.PP
Before you can use your NP package,
you must establish a support environment for your NP-series software.
This section covers various topics concerning the use of your NP package
on a TCP/IP network.
These topics include:
.IP \(bu 0.3i
Setting up and maintaining network data-base files.
.IP \(bu
Setting up a public-access directory for use with
.BR ftp .
.IP \(bu
Managing the routing table used to communicate via gateways
with systems on other networks.
.IP \(bu
Dividing your network into sub-networks.
.IP \(bu
Configuring the number of sockets and the window size of the NP622 TCP image.
.Sh "Overview of the Network Data-base Files"
.PP
This section discusses the following files:
.DS
.ta 0.5i 0.7i
	\(bu	\fB/etc/ftpusers\fR
	\(bu	\fB/etc/hosts\fR
	\(bu	\fB/etc/hosts.equiv\fR
	\(bu	\fB/etc/networks\fR
	\(bu	\fB/etc/protocols\fR
	\(bu	\fB$HOME/.rhosts\fR
	\(bu	\fB/etc/services\fR
.DE
.PP
All of these files have the same layout.
The pound-sign character `#' introduces a comment:
both clients and servers ignore all text from a `#' to the end of the line.
Blank lines are ignored.
Each line of data consists of one or more items.
Each item, in turn, consists of a string of printable character demarcated
by white space;
thus, no data item used by a TCP/IP client or server can have white space
embedded within it.
.PP
You can edit these files by hand, or you can use some of the commands
included with NP package to edit these files interactively.
The following sub-sections discuss the data contained in each file,
and the proper strategy for populating and editing each.
.Sh "/etc/hosts: Set System Names and Addresses"
.PP
The file
.B /etc/hosts
gives the name and address of each host on your system
with which your system can communicate.
There are three ways to identify a host on a network:
by its name, by its Internet address (also called a ``network number''),
or by its Ethernet address.
The Ethernet address is burned into the Ethernet card that that host
uses to hook into the network;
you can assign host names and Internet addresses yourself.
.Sh "Host Names"
.PP
You can assign to any host a name up to 32 characters long.
The name can include letters, digits, and punctuation marks,
but the first character must be a letter.
You must include this name in
.BR /etc/hosts ,
as explained in the section on \fBhosts\fR, later in this section.
Because other users will use your system's host name (or an alias)
when they dispatch inquiries to a server on your computer, you should keep
your host's name brief and to the point.
.PP
You set the host name for your computer when you installed COHERENT.
To change the host name for your computer, edit the file
.BR /etc/uucpname ,
or use the COHERENT command
.B uname
with the option
.BR \-S .
For details, see the Lexicon entries
.B uuname
and
.B uname
in the COHERENT Lexicon.
.Sh "Internet Addresses"
.PP
The Internet address is a four-byte number that identifies your network
and each host on the network.
It uses dot notation.
In dot notation, bytes are separated by periods.
The value of a byte is usually given in decimal (although octal and
hexadecimal can be used as well).
Decimal is the default notation;
to indicate an octal number, prefix it with a a `0' (zero);
to indicate a hexadecimal number, prefix it with `0x'.
For example:
.DM
	120.0.0.1
	Ox85.0x0.0x0.0x1
.DE
.PP
There are three classes of Internet addresses, A, B, and C.
They differ in the number of bytes they use to identify the network
and the number they use to identify each host on the network.
The higher the class of network, more hosts it can identify.
A class is identified by the value of the high-order bits in its
first byte.
The following summarizes each class of network:
.IP \fBA\fR 0.3i
A class-A network uses the first byte of the Internet address
to identify the network, and the remaining three bytes to identify
each host on the network.
The address of each class-A network sets the high-order bit of its first
byte to zero;
thus, the first byte of a class A network must be less
than 128 (decimal).
In the following example, the network number is 57 and the
remaining three bytes give the host address:
.DM
	57.0x00.0x01.0x01
.DE
.IP \fBB\fR
A class-B network uses the first two bytes of the Internet address
to identify the network, and the remaining two bytes to identify
each host on the network.
The address of each class-B network sets the two high-order bits of its
first byte to `10';
thus, the first byte of a class-B network address must be
between 128 and 191 (decimal).
In the following example, the network number is 150.8
and the remaining two bytes give the host address:
.DM
	150.8.123.16
.DE
.IP \fBC\fR
A class-C network uses the first three bytes of the Internet address
to identify the network, and the remaining byte to identify
each host on the network.
The address of each class-C network sets the three high-order bits of its
first byte to `110';
thus, the first byte of a class-C network address must be
between 192 and 240 (decimal).
In the following example, the network number is 192.20.0
and the last byte gives the host address:
.DM
	192.20.0.1
.DE
.PP
Every host on a network must have the same network number \(em that is,
they must differ only in host portion of their addresses.
.PP
If the hosts on your network are going to communicate with other networks on
the Internet, you must obtain a network number from the
University of Southern California Information Sciences Institute at
the following address:
.DS
	USC-Information Sciences Institute
	4676 Admiralty Way
	Marina del Rey, CA 90291
	(213) 822-1511
.DE
Otherwise, you can assign your own network number.
.PP
Regardless of whether you assign your own network number, or receive one
from DARPA, you (or your network's chief administrator)
must assign the Internet address to each host on your network.
Each host on your network must have a unique host address.
.PP
For a more detailed discussion of Internet addressing, see
``Defense to the Rescue,'' by Steven Baker (\fIUNIX Review\fR, March 1992,
pp. 13-22).
.PP
To assign a host address to your host computer, use the command
.BR ifconfig .
For details on this command, see the its entry in the Lexicon at the end
of this manual.
.Sh "Ethernet Addresses"
.PP
The Ethernet address is a unique, six-byte number that identifies
a host on the Ethernet.
It is the physical address of the host that is actually used
in transmitting packets over the Ethernet.
It is permanently stored in the Ethernet board by its manufacturer.
Each manufacturer ensures the uniqueness of the number of each of its boards
\(em not just among the boards it manufactures, but in the world.
Your NP-series board stores its Ethernet address in its ROM.
The NP software translates between
a host's physical Ethernet address and its logical Internet address.
.Sh "The Structure of /etc/hosts"
.PP
Each TCP/IP host on your network must have a file called
.BR /etc/hosts .
This file gives the name and address of every other host on the network.
Your NP distribution kit contains a sample
.BR /etc/hosts .
To add entries to this file, use the command
.BR mkhosts .
This command is summarized in the Lexicon at the back of this manual.
.PP
If your system already contained a copy of
.BR /etc/hosts ,
it was not overwritten when you installed your NP package.
You should, however, run
.B mkhosts
to ensure that your local-host name is correct.
.PP
Each line in
.B /etc/hosts
contains an entry for a host on the network.
The line begins with the Internet address.
The host name comes next, followed by any aliases \(em that
is, alternative names that are also to be recognized as referring
to that host.
For example:
.DM
.ta 0.5i 1.5i 2.5i 3.5i
	# Hosts Data base
	#
	193.16.16.27	accounting	acct	beancounters
	193.16.16.2	janet	jcr
	193.16.3.5	engineering	eng
.DE
.PP
As you can see, a given host can have more than one alias.
Aliases need not be terse; however, you should not use an alias name that
you would not want the users of that host to see.
.PP
Each copy of
.B /etc/hosts
must include the following standard entries:
.DM
.ta 0.5i 1.5i
	127.1	localhost
	127.0.0.1	loopback
.DE
.PP
When you specify only two parts of an address, the
second part represents the final three bytes of the address.
Thus, the addresses
.B 127.1
and
.B 127.0.0.1
are the same address in dot notation.
.PP
The address
.B 127.1
by convention names the local host.
Packets sent to this address are returned to the local host:
they do not go onto the Ethernet.
This loopback address is useful in debugging software.
The host names
.B hostname
and
.B loopback
are also conventional names for the local host.
.PP
Do not change these entries in
.BR /etc/hosts .
You must place a separate entry into
.B /etc/hosts
for your local host's Internet address and host name.
.PP
If you have relatively few hosts on the network, you can
maintain a complete
.B /etc/hosts
file for every host by following these steps:
.IP \fB1.\fR 0.3i
Select one device on the network to be the
.IR "master host" .
This should be the host used by the chief system administrator for your
network.
The superuser on the master host should have root privileges on every
other system on the network.
.IP \fB2.\fR 0.3i
Create a complete
.B /etc/hosts
file for the master host on the network.
(Remember to include an entry for the master host itself.)
.IP \fB3.\fR
Put an entry for the master host into the
.B /etc/hosts
on every other host.
.IP \fB4.\fR
The superuser on the master host then uses the command
.B rcpy
to copy the completed
.B /etc/hosts
from the master host to every other host.
.IP \fB5.\fR
Whenever a host is added to or deleted from the network,
the chief system administrator updates only the
.B /etc/hosts
on the master host, and then redistributes it to every other host on the
network.
.Sh "/etc/services"
.PP
The file
.B /etc/services
lists the services provided by TCP/IP and related protocols.
This is a standard file, and you should not have to change the one provided
as part of your NP-series network protocol package distribution kit.
.Sh "/etc/hosts.equiv"
.PP
The file
.B /etc/hosts.equiv
establishes equivalent accounts among the hosts on the network.
If your local host names a host in
.BR /etc/hosts.equiv ,
then the users on that host can use the commands
.B rshl
and
.B rcpy
to access your host without a password.
.PP
To permit users access to some or all of the hosts on the network,
each host should contain a file named
.B /etc/hosts.equiv
that lists the host names of other hosts whose users are to be
allowed access without a password.
.PP
Your NP package contains a sample copy of
.BR /etc/hosts.equiv .
If your host computer already has an
.BR /etc/hosts.equiv ,
it was not overwritten when you installed your NP package,
and you do not need to change it in any way.
.PP
To add entries to
.BR /etc/hosts.equiv ,
use the command
.BR mkhosts .
.Sh "$HOME/.rhosts"
.PP
Each user on each host can have a file named
.B \&.rhosts
file in his login directory.
This file names the users on other systems who can log into his account.
This mechanism is quite useful if one user has a login account
on a number of different hosts on your network,
and wishes to access any of them without the bother of logging in.
.PP
For example, the following gives the
.B \&.rhosts
file that user
.B fred
on system
.B lepanto
has in his home directory:
.DM
	siss81	fb
	mwc	fwb
.DE
.PP
This file lets user
.B fb
on system
.B siss81
and user
.B fwb
on system
.B mwc
log into
.BR fred 's
account.
.PP
The file
.B /.rhosts
names the hosts whose superusers can log into the local host.
For example, consder that file
.B /.rhosts
on system
.B lepanto
reads as follows:
.DM
	siss81	root
	mwc	root
.DE
Here, the superusers on systems
.B mwc
and
.B siss81
can log into system
.B lepanto
and act as the superuser on that system.
.PP
Each host's copy of
.B /.rhosts
should name the master host on your network.
.PP
On some implementations of the UNIX operating system,
a superuser cannot log in to a remote host because
.B root
is only allowed to log in on the system console.
Under COHERENT, the superuser can log in from any terminal.
.PP
To create
.BR /.rhosts ,
use the command
.BR mkhosts .
For more information, see the entries for
.B rlogin
and
.B rshl
in the Lexicon at the end of this manual.
.Sh "/etc/networks"
.PP
The file
.B /etc/networks
gives the names and network numbers of your network and
other networks with which you can communicate.
If you want to communicate on the Internet,
you must create this file by obtaining the official
network data base maintained by the Network Information Control Center (NIC).
(The address of the NIC is given above.)
To this, add information about other networks not listed by NIC,
with which you may want to communicate.
.PP
If you are not going to use the Internet, you can create your own
.B /etc/networks
file.
Each entry should include the following information:
.IP \(bu 0.3i
Official network name.
A network name can contain any printable character other than white space,
newline, or the comment character `#'.
.IP \(bu
Internet network number, as described above in the section on
.BR /etc/hosts .
.IP \(bu
Any aliases for the network name.
.Sh "/etc/protocols"
.PP
The file
.B /etc/protocols
contains information about the protocols used on the Internet.
For each protocol you use,
this file should contain one line with the following information:
.IP \(bu 0.3i
Official protocol name.
.IP \(bu
Protocol number.
.IP \(bu
Any aliases for the protocol name.
.PP
The following example is of a sample version of
.BR /etc/protocols :
.DM
.ta 0.5i 1.25i 2.15i 3.0i
	#
	# Internet (IP) protocols
	#
	ip	0	IP	# internet protocol, pseudo-protocol
	icmp	1	ICMP	# internet control message protocol
	ggp	3	GGP	# gateway-gateway protocol
	tcp	6	TCP	# transmission control protocol
	egp	8	EGP	# exterior gateway protocol
	pup	12	PUP	# PARC universal packet protocol
	udp	17	UDP	# user datagram protocol
	hmp	20	HMP	# host monitoring protocol
	xns-idp	22	XNS-IDP	# Xerox NS IDP
	rdp	27	RDP	# reliable datagram protocol
.DE
.Sh "/etc/ftpusers"
.PP
To restrict access to files on the local host, write into file
.B /etc/ftpusers
the names of all users who are
.I not
allowed access to the local host via the command
.BR ftp .
You should, for example, put
.B uucp
into this file, so that users cannot log in as
.B uucp
and use
.BR uucp 's
privileges to obtain files that contain sensitive information
(e.g., UUCP configuration files that contain the names and passwords of
other remote systems).
.SH "Setting Up Anonymous ftp"
.PP
You can set up on your system an account into which any user can log
anonymously via
.BR ftp ,
with no password required.
The home directory for this account can contain files that you wish to make
accessible to any user on any remote host.
System administrators occasionally do this to make information
available to the public at large, e.g., files of information on how to
obtain an account on the local host or of the services the local host offers.
By convention, such an account is given the login name
.B anonymous
or
.BR ftp ;
thus, such an account usually is called an
.I "anonymous ftp"
account.
.PP
Set up this account carefully, to ensure
that your system's security cannot be breached.
.PP
To set up the directories and file permissions that you need to run anonymous
.BR ftp ,
first create a login account for user
.BR ftp .
Use the following guidelines when you set up its home directory:
.IP \(bu 0.3i
Give user
.B ftp
the home directory
.BR /ftp .
It should have mode 500 \(em that is, it should
be readable and executable only by its owner (that is, by user \fBftp\fR),
and unwritable by anyone.
(For more information on what modes mean, see the Lexicon entry for
.BR ls ).
.IP \(bu
Create the directory
.BR /ftp/bin .
It must be owned by the superuser and have mode 444 (that is, readable by
anyone and writable by no one).
Modify the file
.B /ftp/.profile
to define the environmental variable
.B PATH
to point only to the directory
.BR /ftp/bin .
.IP \(bu
Copy into
.B /ftp/bin
the files
.B /bin/ls
and
.BR /bin/sh .
Give them mode 111.
This ensures that the user who logs in as an anonymous user will be able
to run a shell and to see what files are in
.B /ftp
and its subdirectories, but do nothing else.
For security reasons, you may wish to edit
.B /ftp/etc/passwd
to include only the user
.BR ftp .
.IP \(bu
Create the directory
.BR /ftp/etc .
Make it owned by the superuser and unwritable by anyone.
Copy into it the files
.B /etc/passwd
and
.B /etc/group
so that the
.B ls
command can work properly.
These files should have mode 444.
.IP \(bu
Create the directory
.BR /ftp/pub .
Make it owned by user
.B ftp
and give it mode 777 (that is, readable or writable by anyone).
You (or any user) can then write files into this directory that are to be
accessible via the anonymous account in this directory.
.PP
The following script performs the above steps;
note that it can only be run by the superuser
.BR root :
.B 
.DM
	cd /ftp
	mkdir etc bin dev public
	cp /etc/passwd /etc/group etc
	cp /bin/sh /bin/ls bin
	ls /dev/is* | cpio -pudvm .
	chmod 444 etc/*
	chmod 111 bin/*
	chmod 666 dev/is
	chmod 511 etc dev bin
	chmod 777 public
	exit
.DE
.SH "Routing"
.PP
Your NP package's routing feature lets your host computer
communicate via gateways with hosts on other networks
that are connected to your local network.
.PP
To communicate with a remote host or network, a user
or application name gives the name or Internet address
of the destination, as usual.
Your NP package recognizes that the destination address
requires routing, and forwards the packets to the appropriate gateway,
as defined in your NP package's routing tables.
Your NP package does not alter the destination Internet address of the packet;
rather, it simply routes the packet to the gateway, and lets the gateway
re-route the packet to its destination.
.PP
The routing table specifies the gateway to use for
a particular host on a remote network.
It is the responsibility of your network administrator to maintain
the routing table for your host.
You can use the command
.B route
to add, delete, or display entries in the routing table.
For details, see the entry for
.B route
in the Lexicon at the back of this manual.
.PP
For example, suppose there are two networks.
On network A, host
.B bill
is at address 120.0.0.1; and on network B, host
.B hillary
is at address 128.1.0.1.
Connecting the two networks is a gateway, whose address on
network A is 120.0.0.10.
.PP
.\"
.\" A diagram should go here.
.\"
Packets sent from
.B bill
to
.B hillary
must go through the gateway at 120.0.0.10.
To add this information to the routing table on
.BR bill ,
the administrator on
.B bill
must issue the command
.BR route ,
followed by the argument
.BR add ,
the name or address of the remote destination,
the name or address of the gateway,
and the number of hops (that is, gateways) a packet must traverse
to reach the destination \(em in this case:
.DM
	route add 128.1.0.1 120.0.0.10 1
.DE
.PP
A routing table must be set up every time your NP package is started.
You may find it convenient to combine all the
.B route
commands for your routing table entries in a shell script,
so that you can recreate the table without retyping all the commands each time.
.SH "Dividing Your Network into Subnets"
.PP
As discussed earlier, an Internet address is divided into a network address
and a host address.
All hosts on a network have the same network address; and
every host on a network has a unique host (IP) address.
.PP
In some cases, you may wish to split your
network into sub-networks, or
.IR subnets .
For example,
a large organization might want to put each department onto its own subnet.
This would allow you to control access to departmental resources,
while also keeping one overall network number for communication on the Internet.
.PP
Your NP software supports subnetting.
For communication between subnets, however,
you must have a gateway on the network; but
nodes that run NP software cannot function as a gateway.
.PP
In subnetting, bits from the host address identify the subnet.
The number of bits used in each host address indicates
how many subnets are available to that host.
Conversely, the more bits used in the subnet,
the smaller the number of hosts that can be on the subnet.
.PP
Use a bit mask to identify which bits of the
host address identify the subnet number;
typically, these bits are contiguous and
are the most significant bits of the host address.
When you assign host addresses, use the subnet bits of
the address to indicate which subnet the host is on.
.PP
Each host on the TCP/IP network must be made aware
that subnetting is in effect, and which bits represent the subnet number.
Once it knows this, it can interpret the address correctly.
.PP
You implement subnetting on a host running an
NP package via the netmask parameter of the command
.BR ifconfig .
For details on this command, see its entry in the Lexicon at the back of
this manual.
.PP
The netmask parameter uses a bit mask to specify
which bits of the Internet address are used to identify the subnet.
The mask includes the network address and the subnet address.
You can specify the mask in the following ways:
.IP \(bu 0.3i
As an Internet address in dot notation.
.IP \(bu
As a single hexadecimal number.
.IP \(bu
By using a pseudo-network name.
This name must be included in your copy of
.B /etc/networks
along with the Internet address that specifies the mask.
.PP
For example, if you have a class-B network, and you
want to use four bits of the Internet address for the subnet
address, the mask would be set as follows, using dot notation:
.DM
	ifconfig netmask 255.255.240.0
.DE
.PP
The four subnet bits are contiguous with the network address.
This is not a requirement, but it is recommended.
.PP
The corresponding hexadecimal number is
.DM
	0xFFFFF000
.DE
.PP
If you have the following entry in
.BR /etc/networks ,
you can use subnets as an argument with netmask to specify the four
bits used for the subnet address:
.DM
	255.255.240.0
.DE
.SH "Where To Go From Here
.PP
The next chapter in this manual introduces the commands that you can use
to interrogate other hosts on your network.

.II "yacc^tutorial"
.ds TL "yacc, Yet Another Compiler-Compiler"
.NH "Introduction to yacc" 1
.PP
The first high-level programming language compiler took a very long time to
write.
Since then, much has been learned about how to design languages and how
to translate programs written in high-level languages into
machine instructions.
With what is known today, the writing of a compiler
takes a fraction of the time it used to require.
.PP
Much of this improvement is due to the use of more powerful software
development methods.
In addition, we know about the mathematical properties of computer
programming languages.
Software tools that apply this mathematical knowledge have played a large part
in this improvement.
.PP
The \*(CO system provides two tools to simplify the generation of
compilers.
These tools are the lexical analyzer generator \fBlex\fR and the parser
generator \fByacc\fR.
The following introduces \fByacc\fR, and gives a basic course in its use.
.PP
Although initially intended for the development of
compilers, \fBlex\fR and \fByacc\fR have proven their utility in other,
simpler, tasks.
Examples of very simple languages are included in this tutorial.
.PP
\fByacc\fR accepts a free-form description of a programming language and
its associated parsing, and generates a C program that, when
compiled, will parse a program written in the described language.
It uses a left-to-right, bottom-up technique,
to detect errors in the input as soon as theoretically possible.
\fByacc\fR generates parsers that handle certain grammatical ambiguities
properly.
.PP
This manual presumes that you are familiar with computer-language parsing and
formal methods of description of languages.
Because \fByacc\fR generates its programs in C and uses many of C's syntactic
conventions, you should have a working knowledge of C.
Related documents include \fIUsing the COHERENT System\fR and 
\fIIntroduction to lex\fR.
.SH "Examples"
.PP
The following presents a few small examples that you can
experiment with to get a feel of how to use \fByacc\fR.
Feel free to experiment with the examples to investigate new ideas.
.Sh "Phrases and Parentheses"
.PP
The first example describes a language we call \fBslang\fR,
or \fIsimple language\fR.
.B slang
consists of sentences.
A sentence, in turn, consists
of strings of letters or groups of letters enclosed in
parentheses, terminated by a period.
A group of letters can also include other groups of letters.
.PP
The simplest ``sentence'' in
.B slang
is:
.DM
	a.
.DE
The following demonstrates a sentence that consists only of
a group:
.DM
	(ab).
.DE
As described above,
a group can have another group inside it:
.DM
	ab(cd(ef)).
.DE
.PP
The following gives the
.B yacc
grammar for
.BR slang .
Type it into the file
.B slang.y.
Note that the lexical-analyzer routine \fByylex\fR is included in the
\fByacc\fR input file.
Note also that, as in C, comments are strings placed between the characters
\fB/*\fR and \fB*/\fR.
.DM
	/* Tokens (terminals) are all caps */
	%token LPAREN RPAREN OTHER PERIOD
	%%
	run	:	sent     /* Input can be a single */
		|	run sent /* sentence or several */
		;
.DE
.DM
	sent	:	phrase PERIOD
				{printf ("sentence\en");}
		;
.DE
.DM
	group	:	LPAREN phrase RPAREN
				{printf ("group\en");}
		;
.DE
.DM
	phrase	:		/* empty */
		|	others
		|	group
		|	others group
		;
.DE
.DM
	others	:	OTHER	/* letters and other chars */
		|	others OTHER
		;
	%%
.DE
.DM
	#include <stdio.h>
	#include <ctype.h>
	/* Called by the parser to get a token  */
	yylex ()
	{
	    int c;
	    c = 0;
.DE
.DM
	    while (c == 0) {
		c = getchar();
		if (c == '.') return (PERIOD);
		else if (c == '(') return (LPAREN);
		else if (c == ')') return (RPAREN);
		else if (c == EOF) return (EOF);
		else if (! isalpha(c)) c = 0; 
	    }
	    return (OTHER);
	}
.DE
.PP
To generate and compile the parser described by this input, issue the commands
.DM
	yacc slang.y
	cc y.tab.c -ly -o slang
.DE
.PP
Now, invoke your new parser by typing
.DM
	slang
.DE
and test it by typing the following input:
.DM
	a
.DE
does not reply, since this is not a sentence.
When you type:
.DM
	a.
.DE
.B slang
replies:
.DM
	sentence
.DE
And if you type:
.DM

	abc(def).
.DE
.B slang
replies:
.DM
	group
.DE
As you can see,
.B slang
recognizes groups and sentences within the input you typed,
and reactes by printing an appropriate message.
Try typing
.DM
	aaa(bbb(ccc)).
	(a).
.DE
and see what you get.
To exit from
.BR slang ,
type
.BR <ctrl-C> .
.Sh "Simple Expression Processing"
.PP
The next example creates a small language that includes two
types of statements.
The first type of statement
resembles a procedure call, and the second is an expression.
Procedure names are in upper-case letters,
whereas the variables in expressions are in lower-case letters.
Both procedures and expressions are terminated by a semicolon.
.PP
The following code generates a parser
that identifies either the procedure being called
or the arithmetic expression being calculated.
The lexical input routine is independently generated by \fBlex\fR.
.PP
Enter the following program into the file \fBcalc.y\fR:
.DM
	%token VARIABLE PROCEDURE
	%%
	prog	:	stmnt
		|	prog stmnt
		;
.DE
.DM
	stmnt	:	stat
		|	stat '\en'
		|	error '\en'
		;
.DE
.DM
	stat	:	PROCEDURE ';'
			    {printf ("PROCEDURE is %c\en", $1);}
		|	expr ';'
			    {printf ("Expression\en");}
		;
.DE
.DM
	expr	:	expr '-' expr
			    {printf
			    ("Subtract %c from %c giving E\en",
			    $3, $1);
			    $$ = 'E';
			    }
		|	VARIABLE
			    {$$ = $1;}
		;
.DE
.PP
Enter the lexical-analyzer part of the program into the file \fBcalc.lex\fR:
.DM
	%{
	#include "y.tab.h"
	%}
	%%
	[A-Z]		{
			yylval = yytext [0];
			return PROCEDURE;
			}
.DE
.DM
	[a-z]		{
			yylval = yytext [0];
			return VARIABLE;
			}
	\en		return ('\en');
	.		return (yytext [0]);
.DE
.PP
Now, generate the programs and compile them by typing:
.DM
	yacc calc.y
	lex calc.lex
	cc y.tab.c lex.yy.c -ly -ll -o calc
.DE
The following messages will appear on your console:
.DM
	1 S/R conflict
	y.tab.c:
	lex.yy.c:
.DE
For now, you can freely ignore the S/R conflict (Shift/Reduce) message from
.BR yacc .
We shall deal with the shift and reduce notions later on.
To invoke the newly generated program, type:
.DM
	calc
.DE
To test it, type the following:
.DM
	A;B;
	C;
	a-b-c;
	a-b-c-d-e;
.DE
.B calc
will reply appropriately to each line of input.
To exit, type
.BR <ctrl-C> .
.SH "Background"
.PP
Now that you have tried
.B yacc,
the following gives some background to it, and how the
parsers that it generates operate.
.Sh "LR Parsing"
.PP
.II "yacc^LR parsing"
.II "yacc^left-to-right parsing"
.II "yacc^LALR"
\fByacc\fR generates a ``bottom up'' parser.
More specifically, \fByacc\fR generates parsers that read LALR(1) languages.
.PP
LR parsers scan the input in a left-to-right fashion.
Unfortunately, LR parsers for interesting languages are unpractically large.
LALR(k) parsers, which are derived from LR parsers,
use a ``look ahead'' technique, in which the next \fBk\fR elements
of the input stream are used to help determine reductions.
LALR(1) parsers are small enough to be practical, are easy to generate, and
are fast.
.Sh "Input Specification"
.PP
.II "yacc^BNF"
.II "yacc^Backus-Naur Form"
.II "Backus-Naur Form"
.II BNF
To generate a language with \fByacc\fR,
you must specify its grammar in Backus-Naur Form (BNF).
(For a good introduction to BNF, see the section on parsing in
\fIApplied C\fR.)
The languages recognized by \fByacc\fR-generated parsers are rich and compare
favorably with modern programming languages.
The time required to generate the parser from the input grammar is very
small \(em less than the time required to compile the generated parsers.
.PP
In addition to generating the parser to recognize the input language,
\fByacc\fR lets you include compiler actions within the
grammar rules that are executed as the constructs are recognized.
This greatly simplifies the entire task of writing your compiler.
When used in combination with \fBlex\fR, \fByacc\fR can make the process of
writing a recognizer for a simple language the task of an afternoon.
.Sh "Parser Operation"
.PP
.II "yacc^yyparse"
.II "yacc^library"
.II "yacc^library, yacc"
\fByacc\fR generates a compilable C program that consists of a routine named
\fByyparse\fR, and the information about the grammar encoded into tables.
Routines in the \fByacc\fR library are also used.
.PP
.II "yacc^push-down list"
.II "yacc^stack"
The basic data structure used by the parser is a \fIstack\fR, or \fIpush
down list\fR.
At any time during the parse, the stack contains
information describing the state of the parse.
The state of the parse is related to parts of grammar rules already recognized
in the input to the parser.
.PP
.II "yacc^parse actions"
At each step of the parse, the parser can take one of four actions.
.PP
.II "yacc^shift"
.II "yacc^action, shift"
The first action is to \fIshift\fR.
Information about the input symbol or
nonterminal is pushed onto the stack, along with the state of the parser.
.PP
.II "yacc^reduce"
.II "yacc^action, reduce"
The second type of action is to \fIreduce\fR.
This occurs when a grammar rule
is completely recognized.
Items describing the component parts of the rule are removed from the stack,
and the new state is pushed onto the stack.
Thus, the stack is \fIreduced\fR, and the symbols corresponding to the grammar
rule are \fIreduced\fR to the left part of the rule.
.PP
.II "yacc^error action"
.II "yacc^action, error"
Third, the parser can execute an \fIerror\fR action.
If the current input symbol is incorrect for the state of the stack, it is not
proper for the parser either to shift or reduce.
As a minimum, this state will result in an error message being issued, usually
.DM
	Syntax error
.DE
\fByacc\fR provides capabilities for using this error state to recover
gracefully from errors in the input.
.PP
.II "yacc^accept action"
.II "yacc^action, accept"
.II "yacc^start symbol"
Finally, the parser can \fIaccept\fR the input.
This means that the \fIstart\fR symbol, such as \fIprogram\fR, has been
properly recognized and that the entire input has been accepted.
.PP
Later sections discuss how you can have the parser describe its parsing
actions step-by-step.
.SH "Form of yacc Programs"
.PP
.II "yacc^%%"
.II "yacc^definition section"
.II "yacc^section, definition"
.II "yacc^rules section"
.II "yacc^section, rules"
A
.B yacc
program can have up to three sections.
Each section is marked by the symbol
\fB%%\fR. 
The first section contains declarations.
The second section contains the rules of the grammar.
User-written routines that are to be part of the generated program can be
included in the third section.
The outline of \fByacc\fR specifications is as follows:
.DM
	definitions
	%%
	rules
	%%
	user code
.DE
If there are no definitions or user code, the input can be abbreviated to
.DM
	%%
	rules
.DE
.Sh "Definitions"
.PP
.II "yacc^definitions section"
The first section in a \fByacc\fR specification is the definitions section.
This section includes information about the elements used in the \fByacc\fR
specification.
Additional items are user-defined C statements, such as \fBinclude\fR
statements, that are referenced by other statements in the generated program.
.PP
.II "yacc^token definition"
Each token, such as
.B VARIABLE
in example program
.BR calc ,
must be predefined in a \fB%token\fR statement in the definitions section:
.DM
	%token VARIABLE
.DE
.II "yacc^terminals"
.II "yacc^nonterminals"
Tokens are also called \fBterminals\fR.
Only nonterminals appear as the left
part of a rule, and terminals can appear only on the right side of a rule.
This helps \fByacc\fR distinguish terminals from nonterminals.
Other types of statements that assist in ambiguity resolution appear here,
and will be discussed in later sections.
.PP
.II "yacc^start symbol"
Each grammar that \fByacc\fR generates a parser for must have a \fIstart\fR
symbol.
Once the start symbol has been recognized by the parser, its input is
recognized and accepted.
For a programming-language grammar, this nonterminal represents the entire
program.
.PP
The start
symbol should be declared in the definitions section as:
.DM
	%start program
.DE
If no
.B %start
symbol is declared, it is taken to be the left side of the first
rule in the rules section.
.Sh "Rules"
.PP
Your language's grammar rules must be entered in a variant of BNF.
The two following rules illustrate how to define an expression:
.DM
	exp	:	VARIABLE;
	exp	:	exp '-' exp;
.DE
.II "yacc^{ }"
Action statements that are enclosed in braces
\fB{ }\fR specify the semantics of
the language, and are embedded within the rules.
More information about how rules are built is given below.
.Sh "User Code"
.PP
.II "yacc^action statements"
.II "yacc^user code"
Action statements may require other routines, such as common code-generating
routines, or symbol table building routines.
Such user code can be included in the generated parser after the rules section
and a \fB%%\fR delimiter.
.PP
The following sections discuss definitions and rules in detail.
.SH "Rules"
.PP
.II "yacc^rule, sections"
.I Rules
describe how programming-language constructs are put together.
Any given language can be described by many configurations of rules.
This frees you to write the rules for clarity and readability.
.PP
.II "yacc^production"
.II "yacc^reduction"
A rule consists of a left part and a right part.
The left part is said to \fIproduce\fR the right part;
or, the right part is said to \fIreduce to\fR the left part.
A rule can also include the action the parser is to perform
once it (the rule) is reduced.
.Sh "General Form of Rules"
.PP
.II "yacc^rule format"
.II "yacc^comments, in rules"
Blanks and tabs are ignored within rules (except in the action parts).
Comments can be enclosed between \fB/*\fR and \fB*/\fR.
The left part of the rule is followed by a colon.
Then come the elements of the right part, followed by a semicolon.
.PP
Rules that have the same left part can be grouped together with the left part
omitted and a vertical bar signifying ``or''.
For example, the grammar
.DM
	exp	:	VARIABLE;
	exp	:	exp '-' exp;
.DE
can be written as:
.DM
	exp	:	VARIABLE
		|	exp '-' exp;
.DE
Note that these are equivalent to the BNF:
.DM
	<exp>	::=	VARIABLE
	<exp>	::=	<exp> - <exp>
.DE
.PP
A rule can also contain C statements that are the
compiler actions themselves.
These actions are enclosed in braces \fB{\fR and \fB}\fR and are executed by
the generated parser when the grammar rule has been recognized.
More will be said about actions in the following section.
.Sh "Suggested Style"
.PP
.II "yacc^rule, format"
.II "yacc^rule, style"
.B yacc
permits you to write rules in completely free form.
For example, the grammar for the above rule can be written:
.DM
	exp:VARIABLE|exp'-'exp;
.DE
However, this form is much less readable.
.PP
Two styles of
.B yacc
grammar are in common use.
The first of these is used throughout this manual.
.PP
First, start the left part at the beginning of the line;
follow it with a tab; then a colon.
The right part should be on the same line, also preceded by a tab.
.PP
Second, group all rules with the same left part together, and use the vertical
bar aligned under the colon for all but the first rule in the group.
.PP
.II "yacc^actions"
Third, place action items on a separate line following the associated rule,
preceded by three tabs.
.PP
Finally, precede the terminating semicolon with a single tab,
to align it with the colon and vertical bar.
.PP
The outline of this style is:
.DM
	left	:	right1 right2
				{action1}
		|	right3 right4
				{action2}
		;
.DE
.PP
This style is compact and works well for languages whose rules and actions
together are simple.
.PP
For somewhat more extensive languages, or for additional flexibility in adding
statements to the action part, use the following modification of the style.
.DM
	left	:	right1 right2 {
				action1
				}
		|	right3 right4 {
				action2
				}
		;
.DE
.PP
For specifications that have larger rules or more complex actions, another
style is recommended.
.PP
As in the first style, group rules with the same left part,
and use the vertical bar.
Place the left part, with its terminating colon, on a line by itself.
Then indent
the right parts of the rule one or more tabs as necessary to
make the rule and actions readable.
Finally,
the vertical bar and the
semicolon should be at the beginning of the line.
.PP
The outline for this style is as follows:
.DM
	left:
		right1 right2 {
			action1
			}
	|	right3 right4 {
			action2
			}
	;
.DE
.PP
Since the input to \fByacc\fR can be entirely free form, there is no
restriction on how to write your rules.
However, if you use a
consistent style throughout, it will make your job easier.
.SH "Actions"
.PP
.II "yacc^rule, actions"
In addition to generating a parser to recognize a specific language, \fByacc\fR
also lets you include parsing action statements.
With this feature, you can include C-language action statements that will be
performed when specified constructs are recognized.
.Sh "Basic Action Statements"
.PP
The example language
.B slang,
described above, the action statements simply
print information on the terminal as productions are recognized:
.DM
	sent	:	phrase PERIOD
				{printf ("sentence\en");}
		;
	group	:	LPAREN phrase RPAREN
				{printf ("group\en");}
		;
.DE
Even if your actions will be more complex, using \fBprintf\fR statements in
this way can help verify your grammar early in the development process.
.Sh "Action Values"
.PP
.II "yacc^rule, values"
If the specification is for the grammar of a programming language, the actions
will normally interface to routines that access symbol tables or
generate code.
.PP
\fByacc\fR lets rules assume a \fIvalue\fR to help
keep track of intermediate results within rules.
These values can contain symbol-table information, code-generation
information, or other semantic information.
.PP
To set a value for a rule, simply use a statement of the form
.DM
	$$ = <value>;
.DE
within an action statement.
The symbol \fB$$\fR is the value of the production.
This value can be used by other rules that use this rule as a non-terminal
part.
.PP
The example program
.B calc,
given above, illustrates the use of the value of productions:
.DM
	expr	:	expr '-' expr {
			    printf
				("Subtract %c from %c giving E\en",
				$3, $1);
			    $$ = 'E';
			    }
		|	VARIABLE
				{$$ = $1;}
		;
.DE
The first rule's action statement sets the value of the production \fBexpr\fR
to \fB'E'\fR: 
.DM
	$$ = 'E';
.DE
.PP
The \fIvalue\fR of a rule is significant in that it can be used in
productions including that rule as a nonterminal part.
.PP
An example is given in the first rule above.
The \fBprintf\fR statement refers to the items \fB$1\fR and \fB$3\fR.
\fByacc\fR interprets these symbols to mean the value of elements one
and three of the right side, respectively;
that is to say, \fB$1\fR refers to the value of the first \fBexpr\fR in the
right side of the first rule, and \fB$3\fR refers to the second \fBexpr\fR,
as illustrated below:
.DM
	expr	:	expr '-' expr
			$1   $2   $3
.DE
.B calc
does not reference \fB$2\fR.
.PP
.II "yacc^token, value"
The value for the tokens is provided by the lexical analyzer.
The second rule for \fBexpr\fR uses this to get the value of the token
\fBVARIABLE\fR.
The value represented by \fB$1\fR is provided by the lexical
analyzer in the statement
.DM
	yylval = yytext [0];
.DE
.PP
To give another example, here is a simple calculator language, called
.B digit,
which performs arithmetic on one-digit numbers and prints the results.
Type the following grammar into the file \fBdigit.y\fR:
.DM
	%token DIGIT
	%%
	session :	calcn
		|	session calcn
		;
.DE
.DM
	calcn	:	expr '\en' /* print results */
				{printf ("%d\en", $1);}
		;
.DE
.DM
	expr	:	term '+' term
				{$$ = $1 + $3;}
		|	term '-' term
				{$$ = $1 - $3;}
		;
.DE
.DM
	term	:	DIGIT
				{$$ = $1;}
		;
.DE
.DM
	%%
	#include <stdio.h>
	yylex ()
	{
	    int c;
	    c = 0;
.DE
.DM
	    while (c == 0) { /* ignore control chars and space */
		c = getchar();
		if (c <= 0) return (c); /* could be EOF */
		if (c == '\en') return (c); /* set c to ignore */
.DE
.DM
		if ((c <= '9') && (c >= '0')) {
		    yylval = c - '0';
		    return (DIGIT);
		}
		if (c <= ' ') c = 0;
	    }
	    return (c);
	}
.DE
This creates the \fByacc\fR specification file.
To turn it into a program, type
.DM
	yacc digit.y
	cc y.tab.c -ly -o digit
.DE
To invoke the compiled progra, type:
.DM
	digit
.DE
And to test it, type the following:
.DM
	1+2
	2+2
	8+9
.DE
\fBdigit\fR will reply, respectively:
.DM
	3
	4
	17
.DE
.PP
To exit from
.BR digit ,
type
.BR <ctrl-C> .
.PP
.B digit
is essentially an interpreter \(em
results are calculated as numbers are typed in.
When you type in
.DM
	1+1
.DE
the parser recognizes the construct
.DM
	term '+' term
.DE
and executes the statement that adds two numbers together.
The two numbers each in turn came from the construct
.DM
	term	:	DIGIT
.DE
and the value of the digit came from \fByylex\fR.
When the statement
\fBcalcn\fR is recognized, the value is printed as the result.
Thus, the calculations are performed at the time that the constructs are
recognized.
If a compiler were being generated, the actions would likely build some form of
intermediate code, or expression tree, as in:
.DM
	expr	:	term '+' term
				{$$=tree (plus, $1, $3);}
.DE
.Sh "Structured Values"
.PP
All the examples thus far have shown action values as simple \fBint\fR types.
This is not sufficient for a large interpreter or compiler, because
at different
points in the language a value can represent a constant values, a pointer to
code generation trees, or symbol table information.
.PP
To solve this problem, \fByacc\fR allows you to
define the values of \fB$$\fR and \fB$n\fR as a \fIunion\fR of several types.
This is done in the definitions section with the \fBunion\fR statement.
For example, to declare action values as
an integer, tree pointer, or a symbol-table pointer, you would use
the following code:
.DM
	%union {
	    int cval;
	    struct tree_t tree;
	    struct sytp_t sytp;
	}
.DE
This says that action values can be a constant value \fBcval\fR, a code tree
pointer \fBtree\fR, or a symbol-table pointer \fBsytp\fR.
.PP
.II "yacc^token, definition"
.II "yacc^%token"
To ensure
that the correct types are used in assignments and calculations in actions
in the generated C program, each token whose value will be used is declared
with the appropriate type:
.DM
	%token <tree> A B
	%token <cval> CONST
.DE
.II "yacc^rule, type"
.II "yacc^%token"
In addition,
the rules themselves can have a type declaration, as they
also can pass action values.
Their type is declared in the \fB%type\fR statement:
.DM
	%type <sytp> variable
.DE
.II "yacc^type, of nonterminal"
This declares the nonterminal \fBvariable\fR to reference the \fBsytp\fR
field of the value union.
.PP
.II "yacc^value, qualification"
The values referenced in the action statements do not need to be qualified
(unless they are referencing a field of one of the union elements).
\fByacc\fR generates the necessary qualification for the references,
based upon
the type information provided in the \fB%type\fR and \fB%token\fR statements.
.PP
.II "yacc^default, action"
Keep in mind that productions that do not have explicit actions will default
to an action of
.DM
	$$ = $1
.DE
which might cause a type clash when compiling the generated parser.
This is more likely to arise during debugging,
when you have defined the types but have not put in the actions.
.SH "Handling Ambiguities"
.PP
.II "yacc^ambiguity"
The ideal grammar for a language is readable and unambiguous.
If the grammar is readable, its users will find it easy to use.
If the language is unambiguous, the parser generator will parse the programs
correctly.
However, many common programming language constructs are ambiguous.
Consider the following definition of an \fBif\fR statement:
.DM
	statement	:	if_statement
			|	others
	if_statement	:	IF cond THEN statement
			|	IF cond THEN statement ELSE statement
.DE
.PP
Consider a program that contains a statement
.DM
	if a > b then if c < d then a = d else b = c;
.DE
The parser does not know by the grammar specification which
\fBif_statement\fR the \fBelse\fR belongs with.
At the point of the \fBelse\fR, the parser could correctly recognize it as
part of the first \fBif\fR or the second \fBif\fR.
The indentations illustrate
the interpretation of the ambiguity associating the \fBelse\fR with the first
\fBif\fR. 
.DM
	if a > b then
	    if c < d then
		a = d;
	else
	    b = c;
.DE
Associating it with the second \fBif\fR: 
.DM
	if a > b then
		if c < d then
			a = d;
		else
			b = c;
.DE
.PP
One solution to this ambiguity is to modify the language and rewrite the
grammar.
Some programming languages (including the \*(CO shell) have a closing
element to the \fBif\fR statement, such as \fBfi\fR.
The grammar for this approach is:
.DM
	statement	:	if_statement
			|	others
	if_statement	:	IF cond THEN statement FI
			|	IF cond THEN statement ELSE statement FI
.DE
Another ambiguity arises from a grammar for common binary arithmetic
expressions.
The following sample specifies binary subtraction:
.DM
	exp	:	TERM
		|	exp '-' exp
		;
.DE
For the program fragment
.DM
	a - b - c
.DE
the parser can correctly interpret the expression as
.DM
	(a - b) - c
.DE
or as
.DM
	a - (b - c)
.DE
While for the \fBif\fR example, the language can be
reasonably modified to remove the ambiguity,
it is unreasonable in the case of expressions.
The grammar can be rewritten for \fBexp\fR but it is less convenient.
.Sh "How yacc Reacts"
.PP
.II "yacc^ambiguity, default handling"
Because some ambiguities, such as the ones detailed above, are common,
\fByacc\fR automatically handles some of them.
.PP
.II "yacc^shift-reduce conflicts"
.II "yacc^shift"
.II "yacc^reduce"
The ambiguity exemplified by the \fBif then else\fR grammar is
called a \fIshift-reduce\fR conflict.
The parser generator can either choose to shift, meaning to add more elements
to the parse stack, or to reduce, meaning to generate the smaller production.
In the terms of \fBif\fR, the shift would match the \fBelse\fR with the first
\fBthen\fR.
Alternatively, the reduce choice will match the \fBelse\fR with
the latest (rightmost) unmatched \fBthen\fR.
.PP
.II "yacc^shift-reduce conflicts"
Unless otherwise specified, \fByacc\fR resolves shift-reduce conflicts in
favor of the shift.
This means that the \fBif\fR ambiguity will be resolved in favor of matching
the \fBelse\fR with the rightmost unmatched \fBthen\fR.
Likewise, the expression
.DM
	a - b - c
.DE
will be interpreted as
.DM
	a - (b - c)
.DE
.Sh "Additional Control"
.PP
.II "yacc^ambiguity, resolution"
.II "yacc^associativity"
\fByacc\fR provides tools to help resolve some of these ambiguities.
When \fByacc\fR detects shift-reduce conflicts,
it consults the precedence and
associativity of the rule and the input symbol to make a decision.
.PP
.II "yacc^definition section"
For the case of binary operators, you can define the associativity of each
of the operators by use of the defining words \fB%left\fR and \fB%right\fR.
These appear in the definition section with \fB%token\fR.
.PP
The usual interpretation of
.DM
	a - b - c
.DE
is
.DM
	(a - b) - c
.DE
.II "yacc^associative, left"
which is called \fIleft\fR associative.
However, the shift/reduce conflict inherent in
.DM
	exp '-' exp
.DE
.II "yacc^associative, right"
is resolved in favor of the reduce, or in a right-associative manner:
.DM
	a - (b - c)
.DE
.PP
.II "yacc^%left"
.II "yacc^%token"
To signal \fByacc\fR that you want the left-associative interpretation,
enter the grammer as:
.DM
	%left '+' '-'
	%token TERM
	%%
	expr	:	TERM
		|	expr '-' expr
		|	expr '+' expr
		;
.DE
Some operators, such as assignment, require right associativity.
The statement
.DM
	a := b + c
.DE
is to be interpreted as
.DM
	a := (b + c)
.DE
.II "yacc^%right"
The \fB%right\fR keyword tells \fByacc\fR that the following terminal is to
right associate.
.Sh "Precedence"
.PP
.II "yacc^precedence"
Most arithmetic operators are left associative.
For example, with the grammar
.DM
	%right =
	%left '-' '+' '*' '/'
	%%
	expr	:	expr '-' expr
		|	expr '*' expr
		|	expr '+' expr
		|	expr '/' expr
		|	expr '=' expr
		;
.DE
The expression
.DM
	a = b + c * d - e
.DE
based on associativity alone will be evaluated
.DM
	a = (((b + c) * d) - e)
.DE
which is not according to custom.
We normally think of \fB*\fR as having higher precedence
than \fB+\fR or \fB-\fR, meaning that it is evaluated before other operators
with the same associativity.
The evaluation preferred is
.DM
	a = (b + (c * d) - e)
.DE
.PP
.II "yacc^%left"
.II "yacc^precedence"
To generate a parser with this evaluation, use several lines of \fB%left\fR,
one line for each level of precedence.
Each line containing \fB%left\fR describes tokens of the same precedence.
The precedence increases with each line.
Thus, to get the common notion of arithmetic precedence, use a grammar of
.DM
	%right =
	%left '-' '+'
	%left '*' '/'
	%%
	expr	:	expr '-' expr
		|	expr '*' expr
		|	expr '+' expr
		|	expr '/' expr
		|	expr '=' expr
		;
.DE
.PP
.II "yacc^%left"
.II "yacc^%right"
This method of \fB%left\fR and \fB%right\fR gives tokens a precedence
and an associativity.
This can eliminate ambiguities where these operators are involved.
But what about the precedence of rules or nonterminals?
.PP
.II "yacc^%prec"
.II "yacc^rules, precedence"
.II "yacc^precedence"
To specify the precedence of rules, the \fB%prec\fR keyword at the end of the
rule sets the precedence of the rule to the token following the keyword.
To add unary minus to the grammar above, and to give it the precedence of
multiply, use \fB%prec *\fR at the end of the unary rule.
.DM
	%right =
	%left '-' '+' '*' '/'
	%%
	expr	:	expr '-' expr
		|	expr '*' expr
		|	expr '+' expr
		|	expr '/' expr
		|	expr '=' expr
		|	'-' expr %prec *
		;
.DE
.II "yacc^%nonassoc"
.II "yacc^nonassociative"
.II "yacc^%left"
.II "yacc^right"
If associativity is not specified, \fByacc\fR will report the number of
shift/reduce conflicts.
When associativity is specified with \fB%left\fR, \fB%right\fR or
\fB%nonassoc\fR, this is considered to reduce the number of conflicts,
and thus the number of conflicts reported will not include the count of these.
.SH "Error Handling"
.PP
.II "yacc^error, recovery"
Parsers generated by \fByacc\fR are designed to parse correct programs.
If an input program contains errors, the LALR(1) parser will detect the error
as soon as is theoretically possible.
The error is identified, and the programmer can correct the error and
recompile.
.PP
However, in most programming environments, it is unacceptable to stop
compiling after the detection of a single error.
\fByacc\fR parsers attempt to go on so that the programmer may find as many
errors as possible.
.PP
.II "yacc^error, token"
.II "yacc^token, error"
When an error is detected, the parser looks for a special token in the input
grammar named \fBerror\fR.
If none is found, the parser simply exits after issuing the message
.DM
	Syntax error
.DE
If the special token \fBerror\fR is present in the input grammar error
recovery is modified.
Upon detection of an error, the parser removes items from the stack until
\fBerror\fR is a legal input token and processes any action associated with
this rule.
\fBerror\fR is the lookahead token at this point.
.PP
.II "yacc^error, recovery"
Processing is resumed with the token causing the error as the lookahead token.
However, the parser attempts to resynchronize by reading and processing three
more tokens before resuming normal processing.
If any of these three are in error, they are deleted and no error message is
given.
Three tokens must be read without error before the parser leaves the error
state.
.PP
.II "yacc^error, token"
.II "yacc^token, error"
A good place to put the \fBerror\fR token is at a statement level.
For example, the \fBcalc.y\fR example in chapter 2 defines a statement as
.DM
	stmnt	:	stat
		|	stat '\en'
		|	error '\en'
		;
.DE
Thus, any error on a line will cause the rest of the line to be ignored.
.PP
.II "yacc^yyerrok"
There is still a chance for trouble, however.
If the next line contains an error in the first two tokens, they will be
deleted with no error message and parsing will resume somewhere in the middle
of the line.
To give a truly fresh start at the beginning of the line,
the function \fByyerrok\fR will cause the parser to resume normal
processing immediately.
Thus, an improved grammar is
.DM
	stmnt	:	stat
		|	stat '\en'
		|	error '\en'
				{yyerrok;}
		;
.DE
will cause normal processing to begin with the start of the next line.
.PP
Error recovery is a complex issue.
This section covers only what the parser can do in recovering from syntax
errors.
Semantic error recovery, such as retracting emitted code, or correcting symbol
table entries, is even more complex, and is not discussed here.
.PP
\fByacc\fR reserves a special token \fBerror\fR to aid in resynchronizing the
parse.
After an error is detected, the stack is readjusted, and processing cautiously
resumes while three error-free tokens are processed.
\fByyerrok\fR will cause normal processing to resume immediately.
The token causing the error is retained as the lookahead token unless
\fBYYCLEARIN\fR is executed.
.SH "Summary"
.PP
\fByacc\fR is an efficient and easy-to-use program to help automate the input
phase of programs that benefit by strict checking of complex input.
Such programs include compilers and interactive command language processors.
.PP
\fByacc\fR generates an LALR(1) parser, that implements
the grammar specifying the structure of the input.
A simple lexical analyser routine can be hand-constructed to fit in among
the rules, or you can use the \*(CO command \fBlex\fR to generate a lexical
analyzer that will fit with the parser.
.PP
As the structured input is analyzed and verified, you assign meaning to the
input by writing semantic \fBactions\fR as part of the grammatical rules
describing the structure of the input.
.PP
\fByacc\fR parsers are capable of handling certain \fIambiguities\fR, such
as that inherent in typical \fBif then else\fR constructs.
This simplifies the construction of many common grammars.
.PP
\fByacc\fR provides a few simple tools to aid in error recovery.
However, the area of error recovery is complex and must be approached with
caution.
.Sh "Helpful Hints"
.PP
Until you have mastered \fByacc\fR, the best way to build your program is to 
do it a piece at a time.
For example, if you are writing a Pascal compiler,
you might start with the grammar
.DM
	%token PROG BEG END OTHER
	program :	PROG tokens BEG END '.'
		;
	tokens	:	OTHER
		|	tokens OTHER
		;
.DE
and with a simple lexical analyzer of:
.DM
	PROGRAM		return (PROG);
	BEGIN		return (BEG);
	END		return (END);
	.		return (yytext [0]);
.DE
With the generated program, you can easily test the grammar by feeding it
simple programs.
Then add items to both the lexical analyzer and \fByacc\fR grammar.
With this approach, you can see the parser working, and if it behaves
differently than you expect, you can more easily pinpoint the cause.
.PP
If you have difficulty understanding what actions your parser is taking,
\fByacc\fR will produce for you a complete description of the generated parser.
To use this, you should be familiar with the way LALR(1) parsers work.
To get this verbose output, specify the \fB-v\fR option on the command line.
The result will appear in the file \fBy.output\fR.
.PP
In addition, you can have the parser give you a token-by-token description
of its actions while it does them, by specifying the debug option \fB-d\fR.
This also generates the file \fBy.output\fR, which is helpful in reading
the debug output.
The debug code is generated when the \fB-d\fR option is used,
but is not activated unless the \fBYYDEBUG\fR identifier is defined.
Include some code in the definitions section to activate it:
.DM
	%{
	    define YYDEBUG
	%}
.DE
Your parser can turn on and off the debugging at execution time by setting the
variable \fBYYDEBUG\fR:
one for on, zero for off.
.PP
A frequent cause of grammar conflicts is the empty statement.
You should use it with caution.
.B yacc
generates
empty statements when you specify actions
in the middle of a rule rather than at the end; for example:
.DM
	def	:	DEFINE {defstart();}
				identifier {defid ($2);}
		;
.DE
\fByacc\fR generates an additional rule:
.DM
	$def	:	/* empty */
				{defstart();}
		;
	def	:	DEFINE $def identifier {defid ($2);}
		;
.DE
The resulting empty statement can cause parser conflicts if there are similar
rules and the empty statement is not sufficient to distinguish between them.
.\".SH "Example"
.\".PP
.\"This tutorial closes with a larger example that incorporates most of the
.\"features of \fByacc\fR discussed here.
.\"You can type it as shown, and modify it to improve its operation.
.\".PP
.\"This example, called
.\".BR nav ,
.\"calculates the great circle
.\"path and bearing from one point on the globe to another.
.\"Each pair of points is input on one line.
.\"The coordinates of the origin and destination are preceeded, respectively,
.\"by the keywords
.\"\fBFROM\fR and \fBTO\fR, and can appear in either order.
.\"Longitude and latitude are followed, respectively,
.\"by the letters \fBE\fR or \fBW\fR, and \fBN\fR and \fBS\fR.
.\"Lower-case may also be used for these letters.
.\".PP
.\"The numeric part of the coordinates may be entered in degrees, minutes, and
.\"optional seconds, or in fractional degrees.
.\"You can use
.\"the symbols \fB^\fR, \fBo\fR, or \fBd\fR to specify degrees
.\"because the raised
.\"circle customarily used for degrees is not available on most terminals.
.\"An apostrophe \fB'\fR follows minutes, and a quotation mark \fB"\fR follows
.\"seconds.
.\".PP
.\"As an example of using \fBnav\fR, calculate the great circle
.\"distance and initial heading from Charlestown, Indiana, to Charlestown,
.\"Australia:
.\".DM
.\"	from 38d27'n 85d40'w to 151d42'e 32d58's;
.\".DE
.\"The result will be:
.\".DM
.\"	From lat 38.450 long 85.667 To lat -32.967 long -151.700
.\"	Distance 8030.623, Init course is 258.417
.\".DE
.\"Here, the coordinates are echoed in decimal degrees.
.\"To exit the program, type
.\".BR <ctrl-C> .
.\".PP
.\"To begin,
.\"type the following \fByacc\fR specification file into the \fBnav.y\fR: 
.\".DM
.\"	%{
.\"	#include "ll.h"
.\"	#define YYTNAMES
.\"		double fromlat, fromlon, tolat, tolon;
.\"		extern calcpath();
.\"	%}
.\".DE
.\".DM
.\"	%union {
.\"		double dgs;
.\"		long dgsi;
.\"		struct ll wh;
.\"		}
.\".DE
.\".DM
.\"	%token NEWLINE FROM TO CIRCLE QUOTE DQUOTE SEP SEMI COMMA
.\"	%token NSYM SSYM WSYM ESYM
.\"	%token <dgs> FNUM
.\"	%token <dgsi> NUM
.\"	%type <dgs> degrees long lat deg
.\"	%type <wh> where from to
.\"	%%
.\".DE
.\".DM
.\"	prob	:	single
.\"		|	prob single
.\"		;
.\".DE
.\".DM
.\"	single	:	sing {
.\"				calcpath();
.\"				}
.\"		|	error NEWLINE {
.\"				yyerrok; YYCLEARIN;
.\"				printf ("Enter line again.\en");
.\"				}
.\"		;
.\".DE
.\".DM
.\"	sing	:	from SEP to SEMI NEWLINE {
.\"				fromlat = $1.lat;
.\"				fromlon = $1.lon;
.\"				tolat = $3.lat;
.\"				tolon = $3.lon;
.\"				}
.\".DE
.\".DM
.\"		|	to SEP from SEMI NEWLINE {
.\"				tolat = $1.lat;
.\"				tolon = $1.lon;
.\"				fromlat = $3.lat;
.\"				fromlon = $3.lon;
.\"				}
.\".DE
.\".DM
.\"		|	to SEMI NEWLINE {
.\"				tolat = $1.lat;
.\"				tolon = $1.lon;
.\"				}
.\"		;
.\".DE
.\".DM
.\"	from	:	FROM SEP where {
.\"				$$ = $3;
.\"				}
.\"		;
.\".DE
.\".DM
.\"	to	:	TO SEP where {
.\"				$$ = $3;
.\"				}
.\"		;
.\".DE
.\".DM
.\"	where	:	lat SEP long {
.\"				$$.lat = $1;
.\"				$$.lon = $3;
.\"				}
.\"		|	long SEP lat {
.\"				$$.lon = $1;
.\"				$$.lat = $3;
.\"				}
.\"		;
.\".DE
.\".DM
.\"	lat	:	degrees NSYM {
.\"				$$ = $1;
.\"				}
.\"		|	degrees SSYM {
.\"				$$ = - $1;
.\"				}
.\"		;
.\".DE
.\".DM
.\"	long	:	degrees WSYM {
.\"				$$ = $1;
.\"				}
.\"		|	degrees ESYM {
.\"				$$ = - $1;
.\"				}
.\"		;
.\".DE
.\".DM
.\"	degrees	:	FNUM	/* e. g. 128.3 */ {
.\"				$$ = $1;
.\"				}
.\"		|	NUM CIRCLE NUM QUOTE /* deg min */ {
.\"				$$=$1 + $3/60.0;
.\"				}
.\"		|	NUM CIRCLE NUM QUOTE NUM DQUOTE
.\"				/* and seconds */ {
.\"				$$=$1 + $3/60.0 + $5/3600.0;
.\"				}
.\"		|	NUM CIRCLE NUM QUOTE FNUM DQUOTE {
.\"				$$=$1 + $3/60.0 + $5/3600.0;
.\"				}
.\"		;
.\"	%%
.\".DE
.\".DM
.\"	#include <stdio.h>
.\"	yyerror (s)
.\".DE
.\".DM
.\"	char *s;
.\"	{
.\"	    struct yytname *p;
.\"	    fprintf (stderr, "%s ", s);
.\".DE
.\".DM
.\"	    for (p = yytnames; p -> tn_name != NULL; ++p)
.\"		if (p->tn_val == yychar) {
.\"		    fprintf (stderr, "at %s", p->tn_name);
.\"		    break;
.\"		}
.\"	    fprintf (stderr, "\en");
.\"	}
.\".DE
.\".PP
.\"Both the lexical analyzer and the parser need the following header file
.\"\fBll.h\fR.
.\"Type the following:
.\".DM
.\"	cat > ll.h
.\"	struct ll {
.\"	    double lat;
.\"	    double lon;
.\"	};
.\"	<ctrl-D>
.\".DE
.\".PP
.\"To turn \fByacc\fR file \fBnav.y\fR into a program, type
.\".DM
.\"	yacc -hdr nav.tab.h -d -v nav.y
.\"	mv y.tab.c nav.y.c
.\".DE
.\".PP
.\"The grammar is straightforward.
.\"The types used in the actions require a
.\".BR union ,
.\"because integer degrees, floating-point
.\"degrees, and pairs of floating point degrees are used as action values.
.\"The lexical analyzer recognizes integer and floating-point numbers,
.\"and passes the value through \fByylval\fR.
.\"The rule for \fBdegrees\fR combines
.\"different degree representations to one double-precision number.
.\".PP
.\"The \fBN\fR, \fBS\fR, \fBE\fR, and \fBW\fR symbols convert a location to a
.\"signed representation:
.\"\fBS\fR and \fBE\fR result in negative degrees,
.\"\fBN\fR and \fBW\fR as positive.
.\".PP
.\"The rule for \fBwhere\fR converts the single-numbered latitude and longitude
.\"into a double number of \fB<wh>\fR type.
.\"Note that it can process the coordinates in either order.
.\".PP
.\"The rule \fBsingle\fR handles the destination and origin in either order.
.\"It takes the pairs of coordinates from \fBfrom\fR and \fBto\fR and stores them
.\"in the global variables that the calculation routine uses.
.\"The error token will halt error recovery at the end of the line,
.\"so that in case of error the user can reenter the correct line.
.\"If many great circles are being computed from the same origin,
.\"you need to enter only the destination after the first time.
.\".PP
.\"Once a set of coordinates has been recognized, the function
.\".B calcpath
.\"calculates the great circle.
.\".PP
.\"The error routine \fByyerror\fR accepts an error message from the parser,
.\"and examines the table of tokens to find the name of the token where the error
.\"is detected.
.\"If it is found, it is printed.
.\"To get these token names in the program, the symbol \fBYYTNAMES\fR
.\"must be defined.
.\".PP
.\"The following code gives the lexical analyzer.
.\"Type it into the file \fBnav.l\fR:
.\".DM
.\"	%{
.\"	#include "ll.h"
.\"	#include "nav.tab.h"
.\"	%}
.\"		int integer;
.\"		double real;
.\"	%%
.\".DE
.\".DM
.\".ta 0.5i 1.5i
.\"	[nN]	return (NSYM);
.\"	[sS]	return (SSYM);
.\"	[eE]	return (ESYM);
.\"	[wW]	return (WSYM);
.\"	o|"^"|d	return (CIRCLE);
.\"	\e"	return (DQUOTE);
.\"	\e'	return (QUOTE);
.\"	\en	return (NEWLINE);
.\"	from	return (FROM);
.\"	FROM	return (FROM);
.\"	to	return (TO);
.\"	TO	return (TO);
.\".DE
.\".DM
.\"	[0-9]+		{
.\"			sscanf (yytext, "%d", &integer);
.\"			yylval.dgsi = (long) integer;
.\"			return (NUM);
.\"			}
.\".DE
.\".DM
.\"	[0-9]+"."([0-9]+)? {
.\"			sscanf (yytext, "%f", &real);
.\"			yylval.dgs = (double) real;
.\"			return (FNUM);
.\"			}
.\"	,		return (COMMA);
.\"	;		return (SEMI);
.\"	[ \et]		return (SEP);
.\"	.		{
.\"			printf ("Illegal character [%s]\en", yytext);
.\"			return (yytext [0]);
.\"			}
.\".DE
.\"The lexical analyzer partitions the input into the
.\"tokens expected by the parser.
.\"For the symbols in the grammar, it returns the token type.
.\"It also recognizes integer and floating-point numbers, and converts them
.\"to integers.
.\".PP
.\"Note that the \fBll.h\fR file is required even though there is no explicit
.\"reference to its contents.
.\"This is needed because the \fB%union\fR in \fBnav.y\fR generates the header
.\"file \fBnav.tab.h\fR, referring to the \fBll\fR structure.
.\".PP
.\"Turn \fBlex\fR file \fBnav.l\fR into program by typing:
.\".DM
.\"	lex nav.l
.\"	mv lex.yy.c nav.l.c
.\".DE
.\"Finally, you should type the following code into
.\"file \fBnavcalc.c\fR.
.\"It is C code that calculates the great circle route:
.\".DM
.\"	#include <stdio.h>
.\"	#include <math.h>
.\"	/*
.\"	 *	Given latitude and longitude of start and finish,
.\"	 *	calculate the great circle path.
.\"	 */
.\"	extern	double fromlon, fromlat, tolon, tolat;
.\".DE
.\".DM
.\"	calcpath ()
.\"	{
.\"		double rad = PI / 180.0;
.\"		double initcourse, arg, dist, d60;
.\"		double rfromlat, rfromlon, rtolat, rtolon;
.\".DE
.\".DM
.\"		printf ("From lat %.3f long %.3f ",
.\"		    fromlat, fromlon);
.\"		printf ("To lat %.3f long %.3f\en",
.\"		    tolat, tolon);
.\".DE
.\".DM
.\"		rfromlat = fromlat * rad;
.\"		rfromlon = fromlon * rad;
.\"		rtolat = tolat * rad;
.\"		rtolon = tolon * rad;
.\".DE
.\".DM
.\"		d60 = acos (
.\"		    sin (rfromlat) * sin (rtolat) +
.\"		    cos (rfromlat) * cos (rtolat) *
.\"			 cos (rfromlon - rtolon)
.\"		 );
.\"		dist = 60 * d60 / rad;
.\".DE
.\".DM
.\"		arg = (sin (rtolat) - cos (d60) * sin (rfromlat))
.\"			/
.\"			(sin (d60) * cos (rfromlat));
.\".DE
.\".DM
.\"		initcourse = acos (arg) / rad;
.\"		if (sin (rfromlon - rtolon) < 0)
.\"		    initcourse = 360 - initcourse;
.\".DE
.\".DM
.\"		printf ("Distance %.3f, Init course is %.3f\en\en",
.\"		    dist, initcourse);
.\"	}
.\".DE
.\"And now compile all three programs together.
.\".DM
.\"	cc nav.y.c nav.l.c navcalc.c -ly -lm -ll -f -o nav
.\".DE
.\"The standard formula is used to calculate great circle path and bearing.
.\"Note that there are several limitations that are not checked for here;
.\"For example,
.\"diametrically opposite points on the globe have no unique great circle
.\"path between them.
.\"In addition, neither of the points should be at either of the poles.
.\"These checks can be added if you wish to use \fBnav\fR program as a general
.\"rather than a tutorial tool.
.SH "Where to Go From Here"
.PP
The Lexicon article for \fByacc\fR summarizes its command syntax and
features.
The tutorial for \fBlex\fR, the \*(CO lexical analyzer, describes
how to combine \fBlex\fR with \fByacc\fR to build applications simply.

.NH "Changes From Release 4.2.05"
.PP
The following describes how \*(CO release 4.2.10 differs from
\*(CO release 4.2.05, which was the last release of \*(CO shipped to users.
.SH "Changes to the Kernel"
.PP
The following changes have been made to the \*(CO kernel and drivers:
.IP \(bu 0.3i
Some kernel bugs have been corrected that caused panics under
special conditions.
In particular, the bug that causes the ``Ring 1 Panic' has been traced
to the AT driver, and changes made to correct it.
.IP \(bu
Under \*(CO 4.2.05, the driver
.B asy
attempted to test for the presence of a UART.
However, the test did not always work correctly
because some newer 16550's no longer follow specification of IIR = xx00 xxxx.
The test has been rewritten to take this into account.
.IP \(bu
The driver
.B vtnkb
now supports Greek keyboards.
.IP \(bu
The driver
.B hai
has been changed to make its resetting more robust.
It now supports 255-head hard disks correctly.
Its default timeout has also been increased, to eliminate bogus
timeout messages when running slow drives.
.IP \(bu
The driver
.B at
has been modified to address a bug that caused panics and timeouts.
.IP \(bu
The kernel now clears the U area upon startup.
This problem had caused \*(CO installation to fail on a few systems.
.IP \(bu
Under certain circumstances, the kernel would crash if given a bad
physical address; it now complains and keeps running.
.IP \(bu
The kernel now recognizes Cyrix parts.
You can optionally enable the internal cache on the
SRx, SRx2, DRx, and DRx2 upgrade parts.
.IP \(bu
The file system has been changed to be more robust.
.IP \(bu
Global variable
.B RLOCKS
is now tunable.
.IP \(bu
In some instances, kernel error messages would print a bogus
number for a system call.
This has been fixed.
.IP \(bu
In some circumstances, the kernel used
.B rep
I/O instructions instead of explicit loops.
On some motherboards, this can cause the CPU to outrun the I/O bus.
The kernel has now removed all
.B rep
instructions and uses loops instead.
.IP \(bu
Variables
.B MSGQID_SPEC
and
.B MSGQSZ_SPEC
have been added to file
.BR /conf/install_conf/src/mtune .
.IP \(bu
Routines that report CPU idle times have been upgraded.
.IP \(bu
Under certain circumstances,
signalling did not work correctly.
This has been fixed.
.IP \(bu
Under \*(CO 4.2.05,
some screen contents would be lost
when the user switched sessions on a system with two video adapters.
This has been repaired.
.IP \(bu
Routines
.BR __kdenabio() ,
.BR __kddisabio() ,
.BR __kdaddio() ,
and
.B __kddelio()
have been added to the \*(CO device-driver kit.
.IP \(bu
Invoking
.B brk()
twice consecutively with the same arguments would cause a
.B PTOV
fault.
This has been fixed.
.IP \(bu
Changes to the kernel now permit
.B reboot
to reboot the system, rather than just bring it down and wait for the user
to press the reset the button.
.IP \(bu
The instruction
.DM
	while (sbrk(4096))
.DE
.IP
would crash the system under some circumstances.
This has been fixed.
.IP \(bu
The memory manager erroneously rounded down
byte lengths not a multiple of a page size,
which under some circumstances created problems.
This has been corrected.
.IP \(bu
The memory manager returned filler below the alignment address.
This has been corrected.
.SH "Changes to Commands and Scripts"
.PP
The following changes have been made to \*(CO commands and scripts:
.IP \fB/bin/cc\fR
This version (4.5.1) fixes a bug in sign extension, which affected
the compilation of some X applications.
It also fixes option \fB\-g\fR, which generates debugging information.
Under previous releases, this option would break the COFF output.
Other changes correct inappropriate extension of arguments from
.B short
to
.BR int .
.IP \fB/bin/df\fR
This command now uses
.B fstat
and
.B fstatfs
instead of opening raw device.
Environmental variables
.BR DF_OLD ,
.BR OLDSTYLE,
etc., now no longer affect its behavior.
.IP \fB/bin/fwtable\fR
This version (1.6) fixes a bug that caused it to generate bogus tables under
certain conditions.
.IP \fB/bin/ld\fR
This version (4.2.3) fixes some minor bugs.
.IP \fB/bin/login\fR
This has been recompiled to use the latest version of
.BR ctime() .
.IP \fB/bin/make\fR
This command now correctly handles
.BR Makefile s
generated by
.BR imake .
.IP \fB/bin/man\fR
The version of this command shipped with \*(CO 4.2.05 could run out
of memory if it attempted to read too many index files.
This has been fixed:
now it can read an indefinite number of index files.
.IP \fB/bin/newgrp\fR
The version of this program under 4.2.05 incorrectly set no password in a
newly created group, thus creating a security hole.
This has been fixed.
Its default permissions have also been set to \fBr-s-x-x root bin\fR.
.IP \fB/bin/ps\fR
This now returns the proper exit status.
.IP \fB/bin/qfind\fR
This command would page fault under certain circumstances.
It has been repaired.
.IP \fB/bin/sed\fR
This command
features improved error reporting.
.IP \fB/bin/sh\fR
.B exec
has been repaired.
.IP \fB/bin/test\fR
This command now correctly handles empty arguments, and reacts correctly
when handed no arguments.
.IP \fB/bin/troff\fR
This command's suite of font-width tables have been rebuilt using new
.B .tfm
tables supplied by Hewlett-Packard.
These tables are stored in directory
.BR /usr/lib/roff/troff_pcl/fwt .
.IP \fB/bin/wc\fR
This now returns the proper exit status.
.IP \fB/etc/build\fR
This script now allow lets you skip running
.B badscan
on AT drives.
It also allows you to
.B badscan
SCSI drives; this is now allowed because of problems with bad blocks
reported by users who have removable SCSI media.
.IP \fB/etc/build.u\fR
Corrected the word ``Owervite'' to ``Overwrite'' in an error message.
.IP \fB/etc/fsck\fR
This command would page fault if accidentally run on a
.B cpio
backup disk.
This has been fixed.
.IP
The ``memory allocation failed'' error message has been expanded.
.IP \fB/etc/install\fR
This command now correctly handles partial installations.
If it finds a tag file in the root directory, it asks you whether to
continue, rather than simply aborting installation.
.IP \fB/etc/mklost+found\fR
This script is a new command that lets you build a larger
.B lost+found
directory than \*(CO utilities build by default.
.IP \fB/etc/newusr\fR
This script had a problem whereby it mistakenly used the identifier
.BR add_user .
This has been repaired.
.IP
Because
.B vsh
is not a login shell, this has been removed from the list of login shells
presented to the user.
.IP \fB/etc/profile\fR
This file now uses
.B cat
to display the file
.B /etc/motd
by default.
This is not done if
.B $HOME
is
.BR /etc .
.IP
Instruction
.DM
	[ -f /etc/motd ...
.DE
.IP
has been changed to:
.DM
	[ -s /etc/motd ...
.DE
.IP \fB/etc/reboot\fR
Changes to the kernel now permit
.B reboot
to reboot the system, rather than just bring it down and wait for the user
to press the reset the button.
Note that it still prompts you to press the reset button, but if you wait
a few moments it will (in all probability) reboot your system automatically.
.IP \fB/etc/wall\fR
This command has been changed so that it no longer hangs when
it encounters a bogus entry in
.BR /etc/utmp .
This corrects the problem that caused the script
.B /etc/shutdown
to hang after a user had run X.
.IP \fB/etc/conf/aha/mkdev\fR
This script has been added.
It walks you through the process of describing your SCSI devices to the driver
.B aha
(the alternate driver for Adaptec SCSI disks).
.IP \fB/etc/conf/asy/mkdev\fR
This scipt now walks you through the process of configuring a modem, as well
as describing a serial port.
Its prompts have been reworded to make them clearer.
.IP \fB/etc/conf/at/mkdev\fR
This script has been added.
It walks you through the process of describing your AT disks to the driver
.BR at .
.IP \fB/etc/conf/bin/devadm\fR
Identifier
.B STARTUP
has been corrected to
.BR START .
.IP \fB/etc/conf/cohmain/mkdev\fR
This script now asks you whether you wish to enable the Cyrix upgrade cache,
should your system have a Cyrix part.
A new global variable identifies CPU type.
.IP \fB/etc/conf/hai/mkdev\fR
The initial version of this script confused variables
.B ID
and
.BR i ,
which created problems under certain circumstances.
This has been repaired.
.IP
This script has also been modified to permit you to install a tape driver
even if you do not have a SCSI hard disk.
.IP
Its prompts have been reworded to make them clearer.
.IP \fB/etc/conf/install_conf/sdevice\fR
Defaults for drivers
.BR echo ,
.BR loop ,
and
.B dump
were incorrectly set to `Y'; now correctly set to `N'.
.IP \fB/etc/conf/lp/mkdev\fR
This script's prompts have been reworded to make them clearer.
.IP \fB/etc/conf/pty/mkdev\fR
This script has been added to the release.
It walks you through the task of configuring the driver
.BR pty ,
which handles pseudo-TTYs.
.IP \fB/etc/conf/ss/mkdev\fR
This script has been added.
It walks you through the configuring of the driver
.B ss
(the alternate driver for Seagate SCSI disks).
.IP \fB/etc/conf/bin/idbld\fR
This new script walks you through the process of building an entirely
new kernel.
It invokes each
.B mkdev
script in turn, then invokes
.BR /etc/conf/bin/idmkcoh
to build the newly reconfigured kernel.
.\".IP \fB/etc/install\fR
.\"This command now supports pre-files.
.\"That is, it executes file \fB/conf/\fItag\fB.pre\fR
.\"before
.IP \fB/usr/bin/cancel\fR
This now correctly cancels a job for the MLP spooler.
.IP \fB/usr/bin/elvis\fR
This has been updated to release 1.8.
.IP
The command
.B cc
in this editor did not work properly.
This has been repaired.
.IP
.B elvis
now invokes
.B elvprsv
from
.BR /etc/rc .
.B elvprsv
and
.B elvrec
have permissions \fB4755 root root\fR, and
.B /usr/preserve
now has permissions \fB755 root root\fR.
.IP \fB/usr/bin/gzip\fR
This has been updated to use the latest GNU sources.
.IP \fB/usr/bin/ksh\fR
The previous release of this shell dropped argument 1; this has
been fixed.
Its handling of
.B SIGINT
and
.B SIGQUIT
have also been fixed.
.IP \fB/usr/bin/lp\fR
.IS \fB/usr/bin/lpsched\fR
Several bugs have been fixed in the MLP spooler and daemon.
In particular, the option \fB\-m\fR now works.
.SH "Changes to Library Routines and Macros"
.PP
The following library routines and macros have been changed or repaired.
.IP \fBftime()\fR
This has been restored as a COFF system call.
.IP \fBlibcurses\fR
This library has been updated to fix bugs and incorporated some previously
unsupported routines.
.IP \fBva_start()\fR
This routine, in header file
.BR <stdarg.h> ,
has been rewritten so that it can be used with the GNU C++ compiler
.BR g++ .
.IP \fBdiv()\fR
In-lining of this routine, which lives in header file
.BR <stdlib.h> ,
has been conditionalized.
This is done because
.B gcc
correctly handles such in-lined routines, but
.B g++
does not.
.IP \fBldiv()\fR
In-lining of this routine, which lives in header file
.BR <stdlib.h> ,
has been conditionalized.
This is done because
.B gcc
correctly handles such in-lined routines, but
.B g++
does not.
.IP \fBprintf()\fR
This has been updated to correct some minor errors.
.IP \fB/lib/ndp/libm.a\fR
This library lacked some floating-point op-codes for hardware floating-point
arithmetic.
This has been corrected.
.SH "Changes to Header Files"
.PP
.IP \fB/usr/include/float.h\fR
The values for
.B DBL_MAX
and
.B DBL_MIN
have been corrected.
.IP \fB/usr/include/limits.h\fR
.B __SCHAR_MIN
was misspelled.
This has been corrected.
.IP \fB/usr/include/math.h\fR
This file now contains the following corrected prototypes for
.B frexp
and
.BR ldexp :
.DM
	double	frexp	__PROTO ((double _x, int * _iptr));
	double	ldexp	__PROTO ((double _x, int _i));
.DE
.IP \fB/usr/include/stdlib.h\fR
This header file has had the line
.DM
	#include <common/xdebug.h>
.DE
.IP
removed.
.IP \fB/usr/include/common/__stat.h\fR
The R4
.B stat
structure in this header file has been suppressed, so that it
works with the latest release of GNU C.
.IP \fB/usr/include/coh/proc.h\fR
.IS \fB/usr/include/coh/timeout.h\fR
These header files have been added to make the kernel more compatible with GCC.
.IP \fB/usr/include/sys/confinfo.h\fR
Added
.B EXTERN_CLOSE
declaration to
.BR DECLARE_OPEN_CLOSE .
.IP \fB/usr/include/sys/cyrix.h\fR
This header file has been added to help support the Cyrix part.
.IP \fB/usr/include/sys/mmu.h\fR
Symbols
.B SEG_PWT
and
.B SEG_PCD
have been added to this header file.
.IP \fB/usr/include/sys/stat.h\fR
The R4
.B stat
structure in this header file has been suppressed, so that it
works with the latest release of GNU C.
.IP \fB/usr/include/sys/msg.h\fR
.IS \fB/usr/include/sys/sem.h\fR
.IS \fB/usr/include/sys/shm.h\fR
BCS-compatible pid length has been restored.
.IP \fB/usr/include/sys/types.h\fR
Type
.B u_long
et al. have been added.
.SH "Miscellaneous Changes"
.PP
The following miscellaneous changes have been made:
.IP  "Floppy-Disk Device Nodes\fR"
A number of changes have been made to floppy-disk device nodes.
The following nodes have been deleted:
.DM
	/dev/f9d0
	/dev/f9d1
	/dev/rf9d0
	/dev/rf9d1
.DE
.IP
The following nodes have been deleted and remade:
.DM
.ta 0.5i 2.0i
	/dev/dsk/f03d	/dev/rdsk/f03d
	/dev/dsk/f13h	/dev/rdsk/f13h
	/dev/dsk/f03d	/dev/rdsk/f03d
	/dev/dsk/f13h	/dev/rdsk/f13h
.DE
.IP "\fBSCSI Disk Device Nodes\fR"
Permissions on devices \fB/dev/{r}sd[a-d]\fR have been changed
\fB600 sys sys\fR.
Permissions on devices \fB/dev/{r}sdx\fR have been changed to
\fB600 root root\fR.
This matches the permissions for the \fBat\fR devices.
The
.B mkdev
scripts for these devices have also been updated to enforce these changes.
.IP \fB/lib/libc.a\fR
.IS \fB/lib/ndp/libc.a\fR
This version (4.2.3) fixes some bugs in some library routines, and include
a few routines that had been left out.
.IP \fB/lib/yyparse.c\fR
This has been updated to correct some minor bugs.
.IP "\fBManual Pages\fR"
These have been updated to include the latest changes and updates to the
software.
.IP \fB/usr/lib/makeactions\fR
.IS \fB/usr/lib/makemacros\fR
These have been updated to conform more closely to published standards.
.IP \fB/usr/lib/shell_lib.sh\fR
The routine
.B split_path
has had a minor bug corrected.
.IP \fB/usr/lib/uucp/sys\fR
The default version of this file
now includes the instructions
.DM
	remote-send
	remote-receive
	local-send
	local-receive
.DE
.IP
for the entry for site
.BR mwcbbs .
.IP \fB/usr/lib/libcurses.a\fR
.IS \fB/usr/lib/ndp/libcurses.a\fR
These incorporate fixes to minor bugs in the
.B curses
routines.
.IP \fBterminfo\fR
.IS \fBtermcap\fR
Some terminal descriptions have been repaired, in particular, the
.B xterm
entry in
.BR termcap .
.IP
Regional scrolling has been fixed in the
.B termcap
description for the console;
.B Blast
and GNU Emacs now scroll correctly.

.ds TL "Advanced cohulip"
.ds TI COHULIP
.NH "Advanced cohulip"
.PP
Once you have mastered using
.B cohulip
to communicate with one network, you may wish to explore how to use
.B cohulip
in a more sophisticated way.
The following sections discuss various advanced topics.
We hope that find them helpful.
.SH "Sample FTP Session"
.PP
The following walks you through a sample FTP session.
.II "Wright, Randy"
It is adapted from a posting by Randy Wright.
.PP
Each line is numbered, for reference below;
normally, lines are not numbered.
Text in Roman is generated by
.B cohulip
itself.
Text in
.B bold
comes from the remote host; and text in
.I italics
is typed by the user:
.nf
.sp \n(pDu
.ta 0.3i 1.0iR 1.5iR 2.0iR 2.2iL 4.0iL 6.0iL
1	    Coherent User Level Internet Package (cohulip)
2	                   derived from
3	 Internet Protocol Package, (C) 1988 by Phil Karn, KA9Q
4	     with contributed code from many other sources
5	
6	        This version is cohulip 2.1  with options:
7	        SLIP, ETHERNET, TRACE, MXSOCKETS
8	
9	startup: [/usr/net/startup.net]
10	ne_attach: /dev/ne0 [00:00:1b:00:0e:d7]
11	net> \fIftp rwsyss\fR
12	SYN sent
13	Estab.
14	\fB220 \fRrwsyss FTP server (rwsyss 1.0 #1 Tue May 24 17:30:31 PDT 1994 i386) ready.
15	Enter user name: \fIrw\fR
16	\fB331 \fRPassword required for rw.
17	Password: 
18	\fB230 \fRUser rw logged in.
19	ftp> \fI^]\fR
20	net> \fItcp status\fR
21	conout 1, conin 0, reset out 0, runt 0, chksum err 0, bdcsts 0
22		&TCB	RcvQ	SndQ	Local socket	Remote socket	State
23		406284	0	0	stalo:1001	rwsyss.wimsey.b:ftp	Estab.  
24		405ebc	0	0	stalo:echo	0.0.0.0:0	Listen   (S)
25		40608c	0	0	stalo:telnet	0.0.0.0:0	Listen   (S)
26		405fa4	0	0	stalo:ftp	0.0.0.0:0	Listen   (S)
27	net> \fItcp status 406284\fR
28	Local: stalo:1001 Remote: rwsyss.wimsey.b:ftp State: Estab.
.ta 0.3i 1.0i 2.0i 3.0i 4.0i 5.0i 6.0i
29		Init seq	Unack	Next	Resent	CWind	Thrsh	Wind	MSS Queue	Total
30	Send:	393870	393887	393887	0	1047	65535	4096	1024	0	22
31	Recv:	dc7f2533	dc7f25c1	0	6000	0	141
32	Backoff 0 Timer stopped SRTT 1544 ms Mean dev 745 ms
33	net> 
34	
35	ftp> \fIhash\fR
36	HASH MARK (#) on 1k boundaries is ON
37	ftp> \fIbell\fR
38	BEEP at end of tranfer is ON
39	ftp> \fItype i\fR
40	\fB200 \fRType set to I.
41	ftp> \fIget china-l\fR
42	\fB200 \fRPORT command successful.
43	\fB150 \fROpening BINARY mode data connection for china-l (14832 bytes).
44	##############\fB226 \fRTransfer complete.
45	Get complete, 14832 bytes received in 0 secs
46	
47	ftp> \fIquit\fR
48	\fB221 \fRGoodbye.
49	ClosWait
50	Last ACK
51	Closed (Reset)
52	net> \fIexit\fR
.PP
The following explains in detail each line of the above session.
.IP \fB1-8\fR
The banner that
.B net
displays when you start it up.
Note that this banner may change somewhat in your version of
.BR net .
.IP \fB9\fR
.B net
names the file it opened to read its startup commands.
.IP \fB10\fR
.B net
attaches an Ethernet device to a session named ``ne0''.
A device cannot be used unless it is first attached.
.B net
also displays the Ethernet card's Ethernet address.
This information can sometimes be useful if you are debugging ARP.
.IP \fB11\fR
.B net
has issued a prompt, and the user has entered the command to begin
an FTP session with system
.BR rwsyss .
.B net
displays this prompt after it has executed all commands in the startup script.
.IP \fB12-13\fR
TCP has initiated a connection with
.BR rwsyss .
No work can be done on a TCP connection until it has become established.
.IP \fB14\fR
This is a typical response from an FTP server.
The remote FTP server simply sends the three-digit message that appears at
the beginning of the message; the text is local client's interpretation of
that three-digit number.
In this case, message 220 indicates that
.B net
has established connections with the remote server.
.IP \fB15\fR
.B net
sees that the remote server is ready for a user name,
because its previous message began with the number 220.
Therefore, it prompts the user for his name; and the user type it (in this case,
.BR rw ).
.B net
then sends that name to the remote server.
.IP \fB16\fR
Message 331 from the remote server indicates that
it has received the user's name, and now wants the password.
.IP \fB17\fR
In response to message 331,
.B net
shuts off echoing and displays a prompt for the password.
After the user types the password and presses
.BR <return> ,
.B net
dispatches the password the the remote FTP server and turns on echoing again.
.IP \fB18\fR
Message 230 from the remote server indicates that it has
evaluated and accepted the password and user name.
User
.B rw
is now logged in and can do FTP work.
.IP \fB19\fR
The user has typed the escape character.
This special keystroke lets him return to the
.B net>
prompt.
At this prompt, the user can issue any of
.BR net 's
commands.
.IP
.B cohulip
can have any number
of ``sessions'' going simultaneously.
For example, you can have an FTP session with two different
systems while also having a TELNET chat with a third.
To move from one session to another, you must
``escape'' from the current session to the
.B net>
prompt, then use a
.B net
command to enter the other session.
In addition, you must escape to the
.B net>
prompt before you can issue a command that modifies
the whole of the TCP/IP software.
.IP \fB20\fR
The user has typed command
.BR "tcp status" ,
which shows the overall status of the TCP software.
.IP \fB21-26\fR
These lines show the output of command
.BR "tcp status" :
.DM
	conout 1, conin 0, reset out 0, runt 0, chksum err 0, bdcsts 0
.DE
.B conout
is the current number of outgoing connections;
that is, connections initiated from the local host.
.B conin
is the current number of connections initiated from
a remote host to this host.
.B "reset out"
is the number of connections that have been reset.
Reseting a connection closes it without notification
of the remote site.
.B runt
is the number of datagrams that were less than the minimum
length needed to carry an IP header.
.B "chksum err"
is the number of datagrams whose checksum show that the datagram was corrupt.
.B bdcsts
is the number of datagrams that were rejected because
they were broadcast datagrams, rather than addressed datagrams.
.DM
	  &TCB RcvQ SndQ Local socket            Remote socket           State
	406284    0    0 stalo:1001              rwsyss.wimsey.b:ftp     Estab.  
	405ebc    0    0 stalo:echo              0.0.0.0:0               Listen   (S)
	40608c    0    0 stalo:telnet            0.0.0.0:0               Listen   (S)
	405fa4    0    0 stalo:ftp               0.0.0.0:0               Listen   (S)
.DE
These lines give the status of each ``socket.''
Each connection or potential connection has a transmission-control block
(TCB).
The number under
.B &TCB
is the address of a given session's TCB;
you can be used this address to direct
.B tcp
commands to a particular session.
.II "receive queue"
.II "send queue"
.II RcvQ
.II SndQ
.B RcvQ
and
.B SndQ
are, respectively, the receive queue and the send queue \(em that is,
the number of bytes that have been received and have not yet been used,
and the number of bytes sent but have not yet been acknowledged by the remote
host.
A build-up in the receive queue
indicates that data are coming in faster than they are being used
locally.
A build-up in the send queue
.I may
indicate that the transmission path is clogged.
.IP
The local socket gives the IP address of the local host plus and the port
it has linked to the connection;
the remote socket gives the remote site's IP address and the port it has
linked to the connection \(em usually a ``well-known'' port that is associated
with a given server.
An address of 0.0.0.0 indicates that a connection is not yet established.
.IP
There are ten possible states for a TCP connection.
Most states are transient.
The
.B Listen
state indicates that a local server awaits a request from a remote site.
In this display, three servers are running and awaiting connection requests:
the
.B echo
server, the TELNET server and the FTP server.
The one connection that is in state
.B Estab.
is the FTP-control connection with
.BR rwsyss .
.IP \fB27\fR
This is a variant of the
.B "tcp status"
command that yields detailed information
on a particular connection.
Argument 406284 is the address of the TCB for the session that is logged
into site
.BR rwsyss ,
as shown in the above table.
.IP \fB28-32\fR
These give the output that
.B net
generated in respond to the previous command.
.DM
	Local: stalo:1001 Remote: rwsyss.wimsey.b:ftp State: Estab.
.DE
This is the general information about who is connected, and the TCP state. 
.DM
	      Init seq    Unack     Next Resent CWind Thrsh  Wind  MSS Queue      Total
	Send:   393870   393887   393887      0  1047 65535  4096 1024     0         22
	Recv: dc7f2533          dc7f25c1      0              6000          0        141
.DE
This displays information for both the send setup and the receive setup.
Each TCP session starts out with an initial sequence number;
this number represents the starting point of bytes that are sent and
received over the connection.
.RS
.IP \fBUnack\fR
The sequence number of the last byte transmitted that
whose receipt the remote host has not yet acknowledged.
.IS \fBNext\fR
A value that represents the sequence-number
acknowledgement expected from the other end of the connection.
.IS \fBResent\fR
The number of datagrams that have been resent due to not
being acknowledged within the time limits kept by TCP.
.IS \fBCwind\fR
The amount of space available in the current ``window.''
TCP is a ``sliding window'' style protocol.
.IS \fBThrsh\fR
The number of miliseconds of timeout that will cause a ``slow
start'' to kick in.
The slow-start situation puts a delay between datagrams
to allow an overloaded network to recover from congestion.
.IS \fBWind\fR
The window size that each of the connection ``bid''
at the start of the connection.
.IS \fBMSS\fR
The maximum segment size of each side as ``bid'' at the beginning
of the connection.
.IS \fBmss\fR
The maximum data size of each datagram.
.IS \fBQueue\fR
The number of outstanding bytes in the channel.
Total is the total number of bytes either
sent or received since the connection began.
.DM
	Backoff 0 Timer stopped SRTT 1544 ms Mean dev 745 ms
.DE
TCP has sophisticated mechanisms to deal with network congestion.
This line tells you about the current state
of the backoff timer and calculations that TCP is performing
to give the best performance without worsening network congestion.
There are four fields in this line:
.DS
	Backoff ###
	Timer state
	SRTT #### ms
	Mean dev #### ms
.DE
These fields tell you the state of congestion that exists
on your connections.
.B cohulip
supports
two types of timer:
linear and exponential.
In the linear backoff timer,
.B net
increments
the value of
.B Backoff
by one step each time
.B net
retransmits a datagram due to a timeout.
In an exponential backoff,
.B net
doubles the backoff value each time a datagram retransmission occurs.
.B net
then multiplies the backoff value by the
.BR SRTT ,
and adds that product to the sum of one  second and the mean deviation
in order to determine the amount of time to wait for the next retransmission
timeout.
The effect of this is that if a datagram is not acknowledged
by the remote site within the normal round trip time,
.B net
assumes that it is lost, and retransmits it.
Then the timer is set at a longer
amount of time than the round-trip time.
If the second datagram is not acknowledged within the timeout period,
it is retransmitted again
and the timeout period is increased even more.
This can continue until very long periods of time pass between attempts.
The acknowledgement of a datagram turns off the backoff, unless the
timeout figures have exceeded the slow-start threshold.
.IP
.B SRTT
is the ``smoothed'' round-trip time, in miliseconds.
.B "Mean dev"
is the mean deviation, in milliseconds.
As you can see, TCP does a fair amount of arithmetic to
keep things flowing smoothly.
.IP \fB33-34\fR
The user has pressed
.B <enter>
to return to the current session.
.IP \fB35-36\fR
The user turns on the hash-mark function for FTP, and
.B net
replies that it is on.
.IP \fB37-38\fR
The user turns on the bell function, and
.B net
acknowledges it.
.B net
will now beep when it finishes transferring a file.
.IP \fB39-40\fR
The user sets the FTP session to type `i', and
.B net
acknowledges the command.
This means that the user wants files to be transmitted in ``image''
(binary) mode.
.B net
also recognizes `b' (``binary'') as a synonym for ``image.''
The other available modes are `a' (``ASCII''); and `l',
which lets you specify an oddball byte length for ASCII text.
.IP \fB41\fR
Now we cut to the chase:
the user tells
.B net
to get (i.e., download) file
.B china-l
from the remote site.
.B net
will copy it into the user's current directory on the local host.
.IP \fB42-46\fR
These lines give progress reports about the file transfer.
FTP always opens a second TCP connection over which data is
transferred.
Message 200 indicates that
.B net
established the second channel with the remote server.
Message 150 tells the user that the file has been opened
and transfer of data begun.
.IP
The hash-mark function in the local software displays a ``hash''
character `#' after it transfers each kilobyte of data.
Message 226 from the remote host comes from the ``command'' connection.
It indicates that the transfer of data is complete.
(Sometimes the transfer-complete message
can arrive before all of the data arrives! This does not indicate
that an error has happened.)
.IP
Line 45 indicates that
.b net
has received the 14,832 bytes, and that it has detected the closure
of the data connection.
.IP 
Finally, line 47 shows that
.B net
has beeped to indicate that file transfer has completed, as the user
requested earlier.
.IP \fB47\fR
The user issues a command to close the connection gracefully.
.B net
sends this command to the remote host, which initiates the closure sequence.
.IP
A TCP connection does not close instantly.
TCP pauses a bit to ensure that no data is lost.
It gets and acknowledges some more datagrams from the remote site.
When the connection has finally closed entirely,
.B net
automatically returns the user to its
.B net>
prompt.
.IP \fB48-51\fR
Message 221 from the remote site acknowledges that the connection is now
closed.
The other three lines show that
.B net
has performed the housekeeping chores associated with
closing a connection properly.
.IP \fB52\fR
The user exits from
.BR net .
.SH "Anonymous FTP"
.PP
``Anonymous FTP'' means that a site permits user ``anonymous'' to access
itself via FTP.
In this way, anyone can use the information that you have made available
on your system.
What user ``anonymous'' can do depends entirely upon how that site's
administrator has structured it.
.PP
The following sub-section describes how to use anonymous FTP to
access a remote host.
.II "Yanoff, Scott"
It is adapted from the document \fIA Short Guide to Anonymous ftp\fR,
which was written by Scott Yanoff (yanoff@csd4.csd.uwm.edu).
.Sh "Accessing a Remote Host via Anonymous FTP"
.PP
A great deal of useful information is stored in files at computers
throughout the country and the world.
Many of these file are freely available to users of the Internet.
A simple method for transferring such files from a remote computer to a
user's computer is anonymous FTP.
Anonymous FTP allows a user to transfer files without having an account
at the remote computer (i.e., the user is anonymous).
.PP
To access an anonymous FTP site, you must know the site's name.
For example, nic.ddn.mil is the name of the Network Information Center
of the Department of Defense Network. 
The procedure for accessing this site follows.
The text in Roman text is printed by
.BR net .
The text in
.I italics
gives what the user types on her local system to access nic.ddn.mil;
and the text in
.B bold
is returned by the remote site.
Each line is numbered; the numbers do not actually appear on the screen:
.sp \n(pDu
.nf
.ta 0.3i
1	net> \fIftp nic.ddn.mil\fR
2	Connected to nic.ddn.mil
3	\fB220 \fRNIC.DDN.MIL FTP Server Process 5z(47)-6 at Tue 30-Jul-91 12:56-PDT\fR
4	Name  (nic.ddn.mil:msmith) : \fIanonymous\fR
5	Password  (nic.ddn.mil:anonymous) :\fI---------\fR
6	\fB331 \fRANONYMOUS  user ok, send real ident as password.\fR
7	\fB230 \fRUser ANONYMOUS logged in at Tue  30-Jul-91  12:56-PDT,  job 46.\fR
8	\fRftp>\fR
.PP
The following explains each line in turn:
.IP \fB1\fR 0.3i
At the
.B net
prompt, user FTPs to nic.ddn.mil.
.IP \fB2\fR
User is connected to the FTP site.
As explained earlier, the remote server returns only the number of the message;
the text of the message is generated by the local client \(em in this case,
.BR net .
.IP \fB3\fR
Remote host notes the time of the user's login.
.IP \fB4\fR
The user logs in as ``anonymous''.
.IP \fB5\fR
The user enters password of ``guest'',
which does not appear on screen.
.IP \fB6-7\fR
Remote host acknowledges the user's login, and notes time.
.IP \fB8\fR
The user sees the prompt
.BR ftp> ,
and now begin to explore the remote host.
.PP
Once you have accessed the FTP site, to transfer a file you may have to 
change directories to the directory that your file is located in.
It is a good idea to list the contents of the directory before attempting to
transfer a file:
.sp \n(pDu
.nf
.ta 0.3i
1	\fB230\fR- Guest login ok, access restrictions apply.\fR
2	Starting cwd is /pub.
3	\fB230 \fRLocal time is: Wed Jul 31 14:18:29 1991\fR
4	\fRftp> \fIdir\fR
5	\fB200 \fRPORT command successful.\fR
6	\fB150 \fROpening ASCII mode data connection for /bin/ls.\fR
7	\fBREADME\fR
8	\fBnic\fR
9	\fB226 \fRTransfer complete.\fR
10	\fR11 bytes received in 0.1 seconds (0.01 Kbytes/s)\fR
11	\fRftp> \fIcd nic\fR
12	\fB250 \fRCWD command successful.\fR
13	\fRftp> \fIdir\fR
14	\fB200 \fRPORT command successful.\fR
15	\fB150 \fROpening ASCII mode data connection for /bin/ls.\fR
16	\fBinterest.groups\fR
17	\fBnetworking.terms\fR
18	\fB226 \fRTransfer complete.\fR
19	\fR74 bytes received in 0.11 seconds (0.66 Kbytes/s)\fR
20	\fRftp> \fIget interest.groups\fR
21	\fB200 \fRPORT command successful.\fR
22	\fB150 \fROpening ASCII mode data connection for interest.groups (721283 bytes).\fR
23	\fB226 \fRTransfer complete.\fR
24	\fR738182 bytes received in 15 seconds (48 Kbytes/s)\fR
25	\fRftp> \fIquit\fR
26	\fB221 \fRGoodbye.\fR
.PP
The following explains the above in detail:
.IP \fB1-3\fR
Remote host allows user access.
.IP \fB4\fR
User uses FTP command
.B dir
to display contents of current directory.
.IP \fB5-6\fR
Remote host acknowledges
.B dir
command and begins sequence.
.IP \fB7-8\fR
Listing of directories.
.IP \fB9-10\fR
Remote host completes display and notes the time it took.
.IP \fB11\fR
User uses FTP command
.B cd
to enter directory
.BR nic .
.IP \fB12\fR
Remote host acknowledges change of directory.
.IP \fB13\fR
User invokes FTP command
.B dir
to view contents of the current directory, which is now directory
.BR nic .
.IP \fB14-15\fR
Remote host acknowledges receipt of command.
.IP \fB16-17\fR
Remote host displays contents of current directory.
.IP \fB18-19\fR
Remote host completes display and notes the time it took.
.IP \fB20\fR
User asks FTP to download file
.B interest.groups
to her local host.
.IP \fB21-24\fR
Remote host downloads file, notes size of file, and computes the time the
file transfer took.
.IP \fB25\fR
User logs off the remote host.
.IP \fB26\fR
Remote host acknowledges her departure.
.Sh "Configuring cohulip for Anonymous FTP"
.PP
If you wish, you can open your site for anonymous FTP.
Then, as long as you are ``on the air,'' users can log into your system
and access whatever files you make available to them.
.PP
To open your site to anonymous FTP requires only three steps:
preparing a directory (or directories) for the users to access;
modifying the file
.BR $NETHOME/ftpusers ;
and then starting the FTP server.
The following discusses each of these steps in detail.
.PP
To begin, select a directory for these users to log into.
.I
Do not put any files into this directory that you do not want broadcast
to the world!
.R
If you expect a lot of traffic on your system, you may wish to set aside
an entire file system for anonymous FTP; otherwise, a portion of an
an existing file system will serve.
.PP
Next, you must modify file
.BR $NETHOME/ftpusers .
This file names every user who has permission to log into your system.
An entry in this file consists of the user's name, his password, then between
one and eight pairs of directories and permissions.
These name the directories to which the anonymous user has access,
and what the user can do there.
Permissions state what the user can do there;
it is the sum of the following values:
.DS
.ta 0.5i 0.8i
	\fB1\fR	Read an existing file
	\fB2\fR	Create a new file and write matter into it
	\fB4\fR	Overwrite an existing file or delete a file
.DE
Note that when you name a directory in
.BR ftpusers ,
it and all of its subdirectories become accessible by the user.
.PP
For anonymous FTP, the user's name should be
.BR anonymous ,
and the password `*', which indicates all passwords.
The directory should be one that contains nothing sensitive.
It is not a good idea to give overwrite permission to an anonymous user.
The following gives an example:
.DM
	anonymous * /projects/pub 3
.DE
Here, user
.B anonymous
can access directory
.B /projects/pub
and its subdirectories.
The users can read files and create new files, but not overwrite or delete
any existing files.
.PP
Once you have selected your file and modified
.BR ftpusers ,
all that remains is to add the command
.B "start ftp"
to your startup script, then invoke
.BR net .
Your system is now open for anonymous FTP.
.SH "Tracing and Debugging a cohulip Session"
.PP
The
.B net
command
.B trace
permits you to dump a copy of the datagrams that you exchange
with a remote site.
You can dump datagrams either to the screen or into a file.
This section describes how to initiate a trace, then how to interpret
its output.
.PP
.II "Wright, Randy"
This section is adapted from various mail messages written by Randy Wright.
.Sh "Initiating a Trace"
.PP
The following describes how to initiate a trace of an FTP session to site
.B raven
that is performed through a SLIP connection to an Internet provider.
The description here is easily adapted to an Ethernet connection.
.PP
To initiate a trace, do the following:
.IP \(bu 0.3i
Invoke
.BR net .
Dial your Internet provider and log in, and set the IP addresses of your
local host and domain-name server in the usual manner.
.IP \(bu
Enter the following commands at the
.B net>
prompt:
.DM
	trace to /usr/net/tracefile
	trace sl0 211
.DE
The first
.B trace
command redirects its output into file
.BR /usr/net/tracefile .
The second command tells it to trace session
.BR sl0 .
The digits ``211'' are three flags that set the following behaviors:
.RS
.IP \fB2\fR 0.3i
Decode and display both data and headers.
.IS \fB1\fR
Enable tracing of incoming datagrams.
.IS \fB1\fR
Enable tracing of outgoing datagrams.
.RE
.IP
For details on the syntax of
.BR trace ,
see its entry in the chapter entitled \fIRunning net\fR.
.IP \(bu
Once the trace is launched, type the command
.B "ftp raven"
at the
.B net>
prompt.
The data datagrams are recorded in
a file called
.BR /usr/net/tracefile .
.IP \(bu
After you have logged in, type the escape character
.B <ctrl-]>
to return to the
.B net>
prompt.
.IP \(bu
Issue the command:
.DM
	tcp status
.DE
This displays the sockets status.
Look for the
.B ftp
socket that is connected to the remote site.
Write onto a piece of paper the numbers of the
.B RcvQ
and the
.BR SndQ .
The former identifies the receive queue, and the latter the send queue.
.IP \(bu
To turn off tracing, enter the command from the
.B net>
prompt:
.DM
	trace sl0 000
.DE
.Sh "Interpreting a Packet"
.PP
Now that the trace has been captured, you can read it.
The following introduces the structure of a TCP datagram, and suggests how
you can read it.
.PP
As you recall from the chapter on TCP/IP basics, a typical datagram is
built in layers:
20 bytes of IP header, followed by 20 bytes of TCP header, followed by
a variable amount of data.
That chapter describes each byte of each header in detail.
.PP
It is possible to get corrupted datagrams over modem connections.
This will show up in the messages logged by the
.B trace
command,
because the tracing software
analyzes the datagrams and detects mal-formed datagrams.
This is discussed below.
.Sh "Reading a Tracefile"
.PP
The following example reads the tracefile that we captured during the
first part of this section.
For purposes of this example, we assume that there is a problem with
a connection to remote site
.BR raven :
it hangs after login.
We'll also assume that
.B RecQ
is 0 and the
.B SndQ
is 16.
.PP
The following gives the first datagram recorded in the tracefile.
The local host has sent it to
.BR raven :
.DM
	sl0 sent:
	IP: len 44 199.3.32.100->137.229.10.39 ihl 20 ttl 31 prot TCP
	TCP: 1001->21 Seq x138ce20 SYN Wnd 1500 MSS 1500
	0000  45 00 00 2c 00 00 00 00 1f 06 20 59 c7 03 20 64  E..,...... YG. d
	0010  89 e5 0a 27 03 e9 00 15 01 38 ce 20 00 00 00 00  .e.'.i...8N ....
	0020  60 02 05 dc 43 58 00 00 02 04 05 dc              `..\eCX.....\e
.DE
This IP datagram is being sent out of the serial port.
It contains a TCP SYN datagram
that alerts the remote computer to setup a connection.
The remote host is supposed to reply with a SYN ACK datagram.
This SYN and SYN ACK allows the two hosts to agree on window size,
message size, and the number that is assigned to the first data byte.
The printout is hexadecimal bytes in network order rather than in Intel order.
.PP
A breakdown of the fields in the datagram appears below.
The
.B Seq
number is a random number generated to represent the
first byte of data in your data stream that you wish to send to
.BR raven .
.PP
The TCP software tracks and acknowledges bytes of data:
that's why it emphasizes byte numbers.
Each datagram also has a checksum.
If the checksum does not add up correctly, the remote host tosses the
datagram into the bit bucket.
.PP
The second datagram appears as follows.
The local host has received it from
.BR raven :
.DM
	sl0 recv:
	IP: len 40 137.229.10.39->199.3.32.100 ihl 20 ttl 39 prot TCP
	TCP: 21->1001 Seq x28cb5c00 Ack x138ce21 SYN ACK Wnd 16384
	0000  45 00 00 28 23 ab 00 00 27 06 f4 b1 89 e5 0a 27  E..(#+..'.t1.e.'
	0010  c7 03 20 64 00 15 03 e9 28 cb 5c 00 01 38 ce 21  G. d...i(K\e..8N!
	0020  50 12 40 00 9c 3b 00 00                          P.@..;..
.DE
This a SYN ACK datagram from
.BR raven .
It wants to have a TCP window size (\fBWnd\fR) of 16,384 bytes;
however, in the first datagram you had said that you wanted a window size
of 1,500 bytes.
The protocol specifies that the smaller of the two will be used.
.B raven
has informed you of the first byte in its data stream.
It has also confirmed the first byte in your data stream.
.PP
The third datagram appears as follows.
The local host has sent it to
.BR raven :
.DM
	sl0 sent:
	IP: len 40 199.3.32.100->137.229.10.39 ihl 20 ttl 31 prot TCP
	TCP: 1001->21 Seq x138ce21 Ack x28cb5c01 ACK Wnd 1500
	0000  45 00 00 28 00 01 00 00 1f 06 20 5c c7 03 20 64  E..(...... \eG. d
	0010  89 e5 0a 27 03 e9 00 15 01 38 ce 21 28 cb 5c 01  .e.'.i...8N!(K\e.
	0020  50 10 05 dc d6 60 00 00                          P..\eV`..
.DE
Instruction \fBSeq\fR acknowledges that byte 138ce21 is the position in your
sent data stream.
Instruction \fBAck\fR states that byte 28cb5c01
is the next byte you want from
.BR raven .
.PP
The fourth datagram appears as follows.
The local host has received it from
.BR raven :
.DM
	sl0 recv:
	IP: len 130 137.229.10.39->199.3.32.100 ihl 20 ttl 39 prot TCP
	TCP: 21->1001 Seq x28cb5c01 Ack x138ce21 PSH ACK Wnd 16384
	0000  45 00 00 82 24 0d 00 00 27 06 f3 f5 89 e5 0a 27  E...$...'.su.e.'
	0010  c7 03 20 64 00 15 03 e9 28 cb 5c 01 01 38 ce 21  G. d...i(K\..8N!
	0020  50 18 40 00 ad f4 00 00 32 32 30 20 72 61 76 65  P.@.-t..220 rave
	0030  6e 2e 61 6c 61 73 6b 61 2e 65 64 75 20 46 54 50  n.alaska.edu FTP
	0040  20 73 65 72 76 65 72 20 28 56 65 72 73 69 6f 6e   server (Version
	0050  20 77 75 2d 32 2e 34 28 32 29 20 46 72 69 20 41   wu-2.4(2) Fri A
	0060  70 72 20 32 32 20 31 31 3a 30 30 3a 33 35 20 41  pr 22 11:00:35 A
	0070  4b 44 54 20 31 39 39 34 29 20 72 65 61 64 79 2e  KDT 1994) ready.
	0080  0d 0a                                            ..
.DE
If displayed on the screen, it would appear as follows:
.DM
	220 raven.alaska.edu FTP server (Version wu-2.4(2) Fri Apr 22 11:00:35 AKDT 1994) ready.
.DE
The fifth datagram appears as follows.
The local host sent it to
.BR raven :
.DM
	sl0 sent:
	IP: len 40 199.3.32.100->137.229.10.39 ihl 20 ttl 31 prot TCP
	TCP: 1001->21 Seq x138ce21 Ack x28cb5c5b ACK Wnd 1500
	0000  45 00 00 28 00 02 00 00 1f 06 20 5b c7 03 20 64  E..(...... [G. d
	0010  89 e5 0a 27 03 e9 00 15 01 38 ce 21 28 cb 5c 5b  .e.'.i...8N!(K\[
	0020  50 10 05 dc d6 06 00 00                          P..\V...
.DE
It acknowledges that the local host received the previous message.
.PP
The sixth datagram also goes from the local host to
.BR raven :
.DM
	sl0 sent:
	>IP: len 56 199.3.32.100->137.229.10.39 ihl 20 ttl 31 prot TCP
	TCP: 1001->21 Seq x138ce21 Ack x28cb5c5b PSH ACK Wnd 1500
	0000  45 00 00 38 00 03 00 00 1f 06 20 4a c7 03 20 64  E..8...... JG. d
	0010  89 e5 0a 27 03 e9 00 15 01 38 ce 21 28 cb 5c 5b  .e.'.i...8N!(K\[
	0020  50 18 05 dc 4e 12 00 00 55 53 45 52 20 61 6e 6f  P..\N...USER ano
	0030  6e 79 6d 6f 75 73 0d 0a                          nymous..
.DE
The local command
.B net
has prompted you for a user name, obtained it and stuck it into this datagram.
Note that with FTP, the commands for login identifier and password are
generated on your local host \(em \fInot\fR by the remote host.
.PP
The seventh datagram repeats the sixth:
.DM
	sl0 sent:
	IP: len 56 199.3.32.100->137.229.10.39 ihl 20 ttl 31 prot TCP
	TCP: 1001->21 Seq x138ce21 Ack x28cb5c5b PSH ACK Wnd 1500
	0000  45 00 00 38 00 04 00 00 1f 06 20 49 c7 03 20 64  E..8...... IG. d
	0010  89 e5 0a 27 03 e9 00 15 01 38 ce 21 28 cb 5c 5b  .e.'.i...8N!(K\[
	0020  50 18 05 dc 4e 12 00 00 55 53 45 52 20 61 6e 6f  P..\N...USER ano
	0030  6e 79 6d 6f 75 73 0d 0a                          nymous..
.DE
.B net
did not receive an acknowledgement for the previous datagram, so
it is resending it.
Note that
.B net
uses a ``backoff'' timer system:
When it sends datagram, it sets a timer.
When the timer expires,
.B net
resends the datagram; then doubles the timer's time and set the timer again.
This results in increasing amounts of time being spent waiting between sends.
When
.B net
receives an acknowledgement, it cancels all timers and
sends the next datagram, if there is one.
.PP
For the sake of brevity, we will not show the next five datagrams.
They repeat the previous two, sending them at ever-lengthening intervals.
The acknowledgment of the datagram
.B "USER anonymous"
never came despite seven tries.
At this point, the impatient user pressed the escape key \fB<ctrl-]>\fR
and \fBclose\fRd the FTP session.
.PP
So, what caused the problem?
The datagrams appear to be correct, so
two possible causes come to mind:
the modem does not have modem control turned on, or
an upstream site has botched up the routes.
.PP
If your modem has little lights that flash when data go through,
you can use the command
.B kick
to test the modem.
This command order TCP to ignore the timeout and ``kick'' the next
datagram out to its device.
To invoke this command, press the escape character
.B <ctrl-]>
to return to the
.B net>
prompt, then type
.BR kick .
The modem lights should flash as the datagram goes out the wire.
If they do not, then the problem is somehow involved with your modem
or serial connection.
.Sh "Dump of a Malformed Datagram"
.PP
As noted above, the command
.B trace
analyzes datagrams as it dumps them, and marks any malformed datagrams
that it finds.
For example:
.DM
	sl0 recv:
	IP: len 3338 73.80.32.97->100.100.114.101 ihl 52 ttl 108 tos 10 
	id 18798 offs 45832 DF MF CHECKSUM ERROR (9549)
.DE
This checksum message means something is wrong with the datagrams.
Protocol problems almost always produce this message.
This message can also appear if the modem overruns the serial port,
or if something is wrong in the startup script.
.PP
A closer look at the datagram contents reveals that it is not
an IP datagram at all.
The first digit in an IP datagram usually is 0x45.
This datagram begins with 0x0d \(em a carriage return character:
.DM
	0000  0d 0a 0d 0a 49 6e 76 61 6c 69 64 20 49 50 20 61  ....Invalid IP a
	0010  64 64 72 65 73 73 2c 20 73 6b 69 70 70 69 6e 67  ddress, skipping
	0020  20 62 75 74 7a 65 6e 2d 73 6c 69 70 0d 0a 49 6e   butzen-slip..In
	0030  76 61 6c 69 64 20 49 50 20 61 64 64 72 65 73 73  valid IP address
	0040  2c 20 73 6b 69 70 70 69 6e 67 20 61 64 64 0d 0a  , skipping add..
	0050  50 61 63 6b 65 74 20 6d 6f 64 65 20 65 6e 61 62  Packet mode enab
	0060  6c 65 64 0d 0a                                   led..
.DE
If all your datagrams were like this, then you could assume that
your IP provider had not yet launched SLIP.
.SH "cohulip and DOS"
.PP
You can use
.B cohulip
to access a machine that is running \*(MD.
You can do so via Ethernet or SLIP.
.Sh "cohulip and DOS via SLIP"
.PP
.II "MS-DOS^accessing via SLIP"
.II "Chalmers, Robert"
The following directions, which are adapted from mail by
Robert Chalmers (earth@nanguo.cstpl.com.au) describe how to
get \*(MD and \*(CO to exchange files via SLIP.
.PP
.II WinTrumpet
.II WinSoc
.II WinQvtnet
If you have an \*(MD machine that runs Windows,
get a copy of
.BR WinTrumpet ,
.BR WinSoc ,
and
.BR WinQvtnet .
A copy of Microsoft's TCP/IP would also be helpful.
.PP
To start a SLIP session from Windows to
.BR cohlip ,
do the following:
.IP \(bu 0.3i
Configure your
.B WinSoc/Wintrumpet
set up, using
.B tcpman.exe
to be a SLIP host.
This is easy:
just point and click.
Make sure your hosts are in the the file
.BR Windows\ehosts .
.IP \(bu
Then set up your modem so that it auto-answers.
If it is Hayes-compatible, use the modem command ATS0=1.
.IP \(bu
Run
.BR tcpman ,
so you have the
.B Wintrumpet
window open and telling you that SLIP is started.
You don't need to dial out from your \*(MD machine.
.IP \(bu
Next, invoke
.B net
on your \*(CO machine, with the configuration file used for SLIP.
Then, simply dial the \*(MD machine.
Put only the telephone number of your \*(MD machine into the dialing script
that is part of the
.B attach
command.
.IP \(bu
When the \*(MD side is connected,
click on
.B QvtNet
and open a connection to
the
.B cohulip
host.
.PP
In the blink of an eye, you are connected.
You get a login prompt; from there you can login in,
use FTP to transfer files, and so on.
At this point the Microsoft TCP/IP will also talk to your \*(CO side.
.PP
Note that in some instances, your connection will drop if nothing is
sent through the modem for approximately five minutes.
If this is a problem, use the command
.B ping
to ping the remote site continually.
This will ensure that some datagrams are always moving between your local
host and the remote machine, and so keep the connection open.
.PP
You can also use SLIP to communicate directly serial lines, without
needing modems between the two computers.
Just be sure to use a null modem in your serial line.
For details, see the entries for
.B terminal
and
.B RS-232
in the \*(CO Lexicon.
.Sh "cohulip and DOS via Netware"
.PP
.II Netware
.II "MS-DOS^accessing via Ethernet"
The following directions, which are adapted from a mail message by
Bret Johnson, describe how to connect \*(CO and \*(MD via Ethernet,
using Netware and LAN Workplace (LWP) on the \*(MD side.
.IP \fBGetting the Software\fR
Presumably, you already have a copy of
.BR cohulip .
Contact your local reseller for Unixware and LWP.
.IP "\fBSetting up LAN Workplace for MS-DOS\fR"
First, install LWP as described in the manual.
Then edit configuration files
.BR ETHERS ,
.BR FTPDUSR.LOG ,
.BR RESOLV.CFG ,
and
.BR HOSTS ;
all are in directory
.BR C:\eNET\eTCP :
.RS
.IP \fBETHERS\fR
This file links an Ethernet address to an IP address, as shown in the
following example:
.DM           
	# Ethernet Address	IP Address
	02:00:02:00:df:fe       223.254.254.10
	00:00:1b:33:c4:ac       223.254.254.20
.DE
.IP \fBFTPDUSR.LOG\fR
This is your FTP password file, much like
.BR cohulip 's
file
.BR $NETHOME/ftusers .
An example follows:
.DM
	# username:password
	bret:BRETPASS
	kimberly:KIMPASS
.DE
.IP \fBHOSTS\fR
This file is where you define other computers in your network.
It is analogous to the
.B cohulip
file
.BR net.hosts .
If you have a domain name server (DNS), it will check the DNS first,
then this file.
An example follows:
.DM
	# IP Address    name and optional aliases
	223.254.254.10  bret.bjohns.jcc.com bret
	223.254.254.20  kim.bjohns.jcc.com kim
	127.0.0.1       loopback
	198.234.99.85   olc_mar.odn.ohio.gov reg6
.DE
Other than file
.BR FTPDUSR.LOG ,
this is the only configuration file you really
need to get LWP up and running in a small network.
.RE
.IP "\fBSet your PATH\fR"
Now, set your
.B PATH
to where LWP executable file lives:
.DM
	PATH C:\NET\BIN;%path%
.DE
.IP "\fBTest the Configuration\fR"
Run a few programs to check that everything set up correctly; for example
.DM
	PING 223.254.254.10
.DE
or
.DM
	PING bret
.DE
These should return something like:
.DM
	223.254.254.10 is alive
	bret is alive
.DE
The command
.DM
	FTP 223.254.254.10
.DE
or
.DM
	FTP bret
.DE
should return:
.DM
	220 bjohns FTP version cohulip 2.1 ready
.DE
or:
.DM
	remote name:
.DE
Command
.DM
	TNVT220 223.254.254.10
.DE
or
.DM
	TNVT220 bret
.DE
should return:
.DM
	coherent login:
.DE
.PP
If the tests work out correctly, all should be welland you can safely use
LWP and
.BR cohulip .
.PP
You may encounter some problems access \*(MD from \*(CO.
When you TELNET from \*(CO to a box runing LWP XPC,
.B cohulip
flies past the XPC prompt and exits from the TELNET session.
When you FTP from \*(CO to LWP, you can log in but you never receive
a prompt for a password.
You must explicitly type in
.BR ftp 's
.B pass
command with your password.
.SH "Routing Between Networks"
.PP
.B cohulip
is not robust enough to act as a gateway between two networks.
However, you can use
.B cohulip
to access more than one network simultaneously, and so
(in a very limited way)
you can move files from a machine on one network to a machine on another.
.II "Wright, Randy"
The following descriptions is adapted from mail messages by Randy Wright.
.Sh "Connecting Between Networks"
.PP
Note that because
.B cohulip
is endowed with ``host''-style IP services,
you should be very careful when hooking it into more than one Ethernet
network simultaneously.
That is because
.B cohulip
can create data storms in networks that have more
than one possible path to the any spot on the LAN.
.PP
However, you can use
.B cohulip
on both SLIP and Ethernet simultaneously.
If you have a smallish ``tree'' style LAN and cooperation from your Internet
provider,
you get Internet services directly to the Ethernet-only machines.
The key to this is to set up the routing tables correctly.
Here's an example:
.ie p .PH 1 1 \\*(XD/routing.eps
.el \{\
.DM
                                  |  <-- SLIP to Internet provider
                              +---+------------+ 
                              | cohulip        | 
                              | 199.199.10.01  | <- cocoh.gate.com 
                              +------|---------+
                                     |  <- ethernet network: 199.199.10.0
          +-----------------------------------------------+
          |                                               |
      +---+----------+                                +---+----------+
      | cohulip      | <- coolcoh.gate.com            | SLIK IP      |
      | 199.199.10.2 |                                | 199.199.10.3 | 
      +--------------+             slick.gate.com ->  +--------------+
.DE
\}
.PP	                                    
In this setup, site
.B cocoh.gate.com
is acting as a SLIP \(<-\(-> Ethernet router.
The network is simple enough that this is a practical thing to do.
The trick is setting up the routing tables correctly.
The routing table for site
.B cocoh
contains the following entries:
.DM
	default	        sl0
	199.199.10.2    ne0
	199.199.10.3    ne0
.DE
To set these, add the following commands to
.BR coco 's
startup script:
.DM
	route add default sl0
	route add 199.199.10.2 ne0
	route add 199.199.10.3 ne0
.DE
The routing tables for sites
.B coolcoh
and
.B slick
are:
.DM
	default         ne0
.DE
Add the following command to each site's startup script:
.DM
	route add default ne0
.DE
If your Internet provider can be persuaded to route all datagrams
destined for network 199.199.10.0 to site
.B cocoh
(if it is up), then sites
.B coolcoh
and
.B slick
will be able to
.BR ftp ,
.BR telnet ,
etc., over the Internet.
.PP
If the Internet provider provides excellent service,
he might be persuaded to provide entries in his name server to
resolve the names
.B coolcoh.gate.com
and
.B slick.gate.com
as well as
.BR cocoh.gate.com .
You'll probably need to buy full-time connectivity
to get this level of service, but that is what is needed for all the
Internet world to be able to find you by name.
.PP
This kind of network is acceptable for many more hosts on the Ethernet than the
simple 3 that are shown here.
Note, however, that there is two big limitation to this arrangement.
First, the machines on the LAN can access the Internet only while the machine
with SLIP is dialed into your Internet provider.
Second,
.B cohulip
is not robust enough to know whether a machine on the LAN is ``on the air''
or not; thus, it cannot send the message ``host unreachable''
should someone the Internet attempt to send a datagram to a machine on
your LAN that was inaccessible.
If, however, intermittent access is acceptable on your LAN, and if
you are willing to subject remote users to a ``no answer'' situation
rather than the pleasanter ``host unreachable'' message, then
.B cohulip
can provide some rudimentary but useful routing services.
.Sh "Firewall Between Networks"
.PP
If the Internet service provider does not co-operate, then you must
use a two-step transfer to move data between the Ethernet-only
machines and the Internet.
In this way,
.B cohulip
can serve as a firewall between two networks.
In this method, you run two versions of
.BR net :
one configured for Ethernet and the other for SLIP.
.PP
To begin,
you must create two versions of your startup script:
one for the network accessed via SLIP, and the other for the network
accessed via Ethernet.
Call one
.B startup.slip
and the other
.BR startup.ether .
.PP
.B startup.net
should invoke the
.B telunix
server as well as those for TELNET and FTP.
Invoke it with the command:
.DM
	net startup.ether
.DE
Let this copy of
.B net
run all the time.
You can embed the command in script
.BR /etc/rc ,
so that it is invoked automatically when you boot your system.
.PP
.B startup.slip
should be configured for SLIP, and to dial the Internet provider.
A user on a machine with Ethernet-only access would use
.B telunix
to log into the ``firewall'' machine, then run the command
.DM
	net startup.slip
.DE
to access the Internet.
In this way, all users on all Ethernet machines can
access the Internet via SLIP,
but the Internet cannot have access to anything on your Ethernet.
.SH "telunix \(em Remote Login"
.PP
The
.B telunix
server lets users on remote system log into your system via the application
.BR telnet .
Unlike
.BR telnet ,
.B telunix
provides a modicum of login protection for your system.
.PP
Before you can use
.BR telunix ,
you must have installed pseudo-ttys into your kernel.
If you did not do so when you installed \*(CO onto your system, you can do
so now.
For information on how to do this, read the entry for
.B pty
in the \*(CO Lexicon.
.PP
To enable the login server,
use the command:
.DM
	start telunix
.DE
You can give this either from command prompt or from within a startup file.
By default, the login server is connected to socket 513; however,
.B telunix
takes an optional second argument with which you can set the socket
to which the is connected.
.PP
If a user simply closes the TELNET session while logged in, it appears
that the login closes normally, but there is no mechanism for closing the
TELNET session when a user logs out.
Also, there is no processing of user's end-of-line sequence.
You may wish to put something like the following into file
.B $HOME/.profile
of every user who will log in only via
.BR telunix :
.DM
	stty -echo
	echo "Welcome Message ..."
	echo "To prevent double prompts, do "eol unix" before starting telnet." 
	echo "Use "exit" to log off, then "close" from your end to close session."
	cd /usr/public  # or whatever you want to do with him...
.DE
What you do with this guy after he logs on to your machine is up to you.
.SH "Traffic Jams on the Information Superhighway"
.PP
Computer networks, like disk drives, suffer from a corollary to
Parkinson's Law:
that is, data immediately increases to fill the space available to it.
However, there are ways to cope with this congestion, to ensure that
your jobs are executed as quickly as possible.
.PP
The following information should be helpful to user who use
.BR cohulip 's
SLIP to access the Internet.
The information can also be applied to busy LANs over Ethernet.
.II "Wright, Randy"
It was adapted from mail messages written by Randy Wright.
.PP
To begin, you must remember that traffic conditions on the Internet
vary from second to second.
Sometimes the traffic is heavy; other times, it is light.
(The easiest solution to a congestion problem is to defer your
Internet work until traffic light \(em generally, during the middle
of the night.)
It is also worth noting that some
Internet providers oversell their bandwidth.
You may be sharing a 56-kilobaud link with another 50 sites, or more.
.PP
These situations present traffic situations to which TCP reacts
in defined ways.
Thus, you can tune TCP to react optimally to various traffic loads.
.Sh "Basics of TCP"
.PP
This is a
.I simplified
explanation of some TCP features.
It is somewhat technical, but it has been trimmed and edited to make it
easier for novices to grasp.
.PP
TCP has some sophisticated mechanisms to detect and respond to
network errors and slowdowns.
It keeps track of how long the typical round-trip time
is between the endpoints of the connection.
.II SRTT
.II "smoothed round-trip time"
Using statistical techniques, it constantly updates a value
known as the smoothed round-trip time (SRTT), and the mean
deviation from that SRTT.
The values lets your local host determine how long it should expect
to wait before the remote host acknowledges the data it has sent.
.II "timeout value"
We will call this interval of time the
.IR "timeout value" .
And yes, TCP does expect the remote host to acknowledge receipt of every
byte sent.
This mechanism stops TCP from jamming more data into a
connection may already be choked with data.
.PP
.II "window size"
TCP has a user-settable number known as the
.IR "window size" .
TCP will not allow more than that window-size bytes of data to be
unacknowledged at any one time.
Thus, no more than
.I window-size
bytes can be unacknowledged for
.I timeout
miliseconds before TCP concludes that something went wrong
and begins to retransmit the unacknowledged data.
.PP
In brief, a TCP sender expects the TCP receiver to say ``thank you''
for each byte received.
If the gratitude is not forthcoming,
a TCP sender, in effect, clears its throat and restates itself
over and over until the receiver responds correctly.
The sender will not stop asking for acknowledgement until hell freezes over.
.PP
If the dialogue between the TCP receiver and the TCP sender
gets out of hand, a higher-level protocol (such as FTP)
or the user may intervene, usually by aborting the connection.
.BR cohulip 's
implementation of FTP
is not robust enough to detect a stalled transfer, so you must do it by hand.
.PP
If traffic is light on the networks and no equipment is malfunctioning,
the acknowledgements normally do arrive before TCP's timeout occurs.
However, if there is heavy traffic, datagrams can get stuck in long queues
that exists all over the networks.
Remember, to get from your local host to the remote host, a datagram must
pass through several intervening machines, perhaps as many as a dozen or more.
.II routing
(The number of machines through which the datagram must pass is based on the
.I routing
by which the datagram moves from your machine to the remote host.
Routing is something of a black art, and is discussed elsewhere.)
.PP
When the TCP sender does not receive acknowledgement of the receipt of
a datagram within the expected time, it enters a kind of congestion mode.
It retransmits the unacknowledged datagram (or datagrams), but
uses a special
.I backoff
facility to increase the timeout \(em that is, to back off from
retransmission.
The sender will retransmit repeatedly until it receives an acknowledgement;
however, with each retransmission, it increases its timeout value.
This mechanism of increasing the timeout value is part of the TCP protocol;
it is designed to help prevent the ``gridlock'' that occurs on the Internet
when sending sites continually retransmit data into a choked connection.
.Sh "How To Tune Your TCP Timer"
.PP
TCP limits how much it will increase its timeout value \(em that is,
it limits the degree to which it will back off from retransmission.
We call this value its
.IR "maximum backoff" .
.PP
.B cohulip
offers two differs ways by which TCP can compute its backoff value:
linear and exponential.
.I Linear
computation increases the timeout by an equal ammount with each retransmission.
.I Exponential
computation doubles the timeout with each retransmission.
.PP
At the prompt
.BR net> ,
you can change the timer type and maximum backoff.
The command is:
.DM
	tcp timer [linear|exponential] [<max backoff minutes>]
.DE
The default is a linear computation and a 30-minute maximum backoff.
As delivered,
.B cohulip
does not allow you to set the maximum backoff to more than five minutes.
If your connection's timeout value has increased to one minute,
in all probability the connection is broken and you should quit.
.PP
Note that if your modem overruns the serial port,
your TCP system can be fooled into believing there is a congestion problem.
You should use a 16550 UART if your modem is faster than 2400 baud.
For details, see the entries for
.B modem
and
.B asy
in the \*(CO Lexicon.
.Sh "How To Detect Congestion"
.PP
On a TELNET session, congestion is obvious:
when you type a key, nothing happens.
.PP
On an FTP session, however, it is more difficult to detect congestion, because
FTP does much of its work silently, in the background.
.II "ftp^hash"
Before you use FTP to transmit or receive a file,
you should type the command
.B hash
at the
.BR ftp>
prompt.
This tells FTP
to display the ``hash'' character `#' whenever it sends or receive
one kilobyte of data.
(Note that FTP's
hash command has nothing to do with hash tables, which is a programming
technique for looking up data quickly.)
.II "ftp^abort"
This feature lets you observe the movement of data;
if transmission appears to be stalled, you can then invoke the FTP command
.B abort
to abort the transmission, and try again later.
.PP
.II "tcp^status"
To observe TCP's status in detail, use
.BR net 's
command
.BR "tcp status" .
(NB, you must enter this command at the prompt
.BR net> ;
it will not do anything if you type it at the
.B ftp>
prompt.)
This command comes in two flavors:
.DS
	\fBtcp status\fR
	\fBtcp status \fItcb\fR
.DE
The first version of this command lists all the
TCP connections or potential connections currently available.
The following gives an example of its output:
.DM
	conout 1, conin 0, reset out 0, runt 0, chksum err 0, bdcsts 0
	    &TCB RcvQ SndQ Local socket            Remote socket           State
	  406284    0    0 stalo:1001              rwsyss.wimsey.b:ftp     Estab.
	  405ebc    0    0 stalo:echo              0.0.0.0:0               Listen   (S)
	  40608c    0    0 stalo:telnet            0.0.0.0:0               Listen   (S)
	  405fa4    0    0 stalo:ftp               0.0.0.0:0               Listen   (S)
.DE
This display shows that there is one
.B conout
(or outgoing connection),
and that it is an FTP conection between systems
.B stalo
and
.BR rwsyss .
.II "datagram^runt"
The first line of the status display also states that there have been
no runt datagrams (i.e., no datagrams that are too small),
and no checksum errors (i.e., your modem is operating correctly).
.PP
The second version of the command
.B "tcp status"
displays detailed information about a given TCP session.
.II "TCP control block"
.II TCB
To elicit this information, you must pass
.B "tcp status"
the address of the TCP session's TCP control block (TCB).
In the above display, a session's TCB is the hexadecimal number
in the column that is headed
.BR &TCB .
.PP
For example, the above display shows that TCB of the FTP session connecting
.B stalo
and
.B rwsyss
has an address of 406284.
Therefore, to see detailed information on this session, we type:
.DM
	tcp status 406284
.DE
This displays the following:
.DM
	Local: stalo:1001 Remote: rwsyss.wimsey.b:ftp State: Estab.
	      Init seq    Unack     Next Resent CWind Thrsh  Wind  MSS Queue      Total
	Send:   1e8480   1e8497   1e8497      0  1047 65535  4096 1024     0         22
	Recv: db5b68c3          db5b6951      0              6000          0        141
	Backoff 0 Timer stopped SRTT 1449 ms Mean dev 835 ms
.DE
This tells me some details on our FTP connection between
.B stalo
and
.BR rwsyss .
In particular, the fifth line of the status display shows the condition
of the timer; we will call this the
.IR "timer-status line" .
.PP
In the above example, the timer-status line has four fields:
.DS
	Backoff value
	Timer state (started or stopped)
	SRTT time, in milliseconds
	Mean deviation, in milliseconds
.DE
The backoff value is an integer from 0 to 255.
This value gives the total backoff time in terms of a number of multiples
of the standard backoff time.
Remember that when TCP retransmits a datagram, it increases the total backoff
time:
if it is using the linear method, it adds the standard backoff time to the
total backoff time; whereas if it is using the exponential method, it doubles
the total backoff time.
If the backoff value is greater than zero, TCP has begun to retransmit
datagrams;
if you know the method by which TCP computes the total backoff time,
you can quickly figure out how many times TCP has retransmitted a datagram.
.PP
The timer state gives the state of the time:
either
.B stopped
or
.BR running .
If the timer state is
.BR running ,
the timer-status line also shows the amount of time left to run,
and the current timeout value in milliseconds.
.PP
Under good conditions, the value of backoff stays at zero or 1.
If the value of backoff reaches ten,
the timer will probably be running and it will be
nearing one minute between retries; at this point,
you probably should try to leave off the Internet, because you are running
up your telephone bill for no good purpose.
.Sh "What To Do If TCP Is Jammed"
.PP
First, you can ``kick'' TCP.
There are two ways to do this.
.PP
.II kick
If the current session is the one you want to kick, just go to the
.B net>
prompt and type:
.DM
	kick
.DE
.II "tcp^kick"
But if you want to kick your FTP data connection or the connection
of some incoming session with your servers, use the command
.DS
	tcp kick \fItcb_address\fR
.DE
where
.I tcp_address
is the address of the session's TCP control block, as displayed by the command
.BR "tcp status" .
This command forces TCP to retransmit immediately any unsent data or
acknowledgment datagrams.
.PP
The ``kick'' commands
do not help if you are the receiving a file via FTP.
Only the sending party can kick things effectively.
.PP
Second, trying increasing the size of the window and the MSS.
When you installed
.BR cohulip ,
the installation program embedded the commands
.DM
	tcp mss 1500
	tcp window 1500
.DE
in your default startup script.
You can try increasing these values, for example, to 6,000 bytes.
The larger the size of a datagram, the more efficient your connection
will be \(em within reason, of course.
Note that increasing the size of a value will not affect the operation of
any sessions that are being executed at that moment.
.PP
When you connect to a remote site, your site and it negotiate over the
maximum size of a datagram, with the smaller of the two values being used.
You can use the command
.B trace
to copy that negotiation into a file.
If the remote site ``bids'' a very large size for datagrams,
you probably can increase the size of your datagrams without risking that
a site that stands between you and the remote host will fragment your
datagrams.
.PP
If all else fails, try working late at night.

.SH "C for Beginners"
.II "introduction to C programming"
.II "C programming^introduction"
.PP
This section briefly introduces the C programming language.
It is in two parts.
The first part describes what a programming language is, and
gives the history of the C programming language.
It also introduces some concepts basic to C, such as
.IR "structured programming" ,
.IR pointer ,
and
.IR operator .
The second part walks through a C programming session.
It emphasizes how a C programmer deals with a real problem, and
demonstrates some aspects of the language.
.PP
This chapter is not designed to teach you the entire C language.
It introduces you to C, so you can read
the rest of this manual with some understanding.
We urge you to look up individual topics of C programming in
the Lexicon, and especially to study the example programs given there.
.Sh "Programming Languages and C"
.PP
Before beginning with C, it is worthwhile to review how a
microprocessor and a computer language work.
.PP
.II microprocessor
A \fImicroprocessor\fR is the part of your computer that actually computes.
.II instructions
Built into it is a group of \fIinstructions\fR.
Each instruction tells the microprocessor to perform a task;
for example, one instruction adds two numbers together,
another stores the result of an arithmetic operation in memory,
and a third copies data from one point in memory to another.
.PP
.II "instruction set"
Together, a microprocessor's instructions form its \fIinstruction set\fR.
The instruction set is, in effect, the microprocessor's
\*(QLnative language\*(QR.
.PP
A microprocessor also contains areas of very
fast storage, called \fIregisters\fR.
.II register
The registers are essential to
arithmetic and data handling within the microprocessor.
How many registers a microprocessor has, and how they are designed,
help to determine how much memory the microprocessor can read and write, or
\fIaddress\fR, and how the microprocessor handles data.
.II address
.PP
.II "computer language"
A \fIcomputer language\fR, as the name implies, lets a human being
use the microprocessor's instruction set.
.II "assembly language"
The lowest level language is called \*(QLassembly language\*(QR.
In assembly language, the programmer calls instructions
directly from the microcomputer's instruction set, and
manipulates the registers within the microprocessor.
To write programs in assembly language, a programmer must
know both the microprocessor's instruction set and the
configuration of its registers.
.Sh "Assembly and High-Level Languages"
.PP
With assembly language,
the programmer can tailor the program specifically to the microprocessor.
However, because each microprocessor has
a unique instruction set and configuration of registers, a
program written in one microprocessor's assembly language cannot
be run on another microprocessor.
For example, no program
written in the assembly language for the Motorola 68000 microprocessor
can be run on the \*(BM or any \f(SCPC\fP-compatible computer.
The program must be entirely rewritten in the assembly language for
the Intel microprocessor, which is difficult and time consuming.
.PP
.II "high-level language"
A \fIhigh-level language\fR helps programmers to avoid these problems.
The programmer does not need to know the microprocessor in detail;
instead of specific microprocessor instructions, he writes a set of
logical constructions.
These constructions are then handed to another program,
which translates them into the
instructions and register calls used by a specific microprocessor.
In theory, a program written in a high-level language can be run on
any microprocessor for which someone has written a translation program.
.PP
A high-level language
allows the programmer to concentrate on the task being executed,
rather than on the details of registers and instructions.
This means that programs can be written more quickly than in assembly
language, and can be maintained more easily.
.Sh "So, What Is C?"
.PP
.II "Ritchie, Dennis"
As noted earlier, C was invented at AT&T Bell Laboratories
by Dennis Ritchie and Ken Thompson.
They created C specifically to re-write the
\*(UN operating system from PDP-11 assembly language.
Ritchie designed C to have the power, speed,
and flexibility of assembly language,
but the portability of high-level languages.
.PP
.II "Kernighan, Brian W."
.II "The C Programming Language"
In 1978, Ritchie and Brian W. Kernighan published
\fIThe C Programming Language\fR,
which described and defined the C language.
.II ANSI
In 1988, the American National Standards Institute (ANSI) published its
standard for the C language.
This standard has, on the whole, become the basis for current implementations
of C.
.PP
Because C is modeled after assembly language,
it has been called a \*(QLmedium-level\*(QR language.
The programmer doesn't have to worry about specific registers or specific
instructions, but he can use all of the
power of the computer almost as directly as he can with assembly language.
.PP
Because C was written by experienced programmers for experienced programmers,
it makes little effort to protect a programmer from himself.
A programmer can easily write a C program that is
legal and compiles correctly but crashes when run.
.II operators
Also, C's punctuation marks,
or \*(QLoperators\*(QR, closely resemble each other.
Thus, a mistake in typing can create a legal
program that compiles correctly but behaves very differently from what
you expect.
.Sh "Structured Programming"
.II "structured programming"
.PP
C is a \fIstructured language\fR.
This means that a C program is assembled from a number of sub-programs,
or \fIfunctions\fR, each of which performs a discrete task.
If this concept is difficult to grasp, consider the following example.
.PP
Suppose you want to turn a file of text into upper-case letters
and print it on the screen.
This job seems simple, but a program to do it must perform five tasks:
.IP \fB1.\fR 0.3i
Read the name of the file to open.
.IP \fB2.\fR
Open the file so it can be read, in much the same way that you
must open a book before you can read it.
.IP \fB3.\fR
Read the text from the file.
.IP \fB4.\fR
Turn what is read into upper-case letters.
.IP \fB5.\fR
Print the transformed text onto the screen.
.PP
A good program will also perform the following tasks:
.IP \fB1.\fR 0.3i
Check that the file requested actually exists.
.IP \fB2.\fR
Check that the file requested is actually a
text file rather than a file of binary information;
the latter makes very little sense when printed on the screen.
.IP \fB3.\fR
Close the program neatly when the work is finished.
.IP \fB4.\fR
Stop processing and print an error message if a problem occurs.
.PP
A structured language like C allows you to write a separate function
for each of these tasks.
.PP
.II function
A structured programming language offers two major advantages
over a non-structured language.
First, it is easier to debug a function than an
entire program because the function can be unplugged from the
program as a whole, made to work correctly, and then plugged back in again.
Second, once a function works, it can be used again and again in
different programs.
.II library
This allows you to create a \fIlibrary\fR of
reliable functions that you can pull off the shelf whenever you need them.
.PP
The functions within a program communicate by passing values to each other.
The value being passed can be an integer, a character, or \(em most
commonly \(em an address within memory where a function can
find data to manipulate.
.II pointer
This passing of addresses, or \fIpointers\fR, is the most efficient way to
manipulate data because by receiving one number, a function
can find its way to a large amount of data.
This speeds up a program's execution.
.PP
C adds some extra tools to help you construct programs.
To begin, C allows you to store functions in compiled form.
These precompiled functions are added only when the program is finally
loaded into memory; this spares you the trouble of having to recompile
the same code again and again.
.II macro
.II "header file"
Second, C adds a preprocessor that expands definitions, or \fImacros\fR,
and pulls in special material stored in \fIheader files\fR.
This allows you to store often-used
definitions in one file and use them just by adding one line to your program.
.Sh "Writing a C Program"
.PP
As noted above, a C program consists of a bundle of sub-programs,
or \fIfunctions\fR, which link together to perform the task you want done.
.II main()
Every C program must have one function that is called \fBmain\fR.
This is the main function; when the computer reads this,
it knows that it must begin to execute the program.
All other functions are subordinate to \fBmain\fR.
When the \fBmain\fR function is finished, the program is over.
.PP
To see how these elements work, review the program \fBhello.c\fR,
which you worked with earlier in this tutorial:
.DM
	main()
	{
		printf("Hello, world\en");
	}
.DE
As you can see, this program begins with the word \fBmain\fR.
The program begins to work at this point.
.II argument
The parentheses after \fBmain\fR
enclose all of the \fIarguments\fR to \fBmain\fR \(em or would, if
this program's \fBmain\fR took any.
An argument is an item of information that a function uses in its work.
.PP
.II braces
The braces \*(Ql{\*(Qr and \*(Ql}\*(Qr
enclose all the material that is subsidiary to \fBmain\fR.
.PP
.II printf()
The word
\*(QLprintf\*(QR \fIcalls\fR a function called \fBprintf()\fR.
This function performs formatted printing.
The line of characters (or \*(QLstring\*(QR) \fIHello, world\fR
is the argument to \fBprintf()\fR:
this argument is what \fBprintf()\fR is to print.
.PP
.II "carriage return"
The characters \*(Ql\en\*(Qr stand for a newline character.
This character ``tosses the carriage'', or moves the cursor to a new
line and returns it to the leftmost column on your screen.
Using this character ensures that when printing is finished,
the cursor is not left fixed in the middle of the screen.
.II semicolon
Finally, the semicolon \*(Ql;\*(Qr at the end of the command
indicates that the function call is finished.
.PP
One point to remember is that \fBprintf()\fR is \fInot\fR part of
the C language.
Rather, it is a \fIfunction\fR that was written by Mark Williams Company,
then compiled and stored in a library for your use.
This means that you do not have to re-invent a formatted printing
function to perform this simple task:
all you have to do is \fIcall\fR the one that Mark Williams has written
for you.
.PP
Although most C programs are more complicated than this example,
every C program has the same elements:
a function called \fBmain()\fR, which marks where execution begins and ends;
braces that fence off blocks of code;
functions that are called from libraries;
and data passed to functions in the form of arguments.
.SH "A Sample C Programming Session"
.PP
This section walks you through a C programming session.
It shows how you can go about planning and writing a program in C.
.PP
C allows you to be precise in your programming,
which should make you a stronger programmer.
Be careful, however, because C does exactly what you tell it to do,
nothing more and nothing less.
If you make a mistake, you can produce
a legal C program that does very unexpected things.
.Sh "Designing a Program"
.PP
Most programmers prefer to work on a program that does something fun or useful.
Therefore, we will write something useful:
a version of the \*(CO utility
.BR scat ,
that we'll call
.BR display .
It will do the following:
.IP 1. 0.3i
Open a text file on disk.
.IP "2."
Display its contents in 23-line chunks (one full screen).
.IP "3."
After displaying a chunk,
wait to see if the user wants to see another chunk.
If the user presses the \fB<return>\fR key alone, display another chunk;
if the user types any other key before pressing the \fB<return>\fR key, exit.
.IP "4."
Exit automatically when the end of file is reached.
.PP
As you can see, the first step in writing a program is to
write down what the program is to do, in as much detail as you
can manage, and preferably in complete sentences.
.PP
Now, invoke \fBed\fR or \*(ME and get ready to type in the program:
.DM
	ed display.c
.DE
or:
.DM
	me display.c
.DE
We suggest that you use the \*(ME editor, because this tutorial will
make numerous changes to the program as it progresses and it will be easier
to see these changes in context if you use a screen editor rather than a
line editor.
The rest of this tutorial assumes that you are using \*(ME.
If you are not familiar with \*(ME, it is briefly described in
\fIUsing the COHERENT System\fR.
A tutorial for \*(ME also appears in this manual,
or you may wish to see the entry for \fBme\fR in the Lexicon.
.PP
In the above commands, the suffix
.B .c
on the file name indicates that this is a file of C code.
If you do not use this suffix, the \fBcc\fR command will not recognize
that this is a file of C code and will refuse to compile it.
.PP
.II comment
Begin by inserting a description of the program into the top of the file in
the form of a
.IR comment .
When a C compiler sees the symbol
\*(Ql/*\*(Qr, it throws away everything it reads until it sees the symbol
\*(Ql*/\*(Qr.
This lets you insert text into your program to explain
what the program does.
.PP
Type the following:
.ID
/*
 * Truncated version of the 'scat' utility.
 * Open a file, print out 23 lines, wait.
 * If user types <return>, print another 23 lines.
 * If user types any other key, exit.
 * Exit when EOF is read.
 */
.IE
Save what you have typed by pressing \fB<ctrl-X>\fR and then \fB<ctrl-S>\fR.
Now, anyone, including you, who looks at this program will know exactly
what it is meant to do.
.Sh "The main() Function"
.PP
As described earlier, the C language permits
.IR "structured programming" .
This means that you can break your program into a group of discrete
functions, each of which performs one task.
Each function can be perfected by itself, and then used again and again
when you need to execute its task.
C requires, however, that you signal which function is the \fImain()\fR
function, the one that controls the operation of the other functions.
Thus, each C program must have a function called
.BR main() .
.PP
.II main()
Now, add
.B main()
to your program.
Type the code that is shaded, below:
.ID
/*
 * Truncated version of the 'scat' utility.
 * Open a file, print out 23 lines, wait.
 * If user types <return>, print another 23 lines.
 * If user types any other key, exit.
 * Exit when EOF is read.
 */
.IE
.ID
.SL
main()
.SL
{
.SL
}
.IE
The parentheses \*(QL()\*(QR show that
.B main()
is a function.
If \fBmain()\fR were to take any arguments,
they would be named between the parentheses.
The braces \*(QL{}\*(QR delimit all code that is subordinate to
.BR main() ;
this will be explained in more detail below.
.PP
Note that the shortest legal C program is
.BR main(){} .
This program doesn't do anything when you run it,
but it will compile correctly and generate an executable file.
.PP
Now, try compiling the program.
Save your text by typing
.BR <ctrl-X><ctrl-S> ,
and then exit from the editor by typing
.BR <ctrl-X><ctrl-C> .
Compile the program by typing:
.ID
	cc display.c
.IE
When compilation is finished, type
.BR display .
The shell will pause briefly, then return the prompt to your screen.
As you can see, you now have a legal, compilable C program, but one
that does nothing.
.Sh "Open a File and Show Text"
.PP
The next step is to install routines that open a file and print
its contents.
For the moment, the program will read only a file called \fBdisplay.c\fR,
and not break it into 23-line portions.
.PP
Type the shaded lines into your program, as follows:
.ID
/*
 * Truncated version of the 'scat' utility.
 * Open a file, print out 23 lines, wait.
 * If user types <return>, print another 23 lines.
 * If user types any other key, exit.
 * Exit when EOF is read.
 */
.IE
.ID
.SL
#include <stdio.h>
.sp \n(PDu
main()
{
.SL
	char string[128];
.SL
	FILE *fileptr;
.IE
.ID
.SL
/* Open file */
.SL
	fileptr = fopen("display.c", "r");
.IE
.ID
.SL
/* Read material and display it */
.SL
	for (;;) {
.SL
		fgets(string, 128, fileptr);
.SL
		printf("%s", string);
.SL
	}
}
.IE
Note first how comments are inserted into the text, to guide the reader.
.PP
Now, note the lines
.ID
	char string[128];
	FILE *fileptr;
.IE
.II char
.II FILE
These
.I declare
two data structures.
.II "data structure"
That is, they tell \*(PN to set aside a specific amount of memory for them.
.PP
.II array
The first declaration, \fBchar string[128];\fR,
declares an array of 128 \fBchar\fRs.
A \fBchar\fR is a data entity that is exactly one byte long;
this is enough space to store exactly one alphanumeric character in memory,
hence its name.
An \fIarray\fR is a set of data elements that are recorded together in memory.
In this instance, the declaration sets aside 128 \fBchar\fRs-worth
of memory.
This declaration reserves space in memory
to hold the data that your program reads.
.PP
.II pointer
The second declaration, \fBFILE *fileptr\fR, declares a
.I pointer
to a \fBFILE\fR structure.
The asterisk shows that the data element points to something,
rather than being the thing itself.
When a variable is declared to be a pointer, the C compiler
sets aside enough space in memory to hold an \fIaddress\fR.
.II address
When your program reads that address, it then knows where the
actual data are residing, and looks for them there.
C uses pointers extensively, because it is much more efficient to
pass the address of data than to pass the data themselves.
You may find the concept of pointers to be a little difficult to grasp;
however, as you gain experience with C, you will find that
they become easy to use.
.PP
.II structure
The \fBFILE\fR structure is the data entity that holds all the
information your program needs to read information from or write
information to a file on the disk.
For a detailed discussion of the \fBFILE\fR structure, see its entry
in the Lexicon.
For now, all you need to remember is that this declaration
sets aside a place to hold a pointer to such a structure, and the
structure itself holds all of the information your program needs
to manipulate a file on disk.
In effect, the variable
.B fileptr
is used within your program as a synonym for the file itself.
.PP
Now, the line
.ID
	fileptr = fopen("display.c", "r");
.IE
.II fopen()
opens the file to be read.
The function
.B fopen()
\fIopens\fR the file, fills the
.B FILE
structure,
and fills the variable
.B fileptr
with the address of where that structure resides in memory.
.PP
.B fopen()
takes two arguments.
The first is the name of the file to be opened, within quotation marks.
The second argument indicates the
.I mode
in which to open the file;
.B r
indicates that the file will be read rather than written into.
.PP
The lines
.ID
	for(;;)
	{
.IE
.II for
begin a
.IR loop .
.II loop
A loop is a section of code that is executed repeatedly until a
condition that you set is fulfilled.
For example, you may define a loop that executes until the
value of a particular variable becomes greater than zero.
.PP
.B for
is built into the C language.
Note that it has braces, just like
.B main()
does; these braces
mean that the following lines, up to the next right brace (\fB}\fR)
are part of this loop.
You can set conditions that control how a
.B for
loop operates; in its present form, it will loop forever.
This will be explained in more detail shortly.
.PP
Two library functions are executed within the loop.
The first,
.ID
	fgets(string, 128, fileptr);
.IE
.II fgets()
reads a line from the file named in the
.B fileptr
variable, and writes it into the character array called
.BR string .
The middle argument ensures that no more than 128 characters will be
read at a time.
The second line within this loop,
.ID
	printf("%s", string);
.IE
.II printf()
prints the line.
.B printf()
is a powerful and subtle function; in its present form,
it prints on the screen the string contained in the variable
.IR string .
.PP
Finally, the line at the top of the program:
.ID
	#include <stdio.h>
.IE
.II #include
tells the C preprocessor \fBcpp\fR to read the
.I "header file"
.II "header file"
called
.BR stdio.h .
.II stdio.h
The term \*(QLSTDIO\*(QR stands for \*(QLstandard input and output\*(QR;
.B stdio.h
declares and defines a number of routines that will
be used to read data from a file and write them onto the screen.
.PP
When you have finished typing in this code, again compile the program
as you did earlier.
If an error occurs, check what you have typed and make sure that it
\fIexactly\fR matches the code shown on the previous page.
If you find any errors, fix them and then recompile.
If errors persist, check it in the table of error messages that appear
at the end of this tutorial.
.PP
When compilation is finished, execute \fBdisplay\fR as you did earlier.
You will see the text from
.B display.c
scroll across the screen.
When the text is finished, however, the \*(CO prompt does not return;
you have not yet inserted code that tells the program to recognize that
the file is finished.
Type
.B <ctrl-C>
to break the program and return to \*(CO.
.Sh "Accepting File Names"
.PP
Of course, you will want \fBdisplay\fR to be able to display the
contents of any file, not just files named
.BR display.c .
The next step is to add code that lets you pass arguments to the
program through its command line.
This task requires that you give the
.B main()
function two arguments.
By tradition, these are always called
.B argc
and
.BR argv .
How they work will be described in a moment.
.II argc
.II argv
.PP
The enhanced program appears as follows.
You should change or insert the lines that are shaded:
.ID
/*
 * Truncated version of the 'scat' utility.
 * Open a file, print out 23 lines, wait.
 * If user types <return>, print another 23 lines.
 * If user types any other key, exit.
 * Exit when EOF is read.
 */
.IE
.ID
#include <stdio.h>
.SL
#define MAXCHAR 128
.IE
.ID
.SL
main(argc, argv)
.SL
/* Declare arguments to main() */
.SL
int argc;
.SL
char *argv[];
{
.SL
	char string[MAXCHAR];
	FILE *fileptr;
.IE
.ID
/* Open file */
.SL
	fileptr = fopen(argv[1], "r");
.IE
.ID
/* Read material and display it */
	for (;;) {
.SL
		fgets(string, MAXCHAR, fileptr);
		printf("%s", string);
	}
}
.IE
First, a small change has been added:
the line
.ID
	#define MAXCHAR 128
.IE
.II #define
defines the
.I "manifest constant"
.B MAXCHAR
to be equivalent to 128.
This is done because the \*(QLmagic number\*(QR 128 is used throughout
the program.
If you decide to change the number of characters
that this program can handle at once, all you would have to do is
to change this one line to alter the entire program.
This cuts down on mistakes in altering and updating the program.
If you look lower in the program, you will see that the declaration
.ID
	char string[128]
.IE
has been changed to read
.ID
	char string[MAXCHAR]
.IE
The two forms are equivalent;
the only difference is that the latter is easier to use.
It is a good idea to use manifest constants wherever possible,
to streamline changes to your program.
.PP
Now, look at the line that declares
.BR main() .
You will see that
.B main()
now has two arguments:
.B argc
and
.BR argv .
.PP
The first is an
.BR int ,
.II int
or integer, as shown by its declaration \(em \fBint argc;\fR.
.B argc
gives the
.I number
of entries typed on a command line.
For example, when you typed
.ID
	display filename
.IE
the value of \fBargc\fR was set to two:
one for the command name itself, and one for the file-name argument.
.B argc
and its value are set by the compiler.
You do not have to do anything to ensure that this value is set correctly.
.PP
.BR argv ,
on the other hand,
is an array of pointers to the command line's arguments.
In this instance, \fBargv[1]\fR points to
name of the file that you want \fBdisplay\fR to read.
This, too, is set by \*(PN, and works automatically.
.PP
.II fopen()
If you look below at the line that declares
.BR fopen() ,
you will see that
.B display.c
has been replaced with
.BR argv[1] ;
this means that you want
.B fopen()
to open the file named in the first argument to the \fBdisplay\fR command.
.PP
Now, try running the program by typing
.ID
	display display.c
.IE
Be sure that you give the command only one file name as an argument,
no more and no less.
Code that checks against errors has not yet been inserted,
and handing it the wrong number of arguments could cause problems for you.
.PP
.B display
will open
.B display.c
and print its contents on the screen.
You still need to type \fB<ctrl-C>\fR when printing is finished;
the code to recognize the end of the file will be inserted later.
.Sh "Error Checking"
.PP
Obviously, the program runs at this stage, but is still fragile,
and could cause problems.
The next step is to stabilize the program by writing code to check for errors.
To do so, a programmer must first write code to capture error conditions,
and then write a routine to react appropriately to an error.
.PP
Our edited program now appears as follows:
.ID
/*
 * Truncated version of the 'scat' utility.
 * Open a file, print out 23 lines, wait.
 * If user types <return>, print another 23 lines.
 * If user types any other key, exit.
 * Exit when EOF is read.
 */
.IE
.ID
#include <stdio.h>
#define MAXCHAR 128
.IE
.ID
main(argc, argv)
/* define arguments to main() */
int argc;
char *argv[];
{
	char string[MAXCHAR];
	FILE *fileptr;
.IE
.ID
.SL
/* Check if right number of arguments was passed */
.SL
	if (argc != 2)
.SL
		error("Usage: display filename");
.IE
.ID
/* Open file */
.SL
	if ((fileptr = fopen(argv[1], "r")) == NULL)
.SL
		error("Cannot open file");
.IE
.ID
/* Read material and display it */
	for (;;) {
		fgets(string, MAXCHAR, fileptr);
		printf("%s", string);
	}
}
.IE
.ID
.SL
/* Process error messages */
.SL
error(message)
.SL
char *message;
.SL
{
.SL
	printf("%s", message);
.SL
	exit(1);
.SL
}
.IE
The additions to the program are introduced by comments.
.PP
The first addition
.ID
	if (argc != 2)
		error("Usage:  display filename");
.IE
checks to see if the correct number of arguments was passed on the command line;
that is to say, it checks to make sure that you named a file
when you typed the \fBdisplay\fR command.
.PP
As noted above,
.B argc
is the number of arguments on the command line, or rather, the
number of arguments plus one, because the command name itself is
always considered to be an argument.
The statement \fBif (argc != 2)\fR checks this.
The
.B if
statement is built into C.
If the condition defined between its parentheses is true, then do
something, but if it is not true, do nothing at all.
The operator
.B !=
means \*(QLdoes not equal\*(QR.
Therefore, our statement means that if \fBargc\fR is not
equal to two (in other words, if there are not two and only two
arguments to the \fBdisplay\fR command \(em the command name itself plus
a file name), execute the function
.BR error .
.B error
is defined below.
.PP
Our
.B fopen()
function also has some error checking added (which will be
described in a moment):
.ID
	if ((fileptr = fopen(argv[1], "r")) == NULL)
		error("Cannot open file");
.IE
.II fopen()
.B fopen()
returns a value called \*(QLNULL\*(QR
.II NULL
if, for any reason, it cannot open the file you requested.
Thus, our new
.B if
statement says that if
.B fopen()
cannot open the file named on the command line
(that is,
.BR argv[1] ),
it should invoke the
.B error()
function.
.PP
C always executes nested functions from the \*(QLinside out\*(QR.
That means that the innermost function (that is, the function that
is enclosed most deeply within the pairs of parentheses) is executed first.
Its result, or what it \fIreturns\fR, is then passed to next
outermost function as an argument; that function is then executed
and what it returns is, in turn, passed to the function that
encloses it, and so on.
In this instance, the innermost function is
.ID
	fileptr = fopen(argv[1], "r")
.IE
.B fopen()
is executed and what it returns is written into
.BR fileptr .
What \fBfopen\fR returned is then passed to the next outer
operation; in this case, it is compared with NULL, as follows:
.ID
	(fileptr = fopen(argv[1], "r")) == NULL)
.IE
What that operation returns is then passed to the outermost function,
in this case the \fBif\fR statement, which evaluates what it is
passed, and acts accordingly.
If
.B fileptr
is NULL (that is, if \fBfopen\fR couldn't open the file),
the \fBif\fR statement will be true and the \fBerror\fR function called.
If, however, the file was opened, \fBfileptr\fR
will not equal NULL and the program will proceed.
.PP
As this example shows, C allows a programmer to nest
functions quite deeply.
Although nested functions are sometimes difficult to untangle when
you read them, they make programming much more convenient.
.PP
Finally, at the bottom of the file is a new function, called
.BR error() :
.ID
	error(message)
	char *message;
	{
		printf("%s", message);
		exit(1);
	}
.IE
This function stands outside of
.BR main() ,
as you can tell because it appears outside of
.BR main() 's
closing brace.
This function is called only when your program needs it.
If there are no errors, the program progresses only
until the closing brace in \fBmain\fR
and the \fBerror\fR function is never called.
.PP
.B error()
takes one argument, the message that is to be printed on the screen.
This message is defined by the routine that calls
.BR error() .
.B error()
uses the function
.B printf()
to print the message, then calls the
.B exit()
.II exit()
function; this, as its name implies, causes the program to stop.
The argument
.B 1
is a special signal that tells \*(CO that something went wrong with
your program.
.PP
When the error checking code is inserted, recompile the program
and execute it without an argument.
Previously, this would cause the program to crash;
now, all it does is print the message
.ID
	Usage: display filename
.IE
and terminate the program.
.Sh "Print a Portion of a File"
.PP
So far, our utility just opens a file and streams its contents over
the screen.
Now, you must insert code to print a 23-line portion of the file.
At present, it will only print the first 23 lines, and then exit.
.PP
To do so, you must insert another
.B for
loop.
.II for
Unlike our first loop, which ran forever, this one will cycle only
23 times, and then stop.
Our updated program appears as follows:
.ID
/*
 * Truncated version of the 'scat' utility.
 * Open a file, print out 23 lines, wait.
 * If user types <return>, print another 23 lines.
 * If user types any other key, exit.
 * Exit when EOF is read.
 */
.IE
.ID
#include <stdio.h>
#define MAXCHAR 128
.IE
.ID
main(argc, argv)
int argc;
char *argv[];
{
	char string[MAXCHAR];
	FILE *fileptr;
.SL
	int ctr;
.IE
.ID
/* Check if right number of arguments was passed */
	if (argc != 2)
		error("Usage: display filename");
.IE
.ID
/* Open file */
	if ((fileptr = fopen(argv[1], "r")) == NULL)
		error("Cannot open file");
.IE
.ID
.SL
/* Output 23 lines */
	for (;;) {
.SL
		for (ctr = 0; ctr < 23; ctr++) {
			fgets(string, MAXCHAR, fileptr);
			printf("%s", string);
.SL
		}
.SL
		exit(0);
	}
}
.IE
.ID
/* Process error messages */
error(message)
char *message;
{
	printf("%s", message);
	exit(1);
}
.IE
The new
.B for
loop is nested inside the loop governed by \fBfor(;;)\fR.
The program also declares a new variable,
.BR ctr ,
at the beginning of the program.
\fBctr\fR keeps track of how many times the loop has executed.
Now, look at the line:
.ID
	for (ctr = 0; ctr < 23; ctr++)
.IE
.II for
It has three sub-statements, which are separated by semicolons.
The first sub-statement sets
.B ctr
to zero;
the second says that execution is to continue as long as
.B ctr
is less than 23; and the third says that
.B ctr
is to be increased by one every time the loop executes
(this is indicated by the
.B ++
appended to
.BR ctr ).
With each iteration of this loop, \fBfgets()\fR reads
a line from the file named on the \fBdisplay\fR command line,
and \fBprintf()\fR prints it on the screen.
.PP
Also, an
.B exit()
call has been set after this new loop.
This ensures that the program
will exit automatically after the loop has finished executing.
This is a temporary measure, to make sure that you no longer have
to type \fB<ctrl-C>\fR to return to the shell.
.PP
When you have updated the program, recompile it in the usual way.
When you run it with an appropriate file of an appropriate length, e.g.,
.B display.c
itself,
.B display
will show the first 23 lines of the file, and then
the shell's prompt will return.
.PP
The program is now approaching its final form.
.Sh "Checking for the End of File"
.PP
The next-to-last step in preparing the program is teaching it to
recognize the end of a file when it sees it.
This does not appear to be needed now because the program exits
automatically after 23 lines or fewer, but it will be quite necessary
when the program begins to display more than one 23-line portion of text.
.PP
The function
.B fgets()
checks to see if it has arrived at the end of a file, and returns a
special value if it has.
.B fgets()
normally returns the address of the string into which it writes its output;
however, if it runs into the end of a file (or if any other error occurs),
it returns the special value NULL.
By reading the value of what \fBfgets()\fR returns,
.B display
can detect if the end of the file has been encountered, and stop reading.
To do so, the \fBfgets()\fR statement must be set within an \fBif\fR
statement.
The
.B if
statement will capture what
.B fgets()
returns, and continue execution as long as the value of the number
returned is not NULL.
.PP
The updated program now appears as follows:
.ID
/*
 * Truncated version of the 'scat' utility.
 * Open a file, print out 23 lines, wait.
 * If user types <return>, print another 23 lines.
 * If user types any other key, exit.
 * Exit when EOF is read.
 */
.IE
.ID
#include <stdio.h>
#define MAXCHAR 128
.IE
.ID
main(argc, argv)
int argc;
char *argv[];
{
	char string[MAXCHAR];
	FILE *fileptr;
	int ctr;
.IE
.ID
/* Check if right number of arguments was passed */
	if (argc != 2)
		error("Usage: display filename");
.IE
.ID
/* Open file */
	if ((fileptr = fopen(argv[1], "r")) == NULL)
		error("Cannot open file");
.IE
.ID
.SL
/* Output 23 lines, while checking for EOF */
	for (;;) {
		for (ctr = 0; ctr < 23; ctr++) {
.SL
			if (fgets(string, MAXCHAR, fileptr) != NULL)
				printf("%s", string);
.SL
			else
.SL
				exit(0);
		}
		exit(0);
	}
}
.IE
.ID
/* Process error messages */
error(message)
char *message;
{
	printf("%s", message);
	exit(1);
}
.IE
First, note that the comment that describes the program's output
has been changed to reflect our changes to the program.
It is important for a programmer
to ensure that the comments and the code are in step with each other.
.PP
Our new
.B if
statement
.ID
	if (fgets(string, MAXCHAR, fileptr) != NULL)
.IE
checks what
.B fgets()
returns:
if it does not return NULL, the end of the file has not been reached,
the \fBif\fR statement is true and the program prints out the next line.
(The operator \fB!=\fR indicates \*(QLnot equal\*(QR.)
If it returns NULL, however, the end of file has been
reached, the \fBif\fR statement is false so the \fBelse\fR statement
is executed, which causes \fBdisplay\fR to exit.
.PP
Note, too, that a new control statement is introduced:
.BR else .
.II else
This, like
.BR if ,
is built into the C language.
An
.B else
statement is always paired with an
.B if
statement; together, they mean that if the condition for which
.B if
is testing is true, the program should do one thing; otherwise, it
should do something else.
In this case, the program says that if the end of file has not been
reached, another line has been read from the file and should be printed on
the screen; however, if it has been reached, then the program should exit.
As you can imagine,
.B if/else
pairs are common in C programming; they are logical and useful.
.PP
One more task must be done on our program; then it is finished.
.Sh "Polling the Keyboard"
.PP
For the program to be complete, it has to ask you if you want to
see another 23-line portion of text whenever the argument contains
more than 23 lines.
The program should write another portion if you press the \fB<return>\fR key
alone; if you type any other key before you press \fB<return>\fR, then it
should exit.
.PP
To do so, we will print a query on the screen, then read what the
user has typed and interpret it.
When these changes are inserted, the program is complete:
.ID
/*
 * Truncated version of the 'scat' utility.
 * Open a file, print out 23 lines, wait.
 * If user types <return>, print another 23 lines.
 * If user types any other key, exit.
 * Exit when EOF is read.
 */
.IE
.ID
#include <stdio.h>
#define MAXCHAR 128
.IE
.ID
main(argc, argv)
int argc;
char *argv[];
{
	char string[MAXCHAR];
	FILE *fileptr;
	int ctr;
.IE
.ID
/* Check if right number of arguments was passed */
	if (argc != 2)
		error("Usage: display filename");
.IE
.ID
/* Open file */
	if ((fileptr = fopen(argv[1], "r")) == NULL)
		error("Cannot open file");
.IE
.ID
/* Output 23 lines, while checking for EOF */
	for (;;) {
		for (ctr = 0; ctr < 23; ctr++) {
			if (fgets(string, MAXCHAR, fileptr) != NULL)
				printf("%s", string);
			else
				exit(0);
		}
.SL
/* Query if user wishes to continue */
.SL
		printf("Continue? ");
.SL
		fflush(stdout);
.SL
		fgets(string, MAXCHAR, stdin);
.IE
.ID
.SL
		if (string[0] != '\en')
			exit(0);
	}
}
.IE
.ID
/* Process error messages */
error(message)
char *message;
{
	printf("%s", message);
	exit(1);
}
.IE
These new lines introduce a few new twists.
The lines
.ID
	printf("Continue? ");
	fflush(stdout);
.IE
print the prompt \fBContinue?\fR on the screen.
Note that no \*(Ql\en\*(Qr appears after the prompt; this ensures that
the cursor does \fInot\fR jump to the next line, but stays next to the prompt.
Because no \*(Ql\en\*(Qr appears after the line, however, you have to
force it to appear on the screen; this is accomplished with the statement:
.ID
	fflush(stdout);
.IE
.B fflush()
flushes matter to an output device.
.B stdout
points to a file stream, just like the stream that you opened with the call to
.BR fopen() ,
earlier in the program.
.B stdout
is opened in the header file \fBstdio.h\fR, which was read at the
beginning of the program; it always points to the user's screen.
.PP
The next line reads the user's keyboard:
.ID
	fgets(string, MAXCHAR, stdin);
.IE
This version of \fBfgets\fR reads matter into our array \fBstring\fR;
however, instead of reading the file pointed to by \fBfileptr\fR, it reads
what is pointed to by \fBstdin\fR.
.B stdin
is a stream that is also defined in \fBstdio.h\fR; it always points to the
user's keyboard.
.PP
Finally, the statement
.ID
	if (string[0] != '\en')
.IE
checks what the user typed by reading the first (that is, the zero-th)
character written in the array \fBstring\fR by the preceding call to
\fBfgets()\fR.
(Note that with C, counting always begins with zero rather than one.)
If the user just types \fB<return>\fR, then \fBstring[0]\fR will hold
\*(Ql\en\*(Qr; and the \fBif\fR statement will \fInot\fR be true,
the program jumps to the preceding \fBfor\fR statement, and more text
is written to the screen.
However, if the user types anything before typing \fB<return>\fR, the
\fBif\fR statement will succeed and the program will exit.
This may seem a little convoluted, but it actually is a straightforward
and efficient way to receive information from the user.
.PP
After you have inserted these changes, again compile the program.
.PP
When compilation is finished, try typing
.ID
	display display.c
.IE
The first 23 lines of the source code to the program
now appear on your screen.
Hit \fB<return>\fR; the next 23 lines appear.
Now, type any other key, and then press \fB<return>\fR:
the program exits.
.PP
You now have a simple but helpful
.B display
utility.
.Sh "For More Information"
.PP
This section has given you a brief, concentrated introduction
to writing a C program.
If you are new to programming, much of what happened must seem strange,
but we hope it helped you to appreciate
the logic of how C works.
.PP
Numerous books are on the market to teach beginners how to program in C;
the following section gives a small bibliography of books on C.
Also, look at the sample C programs in the Lexicon.
These demonstrate how to use many of the functions available
to you with \*(CO.

.\" /usr/lib/roff/nroff/specials.r 7/7/94
.\" Default special character definitions for nroff.
.\"
.ie \\n(HT \\{\\
.\" output is in HyperText format, so use special HyperText characters
.dc en &en;
.dc lq ``
.dc rq ''
.dc em &em;
.dc hy -
.dc bu &bullet;
.dc sq &square;
.dc ru _
.dc 14 1/4
.dc 12 1/2
.dc 34 3/4
.dc fi fi
.dc fl fl
.dc ff ff
.dc Fi ffi
.dc Fl ffl
.dc de degrees
.dc dg +
.dc fm '
.dc ct \o'c|'
.dc rg (r)
.dc co (c)
.dc tm [tm]
.dc pl +
.dc mi -
.dc eq =
.dc ** *
.dc sc "section "
.dc aa \'
.dc ga `
.dc ul _
.dc sl /
.dc *a alpha
.dc *b beta
.dc *g gamma
.dc *d delta
.dc *e epsilon
.dc *z zeta
.dc *y eta
.dc *h theta
.dc *i iota
.dc *k kappa
.dc *l lambda
.dc *m mu
.dc *n nu
.dc *c xi
.dc *o omicron
.dc *p pi
.dc *r rho
.dc *s sigma
.dc ts sigma
.dc *t tau
.dc *u upsilon
.dc *f phi
.dc *x chi
.dc *q psi
.dc *w omega
.dc *A Alpha
.dc *B Beta
.dc *G Gamma
.dc *D Delta
.dc *E Epsilon
.dc *Z Zeta
.dc *Y Eta
.dc *H Theta
.dc *I Iota
.dc *K Kappa
.dc *L Lambda
.dc *M Mu
.dc *N Nu
.dc *C Xi
.dc *O Omicron
.dc *P Pi
.dc *R Rho
.dc *S Sigma
.dc *T Tau
.dc *U Upsilon
.dc *F Phi
.dc *X Chi
.dc *Q Psi
.dc *W Omega
.dc sr "square root"
.dc rn ""
.dc >= \o'>_'
.dc <= \o'<_'
.dc == ==
.dc ~= \o'~_'
.dc ap ~
.dc != \o'=/'
.dc -> ->
.dc <- <-
.dc ua \o'|^'
.dc da \o'|v'
.dc mu <TT>x</TT>
.dc di /
.dc +- \o'+_'
.dc cu union
.dc ca intersection
.dc sb "subset of"
.dc sp "superset of"
.dc ib "improper subset of"
.dc ip "improper superset of"
.dc in infinity
.dc pd "partial derivitive"
.dc gr gradient
.dc no not
.dc is integral
.dc pt "proportional to"
.dc es \o'O/'
.dc mo "member of"
.dc br |
.dc dd "double dagger"
.dc rh ->
.dc lh <-
.dc or |
.dc ci O
.dc lt (
.dc lb (
.dc rt )
.dc rb )
.dc lk (
.dc rk )
.dc bv |
.dc lf [
.dc rf ]
.dc lc [
.dc rc ]
.\"
.\" The following are special characters for the additions characters of the
.\" ISO Latin 1 table.
.dc A0 \X20
.dc A1 \X20
.dc A2 \X20
.dc A3 \X20
.dc A4 \X20
.dc A5 \X20
.dc A6 \X20
.dc A7 \X20
.dc A8 \X20
.dc A9 \X20
.dc AA \X20
.dc AB \X20
.dc AC \X20
.dc AD \X20
.dc AE \X20
.dc AF \X20
.dc B0 \X20
.dc B1 \X20
.dc B2 \X20
.dc B3 \X20
.dc B4 \X20
.dc B5 \X20
.dc B6 \X20
.dc B7 \X20
.dc B8 \X20
.dc B9 \X20
.dc BA \X20
.dc BB \X20
.dc BC \X20
.dc BD \X20
.dc BE \X20
.dc BF \X20
.dc C0 &Agrave;
.dc C1 &Aacute;
.dc C2 &Acirc;
.dc C3 &Atilde;
.dc C4 &Auml;
.dc C5 &Aring;
.dc C6 &AElig;
.dc C7 &Ccedil;
.dc C8 &Egrave;
.dc C9 &Eacute;
.dc CA &Ecirc;
.dc CB &Euml;
.dc CC &Igrave;
.dc CD &Iacute;
.dc CE &Icirc;
.dc CF &Iuml;
.dc D0 &ETH;
.dc D1 \X20
.dc D2 &Ograve;
.dc D3 &Oacute;
.dc D4 &Ocirc;
.dc D5 &Otilde;
.dc D6 &Ouml;
.dc D7 \X20
.dc D8 &Oslash;
.dc D9 &Ugrave;
.dc DA &Uacute;
.dc DB &Ucirc;
.dc DC &Uuml;
.dc DD &Yacute;
.dc DE &THORN;
.dc DF &szlig;
.dc E0 &agrave;
.dc E1 &aacute;
.dc E2 &acirc;
.dc E3 &atilde;
.dc E4 &auml;
.dc E5 &aring;
.dc E6 &aelig;
.dc E7 &ccedil;
.dc E8 &egrave;
.dc E9 &eacute;
.dc EA &ecirc;
.dc EB &euml;
.dc EC &igrave;
.dc ED &iacute;
.dc EE &icirc;
.dc EF &iuml;
.dc F0 &eth;
.dc F1 &ntilde;
.dc F2 &ograve;
.dc F3 &oacute;
.dc F4 &ocirc;
.dc F5 &otilde;
.dc F6 &ouml;
.dc F7 \X20
.dc F8 &oslash;
.dc F9 &ugrave;
.dc FA &uacute;
.dc FB &ucirc;
.dc FC &uuml;
.dc FD &yacute
.dc FE &thorn;
.dc FF &yuml;\\}
.el  \\{\\
.\" normal nroff - not HyperText
.dc en -
.dc lq ``
.dc rq ''
.dc em --
.dc hy -
.dc bu ->
.dc sq []
.dc ru _
.dc 14 1/4
.dc 12 1/2
.dc 34 3/4
.dc fi fi
.dc fl fl
.dc ff ff
.dc Fi ffi
.dc Fl ffl
.dc de degrees
.dc dg +
.dc fm '
.dc ct \o'c|'
.dc rg (r)
.dc co (c)
.dc tm [tm]
.dc pl +
.dc mi -
.dc eq =
.dc ** *
.dc sc "section "
.dc aa \'
.dc ga `
.dc ul _
.dc sl /
.dc *a alpha
.dc *b beta
.dc *g gamma
.dc *d delta
.dc *e epsilon
.dc *z zeta
.dc *y eta
.dc *h theta
.dc *i iota
.dc *k kappa
.dc *l lambda
.dc *m mu
.dc *n nu
.dc *c xi
.dc *o omicron
.dc *p pi
.dc *r rho
.dc *s sigma
.dc ts sigma
.dc *t tau
.dc *u upsilon
.dc *f phi
.dc *x chi
.dc *q psi
.dc *w omega
.dc *A Alpha
.dc *B Beta
.dc *G Gamma
.dc *D Delta
.dc *E Epsilon
.dc *Z Zeta
.dc *Y Eta
.dc *H Theta
.dc *I Iota
.dc *K Kappa
.dc *L Lambda
.dc *M Mu
.dc *N Nu
.dc *C Xi
.dc *O Omicron
.dc *P Pi
.dc *R Rho
.dc *S Sigma
.dc *T Tau
.dc *U Upsilon
.dc *F Phi
.dc *X Chi
.dc *Q Psi
.dc *W Omega
.dc sr "square root"
.dc rn ""
.dc >= \o'>_'
.dc <= \o'<_'
.dc == ==
.dc ~= \o'~_'
.dc ap ~
.dc != \o'=/'
.dc -> ->
.dc <- <-
.dc ua \o'|^'
.dc da \o'|v'
.dc mu x
.dc di /
.dc +- \o'+_'
.dc cu union
.dc ca intersection
.dc sb "subset of"
.dc sp "superset of"
.dc ib "improper subset of"
.dc ip "improper superset of"
.dc in infinity
.dc pd "partial derivitive"
.dc gr gradient
.dc no not
.dc is integral
.dc pt "proportional to"
.dc es \o'O/'
.dc mo "member of"
.dc br |
.dc dd "double dagger"
.dc rh ->
.dc lh <-
.dc or |
.dc ci O
.dc lt (
.dc lb (
.dc rt )
.dc rb )
.dc lk (
.dc rk )
.dc bv |
.dc lf [
.dc rf ]
.dc lc [
.dc rc ]
.\"
.\" The following are special characters for the additions characters of the
.\" ISO Latin 1 table.  Note that these are included just for compatibility
.\" with troff:  every character is mapped to 0x20 (the space character).
.dc A0 \X20
.dc A1 \X20
.dc A2 \X20
.dc A3 \X20
.dc A4 \X20
.dc A5 \X20
.dc A6 \X20
.dc A7 \X20
.dc A8 \X20
.dc A9 \X20
.dc AA \X20
.dc AB \X20
.dc AC \X20
.dc AD \X20
.dc AE \X20
.dc AF \X20
.dc B0 \X20
.dc B1 \X20
.dc B2 \X20
.dc B3 \X20
.dc B4 \X20
.dc B5 \X20
.dc B6 \X20
.dc B7 \X20
.dc B8 \X20
.dc B9 \X20
.dc BA \X20
.dc BB \X20
.dc BC \X20
.dc BD \X20
.dc BE \X20
.dc BF \X20
.dc C0 \X20
.dc C1 \X20
.dc C2 \X20
.dc C3 \X20
.dc C4 \X20
.dc C5 \X20
.dc C6 \X20
.dc C7 \X20
.dc C8 \X20
.dc C9 \X20
.dc CA \X20
.dc CB \X20
.dc CC \X20
.dc CD \X20
.dc CE \X20
.dc CF \X20
.dc D0 \X20
.dc D1 \X20
.dc D2 \X20
.dc D3 \X20
.dc D4 \X20
.dc D5 \X20
.dc D6 \X20
.dc D7 \X20
.dc D8 \X20
.dc D9 \X20
.dc DA \X20
.dc DB \X20
.dc DC \X20
.dc DD \X20
.dc DE \X20
.dc DF \X20
.dc E0 \X20
.dc E1 \X20
.dc E2 \X20
.dc E3 \X20
.dc E4 \X20
.dc E5 \X20
.dc E6 \X20
.dc E7 \X20
.dc E8 \X20
.dc E9 \X20
.dc EA \X20
.dc EB \X20
.dc EC \X20
.dc ED \X20
.dc EE \X20
.dc EF \X20
.dc F0 \X20
.dc F1 \X20
.dc F2 \X20
.dc F3 \X20
.dc F4 \X20
.dc F5 \X20
.dc F6 \X20
.dc F7 \X20
.dc F8 \X20
.dc F9 \X20
.dc FA \X20
.dc FB \X20
.dc FC \X20
.dc FD \X20
.dc FE \X20
.dc FF \X20\\}
.\"
.\" end of /usr/lib/roff/nroff/specials.r

.NH "Xware 6: Ghostscript"
.PP
Congratulations on purchasing Xware 6.
This package contains Ghostscript, a language that closely resembles
PostScript;
.BR gs ,
a Ghostscript interpreter;
.BR ghostview ,
a Ghostscript viewer that lets you display and manipulate images
interactively;
a set of drivers for a variety of input and output devices;
and a variety of example PostScript files.
.SH "What Is Xware?"
Xware is a series of packages from Mark Williams Company
that bundle some of the most popular and useful software
for the X Window System.
Each program in a Xware package comes with an executable binary;
instructions and scripts to help you recompile and install the program;
and a manual page for the program edited and formatted in the \*(CO
Lexicon format, which you can view with the \*(CO command
.BR man .
Many also include source code.
.PP
Other Xware packages are available or are being prepared.
These include packages of X window managers, games, graphics programs,
utilities, and development tools.
Xware makes it easy and convenient for you
to enlarge your supply of X software.
.SH "System Resources"
.PP
Ghostscript and its tools require 16 megabytes of RAM.
They take up approximately nine megabytes of disk space.
.PP
The size of screen required depends upon the image being displayed:
most Ghostscript images fit onto a 800\(mu600 display, although some
very large ones require a 1024\(mu768 display.
.SH "Installing This Package"
.PP
To install this package onto your system, log in as the superuser
.B root
and type the installation command:
either
.DM
	/etc/install Xware6 /dev/fva0 2
.DE
if you have a 3.5-inch floppy-disk drive, or
.DM
	/etc/install Xware6 /dev/fha0 3
.DE
if your floppy-disk drive is 5.25 inches.
.B install
copies the programs into sub-directories of
.BR /u1/gnu :
.IP \fB/u1/gnu/bin\fR
This holds the executable programs
.BR gs ,
which is the Ghostscript interpreter, and
.BR ghostview ,
which is the viewer for displaying and manipulating images.
.IP \fB/u1/gnu/lib/ghostscript\fR
This holds initialization files for Ghostscript.
.IP \fB/u1/gnu/lib/ghostscript/doc\fR
This holds documentation files for Ghostscript and its drivers.
.IP \fB/u1/gnu/lib/ghostscript/fonts\fR
This holds the Ghostscript fonts.
.IP \fB/u1/gnu/lib/ghostscript/examples\fR
This holds example PostScript files.
File
.B gs_man.ps
holds the manual page for
.BR gs ,
formatted into PostScript under the \*(CO implementation of
.BR troff .
.PP
After archives have been copied onto your system into the default
directories, the installation script asks you if you wish to continue
with the installation.
You should answer ``no'' if you do not wish to install Ghostscript into
the default directories, or if you do not have enough disk space to hold
the de-archived files (i.e., about six megabytes).
Otherwise, you should answer ``yes''.
.PP
The installation program will ask you for permission to add the following
line to the end of file
.BR /etc/profile :
.DM
	export GS_LIB=/u1/gnu/lib/ghostscript
.DE
.PP
This environmental variable tells
.B ghostview
where the Ghostscript interpreter and configuration files are stored.
If you do not give the installation program permission to do this,
you must insert this variable by hand into
.BR /etc/profile .
.PP
After installation has completed,
you must make the following modifications to file
.BR /etc/profile :
.IP \(bu 0.3i
Add the directory
.B /u1/gnu/bin
to the definition of the environmental variable
.BR PATH .
.PP
Once you have done this, log in again.
Then you can demonstrate Ghostscript:
invoke X in the usual manner, then type the command
.DM
	ghostview /u1/gnu/lib/ghostscript/examples/tiger.ps
.DE
This displays a picture of a rather fierce tiger on your screen.
The interpreter will then wait for further commands; to exit from it, type
.BR quit .
.\".SH "Changing Defaults and Recompiling"
.\".PP
.\"By default, Ghostscript is configured to run under directory
.\".BR /u1/gnu .
.\"This directory was chosen because Ghostscript is protected by the
.\"Free Software Foundation's ``copyleft'' and
.\".B /u1
.\"is the directory into which all FSF products are installed by default under
.\"\*(CO 4.2.
.\"(These include GNU C and GNU Tools, which are also available through Mark
.\"Williams Company.)
.\"If you wish to install Ghostscript under another directory, you must
.\"recompile it.
.\".PP
.\"Note before you begin that you must recompile with the \*(CO C compiler
.\".BR cc .
.\"You
.\".I cannot
.\"recompile with GNU C, because of inconsistencies with floating-point
.\"arithmetic.
.\"Note, further, you
.\".I must
.\"use the version of the \*(CO C compiler that is included with the
.\"X repair kit; you
.\".I cannot
.\"use the stock compiler included with \*(CO release 4.2.05.
.\"The compiler in the X repair kit fixes a bug that prevented the compiler
.\"from building a proper executable for Ghostscript.
.\"If you do not have the X repair kit, you can download a copy either from
.\"the Mark Williams bulletin board, or (if you have \fBftp\fR access to the
.\"Internet) from site
.\".BR raven.alaska.edu .
.\"If you cannot download the kit electronically, contact Mark Williams Company's
.\"technical support group and a copy will be sent to you, at no charge.
.\".PP
.\"The following describes how to recompile Ghostscript:
.\".IP \(bu 0.3i
.\"First, select the directory under which you wish to install Ghostscript.
.\".IP \(bu
.\"Log in as the superuser
.\".BR root .
.\".IP \(bu
.\"De-archive the Ghostscript sources:
.\"first
.\".B cd
.\"to directory
.\".B /u1/gnu/lib/ghostscript/src
.\"and type the command:
.\".DM
.\"	gtar -xvzf gs.gtz
.\".DE
.\".IP \(bu
.\".B cd
.\"to directory
.\".BR gs256 .
.\".IP \(bu
.\"The next step is the trickiest:
.\"modify the
.\".B Makefile
.\"to reflect the change you wish to make.
.\"Change macro
.\".B prefix
.\"from
.\".B /u1/gnu
.\"to the directory you want.
.\"If you want all of Ghostscript to reside under the same directory tree,
.\"changing
.\".B prefix 
.\"is sufficient.
.\"If you wish to divide it up among different directories, then you must also
.\"modify the macros
.\".BR exec_prefix ,
.\".BR bindir ,
.\".BR datadir ,
.\"and
.\".BR gsdatadir .
.\".IP \(bu
.\"Modify macro
.\".B GS_LIB_DEFAULT
.\"to the directory (or directories) that hold the configuration files and
.\"fonts.
.\"Normally, this is set to the same value as
.\".BR gsdatadir ,
.\"but this is not required.
.\".IP \(bu
.\"Type
.\".DM
.\"	make install
.\".DE
.\".IP
.\"to recompile and install the Ghostscript binaries and configuration
.\"files.
.\".IP \(bu
.\"Next, copy the Ghostscript fonts from directory
.\".B /u1/gnu/lib/ghostscript/fonts
.\"into the directory (or a directory) that you named in the macro
.\".B GS_LIB_DEFAULT
.\"in your modified
.\".BR Makefile .
.\"(Note that we did not include these fonts in the sources because they
.\"are so large.)
.\".IP \(bu
.\".B cd
.\"to the directory into which you installed the fonts, and decompress them
.\"by typing the command:
.\".DM
.\"	gunzip *.gz
.\".DE
.\".PP
.\"Once you have tried Ghostscript and are convinced that it is
.\"installed properly,
.\"you can remove the original installation of Ghostscript.
.\"First, copy the archive
.\".B /u1/gnu/lib/ghostscript/src/gs.gtz
.\"into a place where you wish to store your source archives.
.\"Then remove directory
.\".B /u1/gnu/lib/ghostscript
.\"and its contents, and remove file
.\".BR /u1/gnu/bin/gs.gz .
.\".PP
.\"Should you change your mind, you can still use the original installation.
.\"To do so, log in as the superuser
.\".BR root ,
.\".B cd
.\"to directory
.\".BR /conf ,
.\"and execute the script
.\".BR Xware6.post .
.\".PP
.\"Finally, be sure to name in your
.\".B PATH
.\"the directory into which you put the executable file
.\".BR gs .
.SH "Default Configuration"
.PP
As shipped in Xware 6, Ghostscript is configured to work only with X.
The executable
includes drivers for some output devices.
Each driver is describes in its own
.B .doc
file, in directory
.BR /u1/gnu/lib/ghostscript/doc .
.SH "Copyrights and Credits"
.PP
Ghostscript was written primarily by L. Peter Deutsch, who is president
of Aladdin Enterprises (ghost@aladdin.com).
He was assisted by numerous other persons, who are named in the documentation
files included with Ghostscript.
Ghostscript, its sources, documentation, and ancillary files, are
copyright \(cu 1989, 1992, 1993 Aladdin Enterprises.
All rights reserved.
.PP
Ghostscript is protected by the Free Software Foundation's ``copyleft''.
For details of the rights this document grants you, and the obligations
it imposes, see the file
.B COPYING
which is included with the source files for Ghostscript.
.SH "Technical Support"
.PP
The sources in this package have been run successfully under
\*(CO.
If you have a problem bringing up one of the programs, our
technical support team will attempt to help you.
However, because of the highly technical nature of the source
code in these packages, Mark Williams Company
.I cannot
give you technical assistance should you modify any of the source code
included in this package in any manner whatsoever.
.SH "A Final Word"
.PP
All of the source code for these games, and for all programs shipped in our
Xware packages, is available for free on the Mark Williams bulletin board
system, and on other publicly accessible archives.
The tutorial for
.B UUCP
in the \*(CO manual describes how to contact the BBS and make its services
available to you.

.SH "Installing \*(PN"
.PP
.II installation
To install \*(PN on your system, following the directions in
the appropriate sub-section:
either for the VAX, or for the Intel development system.
.Sh "Installing \*(PN on the VAX"
.PP
To install \*(PN on the VAX, do the following:
.nr l1 0
\*i
Create a directory in which the compiler and its associated support libraries
can reside.
\*i
Copy the distribution tape into the directory via the VMS \fBBACKUP\fR
utility.
\*i
.II INSTAL86C.COM
Invoke the \fBINSTAL86C.COM\fR command file to build the compiler,
including your system run-time library.
\*i
Invoke the \fBSETUP86C.COM\fR command file to make the logical assignments
used by the compiler.  As shipped, each user must invoke the command file.
The compiler can also be made available for system-wide use.
.PP
The following lists the contents of
\fBINSTAL86.COM\fR:
.DM
.ta 4.0i
$
$ !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
$ !	!
$ !   MWC86 Version 2.5.2	!
$ !   Copyright 1982 - 1986 by Mark Williams Company, Chicago.	!
$ !   All rights reserved may not be copied or disclosed	!
$ !   without permission.	!
$ !	!
$ !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
$
$ say ::= write sys$output
$ say "Linking the cross compiler"
$
$
.ta 2.0i
$ link	CCSCAN.obj,-
	cc86.olb/include=dope,-
	cc86.olb/include=macros,-
	cc86.olb/include=paternf,-
	cc86.olb/include=paternb,-
	cc86.olb/include=table0,-
	cc86.olb/include=table1,-
	cc86.olb/include=optab,-
	cc86.olb/include=regnam,-
	cc86.olb/lib
$
$ rename	CCSCAN.exe cc86.exe
$
.DE
The following gives the contents of
.BR SETUP86.COM :
.DM
$! File:  setup86c.com
$! Last edit:  31-JAN-1986
$!+
.ta 1.5i
$!	MWC86 VERSION 2.5.2
$!	COPYRIGHT (C) 1982 - 86
$!	BY MARK WILLIAMS COMPANY, CHICAGO.
$!	ALL RIGHTS RESERVED.
$!	MAY NOT BE COPIED OR DISCLOSED WITHOUT PERMISSION.
$!-
$!
$! This is the command file to set up the Mark Williams Co.
$! iAPX 86 C (VAX/VMS native mode) cross-compiler to run on VMS.
$! It is invoked by including the command
$!
$!	$ @mwc86c:setup86c
$!
$! in one's login.com file.  Here, "mwc" must be
$! the logical name
$! of the device containing this command file.
$! Note that this command file
$! assumes that the executable image of the compiler will reside on
$! DQA0: in directory [mwc86c].  This assignment should be
$! changed to reflect your installation realities.
$!
$ assign dqa0: mwc
$ assign mwc:[mwc86c.include] cc86$include
$ assign mwc:[mwc86c] mwc86c
$ cc86 :== $mwc86c:cc86
$ size :== $mwc86c:size
$!
$! Invoking the compiler:
$!
$! The command line is identical to that on the Intel Series III
$! development system.  You say:
$! 	     cc86 file [options]
$! 
$! The output file is in the same directory and has the
$! same name as the input file; the file type is changed
$! to "o86" (for object) or "a86" (for pseudo-assembly code). 
.DE
.Sh "Installing on the Intel development system"
.PP
To install \*(PN onto the Intel development system, simply
copy all of the files from the distribution disks onto your
hard disk.
Because its operating system does not use directories,
no special organization of the files is necessary.

.NH "COHERENT Update for Comeau C++"
.PP
Thank you for purchasing the Comeau C++ package for \*(CO.
If you are running \*(CO with any release prior to 4.2.14, you
.I must
first install the supplemental-update disk for \*(CO, which
is included with this package.
The \*(CO update kit for Comeau C++ provides updated versions
of several \*(CO utilities (notably,
.B cc
and
.BR ld )
for use with Comeau C++.
.PP
If you are running \*(CO release 4.2.10 or later, do
.I not
install the supplemental update disk \(em it is unnecessary.
If you are running a version of \*(CO that predates release 4.2.05,
you must update to \*(CO 4.2.05 or later before you can run Comeau C++;
for details, contact Mark Williams Company.
.PP
To install the supplemental-update disk, do the following:
.IP \(bu 0.3i
Log in as the superuser
.BR root .
.IP \(bu
Insert the supplemental-update disk into a floppy-disk drive on your
system.
.IP \(bu
Type the following command:
.DM
	/etc/install ComoCOHUpd /dev/\fIdevice\fP 1
.DE
.I device
represents the name of the floppy-disk device into which you have inserted
the disk.
For example, if you inserted the disk into a 3.5-inch floppy-drive that is
drive 0 (i.e., drive A) on your system, you would type the following command:
.DM
	/etc/install ComeauCOHUpd /dev/fva0 1
.DE
For a complete listing of floppy-disk devices available under \*(CO, see
the entry for
.B "floppy disk"
in the \*(CO manual's Lexicon.
.PP
.B install
prompts you to insert the floppy disk into drive A.
It will then copy the floppy disk's contents onto your hard disk.
.B install
will install all items of the update kit into their usual
places on your \*(CO system.
For example, it installs the new
version of the command
.B cc
into directory
.BR /bin .
.PP
For details on how to install and test Comeau C++, see the full
Comeau C++ \*(CO User's Guide.

.TL "Introduction"
.NH "Introduction to COHERENT X"
.PP
Congratulations on your purchase of X Windows for \*(CO!
.II MIT
This product is a port of XFree386 release 1.2,
which implements release 11, revision 5,
of the Massachusetts Institute of Technology's X Window System.
The X Window System (or ``X Windows'' for short)
lets you use your keyboard and mouse to open multiple windows and
run multiple graphics programs simultaneously on your screen.
With X Windows, you can use on your \*(CO system
the wealth of graphics-oriented programs \(em games, graphics-manipulation
programs, images, tools, and utilities \(em available at minimal cost from
many public sources.
.Sh "How to Use This Manual"
.PP
This manual consists of the following:
.IP \(bu 0.3i
An introduction \(em what you are reading right now.
.IP \(bu
An introduction to the X Window System and the window manager
.BR twm ,
including directions on how to customize X Windows and
.B twm
to suit your tastes.
.IP \(bu
An introduction to the X utilities and clients, and directions on how to
use resources to modify clients.
.IP \(bu
A discussion of how to recompile X programs.
This covers such topics as how to construct a
.B Makefile
from an
.BR Imakefile ,
and commonly encountered problems.
.IP \(bu
A Lexicon of manual pages for every
X utility and client included with X Windows for \*(CO.
Note that every Lexicon entry is also available on-line, and can be
read by using the \*(CO command
.BR man .
.PP
If you are experienced in using X,
you can jump to the Lexicon for a summary of the utility or client that
interests you.
The Lexicon entries
.B "X clients"
and
.B "X utilities"
list the clients and utilities included with X Windows for \*(CO.
If you are a beginner, however, we suggest that you read through
the tutorials at the beginning of this manual.
They will help you understand how X works, and so
help you to become productive more quickly.
.SH "System Requirements"
.PP
To run this X Windows for \*(CO, you need the following:
.IP \(bu 0.3i
A computer that is running \*(CO release 4.2 or later.
.IP \(bu
At least four megabytes of RAM.
At least eight megabytes is needed to run the color X server;
16 megabytes is preferred.
.IP \(bu
Twenty-five megabytes of hard-disk space on the file system that holds
directory
.BR /usr/X11 .
More is preferred.
.IP \(bu
A serial mouse \(em that is, a mouse that is plugged into a serial port
on your computer.
Note that X Windows does
.I not
work with a bus mouse \(em that is, a mouse that is plugged directly
into your system's mother board.
We recommend a three-button mouse, although two-button mice can also be used.
This implementation of X works with mice from Microsoft,
Mouse Systems, and Logitech (Mouseman), and with devices that mimic one of
the above, such as those manufactured by Honeywell.
.IP \(bu
A VGA or SVGA video board and monitor.
.SH "Contents of This Package"
.PP
X Windows for \*(CO includes all of the tools you need to
run X on your system.
It also includes tools with which you can import and write X applications.
The package includes the following:
.IP \(bu 0.3i
A large selection of X clients and utilities.
.IP \(bu
Object modules from which the included X programs are linked.
.IP \(bu
Bit-mapped images that can be displayed by an X client.
.IP \(bu
Sample and default configuration files for X programs.
.IP \(bu
A selection of fonts.
.IP \(bu
Header files used by X clients and utilities.
.IP \(bu
Libraries of X functions.
.PP
Please note that the included libraries do
not support a mathematics co-processor.
.SH "Bibliography"
.PP
The X Window System is a huge and elaborate system, for which a huge
literature exists.
This manual can only scratch the surface of X.
It walks you through installing, invoking, and configuring X Windows,
and introduces the tools and clients.
However, much of X lies beyond the scope of this manual, especially if you
wish to import or write X applications.
We recommend the following books for further reading.
.PP
.II "O\'Reilly & Associates"
If you are an experienced programmer and you wish to import or write your
own X Windows applications, there is no substitution for the first five
volumes of \fIThe X Window System,\fR published by O'Reilly & Associates, Inc.
Contact your local bookseller, or write to O'Reilly & Associates, Inc.,
632 Petaluma Avenue, Sebastopol, CA 95472 (1-800-338-6887).
Another useful volume is
\fIThe X Window System in a Nutshell,\fR second edition, edited by
Ellie Cutler, Daniel Gill, and Tim O'Reilly.
(Sebastopol, Calif., O'Reilly & Associates, Inc., 1992), which is
a handy pocket reference for people who already know X internals.
.PP
If you are new to the X Window System, we recommend the following two books:
.IP \(bu 0.3i
Mansfield, Niall:
\fIThe Joy of X:
An Overview of the X Window System.\fR
New York, Addison-Wesley Publishing Co., 1993.
.IP \(bu
Quercia, Valerie, O'Reilly, Tim:
\fIThe X Window System.\fR
Vol. 3,
\fIX Window System User's Guide,\fR ed 4.
Sebastopol, Calif., O'Reilly & Associates, Inc., 1992.
.SH "Technical Support"
.PP
\*(MW provides free technical support to all registered users of X Windows
for \*(CO.
If you are experiencing difficulties with this product,
feel free to contact the Mark Williams Technical Support Staff.
You can telephone,
send electronic mail, or write.
Please note that this support is available \fIonly\fR if you have returned
your User Registration Card for \*(CO.
.PP
.\" RTFM!
Before you contact Mark Williams Technical Support with your problem,
\fIplease check this manual first.\fR
If you do not find an article in the Lexicon that addresses your problem,
be sure to check the index at the back of the manual.
Often, the information that you want is kept in an article that you didn't
consider, and the index will point you to it.
.PP
Another good way to find a topic in the manual is to use the command
.BR apropos ,
which is part of the \*(CO system.
.B apropos
finds every article in the Lexicon that mentions a given word or phrase.
For details on how to use this command, see its entry in the \*(CO Lexicon.
.PP
If the manual does not solve your problem \(em or if you find it to be
misleading or difficult to understand \(em then
Mark Williams Technical Support is available to help you.
You can reach Technical Support via the following routes:
.IP "\fBElectronic Mail\fR"
If you have access to the Internet, send mail to \fBsupport@mwc.com\fR.
This is the preferred means of communication.
Be sure to include your surface address and telephone number
as well as your e-mail address,
so we can contact you even if return electronic mail fails.
.IP "\fBFAX\fR"
Send your technical FAXes to 1-708-291-6750.
.IP "\fBSurface Mail\fR"
Write to Technical Support, Mark Williams Company, 60 Revere Drive,
Northbrook, IL 60062.
.IP "\fBTelephone\fR"
To contact Technical Support via telephone,
call 1-708-291-6700, between 9 AM and 5 PM, Central Time.
Please have your manual at hand.
Please collect as much information as you can concerning your difficulty
before you call.
If possible, call while you are at your machine, so the technical-support
person can walk you through your problem.
.Sh "Help Us Help You"
.PP
Mark Williams Technical Support wants to help you fix your problem as
quickly as possible.
.\" and get the hell off our back.
You can help us to help you by doing the following:
.PP
Before you contact Technical Support, 
\fIwrite down\fR
as carefully as possible what you did that triggered the problem.
Copy down exactly any error messages that appeared on the screen.
.PP
If the problem is triggered by a script or program, try to edit
the script or program to the chunk of code that triggers the problem.
The smaller the chunk of code, the better.
.PP
In your message, please include the following information:
.IP \(bu 0.3i
The make of your computer, and the type and clock speed of its microprocessor.
.IP \(bu
The amount of RAM that you have.
.IP \(bu
The size and make of your hard disk, and the make of its controller.
.IP \(bu
The make of your display (i.e., tube) and controller card, and the amount
of video RAM it has, if known.
.PP
If you have found an error in the manual, please mention the page on
which the error occurs.
.PP
This information will help us to to clear up your problem as quickly
as possible.
.SH "Where To Go From Here"
.PP
If you have not yet done so, you should now install X Windows for
\*(CO onto your system.
For directions on how to do so, turn to the release notes that came with
this manual and follows the directions given there.
.PP
The release notes also give errata \(em that is, mistakes in this manual
that were discovered since its publication, and problems with
X Windows for \*(CO that remain unresolved.
We suggest that you note these in the appropriate places in this manual,
and we hope you will accept our apologies for any inconvenience they may have
have caused you.
.PP
After you have install X Windows for \*(CO, you should turn to the part
of the manual that is most appropriate for your level of experience:
.IP \(bu 0.3i
If you are a beginner, turn to the following tutorial, entitled
.IR "Using the X Window System" .
This walks you through X Windows, and teaches you how to use the window
manager
.BR twm .
.IP \(bu
If you are experienced with the X Window System, turn to
the Lexicon articles entitled
.B "X utilities"
and
.BR "X applications" .
These summarize the utilities and applications that are included with X.
.IP \(bu
If you are interested in porting code to X, turn to the
chapter entitled
.IR "Porting to X" .
This gives practical advice on how to import X code, and walks you through
the modification and compilation of a sample X application.

.sp 6i
.ll 6.25i
.po 1i
.vs 9
Copyright \(co 1982, 1993 by Mark Williams Company.
.br
Portions copyright \(co 1988 by INETCO Systems, Ltd.
.sp
All rights reserved.
.sp
This publication conveys information that is the property of Mark
Williams Company.
It shall not be copied, reproduced or duplicated
in whole or in part without the express written permission of Mark
Williams Company.
Mark Williams Company makes no warranty of any kind
with respect to this material and disclaims any implied warranties of
merchantability or fitness for any particular purpose.
.sp
COHERENT is a trademark of Mark Williams Company.
UNIX is a trademark of Unix Systems Laboratories.
All other products are trademarks or registered
trademarks of the respective holders.
.sp
.ta 1i 2.25i 3.75i
	Revision 6	Printing 5 4 3 2 1
.sp
Published by Mark Williams Company, 60 Revere Drive, Northbrook,
IL 60062.
.sp
.nf
.ta 0.5i 1.5i
Sales:	Phone:	(800) MARK-WMS
	FAX:	(708) 291-6750
	E-mail:	uunet!mwc!sales
		sales@mwc.com
Technical Support:
	Phone:	(708) 291-6700
	FAX:	(708) 291-6750
	E-mail:	uunet!mwc!support
		support@mwc.com
.ta 1.0i
BIX:	join mwc
CompuServ:	76256,427
.sp
.ce 1
Printed in the U.S.A.
.bp

.II sed^tutorial
.ds TL "sed Stream Editor"
.NH "Introduction to the sed Stream Editor" 1
.PP
This is a tutorial for the \*(CO editor \fBsed\fR.
It describes in elementary terms
what \fBsed\fR does.
.PP
This guide is meant for two types of reader: the one who wants a tutorial
introduction to \fBsed\fR, and the one
who wants to use specific sections as
references.
.PP
Related tutorials include \fIUsing the COHERENT System\fR,
which presents the basics of using \*(CO and introduces many useful
programs, and the tutorials for the interactive line editor \fBed\fR
and for the screen editor \*(ME.
.PP
In a nutshell, \fBsed\fR edits
files non-interactively; that is, \fBsed\fR applies your set of commands
to every line of the file being edited.
It is not meant to create a text, as you can do with \fBed\fR,
\fBme\fR, or \fBvi\fR.
Rather, it lets you perform large, intricate
transformations on a file of text, using commands that resemble those
used by \fBed\fR or \fBvi\fR's colon-command mode.
.PP
Although \fBsed\fR is not as easy to control as \fBed\fR or
\*(ME, both of which are interactive,
it can edit a large file very quickly.  
You can use \fBsed\fR
to change computer programs,
natural language manuscripts, command files, electronic mail messages,
or any other type of text file.  
.PP
One last point:
.B sed
normally writes its output to the standard output, which by default is
your screen.
To save its output into a file,
use the shell's `>' operator to redirect the standard output into a file.
.SH "Getting to Know sed"
.PP
\fBsed\fR is a text editor.
It reads a text file 
one line at a time, and applies your set of editing commands
to each line as it is read.
Because it does not
ask you for instructions after it executes each command, \fBsed\fR is
a \fInon-interactive\fR text editor.
.PP
.II "sed^pipes"
The advantages of \fBsed\fR are that it can readily apply the same
editing commands to many files; it can edit a large file
quickly; and it can readily be used with \fIpipes\fR.
A pipe takes the product of
one program and feeds it into another program for further processing.  
If you are unsure of how a pipe works, refer to
\fIsh Shell Command Language Tutorial\fR.
.PP
.II "sed^ed"
\fBsed\fR resembles closely \fBed\fR.
\fBsed\fR and \fBed\fR use almost all of the same
commands, and locate lines in much the same way.
However, there are important differences between \fBed\fR and \fBsed\fR.
\fBed\fR is
interactive:
when you give \fBed\fR a command from the keyboard, it
executes that command immediately and then waits for you to enter
the next command.
\fBsed\fR, on the other hand, accepts your editing commands all at once,
either from the keyboard or, more often, from a file you prepare; 
then, as it reads your text file one line at a time, it applies every
command to every line of text.
Therefore, \fIaddressing\fR (that is,
telling the program what commands should be applied to which lines) is
much more important with \fBsed\fR than with \fBed\fR.
.PP
Keep in mind, too, that \fBsed\fR does not
change your original text file; rather, \fBsed\fR copies it, changes it,
and sends the edited file either to the standard output
or to another file that you name in the command line.
.Sh "Getting Started"
.PP
Here are a few exercises to introduce you to \fBsed\fR.
Type them into your \*(CO system to get a feel for how
\fBsed\fR works.
.PP
As explained above, \fBsed\fR applies a set of editing
commands to your text file.
To edit a file with \fBsed\fR, you must prepare
three elements:
(1) the text file that you wish to edit;
(2) a command file (or \fIscript\fR) that
contains the \fBsed\fR commands you want to apply to the text file;
and
(3) a command line that tells the \*(CO system what you want done and with
which files.
.PP
To begin, then, type the following text into your computer using
the \fBcat\fR command.
(Remember that \fB<ctrl-D>\fR is
typed by holding down the \fIctrl\fR key and simultaneously typing
\fID\fR.)
.DM
	cat >exercise1
	No man will be a sailor who has contrivance enough
	to get himself into a gaol; for being in a ship is
	being in a gaol, with the chance of being drowned.
	<ctrl-D>
.DE
Now, type in the following \fBsed\fR script.  This script will
substitute \fIjail\fR for \fIgaol\fR:
.DM
	cat >script1
	s/gaol/jail/g
	<ctrl-D>
.DE
The last step is to prepare the command line.
The command
line consists of the \fBsed\fR command, the options that tell \fBsed\fR
where its instructions will be coming from (either from a file or directly
from the command line), the name of the file to be edited, and where
the edited file should be send.
The general form of the command line is as follows:  
.DM
	sed [-n] [-e \fIcommands\fP] [-f \fIscriptname\fP] \fItextfile \fP[>\fIfile\fP]\fR
.DE
The \fB\-n\fR option will be explained below, in the section on \fIOutput\fR.
The \fB\-e\fR option tells \fBsed\fR that
\fIcommands\fR follow immediately.
The \fB\-f\fR option tells \fBsed\fR that the
commands are contained in the file \fIscriptname\fR.
\fItextfile\fR is the name of the text file to be edited.
The greater-than symbol \*(Ql>\*(Qr followed
by a file name redirects the edited version of the text file
into \fIfile\fR;
if this option is not used, the edited copy
of the text file will be sent to the standard output.
.PP
In this example, a command script has been prepared, so the \fB\-f\fR
option will be used.
Also, the edited text should appear on the terminal
screen, so the \*(Ql>\*(Qr will not be used.
Type the command line
as follows:
.DM
	sed -f script1 exercise1
.DE
The following text will appear on your screen:
.DM
	No man will be a sailor who has contrivance enough
	to get himself into a jail; for being in a ship is
	being in a jail, with the chance of being drowned.
.DE
You can use
\fBsed\fR not only to substitute one word for another,
but to add lines to files, delete lines, and perform more involved
editing.
No matter how complex your \fBsed\fR editing becomes,
though, \fBsed\fR will always use the basic format just described.  
.PP
The next few sections describe \fBsed\fR's basic commands.  
.Sh "Simple Commands"
.PP
.II "sed^>"
Type in the exercises exactly as shown and examine the results.
Use the \fBcat\fR command to enter the command file
as well as the input file.
The edited text  will appear on your terminal.
Usually when you edit, you will want to redirect the edited text to a new
file; however, for the exercises presented here,
let the edited text appear on your terminal so you
can examine the results immediately.
.Sh "Substituting"
.PP
.II "sed^substitution"
The substitution command is used very often when editing.
\fBsed\fR's substitution command \fBs\fR resembles the same command
in \fBed\fR.
Its form is as follows:
.DM
	s/\fIterm1\fP/\fIterm2\fP/
.DE
This tells \fBsed\fR to substitute \fIterm2\fR for \fIterm1\fR.  
To correct a misspelled word, for example, use this command form:
.DM
	s/mispel/misspell/
.DE
As written, this command changes only the first occurrence of \fBmispel\fR in
each line of your text file.
To change \fIevery\fR occurrence of \fImispel\fR in each line,
add \fBg\fR (the \fBg\fRlobal option) at the end of the command:
.DM
	s/mispel/misspell/g
.DE
If you want to change only the \fIthird\fR
occurrence of \fBmispel\fR on every line,
put a \fB3\fR after the \fBs\fR:
.DM
	s3/mispel/misspell/
.DE
When no digit follows the \fBs\fR and no \fBg\fR follows the
command, only the first occurrence of the term in each line (should
there be one) will be changed.
.PP
To practice the substitution, type the following file into
your system (please include the misspellings):
.DM
	cat >exercise2
	From the Devils Dictionary:
	Hemp, n. A plant from whose fiberous bark is made
	an article of neckware which is frequently put on
	after public speaking in the open air and prevents
	the wearer from tking cold.
	<ctrl-D>
.DE
Now, prepare the following \fBsed\fR script to correct the misspellings:
.DM
	cat >script2
	s/Devils/Devil's/
	s/fiberous/fibrous/
	s/tking/taking/
	<ctrl-D>
.DE
Invoke \fBsed\fR with the following command:
.DM
	sed -f script2 exercise2
.DE
The following will appear on your screen:
.DM
	From the Devil's Dictionary:
	Hemp, n. A plant from whose fiberous bark is made
	an article of neckwear which is frequently put on
	after public speaking in the open air and prevents
	the wearer from taking cold.
.DE
To see how the \fBg\fR command and the number option work,
prepare the following text file:
.DM
	cat >exercise3
	sd	sd	sd	sd
	sd	sd	sd	sd
	sd	sd	sd	sd
	<ctrl-D>
.DE
The following \fBsed\fR script changes the \fIthird\fR \fBsd\fR in each
line to \fBsed\fR:
.DM
	cat >script3
	s3/sd/sed/
	<ctrl-D>
.DE
Invoke \fBsed\fR with the following command line:
.DM
	sed -f script3 exercise3
.DE
The following will appear on your screen:
.DM
	sd	sd	sed	sd
	sd	sd	sed	sd
	sd	sd	sed	sd
.DE
To change \fIevery\fR \fBsd\fR to \fBsed\fR, use the \fBg\fR option.  
Prepare the following \fBsed\fR script:
.DM
	cat >script3a
	s/sd/sed/g
	<ctrl-D>
.DE
The following will appear on your screen:
.DM
	sed	sed	sed	sed
	sed	sed	sed	sed
	sed	sed	sed	sed
.DE
The \fBg\fR command will be most useful for editing prose, when
you have no way to tell how many times a given error will appear on a line.
The numeric option will be most useful for
editing tables and lists.
.Sh "Selecting Lines"
.PP
.II "sed^line^selection"
Each of the substitution commands given
above will be applied to every input line.
Unlike \fBed\fR, there is no error message if no line of text
contains \fIterm1\fR.
.PP
In certain instances, however, you may wish to apply a
particular command only to specific lines.
Lines can be specified (or \fIaddressed\fR)
by \fIpreceding\fR the command with the
identifying line number.
The following exercise demonstrates line selection.
First, prepare the following text file:
.DM
	cat >exercise4
	When a man is tired of London,
	he is tired of life; for there
	is in London all that life can afford.
	<ctrl-D>
.DE
To change the word \fBtired\fR to \fBfatigued\fR on line 2 only,
prepare the following
\fBsed\fR script:
.DM
	cat >script4
	2s/tired/fatigued/
	<ctrl-D>
.DE
Begin the editing of your text file by typing the following
command line:
.DM
	sed -f script4 exercise4
.DE
The following will appear on your screen:
.DM
	When a man is tired of London,
	he is fatigued of life; for there
	is in London all that life can afford.
.DE
Remember that to specify a line number, you must place the number \fIbefore\fR
the command;
but to specify the numeric option (that is, position 
within the line), you must place the number \fIafter\fR the command.
.PP
.II "sed^line^range"
You can define a \fIrange\fR of lines to be edited.
One way to do this is to list the first and last line numbers,
separated by commas, of the block of text in question.
For example, the
following script will change \fBis\fR to \fBwas\fR only in the first
two lines of the text file you just prepared:
.DM
	cat >script4a
	1,2s/is/was/
	<ctrl-D>
.DE
Entering the command line
.DM
	sed -f script4a exercise4
.DE
will bring the following text to your screen:
.DM
	When a man was tired of London,
	he was tired of life, for there
	is in London all that life can afford.
.DE
Note that the word \fBis\fR in line 3 was unaffected by the
substitution command, because it lay outside the range
of lines specified by the command.
.PP
.II "sed^pattern"
You can also select lines by \fIpatterns\fR.
Patterns are \fIstrings\fR (any collection of letters and
numbers, such as a word) that can be combined with commands.
A fuller description of \fIpatterns\fR can be found in the tutorial
for \fBed\fR.
Later on, when we show you other commands, you will
see that line selection by pattern
rather than by line number is quite useful.
.PP
.II "sed^$"
You can use
the end-of-file symbol \*(Ql$\*(Qr for line selection.
When you use this symbol, you do not have to know the exact
number of lines in your text file.
For example, if you want to apply a substitution command from
line 10 through the end of your text file,
the command form is:
.DM
	10,$s/\fIterm1\fR/\fIterm2\fR/
.DE
.Sh "p: Print Lines"
.PP
When \fBsed\fR edits a text file, the edited text is by default
sent to the \fIstandard output\fR, which usually is your terminal's screen.
(As noted above, the edited text can be optionally redirected to
another file by using the shell's \*(Ql>\*(Qr operator.)
Normally, \fBsed\fR prints
every line in the text file, whether the line is changed or not.
.PP
The next exercise will demonstrate these defaults.
First,
type in the following text file:
.DM
.ta 0.5i 1.5i 2.5i
	cat >exercise5
	Bill	g7	r115
	Nora	g8	r115
	Steve	g7	r120
	Ella	g8	r120
	Dave	g7	r115
	Robert	g8	r120
	<ctrl-D>
.DE
Next, create a script that contains no commands, by typing:
.DM
	cat >script5
	<ctrl-D>
.DE
Now, execute this empty script:
.DM
	sed -f script5 exercise5
.DE
Note that \fBsed\fR simply copied your text file to the screen,
without changing it in any way.
.PP
This default, however,
can be inconvenient if you want to print only a selected portion of a file.
Fortunately, with a couple of commands you can control \fBsed\fR's printing.
.PP
The command line option \fB\-n\fR changes \fBsed\fR's printing behavior.
When you invoke \fB\-n\fR, the text file
no longer is printed automatically.
.B sed
prints
only the lines specified by the \fBp\fR command.
The \fBp\fR command makes \fBsed\fR print whatever line (or lines)
to which it is applied.
Use \fB\-n\fR on the command line to stop \fBsed\fR from printing every line
automatically;
then use the \fBp\fR command in the script
to target the lines you want to print.
The following exercise will help you grasp this point.
First, type in the following \fBsed\fR script:
.DM
	cat >script5a
	/g7/p
	<ctrl-D>
.DE
Enter the command line:
.DM
	sed -n -f script5a exercise5
.DE
and the following text will appear on your terminal:
.DM
.ta 0.5i 1.5i 2.5i
	Bill	g7	r115
	Steve	g7	r120
	Dave	g7	r115
.DE
.B sed
prints
only the records of the students in grade 7 (\fBg7\fR).
.PP
It is important to note the order, or \fIsyntax\fR, of the \fB\-n\fR
and \fB\-f\fR command line options.
The correct order is to enter \fB\-n\fR,
then \fB\-f\fR.
(\fB\-nf\fR or \fB\-fn\fR are also acceptable.)
If you type \fB\-f\fR and then \fB\-n\fR, however, all you will get is 
an error message.
.PP
.II "sed^p command^with s"
When you use the \fBp\fR option with a
.B sed
command, \fBsed\fR will print every line of text in which that command
makes a substitution.
This can be useful, but if you are not careful it can also
create some problems.
\fBsed\fR normally prints
every line in your text file, whether or not it is changed
by your script, unless you specify the \fB\-n\fR option in your
command line.
Therefore, if you \fIdo not\fR use the \fB\-n\fR
option in your command line and you \fBdo\fR use the \fBp\fR
option with your \fBs\fR commands, every line that \fBsed\fR
edits will be printed more than once.
.PP
The following script illustrates this point:
.DM
	cat >script5b
	s/g7/g8/gp
	s/r115/r120/gp
	<ctrl-D>
.DE
Now, execute it with the following command:
.DM
	sed -f script5b exercise5
.DE
The result will look like this:
.DM
.ta 0.5i 1.5i 2.5i
	Bill	g8	r115
	Bill	g8	r120
	Bill	g8	r120
	Nora	g8	r120
	Nora	g8	r120
	Steve	g8	r120
	Steve	g8	r120
	Ella	g8	r120
	Dave	g8	r115
	Dave	g8	r120
	Dave	g8	r120
	Robert	g8	r120
.DE
.PP
\fBBill\fR and \fBDave\fR were printed three times:
the first time because
the \fBp\fR option was specified after editing the grade number,
the second time because the \fBp\fR option was specified after
editing the room number, and the third time because the \fB\-n\fR
option was \fInot\fR used on the command line.
\fBSteve\fR and \fBNora\fR were printed twice:
the first time because their lines were edited once
each, and the second time because the \fB\-n\fR option was not used on
the command line.
\fBElla\fR and \fBRobert\fR appeared once because their lines
were not edited at all and the \fB\-n\fR option was not specified in
the command line.
.PP 
To get around this problem, use the \fB\-n\fR option and use \fBp\fR only
once, on the last substitution:
.DM
	cat >script5c
	s/g7/g8/g
	s/r115/r120/gp
	<ctrl-D>
.DE
When you enter the following command line
.DM
	sed -n -f script5c exercise5
.DE
the new result will be:
.DM
.ta 0.5i 1.5i 2.5i
	Bill	g8	r120
	Nora	g8	r120
	Dave	g8	r120
.DE
The \fBw\fR command acts like the \fBp\fR command, except that matched lines
are written to the file whose name follows the \fBw\fR.
The following script shows the correct form:
.DM
	cat >script5d
	s/g8/g9/w grade.9
	s/g7/g8/w grade.8
	<ctrl-D>
.DE
When you execute script5d with this command:
.DM
	sed -f script5d exercise5
.DE
the normal product will be seen produced at your terminal, 
and the edited 
lines will be written to files \fBgrade.8\fR and \fBgrade.9\fR.
File \fBgrade.8\fR will contain:
.DM
.ta 0.5i 1.5i 2.5i
	Bill	g8	r115
	Steve	g8	r120
	Dave	g8	r115
.DE
Note the order in which the two \fBs\fR commands were given.
If their
order were reversed, every text line with \fBg7\fR in it would have \fBg7\fR
changed to \fBg8\fR by the first \fBs\fR command, then have this newly
created \fBg8\fR changed to \fBg9\fR by the second \fBs\fR command.
Thus, \fIall\fR the students would be shown to be in \fBg9\fR,
and every text line would be printed into the file \fBgrade.9\fR.
.Sh "Line Location"
.PP
When you edit a file with \fBsed\fR, it is hard to keep track of line numbers.
As noted earlier, you can locate specific lines with \fBsed\fR by
using patterns as \fIline\fR \fIlocators\fR.
To see how this works, type the following text file into your system:
.DM
	cat >exercise6
	From the Book of Proverbs:
	As a door turneth upon his hinges, so the
	slothful man turneth upon his bed.
	A soft answer turneth away wrath:  but grievous
	words stir up anger.
	<ctrl-D>
.DE
Now, prepare the following \fBsed\fR script:
.DM
	cat >script6
	/door/,/bed/s/turneth/turns/
	<ctrl-D>
.DE
Execute it by entering the following command line:
.DM
	sed -f script6 exercise6
.DE
The text will appear on your terminal this way:
.DM
	From the Book of Proverbs:
	As a door turns upon his hinges, so the
	slothful man turns upon his bed.
	A soft answer turneth away wrath:  but grievous
	words stir up anger.
.DE
Note that the word \fIturns\fR was substituted for the word \fIturneth\fR
only in the first proverb, not the second.
The reason is that the
\fBs\fR command in this instance was preceded by the \fIpatterns\fR
\fBdoor\fR and \fBbed\fR.
These told \fBsed\fR to begin making the substitution
on the first line in which the word \fBdoor\fR appears, and to stop
making the substitution with the first line in which the word \fBbed\fR
appears.
In the text file, the fourth line also contained the word
\fBturneth\fR, but because it lay outside the range of line specified by
the line locators, no substitution was made.
.PP
When \fBsed\fR locates
the last line of a block of text that you have defined, it will immediately 
look for the next occurrence of the first line locator.
If it finds that first line locator, it will then resume making the
substitution to your file until it again finds the second line
locator or comes to the end of the file, whichever occurs first.
In this example, when \fBsed\fR found the word \fBbed\fR, it began
to look again for the word \fBdoor\fR; and if it had found the word \fBdoor\fR,
it would have resumed substituting \fBturns\fR for \fBturneth\fR.
.PP
Remember that, as explained earlier, line numbers can also be used
as line locators.
For example, the \fBsed\fR script
.DM
	2,3s/turneth/turns/
.DE
would have produced the same changes as did the script with the pattern line
locators prepared earlier.
.Sh "Add Lines of Text"
.PP
\fBsed\fR can add lines to your text file.
To see how \fBsed\fR
does this, first prepare the following text file:
.DM
	cat >exercise7
	From the Devil's Dictionary:
	Syllogism, n. A logical formula consisting of a major
	and a minor assumption and an inconsequent.
	<ctrl-D>
.DE
Now, type in the following script:
.DM
	cat >script7
	3a\e
	Economy, n. Purchasing the barrel of whiskey you do not \e
	need for the price of the cow you cannot afford.
	<ctrl-D>
.DE
When you implement the script:
.DM
	sed -f script7 exercise7
.DE
you will see this result:
.DM
	From the Devil's Dictionary:
	Syllogism, n. A logical formula consisting of a major
	and a minor assumption and an inconsequent.
	Economy, n. Purchasing the barrel of whiskey you do not 
	need for the price of the cow you cannot afford.
.DE
The append command \fBa\fR added text \fIafter\fR the third line of the file.
You defined where the text went.
Notice the backslash \*(Ql\e\*(Qr
at the end of the line with the \fBa\fR command.
This indicates that the next line is part of the command.
When you append several lines of text, each line but
the last one to be added must end with a \*(Ql\e\*(Qr as in our example.
.PP
Note that no other editing command, such as \fBs\fR, can affect any line
added with \fBa\fR.
These lines go directly to your screen, or to
a file, should you be sending the edited text there, and are invisible to
all other \fBsed\fR commands.
.PP
The insert command \fBi\fR works like the \fBa\fR command,
except that it adds its lines \fIbefore\fR the
addressed line, rather than after.
The following script shows how the
\fBi\fR command works:
.DM
	cat >script7a
	2i\e
	Peace, n. In international affairs, a period of cheating\e
	between two periods of fighting.
	<ctrl-D>
.DE
Invoking it with this command:
.DM
	sed -f script7a exercise7
.DE
produces this:
.DM
	From the Devil's Dictionary:
	Peace, n. In international affairs, a period of cheating
	between two periods of fighting.
	Syllogism, n. A logical formula consisting of a major
	and a minor assumption and an inconsequent.
.DE
As with the \fBa\fR command, no substitutions or other changes
are performed on lines added with \fBi\fR.
.PP
Note, too, that you can \fIbracket\fR a text line by using the \fBa\fR and
\fBi\fR commands at the same time.
Adding a line with either \fBa\fR
or \fBi\fR does not change line numbers of the text file you are
editing (although it does, of course, change the line numbers of
the file \fBsed\fR writes).
.Sh "Delete Lines"
.PP
The \fBd\fR command deletes lines that you do not want in the edited text.
The original file stays unchanged, of course.
.PP
Lines that match the address (be it a line number, range, or pattern)
of a \fBd\fR command do not appear in the output.
Exercise 8 illustrates the \fBd\fR command:
.DM
	cat >exercise8
	The sun was shining on the sea,
	Shining with all his might.
	He did his very best to make
	The billows smooth and bright --
	And this was odd, because it was
	The middle of the night.
	<ctrl-D>
.DE
Now, you have to define the lines to be deleted
by matching them with a unique pattern or a line number.
To delete lines 3 through 6, prepare this script:
.DM
	cat >script8
	/best/,/night/d
	<ctrl-D>
.DE
The command:
.DM
	sed -f script8 exercise8
.DE
generates this result:  
.DM
	The sun was shining on the sea,
	Shining with all his might.
.DE
Note that when
a line is deleted, no other commands are applied to it.
Usually, if a \fBsed\fR script holds a number of commands,
every one of those commands is applied to every line read from your
text file; however,
\fBsed\fR is logical enough to read the next text line immediately,
should a \fBd\fR command delete the current line
before the series of commands has finished.
.Sh "Change Lines"
.PP
.II "sed^change lines"
The \fBc\fR command combines the \fBi\fR and \fBd\fR options.
Text is inserted before the addressed lines, which are then deleted.
To see how this command works, prepare the following text file:
.DM
	cat >exercise9
	Twas brillig, and the slithy toves
	Did gyre and gimble in the wabe;
	All mimsy were the borogoves,
	And the mome raths outgrabe.
	<ctrl-D>
.DE
Now, type in the following script:
.DM
	cat >script9
	1,2c\e
	Twas brilliant, and the shining cove\e
	Did glare and glimmer in the wave;
	<ctrl-D>
.DE
When you execute your script with the following command line:
.DM
	sed -f script9 exercise9
.DE
the result is:
.DM
	Twas brilliant, and the shining cove
	Did glare and glimmer in the wave;
	All mimsy were the borogoves,
	And the mome raths outgrabe.
.DE
Like the \fBi\fR and \fBa\fR commands,
the \fBc\fR command requires all added lines but the last to end
with \*(Ql\e\*(Qr.
.Sh "Include Lines From a File"
.PP
.II "sed^including a file"
When you edit a file, you may wish to include, or \fIread in\fR,
a second file as part of it.
.II "sed^reading in"
This is done with \fBr\fR command.
To see how this works, type the following file into
your computer, and call it \fBinclude\fR:
.DM
	cat >include
		Then there comes the often-used refrain
		Whose repetitious writing dulls the brain.
	<ctrl-D>
.DE
Now, prepare the file to be edited:
.DM
	cat >exercise10
	To write a poem doesn't take much time;
	Just string some words to rhythm and a rhyme.
	What poets do to language is a crime,
	Words and syntax twisted for a rhyme.
	<ctrl-D>
.DE
When you write your script, you must tell \fBsed\fR where to read in
\fBinclude\fR.
The form of the command should be familiar by now:
.DM
	cat >script10
	/rhyme/r include
	<ctrl-D>
.DE
The result is of
.DM
	sed -f script10 exercise10
.DE
is:
.DM
	To write a poem doesn't take much time;
	Just string some words to rhythm and a rhyme.
		Then there comes the often-used refrain
		Whose repetitious writing dulls the brain.
	What poets do to language is a crime,
	Words and syntax twisting for a rhyme.
		Then there comes the often-used refrain
		Whose repetitious writing dulls the brain.
.DE
Note that the \fBr\fR command
inserted \fBinclude\fR \fIafter\fR the addressed line.
You can address lines by number, of course, as well as by pattern.
.Sh "Quit Processing"
.PP
The \fBq\fR command makes \fBsed\fR stop processing the text file.
You will use this command most often to limit the application your \fBsed\fR
script to a portion of your text file.
For example, if you were editing a large file and
you knew that your commands would be irrelevant to the last half of the
file, you could insert an appropriately addressed \fBq\fR
and save some computer time.
You can also use  this command to print portions of a file.
.PP
To see how this is done, prepare the following text file:
.DM
	cat >exercise11
	An hourglass has a very wide top,
	       a very narrow
	           middle
	        and a bottom
	that is also extremely wide.
	<ctrl-D>
.DE
The following script will print the top of the text file.
Note how the script uses \fBmiddle\fP to address the
line where the file is to be split.
.DM
	cat >script11
	/middle/q
	<ctrl-D>
.DE
The command:
.DM
	sed -f script11 exercise11
.DE
produces:
.DM
	An hourglass has a very wide top,
	       a very narrow
	           middle
.DE
To print out only the lines \fIafter\fR the pattern \fBmiddle\fR, simply delete
the first half of the file with the \fBd\fR command, as follows:
.DM
	cat >script11a
	1,/middle/d
	<ctrl-D>
.DE
The result is the output:
.DM
	        and a bottom
	that is also extremely wide.
.DE
.Sh "Next Line"
.PP
.II "sed^next line"
The \fBn\fR command advances to the next line of the text file.
The \fBn\fR command is useful for instances when you have two or more
interrelated lines, and you want to ensure th
a particular set of patterns is matched over the entire
set of lines.
To see how \fBn\fR works, prepare the following text file:
.DM
	cat >exercise12
	Alpha
	One
	Beta
	Two
	Gamma
	Three
	Delta
	Four
	Epsilon
	Five
	<ctrl-D>
.DE
To print a list of letters alone, type the following script:
.DM
	cat >script12
	n
	d
	<ctrl-D>
.DE
and execute it with the following command line:
.DM
	sed -f script12 exercise12
.DE
The result will be the following:
.DM
	Alpha
	Beta
	Gamma
	Delta
	Epsilon
.DE
Remember that \fBn\fR does \fInot\fR stop processing,
go to the next text line, and begin processing all over again.
Rather, it simply reads the next input line and continues
processing from where it left off.
For example, if your
\fBsed\fR file consisted of three commands, the second of which
was the \fBn\fR command, \fBsed\fR would apply the first
command to the first line it read, then jump to the second line
and apply the last commands.
Then, it would read the third line and begin the pattern over again.
To see how this works, prepare the following text file:
.DM
	cat >exercise13
	Alpha
	Alpha
	Alpha
	Alpha
	<ctrl-D>
.DE
Now type in this script:
.DM
	cat >script13
	s/Alpha/Apple/
	/Apple/n
	s/Alpha/Banana/
	<ctrl-D>
.DE
When you execute the script with this command line:
.DM
	sed -f script13 script13
.DE
the following will appear on your terminal:
.DM
	Apple
	Banana
	Apple
	Banana
.DE
Note that the first substitution command changed the first \fBAlpha\fR
to \fBApple\fR; the \fBn\fR command moved \fBsed\fR to the next
line; and the second \fBs\fR command changed that \fBAlpha\fR
to \fBBanana\fR.
.SH "Advanced sed Commands"
.PP
The following sections discuss
.BR sed 's
advanced features.
They also discuss the method of operation.
.Sh "Work Area"
.PP
As described earlier, \fBsed\fR reads your text file one line at
a time, and applies all of your editing commands to that line.
After
the editing commands have been applied, the edited line is either sent to
the \fIstandard output\fR, written to a file you have named, or thrown
away, depending on what you have told \fBsed\fR to do.
.PP
When \fBsed\fR reads a line from your text file, it copies that line
into a \fIwork area\fR, where it actually executes your editing commands.
\fBsed\fR notes the number of the line in the work area,
then executes each editing command in turn, first
checking to see if the patterns or line numbers specified
in each command actually apply to that line.
After each command is checked in turn and performed if
indicated, \fBsed\fR prints the edited line (if it is supposed to be), and
reads the next text line.
.Sh "Add to Work Area"
.PP
The exercises so far have used only one line in the work area.
The \fBN\fR command, however, tells \fBsed\fR to read a second line into
the work area.
The following exercise illustrates the use of the work area and the \fBN\fR
command.
.DM
	cat >exercise14
	This exercise has a brok
	en word.
	<ctrl-D>
.DE
Now, prepare the following \fBsed\fR script:
.DM
	cat >script14
	/brok$/N
	s/brok\enen/broken/
	s/has/had/
	<ctrl-D>
.DE
and execute it with the following command line:
.DM
	sed -f script14 exercise14
.DE
which produces the following text:
.DM
	This exercise had a broken word.
.DE
You will find it helpful to review this exercise in some detail.
The first command in the script
.DM
	/brok$/N
.DE
tells \fBsed\fR to search for the pattern \fBbrok\fR at the \fIend\fR
of the line of text.
(The dollar sign \*(Ql$\*(Qr in this instance
indicates the end of the line; remember that when the \*(Ql$\*(Qr
is used with a line number, it indicates the end of the \fIfile\fR.)
The \fBN\fR command tells \fBsed\fR to keep this line in the
working space, and copy the \fInext\fR line into the working space as well.
.PP
When \fBsed\fR executes this command on the present text file,
the work area will look like this:
.DM
	This example has a brok<newline>en word.
.DE
Note that the two lines now appear to \fBsed\fR as though they formed
one long line.
The word \fB<newline>\fR represents the end of line character
that tells your terminal or printer to jump to a new line when the text
file is printed out.
This character is invisible, but it is there, and it can be changed or
deleted.
You can describe this character to \fBsed\fR by using
the characters \fB\en\fR.
The first substitution in this script
.DM
	s/brok\enen/broken/
.DE
replaces \fBbrok<newline>en\fR with \fBbroken\fR.
Because the newline character is deleted from the text, what used to be
printed out as two lines on your screen will now be printed out as one.
.PP
Note the difference, too, between the \fBn\fR and \fBN\fR commands.  
The \fBn\fR command will \fIreplace\fR the text line in the work area with the
next line from your text file.
The \fBN\fR command, however,
\fIappends\fR the next line from your text file to the end of the text
already in the working area.
The next exercise demonstrates this difference.
First, create the following text file:
.DM
	cat >exercise15
	Apple
	Apple
	Apple
	Apple
	<ctrl-D>
.DE
Now, prepare the following two scripts:
.DM
	cat >script15
	/Apple/n
	s/Apple/Banana/g
	<ctrl-D>
.sp \n(pDu
	cat >script15a
	/Apple/N
	s/Apple/Banana/g
	<ctrl-D>
.DE
When script15 is executed with the following command line:
.DM
	sed -f script15 exercise15
.DE
this will appear on your screen:
.DM
	Apple
	Banana
	Apple
	Banana
.DE
The \fBn\fR command told \fBsed\fR to print out the line
already in the work area before reading in the next line from the text file.
This meant that \fBsed\fR substituted \fBBanana\fR for \fBApple\fR only on the
\fIsecond\fR line of each pair.
.PP
Note what happens, however, when you run script15a, using this command line:
.DM
	sed -f script15a exercise15
.DE
This text appears:
.DM
	Banana
	Banana
	Banana
	Banana
.DE
Because \fIboth\fR lines of each pair were kept in the
work area, the substitution command changed both of them.
.Sh "Print First Line"
.PP
The \fBP\fR command prints material from the work area.
Unlike the \fBp\fR command,
which prints \fIeverything\fR in the work area, \fBP\fR prints only
the \fIfirst\fR line in the work area.
To see how this works, prepare the following text file:
.DM
	cat >exercise16
	Student:  George
	Teacher:  Mr. Starzynski
	Student:  Marian
	Teacher:  Miss Peterson
	Student:  Ivan
	Teacher:  Mr. Starzynski
	<ctrl-D>
.DE
Now, prepare the following scripts:
.DM
	cat >script16
	/Student/N
	/Mr. Starzynski/p
	<ctrl-D>
.sp \n(pDu
	cat >script16a
	/Student/N
	/Mr. Starzynski/P
	<ctrl-D>
.DE
When the first of these scripts is executed with the following
command line (note the use of the \fB-n\fR option):
.DM
	sed -n -f script16 exercise16
.DE
the result is
.DM
	Student:  George
	Teacher:  Mr. Starzynski
	Student:  Ivan
	Teacher:  Mr. Starzynski
.DE
whereas script16a, when executed as follows:
.DM
	sed -n -f script16a exercise16
.DE
produces
.DM
	Student:  George
	Student:  Ivan
.DE
In
.BR script16 , 
the \fBN\fR command lines pull both the name of the student
and the name of the teacher into \fBsed\fR's work area; the
\fBp\fR command prints the student and teacher in each case where
the teacher is Mr. Starzynski.
In
.BR script16a ,
however, the \fBN\fR pulled both student and teacher into the work area,
the
.B P
command printed only the \fIfirst\fR line of the work area \(em that is,
the name of the student.
.PP
As you can see, \fBP\fR is a powerful tool
that will allow you to select material from
tables, lists, and other repetitive files.
.Sh "Save Work Area"
.PP
\fBsed\fR can create a second work area in addition to the primary
work area in which \fBsed\fR performs its editing.
\fBsed\fR does
not execute any editing commands on the material stored in this
secondary work area; rather, this work area can be used to store
material that you want to edit or insert later.
.PP
The commands \fBh\fR and \fBH\fR copy material from the primary
work area into the secondary work area.
\fBh\fR and \fBH\fR differ
in that \fBh\fR \fIdisplaces\fR any material in the secondary work area
with the line being copied there, whereas \fBH\fR \fIappends\fR the line
being copied onto the material already in the secondary work area.
Note, too,
that both \fBh\fR and \fBH\fR merely \fIcopy\fR the primary work area
into the secondary work area \(em after these commands have been executed,
the material in the primary work area remains intact, and can be
edited further, printed out, or deleted, whichever you prefer.
.PP
The commands \fBg\fR and \fBG\fR copy material back from the secondary
work area into the primary work area.
Again, these commands differ
in that \fBg\fR \fIdisplaces\fR whatever is in the primary work
area with the material from the secondary work area, whereas \fBG\fR
\fIappends\fR the material from the secondary work area onto the
material already in the primary work area.
.PP
The following exercises will demonstrate how these commands are used.
First, create the following text file:
.DM
	cat >exercise17
	fruit:  apple
	berry:  gooseberry
	fruit:  orange
	berry:  raspberry
	fruit:  pear
	berry:  blueberry
	<ctrl-D>
.DE
The first script uses the \fBh\fR and \fBg\fR commands:
.DM
	cat >script17
	/fruit/h
	/fruit/d
	/berry/g
	<ctrl-D>
.DE
When you execute this script with the following command line:
.DM
	sed -f script17 exercise17
.DE
you receive the following text on your screen:
.DM
	fruit:  apple
	fruit:  orange
	fruit:  pear
.DE
Review the last script in detail.
The first command, \fB/fruit/h\fR,
copied the line beginning with \*(QLfruit\*(QR into the secondary work
area, displacing whatever happened to be there.
The command \fB/fruit/d\fR then deleted the line from the
primary work area; if this were not done, it would then have been printed out.
The third command,
\fB/berry/g\fR then recopied the material from the secondary work area into
the primary work area, displacing all lines in the primary work area
that begin with ``berry''.
The result of all this shuffling and displacing was that
the three lines that begin with \fBfruit\fR were printed out.
.PP
The next script demonstrates the \fBH\fR command:
.DM
	cat >script17a
	/fruit/H
	/fruit/d
	/berry/g
	<ctrl-D>
.DE
When you execute this script with the following command line:
.DM
	sed -f script17a exercise 17
.DE
you see:
.DM
	fruit:  apple
	fruit:  apple
	fruit:  orange
	fruit:  apple
	fruit:  orange
	fruit:  pear
.DE
Because the \fBH\fR command \fIappends\fR material into the secondary
work area, rather than replacing it as \fBh\fR does, all three lines
that began with \fBfruit\fR were cumulatively
stored in the secondary work area.
Because the \fBg\fR command was used for every line that began with
\fBberry\fR, the contents of the secondary
work area (that is, the \fBfruit\fR lines)
were written over each of the three lines that began with \fBberry\fR.
.PP
The next script demonstrates the use of the \fBG\fR command:
.DM
	cat >script17b
	/fruit/H
	/fruit/d
	/berry/G
	s/berry://g
	s/fruit://g
	<ctrl-D>
.DE
When you execute this script with the following command line:
.DM
	sed -f script17b exercise17
.DE
you will see:
.DM
	gooseberry
	apple
	raspberry
	apple
	orange
	blueberry
	apple
	orange
	pear
.DE
The \fBH\fR command copies the lines that begin with
\fBfruit\fR into the secondary work area.
The \fBG\fR command then re-copies them from the secondary
work area into the primary work area, and appends them
to the material already in the primary work area \(em that is, to a
line that begins with \fBberry\fR.
.PP
The two substitution commands
then strip off the \fBfruit\fR and \fBberry\fR prefixes; obviously,
these substitutions do not affect the operation of the \fBH\fR and \fBG\fR
commands, but they do create a tidier result.
.PP
By the way, be sure you
distinguish the \fBg\fR command from the \fBg\fR option used with the \fBs\fR
command.
If you do not, what \fBsed\fR finally prints out for
you may appear very strange.
.PP
The final command that uses the secondary work area is \fBx\fR,
which exchanges the two work areas.
The following script shows how this is used:
.DM
	cat >script17c
	/fruit/H
	/fruit/d
	/blueberry/x
	s/berry://g
	s/fruit://g
	<ctrl-D>
.DE
When you execute this script with the following command line:
.DM
	sed -f script17c exercise17
.DE
you see:
.DM
	gooseberry
	raspberry
	apple
	orange
	pear
.DE
The text lines that began with \fBfruit\fR were moved into the
secondary working area.
The \fBx\fR command was executed
when the line that contained the word \fBblueberry\fR was reached, and
the two working areas exchanged their contents.
The \fBfruit\fR lines
were then printed out, while the \fBblueberry\fR line was simply left
in the secondary working at the end of the program, and disappeared
when the program concluded.
.PP
Note that \fBx\fR simply swaps the two working areas \(em there
is no \*(QL\fBX\fR\*(QR command that appends the work areas onto each
other.
.Sh "Transform Characters"
.PP
The \fBy\fR command is a special form of the \fBs\fR command.
With the \fBy\fR command, you can replace a number of
characters easily, without having to write a series of \fBs\fR
commands.
.PP
The form of the command is:
.DM
	y/123/abc/
.DE
In the above example, \fB1\fR will be replaced with \fBa\fR, \fB2\fR
with \fBb\fR,
and \fB3\fR with \fBc\fR throughout the document (no \fBg\fR option is
needed).
For \fBy\fR to work properly there must be a one-to-one
relationship between the characters being replaced and the characters
replacing them.
Also, \fBy\fR cannot make exchanges that involve
more than one character \(em it cannot, for example, replace \fBapple\fR with
\fBbanana\fR.
.PP
One useful task for the \fBy\fR command is to change all upper-case
letters in a file to lower case.
Prepare the following text file to see how this is done:
.DM
	cat >exercise18
	NOW IS THE TIME FOR ALL GOOD MEN TO COME
	TO THE AID OF THE PARTY.  
	<ctrl-D>
.DE
And prepare the following script, which will change
these capitals:
.DM
	cat >script18
	y/ABCDEFGHI/abcdefghi/
	y/JKLMNOPQR/jlkmnopqr/
	y/STUVWXYZ/stuvwxyz/
	<ctrl-D>
.DE
The alphabet is entered here in three chunks, to prevent the
command from being too long to type easily.
Execute this script with the following command line:
.DM
	sed -f script18 exercise18
.DE
The result is:
.DM
	now is the time for all good men to come
	to the aid of the party.
.DE
.Sh "Command Control"
.PP
\fBsed\fR gives you advanced control over the execution of commands.
The next subsections describe how these command controls help you write compact, powerful
scripts.
.Sh "{ }: Command Grouping"
.PP
In several of the exercises presented so far, more than one command
specified the same line locator.
By using braces \*(Ql{\*(Qr and \*(Ql}\*(Qr, you can
bundle commands, which makes writing your scripts easier and
lessens the chance of making a typographical error.
.PP
To see how this is done, type the following exercise:
.DM
	cat >exercise19
	When my love swears that she is made of truth,
	I do believe her, though I know she lies,
	That she might think me some untutored youth,
	Unlearned in the world's false subtleties.
	<ctrl-D>
.DE
Now, prepare the following script:
.DM
	cat >script19
	/truth/{N
	P
	}
	/lies/d
	<ctrl-D>
.DE
When you execute this script with the following command line:
.DM
	sed -f script19 exercise19
.DE
the result on your terminal is:
.DM
	When my love swears that she is made of truth,
	That she might think me some untutored youth,
	Unlearned in the world's false subtleties.
.DE
Note the syntax of this command.
Each subsequent command must go on a line of its own,
as must the right brace \*(Ql}\*(Qr.
If this syntax is not observed, you will receive an error message.
.Sh "!: All But"
.PP
The \fB!\fR flag inverts a line selector; that is to say, the
command will be performed on every line \fIbut\fR the one named
in the line selector.
The following script will show how this works:
.DM
	cat >script19a
	2!d
	<ctrl-D>
.DE
which, when run with the following command line:
.DM
	sed -f script19a exercise19
.DE
produces
.DM
	I do believe her, though I know she lies,
.DE
This script deleted every line \fIexcept\fR line 2.
The \fB!\fR flag may also be used with a range of lines, as indicated by
line numbers or line patterns; in either case, you must place the \fB!\fR flag
\fIafter\fR the line selectors and immediately \fIbefore\fR
the command.
Obviously, the \fB!\fR flag is very powerful,
and can be used to sift out a few desired lines from
a large file.
.Sh "= : Print Line Number"
.PP
You may wish to print only the \fIline number\fR of lines that
contain a selected pattern.
This is done with the \fB=\fR command.
For example, you may wish to know the number of each line in the
exercise that contains the word \fBshe\fR.
The following script:
.DM
	cat >script19b
	/she/=
	<ctrl-D>
.DE
when executed with the following command line (note the \fB-n\fR option):
.DM
	sed -n -f script19b exercise19
.DE
produces this result:
.DM
	1
	2
	3
.DE
These numbers can be stored in a file and used in further editing, or
included with the text of the fully edited file to provide a series
of line markers.
.Sh "Skipping Commands"
.PP
\fBsed\fR normally processes editing commands in order, beginning with the 
first command and proceeding sequentially to the last.
This behavior can be
modified by the branching commands: \fBb\fR, \fBt\fR, and \fB:\fR.
.PP
These commands must be used with the colon (\fB:\fR) command, which
defines a \fIlabel\fR point in the list of commands.
.PP
The \fBbranch\fR command \fBb\fR allows you to skip unconditionally
some editing commands in your script.
The following exercise demonstrates how this can be used:
.DM
	cat >exercise20
	They went to sea in a sieve, they did;
	In a sieve they went to sea;
	In spite of all their friends could say,
	On a winter's morn, on a stormy day,
	In a sieve they went to sea.
	<ctrl-D>
.DE
The following script uses the \fBb\fR command to avoid making certain
changes to the first line of the poem:
.DM
	cat >script20
	s/sea/drink/g
	/They/bend
	s/sieve/ship/g
	:end
.DE
When you execute this script with the following command line:
.DM
	sed -f script20 exercise20
.DE
you will see:
.DM
	They went to drink in a sieve, they did;
	In a ship they went to drink;
	In spite of all their friends could say,
	On a winter's morn, on a stormy day,
	In a ship they went to drink.
.DE
Note that the word \fBsea\fR is changed to \fBdrink\fR throughout the file;
however, when \fBsed\fR noted that the word \fBThey\fR appeared in line 1,
the \fBb\fR command forced it to seek the \fB:\fR command that was
labeled with the word \fBend\fR, and to continue editing only \fIafter\fR
it found the labelled \fB:\fR command.
In so doing, \fBsed\fR skipped
the command to substitute \fBship\fR for \fBsieve\fR,
which is why that substitution was not made in line 1.
.PP
Note the syntax of the \fBb\fR command:
the label follows it without a break.
The text of the label is unimportant,
just so long as it matches that used in the \fBb\fR command; however,
the use of a label allows you to place several \fBb\fR or (as will be
seen) \fBt\fR commands in the same script without mixing them up.
.Sh "t: Test Command"
.PP
The \fBtest\fR command, \fBt\fR, also allows you to change the order in
which editing commands are executed.
Unlike the \fBb\fR command,
which simply examines a line for a given pattern,
the \fBt\fR command \fItests\fR to see if a particular
substitution has been performed.
.PP
The following script demonstrates the use of the \fBt\fR command:
.DM
	cat >script20a
	s/They/they/g
	tend
	s/sieve/ship/
	:end
	s/sea/drink/g
	<ctrl-D>
.DE
which, when executed with the following command line:
.DM
	sed -f script20a exercise20
.DE
produces:
.DM
	they went to drink in a sieve, they did;
	In a ship they went to drink;
	In spite of all their friends could say,
	On a winter's morn, on a stormy day,
	In a ship they went to drink.
.DE
Note that the \fBt\fR command checked to see that \fBthey\fR was
substituted for \fBThey\fR before branching to the \*(Ql:\*(Qr command
labeled with the word \fBend\fR.
.PP
Also note the syntax of the \fBt\fR command:
Like the \fBb\fR command,
the label immediately follows the command and is not separated
by a space; unlike the \fBb\fR command, however, the \fBt\fR command
appears on the line \fIbelow\fR the substitution command for which
it is testing.
.SH "For More Information"
.PP
The Lexicon entry for
.B sed
summarizes its command-line options and commands.
The \*(CO line editor \fBed\fR resembles \fBsed\fR,
except that it works interactively instead of in a stream.
For information on \fBed\fR, see its tutorial or its entry
in the Lexicon.

.TH login "" "" "System Administration"
.PC "Set default values for logging in"
.B "/etc/default/login"
.PP
.II /etc/default/login
The command
.B login
reads the file
.BR /etc/default/login ,
which gives
.BR login 's 
default settings.
These settings dictate some of
.BR login 's
behaviors.
.B login
exports some settings as environmental variables, to help control
the behavior of some other programs within \*(CO.
.PP
For a list of the settings normally set by
.BR /etc/default/login ,
see the Lexicon entry for the command
.BR login .
.SH "See Also"
.Xr "Administering COHERENT," administe
.Xr "login" login

.IP \fBae\fR 1.0i
\fBeditor/ae.tar.Z\fR
(disk 1)
.br
A full-screen editor that allows both MicroEMACS-style
and
.BR vi -style
key bindings.
.IP \fBarc\fR
\fBfile_utils/arc.tar.Z\fR
(disk 1)
.br
A file archiver and unarchiver.
.IP "\fBelm 4.2\fR"
\fBmailers/elm42.zip\fR
(disk 3)
.br
A newer version of the popular UNIX mailer.
.IP "\fBf2c\fR"
\fBlanguages/f2c.zip\fR
(disk 2)
.br
A FORTRAN-to-C translator.
.IP "\fBfreeze\fR"
\fBfile_utils/freeze.zip\fR
(disk 3)
.br
A file compression/decompression utility.
.IP "\fBgraphica 2.2\fR"
\fBgraphics/graphica.zip\fR
(disk 2)
.br
Produces code for PostScript and HPGL printers for printing
charts, graphs, and other documents.
.IP "\fBggrep\fR"
\fBfile_utils/grep.tar.Z\fR
(disk 5)
.br
The
.B GNU
versions of
.B grep
and
.BR egrep .
.IP \fBgzip\fR
\fBfile_utils/gzip.tar.Z\fR
(disk 5)
.br
A file compression/decompression utility from
.BR GNU .
It works with files compressed with
.B pack
from other UNIX systems.
.IP \fBhack\fR
\fBgames/hack.tar.Z\fR
(disk 4)
.br
A 
.BR rogue -style
adventure game.
.IP \fBindent\fR
\fBfile_utils/intent.tar.Z\fR
(disk 1)
.br
A utility to indent C source files.
.IP "\fBka9q\fR"
\fBcommunicate/ka9q.tar.Z\fR
(disk 1)
.br
A popular package used for HAM-radio packet communications.
Provides SLIP support.
.IP \fBmdf\fR
\fBfile_utils/mdf.tar.Z\fR
(disk 1)
.br
Produces System-V style output from COHERENT's
.B df
command.
.IP \fBpatch201\fR
\fBfile_utils/patch201.zip\fR
(disk 3)
.br
Utility to merge context-style
.B diff
output with text files.
.IP "\fBpcl302\fR"
\fBfile_utils/pcl302.zip\fR
(disk 3)
.br
A utility that lists files and directories.
It lists contents of binary files in hexadecimal.
.IP "\fBrn\fR"
\fBnews/rn444.zip\fR
(disk 5)
.br
A very popular newsreader program.
.IP "\fBularn\fR"
\fBgames/ularn.tar.Z\fR
(disk 4)
.br
The search for the cure of dianthroritis through a deadly
dungeon and a volcano.
.IP \fButree\fR
\fBfile_utils/utree.tar.Z\fR
(disk 4)
.br
A utility for listing directories and files.
.IP \fBwarp\fR
\fBgames/warp.tar.Z\fR
(disk 5)
.br
A popular screen game based upon the original Star Trek
television series.
.IP \fBzork\fR
\fBgames/zork.zip\fR
(disk 2)
.br
The popular text adventure game run on many mainframes.

.ds TL "Kernel Internals"
.NH "The COHERENT Kernel"
.PP
.II "kernel^description"
This section sketches the \*(CO kernel.
It also discusses defensive programming practices,
how to rebuild the kernel to include a newly written driver, and how to
interpret a dump from a failed driver.
.PP
The kernel is the program that permanently resides in memory
to control the moment-to-moment operation of \*(CO.
It works by controlling \fIprocesses\fR and \fIdevices\fR.
The following sub-sections introduce each.
.Sh "Processes and Scheduling"
.PP
.II process^definition
A
.I process
is a program that is being executed.
The kernel ``slices'' the processor's time amongst all processes,
which creates the illusion that \*(CO is running many programs simultaneously.
.PP
As you can see, managing processes \(em that is, seeing that each process
receives its share of the processor's time \(em is one of the kernel's main
tasks.
To do this, the kernel creates two queues whose entries describe every
process that the kernel has been asked to execute.
.II "queue^ready"
.II "ready queue"
One, the
.I ready
queue, describes every process that is ready to be processed further by
the microprocessor.
.II "suspended queue"
.II "queue^suspended"
The other, the
.I suspended
queue, describes every process that is waiting for something to happen;
for example, a word-processing program that is awaiting a keystroke
is placed on the suspended queue.
.PP
The kernel selects a process from the ready queue, then executes it
either until it has reached a stopping
point or until it has exhausted the slice of time allotted to it.
If the process has exhausted its slice of time,
the kernel moves it to the end of the ready queue.
.II sleep^definition
If, however, the process is awaiting an event,
the kernel moves it to the suspended queue.
A process on the suspended queue is said to be
.IR sleeping .
In either case,
the kernel saves the current state of the process,
then selects the next process from the ready queue and executes it.
.PP
.II "external events"
When an external event occurs (e.g., the user presses a key), the kernel
searches the suspended queue for a process that is awaiting that event.
If it finds one, the kernel moves it to the ready queue, where it waits
its turn to be executed further.
This continues until all processes have run to completion.
.PP
Before release 4.2.12 of \*(CO, the kernel selected processes from the
ready queue sequentially \(em that is, it executed each process in turn,
regardless of that process's demands upon the system.
With this method of scheduling processes, running a computation-intensive
program under \*(CO (e.g., a compiler) would degrade the system's response
to user input from the keyboard to the point where the system was nearly
useless.
.PP
Beginning with release 4.2.12 of \*(CO, the scheduler has been redesigned
to maximize the number of processes executed.
The scheduler now gives processes that make light demands on the system
(e.g., a user's input from a keyboard)
a higher priority than it gives processes that
make heavy demands on the system (e.g., image processing or compiling).
The new scheduler now permits a user to compile a program in the background
or run a tape backup, yet continue to type input from the console or from
a terminal with no noticeable degradation of response to the keyboard.
The compile will take slightly longer than it would have otherwise, but
the overall usefulness of the system is greatly increased.
.PP
.II "timeout functions"
.II "deferred functions"
In addition to managing processes, the kernel gives timeout functions,
deferred functions, and device drivers sequential, uninterrupted access
to the CPU.
The kernel intersperses
the slices of time it assigns to user processes amongst
the demands of these lower-level routines.
Any time the kernel is about to give the CPU to a user process,
such as after completing a system call, it first checks if
any timeouts or deferred functions are waiting to be called;
if there are, it executes them first.
.SH "Devices"
.PP
.II "device^definition"
A
.I device
is a piece of hardware with which a process must communicate, e.g.,
physical memory, a hard-disk drive, a floppy-disk drive, or a serial port.
Note that, unlike under \*(MD, \*(CO does not permit a program
to access hardware directly:
the \*(CO kernel manages all transfers of data between a process and a device.
.PP
.II "device^block special"
.II "device^character special"
.II "character-special device"
.II "block-special device"
Devices come in two types:
.I character-special
and
.IR block-special .
A
.I "character-special device"
is one with which \*(CO exchanges data one character at a time.
This class of devices includes serial and parallel ports and the console.
.II block
A
.I "block-special device"
is one with which \*(CO exchanges data one block at a time.
\*(CO defines a
.I block
as being 512 bytes (one-half kilobyte).
This class of devices includes the hard disk and the floppy disk.
The size of a block is defined by constant
.B BSIZE
in header
.BR <sys/buf.h> .
.PP
Note that the \*(CO system, unlike most editions of \*(UN,
allows a device driver
to be accessed in either block-special or character-special mode.
For example, under \*(CO both hard disks and floppy disks can be accessed
in either character or block mode.
.II "raw device"
.II "cooked device"
.II "device^raw"
.II "device^cooked"
If a device can be accessed in either mode, its character mode is sometimes
called the
.I raw
device (shown by the fact that its name begins or ends with the letter `r'),
whereas its block mode is sometimes called the
.I cooked
device.
This will be detailed below.
.PP
The kernel uses the structure
.B IO
to manage communication with a device.
It is defined in the header file
.BR <sys/io.h> ,
and includes the following fields:
.IP \fBio_seek\fR 1.0i
Number of bytes from the beginning of the file or device where the driver
should begin to read.
This is, of course, is meaningless for devices for devices like serial ports.
.II BSIZE
In the case of disk drives, this number must indicate the block to be read,
i.e., the number must be evenly divisible by constant
.BR BSIZE ,
which gives the size of a \*(CO block.
If this is not true, an error has occurred.
.IP \fBio_ioc\fR
Number of bytes to read or write.
When the data movement is completed, this should be set to the number
of bytes that remain to be read or written.
If it is not reset to zero, an error has occurred.
.IP \fBio_base\fR
Offset of data to be transferred in the user memory space.
This is converted to a physical or virtual memory address before
performing the read.
.IP \fBio_flag\fR
Flags.
.II io.h
See header file
.B <sys/io.h>
for the flags recognized by \*(CO.
.B IONDLY
indicates that the request is non-blocking.
.Sh "Buffer Cache"
.PP
.II "buffer cache"
A buffer cache is an area of RAM that holds data being written to
or read from a block-special device.
The kernel gives each block-special device its own buffer cache.
The kernel, in turn, assigns to each buffer cache a
.B BUF
structure, which the kernel uses to manipulate that buffer cache.
It is defined in the header file
.BR <sys/buf.h> ,
and includes the following fields:
.IP \fBb_dev\fR 1.0i
A
.B dev_t
structure that describes the device being buffered.
.II major()
.II minor()
The internal kernel macros
.B major()
and
.B minor()
translate this structure into the device's major and minor numbers.
.IP \fBb_req\fR
Type of I/O request, either
.B BREAD
or
.BR BWRITE .
.IP \fBb_bno\fR
The number of the starting block.
.IP \fBb_paddr\fR
The system global (DMA) address for the data.
.IP \fBb_count\fR
The number of bytes to read or write.
.IP \fBb_resid\fR
The number of bytes remaining to be transferred.
A value of zero indicates that all data transferred correctly, i.e., that
an error did not occur.
.SH "Interrupts"
.PP
.II interrupt^definition
Most devices gain the attention of the kernel by sending an
.IR interrupt ,
which is a hardware signal by which the device indicates
that it needs attention.
.PP
.II "interrupt vector"
The kernel assigns a unique pointer, or
.IR "interrupt vector" ,
to each device that uses interrupts.
.II "interrupt handler"
A device's interrupt vector points to a function, or
.IR "interrupt handler" ,
that is designed to service the device.
The kernel stores its table of interrupt vectors at the beginning
of main memory.
.PP
When \*(CO receives the interrupt from a device,
it saves the state of the process that is being executed.
It then reads the table of interrupt vectors and finds the vector for the
interrupt it has just received; then jumps to the handler to which the
interrupt vector points, and executes it.
Executing the interrupt handler may require awakening some sleeping processes.
.PP
When the interrupt handler has finished its work, the kernel
reloads the saved state of the interrupted process into the CPU,
and resumes processing it as if nothing had happened.
.SH "Device Drivers"
.PP
.II "device driver"
A
.I "device driver"
is the software that the kernel uses to communicate with a device.
Each device must have its own driver.
.PP
A driver stands between the kernel and the physical hardware:
.B1
	    Device:
	   I/O ports         \(<-   device   \(<-      COHERENT
	memory mapped I/O    \(->   driver   \(->       kernel
	      DMA
.B2
.PP
As the above
.\" crude
diagram shows, the driver
receives input from the hardware and writes output to it;
and it receives input from the kernel and writes output to it.
.Sh "Communication With an Application"
.PP
.II "device file"
.II mknod
.II "special file"
A user-level application communicates with a driver
via a special file called a
.I "device file"
or a
.IR "special file" .
A driver can have any number of special files.
Its suite of special files can access different devices of the same type
(for example, different floppy-disk drives or different partitions on a
hard disk); or can access the same device in different modes
(for example, a tape
device can be accessed in either rewind or non-rewind mode).
A special file is created with the command
.BR mknod .
.II /dev
Most device files are kept in directory
.BR /dev ;
if you execute the command
.B "ls -l"
on
.BR /dev ,
you will see a set of listings that appear something like the following:
.DM
.ta 1.2i 1.6i 2.1i 2.6i 3.1i 3.4i 4.6i 5.5i
\fI   1	2	3	4	5	6	     7	   8	   9\fP
brw-------	1	sys	sys	11	0	Fri Apr 27	16:56	at0a
brw-------	2	sys	sys	11	1	Fri Apr 27	16:56	at0b
brw-------	1	sys	sys	11	2	Fri Apr 27	16:56	at0c
brw-------	2	sys	sys	11	3	Fri Apr 27	16:56	at0d
brw-------	1	sys	sys	11	4	Fri Apr 27	16:56	at1a
brw-------	1	sys	sys	11	5	Fri Apr 27	16:56	at1b
brw-------	1	sys	sys	11	6	Fri Apr 27	16:56	at1c
brw-------	1	sys	sys	11	7	Fri Apr 27	16:56	at1d
crw-rw-rw-	1	bin	bin	 5	0	Fri Apr 27	16:56	com1r
crw-rw-rw-	3	bin	bin	 6	8	Sat Aug 18	12:57	com2
crw-rw-rw-	3	bin	bin	 6	8	Sat Aug 18	12:57	com2l
crw-rw-rw-	1	bin	bin	 6	0	Fri Apr 27	16:56	com2r
.DE
The listing consists of nine fields, as follows:
.IP \fB1.\fR 0.3i
Permissions.
The first character in the permissions field indicates what type of
device this is:
.B b
indicates a block-special (cooked) device, and
.B c
indicates a character-special (raw) device.
.IP \fB2\fR
Number of links to the file.
.IP \fB3\fR
The login identifier of the user who owns the file.
.IP \fB4\fR
The group identifier of the user who owns the file.
.IP \fB5\fR
.II "major-device number^definition"
Major-device number.
This is a unique number that identifies the device driver to the kernel.
The kernel can handle up to 32 devices at any given time,
numbered zero through 31.
The Lexicon article
.B "device drivers"
gives a table of all device drivers current recogized by the
\*(CO system, and the major-device number of each.
.IP \fB6\fR
Minor-device number.
.II "minor-device number^definition"
In addition to a type and a major-device number, each device file has a
minor-device number.
This allows \*(CO to distinguish among a number of devices of the same type.
For example, this table shows that major number 11 indicates
the AT hard disk.
The above listing shows ten device files with this major-device number 11,
five for device
.B at0
(which supports drive 0), and five for
.B at1
(which supports drive 1).
Files ending in
.B a
through
.B d
each support one partition on the drive;
the file ending in
.B x
supports that drive's partition table.
Each of these device files has a unique minor device number, to allow
the kernel to tell them apart.
.IP \fB7\fR
Date last modified.
.IP \fB8\fR
Time last modified.
.IP \fB9\fR
Name of file.
.Sh "Communication With the Kernel"
.PP
The kernel communicates with the driver through
.I "entry points"
within the driver.
If a user application invokes a system call for a given device (e.g.,
.B open()
or
.BR close() ,
the kernel in turn invokes the appropriate entry point within the driver.
.PP
The method by which entry points are defined within a driver varies,
depending upon whether the driver uses the DDI/DKI interface, or the
internal-kernel interface.
For details, see the entry for
.B "entry points"
within this manual's Lexicon.
.SH "Rebuilding the Kernel"
.PP
.II "device driver^add a new one"
The following walks you through the processing of adding a new driver.
We will add the driver \fBfoo\fR, which drives the popular ``widget'' device.
.IP \fB1.\fR 0.3i
To begin, log in as the superuser
.BR root .
.IP \fB2.\fR
Create a directory to hold the driver's sources and object.
Every driver must have its own directory under directory
.BR /etc/conf ;
and the sources must be held in directory
.B src
in that driver's directory.
In this case, create directory
.BR /etc/conf/foo ;
then create directory
.BR /etc/conf/foo/src .
.IP \fB3.\fR
Copy the sources for the driver into its source directory; in this case,
copy them into
.BR /etc/conf/foo/src .
.IP \fB4.\fR
Compile the driver.
This should create one object file that has the suffix \fB.o\fR.
Copy this file in the driver's home directory, and name it
.BR Driver.o .
In this case, the object for the
driver should be in file
.BR /etc/conf/foo/Driver.o .
.IP
In some rare cases, a driver compile into more than one object.
Use the command
.B ar
to store the objects into one archive called
.B Driver.a ,
and store the archive in the driver's home directory.
The \*(CO commands that build the new kernel know how to handle archives
correctly.
.IP
You may wish to add a
.B Makefile
for your driver, so that it will be recompiled, as needed,
whenever the command
.B idmkcoh
is run.
For a sample
.BR Makefile ,
see the various
.B src
subdirectories under
.BR /etc/conf .
.IP \fB5.\fR
Add an entry to file
.B /etc/conf/mdevice
for the new driver.
This file is a little more complex than
.BR sdevice ;
in particular, it distinguishes between \*(ST-style drivers and
``old-style'' \*(CO drivers.
In most cases, you can simply copy an entry for an existing driver of the
same type, and modify it slightly.
In this case, the entry for
.B foo
should read as follows:
.DM
	# full	func	misc	code	block	char	minor	minor	dma	cpu
	# name	flags	flags	prefix	major	major	min	max	chan	id
	foo	-	CGo	foo	15	15	0	255	-1	-1
.DE
.IP
In almost every case, the full name and the code prefix are identical.
The code prefix also names the directory that holds the driver's object.
Function flags are always always a hyphen, and miscellaneous flags almost
always
.BR CGo .
The block- and character-major numbers again are almost always identical.
The major number is usually assigned by the creator of the device driver.
In future releases of the kernel, these will be assigned dynamically by the
kernel itself; poorly written drivers that depend upon the driver having
a magic major-device number will no longer work.
Finally, the last four columns for non\-\*(ST drivers are almost always
0, 255, \-1, and \-1, respectively.
.IP \fB6.\fR
Add an entry to file
.B /etc/conf/sdevice
for this driver.
.BR sdevice ,
names the drivers to be included in the kernel.
The entries for practically every entry are identical; you need to note only
that the second column marks whether to include the driver in the kernel.
In this case, the entry for the driver
.B foo
should read as follows:
.DM
	foo	Y	0	0	0	0	0x0	0x0	0x0	0x0
.DE
.IP
For details on what each column means, read the comments in file
.BR /etc/conf/sdevice .
.IP \fB7.\fR
If the driver has tunable variables, set them in file
.BR Space.c ,
which should be stored in the driver's home directory.
As it happens,
.B foo
does not need a
.B Space.c
file.
For examples of such files, look in the various sub-directories of
.BR /etc/conf .
If the driver has tunable variables, you must a line for each
to file
.B /etc/conf/mtune
and (optionally) to
.BR /etc/conf/stune .
.IP
For example, suppose that the driver
.B foo
uses an array of
.B foo_info
structures, and that the number of these used is tunable.
Then
.B Space.c
might contain these lines:
.DM
	#include "conf.h"
	#include <sys/foo.h> /* defines struct foo_info */
		...
	extern int num_foo_info = NUM_FOO_INFO;
	extern struct foo_info foo_table[NUM_FOO_INFO];
.DE
.IP
.B /etc/conf/mtune
sets the range of legal values and the default value for
.BR NUM_FOO_INFO .
If you want to set
.B NUM_FOO_INFO
to some value other than the default, then pop an
entry for that variable into
.BR /etc/conf/stune .
.IP
In
.B mtune
and
.BR stune ,
the name given is not that of the tunable variable, but of an enumeration
constant used to initialize that variable.
.B idmkcoh
automatically generates
the header that defines this constant as needed.
.IP \fB8.\fR
Type the command
.B /etc/conf/bin/idmkcoh
to build a new kernel.
If necessary, move the new kernel into the root directory.
.IP \fB9.\fR
Save the old kernel and link the newly build kernel to
.BR /autoboot .
You want save the old kernel, just in case the new one doesn't work.
For directions on how to boot a kernel other than
.BR /autoboot ,
see entry for
.B booting
in the \*(CO Lexicon.
.IP \fB10.\fR
Back up your files!
With a new driver in your kernel, it's best to play it safe.
.IP \fB11.\fR
Reboot your system to invoke the new kernel.
If all goes well, you will now be enjoying the services of the new device
driver.
.PP
Because of space restrictions in the boot procedure,
the newly generated kernel object (e.g.,
.BR /testcoh )
does not contain a complete symbol table:
values for some symbols instead are stored in the ASCII
.B .sym
file (e.g.,
.BR /testcoh.sym ).
The debugger
.B db
can load symbols from a
.B .sym
file if you use its command-line option
.BR \-a .
.II keeplist
.II /etc/conf/install_conf/keeplist
To force a specific symbol to be included within the kernel object
(notably, to make the symbol patchable within the generated kernel),
add the symbol's name to a
.B \-I
option that is output by the file
.BR /etc/conf/install_conf/keeplist .
.SH "Debugging Program Crashes"
.PP
The following describes the \*(CO system's run-time environment.
If your program dies and generates a register dump of the following
form on the system console, this information will help you interpret
what appears on the console.
.PP
When a program dies an untimely death, it dumps information about
the contents of registers and memory onto the console device.
The registers shown are the 386/486 family registers.
All registers that begin with `e' and that are three characters long are
32-bit registers.
Refer to any 386/486 hardware/programming documents for
further details on register specifics.
.PP
Register
.B eip
is the instruction pointer.
This contains the user program's address at the time that
the fault or violation occurred.
Register
.B uesp
is the user-stack pointer.
.B cmd
specifies the command that faulted.
.PP
The following gives a sample dump of registers:
.DM
eax=32  ebx=408080      ecx=40541E      edx=0                 
esi=0   edi=8BF84589    ebp=7FFFF694    esp=FFFFFFE4
cs=B    ds=13           es=13           ss=13
err #14 eip=1C34F       uesp=7FFFF664   cmd=my_cmd
efl=13282       cr2=8BF84589    sig=11  trap_ip=FFC0079F
trapcode=4      User Trap                                     
segmentation violation -- core dumped                                           
.DE
Note that the format differs a little from that shown above.
The dump also gives a traceback readout of addresses in the kernel;
the addresses shown in the backtrace can be looked up file
\fIkernel\fB.sym\fR, where
.I kernel
names the kernel that you were running when the dump occurred.
This is discussed below in more detail.
.PP
The following gives the memory map for iBCS2 under \*(CO:
.DM
       0	-	  3fffff	program text	(fixed size)
  400000	-	 13fffff	program data	(grows upward)
7FC00000	-	7fffffff	program stack	(grows downward)
FFC00000	-	ffffffff	kernel
.DE
Examination of this dump uncovers the following clues about what killed
your program:
.IP \(bu 0.3i
Error 14 indicates a page fault.
The address that generated the fault is in register
.BR cr2 .
.IP \(bu
From the fact that
.B cr2
is an invalid address that matches
.BR edi ,
you can surmise that the program attempted to move a block
or string to an illegal address.
.IP \(bu
The base pointer
.B ebp
points into user stack, as expected.
.IP \(bu
.BR esp ,
the stack pointer,
points into the kernel stack (the top four kilobytes), also as expected.
.IP \(bu
The lower two bits for all the segment registers (\fBcs-ss\fR) are set, so the
program was in user mode.
If all had had their lower bits set,
the dump probably would indicate a panic.
.IP
Header file
.B <sys/reg.h>
defines the error numbers as follows:
.DS
	\fBSIDIV\fR	0	Divide overflow
	\fBSISST\fR	1	Single step
	\fBSINMI\fR	2	NMI (parity)
	\fBSIBPT\fR	3	Breakpoint
	\fBSIOVF\fR	4	Overflow
	\fBSIBND\fR	5	Bound
	\fBSIOP\fR	6	Invalid opcode
	\fBSIXNP\fR	7	Processor extension not available
	\fBSIDBL\fR	8	Double exception
	\fBSIXS\fR	9	Processor extension segment overrun
	\fBSITS\fR	10	Invalid task state segment
	\fBSINP\fR	11	Segment not present
	\fBSISS\fR	12	Stack segment overrun/not present
	\fBSIGP\fR	13	General protection
	\fBSIPF\fR	14	Page fault
	\fBSISYS\fR	32	System call
	\fBSIRAN\fR	33	Random interrupt
	\fBSIOSYS\fR	34	System call
	\fBSIDEV\fR	64	Device interrupt
.DE
Register
.B eip
points into user text space.
To see what the kernel was doing at the time of the crash, you must
check the
.B eip
address and any backtrace addresses against the known kernel text addresses.
Most symbols for any kernel are in its associated
.B .sym
file.
You should sort this before you look up addresses; then you can look up
the address with
.B grep
or a text editor.
Some symbols remain within the kernel executable.
You can use the command
.B "nm -n"
to read these.
The entry points within the
.B CON
structure usually are defined as static, but may be located using the command
.BR /etc/conf/bin/drvldump .
.IP \(bu
Register
.B uesp
is a valid user-stack value.
Note that it is below
.BR ebp .
This is a normal consequence of iBCS2 calling conventions.
.IP \(bu
.B cmd
matches the program you are debugging, indicating that it is
indeed that command and not something it calls.
.IP \(bu
You can pick apart the flag register
.B efl
with your i386 reference manual.
.IP \(bu
The signal number
.B sig
tells you what signal, if any, killed the process.
Header file
.B signal.h
defines signal numbers as follows:
.DS
.ta 0.5i 1.5i 2.0i
	\fBSIGHUP\fR	1	Hangup
	\fBSIGINT\fR	2	Interrupt
	\fBSIGQUIT\fR	3	Quit
	\fBSIGILL\fR	4	Illegal instruction
	\fBSIGTRAP\fR	5	Trace trap
	\fBSIGIOT\fR	6	IOT instruction
	\fBSIGEMT\fR	7	Emulator trap
	\fBSIGFPE\fR	8	floating point exception
	\fBSIGKILL\fR	9	Kill
	\fBSIGBUS\fR	10	Bus error
	\fBSIGSEGV\fR	11	Segmentation violation
	\fBSIGSYS\fR	12	Bad argument to system call
	\fBSIGPIPE\fR	13	Write to pipe with no readers
	\fBSIGALRM\fR	14	Alarm
	\fBSIGTERM\fR	15	Software termination signal
	\fBSIGUSR1\fR	16	User signal 1
	\fBSIGUSR2\fR	17	User signal 2
	\fBSIGCLD\fR	18	Death of a child
	\fBSIGCHLD\fR	18	Death of a child
	\fBSIGPWR\fR	19	Restart
	\fBSIGWINCH\fR	20	Window change
	\fBSIGPOLL\fR	22	Polled event in stream
.DE
.IP \(bu
.B trap_ip
is in kernel text space, as expected.
This will not tell you much unless you are debugging the kernel.
.IP \(bu
The trap code can safely be ignored.
.SH "Where To Go From Here"
.PP
The next section describes in more detail the structure of a device
driver.
It emphasizes the internal-kernel interface, which is that used by
practically all of the drivers shipped with \*(CO 4.2.
The following two sections give examples of drivers for, respectively,
a block device and character device.
.PP
See the entry
.B "device driver"
in this manual's Lexicon for a description of what device drivers are
available with the device-driver kit, and of the articles available in the
Lexicon.

.ds TL "Introduction"
.NH "Introduction" 1
.PP
.II "COHERENT^description"
\*(CO is a professional operating system designed for use on machines
that can run \*(MD.
It has many of the features and functionality of the \*(UN
operating system, but is the creation of Mark Williams Company.
\*(CO gives your
computer multi-tasking, multi-user capabilities without the tremendous
overhead, both in hardware and money, required by current
editions of UNIX.
\*(CO is what \*(UN used to be:
a well-designed system with selected tools and well-designed
utilities that bring out the best in modest computer systems.
.PP
The \*(CO system consists of the following:
.IP \(bu 0.3i
A fully multi-tasking, multi-user kernel.
.IP \(bu
Choice of Bourne or Korn shells.
.IP \(bu
The Mark Williams C compiler, linker,
assembler, archiver, and other tools.
.IP \(bu
A suite of commands, including editors, languages, tools, and utilities.
.IP \(bu
Drivers for peripheral devices, including terminals;
ASCII, PostScript, and PCL printers; dumb serial cards; and tape backup.
.IP \(bu 
Libraries,
including the standard C library, the mathematics library, and libraries for
.B curses
and socket emulation.
.IP \(bu
Numerous tools, utilities, and games.
.PP
For a list of some third-party programs that you can run under \*(CO,
see the release notes that accompany this manual.
New programs are released regularly, so consult the Mark Williams Bulletin
Board for the latest information.
.SH "What Is COHERENT?"
.PP
\*(CO is a multiuser, multitasking operating system.
.I Multiuser
means that with \*(CO, more than one person can use your computer
at any given time.
.I Multitasking
means that with \*(CO, any user can run more than one program at any
given time.
The design of \*(CO employs a few elegant concepts
to give you a powerful and flexible system that is easy to use.
.Sh "What is an Operating System?"
.PP
An \fIoperating system\fR is the master program that controls the
operation of all other programs.
It loads programs into memory, controls their execution, and controls
a program's access to peripheral devices, such as printers, modems, and
terminals.
.PP
Some operating systems (e.g., \*(MD)
permit only one user to use the computer at a time;
and that user can run only one program at a time.
However, you may well
want your computer to support more than one user at a time, and run more than
one program simultaneously.
Sharing not only yields many economies (such as allowing a group of
users to share one printer), but also allows the users to communicate with each
other and so work together more efficiently.
.PP
Any multitasking operating system must be able to do the following tasks
efficiently:
.IP \(bu 0.3i
Schedule computer time
.IS \(bu
Control mass-storage devices (disks and tape drives)
.IS \(bu
Organize disk-storage space
.IS \(bu
Protect programs from conflict
.IS \(bu
Protect stored information from destruction
.IS \(bu
Ease cooperation among users
.PP
Today's operating systems also provide \fItools\fR.
These are programs that are bundled with the operating system, and that
are designed to help you do your work more efficiently.
For example, you need editors, compilers, debuggers, and assemblers
to develop and test programs.
Text formatters and spelling checkers
help you write memoranda, manuals, or books.
Command processors (also called \fIshells\fR)
help you run the computer easily.
Status checkers tell you what programs are being run, who is using
the system, and how much space is left on your disk.
.PP
The combination of operating system and its
tools transforms a boxful of wires and circuits into a useful machine.
.Sh "Design Philosophy"
.PP
A computer system is not an end in itself; rather,
it is a ``bench'' for constructing tools to solve specific problems.
If the operating system is too specialized or limited, the range of
problems it can help you solve will be narrow.
On the other hand, if the operating system is too detailed,
then it becomes complex, idiosyncratic, and potentially unreliable.
.PP
The following quotation from John Conway summarizes well the
philosophy that underlies the design of the \*(CO system:
.II "Conway, John"
.QS
.I
The engineer who wants a machine for some
specific purpose will normally approve the simplest machine that does the job.
He will not usually prefer a multiplicity of parts with the same effect,
nor will he countenance the insertion of components with no function.
.R
.QE
.II "device-independent I/O"
The \*(CO system follows this approach throughout.
In brief, \*(CO is what \*(UN used to be:
an efficient system of selected tools and well-designed utilities, that
brings out the best in your computer system.
.SH "Installation"
.PP
The release notes that come with \*(CO describe how to install
\*(CO.
The release notes also list hardware that is known to work with \*(CO,
and hardware that is known \fInot\fR to work with \*(CO.
Before you begin to install \*(CO on your system, be sure to check
those lists and make sure that your system is compatible with \*(CO.
.PP
Please note that Mark Williams Company tries to keep these lists up to date,
but it is not possible to keep pace with the continual introduction of new
machines and new models.
If you do not find your machine on either list, the odds are that \*(CO
will work correctly with it.
.SH "User Registration and Reaction Report"
.PP
.II "user reaction report"
.II "manual^user reaction report"
Before you continue, fill out the User Registration Card that came with
your copy of \*(CO.
When you return this card, you become eligible for direct telephone support
from the \*(MW technical staff, and you will
automatically receive information about all new releases and updates.
.PP
If you have comments or reactions to the \*(CO software or documentation,
please fill out and mail the User Reaction Report included at the end of the
manual.
We especially wish to know if you found errors in this manual.
\*(MW needs your comments to continue to improve \*(CO.
.SH "Technical Support"
.PP
\*(MW provides free technical support to all registered users of \*(CO.
If you are experiencing difficulties with \*(CO, outside the area of
programming errors, feel free to contact the Mark Williams
Technical Support Staff.
You can telephone,
send electronic mail, or write.
Please note that this support is available \fIonly\fR if you have returned
your User Registration Card for \*(CO.
.PP
.\" RTFM!
Before you contact Mark Williams Technical Support with your problem,
\fIplease check this manual first.\fR
If you do not find an article in the Lexicon that addresses your problem,
be sure to check the index at the back of the manual.
Often, the information that you want is kept in an article that you didn't
consider, and the index will point you to it.
.PP
Another good way to find a topic in the manual is to use the command
.BR apropos ,
which is part of the \*(CO system.
.B apropos
finds every article in the Lexicon that mentions a given term or phrase.
For details on how to use this command, see its entry in the Lexicon.
.PP
If the manual does not solve your problem \(em or if you find it to be
misleading or difficult to understand \(em then
Mark Williams Technical Support is available to help you.
You can reach Technical Support via any number of routes:
.IP "\fBElectronic Mail\fR"
If you have access to the Internet, send mail to \fBsupport@mwc.com\fR.
This is the preferred means of communication.
Be sure to include your surface address and telephone number
as well as your e-mail address,
so we can contact you even if return electronic mail fails.
.IP "\fBFAX\fR"
Send your technical FAXes to 1-708-291-6750.
.IP "\fBSurface Mail\fR"
Write to Technical Support, Mark Williams Company, 60 Revere Drive,
Northbrook, IL 60062.
.IP "\fBTelephone\fR"
To contact Technical Support via telephone,
call 1-708-291-6700, between 9 AM and 5 PM, Central Time.
Please have at hand your manual for \*(CO,
as well as your serial number and version number.
Please collect as much information as you can concerning your difficulty
before you call.
If possible, call while you are at your machine, so the technical support
person can walk you through your problem.
.Sh "Help Us Help You"
.PP
Mark Williams Technical Support wants to help you fix your problem as
quickly as possible, so you can enjoy your \*(CO system.
.\" and get the hell off our back.
You can help us to help you by doing the following:
.PP
Before you contact Technical Support, 
\fIwrite down\fR
as carefully as possible what you did that triggered the problem.
Copy down exactly any error messages that appeared on the screen.
.PP
If the problem is triggered by a script or program, try to edit
the script or program to the chunk of code that triggers the problem.
The smaller the chunk of code, the better.
.PP
In your message, please include the following information:
.IP \(bu 0.3i
The make of your computer, and the type and clock speed of its
microprocessor.
.IP \(bu
The amount of RAM that you have.
.IP \(bu
The size and make of your hard disk, and the make of its controller.
.IP \(bu
If the problem affects the video display, include the make of your
display (i.e., tube) and controller card.
.PP
If you have found an error in the manual, please mention the page on
which the error occurs.
.PP
This information will help us to to clear up your problem as quickly
as possible.
.SH "How To Use This Manual"
.II "manual^how to use"
.PP
\*(CO encompasses an entire world of computing.
Before you learn the signposts of this world, you may find it difficult
to perform even simple tasks; and you may feel confusion and frustration.
.PP
\*(CO, however, more than anything else, consists of tools; and
this manual is one of the most useful tools that your \*(CO system has.
It is designed to guide you through the \*(CO system, to answer your
questions, and to lead you into areas of the system that may never have
explored on your own.
If you can learn to use it effectively, you will both lower the amount of
frustration you will have to endure,
and increase your productivity.
.PP
Beginners, in particular, should look over this manual carefully.
The following sub-sections describe the steps a beginner should take
when she begins to work with this manual.
.Sh "Elementary Tutorials"
.PP
The following tutorials teach the essentials of \*(CO:
they teach both essential information and essential skills.
Every beginner should work through these tutorials:
.IP \(bu 0.3i
First, read the tutorial \fIUsing the COHERENT System\fR.
This tutorial will introduce the \*(CO system and its tools.
It also teaches you such important tasks as how to shut the system
down properly (hint \(em \fInever\fR just shutting the machine off!)
and how to boot it again.
.IP \(bu
Then look at the subsequent tutorial,
\fIIntroducing sh, the Bourne Shell\fR.
The shell is the program through which you give commands to your \*(CO
system; and it incorporates a powerful programming language of its own.
Some of this information will seem obscure to you; but the as with
any language, the more you use the shell's programming language the more
quickly will you acquire fluency.
.IP \(bu
You should then look into learning how to use a text editor under \*(CO.
You will need to use a text editor in order to write scripts, programs,
and documents, which is the heart of using any information-processing
tool like \*(CO.
.IP
\*(CO offers two screen-oriented text editors:
MicroEMACS, and
.BR vi .
The manual has a tutorial on MicroEMACS.
You will find it to be fairly easy to learn how to perform simple text
editing with MicroEMACS.
.Sh "Advanced Tutorials"
.PP
The above tutorials will teach you the rudiments of how to use \*(CO.
The next set of tutorials introduce some of \*(CO's tools and languages.
These tutorials are rather specialized.
A beginner should look only at the ones that interest her:
.IP "\fIIntroduction to the ed Line Editor\fR"
.B ed
is an editor from the early days of \*(UN.
It is line oriented, which means that you edit text by typing commands
rather than by moving a cursor around the screen.
.B ed
is powerful and useful tool, but is of limited appeal to most beginners.
.IP "\fIIntroduction to the sed Stream Editor\fR"
.B sed
is another line-oriented editor.
However, it differs from
.B ed
in that it works non-interactively:
you write a program in the
.B sed
language, then filter one or more files through the program.
.B sed
is very useful if you wish to process large amounts of text quickly
and in an automated manner, but is of limited appear to most beginners.
.IP "\fIThe C Language\fR"
This is a primer on the C language, for persons who have never programmed
before.
C is the native language of \*(CO and \*(UN.
If you are interested in learning something about C, you should look at
this tutorial.
.IP "\fIIntroduction to the awk Language\fR"
.B awk
is a general-purpose for processing text.
With
.BR awk ,
you can process both ordinary text and tables; thus, you can quickly
implement simple data-base programs and other useful tools.
If you are at all interested in processing text or data under \*(CO,
you should look at this tutorial.
.IP "\fIIntroduction to lex, the Lexicon Analyzer\fR"
.B lex
is a tool with which you can generate programs to analyze text lexically.
You write a set of rules for
.BR lex ,
and it generates a program that you can compile and run.
.B lex
is a very useful tool for programmers who have to perform sophisticated
analysis of text.
For many beginners, however, it is of limited appeal.
.IP "\fIIntroduction to yacc\fR"
.B yacc
is another tool that with which you can generate programs.
It is often used with
.B lex
to build sophisticated tools, such as compilers.
If you are interested in building such tools, or if the problem
of parsing text interests you, you will find this tutorial to be helpful.
.IP "\fIbc Desk Calculator Language\fR"
.B bc
is a language in which you can write programs to perform calculations.
The numbers you calculate can be of infinite size and precision
(or as infinite as your system's memory allows).
You can perform calculations ``on the fly,'' as with a desk calculator;
or you can write programs that you store on disk and run repeatedly.
If number-crunching interests you, you should find this tutorial helpful.
.IP "\fIIntroduction to the m4 Macro Processor\fR"
.B m4
is a macro processor.
A
.I macro
is a sign or symbol whose interpretation can be deferred until needed.
For example, a writer may embed a macro in a letter in place of the
name of the person to whom the letter is addressed, and replace the
macro with the name only when the letter is printed.
This permits her to use the same letter over and over again, with the
computer replacing the macro with a different name.
Most \*(CO tools can process macros to a limited extent.
.BR m4 ,
however, will teach you about macro processing, and let you write
your own macro-process programs.
.IP "\fIThe make Programming Discipline\fR"
.B make
is a utility that builds things out of other things.
This tool is absolutely essential to anyone who writes programs
or generates reports.
.IP "\fInroff, The Text-Formatting Language\fR"
.B nroff
is a text-formatting language.
With it (and its related program
.BR troff ),
you can format letters, documents, or even entire books.
For example, this manual was formatted with \*(CO
.BR troff .
.IP "\fIUUCP, Remote Communications Utility\fR"
One of the most attractive features of \*(CO or \*(UN is its ability
to communicate with other computers without needing the assistance of
a human operator.
\*(UU is a set of programs with which you can exchange electronic mail
and files with other \*(CO and \*(UN systems.
With \*(UU (and some help from other computer systems) you can even tie into
the Internet, and participate in the global computer network that is
being expanded every day.
This tutorial will introduce you to \*(UU, and help you get \*(UU up and
running on your system.
.Sh "The Lexicon"
.PP
The bulk of this manual consists of the Lexicon.
This is a set of more than 1,000 articles, arranged in alphabetical order.
Each article discusses one aspect of the \*(CO system:
a command; a library function; a system file; or a general discussion of
a technical topic, such as how to hook up a terminal to your system.
.PP
At first glance, the Lexicon looks like a rag-bag of material
that is in no particular order.
However, this is not true:
it actually has a carefully designed internal structure.
Once you learn this structure, you can use it both
to help you look up a specific item of information quickly,
or take a guided tour through some aspect of the \*(CO system
that you otherwise might never have explored.
.PP
Internally, the Lexicon has a \fItree structure\fR.
Just as the roots and branches of a tree grow from a central trunk,
dividing and subdividing as they progress, so too the articles of the
Lexicon grow from one central article, and divide into ever more detailed
discussions as they go along.
.PP
The central article is the one called
.BR COHERENT .
It gives an overview of the \*(CO system \(em its design philosophy,
how it relates to other operating systems, and its internal structure.
This article introduces (or ``branches into'') the following
three ``overview'' articles:
.IP "\fBRunning COHERENT\fR"
This article introduces other articles that describe things
you can do with \*(CO:
the commands and tools that an ordinary user would use in the course of
her daily work.
.IP "\fBProgramming COHERENT\fR"
This articles introduces other articles that describe how to write
programs for \*(CO.
These articles describe, among other things, the \*(CO C compiler,
and the the libraries and header files included with \*(CO.
.IP "\fBAdministering COHERENT\fR"
This article introduces articles of interest to perons who administer
a \*(CO system.
These articles cover such topics as how to set up mail and \*(UU
on your system; the ``magic'' files that \*(CO uses to manage itself;
and the \*(CO kernel and its device drivers.
.PP
For example, consider that you are a programmer who wants to learn
if \*(CO has a library function that compares two strings.
You would turn first to the article called
.BR COHERENT ,
which would point you to the overview article called
.BR "Programming COHERENT" .
Looking in there, you see a reference to an article on
.BR libraries .
This, in turn, points to the article on
.BR libc ,
which is the standard C library.
Turning to this article, you find a section on string functions, which
has brief summaries of the functions
.BR memcmp() ,
.BR strcmp() ,
and
.BR strncmp() .
Each of these, in turn, is described in detail in its own Lexicon entry, which
By reading each entry, you can quickly find which function suits your purposes.
.PP
As you can see, the overview article briefly summarized the
articles that are available on a given topic.
If you want details, you can turn to the articles themselves \(em which you
can find easily because all of the articles printed in alphabetical order.
.PP
Another approach is to look directly for an article on the subject that
interests you.
For example, suppose you wanted to learn about \*(CO's mail system.
You could open the Lexicon and look for an article called
.BR mail ;
and just as you supposed, there it is.
.PP
If you're looking for a discussion of a specialized topic that does not
have its own article in the Lexicon, look in the Index, which is at the
back of the manual.
Often, you will find an entry that points to the information you want.
.PP
Finally, many users just like to open the Lexicon and leaf through it at
random.
Often, they discover nooks and crannies within the \*(CO system that they
never would have encountered otherwise.
.SH "Where To Go From Here"
.PP
The next step is to install \*(CO if you have not yet done so.
Fill out the user registration card at the back of this manual
and mail it to Mark Williams Company, so you will become eligible for
technical support.
If you are new to \*(UN or \*(CO, turn to the tutorial \fIUsing the
COHERENT System\fR; otherwise, you may wish to study a specialized tutorial
or begin to explore the Lexicon.
.PP
We hope that you enjoy using your \*(CO system!

.ds TL "Character Driver"
.NH "Example of a Character Driver"
.PP
This section gives an example driver for a character device:
the \*(CO driver for the 8250-style asynchronous ports.
It is described in the article
.B asy
in the \*(CO Lexicon.
.PP
In this driver, the minor-device number is a bit map that
describes the features of the port, as follows:
.DS
	0x80	1 for NO modem control, `l' (lower-case ``el'')
	0x40	1 for polled operation (no IRQ service), `p'
	0x20	1 for RTS/CTS flow control, `f'
	0x1F	The channel number - 0 through 31
.DE
Character-device line discipline, which includes such operations as processing
backspaces entered and echoing input characters, is performed in the
.B tty
module in \*(CO 4.2.
Source code is provided in the 4.2 Device-Driver Kit.
Future releases of \*(CO will use a \*(ST-based line discipline.
.SH "Preliminaries"
.PP
The following prefaces the body of the driver.
.Sh "Header Files"
.PP
.B asy
begins by including the following header files.
.DM
#include <sys/errno.h>
#include <sys/stat.h>
#include <termio.h>
#include <poll.h>
.DE
.DM
#include <sys/coherent.h>
#include <kernel/trace.h>
#include <sys/uproc.h>
#include <sys/proc.h>
#include <sys/tty.h>
#include <sys/con.h>
#include <sys/devices.h>
#include <sys/sched.h>
#include <sys/asy.h>
#include <sys/ins8250.h>
#include <sys/poll_clk.h>
.DE
.Sh "Manifest Constants"
.PP
The following gives manifest constants used throughout the driver.
.DM
#define	IEN_USE_MSI	(IE_RxI | IE_TxI | IE_LSI | IE_MSI)
#define	IEN_NO_MSI	(IE_RxI | IE_TxI | IE_LSI)
.DE
.DM
#define CTLQ	0021
#define CTLS	0023
.DE
.DM
.ta 2.0i 3.0i
#define NUM_IRQ	16	/* PC allows irq numbers 0..15 */
#define BPB	8	/* 8 bits per byte */
#define DTRTMOUT	3	/* DTR seconds for close */
#define LOOP_LIMIT	100	/* safety valve on irq loops */
.DE
.DM
.ta 2.5i
/*
 * For rawin silo (see poll_clk.h), use last element of si_buf to count
 * the number of characters in the silo.
 */
#define SILO_CHAR_COUNT	si_buf[SI_BUFSIZ-1]
#define SILO_HIGH_MARK	(SI_BUFSIZ-SI_BUFSIZ/4)
#define SILO_LOW_MARK	(SI_BUFSIZ/4)
#define MAX_SILO_INDEX	(SI_BUFSIZ-2)
#define MAX_SILO_CHARS	(SI_BUFSIZ-1)
.DE
.Sh "Macros"
.PP
.B asy
uses the following macros:
.DM
.ta 2.5i
#define RAWIN_FLUSH(in_silo) { \e
  in_silo->si_ox = in_silo->si_ix; \e
  in_silo->SILO_CHAR_COUNT = 0; }
#define RAWOUT_FLUSH(out_silo)	{ out_silo->si_ox = out_silo->si_ix; }
#define channel(dev)	(dev & 0x1F)
#define IEN	((a0->a_nms)?IEN_NO_MSI:IEN_USE_MSI)
.DE
.DM
.ta 2.0i 3.0i
#define NW_OUTSILO	1	/* bits in need_wake[] entries */
.DE
.DM
typedef void (* VPTR)();	/* pointer to function returning void */
typedef int (* FPTR)();	/* pointer to function returning int */
.DE
.Sh "Local Functions"
.PP
The following declares the functions used locally.
.DM
void asy_putchar();
.DE
.DM
/* Configuration functions (local) */
static void cinit();
.DE
.DM
/* Support functions (local) */
static void add_irq();
static void asy_irq();
static int asy_send();
static void asybreak();
static void asyclock();
static void asycycle();
static void asydump();
static int asyintr();
static void asyparam();
static void asysph();
static void asyspr();
static void asystart();
static void endbrk();
static void irqdummy();
static void upd_irq1();
.DE
.DM
static int p1(),p2(),p3(),p4();
.DE
.DM
extern int albaud[], alp_rate[];
.DE
.Sh "Global Variables"
.PP
.B asy
uses the following global variables:
When the command
.B asypatch
patches the
.B asy
driver for your system's configuration of ports,
it checks whether its internal value for
.B ASY_VERSION
matches this driver's value.
This prevents the patch utility and the driver from getting out of synch.
.DM
int ASY_VER = ASY_VERSION;
int ASY_HPCL = 1;
int ASY_NUM = 0;
int ASYGP_NUM = 0;
asy0_t asy0[MAX_ASY] = {
	{ 0 }
};
asy_gp_t asy_gp[MAX_ASYGP] = {
	{ 0 }
};
.DE
.Sh "Static Variables"
.PP
.B asy
uses the following static variables.
.DM
.ta 3.0i
static asy1_t * asy1;	/* unused entries have type US_NONE */
static short dummy_port;	/* used only during driver startup */
static int poll_divisor;	/* set by asyspr(), read by asyclk() */
static char pptbl [MAX_ASY];	/* channel numbers of polled ports */
static int ppnum;	/* number of channels in pptbl */
.DE
Variables \fBirq0[\fIx\^\fB]\fR and \fBirq1[\fIx\^\fB]\fR
are lists for IRQ number
.IR x .
.B irq0[]
has nodes that may possibly cause an IRQ.
.B irq1[]
contains nodes for active devices.
Whenever a device becomes active or inactive,
.B irq1
is rebuilt from
.BR irq0 .
.PP
.B nodespace
is an array of the nodes that are available.
.B nextnode
points to the next free node.
Nodes are taken from node space only when the driver is loaded.
.DM
static FPTR ptbl [PT_MAX] = { asyintr,p1,p2,p3,p4 };
static struct irqnode *irq0[NUM_IRQ], *irq1[NUM_IRQ];
static struct irqnode nodespace[MAX_ASY];
static char need_wake[MAX_ASY];
static char nextnode;
static int initialized;	/* for asy_putchar() */
.DE
.SH "The Load Routine"
.PP
The first function is
.BR asyload() .
The kernel invokes this function when the driver is loaded into memory.
Because \*(CO 4.2 does not support loadable drivers, this function is
executed only when the kernel boots.
.PP
Field
.B c_load
in the
.B CON
structure contains a pointer to this function.
.DM
static void
asyload()
{
	int s, chan;
	asy0_t *a0;
	asy1_t *a1;
	TTY *tp;
	short port;
	char irq;
	char speed;
	char g;
	char sense_ct = 0;
.DE
.DM
	/* Allocate space for asy structs.  Possible error return. */
	asy1 = (asy1_t *)kalloc(ASY_NUM * sizeof(asy1_t));
	if (asy1 == 0) {
		printf("asyload: can't allocate space for %d async devices\en",
		  ASY_NUM);
		return;
	}
	kclear(asy1, ASY_NUM*sizeof(asy1_t));
.DE
.DM
	/*
	 * For each non-null port:
	 *	sense chip type
	 *	write baud rate to sgtty/termio structs
	 *	disable port interrupts
	 *	hang up port
	 *	set default baud rate (also resets UART)
	 *	hook "start" function into line discipline module
	 *	hook "param" function into line discipline module
	 *	hook CS into line discipline module
	 * 	if port uses irq
	 *		if not in a port group
	 *			add to irq list
	 */
.DE
.DM
	for (chan = 0; chan < ASY_NUM; chan++) {
		a0 = asy0 + chan;
		a1 = asy1 + chan;
		tp = &a1->a_tty;
		speed = a0->a_speed;
		tp->t_sgttyb.sg_ispeed = tp->t_sgttyb.sg_ospeed = speed;
		tp->t_dispeed = tp->t_dospeed = speed;
		port = a0->a_port;
.DE
.DM
		/*
		 * A port address of zero means a skipped entry in the table.
		 * In this case a1->a_ut keeps its initial value of US_NONE.
		 */
		if (port) {
			dummy_port = port;
.DE
.DM
			/*
			 * uart_sense() prints port info.
			 * Do this four times per line.
			 */
			a1->a_ut = uart_sense(port);
			sense_ct++;
			if ((sense_ct & 1) == 0)
				putchar('\en');
			else
				putchar('\et');
.DE
.DM
			s = sphi();
			outb(port+MCR, 0);
			outb(port+LCR, LC_DLAB);
			outb(port+DLL, albaud[speed]);
			outb(port+DLH, albaud[speed] >> 8);
			outb(port+LCR, LC_CS8);
			tp->t_start = asystart;
			/* leave tp->t_param at 0 */
			tp->t_ddp = (char *) chan;
			spl(s);
.DE
.DM
			if (a0->a_irqno && a0->a_asy_gp == NO_ASYGP)
				add_irq (a0->a_irqno, asyintr, chan);
		}
	}
.DE
.DM
	if (sense_ct & 1)
		putchar('\en');
.DE
.DM
	/* for each port group,	add group to irq list */
	for (g = 0 ; g < ASYGP_NUM ; g ++)
		add_irq (asy_gp [g].irq, ptbl [asy_gp [g].gp_type], g);
.DE
.DM
	/* Attach irq routines. */
	for (irq = 0 ; irq < NUM_IRQ ; irq ++) {
		if (irq0 [irq])
			setivec (irq, asy_irq);
	}
}
.DE
.SH "The Unload Routine"
.PP
The kernel invokes function
.B asyunload()
when
.B asy
is unloaded from memory.
As \*(CO 4.2 does not support loadable drivers, this function is never
invoked.
.PP
Field
.B c_uload
in the
.B CON
structure contains a pointer to this function.
.DM
static void
asyunload()
{
	char chan, irq;
.DE
.DM
	/*
	 *  for each channel:
	 *	disable UART interrupts
	 *	hangup port
	 *	cancel timer
	 */
	for (chan = 0; chan < ASY_NUM; chan++) {
		asy0_t * a0 = asy0 + chan;
		asy1_t * a1 = asy1 + chan;
		short port = a0->a_port;
		TTY *tp = &a1->a_tty;
.DE
.DM
		outb(port+IER, 0);
		outb(port+MCR, 0);
		timeout (tp->t_rawtim, 0, NULL, 0);
	}
.DE
.DM
	/* for each irq,  detach irq routine if one was attached */
	for (irq = 0 ; irq < NUM_IRQ ; irq ++)
		if (irq0 [irq])
			clrivec(irq);
.DE
.DM
	/* deallocate dynamic storage */
	if (asy1)
		kfree (asy1);
}
.DE
.SH "The Open Routine"
.PP
The kernel invokes function
.B asyopen()
when a user application invokes the system call
.B open()
to open a serial port.
.PP
Field
.B c_open
in the
.B CON
structure contains a pointer to this function.
.DM
static void
asyopen(dev, mode)
dev_t dev;
int mode;
{
	int s;
	char msr, mcr;
	char chan = channel(dev);
	asy0_t *a0 = asy0 + chan;
	asy1_t *a1 = asy1 + chan;
	TTY *tp = &a1->a_tty;
	short port = a0->a_port;
.DE
.DM
	/* chip not found */
	if (a1->a_ut == US_NONE) {
		set_user_error (ENXIO);
		goto bad_open;
	}
.DE
.DM
	if ((tp->t_flags & T_EXCL) != 0 && ! super()) {
		set_user_error (ENODEV);
		goto bad_open;
	}
.DE
.DM
	/* Can't open for hardware flow control if modem status
	 * interrupts are disallowed.
	 */
	if (a0->a_nms && (dev & CFLOW) != 0) {
		set_user_error (ENXIO);
		goto bad_open;
	}
.DE
.DM
	/* Can't open a polled port if another driver is using polling. */
	if (dev & CPOLL && poll_owner & ~ POLL_ASY) {
		set_user_error (EBUSY);
		goto bad_open;
	}
.DE
.DM
	/* Can't have both com[13] or both com[24] IRQ at once. */
	if (!(dev & CPOLL) && a0->a_ixc) {
		struct irqnode *np = irq1[a0->a_irqno];
		while (np) {
			if (np->func != ptbl[0] || np->arg != chan) {
				set_user_error (EBUSY);
				goto bad_open;
			}
			np = np->next_actv;
		}
	}
.DE
.DM
	/* If port already in use, are new and old open modes compatible? */
	if (a1->a_in_use) {
		int oldmode = 0, newmode = 0; /* mctl:1 irq:2 flow:4 */
.DE
.DM
		if (a1->a_modc)
			oldmode += 1;
		if (a1->a_irq)
			oldmode += 2;
		if (a1->a_flc)
			oldmode += 4;
		if ((dev & NMODC) == 0)
			newmode += 1;
		if ((dev & CPOLL) == 0)
			newmode += 2;
		if (dev & CFLOW)
			newmode += 4;
		if (oldmode != newmode) {
			set_user_error (EBUSY);
			goto bad_open;
		}
	}
.DE
At this point, sleep if another process is opening or closing the port.
This can happen if:
.IP \(bu 0.3i
Another process is trying a first open and awaiting CD.
.IP \(bu 0.3i
Another process is closing the port after losing CD.
.IP \(bu 0.3i
A remote process opened the port,
spawned a daemon,
and disconnected, yet the daemon ignored
.B SIGHUP
and is improperly keeping the port open.
.PP
Do not try to set
.B tp->t_flags
before this sleep!
During the sleep,
.B ttclose()
may be called and clear the flags.
.DM
	while (a1->a_in_use &&
		(a1->a_hcls || ((dev & NMODC) == 0 &&
			(inb (port + MSR) & MS_RLSD) == 0))) {
.DE
.DM
		if (x_sleep ((char *) & tp->t_open, pritty, slpriSigCatch,
				"asyblk") == PROCESS_SIGNALLED) {
			set_user_error (EINTR);
			goto bad_open;
		}
	}
.DE
.DM
	/* If channel not in use, mark it as such. */
	if (a1->a_in_use == 0) {
		/* Save modes for this open attempt to avoid future conflicts.
		 * Then start asycycle() for this port.
		 */
		if (dev & NMODC) {
			tp->t_flags &= ~T_MODC;
			a1->a_modc = 0;
		} else {
			tp->t_flags |= T_MODC;
			a1->a_modc = 1;
		}
.DE
.DM
		if (dev & CPOLL)
			a1->a_irq = 0;
		else
			a1->a_irq = 1;
		if (dev & CFLOW) {
			tp->t_flags |= T_CFLOW;
			a1->a_flc = 1;
		} else {
			tp->t_flags &= ~T_CFLOW;
			a1->a_flc = 0;
		}
	}
	a1->a_in_use++;
.DE
.DM
	/* From here, error exit is bad_open_u. */
	if (tp->t_open == 0) {        /* not already open */
		silo_t	* in_silo = &a1->a_in;
.DE
.DM
		if (!(dev & CPOLL)) {
			upd_irq1(a0->a_irqno);
			a1->a_has_irq = 1;
		}
.DE
.DM
		/* Need to start cycling to scan for CD. */
		asycycle(chan);
.DE
.DM
		s = sphi();
		/* Raise basic modem control lines even if modem
		 * control hasn't been specified.
		 * MC_OUT2 turns on NON-open-collector IRQ line from the UART.
		 * since we can't have two UART's on same IRQ with MC_OUT2 on
		 */
		mcr = MC_RTS | MC_DTR;
.DE
.DM
		if (dev & CPOLL) {
			outb(port+MCR, mcr);
		} else {
			outb(port+MCR, mcr | a0->a_outs);
			outb(port+IER, IEN);
		}
.DE
.DM
		if ((dev & NMODC) == 0) {	/* want modem control? */
			tp->t_flags |= T_HOPEN | T_STOP;
			for (;;) {	/* wait for carrier */
				msr = inb(port+MSR);
				/* If carrier detect present
				 *   if port not already open
				 *     break out of loop and finish first open
				 *   else
				 *     do second (or third, etc.) open
				 */
				if (msr & MS_RLSD)
					break;
.DE
.DM
				/* wait for carrier */
				if (x_sleep ((char *) & tp->t_open, pritty,
					     slpriSigCatch, "need CD")
				    == PROCESS_SIGNALLED) {
					outb(port + MCR, 0);
			    		outb(port + IER, 0);
					set_user_error (EINTR);
					tp->t_flags &= ~(T_HOPEN | T_STOP);
					spl(s);
					goto bad_open_u;
				}
			}
.DE
.DM
			/* Mark that we are no longer hanging in open.
			 * Allow output over the port unless hardware flow
			 * control says not to.
			 */
			tp->t_flags &= ~T_HOPEN;
			tp->t_flags &= ~T_STOP;
			if (!(tp->t_flags & T_CFLOW) || (msr & MS_CTS))
				a1->a_ohlt = 0;
			else
				a1->a_ohlt = 1;
.DE
.DM
			/* Awaken any other opens on same device. */
			wakeup((char *)(&tp->t_open));
		}
		ttopen(tp);				/* stty inits */
		tp->t_flags |= T_CARR;
		if (ASY_HPCL)
			tp->t_flags |= T_HPCL;
.DE
.DM
		asyparam(tp);	/* gimmick: do this while t_open is zero */
.DE
.DM
		/* TO DO: flush UART input register(s) */
		spl(s);
.DE
.DM
		/* Turn on polling for the port. */
		if (dev & CPOLL) {
			a1->a_poll = 1;
			asyspr();
		}
	} /* end of first-open case */
.DE
.DM
	tp->t_open++;
	ttsetgrp(tp, dev, mode);
	return;
.DE
.DM
bad_open_u:
	a1->a_in_use--;
	wakeup((char *)(&tp->t_open));
bad_open:
	return;
}
.DE
.SH "The Close Routine"
.PP
The kernel invokes function
.B asyclose()
when a user application invokes the system call
.B close()
to close a serial port.
.PP
Field
.B c_close
in the
.B CON
structure contains a pointer to this function.
.DM
static void
asyclose(dev, mode)
dev_t dev;
int mode;
{
	int chan = channel(dev);
	asy0_t *a0 = asy0 + chan;
	asy1_t *a1 = asy1 + chan;
	TTY *tp = &a1->a_tty;
	silo_t *out_silo = &a1->a_out;
	silo_t *in_silo = &a1->a_in;
	int flags, maj;
	int s;
	short port = a0->a_port;
	char lsr;
.DE
.DM
	if (--tp->t_open)
		goto not_last_close;
	s = sphi();
.DE
.DM
	a1->a_hcls = 1; /* disallow reopen till done closing */
	flags = tp->t_flags; /* save flags - ttclose() zeroes them */
	ttclose(tp);
.DE
.DM
	/* Wait for output silo and UART xmit buffer to empty.
	 * Allow signal to break the sleep.
	 */
	for (;;) {
		int chipEmpty = 0, siloEmpty = 0;
.DE
.DM
		lsr = inb(port + LSR);
		chipEmpty = (lsr & LS_TxIDLE);
		siloEmpty = (out_silo->si_ix == out_silo->si_ox);
.DE
.DM
		if (chipEmpty && siloEmpty)
			break;
		need_wake[chan] |= NW_OUTSILO;
		if (x_sleep ((char *) out_silo, pritty, slpriSigCatch,
			     "asyclose") == PROCESS_SIGNALLED) {
			RAWOUT_FLUSH(out_silo);
			break;
		}
	}
	need_wake[chan] &= ~NW_OUTSILO;
.DE
.DM
	/* If not hanging in open */
	if ((flags & T_HOPEN) == 0) {
		/* Disable interrupts. */
		outb(port+IER, 0);
		outb(port+MCR, inb(port+MCR) & ~MC_OUTS);
	}
.DE
.DM
	/* If hupcls */
	if (flags & T_HPCL) {
		/* Hangup port - drop DTR and RTS. */
		outb(port+MCR, inb(port+MCR) & MC_OUTS);
.DE
.DM
		/* Hold dtr low for timeout */
		maj = major(dev);
		drvl[maj].d_time = 1;
.DE
.DM
		x_sleep ((char *) & drvl [maj].d_time, pritty, slpriNoSig,
			 "drop DTR");
		drvl[maj].d_time = 0;
	}
.DE
.DM
	a1->a_poll = 0;
	asyspr();
	RAWIN_FLUSH(in_silo);
	a1->a_hcls = 0; /* allow reopen - done closing */
	wakeup((char *)(&tp->t_open));
	spl(s);
	a1->a_in_use--;
.DE
.DM
	if (!(dev & CPOLL))
		upd_irq1(a0->a_irqno);
	return;
.DE
.DM
not_last_close:
	a1->a_in_use--;
	wakeup((char *)(&tp->t_open));
	return;
}
.DE
.SH "The Read Routine"
.PP
The kernel invokes function
.B asyread()
when a user application invokes the system call
.B read()
to read data from a serial port.
.PP
Field
.B c_read
in the
.B CON
structure contains a pointer to this function.
.DM
static void
asyread(dev, iop)
dev_t dev;
register IO * iop;
{
	int chan = channel(dev);
	asy1_t *a1 = asy1 + chan;
	TTY *tp = &a1->a_tty;
	ttread(tp, iop);
}
.DE
.SH "The Timeout Routine"
.PP
The kernel invokes function
.B asytimer()
when a timeout occurs.
.PP
Field
.B c_timer
in the
.B CON
structure contains a pointer to this function.
.DM
static void
asytimer(dev)
dev_t dev;
{
	if (++drvl[major(dev)].d_time > DTRTMOUT)
		wakeup((char *)&drvl[major(dev)].d_time);
}
.DE
.SH "The Write Routine"
.PP
The kernel invokes function
.B asywrite()
when a user application invokes the system call
.B write()
to write data to this port.
.PP
Field
.B c_write
in the
.B CON
structure contains a pointer to this function.
.DM
static void
asywrite(dev, iop)
dev_t dev;
register IO * iop;
{
	int chan = channel(dev);
	asy0_t *a0 = asy0 + chan;
	asy1_t *a1 = asy1 + chan;
	TTY *tp = &a1->a_tty;
	short port = a0->a_port;
	register int c;
.DE
.DM
	/* Treat user writes through tty driver. */
	if (iop->io_seg != IOSYS) {
		ttwrite(tp, iop);
		return;
	}
.DE
.DM
	/* Treat kernel writes by blocking on transmit buffer. */
	while ((c = iogetc(iop)) >= 0) {
		/* Wait until transmit buffer is empty.
		 * Check twice to prevent critical race with interrupt handler.
		 */
		for (;;) {
			if (inb(port+LSR) & LS_TxRDY)
				if (inb(port+LSR) & LS_TxRDY)
					break;
		}
.DE
.DM
		/* Output the next character. */
		outb(port+DREG, c);
	}
}
.DE
.SH "The ioctl Routine"
.PP
The kernel invokes function
.B asyioctl()
when a user application invokes the system call
.B ioctl()
to manipulate a serial device.
.PP
Field
.B c_open
in the
.B CON
structure contains a pointer to this function.
.DM
static void
asyioctl(dev, com, vec)
dev_t dev;
int com;
struct sgttyb *vec;
{
	int chan = channel(dev);
	asy0_t *a0 = asy0 + chan;
	asy1_t *a1 = asy1 + chan;
	TTY *tp = &a1->a_tty;
	int s;
	int temp;
	silo_t *out_silo = &a1->a_out;
	silo_t *in_silo = &a1->a_in;
	short port = a0->a_port;
	unsigned char msr, mcr, lcr, ier;
	char do_ttioctl = 0;
	char do_asyparam = 0;
.DE
.DM
	s = sphi();
	ier = inb(port+IER);
	mcr = inb(port+MCR);	/* get current MCR register status */
	lcr = inb(port+LCR);	/* get current LCR register status */
.DE
.DM
	/* If command will drain output, do the drain now
	 * before calling ttioctl().
	 * Don't do this for 286 kernel:  we're running out of code space.
	 */
	switch(com) {
.DE
.DM
	case TCSETAW:
	case TCSETAF:
	case TCSBRK:
	case TIOCSETP:
		/* Wait for output silo and UART xmit buffer to empty.
		 * Allow signal to break the sleep.
		 */
		for (;;) {
			if (! ttoutp (tp) &&
			    out_silo->si_ix == out_silo->si_ox &&
			    (inb (port + LSR) & LS_TxIDLE) != 0)
				break;
			need_wake[chan] |= NW_OUTSILO;
.DE
.DM
			if (x_sleep ((char *) out_silo, pritty, slpriSigCatch,
				     "asydrain") == PROCESS_SIGNALLED)
				break;
		}
		need_wake [chan] &= ~NW_OUTSILO;
	}
.DE
.DM
	switch(com) {
	case TIOCSBRK:	/* set BREAK */
		outb (port + LCR, lcr | LC_SBRK);
		break;
.DE
.DM
	case TIOCCBRK:	/* clear BREAK */
		outb (port + LCR, lcr & ~ LC_SBRK);
		break;
.DE
.DM
	case TIOCSDTR:	/* set DTR */
		outb (port + MCR, mcr | MC_DTR);
		break;
.DE
.DM
	case TIOCCDTR:	/* clear DTR */
		outb (port + MCR, mcr & ~ MC_DTR);
		break;
.DE
.DM
	case TIOCSRTS:	/* set RTS */
		outb (port + MCR, mcr | MC_RTS);
		break;
.DE
.DM
	case TIOCCRTS:	/* clear RTS */
		outb (port + MCR, mcr & ~ MC_RTS);
		break;
.DE
.DM
	case TIOCRSPEED:	/* set "raw" I/O speed divisor */
		outb (port + LCR, lcr | LC_DLAB); /* set speed latch bit */
		outb (port + DLL, (unsigned) vec);
		outb (port + DLH, (unsigned) vec >> 8);
		outb (port + LCR, lcr); /* reset latch bit */
		break;
.DE
.DM
	case TIOCWORDL:		/* set word length and stop bits */
		outb (port + LCR, ((lcr & ~ 0x7) | ((unsigned) vec & 0x7)));
		break;
.DE
.DM
	case TIOCRMSR:		/* get CTS/DSR/RI/RLSD (MSR) */
		msr = inb (port + MSR);
		temp = msr >> 4;
		kucopy (& temp, (unsigned *) vec, sizeof (unsigned));
		break;
.DE
.DM
	case TIOCFLUSH:		/* Flush silos here, queues in tty.c */
		RAWIN_FLUSH (in_silo);
		RAWOUT_FLUSH (out_silo);
		do_ttioctl = 1;
		break;
.DE
.DM
		/* If port parameters change, plan to call asyparam().
		 * Need to check now before structs are updated.
		 */
	case TCSETA:
	case TCSETAW:
	case TCSETAF:
		{
			struct	termio	trm;
.DE
.DM
			ukcopy (vec, & trm, sizeof (struct termio));
			if (trm.c_cflag != tp->t_termio.c_cflag)
				do_asyparam = 1;
		}
		do_ttioctl = 1;
		break;
.DE
.DM
	case TIOCSETP:
	case TIOCSETN:
		{
			struct	sgttyb	sg;
.DE
.DM
			ukcopy(vec, &sg, sizeof(struct sgttyb));
			if (sg.sg_ispeed != tp->t_sgttyb.sg_ispeed ||
			   ((sg.sg_flags ^ tp->t_sgttyb.sg_flags) & ANYP) != 0)
				do_asyparam = 1;
		}
		do_ttioctl = 1;
		break;
.DE
.DM
	default:
		do_ttioctl = 1;
	}
.DE
.DM
	outb (port + IER, ier);
	if (do_ttioctl)
		ttioctl (tp, com, vec);
	spl (s);
	if (do_asyparam)
		asyparam (tp);
.DE
.DM
	/* Things to be done after calling ttioctl(). */
	switch(com) {
	case TCSBRK:
		/* Send 0.25 second break:
		 * 1.  Turn on break level.
		 * 2.  Set timer to turn off break level 0.25 sec later.
		 * 3.  Sleep till timer expires.
		 * 4.  Turn off break level.
		 */
		outb (port + LCR, lcr | LC_SBRK);
		a1->a_brk = 1;
		timeout (& tp->t_sbrk, HZ / 4, endbrk, chan);
.DE
.DM
		while (a1->a_brk)
			x_sleep (a1, pritty, slpriNoSig, "asybreak");
.DE
.DM
		outb (port + LCR, lcr & ~ LC_SBRK);
	}
}
.DE
.SH "Turn Off the Break Level"
.PP
Function
.B endbrk()
turns off the break level.
Called from a timeout after the function
.BR "ioctl(fd, TCSBRK, 0)" .
.DM
void
endbrk(chan)
int chan;
{
	asy1_t	*a1 = asy1 + chan;
	a1->a_brk = 0;
	wakeup (a1);
}
.DE
.SH "Read Parameters"
.PP
Function
.B asyparam()
reads parameters from the port.
.DM
static void
asyparam(tp)
TTY * tp;
{
	int chan = (int)tp->t_ddp;
	asy0_t *a0 = asy0 + chan;
	asy1_t *a1 = asy1 + chan;
	short port = a0->a_port;
	int s;
	int write_baud=1, write_lcr=1;
	unsigned char mcr, newlcr, speed, oldSpeed;
	unsigned short cflag = tp->t_termio.c_cflag;
.DE
.DM
	speed = cflag & CBAUD;
	switch (cflag & CSIZE) {
	case CS5:  newlcr = LC_CS5;  break;
	case CS6:  newlcr = LC_CS6;  break;
	case CS7:  newlcr = LC_CS7;  break;
	case CS8:  newlcr = LC_CS8;  break;
	}
.DE
.DM
	if (cflag & CSTOPB)
		newlcr |= LC_STOPB;
	if (cflag & PARENB) {
		newlcr |= LC_PARENB;
		if ((cflag & PARODD) == 0)
			newlcr |= LC_PAREVEN;
	}
.DE
.DM
	/* Don't bang on the UART needlessly.
	 * Writing baud rate resets the port, which loses characters.
	 * You want this on first open, NOT on later opens.
	 */
	oldSpeed = a0->a_speed;
.DE
.DM
	if (speed == oldSpeed && tp->t_open) {
		write_baud = 0;
		if (newlcr == a1->a_lcr) {
			write_lcr = 0;
		}
	}
	a0->a_speed = speed;
	a1->a_lcr = newlcr;
.DE
.DM
	if (write_lcr) {
		char ier_save;
		s = sphi();
		ier_save = inb(port+IER);
.DE
.DM
		if (write_baud) {
			if (speed) {
				short divisor = albaud [speed];
.DE
.DM
				if (oldSpeed == 0) {
					/* if previous baud rate was zero,
					 * need to go off hook. */
					mcr = inb(port+MCR) | (MC_RTS | MC_DTR);
					outb(port+MCR, mcr);
				}
.DE
.DM
				outb(port+LCR, LC_DLAB);
				outb(port+DLL, divisor);
				outb(port+DLH, divisor >> 8);
			} else {
				/* Baud rate of zero means hang up. */
				mcr = inb(port+MCR) & ~(MC_RTS | MC_DTR);
				outb(port+MCR, mcr);
			}
		}
.DE
.DM
		outb(port+LCR, newlcr);
		if (a1->a_ut == US_16550A)
			outb(port+FCR, FC_ENABLE | FC_Rx_RST | FC_Rx_08);
		outb(port+IER, ier_save);
		spl(s);
	}
.DE
.DM
	if (write_baud)
		asyspr ();
}
.DE
.SH "Start Processing"
.PP
Function
.B asystart()
starts processing of data.
.DM
static void
asystart(tp)
TTY * tp;
{
	int chan = (int)tp->t_ddp;
	asy0_t *a0 = asy0 + chan;
	asy1_t *a1 = asy1 + chan;
	short port = a0->a_port;
	int s;
	int need_xmit = 1; /* True if should start sending data now. */
	silo_t *out_silo = &a1->a_out;
	char lsr;
.DE
.DM
	/* Read line status register AFTER disabling interrupts. */
	s = sphi ();
	lsr = inb (port + LSR);
.DE
.DM
	/* Process break indication.
	 * NOTE: Break indication cleared when line status register was read.
	 */
	if (lsr & LS_BREAK)
		defer (asybreak, chan);
.DE
.DM
	/* If no output data, it may be time to finish closing the port;
	 * but won't need another xmit interrupt.
	 */
	if (out_silo->si_ix == out_silo->si_ox) {
		if (need_wake[chan] & NW_OUTSILO) {
			need_wake[chan] &= ~NW_OUTSILO;
			wakeup((char *)out_silo);
		}
		need_xmit = 0;
	}
.DE
.DM
	/* Do nothing if output is stopped. */
	if (tp->t_flags & T_STOP)
		need_xmit = 0;
	if (a1->a_ohlt)
		need_xmit = 0;
.DE
.DM
	/* Start data transmission by writing to UART xmit reg. */
	if ((lsr & LS_TxRDY) && need_xmit) {
		int xmit_count;
		xmit_count = (a1->a_ut == US_16550A)?16:1;
		asy_send(out_silo, port+DREG, xmit_count);
	}
	spl(s);
}
.DE
.SH "The Poll Routine"
.PP
The kernel invokes function
.B asypoll()
when a user application invokes the system call
.B poll()
to poll a serial port.
.PP
Field
.B c_poll
in the
.B CON
structure contains a pointer to this function.
.DM
static int
asypoll(dev, ev, msec)
dev_t dev;
int ev;
int msec;
{
	int chan = channel(dev);
	asy1_t *a1 = asy1 + chan;
	TTY *tp = & a1->a_tty;
	return ttpoll(tp, ev, msec);
}
.DE
.SH "Wake Up Sleeping Devices"
.PP
Function
.B asycycle()
wakes up of any sleeping ports at regular intervals.
.DM
static void
asycycle(chan)
int chan;
{
	asy0_t *a0 = asy0 + chan;
	asy1_t *a1 = asy1 + chan;
	TTY *tp = &a1->a_tty;
	short port = a0->a_port;
	int s;
	char msr, mcr;
	silo_t *out_silo = &a1->a_out;
	silo_t *in_silo = &a1->a_in;
	int n, ch;
	int do_start = 1;
	unsigned char iir;
.DE
.DM
	/* Check Carrier Detect (RLSD).
	 * Modem status interrupts were not enabled due to 8250 hardware bug.
	 * Enabling modem status and receive interrupts may cause lockup
	 * on older parts.
	 */
	if (tp->t_flags & T_MODC) {
		/* Get status */
		msr = inb(port+MSR);
.DE
.DM
		/* Carrier changed. */
		if ((msr & MS_RLSD) && !(tp->t_flags & T_CARR)) {
			/* Carrier is on - wakeup open. */
			s = sphi();
			tp->t_flags |= T_CARR;
			spl(s);
			wakeup((char *)(&tp->t_open));
		}
.DE
.DM
		if (!(msr & MS_RLSD) && (tp->t_flags & T_CARR)) {
			s = sphi();
			RAWIN_FLUSH(in_silo);
			RAWOUT_FLUSH(out_silo);
			tp->t_flags &= ~T_CARR;
			spl(s);
			tthup(tp);
		}
	}
.DE
.DM
	/* Empty raw input buffer.
	 * The line discipline module (tty.c) will set T_ISTOP true when the
	 * tt input queue is nearly full (tp->t_iq.cq_cc >= IHILIM), and make
	 * T_ISTOP false when it's ready for more input.
	 * When T_ISTOP is true, ttin() simply discards the character passed.
	 */
	if (!(tp->t_flags & T_ISTOP)) {
		while (in_silo->SILO_CHAR_COUNT > 0) {
			s = sphi();
			ttin(tp, in_silo->si_buf[in_silo->si_ox]);
			if (in_silo->si_ox < MAX_SILO_INDEX)
				in_silo->si_ox++;
			else
				in_silo->si_ox = 0;
			in_silo->SILO_CHAR_COUNT--;
			spl(s);
		}
	}
.DE
.DM
	/* Hardware flow control.
	 *	Check CTS to see if we need to halt output.
	 *	(MS_INTR should have done this - repeat code here to be sure)
	 *	Check input silo to see if we need to raise RTS.
	 */
	if (tp->t_flags & T_CFLOW) {
		/* Get status */
		msr = inb(port+MSR);
		s = sphi();
		if (msr & MS_CTS)
			a1->a_ohlt = 0;
		else
			a1->a_ohlt = 1;
		spl(s);
.DE
.DM
		/* If using hardware flow control, see if we need to drop RTS. */
		if ((tp->t_flags & T_CFLOW)
		&& (in_silo->SILO_CHAR_COUNT > SILO_HIGH_MARK)) {
			s = sphi();
			mcr = inb(port+MCR);
			if (mcr & MC_RTS) {
				outb(port+MCR, mcr & ~MC_RTS);
			}
			spl(s);
		}
.DE
.DM
		/* If input silo below low mark, assert RTS */
		if (in_silo->SILO_CHAR_COUNT <= SILO_LOW_MARK) {
			s = sphi();
			mcr = inb(port+MCR);
.DE
.DM
			if ((mcr & MC_RTS) == 0) {
				outb(port+MCR, mcr | MC_RTS);
			}
			spl(s);
		}
	}
.DE
.DM
	/* Calculate free output slot count. */
	n = sizeof(out_silo->si_buf) - 1;
	n += out_silo->si_ox - out_silo->si_ix;
	n %= sizeof(out_silo->si_buf);
.DE
.DM
	/* Fill raw output buffer */
	for (;;) {
		if (--n < 0)
			break;
		s = sphi();
		ch = ttout(tp);
		spl(s);
		if (ch < 0)
			break;
.DE
.DM
		s = sphi();
		out_silo->si_buf[out_silo->si_ix] = ch;
		if (out_silo->si_ix >= sizeof(out_silo->si_buf) - 1)
			out_silo->si_ix = 0;
		else
			out_silo->si_ix++;
		spl(s);
	}
.DE
.DM
	/* if port has an interrupt pending (probably missed an irq)
	 *	the following two loops should not be merged
	 *	- need ALL port irq's inactive at once
	 *	for each port on this irq line (use irq1 for this)
	 *		disable interrupts (clear IER)
	 *	for each port on this irq line
	 *		restore interrupts
	 */
	if (a1->a_has_irq && ((iir = inb (port + IIR)) & 1) == 0) {
		struct irqnode *ip;
		asy_gp_t *gp;
		int s;
		short p;
		char c, slot;
.DE
.DM
		do_start = 0;
		s = sphi ();
		ip = irq1 [a0->a_irqno];
.DE
.DM
		while(ip) {
			if (ip->func == asyintr) {
				p = ip->arg;
				outb (p + IER, 0);
			} else {
				gp = asy_gp + ip->arg;
				for (slot = 0; slot < MAX_SLOTS; slot++) {
					if ((c = gp->chan_list [slot]) <
					    MAX_ASY) {
						p = asy0 [c].a_port;
						outb (p + IER, 0);
					}
				}
			}
			ip = ip->next_actv;
		}
.DE
.DM
		/* Now, all ports on the offending irq line have irq off. */
		ip = irq1 [a0->a_irqno];
		while (ip) {
			if (ip->func == asyintr) {
				p = ip->arg;
				outb (p + IER, IEN);
			} else {
				gp = asy_gp + ip->arg;
				for (slot = 0; slot < MAX_SLOTS; slot++) {
					if ((c = gp->chan_list [slot]) <
					    MAX_ASY){
						p = asy0 [c].a_port;
						outb (p + IER, IEN);
					}
				}
			}
			ip = ip->next_actv;
		}
		spl (s);
	}
.DE
.DM
	if (do_start)
		ttstart (tp);
.DE
.DM
	/* Schedule next cycle. */
	if (a1->a_in_use)
		timeout (& tp->t_rawtim, HZ / 10, asycycle, chan);
}
.DE
.SH "Suppress Interrupts During Chip Sensing"
.PP
Function
.B irqdummy()
suppresses interrupts that may occur during chip sensing.
.DM
static void
irqdummy()
{
	/* Try to clear all pending interrupts. */
	inb(dummy_port+IIR);
	inb(dummy_port+LSR);
	inb(dummy_port+MSR);
	inb(dummy_port+DREG);
}
.DE
.SH "Add a Port Information to IRQ0 List"
.PP
Function
.B add_irq()
adds information about a port to the
.B irq0
list.
.DM
static void
add_irq(irq, func, arg)
int irq;
int (*func)();
int arg;
{
	struct irqnode * np;
.DE
.DM
	/* Sanity check */
	if (irq <= 0 || irq >= NUM_IRQ)
		return;
.DE
.DM
	if (nextnode < MAX_ASY) {
		np = nodespace + nextnode++;
		np->func = func;
		np->arg = arg;
		np->next = irq0[irq];
		irq0[irq] = np;
	} else {
		printf("asy: too many irq nodes (%d)\en", nextnode);
	}
}
.DE
.SH "Service an Interrupt"
.PP
Function
.B asy_irq()
services an async interrupt.
.DM
static void
asy_irq (level)
int level;
{
	struct irqnode *ip = irq1 [level];
	int doit;
.DE
.DM
	do {
		struct irqnode * here = ip;
.DE
.DM
		doit = 0;
.DE
.DM
		while (here != NULL) {
			doit |= (* here->func) (here->arg);
			here = here->next_actv;
		}
	} while (doit);
}
.DE
.SH "Rebuild Links for Active Devices"
.PP
Function
.B upd_irq1()
rebuild the links for active devices.
.DM
static void
upd_irq1(irq)
int irq;
{
	struct irqnode *np;
	asy1_t *a1;
	int chan;
	int s;
.DE
.DM
	/* Sanity check */
	if (irq <= 0 || irq >= NUM_IRQ)
		return;
.DE
.DM
	/* For each node in the irq0 list
	 *	if node is for irq status port
	 *		for each channel using the status port
	 *			if channel in use, in irq mode
	 *				add node to irq1 list
	 *				skip rest of channels for this node
	 *	else - node is for simple UART
	 *		if channel in use, in irq mode
	 *			add node to irq1 list
	 */
.DE
.DM
	s = sphi();
	np = irq0[irq];
	irq1[irq] = 0;
	while (np) {
		if (np->func != asyintr) {
			char ix, loop = 1;
			asy_gp_t *gp = asy_gp + np->arg;
.DE
.DM
			for (ix = 0; ix < MAX_SLOTS && loop; ix++) {
				if ((chan = gp->chan_list[ix]) < MAX_ASY) {
					a1 = asy1 + chan;
					if (a1->a_in_use && a1->a_irq) {
						np->next_actv = irq1[irq];
						irq1[irq] = np;
						loop = 0;
					}
				}
			}
.DE
.DM
		} else {
			a1 = asy1 + np->arg;
			if (a1->a_in_use && a1->a_irq) {
				np->next_actv = irq1[irq];
				irq1[irq] = np;
			}
		}
		np = np->next;
	}
	spl(s);
}
.DE
.SH "The Break Routine"
.PP
Function
.B asybreak()
breaks connection with a port.
.DM
static void
asybreak(chan)
int chan;
{
	int s;
	asy1_t *a1 = asy1 + chan;
	silo_t *out_silo = &a1->a_out;
	silo_t *in_silo = &a1->a_in;
	TTY *tp = &a1->a_tty;
.DE
.DM
	s = sphi();
	RAWIN_FLUSH(in_silo);
	RAWOUT_FLUSH(out_silo);
	spl(s);
	ttsignal(tp, SIGINT);
}
.DE
.SH "Handle an Interrupt"
.PP
Function
.B asyintr()
handles an interrupt for a single channel.
.DM
static int
asyintr(chan)
int chan;
{
	asy0_t *a0 = asy0 + chan;
	asy1_t *a1 = asy1 + chan;
	TTY *tp = &a1->a_tty;
	silo_t *out_silo = &a1->a_out;
	silo_t *in_silo = &a1->a_in;
	int c, xmit_count;
	int ret = 0;
	short port = a0->a_port;
	unsigned char msr, lsr;
.DE
.DM
	if (chan >= MAX_ASY) {
		printf("asy: irq on channel %d\en", chan);
		return 0;
	}
.DE
.DM
rescan:
	switch (inb(port+IIR) & 0x07) {
	case LS_INTR:
		ret = 1;
		lsr = inb(port + LSR);
		if (lsr & LS_BREAK)
			defer(asybreak, chan);
		goto rescan;
.DE
.DM
	case Rx_INTR:
		ret = 1;
		c = inb(port+DREG);
		if (tp->t_open == 0)
			goto rescan;
.DE
.DM
		/* Must recognize XOFF quickly to avoid transmit overrun.
		 * Recognize XON here as well to avoid race conditions.
		 */
		if (_IS_IXON_MODE (tp)) {
			/* XON */
			if (_IS_START_CHAR (tp, c) ||
			    (_IS_IXANY_MODE (tp) &&
			     (tp->t_flags & T_STOP) != 0)) {
				tp->t_flags &= ~(T_STOP | T_XSTOP);
				goto rescan;
			}
.DE
.DM
			/* XOFF */
			if (_IS_STOP_CHAR (tp, c)) {
				tp->t_flags |= T_STOP;
				goto rescan;
			}
		}
.DE
.DM
		/* Save char in raw input buffer. */
		if (in_silo->SILO_CHAR_COUNT < MAX_SILO_CHARS) {
			in_silo->si_buf[in_silo->si_ix] = c;
			if (in_silo->si_ix < MAX_SILO_INDEX)
				in_silo->si_ix ++;
			else
				in_silo->si_ix = 0;
			in_silo->SILO_CHAR_COUNT ++;
		}
.DE
.DM
		/* If using hardware flow control, see if we need to drop RTS. */
		if ((tp->t_flags & T_CFLOW) != 0 &&
		    in_silo->SILO_CHAR_COUNT > SILO_HIGH_MARK) {
			unsigned char mcr = inb (port + MCR);
			if (mcr & MC_RTS) {
				outb(port+MCR, mcr & ~MC_RTS);
			}
		}
		goto rescan;
.DE
.DM
	case Tx_INTR:
		ret = 1;
		/* Do nothing if output is stopped. */
		if (tp->t_flags & T_STOP) {
			goto rescan;
		}
		if (a1->a_ohlt)
			goto rescan;
.DE
.DM
		/* Transmit next char in raw output buffer. */
		xmit_count = (a1->a_ut == US_16550A)?16:1;
		asy_send(out_silo, port+DREG, xmit_count);
		goto rescan;
.DE
.DM
	case MS_INTR:
		ret = 1;
		/* Get status (and clear interrupt). */
		msr = inb(port+MSR);
.DE
.DM
		/* Hardware flow control.
		 *	Check CTS to see if we need to halt output.
		 */
		if (tp->t_flags & T_CFLOW) {
			if (msr & MS_CTS)
				a1->a_ohlt = 0;
			else
				a1->a_ohlt = 1;
		}
		goto rescan;
.DE
.DM
	default:
		return ret;
	} /* endswitch */
}
.DE
.SH "Handle Timer Interrupts"
.PP
Function
.B asyclk()
is called every time
.B T0
interrupts.
If it returns zero,
.B asy
performs the usual system timer routines.
It polls all pollable ports.
.DM
static int
asyclk()
{
	static int count;
	int ix;
.DE
.DM
	for (ix = 0; ix < ppnum; ix++)
		asysph(pptbl[ix]);
	count++;
	if (count >= poll_divisor)
		count = 0;
	return count;
}
.DE
.SH "Set Polling Rate on a Port"
.PP
Function
.B asyspr()
sets the polling rate on a port.
.B asy
calls it
when a port is opened, closed, or changes speed.
It sets the polling rate only as fast as needed, and shuts off polling
whenever possible.
It updates the links in
.BR irq1[0] ,
which lists the polled-mode ports.
.DM
static void
asyspr()
{
	asy0_t *a0;
	asy1_t *a1;
	int chan;
	int s;
	int ix, max_rate, port_rate;
.DE
.DM
	/* Rebuild table of pollable ports. */
	s = sphi();
	ppnum = 0;
	for (chan = 0; chan < ASY_NUM; chan++) {
		a1 = asy1 + chan;
		if (a1->a_poll)
			pptbl[ppnum++] = chan;
	}
	spl(s);
.DE
.DM
	/* If another driver has the polling clock, do nothing. */
	if (poll_owner & ~ POLL_ASY)
		return;
.DE
.DM
	/* Find highest valid polling rate in units of HZ/10.
	 * If using FIFO chip, can poll at 1/16 the usual rate.
	 */
	max_rate = 0;
	for (ix = 0; ix < ppnum; ix++) {
		chan = pptbl[ix];
		a0 = asy0 + chan;
		a1 = asy1 + chan;
		port_rate = alp_rate[a0->a_speed];
		if (a1->a_ut == US_16550A) {
			port_rate /= 16;
			if (port_rate % HZ)
				port_rate += HZ - (port_rate % HZ);
		}
.DE
.DM
		if (max_rate < port_rate)
			max_rate = port_rate;
	}
.DE
.DM
	/* if max_rate is not current rate, adjust the system clock */
	if (max_rate != poll_rate) {
		poll_rate = max_rate;
		poll_divisor = poll_rate/HZ; /* used in asyclk() */
		altclk_out(); /* stop previous polling */
		poll_owner &= ~ POLL_ASY;
.DE
.DM
		if (poll_rate) { /* resume polling at new rate if needed */
			poll_owner |= POLL_ASY;
			altclk_in(poll_rate, asyclk);
		}
	}
}
.DE
.SH "Handle Polling"
.PP
Function
.B asysph()
handles the polling of serial ports.
.DM
static void
asysph(chan)
int chan;
{
	asy0_t *a0 = asy0 + chan;
	asy1_t *a1 = asy1 + chan;
	TTY *tp = &a1->a_tty;
	silo_t *out_silo = &a1->a_out;
	silo_t *in_silo = &a1->a_in;
	int c, xmit_count;
	short port = a0->a_port;
	char lsr;
.DE
.DM
	/* Check for received break first.
	 * This status is wiped out on reading the LSR.
	 */
	lsr = inb(port + LSR);
	if (lsr & LS_BREAK)
		defer(asybreak, chan);
.DE
.DM
	/* Handle all incoming characters. */
	for (;;) {
		lsr = inb(port + LSR);
		if ((lsr & LS_RxRDY) == 0)
			break;
		c = inb(port+DREG);
		if (tp->t_open == 0)
			continue;
.DE
.DM
		/* Must recognize XOFF quickly to avoid transmit overrun.
		 * Recognize XON here as well to avoid race conditions.
		 */
		if (_IS_IXON_MODE (tp)) {
			/* XOFF */
			if (_IS_STOP_CHAR (tp, c)) {
				tp->t_flags |= T_STOP;
				continue;
			}
.DE
.DM
			/* XON */
			if (_IS_START_CHAR (tp, c)) {
				tp->t_flags &= ~T_STOP;
				continue;
			}
		}
.DE
.DM
		/* Save char in raw input buffer. */
		if (in_silo->SILO_CHAR_COUNT < MAX_SILO_CHARS) {
			in_silo->si_buf[in_silo->si_ix] = c;
			if (in_silo->si_ix < MAX_SILO_INDEX)
				in_silo->si_ix++;
			else
				in_silo->si_ix = 0;
			in_silo->SILO_CHAR_COUNT++;
		}
.DE
.DM
		/* If using hardware flow control, see if we need to drop RTS. */
		if ((tp->t_flags & T_CFLOW)
		  && (in_silo->SILO_CHAR_COUNT > SILO_HIGH_MARK)) {
			unsigned char mcr = inb(port+MCR);
			if (mcr & MC_RTS) {
				outb(port+MCR, mcr & ~MC_RTS);
			}
		}
	}
.DE
.DM
	/* Handle outgoing characters. Do nothing if output is stopped. */
	lsr = inb(port + LSR);
	if ((lsr & LS_TxRDY)
	  && !(tp->t_flags & T_STOP)
	  && !(a1->a_ohlt)) {
		/* Transmit next char in raw output buffer. */
		xmit_count = (a1->a_ut == US_16550A)?16:1;
		asy_send(out_silo, port+DREG, xmit_count);
	}
.DE
.DM
	/* Hardware flow control.
	 *	Check CTS to see if we need to halt output.
	 */
	if (tp->t_flags & T_CFLOW) {
		if (inb(port+MSR) & MS_CTS)
			a1->a_ohlt = 0;
		else
			a1->a_ohlt = 1;
	}
}
.DE
.SH "Write to UART"
.PP
Function
.B asy_send()
write to the
.B xmit
data register of the UART.
Assume all checking about whether it's time to send has been done already.
This function is
called by time-critical IRQ and polling routines!
.PP
Argument
.I rawout
is the output silo for the TTY structure that supplies data to the port.
.I dreg
is the I/O address of the UART
.B xmit
data register.
.I xmit_count
is the maximum number of characters we can write (16 for FIFO parts).
.DM
static int
asy_send(rawout, dreg, xmit_count)
register silo_t *rawout;
int dreg, xmit_count;
{
	/* Transmit next chars in raw output buffer. */
	for (;(rawout->si_ix != rawout->si_ox) && xmit_count; xmit_count--) {
		outb(dreg, rawout->si_buf[rawout->si_ox]);
		/* Adjust raw output buffer output index. */
		if (++rawout->si_ox >= sizeof(rawout->si_buf))
			rawout->si_ox = 0;
	}
	return xmit_count;
}
.DE
.SH "Interrupt Handler for Comtrol-Type Port Groups"
.PP
Function
.B p1()
is the interrupt handler for Comtrol-type port groups.
The status register has one in bit positions for interrupting ports.
.DM
static int
p1(g)
int g;
{
	asy_gp_t *gp = asy_gp + g;
	short port = gp->stat_port;
	unsigned char status, index, chan;
	int safety = LOOP_LIMIT;
	int ret = 0;
.DE
.DM
	/* while any port is active
	 *	call simple interrupt handler for active channel
	 */
	while (status = inb(port)) {
		ret = 1;
		index = 0;
		if (status & 0xf0) {
			status &= 0xf0;
			index +=4;
		} else
			status &= 0x0f;
.DE
.DM
		if (status & 0xcc) {
			status &= 0xcc;
			index +=2;
		} else
			status &= 0x33;
.DE
.DM
		if (status & 0xaa)
			index++;
		chan = gp->chan_list[index];
		asyintr(chan);
.DE
.DM
		if (safety-- == 0) {
			printf("asy: p1 runaway - status %x\en", status);
			break;
		}
	}
	return ret;
}
.DE
.SH "Interrupt Handler for Arnet-Type Port Groups"
.PP
Function
.B p2()
is the interrupt handler for Arnet-type port groups.
The status register has zero in bit positions for interrupting ports.
.DM
static int
p2(g)
int g;
{
	asy_gp_t *gp = asy_gp + g;
	short port = gp->stat_port;
	unsigned char status, index, chan;
	int safety = LOOP_LIMIT;
	int ret = 0;
.DE
.DM
	/* while any port is active
	 *	call simple interrupt handler for active channel
	 */
	while (status = ~inb(port)) {
		ret = 1;
		index = 0;
		if (status & 0xf0) {
			status &= 0xf0;
			index +=4;
		} else
			status &= 0x0f;
.DE
.DM
		if (status & 0xcc) {
			status &= 0xcc;
			index +=2;
		} else
			status &= 0x33;
.DE
.DM
		if (status & 0xaa)
			index++;
		chan = gp->chan_list[index];
		asyintr(chan);
		if (safety-- == 0) {
			printf("asy: p2 runaway - status %x\en", status);
			break;
		}
	}
	return ret;
}
.DE
.SH "Interrupt Handler for GTEK-Type Port Groups"
.PP
Function
.B p3()
is the interrupt handler for GTEK-type port groups.
.DM
static int
p3(g)
int g;
{
	asy_gp_t *gp = asy_gp + g;
	short port = gp->stat_port;
	unsigned char index, chan;
.DE
.DM
	/* Call simple interrupt handler for active channel. */
	index = inb(port) & 7;
	chan = gp->chan_list[index];
	return asyintr(chan);
}
.DE
.SH "Interrupt Handler for DigiBoard-Type Port Groups"
.PP
Function
.B p4()
is the interrupt handler for DigiBoard-type port groups.
.DM
static int
p4(g)
int g;
{
	asy_gp_t *gp = asy_gp + g;
	short port = gp->stat_port;
	unsigned char index, chan;
	int ret = 0;
	int safety = LOOP_LIMIT;
.DE
.DM
	/* Status register has slot number for active port,
	 * or 0xFF if no port is active.
	 */
	for (;;) {
		index = inb(port);
		if (index == 0xFF)
			break;
.DE
.DM
		if (safety-- == 0) {
			printf("asy: p4 runaway - status %x\en", index);
			break;
		}
.DE
.DM
		ret = 1;
		chan = gp->chan_list[index&0xF];
		asyintr(chan);
	}
	return ret;
}
.DE
.SH "The CON Structure"
.PP
Finally, the
.B CON
structure
holds pointers to the driver's functions that are invoked by the kernel.
.DM
.ta 0.5i 2.5i
CON asycon = {
	DFCHR|DFPOL,	/* Flags */
	ASY_MAJOR,	/* Major index */
	asyopen,	/* Open */
	asyclose,	/* Close */
	NULL,	/* Block */
	asyread,	/* Read */
	asywrite,	/* Write */
	asyioctl,	/* Ioctl */
	NULL,	/* Powerfail */
	asytimer,	/* Timeout */
	asyload,	/* Load */
	asyunload,	/* Unload */
	asypoll	/* Poll */
};
.DE
.SH "Where To Go From Here"
.PP
The Lexicon describes the functions invoked within this driver.
The previous section gives an example of a driver for a block device.

.TH passwd "" "" "System Administration"
.PC "Define system users"
.PP
The file
.B /etc/passwd
holds information about each user who has permission to use
the \*(CO system.
This information is read by the commands
.B login
and
.B passwd
whenever a user attempts to log in, to ensure that that user is
really himself and not an impostor.
.PP
.B /etc/passwd
holds one record for each user; each record, in turn, consists of
seven colon-separated fields, as follows:
.DM
	name:password:user_id:group_id:comments:home_dir:shell
.DE
.PP
.I name
is the user's login name.
.PP
.I password
is his encrypted password.
If this field holds a single asterisk `*', then the program
.B login
reads his password out of the file
.BR /etc/shadow .
.PP
.I user_id
is a unique number that is also used to identify the user.
.I group_id
identifies the group to which the user belongs, if any.
.PP
.I comments
holds miscellaneous data, such as names, telephone numbers, or
office numbers.
.PP
.I home_dir
gives the user's home directory.
.PP
Finally,
.I shell
gives the program that is first executed when the user logs on;
in most instances, this is an interactive shell (default, \fB/bin/sh\fR).
.PP
If you wish, you can set additional passwords to control users who
attempt to log into your system remotely (that is, via a modem).
You can set a different remote-access password for each group of users,
based on the program invoked when they log in; for example, you can
set one password for the users who log in and invoke
.BR uucico ,
and another for the users who log in and invoke the interactive shells
.B ksh
or
.BR sh .
For details on how to do this, see the Lexicon entries
.B d_passwd
and
.BR dialups .
.PP
When a user creates a file, that file is ``owned'' by him.
For example, whenever user
.B joe
create a file, that file is ``owned'' by
.BR joe ;
and
.B joe
has user-level permissions on that file.
.II chown
The superuser
.B root
can use the command
.B chown
to change the ownership of a file from one user to another.
For details on this command, see its entry in the Lexicon.
.SH "See Also"
.Xr "Administering COHERENT," administe
.Xr "chown," chown.c
.Xr "passwd [command]" passwd.c
.R
.SH Notes
.B /etc/passwd
can be read by anyone:
if access to it were refused to a user, he could not log on.
Thus, the passwords encrypted within it can be read and copied by anyone,
and so may be vulnerable to brute-force decryption.
For this reason, close attention should be paid to passwords:
they should not be common words or names, preferably mix cases
or use unique spellings, and be at least six characters long.

.IP \fBae\fR 1.0i
A full-screen editor that allows both \*(ME-style
and
.BR vi -style
key bindings.
.IS \fBarc\fR
A file archiver and unarchiver.
.IS "\fBelm 4.2\fR"
A newer version of the popular \*(UN mailer.
.IS "\fBf2c\fR"
A FORTRAN-to-C translator.
.IS "\fBfreeze\fR"
A file compression/decompression utility.
.IS "\fBgraphica 2.2\fR"
Produces code for PostScript and HPGL printers for printing
charts, graphs, and other documents.
.IS "\fBggrep\fR"
The
.B GNU
versions of
.B grep
and
.BR egrep .
.IS \fBgzip\fR
A file compression/decompression utility from
.BR GNU .
It works with files compressed with
.B pack
from other \*(UN systems.
.IS \fBhack\fR
A 
.BR rogue -style
adventure game.
.IS \fBindent\fR
A utility to indent C source files.
.IS "\fBka9q\fR"
A popular package used for HAM-radio packet communications.
Provides SLIP support.
.IS \fBmdf\fR
Produces System-V style output from \*(CO's
.B df
command.
.IS \fBpatch201\fR
Utility to merge context-style
.B diff
output with text files.
.IS "\fBpcl302\fR"
A utility that lists files and directories.
It Lists contents of binary files in hexadecimal.
.IS "\fBrn\fR"
A very popular newsreader program.
.IS "\fBularn\fR"
The search for the cure of dianthroritis through a deadly
dungeon and a volcano.
.IS \fButree\fR
A utility for listing directories and files.
.IS \fBwarp\fR
A popular screen game based upon the original Star Trek
television series.
.IS \fBzork\fR
The popular text adventure game run on many mainframes.

.lf B	Bookman_B.fwt   8
.lf I	Bookman_I.fwt   8
.lf R	Bookman_R.fwt   8
.lf HH	HelvNar_B.fwt  14
.lf HR	HelvNar_R.fwt  10
.lf S	Symbol.fwt      8
.lf DB	Dingbats.fwt    8
.vs 9
.ll 6.0i
.wh 0 HD
.wh -1.5i FO
.de HD
.sp |0.75i
..
.de FO
..
.po 1.0i
.sp
.ft HH
.ce
\f(HHORDER  FORM\fR
.sp 12p
Use this convenient form to order additional COHERENT products
from Mark Williams Company.
Simply fill it out, detach, fold, and seal it.
Or call 1-800-636-6700 or 1-708-291-6700.
.ta 0.75i 4.5iC 5.5iC
.nf
.sp 6p
			\fICOHERENT Club\fR
\fIQuantity	Product	Price*	Price*\fR
.sp 6p
________	COHERENT 4.2 (1-4 User License)	$99.95	$99.95
.sp 6p
________	COHERENT 4.2 (1-4 User License) with X Windows	$149.95	$149.95
.sp 6p
________	COHERENT 4.2 (Unlimited User License)	$299.95	$299.95
.sp 6p
________	COHERENT 4.2 (Unlimited User License) with X Windows	$349.95	$349.95
.sp 6p
________	COHERENT 3.2 (16 bit OS that runs on 80286 PC's too)	$99.95	$99.95
.sp 6p
________	Update to COHERENT 4.2 from any earlier Coherent	$79.95	$49.95
.sp 6p
________	X Windows for Coherent 4.2	$99.95	$79.95
.sp 6p
________	X Windows and Update to COHERENT 4.2	$149.90	$119.90
.sp 6p
________	COHERENT Device Driver Kit 4.2	$59.95	$49.95
.sp 6p
________	Update to Device Driver Kit 4.2	$29.95	$19.95
.sp 6p
________	COHERENT Device Driver Kit 1.2	$39.95	$39.95
.sp 6p
________	COHware Volume 1	$35.00	$31.00
.sp 6p
________	COHware Volume 2	$40.00	$31.00
.sp 6p
________	COHware Volume 3	$40.00	$31.00
.sp 6p
________	COHware Volume 4	$49.00	$40.00
.sp 6p
________	COHware Volume 5	$49.00	$40.00
.sp 6p
________	GNU Tools	$49.95	$39.95
.sp 6p
________	GNU C (GCC 2.3 C Compiler)	$79.95	$59.95
.sp 6p
________	GNU C Sources (GCC 2.3 C Compiler Sources)	$99.95	$89.95
.sp 6p
________	COHERENT Club Membership	$49.95	N/A
.sp
.fi
Please specify size of \f(HRA:\fP drive: ______ 5.25'' 1.2MB or ______ 3.5'' 1.44MB
.sp
.ft HH
.ce
60-Day Money Back Guarantee
.ft R
.sp
.ce
.nf
\f(DBq\fP Visa    \f(DBq\fP Master Card    \f(DBq\fP Discover Card    \f(DBq\fP American Express    \f(DBq\fP Check Enclosed
.sp 6p
Card #:___________________________________________   Expiration Date: ____________________________
.sp 6p
Name: _________________________________________________________________________________________
.sp 6p
Company: ______________________________________________________________________________________
.sp 6p
Address: _______________________________________________________________________________________
.sp 6p
City: ________________________________________  State: ______________________  Zip: _________________
.sp 6p
Country:  ______________________________________________________________________________________
.sp 6p
Daytime Phone: ______________________________________  FAX: _____________________________________
.sp 6p
Serial Number: _________________________________________________________________________________
.sp 6p
.fi
If you want to be notified of new products via electronic mail, enter your e-mail
address here:
.sp
_________________________________________
.sp
.fi
* \fIShipping Charges\fP \(em COHERENT: Add $12 USA; $20 Canada; $50 Australia,
France, New Zealand, and Scandinavia; $35 all other countries.
All Other Products: Add $5 per product for USA; for Canada add $8 for first
product and $4 for each additional product; for France, Australia, New Zealand,
and Scandinavia add $15 for first product and $9 for each additional
product; all other countries add $10 for the first product and $5 for
each additional product.
.\" Device Driver Kit: Add $20 outside of the U.S. and Canada.
.\" COHware: Add $10 outside of the U.S. and Canada.
Illinois residents please add 7.5% sales tax.
.sp 2
.ce
FOLD  AND  SEAL  BEFORE  MAILING

.ds VN "2.5.6"
.ll 6.0i
.wh 0 HD
.wh -1.5i FO
.de HD
.sp |2.2i
..
.de FO
.bp
..
.po 1.0i
.sp
.ce 50
.ft HH
.vs 20
GCC  Development System  for  COHERENT
.sp
Release  \*(VN
.sp 3
Installation  Release  Notes
.sp 3
Read  This  First!
.ce 0

.ds TL Documentation
.NH Documentation
.PP
Full documentation for
.B gcc
is supplied by the Free Software Foundation.
This release includes it in compressed form.
When you install GNU C onto your COHERENT system, the installation script
will check how much space is free on your disk, and asks you if you want
the documentation to be uncompressed.
Documentation is installed into directory
.BR /usr/local/docs .
The following describes the contents of each file, and gives hints as
to where to find information on a given topic.
.PP
The documentation for
.B gcc
consists of approximately 24 files that are supplied in the subdirectory
.B /usr/local/docs
of this release.
The following introduces the contents of each file, to help you
find the information you seek about this product.
.IP \fBcpp.info\fR
This is the first of four files that together make up the manual on
.BR cpp ,
the preprocessor for the GNU C compiler.
It gives a copyright statement and a ``tag table,'' which gives each
subheading in the manual plus its offset (in characters) within the entire
concatenated manual.
.IP \fBcpp.info-1\fR
The second file of the manual for
.BR cpp .
It contains the following sections (note that the degree of
indentation indicates the level of subheading):
.sp \n(pDu
.nf
The C Preprocessor
	Transformations Made Globally
	Preprocessor Commands
	Header Files
		Uses of Header Files
		The `#include' Command
		How `#include' Works
		Once-Only Include Files
	Inheritance and Header Files
	Macros
		Simple Macros
		Macros with Arguments
		Predefined Macros
			Standard Predefined Macros
			Nonstandard Predefined Macros
		Stringification
		Concatenation
		Undefining Macros
		Redefining Macros
		Pitfalls and Subtleties of Macros
			Improperly Nested Constructs
			Unintended Grouping of Arithmetic
.fi
.IP \fBcpp.info-2\fR
The third file of the
.B cpp
manual.
It contains the following sections:
.sp \n(pDu
.nf
			Swallowing the Semicolon
			Duplication of Side Effects
			Self-Referential Macros
			Separate Expansion of Macro Arguments
			Cascaded Use of Macros
		Newlines in Macro Arguments
		Why Conditionals are Used
		Syntax of Conditionals
			The `#if' Command
			The `#else' Command
			The `#elif' Command
		Keeping Deleted Code for Future Reference
		Conditionals and Macros
		Assertions
		The `#error' and `#warning' Commands
	Combining Source Files
	Miscellaneous Preprocessor Commands
	C Preprocessor Output
	Invoking the C Preprocessor
Concept Index
.fi
.IP \fBcpp.info-3\fR
The last file of the manual for
.BR cpp .
It contains an index to the entire manual.
.IP \fBgcc.info\fR
This is the first of 20 files that together make up the manual for
.BR gcc .
It gives the the ``tag table'' for the \fBgcc\fR manual.
.IP \fBgcc.info-1\fR
The second file of the
.B gcc
manual.
It contains the opening sections of the manual.
.sp \n(pDu
Note that the section
.B "GNU GENERAL PUBLIC LICENSE"
describes the license by which this product is distributed to you by
Mark Williams Company, and by which you may distribute it to other people.
.sp \n(pDu
Section \fBProtect Your Freedom \(em Fight ``Look And Feel''\fR
is a political statement.
.\" In the words of Abraham Lincoln, ``Those who like this sort of thing
.\" will find this to be the sort of thing they like.''
.sp \n(pDu
Section
.B "Option Summary"
summarizes the hundreds of switches and options that are available with
.BR gcc ;
you should scan it, at least, to become aware of what you can do with
this compiler.
.sp \n(pDu
.nf
Introduction
GNU GENERAL PUBLIC LICENSE
	Preamble
	How to Apply These Terms to Your New Programs
Contributors to GNU CC
Protect Your Freedom--Fight "Look And Feel"
GNU CC Command Options
	Option Summary
	Options Controlling the Kind of Output
.fi
.IP \fBgcc.info-2\fR
The third file of the manual for
.BR gcc .
It contains the following sections:
.sp \n(pDu
.nf
	Options Controlling Dialect
	Options to Request or Suppress Warnings
	Options for Debugging Your Program or GNU CC
	Options That Control Optimization
	Options Controlling the Preprocessor
	Passing Options to the Assembler
.fi
.IP \fBgcc.info-3\fR
The fourth file of the manual for
.BR gcc .
It contains the following sections:
.sp \n(pDu
.nf
	Options for Linking
	Options for Directory Search
	Specifying Target Machine and Compiler Version
	Specifying Hardware Models and Configurations
		M680x0 Options
		VAX Options
		SPARC Options
		Convex Options
		AMD29K Options
		M88K Options
		IBM RS/6000 Options
		IBM RT Options
		MIPS Options
		Intel 386 Options
		HPPA Options
		Intel 960 Options
		DEC Alpha Options
		Options for System V
	Options for Code Generation Conventions
.fi
.IP \fBgcc.info-4\fR
The fifth file of the manual for
.BR gcc .
It contains the following sections.
Note that the section
.B "Installing GNU CC"
and its subsections
are superceded by the directions given earlier in these notes, at least
for installation onto the \*(CO system.
.sp \n(pDu
.nf
	Environment Variables Affecting GNU CC
	Running Protoize
Installing GNU CC
	Compilation in a Separate Directory
	Building and Installing a Cross-Compiler
	Installing GNU CC on the HP Precision Architecture
	Installing GNU CC on the Sun
	Installing GNU CC on the 3b1
.fi
.IP \fBgcc.info-5\fR
The sixth file of the manual for
.BR gcc .
It contains the following sections.
Note that all sections on installation are superceded by the
directions given earlier in these notes, at least for installation
under the \*(CO system:
.sp \n(pDu
.nf
	Installing GNU CC on Unos
	Installing GNU CC on VMS
	Installing GNU CC on the WE32K
	Installing GNU CC on the MIPS
GNU Extensions to the C Language
	Statements and Declarations within Expressions
	Locally Declared Labels
	Labels as Values
	Nested Functions
	Naming an Expression's Type
	Referring to a Type with `typeof'
	Generalized Lvalues
	Conditional Expressions with Omitted Operands
	Double-Word Integers
	Arrays of Length Zero
	Arrays of Variable Length
	Macros with Variable Numbers of Arguments
	Non-Lvalue Arrays May Have Subscripts
	Arithmetic on `void'- and Function-Pointers
	Non-Constant Initializers
	Constructor Expressions
	Labeled Elements in Initializers
	Case Ranges
	Cast to a Union Type
.fi
.IP \fBgcc.info-6\fR
The seventh file of the manual for
.BR gcc .
It contains the following sections:
.sp \n(pDu
.nf
	Declaring Attributes of Functions
	Prototypes and Old-Style Function Definitions
	Dollar Signs in Identifier Names
	The Character ESC in Constants
	Inquiring on Alignment of Types or Variables
	Specifying Attributes of Variables
	An Inline Function is As Fast As a Macro
	Assembler Instructions with C Expression Operands
	Controlling Names Used in Assembler Code
	Variables in Specified Registers
		Defining Global Register Variables
		Specifying Registers for Local Variables
	Alternate Keywords
	Incomplete `enum' Types
Known Causes of Trouble with GNU CC
	Actual Bugs We Haven't Fixed Yet
	Installation Problems
	Cross-Compiler Problems
.fi
.IP \fBgcc.info-7\fR
The eighth file of the manual for
.BR gcc .
It contains the following sections:
.sp \n(pDu
.nf
	Interoperation
	Incompatibilities of GNU CC
	Disappointments and Misunderstandings
	Caveats of using `protoize'
	Certain Changes We Don't Want to Make
Reporting Bugs
	Have You Found a Bug?
	Where to Report Bugs
	How to Report Bugs
.fi
.IP \fBgcc.info-8\fR
The ninth file of the manual for
.BR gcc .
It contains the following sections:
.sp \n(pDu
.nf
	Sending Patches for GNU CC
How To Get Help with GNU CC
Using GNU CC on VMS
	Include Files and VMS
	Global Declarations and VMS
	Other VMS Issues
GNU CC and Portability
Interfacing to GNU CC Output
Passes and Files of the Compiler
RTL Representation
	RTL Object Types
.fi
.IP \fBgcc.info-9\fR
The tenth file of the manual for
.BR gcc .
It contains the following sections:
.sp \n(pDu
.nf
	Access to Operands
	Flags in an RTL Expression
	Machine Modes
	Constant Expression Types
	Registers and Memory
	RTL Expressions for Arithmetic
	Comparison Operations
	Bit Fields
.fi
.IP \fBgcc.info-10\fR
The 11th file of the manual for
.BR gcc .
It contains the following sections:
.sp \n(pDu
.nf
	Conversions
	Declarations
	Side Effect Expressions
	Embedded Side-Effects on Addresses
	Assembler Instructions as Expressions
	Insns
	RTL Representation of Function-Call Insns
	Structure Sharing Assumptions
Machine Descriptions
.fi
.IP \fBgcc.info-11\fR
The 12th file of the manual for
.BR gcc .
It contains the following sections:
.sp \n(pDu
.nf
	Everything about Instruction Patterns
	Example of `define_insn'
	RTL Template for Generating and Recognizing Insns
	Output Templates and Operand Substitution
	C Statements for Generating Assembler Output
	Operand Constraints
		Simple Constraints
		Multiple Alternative Constraints
		Register Class Preferences
		Constraint Modifier Characters
		Not Using Constraints
.fi
.IP \fBgcc.info-12\fR
The 13th file of the manual for
.BR gcc .
It contains the following sections:
.sp \n(pDu
.nf
	Standard Names for Patterns Used in Generation
	When the Order of Patterns Matters
	Interdependence of Patterns
	Defining Jump Instruction Patterns
	Canonicalization of Instructions
	Defining Machine-Specific Peephole Optimizers
.fi
.IP \fBgcc.info-13\fR
The 14th file of the manual for
.BR gcc .
It contains the following sections:
.sp \n(pDu
.nf
	Defining RTL Sequences for Code Generation
	Splitting Instructions into Multiple Instructions
	Instruction Attributes
		Defining Attributes and their Values
		Attribute Expressions
		Assigning Attribute Values to Insns
		Example of Attribute Specifications
		Computing the Length of an Insn
		Constant Attributes
		Delay Slot Scheduling
		Specifying Function Units
Target Description Macros
.fi
.IP \fBgcc.info-14\fR
The 15th file of the manual for
.BR gcc .
It contains the following sections:
.sp \n(pDu
.nf
	Controlling the Compilation Driver, `gcc'
	Run-time Target Specification
	Storage Layout
	Layout of Source Language Data Types
	Register Usage
		Basic Characteristics of Registers
		Order of Allocation of Registers
		How Values Fit in Registers
		Handling Leaf Functions
		Registers That Form a Stack
		Obsolete Macros for Controlling Register Usage
.fi
.IP \fBgcc.info-15\fR
The 16th file of the manual for
.BR gcc .
It contains the following sections:
.sp \n(pDu
.nf
	Register Classes
	Describing Stack Layout and Calling Conventions
		Basic Stack Layout
		Registers That Address the Stack Frame
		Eliminating Frame Pointer and Arg Pointer
		Passing Function Arguments on the Stack
		Passing Arguments in Registers
		How Scalar Function Values Are Returned
		How Large Values Are Returned
		Caller-Saves Register Allocation
.fi
.IP \fBgcc.info-16\fR
The 17th file of the manual for
.BR gcc .
It contains the following sections:
.sp \n(pDu
.nf
		Function Entry and Exit
		Generating Code for Profiling
	Implementing the Varargs Macros
	Trampolines for Nested Functions
	Implicit Calls to Library Routines
	Addressing Modes
	Condition Code Status
.fi
.IP \fBgcc.info-17\fR
The 18th file of the manual for
.BR gcc .
It contains the following sections:
.sp \n(pDu
.nf
	Describing Relative Costs of Operations
	Dividing the Output into Sections (Texts, Data, ...)
	Position Independent Code
	Defining the Output Assembler Language
		The Overall Framework of an Assembler File
		Output of Data
		Output of Uninitialized Variables
		Output and Generation of Labels
		How Initialization Functions Are Handled
		Macros Controlling Initialization Routines
.fi
.IP \fBgcc.info-18\fR
The 19th file of the manual for
.BR gcc .
It contains the following sections:
.sp \n(pDu
.nf
		Output of Assembler Instructions
		Output of Dispatch Tables
		Assembler Commands for Alignment
	Controlling Debugging Information Format
		Macros Affecting All Debugging Formats
		Specific Options for DBX Output
		Open-Ended Hooks for DBX Format
		File Names in DBX Format
		Macros for SDB and DWARF Output
	Cross Compilation and Floating Point Format
	Miscellaneous Parameters
The Configuration File
.fi
.IP \fBgcc.info-19\fR
The 20th, and last, file of the manual for
.BR gcc .
It contains the index to the entire
.B gcc
manual.

/v/fwb/doc/mwc/lx/ANSI/raise
/v/fwb/doc/mwc/lx/ANSI/rand
/v/fwb/doc/mwc/lx/TOS/random
/v/fwb/doc/mwc/lx/MULTI/randomaccess
/v/fwb/doc/mwc/lx/ANSI/rangeerror
/v/fwb/doc/mwc/lx/MULTI/ranlib
/v/fwb/doc/mwc/lx/TOS/rdy
/v/fwb/doc/mwc/lx/TOS/rdy.a
/v/fwb/doc/mwc/lx/MULTI/read
/v/fwb/doc/mwc/lx/MULTI/readonlymemory
/v/fwb/doc/mwc/lx/ANSI/realloc
/v/fwb/doc/mwc/lx/MULTI/record
/v/fwb/doc/mwc/lx/MULTI/register
/v/fwb/doc/mwc/lx/ANSI/register
/v/fwb/doc/mwc/lx/ANSI/remove
/v/fwb/doc/mwc/lx/ANSI/rename
/v/fwb/doc/mwc/lx/TOS/rescomp
/v/fwb/doc/mwc/lx/TOS/resdecom
/v/fwb/doc/mwc/lx/TOS/resource
/v/fwb/doc/mwc/lx/ANSI/return
/v/fwb/doc/mwc/lx/ANSI/rewind
/v/fwb/doc/mwc/lx/MULTI/rindex
/v/fwb/doc/mwc/lx/MULTI/rm
/v/fwb/doc/mwc/lx/MULTI/rmdir
/v/fwb/doc/mwc/lx/TOS/rsconf
/v/fwb/doc/mwc/lx/TOS/rsconf_
/v/fwb/doc/mwc/lx/MULTI/runtimestartup
/v/fwb/doc/mwc/lx/ANSI/rvalue
/v/fwb/doc/mwc/lx/TOS/rwabs

.NH "The Lexicon" 1
.PP
The following pages contain Lexicon articles that have
changed substantially or been added since the last
printing of the \*(CO manual.
.PP
Please note that the on-line manual pages supplied with \*(CO may
include last-minute changes and corrections that are not reflected in
the printed documentation.
If there is a discrepancy between the on-line manual page and the printed
documentation, you should assume that the on-line manual page is correct.

.ds TL "GNU Tools for COHERENT"
.ds TI ""
.NH "Introduction"
.PP
GNU Tools is a collection of utilities from the Free Software Foundation.
These tools are commonly used on various implementations of \*(UN and
other \*(UN-like operating systems.
.PP
GNU Tools can be compiled and run on any system that runs \*(CO
(that is, \*(CO version 4.2 or greater).
Your system must have at least three megabytes of RAM to run most
of these tools; four megabytes is recommended.
.PP
Mark Williams Company does not offer technical support for GNU Tools, other
than to assist you in installing it.
We will post on the MWC BBS notices of bugs and fixes as we are informed of them.
We would appreciate being informed of any bugs that you
have discovered and any fixes you have implemented.
.PP
Finally, if you are interested in further support of the tools included with
GNU Tools, you should subscribe the GNU news groups on the Internet, or
you can post to newsgroup
.BR comp.os.coherent .
.SH "Installation"
.PP
Before you begin, please note the following:
.PP
.B
If you are installing both GNU Tools and GNU C onto your system, be sure
to install GNU C \fIfirst\^\fP!
.R
If you fail to do so, problems may arise.
.PP
The rest of these notes assume that you either are installing only the GNU
Tools onto your system, or that you have already installed GNU C release 2.5.6
onto your system.
.PP
To install GNU Tools onto your \*(CO system, use the \*(CO
.B install
command.
You must have roughly 16,000 blocks (eight megabytes) free on
the file system that holds directory
.BR /u1 .
That usually is your root file system, but you can also mount a separate file
system onto that directory should you wish.
If you are going to make heavy use of GNU tools and sources, you may wish
to consider doing so.
.PP
To install the package from 5.25-inch floppy disks in floppy-disk drive 0
(i.e., drive A), use the following command:
.DM
	/etc/install \-c GNUtools /dev/fha0 3
.DE
To install the package from 3.5-inch floppy disks in floppy-disk drive 0,
use the following command:
.DM
	/etc/install \-c GNUtools /dev/fva0 2
.DE
.B install
prompts you to insert each floppy disk in turn into drive A.
It then copies each disk's contents onto your hard disk.
.PP
Finally, you should modify your file
.B /etc/profile
to change the setting of the environmental variable
.BR PATH .
If you want GNU tools to take precedence over the \*(CO commands, place
.B /u1/gnu/bin
at the
.I beginning
of your
.BR PATH ;
otherwise, place it at the end.
.SH Documentation
.PP
To see the suite of commands that are included with this package,
simply type the command:
.DM
	lc /u1/gnu/bin
.DE
This package includes standard manual pages for many of these commands.
It also includes the GNU command
.BR info .
This command is an interactive, Hypertext-like reader
for GNU documentation.
To learn how to use
.BR info ,
simply type:
.DM
	info info
.DE
This tells
.B info
to present a tutorial about itself.
It would be well worth your while to take a few minutes to learn
how to use this command:
once you have learned how to use
.BR info ,
you can easily learn how to use all of the other GNU tools.
.PP
Please note that before you can use
.BR info ,
you must have followed the directions on renaming the file
.BR dir.new ,
as presented during installation.
.SH Conclusion
.PP
Mark Williams Company has ported these tools to \*(CO.
Please note that these tools have been tested under \*(CO;
however, Mark Williams Company makes no guarantee that they are free
of bugs.
\fICaveat utilitor.\fR
.PP
We hope that you enjoy working with these tools.
If you have any comments, fixes, or requests, please mail or E-mail them to
.BR support@mwc.com .

.\" beginning is by fwb
.ds TL "TCP/IP Basics"
.ds TI COHULIP
.NH "TCP/IP History and Design"
.PP
Networking is one of the most exciting developments of computing in the 1990s.
Thanks to networking, each user on a personal computer can communicate
easily with other computers \(em either locally
(that is, computers in the same room or the same building)
or remotely
(that is, computers in other buildings, other cities, or other countries).
Networking places a world of information at your fingertips.
.PP
All of this power comes at a price, however:
networking is a complicated (and complex) topic.
It is possible to use a network without much study; but to set up networking
on your \*(CO machine and use it to its best advantage,
you must make the effort to learn how networking works.
.PP
This chapter introduces the basics of networking.
It is intended to give you a frame of reference, so that when you work with
.BR cohulip ,
you can use it to best advantage; and so that when a problem arises,
you will have a fighting chance of solving it yourself.
We hope that this chapter will cast some light on this subject for you,
and help you get the most out of
.BR cohulip .
.PP
.II "Hedrick, Charles L."
Please note that this chapter is based on the document
.I "Introduction to the Internet Protocols"
written by Charles L. Hedrick of Rutgers University.
The portions of that chapter taken from
his document are copyright \(co 1988 by Charles Hedrick,
and are used by permission.
.SH "What Is A Network?"
.PP
A major problem with discussing networking is that the term
.I network
has three different meanings:
.IP \fIHardware\fR 0.75i
The equipment that physically connects computers.
These can include Ethernet cards; serial cables (that is, a cable
strung directly from one computer's serial port to another's); and modems.
.IP \fIProtocols\fR
The rules by which computers communicate with each other.
These rules can either govern the behavior of hardware;
how systems package and unpackage data;
and how systems locate each other (also called \fIaddressing\fR).
.IP \fIServices\fR
The programs that actually perform networking tasks.
.PP
It is important to distinguish among these definitions of
.I network
when you think about networking.
.Sh "An Example of a Network"
.PP
For years, you have use a networked machine to exchange information
with persons at remote sites:
that is, you have used the telephone.
Consider what happens when make a telephone call:
.IP \(bu 0.3i
You initialize your system to transmit your data \(em i.e.,
you pick up the telephone receiver.
.IP \(bu
You wait for the network to notify you that it is ready to handle your
transmission \(em i.e., you listen for the dial tone.
.IP \(bu
You enter the seven-digit ``address'' of the remote system with which
you wish to exchange data \(em i.e., you dial the phone.
.IP \(bu
If you only know the other system's name, you must
translate that name into the remote system's address \(em that is, you must
look up your friend's name in your phone book and find his phone number.
.IP \(bu
If you do not have the number listed in your phone book, you must contact
a special remote system that will translate the name into the address \(em
that is, you telephone Directory Assistance.
.IP \(bu
The network interprets the seven-digit address and notifies the remote
system that a message is coming \(em i.e., it rings the other person's phone.
.IP \(bu
If the remote system is engaged with another site, the network notifies
you and you break off your transmission \(em i.e., you hear a busy signal
and hang up the phone.
.IP \(bu
Otherwise, the remote system engages the network to receive your
transmission \(em i.e., the person you are calling picks up the phone.
.IP \(bu
You and the remote system ``handshake'' to begin exchanging data \(em i.e.,
you and the person you are calling say ``Hello''.
.IP \(bu
You and the remote system identify each other \(em that is, the person you're
calling recognizes your voice, or you say who you are.
.IP \(bu
If the remote system does not recognize you
or it does not wish to receive your transmission
(perhaps you are selling aluminum siding or software),
it breaks off contact \(em i.e., the other person hangs up the phone.
.IP \(bu
If the conversation gets this far, data transmission commences \(em that is,
you begin to converse with other person.
.IP \(bu
When data transmission has ended, you disengage from the remote system \(em
i.e., when you're finished conversing, you say ``Bye''.
.IP \(bu
Finally, you disengage your system from the network \(em i.e., you hang up
the phone.
.PP
It may sound odd, but when two computers exchange data over a network,
they go through many of the same steps as you did when you made your
telephone call:
.IP \(bu 0.3i
Engage the physical device (either the Ethernet card or the modem).
.IP \(bu
Address the remote system.
.I Addressing
usually involved translating a name that you understand (e.g.,
.BR raven.alaska.edu )
into a number that the computer can understand (e.g.,
.BR 137.229.10.39 ).
.II "name server"
.II "domain-name server"
Your computer may be able to look up the number in one of its own files,
or it may be have to call a special remote system (called the
.IR "domain-name server" ),
which is the computer equivalent of Directory Assistance.
.IP \(bu
When the remote system is engaged, your system and the remote system
identify each other.
.IP \(bu
Data are exchanged.
.IP \(bu
When transmission concludes, the systems disengage.
.IP \(bu
Your system then either dials another system or disengaged from the network.
.PP
As with a computer network, you telephone conversation also involves
hardware, protcols, and services.
.IP \(bu 0.3i
The hardware is represented by the telephone itself and the switching
system that connected your two systems.
You need to know how to dial your telephone, but you do not need to worry
about how the switching system works; in the same way, you need to know
how to manipulate your modem or Ethernet card, but you need not worry about
all of the details of the intervening software.
.IP \(bu
Protocols affect many aspects of your conversion.
Protocol determines that a telephone's ``address'' is a seven-digit number.
Protocol also determines that the address is written with a hyphen between
the third and fourth digits.
Protocol also determines what you say to introduce yourself to a remote
system, how you introduce yourself, and what you say to disengage from the
remote system.
.IP \(bu
In this analogy, you take the place of the system, as you and
your knowledge control the telephone and the conversation.
However, for a computer to carry on a networking conversation, a program
must be written for each task that you perform \(em from looking up an
address, to dialing the telephone, to to conversing with the remote system.
.PP
The analogy between a telephone and computer network is not exact.
For example, your system can ``converse'' with multiple remote systems
simultaneously.
However, as you read this chapter,
you should remember that you have been using a network all of your life:
.I
Networking software simply instructs a computer to perform the same tasks
that you perform when you make a telephone call.
.R
In brief, if you can use a telephone, you should be able to grasp the
principles of networking; and if you can grasp those basics,
you should be able to grasp what
.B cohulip
does, and why.
.Sh "Protocols, the Internet, and TCP/IP"
.PP
Much has been written about the Internet and TCP/IP.
However,
what is not much appreciated is the fact that underlying these creations
are \fIprotocols\fR \(em documents, really \(em that describe how the Internet
and its services work.
These protocols are the result of years of work, much of it sponsored by
the federal government.
.PP
.II ARPA
.II "Advanced Research Projects Agency"
.II DARPA
.II "Defense Advanced Research Projects Agency"
.II "U.S. Department of Defense"
Research in networking was begun in the 1960s by the U.S. Department of
Defense's Advanced Research Projects Agency (ARPA) \(em later renamed
the Defense Advanced Research Projects Agency (DARPA).
The first network became operational in December 1969; it had four systems.
.II ARPAnet
This network, after development and expansion, became known as
.IR ARPAnet .
.PP
ARPA wrote, or commissioned, a set of protocols that describe how
ARPAnet works.
The most accurate name for the set of protocols we are describing is the
.IR "Internet protocol suite" ;
however, they now are almost universally called
.IR TCP/IP ,
after two of the most commonly used of the protocols:
.I TCP
(the ``Transmission Control Protocol''), and
.I IP
(the ``Internet Protocol'').
.PP
After it shook the kinks out of ARPAnet, the Defense Department created
other networks:
MILNET, to connect military installations in the United States; and
MINET, to connect installations in Europe.
.II NSF
.II "National Science Foundation"
.II CSNET
In 1980, the National Science Foundation (NSF) used the TCP/IP protocols
to create its Computer Science Network (CSNET), to link universities in the
United States; and later created NSFNET to link supercomputers.
Other networks include regional networks such as NYsernet,
local networks at a number of university and research institutions,
and a number of other military networks.
All of these networks, in turn, are connected to each other.
Thus, users can send messages from any of them to any other,
except where there are security or other policy restrictions on access.
.II Internet
Networks proliferate continually; and
this profusion of interlinked networks has grown into what we call the
.IR Internet .
.PP
.\" begin text by Charles Hedrick
.II "Defense Data Network"
.II "DDN^definition"
The set of Internet networks that are managed by the Department of Defense
is called the Defense Data Network (DDN).
This includes some research-oriented networks,
such as the ARPAnet, as well as more strictly military ones.
(Because much of the funding for Internet protocol developments is done 
via the DDN organization, the terms ``Internet'' and ``DDN''
can sometimes seem equivalent.)
.PP
The rest of this chapter discusses the TCP/IP protocols.
Other networking protocols have been written by private industry;
examples include AppleTalk and Novell networks.
However, TCP/IP is the ``native language'' of the Internet;
and these are the protocols that
.B cohulip
implements.
What follows
is not intended to be a complete description of these protocols;
but it can give you a reasonable idea of what they can do.
.PP
If you need to know the details of any TCP/IP protocols,
you will want to read the protocol document yourself.
Throughout this chapter, you will find references to the standards, in the
form of ``RFC'' or ``IEN'' numbers.
These are document numbers.
The final section of this chapter says how you can get copies
of these standards.
.PP
One last note:
from time to time, a protocol and a service will have the same name.
For example, the Internet's file-transfer protocol (FTP) describes how
to transfer files between machines; and the client program named
.B ftp
implements the FTP to transfer files.
We distinguish protocols from programs by printing the protocol's
acronym in capital letters and Roman type (e.g., ``FTP'') and printing
the program's name in lower-case letters and bold type (e.g.,
.BR ftp ).
.SH "Basic TCP/IP Protocols"
.PP
.II "Internet^protocol suite"
As mentioned above, what we call
.I TCP/IP
actually is a family of protocols.
A few provide low-level functions that are needed by many applications.
These include IP, TCP, and UDP.
(These will be described in a bit more detail later.)
Others are protocols for doing specific tasks, e.g., transferring files
between computers, sending mail, or finding out who is logged onto
another computer.
.PP
Initially, TCP/IP was used mostly between minicomputers or mainframes.
These machines had their own disks, and generally were self-contained.
Thus, the most important traditional TCP/IP services are
file transfer (FTP), remote login (TELNET), and computer mail (SMTP).
.Sh "FTP: File Transfer Protocol"
.PP
.II "FTP^definition"
.II "file transfer protocol"
.II "protocol^file transfer"
The file-transfer protocol (FTP) allows a user on any computer to exchange
files with another computer.
He must log into the remote computer by specifying
a user name and password.
FTP provides for transferring files between machines that have
different character sets, end-of-line conventions, etc.
.PP
.II "network file system"
.II NFS
.II NetBIOS
This is not quite the same thing as more recent network-file system (NFS)
or NetBIOS protocols.
Rather, you must invoke FTP any time you want to access a file
from another system; copy the file to your own system;
then work with your local copy.
.II "RFC 959"
See RFC 959 for specifications for FTP.
.Sh "TELNET: Remote Login"
.PP
.II "TELNET^definition"
.II "network terminal protocol"
.II "protocol^network terminal"
The network terminal protocol (TELNET) lets a user log onto another 
computer on the network.
You start a remote session by specifying a computer to connect to.
From that time until you finish the session, anything you type
is sent to the other computer.
.PP
Note that you are really still talking to your own computer;
but the
.B telnet
program effectively makes your computer invisible while it is running.
Every character you type is sent directly to the other system.
Generally, the connection to the remote computer behaves much like a
dialup connection;
that is, the remote system asks you to log in and give a password,
in whatever manner it would normally ask a user who had just dialed it up.
When you log off of the other computer,
.B telnet
exits, and once again what you type goes to your local computer.
.PP
.II "RFC 854"
.II "RFC 855"
.II Telenet
See RFCs 854 and 855 for specifications for TELNET.
By the way, do not confuse TELNET protocol with Telenet,
a vendor of commercial network services.
.Sh "SMTP: Simple Mail Transfer Protocol"
.PP
.II "SMTP^definition"
.II "simple mail transfer protocol"
.II "protocol^simple mail transfer"
.II mail
SMTP allows you to send messages to users on other computers.
Originally, people tended to use only one or two specific computers.
They would maintain ``mail files'' on those machines.
The computer mail system is simply a way for you to add a
message to another user's mail file.
.II "RFC 821"
.II "RFC 822"
.\" .II "RFC 937"
See RFCs 821 and 822 for specifications for computer mail.
.Sh "Client/Server Architecture"
.PP
The above services should be present in any implementation of TCP/IP,
and they still play a very important role in TCP/IP-based networks.
However, the way in which networks are used has been changing.
The older model of a number of large, self-sufficient computers is
beginning to change.
Now many installations have several kinds of computers,
including microcomputers, workstations, minicomputers, and mainframes.
A computer now is likely to be configured to perform a specialized task.
Although people are still likely to work with one specific computer,
that computer will call on other systems on the network for specialized
services.
.PP
.II "client/server model^definition"
.II server^definition
.II client^definition
This has led to the server/client model of network services.
A
.I server
is the program that provides a specific service to the rest of the network.
A
.I client
is the program that requests the service.
(Note that the server and client need not be on different computers.
They could be different programs running on the same computer;
for example, in \*(CO's implementation of the X Window System, the X server
and its clients both reside on the same machine.)
.PP
The following describes
some of the servers typically present in a modern computer setup.
Note that these computer services can all be provided
within the framework of TCP/IP:
.IP "\fINFS and NetBIOS\fR"
These permit a system to access files on another computer
in a fashion that is more closely integrated than FTP permits.
A network-file system provides the illusion that disks or other
devices on one system are directly connected to another.
You do not have to use a special network utility like FTP
to access a file on another system:
your computer simply thinks it has some extra disk drives.
These extra ``virtual'' drives refer to the other system's disks.
.IP
This capability is useful for several different purposes.
It lets you place large disks on a few computers,
but let all systems on the network access them.
Aside from the obvious economic benefits,
it makes system maintenance and backup easier, because you
do not need to worry about updating and backing up copies on many
different machines.
A number of vendors now offer high-performance diskless computers.
These computers have no disk drives at all.
.II "file server"
They depend entirely upon disks attached to a common ``file server.''
.IP
.II "RFC 1001"
.II "RFC 1002"
.II "NetBIOS^definition"
See RFCs 1001 and 1002 for a description of PC-oriented NetBIOS over TCP.
.II "NFS^definition"
In the workstation and minicomputer area, Sun's
Network File System (NFS) is more likely to be used.
Protocol specifications for it are available from Sun Microsystems.
.IP "\fIRemote Printing\fR"
This allows you to access printers on other
computers as if they were directly attached to yours.
.II "remote lineprinter protocol"
.II "protocol^remote lineprinter"
The most commonly used protocol is the remote line-printer protocol from
Berkeley \*(UN.
Unfortunately, there is no protocol document for this.
However, the C code is widely available, so implementations are common.
.IP "\fIRemote Execution\fR"
.II "remote execution"
This allows you to request that a particular
program be run on a different computer.
This is useful when you can
do most of your work on a small computer, but a few tasks require the
resources of a larger system.
.IP
There are a number of different kinds of remote execution.
Some operate on a command-by-command basis:
that is, you request that a specific command or set of commands
should run on some specific computer.
(More sophisticated versions will choose a system that happens to be free.)
.II "remote procedure calls"
However, there are also ``remote procedure call'' systems that allow a
program to call a subroutine that will run on another computer.
There are many protocols of this sort.
.II rsh
.II rexec
Berkeley \*(UN contains two servers to execute commands remotely:
.B rsh
and
.BR rexec .
.IP "\fIName Servers\fR"
.II "name server"
In large installations, there are a number of different collections
of names that have to be managed.
This includes users and their passwords, names and network addresses for
computers, and accounts.
It becomes very tedious to keep these data up to date on all of the computers.
Thus, the data bases are kept on a small number of systems.
Other systems access the data over the network.
.IP
.II "RFC 822"
.II "RFC 823"
.II "name-server protocol"
.II "protocol^name server"
RFC 822 and 823 describe the name-server protocol used to
keep track of host names and Internet addresses on the Internet.
This is now a required part of any TCP/IP implementation.
.II "IEN 116"
IEN 116
describes an older name-server protocol that is used by a few
terminal servers and other products to look up host names.
.IP
.II "Yellow Pages"
Sun's Yellow Pages system is designed as a general mechanism to handle user
names, file-sharing groups,
and other data bases commonly used by \*(UN systems.
It is widely available commercially.
Its protocol definition is available from Sun.
.IP "\fITerminal Servers\fR"
.II "terminal server"
Many installations no longer connect terminals directly to computers.
Instead, they connect them to terminal servers.
A terminal server is simply a small computer that knows only the
TELNET protocol (or some other protocol) to do remote login,
plus name service and a few other protocols.
.IP
A user who is connected to one of these simply types the name of a computer,
the server connects him to it.
Most servers permit you to have more than one connection active at a time;
they can switch between connections rapidly, and notify a user
when output is waiting on another connection.
.IP "\fINetwork-Oriented Windowing Systems\fR"
Until recently, high-performance graphics programs had to execute
on a computer that had a bit-mapped graphics screen directly attached to it.
Network windowing systems allow a program to use a display
on a different computer.
Full-scale network windowing systems provide an interface that lets
you distribute jobs to the systems that are best suited to handle them,
but still give you a single, graphically based user interface.
.IP
.II "X Window System"
The most widely-implemented windowing system is the X Window System.
.II "Project Athena"
.II "Massachusetts Institute of Technology"
.II MIT
A protocol description is available from the Massachusetts Institute of
Technology's Project Athena.
A reference implementation is publicly available from MIT.
.II NeWS
A number of vendors are also supporting NeWS,
a windowing system defined by Sun.
Both of these systems are designed to use TCP/IP.
.PP
Note that some of the protocols described above were designed by Berkeley, 
Sun, or other organizations.
Thus, they are not officially part of the Internet protocol suite.
However, they are implemented using TCP/IP, just as normal TCP/IP
application protocols are.
Because the protocol definitions are not considered proprietary,
and because commercially supported implementations are widely available,
it is reasonable to think of these protocols as being effectively part
of the Internet suite.
.PP
The above list gives services most commonly available through TCP/IP.
Most other protocols are specialized facilities for
retrieving information of various kinds, such as who is logged in on a
given system, the time of day, etc.
.II "RFC 1011"
If you need a facility that is not listed here, we encourage you
to look through the current edition of Internet Protocols
(currently RFC 1011), which lists all of the available protocols, and also
to look at some of the major TCP/IP implementations to see what various
vendors have added.
.SH "Structure of the TCP/IP Protocols"
.PP
TCP/IP is a layered set of protocols.
To understand what this means, it is useful to look at an example.
A typical situation is sending mail.
.IP \(bu 0.3i
First, there is a protocol for mail.
This defines a set of commands which one machine sends to another, e.g.,
commands to specify who the sender of the message is,
whom it is being sent to, and then the text of the message.
However, this protocol assumes that there is a way to
communicate reliably between the two computers \(em
like other application protocols,
it simply defines a set of commands and messages to be sent.
.IP \(bu
Mail hands its output to TCP.
TCP is responsible for making sure that data get through to the other end.
It keeps track of what data are sent, and retransmits anything
that did not get through.
If a message is too large to send in one burst, TCP breaks it into
pieces that it dispatches separately.
It also listens for confirming messages from the remote machine, to make
sure that all arrive data arrived correctly.
.IP
Because these functions are needed for
many applications, they are put together into a separate protocol, rather
than being part of the specifications for sending mail.
You can think of
TCP as forming a library of routines that applications can use when they
need reliable network communications with another computer.
.IP \(bu
TCP, in turn, calls on the services of IP.
Although the services that TCP supplies
are needed by many applications, there are still some kinds of
applications that don't need them.
However there are some services that every application needs.
So these services are put together into IP.
As with TCP, you can think of IP as a library of routines that TCP calls on,
but which is also available to applications that don't use TCP.
.IP \(bu
Finally, IP passes the data to the device that physically dispatches the
data to the remote system \(em either an Ethernet card or a serial port.
.PP
This strategy of building several levels of protocol is called
.IR layering .
We think of the applications programs such as mail, TCP, and IP, as each being
separate ``layers,'' each of which calls on the services of the layer below it.
.PP
Generally, TCP/IP applications use four layers:
.IP \(bu 0.3i
An application protocol such as
.BR mail .
.IP \(bu
A protocol, such as TCP, which packages data and monitors their transmission
to the remote site.
.IP \(bu
IP, which provides the basic service of getting datagrams to their destination.
.IP \(bu
The protocols needed to manage a specific physical medium, such as 
Ethernet or a serial line.
.PP
The system that receives the message reverses the process:
.IP \(bu 0.3i
The physical device receives the data.
.IP \(bu
The data are handed to IP, which confirms that they have arrived at the
correct destination.
.IP \(bu
IP hands the data to TCP, which confirms that all data have arrived,
send messages back to the sender to confirm the arrival of the data,
and assembles the datagrams back into one message.
.IP \(bu
TCP hands its reassembled message to the mail application, which handles
it \(em either pops it into a user's mailbox or forwards it to another
system, whichever is required.
.PP
.II "networking^ARPAnet model"
This four-layer model of networking is called the
.IR "ARPAnet model" ,
as it was developed by ARPA.
The terms ``TCP/IP model'' and ``ARPAnet model'' are used interchangeably,
although, as we noted above, TCP and IP are only two of the many
ARPAnet protocols.
.II ISO
.II "International Standards Organization"
.II OSI
.II "networking^OSI model"
.II "networking^ARPAnet model"
.II "Open Systems Interconnect model"
The International Standards Organization (ISO) has published a seven-layer
model of networking, called the Open Systems Interconnect (OSI) model.
.II "layer cake"
.II "cake, layer"
These models are sometimes called ``layer cakes,'' because their layers
are stacked upon each other.
The following diagram compares the OSI and ARPAnet models:
.ie p .PH 1 1 \\*(XD/osi.eps
.el \{\
.DM
   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
   |          Application          |                               |
   |                               |                               |
   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+                               |
   |          Presentation         |          Application          |
   |                               |          (e.g., ftp)          |
   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+                               |
   |             Session           |-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
   |                               |                               |
   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+          Host-to-Host         |
   |            Transport          |             (TCP)             |
   |                               |                               |
   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
   |             Network           |          Internet (IP)        |
   |                               |-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+                               |
   |            Data Link          |                               |
   |                               |          Network Access       |
   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+         (Ethernet, SLIP)      |
   |             Physical          |                               |
   |                               |                               |
   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
               OSI Model                      ARPAnet Model
.DE
\}
.PP
.II "TCP/IP stack"
The literature and advertisements speak of a ``TCP/IP stack.''
This term originates in the stacked design of the ARPAnet and OSI models.
.PP
Each ``layer'' in the TCP/IP ``layer cake'' usually is implemented as a
separate program.
.BR cohulip ,
however, combines the first three layers into one program, called
.BR net .
.PP
Although the OSI model is presented throughout the literature of networking,
we will not discuss it further here, as it does not directly apply to TCP/IP.
The above diagram lets you compare OSI's seven-layer stack with
ARPAnet's four layers.
.Sh "TCP and IP Tasks"
.PP
.II "catenet model"
.II "networking^catenet model"
TCP/IP is based on the ``catenet model.''
This model assumes that there are a large number of independent
networks connected by gateways.
The user should be able to access computers or other resources
on any of these networks.
.PP
Datagrams often pass through a dozen different networks before
getting to their final destination.
The routing needed to accomplish this should be completely
invisible to the user.
.II "Internet address^definition"
As far as the user is concerned,
all he needs to know in order to access another system is an
.IR "Internet address" .
This is a address that looks like
.BR 128.6.4.194 .
It is actually a 32-bit number.
However, it is normally written as four decimal numbers,
each representing eight bits of the address.
.II octet
(We will use the usual term ``byte'' for such eight-bit chunks.
Please note that the Internet documentation calls them ``octets,''
because TCP/IP is supported by some computers that have byte
sizes other than eight bits.)
.PP
Generally, the structure of the address gives you
some information about how to get to the system.
For example, 128.6 is a network number assigned
by a central authority to Rutgers University.
Rutgers uses the next byte to indicate which of the campus Ethernets is
involved.
128.6.4 happens to be an Ethernet used by the Computer Science department.
The last byte allows for up to 254 systems on each Ethernet.
(It is 254 instead of 256 because values 0 and 255 are not allowed,
for reasons that will be discussed later.)
Note that 128.6.4.194 and 128.6.5.194 would be different 
systems.
The structure of an Internet address is described in a bit more detail later.
.PP
Of course, people normally refer to systems by name,
rather than by Internet address.
When we specify a name, the network software looks it up in a data base,
and comes up with the corresponding Internet address.
Most of the network software deals strictly in terms of the address.
.II "RFC 882"
(RFC 882 describes the name-server technology used to handle this lookup.)
.PP
TCP/IP is built on
.I connectionless
technology.
Information is transferred as a sequence of datagrams.
.II datagram^definition
A
.I datagram
is a collection of data that is sent as a single message.
Each of these datagrams is sent through the network individually.
There are provisions to open connections
(i.e., to start a conversation that will continue for some time).
However, at some level, information from those connections is
broken up into datagrams, and each of those datagrams are treated
by the network as completely separate from all others.
.PP
For example, suppose you want to transfer a 15,000-byte file.
Most networks can't handle a 15,000-byte datagram.
So the protocols will break this up into something like 30 500-byte datagrams.
Each of these datagrams will be sent to the other end.
At that point, they will be reassembled into the 15000-byte file.
However, while those datagrams are in transit, the network doesn't know
that there is any connection between them.
It is perfectly possible that datagram 14 will
arrive before datagram 13.
It is also possible that somewhere in
the network, an error will occur and some datagram won't get through at all.
In that case, that datagram has to be sent again.
.PP
.II packet^definition
Note by the way that the terms
.I datagram
and
.I packet
often are used synonymously; however,
datagram is the correct word to use when discussing TCP/IP.
A datagram is a unit of data, which is what the protocols deal with.
A packet is a physical thing that appears on an Ethernet or some wire.
In most cases, a packet simply contains a datagram,
so there is very little practical difference between them.
However, they can differ.
When TCP/IP is used on top of X.25,
the X.25 interface breaks the datagrams up into 128-byte packets.
This is invisible to IP, because the packets are reassembled
into a single datagram at the other end before being processed by TCP/IP.
So in this case, one IP datagram would be carried by several packets.
However, most media take advantage of the fact that it is more efficient to
to send one datagram per packet, so the distinction tends to vanish.
.PP
Two separate protocols are involved in handling TCP/IP datagrams.
.II TCP^definition"
TCP is responsible for breaking up the
message into datagrams, reassembling them at the other end,
resending anything that gets lost, and putting things back in the right order.
.II IP^definition
IP is responsible for routing individual datagrams \(em that is, finding the
address of the remote system, and ensuring that the datagrams are dispatched
to it.
.PP
It may seem like TCP is doing all the work.
In a small network, this is true.
However, in the Internet, simply getting a datagram to its destination
can be a complex job.
A connection may require the datagram to go through several
networks at your local site, a fiber-optic line to the major center,
a couple of Ethernets there, then a series of 56-kilobaud telephone lines
to another NSFnet site, and more Ethernets elsewhere.
Keeping track of the routes to all of the destinations and handling
incompatibilities among different transport media turns out to be
a complex job.
.PP
The interface between TCP and IP is fairly simple:
TCP simply hands IP a datagram with a destination, and IP delivers it.
IP doesn't know, or care,
how this datagram relates to any datagram that precedes it or follows it.
.PP
It may have occurred to you that something is missing here.
We have talked about Internet addresses, but not about how you keep track of
multiple connections to a given system.
Clearly it isn't enough to get a datagram to the right destination.
TCP has to know which connection this datagram is part of.
.II demultiplexing^definition
This task is referred to as
.IR demultiplexing .
In fact, there are several levels of demultiplexing going on in TCP/IP.
.II "TCP/IP^headers
The information needed to do this demultiplexing is contained in a series of
.IR headers .
.PP
A header is simply a few extra bytes tacked onto the
beginning of a datagram by some protocol in order to keep track of it.
It's a lot like putting a letter into an envelope and putting an address
on the outside of the envelope;
except with modern networks it happens several times.
It's like you put the letter into a little envelope, your
secretary puts that into a somewhat bigger envelope, the Post Office
puts that envelope into a still bigger one, and so on.
.PP
The following is an overview of the headers that get stuck on a
message that passes through a typical TCP/IP network.
.Sh "The TCP Level"
.PP
First, we will discuss the TCP level.
We start with a single data stream, say, a file you are trying to send to
some other computer:
.DM
	......................................................
.DE
.PP
TCP breaks it up into manageable chunks.
To do this, TCP must know how large a datagram your network can handle.
Actually, the TCP at each end says how big a datagram it can handle;
then together they pick the smaller size:
.DM
	....  ....  ....  ....  ....  ....  ....  ....
.DE
.PP
TCP puts a header at the front of each datagram.
This header actually contains at least 20 bytes,
but the most important ones are a source and destination
.IR "port number"
and a
.IR "sequence number" .
.PP
.II "TCP^port numbers"
.II "ports"
TCP uses the port numbers to keep track of different conversations.
Suppose three different people are transferring files.
Your TCP might allocate port numbers 1000, 1001, and 1002 to these transfers.
When you are sending a datagram, this becomes the source port number,
because you are the source of the datagram.
Of course, the TCP at the other end has assigned a port number
of its own for the conversation.
Your TCP has to know the port number used by the other end as well.
(It finds out when the connection starts, as we will explain below.)
It puts this in the destination port field.
Of course, if the other end sends a datagram back to you, the source and
destination port numbers will be reversed, because then it will be the
source and you will be the destination.
.PP
.II "TCP^sequence number"
Each datagram has a sequence number.
This is used so that the other end can make sure that it gets the datagrams
in the right order, and that it hasn't missed any.
TCP doesn't number the datagrams, but the bytes.
So if there are 500 bytes of data in each datagram,
the first datagram might be numbered 0, the second 500,
the next 1,000, the next 1,500, etc.
.PP
.II TCP^checksum
TCP attaches a
.IR checksum .
This is a number that is computed by adding up
all the bytes in the datagram (more or less \(em see the TCP specification).
The result is put in the header.
TCP at the other end computes the checksum again.
If they disagree, something bad happened to the datagram in transmission,
and TCP throws it away.
The datagram now appears as follows:
.ie p .PH 1 1 \\*(XD/tcp_header.eps
.el \{\
.DM
   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
   |         Source Port           |        Destination Port       |
   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
   |                      Sequence Number                          |
   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
   |                     Acknowledgment Number                     |
   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
   | Data  |           |U|A|P|R|S|F|                               |
   | Offset| Reserved  |R|C|S|S|Y|I|             Window            |
   |       |           |G|K|H|T|N|N|                               |
   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
   |           Checksum            |          Urgent Pointer       |
   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
   |    your data ...  next 500 bytes                              |
   | ......                                                        |
.DE
\}
.PP
The following describes each byte in the TCP header:
.IP \fB0-1\fR
The number of source port, binary format.
This usually is a number that the sender selects at random,
to ensure that each session moving between the two hosts is uniquely identified.
.IP \fB2-3\fR
Destination port, binary format.
This usually is a ``well-known port.''
The number of this port varies, depending upon the server on the remote
host for which this datagram is meant.
.IP \fB4-7\fR
Sequence number:
the sender's location in his data stream.
.IP \fB8-11\fR
Acknowledgement number:
the sender expects this byte next.
.IS \fB12-13\fR
.II "TCP^urgent field"
Header length, and code bits (bit fields).
The
.I urgent
field lets one end tell the other to skip ahead in its processing
to a particular byte.
This is often useful for handling asynchronous events \(em for example,
when you type a command to abort data transmission.
.IP \fB14-15\fR
.II "TCP^window field"
Window, which controls how much data can be in transit at any one time.
It is not practical to wait for each datagram to be acknowledged before sending 
the next one:
That would slow things down too much.
On the other hand, you can't just keep sending,
or a fast computer might overrun the capacity of a slow one to absorb data.
As the computer receives data, the amount of space left in its window decreases.
When it goes to zero, the sender has to stop.
.IP
As the receiver processes the data, it increases its window,
indicating that it is ready to accept more data.
Often the same datagram can be used
to acknowledge receipt of a set of data and to give permission for
additional new data (by an updated window).
.IP \fB16-17\fR
Checksum.
.IP \fB18-19\fR
Urgent pointer.
It points to out-of-band error messages.
This field usually is not used.
.PP
If we abbreviate the TCP header as
.BR T ,
the whole file now looks like this:
.DM
	T....  T....  T....  T....  T....  T....  T....
.DE
.PP
To make sure the datagram has arrived at its destination,
the recipient must send back an
.IR acknowledgment .
.II "TCP^acknowledgement number"
This is a datagram whose acknowledgment-number field is filled in.
For example, sending a packet with an acknowledgment of ``1500''
indicates that you have received all the data up to byte number 1500.
If the sender doesn't get an acknowledgment within a reasonable
amount of time, it sends the data again.
.PP
For a fuller discussion of the TCP header,
see the chapter \fIAdvanced cohulip\fR, later in this manual.
.Sh "The IP level"
.PP
TCP sends each of these datagrams to IP.
Of course it has to tell IP the Internet address of the computer
at the other end.
Note that this is all IP is concerned about.
It doesn't care about what is in the datagram, or even in the TCP header.
IP's job is simply to find a route for the datagram and get it
to the other end.
.PP
To allow gateways or other intermediate systems to forward the datagram,
IP adds its own header:
.ie p .PH 1 1 \\*(XD/ip_header.eps
.el \{\
.DM
   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
   |Version|  IHL  |Type of Service|            Total Length       |
   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
   |         Identification        |Flags|     Fragment Offset     |
   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
   |  Time to Live |    Protocol   |         Header Checksum       |
   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
   |                        Source Address                         |
   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
   |                     Destination Address                       |
   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
   |  TCP header, then your data ......                            |
   |                                                               |
.DE
\}
.PP
The following describes each byte in the IP header:
.IP "\fB0\fR"
Version and header length (bit fields).
Almost always 0x45.
.IP "\fB1\fR
Service type.
This usually is zero.
.IP "\fB2-3\fR"
Total length.
This varies, depending upon the size of the data field that the two systems
negotiated.
.IP "\fB4-5\fR
Datagram identifier.
.IP "\fB6-7\fR
Flags (bit fields) and fragment offset.
This and the previous field help to manage fragmentation of
datagrams \(em that is, when a site that lies between you and the remote
host must break
a datagram into pieces because the datagram is too large for it to handle.
This is discussed below.
.IP "\fB8\fR"
.II "IP^time to live"
.II "time to live"
Time to live.
This is a number that is decremented whenever the datagram
passes through a system.
When it goes to zero, the datagram is discarded.
This is to prevent a datagram from wandering endlessly through a network
should a loop develop.
This should be impossible, but well-designed networks are built
to cope with ``impossible'' conditions.
.IP "\fB9\fR"
.II "IP^protocol number"
Protocol number.
The protocol number tells IP at the other end to send the datagram to TCP.
Although most IP traffic uses TCP, there are other protocols that can use IP,
so you have to tell IP which protocol to send the datagram to.
Value 0x06 indicates that this is a TCP datagram, 0x01 indicates an
ICMP (\fBping\fR) datagram; and 0x11 indicates a UDP datagram.
.IP "\fB10-11\fR"
.II "IP^checksum"
Header checksum.
This allows IP at the other end to verify
that the header wasn't damaged in transit.
Note that TCP and IP have separate checksums.
IP needs to verify that the header wasn't damaged in transit,
or it could send a message to the wrong place.
It is both more efficient and safer to have TCP compute a separate
checksum for the TCP header and data.
.IP "\fB12-15\fR"
.II "IP^addresses"
The sender's IP address \(em that is,
the IP address of your machine \(em in binary.
This is necessary so the other end knows where the datagram came from.
Note that the binary number is in network byte-order.
.IP "\fB16-19\fR"
The recipient's IP address, in binary.
The destination Internet address is the address of the other machine.
This is necessary so any gateways in the middle know where you
want the datagram to go.
Note that the binary number is in network byte-order.
.PP
If we represent the IP header by an `I', your file now looks like this:
.DM
	IT....  IT....  IT....  IT....  IT....  IT....  IT....
.DE
.PP
Once IP has added its header to a datagram,
it's possible that no more headers are needed.
.\" This paragraph by fwb.
However, your machine uses a physical interface into the network.
.B cohulip
supports two such interfaces:
Ethernet, and the serial-line interface protocol (SLIP).
Each attaches its own header to a datagram.
We will discuss each in turn.
.Sh "The Ethernet Level"
.PP
.II "Ethernet^headers"
Ethernet is a
.IR "broadcast medium" .
That is, it is in effect like an old-fashioned party-line telephone:
when you send a packet out on the Ethernet,
every machine on the network sees the packet.
Something is needed to make sure that the right machine gets the packet.
As you might guess, this involves the Ethernet header.
.PP
Every Ethernet packet has a 14-byte header that includes the
source and destination Ethernet address, and a type code.
(This header is attached to each datagram by the Ethernet card itself:
.B cohulip
contains no code either to read or to write these headers.)
Each Ethernet card pays attention only to packets with its own Ethernet
address in the destination field.
.II "Ethernet^addresses"
Unfortunately, Ethernet has its own addresses, which are different
from those used by IP.
The people who designed Ethernet wanted to make sure that no
two machines would end up with the same Ethernet address.
Furthermore,
they didn't want the user to have to worry about assigning addresses,
so each Ethernet card comes from the factory with its address built in.
To make sure that they would never have to reuse addresses, the
Ethernet designers allocated 48 bits for the Ethernet address.
People who make Ethernet equipment have to register with a central
authority, to make sure that the numbers they assign don't overlap any
other manufacturer.
.PP
It is important to remember that there is no connection between
a machine's Ethernet address and its Internet address.
Each machine must have a table that maps a given Ethernet
address to its corresponding Internet address.
(We will describe how this table is constructed a bit later.)
.PP
.II "Ethernet^type code"
In addition to the addresses, the header contains a type code.
The type code is to allow for several different protocol families
to be used on the same network.
So you can use TCP/IP, DECnet, Xerox NS, etc., all at the same time.
Each of them will put a different value in the type field.
.PP
.II "Ethernet^checksum"
Finally, there is a checksum.
The Ethernet controller computes a checksum of the entire packet.
When the other end receives the packet,
it recomputes the checksum, and throws the packet away if the answer
disagrees with the original.
The checksum is put on the end of the 
packet, not in the header.
.PP
The final result is that your message looks like this:
.ie p .PH 1 1 \\*(XD/ethernet.eps
.el \{\
.DM
   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
   |       Ethernet destination address (first 32 bits)            |
   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
   | Ethernet dest (last 16 bits)  |Ethernet source (first 16 bits)|
   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
   |       Ethernet source address (last 32 bits)                  |
   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
   |        Type code              |
   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
   | IP header, then TCP header, then your data                    |
   |                                                               |
      ...
   |                                                               |
   |   end of your data                                            |
   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
   |                        Ethernet Checksum                      |
   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
.DE
\}
.PP
If we represent the Ethernet header with "E", and the Ethernet checksum 
with "C", your file now looks like this:
.DM
	EIT....C EIT....C EIT....C EIT....C EIT....C
.DE
.PP
When these packets are received by the other end, of course all the
headers are removed:
.IP \(bu 0.3i
The Ethernet interface removes the Ethernet header and the checksum.
It looks at the type code.
Because the type code is the one assigned to IP,
the Ethernet device driver passes the datagram to IP.
.IP \(bu
IP removes the IP header.
It looks at the IP protocol field.
Because the protocol type is TCP, it passes the datagram to TCP.
.IP \(bu
TCP now looks at the sequence number,
and uses it (and other information) to reassemble the file.
.PP
TCP then passes the reassembled file to the application for final disposal.
We will discuss later just
how TCP identifies the application to which it should pass the file,
and how it tells the application that it should process the file.
.\" This section is by fwb
.Sh "The SLIP Level"
.PP
.B cohulip
can use either of two physical channels to move datagrams from your
machine to another.
The first is Ethernet, which was discussed above.
The other is through a serial port, which accesses the other machine
either via a cable (i.e., ``direct link'') or via a modem.
To move datagrams through a serial port,
.B cohulip
uses SLIP (Serial-Line Internet Protocol).
.PP
SLIP is much simpler than Ethernet.
It does not add a header or checksum to a datagram.
.II "SLIP END"
Rather, after it receives the datagram from IP,
it merely writes the magic character SLIP END (0xC0) onto the
end of a datagram, to mark that the datagram has ended, and
sends it to the receiving machine.
.PP
Thus, a SLIP datagram looks like this:
.ie p .PH 1 1 \\*(XD/slip.eps
.el \{\
.DM
   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
   |                        IP header                              |
   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
   |                        TCP header                             |
   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
   |                         your data                        |0xC0|
   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
.DE
\}
.PP
If the character SLIP END is part of the datagram itself, SLIP
prefaces it with the character SLIP ESC (0xDB),
causing the other machine to ignore that SLIP END character.
Likewise, if SLIP ESC is part of the datagram itself, SLIP follows it
with the character 0xDD, which tells SLIP on the
other machine to ignore that SLIP ESC character.
.PP
SLIP does not add its own addressing envelope,
because a serial line can pass only from one machine to another \(em
there's no way a message can go astray.
However, the lack of a checksum can create problems:
if a datagram is garbled in transmission, this fact must be discovered
by the IP or TCP level when it examines its own checksum, which is wasteful.
.PP
.\" resume text by Charled Hedrick
This ends our initial summary of TCP/IP.
There are still some crucial concepts we haven't gotten to,
so we'll now go back and add details in several areas.
.II "RFC 793"
.II "TCP^RFC"
.II "RFC^791"
.II "IP^RFC"
.II "RFC 894"
.II "RFC 826"
.II "Ethernet^RFCs"
For detailed descriptions of the items discussed here see, RFC 793 for TCP,
RFC 791 for IP, and RFCs 894 and 826 for sending IP over Ethernet.
.SH "Well-Known Ports and the Applications Layer"
.PP
So far, we have described how a stream of data is broken up into datagrams,
sent to another computer, and reassembled.
However, something more is needed before we can accomplish anything useful.
There must be a way for a human being to open a connection to a specified
computer, log into it, perform a task on that computer, receive its output,
and view it.
.II "applications protocols"
.II "protocols^applications"
This is done by
.IR "application protocols" .
.PP
The application protocols run ``on top'' of TCP/IP \(em that is,
when they want to send a message, they give the message to TCP.
TCP makes sure it gets delivered to the other end.
Because TCP and IP take care of all the networking details,
the applications protocols can treat a network
connection as if it were a simple byte stream,
like a terminal or telephone line.
.PP
Before going into more details about applications programs, we have to
describe how you find an application.
.PP
Suppose you want to send a file to
a computer whose Internet address is 128.6.4.7.
To start the process, you need more than just the Internet address:
you must connect to the FTP server at the other end.
In general, a networking program is written to perform a specific set of tasks.
Most systems have separate programs to handle file transfers,
remote terminal logins, mail, etc.
(\fBcohulip\fR is an exception to this rule.)
Thus when you connect to 128.6.4.7,
you must specify that you want to talk to the FTP server.
.II "ports^well known"
This is done by having a
.I "well-known port"
for each server.
.PP
Recall that TCP uses port numbers to track each conversation.
User programs normally are are assigned a port more or less at random.
However, the Internet assigns specific port numbers to the programs
that sit waiting for requests.
.PP
For example, if you want to send a file, you will start a program called
.BR ftp .
It opens a connection using some random number, say ``1234,''
for the port on its end.
However, it specifies port number 21 for remote host,
because 21 is the number of the well-known port for the FTP server.
.PP
As you can see, two different programs are involved.
You run
.B ftp
on your side.
This is a program designed to accept commands from your terminal
and pass them on to the other end.
Such a program is called a
.IR client .
The program that you talk to on the other machine accepts commands from
the client, executes them, and returns the output to the client.
Such a program is called a
.IR server .
The method of passing commands to a server via a client is the
.IR "client/server architecture"
about which so much is being written nowadays.
.PP
.\" resuming Charles Hedrick's text
.II "Assigned Numbers"
The official port numbers for each program are given in
.IR "Assigned Numbers" .
.\" fwb
The following gives the well-known ports that are used commonly:
.DS
	\fB7\fR	echo
	\fB9\fR	discard
	\fB20\fR	FTP data
	\fB21\fR	FTP control
	\fB23\fR	TELNET
	\fB25\fR	SMTP (mail)
	\fB79\fR	finger
	\fB87\fR	ttylink in NOS
	\fB540\fR	\*(UU
	\fB1234\fR	the UDP port used by remote
.DE
.\" Hedrick
Therefore, a connection is actually described by a set of four numbers:
the sender's Internet address and TCP port, and the recipient's
Internet address and TCP port.
Each datagram has all four numbers in it:
the Internet addresses are in the IP header,
and the TCP port numbers are in the TCP header.
.PP
No two connections can have the same set of numbers.
It is enough for any one number to be different.
For example, it is perfectly possible for two different users on a machine to
be sending files to the same other machine.
This could result in connections with the following parameters:
.DS
.ta 0.5i 1.5i 3.25i 5.0i
		\fIInternet addresses	TCP ports\fR
	\fIConnection 1\fB	128.6.4.194, 128.6.4.7	1234, 21\fR
	\fIConnection 2\fB	128.6.4.194, 128.6.4.7	1235, 21\fR
.DE
.PP
Because the same machines are involved, the Internet addresses are the same.
Because both sessions are performing file transfers, one end of the connection
involves the well-known port number for FTP.
The only thing that differs is the port number for the program
that the users are running; and that's enough of a difference.
.PP
Generally, at least one end of the connection asks the network software
to assign it a port number that is guaranteed to be unique.
Normally, it's the user's end because the server has to use a well-known number.
.PP
Now that we know how to open connections, let's get back to the
applications programs.
As mentioned earlier, once TCP has opened a
connection, we have something that might as well be a simple wire.
All the hard parts are handled by TCP and IP.
However, we still need to agree on what we send over this connection:
that is, what commands the application understands
and the format in which we send them.
Generally, what is sent is a combination of commands and data.
They use context to differentiate.
For example, the mail protocol works like this:
.IP \(bu 0.3i
Your mail program opens a connection to the mail server at the other end.
.IP \(bu
Your program gives it your machine's name, the sender of the message,
and the recipients you want it sent to.
.IP \(bu
It then sends a command saying that it is starting the message.
.IP \(bu
The other end stops treating what it sees as commands,
and starts accepting the message.
.IP \(bu
Your end then starts sending the text of the message.
.IP \(bu
At the end of the message, a special mark is sent (a dot in the first column).
After that, both ends understand that your program is again sending commands.
.PP
This is the simplest way to do things, and the one that most applications use.
.PP
File transfer is somewhat more complex.
The file-transfer protocol involves two different connections.
It starts out just like mail.
The user's program sends commands like ``log me in as this user,''
``here is my password,'' ``send me the file with this name.''
However, once the command to send data is sent, a second connection
is opened for the data itself.
It would certainly be possible to send the data on the same connection,
as mail does; but file transfers often take a long time.
The designers of the file-transfer protocol wanted to allow the user
to continue issuing commands while the transfer is going on.
For example, the user might make an inquiry, or he might abort the transfer.
Thus, the designers felt it was best to use a separate connection
for the data and leave the original command connection for commands.
(It is also possible to open command connections to two different computers,
and tell them to send a file from one to the other.
In that case, the data couldn't go over the command connection.)
.PP
Remote-terminal connections use yet another mechanism.
For remote logins, there is just one connection.
It normally sends data.
When it is necessary to send a command (e.g.,
to set the terminal type or to change some mode),
a special character is used to indicate that the next character is a command.
If the user happens to type that special character as data,
two of them are sent.
.PP
We are not going to describe the application protocols in detail in this
document.
It's better to read the RFCs yourself.
However, applications use a couple of common conventions
that will be described here.
First, the common network representation:
TCP/IP is intended to be usable on any computer.
Unfortunately, not all computers agree on how data are represented.
There are differences in character codes (ASCII vs. EBCDIC),
in end-of-line conventions (carriage return, line feed,
or a representation using counts), and in whether terminals expect characters
to be sent individually or a line at a time.
.PP
To allow computers of different kinds to communicate,
each application's protocol defines a standard representation.
Note that TCP and IP do not care about the representation.
TCP simply sends bytes.
However, the programs at both ends must agree on how the
bytes are to be interpreted.
The RFC for each application specifies the standard representation for that
application.
.II "net ASCII"
Normally, it is
.IR "net ASCII" .
This uses ASCII characters, with end of line denoted by a
carriage return followed by a line feed.
.PP
.II "standard terminal"
For remote login, there is also a definition of a
.IR "standard terminal" ,
which turns out to be a half-duplex terminal with echoing happening
on the local machine.
Most applications also make provisions for the two computers
to agree on other representations that they may find more convenient.
For example, PDP-10s have 36-bit words.
There is a way that two PDP-10s can agree to send a 36-bit binary file.
Likewise, two systems that prefer full-duplex terminal conversations
can agree on that.
However each application has a standard representation, which every 
machine must support.
.Sh "An Example Application: SMTP"
.PP
.II "simple mail transfer protocol"
.II "SMTP^definition"
To give a bit better idea what is involved in the application
protocols, we're going to show an example of the simple mail transfer
protocol (SMTP), which is the mail protocol.
We assume that a computer called
.B topaz.rutgers.edu
wants to send the following message:
.DM
	Date: Sat, 25 Jun 94 13:26:31 EDT
	From: hedrick@topaz.rutgers.edu
	To: levy@red.rutgers.edu
	Subject: meeting
.sp
	Let's get together Monday at 1pm.
.DE
.PP
.II "RFC 822"
First, note that the format of the message itself is described by an
Internet standard (RFC 822).
The standard specifies the fact that the message must be transmitted
as net ASCII
(i.e., it must be ASCII, with the end of each line of text marked by the
character pair CR/LF).
It also describes the general structure, as a group of header lines,
then a blank line, and then the body of the message.
Finally, it describes the syntax of the header lines in detail.
In general, they consist of a keyword and then a value.
.PP
Note that the addressee is indicated as
.BR levy@red.rutgers.edu .
Initially, addresses were simply ``person at machine.''
.II "mail server"
However, current standards make things more flexible, and
make provision for systems to handle other systems' mail.
This can allow automatic forwarding on behalf of
computers not connected to the Internet.
It can be used to direct mail for a number of systems to one central
mail server.
Indeed, there is no requirement that an actual computer by the name of
.B red.rutgers.edu
even exist:
the name servers could be set up so that you mail to department
names, and each department's mail is routed automatically to an 
appropriate computer.
.PP
It is also possible that the part before the `@' is
something other than a user name.
It is possible for programs to be set up to process mail.
There are also provisions to handle mailing lists, and generic names such as
.B postmaster
or
.BR operator .
.PP
.II "RFC 821"
.II "RFC 974"
The way the message is to be sent to another system is described
by RFCs 821 and 974.
The program that is going to be doing the sending asks the
name server several queries to determine where to route the message.
The first query is to find out which machines handle mail for the name 
.BR red.rutgers.edu .
In this case, the server replies that
.B red.rutgers.edu 
handles its own mail.
The program then asks for the address of 
.BR red.rutgers.edu ,
which is 128.6.4.2.
Then the mail program opens a TCP 
connection to port 25 on 128.6.4.2.
(Port 25 is the well-known port used for receiving mail.)
Once this connection is established, the mail program starts sending commands.
.PP
Here is a typical conversation.
Each line is labeled as to whether it is from
.B topaz
or
.BR red .
Note that
.B topaz
initiated the connection:
.DM
	RED 220 RED.RUTGERS.EDU SMTP Service at 27 Jun 94 05:17:18
	EDT
	TOPAZ HELO topaz.rutgers.edu
	RED 250 RED.RUTGERS.EDU - Hello, TOPAZ.RUTGERS.EDU
	TOPAZ MAIL From:<hedrick@topaz.rutgers.edu>
	RED 250 MAIL accepted
	TOPAZ RCPT To:<levy@red.rutgers.edu>
	RED 250 Recipient accepted
	TOPAZ DATA
	RED 354 Start mail input; end with <CRLF>.<CRLF>
	TOPAZ Date: Sat, 27 Jun 87 13:26:31 EDT
	TOPAZ From: hedrick@topaz.rutgers.edu
	TOPAZ To: levy@red.rutgers.edu
	TOPAZ Subject: meeting
	TOPAZ
	TOPAZ Let's get together Monday at 1pm.
	TOPAZ .
	RED 250 OK
	TOPAZ QUIT
	RED 221 RED.RUTGERS.EDU Service closing transmission channel
.DE
.PP
First, note that commands all use normal text.
This is typical of the Internet standards.
Many of the protocols use standard ASCII commands.
This makes it easy to watch what is going on and to diagnose problems.
For example, the mail program keeps a log of each conversation.
If something goes wrong, the log file can simply be mailed to the postmaster.
Since it is normal text, he can see what was going on.
It also allows a human to interact directly with the mail server, for testing.
(Some newer protocols are complex enough that this is not practical.
The commands would have to have a syntax that would require a
significant parser.
Thus, there is a tendency for newer protocols to use binary formats.
Usually they are structured like C or Pascal record structures.)
.PP
Second, note that the each response begins with a number.
This also is typical of Internet protocols.
The protocol defines the allowable responses; and the number that
prefixes a response lets the user program respond unambiguously.
The rest of the response is text, which is normally for use by any
human who may be watching the screen or reading a log;
it has no effect on the operation of the programs.
(However there is one point at which the protocol uses part of
the text of the response.)
The commands themselves simply allow the mail program on one end
to tell the mail server the information it needs to know in order to
deliver the message.
In this case, the mail server could get
the information by looking at the message itself.
But for more complex cases, that would not be safe.
.PP
Every session must begin with
.BR HELO ,
which gives the name of the system that initiated the connection.
Then the sender and recipients are specified.
(There can be more than one RCPT command, if there are several recipients.)
Finally, the data are sent.
Note that the text of the message is terminated by a line that
contains just a period.
(If such a line appears within the message, the period is doubled.)
.PP
After the message is accepted, the sender can send
another message, or terminate the session as in the example above.
.PP
There is a pattern to the response numbers, based their the initial digit:
.IP \fB2\fR 0.3i
Responses that begin with this digit indicate success.
.IP \fB3\fR
A further action is needed, as shown above.
.IP \fB4\fR
A temporary error, such as a disk filling.
The message should be saved, and tried again later.
.IP \fB5\fR
A permanent error, such as a non-existent recipient.
The message should be returned to the sender with an error message.
.PP
.II "RFC 814"
.II "RFC 821"
.II "RFC 822"
.II "RFC 959"
.II "RFC 854"
.II "RFC 855"
For more details about the protocols mentioned in this section, see RFCs
821/822 for mail, RFC 959 for file transfer, and RFCs 854/855 for remote  logins.
For the well-known port numbers, see the current edition of 
.IR "Assigned Numbers" ,
and possibly RFC 814.
.SH "Protocols other than TCP: UDP and ICMP"
.PP
So far, we have described only connections that use TCP.
However, many applications send messages that always fit in a single datagram,
for which TCP is not the best protocol.
.PP
For example, consider name lookup.
When a user attempts to connect to another system,
he usually specifies the system by name rather than Internet address.
His system must translate that name into an IP address before it can do
anything.
Most systems do not have a copy of the data base that translates system
names into IP addresses;
so the user's system must send a query to a system that does have it.
This query is very brief;
it fits in one datagram, as does the answer.
.PP
We don't need all the complexity of TCP to send a message that consists
of a single datagram.
For applications like this, there are alternatives to TCP.
.Sh "UDP"
.PP
.II UDP^definition
.II "user datagram protocol"
.II "protocol^user datagram"
The most common alternative is the user datagram protocol (UDP).
UDP is designed for applications where you don't need to put sequences of
datagrams together.
.PP
UDP fits into a network much like TCP does.
The network software writes a UDP header at the beginning of your data,
analogous to the TCP header.
Then UDP passes the data to IP, which adds the IP header;
the only difference on the IP level is that it writes UDP's protocol
number in the protocol field instead of TCP's.
.PP
UDP doesn't do as much as TCP does.
It provides port numbers, so that several programs can use it at once.
UDP ports are used just like TCP ports, and
there are well-known ports for servers that use UDP.
Thus, the UDP header is shorter than a TCP header:
it has source and destination port numbers, and a checksum,
but little else.
.PP
.II "IEN 116"
.II "RFC 882"
.II "RFC 883"
UDP is used by the protocols
that handle name lookups (see IEN 116, RFC 882, and RFC 883), and a number
of similar protocols.
.Sh "ICMP"
.PP
.II ICMP^definition
.II "Internet control message protocol"
.II "protocol^Internet control message"
Another alternative protocol is the Internet Control-Message Protocol (ICMP).
ICMP is used for error messages, and other messages intended
for the TCP/IP software itself, rather than a user program.
.PP
For example, if you attempt to connect to a host, your system may get back
an ICMP message saying ``host unreachable.''
ICMP can also be used to find out some information about the network.
.II "RFC 792"
See RFC 792 for details of ICMP.
.PP
ICMP is similar to UDP, in that it handles messages that fit in one datagram.
However it is even simpler than UDP.
It doesn't even have port numbers in its header.
Because not all ICMP messages are interpreted by the network software itself,
no port numbers are needed to say where a ICMP message is supposed to go.
.\"
.SH "TCP/IP Architecture:  A Summary"
.PP
The following diagram summarizes what we have presented on TCP/IP
architecture to this point:
.PH 1 1 \\*(XD/tcpip.eps
.PP
This diagram shows a human being on the remote host, who is using
two clients:
.B telnet
and
.BR mail .
.PP
The twisty dotted line traces the movement of mail from the human being on
the local host to the human being remote host, as follows:
.IP \(bu 0.3i
The human being on the local host invokes the mailer
.B elm
to send mail.
.IP \(bu
.BR elm ,
in turn, talks to
.BR smail ,
which manages mail.
.IP \(bu
.B smail
passes mail to TCP.
TCP breaks up the mail message into datagrams;
assigned the new SMTP session a port selected at random;
establishes a connection port 25 with the remote site
(the well-known port for mail);
and passes the datagrams to IP for transmission to the remote site.
.IP \(bu
IP looks up the address of the remote site, resolves that into an Ethernet
address, and launches the datagram down the Ethernet.
.IP \(bu
We do not know, or particularly care, which how many machines
handled the datagrams in between the local host and the remote host.
It may be few or it may be many.
.IP \(bu
The datagrams arrive at IP on the remote host, which confirms that the
datagrams belong at this site,
computes the checksums to confirm the integrity of the datagrams,
and passes them to TCP.
.IP \(bu
TCP computes its own checksums,
reassembles the datagrams into their original file.
Because this connection is bound to port 25, it then passes the
file to the mail server, which is the mail handler on this site.
.IP \(bu
The mail resides where the mail server
has placed it until the human being on the remote host invokes her mailer,
and disposes of the message.
.PP
The twisty dashed line shows how the human being on the local system
uses the
.B telnet
client to echo packets from the remote system:
.IP \(bu 0.3i
First, the user invokes the client
.B telnet, and tells it to access port 7 on the remote system.
Port 7 is the well-known port for the
.B echo
server.
.IP \(bu
The human being types something, then presses
.BR <return> .
What the human has typed is passed to the
.B telnet
client.
.IP \(bu
.B telnet
accesses TCP, which builds a message which contains what the human typed,
binds it to port 7,
and passes it to IP.
.IP \(bu
IP finds the address of the remote host (assuming that the human being
did not name it on
.BR telnet 's
command line), and launches the datagram over the Ethernet.
.IP \(bu
Once again, the datagram winds its way through the maze of machines that
comprise the Internet, and arrives at the IP server on the remote machine.
.IP \(bu
IP confirms that this datagram has arrived at the correct site,
computes the checksum to confirm the integrity of the datagram,
and passes
it to UDP.
.IP \(bu
UDP computes its own checksum.
Because the message is bound to port 7, it passes it to the
.B echo
server.
.IP \(bu
The
.B echo
server on the remote host echoes what it receives from remote host
and sends it back up the line.
.IP \(bu
The return packet makes its way back up the line, until it finally arrives
at the
.B telnet
client on the local host.
.BR telnet ,
in turn, redisplays on the human being's screen.
.IP \(bu
This cycle continues until the human being on the local host exits
from the
.B telnet
client.
.PP
Each of the step in the above is vastly more complicated than this
description indicates.
However, this description should give you an idea of how clients,
UDP, TCP, IP, and servers dovetail.
.\" Hedrick
.SH "Tracking Names and Information: The Domain System"
.PP
As we indicated earlier, the network software generally needs a 32-bit
Internet address to open a connection or send a datagram.
However, humans prefer to deal with computers by name rather than number.
Thus, there is a data base that allows the software to look up a
computer's name and find its corresponding number.
.PP
When the Internet was small, this was easy.
Each system had a file that listed every other system,
giving both its name and number.
Nowadays, there are too many computers for this approach to be practical.
.II "name server"
Thus, these files have been replaced by a set of
.I "name servers"
that keep track of host names and the corresponding Internet addresses.
(In fact these servers are somewhat more general than that.
This is just one kind of information stored in the domain system.) 
.PP
Note that a set of interlocking servers are used, rather than a single
central one.
There are now so many different institutions connected to the Internet
that it would be impractical for them to notify a central
authority whenever they installed or moved a computer.
Thus, naming authority is delegated to individual institutions.
The name servers form a tree, corresponding to institutional structure.
The names themselves follow a similar structure.
.PP
A typical example is the name
.BR borax.lcs.mit.edu.
This is a computer at the Laboratory for Computer Science (LCS) at MIT.
To find its Internet address, you might potentially
have to consult four different servers:
.IP \(bu 0.3i
First, you would ask a central server (called the
.IR "root server" )
where the EDU server is.
EDU is a server that keeps track of educational institutions.
The root server would give you the names and Internet addresses
of several servers for EDU.
(There are several servers at each level, to allow for the possibly that one
might be down.)
.IP \(bu
You would then ask EDU where the server for MIT is.
Again, it would give you names and Internet addresses of several servers.
Generally, not all of those servers would be at MIT,
to allow for the possibility of a general power failure at MIT.
.IP \(bu
Then you would ask MIT where the server for LCS is.
.IP \(bu
Finally, you would ask one of the LCS servers about
.BR borax .
.PP
.II domain^definition
The final result would be the Internet address for
.BR borax.lcs.mit.edu .
Each of these levels is called a
.IR domain .
The entire name,
.BR borax.lcs.mit.edu ,
is called a
.IR "domain name" .
(So are names of higher-level domains, such as
.BR lcs.mit.edu ,
.BR mit.edu ,
and
.BR edu .)  
.PP
Fortunately, you don't really have to go through all of this most of the time.
First of all, the root name-servers also happen to be the name
servers for the top-level domains, such as
.BR edu .
Thus, a single query to a root server will get you to MIT.
Second, software generally remembers answers that it received previously.
So, once we look up a name at
.BR lcs.mit.edu ,
our software remembers where to find servers for
.BR lcs.mit.edu ,
.BR mit.edu ,
and
.BR edu .
It also remembers the translation of
.BR borax.lcs.mit.edu .
.PP
Each of these pieces of information has a ``time to live'' associated with it.
Typically, this is a few days.
After that, system no longer regards the information as reliable,
and looks it up again.
This allows institutions to change things.
.PP
The domain system is not limited to finding out Internet addresses.
Each domain name is a node in a data base.
The node can have records that define a number of different properties.
Examples are Internet address, computer type, and a list of services
provided by a computer.
A program can ask for a specific piece of information,
or all information about a given name.
It is possible for a node in the data base to be marked as an
.I alias
(or nickname) for another node.
It is also possible to use the domain system to store information about users,
mailing lists, or other objects.
.PP
There is an Internet standard defining the operation of these data bases,
as well as the protocols used to make queries of them.
Every network utility has to be able to make such queries,
because this is now the official way to evaluate host names.
Generally utilities will talk to a server on their own system.
This server will take care of contacting the other servers for them.
This keeps down the amount of code that has to be in each application program.
.PP
The domain system is particularly important for handling computer mail.
There are entry types to define what computer handles mail for a given
name, to specify where an individual is to receive mail, and to define
mailing lists.
.PP
.II "RFC 882"
.II "RFC 883"
.II "RFC 973"
.II "RFC 974"
See RFCs 882, 883, and 973 for specifications of the domain system.
RFC 974 defines the use of the domain system in sending mail.
.SH Routing
.PP
Earlier, we said that stated that IP is responsible
for sending datagrams to their destination;
but little was said about how it would do this.
.II routing^definition
The task of finding how to get a datagram to its destination is referred to as
.IR "routing" .
.PP
Many of the details depend upon the implementation.
However some general things can be said.
.Sh "Gateways"
.PP
First, it is necessary to understand the model on which IP is based.
IP assumes that a system is attached to some local network.
We assume that the system can send datagrams to any other system on its
own network.
(In the case of Ethernet, it simply finds the Ethernet address of the
destination system, and puts the datagram out on the Ethernet.)
The problem comes when a system is asked to send a datagram to a system on a
different network.
This problem is handled by gateways.
.PP
.II gateway^definition
A
.I gateway
is a system that connects a network with one or more other networks.
Gateways are often normal computers that happen to have more than one network
interface.
For example, we have a machine that has two different Ethernet
interfaces \(em it is connected to networks 128.6.4 and 128.6.3.
Thus, this machine can act as a gateway between those two networks.
.PP
The software on a gateway must be set up so that it will forward
datagrams from one network to the other.
That is, if a machine on network 128.6.4 sends a datagram to the gateway,
and the datagram is addressed to a machine on network 128.6.3,
the gateway will forward the datagram to the destination.
Major communications centers often have gateways that
connect a number of different networks.
(In many cases, special-purpose gateway systems provide better performance
or reliability than general-purpose systems acting as gateways.
A number of vendors sell such systems.)
.Sh "Routing Through Gateways"
.PP
Routing in IP is based entirely upon the network number of the destination
address.
Each computer has a table of network numbers.
For each network number, a gateway is listed;
this is the gateway to be used to get to that network.
Note that the gateway doesn't have to connect directly to the network \(em
it just has to be the best place to go to get there.
.PP
For example at Rutgers, our interface to NSFnet is at the John von Neuman
Supercomputer Center (JvNC).
Our connection to JvNC is via a high-speed
serial line connected to a gateway whose address is 128.6.3.12.
Systems on net 128.6.3 will list 128.6.3.12 as the gateway
for many off-campus networks.
However, systems on net 128.6.4 will list 128.6.4.1 as the
gateway to those same off-campus networks.
Site 128.6.4.1 is the gateway between networks 128.6.4 and 128.6.3,
so it is the first step in getting to JvNC.
.PP
When a computer wants to send a datagram, it first checks to see if the
destination address is on the system's own local network.
If so, the datagram can be sent directly.
Otherwise, the system expects to find an entry for the network that
the destination address is on.
The datagram is sent to the gateway listed in that entry.
This table can get quite large.
.PP
For example, the Internet now includes thousands of individual networks.
Thus various strategies have been developed to reduce the size
of the routing table.
.II "default routes"
.II "routing^default routes"
One strategy is to depend upon
.IR "default routes" .
.PP
Often, there is only one gateway out of a network.
This gateway might connect a local Ethernet to a campus-wide backbone network.
In that case, we don't need to have a separate entry for every network
in the world.
.II "routing^default gateway"
.II "default gateway"
We simply define that gateway as a
.IR "default" :
when no specific route is found for a datagram, the datagram is sent
to the default gateway.
A default gateway can be used even when there are several gateways on a network.
Note that when your machine only has a SLIP connection to an Internet provider,
that provider is your default gateway by definition, and
all of your datagrams are routed to it automatically.
.Sh "Optimal Gatways"
.PP
When you attempt to route through a gateway, that gateway can reply
``I'm not the best gateway \(em use this one instead.''
.II ICMP
(The message is sent via ICMP.
.II "RFC 792
See RFC 792.)
Most network software is designed to use these
messages to add entries to their routing tables.
For example,
suppose network 128.6.4 has two gateways, 128.6.4.59 and 128.6.4.1.
Gateway 128.6.4.59 leads to several other internal Rutgers networks; and
128.6.4.1 leads indirectly to the NSFnet.
Suppose we set 128.6.4.59 as a default gateway, and have no other
routing-table entries.
Now, what happens when we need to send a datagram to MIT?
MIT is network 18.
Because we have no entry for network 18, the datagram
is sent to the default, 128.6.4.59.
As it happens, this gateway is the wrong one,
so it forwards the datagram to 128.6.4.1;
but it also returns error message to our system that says, in effect,
``To get to network 18, use 128.6.4.1.''
Our software then adds an entry to the routing table, and
then sends all future MIT datagrams directly to 128.6.4.1.
.II "ICMP"
(The error message is sent using the ICMP protocol.
The message type is called 
.IR "ICMP redirect" .)
.PP
Most IP experts recommend that an individual computer should not try to keep
track of the entire network.
Instead, it should start with default gateways,
and let the gateways tell them the routes, as just described.
.PP
However, this doesn't say how the gateways should find out about the routes.
The gateways can't depend upon this strategy.
They have to have fairly complete routing tables.
For this, some sort of routing protocol is needed.
.II "routing^protocol"
.II "protocol^routing"
A
.I "routing protocol"
is simply a technique for the gateways to find each other,
and keep up to date about the best way to get to every network.
.II "RFC 1009"
RFC 1009 reviews gateway design and routing.
.\" .II rip.doc
.\" However,
.\" .B rip.doc
.\" is probably a better introduction to the subject.
.\" It contains some tutorial material, and a detailed description of the most
.\" commonly used routing protocol.
.SH "Classes of Internet Addresses"
.PP
As indicated earlier, an Internet address is a 32-bit number, which normally
is written in decimal as four bytes, e.g., ``128.6.4.7''.
Actually, there are three different types of address.
The problem is that an address has to indicate both the network,
and the host within the network.
.PP
When Internet addressing was designed,
the designers believed that eventually there would be many networks.
Many of them would be small, but probably 24 bits would be needed
to represent all the IP networks.
It was also felt that some very big networks might need 24 bits
to represent all of their hosts.
This would seem to lead to 48-bit addresses.
However, the designers really wanted to use 32-bit addresses,
so they adopted a kludge.
Because the designers assumed that most networks would be small,
they set up three different ranges of address.
.PP
.II "network^class A"
A
.I class-A
address uses only the first byte for the network number;
these begins with numbers 1 to 126.
The other three bytes (24 bits) of the address
are available to identify a host within the network.
Class-A addresses are used for 126 large networks.
The ARPAnet is one, and there are a few large commercial networks;
but few normal organizations get a class-A address.
.PP
.II "network^class B"
Most large organizations use a
.I "class-B"
address.
Class-B addresses use the first two bytes (16 bits) for the network number.
Thus, class-B network comprise network numbers 128.1 through 191.254.
(We avoid 0 and 255, for reasons that we see below.
We also avoid addresses beginning with 127,
because that is used by some systems for special purposes.)
The last two bytes (16 bits) of the address are available for host addresses.
Thus, a class-B network to hold up to 64,516 hosts,
which should be enough for most organizations.
.PP
.II "network^class C"
Finally,
.IR class-C
addresses use three bytes, in the range 192.1.1 to 223.254.254.
Only the last byte (eight bits) are available to identify hosts within a
network; thus, a class-C network can contain no more than 254 hosts,
but there can be lots of these networks.
.PP
Addresses above 223 are reserved for future use,
as classes D and E (which are not yet defined).
.PP
Many large organizations find it convenient to divide their network number into
.IR subnets .
For example, Rutgers has been assigned a class B address, 128.6.
We find it convenient to use the third byte of the address to
indicate which Ethernet a host is on.
This division has no significance outside of Rutgers.
A computer at another institution would treat all
datagrams addressed to 128.6 the same way,
and would not look at the third byte of the address.
Thus, computers outside Rutgers would not have
different routes for 128.6.4 or 128.6.5;
but inside Rutgers, we treat 128.6.4 and 128.6.5 as separate networks.
In effect, gateways inside
Rutgers have separate entries for each Rutgers subnet,
whereas gateways outside Rutgers just have one entry for 128.6.
.PP
Note that we could do exactly the same thing by using a separate
class-C address for each Ethernet.
As far as Rutgers is concerned, it would be just as convenient
for us to have a number of class-C addresses.
However, using class-C addresses would make things inconvenient
for the rest of the world:
every institution that wanted to talk to us would have to have
a separate entry for each one of our networks.
If every institution did this, there would be far too many networks
for any reasonable gateway to keep track of.
By subdividing a class B network, we hide our internal structure from
everyone else, and save them trouble.
.II "RFC 950"
This subnet strategy requires special provisions in the network software.
It is described in RFC 950.
.Sh "Special Addresses"
.PP
Addresses 0 and 255 have special meanings.
.PP
.II address^0
Address 0 is reserved.
It is used in two special situations:
.IP \(bu 0.3i
Zero can be substituted for the host portion
of the IP address to yield a network address.
.IP \(bu
Address 0 can be used by machines that do not know their own addresses.
In certain circumstances, it is possible for a machine not to know
the number of the network it is on, or even its own host address.
For example, 0.0.0.23 would be a machine that knew it was host
number 23, but didn't know on what network.
.PP
.II address^255
.II broadcasting
Address 255 is used for broadcasting.
A
.I broadcast
is a message that you want every system on the network to see.
Broadcasts are used when a machine does not know whom to talk to.
For example, suppose you need to look up a host name and get its
Internet address.
If you don't know the address of the nearest name server,
you might send the request as a broadcast.
There are also cases where a number of systems are interested in information:
it is less expensive to send a single broadcast than to send a
datagram to each host that is interested in the information.
To send a broadcast, use a special address that is constructed from your network
address with ``255'' in the part of the address where the host number goes.
For example, if you are on network 128.6.4, you would use send a
broadcast to address 128.6.4.255.
.PP
How this is actually implemented depends upon the medium.
It is not possible to send broadcasts on the ARPAnet, or on a SLIP connection.
However, a broadcast is possible on an Ethernet:
if you use an Ethernet address with 255,
every machine on the Ethernet must look at that packet.
.PP
Although the official broadcast address for network 128.6.4 is now
128.6.4.255, there are some other addresses that may be treated as
broadcasts by certain implementations.
For convenience, the Standard also allows 255.255.255.255 to be used.
This refers to all hosts on the local network.
It is often simpler to use 255.255.255.255 instead of finding 
out the network number for the local network and forming a broadcast
address such as 128.6.4.255.
.PP
Because 0 and 255 are used for unknown and broadcast addresses,
a normal host should never be given an address that contains 0 or 255.
An address should never begin with 0, 127, or any number above 223.
.II Martians
.II "Central University of Mars"
Addresses violating these rules are sometimes referred to as ``Martians,''
because of rumors that the Central University of Mars uses network 255.
.SH "Datagram Fragmentation and Reassembly"
.PP
TCP/IP is designed for use with many different kinds of network.
.PP
Unfortunately, network designers do not agree about how big a packet can be.
Ethernet packets can be up to 1,500 bytes long.
ARPAnet packets have a maximum of about 1,000 bytes.
Some very fast networks have much larger packet sizes.
.PP
At first, you might think that IP should simply settle
on the smallest possible size.
Unfortunately, this causes serious performance problems:
when transferring large files, big packets are far more efficient
than small ones; therefore,
we want to use the largest packet possible.
But we also want to be able to handle networks with small limits.
TCP and IP have two ways to deal with this problem.
.PP
.II datagram^negotiation
First, TCP ``negotiates'' the size of the datagram.
When a TCP connection first opens,
each end ``bids'' maximum datagram size that it can handle.
The smaller of these ``bids'' is used for the rest of the connection.
This lets the sites use the largest datagram that both can handle.
.PP
However, this doesn't completely solve the problem, because
the two ends do not know about all of the machines that lie between them.
For example, when sending data between Rutgers and Berkeley,
it is likely that both computers will be on Ethernets.
Thus, each can handle 1,500-byte datagrams.
However, the connection will at some point end up going over the ARPAnet,
which cannot handle packets that large.
.PP
For this reason, IP can split a datagram into pieces.
.II fragmentation
This is called
.IR fragmentation .
The IP header contains fields that indicate that a datagram has been split,
and the information needed to reassemble the datagram from the fragments.
.PP
Thus, if a gateway connects an Ethernet to the ARPAnet,
it must be prepared to take 1,500-byte Ethernet packets and
split them into pieces that will fit onto the ARPAnet.
Further, every host implementation of TCP/IP must be prepared to
accept fragments and reassemble them.
.II reassembly
This is called
.IR reassembly .
.PP
Implementations of TCP/IP differ in how they select the size of a datagram.
Many implementations use 576-byte datagrams when they cannot verify
that the entire path can handle larger packets.
Because many implementations have bugs in the code that reassemble fragments
implementors often try to avoid having packets fragmented during transmission.
Different implementors on how they decide it is safe to use larger datagrams:
some use them only for the local network,
whereas others use them for any network on the same campus.
However, a size of 576 bytes is a ``safe'' size
that every implementation must support.
.SH "Ethernet Encapsulation: ARP"
.PP
Earlier,
there was a brief discussion about what IP datagrams look like on an Ethernet.
This discussion introduced the Ethernet header and checksum.
However it left one hole:
it didn't say how to figure out what Ethernet address
to use when you want to talk to a given Internet address.
.II "protocol^address resolution"
.II "address resolution protocol"
.II ARP^definition
In fact, there is a separate protocol for this, called
.I "address resolution protocol"
(ARP).
.PP
Please note that ARP is not an IP protocol:
that is, the ARP datagrams do not have IP headers.
.PP
Suppose you are on system 128.6.4.194 and you want to connect
to system 128.6.4.7.
Your system first verifies that 128.6.4.7 is on the same network,
so it can talk directly via Ethernet.
Then it looks up 128.6.4.7 in its ARP table,
to see if it already knows its Ethernet address.
If it does, it sticks on an Ethernet header and send the packet.
.PP
Suppose, however, that the target system is not the sender's ARP table.
The sender cannot send the packet, because it needs the Ethernet address.
In this situation, the sender uses the ARP protocol to send an ARP request.
Essentially, an ARP request says, ``I need the Ethernet address for 128.6.4.7.''
Every system listens to ARP requests.
When a system sees an ARP request for itself, it must respond.
.II "Ethernet^address notation"
.II "address^Ethernet notation"
Host 128.6.4.7 sees the request, and responds with an ARP reply that says,
in effect, ``IP host 128.6.4.7 has Ethernet address 8:0:20:1:56:34.''
(Recall that Ethernet addresses are 48 bits, or six bytes.)
Ethernet addresses are conventionally shown in
hexadecimal notation, with bytes separated by colons.)
.PP
The sender writes this information into its ARP table,
to spare it the trouble of sending another ARP for the same recipient;
then proceeds with its transmission.
Most systems treat the ARP table as a cache,
and erase entries from it if they have not been used
within a certain period of time.
.PP
Note, by the way, that an ARP request must be sent as broadcast;
after all, the whole reason for sending an ARP request is that you don't
know the Ethernet address.
To broadcast over an Ethernet network, a host sends a packet to Ethernet
address ``FF:FF:FF:FF:FF:FF'' (i.e., an Ethernet address of all ones).
By convention, every machine on the Ethernet must
pay attention to a packet with this address; therefore,
every system sees every ARP request.
Each system checks whether the request is for its IP address:
if so, it responds; if not, it ignores it.
(Some hosts use ARP requests to update their knowledge
about other hosts on the network, even if the request isn't for them.)
Note that packets whose IP address indicates broadcast (e.g.,
255.255.255.255 or 128.6.4.255) are also sent with an Ethernet address
that is all ones.
.SH "Getting More Information"
.PP
This concludes our introduction of the basics of networking.
If you want more information, you should look into the source documents
for the Internet.
The Internet comprises literally hundreds of documents;
the following describes the ones that we believe are the most important.
.PP
An Internet standard is called a
.IR "request for comment"
(RFC).
A proposed standard is initially issued as a proposal, and given an RFC number.
When it is finally accepted, it is added to Official Internet Protocols,
but it is still referred to by the RFC number.
.PP
We have also included two IENs.
(IENs used to be a separate classification for more informal documents.
This classification no longer exists \(em RFCs are now used
for all official Internet documents,
and a mailing list is used for more informal reports.)
.PP
The convention is that whenever an RFC is revised, the revised version gets a
new number.
This is fine for most purposes, but it causes problems with two documents:
Assigned Numbers and Official Internet Protocols.
These documents are being revised all the time, so their RFC numbers
keeps changing.
You will have to look in file
.B rfc-index.txt
to find the number of the latest edition.
.PP
.II "RFC 791"
To begin, anyone who is seriously interested in TCP/IP should read RFC 791,
which describes IP.
.II "RFC 1009"
RFC 1009 is also useful \(em it specifies gateways to be used by NSFnet.
As such, it contains an overview of much of the TCP/IP technology.
.PP
You should probably also read the description of at least one of the
application protocols, just to get a feel for the way things work.
.II "RFC 821"
.II "RFC 822"
RFCs 821 and 822, which describe mail, are a good place to begin.
.PP
.II "RFC 793"
RFC 793 defines TCP.
This is, of course, a very basic specification.
However, it is fairly complex, so you should only read this
when you have the time and patience to think about it carefully.
.II "Postel, Jon"
Fortunately, the author of the major RFCs (Jon Postel) writes very well,
so the RFC 793 is far easier to read than you would expect,
given the complexity of what it is describing.
.PP
You can look at the other RFCs as you become curious about
their subject matter.
Here is a list of the documents you are likely to want:
.IP "\fBrfc-index\fR" 1.0i
.II "rfc-index"
This lists all of the RFCs.
.IP "\fBRFC 1012\fR"
.II "RFC^listing"
.II "RFC 1012"
This gives a somewhat fuller list of all RFCs.
.IP "\fBRFC 1011\fR"
.II "RFC 1011"
.II "protocol^official list"
Official protocols.
It's useful to scan this to see what tasks protocols have been built for.
This defines which RFCs are actual standards,
as opposed to requests for comments.
.IP "\fBRFC 1010\fR"
.II "RFC 1010"
.II "assigned numbers"
Assigned numbers.
If you are working with TCP/IP,
you will want a copy of this as a reference.
It's not very exciting to read.
It lists all the officially defined well-known ports and lots of other things.
.IP "\fBRFC 1009\fR"
.II "RFC 1009"
.II NSFnet^protocol
NSFnet gateway specifications.
This gives a good overview of IP routing and gateway technology.
.IP "\fBRFC 1001, RFC 1002\fR"
.II "RFC 1001"
.II "RFC 1002"
.II netBIOS^protocol
netBIOS:
networking for PCs.
.IP "\fBRFC 973\fR"
.II "RFC 973"
.II domains^protocol
Update on domains.
.IP "\fBRFC 959\fR"
.II "RFC 959"
.II FTP^protocol
The file-transfer protocol (FTP).
.IP "\fBRFC 950\fR"
.II "RFC 950"
.II subnets^definition
Definition of subnets.
.IP "\fBRFC 937\fR"
.II "RFC 937"
.II POP2^protocol
Protocol for POP2, for reading mail on PCs.
.IP "\fBRFC 894\fR"
.II "RFC 894"
.II "RFC 825"
.II "IP^protocol for implementation"
How IP is to be put on Ethernet.
See also RFC 825.
.IP "\fBRFC 882, RFC 883\fR"
.II "RFC 882"
.II "RFC 883"
Definition of domains, i.e., the data base used to go from host names to
Internet address and back.
.II UUCP
This is also used to route \*(UU messages.
.II "RFC 973"
See also RFC 973.
.IP "\fBRFC 854, RFC 855\fR"
.II "RFC 854"
.II "RFC 855"
.II TELNET^protocol
Definition of the TELNET protocol, for remote logins.
.IP "\fBRFC 826\fR"
.II "RFC 826"
.II ARP^protocol
Protocol for ARP, for finding out Ethernet addresses.
.IP "\fBRFC 821\fR"
.IS "\fBRFC 822\fR"
.II "RFC 821"
.II "RFC 822"
.II mail^protocol
Definition for mail.
.IP "\fBRFC 814\fR"
.II "RFC 814"
.II "well-known ports^protocol"
Protocol for names and ports.
.II "well-known ports"
It gives the concepts that underlie
``well-known ports''.
.IP "\fBRFC 793\fR"
.II "RFC  793"
.II "TCP^protocol"
Protocol that defines TCP.
.IP "\fB792\fR
.II "RFC 792"
.II ICMP^protocol
Protocol that defines ICMP.
.IP "\fBRFC 791\fR"
.II "RFC 791"
.II IP^protocol
Protocol that defines IP.
.IP "\fBRFC 768\fR"
.II "RFC 768"
.II UDP^protocol
Protocol that defines UDP.
.IP \fBrip.doc\fR
.II rip.doc
Details of the most commonly used routing protocol.
.IP \fBIEN-116\fR
.II IEN-116
Protocol that defines the old name server
(still needed by several kinds of system).
.IP \fBIEN-48\fR
.II IEN-48
.II "Catnet modem"
The Catenet model, which describes the philosophy behind TCP/IP.
.PP
The following documents are somewhat more specialized:
.IP "\fBRFC 813\fR" 1.0i
.II "RFC 813"
Window and acknowledgment strategies in TCP.
.IP "\fBRFC 815\fR"
.II "RFC 815"
.II "datagram^reassembly"
Techniques for reassembling datagrams.
.IP "\fBRFC 816\fR"
.II "RFC 816"
Techniques to isolate and resolve faults.
.IP "\fBRFC 817\fR"
.II "RFC 817"
Modularity and efficiency in implementation
.IP "\fBRFC 879\fR"
.II "RFC 879"
The maximum-segment-size option in TCP.
.IP "\fBRFC 896\fR"
.II "RFC 896"
Congestion control
.IP "\fBRFC 827, RFC 888, RFC 904, RFC 975, RFC 985\fR"
.II "RFC 827"
.II "RFC 888"
.II "RFC 904"
.II "RFC 975"
.II "RFC 985"
.II EGP
EGP and related issues.
.Sh "How To Obtain Documents"
.PP
The most important RFCs have been collected into a three-volume
set, the DDN Protocol Handbook.
.II "DDN Protocol Handbook"
.II "DDN Network Information Center"
It is available from the DDN Network Information Center,
SRI International, 333 Ravenswood Avenue, Menlo Park, CA 94025
(telephone 800-235-3155).
You should be able to get them via anonymous FTP from
.BR sri-nic.arpa .
.PP
.B rip.doc
is available by anonymous FTP from
.BR topaz.rutgers.edu ,
as
.BR /pub/tcp-ip-docs/rip.doc .
.PP
The InfoMagic CD-ROM of standards
contains (among many other things) the ARPAnet RFCs.
This CD-ROM is available from many commercial sources; or you can telephone
InfoMagic at 1-800-800-6613.
.SH "Where To Go From Here"
.PP
The next chapter describes how to install and configure
.BR cohulip .
Please read it thoroughly before you attempt to install anything.
.PP
The subsequent chapters describe how run the application
.BR net ,
whic is the program that actually performs networking tasks;
and how to administer
.BR cohulip .

.NH "Installing BBL Images for UNIX or COHERENT"
.PP
The following document describes how to install the Cardinal Mazarine
package of images onto your \*(UN or \*(CO system.
If you have a \*(CO system, it also describes how to use the enclosed
macros and binding files to include the images in the output of
.BR troff .
.SH "Installing Cardinal Mazarine"
.PP
The Cardinal Mazarine package consists of files compressed by the GNU
utility
.BR gzip ,
and are stored on a
.B tar
archive.
To copy the files from the disk onto your system,
.B cd
to the directory in which you wish to store the images, then insert the
disk into your high-density, 3.5-inch disk drive and type the following
command:
.DM
	tar xvf /dev/\fIdevice\fR
.DE
where
.I device
is the name of the device from which you are reading the archive.
The files are stored in directory
.BR mazarine ,
which is created in the current directory.
.PP
When the disk is copied onto your system,
.B cd
to the sub-directory
.BR mazarine ,
then type the following command to un-compress the files:
.DM
	gzip \-d *.gz
.DE
That's all there is to it.
If you are using \*(UN, you should remove the file
.B tmac.eps
and the files
.BR *.bnd ,
as you cannot use them.
If you are using \*(CO, read on; the following will show you how to use
these files with \*(CO's implementation of
.BR troff .
.SH "Using BBL Images with COHERENT troff"
.PP
As noted above, in addition to the encapsulated PostScript images, this
package contains binding files and a set of macros that can be used with
the \*(CO operating system's implementation of
.BR troff .
They
.I cannot
be used with standard \*(UN
.B troff
as they employ some extensions to the
.B troff
language that are unique to the \*(CO implementation of
.BR troff .
.PP
To use the macros, \*(CO users
log in as
.B root
or
.BR bin ,
then move the file
.B tmac.eps
into directory
.BR /usr/lib .
.PP
The macro package
.B tmac.eps
reads a binding file that gives the bounding-box for the image, and names
the file that holds the image itself.
(For details on what the bounding box is and how these macros use it,
see the comments at the head of
.BR tmac.eps .)
A binding file, by convention, has the suffix
.BR .bnd ;
for example, the image
.B cmz.eps
has the binding file
.BR cmz.bnd .
.PP
To patch an image into a
.B troff
document, you must do the following:
.IP \fB1.\fR 0.3i
Define the string
.BR XA ,
which names the base directory of the images.
.IP \fB2.\fR
Call the appropriate binding file, using one of the macros in
.BR tmac.eps .
.IP \fB3.\fR
Include
.B tmac.eps
on your
.B troff
command line.
.PP
For example, assume that you have installed the Cardinal Mazarine
into directory
.BR /usr/bbl .
The following example, called
.BR test.eps ,
gives a brief program that prints the capital `Z' from this package:
.sp \n(pDu
.nf
.ft L
.vs 9p
	.ds XA /usr/bbl
	.SH
	An Example Image
	.PP
	This mass of text precedes the image.
	This mass of text precedes the image.
	This mass of text precedes the image.
	This mass of text precedes the image.
	This mass of text precedes the image.
	This mass of text precedes the image.
	This mass of text precedes the image
	This mass of text precedes the image.
	This mass of text precedes the image:
	.PH 1 1 /usr/bbl/mazarine/cmz.bnd
	.PP
	This mass of text follows the image.
	This mass of text follows the image.
	This mass of text follows the image.
	This mass of text follows the image.
	This mass of text follows the image.
	This mass of text follows the image.
	This mass of text follows the image.
	This mass of text follows the image.
	This mass of text follows the image.
.vs 10p
.PP
As you can see, this example includes the binding file
.BR cmz.bnd ,
not the image file
.BR cmz.eps .
To compile and print this example, use the following command:
.DM
	troff -p -ms -meps test.eps | lp
.DE
Note that the \fB.eps\fR macros do not set up page; they only position
images.
You must use a standard
.B troff
macro package, such as \fB\-ms\fR or \fB-man\fR, to set up the page.
.PP
That all there is to it.
.SH "The tmac.eps Macros"
.PP
.B tmac.eps
includes the following macros:
.IP "\fB.PH\fR"
Picture Here \(em center a picture on the page at the point where this
macro is called.
It takes three arguments:
the image's X scaling factor;
the image's Y scaling factor;
and full path name of the image's binding file.
The macro ensures that enough space is on the page to print the
and repositions the text and the image appropriately so there is
no collision or overwriting.
If there's not enough space, the image
is bumped to the next page.
Example call:
.DM
	.PH 1 1 /usr/bbl/cm12.bnd
.DE
.IP \fB.PF\fR
Picture Fill \(em fill up the rest of the white space on the
current page with a picture.
It takes three arguments:
the image's X scaling factor;
the image's Y scaling factor;
and full path name of the image's binding file.
If the remaining white space on the page cannot hold the image, it
prints nothing.
Example call:
.DM
	.PF 1 1 /usr/bbl/cm12.bnd
.DE
.IP \fB.PL\fR
Picture Left \(em set an image flush left on the page at the point where this
macro is called.
It takes three arguments:
the image's X scaling factor;
the image's Y scaling factor;
and the full path name of the image's binding file.
Unlike the macros
.B .PF
and
.BR .PH ,
which clear clear out a horizontal band on the page,
.B .PL
sets a trap and indents properly, so text can flow around the image.
If the image will not fit on this page, do nothing.
Example call:
.DM
	.PL 1 1 /usr/bbl/cm12.bnd
.DE
.IP \fB.PB\fR
Picture Beginning \(em set an image flush left on the page at the point
where this macro is called.
Unlike
.BR .PL ,
the image does
.I not
have to have text appear before it on the page.
Use this macro for initial capitals and things like that.
It takes three arguments:
the image's X scaling factor;
the image's Y scaling factor;
and full path name of the image's binding file.
Example call:
.DM
	.PB 1 1 /usr/PostScript/bbl/pj12.bnd
.DE
.IP \fB.PR\fR
Picture Right \(em set an image flush right on the page at the point where this
macro is called.
It takes three arguments:
the image's X scaling factor;
the image's Y scaling factor;
and full path name of the image's binding file.
Example call:
.DM
	.PR 1 1 /usr/PostScript/bbl/pj12.bnd
.DE
.PP
We hope you enjoy using these macros.

.ds TL "User Groups"
.ds TI "RELEASE NOTES"
.NH "On-Line Services With COHERENT"
.PP
Numerous groups and services are available to you through your \*(CO system.
User groups offer the chance to meet with your fellow \*(CO users.
Bulletin boards let you download software and mail.
.\"The on-line discussion groups available through CompuServe and the Internet
.\"let you chat with fellow \*(CO users and Mark Williams developers.
.SH "User Groups and Bulletin Boards"
.PP
\*(CO users groups are established in many parts of the wrold.
The following lists registered \*(CO user groups.
It also lists bulletin boards that offer material of interest to \*(CO users.
Each entry gives the address of the group and way in which you can contact
its administrator.
.PP
Please note that these groups are administered by people who volunteer time
and equipment to help you.
Please respect this:
for example, do not telephone administrators late at night with questions.
.Sh Australia
.DS
	Australian Coherent Users Group/BBS
	Richard Lindner (rjl@spectre.apana.org.au)
	P.O.Box 1555
	Wodonga, Vic. 3689
	Australia
		Data: 61 60 208773
		FAX: 61 60 562105
.DE
.DS
	Robert Chalmers
	22 Minster Street
	Mackay.	4740
	Queensland
	Australia
		Site Name:
			nanguo (cstpl.com.au)
		Data:	+61 79 524527 (Mackay, 24 hours)
			+61  7 8011737 (Brisbane, 24 hours)
		Voice:	+61 79 524395 (9 AM \(em 5 PM Australian EST)
		FAX:	+61 79 524032 (24 hours)
		e-mail:	robert@cstpl.com.au
			paul@cstpl1.cstpl.com.au
		Info-Server:
			info@cstpl.com.au (Subject: list)
.DE
.Sh Germany
.DS
	Olaf Matthaei
	Luckenwalderstrasse 38
	15711 Koenigswusterhausen
	Germany
		e-mail: \fBmailserver@kwcom.in-berlin.de\fR
.DE
.DS
	Udo Munk (udo@umunk.gun.de)
	Udo Munk's Private BBS
	Oberstrasse 21, 41460 Neuss
	Germany
		Data: +49 2131 278869
		Login: uucp
		passwd: public (Only for the first call)
.DE
.DS
	Axel Reinhold (Axel_Reinhold@wun.maus.de)
	ARXBBS
	Untere Bergstrasse 9
	95100 Selb
	Germany
		Data: +49-9287/87446
		FAX:  +49-9287/87232
		BBS:  +49-9287/8244 (V22-V32bis N/8/1)
		Hours: 22:00 \(em 06:00 CET Daily
		       07:00 \(em 12:00 CET Monday \(em Friday
		Modem: 14.4k \(em 1200 baud V.42Bis & MNP-5
.DE
.\".Sh Japan
.\".DS
.\"	Japanese \*(CO Users Group 
.\"	Yoshihisa Suda
.\"	924-111
.\"	Misawa Hino-City
.\"	Tokyo, Japan T191
.\"		Fax: +81 425 92 4646
.\".DE
.Sh "The Netherlands"
.DS
	First Dutch COHERENT Users' Group & BBS
	Aart Van Erven (aart@fdcbbs.iaf.nl)
	Mezenhof 119
	1742 GJ
	Schagen
	The Netherlands
		Data: +31 2240 97099 (14.4 kilobaud)
		UUCP test login: guest		
.DE
.Sh "New Zealand"
.DS
	ACME BBS
	Craig Harding
	P.O. Box 128
	Palmerston North
	New Zealand
.DE
.Sh "United States"
.DS
	Good News BBS and Users Group
	Timothy G. Wells
	3740 Boudinot Ave.
	Cincinnati, OH  45211
.DE
.DS
	Bay Area \*(CO Users Group
	Viki Tamaradze
	P.O. Box 622
	El Cerrito, CA 94530
		Telephone: 510-549-1876
.DE
.DS
	COHERENT Support BBS
	Dmitry L. Gringauz (dmitry@golem.com)
	Data: 415-312-8751, login as ``guest''
.DE
.PP
Mark Williams Company makes every effort to keep these listings up to date.
However, we cannot guarantee that all the user groups listed are
still active, nor can we guarantee that the BBS information is current.
If you do discover a discrepancy,
please contact the User Group Co-ordination Director at Mark Williams Company.
.\".SH "Preferred COHERENT Bulletin Boards"
.\".PP
.\"The following lists the preferred bulletin boards throughout the world.
.\"These bulletin boards are authorized to carry updates to \*(CO software,
.\"among other services.
.\".PP
.\".I Note:
.\"The hardworking administrators of these systems are volunteers, who
.\"donate their time and expertise to \*(CO users in your area.
.\"\fIPlease do not abuse their generosity!\fR
.\"If you truly need advice, please send electronic mail:
.\"do \fInot\fR telephone.
.\".Sh Australia
.\".PP
.\".DS
.\"	Australian \*(CO Users Group BBS
.\"	System Administrator:  Richard Lindner
.\"	E-mail:  rjl@spectrum.pub.uu.oz.au
.\"	Telephone:  +61-3-882-4690
.\"	FAX:  +61-3-824-0655
.\".DE
.\".Sh Germany
.\".PP
.\".DS
.\"	ARXBBS
.\"	System Administrator: Axel Reinhold
.\"	Untere Bergstrasse 9
.\"	W-8672 Selb, Germany
.\"	Modem: +49-9287-814400 (1200 Baud V42.BIS + MNP-5)
.\"	22:00 - 06:00 CET Daily
.\"	07:00 - 12:00 CET Monday - Friday
.\".DE
.\".DS
.\"	Udo Munk's private BBS
.\"	Udo Munk
.\"	Oberstrasse 21
.\"	4040 Neuss 1, Germany
.\"	Telephone: +49-2131-275348
.\".sp \n(pDu
.\"	Modem: +49-2131-278869
.\"	system name: umunk
.\"	login: uucp
.\"	passwd: public
.\".sp \n(pDu
.\".fi
.\".B /usr/lib/uucp/Permissions
.\"must have the field
.\".B MYNAME=bbsuser
.\"for first connect.
.\"At the first connect, download the file
.\".BR /usr/spool/uucppublic/info .
.\".DE
.\".Sh "New Zealand"
.\".DS
.\"	ME BBS
.\"	Contact: Craig Harding
.\"	P.O. Box 128, Palmerston North, New Zealand
.\".DE
.SH "Registering Your COHERENT User Group"
.PP
If you are the member of a \*(CO user group or special interest group and
your group is not listed above, you can register your group with Mark Williams
Company by writing to the User Group Co-ordination Director.
By doing so, you ensure your group's inclusion in the next listing.
When you register your group, please include the following information:
.IP \(bu 0.3i
The name and address of the group.
.IP \(bu
The name of the group's administrator (if any).
.IP \(bu
Size of the group.
.IP \(bu
Date group was established.
.IP \(bu
Frequency and nature of group meetings.

.ds T1 "COHERENT"
.ds T2 "Device  Driver  Kit"
.ds MW "Mark Williams Company"
.ds CR "1993"
.ds OS COHERENT
.ds RN "Release 4.2"
.ll 6.0i
.wh 0 HD
.wh -1.5i FO
.de HD
.sp |3.0i
..
.de FO
..
.po 1.25i
.sp 3
.ce
\f(HH\*(T1\fR
.sp 1
.ce
\f(HH\*(T2\fR
.sp 1
.ce 1
\*(RN
.sp |7.5i
.ce 1
Copyright \(co \*(CR
.sp 2
.ce 4
\*(MW
60 Revere Drive
Northbrook, Illinois  60062
Telephone:  (708) 291-6700
.sp 3
.fi
\*(MW makes no warranty of any kind
with respect to this material
and disclaims any implied warranties of merchantability or
fitness for any particular purpose.
.sp
The information contained herein is subject to change without notice.
.sp 2
.ce 1
Printed in U.S.A.

.po 1i
.sp 1i
.ll 6i
.ce
\f(HLUser Evaluation Report\fR
.sp
To keep this manual free of errors and to help us
improve X Windows for COHERENT, please send us your reactions.
Please fill in the form below, detach it, and mail it to:
.sp
.ce 3
Mark Williams Company
.br
60 Revere Drive
.br
Northbrook, IL  60062
.sp
.nf
.ta 1.25i
\! .1 setlinewidth
Name:	____________________________________________________________________
.sp
Company:	____________________________________________________________________
.sp
Address:	____________________________________________________________________
.sp
City/State/Zip:	____________________________________________________________________
.sp
Phone:	____________________________________________________________________
.sp
Date:	____________________________________________________________________
.sp 2
Version and hardware used:
.sp 2
Did you find any errors in the manual?
.sp 2
Can you suggest any improvements to the manual?
.sp 2
Did you find any bugs in the software?
.sp 2
Can you suggest any improvements or enhancements to the software?
.sp 2
Additional comments:

.lf B	Bookman_B.fwt   8
.lf I	Bookman_I.fwt   8
.lf R	Bookman_R.fwt   8
.lf HH	HelvNar_B.fwt  14
.lf HR	HelvNar_R.fwt  10
.lf S	Symbol.fwt      8
.lf DB	Dingbats.fwt    8
.vs 9
.ll 6.0i
.wh 0 HD
.wh -1.5i FO
.de HD
.sp |0.75i
..
.de FO
..
.po 1.0i
.sp
.ft HH
.ce
\f(HHORDER  FORM\fR
.sp 12p
Use this convenient form to order additional X products
from Mark Williams Company.
Simply fill it out, detach, fold, and seal it.
Or you can order by calling 1-800-636-6700 or 1-708-291-6700.
.ta 0.75i 4.5iC 5.5iC
.nf
.sp 6p
			\fICOHERENT Club\fR
\fIQuantity	Product	Price*	Price*\fR
.sp 6p
________	COHERENT Club Membership	$49.95	N/A
.sp 6p
________	X Windows for COHERENT 4.2	$79.95	$79.95
.sp 6p
________	Xware Volume 1 (Window Managers)	$79.95	$59.95
.sp 6p
________	Xware Volume 2 (Games)	$79.95	$59.95
.sp 6p
________	Xware Volume 3 (Graphics)	$79.95	$59.95
.sp 6p
________	Xware Volume 4 (Utilities)	$79.95	$59.95
.sp 6p
________	Xware Volume 5 (Development Tools)	$79.95	$59.95
.sp 6p
________	Xware Volume 6 (Ghostscript)	$79.95	$59.95
.sp 6p
________	GNU C 2.5.6	$79.95	$59.95
.sp 6p
________	Update to GNU C	$79.95	$39.95
.sp 6p
________	GNU C Sources (GCC 2.3 C Compiler Sources)	$79.95	$59.95
.sp 6p
________	Update to GNU C sources	$79.95	$39.95
.sp 6p
________	GNU Tools	$79.95	$59.95
.sp 6p
________	Update to GNU Tools	$79.95	$39.95
.sp
.fi
Please specify size of \f(HRA:\fP drive: ______ 5.25'' 1.2MB or ______ 3.5'' 1.44MB
.sp
.ft HH
.ce
60-Day Money Back Guarantee
.ft R
.sp
.ce
.nf
\f(DBq\fP Visa    \f(DBq\fP Master Card    \f(DBq\fP Discover Card    \f(DBq\fP American Express    \f(DBq\fP Check Enclosed
.sp 6p
Card #:___________________________________________   Expiration Date: ____________________________
.sp 6p
Name: _________________________________________________________________________________________
.sp 6p
Company: ______________________________________________________________________________________
.sp 6p
Address: _______________________________________________________________________________________
.sp 6p
City: ________________________________________  State: ______________________  Zip: _________________
.sp 6p
Country:  ______________________________________________________________________________________
.sp 6p
Daytime Phone: ______________________________________  FAX: _____________________________________
.sp 6p
Serial Number: _________________________________________________________________________________
.sp 6p
.fi
If you want to be notified of new products via electronic mail, enter your e-mail
address here:
.sp
_________________________________________
.sp
.fi
* \fIShipping Charges\fP \(em COHERENT: Add $12 USA; $20 Canada; $50 Australia,
France, New Zealand, and Scandinavia; $35 all other countries.
All Other Products: Add $5 per product for USA; for Canada add $8 for first
product and $4 for each additional product; for France, Australia, New Zealand,
and Scandinavia add $15 for first product and $9 for each additional
product; all other countries add $10 for the first product and $5 for
each additional product.
.\" Device Driver Kit: Add $20 outside of the U.S. and Canada.
.\" COHware: Add $10 outside of the U.S. and Canada.
Illinois residents please add 7.5% sales tax.
.sp 2
.ce
FOLD  AND  SEAL  BEFORE  MAILING

.ds TL Introduction
.NH "Introduction"
.PP
This manual documents version 4.2 of the \*(CO Device-Driver Kit.
This kit is designed to help you write device drivers for \*(CO release 4.2.
It describes the contents of the kit, introduces the \*(CO kernel,
gives advice on how to go about writing a device driver,
gives examples of device drivers, and documents all of the
kernel's accessible functions in Lexicon format.
.PP
Before you continue, please read the following carefully:
.QS
.I
This kit will not teach you how to write a device driver.
It is to be used only by persons who are technically knowledgeable.
Due to the highly specialized nature of device drivers, this product is
not eligible for technical support from Mark Williams Company.
.R
.QE
If you discover a bug in the product or you have a suggestion on how
it can be improved, please contact Mark Williams Company.
If you run into a difficulty with the hardware for which you are
writing the driver, please consult that hardware's technical-reference
manual or contact its manufacturer.
.PP
Further, a bug in a device driver can inflict great damage on an operating
system and its files.
You should expect that during development, you will damage the contents
of your hard disk at least once.
Therefore, we implore you to practice defensive programming
in designing and testing your device driver, to protect irreplacable
files from damage or destruction.
This manual will give you suggestions on how to do this most easily.
.SH "Changes From Earlier Releases"
.PP
Release 4.2 completely changes the \*(CO Device-Driver Kit:
.IP \(bu 0.3i
Tools for modifying and relinking the \*(CO kernel are now included within
the \*(CO system itself.
.IP \(bu
.II DDI/DKI^definition
Release 4.2 introduces the \*(CO implementation of the \*(UN Device Driver
Interface/Driver-Kernel Interface (DDI/DKI), and \*(ST.
We now discourage programmers from using internal kernel calls within their
drivers unless absolutely necessary.
.SH "The Kit"
.PP
The \*(CO Device Driver Kit consists of the following:
.IP \(bu 0.3i
Source code for most \*(CO device drivers.
.IP \(bu
Configuration files for the device drivers.
.IP \(bu
This manual.
.SH "Installing the Device Driver Kit"
.PP
The \*(CO Device Driver Kit requires that you are currently
running a production copy of \*(CO release 4.2.
.PP
To install the \*(CO Device Driver Kit, log in as the superuser
.BR root .
Then type the command:
.DM
	/etc/install -c Drv_420 /dev/fha0 1
.DE
for a 5.25-inch floppy-disk drive, or
.DM
	/etc/install -c Drv_420 /dev/fva0 1
.DE
for a 3.5-inch floppy-disk drive.
.PP
The installation program will prompt you to insert the write-protected
floppy disk into the device you named on the command line.
After the installation completes, place your distribution disk in
a safe place, away from heat or magnetic fields.
.SH "Using This Manual"
.PP
This manual consists of six sections:
.IP \fB1.\fR 0.3i
The introduction \(em the section you are reading now.
.IP \fB2.\fR
A sketch of the \*(CO kernel, and how it works.
.IP \fB3.\fR
Writing a device driver using internal kernel calls.
This chapter describes methods that must be used to write block drivers.
.IP \fB4.\fR
Example of a block driver.
.IP \fB5.\fR
Example of a character driver.
.IP \fB6.\fR
The Lexicon.
This gives an entry for each DDI/DKI, \*(ST, or internal-kernel function
or macro.
It also contains overview articles, which introduce classes of functions
or macros, and articles that summarize technical information.
Note that you can use the command
.B man
to view these articles;
and you can view their calling conventions by invoking the command
.BR help .
.PP
As noted above, this manual will not teach you how to write a device driver.
If you are seeking a tutorial, we suggest you look at one of the volumes
listed below.
We hope, however, that you will find the tutorials a helpful guide to
the \*(CO kernel and resources, and the Lexicon a useful summary.
.SH Bibliography
.PP
The following reference manuals discuss the writing of \*(UN device drivers,
the Intel 80386 microprocessor, \*(ST, and related topics.
.PP
Intel Corporation:
\fI386 EX Programmer's Reference Manual\fR.
Santa Clara, Ca.: Intel Corporation, 1990 (part 230985-002).
.PP
Campbell, J.:
\fIC Programmers Guide to Serial Communication\fR.
Indianapolis:
Howard Sams & Company, 1989
(ISBN 0-67222-584-0).
.PP
Crawford, J.; Gelsinger, P.:
\fIProgramming the 80386\fR.
SYBEX Incorporated, 1987 (ISBN 0-89588-381-3).
.PP
Plauger, P.:
Evaluating device controllers.
\fIEmbedded Systems Programming,\fR
March 1991, pp 87-92.
.PP
Comer, D.:
\fIOperating System Design: The XINU Approach.\fR
Englewood Cliffs, NJ:
Prentice Hall, Incorporated, 1984 (ISBN 0-13-637539-1).
.PP
Egan, J.; Teixeira, T.:
\fIWriting A UNIX Device Driver.\fR
Englewood Cliffs, NJ:
John Wiley and Sons, Incorporated, 1988 (ISBN 0-471-62859-X).
.PP
\*(UN System Laboratories, Incorporated:
\fIDevice-Driver Interface/Driver-Kernel Interface Reference Manual for
Intel Processors.\fR
Englewood Cliffs, NJ:
Prentice-Hall, Incorportaed, 1992.
.PP
AT&T:
\fIUNIX System V STREAMS Primer.\fR
Englewood Cliffs, NJ:
Prentice-Hall, Incorporated, 1987.
.PP
AT&T:
\fIUNIX System V STEAMS Programmer's Guide.\fR
Englewood Cliffs, NJ:
Prentice-Hall, Incorporated, 1987.
.PP
\*(UN System Laboratories, Incorporated:
\fIUNIX System V Release 4 Programmer's Guide:
STREAMS.\fR
Englewood Cliffs, NJ:
Prentice-Hall, Incorporated, 1990.
.PP
Ritchie, D.:
A stream input-output system, in
\fIUnix Research System, Volume II: Papers\fR
(ed. 10).
Murray Hill, NJ:
Computing Research Center, AT&T Bell Laboratories, 1990.

.NH "The Lexicon" 1
.PP
.II Lexicon^introduction
The rest of this manual consists of a Lexicon.
This Lexicon contains one article for each of the utilities and clients
included with X Windows for \*(CO.
The articles appear in alphabetical order.

.ds TI ""
.ds TL ""
.NH "COHERENT 4.2.10"
.PP
\*(CO 4.2.10 is a maintenance release of \*(CO that is designed to
fix problems reported with the last release of \*(CO, which is
release 4.2.05.
You have received this release because you have reported a problem
with your \*(CO system.
.PP
The following briefly describes how to update your \*(CO system to
\*(CO 4.2.10.
It also describes how to install it onto a system that does not now
have \*(CO.
.SH "Updating to COHERENT 4.2.10"
.PP
To update \*(CO 4.2.05 to release 4.2.10, do the following:
.IP \(bu 0.3i
Log in as the superuser
.BR root .
.IP \(bu
Insert the boot disk (disk 1) from your 4.2.10 installation kit into
drive 0 (drive A:) of your system.
.IP \(bu
Type the command
.DM
	/etc/shutdown halt 0
.DE
.IP
to shut down your system.
At the prompt, press the reset button on your computer.
.IP \(bu
A miniature version of \*(CO will be booted from the floppy disk in drive 0.
At the `?' prompt, type the command
.BR update .
.IP \(bu
Follow the messages and prompts as they appear on your screen.
.PP
The updating process closely resembles that for release 4.2.05, as described
in the release notes that you received with that product.
There are some differences, but these lie mainly in the wording of some
the messages and prompts, and in the order in which some tasks are performed.
.SH "Installing COHERENT 4.2.10"
.PP
To install \*(CO release 4.2.10, do the following:
.IP \(bu 0.3i
Turn off your system.
.IP \(bu
Insert the boot floppy disk (disk 1) from your installation kit into drive
A of your system.
.IP \(bu
Reboot your computer.
A miniature version of \*(CO will be booted from the floppy disk in drive A.
At the `?' prompt, type the command
.BR install .
.IP \(bu
Follow the messages and prompts as they appear on your screen.
.PP
The installation process closely resembles that for release 4.2.05,
as described in the release notes that you received with that product.
There are some differences, but these lie mainly in the wording of some
the messages and prompts, and in the order in which some tasks are performed.
.SH "A Remaining Problem"
.PP
\*(CO 4.2.10 still has a problem when it builds a file system
on a very large partition.
.PP
When you attempt to build a file sytsem on a disk partition that is larger
than approximately 200 megabytes, \*(CO may create a file system that
does not work properly.
This is because the program (called \fBmkfs\fR) that builds the file system
uses some default settings for aspects of the file system, including the
number of files that the file system can hold.
It sets the number of files based on the size of the file system it is
building; but when the file system is larger than 200 megabytes,
.B mkfs
occasionally attempts to build a file system that can hold an impossibly large
number of files (that is, more than 65,000).
This occurs under the following circumstances:
.IP \(bu 0.3i
When you use the default settings of
.B mkfs
to build a file system on a partition that exceeds 200 megabytes.
.IP \(bu
When you use
.B mkfs
to build a file system that exceeds 200 megabytes, using a prototype file
built by the program
.BR badscan .
.IP \(bu
When you explicitly request an impossibly large number of files.
.PP
If you are updating and your \*(CO file systems now work correctly,
do not alter anything when you update.
Your file systems will continue to work correctly.
.PP
If you are installing, however, and you are going to build a \*(CO file
system onto a partition that exceeds 200 megabytes, we suggest that you
do either of the following:
.IP \fB1.\fR 0.3i
During installation, when the time comes to change (or confirm)
the configuration of your hard disk, reorganize your disk so that no
partition exceeds 200 megabytes.
The release notes that came with \*(CO 4.2.05 describe how to do this.
Please note, however, that if you want DOS and \*(CO to reside on the
same hard disk, doing so could destroy your DOS file system and
require that you rebuild it.
This is described in detail in the release notes; study them carefully.
.IP \fB2.\fR
If you do not wish to alter the configuration of your hard disk, install
\*(CO without changing any partition.
However, make your root partition a partition that is smaller than 200
megabytes.
Then, when you have installed \*(CO and it boots properly, invoke
the command
.B mkfs
by hand with its option \fB\-i\fR explicitly
to set the number of i-nodes (that is, the number of files)
to a number smaller than 65,000.
You can then use that file system without any trouble.
.PP
If you observe these rules, you should be able to install \*(CO on very
large partitions without any trouble whatsoever.
.SH Conclusion
.PP
We would appreciate it if you would immediately report any problems you
experience to Mark Williams Company.
Send electronic mail to \fBsupport@mwc.com\fR; or telephone or write to
MWC Technical Support as described in the release notes.
.PP
Thank you for your patience in this matter; and we hope you enjoy
using \*(CO 4.2.10.

.ds TI "RELEASE NOTES"
.ds TL "Introduction"
.NH "Introduction"
.PP
Thank you for selecting X Windows for \*(CO.
.PP
These notes describe the changes to this product from release 1.0.
They also describe how to install X Windows for \*(CO onto your
\*(CO system, and the additional packages of X software that are
available from Mark Williams and other vendors.
.PP
We suggest you read these notes carefully before you begin to install
X Windows for \*(CO:
otherwise, you may stumble over a problem for which a fix has already
been described.
.SH "Changes from Release 1.0"
.PP
This release corrects a number of minor problems with the
original release of X Windows for \*(CO, and includes some extra features.
We hope that these changes will enhance your enjoyment of this product.
.PP
The following describes changes to X Windows for \*(CO since release 1.0:
.IP \(bu 0.3i
The manual has been revised.
Typographical errors have been corrected, and technical descriptions
have been improved and made more thorough.
.IP \(bu
The installation script has been thoroughly rewritten.
The old script would, under certain conditions, write a configuration file
that did not work correctly; nor did it always react correctly to error
conditions.
The new script is more accurate and more robust.
.IP \(bu
The installation program now uses the new command
.BR findmouse .
This command, as its name implies, helps you to find the port into which
your mouse is plugged.
.IP \(bu
Command
.B bdftopcf
is now included.
The command generates a PCF bitmapped font from a BDF font-description file.
You can use this to help import fonts from third-party suppliers.
.IP \(bu
Script
.B mkdirhier
has been rewritten to work correctly.
.IP \(bu
Script
.B startx
has been rewritten.
It now refuses to start X from within X.
.IP \(bu
Header files
.BR Xos.h ,
.BR Xfuncs.h ,
and
.BR Xlib.h
have been corrected.
Previous versions contained errors that stopped the compilation of
some third-party X programs.
.IP \(bu
Configuration file
.B x386.cf
has been corrected.
The previous version contained an error that prevented a
.B Makefile
generated from an
.B Imakefile
from being compiled by the GNU C compiler.
.IP \(bu
The release now includes the source archive
.BR xwave.gtz ,
which contains source code for the X application
.BR xwave .
This is used as an example of how to recompile an X application
under X Windows for \*(CO.
.SH "Known Bugs"
.PP
X Windows for \*(CO contains the following bugs.
We are working to correct them, and corrected versions of the applications
in question will be posted as soon as they are available.
In the meantime, however, you should be warned of them.
.IP \(bu 0.3i
The X bit-map editor
.B bitmap
does not always work correctly.
In particular, it does not properly load a bit-mapped image.
Attempting to do so from within the application may lock up X Windows.
.IP \(bu
Resizing the X calculator
.B xcalc
may cause X to crash.
.B xcalc
does work correctly, however, if you use it as it first appears on
the screen.
.IP \(bu
The X server may leave garbage characters in the terminal's input queue when
it exits.
Type
.B <ctrl-U>
to erase them before you type the first command after you exit X.
.SH "Errors in the Manual"
.PP
As of this writing, no errors have been discovered in the manual.
.PP
If you discover an error, please send e-mail to manual@mwc.com.
Describe the error and the page on which it occurs.
Please be specific.
This will ensure that the error is corrected in the next printing of
the manual.

.II "lex^tutorial"
.ds TL "lex Lexical Analyzer"
.NH "Introduction to lex, the Lexical Analyzer" 1
.PP
Many computer applications involve reading text strings.
This is especially true for man-machine communication.
.PP
For some forms of textual input, a programmer can design a program
by hand to process it.
However, it is much easier to implement such programs
when you use a software tool that will automatically
construct a program to process the data.
The \*(CO command \fBlex\fR is such a tool.
.PP
.II "lex^program generator"
\fBlex\fR accepts expressions that describe the text input,
and generates a program to process it.
In computer-ese,
\fBlex\fR is a ``lexical scanner program generator''.
.PP
This document tells you how to use \fBlex\fR.
It presents
many simple examples to illustrate how to use its
features and how to use the generated program with other
tools provided with \*(CO, notably the parser generator \fByacc\fR.
.PP
Readers of this document are presumed to be familiar with the C programming
language and the use of the \*(CO system.
Related documents include
\fIUsing the COHERENT System\fR and the tutorial to
\fRyacc\fR, the \*(CO parser generator.
.SH "How To Use lex"
.PP
\fBlex\fR generates lexical scanners for compilers, to do
statistical analysis of text, and to generate filters for many
diverse tasks.
This section gives examples of how to use \fBlex\fR.
Later sections discuss the concepts used in these examples in detail.
.Sh "Translating Strings"
.PP
The first example tells \fBlex\fR to match an input string
and replace it with a different string \(em in this case, replace
the misspelled word ``removeable'' with the correctly spelled ``removable''.
The program outputs unchanged all strings that it does not recognize.
Enter the following program into the file \fBrmv.lex\fR.
.DM
	%%
	removeable	printf ("removable");
.DE
.II "lex^lex specification"
This creates the \fBlex\fP specification.
Use the following command line to
pass this specification through \fBlex\fR:
.DM
	lex rmv.lex
.DE
This produces a C program named \fBlex.yy.c\fR,
which you can compile by typing:
.DM
	cc lex.yy.c -ll -o rmv
.DE
The executable program \fBrmv\fR is now ready to use.
To illustrate its use, type:
.DM
	rmv
	Is this file removeable?
	<ctrl-D>
.DE
\fBrmv\fR replies:
.DM
	Is this file removable?
.DE
Note that the generated program reads from standard input and writes to
standard output.
.Sh "Remove Blanks From Input"
.PP
The next example deletes all blanks and tabs from the input.
Type the following \fBlex\fR program into file \fBnosp.lex\fR:
.DM
	%%
	[ \et]+  ;
.DE
Generate and compile the program with the following commands:
.DM
	lex nosp.lex
	cc lex.yy.c -ll -o nosp
.DE
To invoke the program, type
.BR nosp .
Now, test it by typing the following:
.DM
	This may be hard to read after processing.
	<ctrl-D>
.DE
.B nosp
outputs:
.DM
	Thismaybehardtoreadafterprocessing.
.DE
.Sh "Trimming Blanks"
.PP
The previous example can be rewritten to remove strings of blanks or tabs and
replace them with one space.
Type the following into file \fBonesp.lex\fR:
.DM
	%%
	[ \et]+  printf (" ");
.DE
Generate and compile this with the following commands:
.DM
	lex onesp.lex
	cc lex.yy.c -ll -o onesp
.DE
Invoke your program with the command \fBonesp\fR.
Now, type the following text to test the program;
be sure to separate each word by two spaces:
.DM
	This  should  be  easier  to  read.
	<ctrl-D>
.DE
.B onesp
prints the following:
.DM
	This should be easier to read.
.DE
.SH "lex Specification Form"
.PP
This section discusses the form of the \fBlex\fR specification.
.Sh "Simple Form"
.PP
The examples shown above use the simplest form of a
\fBlex\fR program.
Consider the text of the example \fBrmv.lex\fR:
.DM
	%%
	removeable	printf ("removable");
.DE
The symbol
.DM
	%%
.DE
.II "lex^%%"
divides sections of the \fBlex\fR specification.
Not all specifications need to be present, but at least one
\fB%%\fR must appear in a \fBlex\fR program.
.PP
.II "lex^definitions"
.II "lex^rules"
This symbol separates \fBlex\fR \fIdefinitions\fR from \fIrules\fR.
With nothing before the \fB%%\fR, there are no definitions.
Rules follow the \fB%%\fR.
No definitions are needed in the simplest of \fBlex\fR specifications.
.Sh "Rules in lex"
.PP
The format of a \fBlex\fR rule is simple.
Every rule has two parts.
Refer to the program \fBrmv\fR:
.DM
	removeable	printf ("removable");
.DE
The first part begins at the beginning of the line and ends with a space or tab.
In the example rule, the first part is
.DM
	removeable
.DE
.II "lex^pattern"
This part is called the \fIpattern\fR.
.PP
.II "lex^action"
The second part follows the space or tab, and is called the \fIaction\fR.
The action in this example is:
.DM
	printf ("removable");
.DE
When the pattern specified by the rule is found in the input,
the corresponding action is performed.
Thus, this rule detects every appearance of \fIremoveable\fR
and outputs the correct spelling.
.PP
A
.B lex
program tries each rule's pattern in turn, and performs the
associated action if and only if the pattern matches.
Actions often modify the input that matched the pattern;
they may also do nothing for certain patterns.
To illustrate this, type the following specification
into file \fBerase.lex\fR:
.DM
	%%
	erase	;
.DE
Then compile the generated program with the following commands:
.DM
	lex erase.lex
	cc lex.yy.c -ll -o erase
.DE
This program copies all its input to its output, except for any appearance of
the string \fBerase\fR.
Invoke the program by typing
.BR erase ,
and then test it by typing:
.DM
	Have you erased the blackboard?
	<ctrl-D>
.DE
.B erase
then prints:
.DM
	Have you d the blackboard?
.DE
If the input contains patterns that do not match any of the patterns
in the suite of rules you typed into
.BR lex ,
they are simply output unchanged.
Usually, you will want to write a rule to cover every case.
.Sh "Statements in lex"
.PP
.II "lex^statements"
As noted earlier, \fBlex\fR is a program generator.
It reads the specifications that you prepare for it,
and writes a C program that is used with the \fBlex\fR library.
Many of the actions in the rules you specify, such as
.DM
	printf ("removable");
.DE
are themselves C statements.
These statements are included in the resulting program, along with other
statements that \fBlex\fR provides so the program can run.
.PP
You can include
other statements, should the program need them, by placing them in
appropriate places.
The following program, called
.BR count.lex ,
shows how this is done.
It counts the number of \fItokens\fR, or strings of non-blank characters.
Type the following into the file \fBcount.lex\fR exactly as printed:
.DM
 		int count;
	%%
	[^ \et\en]+	count++;
	[ \et\en]+	;
	%%
	yywrap ()
	{
	 	printf ("Number of tokens:%d\en", count);
	 	return (1);
	}
.DE
Statements other than rule actions appear in two places in the program.
The first such statement is in the definition section, which precedes the
rule section delimiter \fB%%\fR:
.DM
		int count;
.DE
This C statement declares the variable \fBcount\fR to be an integer variable.
Notice that it is preceded by a tab;
a tab or a space indicates to \fBlex\fR that an input line is not a rule.
.PP
The second kind of non-rule statement follows the second \fB%%\fR,
which marks the end of the rules section.
.B lex
regards anything that follows the second delimiter as being
source statements.
.PP
.II "lex^yywrap"
The above example includes a function named \fByywrap\fR.
\fBlex\fR programs always call this function at the end of processing.
The above program fills this function with code that prints the
number of tokens in the text.
If you do not include a routine named \fByywrap\fR,
\fBlex\fR will use a standard one from its library.
.PP
Compile the program by typing the following commands:
.DM
	lex count.lex
	cc lex.yy.c -ll -o count
.DE
Run the program by typing:
.DM
	count <count.lex
.DE
This counts the tokens in the \fBcount.lex\fR file itself.
.B count
will print the following:
.DM
	Number of tokens:21
.DE
.Sh "Groups of Statements"
.PP
.II "lex^statements multiple"
In previous examples, the C statement in the action part of the rule is a
single statement.
In many \fBlex\fR applications, however, you will need to use
more than one statement per rule.
.PP
.II "lex^braces"
.II "lex^repetitions, zero or more"
To do so, enclose the statements in the braces \fB{\fR\ \fB}\fR.
The following example illustrates grouping.
This \fBlex\fR specification generates
a program to add numbers found in the input and
print the total whenever it reads an asterisk `\fB*\fR'.
Type the following program into \fBnsum.lex\fR:
.DM
	 	int number, sum;
	%%
	[0-9]+	{
		sscanf (yytext, "%d", &number);
		sum += number;
		printf ("%s", yytext);
		}
	"*"	{
		printf ("%s", yytext);
		printf ("%d", sum);
		sum = 0;
		}
.DE
Compile the program by typing:
.DM
	lex nsum.lex
	cc lex.yy.c -ll -o nsum
.DE
To run the generated \fBnsum\fR program, enter a sample data file by typing:
.DM
	cat >numbers
	one two three
	1 2 3 4 * 1 2 3 5 *
	*
	done
	<ctrl-D>
.DE
Run the program by typing:
.DM
	nsum <numbers
.DE
.B nsum
will print:
.DM
	one two three
	1 2 3 4 *10 1 2 3 5 *11
	*0
	done
.DE
The statements that follow the definitions
.DM
	[0-9]+
.DE
and
.DM
	*
.DE
are enclosed in braces, because each action triggers several statements.
Consider the first of these:
.DM
	[0-9]+	{
		sscanf (yytext, "%d", &number);
		sum += number;
		printf ("%s", yytext);
		}
.DE
The pattern looks for strings of digits.
.B sscanf
converts each such string into a number and saves it in the variable
\fBnumber\fR.
Now, consider the second rule:
.DM
	"*"	{
		printf ("%s", yytext);
		printf ("%d", sum);
		sum = 0;
		}
.DE
This specifies that upon detection of \fB*\fR
in the input, the program is to print the sum of the numbers
and then reset the counter to zero.
In both of these rules, the statement
.DM
	 printf ("%s", yytext);
.DE
prints the number or \fB*\fR so that the output shows
the input as well as the total.
.II "lex^yytext"
.B lex
defines
the variable \fByytext\fR.
It always contains the string that matches the pattern.
.PP
If the input is neither a number nor an asterisk, no pattern specifically
matches it.
Therefore, the program echoes it unchanged to the standard output.
.Sh "Using the Same Action"
.PP
.II "lex^rules, with same action"
To make it easier for you to write actions, \fBlex\fR allows you to
.I abbreviate
rules; that is, you have to write only once any action
that is performed upon detection of several patterns.
To abbreviate rules represented symbolically by
.DM
	p1	action1
	p2	action1
.DE
use the vertical bar operator:
.DM
	p1	|
	p2	action1
.DE
The vertical bar means ``use the action from the
first rule that declares an action.''
An example is given in the section on macro abbreviations, below.
.SH "Patterns"
.PP
.II "lex^patterns"
.II "lex^regular expressions"
The first part of each rule in the \fBlex\fR rules section
is a pattern that may match parts of the input.
This section describes how to construct these patterns, sometimes called
\fIregular\fR \fIexpressions\fR.
If you are familiar with \fBed\fR and how its patterns work,
this will be familiar to you.
.Sh "Simple Patterns"
.PP
The simplest kind of pattern is a string of characters that matches itself.
A previous section presented an illustration of this:
.DM
	%%
	removeable	printf ("removable");
.DE
The regular expression ``removeable''
matches all occurrences of \fIremoveable\fR that appear in the input text.
.PP
Certain characters have special meaning to \fBlex\fR patterns.
To match a special character literally, you must \fIquote\fR it.
For example, \fB*\fR has special meaning.
To match the asterisk literally (that is to match any `*'s that
appear in the input), surround it with quotation marks:
.DM
	"*"
.DE
Another way to quote characters is to precede it
with the backslash character '\fB\e\fR'.
.DM
	\e*
.DE
The following characters each have special meaning and must be quoted
to be matched as text characters:
.DM
	" \e ( ) < > { } % * + ? [ ] - ^ / $ . |
.DE
However, within \fB"\fR, the \fB\e\fR still has its meaning, so to match
the string \fB\e*\fR use the regular expression:
.DM
	"\e\e*"
.DE
Also, to match a quote character, use:
.DM
	\e"
.DE
.Sh "Classes of Characters"
.PP
.II "lex^patterns"
The power of patterns comes from special characters that match more than
one character.
The following examines each special character in detail.
.PP
.II "lex^dot"
The
.I period
or
.I dot
matches any character except newline.
The following regular expression matches any pair of characters that
begins with \fBJ\fR:
.DM
	J.
.DE
The following example prints in square brackets any sequence of five
characters that precedes a blank.
Type the following into the file \fBfive.lex\fR:
.DM
	%%
	....." "	printf ("[%s]", yytext);
.DE
Compile the program with the following commands:
.DM
	lex five.lex
	cc lex.yy.c -ll -o five
.DE
Now, type the following to create a test file for
.BR five :
.DM
	cat > work
	how well does this work?
	no match
	<ctrl-D>
.DE
Now, test
.B five
by typing:
.DM
	five < work
.DE
The result is:
.DM
	how[ well ]does[ this ]work?
	no match
.DE
The second line of the input does not have any matches.
Because the \fBdot\fR
pattern character does not match the end-of-line character,
all five characters that precede the blank must be on the same line.
.PP
.II "lex^character classes"
Another way to match many characters, but selectively, is with the
\fIcharacter\fR \fIclass\fR operation.
Enclose in square brackets
the set of characters to be matched.
Any of the characters listed there will match one character of the input.
For example,
.DM
	[0123456789]
.DE
matches any decimal digit in the input.
Characters may be in any order within the brackets.
Thus
.DM
	[0246813579]
.DE
is equivalent to the example above.
.PP
To simplify specifying for character classes, you can specify ranges of
characters.
The beginning and end of the range is separated by a hyphen.
To match all decimal digits as above, use:
.DM
	[0-9]
.DE
To match all alphabetic characters, type:
.DM
	[a-zA-Z]
.DE
.II "lex^match, exception"
.II "lex^exception"
The special character \fB^\fR, when used after the opening bracket `\fB[\fR',
tells
.B lex
to match any character \fIexcept\fR those enclosed.
The following example finds all strings that consist of two digits
followed by a third character that is neither an alphabetic character
nor a period,
and prints them enclosed by \fB{\fR
and \fB}\fR.
Type the following into file \fBtwodig.lex\fR:
.DM
	%%
	[0-9][0-9][^\e.a-zA-Z]	printf ("{%s}", yytext);
.DE
Process and compile the program by typing the following commands:
.DM
	lex twodig.lex
	cc lex.yy.c -ll -o twodig
.DE
Invoke the program by typing
.BR twodig ,
and test it by entering the following text:
.DM
	12. 12 12a 1 12 b
	<ctrl-D>
.DE
.B twodig
prints the following in reply:
.DM
	12. {12 }12a 1 {12 }b
.DE
.Sh "Repetition"
.PP
.II "lex^repetition"
In the patterns shown so far,
each character matches only one character at a time.
However,
many interesting input patterns involve repetition of characters.
The above program
.B twodig.lex
used such repetition, albeit in a primitive way.
.PP
.II "lex^+"
.II "lex^repetion, zero or more"
To match one or more instances of a character, follow it with the pattern
operator \fB+\fR.
Consider the summation example in \fBnsum.lex\fR,
shown earlier,
which recognized strings of input numbers and added them to a total:
.DM
	[0-9]+	{
		sscanf (yytext, "%d", &number);
		sum += number;
		printf ("%s", yytext);
		}
.DE
The pattern
.DM
	[0-9]+
.DE
matches a string of one or more digits.
.PP
.II "lex^*"
The operator \fB*\fR will match \fIzero\fR or more characters of a specified
type.
The following example deletes all characters between square brackets.
Type it into file \fBstar.lex\fR:
.DM
	%%
	\e[.*\e]	printf ("[]");
.DE
Type the following commands to generate and compile the program:
.DM
	lex star.lex
	cc lex.yy.c -ll -o star
.DE
Type the following to create a test file:
.DM
	cat > disappear
	[This should disappear]
	[what happens with two] of them [on a line?]
	<ctrl-D>
.DE
Now, use the test file with
.BR star :
.DM
	star < disappear
.DE
The output is:
.DM
	[]
	[]
.DE
In looking at the example's input,
you might have expected the output to be:
.DM
	[]
	[] of them []
.DE
.II "lex^match, longest"
.B lex
does not produce the latter output because it generates
recognizers that find the longest match if several matches are possible.
Therefore,
.B star
matched the first \fB[\fR, then all characters up to and
including the second \fB]\fR.
When you write a pattern that matches many characters, you should bear
this possibility in mind.
.PP
To change the program to match the first \fB]\fR, rewrite it as follows:
.DM
	%%
	\e[[^\e]]*\e]	printf ("[]");
.DE
The regular expression now matches a string of all characters except a \fB]\fR,
when that string is enclosed in square brackets.
.PP
.II "lex^?"
.II "lex^optional match"
.II "lex^match, optional"
The `\fB?\fR' character signals that the previous character or
regular expression is optional.
In other words, `\fB?\fR'
signals zero or one instance of a character or regular expression.
.PP
To see how this would be used in a program, consider
a text processor that regards a word as being a
strings of alphabetic characters that may or may not be followed by a period.
The following example does this, and encloses the
recognized words in parentheses.
Enter it into file \fBword.lex\fR:
.DM
	%%
	[a-zA-Z]+\e.?	printf ("(%s)", yytext);
.DE
Generate and compile the program with the following commands:
.DM
	lex word.lex
	cc lex.yy.c -ll -o word
.DE
Create a test file:
.DM
	cat > words
	These are words.
	Question mark not included?
	<ctrl-D>
.DE
And test
.B word
with the following command:
.DM
	word < words
.DE
The result is
.DM
	(These) (are) (words.)
	(Question) (mark) (not) (included)?
.DE
.II "lex^?"
.II "lex^repetitions, zero or one"
The question mark, like the \fB*\fR and \fB+\fR operators, can also follow
another specification of a pattern.
If you wanted to end a sentence with a character other than a
period, the following code will do the job for you:
.DM
		[a-zA-Z]+[.?!,]?
.DE
The characters
.DM
	.?!,
.DE
are optional.
.PP
.II "lex^braces, in patterns"
.II "lex^repetition, specific count"
The `+' and `*' operators may match many characters.
If you wish to match a specific number of characters or patterns, follow the
patterns with the repetition within braces \fB{\fR and \fB}\fR.
For example
.DM
	[0-9]{3}
.DE
matches a string of exactly three characters.
With this information, you should be able to rewrite the pattern part of
.BR twodig.lex ,
described above.
.PP
You can also specify a range of counts.
To match from seven to nine occurrences of lower-case alphabetic characters,
use:
.DM
	[a-z]{7,9}
.DE
.Sh "Choices and Grouping"
.PP
.II "lex^alternatives"
.II "lex^|"
To indicate alternate choices of characters or regular expressions,
separate them in the regular expression with a vertical bar operator \fB|\fR.
For example, if you wish
to match either three decimal digits or the character \fBa\fR, use:
.DM
	[0-9]{3}|a
.DE
.II "lex^( and )"
.II "lex^grouping, ()"
Parentheses help to group the parts of the pattern
that are separated by the vertical bar:
.DM
	(abc)|(def)
.DE
This pattern will match either the string \fBabc\fR or the string \fBdef\fR.
.Sh "Matching Non-Graphic Characters"
.PP
.II "lex^non-graphic character"
.II "lex^match, non-graphic characters"
Non-special, graphic characters in patterns match themselves.
Most non-graphic characters, such as space, tab, and control characters,
cannot be matched directly.
\fBlex\fR provides special sequences to match control characters.
The following example removes tabs and
blanks from the beginning and end of input lines.
Type it into file \fBdeblank.lex\fR:
.DM
	%%
	[ \et]+\en	printf ("\en");
	\en[ \et]+	printf ("\en");
.DE
Generate and compile the program with the following commands:
.DM
	lex deblank.lex
	cc lex.yy.c -ll -o deblank
.DE
Type the following to create a test file:
.DM	
	cat > sportab
	begins with no space or tab
		begins with tab
	   begins with three spaces
	<ctrl-D>
.DE
Type the following to test
.BR deblank :
.DM
	deblank < sportab
.DE
The result is:
.DM
	begins with no space or tab
	begins with tab
	begins with three spaces
.DE
.II "lex^non-graphic characters"
The special regular expression \fB\et\fR represents \fItab\fR, and \fB\en\fR
represents \fInewline\fR.
.PP
To match the backspace character, use \fB\eb\fR.
Form feed is matched by \fB\ef\fR.
To match an arbitrary character with a known octal value, use
three octal digits after the backslash;
for example,
.DM
	\e007
.DE
.SH "More Patterns"
.PP
This section discusses more advanced capabilities of patterns.
.Sh "Line Context"
.PP
Like \fBed\fR, \fBlex\fR
patterns can include characters that represent the beginning and end of line.
To match a line that consists of exactly five alphabetic characters, type:
.DM
	^[a-zA-Z]{5}$
.DE
.II "lex^end of line"
.II "lex^beginning of line $"
.II "lex^$"
The character \fB^\fR matches the beginning of the line, and \fB$\fR
matches the end of the line.
.Sh "Context Matching"
.PP
.II "lex^//"
.II "lex^match, in context"
.II "lex^context match"
A slash (virgule) `\fB/\fR'
shows that a following context is necessary to match a string.
For example, the following program
matches the string \fBmatch\fR
only if it is immediately followed by the string \fBing\fR.
Type it into file \fBmatch.lex\fR:
.DM
	%%
	match/ing	printf ("{%s}", yytext);
.DE
To compile the program, type the following commands:
.DM
	lex match.lex
	cc lex.yy.c -ll -o match
.DE
Type the following to create a test file:
.DM
	
	cat > matchtit
	Will this match?
	This is a matching test.
	<ctrl-D>
.DE
And run it against
.B match
by typing:
.DM
	match < matchtit
.DE
The result is:
.DM
	Will this match?
	This is a {match}ing test.
.DE
Notice that the string before the slash is matched.
The program does not match
the part that follows the slash, even though the string must
be there for the first part to be matched.
Thus, the regular expression that follows the slash may also be
matched on its own.
To see how this works, type the following into the file
.BR match2.lex :
.DM
	%%
	match/ing	printf ("{%s}", yytext);
	ing		printf ("ed");
.DE
To compile the program, type the following commands:
.DM
	lex match2.lex
	cc lex.yy.c -ll -o match2
.DE
Once again, create a test file:
.DM
	cat > matching
	Will this match?
	This is a matching test.
	You must now sing for your supper.
	<ctrl-D>
.DE
And run it:
.DM
	match2 < matching
.DE
The result is:
.DM
	Will this match?
	This is a {match}ed test.
	You must now sed for your supper.
.DE
.II "lex^context match"
.II "lex^match, in context"
The context-string that follows the \fB/\fR
may be a regular expression.
The following example
matches the whole-number portion of a decimal fraction.
Type it into the file
.BR wholept.lex :
.DM
	%%
	"-"?[0-9]+/"."[0-9]+	printf ("(%s)", yytext);
.DE
To compile the program, type the following commands:
.DM
	lex wholept.lex
	cc lex.yy.c -ll -o wholept
.DE
Invoke the program by typing
.BR wholept ;
then type the following to test it:
.DM
	123 12345 1234.567
1	<ctrl-D>
.DE
The result will be:
.DM
	123 12345 (1234).567
.DE
As you can see,
the part of the regular expression
.DM
	"-"?
.DE
matches an optional leading minus sign.
Then
.DM
	[0-9]+
.DE
matches a string of at least one decimal digit.
Then, the following context must match the regular expression
.DM
	"."[0-9]+
.DE
which matches the fractional part of the number.
When it finds a number that matches, it prints the number's whole part
enclosed in parentheses.
.Sh "Macro Abbreviations"
.PP
.II "lex^macro"
.II "lex^abbreviations"
.B lex
also provides a macro facility that can substantially simplify
the writing of complex regular expressions.
.PP
A \fImacro\fR
is a named body of text.
A macro processor simply replaces the name of the macro
with the text of the macro.
.PP
To illustrate, type following example into file \fBfloat.lex\fR.
It recognizes integer and floating point constants according to the C format:
.DM
	d [0-9]+
	e [Ee][+-]?[0-9]+
	%%
	{d}\e.		|
	{d}\e.{d}	|
	\e.{d}		|
	{d}\e.{e}	|
	\e.{d}{e}	|
	{d}\e.{d}{e}	|
	{d}{e}		printf ("F:[%s]", yytext);
.DE
.II "lex^macro"
.B lex
replaces the macro name
.B e
with the code that matches a string of digits at least one digit long.
It replaces the macro name \fBd\fR with code that matches the
number's exponent.
These two are invoked in the manner of
.DM
	{d}
.DE
within a pattern.
To compile the program, type the following commands:
.DM
	lex float.lex
	cc lex.yy.c -ll -o float
.DE
Type the following to create a test file:
.DM
	cat > flonumb
	1 1. 1.2 1.e4 1e4
	.1e4 e4 .1 . 0 1.2e3
	<ctrl-D>
.DE
And test it by typing:
.DM
	float < flonumb
.DE
The result is:
.DM
	1 F:[1.] F:[1.2] F:[1.e4] F:[1e4]
	F:[.1e4] e4 F:[.1] . 0 F:[1.2e3]
.DE
.Sh "Context: Start Rules"
.II "lex^context, start"
.II "lex^rules, context start"
.II "lex^start condition"
.PP
Many tasks in lexical processing require the program to be aware of
a token's context.
\fBlex\fR
lets you make processing conditional upon previously processed input.
This is done by using \fBstart conditions\fR.
.PP
.II "lex^definitions"
.II "lex^%S"
Start conditions are named in the definitions section as follows:
.DM
	%S name1 name2
.DE
.II "lex^< >"
.II "lex^angle brackets"
where \fBname1\fR and \fBname2\fR are names of start conditions.
These start conditions are then used by prefixing a pattern with
the start condition's name enclosed in angle brackets.
For example:
.DM
	<name1>
.DE
.II "lex^BEGIN action"
For example, you can use one start condition to control the scanning
of comments in a Pascal-like language.
The start condition is set by the \fBlex\fR statement \fBBEGIN\fR
when the beginning bracket of the comment is found.
The comment is scanned for strings that begin with \fB$\fR
to signal compiler operation.
To see how this works,
type the following into the file \fBcomment.lex\fR:
.DM
.ta 0.5i 1.2i 1.7i
	%S CMNT
	%%
	<CMNT>\e$[ler]	printf ("Option is %s.\en", yytext);
	<CMNT>[^\e}]	;
	<CMNT>\e}		BEGIN 0;
	\e{		BEGIN CMNT;
.DE
To compile, use the following commands:
.DM
	lex comment.lex
	cc lex.yy.c -ll -o comment
.DE
Once again, create a test file:
.DM
	cat > option
	{This is a comment}
	{This comment has options $l $e $r}
	program
	information
	<ctrl-D>
.DE
And run it by typing:
.DM
	comment < option
.DE
The result is:
.DM
	Option is $l.
	Option is $e.
	Option is $r.
.sp \n(pDu
	program
	information
.DE
The context start condition is named following \fBBEGIN\fR
in the action part of the rule.
To return to the normal condition, use \fB0\fR as the context name.
.Sh "Separate Contexts"
.PP
.II "lex^context, separate"
If you wish to perform context-dependent processing that is more
complex than that shown in the example above,
you will find it convenient to use separate contexts.
.PP
The names of the contexts are defined in the definitions sections,
after the definitions of any start conditions:
For example:
.DM
	%C name name ...
.DE
The \fBlex\fR function \fByyswitch\fR switches to a new context.
.PP
The body of the context's rules is preceded in the rules section by:
.DM
	%C name
.DE
To see how this works, type the following into file \fBpre.lex\fR.
It is part of a program that recognizes the preprocessor statements in a
C program:
.DM
	%C PRE
	%%
	^# 	yyswitch (PRE);
	[^#\en]+		printf ("[%s]", yytext);
	%C PRE
	include.+	|
	define.+	{
			printf("{%s}", yytext);
			yyswitch(0);
			}
	.+		{
			printf ("{??%s}", yytext);
			yyswitch (0);
			}
.DE
A \fB#\fR in column 1 signals the beginning of a preprocessor statement.
Upon recognizing this condition, this program uses \fByyswitch\fR
to activate the context \fBPRE\fR.
.PP
Within this separate context, individual rules recognize different
preprocessor statements; this example includes only two.
Each of the rules prints the preprocessor line enclosed in braces
\fB{\fR \fB}\fR.
In addition, the rules switch back to the original (and unnamed) context
by the statement
.DM
	yyswitch (0);
.DE
To compile and test this program, use the following commands:
.DM
	lex pre.lex
	cc lex.yy.c -ll -o pre
	pre <lex.yy.c | more
.DE
.II "lex^context, switch"
This example uses the function \fByyswitch\fR
to return to the original context at the end of each rule in the secondary
context.
Some applications require a return to the context that was previously
in force.
To assist in this, \fByyswitch\fR returns the value of the previous context.
.PP
To modify the example to switch to the previous context,
add a statement to the definitions section to declare a variable to hold
the previous context:
.DM
	int prev;
.DE
Then, when switching, save the current context:
.DM
	prev = yyswitch (NEW);
.DE
To switch back, use:
.DM
	yyswitch (prev);
.DE
To summarize, you can specify a match at the beginning and end of input lines.
You may need a following context for a match.
Macros provide a means of abbreviating elements of patterns.
\fBlex\fR
can qualify some patterns based on a start context, or process entirely
separate contexts.
.SH "More About Writing Actions"
.PP
This section discusses predefined \fBlex\fR actions and how to use them.
It also presents other \fBlex\fR routines that are useful in writing actions.
.Sh "ECHO"
.PP
.II "lex^ECHO"
Many \fBlex\fR actions simply output the matched pattern:
.DM
	[0-9]+	printf ("%s", yytext);
.DE
This form has been used in the examples because many examples
also output additional material, such as enclosing braces,
to illustrate the matched token.
.PP
\fBlex\fR provides a simpler way to echo the exact token matched:
.DM
	[0-9]+		ECHO;
.DE
The following example echoes all strings of digits twice, and everything
else once.
Type it into file \fBdouble.lex\fR:
.DM
	%%
	[0-9]+		{ECHO; ECHO;}
	[^0-9]+		ECHO;
.DE
To compile the program, use the commands:
.DM
	lex double.lex
	cc lex.yy.c -ll -o double
.DE
To invoke the program, type
.BR double ;
and to test it, type the following text:
.DM
	abcdef 123 678 as45 67gh
	<ctrl-D>
.DE
.B double
will reply:
.DM
	abcdef 123123 678678 as4545 6767gh
.DE
.Sh "Processing Overlapping Strings"
.PP
The \fBlex\fR processing illustrated to this point has
been restricted to programs whose rules recognize distinct strings.
That is, once any character of a string is matched by a regular expression,
it cannot be matched by another.
.PP
.II "lex^REJECT"
Some applications require that strings be matched by more than one rule;
such multiply-matched strings are called \fIoverlapping strings\fR.
The \fBlex\fR action word \fBREJECT\fR provides this capability.
When \fBREJECT\fR
appears in a rule, other rules can also match the string.
Remember, however, that \fBlex\fR
programs give precedence to the longest string that matches a regular
expression.
.PP
The following example determines the number of letter pairs, or \fIdigrams\fR,
in its input.
The input is presumed to be lower-case letters.
Enter the following into
\fBdigram.lex\fR:
.DM
		int digram [128] [128];
	%%
	[a-z][a-z]	{
			digram [yytext [0]] [yytext [1]]++;
			REJECT;
			}
	.		;
	\en		;
	%%
	yywrap ()
	{
	    int i1, i2;
	    for (i1 = 'a'; i1 <= 'z'; i1++)
		for (i2 = 'a'; i2 <= 'z'; i2++)
		    if (digram [i1] [i2] != 0)
			printf ("%d\et%c%c\en",
			    digram [i1] [i2], i1, i2);
	}
.DE
To compile the program, type the commands:
.DM
	lex digram.lex
	cc lex.yy.c -ll -o digram
.DE
To invoke the program, type
.BR digram ;
and test it with the following text:
.DM
	this is a test of digrams.
	<ctrl-D>
.DE
The result will be:
.DM
	1	am
	1	di
	1	es
	1	gr
	1	hi
	1	ig
	2	is
	1	ms
	1	of
	1	ra
	1	st
	1	te
	1	th
.DE
.Sh "yylex"
.PP
.II "lex^yylex"
.II "lex^definitions section"
.II "lex^sections, definitions"
.B lex
places the actions you provide for the rules in your \fBlex\fR
program into a C routine named \fByylex\fR.
.PP
If you add variable declarations in the definitions section before the first
\fB%%\fR, \fByylex\fR
can access them, as in the example \fBdigram.lex\fR, shown above.
You can also declare variables that are local to \fByylex\fR,
if you place the declarations after the rules section
delimiter and before the first rule.
A tab or space must precede the declaration, where the
.B %
symbols are at the beginning of the line.
See the example
.BR yacclex.lex ,
below.
.PP
The following program is a different version of \fBdigram.lex\fR,
called \fBdigram2.lex\fR; it uses such a declaration.
.DM
		int digram [128] [128];
	%%
		int t0, t1;
	[a-z][a-z]	{
			t0 = yytext [0];
			t1 = yytext [1];
			digram [t0] [t1]++;
			REJECT;
			}
	%%
	yywrap ()
	{
	    int i1, i2;
	    for (i1 = 'a'; i1 <= 'z'; i1++)
		for (i2 = 'a'; i2 <= 'z'; i2++)
		    if (digram [i1] [i2] != 0)
			printf ("%d\et%c%c\en",
			    digram [i1] [i2], i1, i2);
	}
.DE
.Sh "Header Section"
.PP
.II "lex^header section"
.II "lex^section, header"
You can insert
additional code at the beginning of the generated program by
including such code in the definitions section.
An earlier example, \fBcount.lex\fR, demonstrated how to do this:
.DM
		int count;
	%%
	[^ \et\en]+	count++;
	[ \et\en]+	;
	%%
	yywrap ()
	{
	    printf ("Number of tokens:%d \en ", count);
	    return (1);
	}
.DE
A tab or space character must precede the code you include.
.PP
If you wish to insert \fBinclude\fR
or any other C preprocessor statement at the beginning of the program,
however, a different technique must be used.
This stems from the fact that the preprocessor statements must begin at
the beginning of the line, and the blank or tab precludes this.
.PP
.II "lex^%{ %}"
The alternative method to add code to the beginning is as follows:
.DM
	%{
	... code ...
	%}
.DE
where the \fB%\fR symbols are at the beginning of the line.
.Sh "Additional Routines"
.PP
.II "lex^yywrap"
If your version of \fByywrap\fR
or any of the rules that you write need other routines,
you can include code for them after a second \fB%%\fR.
(This was where \fByywrap\fR was shown in \fBdigram.lex\fR.)
If you wish to provide your own version of \fBinput\fR
or \fBoutput\fR, you must define it there.
.SH "Using lex With yacc"
.PP
.II "lex^yacc"
Although \fBlex\fR can handle many applications by itself,
it is often used with the parser-generator \fByacc\fR.
For example,
programming-language compilers often have parts generated
by both \fBlex\fR and \fByacc\fR.
.PP
.II "lex^tokens"
Like \fBlex\fR, \fByacc\fR is a program generator.
Its programs can recognize input that is
structured according to a grammar fed to the \fByacc\fR program generator.
In most instances,
\fByacc\fR-generated programs require \fItokens\fR as input, instead
of individual characters.
In the context of a programming language, a token is a variable name or
a special character (such as an operator).
\fBlex\fR is often used with \fByacc\fR because \fBlex\fR
is especially well suited for partitioning text input into tokens.
.PP
A \fByacc\fR-generated
program expects a token number as input from the routine \fByylex\fR.
\fByacc\fR assigns a unique number, or constant definition,
to each unique type of token,
and expects \fByylex\fR to return these numbers as input.
.PP
For your \fBlex\fR program
to access these predefined constant definitions for token types,
you must include the generated \fBlex\fR source in the \fByacc\fR specification.
.PP
The following examples process very simple input, to
illustrate how to assemble \fBlex\fR- and \fByacc\fR-generated
programs.
To begin, type the following into the file \fByacclex.yy\fR:
.DM
	%token beginning midtok ending
	%start simplistic
	%%
	simplistic :	beginning middle ending
				{printf ("recognized"); };
	middle	:	midtok;
	middle	:	middle midtok;
	%%
.DE
When \fByacc\fR processes this program, it produces the file \fBy.tab.h\fR
that contains the token-name definitions.
The following \fBlex\fR source reads \fBy.tab.h\fR to learn of the
constant definitions that \fByacc\fR generated;
type it into file \fByacclex.lex\fR:
.DM
	%{
	#include "y.tab.h"
	%}
	%%
	"("	return (beginning);
	")"	return (ending);
	[a-zA-Z]	return (midtok);
.DE
The symbolic definition of the token names are \fBbeginning\fR,
\fBending\fR and \fBmidtok\fR.
.PP
To compile the programs, type the following commands:
.DM
	yacc yacclex.yy
	lex yacclex.lex
	cc y.tab.c lex.yy.c -ly -ll -o yacclex
.DE
Type
.B yacclex
to invoke the new program; and test by typing the following:
.DM
	(abcdef)
	<ctrl-D>
.DE
The result will be:
.DM
	recognized
.DE
.SH Summary
.PP
.B lex
is a utility that generates lexical analyzers according to
a set of specifications that you write.
.I "Lexical analysis"
means to read a mass of text, recognize strings within that mass,
and react appropriately when each type of string is discovered.
With
.BR lex ,
you can write programs to perform complex analysis of text simply
by describing what analysis you want to perform, without worrying
about the messy details of how that analysis is actually performed;
thus, \fBlex\fR is a fine example of what is nowadays called a
``fourth-generation language''.
.PP
.B lex
is especially well suited to work with the parser-generator
.BR yacc .
By using them together, you can efficiently build command processors
and even entire computer languages.

.NH "Xware 3: Graphics"
.PP
Congratulations on purchasing Xware 3: the graphics package for \*(CO.
.PP
This package also holds the library
.BR libXpm.a ,
whose functions manipulate pix-mapped images;
a manual page for every program;
and a selection of GIF images for your enjoyment.
.SH "What is Xware?"
Xware is a series of packages from Mark Williams Company
that bundle some of the most popular and useful software
for the X Window System.
Each program in a Xware package comes with an executable binary;
source code;
instructions and scripts to help you recompile and install the program;
and a manual page for the program edited and formatted in the \*(CO
Lexicon format, which you can view with the \*(CO command
.BR man .
.PP
Other Xware packages are available or are being prepared.
These include packages of X window managers, games,
tools and utilities, and development tools.
Xware makes it easy and convenient for you
to enlarge your supply of X software.
.SH "System Resources"
.PP
All of the programs in this package run in eight megabytes of RAM.
.PP
The amount of disk space depends upon how many programs you install,
and whether you leave the sources archived on your system or delete them.
As a rule of thumb,
you should assume that each de-archived program and its sources
consume between one-half and one megabyte of disk space.
The exception is the set of screen-saver programs, which are
described below; each of these requires approximately 500 kilobytes of
disk space.
Directions on how to install a program are given below.
.PP
The size of the screen required varies from program to program.
A few will run on 640\(mu480 screen; most fit into 800\(mu600;
a few require a 1024\(mu768 screen.
Those that use the 1024\(mu768 screen can, in most instances,
be run under 800\(mu600, although the image being displayed may be cropped.
.PP
Most programs recompile correctly with the \*(CO C compiler.
A few must be recompiled with the GCC compiler, which is
not included with this package.
Each archive contains a file named
.BR README.Coh ,
which describes how to install and recompile it.
.SH "Contents of This Package"
.PP
The individual programs are kept in the form of compressed archives.
When you install Xware onto your system, all of the archives are
copied into directory
.BR /usr/X11/graphics .
The GIF images that are also included are installed into directory
.BR /usr/X11/gif ,
and the manual pages are installed into directory
.BR /usr/man/Xware3 .
.PP
The following describes the contents of this package:
.IP "\fB30dora.gif\fR"
.IS "\fB30dorac.gif\fR"
.IS "\fBapollo.gif\fR"
.IS "\fBapollo10.gif\fR"
.IS "\fBapollo9.gif\fR"
.IS "\fBapolloe2.gif\fR"
.IS "\fBfoc.gif\fR"
.IS "\fBm100.gif\fR"
.IS "\fBm100comp.gif\fR"
.IS "\fBm100gn.gif\fR"
.IS "\fBnovacygb.gif\fR"
.IS "\fBnovacygc.gif\fR"
These files contain some striking space images.
Those with the prefix ``apollo'' were taken from Project Apollo.
File
.B apolloe2.gif
contains a strikingly beautiful view of the Earth photographed about
halfway between the Earth and the Moon.
The other images were downloaded from the newly repaired
Hubble Space Telescope, and show the amazing detail that that instrument
can now achieve.
You can display these files with the program
.BR xv ,
described below.
.IP "\fBmpeg_play\fR"
Play MPEG video files.
Unlike other animation formats, which display a series of
bit-mapped image, MPEG files consist of instructions for computing the
images being shown.
.IP "\fBplanetge\fR"
This package consists of three programs, with which you can model
the geology and climate of an imaginary planet.
.IP
The first program,
.BR tec ,
models the plate tectonics of your imaginary planet, using a description
file that you prepare, then animates the movement of the continents
over the aeons.
It also draws maps that can be used by the other two programs.
.IP
The second program,
.BR clim ,
takes a map drawn by
.B tec
and models the climate for that planet.
Again, you can write a description that sets climatary parameters for
the planet, e.g., the planet's degree of inclination from the
plane of the ecliptic.
.IP
Finally, the program
.B planet
takes a two-dimensional map generated by
.BR tec
wraps it around a sphere, then rotates it for you.
.IP "\fBspaceout\fR"
Watch the stars fly past you, just as they did at the beginning of the
old ``Star Trek'' television program.
.IP "\fBxanim\fR"
Run
.B .anim
files that have been generated on an Amiga.
Included is a sample animation that does something interesting.
.IP "\fBxdali\fR"
Create a digital clock.
Unlike
.BR xclock ,
however, the letters of this clock ``melt'' into each other,
in a manner reminiscent of Salvadore Dali's melting watches.
.\".IP "\fBxgrasp\fR"
.\"Run GRASP (\fB.gl\fR)
.\"files generated under MS-DOS.
.\"The animation and color reproduction is quite good.
.IP "\fBxmandel\fR"
Explore the Mandelbrot set interactively.
This program will also save Mandelbrot images in GIF format, so you can
redisplay them later with the program
.BR xv .
.IP "\fBxphoon\fR"
Draw the current phase of the Moon on your system's root window.
It's an old favorite on Sun workstations.
.IP "\fBxpm\fR"
This archive contains the archive
.B libXpm.a
plus its source code.
This archive
also contains the command
.BR sxpm ,
which demonstrates how to use and display an XPM.
.IP
When you install this package onto your system,
the compiled archive
.B libXpm.a
is automatically copied into directory
.BR /usr/X11/lib .
.IP "\fBxscreen\fR"
This is a package of screensaver programs.
It consists of a utility that can install a graphics programs as a
screen-saver; plus a number of graphics programs.
Note that because this package is so large, only unlinked objects are
included \(em not source code or (in most instances) linked executables.
The file
.B README.Coh
describes how to re-link the programs and install them.
The package consists of the following programs:
.RS
.IP \fBxscreensaver\fR
Display graphics programs as screen-savers.
By modifying its resource file, you can tell this program to display one
graphics program as a screen-saver, or cycle among a number of programs.
.IP \fBxscreensaver-c\fR
Send instructions to
.B xscreensaver
even while it is running.
.IP \fBattraction\fR
Model the dance of nuclear particles, which attract or repel
each other depending upon how close they are to one another.
.IP \fBblitspin\fR
Rotate a bit-mapped image in an interesting way.
.IP \fBdecayscreen\fR
Take a snapshot of the root window, then slowly modify the image so that the
screen appears to be melting.
.IP \fBgreynetic\fR
Randomly draw stippled or colored rectangles.
.IP \fBhalo\fR
Randomly draw stippled or colored circles.
.IP \fBhelix\fR
Draw helical string-art patterns.
.IP \fBhopalong\fR
Draw real-plane fractals.
.IP \fBhypercube\fR
Animate a two-dimensional projection of a four-dimensional object.
.IP \fBimsmap\fR
Generate fractal maps.
.IP \fBnoseguy\fR
Animate a little man, who wanders around the screen and recites fortunes.
.IP \fBpyro\fR
Simulate fireworks exploding on the screen.
.IP \fBrocks\fR
Animate a flight through the asteroid belt.
Excellent animation!
.IP \fBqix\fR
Bounce colored lines around a window.
.IP \fBrorschach\fR
Generate Rorschach blots.
(Interpretation is entirely up to you.)
.IP \fBslidescreen\fR
Divide the screen into squares, then slide the squares around.
It resembles the game
.BR puzzle ,
except that it creates disorder out of order rather than the other way around.
.IP \fBxroger\fR
Display a variorum (and, some claim, more accurate) version of the X logo.
.RE
.IP "\fBxswarm\fR"
This program animates a swarm of ``bees'' that endlessly chase a ``wasp''
around its window.
Its many features let you do interesting things with the root window.
.IP "\fBxv\fR"
Display and modify a great variety of images, including the GIF images
included with this package.
This is the standard X program for displaying pictures.
.SH "Installing This Package"
.PP
To install this package onto your system, log in as the superuser
.B root
and type the installation command:
either
.DM
	/etc/install Xware3 /dev/fva0 4
.DE
if you have a 3.5-inch floppy-disk drive, or
.DM
	/etc/install Xware3 /dev/fha0 5
.DE
if your floppy-disk drive is 5.25 inches.
.B install
copies the programs into directory
.BR /usr/X11/graphics ,
installs the few extra tools you need to recompile these programs,
copies the GIF files into directory
.BR /usr/X11/gif ,
and automatically installs the manual pages for the programs.
.SH "Installing an Individual Program"
.PP
As described above, each program is kept in a compressed archive in directory
.BR /usr/X11/graphics .
Each archive contains a compiled version of the program, ready for running;
the sources for the program;
a file called
.BR README.Coh ,
which describes how to recompile the program, should you wish; and a script
named
.BR Install.Coh ,
which installs the program for you.
To install a program so you can use it, do the following:
.IP \(bu 0.3i
.B cd
to directory
.BR /usr/X11/graphics .
.IP \(bu
Use the command
.B gtar
to de-archive and uncompress the archive that holds the program you want.
For example, if you want to install program
.BR xanim ,
type the command:
.DM
	gtar -xvzf xanim.gtz
.DE
.IP \(bu
Change to the directory that holds the newly de-archived program.
For example, when you un-tar archive
.BR xanim.gtz ,
the program and its source files are copied into directory
.BR xanim .
.IP \(bu
Use the command
.B su
to become the superuser
.BR root ,
and execute script
.BR Install.Coh .
Each program has such a script, and it handles all the details of
installation for you.
.IP \(bu
After you have installed the program, you may wish to remove the source
code and other files that you do not need.
To do so,
.B cd
back to the program's parent directory, and use the command
.B "rm \-rf"
to remove the directory and its contents.
For example, after you have installed
.BR xanim ,
you can remove this directory by typing the following commands:
.DM
	cd ..
	rm -rf xanim
.DE
Note that the archive from which you copied the program,
.BR xanim.gtz ,
is untouched by removing the directory
.BR xanim .
You can always de-archive the program again should you wish to work with
its program files or re-install it.
.PP
If you wish to recompile a program, follow the directions given in file
.B README.Coh
in that program's source directory.
.SH "Copyrights"
.PP
Please note that the software in this package comes from third-party sources.
It is offered ``as is'', with no guarantee or warranty stated or implied,
whatsoever.
The copyrights on the source code and any executables built from it
belong to the persons who wrote the original code; full copyright
statements are included with the source code to each program.
We ask that you read and respect these statements.
.SH "Technical Support"
.PP
The sources in this package have been compiled and run successfully under
\*(CO.
If you have a problem bringing up one of the programs or with
compiling the source code as it is configured in this package, our
technical support team will attempt to help you.
However, because of the highly technical nature of the source
code in these packages, Mark Williams Company
.I cannot
give you technical assistance should you modify any of the source code
included in this package in any manner whatsoever.
.SH "A Final Word"
.PP
Most of the source code for these programs, and for the program shipped in
our other Xware packages,
is available for free on the Mark Williams bulletin board system.
The tutorial for
.B UUCP
in the \*(CO manual describes how to contact the BBS and make its services
available to you.
.PP
We hope that you enjoy using these graphical programs!

.po 1i
.sp 1i
.ll 6i
.ce
\f(HLUser Evaluation Report\fR
.sp
To keep this manual free of errors and to help us
improve COHERENT, please sent us your reactions.
Please fill in the form below, detach it, and mail it to:
.sp
.ce 3
Mark Williams Company
.br
60 Revere Drive
.br
Northbrook, IL  60062
.sp
.nf
.ta 1.25i
\! .1 setlinewidth
Name:	____________________________________________________________________
.sp
Company:	____________________________________________________________________
.sp
Address:	____________________________________________________________________
.sp
City/State/Zip:	____________________________________________________________________
.sp
Phone:	____________________________________________________________________
.sp
Date:	____________________________________________________________________
.sp 2
Version and hardware used:
.sp 2
Did you find any errors in the manual?
.sp 2
Can you suggest any improvements to the manual?
.sp 2
Did you find any bugs in the software?
.sp 2
Can you suggest any improvements or enhancements to the software?
.sp 2
Additional comments:

.ds TL "Bulletin Board"
.NH "Mark Williams Bulletin Board" 1
.PP
Mark Williams Company has set up a \*(CO \*(UU node for dial-up
use by our customers.
It serves three major purposes:
.IP \fB1.\fR 0.3i
As a remote site with which you can test your \*(UU configuration.
.IP \fB2.\fR
As a source of news, bug fixes, and public-domain software for you to download.
In addition, the BBS lists new \*(QLthird party\*(QR
software and hardware that work with \*(CO.
.IP \fB3.\fR
As a mail drop for customers who request an account.
If you wish,
you can can exchange electronic mail with MWC and other \*(CO users.
.SH "Accessing the MWC BBS"
.PP
Before you try to access the MWC BBS, note that you
.I must
use \*(UU.
You cannot use
.BR ckermit ,
.BR Procomm ,
or any other communications utility.
.PP
Before you proceed, please review the tutorial on \*(UU in the \*(CO manual.
It includes an exhaustive tutorial on this powerful utility and uses
.B mwcbbs
throughout it.
In most cases, the tutorial gives you all the information you need.
.PP
You can access
.B mwcbbs
through the following three telephone numbers:
.DS
.ta 0.5i 3.5i
	1200/2400-baud generic modem:	708-559-0412
	9600-baud Trailblazer modem:	708-559-0445
	9600-baud V.32 or HST modem:	708-559-0452
.DE
.SH "Downloading Files"
.PP
Once you have succeeded in contacting
.BR mwcbbs ,
you can begin to exchange files and mail with Mark Williams personnel,
and with other \*(CO users.
.PP
For your initial contact with \fBmwcbbs\fR, we recommend that you download
the introductory message \fBhowto.start\fR from directory
.BR /usr/spool/uucppublic/mwcnews .
For example, the command:
.DM
	uucp -r mwcbbs!/usr/spool/uucppublic/mwcnews/howto.start /usr/spool/uucppublic
.DE
queues up a request to copy file \fBhowto.start\fR into directory
.B /usr/spool/uucppublic
on your system.
This file contains information on available downloads, new \*(CO
developments, and how to obtain an individual account on the system.
If the time at which you type the \fBuucp\fR command is within the range
of times allowed in the entry for
.B mwcbbs
in
.BR /usr/lib/uucp/sys ,
your modem will call \fBmwcbbs\fR immediately \(em
you can check this with the commands \fBps\fR or \fBuulog\fR.
If you wish to force polling of mwcbbs at a time not specified in
.BR /usr/lib/uucp/sys ,
you can do so with the command:
.DM
	su uucp /usr/lib/uucp/uucico -Smwcbbs  &
.DE
You can then monitor the progress of the transfer via the command:
.DM
	uulog -f mwcbbs
.DE
To stop monitoring the call, type
.BR <ctrl-C> .
.SH "Electronic Mail Access"
.PP
The following electronic mail addresses are available to customers.
.PP
For issues relating to administration of the BBS node, send mail to
.BR mwcbbs!admin .
.PP
For matters relating to support of \*(CO and related
products, send mail to
.BR mwcbbs!support .
.PP
Additional mail aliases may appear from time to time.
Please remember that mail sent to either of the aforementioned addresses
will be sent to \fBmwcbbs\fR only when you invoke
.BR uucico .
You can do this interactively from the \*(CO shell,
as shown in the example above, or at regular intervals as a \fBcron\fR task.
The following gives a sample line for your
.B cron
file:
.DM
	15 20 * * * su uucp /usr/lib/uucp/uucico -smwcbbs
.DE
This line will check every day at 8:15 PM for
.B uucp
and
.B mail
requests which have been queued for
.BR mwcbbs ,
and, if any are found, will call \fBmwcbbs\fR.
See the Lexicon article
.B cron
for further information.
.PP
Please note that while the BBS supports inbound electronic mail from
your system to
.B mwcbbs
via anonymous \*(UU,
we cannot reply to your electronic mail messages unless
you have an account on
.BR mwcbbs .
To request an account on
.BR mwcbbs ,
download the file
.B howto.start
from directory
.B /usr/spool/uucppublic/mwcnews
on
.BR mwcbbs ,
and follow its directions.

.II "sh^tutorial"
.ds TL "The Bourne Shell"
.NH "Introducing sh, the Bourne Shell" 1
.PP
.II script
.II shell
.II commands^COHERENT
.B sh
is the command that invokes the Bourne shell, which is the \*(CO
system's default command interpreter.
The Bourne shell interpets commands, and much more.
It is, in effect, both a programming language and an interpreter.
.PP
At least one writer has noted that the shell is
the original ``fourth-generation language'' \(em that is, a powerful
programming language that is straightforward enough to be programmed
by non-programmers.
You will find that taking a little time to master the rudiments of
the shell programming language will pay enormous benefits in making
best use of your \*(CO system.
.SH "Simple Commands"
.PP
.II "shell^simple commands"
The shell command language is built around simple commands.
For example, the following command lists all files in the current directory:
.DM
	lc
.DE
.II semicolons
.II ;
You can combine
several simple commands on one line by separating them with semicolons:
.DM
	who;du;mail
.DE
.II "shell^sequential execution of commands"
The shell executes
the commands in sequence as if they had been typed:
.DM
	who
	du
	mail
.DE
In both of these examples, \fBdu\fR does not begin execution until \fBwho\fR
is finished, and \fBmail\fR does not begin until \fBdu\fR is done.
.SH "Special Characters"
.PP
The shell treats the following characters
specially;
if you want to use them without their special
meaning, you must precede them with the backslash character \fB\e\fR, or
enclose them within quotation marks:
.DM
	*  ?  [  ]  |  ||  ;  {  }  (  )  &  &&
	$  =  :  \(ga  '  "  <  >  <<  >>
.DE
The function of these characters will be explained later in this
section.
To use one of these characters in a command, for example `?', type:
.DM
	echo \e?
.DE
In addition, the shell treats the following words in a special way when they
appear as the first word of a command:
.DM
.ta 0.5i 1.25i 2.0i 2.75i 3.5i 4.25i
	if	then	elif	else	fi
.sp \n(pDu
	case	esac
.sp \n(pDu
	do	done
.sp \n(pDu
	for	in
.sp \n(pDu
	until	while	break
.sp \n(pDu
	test
.DE
.SH "Running Commands in the Background"
.PP
.II "commands^concurrent execution"
.II &
The shell can execute
commands simultaneously as well as sequentially.
This means that while the shell is executing one command,
it lets you type and execute another command.
Under the shell, the number of commands you can execute at the same
time is limited mainly by the amount of memory and disk space on your
system.
.PP
If a command is followed by the
special character `&', the shell begins to execute it
immediately, and prompts you to enter another command.
For example, if you need to \fBsort\fR a large file
but want to continue with other commands while the
sort is executing, you can type:
.DM
	sort >bigfile.sorted bigfile.unsorted &
	ed prog
.DE
This allows you to
edit file \fBprog\fR while your computer quietly executes the sort
in the background.
.PP
.II commands^background
.II process^id
When you run a command with \fB&\fR,
the shell types the \fIprocess\fR \fIid\fR of the command started in
background.
When the \*(CO system runs a command, it assigns that command
a \fIprocess id\fR, which is a number that uniquely identifies that
command to \*(CO.
Normally, there is no need to be concerned about these numbers.
However, when you run commands in the background,
the shell tells you the id of the background process so you
can keep track of its execution.
.PP
.II ps
The command
.DM
	ps
.DE
lists the processes you are currently running.
If you have no background jobs, the response is:
.DM
	TTY PID
	30: 362 -sh
	30: 399 ps
.DE
.II process
.II ps
The first column shows the number that \*(CO has assigned
to your terminal.
This is the same terminal number printed out by \fBwho\fR.
The second column shows the process id;
the third column shows the program or command executing.
The characters \fB-sh\fR in the third column means the login shell.
There are two processes because the shell is running the \fBps\fR
command as a separate process.
.PP
Once you have started a background command, \fBps\fR
shows you the process entry, which has the process id that the
shell typed out for you.
.PP
.II "background process"
.II process^background
.II wait
If you need the results from a background job,
you can wait for it to finish by issuing the command:
.DM
	wait
.DE
The shell will then accept no further commands until all your background jobs
are finished.
If there are no background jobs, there will be no delay.
.SH Scripts
.PP
.II "file^of commands"
.II "commands^in files"
Many of the commands that you use in \*(CO are \fIprograms\fR,
such as \fBed\fR.
Others, like the \fBman\fR command, are \fIscripts\fR, or files that
merely contain calls to other commands.
You can write scripts on your own, simply by using a text editor
to type into a file the commands you wish to execute.
If you frequently use a set of commands,
you can save yourself from having to type them over and over by
simply typing them once into a script.
.PP
.II sh
.II script
.II shell^script
For example, suppose that you wish to check periodically the amount of
disk space that you have used, the amount of disk space still available, and
see who is using the system.
You can write a script to do all of this automatically.
Create the script \fBgood.am\fR by
typing the following commands:
.DM
	ed
	a
	du
	df
	who | sort
	mail
	.
	w good.am
	q
.DE
From now on, to execute the above-listed commands, you need only type:
.DM
	sh good.am
.DE
where \fBsh\fR is a command that means: read commands from a file, in this
case \fBgood.am\fR.
If you can issue a command from your terminal, you can also execute it
from within a script.
.PP
.II chmod
.II sh
You can make a command file directly executable by using the command
.BR chmod .
For example, the command
.DM
	chmod +x good.am
.DE
lets you execute the script \fBgood.am\fR by typing
.DM
	good.am
.DE
and leaving off the \fBsh\fR.
Once you have done the \fBchmod\fR
command, you can still issue the commands by typing:
.DM
	sh good.am
.DE
as well as use \fBed\fR or \*(ME to change the contents of the script.
.PP
.II script
Notice that the commands called by a script may themselves be scripts.
This is illustrated by the following script, \fBsecond.sh\fR:
.DM
	ed
	a
	good.am
	lc
	.
	w second.sh
	q
.DE
Thus, typing:
.DM
	sh second.sh
.DE
calls the script \fBgood.am\fR, and also calls the command \fBlc\fR.
.SH "\&.profile: Login Shell Script"
.PP
.II prompt
.II directory^home
.II "home directory"
When you log into the system and before you are issued your first prompt,
\*(CO checks your home directory for a file named \fB.profile\fR;
if it is present, the shell executes the commands it contains.
.PP
This enables you to have \*(CO execute commands as soon as you log in.
Check if your installation provides one for you by doing an \fBlc\fR
(be sure that your current directory is the home directory).
If the file is there, print it by saying:
.DM
	cat .profile
.DE
Some of the commands may be of the form:
.DM
	PATH=':/bin:/usr/bin'
.DE
This sort of command will be discussed below.
.SH "Substitutions"
.PP
Scripts of the form shown above are processed by the \*(CO shell
without change.
.II "substitution^in commands"
However,
the \*(CO shell increases the power of commands by performing three kinds
of substitutions within commands before it executes them.
.PP
First, it replaces
special characters in commands with file names from
the current or other directories.
This allows you to issue a single command that processes several files.
.PP
Second, you can give a script \fIarguments\fR, much like arguments that are
passed to a Pascal, Algol, or C procedure.
This lets you target the
action of the script to a specific file name specified when you call it.
.PP
Third, the output of one command can be ``piped'' into another command
to serve as its input.
.PP
.II echo
We will use the command \fBecho\fR to illustrate these
kinds of substitution.
Remember that substitutions take place for all
commands in the same way that they do for \fBecho\fR.
.SH "File Name Substitution"
.PP
File names are often used as command parameters.
That is, you will often tell a command to do something to one
or more files.
By using special shell characters, you can substitute file names in commands.
These special characters describe file name \fIpatterns\fR for the shell to
look for in the directory.
When the shell finds the file names, it replaces the pattern with them.
.PP
.II *
.II patterns
The asterisk
\fB*\fR
matches any number of any characters in file names.
Thus,
.DM
	echo *
.DE
echoes all the file names in the current directory, whereas
.DM
	echo f*
.DE
gives all file names that begin with the letter \fBf\fR, and
.DM
	echo a*z
.DE
lists all names that begin with \fBa\fR and end with \fBz\fR.
.PP
.II *
.II echo
To illustrate more clearly, create two files by typing
.DM
	cat >zz1
	<ctrl-D>
	cat >zz2
	<ctrl-D>
.DE
Then the \fBecho\fR command
.DM
	echo zz*
.DE
produces the output:
.DM
	zz1 zz2
.DE
Thus, by using a single \fB*\fR, you can substitute several file names into
a command.
In other words, the command
.DM
	echo zz*
.DE
is equivalent to
.DM
	echo zz1 zz2
.DE
If no file names fit the pattern, the special characters
are not changed, but left in the command exactly as you typed them.
To illustrate, type the command
.DM
	rm zz*
	echo zz*
.DE
The first command will remove all files whose names begin with \fBzz\fR, and is
therefore equivalent to:
.DM
	rm zz1 zz2
.DE
The \fBecho\fR command that follows, however, echoes
.DM
	zz*
.DE
because no files begin with \fBzz\fR; they were just removed.
.PP
.II *
.II apostrophe
Enclosing command words within apostrophes
prevents the shell from matching file names with the
enclosed characters.
In the unlikely event that you have a file whose name is
.DM
	zz*
.DE
that you want to remove, use the command
.DM
	rm 'zz*'
.DE
The \fB*\fR
is enclosed within apostrophes, and therefore is not changed by the shell.
.PP
.II ?
.II "question mark"
.II "file^creating empty"
Another special character \fB?\fR match any one letter.
To see how this works,
create empty files \fBfile1\fR, \fBfile2\fR, and \fBfile33\fR by typing:
.DM
	>file1
	>file2
	>file33
.DE
The command
.DM
	echo file?
.DE
replies
.DM
	file1 file2
.DE
because \fB?\fR does not match \fB33\fR.
.PP
.II ]
.II [
You can use
brackets \fB[\fR and \fB]\fR
to indicate a choice of single characters in a pattern:
.DM
	echo file[12]
.DE
This command replies:
.DM
	file1 file2
.DE
To match a range of characters, separate the beginning and end of the range
with a hyphen.
The command
.DM
	echo [a-m]*
.DE
prints any file name beginning with a lower-case letter from the first
half of the alphabet, and is exactly equivalent to:
.DM
	echo [abcdefghijklm]*
.DE
.II "order^of matched file names"
When such patterns find several file names,
they are inserted in alphabetical order.
.PP
.II patterns
.II /
Because the character \fB/\fR
is important in path names, the shell does not match it
with \fB*\fR or \fB?\fR in
patterns.
The slash must be matched explicitly; that is, it is matched only by a
\fB/\fR itself.
Therefore, to find all the files in the
\fB/usr\fR directories with the name \fBnotes\fR, type:
.DM
	echo /usr/*/notes
.DE
The asterisk matches all the subdirectories of \fB/usr\fR that contain a
file named \fBnotes\fR.
.PP
In addition, a leading period in a file name must be
matched explicitly.
If you have a file in your current directory with the
name \fB.profile\fR, the command
.DM
	echo *file
.DE
does not match it.
.PP
These patterns can appear anywhere within a command or a command file.
.SH "Parameter Substitution"
.PP
.II parameter^positional
Each shell script can have up to nine \fIpositional parameters\fR.
This lets you write scripts that can be used for many circumstances.
Recall that command parameters follow the command
itself and are separated by tabs or spaces.
An example of a command reference with two parameters is:
.DM
	show first second
.DE
where \fBfirst\fR and \fBsecond\fR are the parameters.
.PP
.II script
.II $
To substitute the positional parameters in the script, use the character
\fB$\fR followed by the decimal number of the parameter.
Consider the following example.
First, create two sample files:
.DM
	cat > first
	line 1
	line two
	line 3
	<ctrl-D>
	cat > second
	line 1
	line 2
	line 3
	<ctrl-D>
.DE
.II parameter^positional
Then, issue the commands
.DM
	cat first
	cat second
	diff first second
.DE
.II parameter^fewer
.II parameter^null
Inspect the output carefully.
The command
.B diff
compares two files and prints all lines that differ.
In this case, it prints
.B "line two"
and
.BR "line 2" .
.PP
Now, build the script
.BR show ,
which uses parameter substitution:
.DM
	ed show
	a
	cat $1
	cat $2
	diff $1 $2
	.
	wq
	chmod +x show
.DE
To demonstrate the effet of
.BR show ,
type:
.DM
	show first second
.DE
Inspect the output and compare it with the output you received earlier.
.PP
If you issue the
.B show
command with fewer than the required number of parameters, the shell
substitutes an empty string in its place.
For example, using the command
.DM
	show first
.DE
is equivalent to
.DM
	cat first
	cat
	diff first
.DE
where the null string has been substituted for
.BR $2 .
.PP
The example above shows the parameter references separated from each
other by a space.
In some uses, you may wish to prefix a substituted parameter to a name
or a number.
When more than one digit follows a
.BR $ ,
The shell picks up the first digit as the number of the parameter.
To illustrate, build the shell file \fBpos\fR:
.DM
	ed
	a
	echo $167
	.
	w pos
	q
	chmod +x pos
.DE
Then call the script with
.DM
	pos five
.DE
and the result will be:
.DM
	five67
.DE
.SH "Shell Variable Substitution"
.PP
.II shell^variable
In addition to positional parameters, the shell provides \fIvariables\fR.
You can assign values to variables, test them, and substitute them in
commands.
.PP
.II "case sensitivity^in shell variable"
The variable name can be built from letters, numbers, and the
underscore character; for example:
.DM
	high_tension
	a
	directory
	167
.DE
Note that keywords must not be single digits, because the shell then treats
them as positional parameters.
Be aware that the shell treats upper-case and lower-case letters
differently in variable names.
.PP
.II shell^variable
.II variable^shell
An assignment statement gives a value to a shell variable:
.DM
	a=welcome
.DE
You can inspect their value with the \fBecho\fR command:
.DM
	echo $a
.DE
The shell substitutes
the value of the variable \fBa\fR in the \fBecho\fR command,
which then appears as
.DM
	echo welcome
.DE
\*(CO responds to this command by printing:
.DM
	welcome
.DE
Don't forget the \fB$\fR when referring to the value.
.PP
.II space
Notice that the shell looks for special characters in any command
that it sees \(em this includes the \fIspace\fR character.
To avoid problems, enclose the value to be assigned in apostrophes:
.DM
	phrase='several words long'
.DE
There are several uses for variables.
One is to hold a long string that you
expect to type repeatedly as part of a command.
If you are editing files in a subdirectory like
.DM
	/usr/wisdom/source/widget
.DE
you can abbreviate if you set a variable \fBpw\fR to:
.DM
	pw='/usr/wisdom/source/widget'
.DE
Then simply using \fB$pw\fR in a command
.DM
	echo $pw
.DE
substitutes the long path name.
.PP
.II keyword^parameters
.II parameter^keyword
Another use of shell variables is as keyword parameters to commands.
These then can be used the same way as positional parameters.
To see how this works, create another script resembling \fBshow\fR:
.DM
	ed
	a
	cat $one
	cat $two
	diff $one $two
	.
	w show2
	q
	chmod +x show2
.DE
To use \fBshow2\fR, issue:
.DM
	one=first two=second show2
.DE
This is equivalent in effect to:
.DM
	cat first
	cat second
	diff first second
.DE
.II brace
Unlike positional parameters, keyword parameters may be several
characters in length.
If you want some text to follow immediately a keyword
parameter, enclose the keyword parameter in braces.
To illustrate this,
build a command file called \fBbrace\fR, as follows:
.DM
	ed
	a
	echo 'with brace:' ${a}bc
	echo 'without brace:' $abc
	.
	w brace
	q
	chmod +x brace
.DE
Call the command file with \fBa\fR set:
.DM
	a=567 brace
.DE
The result is:
.DM
	with brace: 567bc
	without brace:
.DE
.II "parameter^assigning keyword"
When used in this way, the keyword
parameters must be assigned before
the command and on the same line as the command.
In this case, the assignment of keyword parameters does not affect
the variable after the command is executed.
For example, if you type:
.DM
	one=ordinal
	one=first two=second show2
	echo 'value of one is ' $one
.DE
\fBecho\fR produces:
.DM
	value of one is ordinal
.DE
.II parameter^positional
Variables set other than on the line of a command are not normally
accessible to a script.
To illustrate, build a parameter display script:
.DM
	ed
	a
	echo 1 $1 2 $2 p1 $p1 p2 $p2
	.
	w pars
	q
	chmod +x pars
.DE
This will be used to show the behavior of parameters.
The parameters to \fBecho\fR without a \fB$\fR help to read the output.
To pass positional parameters, type:
.DM
	pars ay bee
.DE
The output is:
.DM
	1 ay 2 bee p1 p2
.DE
To pass keyword parameters, type:
.DM
	p1=start p2=begin pars
.DE
The result is:
.DM
	1 2 p1 start p2 begin
.DE
To illustrate that the setting of \fBp1\fR and \fBp2\fR did not ``stick'', type:
.DM
	echo $p1 $p2 'to show'
.DE
\fBecho\fR replies:
.DM
	to show
.DE
This indicates that \fBp1\fR and \fBp2\fR are not set.
.PP
Illustrating that variables set separately from a command are not seen by
the command, type:
.DM
	p1=outside1 p2=outside2
	pars
.DE
This replies:
.DM
	1 2 p1 p2
.DE
.II export
.II shell^variable
.II variable^shell
By using the \fBexport\fR command, however, such variables can be made
available to commands.
The commands
.DM
	export p1 p2
	p1='see me' p2=hello
	pars
.DE
produce:
.DM
	1 2 p1 see me p2 hello
.DE
This indicates that after the \fBexport\fR
of \fBp1\fR and \fBp2\fR, they are available to other commands.
Once a variable has appeared in an \fBexport\fR command,
its value can be changed without a need to \fBexport\fR it again.
.SH "Command Substitution"
.PP
.II "grave accent"
By enclosing a command between \fB\(ga\fR characters, you can
feed its output onto the command line of another command.
For example
.DM
	echo \(gals\(ga
.DE
echoes the output of the \fBls\fR command.
.SH "Special Shell Variables"
.PP
.II cd
.II HOME
.II directory^home
.II default^directory
When you log into the \*(CO system, it sets
the shell variable \fBHOME\fR to your \fIhome\fR or default directory path.
If your user name is \fBhenry\fR, then the command
.DM
	echo $HOME
.DE
on most systems prints:
.DM
	/usr/henry
.DE
The change directory command \fBcd\fR sets the working directory
to the path found in \fBHOME\fR if no argument is given.
.PP
.II PS1
.II PS2
.II >
.II $
.II default^prompt
.II prompt
The shell normally prompts you with \fB$\fR for commands, and with
\fB>\fR if more information is needed.
These two prompts are taken by the shell from the variables
\fBPS1\fR and \fBPS2\fR.
You can change these if you want different prompts, for example
.DM
	PS1="Fred's Software Palace: "
	PS2='!'
.DE
To have these take effect each time you log in, put the assignment statements
in your \fB.profile\fR file.
.PP
.II /bin
.II PATH
The shell variable \fBPATH\fR lists the path names of
directories that contain commands.
To show the contents of
.BR PATH ,
type:
.DM
	echo $PATH
.DE
It typically will show:
.DM
	:/bin:/usr/bin
.DE
.II ": (colon)"
.II "parent directory"
.II directory^parent
This means that the shell looks for a command first in the current
directory, then in \fB/bin\fR, and, if not found there, then in \fB/usr/bin\fR.
The path names are separated by `:'.
This means that an empty string precedes the first `:', the current directory.
Another common setting for \fBPATH\fR is:
.DM
	:..:/bin:/usr/bin
.DE
This means that the shell seeks commands
first in the current directory, then in  `..'
(the parent directory of the current directory),
then in \fB/bin\fR, and finally in \fB/usr/bin\fR.
.SH "dot . : Read Commands"
.PP
.II "dot command"
Similar to the command \fBsh\fR is the \fB.\fR command.
The command
.DM
	. cfil
.DE
causes the shell to read and execute commands from \fBcfil\fR.
.PP
This differs from the \fBsh\fR command in several respects.
First, there's no way to pass parameters to \fBcfil\fR with the `.' command.
Second, the \fBsh\fR command executes another shell to read the commands,
whereas `.' simply reads the commands directly.
Finally, all the string
variables and parameters are accessible by \fBcfil\fR.
.PP
The command file \fBgood.am\fR created earlier can be executed with:
.DM
	. good.am
.DE
This has the same effect.
Similarly, the `.' can itself be used within a command file:
.DM
	ed
	a
	. good.am
	lc
	.
	w third.sh
	q
.DE
Then, the command
.DM
	. third.sh
.DE
has the same result as the command:
.DM
	sh third.sh
.DE
.SH "Values Returned by Commands"
.PP
.II failure
.II success
.II commands^value
.II "value from command"
Most \*(CO commands return a value that indicates success or failure.
For example, if
.B grep
cannot find your file, it issues a diagnostic message and
returns a value that tells the shell that something went wrong.
You can examine this value by typing the command:
.DM
	echo $?
.DE
This tells you the value returned by the last command executed.
Zero indicates success (true),
whereas a non-zero value indicates failure (false).
Note that this convention is the opposite of that in the C language
(a fact that has led to confusion on occasion).
.PP
.II cmp
You can use the value returned by a command to affect decisions about
executing other commands.
.SH "test: Condition Testing"
.PP
.II test
For most commands, the return value is a side-effect of their operation.
However, the \fBtest\fR command's only task is to return a value.
This command can test many conditions, and return a value to indicate
whether the requested condition is true or false.
.PP
The command
.DM
	test -f file01
.DE
returns true (zero) if \fBfile01\fR exists and is not a directory.
To check if a file is a directory, use:
.DM
	test -d file01
.DE
.II parameter^substitution
.II testing^strings
.II "substitution^of parameters"
.B test
can also test strings.
This is useful when you are using parameter substitution.
To illustrate, build the following command:
.DM
	ed
	a
	test $1 = $2
	echo 'test 1 & 2 for equal:' $?
	test $1 != $2
	echo 'test 1 & 2 for not equal:' $?
	.
	w test.ed
	q
	chmod +x test.ed
.DE
Because the `=' is a parameter, be sure to surround it with space characters.
.PP
This command file tests its two parameters for equality.
Try the commands:
.DM
	test.ed one two
	test.ed one one
.DE
The
.B test
command has many other options;
see the Lexicon entry for
.B test
for details.
.SH "Executing Commands Conditionally"
.PP
.II ||
.II cmp
Type the following commands to create two files:
.DM
	cat >file1
	line one
	line two
	line three
	<ctrl-D>
	cat >file2
	line one
	two is different
	line three
	<ctrl-D>
.DE
Now, compare the files and print the return value:
.DM
	cmp -s file1 file2
	echo $?
.DE
The command
.B cmp
compares two files byte-by-byte; the
.B \-s
option tells
.B cmp
merely to indicate whether the files were the same.
The command
.DM
	echo $?
.DE
prints
.B 1
(false) because the files are not the same.
.PP
To process a second command based on the result returned by the first, type:
.DM
	cmp -s file1 file2 || cat file2
.DE
The characters \fB||\fR signify that the following command \fBcat\fR should be
executed if the \fBcmp\fR
command returns a non-zero value, which it will for this example.
.PP
.II &&
The two characters \fB&&\fR execute the command that follows them
only if the preceding command returns true (zero).
.PP
To see how this works, create a third file with the command:
.DM
	cp file1 file3
.DE
Type the command:
.DM
	cmp -s file1 file3 && rm file3
.DE
This command removes \fBfile3\fR if \fBcmp\fR
indicates that \fBfile1\fR and \fBfile3\fR are identical.
Because \fBcmp\fR is preceded by the copy command
\fBcp\fR, the files \fBfile1\fR and \fBfile3\fR are identical,
and so \fBfile3\fR is removed.
.SH "Control Flow"
.PP
Because the shell is a programming language as well as a program, it
provides constructs for conditional execution and loops.
These are \fBfor\fR, \fBif\fR, \fBwhile\fR, \fBuntil\fR, and \fBcase\fR.
Also, a subshell can be executed within `(' and `)'.
.Sh "for: Execute a Loop"
.PP
The \fBfor\fR construct processes a set of commands once for
each element in a list of items.
.PP
.II do
.II done
To illustrate \fBfor\fR,
type the following commands to \*(CO:
.DM
	for i in a b c
	do echo $i
	done
.DE
The items
.BR a ,
.BR b ,
and
.B c
form the list of value that the variable
.B i
assumes.
The shell executes \fBecho\fR with \fBi\fR assuming each
value in turn.
The result of these commands is:
.DM
	a
	b
	c
.DE
.II done
.II >
.II for
Notice that after you type the line containing \fBfor\fR,
\*(CO prompts with a different character \fB>\fR
(on most \*(CO systems).
The shell does this to remind you that you must type more information.
After you type the line containing \fBdone\fR, the prompt again becomes
\fB$\fR.
.PP
The \fBfor\fR command is usually used within a script.
Also, you can leave off the list of value to the index variable;
when you do this, the shell by default uses the arguments typed on
the script's command line as the values for the index variable.
To illustrate, type:
.DM
	ed
	a
	for i
	do echo $i
	echo '---'
	done
	.
	w script.for
	q
	chmod +x script.for
.DE
The statement 
.B "for i"
is equivalent to:
.DM
	for i in $*
.DE
where \fB$*\fR means ``all positional parameters''.
Notice that two commands are repeated for each value of \fBi\fR.
Now, call
.B script.for
with the following command line:
.DM
	script.for 1 2 3 4 test
.DE
The result is:
.DM
	1
	---
	2
	---
	3
	---
	4
	---
	test
	---
.DE
.Sh "if: Execute Conditionally"
.PP
\fBif\fR tests the result of a command and
conditionally executes other commands based upon that result.
It can be used instead of \fB&&\fR and \fB||\fR, as shown above.
To demonstrate this, first type the command:
.DM
	cp file1 file3
.DE
This creates
.B file3
(because we deleted it on the previous page).
Then type:
.DM
	if cmp -s file1 file2 
	then cat file3
	fi
.DE
This means that the shell executes
.DM
	cat file3
.DE
if \fBcmp\fR returns zero (true).
.PP
.II fi
.II else
.II if
.II false
To get the same result as given by the previously illustrated command:
.DM
	cmp -s file1 file3 && rm file3
.DE
with the \fBif\fR statement, also use \fBelse\fR:
.DM
	if cmp -s file1 file3
	then
	else rm file3
	fi
.DE
The commands between \fBelse\fR and \fBfi\fR are executed if the result
of the command following the \fBif\fR is false or non-zero.
Note that there is no command following \fIthen\fR.
.PP
.II if
.II elif
The \fBelif\fR statement lets you test several
conditions with one \fBif\fR statement and act on the one that is true.
In general terms,
.DM
	if command1
	then action1
	elif command2
	then action2
	elif command3
	then action3
	else action4
	fi
.DE
The items labeled \fIcommand\fR and \fIaction\fR are both commands or lists of
commands.
.PP
First, the shell executes \fBcommand1\fR.
If the result is true, it performs \fBaction1\fR.
If the result from \fBcommand1\fR is not true, the shell then
executes \fBcommand2\fR.
If its result is true, then it performs \fBaction2\fR.
This process continues so long as none of the commands return a true result.
If none of the command results are true, the action following the
\fBelse\fR is executed.
.PP
To illustrate
.BR elif ,
create a shell script that list on your terminal
only one of the three file-name arguments.
Use the command
.DM
	test -f name
.DE
which returns true if \fIname\fR is an existing non-directory
file.
.DM
	ed
	a
	if test -f $1
	then cat $1
	elif test -f $2
	then cat $2
	elif test -f $3
	then cat $3
	else echo 'None are files'
	fi
	.
	w cat.1
	q
	chmod +x cat.1
.DE
Now, let's exercise
.BR cat.1 .
Type:
.DM
	cat.1 file1 file2 file3
	cat.1 file3 file2 file1
	cat.1 foo bar baz
.DE
Examine the results.
.Sh "while: Execute a Loop"
.PP
.II while
Another looping or repetitive shell statement is the \fBwhile\fR statement.
The commands
.DM
	while command1
	do command2
	done
.DE
first performs \fIcommand1\fR.
If its result is true, \fIcommand2\fR is
executed, and \fIcommand1\fR is again executed.
This process continues until \fIcommand1\fR returns false (non-zero).
.Sh "until: Another Looping Construct"
.PP
.II until
The construct
.B until
resembles
.BR while .
For example, the commands:
.DM
	until command1
	do command2
	done
.DE
execute \fIcommand2\fR until \fIcommand1\fR returns true (zero).
.Sh "case: Serial Conditional Execution"
.PP
.II case
The \fBcase\fR statement resembles the \fBif\fR
statement in that it offers a multiple choice.
To illustrate, type the following script, which lets you choose
one of several ways to list the contents of a directory:
.DM
	ed
	a
	case $1 in
	     1) ls -l;;
	     2) ls;;
	     3) lc;;
	     *) echo unknown parameter $1;;
	esac
	.
	w dir
	q
	chmod +x dir
.DE
.II )
.II esac
.II case
The words \fBcase\fR and \fBesac\fR bracket the entire \fBcase\fR statement.
The effect of the command
.DM
	dir 2
.DE
is equivalent to:
.DM
	ls
.DE
Each choice within the \fBcase\fR statement is indicated by a string followed
by \fB)\fR:
.DM
	2)
.DE
indicates what is to be executed if argument \fB$1\fR has the value \fB2\fR.
.PP
.II case
.II *
.II "choices^in case statements"
.II *)
.II "vertical bar"
.II |
The strings that select the choices may be patterns.
The choice `*)' signifies that a match can be made on any string.
Notice that this resembles the use of \fB*\fR to substitute any file name.
An expression of the form
.DM
	[1-9])
.DE
in a \fBcase\fR statement matches any digit from 1 through 9.
A list of alternatives can be presented by separating
the choices with a vertical bar:
.DM
	a|b|c) command
.DE
.II ";; (double semicolon)"
Each command or command list in the case choice must be
terminated by a double semicolon \fB;;\fR.
.SH Summary
.PP
The shell is a command programming language that handles simple commands
as well as complex commands that can iterate as well as make decisions.
Three kinds of substitution are provided to increase the power of your
commands.
.PP
For more information about the shell, see the tutorial for the shell
that follows in this manual.
For more information about a given command, see its entry in the Lexicon.
.PP
Note, too, that the \*(CO system also includes the Korn shell \fBksh\fR.
This is a superset of the Bourne shell described here, and has many features
that you may find useful.
For information about this shell, see the Lexicon entry for \fBksh\fR.

.ds RN "GCC Development System" 
.ds VN 2.5.6
.ds CR 1994
.ds IF COHERENT
.ds OS COHERENT
.ds KR "\fIThe C Programming Language,\fR ed. 2"
.ds PN COHERENT
.ds TI "The COHERENT System"
.ds TL "Release Notes"
.ds Ql `
.ds Qr '
.ds QL ``
.ds QR ''

%! Adobe PostScript follows...
%%BeginExitServer: 0
serverdict begin 0 exitserver
%%EndExitServer
%!PS-AdobeFont-1.0: Keyboard-Regular 001.000
%%CreationDate: 4.3.1992 11:45:58 Uhr 
%%VMusage: 1024 39559
 
% Duplication prohibited. All rights reserved.
% URW Software, Copyright 1992 by URW
%%EndComments
FontDirectory/Keyboard-Regular known{/Keyboard-Regular findfont dup/UniqueID known{dup
/UniqueID get 4923787 eq exch/FontType get 1 eq and}{pop false}ifelse
{save true}{false}ifelse}{false}ifelse
12 dict begin
/FontInfo 9 dict dup begin
 /version (001.000) readonly def
 /FullName (Keyboard-Regular) readonly def
 /FamilyName (Keyboard) readonly def
 /Weight (Medium) readonly def
 /ItalicAngle 0 def
 /isFixedPitch false def
 /UnderlinePosition -115 def
 /UnderlineThickness 70 def
 /Notice (URW Software, Copyright 1992 by URW) readonly def
end readonly def
/FontName /Keyboard-Regular def
/Encoding StandardEncoding def
/PaintType 0 def
/FontType 1 def
/StrokeWidth 0 def
/FontMatrix[0.001 0 0 0.001 0 0]readonly def
/UniqueID 4923787 def
/FontBBox[-25 -218 1026 859]readonly def
currentdict end
currentfile eexec
[encoded data, 75075 characters]
73D7264B0643207B
0000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000
cleartomark{restore}if

#!/bin/sh
# COHERENT version of Berkeley command "apropos"
# Coherent 386 release 4.2
# Copyright (c) 1982, 1994 by Mark Williams Company.
# All rights reserved. May not be copied without permission.
#
# History:
# 03/17/1993: original version, written in C (fwb)
# 10/07/94: Rewrote in the shell; included support for $MANPATH

VERSION=2.0

# find which files are to be displayed;
# $1 is a copy of MANPATH; $2 is the token being sought
split_path () {
	while : ; do
		case "$1" in
		'' | :)	break
			;;

		:*)	set -- "${1#:}" $2
			;;

		*:*)	eval "find_descrip ${1%:"${1#*:}"} $2"
			set -- "${1#*:} $2"
			;;

		*)	eval "find_descrip $1 $2"
			break
			;;
		esac
	done
	return 1
}

# find descriptions for a given token.
# $1 is the directory whose index files are to be searched;
# $2 is the token being sought
find_descrip () {
	grep $2 $1/*.index |
		awk '{ for (i = 2 ; i <= NF; i++)
			if (i == 2)
				printf ("%s:\t", $i)
			else {
				if (i == NF)
					printf ("%s\n", $i)
				else
					printf ("%s ", $i) 
			}
		}'
}

# if environmental variable PAGER is not set, set it to "more"
if [ "$PAGER" = "" ]; then
	PAGER="more"
fi

# if environmental variable MANPATH is not set, set it to "/usr/man"
if [ "$MANPATH" = "" ]; then
	PAGER="/usr/man"
fi

# If no args, print help message and exit
if [ $# -eq 0 ]; then
	echo "Usage: apropos [-V] [token [ ... ] ]"
	exit 0
fi

# Print version number
if [ $1 = "-V" ]; then
	echo "apropos: version $VERSION"
	exit 0
fi

# execute the command
for i in $*
do
	split_path $MANPATH $i
done

# end of "apropos"

#!/bin/sh
# readbb.sh
# read the bounding-box parameters from an EPS image.  Use it because the
# GNU program "psbb" is far too finicky about what it calls an EPS file.
# By Fred Butzen, 10/16/1994

lx=0
ly=0
ux=0
uy=0

if [ $# -eq 0 ]; then
	echo Usage: readbox.sh filename.eps
	exit 1
fi

grep BoundingBox $1 | read JUNK lx ly ux uy ; echo .BB $lx $ly $ux $uy

# end of readbb.sh

#!/bin/sh
# COHERENT version of command "man"
# Coherent 386 release 4.2
# Copyright (c) 1982, 1994 by Mark Williams Company.
# All rights reserved. May not be copied without permission.
#
# History:
# 10/31/90: original version, written in C (steve)
# 10/07/94: Rewritten in the shell (fwb); included support for $MANPATH

VERSION=2.0.1

# if environmental variable PAGER is not set, set it to "more"
if [ "$PAGER" = "" ]; then
	PAGER="more"
fi

# if environmental variable MANPATH is not set, set it to "/usr/man"
if [ "$MANPATH" = "" ]; then
	MANPATH="/usr/man"
fi

# find which files are to be displayed;
# $1 is a copy of MANPATH; $2 is the token being sought
split_path () {
	while : ; do
		case "$1" in
		'' | :)	break
			;;

		:*)	set -- "${1#:}" $2
			;;

		*:*)	eval "find_files ${1%:"${1#*:}"} $2"
			set -- "${1#*:} $2"
			;;

		*)	eval "find_files $1 $2"
			break
			;;
		esac
	done
	return 1
}

# find which files apply to a given token.
# $1 is the directory whose index files are to be searched;
# $2 is the token being sought
find_files () {
	display_files `awk "\$2~/^$2\$/ || \$2~/^$2\(\)\$/ \
		{ print \"$1/\" \$1 }" $1/*.index`
}

# display a bunch of files
display_files () {
	if [ $# -gt 0 ]; then
		if [ $PAGER != "echo" ]; then
			echo "\n\n\n"
		fi
		NOFILES=1
		$PAGER $*
	fi
}

# If no args, print help message and exit
if [ $# -eq 0 ]; then
	echo "
Usage: man [-wdV] article [ article ... ]
	-w displays each article's path
	-d displays all available articles
	-V displays version number
	To search for an article on a given topic, use the command 'apropos'.
"
	exit 0
fi

# check for command-line options
while : ; do
	case $1 in
		-w)	PAGER=echo ; shift ;;
		-V)	echo "man: version $VERSION" ; exit 0 ;;
		-d)	ls -C /usr/man/* | $PAGER ; exit 0 ;;
		*)	break ;;
	esac
done

for TOKEN in $*
do
	NOFILES=0

	split_path $MANPATH $TOKEN

	if [ $NOFILES -eq 0 ]; then
		echo "\nman: No manual entry for \"$TOKEN\"\n"
	fi
done

# end of "man"
